/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],re=function(X){for(var e=[],O=0,D=X.length;O<D;O++)e[O]=se[X[O]];return e};define(se[73],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class O{static get(){const I=new Map,N=new Map,A=new Map,P=new Map;function u(w,$){w.has($.detail)||w.set($.detail,-$.timestamp)}function a(w,$){const R=w.get($.detail);R&&(R>=0||w.set($.detail,R+$.timestamp))}let h=[];typeof X=="function"&&typeof X.getStats=="function"&&(h=X.getStats().slice(0).sort((w,$)=>w.timestamp-$.timestamp));for(const w of h)switch(w.type){case 10:u(I,w);break;case 11:case 12:a(I,w);break;case 21:u(N,w);break;case 22:a(N,w);break;case 33:u(A,w);break;case 34:a(A,w);break;case 31:u(P,w);break;case 32:a(P,w);break}let b=0;A.forEach(w=>b+=w);function y(w){const $=[];return w.forEach((R,d)=>$.push([d,R])),$}return{amdLoad:y(I),amdInvoke:y(N),nodeRequire:y(A),nodeEval:y(P),nodeRequireTotal:b}}static toMarkdownTable(I,N){let A="";const P=[];return I.forEach((u,a)=>{P[a]=u.length}),N.forEach(u=>{u.forEach((a,h)=>{typeof a>"u"&&(a=u[h]="-");const b=a.toString().length;P[h]=Math.max(b,P[h])})}),I.forEach((u,a)=>{A+=`| ${u+" ".repeat(P[a]-u.toString().length)} `}),A+=`|
`,I.forEach((u,a)=>{A+=`| ${"-".repeat(P[a])} `}),A+=`|
`,N.forEach(u=>{u.forEach((a,h)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(P[h]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=O}),define(se[54],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=D,e.$4h=I,e.$5h=N;function O(A){return(P,u,a)=>{let h=null,b=null;if(typeof a.value=="function"?(h="value",b=a.value):typeof a.get=="function"&&(h="get",b=a.get),!b)throw new Error("not supported");a[h]=A(b,u)}}function D(A,P,u){let a=null,h=null;if(typeof u.value=="function"?(a="value",h=u.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",h=u.get),!h)throw new Error("not supported");const b=`$memoize$${P}`;u[a]=function(...y){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,y)}),this[b]}}function I(A,P,u){return O((a,h)=>{const b=`$debounce$${h}`,y=`$debounce$result$${h}`;return function(...w){this[y]||(this[y]=u?u():void 0),clearTimeout(this[b]),P&&(this[y]=P(this[y],...w),w=[this[y]]),this[b]=setTimeout(()=>{a.apply(this,w),this[y]=u?u():void 0},A)}})}function N(A,P,u){return O((a,h)=>{const b=`$throttle$timer$${h}`,y=`$throttle$result$${h}`,w=`$throttle$lastRun$${h}`,$=`$throttle$pending$${h}`;return function(...R){if(this[y]||(this[y]=u?u():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...R)),this[$])return;const d=this[w]+A;d<=Date.now()?(this[w]=Date.now(),a.apply(this,[this[y]]),this[y]=u?u():void 0):(this[$]=!0,this[b]=setTimeout(()=>{this[$]=!1,this[w]=Date.now(),a.apply(this,[this[y]]),this[y]=u?u():void 0},d-Date.now()))}})}}),define(se[74],re([0,1,9]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=D,e.$ed=I,e.$fd=N,e.$gd=A,e.$hd=P,e.$id=u;function D(a,h){if(!a)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function I(a,h="Unreachable"){throw new Error(h)}function N(a,h="unexpected state"){if(!a)throw new O.$cb(`Assertion Failed: ${h}`)}function A(a){a||(0,O.$1)(new O.$cb("Soft Assertion Failed"))}function P(a){if(!a()){debugger;a(),(0,O.$1)(new O.$cb("Assertion Failed"))}}function u(a,h){let b=0;for(;b<a.length-1;){const y=a[b],w=a[b+1];if(!h(y,w))return!1;b++}return!0}}),define(se[38],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=A,e.$Kn=b,e.$Ln=y,e.$Mn=w,e.$Nn=$,e.$On=R,e.$Pn=d,e.$Qn=l,e.$Rn=c,e.$Sn=v,e.$Tn=p,e.$Un=g;var O;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var D;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var N;(function(n){n.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(n,r=!1){let t=0;const i=n.length;let s="",o=0,f=16,S=0;function k(ie){let ue=0,le=0;for(;ue<ie;){const ce=n.charCodeAt(t);if(ce>=48&&ce<=57)le=le*16+ce-48;else if(ce>=65&&ce<=70)le=le*16+ce-65+10;else if(ce>=97&&ce<=102)le=le*16+ce-97+10;else break;t++,ue++}return ue<ie&&(le=-1),le}function j(ie){t=ie,s="",o=0,f=16,S=0}function L(){const ie=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&a(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&a(n.charCodeAt(t)))for(t++;t<n.length&&a(n.charCodeAt(t));)t++;else return S=3,n.substring(ie,t);let ue=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&a(n.charCodeAt(t))){for(t++;t<n.length&&a(n.charCodeAt(t));)t++;ue=t}else S=3;return n.substring(ie,ue)}function q(){let ie="",ue=t;for(;;){if(t>=i){ie+=n.substring(ue,t),S=2;break}const le=n.charCodeAt(t);if(le===34){ie+=n.substring(ue,t),t++;break}if(le===92){if(ie+=n.substring(ue,t),t++,t>=i){S=2;break}switch(n.charCodeAt(t++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const V=k(4);V>=0?ie+=String.fromCharCode(V):S=4;break}default:S=5}ue=t;continue}if(le>=0&&le<=31)if(u(le)){ie+=n.substring(ue,t),S=2;break}else S=6;t++}return ie}function C(){if(s="",S=0,o=t,t>=i)return o=i,f=17;let ie=n.charCodeAt(t);if(P(ie)){do t++,s+=String.fromCharCode(ie),ie=n.charCodeAt(t);while(P(ie));return f=15}if(u(ie))return t++,s+=String.fromCharCode(ie),ie===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),f=14;switch(ie){case 123:return t++,f=1;case 125:return t++,f=2;case 91:return t++,f=3;case 93:return t++,f=4;case 58:return t++,f=6;case 44:return t++,f=5;case 34:return t++,s=q(),f=10;case 47:{const ue=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!u(n.charCodeAt(t));)t++;return s=n.substring(ue,t),f=12}if(n.charCodeAt(t+1)===42){t+=2;const le=i-1;let ce=!1;for(;t<le;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,ce=!0;break}t++}return ce||(t++,S=1),s=n.substring(ue,t),f=13}return s+=String.fromCharCode(ie),t++,f=16}case 45:if(s+=String.fromCharCode(ie),t++,t===i||!a(n.charCodeAt(t)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=L(),f=11;default:for(;t<i&&J(ie);)t++,ie=n.charCodeAt(t);if(o!==t){switch(s=n.substring(o,t),s){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return s+=String.fromCharCode(ie),t++,f=16}}function J(ie){if(P(ie)||u(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let ie;do ie=C();while(ie>=12&&ie<=15);return ie}return{setPosition:j,getPosition:()=>t,scan:r?ne:C,getToken:()=>f,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>S}}function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function u(n){return n===10||n===13||n===8232||n===8233}function a(n){return n>=48&&n<=57}var h;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(h||(h={}));function b(n,r){const t=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function S(k,j,L,q){o.value=k,o.offset=j,o.length=L,o.type=q,o.colonOffset=void 0,s=o}try{v(n,{onObjectBegin:(k,j)=>{if(r<=k)throw i;s=void 0,f=r>k,t.push("")},onObjectProperty:(k,j,L)=>{if(r<j||(S(k,j,L,"property"),t[t.length-1]=k,r<=j+L))throw i},onObjectEnd:(k,j)=>{if(r<=k)throw i;s=void 0,t.pop()},onArrayBegin:(k,j)=>{if(r<=k)throw i;s=void 0,t.push(0)},onArrayEnd:(k,j)=>{if(r<=k)throw i;s=void 0,t.pop()},onLiteralValue:(k,j,L)=>{if(r<j||(S(k,j,L,g(k)),r<=j+L))throw i},onSeparator:(k,j,L)=>{if(r<=j)throw i;if(k===":"&&s&&s.type==="property")s.colonOffset=j,f=!1,s=void 0;else if(k===","){const q=t[t.length-1];typeof q=="number"?t[t.length-1]=q+1:(f=!0,t[t.length-1]=""),s=void 0}}})}catch(k){if(k!==i)throw k}return{path:t,previousNode:s,isAtPropertyKey:f,matches:k=>{let j=0;for(let L=0;j<k.length&&L<t.length;L++)if(k[j]===t[L]||k[j]==="*")j++;else if(k[j]!=="**")return!1;return j===k.length}}}function y(n,r=[],t=N.DEFAULT){let i=null,s=[];const o=[];function f(k){Array.isArray(s)?s.push(k):i!==null&&(s[i]=k)}return v(n,{onObjectBegin:()=>{const k={};f(k),o.push(s),s=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const k=[];f(k),o.push(s),s=k,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:f,onError:(k,j,L)=>{r.push({error:k,offset:j,length:L})}},t),s[0]}function w(n,r=[],t=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(k){i.type==="property"&&(i.length=k-i.offset,i=i.parent)}function o(k){return i.children.push(k),k}v(n,{onObjectBegin:k=>{i=o({type:"object",offset:k,length:-1,parent:i,children:[]})},onObjectProperty:(k,j,L)=>{i=o({type:"property",offset:j,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:k,offset:j,length:L,parent:i})},onObjectEnd:(k,j)=>{i.length=k+j-i.offset,i=i.parent,s(k+j)},onArrayBegin:(k,j)=>{i=o({type:"array",offset:k,length:-1,parent:i,children:[]})},onArrayEnd:(k,j)=>{i.length=k+j-i.offset,i=i.parent,s(k+j)},onLiteralValue:(k,j,L)=>{o({type:g(k),offset:j,length:L,parent:i,value:k}),s(j+L)},onSeparator:(k,j,L)=>{i.type==="property"&&(k===":"?i.colonOffset=j:k===","&&s(j))},onError:(k,j,L)=>{r.push({error:k,offset:j,length:L})}},t);const S=i.children[0];return S&&delete S.parent,S}function $(n,r){if(!n)return;let t=n;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function R(n){if(!n.parent||!n.parent.children)return[];const r=R(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}function d(n){switch(n.type){case"array":return n.children.map(d);case"object":{const r=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(r[t.children[0].value]=d(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}function l(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}function c(n,r,t=!1){if(l(n,r,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const o=c(i[s],r,t);if(o)return o}return n}}function v(n,r,t=N.DEFAULT){const i=A(n,!1);function s(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Y){return Y?_=>Y(_,i.getTokenOffset(),i.getTokenLength()):()=>!0}const f=s(r.onObjectBegin),S=o(r.onObjectProperty),k=s(r.onObjectEnd),j=s(r.onArrayBegin),L=s(r.onArrayEnd),q=o(r.onLiteralValue),C=o(r.onSeparator),J=s(r.onComment),ne=o(r.onError),ie=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function le(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ie||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(Y){case 12:case 13:ie?ce(10):J();break;case 16:ce(1);break;case 15:case 14:break;default:return Y}}}function ce(Y,_=[],F=[]){if(ne(Y),_.length+F.length>0){let U=i.getToken();for(;U!==17;){if(_.indexOf(U)!==-1){le();break}else if(F.indexOf(U)!==-1)break;U=le()}}}function V(Y){const _=i.getTokenValue();return Y?q(_):S(_),le(),!0}function Z(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(ce(2),Y=0)}catch{ce(2)}q(Y);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return le(),!0}function B(){return i.getToken()!==10?(ce(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(C(":"),le(),Q()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function T(){f(),le();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||ce(4,[],[]),C(","),le(),i.getToken()===2&&ue)break}else Y&&ce(6,[],[]);B()||ce(4,[],[2,5]),Y=!0}return k(),i.getToken()!==2?ce(7,[2],[]):le(),!0}function H(){j(),le();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||ce(4,[],[]),C(","),le(),i.getToken()===4&&ue)break}else Y&&ce(6,[],[]);Q()||ce(4,[],[4,5]),Y=!0}return L(),i.getToken()!==4?ce(8,[4],[]):le(),!0}function Q(){switch(i.getToken()){case 3:return H();case 1:return T();case 10:return V(!0);default:return Z()}}return le(),i.getToken()===17?t.allowEmptyContent?!0:(ce(4,[],[]),!1):Q()?(i.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function p(n,r){const t=A(n),i=[];let s,o=0,f;do switch(f=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==f&&i.push(n.substring(o,f)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return i.join("")}function g(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[75],re([0,1,38]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=D,e.$Wn=I,e.$Xn=P,e.$Yn=u;function D(a,h,b){let y,w,$,R,d;if(h){for(R=h.offset,d=R+h.length,$=R;$>0&&!u(a,$-1);)$--;let f=d;for(;f<a.length&&!u(a,f);)f++;w=a.substring($,f),y=A(w,b)}else w=a,y=0,$=0,R=0,d=a.length;const l=P(b,a);let c=!1,v=0,p;b.insertSpaces?p=N(" ",b.tabSize||4):p="	";const g=(0,O.$Jn)(w,!1);let n=!1;function r(){return l+N(p,y+v)}function t(){let f=g.scan();for(c=!1;f===15||f===14;)c=c||f===14,f=g.scan();return n=f===16||g.getTokenError()!==0,f}const i=[];function s(f,S,k){!n&&S<d&&k>R&&a.substring(S,k)!==f&&i.push({offset:S,length:k-S,content:f})}let o=t();if(o!==17){const f=g.getTokenOffset()+$,S=N(p,y);s(S,$,f)}for(;o!==17;){let f=g.getTokenOffset()+g.getTokenLength()+$,S=t(),k="";for(;!c&&(S===12||S===13);){const L=g.getTokenOffset()+$;s(" ",f,L),f=g.getTokenOffset()+g.getTokenLength()+$,k=S===12?r():"",S=t()}if(S===2)o!==1&&(v--,k=r());else if(S===4)o!==3&&(v--,k=r());else{switch(o){case 3:case 1:v++,k=r();break;case 5:case 12:k=r();break;case 13:c?k=r():k=" ";break;case 6:k=" ";break;case 10:if(S===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?k=" ":S!==5&&S!==17&&(n=!0);break;case 16:n=!0;break}c&&(S===12||S===13)&&(k=r())}const j=g.getTokenOffset()+$;s(k,f,j),o=S}return i}function I(a,h){const b=JSON.stringify(a,void 0,h.insertSpaces?h.tabSize||4:"	");return h.eol!==void 0?b.replace(/\r\n|\r|\n/g,h.eol):b}function N(a,h){let b="";for(let y=0;y<h;y++)b+=a;return b}function A(a,h){let b=0,y=0;const w=h.tabSize||4;for(;b<a.length;){const $=a.charAt(b);if($===" ")y++;else if($==="	")y+=w;else break;b++}return Math.floor(y/w)}function P(a,h){for(let b=0;b<h.length;b++){const y=h.charAt(b);if(y==="\r")return b+1<h.length&&h.charAt(b+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return a&&a.eol||`
`}function u(a,h){return`\r
`.indexOf(a.charAt(h))!==-1}}),define(se[76],re([0,1,38,75]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=I,e.$1n=N,e.$2n=A,e.$3n=P,e.$4n=u;function I(a,h,b){return N(a,h,void 0,b)}function N(a,h,b,y,w){const $=h.slice(),R=[],d=(0,O.$Mn)(a,R);let l,c;for(;$.length>0&&(c=$.pop(),l=(0,O.$Nn)(d,$),l===void 0&&b!==void 0);)typeof c=="string"?b={[c]:b}:b=[b];if(l)if(l.type==="object"&&typeof c=="string"&&Array.isArray(l.children)){const v=(0,O.$Nn)(l,[c]);if(v!==void 0)if(b===void 0){if(!v.parent)throw new Error("Malformed AST");const p=l.children.indexOf(v.parent);let g,n=v.parent.offset+v.parent.length;if(p>0){const r=l.children[p-1];g=r.offset+r.length}else g=l.offset+1,l.children.length>1&&(n=l.children[1].offset);return A(a,{offset:g,length:n-g,content:""},y)}else return A(a,{offset:v.offset,length:v.length,content:JSON.stringify(b)},y);else{if(b===void 0)return[];const p=`${JSON.stringify(c)}: ${JSON.stringify(b)}`,g=w?w(l.children.map(r=>r.children[0].value)):l.children.length;let n;if(g>0){const r=l.children[g-1];n={offset:r.offset+r.length,length:0,content:","+p}}else l.children.length===0?n={offset:l.offset+1,length:0,content:p}:n={offset:l.offset+1,length:0,content:p+","};return A(a,n,y)}}else if(l.type==="array"&&typeof c=="number"&&Array.isArray(l.children))if(b!==void 0){const v=`${JSON.stringify(b)}`;let p;if(l.children.length===0||c===0)p={offset:l.offset+1,length:0,content:l.children.length===0?v:v+","};else{const g=c===-1||c>l.children.length?l.children.length:c,n=l.children[g-1];p={offset:n.offset+n.length,length:0,content:","+v}}return A(a,p,y)}else{const v=c,p=l.children[v];let g;if(l.children.length===1)g={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===v){const n=l.children[v-1],r=n.offset+n.length,t=l.offset+l.length;g={offset:r,length:t-2-r,content:""}}else g={offset:p.offset,length:l.children[v+1].offset-p.offset,content:""};return A(a,g,y)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${l.type}`);else return b===void 0?[]:A(a,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(b)},y)}function A(a,h,b){let y=P(a,h),w=h.offset,$=h.offset+h.content.length;if(h.length===0||h.content.length===0){for(;w>0&&!(0,D.$Yn)(y,w-1);)w--;for(;$<y.length&&!(0,D.$Yn)(y,$);)$++}const R=(0,D.$Vn)(y,{offset:w,length:$-w},b);for(let l=R.length-1;l>=0;l--){const c=R[l];y=P(y,c),w=Math.min(w,c.offset),$=Math.max($,c.offset+c.length),$+=c.content.length-c.length}const d=a.length-(y.length-$)-w;return[{offset:w,length:d,content:y.substring(w,$)}]}function P(a,h){return a.substring(0,h.offset)+h.content+a.substring(h.offset+h.length)}function u(a,h){const b=h.slice(0).sort((w,$)=>{const R=w.offset-$.offset;return R===0?w.length-$.length:R});let y=a.length;for(let w=b.length-1;w>=0;w--){const $=b[w];if($.offset+$.length<=y)a=P(a,$);else throw new Error("Overlapping edit");y=$.offset}return a}}),define(se[77],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=O,e.rot=D;function O(P,u,a){return Math.min(Math.max(P,u),a)}function D(P,u){return(u+P%u)%u}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=I;class N{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=N;class A{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=A}),function(){function X(I){const N=[];typeof I=="number"&&N.push("code/timeOrigin",I);function A(u){N.push(u,Date.now())}function P(){const u=[];for(let a=0;a<N.length;a+=2)u.push({name:N[a],startTime:N[a+1]});return u}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(I+A.startTime)});return N}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function O(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=O(D))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var D in O)(typeof exports=="object"?exports:X)[D]=O[D]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function O(D){if(e[D])return e[D].exports;var I=e[D]={i:D,l:!1,exports:{}};return X[D].call(I.exports,I,I.exports,O),I.l=!0,I.exports}return O.m=X,O.c=e,O.d=function(D,I,N){O.o(D,I)||Object.defineProperty(D,I,{enumerable:!0,get:N})},O.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},O.t=function(D,I){if(1&I&&(D=O(D)),8&I||4&I&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(O.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&I&&typeof D!="string")for(var A in D)O.d(N,A,function(P){return D[P]}.bind(null,A));return N},O.n=function(D){var I=D&&D.__esModule?function(){return D.default}:function(){return D};return O.d(I,"a",I),I},O.o=function(D,I){return Object.prototype.hasOwnProperty.call(D,I)},O.p="",O(O.s=0)}([function(X,e,O){(function(D){var I;e=X.exports=F,I=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],u=e.src=[],a=0,h=a++;u[h]="0|[1-9]\\d*";var b=a++;u[b]="[0-9]+";var y=a++;u[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=a++;u[w]="("+u[h]+")\\.("+u[h]+")\\.("+u[h]+")";var $=a++;u[$]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var R=a++;u[R]="(?:"+u[h]+"|"+u[y]+")";var d=a++;u[d]="(?:"+u[b]+"|"+u[y]+")";var l=a++;u[l]="(?:-("+u[R]+"(?:\\."+u[R]+")*))";var c=a++;u[c]="(?:-?("+u[d]+"(?:\\."+u[d]+")*))";var v=a++;u[v]="[0-9A-Za-z-]+";var p=a++;u[p]="(?:\\+("+u[v]+"(?:\\."+u[v]+")*))";var g=a++,n="v?"+u[w]+u[l]+"?"+u[p]+"?";u[g]="^"+n+"$";var r="[v=\\s]*"+u[$]+u[c]+"?"+u[p]+"?",t=a++;u[t]="^"+r+"$";var i=a++;u[i]="((?:<|>)?=?)";var s=a++;u[s]=u[b]+"|x|X|\\*";var o=a++;u[o]=u[h]+"|x|X|\\*";var f=a++;u[f]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[l]+")?"+u[p]+"?)?)?";var S=a++;u[S]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[c]+")?"+u[p]+"?)?)?";var k=a++;u[k]="^"+u[i]+"\\s*"+u[f]+"$";var j=a++;u[j]="^"+u[i]+"\\s*"+u[S]+"$";var L=a++;u[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=a++;u[q]="(?:~>?)";var C=a++;u[C]="(\\s*)"+u[q]+"\\s+",P[C]=new RegExp(u[C],"g");var J=a++;u[J]="^"+u[q]+u[f]+"$";var ne=a++;u[ne]="^"+u[q]+u[S]+"$";var ie=a++;u[ie]="(?:\\^)";var ue=a++;u[ue]="(\\s*)"+u[ie]+"\\s+",P[ue]=new RegExp(u[ue],"g");var le=a++;u[le]="^"+u[ie]+u[f]+"$";var ce=a++;u[ce]="^"+u[ie]+u[S]+"$";var V=a++;u[V]="^"+u[i]+"\\s*("+r+")$|^$";var Z=a++;u[Z]="^"+u[i]+"\\s*("+n+")$|^$";var B=a++;u[B]="(\\s*)"+u[i]+"\\s*("+r+"|"+u[f]+")",P[B]=new RegExp(u[B],"g");var T=a++;u[T]="^\\s*("+u[f]+")\\s+-\\s+("+u[f]+")\\s*$";var H=a++;u[H]="^\\s*("+u[S]+")\\s+-\\s+("+u[S]+")\\s*$";var Q=a++;u[Q]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)I(Y,u[Y]),P[Y]||(P[Y]=new RegExp(u[Y]));function _(x,K){if(x instanceof F)return x;if(typeof x!="string"||x.length>N||!(K?P[t]:P[g]).test(x))return null;try{return new F(x,K)}catch{return null}}function F(x,K){if(x instanceof F){if(x.loose===K)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof F))return new F(x,K);I("SemVer",x,K),this.loose=K;var ee=x.trim().match(K?P[t]:P[g]);if(!ee)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ve=+ge;if(ve>=0&&ve<A)return ve}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(x,K){var ee=_(x,K);return ee?ee.version:null},e.clean=function(x,K){var ee=_(x.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(x){return I("SemVer.compare",this.version,this.loose,x),x instanceof F||(x=new F(x,this.loose)),this.compareMain(x)||this.comparePre(x)},F.prototype.compareMain=function(x){return x instanceof F||(x=new F(x,this.loose)),m(this.major,x.major)||m(this.minor,x.minor)||m(this.patch,x.patch)},F.prototype.comparePre=function(x){if(x instanceof F||(x=new F(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],ge=x.prerelease[K];if(I("prerelease compare",K,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return m(ee,ge)}while(++K)},F.prototype.inc=function(x,K){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,K,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new F(x,ee).inc(K,ge).version}catch{return null}},e.diff=function(x,K){if(G(x,K))return null;var ee=_(x),ge=_(K);if(ee.prerelease.length||ge.prerelease.length){for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return"pre"+ve;return"prerelease"}for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return ve},e.compareIdentifiers=m;var U=/^[0-9]+$/;function m(x,K){var ee=U.test(x),ge=U.test(K);return ee&&ge&&(x=+x,K=+K),ee&&!ge?-1:ge&&!ee?1:x<K?-1:x>K?1:0}function E(x,K,ee){return new F(x,ee).compare(new F(K,ee))}function z(x,K,ee){return E(x,K,ee)>0}function M(x,K,ee){return E(x,K,ee)<0}function G(x,K,ee){return E(x,K,ee)===0}function W(x,K,ee){return E(x,K,ee)!==0}function te(x,K,ee){return E(x,K,ee)>=0}function ae(x,K,ee){return E(x,K,ee)<=0}function he(x,K,ee,ge){var ve;switch(K){case"===":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),ve=x===ee;break;case"!==":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),ve=x!==ee;break;case"":case"=":case"==":ve=G(x,ee,ge);break;case"!=":ve=W(x,ee,ge);break;case">":ve=z(x,ee,ge);break;case">=":ve=te(x,ee,ge);break;case"<":ve=M(x,ee,ge);break;case"<=":ve=ae(x,ee,ge);break;default:throw new TypeError("Invalid operator: "+K)}return ve}function pe(x,K){if(x instanceof pe){if(x.loose===K)return x;x=x.value}if(!(this instanceof pe))return new pe(x,K);I("comparator",x,K),this.loose=K,this.parse(x),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(x,K){return m(K,x)},e.major=function(x,K){return new F(x,K).major},e.minor=function(x,K){return new F(x,K).minor},e.patch=function(x,K){return new F(x,K).patch},e.compare=E,e.compareLoose=function(x,K){return E(x,K,!0)},e.rcompare=function(x,K,ee){return E(K,x,ee)},e.sort=function(x,K){return x.sort(function(ee,ge){return e.compare(ee,ge,K)})},e.rsort=function(x,K){return x.sort(function(ee,ge){return e.rcompare(ee,ge,K)})},e.gt=z,e.lt=M,e.eq=G,e.neq=W,e.gte=te,e.lte=ae,e.cmp=he,e.Comparator=pe;var ye={};function fe(x,K){if(x instanceof fe)return x.loose===K?x:new fe(x.raw,K);if(x instanceof pe)return new fe(x.value,K);if(!(this instanceof fe))return new fe(x,K);if(this.loose=K,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function me(x){return!x||x.toLowerCase()==="x"||x==="*"}function de(x,K,ee,ge,ve,Oe,Se,Le,je,Ae,qe,De,Ne){return((K=me(ee)?"":me(ge)?">="+ee+".0.0":me(ve)?">="+ee+"."+ge+".0":">="+K)+" "+(Le=me(je)?"":me(Ae)?"<"+(+je+1)+".0.0":me(qe)?"<"+je+"."+(+Ae+1)+".0":De?"<="+je+"."+Ae+"."+qe+"-"+De:"<="+Le)).trim()}function we(x,K){for(var ee=0;ee<x.length;ee++)if(!x[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<x.length;ee++)if(I(x[ee].semver),x[ee].semver!==ye&&x[ee].semver.prerelease.length>0){var ge=x[ee].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function Ee(x,K,ee){try{K=new fe(K,ee)}catch{return!1}return K.test(x)}function Ie(x,K,ee,ge){var ve,Oe,Se,Le,je;switch(x=new F(x,ge),K=new fe(K,ge),ee){case">":ve=z,Oe=ae,Se=M,Le=">",je=">=";break;case"<":ve=M,Oe=te,Se=z,Le="<",je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(x,K,ge))return!1;for(var Ae=0;Ae<K.set.length;++Ae){var qe=K.set[Ae],De=null,Ne=null;if(qe.forEach(function(ze){ze.semver===ye&&(ze=new pe(">=0.0.0")),De=De||ze,Ne=Ne||ze,ve(ze.semver,De.semver,ge)?De=ze:Se(ze.semver,Ne.semver,ge)&&(Ne=ze)}),De.operator===Le||De.operator===je||(!Ne.operator||Ne.operator===Le)&&Oe(x,Ne.semver)||Ne.operator===je&&Se(x,Ne.semver))return!1}return!0}pe.prototype.parse=function(x){var K=this.loose?P[V]:P[Z],ee=x.match(K);if(!ee)throw new TypeError("Invalid comparator: "+x);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new F(ee[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(x){return I("Comparator.test",x,this.loose),this.semver===ye||(typeof x=="string"&&(x=new F(x,this.loose)),he(x,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(x,K){if(!(x instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(x.value,K),Ee(this.value,ee,K);if(x.operator==="")return ee=new fe(this.value,K),Ee(x.semver,ee,K);var ge=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Oe=this.semver.version===x.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=he(this.semver,"<",x.semver,K)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),je=he(this.semver,">",x.semver,K)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ge||ve||Oe&&Se||Le||je},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(x){var K=this.loose;x=x.trim(),I("range",x,K);var ee=K?P[H]:P[T];x=x.replace(ee,de),I("hyphen replace",x),x=x.replace(P[B],"$1$2$3"),I("comparator trim",x,P[B]),x=(x=(x=x.replace(P[C],"$1~")).replace(P[ue],"$1^")).split(/\s+/).join(" ");var ge=K?P[V]:P[Z],ve=x.split(" ").map(function(Oe){return function(Se,Le){return I("comp",Se),Se=function(je,Ae){return je.trim().split(/\s+/).map(function(qe){return function(De,Ne){I("caret",De,Ne);var ze=Ne?P[ce]:P[le];return De.replace(ze,function(Fe,be,Pe,ke,Re){var Ue;return I("caret",De,Fe,be,Pe,ke,Re),me(be)?Ue="":me(Pe)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(ke)?Ue=be==="0"?">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+".0 <"+(+be+1)+".0.0":Re?(I("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+ke+Re+" <"+be+"."+Pe+"."+(+ke+1):">="+be+"."+Pe+"."+ke+Re+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+ke+Re+" <"+(+be+1)+".0.0"):(I("no pr"),Ue=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+ke+" <"+be+"."+Pe+"."+(+ke+1):">="+be+"."+Pe+"."+ke+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+ke+" <"+(+be+1)+".0.0"),I("caret return",Ue),Ue})}(qe,Ae)}).join(" ")}(Se,Le),I("caret",Se),Se=function(je,Ae){return je.trim().split(/\s+/).map(function(qe){return function(De,Ne){var ze=Ne?P[ne]:P[J];return De.replace(ze,function(Fe,be,Pe,ke,Re){var Ue;return I("tilde",De,Fe,be,Pe,ke,Re),me(be)?Ue="":me(Pe)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(ke)?Ue=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":Re?(I("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=">="+be+"."+Pe+"."+ke+Re+" <"+be+"."+(+Pe+1)+".0"):Ue=">="+be+"."+Pe+"."+ke+" <"+be+"."+(+Pe+1)+".0",I("tilde return",Ue),Ue})}(qe,Ae)}).join(" ")}(Se,Le),I("tildes",Se),Se=function(je,Ae){return I("replaceXRanges",je,Ae),je.split(/\s+/).map(function(qe){return function(De,Ne){De=De.trim();var ze=Ne?P[j]:P[k];return De.replace(ze,function(Fe,be,Pe,ke,Re,Ue){I("xRange",De,Fe,be,Pe,ke,Re,Ue);var Ce=me(Pe),Me=Ce||me(ke),Te=Me||me(Re);return be==="="&&Te&&(be=""),Ce?Fe=be===">"||be==="<"?"<0.0.0":"*":be&&Te?(Me&&(ke=0),Te&&(Re=0),be===">"?(be=">=",Me?(Pe=+Pe+1,ke=0,Re=0):Te&&(ke=+ke+1,Re=0)):be==="<="&&(be="<",Me?Pe=+Pe+1:ke=+ke+1),Fe=be+Pe+"."+ke+"."+Re):Me?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Te&&(Fe=">="+Pe+"."+ke+".0 <"+Pe+"."+(+ke+1)+".0"),I("xRange return",Fe),Fe})}(qe,Ae)}).join(" ")}(Se,Le),I("xrange",Se),Se=function(je,Ae){return I("replaceStars",je,Ae),je.trim().replace(P[Q],"")}(Se,Le),I("stars",Se),Se}(Oe,K)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Oe){return!!Oe.match(ge)})),ve=ve.map(function(Oe){return new pe(Oe,K)})},fe.prototype.intersects=function(x,K){if(!(x instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return x.set.some(function(ve){return ve.every(function(Oe){return ge.intersects(Oe,K)})})})})},e.toComparators=function(x,K){return new fe(x,K).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new F(x,this.loose));for(var K=0;K<this.set.length;K++)if(we(this.set[K],x))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(x,K,ee){var ge=null,ve=null;try{var Oe=new fe(K,ee)}catch{return null}return x.forEach(function(Se){Oe.test(Se)&&(ge&&ve.compare(Se)!==-1||(ve=new F(ge=Se,ee)))}),ge},e.minSatisfying=function(x,K,ee){var ge=null,ve=null;try{var Oe=new fe(K,ee)}catch{return null}return x.forEach(function(Se){Oe.test(Se)&&(ge&&ve.compare(Se)!==1||(ve=new F(ge=Se,ee)))}),ge},e.validRange=function(x,K){try{return new fe(x,K).range||"*"}catch{return null}},e.ltr=function(x,K,ee){return Ie(x,K,"<",ee)},e.gtr=function(x,K,ee){return Ie(x,K,">",ee)},e.outside=Ie,e.prerelease=function(x,K){var ee=_(x,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(x,K,ee){return x=new fe(x,ee),K=new fe(K,ee),x.intersects(K)},e.coerce=function(x){if(x instanceof F)return x;if(typeof x!="string")return null;var K=x.match(P[L]);return K==null?null:_((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,O(1))},function(X,e){var O,D,I=X.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(d){if(O===setTimeout)return setTimeout(d,0);if((O===N||!O)&&setTimeout)return O=setTimeout,setTimeout(d,0);try{return O(d,0)}catch{try{return O.call(null,d,0)}catch{return O.call(this,d,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:N}catch{O=N}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var u,a=[],h=!1,b=-1;function y(){h&&u&&(h=!1,u.length?a=u.concat(a):b=-1,a.length&&w())}function w(){if(!h){var d=P(y);h=!0;for(var l=a.length;l;){for(u=a,a=[];++b<l;)u&&u[b].run();b=-1,l=a.length}u=null,h=!1,function(c){if(D===clearTimeout)return clearTimeout(c);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(c);try{D(c)}catch{try{return D.call(null,c)}catch{return D.call(this,c)}}}(d)}}function $(d,l){this.fun=d,this.array=l}function R(){}I.nextTick=function(d){var l=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)l[c-1]=arguments[c];a.push(new $(d,l)),a.length!==1||h||P(w)},$.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=R,I.addListener=R,I.once=R,I.off=R,I.removeListener=R,I.removeAllListeners=R,I.emit=R,I.prependListener=R,I.prependOnceListener=R,I.listeners=function(d){return[]},I.binding=function(d){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(d){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(se[78],re([0,1]),function(X,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0;class D{constructor(P,u,a){this.level=P,this.key=u,this.value=a,this.forward=[]}}const I=void 0;class N{constructor(P,u=2**16){this.comparator=P,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,I,I)}get size(){return this.f}clear(){this.e=new D(this.c,I,I),this.f=0}has(P){return!!N.g(this,P,this.comparator)}get(P){return N.g(this,P,this.comparator)?.value}set(P,u){return N.h(this,P,u,this.comparator)&&(this.f+=1),this}delete(P){const u=N.k(this,P,this.comparator);return u&&(this.f-=1),u}forEach(P,u){let a=this.e.forward[0];for(;a;)P.call(u,a.value,a.key,this),a=a.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",u=this.e.forward[0];for(;u;)P+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return P}static g(P,u,a){let h=P.e;for(let b=P.d-1;b>=0;b--)for(;h.forward[b]&&a(h.forward[b].key,u)<0;)h=h.forward[b];if(h=h.forward[0],h&&a(h.key,u)===0)return h}static h(P,u,a,h){const b=[];let y=P.e;for(let w=P.d-1;w>=0;w--){for(;y.forward[w]&&h(y.forward[w].key,u)<0;)y=y.forward[w];b[w]=y}if(y=y.forward[0],y&&h(y.key,u)===0)return y.value=a,!1;{const w=N.j(P);if(w>P.d){for(let $=P.d;$<w;$++)b[$]=P.e;P.d=w}y=new D(w,u,a);for(let $=0;$<w;$++)y.forward[$]=b[$].forward[$],b[$].forward[$]=y;return!0}}static j(P,u=.5){let a=1;for(;Math.random()<u&&a<P.c;)a+=1;return a}static k(P,u,a){const h=[];let b=P.e;for(let y=P.d-1;y>=0;y--){for(;b.forward[y]&&a(b.forward[y].key,u)<0;)b=b.forward[y];h[y]=b}if(b=b.forward[0],!b||a(b.key,u)!==0)return!1;for(let y=0;y<P.d&&h[y].forward[y]===b;y++)h[y].forward[y]=b.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===I;)P.d-=1;return!0}}e.$Ds=N}),define(se[46],re([0,1,9,2]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=I,e.$te=N,e.$ue=A,e.$ve=P,e.$we=a,e.$xe=h,e.$ye=b,e.$ze=y,e.$Ae=w,e.$Be=$,e.$Ce=R,e.$De=d,e.$Ee=l,e.$Fe=c,e.$Ge=v;function I(p){const g=p;return g?typeof g.read=="function":!1}function N(p){const g=p;return g?[g.on,g.pause,g.resume,g.destroy].every(n=>typeof n=="function"):!1}function A(p){const g=p;return g?N(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}function P(p,g){return new u(p,g)}class u{constructor(g,n){this.e=g,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(n=>n(g))}h(g){this.c.error.length===0?(0,O.$1)(g):this.c.error.slice(0).forEach(n=>n(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,n){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(g,n){if(this.a.destroyed)return;let r;switch(g){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(p,g){const n=[];let r;for(;(r=p.read())!==null;)n.push(r);return g(n)}function h(p,g,n){const r=[];let t;for(;(t=p.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?g(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return p.read()}}}function b(p,g){return new Promise((n,r)=>{const t=[];y(p,{onData:i=>{g&&t.push(i)},onError:i=>{g?r(i):n(void 0)},onEnd:()=>{n(g?g(t):void 0)}})})}function y(p,g,n){p.on("error",r=>{n?.isCancellationRequested||g.onError(r)}),p.on("end",()=>{n?.isCancellationRequested||g.onEnd()}),p.on("data",r=>{n?.isCancellationRequested||g.onData(r)})}function w(p,g){return new Promise((n,r)=>{const t=new D.$Tc,i=[],s=S=>{if(i.push(S),i.length>g)return t.dispose(),p.pause(),n({stream:p,buffer:i,ended:!1})},o=S=>(t.dispose(),r(S)),f=()=>(t.dispose(),n({stream:p,buffer:i,ended:!0}));t.add((0,D.$Sc)(()=>p.removeListener("error",o))),p.on("error",o),t.add((0,D.$Sc)(()=>p.removeListener("end",f))),p.on("end",f),t.add((0,D.$Sc)(()=>p.removeListener("data",s))),p.on("data",s)})}function $(p,g){const n=P(g);return n.end(p),n}function R(){const p=P(()=>{throw new Error("not supported")});return p.end(),p}function d(p){let g=!1;return{read:()=>g?null:(g=!0,p)}}function l(p,g,n){const r=P(n);return y(p,{onData:t=>r.write(g.data(t)),onError:t=>r.error(g.error?g.error(t):t),onEnd:()=>r.end()}),r}function c(p,g,n){let r=!1;return{read:()=>{const t=g.read();return r?t:(r=!0,t!==null?n([p,t]):p)}}}function v(p,g,n){let r=!1;const t=P(n);return y(g,{onData:i=>r?t.write(i):(r=!0,t.write(n([p,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(p)),t.end()}}),t}}),define(se[14],re([0,1,169,46]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=a,e.$Je=h,e.$Ke=b,e.$Le=y,e.$Me=w,e.$Ne=$,e.$Oe=R,e.$Pe=d,e.$Qe=l,e.$Re=c,e.$Se=v,e.$Te=p,e.$Ue=g,e.$Ve=n,e.$We=r,e.$Xe=t,e.$Ye=i,e.$Ze=s,e.$1e=o,e.$2e=k;const I=typeof Buffer<"u",N=new O.$V(()=>new Uint8Array(256));let A,P;class u{static alloc(L){return I?new u(Buffer.allocUnsafe(L)):new u(new Uint8Array(L))}static wrap(L){return I&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new u(L)}static fromString(L,q){return!(q?.dontUseNodeBuffer||!1)&&I?new u(Buffer.from(L)):(A||(A=new TextEncoder),new u(A.encode(L)))}static fromByteArray(L){const q=u.alloc(L.length);for(let C=0,J=L.length;C<J;C++)q.buffer[C]=L[C];return q}static concat(L,q){if(typeof q>"u"){q=0;for(let ne=0,ie=L.length;ne<ie;ne++)q+=L[ne].byteLength}const C=u.alloc(q);let J=0;for(let ne=0,ie=L.length;ne<ie;ne++){const ue=L[ne];C.set(ue,J),J+=ue.byteLength}return C}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=u.alloc(this.byteLength);return L.set(this),L}toString(){return I?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(L,q){return new u(this.buffer.subarray(L,q))}set(L,q){if(L instanceof u)this.buffer.set(L.buffer,q);else if(L instanceof Uint8Array)this.buffer.set(L,q);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),q);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),q);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return y(this.buffer,L)}writeUInt32BE(L,q){w(this.buffer,L,q)}readUInt32LE(L){return $(this.buffer,L)}writeUInt32LE(L,q){R(this.buffer,L,q)}readUInt8(L){return d(this.buffer,L)}writeUInt8(L,q){l(this.buffer,L,q)}indexOf(L,q=0){return a(this.buffer,L instanceof u?L.buffer:L,q)}}e.$He=u;function a(j,L,q=0){const C=L.byteLength,J=j.byteLength;if(C===0)return 0;if(C===1)return j.indexOf(L[0]);if(C>J-q)return-1;const ne=N.value;ne.fill(L.length);for(let ce=0;ce<L.length;ce++)ne[L[ce]]=L.length-ce-1;let ie=q+L.length-1,ue=ie,le=-1;for(;ie<J;)if(j[ie]===L[ue]){if(ue===0){le=ie;break}ie--,ue--}else ie+=Math.max(L.length-ue,ne[j[ie]]),ue=L.length-1;return le}function h(j,L){return j[L+0]<<0>>>0|j[L+1]<<8>>>0}function b(j,L,q){j[q+0]=L&255,L=L>>>8,j[q+1]=L&255}function y(j,L){return j[L]*2**24+j[L+1]*2**16+j[L+2]*2**8+j[L+3]}function w(j,L,q){j[q+3]=L,L=L>>>8,j[q+2]=L,L=L>>>8,j[q+1]=L,L=L>>>8,j[q]=L}function $(j,L){return j[L+0]<<0>>>0|j[L+1]<<8>>>0|j[L+2]<<16>>>0|j[L+3]<<24>>>0}function R(j,L,q){j[q+0]=L&255,L=L>>>8,j[q+1]=L&255,L=L>>>8,j[q+2]=L&255,L=L>>>8,j[q+3]=L&255}function d(j,L){return j[L]}function l(j,L,q){j[q]=L}function c(j){return D.$we(j,L=>u.concat(L))}function v(j){return D.$De(j)}function p(j){return D.$ye(j,L=>u.concat(L))}async function g(j){return j.ended?u.concat(j.buffer):u.concat([...j.buffer,await p(j.stream)])}function n(j){return D.$Be(j,L=>u.concat(L))}function r(j){return D.$Ee(j,{data:L=>typeof L=="string"?u.fromString(L):u.wrap(L)},L=>u.concat(L))}function t(j){return D.$ve(L=>u.concat(L),j)}function i(j,L){return D.$Fe(j,L,q=>u.concat(q))}function s(j,L){return D.$Ge(j,L,q=>u.concat(q))}function o(j){let L=0,q=0,C=0;const J=new Uint8Array(Math.floor(j.length/4*3)),ne=ue=>{switch(q){case 3:J[C++]=L|ue,q=0;break;case 2:J[C++]=L|ue>>>2,L=ue<<6,q=3;break;case 1:J[C++]=L|ue>>>4,L=ue<<4,q=2;break;default:L=ue<<2,q=1}};for(let ue=0;ue<j.length;ue++){const le=j.charCodeAt(ue);if(le>=65&&le<=90)ne(le-65);else if(le>=97&&le<=122)ne(le-97+26);else if(le>=48&&le<=57)ne(le-48+52);else if(le===43||le===45)ne(62);else if(le===47||le===95)ne(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${j[ue]}`)}}const ie=C;for(;q>0;)ne(0);return u.wrap(J).slice(0,ie)}const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:j},L=!0,q=!1){const C=q?S:f;let J="";const ne=j.byteLength%3;let ie=0;for(;ie<j.byteLength-ne;ie+=3){const ue=j[ie+0],le=j[ie+1],ce=j[ie+2];J+=C[ue>>>2],J+=C[(ue<<4|le>>>4)&63],J+=C[(le<<2|ce>>>6)&63],J+=C[ce&63]}if(ne===1){const ue=j[ie+0];J+=C[ue>>>2],J+=C[ue<<4&63],L&&(J+="==")}else if(ne===2){const ue=j[ie+0],le=j[ie+1];J+=C[ue>>>2],J+=C[(ue<<4|le>>>4)&63],J+=C[le<<2&63],L&&(J+="=")}return J}}),define(se[43],re([0,1,31]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$qj=void 0,e.$mj=D,e.$nj=I,e.$oj=N,e.$pj=P,e.$rj=R;function D(l){return I(l,0)}function I(l,c){switch(typeof l){case"object":return l===null?N(349,c):Array.isArray(l)?u(l,c):a(l,c);case"string":return P(l,c);case"boolean":return A(l,c);case"number":return N(l,c);case"undefined":return N(937,c);default:return N(617,c)}}function N(l,c){return(c<<5)-c+l|0}function A(l,c){return N(l?433:863,c)}function P(l,c){c=N(149417,c);for(let v=0,p=l.length;v<p;v++)c=N(l.charCodeAt(v),c);return c}function u(l,c){return c=N(104579,c),l.reduce((v,p)=>I(p,v),c)}function a(l,c){return c=N(181387,c),Object.keys(l).sort().reduce((v,p)=>(v=P(p,v),I(l[p],v)),c)}class h{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=I(c,this.g),this.g}}e.$qj=h;var b;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function y(l,c,v=32){const p=v-c,g=~((1<<p)-1);return(l<<c|(g&l)>>>p)>>>0}function w(l,c=0,v=l.byteLength,p=0){for(let g=0;g<v;g++)l[c+g]=p}function $(l,c,v="0"){for(;l.length<c;)l=v+l;return l}function R(l,c=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(v=>v.toString(16).padStart(2,"0")).join(""):$((l>>>0).toString(16),c/4)}class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const v=c.length;if(v===0)return;const p=this.p;let g=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=c.charCodeAt(0),t=0);;){let i=r;if(O.$Df(r))if(t+1<v){const s=c.charCodeAt(t+1);O.$Ef(s)?(t++,i=O.$Ff(r,s)):i=65533}else{n=r;break}else O.$Ef(r)&&(i=65533);if(g=this.w(p,g,i),t++,t<v)r=c.charCodeAt(t);else break}this.r=g,this.u=n}w(c,v,p){return p<128?c[v++]=p:p<2048?(c[v++]=192|(p&1984)>>>6,c[v++]=128|(p&63)>>>0):p<65536?(c[v++]=224|(p&61440)>>>12,c[v++]=128|(p&4032)>>>6,c[v++]=128|(p&63)>>>0):(c[v++]=240|(p&1835008)>>>18,c[v++]=128|(p&258048)>>>12,c[v++]=128|(p&4032)>>>6,c[v++]=128|(p&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,c[0]=c[64],c[1]=c[65],c[2]=c[66]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=d.g,v=this.q;for(let f=0;f<64;f+=4)c.setUint32(f,v.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)c.setUint32(f,y(c.getUint32(f-12,!1)^c.getUint32(f-32,!1)^c.getUint32(f-56,!1)^c.getUint32(f-64,!1),1),!1);let p=this.h,g=this.l,n=this.m,r=this.n,t=this.o,i,s,o;for(let f=0;f<80;f++)f<20?(i=g&n|~g&r,s=1518500249):f<40?(i=g^n^r,s=1859775393):f<60?(i=g&n|g&r|n&r,s=2400959708):(i=g^n^r,s=3395469782),o=y(p,5)+i+t+s+c.getUint32(f*4,!1)&4294967295,t=r,r=n,n=y(g,30),g=p,p=o;this.h=this.h+p&4294967295,this.l=this.l+g&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$sj=d}),define(se[55],re([0,1,31]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(D||(D={})),function(I){const N="error",A="warning",P="warn",u="info",a="ignore";function h(y){return y?O.$zf(N,y)?I.Error:O.$zf(A,y)||O.$zf(P,y)?I.Warning:O.$zf(u,y)?I.Info:I.Ignore:I.Ignore}I.fromValue=h;function b(y){switch(y){case I.Error:return N;case I.Warning:return A;case I.Info:return u;default:return a}}I.toString=b}(D||(D={})),e.default=D}),define(se[27],re([0,1,3]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=D,e.$6n=I,e.$7n=A,e.$8n=u,e.$9n=a,e.$0n=h,e.$$n=b,e.$_n=y,e.$ao=w,e.$bo=$,e.$co=R,e.$do=d,e.$eo=l;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const v=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([p,g])=>{v[p]=g&&typeof g=="object"?D(g):g}),v}function I(c){if(!c||typeof c!="object")return c;const v=[c];for(;v.length>0;){const p=v.shift();Object.freeze(p);for(const g in p)if(N.call(p,g)){const n=p[g];typeof n=="object"&&!Object.isFrozen(n)&&!(0,O.$bg)(n)&&v.push(n)}}return c}const N=Object.prototype.hasOwnProperty;function A(c,v){return P(c,v,new Set)}function P(c,v,p){if((0,O.$hg)(c))return c;const g=v(c);if(typeof g<"u")return g;if(Array.isArray(c)){const n=[];for(const r of c)n.push(P(r,v,p));return n}if((0,O.$ag)(c)){if(p.has(c))throw new Error("Cannot clone recursive data-structure");p.add(c);const n={};for(const r in c)N.call(c,r)&&(n[r]=P(c[r],v,p));return p.delete(c),n}return c}function u(c,v,p=!0){return(0,O.$ag)(c)?((0,O.$ag)(v)&&Object.keys(v).forEach(g=>{g in c?p&&((0,O.$ag)(c[g])&&(0,O.$ag)(v[g])?u(c[g],v[g],p):c[g]=v[g]):c[g]=v[g]}),c):v}function a(c,v){if(c===v)return!0;if(c==null||v===null||v===void 0||typeof c!=typeof v||typeof c!="object"||Array.isArray(c)!==Array.isArray(v))return!1;let p,g;if(Array.isArray(c)){if(c.length!==v.length)return!1;for(p=0;p<c.length;p++)if(!a(c[p],v[p]))return!1}else{const n=[];for(g in c)n.push(g);n.sort();const r=[];for(g in v)r.push(g);if(r.sort(),!a(n,r))return!1;for(p=0;p<n.length;p++)if(!a(c[n[p]],v[n[p]]))return!1}return!0}function h(c){const v=new Set;return JSON.stringify(c,(p,g)=>{if((0,O.$ag)(g)||Array.isArray(g)){if(v.has(g))return"[Circular]";v.add(g)}return typeof g=="bigint"?`[BigInt ${g.toString()}]`:g})}function b(c,v){const p=Object.create(null);return!c||!v||Object.keys(v).forEach(n=>{const r=c[n],t=v[n];a(r,t)||(p[n]=t)}),p}function y(c,v){const p=v.toLowerCase(),g=Object.keys(c).find(n=>n.toLowerCase()===p);return g?c[g]:c[v]}function w(c,v){const p=Object.create(null);for(const[g,n]of Object.entries(c))v(g,n)&&(p[g]=n);return p}function $(c){let v=[];for(;Object.prototype!==c;)v=v.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return v}function R(c){const v=[];for(const p of $(c))typeof c[p]=="function"&&v.push(p);return v}function d(c,v){const p=n=>function(){const r=Array.prototype.slice.call(arguments,0);return v(n,r)},g={};for(const n of c)g[n]=p(n);return g}function l(c,v){const p={};for(const[g,n]of Object.entries(c))p[g]=v(n,g);return p}}),define(se[28],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=D;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(I){return O.test(I)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(P){for(let u=0;u<P.length;u++)P[u]=Math.floor(Math.random()*256);return P};const N=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){I(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let u=0,a="";return a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a}}()}),define(se[79],re([0,1,33]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=N;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function I(A){const P=A.replace(/\-/g,":").toLowerCase();return!D.has(P)}function N(){const A=(0,O.networkInterfaces)();for(const P in A){const u=A[P];if(u){for(const{mac:a}of u)if(I(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[80],re([7,4]),function(X,e){return X.create("vs/base/common/date",e)}),define(se[81],re([0,1,80]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=a,e.$5m=h,e.$6m=b;const D=60,I=D*60,N=I*24,A=N*7,P=N*30,u=N*365;function a(y,w,$,R){typeof y!="number"&&(y=y.getTime());const d=Math.round((new Date().getTime()-y)/1e3);if(d<-30)return(0,O.localize)(0,null,a(new Date().getTime()+d*1e3,!1));if(!R&&d<30)return(0,O.localize)(1,null);let l;return d<D?(l=d,w?l===1?$?(0,O.localize)(2,null,l):(0,O.localize)(3,null,l):$?(0,O.localize)(4,null,l):(0,O.localize)(5,null,l):l===1?$?(0,O.localize)(6,null,l):(0,O.localize)(7,null,l):$?(0,O.localize)(8,null,l):(0,O.localize)(9,null,l)):d<I?(l=Math.floor(d/D),w?l===1?$?(0,O.localize)(10,null,l):(0,O.localize)(11,null,l):$?(0,O.localize)(12,null,l):(0,O.localize)(13,null,l):l===1?$?(0,O.localize)(14,null,l):(0,O.localize)(15,null,l):$?(0,O.localize)(16,null,l):(0,O.localize)(17,null,l)):d<N?(l=Math.floor(d/I),w?l===1?$?(0,O.localize)(18,null,l):(0,O.localize)(19,null,l):$?(0,O.localize)(20,null,l):(0,O.localize)(21,null,l):l===1?$?(0,O.localize)(22,null,l):(0,O.localize)(23,null,l):$?(0,O.localize)(24,null,l):(0,O.localize)(25,null,l)):d<A?(l=Math.floor(d/N),w?l===1?(0,O.localize)(26,null,l):(0,O.localize)(27,null,l):l===1?(0,O.localize)(28,null,l):(0,O.localize)(29,null,l)):d<P?(l=Math.floor(d/A),w?l===1?$?(0,O.localize)(30,null,l):(0,O.localize)(31,null,l):$?(0,O.localize)(32,null,l):(0,O.localize)(33,null,l):l===1?$?(0,O.localize)(34,null,l):(0,O.localize)(35,null,l):$?(0,O.localize)(36,null,l):(0,O.localize)(37,null,l)):d<u?(l=Math.floor(d/P),w?l===1?$?(0,O.localize)(38,null,l):(0,O.localize)(39,null,l):$?(0,O.localize)(40,null,l):(0,O.localize)(41,null,l):l===1?$?(0,O.localize)(42,null,l):(0,O.localize)(43,null,l):$?(0,O.localize)(44,null,l):(0,O.localize)(45,null,l)):(l=Math.floor(d/u),w?l===1?$?(0,O.localize)(46,null,l):(0,O.localize)(47,null,l):$?(0,O.localize)(48,null,l):(0,O.localize)(49,null,l):l===1?$?(0,O.localize)(50,null,l):(0,O.localize)(51,null,l):$?(0,O.localize)(52,null,l):(0,O.localize)(53,null,l))}function h(y,w){const $=Math.abs(y/1e3);return $<1?w?(0,O.localize)(54,null,y):(0,O.localize)(55,null,y):$<D?w?(0,O.localize)(56,null,Math.round(y)/1e3):(0,O.localize)(57,null,Math.round(y)/1e3):$<I?w?(0,O.localize)(58,null,Math.round(y/(1e3*D))):(0,O.localize)(59,null,Math.round(y/(1e3*D))):$<N?w?(0,O.localize)(60,null,Math.round(y/(1e3*I))):(0,O.localize)(61,null,Math.round(y/(1e3*I))):(0,O.localize)(62,null,Math.round(y/(1e3*N)))}function b(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[82],re([7,4]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(se[34],re([0,1,19,3,82]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=u,e.$kj=a,e.$lj=h;function N(b,y){return y&&(b.stack||b.stacktrace)?I.localize(0,null,P(b),A(b.stack)||A(b.stacktrace)):P(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?I.localize(1,null,b.message):b.message||I.localize(2,null)}function u(b=null,y=!1){if(!b)return I.localize(3,null);if(Array.isArray(b)){const w=O.$Hb(b),$=u(w[0],y);return w.length>1?I.localize(4,null,$,w.length):$}if(D.$$f(b))return b;if(b.detail){const w=b.detail;if(w.error)return N(w.error,y);if(w.exception)return N(w.exception,y)}return b.stack?N(b,y):b.message?b.message:I.localize(5,null)}function a(b){const y=b;return y instanceof Error&&Array.isArray(y.actions)}function h(b,y){let w;return typeof b=="string"?w=new Error(b):w=b,w.actions=y,w}}),define(se[83],re([7,4]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(se[84],re([0,1,83]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=D;function D(I){switch(I){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}}),define(se[56],re([0,1,12]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=N,e.$pm=A;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D||(e.Source=D={}));var I;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(I||(e.TerminateResponseCode=I={}));function N(P,...u){const a=u.reduce((y,w)=>(y[w]=!0,y),{}),h=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!a[y]).forEach(y=>{for(let w=0;w<h.length;w++)if(y.search(h[w])!==-1){delete P[y];break}})}function A(P){P&&(delete P.DEBUG,O.$j&&delete P.DYLD_LIBRARY_PATH,O.$k&&delete P.LD_PRELOAD)}}),define(se[85],re([0,1,11]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=D,e.$1q=I,e.$2q=N,e.log=P;function D(a){const h=a;return h&&typeof h.type=="string"&&typeof h.severity=="string"}function I(a){const h=[];let b;try{const y=JSON.parse(a.arguments),w=y[y.length-1];w&&w.__$stack&&(y.pop(),b=w.__$stack),h.push(...y)}catch{h.push("Unable to log remote console arguments",a.arguments)}return{args:h,stack:b}}function N(a){if(typeof a!="string")return N(I(a).stack);const h=a;if(h){const b=A(h),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(y&&y.length===4)return{uri:O.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}function A(a){if(!a)return a;const h=a.indexOf(`
`);return h===-1?a:a.substring(0,h)}function P(a,h){const{args:b,stack:y}=I(a),w=typeof b[0]=="string"&&b.length===1;let $=A(y);$&&($=`(${$.trim()})`);let R=[];if(typeof b[0]=="string"?$&&w?R=[`%c[${h}] %c${b[0]} %c${$}`,u("blue"),u(""),u("grey")]:R=[`%c[${h}] %c${b[0]}`,u("blue"),u(""),...b.slice(1)]:R=[`%c[${h}]%`,u("blue"),...b],$&&!w&&R.push($),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,R)}function u(a){return`color: ${a}`}}),define(se[47],re([0,1,14,11]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=I,e.$7h=N,e.$8h=P;function I(u){return JSON.stringify(u,A)}function N(u){let a=JSON.parse(u);return a=P(a),a}function A(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function P(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof O.$He||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let h=0;h<u.length;++h)u[h]=P(u[h],a+1);else for(const h in u)Object.hasOwnProperty.call(u,h)&&(u[h]=P(u[h],a+1))}return u}}),define(se[86],re([0,1,73,15,12,11]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_D=h;class A{constructor(y,w,$){this.id=y,this.dependencies=w,this.callback=$}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(y,w,$)=>{typeof y!="string"&&($=w,w=y,y=null),(typeof w!="object"||!Array.isArray(w))&&($=w,w=null),this.c.push(new A(y,w,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){if(y.startsWith(window.location.origin)||y.startsWith("vscode-file://vscode-app"))return y;throw new Error(`[trusted_script_src] Invalid script url: ${y}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){return y}})))}async load(y){this.g();const w=await(this.a?this.i(y):this.b?this.h(y):this.j(y));if(!w)throw new Error(`Did not receive a define call from script ${y}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${y}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(y){return new Promise((w,$)=>{const R=document.createElement("script");R.setAttribute("async","async"),R.setAttribute("type","text/javascript");const d=()=>{R.removeEventListener("load",l),R.removeEventListener("error",c)},l=v=>{d(),w(this.c.pop())},c=v=>{d(),$(v)};R.addEventListener("load",l),R.addEventListener("error",c),this.f&&(y=this.f.createScriptURL(y)),R.setAttribute("src",y),window.document.getElementsByTagName("head")[0].appendChild(R)})}i(y){return new Promise((w,$)=>{try{this.f&&(y=this.f.createScriptURL(y)),importScripts(y),w(this.c.pop())}catch(R){$(R)}})}async j(y){try{const w=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,R=globalThis._VSCODE_NODE_MODULES.module,d=N.URI.parse(y).fsPath,l=w.readFileSync(d).toString(),c=R.wrap(l.replace(/^#!.*/,""));return new $.Script(c).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function h(b,y,w){if(O.$T){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[b]&&(b=a[b]);const $=`${b}/${y}`;if(u.has($))return u.get($);let R;if(/^\w[\w\d+.-]*:\/\//.test($))R=$;else{const v=`${w&&!I.$o?D.$Pg:D.$Og}/${$}`;R=D.$Sg.asBrowserUri(v).toString(!0)}const d=P.INSTANCE.load(R);return u.set($,d),d}else return await new Promise(($,R)=>{X([b],$,R)})}}),define(se[87],re([0,1,33,48,28,79,12]),function(X,e,O,D,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0,e.$Hn=u,e.$In=b,e.$Gn=new class{c(y){return this.a||(this.a=D.$Ei.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,w=0;const $=(0,O.networkInterfaces)();for(const R in $){const d=$[R];if(d)for(const{mac:l,internal:c}of d)c||(w+=1,this.c(l.toUpperCase())&&(y+=1))}this.b=w>0?y/w:0}return this.b}};let P;async function u(y){return P||(P=(async()=>await a(y)||I.$Ug())()),P}async function a(y){try{const w=await new Promise((R,d)=>{X(["crypto"],R,d)}),$=(0,N.$Fn)();return w.createHash("sha256").update($,"utf8").digest("hex")}catch(w){y(w);return}}const h="Software\\Microsoft\\SQMClient";async function b(y){if(A.$i){const w=await new Promise(($,R)=>{X(["@vscode/windows-registry"],$,R)});try{return w.GetStringRegKey("HKEY_LOCAL_MACHINE",h,"MachineId")||""}catch($){return y($),""}}return""}}),define(se[88],re([0,1,33,16,25]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=c,e.$nm=v;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let h;process.env.PROCESSOR_ARCHITEW6432?h=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?h=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?h=1:h=0;class b{constructor(g,n,r){this.exePath=g,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await I.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:p=!1}={}){return p?a===0?process.env["ProgramFiles(x86)"]||null:h===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:p=!1,findPreview:g=!1}={}){const n=y({useAlternateBitness:p});if(!n)return null;const r=D.$jc(n,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const f of await I.Promises.readdir(r)){let S=-1;if(g){const j=f.indexOf("-");if(j<0)continue;const L=f.substring(0,j);if(!N.test(L)||f.substring(j+1)!=="preview")continue;S=parseInt(L,10)}else{if(!N.test(f))continue;S=parseInt(f,10)}if(S<=t)continue;const k=D.$jc(r,f,"pwsh.exe");await I.SymlinkSupport.existsFile(k)&&(i=k,t=S)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",o=g?" Preview":"";return new b(i,`PowerShell${o}${s}`,!0)}async function $({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const g=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=p?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await I.Promises.readdir(g))if(n.test(t)){const i=D.$jc(g,t,"pwsh.exe");return new b(i,r)}return null}function R(){const p=D.$jc(O.homedir(),".dotnet","tools","pwsh.exe");return new b(p,".NET Core PowerShell Global Tool")}function d(){const p=D.$jc(process.env.windir,a===1&&h!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(p,"Windows PowerShell",!0)}async function*l(){let p=await w();p&&(yield p),p=await w({useAlternateBitness:!0}),p&&(yield p),p=await $(),p&&(yield p),p=R(),p&&(yield p),p=await w({findPreview:!0}),p&&(yield p),p=await $({findPreview:!0}),p&&(yield p),p=await w({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=d(),p&&(yield p)}async function*c(){for await(const p of l())await p.exists()&&(yield p)}async function v(){for await(const p of c())return p;return null}}),define(se[57],re([0,1,16,12,35,56,3,25]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$qm=u,e.$rm=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function u(b=I.env){return b.comspec||"cmd.exe"}function a(b){let y=[],w=!1;const $=function(R){if(w){y.push(R);return}(!b.send(R,l=>{if(l&&console.error(l),w=!1,y.length>0){const c=y.slice(0);y=[],c.forEach(v=>$(v))}})||D.$i)&&(w=!0)};return{send:$}}var h;(function(b){async function y(w,$,R){if(O.$ic(w))return w;if($===void 0&&($=I.cwd()),O.$mc(w)!=="."||(R===void 0&&A.$$f(I.env.PATH)&&(R=I.env.PATH.split(O.$tc)),R===void 0||R.length===0))return O.$jc($,w);async function l(c){if(await P.Promises.exists(c)){let v;try{v=await P.Promises.stat(c)}catch(p){p.message.startsWith("EACCES")&&(v=await P.Promises.lstat(c))}return v?!v.isDirectory():!1}return!1}for(const c of R){let v;if(O.$ic(c)?v=O.$jc(c,w):v=O.$jc($,c,w),await l(v))return v;let p=v+".com";if(await l(p)||(p=v+".exe",await l(p)))return p}return O.$jc($,w)}b.findExecutable=y})(h||(e.win32=h={}))}),define(se[89],re([0,1,33,12,88,57]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=A;async function A(b,y){return b===1?D.$i?h():N.$qm(y):u(b,y)}let P=null;function u(b,y){if(D.$k&&b===2||D.$j&&b===3)return"/bin/bash";if(!P){let w;if(D.$i)w="/bin/bash";else{if(w=y.SHELL,!w)try{w=(0,O.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}P=w}return P}let a=null;async function h(){return a||(a=(await(0,I.$nm)()).exePath),a}});var $e=this&&this.__decorate||function(X,e,O,D){var I=arguments.length,N=I<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,O):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(X,e,O,D);else for(var P=X.length-1;P>=0;P--)(A=X[P])&&(N=(I<3?A(N):I>3?A(e,O,N):A(e,O))||N);return I>3&&N&&Object.defineProperty(e,O,N),N};define(se[58],re([0,1,19,8,14,20,54,9,5,2,47,31,3]),function(X,e,O,D,I,N,A,P,u,a,h,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.ProxyChannel=e.$gi=e.$di=e.$ci=e.$bi=e.RequestInitiator=e.$ai=e.$0h=e.$9h=void 0,e.$$h=o,e.$_h=f,e.$ei=C,e.$fi=J;var w;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(w||(w={}));function $(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var R;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(R||(R={}));function d(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(l||(l={}));function c(B){let T=0;for(let H=0;;H+=7){const Q=B.read(1);if(T|=(Q.buffer[0]&127)<<H,!(Q.buffer[0]&128))return T}}const v=t(0);function p(B,T){if(T===0){B.write(v);return}let H=0;for(let Y=T;Y!==0;Y=Y>>>7)H++;const Q=I.$He.alloc(H);for(let Y=0;T!==0;Y++)Q.buffer[Y]=T&127,T=T>>>7,T>0&&(Q.buffer[Y]|=128);B.write(Q)}class g{constructor(T){this.b=T,this.a=0}read(T){const H=this.b.slice(this.a,this.a+T);return this.a+=H.byteLength,H}}e.$9h=g;class n{constructor(){this.a=[]}get buffer(){return I.$He.concat(this.a)}write(T){this.a.push(T)}}e.$0h=n;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function t(B){const T=I.$He.alloc(1);return T.writeUInt8(B,0),T}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(B,T){if(typeof T>"u")B.write(i.Undefined);else if(typeof T=="string"){const H=I.$He.fromString(T);B.write(i.String),p(B,H.byteLength),B.write(H)}else if(s&&Buffer.isBuffer(T)){const H=I.$He.wrap(T);B.write(i.Buffer),p(B,H.byteLength),B.write(H)}else if(T instanceof I.$He)B.write(i.VSBuffer),p(B,T.byteLength),B.write(T);else if(Array.isArray(T)){B.write(i.Array),p(B,T.length);for(const H of T)o(B,H)}else if(typeof T=="number"&&(T|0)===T)B.write(i.Uint),p(B,T);else{const H=I.$He.fromString(JSON.stringify(T));B.write(i.Object),p(B,H.byteLength),B.write(H)}}function f(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(c(B)).toString();case r.Buffer:return B.read(c(B)).buffer;case r.VSBuffer:return B.read(c(B));case r.Array:{const H=c(B),Q=[];for(let Y=0;Y<H;Y++)Q.push(f(B));return Q}case r.Object:return JSON.parse(B.read(c(B)).toString());case r.Int:return c(B)}}class S{constructor(T,H,Q=null,Y=1e3){this.h=T,this.j=H,this.k=Q,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(T,H){this.b.set(T,H),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const H=this.o([T.type]);this.k?.logOutgoing(H,0,1,d(T.type));return}case 201:case 202:case 204:case 203:{const H=this.o([T.type,T.id],T.data);this.k?.logOutgoing(H,T.id,1,d(T.type),T.data);return}}}o(T,H=void 0){const Q=new n;return o(Q,T),o(Q,H),this.p(Q.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const H=new g(T),Q=f(H),Y=f(H),_=Q[0];switch(_){case 100:return this.k?.logIncoming(T.byteLength,Q[1],1,`${$(_)}: ${Q[2]}.${Q[3]}`,Y),this.s({type:_,id:Q[1],channelName:Q[2],name:Q[3],arg:Y});case 102:return this.k?.logIncoming(T.byteLength,Q[1],1,`${$(_)}: ${Q[2]}.${Q[3]}`,Y),this.t({type:_,id:Q[1],channelName:Q[2],name:Q[3],arg:Y});case 101:return this.k?.logIncoming(T.byteLength,Q[1],1,`${$(_)}`),this.u({type:_,id:Q[1]});case 103:return this.k?.logIncoming(T.byteLength,Q[1],1,`${$(_)}`),this.u({type:_,id:Q[1]})}}s(T){const H=this.b.get(T.channelName);if(!H){this.v(T);return}const Q=new N.$qe;let Y;try{Y=H.call(this.j,T.name,T.arg,Q.token)}catch(U){Y=Promise.reject(U)}const _=T.id;Y.then(U=>{this.m({id:_,data:U,type:201})},U=>{U instanceof Error?this.m({id:_,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:_,data:U,type:203})}).finally(()=>{F.dispose(),this.d.delete(T.id)});const F=(0,a.$Sc)(()=>Q.cancel());this.d.set(T.id,F)}t(T){const H=this.b.get(T.channelName);if(!H){this.v(T);return}const Q=T.id,_=H.listen(this.j,T.name,T.arg)(F=>this.m({id:Q,data:F,type:204}));this.d.set(T.id,_)}u(T){const H=this.d.get(T.id);H&&(H.dispose(),this.d.delete(T.id))}v(T){let H=this.g.get(T.channelName);H||(H=[],this.g.set(T.channelName,H));const Q=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:T,timeoutTimer:Q})}w(T){const H=this.g.get(T);if(H){for(const Q of H)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$ai=S;var k;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class j{constructor(T,H=null){this.l=T,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$fe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=H}getChannel(T){const H=this;return{call(Q,Y,_){return H.a?Promise.reject(new P.$5):H.m(T,Q,Y,_)},listen(Q,Y){return H.a?u.Event.None:H.o(T,Q,Y)}}}m(T,H,Q,Y=N.CancellationToken.None){const _=this.g++,U={id:_,type:100,channelName:T,name:H,arg:Q};if(Y.isCancellationRequested)return Promise.reject(new P.$5);let m;return new Promise((z,M)=>{if(Y.isCancellationRequested)return M(new P.$5);const G=()=>{const he=pe=>{switch(pe.type){case 201:this.f.delete(_),z(pe.data);break;case 202:{this.f.delete(_);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,M(ye);break}case 203:this.f.delete(_),M(pe.data);break}};this.f.set(_,he),this.p(U)};let W=null;this.b===l.Idle?G():(W=(0,D.$lh)(he=>this.u()),W.then(()=>{W=null,G()}));const te=()=>{W?(W.cancel(),W=null):this.p({id:_,type:101}),M(new P.$5)},ae=Y.onCancellationRequested(te);m=(0,a.$Rc)((0,a.$Sc)(te),ae),this.d.add(m)}).finally(()=>{m.dispose(),this.d.delete(m)})}o(T,H,Q){const Y=this.g++,F={id:Y,type:102,channelName:T,name:H,arg:Q};let U=null;const m=new u.$fe({onWillAddFirstListener:()=>{U=(0,D.$lh)(z=>this.u()),U.then(()=>{U=null,this.d.add(m),this.p(F)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(m),this.p({id:Y,type:103}))}}),E=z=>m.fire(z.data);return this.f.set(Y,E),m.event}p(T){switch(T.type){case 100:case 102:{const H=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(H,T.id,0,`${$(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const H=this.q([T.type,T.id]);this.j?.logOutgoing(H,T.id,0,$(T.type));return}}}q(T,H=void 0){const Q=new n;return o(Q,T),o(Q,H),this.r(Q.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const H=new g(T),Q=f(H),Y=f(H),_=Q[0];switch(_){case 200:return this.j?.logIncoming(T.byteLength,0,0,d(_)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,Q[1],0,d(_),Y),this.t({type:Q[0],id:Q[1],data:Y})}}t(T){if(T.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$bi=j,$e([A.$3h],j.prototype,"onDidInitializePromise",null);class L{get connections(){const T=[];return this.f.forEach(H=>T.push(H)),T}constructor(T,H,Q){this.a=new Map,this.f=new Set,this.g=new u.$fe,this.onDidAddConnection=this.g.event,this.h=new u.$fe,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(T(({protocol:Y,onDidClientDisconnect:_})=>{const F=u.Event.once(Y.onMessage);this.j.add(F(U=>{const m=new g(U),E=f(m),z=new S(Y,E,H,Q),M=new j(Y,H);this.a.forEach((W,te)=>z.registerChannel(te,W));const G={channelServer:z,channelClient:M,ctx:E};this.f.add(G),this.g.fire(G),this.j.add(_(()=>{z.dispose(),M.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(T,H){const Q=this;return{call(Y,_,F){let U;if((0,y.$mg)(H)){const E=(0,O.$3b)(Q.connections.filter(H));U=E?Promise.resolve(E):u.Event.toPromise(u.Event.filter(Q.onDidAddConnection,H))}else U=H.routeCall(Q,Y,_);const m=U.then(E=>E.channelClient.getChannel(T));return C(m).call(Y,_,F)},listen(Y,_){if((0,y.$mg)(H))return Q.k(T,H,Y,_);const F=H.routeEvent(Q,Y,_).then(U=>U.channelClient.getChannel(T));return C(F).listen(Y,_)}}}k(T,H,Q,Y){const _=this;let F;const U=new u.$fe({onWillAddFirstListener:()=>{F=new a.$Tc;const m=new u.$le,E=new Map,z=G=>{const te=G.channelClient.getChannel(T).listen(Q,Y),ae=m.add(te);E.set(G,ae)},M=G=>{const W=E.get(G);W&&(W.dispose(),E.delete(G))};_.connections.filter(H).forEach(z),u.Event.filter(_.onDidAddConnection,H)(z,void 0,F),_.onDidRemoveConnection(M,void 0,F),m.event(U.fire,U,F),F.add(m)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return U.event}registerChannel(T,H){this.a.set(T,H);for(const Q of this.f)Q.channelServer.registerChannel(T,H)}dispose(){this.j.dispose();for(const T of this.f)T.channelClient.dispose(),T.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ci=L;class q{constructor(T,H,Q=null){const Y=new n;o(Y,H),T.send(Y.buffer),this.a=new j(T,Q),this.d=new S(T,H,Q)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,H){this.d.registerChannel(T,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$di=q;function C(B){return{call(T,H,Q){return B.then(Y=>Y.call(T,H,Q))},listen(T,H){const Q=new u.$oe;return B.then(Y=>Q.input=Y.listen(T,H)),Q.event}}}function J(B){let T=!1;return{call(H,Q,Y){return T?B.call(H,Q,Y):(0,D.$zh)(0).then(()=>T=!0).then(()=>B.call(H,Q,Y))},listen(H,Q){if(T)return B.listen(H,Q);const Y=new u.$oe;return(0,D.$zh)(0).then(()=>T=!0).then(()=>Y.input=B.listen(H,Q)),Y.event}}}class ne{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const H of T.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await u.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.$gi=ne;var ie;(function(B){function T(_,F,U){const m=_,E=U&&U.disableMarshalling,z=new Map;for(const M in m)Q(M)&&z.set(M,u.Event.buffer(m[M],!0,void 0,F));return new class{listen(M,G,W){const te=z.get(G);if(te)return te;const ae=m[G];if(typeof ae=="function"){if(Y(G))return ae.call(m,W);if(Q(G))return z.set(G,u.Event.buffer(m[G],!0,void 0,F)),z.get(G)}throw new P.$bb(`Event not found: ${G}`)}call(M,G,W){const te=m[G];if(typeof te=="function"){if(!E&&Array.isArray(W))for(let he=0;he<W.length;he++)W[he]=(0,h.$8h)(W[he]);let ae=te.apply(m,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new P.$bb(`Method not found: ${G}`)}}}B.fromService=T;function H(_,F){const U=F&&F.disableMarshalling;return new Proxy({},{get(m,E){if(typeof E=="string")return F?.properties?.has(E)?F.properties.get(E):Y(E)?function(z){return _.listen(E,z)}:Q(E)?_.listen(E):async function(...z){let M;F&&!(0,y.$hg)(F.context)?M=[F.context,...z]:M=z;const G=await _.call(E,M);return U?G:(0,h.$8h)(G)};throw new P.$bb(`Property not found: ${String(E)}`)}})}B.toService=H;function Q(_){return _[0]==="o"&&_[1]==="n"&&b.$yf(_.charCodeAt(2))}function Y(_){return/^onDynamic/.test(_)&&b.$yf(_.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const T=B.toString();if(T!=="[object Object]")return T}return B}function ce(B){return Array.isArray(B)?B.map(le):le(B)}function V(B,T,H,Q,Y,_,F){F=ce(F);const U=ue[Y],m=U[Q%U.length];let E=[`%c[${B}]%c[${String(T).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${m}`];/\($/.test(_)?(E=E.concat(F),E.push(")")):E.push(F),console.log.apply(console,E)}class Z{constructor(T,H){this.d=T,this.f=H,this.a=0,this.b=0}logOutgoing(T,H,Q,Y,_){this.b+=T,V(this.d,this.b,T,H,Q,Y,_)}logIncoming(T,H,Q,Y,_){this.a+=T,V(this.f,this.a,T,H,Q,Y,_)}}e.$hi=Z}),define(se[90],re([0,1,59,8,14,20,85,9,5,2,27,57,56,58]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;class $ extends w.$ai{constructor(l){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",c=>I.$He.wrap(Buffer.from(c,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$4q=$;class R{constructor(l,c){this.i=l,this.j=c,this.c=new Set,this.g=new Map,this.h=new u.$fe,this.onDidProcessExit=this.h.event;const v=c&&c.timeout?c.timeout:6e4;this.b=new D.$vh(v),this.d=null,this.f=null}getChannel(l){const c=this;return{call(v,p,g){return c.k(l,v,p,g)},listen(v,p){return c.l(l,v,p)}}}k(l,c,v,p=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const g=this.n(l),n=(0,D.$lh)(i=>g.call(c,v,i)),r=p.onCancellationRequested(()=>n.cancel()),t=(0,a.$Sc)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(l,c,v){if(!this.b)return u.Event.None;this.b.cancel();let p;const g=new u.$fe({onWillAddFirstListener:()=>{p=this.n(l).listen(c,v)(g.fire,g),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,h.$5n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,y.$pm)(c.env),this.d=(0,O.fork)(this.i,l,c);const v=new u.$fe,g=u.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.$Zq)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}v.fire(I.$He.wrap(Buffer.from(o,"base64")))}),n=this.j.useQueue?(0,b.$rm)(this.d):this.d,r=o=>this.d&&this.d.connected&&n.send(o.buffer.toString("base64")),t=v.event,i={send:r,onMessage:t};this.f=new w.$bi(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,f)=>{process.removeListener("exit",s),g.dispose(),this.c.forEach(S=>(0,a.$Pc)(S)),this.c.clear(),o!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+f),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:f})})}return this.f}n(l){let c=this.g.get(l);return c||(c=this.m.getChannel(l),this.g.set(l,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$5q=R}),define(se[91],re([0,1,8,5,2,47,3]),function(X,e,O,D,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.StorageState=e.StorageHint=void 0,e.$Zp=u;var P;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function u(y){const w=y;return w?.changed instanceof Map||w?.deleted instanceof Set}var a;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(a||(e.StorageState=a={}));class h extends I.$Uc{static{this.a=100}constructor(w,$=Object.create(null)){super(),this.r=w,this.s=$,this.b=this.B(new D.$ie),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new O.$wh(h.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach(($,R)=>this.w(R,$)),w.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(w,$){if(this.c===a.Closed)return;let R=!1;(0,A.$hg)($)?R=this.f.delete(w):this.f.get(w)!==$&&(this.f.set(w,$),R=!0),R&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,$){const R=this.f.get(w);return(0,A.$hg)(R)?$:R}getBoolean(w,$){const R=this.get(w);return(0,A.$hg)(R)?$:R==="true"}getNumber(w,$){const R=this.get(w);return(0,A.$hg)(R)?$:parseInt(R,10)}getObject(w,$){const R=this.get(w);return(0,A.$hg)(R)?$:(0,N.$7h)(R)}async set(w,$,R=!1){if(this.c===a.Closed)return;if((0,A.$hg)($))return this.delete(w,R);const d=(0,A.$ag)($)||Array.isArray($)?(0,N.$6h)($):String($);if(this.f.get(w)!==d)return this.f.set(w,d),this.j.set(w,d),this.h.delete(w),this.b.fire({key:w,external:R}),this.D()}async delete(w,$=!1){if(!(this.c===a.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:$}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===a.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$1p=h;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach(($,R)=>this.a.set(R,$)),w.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$2p=b}),define(se[92],re([7,4]),function(X,e){return X.create("vs/base/node/zip",e)}),define(se[49],re([0,1,60,8,16,3,25,92]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=void 0,e.zip=d,e.$nq=l,e.$oq=v,e.$kq="end of central directory record signature not found";const u=new RegExp(e.$kq);class a extends Error{constructor(g,n){let r=n.message;switch(g){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=g,this.cause=n}}e.$lq=a;function h(p){const g=p.externalFileAttributes>>16||33188;return[448,56,7].map(n=>g&n).reduce((n,r)=>n+r,g&61440)}function b(p){if(p instanceof a)return p;let g;return u.test(p.message)&&(g="CorruptZip"),new a(g,p)}function y(p,g,n,r,t,i){const s=I.$mc(g),o=I.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(P.localize(0,null,g)));const f=I.$jc(r,g);let S;return i.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((k,j)=>{if(!i.isCancellationRequested)try{S=(0,O.createWriteStream)(f,{mode:n}),S.once("close",()=>k()),S.once("error",j),p.once("error",j),p.pipe(S)}catch(L){j(L)}}))}function w(p,g,n,r){let t=(0,D.$lh)(()=>Promise.resolve()),i=0;const s=r.onCancellationRequested(()=>{t.cancel(),p.close()});return new Promise((o,f)=>{const S=new D.$th,k=j=>{j.isCancellationRequested||(i++,p.readEntry())};p.once("error",f),p.once("close",()=>t.then(()=>{r.isCancellationRequested||p.entryCount===i?o():f(new a("Incomplete",new Error(P.localize(1,null,i,p.entryCount))))},f)),p.readEntry(),p.on("entry",j=>{if(r.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){k(r);return}const L=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(L)){const J=I.$jc(g,L);t=(0,D.$lh)(ne=>A.Promises.mkdir(J,{recursive:!0}).then(()=>k(ne)).then(void 0,f));return}const q=R(p,j),C=h(j);t=(0,D.$lh)(J=>S.queue(()=>q.then(ne=>y(ne,L,C,g,n,J).then(()=>k(J)))).then(null,f))})}).finally(()=>s.dispose())}async function $(p,g=!1){const{open:n}=await new Promise((r,t)=>{X(["yauzl"],r,t)});return new Promise((r,t)=>{n(p,g?{lazyEntries:!0}:void 0,(i,s)=>{i?t(b(i)):r((0,N.$jg)(s))})})}function R(p,g){return new Promise((n,r)=>{p.openReadStream(g,(t,i)=>{t?r(b(t)):n((0,N.$jg)(i))})})}async function d(p,g){const{ZipFile:n}=await new Promise((r,t)=>{X(["yazl"],r,t)});return new Promise((r,t)=>{const i=new n;g.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const s=(0,O.createWriteStream)(p);i.outputStream.pipe(s),i.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(p))})}function l(p,g,n={},r){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let i=$(p,!0);return n.overwrite&&(i=i.then(s=>A.Promises.rm(g).then(()=>s))),i.then(s=>w(s,g,{sourcePathRegex:t},r))}function c(p,g){return $(p).then(n=>new Promise((r,t)=>{n.on("entry",i=>{i.fileName===g&&R(n,i).then(s=>r(s),s=>t(s))}),n.once("close",()=>t(new Error(P.localize(2,null,g))))}))}function v(p,g){return c(p,g).then(n=>new Promise((r,t)=>{const i=[];n.once("error",t),n.on("data",s=>i.push(s)),n.on("end",()=>r(Buffer.concat(i)))}))}}),define(se[93],re([7,4]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[94],re([7,4]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(se[95],re([7,4]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(se[96],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(se[97],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[98],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(se[99],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[100],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[101],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(se[102],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(se[103],re([7,4]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[104],re([7,4]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(se[105],re([7,4]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(se[106],re([7,4]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[107],re([7,4]),function(X,e){return X.create("vs/platform/languagePacks/common/languagePacks",e)}),define(se[108],re([7,4]),function(X,e){return X.create("vs/platform/log/common/log",e)}),define(se[109],re([7,4]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(se[110],re([7,4]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(se[111],re([7,4]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[112],re([7,4]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[113],re([7,4]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(se[114],re([0,1,9,95]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var I;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(I||(e.TokenType=I={}));function N(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,D.localize)(3,null),P=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return h.isTripleEq?"===":"==";case 4:return h.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return h.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return h.lexeme;case 18:return h.lexeme;case 19:return h.lexeme;case 20:return"EOF";default:throw(0,O.$8)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(h){return this.c=h,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(h){return this.r()||this.c.charCodeAt(this.e)!==h?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(h){this.f.push({type:h,offset:this.d})}l(h){const b=this.d,y=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:y};this.g.push({offset:b,lexeme:y,additionalInfo:h}),this.f.push(w)}n(){this.m.lastIndex=this.d;const h=this.m.exec(this.c);if(h){this.e=this.d+h[0].length;const b=this.c.substring(this.d,this.e),y=u.b.get(b);y?this.k(y):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let h=this.e,b=!1,y=!1;for(;;){if(h>=this.c.length){this.e=h,this.l(P);return}const $=this.c.charCodeAt(h);if(b)b=!1;else if($===47&&!y){h++;break}else $===91?y=!0:$===92?b=!0:$===93&&(y=!1);h++}for(;h<this.c.length&&u.a.has(this.c.charCodeAt(h));)h++;this.e=h;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=u}),define(se[115],re([0,1,81,54,15,16,35,17,11]),function(X,e,O,D,I,N,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=void 0,e.$9m=h,e.$0m=b,e.$7m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,N.$mc)(I.$Sg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,N.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,P.$_g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:I.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$_g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,O.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$jc)(this.userDataPath,"logs",w)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$_g)(u.URI.file((0,N.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$_g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$_g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$_g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=A.env.VSCODE_PORTABLE;return w?u.URI.file((0,N.$jc)(w,"argv.json")):(0,P.$_g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,N.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,N.$kc)(w):(0,N.$hc)((0,N.$jc)(I.$Sg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?u.URI.file((0,N.$kc)(w)):u.URI.file((0,N.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,N.$kc)(w);const $=A.env.VSCODE_EXTENSIONS;if($)return $;const R=A.env.VSCODE_PORTABLE;return R?(0,N.$jc)(R,"extensions"):(0,P.$_g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map($=>/^[^:/?#]+?:\/\//.test($)?u.URI.parse($):u.URI.file((0,N.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?u.URI.parse(w):u.URI.file((0,N.$hc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return h(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$7m.test(w))}get extensionLogLevel(){const w=[];for(const $ of this.args.log||[]){const R=e.$7m.exec($);R&&R[1]&&R[2]&&w.push([R[1],R[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,P.$_g)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=A.env.VSCODE_PORTABLE;return w?u.URI.file((0,N.$jc)(w,"policy.json")):(0,P.$_g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,$,R){this.a=w,this.b=$,this.c=R,this.editSessionId=this.args.editSessionId}}e.$8m=a,$e([D.$3h],a.prototype,"appRoot",null),$e([D.$3h],a.prototype,"userHome",null),$e([D.$3h],a.prototype,"userDataPath",null),$e([D.$3h],a.prototype,"appSettingsHome",null),$e([D.$3h],a.prototype,"tmpDir",null),$e([D.$3h],a.prototype,"cacheHome",null),$e([D.$3h],a.prototype,"stateResource",null),$e([D.$3h],a.prototype,"userRoamingDataHome",null),$e([D.$3h],a.prototype,"userDataSyncHome",null),$e([D.$3h],a.prototype,"sync",null),$e([D.$3h],a.prototype,"machineSettingsResource",null),$e([D.$3h],a.prototype,"workspaceStorageHome",null),$e([D.$3h],a.prototype,"localHistoryHome",null),$e([D.$3h],a.prototype,"keyboardLayoutResource",null),$e([D.$3h],a.prototype,"argvResource",null),$e([D.$3h],a.prototype,"isExtensionDevelopment",null),$e([D.$3h],a.prototype,"untitledWorkspacesHome",null),$e([D.$3h],a.prototype,"builtinExtensionsPath",null),$e([D.$3h],a.prototype,"extensionsPath",null),$e([D.$3h],a.prototype,"extensionDevelopmentLocationURI",null),$e([D.$3h],a.prototype,"extensionDevelopmentKind",null),$e([D.$3h],a.prototype,"extensionTestsLocationURI",null),$e([D.$3h],a.prototype,"debugExtensionHost",null),$e([D.$3h],a.prototype,"logLevel",null),$e([D.$3h],a.prototype,"extensionLogLevel",null),$e([D.$3h],a.prototype,"serviceMachineIdResource",null),$e([D.$3h],a.prototype,"disableTelemetry",null),$e([D.$3h],a.prototype,"disableWorkspaceTrust",null),$e([D.$3h],a.prototype,"useInMemorySecretStorage",null),$e([D.$3h],a.prototype,"policyFile",null);function h(y,w){return b(y["inspect-extensions"],y["inspect-brk-extensions"],5870,w,y.debugId,y.extensionEnvironment)}function b(y,w,$,R,d,l){const v=Number(w||y)||(R?null:$),p=v?!!w:!1;let g;if(l)try{g=JSON.parse(l)}catch{}return{port:v,break:p,debugId:d,env:g}}}),function(){"use strict";function X(e,O,D){function I(A,P){const u=N(A,P),a=[u];return e.isAbsolute(u)||a.unshift(D),e.resolve(...a)}function N(A,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,P);const h=A["user-data-dir"];if(h)return h;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(b,"AppData","Roaming")}break;case"darwin":a=e.join(O.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,P)}return{getUserDataPath:I}}if(typeof define=="function")define(se[116],re([170,33,35]),function(e,O,D){return X(e,O,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=X(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[117],re([0,1,33,115,116]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$_m=A,e.$an=P;class N extends D.$8m{constructor(a,h){super(a,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,I.getUserDataPath)(a,h.nameShort)},h)}}e.$$m=N;function A(u,a){return(0,D.$0m)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}function P(u,a){return(0,D.$0m)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}}),define(se[118],re([0,1,3,99]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=I;function I(A,P,u,a){try{N(A,P,u,a)}catch(h){A.error(h?.message??h)}return P}function N(A,P,u,a){const h=(b,y,w)=>{const $=b[y];if((0,O.$$f)($)){const R=$,d=R.length;if(d>1&&R[0]==="%"&&R[d-1]==="%"){const l=R.substr(1,d-2);let c=u[l];c===void 0&&a&&(c=a[l]);const v=typeof c=="string"?c:c?.message,p=a?.[l],g=typeof p=="string"?p:p?.message;if(!v){g||A.warn(`[${P.name}]: ${(0,D.localize)(0,null,l)}`);return}if(w&&(y==="title"||y==="category")&&g&&g!==v){const n={value:v,original:g};b[y]=n}else b[y]=v}}else if((0,O.$ag)($))for(const R in $)$.hasOwnProperty(R)&&(R==="commands"?h($,R,!0):h($,R,w));else if(Array.isArray($))for(let R=0;R<$.length;R++)h($,R,w)};for(const b in P)P.hasOwnProperty(b)&&h(P,b)}}),define(se[119],re([0,1,49,102]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=I;function I(N){return(0,O.$oq)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}}),define(se[50],re([0,1,17,55,103,44]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=u,e.$Lp=a,e.$Mp=h,e.$Np=b,e.$Op=y,e.$Pp=w,e.$Qp=$;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function u(l){return l=l.trim(),l==="*"||A.test(l)}function a(l){if(!u(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=l.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function h(l){if(!l)return null;const c=l.majorBase,v=l.majorMustEqual,p=l.minorBase;let g=l.minorMustEqual;const n=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(c===0||(g=!1),r=!1);let t=0;if(l.preRelease){const i=P.exec(l.preRelease);if(i){const[,s,o,f]=i;t=Date.UTC(Number(s),Number(o)-1,Number(f))}}return{majorBase:c,majorMustEqual:v,minorBase:p,minorMustEqual:g,patchBase:n,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:t}}function b(l,c,v){let p;typeof l=="string"?p=h(a(l)):p=l;let g;c instanceof Date?g=c.getTime():typeof c=="string"&&(g=new Date(c).getTime());let n;if(typeof v=="string"?n=h(a(v)):n=v,!p||!n)return!1;const r=p.majorBase,t=p.minorBase,i=p.patchBase;let s=n.majorBase,o=n.minorBase,f=n.patchBase;const S=n.notBefore;let k=n.majorMustEqual,j=n.minorMustEqual,L=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||g&&g<S?!1:i>=f:(r===1&&s===0&&(!k||!j||!L)&&(s=1,o=0,f=0,k=!0,j=!1,L=!1),r<s?!1:r>s?!k:t<o?!1:t>o?!j:i<f?!1:i>f?!L:!(g&&g<S))}function y(l,c,v,p,g){const n=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return n.push([D.default.Error,I.localize(0,null)]),n;if(typeof p.name!="string")return n.push([D.default.Error,I.localize(1,null,"name")]),n;if(typeof p.version!="string")return n.push([D.default.Error,I.localize(2,null,"version")]),n;if(!p.engines)return n.push([D.default.Error,I.localize(3,null,"engines")]),n;if(typeof p.engines.vscode!="string")return n.push([D.default.Error,I.localize(4,null,"engines.vscode")]),n;if(typeof p.extensionDependencies<"u"&&!d(p.extensionDependencies))return n.push([D.default.Error,I.localize(5,null,"extensionDependencies")]),n;if(typeof p.activationEvents<"u"){if(!d(p.activationEvents))return n.push([D.default.Error,I.localize(6,null,"activationEvents")]),n;if(typeof p.main>"u"&&typeof p.browser>"u")return n.push([D.default.Error,I.localize(7,null,"activationEvents","main","browser")]),n}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&n.push([D.default.Warning,I.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return n.push([D.default.Error,I.localize(9,null,"main")]),n;{const i=(0,O.$_g)(v,p.main);(0,O.$6g)(i,v)||n.push([D.default.Warning,I.localize(10,null,i.path,v.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return n.push([D.default.Error,I.localize(11,null,"browser")]),n;{const i=(0,O.$_g)(v,p.browser);(0,O.$6g)(i,v)||n.push([D.default.Warning,I.localize(12,null,i.path,v.path)])}}if(!N.valid(p.version))return n.push([D.default.Error,I.localize(13,null)]),n;const r=[];if(!w(l,c,p,g,r))for(const i of r)n.push([D.default.Error,i]);return n}function w(l,c,v,p,g){return p||typeof v.main>"u"&&typeof v.browser>"u"?!0:R(l,c,v.engines.vscode,g)}function $(l,c,v){return l==="*"||R(c,v,l)}function R(l,c,v,p=[]){const g=h(a(v));if(!g)return p.push(I.localize(14,null,v)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return p.push(I.localize(15,null,v)),!1}else if(!g.majorMustEqual)return p.push(I.localize(16,null,v)),!1;return b(l,c,g)?!0:(p.push(I.localize(17,null,l,v)),!1)}function d(l){if(!Array.isArray(l))return!1;for(let c=0,v=l.length;c<v;c++)if(typeof l[c]!="string")return!1;return!0}}),define(se[120],re([0,1,14,28]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=I;async function I(N,A,P){let u=P&&P.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const h=(await A.readFile(N.serviceMachineIdResource)).value.toString();u=(0,D.$Tg)(h)?h:null}catch{u=null}if(!u){u=(0,D.$Ug)();try{await A.writeFile(N.serviceMachineIdResource,O.$He.fromString(u))}catch{}}return P?.store("storage.serviceMachineId",u,-1,1),u}}),define(se[51],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class O{constructor(I,N=[],A=!1){this.ctor=I,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$vi=O}),define(se[121],re([0,1,51]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Bs=N,e.$Cs=A;const D=[];var I;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function N(P,u,a){u instanceof O.$vi||(u=new O.$vi(u,[],!!a)),D.push([P,u])}function A(){return D}}),define(se[122],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0;class O{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$er=O;class D{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const P=this.lookupOrInsertNode(N),u=this.lookupOrInsertNode(A);P.outgoing.set(u.key,u),u.incoming.set(P.key,P)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const P of this.a.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let P=this.a.get(A);return P||(P=new O(A,N),this.a.set(A,P)),P}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,P]of this.a)N.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const P=new Set([N]),u=this.c(A,P);if(u)return u}}c(N,A){for(const[P,u]of N.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const a=this.c(u,A);if(a)return a;A.delete(P)}}}e.$fr=D}),define(se[29],re([0,1,3,11,10]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=N,e.$7i=A,e.$8i=u,e.$9i=a,e.$0i=h,e.$$i=b,e.$_i=y,e.$aj=$,e.$bj=R,e.$cj=d,e.$5i=(0,I.$yi)("configurationService");function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof D.URI)}var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function u(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}function h(l,c){const v=Object.create(null);for(const p in l)b(v,p,l[p],c);return v}function b(l,c,v,p){const g=c.split("."),n=g.pop();let r=l;for(let t=0;t<g.length;t++){const i=g[t];let s=r[i];switch(typeof s){case"undefined":s=r[i]=Object.create(null);break;case"object":if(s===null){p(`Ignoring ${c} as ${g.slice(0,t+1).join(".")} is null`);return}break;default:p(`Ignoring ${c} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=v}catch{p(`Ignoring ${c} as ${g.join(".")} is ${JSON.stringify(r)}`)}else p(`Ignoring ${c} as ${g.join(".")} is ${JSON.stringify(r)}`)}function y(l,c){const v=c.split(".");w(l,v)}function w(l,c){const v=c.shift();if(c.length===0){delete l[v];return}if(Object.keys(l).indexOf(v)!==-1){const p=l[v];typeof p=="object"&&!Array.isArray(p)&&(w(p,c),Object.keys(p).length===0&&delete l[v])}}function $(l,c,v){function p(r,t){let i=r;for(const s of t){if(typeof i!="object"||i===null)return;i=i[s]}return i}const g=c.split("."),n=p(l,g);return typeof n>"u"?v:n}function R(l,c,v){Object.keys(c).forEach(p=>{p!=="__proto__"&&(p in l?O.$ag(l[p])&&O.$ag(c[p])?R(l[p],c[p],v):v&&(l[p]=c[p]):l[p]=c[p])})}function d(l){return l.replace(/[\[\]]/g,"")}}),define(se[123],re([0,1,12,31,114,10,94,9]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=a,e.$xj=r,e.$yj=t,e.$Rj=Y;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",O.$j),u.set("isLinux",O.$k),u.set("isWindows",O.$i),u.set("isWeb",O.$o),u.set("isMacNative",O.$j&&!O.$o),u.set("isEdge",O.$H),u.set("isFirefox",O.$F),u.set("isChrome",O.$E),u.set("isSafari",O.$G);function a(U,m){if(u.get(U)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(U,m)}const h=Object.prototype.hasOwnProperty;var b;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const y={regexParsingWithErrorRecovery:!0},w=(0,A.localize)(0,null),$=(0,A.localize)(1,null),R=(0,A.localize)(2,null),d=(0,A.localize)(3,null),l=(0,A.localize)(4,null),c=(0,A.localize)(5,null),v=(0,A.localize)(6,null),p=(0,A.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(m=y){this.k=m,this.d=new I.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(m){if(m===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(m).scan(),this.g=0,this.h=[];try{const E=this.l();if(!this.E()){const z=this.D(),M=z.type===17?c:void 0;throw this.h.push({message:l,offset:z.offset,lexeme:I.$tj.getLexeme(z),additionalInfo:M}),g.c}return E}catch(E){if(E!==g.c)throw E;return}}l(){return this.m()}m(){const m=[this.o()];for(;this.y(16);){const E=this.o();m.push(E)}return m.length===1?m[0]:n.or(...m)}o(){const m=[this.s()];for(;this.y(15);){const E=this.s();m.push(E)}return m.length===1?m[0]:n.and(...m)}s(){if(this.y(2)){const m=this.D();switch(m.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const E=this.l();return this.A(1,d),E?.negate()}case 17:return this.z(),q.create(m.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",m)}}return this.t()}t(){const m=this.D();switch(m.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const E=this.l();return this.A(1,d),E}case 17:{const E=m.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const G=M.lexeme,W=G.lastIndexOf("/"),te=W===G.length-1?void 0:this.w(G.substring(W+1));let ae;try{ae=new RegExp(G.substring(1,W),te)}catch{throw this.B("REGEX",M)}return le.create(E,ae)}switch(M.type){case 10:case 19:{const G=[M.lexeme];this.z();let W=this.D(),te=0;for(let fe=0;fe<M.lexeme.length;fe++)M.lexeme.charCodeAt(fe)===40?te++:M.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?te++:M.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;G.push(I.$tj.getLexeme(W)),this.z(),W=this.D()}const ae=G.join(""),he=ae.lastIndexOf("/"),pe=he===ae.length-1?void 0:this.w(ae.substring(he+1));let ye;try{ye=new RegExp(ae.substring(1,he),pe)}catch{throw this.B("REGEX",M)}return n.regex(E,ye)}case 18:{const G=M.lexeme;this.z();let W=null;if(!(0,D.$9e)(G)){const te=G.indexOf("/"),ae=G.lastIndexOf("/");if(te!==ae&&te>=0){const he=G.slice(te+1,ae),pe=G[ae+1]==="i"?"i":"";try{W=new RegExp(he,pe)}catch{throw this.B("REGEX",M)}}}if(W===null)throw this.B("REGEX",M);return le.create(E,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,R);const M=this.u();return n.notIn(E,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return n.equals(E,M);switch(M){case"true":return n.has(E);case"false":return n.not(E);default:return n.equals(E,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return n.notEquals(E,M);switch(M){case"true":return n.not(E);case"false":return n.has(E);default:return n.notEquals(E,M)}}case 5:return this.z(),ie.create(E,this.u());case 6:return this.z(),ue.create(E,this.u());case 7:return this.z(),J.create(E,this.u());case 8:return this.z(),ne.create(E,this.u());case 13:return this.z(),n.in(E,this.u());default:return n.has(E)}}case 20:throw this.h.push({message:v,offset:m.offset,lexeme:"",additionalInfo:p}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const m=this.D();switch(m.type){case 17:case 18:return this.z(),m.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(m){return m.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(m){return this.C(m)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(m,E){if(this.C(m))return this.z();throw this.B(E,this.D())}B(m,E,z){const M=(0,A.localize)(8,null,m,I.$tj.getLexeme(E)),G=E.offset,W=I.$tj.getLexeme(E);return this.h.push({message:M,offset:G,lexeme:W,additionalInfo:z}),g.c}C(m){return this.D().type===m}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=g;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(m){return f.create(m)}static equals(m,E){return S.create(m,E)}static notEquals(m,E){return L.create(m,E)}static regex(m,E){return le.create(m,E)}static in(m,E){return k.create(m,E)}static notIn(m,E){return j.create(m,E)}static not(m){return q.create(m)}static and(...m){return Z.create(m,null,!0)}static or(...m){return B.create(m,null,!0)}static greater(m,E){return J.create(m,E)}static greaterEquals(m,E){return ne.create(m,E)}static smaller(m,E){return ie.create(m,E)}static smallerEquals(m,E){return ue.create(m,E)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(m){return m==null?void 0:this.c.parse(m)}}e.$wj=n;function r(U){const m=new g({regexParsingWithErrorRecovery:!1});return U.map(E=>(m.parse(E),m.lexingErrors.length>0?m.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):m.parsingErrors.length>0?m.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function t(U,m){const E=U?U.substituteConstants():void 0,z=m?m.substituteConstants():void 0;return!E&&!z?!0:!E||!z?!1:E.equals(z)}function i(U,m){return U.cmp(m)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!1}serialize(){return"false"}keys(){return[]}map(m){return this}negate(){return o.INSTANCE}}e.$zj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(m){return this.type-m.type}equals(m){return m.type===this.type}substituteConstants(){return this}evaluate(m){return!0}serialize(){return"true"}keys(){return[]}map(m){return this}negate(){return s.INSTANCE}}e.$Aj=o;class f{static create(m,E=null){const z=u.get(m);return typeof z=="boolean"?z?o.INSTANCE:s.INSTANCE:new f(m,E)}constructor(m,E){this.key=m,this.c=E,this.type=2}cmp(m){return m.type!==this.type?this.type-m.type:H(this.key,m.key)}equals(m){return m.type===this.type?this.key===m.key:!1}substituteConstants(){const m=u.get(this.key);return typeof m=="boolean"?m?o.INSTANCE:s.INSTANCE:this}evaluate(m){return!!m.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(m){return m.mapDefined(this.key)}negate(){return this.c||(this.c=q.create(this.key,this)),this.c}}e.$Bj=f;class S{static create(m,E,z=null){if(typeof E=="boolean")return E?f.create(m,z):q.create(m,z);const M=u.get(m);return typeof M=="boolean"?E===(M?"true":"false")?o.INSTANCE:s.INSTANCE:new S(m,E,z)}constructor(m,E,z){this.c=m,this.d=E,this.f=z,this.type=4}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){const m=u.get(this.c);if(typeof m=="boolean"){const E=m?"true":"false";return this.d===E?o.INSTANCE:s.INSTANCE}return this}evaluate(m){return m.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(m){return m.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Cj=S;class k{static create(m,E){return new k(m,E)}constructor(m,E){this.d=m,this.f=E,this.type=10,this.c=null}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.d,this.f,m.d,m.f)}equals(m){return m.type===this.type?this.d===m.d&&this.f===m.f:!1}substituteConstants(){return this}evaluate(m){const E=m.getValue(this.f),z=m.getValue(this.d);return Array.isArray(E)?E.includes(z):typeof z=="string"&&typeof E=="object"&&E!==null?h.call(E,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(m){return m.mapIn(this.d,this.f)}negate(){return this.c||(this.c=j.create(this.d,this.f)),this.c}}e.$Dj=k;class j{static create(m,E){return new j(m,E)}constructor(m,E){this.d=m,this.f=E,this.type=11,this.c=k.create(m,E)}cmp(m){return m.type!==this.type?this.type-m.type:this.c.cmp(m.c)}equals(m){return m.type===this.type?this.c.equals(m.c):!1}substituteConstants(){return this}evaluate(m){return!this.c.evaluate(m)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(m){return m.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=j;class L{static create(m,E,z=null){if(typeof E=="boolean")return E?q.create(m,z):f.create(m,z);const M=u.get(m);return typeof M=="boolean"?E===(M?"true":"false")?s.INSTANCE:o.INSTANCE:new L(m,E,z)}constructor(m,E,z){this.c=m,this.d=E,this.f=z,this.type=5}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){const m=u.get(this.c);if(typeof m=="boolean"){const E=m?"true":"false";return this.d===E?s.INSTANCE:o.INSTANCE}return this}evaluate(m){return m.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(m){return m.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Fj=L;class q{static create(m,E=null){const z=u.get(m);return typeof z=="boolean"?z?s.INSTANCE:o.INSTANCE:new q(m,E)}constructor(m,E){this.c=m,this.d=E,this.type=3}cmp(m){return m.type!==this.type?this.type-m.type:H(this.c,m.c)}equals(m){return m.type===this.type?this.c===m.c:!1}substituteConstants(){const m=u.get(this.c);return typeof m=="boolean"?m?s.INSTANCE:o.INSTANCE:this}evaluate(m){return!m.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(m){return m.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$Gj=q;function C(U,m){if(typeof U=="string"){const E=parseFloat(U);isNaN(E)||(U=E)}return typeof U=="string"||typeof U=="number"?m(U):s.INSTANCE}class J{static create(m,E,z=null){return C(E,M=>new J(m,M,z))}constructor(m,E,z){this.c=m,this.d=E,this.f=z,this.type=12}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){return this}evaluate(m){return typeof this.d=="string"?!1:parseFloat(m.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(m){return m.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Hj=J;class ne{static create(m,E,z=null){return C(E,M=>new ne(m,M,z))}constructor(m,E,z){this.c=m,this.d=E,this.f=z,this.type=13}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){return this}evaluate(m){return typeof this.d=="string"?!1:parseFloat(m.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(m){return m.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Ij=ne;class ie{static create(m,E,z=null){return C(E,M=>new ie(m,M,z))}constructor(m,E,z){this.c=m,this.d=E,this.f=z,this.type=14}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){return this}evaluate(m){return typeof this.d=="string"?!1:parseFloat(m.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(m){return m.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Jj=ie;class ue{static create(m,E,z=null){return C(E,M=>new ue(m,M,z))}constructor(m,E,z){this.c=m,this.d=E,this.f=z,this.type=15}cmp(m){return m.type!==this.type?this.type-m.type:Q(this.c,this.d,m.c,m.d)}equals(m){return m.type===this.type?this.c===m.c&&this.d===m.d:!1}substituteConstants(){return this}evaluate(m){return typeof this.d=="string"?!1:parseFloat(m.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(m){return m.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Kj=ue;class le{static create(m,E){return new le(m,E)}constructor(m,E){this.d=m,this.f=E,this.type=7,this.c=null}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.d<m.d)return-1;if(this.d>m.d)return 1;const E=this.f?this.f.source:"",z=m.f?m.f.source:"";return E<z?-1:E>z?1:0}equals(m){if(m.type===this.type){const E=this.f?this.f.source:"",z=m.f?m.f.source:"";return this.d===m.d&&E===z}return!1}substituteConstants(){return this}evaluate(m){const E=m.getValue(this.d);return this.f?this.f.test(E):!1}serialize(){const m=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${m}`}keys(){return[this.d]}map(m){return m.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Lj=le;class ce{static create(m){return new ce(m)}constructor(m){this.c=m,this.type=8}cmp(m){return m.type!==this.type?this.type-m.type:this.c.cmp(m.c)}equals(m){return m.type===this.type?this.c.equals(m.c):!1}substituteConstants(){return this}evaluate(m){return!this.c.evaluate(m)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(m){return new ce(this.c.map(m))}negate(){return this.c}}e.$Mj=ce;function V(U){let m=null;for(let E=0,z=U.length;E<z;E++){const M=U[E].substituteConstants();if(U[E]!==M&&m===null){m=[];for(let G=0;G<E;G++)m[G]=U[G]}m!==null&&(m[E]=M)}return m===null?U:m}class Z{static create(m,E,z){return Z.d(m,E,z)}constructor(m,E){this.expr=m,this.c=E,this.type=6}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let E=0,z=this.expr.length;E<z;E++){const M=i(this.expr[E],m.expr[E]);if(M!==0)return M}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let E=0,z=this.expr.length;E<z;E++)if(!this.expr[E].equals(m.expr[E]))return!1;return!0}return!1}substituteConstants(){const m=V(this.expr);return m===this.expr?this:Z.create(m,this.c,!1)}evaluate(m){for(let E=0,z=this.expr.length;E<z;E++)if(!this.expr[E].evaluate(m))return!1;return!0}static d(m,E,z){const M=[];let G=!1;for(const W of m)if(W){if(W.type===1){G=!0;continue}if(W.type===0)return s.INSTANCE;if(W.type===6){M.push(...W.expr);continue}M.push(W)}if(M.length===0&&G)return o.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(i);for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];for(;M.length>1;){const W=M[M.length-1];if(W.type!==9)break;M.pop();const te=M.pop(),ae=M.length===0,he=B.create(W.expr.map(pe=>Z.create([pe,te],null,z)),null,ae);he&&(M.push(he),M.sort(i))}if(M.length===1)return M[0];if(z){for(let W=0;W<M.length;W++)for(let te=W+1;te<M.length;te++)if(M[W].negate().equals(M[te]))return s.INSTANCE;if(M.length===1)return M[0]}return new Z(M,E)}}serialize(){return this.expr.map(m=>m.serialize()).join(" && ")}keys(){const m=[];for(const E of this.expr)m.push(...E.keys());return m}map(m){return new Z(this.expr.map(E=>E.map(m)),null)}negate(){if(!this.c){const m=[];for(const E of this.expr)m.push(E.negate());this.c=B.create(m,this,!0)}return this.c}}e.$Nj=Z;class B{static create(m,E,z){return B.d(m,E,z)}constructor(m,E){this.expr=m,this.c=E,this.type=9}cmp(m){if(m.type!==this.type)return this.type-m.type;if(this.expr.length<m.expr.length)return-1;if(this.expr.length>m.expr.length)return 1;for(let E=0,z=this.expr.length;E<z;E++){const M=i(this.expr[E],m.expr[E]);if(M!==0)return M}return 0}equals(m){if(m.type===this.type){if(this.expr.length!==m.expr.length)return!1;for(let E=0,z=this.expr.length;E<z;E++)if(!this.expr[E].equals(m.expr[E]))return!1;return!0}return!1}substituteConstants(){const m=V(this.expr);return m===this.expr?this:B.create(m,this.c,!1)}evaluate(m){for(let E=0,z=this.expr.length;E<z;E++)if(this.expr[E].evaluate(m))return!0;return!1}static d(m,E,z){let M=[],G=!1;if(m){for(let W=0,te=m.length;W<te;W++){const ae=m[W];if(ae){if(ae.type===0){G=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){M=M.concat(ae.expr);continue}M.push(ae)}}if(M.length===0&&G)return s.INSTANCE;M.sort(i)}if(M.length!==0){if(M.length===1)return M[0];for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];if(z){for(let W=0;W<M.length;W++)for(let te=W+1;te<M.length;te++)if(M[W].negate().equals(M[te]))return o.INSTANCE;if(M.length===1)return M[0]}return new B(M,E)}}serialize(){return this.expr.map(m=>m.serialize()).join(" || ")}keys(){const m=[];for(const E of this.expr)m.push(...E.keys());return m}map(m){return new B(this.expr.map(E=>E.map(m)),null)}negate(){if(!this.c){const m=[];for(const E of this.expr)m.push(E.negate());for(;m.length>1;){const E=m.shift(),z=m.shift(),M=[];for(const G of F(E))for(const W of F(z))M.push(Z.create([G,W],null,!1));m.unshift(B.create(M,null,!1))}this.c=B.create(m,this,!0)}return this.c}}e.$Oj=B;class T extends f{static{this.d=[]}static all(){return T.d.values()}constructor(m,E,z){super(m,null),this.f=E,typeof z=="object"?T.d.push({...z,key:m}):z!==!0&&T.d.push({key:m,description:z,type:E!=null?typeof E:void 0})}bindTo(m){return m.createKey(this.key,this.f)}getValue(m){return m.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(m){return S.create(this.key,m)}notEqualsTo(m){return L.create(this.key,m)}}e.$Pj=T,e.$Qj=(0,N.$yi)("contextKeyService");function H(U,m){return U<m?-1:U>m?1:0}function Q(U,m,E,z){return U<E?-1:U>E?1:m<z?-1:m>z?1:0}function Y(U,m){if(U.type===0||m.type===1)return!0;if(U.type===9)return m.type===9?_(U.expr,m.expr):!1;if(m.type===9){for(const E of m.expr)if(Y(U,E))return!0;return!1}if(U.type===6){if(m.type===6)return _(m.expr,U.expr);for(const E of U.expr)if(Y(E,m))return!0;return!1}return U.equals(m)}function _(U,m){let E=0,z=0;for(;E<U.length&&z<m.length;){const M=U[E].cmp(m[z]);if(M<0)return!1;M===0&&E++,z++}return E===U.length}function F(U){return U.type===9?U.expr:[U]}}),define(se[61],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0,e.$No=(0,O.$yi)("downloadService")}),define(se[18],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,O.$yi)("environmentService"),e.$Gi=(0,O.$zi)(e.$Fi)}),define(se[21],re([0,1,97,10]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.ExtensionManagementErrorCode=e.$$o=e.ExtensionGalleryErrorCode=e.$0o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$4o=I,e.$5o=N,e.$6o=A,e.$7o=P,e.$8o=u,e.$9o=a,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionsSync",e.$2o="dependecyOrPackExtensionInstall",e.$3o="clientTargetPlatform";function I(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(c,v){switch(c){case 3:return v==="x64"?"win32-x64":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function P(c,v){return v==="web"&&!c.includes("web")}function u(c,v,p){return P(v,p)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===p}function a(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var h;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(h||(e.SortBy=h={}));var b;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var y;(function(c){c.Install="install",c.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var w;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$0o=(0,D.$yi)("extensionGalleryService");var $;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed",c.DownloadFailedWriting="DownloadFailedWriting"})($||(e.ExtensionGalleryErrorCode=$={}));class R extends Error{constructor(v,p){super(v),this.code=p,this.name=p}}e.$$o=R;var d;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.DownloadFailedWriting="DownloadFailedWriting",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.ScanningExtension="ScanningExtension",c.ReadUninstalled="ReadUninstalled",c.UnsetUninstalled="UnsetUninstalled",c.Delete="Delete",c.Rename="Rename",c.IntializeDefaultProfile="IntializeDefaultProfile",c.AddToProfile="AddToProfile",c.PostInstall="PostInstall",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));class l extends Error{constructor(v,p){super(v),this.code=p,this.name=p}}e.$_o=l,e.$ap=(0,D.$yi)("extensionManagementService"),e.$bp="extensionsIdentifiers/disabled",e.$cp="extensionsIdentifiers/enabled",e.$dp=(0,D.$yi)("IGlobalExtensionEnablementService"),e.$ep=(0,D.$yi)("IExtensionTipsService"),e.$fp=(0,O.localize2)(0,"Extensions"),e.$gp=(0,O.localize2)(1,"Preferences")}),define(se[62],re([0,1,14,9,105,13]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=A;async function A(h,b,y,w,$,R){let d;try{await P(h,b,y,w,$,R)}catch(l){d=l}finally{d&&$.errorTransformer&&(d=$.errorTransformer(d)),typeof d<"u"&&y.error(d),y.end()}}async function P(h,b,y,w,$,R){u(R);const d=await h.open(b,{create:!1});try{u(R);let l=0,c=0,v=$&&typeof $.length=="number"?$.length:void 0,p=O.$He.alloc(Math.min($.bufferSize,typeof v=="number"?v:$.bufferSize)),g=$&&typeof $.position=="number"?$.position:0,n=0;do c=await h.read(d,g,p.buffer,n,p.byteLength-n),g+=c,n+=c,l+=c,typeof v=="number"&&(v-=c),n===p.byteLength&&(await y.write(w(p)),p=O.$He.alloc(Math.min($.bufferSize,typeof v=="number"?v:$.bufferSize)),n=0);while(c>0&&(typeof v!="number"||v>0)&&u(R)&&a(l,$));if(n>0){let r=n;typeof v=="number"&&(r=Math.min(n,v)),y.write(w(p.slice(0,r)))}}catch(l){throw(0,N.$gl)(l)}finally{await h.close(d)}}function u(h){if(h.isCancellationRequested)throw(0,D.$6)();return!0}function a(h,b){if(typeof b?.limits?.size=="number"&&h>b.limits.size)throw(0,N.$fl)((0,I.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[124],re([0,1,60,2,52,5,11,8]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;class u extends D.$Uc{constructor(){super(),this.a=this.B(new N.$fe),this.onDidChangeFile=this.a.event,this.b=this.B(new N.$fe),this.onDidLogMessage=this.b.event,this.c=this.B(new N.$fe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new D.$4c),this.m=new Set,this.n=5007,this.r=new P.$Vh,this.P=!1,this.B(this.f(h=>this.s(h)))}s(h){this.t(h)&&this.w(h)}t(h){return(0,I.$Nq)(h)}async watch(h){this.r.isSettled||this.r.complete(),this.r=new P.$Vh;try{this.h.clear(),this.g.clear();for(const b of h)this.t(b)?this.h.set(b.correlationId,b):this.g.add(b);for(const[b]of this.j)this.h.has(b)||(this.j.deleteAndDispose(b),this.m.delete(b));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(h=>!this.j.has(h.correlationId))])}isSuspended(h){return typeof h.correlationId!="number"?!1:this.m.has(h.correlationId)?"polling":this.j.has(h.correlationId)}async w(h){if(this.j.has(h.correlationId))return;const b=new D.$Tc;this.j.set(h.correlationId,b),await this.r.p,!b.isDisposed&&(this.z(h,b),this.u())}y(h){this.j.deleteAndDispose(h.correlationId),this.m.delete(h.correlationId),this.u()}z(h,b){this.C(h,b)?(this.N(`reusing an existing recursive watcher to monitor ${h.path}`),this.m.delete(h.correlationId)):(this.D(h,b),this.m.add(h.correlationId))}C(h,b){const y=this.M?.subscribe(h.path,(w,$)=>{b.isDisposed||(w?this.z(h,b):$?.type===1&&this.F(h))});return y?(b.add(y),!0):!1}D(h,b){let y=!1;const w=($,R)=>{if(b.isDisposed)return;const d=this.G($),l=this.G(R),c=y;y=d,!d&&(l||c)&&this.F(h)};this.N(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,O.watchFile)(h.path,{persistent:!1,interval:this.n},w)}catch($){this.O(`fs.watchFile() failed with error ${$} on path ${h.path} (correlationId: ${h.correlationId})`)}b.add((0,D.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,O.unwatchFile)(h.path,w)}catch($){this.O(`fs.unwatchFile() failed with error ${$} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}F(h){this.N(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const b={resource:A.URI.file(h.path),type:1,cId:h.correlationId};this.a.fire([b]),this.H(b,h),this.y(h)}G(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(h,b){if(this.P){const y=` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.I(y,b)}}I(h,b){this.P&&this.N(`${h}${typeof b.correlationId=="number"?` <${b.correlationId}> `:""}`)}J(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,I.$Xq)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.P=h}}e.$7q=u}),define(se[125],re([0,1,5,171,124,12,172,63]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class u extends I.$7q{constructor(h){super(),this.M=h,this.onDidError=O.Event.None,this.watchers=new Set}async L(h){h=this.X(h);const b=[],y=new Set(Array.from(this.watchers));for(const w of h){const $=this.S(w);$&&(0,D.$wk)($.request.excludes,w.excludes)&&(0,D.$wk)($.request.includes,w.includes)?y.delete($):b.push(w)}b.length&&this.N(`Request to start watching: ${b.map(w=>this.J(w)).join(",")}`),y.size&&this.N(`Request to stop watching: ${Array.from(y).map(w=>this.J(w.request)).join(",")}`);for(const w of y)this.W(w);for(const w of b)this.U(w)}S(h){for(const b of this.watchers)if(typeof h.correlationId=="number"||typeof b.request.correlationId=="number"){if(b.request.correlationId===h.correlationId)return b}else if((0,P.$wg)(b.request.path,h.path,!N.$k))return b}U(h){const b=new A.$_q(h,this.M,w=>this.a.fire(w),()=>this.c.fire(h),w=>this.b.fire(w),this.P),y={request:h,instance:b};this.watchers.add(y)}async stop(){await super.stop();for(const h of this.watchers)this.W(h)}W(h){this.N("stopping file watcher",h),this.watchers.delete(h),h.instance.dispose()}X(h){const b=new Map;for(const y of h){const w=N.$k?y.path:y.path.toLowerCase();let $=b.get(y.correlationId);$||($=new Map,b.set(y.correlationId,$)),$.has(w)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(y)}`),$.set(w,y)}return Array.from(b.values()).map(y=>Array.from(y.values())).flat()}async setVerboseLogging(h){super.setVerboseLogging(h);for(const b of this.watchers)b.instance.setVerboseLogging(h)}N(h,b){this.P&&this.b.fire({type:"trace",message:this.$(h,b)})}O(h){this.b.fire({type:"warn",message:this.$(h)})}$(h,b){return b?`[File Watcher (node.js)] ${h} (${this.J(b.request)})`:`[File Watcher (node.js)] ${h}`}}e.$br=u}),define(se[126],re([0,1,52,125]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class I extends O.$Qq{constructor(A,P,u){super(A,P,u),this.s()}r(A){return A.add(new D.$br(void 0))}}e.$cr=I}),define(se[127],re([0,1,15,58,90,52]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class A extends N.$Rq{constructor(u,a,h){super(u,a,h),this.s()}r(u){const a=u.add(new I.$5q(O.$Sg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:h,signal:b})=>this.t(`terminated by itself with code ${h}, signal: ${b} (ETERM)`))),D.ProxyChannel.toService((0,D.$fi)(a.getChannel("watcher")))}}e.$6q=A}),define(se[64],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class O{constructor(...I){this.a=new Map;for(const[N,A]of I)this.set(N,A)}set(I,N){const A=this.a.get(I);return this.a.set(I,N),A}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$wi=O}),define(se[128],re([0,1,8,9,2,51,122,10,64,173]),function(X,e,O,D,I,N,A,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;const h=!1;class b extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class y{constructor(d=new u.$wi,l=!1,c,v=h){this.i=d,this.j=l,this.k=c,this.l=v,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(P.$xi,this),this._globalGraph=v?c?._globalGraph??new A.$fr(p=>p):void 0}dispose(){if(!this.f){this.f=!0,(0,I.$Pc)(this.h),this.h.clear();for(const d of this.g)(0,I.$Oc)(d)&&d.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(d){this.m();const l=new class extends y{dispose(){this.h.delete(l),super.dispose()}}(d,this.j,this,this.l);return this.h.add(l),l}invokeFunction(d,...l){this.m();const c=$.traceInvocation(this.l,d);let v=!1;try{return d({get:g=>{if(v)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const n=this.s(g,c);if(!n)throw new Error(`[invokeFunction] unknown service '${g}'`);return n}},...l)}finally{v=!0,c.stop()}}createInstance(d,...l){this.m();let c,v;return d instanceof N.$vi?(c=$.traceCreation(this.l,d.ctor),v=this.o(d.ctor,d.staticArguments.concat(l),c)):(c=$.traceCreation(this.l,d),v=this.o(d,l,c)),c.stop(),v}o(d,l=[],c){const v=P._util.getServiceDependencies(d).sort((n,r)=>n.index-r.index),p=[];for(const n of v){const r=this.s(n.id,c);r||this.y(`[createInstance] ${d.name} depends on UNKNOWN service ${n.id}.`,!1),p.push(r)}const g=v.length>0?v[0].index:l.length;if(l.length!==g){console.trace(`[createInstance] First service dependency of ${d.name} at position ${g+1} conflicts with ${l.length} static arguments`);const n=g-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,g)}return Reflect.construct(d,l.concat(p))}q(d,l){if(this.i.get(d)instanceof N.$vi)this.i.set(d,l);else if(this.k)this.k.q(d,l);else throw new Error("illegalState - setting UNKNOWN service instance")}r(d){const l=this.i.get(d);return!l&&this.k?this.k.r(d):l}s(d,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const c=this.r(d);return c instanceof N.$vi?this.u(d,c,l.branch(d,!0)):(l.branch(d,!1),c)}u(d,l,c){if(this.t.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.t.add(d);try{return this.v(d,l,c)}finally{this.t.delete(d)}}v(d,l,c){const v=new A.$fr(n=>n.id.toString());let p=0;const g=[{id:d,desc:l,_trace:c}];for(;g.length;){const n=g.pop();if(v.lookupOrInsertNode(n),p++>1e3)throw new b(v);for(const r of P._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${d} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof N.$vi){const i={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};v.insertEdge(n,i),g.push(i)}}}for(;;){const n=v.roots();if(n.length===0){if(!v.isEmpty())throw new b(v);break}for(const{data:r}of n){if(this.r(r.id)instanceof N.$vi){const i=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,i)}v.removeNode(r)}}return this.r(d)}w(d,l,c=[],v,p){if(this.i.get(d)instanceof N.$vi)return this.x(d,l,c,v,p,this.g);if(this.k)return this.k.w(d,l,c,v,p);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}x(d,l,c=[],v,p,g){if(v){const n=new y(void 0,this.j,this,this.l);n.c=String(d);const r=new Map,t=new O.$Rh(()=>{const i=n.o(l,c,p);for(const[s,o]of r){const f=i[s];if(typeof f=="function")for(const S of o)S.disposable=f.apply(i,S.listener)}return r.clear(),g.add(i),i});return new Proxy(Object.create(null),{get(i,s){if(!t.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let S=r.get(s);return S||(S=new a.$5c,r.set(s,S)),(j,L,q)=>{if(t.isInitialized)return t.value[s](j,L,q);{const C={listener:[j,L,q],disposable:void 0},J=S.push(C);return(0,I.$Sc)(()=>{J(),C.disposable?.dispose()})}}}if(s in i)return i[s];const o=t.value;let f=o[s];return typeof f!="function"||(f=f.bind(o),i[s]=f),f},set(i,s,o){return t.value[s]=o,!0},getPrototypeOf(i){return l.prototype}})}else{const n=this.o(l,c,p);return g.add(n),n}}y(d,l){if(l&&console.warn(d),this.j)throw new Error(d)}}e.$gr=y;var w;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})(w||(w={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,l){return d?new $(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(d,l){return d?new $(1,l.name):$.c}static{this.f=0}constructor(d,l){this.type=d,this.name=l,this.g=Date.now(),this.h=[]}branch(d,l){const c=new $(3,d.toString());return this.h.push([d,l,c]),c}stop(){const d=Date.now()-this.g;$.f+=d;let l=!1;function c(p,g){const n=[],r=new Array(p+1).join("	");for(const[t,i,s]of g.h)if(i&&s){l=!0,n.push(`${r}CREATES -> ${t}`);const o=c(p+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(d>2||l)&&$.all.add(v.join(`
`))}}e.$hr=$});var oe=this&&this.__param||function(X,e){return function(O,D){e(O,D,X)}};define(se[65],re([0,1,20,2,12,107,21,10]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=void 0,e.$Ur=u;function u(h){return h.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.$Vr=(0,P.$yi)("languagePackService");let a=class extends D.$Uc{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new O.$qe;setTimeout(()=>b.cancel(),1e3);let y;try{y=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const $=y.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(d=>d.startsWith("lp-"))).map(R=>{const d=R.properties.localizedLanguages?.[0],l=u(R);return{...this.f(l,d,R),extensionId:R.identifier.id,galleryExtension:R}});return $.push(this.f("en","English")),$}f(b,y,w){const $=y??b;let R;if($!==b&&(R=`(${b})`),b.toLowerCase()===I.$w.toLowerCase()&&(R??="",R+=(0,N.localize)(0,null)),w?.installCount){R??="";const d=w.installCount;let l;d>1e6?l=`${Math.floor(d/1e5)/10}M`:d>1e3?l=`${Math.floor(d/1e3)}K`:l=String(d),R+=` $(cloud-download) ${l}`}return{id:b,label:$,description:R}}};e.$Wr=a,e.$Wr=a=$e([oe(0,A.$0o)],a)}),define(se[6],re([0,1,108,34,5,43,2,30,12,17,3,11,123,10]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=R,e.log=l,e.$gk=f,e.$hk=S,e.$ik=k,e.$jk=j,e.$5j=(0,w.$yi)("logService"),e.$6j=(0,w.$yi)("loggerService");function $(){return new Date().toISOString()}function R(L){return(0,h.$cg)(L)}var d;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$8j=d.Info;function l(L,q,C){switch(q){case d.Trace:L.trace(C);break;case d.Debug:L.debug(C);break;case d.Info:L.info(C);break;case d.Warning:L.warn(C);break;case d.Error:L.error(C);break;case d.Off:break;default:throw new Error(`Invalid log level ${q}`)}}function c(L,q=!1){let C="";for(let J=0;J<L.length;J++){let ne=L[J];if(ne instanceof Error&&(ne=(0,D.$jj)(ne,q)),typeof ne=="object")try{ne=JSON.stringify(ne)}catch{}C+=(J>0?" ":"")+ne}return C}class v extends A.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new I.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(q){this.b!==q&&(this.b=q,this.c.fire(this.b))}getLevel(){return this.b}f(q){return this.b!==d.Off&&this.b<=q}}e.$0j=v;class p extends v{constructor(q){super(),this.h=q}f(q){return this.h||super.f(q)}trace(q,...C){this.f(d.Trace)&&this.g(d.Trace,c([q,...C],!0))}debug(q,...C){this.f(d.Debug)&&this.g(d.Debug,c([q,...C]))}info(q,...C){this.f(d.Info)&&this.g(d.Info,c([q,...C]))}warn(q,...C){this.f(d.Warning)&&this.g(d.Warning,c([q,...C]))}error(q,...C){if(this.f(d.Error))if(q instanceof Error){const J=Array.prototype.slice.call(arguments);J[0]=q.stack,this.g(d.Error,c(J))}else this.g(d.Error,c([q,...C]))}flush(){}}e.$$j=p;class g extends v{constructor(q=e.$8j){super(),this.setLevel(q),this.g=!u.$i}trace(q,...C){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,q,...C):console.log(`[main ${$()}]`,q,...C))}debug(q,...C){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,q,...C):console.log(`[main ${$()}]`,q,...C))}info(q,...C){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,q,...C):console.log(`[main ${$()}]`,q,...C))}warn(q,...C){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,q,...C):console.warn(`[main ${$()}]`,q,...C))}error(q,...C){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,q,...C):console.error(`[main ${$()}]`,q,...C))}flush(){}}e.$_j=g;class n extends v{constructor(q=e.$8j,C=!0){super(),this.g=C,this.setLevel(q)}trace(q,...C){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",q,...C):console.log(q,...C))}debug(q,...C){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",q,...C):console.log(q,...C))}info(q,...C){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",q,...C):console.log(q,...C))}warn(q,...C){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",q,...C):console.log(q,...C))}error(q,...C){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",q,...C):console.error(q,...C))}flush(){}}e.$ak=n;class r extends v{constructor(q,C=e.$8j){super(),this.g=q,this.setLevel(C)}trace(q,...C){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(q),...C])}debug(q,...C){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(q),...C])}info(q,...C){this.f(d.Info)&&this.g.log(d.Info,[this.h(q),...C])}warn(q,...C){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(q),...C])}error(q,...C){this.f(d.Error)&&this.g.log(d.Error,[this.h(q),...C])}h(q){return typeof q=="string"?q:(0,D.$jj)(q,this.f(d.Trace))}flush(){}}e.$bk=r;class t extends v{constructor(q){super(),this.g=q,q.length&&this.setLevel(q[0].getLevel())}setLevel(q){for(const C of this.g)C.setLevel(q);super.setLevel(q)}trace(q,...C){for(const J of this.g)J.trace(q,...C)}debug(q,...C){for(const J of this.g)J.debug(q,...C)}info(q,...C){for(const J of this.g)J.info(q,...C)}warn(q,...C){for(const J of this.g)J.warn(q,...C)}error(q,...C){for(const J of this.g)J.error(q,...C)}flush(){for(const q of this.g)q.flush()}dispose(){for(const q of this.g)q.dispose();super.dispose()}}e.$ck=t;class i extends A.$Uc{constructor(q,C,J){if(super(),this.h=q,this.j=C,this.b=new P.$Ac,this.c=this.B(new I.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$fe),this.onDidChangeVisibility=this.g.event,J)for(const ne of J)this.b.set(ne.resource,{logger:void 0,info:ne})}m(q){return(0,h.$$f)(q)?[...this.b.values()].find(C=>C.info.id===q):this.b.get(q)}getLogger(q){return this.m(q)?.logger}createLogger(q,C){const J=this.n(q),ne=(0,h.$$f)(q)?q:C?.id??(0,N.$mj)(J.toString()).toString(16);let ie=this.b.get(J)?.logger;const ue=C?.logLevel==="always"?d.Trace:C?.logLevel;ie||(ie=this.s(J,ue??this.getLogLevel(J)??this.h,{...C,id:ne}));const le={logger:ie,info:{resource:J,id:ne,logLevel:ue,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(le.info),this.b.set(J,le),ie}n(q){return(0,h.$$f)(q)?(0,a.$_g)(this.j,`${q}.log`):q}setLogLevel(q,C){if(b.URI.isUri(q)){const J=q,ne=C,ie=this.b.get(J);ie&&ne!==ie.info.logLevel&&(ie.info.logLevel=ne===this.h?void 0:ne,ie.logger?.setLevel(ne),this.b.set(ie.info.resource,ie),this.f.fire([J,ne]))}else{this.h=q;for(const[J,ne]of this.b.entries())this.b.get(J)?.info.logLevel===void 0&&ne.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(q,C){const J=this.m(q);J&&C!==!J.info.hidden&&(J.info.hidden=!C,this.b.set(J.info.resource,J),this.g.fire([J.info.resource,C]))}getLogLevel(q){let C;return q&&(C=this.b.get(q)?.info.logLevel),C??this.h}registerLogger(q){const C=this.b.get(q.resource);C?C.info.hidden!==q.hidden&&this.setVisibility(q.resource,!q.hidden):(this.b.set(q.resource,{info:q,logger:void 0}),this.c.fire({added:[q],removed:[]}))}deregisterLogger(q){const C=this.b.get(q);C&&(C.logger&&C.logger.dispose(),this.b.delete(q),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const q of this.b.values())yield q.info}getRegisteredLogger(q){return this.b.get(q)?.info}dispose(){this.b.forEach(q=>q.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=i;class s{constructor(){this.onDidChangeLogLevel=new I.$fe().event}setLevel(q){}getLevel(){return d.Info}trace(q,...C){}debug(q,...C){}info(q,...C){}warn(q,...C){}error(q,...C){}critical(q,...C){}dispose(){}flush(){}}e.$ek=s;class o extends s{}e.$fk=o;function f(L){if(L.verbose)return d.Trace;if(typeof L.logLevel=="string"){const q=j(L.logLevel.toLowerCase());if(q!==void 0)return q}return e.$8j}function S(L){switch(L){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function k(L){switch(L){case d.Trace:return{original:"Trace",value:O.localize(0,null)};case d.Debug:return{original:"Debug",value:O.localize(1,null)};case d.Info:return{original:"Info",value:O.localize(2,null)};case d.Warning:return{original:"Warning",value:O.localize(3,null)};case d.Error:return{original:"Error",value:O.localize(4,null)};case d.Off:return{original:"Off",value:O.localize(5,null)}}}function j(L){switch(L){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$kk=new y.$Pj("logLevel",S(d.Info))}),define(se[129],re([0,1,19,8,9,5,63,2,16,52,6]),function(X,e,O,D,I,N,A,P,u,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class b extends P.$Uc{constructor(w,$){super(),this.a=w,this.b=$,this.c=this.B(new N.$fe),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$fe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$wh(0)),this.w=[],this.y=this.B(new D.$wh(0))}watch(w,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(w,$):this.z(w,$)}n(w,$){const R={path:this.J(w),excludes:$.excludes,includes:$.includes,recursive:$.recursive,filter:$.filter,correlationId:$.correlationId},d=(0,O.$Tb)(this.j,R);return this.r(),(0,P.$Sc)(()=>{d(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,I.$1)(w))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,a.$Sq)($)),$=>this.G($),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const $ of this.j)(0,a.$Oq)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const $ of this.j)(0,a.$Oq)($)&&w.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,$){const R={path:this.J(w),excludes:$.excludes,includes:$.includes,recursive:!1,filter:$.filter,correlationId:$.correlationId},d=(0,O.$Tb)(this.w,R);return this.C(),(0,P.$Sc)(()=>{d(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,I.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,a.$Sq)(w)),w=>this.G(w),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,u.$hc)(w.fsPath)}J(w){const $=this.I(w);return(0,A.$Ag)($)}}e.$Yq=b}),define(se[130],re([0,1,19,8,14,20,5,43,66,2,48,15,131,17,46,104,13,62,6,9]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$,R,d,l,c,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;let g=class extends a.$Uc{static{p=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new A.$fe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$fe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$fe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$fe),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$fe),this.Y=this.B(new A.$fe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$fe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$Hh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${r}`);const i=new a.$Tc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),i.add(t.onDidChangeFile(s=>{const o=new d.$ll(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Pc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(i){t.push(i)}}),!this.h.has(r)&&await D.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,w.$dh)(r))throw new d.$nl((0,R.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const i=new v.$bb;throw i.message=(0,R.localize)(1,null,r.toString()),i}return t}async m(r){const t=await this.j(r);if((0,d.$$k)(t)||(0,d.$8k)(t)||(0,d.$_k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,d.$$k)(t)||(0,d.$8k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(i){throw(0,d.$il)(i)===d.FileSystemProviderErrorCode.FileNotFound?new d.$nl((0,R.localize)(2,null,this.sb(r)),1):(0,d.$gl)(i)}}async s(r,t){const i=await this.j(r),s=this.S(i),o=t?.resolveTo,f=t?.resolveSingleChildDescendants,S=t?.resolveMetadata,k=await i.stat(r);let j;return this.t(i,r,k,void 0,!!S,(L,q)=>(j||(j=h.$Ei.forUris(()=>!s),j.set(r,!0),o&&j.fill(!0,o)),j.get(L.resource)||j.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&f?q===1:!1))}async t(r,t,i,s,o,f){const{providerExtUri:S}=this.R(r),k={resource:t,name:S.basename(t),isFile:(i.type&d.FileType.File)!==0,isDirectory:(i.type&d.FileType.Directory)!==0,isSymbolicLink:(i.type&d.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&d.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&d.FilePermission.Locked),etag:(0,d.$yl)({mtime:i.mtime,size:i.size}),children:void 0};if(k.isDirectory&&f(k,s)){try{const j=await r.readdir(t),L=await D.Promises.settled(j.map(async([q,C])=>{try{const J=S.joinPath(t,q),ne=o?await r.stat(J):{type:C};return await this.t(r,J,ne,j.length,o,f)}catch(J){return this.b.trace(J),null}}));k.children=(0,O.$Hb)(L)}catch(j){this.b.trace(j),k.children=[]}return k}return k}async resolveAll(r){return D.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),i=await t.stat(r);return this.t(t,r,i,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(i){return i}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new d.$nl((0,R.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=I.$He.fromString(""),i){await this.u(r,i);const s=await this.writeFile(r,t);return this.r.fire(new d.$kl(r,0,s)),s}async writeFile(r,t,i){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let f=i;if((0,d.$bl)(s)&&!f?.atomic){const S=s.enforceAtomicWriteFile?.(r);S&&(f={...i,atomic:S})}try{await this.w(s,r,f)||await this.U(s,o.dirname(r));let k;if((0,d.$8k)(s)&&!(t instanceof I.$He))if((0,$.$te)(t)){const j=await(0,$.$Ae)(t,3);j.ended?k=I.$He.concat(j.buffer):k=j}else k=(0,$.$xe)(t,j=>I.$He.concat(j),3);else k=t;!(0,d.$$k)(s)||(0,d.$8k)(s)&&k instanceof I.$He||(0,d.$8k)(s)&&(0,d.$bl)(s)&&f?.atomic?await this.hb(s,r,f,k):await this.db(s,r,f,k instanceof I.$He?(0,I.$Se)(k):k),this.r.fire(new d.$kl(r,4))}catch(S){throw new d.$nl((0,R.localize)(4,null,this.sb(r),(0,d.$gl)(S).toString()),(0,d.$jl)(S),f)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,i){const s=!!i?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,R.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,R.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,R.localize)(7,null,this.sb(t)));if(s)throw new Error((0,R.localize)(8,null,this.sb(t)))}let f;try{f=await r.stat(t)}catch{return}if(f.type&d.FileType.Directory)throw new d.$nl((0,R.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,f),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==d.$xl&&typeof f.mtime=="number"&&typeof f.size=="number"&&i.mtime<f.mtime&&i.etag!==(0,d.$yl)({mtime:i.mtime,size:f.size}))throw new d.$nl((0,R.localize)(10,null),3,i);return f}async readFile(r,t,i){const s=await this.m(r);return t?.atomic?this.z(s,r,t,i):this.C(s,r,t,i)}async z(r,t,i,s){return new Promise((o,f)=>{this.cb.queueFor(t,async()=>{try{const S=await this.C(r,t,i,s);o(S)}catch(S){f(S)}},this.R(r).providerExtUri)})}async C(r,t,i,s){const o=await this.D(r,t,{...i,preferUnbuffered:!0},s);return{...o,value:await(0,I.$Te)(o.value)}}async readFileStream(r,t,i){const s=await this.m(r);return this.D(s,r,t,i)}async D(r,t,i,s){const o=new N.$qe(s);let f=i;(0,d.$al)(r)&&r.enforceAtomicReadFile?.(t)&&(f={...i,atomic:!0});const S=this.J(t,f).then(j=>j,j=>{throw o.dispose(!0),j});let k;try{return typeof f?.etag=="string"&&f.etag!==d.$xl&&await S,f?.atomic&&(0,d.$al)(r)||!((0,d.$$k)(r)||(0,d.$_k)(r))||(0,d.$8k)(r)&&f?.preferUnbuffered?k=this.I(r,t,f):(0,d.$_k)(r)?k=this.G(r,t,o.token,f):k=this.H(r,t,o.token,f),k.on("end",()=>o.dispose()),k.on("error",()=>o.dispose()),{...await S,value:k}}catch(j){throw k&&await(0,$.$ye)(k),this.F(j,t,f)}}F(r,t,i){const s=(0,R.localize)(11,null,this.sb(t),(0,d.$gl)(r).toString());return r instanceof d.$pl?new d.$pl(s,r.stat,i):r instanceof d.$ol?new d.$ol(s,r.fileOperationResult,r.size,r.options):new d.$nl(s,(0,d.$jl)(r),i)}G(r,t,i,s=Object.create(null)){const o=r.readFileStream(t,s,i);return(0,$.$Ee)(o,{data:f=>f instanceof I.$He?f:I.$He.wrap(f),error:f=>this.F(f,t,s)},f=>I.$He.concat(f))}H(r,t,i,s=Object.create(null)){const o=(0,I.$Xe)();return(0,l.$Lq)(r,t,o,f=>f,{...s,bufferSize:this.a,errorTransformer:f=>this.F(f,t,s)},i),o}I(r,t,i){const s=(0,$.$ve)(o=>I.$He.concat(o));return(async()=>{try{let o;i?.atomic&&(0,d.$al)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(t,o.byteLength,i),s.end(I.$He.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new d.$nl((0,R.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==d.$xl&&t.etag===i.etag)throw new d.$pl((0,R.localize)(13,null),i,t);return this.L(r,i.size,t),i}L(r,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new d.$ol((0,R.localize)(14,null,this.sb(r)),7,t,i)}async canMove(r,t,i){return this.M(r,t,"move",i)}async canCopy(r,t,i){return this.M(r,t,"copy",i)}async M(r,t,i,s){if(r.toString()!==t.toString())try{const o=i==="move"?this.qb(await this.n(r),r):await this.m(r),f=this.qb(await this.n(t),t);await this.Q(o,r,f,t,i,s)}catch(o){return o}return!0}async move(r,t,i){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),f=await this.N(s,r,o,t,"move",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$kl(r,f==="move"?2:3,S)),S}async copy(r,t,i){const s=await this.m(r),o=this.qb(await this.n(t),t),f=await this.N(s,r,o,t,"copy",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$kl(r,f==="copy"?3:2,S)),S}async N(r,t,i,s,o,f){if(t.toString()===s.toString())return o;const{exists:S,isSameResourceWithDifferentPathCase:k}=await this.Q(r,t,i,s,o,f);if(S&&!k&&f&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),o==="copy"){if(r===i&&(0,d.$9k)(r))await r.copy(t,s,{overwrite:f});else{const j=await this.resolve(t);j.isDirectory?await this.P(r,j,i,s):await this.O(r,t,i,s)}return o}else return r===i?(await r.rename(t,s,{overwrite:f}),o):(await this.N(r,t,i,s,"copy",f),await this.del(t,{recursive:!0}),"copy")}async O(r,t,i,s){if((0,d.$$k)(r)&&(0,d.$$k)(i))return this.jb(r,t,i,s);if((0,d.$$k)(r)&&(0,d.$8k)(i))return this.pb(r,t,i,s);if((0,d.$8k)(r)&&(0,d.$$k)(i))return this.nb(r,t,i,s);if((0,d.$8k)(r)&&(0,d.$8k)(i))return this.lb(r,t,i,s)}async P(r,t,i,s){await i.mkdir(s),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async o=>{const f=this.R(i).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),i,f):this.O(r,o.resource,i,f)}))}async Q(r,t,i,s,o,f){let S=!1;if(r===i){const{providerExtUri:j,isPathCaseSensitive:L}=this.R(r);if(L||(S=j.isEqual(t,s)),S&&o==="copy")throw new Error((0,R.localize)(15,null,this.sb(t),this.sb(s)));if(!S&&j.isEqualOrParent(s,t))throw new Error((0,R.localize)(16,null,this.sb(t),this.sb(s)))}const k=await this.exists(s);if(k&&!S){if(!f)throw new d.$nl((0,R.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===i){const{providerExtUri:j}=this.R(r);if(j.isEqualOrParent(t,s))throw new Error((0,R.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:k,isSameResourceWithDifferentPathCase:S}}R(r){const t=this.S(r);return{providerExtUri:t?w.$2g:w.$4g,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new d.$kl(r,0,i)),i}async U(r,t){const i=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&d.FileType.Directory))throw new Error((0,R.localize)(19,null,this.sb(t)));break}catch(o){if((0,d.$il)(o)!==d.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(s.basename(t)),t=s.dirname(t)}for(let o=i.length-1;o>=0;o--){t=s.joinPath(t,i[o]);try{await r.mkdir(t)}catch(f){if((0,d.$il)(f)!==d.FileSystemProviderErrorCode.FileExists)throw f}}}async canDelete(r,t){try{await this.W(r,t)}catch(i){return i}return!0}async W(r,t){const i=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,R.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(i.capabilities&65536))throw new Error((0,R.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,R.localize)(22,null,this.sb(r)));let f;try{f=await i.stat(r)}catch{}if(f)this.rb(r,f);else throw new d.$nl((0,R.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const k=await this.resolve(r);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,R.localize)(24,null,this.sb(r)))}return i}async del(r,t){const i=await this.W(r,t);let s=t;if((0,d.$cl)(i)&&!s?.atomic){const k=i.enforceAtomicDelete?.(r);k&&(s={...t,atomic:k})}const o=!!s?.useTrash,f=!!s?.recursive,S=s?.atomic??!1;await i.delete(r,{recursive:f,useTrash:o,atomic:S}),this.r.fire(new d.$kl(r,1))}async cloneFile(r,t){const i=await this.j(r),s=this.qb(await this.n(t),t);if(!(i===s&&this.R(i).providerExtUri.isEqual(r,t)))return i===s&&(0,d.$0k)(i)?i.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),i===s&&(0,d.$9k)(i)?this.cb.queueFor(r,()=>i.copy(r,t,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(r,()=>this.O(i,r,s,t),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:p.ab++})}watch(r,t={recursive:!1,excludes:[]}){const i=new a.$Tc;let s=!1,o=()=>{s=!0};i.add((0,a.$Sc)(()=>o())),(async()=>{try{const S=await this.bb(r,t);s?(0,a.$Pc)(S):o=()=>(0,a.$Pc)(S)}catch(S){this.b.error(S)}})();const f=t.correlationId;if(typeof f=="number"){const S=i.add(new A.$fe);return i.add(this.X.event(j=>{j.correlates(f)&&S.fire(j)})),{onDidChange:S.event,dispose:()=>i.dispose()}}return i}async bb(r,t){const i=await this.j(r),s=(0,P.$mj)([this.R(i).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:i.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Pc)(r.disposable);this.$.clear()}async db(r,t,i,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,$.$te)(s)||(0,$.$ue)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(f){throw(0,d.$gl)(f)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,i){let s=0,o;if((0,$.$ue)(i)){if(i.buffer.length>0){const f=I.$He.concat(i.buffer);await this.gb(r,t,f,f.byteLength,s,0),s+=f.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((f,S)=>{(0,$.$ze)(o,{onData:async k=>{o.pause();try{await this.gb(r,t,k,k.byteLength,s,0)}catch(j){return S(j)}s+=k.byteLength,setTimeout(()=>o.resume())},onError:k=>S(k),onEnd:()=>f()})})}async fb(r,t,i){let s=0,o;for(;(o=i.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,i,s,o,f){let S=0;for(;S<s;){const k=await r.write(t,o+S,i.buffer,f+S,s-S);S+=k}}async hb(r,t,i,s){return this.cb.queueFor(t,()=>this.ib(r,t,i,s),this.R(r).providerExtUri)}async ib(r,t,i,s){let o;s instanceof I.$He?o=s:(0,$.$te)(s)?o=await(0,I.$Te)(s):(0,$.$ue)(s)?o=await(0,I.$Ue)(s):o=(0,I.$Re)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,t,i,s){return this.cb.queueFor(s,()=>this.kb(r,t,i,s),this.R(i).providerExtUri)}async kb(r,t,i,s){let o,f;try{o=await r.open(t,{create:!1}),f=await i.open(s,{create:!0,unlock:!1});const S=I.$He.alloc(this.a);let k=0,j=0,L=0;do L=await r.read(o,k,S.buffer,j,S.byteLength-j),await this.gb(i,f,S,L,k,j),k+=L,j+=L,j===S.byteLength&&(j=0);while(L>0)}catch(S){throw(0,d.$gl)(S)}finally{await D.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof f=="number"?i.close(f):Promise.resolve()])}}async lb(r,t,i,s){return this.cb.queueFor(s,()=>this.mb(r,t,i,s),this.R(i).providerExtUri)}async mb(r,t,i,s){return i.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,i,s){return this.cb.queueFor(s,()=>this.ob(r,t,i,s),this.R(i).providerExtUri)}async ob(r,t,i,s){const o=await i.open(s,{create:!0,unlock:!1});try{const f=await r.readFile(t);await this.gb(i,o,I.$He.wrap(f),f.byteLength,0,0)}catch(f){throw(0,d.$gl)(f)}finally{await i.close(o)}}async pb(r,t,i,s){const o=await(0,I.$Te)(this.H(r,t,N.CancellationToken.None));await this.hb(i,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new d.$nl((0,R.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&d.FilePermission.Readonly)throw new d.$nl((0,R.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===b.Schemas.file?r.fsPath:r.toString(!0)}};e.$Mq=g,e.$Mq=g=p=$e([oe(0,c.$5j)],g)}),define(se[132],re([0,1,60,174,8,30,14,5,63,2,16,12,17,46,25,106,13,62,129,34,127,126]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$,R,d,l,c,v,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0,(()=>{try{(0,D.gracefulify)(O)}catch(r){console.error(`Error enabling graceful-fs: ${(0,v.$jj)(r)}`)}})();class n extends c.$Yq{static{this.L=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=P.Event.None,this.P=new N.$Ac(s=>y.$3g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,b.$k&&(this.M|=1024)),this.M}async stat(t){try{const{stat:i,symbolicLink:s}=await $.SymlinkSupport.stat(this.I(t));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await $.Promises.readdir(this.I(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let f;o.isSymbolicLink()?f=(await this.stat((0,y.$_g)(t,o.name))).type:f=this.O(o),s.push([o.name,f])}catch(f){this.a.trace(f)}})),s}catch(i){throw this.hb(i)}}O(t,i){let s;return i?.dangling?s=d.FileType.Unknown:t.isFile()?s=d.FileType.File:t.isDirectory()?s=d.FileType.Directory:s=d.FileType.Unknown,i&&(s|=d.FileType.SymbolicLink),s}async Q(t){const i=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new I.$xh;return this.P.set(t,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(t)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),s=await this.Q(t));const o=this.I(t);return await $.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{s?.dispose()}}R(t){n.L&&this.a.trace(t)}readFileStream(t,i,s){const o=(0,w.$ve)(f=>A.$He.concat(f.map(S=>A.$He.wrap(S))).buffer);return(0,l.$Lq)(this,t,o,f=>f.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(t,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(t)?this.U(t,(0,y.$_g)((0,y.$$g)(t),`${(0,y.$9g)(t)}${s.atomic.postfix}`),i,s):this.W(t,i,s)}async S(t){try{const i=this.I(t),{symbolicLink:s}=await $.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(t,i,s,o){const f=new a.$Tc;try{f.add(await this.Q(t)),f.add(await this.Q(i)),await this.W(i,s,o,!0);try{await this.rename(i,t,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{f.dispose()}}async W(t,i,s,o){let f;try{const S=this.I(t);if(!s.create||!s.overwrite){if(await $.Promises.exists(S)){if(!s.overwrite)throw(0,d.$fl)((0,R.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,d.$fl)((0,R.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(f,0,i,0,i.byteLength)}catch(S){throw await this.ib(t,S)}finally{typeof f=="number"&&await this.close(f)}}static{this.$=!0}static configureFlushOnWrite(t){n.$=t}async open(t,i,s){const o=this.I(t);let f;(0,d.$6k)(i)&&!s&&(f=await this.Q(t));let S;try{if((0,d.$6k)(i)&&i.unlock)try{const{stat:j}=await $.SymlinkSupport.stat(o);j.mode&128||await $.Promises.chmod(o,j.mode|128)}catch(j){j.code!=="ENOENT"&&this.a.trace(j)}let k;if((0,d.$6k)(i)){if(b.$i)try{await $.Promises.truncate(o,0),k="r+"}catch(j){j.code!=="ENOENT"&&this.a.trace(j)}k||(k="w")}else k="r";S=await $.Promises.open(o,k)}catch(k){throw f?.dispose(),(0,d.$6k)(i)?await this.ib(t,k):this.hb(k)}if(this.X.set(S,0),(0,d.$6k)(i)&&this.Z.set(S,t),f){const k=this.Y.get(S);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${o})`),this.Y.set(S,f),k&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${o})`),k.dispose())}return S}async close(t){const i=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&n.$)try{await $.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await $.Promises.close(t)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(t)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,o,f){const S=this.ab(t,i);let k=null;try{k=(await $.Promises.read(t,s,o,f,S)).bytesRead}catch(j){throw this.hb(j)}finally{this.bb(t,S,k)}return k}ab(t,i){return i===this.X.get(t)?null:i}bb(t,i,s){const o=this.X.get(t);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(t,o+s):this.X.delete(t)))}async write(t,i,s,o,f){return(0,I.$Sh)(()=>this.cb(t,i,s,o,f),100,3)}async cb(t,i,s,o,f){const S=this.ab(t,i);let k=null;try{k=(await $.Promises.write(t,s,o,f,S)).bytesWritten}catch(j){throw await this.ib(this.Z.get(t),j)}finally{this.bb(t,S,k)}return k}async mkdir(t){try{await $.Promises.mkdir(this.I(t))}catch(i){throw this.hb(i)}}async delete(t,i){try{const s=this.I(t);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,h.$jc)((0,h.$mc)(s),`${(0,h.$nc)(s)}${i.atomic.postfix}`)),await $.Promises.rm(s,$.RimRafMode.MOVE,o)}else try{await $.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let f=!1;try{const{stat:S,symbolicLink:k}=await $.SymlinkSupport.stat(s);f=S.isDirectory()&&!k}catch{}if(f)await $.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.hb(s)}}async rename(t,i,s){const o=this.I(t),f=this.I(i);if(o!==f)try{await this.db(t,i,"move",s.overwrite),await $.Promises.rename(o,f)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(2,null,(0,h.$nc)(o),(0,h.$nc)((0,h.$mc)(f)),S.toString()))),this.hb(S)}}async copy(t,i,s){const o=this.I(t),f=this.I(i);if(o!==f)try{await this.db(t,i,"copy",s.overwrite),await $.Promises.copy(o,f,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(3,null,(0,h.$nc)(o),(0,h.$nc)((0,h.$mc)(f)),S.toString()))),this.hb(S)}}async db(t,i,s,o){const f=this.I(t),S=this.I(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,u.$wg)(f,S,!0)),k){if(s==="copy")throw(0,d.$fl)((0,R.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const L=await this.N(t);if(!L)throw(0,d.$fl)((0,R.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const q=await this.N(i);if(q){if(!o)throw(0,d.$fl)((0,R.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);L.type&d.FileType.File&&q.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.eb(t,i,!1)}async eb(t,i,s){const o=this.I(t),f=this.I(i),S=!!(this.capabilities&1024);if((0,u.$wg)(o,f,!S))return;const k=new a.$Tc;try{k.add(await this.Q(t)),k.add(await this.Q(i)),s&&await $.Promises.mkdir((0,h.$mc)(f),{recursive:!0}),await $.Promises.copyFile(o,f)}catch(j){if(j.code==="ENOENT"&&!s)return this.eb(t,i,!0);throw this.hb(j)}finally{k.dispose()}}t(t,i,s){return new p.$6q(o=>t(o),o=>i(o),s)}F(t,i,s){return new g.$cr(o=>t(o),o=>i(o),s)}hb(t){if(t instanceof d.$el)return t;let i=t,s;switch(t.code){case"ENOENT":s=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=d.FileSystemProviderErrorCode.Unknown;break;default:s=d.FileSystemProviderErrorCode.Unknown}return(0,d.$fl)(i,s)}async ib(t,i){let s=this.hb(i);if(t&&s.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await $.SymlinkSupport.stat(this.I(t));o.mode&128||(s=(0,d.$fl)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$dr=n}),define(se[133],re([0,1,2,6]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;class I extends O.$Uc{constructor(A,P=[]){super(),this.a=new D.$ck([A,...P]),this.B(A.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...P){this.a.trace(A,...P)}debug(A,...P){this.a.debug(A,...P)}info(A,...P){this.a.info(A,...P)}warn(A,...P){this.a.warn(A,...P)}error(A,...P){this.a.error(A,...P)}flush(){this.a.flush()}}e.$bQ=I}),define(se[134],re([0,1,13,6]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;var I;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(I||(I={}));async function N(a,h,b,y,w){try{const $=await new Promise((d,l)=>{X(["@vscode/spdlog"],d,l)});$.setFlushOn(I.Trace);const R=await $.createAsyncRotatingLogger(a,h,b,y);return w?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch($){console.error($)}return null}function A(a,h,b){switch(h){case D.LogLevel.Trace:a.trace(b);break;case D.LogLevel.Debug:a.debug(b);break;case D.LogLevel.Info:a.info(b);break;case D.LogLevel.Warning:a.warn(b);break;case D.LogLevel.Error:a.error(b);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${h}`)}}function P(a,h){switch(h){case D.LogLevel.Trace:a.setLevel(I.Trace);break;case D.LogLevel.Debug:a.setLevel(I.Debug);break;case D.LogLevel.Info:a.setLevel(I.Info);break;case D.LogLevel.Warning:a.setLevel(I.Warning);break;case D.LogLevel.Error:a.setLevel(I.Error);break;case D.LogLevel.Off:a.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${h}`)}}class u extends D.$$j{constructor(h,b,y,w,$){super(),this.m=[],this.setLevel($),this.n=this.s(h,b,y,w),this.B(this.onDidChangeLogLevel(R=>{this.r&&P(this.r,R)}))}async s(h,b,y,w){const $=y?6:1,R=30/$*O.$Al.MB,d=await N(h,b,R,$,w);if(d){this.r=d,P(this.r,this.getLevel());for(const{level:l,message:c}of this.m)A(this.r,l,c);this.m=[]}}g(h,b){this.r?A(this.r,h,b):this.getLevel()<=h&&this.m.push({level:h,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$3P=u}),define(se[135],re([0,1,28,6,134]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;class N extends D.$dk{s(P,u,a){return new I.$3P((0,O.$Ug)(),P.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$4P=N}),define(se[39],re([0,1,5,66,2,10]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=void 0,e.$ho=(0,N.$yi)("policy");class A extends I.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$fe),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const h=Object.keys(this.f).length;return this.f={...a,...this.f},h!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(b,[y,w])=>({...b,[y]:w}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[h,b])=>({...a,[h]:{definition:b,value:this.g.get(h)}}),{})}}e.$io=A;class P{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$jo=P}),define(se[136],re([0,1,8,5,66,3,13,6,39]),function(X,e,O,D,I,N,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;function a(b,y){const w=[];for(const $ of new Set(I.Iterable.concat(b.keys(),y.keys())))b.get($)!==y.get($)&&w.push($);return w}let h=class extends u.$io{constructor(y,w,$){super(),this.m=y,this.n=w,this.s=$,this.c=this.B(new O.$wh(500));const R=D.Event.filter(w.onDidFilesChange,d=>d.affects(y));this.B(w.watch(y)),this.B(R(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const w=await this.n.readFile(this.m),$=JSON.parse(w.value.toString());if(!(0,N.$ag)($))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys($))this.f[R]&&y.set(R,$[R])}catch(w){w.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",w)}return y}async w(){const y=await this.u(),w=a(this.g,y);this.g=y,w.length>0&&this.h.fire(w)}};e.$vec=h,e.$vec=h=$e([oe(1,A.$5k),oe(2,P.$5j)],h)}),define(se[137],re([0,1,39,8,2,6]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;let A=class extends O.$io{constructor(u,a){super(),this.m=u,this.n=a,this.a=new D.$sh,this.b=this.B(new I.$Vc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((h,b)=>{X(["@vscode/policy-watcher"],h,b)});await this.a.queue(()=>new Promise((h,b)=>{try{this.b.value=a(this.n,u,y=>{this.t(y),h()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),b(y)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const h=u[a];h===void 0?this.g.delete(a):this.g.set(a,h)}this.h.fire(Object.keys(u))}};e.$uec=A,e.$uec=A=$e([oe(0,N.$5j)],A)}),define(se[32],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,O.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"}),define(se[36],re([0,1,74,3]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class I{constructor(){this.a=new Map}add(A,P){O.ok(D.$$f(A)),O.ok(D.$ag(P)),O.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,P)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$fo=new I}),define(se[138],re([0,1,5,36]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function I(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class N{constructor(){this.b=new O.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[I(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;D.$fo.add(e.$go.JSONContribution,A)}),define(se[40],re([0,1,19,5,3,93,29,138,36]),function(X,e,O,D,I,N,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=R,e.$wo=d,e.$xo=l,e.$yo=v,e.$zo=p;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$ko={Configuration:"base.contributions.configuration"};var h;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(h||(e.ConfigurationScope=h={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const b=u.$fo.as(P.$go.JSONContribution);class y{constructor(){this.h=new Set,this.i=new D.$fe,this.onDidSchemaChange=this.i.event,this.j=new D.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.n(n,r,t),b.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.o(n,r),b.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.o(r,t),this.n(n,!1,t),b.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const t=[];for(const{overrides:i,source:s}of n)for(const o in i)if(r.add(o),e.$uo.test(o)){const f=this.a.get(o),S=f?.valuesSources??new Map;if(s)for(const q of Object.keys(i[o]))S.set(q,s);const k={...f?.value||{},...i[o]};this.a.set(o,{source:s,value:k,valuesSources:S});const j=(0,A.$cj)(o),L={type:"object",default:k,description:N.localize(1,null,j),$ref:e.$ro,defaultDefaultValue:k,source:I.$$f(s)?void 0:s,defaultValueSource:s};t.push(...R(o)),this.d[o]=L,this.b.properties[o]=L}else{this.a.set(o,{value:i[o],source:s});const f=this.d[o];f&&(this.w(o,f),this.r(o,f))}this.m(t)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:t,source:i}of n)for(const s in t){const o=this.a.get(s),f=I.$$f(i)?i:i?.id,S=I.$$f(o?.source)?o?.source:o?.source?.id;if(f===S)if(r.add(s),this.a.delete(s),e.$uo.test(s))delete this.d[s],delete this.b.properties[s];else{const k=this.d[s];k&&(this.w(s,k),this.r(s,k))}}this.u()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,t){n.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(n,r){const t=i=>{if(i.properties)for(const s in i.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,t,i,s=3,o){s=I.$hg(n.scope)?s:n.scope;const f=n.properties;if(f)for(const k in f){const j=f[k];if(r&&v(k,j)){delete f[k];continue}if(j.source=t,j.defaultDefaultValue=f[k].default,this.w(k,j),e.$uo.test(k)?j.scope=void 0:(j.scope=I.$hg(j.scope)?s:j.scope,j.restricted=I.$hg(j.restricted)?!!i?.includes(k):j.restricted),f[k].hasOwnProperty("included")&&!f[k].included){this.f[k]=f[k],delete f[k];continue}else this.d[k]=f[k],f[k].policy?.name&&this.e.set(f[k].policy.name,k);!f[k].deprecationMessage&&f[k].markdownDeprecationMessage&&(f[k].deprecationMessage=f[k].markdownDeprecationMessage),o.add(k)}const S=n.allOf;if(S)for(const k of S)this.p(k,r,t,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=t=>{const i=t.properties;if(i)for(const o in i)this.r(o,i[o]);t.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$lo.properties[n]=r,r.scope){case 1:e.$mo.properties[n]=r;break;case 2:e.$no.properties[n]=r;break;case 6:e.$oo.properties[n]=r;break;case 3:e.$po.properties[n]=r;break;case 4:e.$qo.properties[n]=r;break;case 5:e.$qo.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$lo.properties[n],r.scope){case 1:delete e.$mo.properties[n];break;case 2:delete e.$no.properties[n];break;case 6:delete e.$oo.properties[n];break;case 3:delete e.$po.properties[n];break;case 4:case 5:delete e.$qo.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$ro};this.w(r,t),e.$lo.properties[r]=t,e.$mo.properties[r]=t,e.$no.properties[r]=t,e.$oo.properties[r]=t,e.$po.properties[r]=t,e.$qo.properties[r]=t}}v(){const n={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=n,e.$mo.patternProperties[e.$to]=n,e.$no.patternProperties[e.$to]=n,e.$oo.patternProperties[e.$to]=n,e.$po.patternProperties[e.$to]=n,e.$qo.patternProperties[e.$to]=n,this.i.fire()}w(n,r){const t=this.a.get(n);let i=t?.value,s=t?.source;I.$fg(i)&&(i=r.defaultDefaultValue,s=void 0),I.$fg(i)&&(i=l(r.type)),r.default=i,r.defaultValueSource=s}}const w="\\[([^\\]]+)\\]",$=new RegExp(w,"g");e.$to=`^(${w})+$`,e.$uo=new RegExp(e.$to);function R(g){const n=[];if(e.$uo.test(g)){let r=$.exec(g);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=$.exec(g)}}return(0,O.$Mb)(n)}function d(g){return g.reduce((n,r)=>`${n}[${r}]`,"")}function l(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const c=new y;u.$fo.add(e.$ko.Configuration,c);function v(g,n){return g.trim()?e.$uo.test(g)?N.localize(7,null,g):c.getConfigurationProperties()[g]!==void 0?N.localize(8,null,g):n.policy?.name&&c.getPolicyConfigurations().get(n.policy?.name)!==void 0?N.localize(9,null,g,n.policy?.name,c.getPolicyConfigurations().get(n.policy?.name)):null:N.localize(6,null)}function p(){const g=[],n=c.getConfigurationProperties();for(const r of Object.keys(n))g.push([r,n[r].scope]);return g.push(["launch",4]),g.push(["task",4]),g}}),define(se[67],re([0,1,19,5,38,2,30,27,3,11,29,40,36]),function(X,e,O,D,I,N,A,P,u,a,h,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=v;function w(r){return Object.isFrozen(r)?r:P.$6n(r)}class ${static createEmptyModel(t){return new $({},[],[],void 0,t)}constructor(t,i,s,o,f){this.b=t,this.c=i,this.d=s,this.raw=o,this.f=f,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof $)return i;const s=new R("",this.f);return s.parseRaw(i),s.configurationModel});this.g=t.reduce((i,s)=>s===i?s:i.merge(s),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,h.$aj)(this.contents,t):this.contents}inspect(t,i){const s=this;return{get value(){return w(s.rawConfiguration.getValue(t))},get override(){return i?w(s.rawConfiguration.getOverrideValue(t,i)):void 0},get merged(){return w(i?s.rawConfiguration.override(i).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:f,identifiers:S,keys:k}of s.rawConfiguration.overrides){const j=new $(f,k,[],void 0,s.f).getValue(t);j!==void 0&&o.push({identifiers:S,value:j})}return o.length?w(o):void 0}}}getOverrideValue(t,i){const s=this.j(i);return s?t?(0,h.$aj)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const s of this.overrides)s.identifiers.includes(t)&&i.push(...s.keys);return O.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return O.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.h(t),this.a.set(t,i)),i}merge(...t){const i=P.$5n(this.contents),s=P.$5n(this.overrides),o=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const S of t)if(f.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i(i,S.contents);for(const k of S.overrides){const[j]=s.filter(L=>O.$ub(L.identifiers,k.identifiers));j?(this.i(j.contents,k.contents),j.keys.push(...k.keys),j.keys=O.$Mb(j.keys)):s.push(P.$5n(k))}for(const k of S.keys)o.indexOf(k)===-1&&o.push(k)}return new $(i,o,s,f.every(S=>S instanceof $)?void 0:f,this.f)}h(t){const i=this.j(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of O.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let f=this.contents[o];const S=i[o];S&&(typeof f=="object"&&typeof S=="object"?(f=P.$5n(f),this.i(f,S)):f=S),s[o]=f}return new $(s,this.keys,this.overrides,void 0,this.f)}i(t,i){for(const s of Object.keys(i)){if(s in t&&u.$ag(t[s])&&u.$ag(i[s])){this.i(t[s],i[s]);continue}t[s]=P.$5n(i[s])}}j(t){let i=null,s=null;const o=f=>{f&&(s?this.i(s,f):s=P.$5n(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===t?i=f.contents:f.identifiers.includes(t)&&o(f.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.k(t,i,!0)}setValue(t,i){this.k(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,h.$_i)(this.contents,t),b.$uo.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>O.$ub(s.identifiers,(0,b.$vo)(t))),1))}k(t,i,s){(0,h.$$i)(this.contents,t,i,o=>this.f.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),b.$uo.test(t)&&this.overrides.push({identifiers:(0,b.$vo)(t),keys:Object.keys(this.contents[t]),contents:(0,h.$0i)(this.contents[t],o=>this.f.error(o))})}}e.$Ao=$;class R{constructor(t,i){this.f=t,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||$.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!u.$hg(t)){const s=this.h(t);this.parseRaw(s,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:s,keys:o,overrides:f,restricted:S,hasExcludedProperties:k}=this.i(t,i);this.b=new $(s,o,f,k?[t]:void 0,this.g),this.c=S||[]}h(t){let i={},s=null,o=[];const f=[],S=[];function k(L){Array.isArray(o)?o.push(L):s!==null&&(o[s]=L)}const j={onObjectBegin:()=>{const L={};k(L),f.push(o),o=L,s=null},onObjectProperty:L=>{s=L},onObjectEnd:()=>{o=f.pop()},onArrayBegin:()=>{const L=[];k(L),f.push(o),o=L,s=null},onArrayEnd:()=>{o=f.pop()},onLiteralValue:k,onError:(L,q,C)=>{S.push({error:L,offset:q,length:C})}};if(t)try{I.$Sn(t,j),i=o[0]||{}}catch(L){this.g.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return i}i(t,i){const s=y.$fo.as(b.$ko.Configuration).getConfigurationProperties(),o=this.j(t,s,!0,i);t=o.raw;const f=(0,h.$0i)(t,j=>this.g.error(`Conflict in settings file ${this.f}: ${j}`)),S=Object.keys(t),k=this.l(t,j=>this.g.error(`Conflict in settings file ${this.f}: ${j}`));return{contents:f,keys:S,overrides:k,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(t,i,s,o){let f=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:f};const S={},k=[];for(const j in t)if(b.$uo.test(j)&&s){const L=this.j(t[j],i,!1,o);S[j]=L.raw,f=f||L.hasExcludedProperties,k.push(...L.restricted)}else{const L=i[j],q=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&k.push(j),!o.exclude?.includes(j)&&(o.include?.includes(j)||(q===void 0||o.scopes===void 0||o.scopes.includes(q))&&!(o.skipRestricted&&L?.restricted))?S[j]=t[j]:f=!0}return{raw:S,restricted:k,hasExcludedProperties:f}}l(t,i){const s=[];for(const o of Object.keys(t))if(b.$uo.test(o)){const f={};for(const S in t[o])f[S]=t[o][S];s.push({identifiers:(0,b.$vo)(o),keys:Object.keys(f),contents:(0,h.$0i)(f,i)})}return s}}e.$Bo=R;class d extends N.$Uc{constructor(t,i,s,o,f){super(),this.c=t,this.f=i,this.g=o,this.h=f,this.b=this.B(new D.$fe),this.onDidChange=this.b.event,this.a=new R(this.c.toString(),f),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&s.isEqual(S.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return $.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=d;class l{constructor(t,i,s,o,f,S,k,j,L,q,C,J,ne){this.a=t,this.b=i,this.c=s,this.overrideIdentifiers=o,this.d=f,this.f=S,this.g=k,this.h=j,this.i=L,this.j=q,this.k=C,this.l=J,this.m=ne}get value(){return w(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class c{constructor(t,i,s,o,f,S,k,j,L,q){this.j=t,this.l=i,this.m=s,this.n=o,this.p=f,this.q=S,this.r=k,this.s=j,this.t=L,this.u=q,this.h=null,this.i=new A.$Ac,this.v=null}getValue(t,i,s){return this.w(t,i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this.t.get(s.resource),o||(o=$.createEmptyModel(this.u),this.t.set(s.resource,o))):o=this.s,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this.h=null)}inspect(t,i,s){const o=this.w(t,i,s),f=this.A(i.resource,s),S=i.resource?this.t.get(i.resource)||this.s:this.s,k=new Set;for(const j of o.overrides)for(const L of j.identifiers)o.getOverrideValue(t,L)!==void 0&&k.add(L);return new l(t,i,o.getValue(t),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,f||void 0,S)}keys(t){const i=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,i){this.r.set(t,i),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=[];if(!i){const{added:o,updated:f,removed:S}=g(this.j,t);i=[...o,...f,...S]}for(const o of i)for(const f of(0,b.$vo)(o)){const S=this.j.getKeysForOverrideIdentifier(f),k=t.getKeysForOverrideIdentifier(f),j=[...k.filter(L=>S.indexOf(L)===-1),...S.filter(L=>k.indexOf(L)===-1),...S.filter(L=>!P.$9n(this.j.override(f).getValue(L),t.override(f).getValue(L)))];s.push([f,j])}return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:s,removed:o}=g(this.l,t),f=[...i,...s,...o];return f.length&&this.updatePolicyConfiguration(t),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:s,removed:o,overrides:f}=g(this.applicationConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateApplicationConfiguration(t),{keys:S,overrides:f}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:f}=g(this.localUserConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateLocalUserConfiguration(t),{keys:S,overrides:f}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:f}=g(this.remoteUserConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateRemoteUserConfiguration(t),{keys:S,overrides:f}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:f}=g(this.workspaceConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateWorkspaceConfiguration(t),{keys:S,overrides:f}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:o,updated:f,removed:S,overrides:k}=g(s,i),j=[...o,...f,...S];return(j.length||!s)&&this.updateFolderConfiguration(t,i),{keys:j,overrides:k}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:f,overrides:S}=g(i,void 0);return{keys:[...s,...o,...f],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,i,s){let o=this.x(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(o=o.merge(this.l)),o}x({resource:t},i){let s=this.y();if(i&&t){const o=i.getFolder(t);o&&(s=this.z(o.uri)||s);const f=this.t.get(t);f&&(s=s.merge(f))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let i=this.i.get(t);if(!i){const s=this.y(),o=this.r.get(t);o?(i=s.merge(o),this.i.set(t,i)):i=s}return i}A(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:f}=this.r.get(i);return t.push([i,{contents:s,overrides:o,keys:f}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.q.keys.forEach(i=>t.add(i)),this.r.forEach(i=>i.keys.forEach(s=>t.add(s))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}D(t){const i=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.q.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t,i){const s=this.E(t.defaults,i),o=this.E(t.policy,i),f=this.E(t.application,i),S=this.E(t.user,i),k=this.E(t.workspace,i),j=t.folders.reduce((L,q)=>(L.set(a.URI.revive(q[0]),this.E(q[1],i)),L),new A.$Ac);return new c(s,o,f,S,$.createEmptyModel(i),k,j,$.createEmptyModel(i),new A.$Ac,i)}static E(t,i){return new $(t.contents,t.keys,t.overrides,void 0,i)}}e.$Do=c;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(f=>t.add(f)),o.overrides.forEach(([f,S])=>{const k=(0,A.$xc)(i,f,new Set);S.forEach(j=>k.add(j))});const s=[];return i.forEach((o,f)=>s.push([f,[...o.values()]])),{keys:[...t.values()],overrides:s}}class p{constructor(t,i,s,o,f){this.change=t,this.f=i,this.g=s,this.h=o,this.i=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of t.keys)this.affectedKeys.add(S);for(const[,S]of t.overrides)for(const k of S)this.affectedKeys.add(k);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=c.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,i){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const f=o+s.length;if(f>=this.d.length)return!1;const S=this.d.charCodeAt(f);if(S!==this.b&&S!==this.c)return!1;if(i){const k=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,j=this.g.getValue(t,i,this.h);return!P.$9n(k,j)}return!0}}e.$Fo=p;function g(r,t){const{added:i,removed:s,updated:o}=n(t?.rawConfiguration,r?.rawConfiguration),f=[],S=r?.getAllOverrideIdentifiers()||[],k=t?.getAllOverrideIdentifiers()||[];if(t){const j=k.filter(L=>!S.includes(L));for(const L of j)f.push([L,t.getKeysForOverrideIdentifier(L)])}if(r){const j=S.filter(L=>!k.includes(L));for(const L of j)f.push([L,r.getKeysForOverrideIdentifier(L)])}if(t&&r){for(const j of S)if(k.includes(j)){const L=n({contents:r.getOverrideValue(void 0,j)||{},keys:r.getKeysForOverrideIdentifier(j)},{contents:t.getOverrideValue(void 0,j)||{},keys:t.getKeysForOverrideIdentifier(j)});f.push([j,[...L.added,...L.removed,...L.updated]])}}return{added:i,removed:s,updated:o,overrides:f}}function n(r,t){const i=r?t?r.keys.filter(f=>t.keys.indexOf(f)===-1):[...r.keys]:[],s=t?r?t.keys.filter(f=>r.keys.indexOf(f)===-1):[...t.keys]:[],o=[];if(r&&t){for(const f of t.keys)if(r.keys.indexOf(f)!==-1){const S=(0,h.$aj)(t.contents,f),k=(0,h.$aj)(r.contents,f);P.$9n(S,k)||o.push(f)}}return{added:i,removed:s,updated:o}}}),define(se[139],re([0,1,19,5,2,27,3,67,40,6,39,36]),function(X,e,O,D,I,N,A,P,u,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=void 0;class y extends I.$Uc{get configurationModel(){return this.b}constructor(d){super(),this.c=d,this.a=this.B(new D.$fe),this.onDidChangeConfiguration=this.a.event,this.b=P.$Ao.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(b.$fo.as(u.$ko.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:l})=>this.f(Array.from(d),l))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(d,l){this.j(d,b.$fo.as(u.$ko.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}g(){return{}}h(){this.b=P.$Ao.createEmptyModel(this.c);const d=b.$fo.as(u.$ko.Configuration).getConfigurationProperties();this.j(Object.keys(d),d)}j(d,l){const c=this.g();for(const v of d){const p=c[v],g=l[v];p!==void 0?this.b.addValue(v,p):g?this.b.addValue(v,g.default):this.b.removeValue(v)}}}e.$Go=y;class w{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=P.$Ao.createEmptyModel(new a.$fk)}async initialize(){return this.configurationModel}}e.$Ho=w;let $=class extends I.$Uc{get configurationModel(){return this.b}constructor(d,l,c){super(),this.c=d,this.f=l,this.g=c,this.a=this.B(new D.$fe),this.onDidChangeConfiguration=this.a.event,this.b=P.$Ao.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const l={},c=[],v=b.$fo.as(u.$ko.Configuration).getConfigurationProperties();for(const p of d){const g=v[p];if(!g){c.push(p);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}c.push(p),l[g.policy.name]={type:g.type}}}return(0,A.$lg)(l)||await this.f.updatePolicyDefinitions(l),c}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const l=b.$fo.as(u.$ko.Configuration).getPolicyConfigurations(),c=(0,O.$Hb)(d.map(v=>l.get(v)));this.m(c,!0)}m(d,l){this.g.trace("PolicyConfiguration#update",d);const c=b.$fo.as(u.$ko.Configuration).getConfigurationProperties(),v=[],p=this.b.isEmpty();for(const g of d){const n=c[g]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(p?r!==void 0:!(0,N.$9n)(this.b.getValue(g),r))&&v.push([g,r])}else this.b.getValue(g)!==void 0&&v.push([g,void 0])}if(v.length){this.g.trace("PolicyConfiguration#changed",v);const g=this.b;this.b=P.$Ao.createEmptyModel(this.g);for(const n of g.keys)this.b.setValue(n,g.getValue(n));for(const[n,r]of v)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);l&&this.a.fire(this.b)}}};e.$Io=$,e.$Io=$=$e([oe(1,h.$ho),oe(2,a.$5j)],$)}),define(se[140],re([0,1,19,8,14,5,38,76,2,30,27,12,17,29,67,40,139,39]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$,R,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=void 0;class c extends u.$Uc{constructor(g,n,r,t){super(),this.m=g,this.n=t,this.h=this.B(new N.$fe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.$Go(t)),this.c=r instanceof l.$jo?new d.$Ho:this.B(new d.$Io(this.b,r,t)),this.f=this.B(new $.$Co(this.m,{},y.$3g,n,t)),this.a=new $.$Do(this.b.configurationModel,this.c.configurationModel,$.$Ao.createEmptyModel(t),$.$Ao.createEmptyModel(t),$.$Ao.createEmptyModel(t),$.$Ao.createEmptyModel(t),new a.$Ac,$.$Ao.createEmptyModel(t),new a.$Ac,t),this.j=new v(g,n,this),this.g=this.B(new D.$Kh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:s})=>this.s(i,s))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new $.$Do(g,n,$.$Ao.createEmptyModel(this.n),r,$.$Ao.createEmptyModel(this.n),$.$Ao.createEmptyModel(this.n),new a.$Ac,$.$Ao.createEmptyModel(this.n),new a.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(g,n){const r=typeof g=="string"?g:void 0,t=(0,w.$6i)(g)?g:(0,w.$6i)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue(g,n,r,t,i){const s=(0,w.$7i)(r)?r:(0,w.$6i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=s?t:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${g} to target ${o}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,O.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const f=this.inspect(g,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(f.policyValue!==void 0)throw new Error(`Unable to write ${g} because it is configured in system policy.`);if((0,h.$9n)(n,f.defaultValue)&&(n=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const k=s.overrideIdentifiers.sort(),j=this.a.localUserConfiguration.overrides.find(L=>(0,O.$ub)([...L.identifiers].sort(),k));j&&(s.overrideIdentifiers=j.identifiers)}const S=s?.overrideIdentifiers?.length?[(0,R.$wo)(s.overrideIdentifiers),g]:[g];await this.j.write(S,n),await this.reloadConfiguration()}inspect(g,n={}){return this.a.inspect(g,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.r(g)}r(g){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(g);this.u(r,n,2)}s(g,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(g,n);this.u(t,r,7)}t(g){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(g);this.u(r,n,7)}u(g,n,r){const t=new $.$Fo(g,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$Jo=c;class v{constructor(g,n,r){this.b=g,this.c=n,this.d=r,this.a=new D.$Fh}write(g,n){return this.a.queue(()=>this.e(g,n))}async e(g,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)r="{}";else throw s}const t=[];if((0,A.$Ln)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(r,g,n);r=(0,P.$4n)(r,i),await this.c.writeFile(this.b,I.$He.fromString(r))}f(g,n,r){const{tabSize:t,insertSpaces:i,eol:s}=this.h;if(!n.length){const o=JSON.stringify(r,null,i?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,P.$1n)(g,n,r,{tabSize:t,insertSpaces:i,eol:s})}get h(){if(!this.g){let g=b.OS===3||b.OS===2?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(g=n),this.g={eol:g,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(se[68],re([0,1,15]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=D,e.$Km=I,e.$Lm=N,e.$Mm=A;function D(u){return u.scheme===O.Schemas.vscodeRemote?u.authority:void 0}function I(u){if(!u)return;const a=u.indexOf("+");return a<0?u:u.substr(0,a)}function N(u){const{host:a,port:h}=P(u);if(typeof h>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:h}}function A(u,a){let{host:h,port:b}=P(u);return typeof b>"u"&&(b=a),{host:h,port:b}}function P(u){const a=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const h=u.match(/^(\[[0-9a-z:]+\])$/);if(h)return{host:h[1],port:void 0};const b=u.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:u,port:void 0}}}),define(se[37],re([0,1,31,10,68]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=N,e.$Wm=b,e.$Xm=y,e.$Ym=w,e.$Zm=$,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function N(R){if(typeof R=="object"&&R!==null&&R.supported!==!0)return R.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(A||(e.ExtensionType=A={}));var P;(function(R){R.WIN32_X64="win32-x64",R.WIN32_ARM64="win32-arm64",R.LINUX_X64="linux-x64",R.LINUX_ARM64="linux-arm64",R.LINUX_ARMHF="linux-armhf",R.ALPINE_X64="alpine-x64",R.ALPINE_ARM64="alpine-arm64",R.DARWIN_X64="darwin-x64",R.DARWIN_ARM64="darwin-arm64",R.WEB="web",R.UNIVERSAL="universal",R.UNKNOWN="unknown",R.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class u{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,l){if(typeof d>"u"||d===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof d=="string"||typeof l=="string"){const c=typeof d=="string"?d:d.value,v=typeof l=="string"?l:l.value;return O.$zf(c,v)}return d._lower===l._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Tm=u;class a{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const l of d)this.add(l)}add(d){this.c.add(u.toKey(d))}delete(d){return this.c.delete(u.toKey(d))}has(d){return this.c.has(u.toKey(d))}}e.$Um=a;class h{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(u.toKey(d))}get(d){return this.c.get(u.toKey(d))}has(d){return this.c.has(u.toKey(d))}set(d,l){this.c.set(u.toKey(d),l)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=h;function b(R){return y(R)}function y(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}function w(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}function $(R,d){if(d){const l=`onResolveRemoteAuthority:${(0,I.$Km)(d)}`;return!!R.activationEvents?.includes(l)}return!1}e.$1m=(0,D.$yi)("IBuiltinExtensionsScannerService")}),define(se[141],re([0,1,2,37,13]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;class N extends O.$Uc{constructor(P,u,a,h,b){super(),this.a=P,this.b=u,this.c=a,this.f=b,this.B(h.onDidInstallExtensions(y=>this.g(y))),this.B(h.onDidUninstallExtension(y=>this.h(y)))}g(P){for(const u of P)u.local&&this.invalidate(u.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,P)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,D.$Nm))}catch(u){(0,I.$jl)(u)!==1&&this.f.error(u)}}}e.$Fq=N}),define(se[45],re([0,1,14,9,2,109,40,10,6,36]),function(X,e,O,D,I,N,A,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0,e.$Tp=y,e.$Up=w,e.$Vp=$,e.$Wp=R,e.$Xp=d,e.$Yp=l,e.$Rp=(0,P.$yi)("requestService");class h{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?g[n]="*****":g[n]=this.b[n];this.a=g}return this.a}}class b extends I.$Uc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,N.localize)(0,null),when:u.$kk.isEqualTo((0,u.$hk)(u.LogLevel.Trace)).serialize()})}async c(g,n,r){const t=`${g} #${++this.b}: ${n.url}`;this.a.trace(`${t} - begin`,n.type,new h(n.headers??{}));try{const i=await r();return this.a.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,n.type,(0,D.$0)(i)),i}}}e.$Sp=b;function y(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}function w(p){return p.res.statusCode===204}async function $(p){return w(p)?null:(await(0,O.$Te)(p.stream)).toString()}async function R(p){if(!y(p))throw new Error("Server returned "+p.res.statusCode);return $(p)}async function d(p){if(!y(p))throw new Error("Server returned "+p.res.statusCode);if(w(p))return null;const n=(await(0,O.$Te)(p.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}function l(p){v(p)}let c;function v(p){const g=a.$fo.as(A.$ko.Configuration),n=c;c={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[c],remove:n?[n]:[]})}v(1)}),define(se[142],re([0,1,20,15,13,45]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=void 0;let A=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,h=O.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,a);return}const b={type:"GET",url:u.toString(!0)},y=await this.a.request(b,h);if(y.res.statusCode===200)await this.b.writeFile(a,y.stream);else{const w=await(0,N.$Wp)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${w}`)}}};e.$qQ=A,e.$qQ=A=$e([oe(0,N.$Rp),oe(1,I.$5k)],A)}),define(se[143],re([0,1,144,3]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=N;function I(A,P){return A.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:A.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function N(A,P,u={}){const a=(0,O.parse)(A),h=u.proxyUrl||I(a,P);if(!h)return null;const b=(0,O.parse)(h);if(!/^https?:$/.test(b.protocol||""))return null;const y={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,D.$eg)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((w,$)=>{X(["http-proxy-agent"],w,$)})).HttpProxyAgent(h,y):new(await new Promise((w,$)=>{X(["https-proxy-agent"],w,$)})).HttpsProxyAgent(h,y)}}),define(se[145],re([0,1,59,16,110,20,34,9,12,28,89,175,8,77]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=R;let $;async function R(l,c,v,p){return v["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Cm)(p)&&!v["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Cm)(p)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),$||($=y.Promises.withAsyncBody(async(g,n)=>{const r=new N.$qe;let t=1e4;const i=l.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,w.$Dm)(i,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),n(new Error((0,I.localize)(0,null)))},t);try{g(await d(c,r.token))}catch(o){!(0,P.$4)(o)&&!r.token.isCancellationRequested?n(new Error((0,I.localize)(1,null,(0,A.$jj)(o)))):g({})}finally{clearTimeout(s),r.dispose()}})),$)}async function d(l,c){const v=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",v);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",p);const g=(0,a.$Ug)().replace(/-/g,"").substr(0,12),n=new RegExp(g+"({.*})"+g),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",r);const t=await(0,h.$sm)(u.OS,r);return l.trace("getUnixShellEnvironment#shell",t),new Promise((i,s)=>{if(c.isCancellationRequested)return s(new P.$5);const o=(0,D.$nc)(t);let f,S;const k="";/^pwsh(-preview)?$/.test(o)?(f=`& '${process.execPath}' ${k} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,S=["-Login","-Command"]):o==="nu"?(f=`^'${process.execPath}' ${k} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,S=["-i","-l","-c"]):o==="xonsh"?(f=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,S=["-i","-l","-c"]):(f=`'${process.execPath}' ${k} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?S=["-ic"]:S=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),f);const j=(0,O.spawn)(t,[...S,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});c.onCancellationRequested(()=>(j.kill(),s(new P.$5))),j.on("error",C=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,A.$jj)(C)),s(C)});const L=[];j.stdout.on("data",C=>L.push(C));const q=[];j.stderr.on("data",C=>q.push(C)),j.on("close",(C,J)=>{const ne=Buffer.concat(L).toString("utf8");l.trace("getUnixShellEnvironment#raw",ne);const ie=Buffer.concat(q).toString("utf8");if(ie.trim()&&l.trace("getUnixShellEnvironment#stderr",ie),C||J)return s(new Error((0,I.localize)(2,null,C,J)));const ue=n.exec(ne),le=ue?ue[1]:"{}";try{const ce=JSON.parse(le);v?ce.ELECTRON_RUN_AS_NODE=v:delete ce.ELECTRON_RUN_AS_NODE,p?ce.ELECTRON_NO_ATTACH_CONSOLE=p:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ce),i(ce)}catch(ce){l.error("getUnixShellEnvironment#errorCaught",(0,A.$jj)(ce)),s(ce)}})})}}),define(se[146],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=e.$5P=void 0,e.$5P=(0,O.$yi)("stateReadService"),e.$6P=(0,O.$yi)("stateService")}),define(se[69],re([0,1,8,14,2,3,18,13,6]),function(X,e,O,D,I,N,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=e.$8P=e.$7P=e.SaveStrategy=void 0;var a;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class h extends I.$Uc{constructor($,R,d,l){super(),this.h=$,this.j=R,this.m=d,this.n=l,this.a=Object.create(null),this.b="",this.c=this.B(new O.$wh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch($){$.fileOperationResult!==1&&this.m.error($)}}getItem($,R){const d=this.a[$];return(0,N.$hg)(d)?R:d}setItem($,R){this.setItems([{key:$,data:R}])}setItems($){let R=!1;for(const{key:d,data:l}of $)this.a[d]!==l&&((0,N.$hg)(l)?(0,N.$fg)(this.a[d])||(this.a[d]=void 0,R=!0):(this.a[d]=l,R=!0));R&&this.s()}removeItem($){(0,N.$fg)(this.a[$])||(this.a[$]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const $=JSON.stringify(this.a,null,4);if($!==this.b)try{await this.n.writeFile(this.h,D.$He.fromString($),{atomic:{postfix:".vsctmp"}}),this.b=$}catch(R){this.m.error(R)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$7P=h;let b=class extends I.$Uc{constructor($,R,d,l){super(),this.a=this.B(new h(R.stateResource,$,d,l))}async init(){await this.a.init()}getItem($,R){return this.a.getItem($,R)}};e.$8P=b,e.$8P=b=$e([oe(1,A.$Fi),oe(2,u.$5j),oe(3,P.$5k)],b);class y extends b{setItem($,R){this.a.setItem($,R)}setItems($){this.a.setItems($)}removeItem($){this.a.removeItem($)}close(){return this.a.close()}}e.$9P=y}),define(se[70],re([0,1,12,35,28]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=A,e.$ip=P;function N(u){if(O.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function A(u,a,h,b,y,w,$,R,d){const l=Object.create(null);l["common.machineId"]=w,l["common.sqmId"]=$,l.sessionID=(0,I.$Ug)()+Date.now(),l.commitHash=b,l.version=y,l["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,O.$h)(O.$u),l["common.nodePlatform"]=D.$dc,l["common.nodeArch"]=h,l["common.product"]=d||"desktop",R&&(l["common.msftInternal"]=R);let c=0;const v=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),O.$l&&(l["common.snap"]="true");const p=N(a);return p&&(l["common.platformDetail"]=p),l}function P(u){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const h=a.toLowerCase();return u.some(b=>h===b)}}),define(se[22],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,O.$yi)("telemetryService"),e.$5l=(0,O.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var I;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(se[71],re([0,1,9,10,6,22]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.ExtensionSignatureVerificationCode=e.$dq=void 0,e.$dq=(0,D.$yi)("IExtensionSignatureVerificationService");var A;(function(a){a.None="None",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.Success="Success",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(A||(e.ExtensionSignatureVerificationCode=A={}));class P extends Error{constructor(h){super(h),this.code=h}}e.$eq=P;let u=class{constructor(h,b){this.b=h,this.c=b}d(){return this.a||(this.a=new Promise((h,b)=>X(["@vscode/vsce-sign"],async y=>h(y),b))),this.a}async verify(h,b,y,w){let $;try{$=await this.d()}catch(c){return this.b.error("Could not load vsce-sign module",(0,O.$0)(c)),this.b.info(`Extension signature verification is not done: ${h}`),!1}const R=new Date().getTime();let d;try{this.b.trace(`Verifying extension signature for ${h}...`),d=await $.verify(b,y,this.b.getLevel()===I.LogLevel.Trace)}catch(c){d={code:"UnknownError",didExecute:!1,output:(0,O.$0)(c)}}const l=new Date().getTime()-R;if(this.b.info(`Extension signature verification result for ${h}: ${d.code}. Executed: ${d.didExecute}. Duration: ${l}ms.`),this.b.trace(`Extension signature verification output for ${h}:
${d.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:h,code:d.code,duration:l,didExecute:d.didExecute,clientTargetPlatform:w}),d.code==="Success")return!0;throw new P(d.code)}};e.$fq=u,e.$fq=u=$e([oe(0,I.$5j),oe(1,N.$4l)],u)}),define(se[41],re([0,1,27,3,68,70,22]),function(X,e,O,D,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$qp=h,e.$rp=b,e.$sp=y,e.$tp=w,e.$up=R,e.$vp=l,e.$wp=c,e.$xp=g;class P{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$jp=P;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$kp=u,e.$lp=new u;class a{async publicLog(r,t,i){}async publicLogError(r,t,i){}}e.$mp=a,e.$np="telemetry",e.$op="extensionTelemetryLog",e.$pp={log:()=>null,flush:()=>Promise.resolve(null)};function h(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}function b(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function y(n){const r=n.getValue(A.$_l),t=n.getValue(A.$am);if(n.getValue(A.$bm)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(n){const r={},t={},i={};d(n,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const o=i[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function R(n){if(!n)return"none";const r=(0,I.$Km)(n);return $.has(r)?r:"other"}function d(n,r,t=0,i){if(n)for(const s of Object.getOwnPropertyNames(n)){const o=n[s],f=i?i+s:s;Array.isArray(o)?r[f]=(0,O.$0n)(o):o instanceof Date?r[f]=o.toISOString():(0,D.$ag)(o)?t<2?d(o,r,t+1,f+"."):r[f]=(0,O.$0n)(o):r[f]=o}}function l(n,r){const t=n.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,N.$ip)(t)||i}function c(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function v(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let t=n;const i=[];for(const S of r)for(;;){const k=S.exec(n);if(!k)break;i.push([k.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(t="";;){const S=o.exec(n);if(!S)break;const k=i.some(([j,L])=>S.index<L&&j<o.lastIndex);!s.test(S[0])&&!k&&(t+=n.substring(f,S.index)+"<REDACTED: user-file-path>",f=o.lastIndex)}return f<n.length&&(t+=n.substr(f)),t}function p(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(n))return`<REDACTED: ${t.label}>`;return n}function g(n,r){return(0,O.$7n)(n,t=>{if(t instanceof P||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let i=t.replaceAll("%20"," ");i=v(i,r);for(const s of r)i=i.replace(s,"");return i=p(i),i}})}}),define(se[26],re([0,1,31,21,37,12,11,9,35,41]),function(X,e,O,D,I,N,A,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$zp=void 0,e.$yp=h,e.$Ap=$,e.$Bp=R,e.$Cp=d,e.$Dp=l,e.$Ep=c,e.$Fp=v,e.$Gp=p,e.$Ip=g,e.$Jp=r;function h(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,O.$uf)(t.id,i.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,s,o)}static parse(i){const s=b.exec(i);return s&&s[1]&&s[2]?new y({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?h(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$zp=y;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(t){const i=w.exec(t);return i&&i[1]?[d(i[1]),i[2]]:[d(t),void 0]}function R(t,i){return`${t}.${i}`}function d(t){return t.toLowerCase()}function l(t,i){return d(R(t??I.$Pm,i))}function c(t,i){const s=[],o=f=>{for(const S of s)if(S.some(k=>h(i(k),i(f))))return S;return null};for(const f of t){const S=o(f);S?S.push(f):s.push([f])}return s}function v(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function p(t){return{id:new a.$jp(t.identifier.id),name:new a.$jp(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Hp=new I.$Tm("pprice.better-merge");function g(t,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const f=o.shift();if(f&&s.every(S=>!h(S.identifier,{id:f}))){const S=t.filter(k=>h(k.identifier,{id:f}));S.length===1&&(s.push(S[0]),o.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function n(t,i){if(!N.$k)return!1;let s;try{s=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){i.debug("Error while getting the os-release file.",(0,P.$0)(f))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const s=await n(t,i),o=(0,D.$6o)(s?"alpine":N.$u,u.$ec);return i.debug("ComputeTargetPlatform:",o),o}}),define(se[147],re([0,1,20,9,15,17,44,11,98,21,26,37]),function(X,e,O,D,I,N,A,P,u,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;const y=R=>(0,u.localize)(0,null,R),w=(0,u.localize)(1,null,"ms-dotnettools.csharp");let $=class{constructor(d,l,c){this.a=d,this.b=l,this.d=c}get f(){}async listExtensions(d,l,c){let v=await this.b.getInstalled(1,c);const p=b.$Sm.map(n=>n.toLowerCase());if(l&&l!==""){if(p.indexOf(l.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}v=v.filter(n=>n.manifest.categories?n.manifest.categories.map(t=>t.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){this.a.info("Possible Categories: "),p.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),v=v.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let g;for(const n of v)g!==n.identifier.id&&(g=n.identifier.id,this.a.info(d?`${g}@${n.manifest.version}`:g))}async installExtensions(d,l,c,v){const p=[];try{d.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const g=[],n=[],r=(i,s,o)=>{n.push({id:i,version:s!=="prerelease"?s:void 0,installOptions:{...c,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||c.installPreReleaseVersion}})};for(const i of d)if(i instanceof P.URI)g.push({vsix:i,installOptions:c});else{const[s,o]=(0,h.$Ap)(i);r(s,o,!1)}for(const i of l)if(i instanceof P.URI)g.push({vsix:i,installOptions:{...c,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,h.$Ap)(i);r(s,o,!0)}const t=await this.b.getInstalled(void 0,c.profileLocation);if(g.length&&await Promise.all(g.map(async({vsix:i,installOptions:s})=>{try{await this.h(i,s,v,t)}catch(o){this.a.error(o),p.push(i.toString())}})),n.length){const i=await this.g(n,t,v);p.push(...i)}}catch(g){throw this.a.error((0,u.localize)(5,null,(0,D.$0)(g))),g}if(p.length)throw new Error((0,u.localize)(6,null,p.join(", ")))}async updateExtensions(d){const l=await this.b.getInstalled(1,d),c=[];for(const n of l)n.identifier.uuid&&c.push({...n.identifier,preRelease:n.preRelease});this.a.trace((0,u.localize)(7,null,c.length));const v=await this.d.getExtensions(c,{compatible:!0},O.CancellationToken.None),p=[];for(const n of v)for(const r of l)(0,h.$yp)(r.identifier,n.identifier)&&(0,A.gt)(n.version,r.manifest.version)&&p.push({extension:n,options:{operation:3,installPreReleaseVersion:r.preRelease,profileLocation:d}});if(!p.length){this.a.info((0,u.localize)(8,null));return}this.a.info((0,u.localize)(9,null,p.map(n=>n.extension.identifier.id).join(", ")));const g=await this.b.installGalleryExtensions(p);for(const n of g)n.error?this.a.error((0,u.localize)(10,null,n.identifier.id,(0,D.$0)(n.error))):this.a.info((0,u.localize)(11,null,n.identifier.id,n.local?.manifest.version))}async g(d,l,c){if(d=d.filter(({id:n,version:r})=>{const t=l.find(i=>(0,h.$yp)(i.identifier,{id:n}));if(t){if(!c&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,u.localize)(12,null,n,t.manifest.version,n)),!1;if(r&&t.manifest.version===r)return this.a.info((0,u.localize)(13,null,`${n}@${r}`)),!1}return!0}),!d.length)return[];const v=[],p=[],g=await this.j(d);if(await Promise.all(d.map(async({id:n,version:r,installOptions:t})=>{const i=g.get(n.toLowerCase());if(!i){this.a.error(`${y(r?`${n}@${r}`:n)}
${w}`),v.push(n);return}try{const o=await this.d.getManifest(i,O.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),v.push(n);return}const s=l.find(o=>(0,h.$yp)(o.identifier,i.identifier));if(s){if(i.version===s.manifest.version){this.a.info((0,u.localize)(14,null,r?`${n}@${r}`:n));return}this.a.info((0,u.localize)(15,null,n,i.version))}t.isBuiltin?this.a.info(r?(0,u.localize)(16,null,n,r):(0,u.localize)(17,null,n)):this.a.info(r?(0,u.localize)(18,null,n,r):(0,u.localize)(19,null,n)),p.push({extension:i,options:{...t,installGivenVersion:!!r}})})),p.length){const n=await this.b.installGalleryExtensions(p);for(const r of n)r.error?(this.a.error((0,u.localize)(20,null,r.identifier.id,(0,D.$0)(r.error))),v.push(r.identifier.id)):this.a.info((0,u.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return v}async h(d,l,c,v){const p=await this.b.getManifest(d);if(!p)throw new Error("Invalid vsix");if(await this.l(p,c,l.profileLocation,v))try{await this.b.install(d,l),this.a.info((0,u.localize)(22,null,(0,N.$9g)(d)))}catch(n){if((0,D.$4)(n))this.a.info((0,u.localize)(23,null,(0,N.$9g)(d)));else throw n}}async j(d){const l=new Map,c=d.some(g=>g.installOptions.installPreReleaseVersion),v=await this.b.getTargetPlatform(),p=[];for(const g of d)a.$Xo.test(g.id)&&p.push({...g,preRelease:c});if(p.length){const g=await this.d.getExtensions(p,{targetPlatform:v},O.CancellationToken.None);for(const n of g)l.set(n.identifier.id.toLowerCase(),n)}return l}k(d){return!0}async l(d,l,c,v){if(!l){const p={id:(0,h.$Dp)(d.publisher,d.name)},g=v.find(n=>(0,h.$yp)(p,n.identifier)&&(0,A.gt)(n.manifest.version,d.version));if(g)return this.a.info((0,u.localize)(24,null,g.identifier.id,g.manifest.version,d.version)),!1}return this.k(d)}async uninstallExtensions(d,l,c){const v=async g=>{if(g instanceof P.URI){const n=await this.b.getManifest(g);return(0,h.$Bp)(n.publisher,n.name)}return g},p=[];for(const g of d){const n=await v(g),t=(await this.b.getInstalled(void 0,c)).filter(i=>(0,h.$yp)(i.identifier,{id:n}));if(!t.length)throw new Error(`${this.m(n)}
${w}`);if(t.some(i=>i.type===0)){this.a.info((0,u.localize)(25,null,n));return}if(!l&&t.some(i=>i.isBuiltin)){this.a.info((0,u.localize)(26,null,n));return}this.a.info((0,u.localize)(27,null,n));for(const i of t)await this.b.uninstall(i,{profileLocation:c}),p.push(i);this.f?this.a.info((0,u.localize)(28,null,n,this.f)):this.a.info((0,u.localize)(29,null,n))}}async locateExtension(d){const l=await this.b.getInstalled();d.forEach(c=>{l.forEach(v=>{if(v.identifier.id===c&&v.location.scheme===I.Schemas.file){this.a.info(v.location.fsPath);return}})})}m(d){return this.f?(0,u.localize)(30,null,d,this.f):(0,u.localize)(31,null,d)}};e.$gq=$,e.$gq=$=$e([oe(1,a.$ap),oe(2,a.$0o)],$)}),define(se[148],re([0,1,5,2,30,26,37]),function(X,e,O,D,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0;class P extends D.$Uc{constructor(a,h,b,y,w,$,R){super(),this.f=a,this.g=h,this.h=b,this.j=y,this.m=w,this.n=$,this.r=R,this.a=this.B(new O.$fe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$4c),this.s().then(null,d=>R.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(h=>(this.c.set(h.id,(0,D.$Rc)(this.n.watch(this.m.extUri.dirname(h.extensionsResource)),this.n.watch(h.extensionsResource))),this.G(h.extensionsResource))))}catch(h){throw this.r.error(h),h}}async w(a){for(const h of a.extensions)this.I(this.L(h.identifier,h.version),a.profileLocation)}async y(a){for(const h of a.extensions){const b=this.L(h.identifier,h.version);a.error?this.J(b,a.profileLocation):this.I(b,a.profileLocation)}}async z(a){for(const h of a.extensions)this.J(this.L(h.identifier,h.version),a.profileLocation)}async C(a){const h=[],b=[];for(const y of a.extensions){const w=this.L(y.identifier,y.version);a.error?this.I(w,a.profileLocation):(this.J(w,a.profileLocation),this.b.has(w)||(this.r.debug("Extension is removed from all profiles",y.identifier.id,y.version),b.push(this.f.scanInstalledExtensionAtLocation(y.location).then($=>{$?h.push($):this.r.info("Extension not found at the location",y.location.toString())},$=>this.r.error($)))))}try{await Promise.all(b),h.length&&await this.H(h)}catch(y){this.r.error(y)}}D(a){for(const h of this.h.profiles)a.contains(h.extensionsResource,0,1)&&this.F(h.extensionsResource)}async F(a){const h=[],b=[],y=await this.j.scanProfileExtensions(a),w=new Set,$=new Set;for(const[R,d]of this.b)d.has(a)&&$.add(R);for(const R of y){const d=this.L(R.identifier,R.version);w.add(d),$.has(d)||(h.push(R.identifier),this.I(d,a))}for(const R of $)if(!w.has(R)){const d=this.M(R);d&&(b.push(d.identifier),this.J(R,a))}(h.length||b.length)&&this.a.fire({added:h.length?{extensions:h,profileLocation:a}:void 0,removed:b.length?{extensions:b,profileLocation:a}:void 0})}async G(a){const h=await this.j.scanProfileExtensions(a);for(const b of h)this.I(this.L(b.identifier,b.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(b=>!this.b.has(this.L(b.identifier,b.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,h){let b=this.b.get(a);b||this.b.set(a,b=new I.$Bc(y=>this.m.extUri.getComparisonKey(y))),b.add(h)}J(a,h){const b=this.b.get(a);b&&b.delete(h),b?.size||this.b.delete(a)}L(a,h){return`${A.$Tm.toKey(a.id)}@${h}`}M(a){const[h,b]=(0,N.$Ap)(a);return b?{identifier:{id:h},version:b}:void 0}}e.$Gq=P}),define(se[149],re([0,1,120,41]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=I;async function I(N,A,P,u,a,h,b){const y={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,D.$qp)(A,P)&&(0,D.$sp)(u)===3){const w=await(0,O.$$p)(P,a,h);y["X-Market-User-Id"]=w,y["VSCode-SessionId"]=b.machineId||w}return y}}),define(se[150],re([0,1,176,19,8,2,15,16,25,18,21,26,6,65,11]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0;let R=class extends w.$Wr{constructor(v,p,g,n){super(g),this.h=v,this.j=n,this.g=this.B(new d(p,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(v,p){const n=(await this.g.getLanguagePacks())[p];if(!n){this.j.warn(`No language pack found for ${p}`);return}const r=n.translations[v];return r?$.URI.file(r):void 0}async getInstalledLanguages(){const v=await this.g.getLanguagePacks(),p=Object.keys(v).map(g=>{const n=v[g];return{...this.f(g,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((g,n)=>g.label.localeCompare(n.label)),p}async m(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",v.identifier.id),await this.update())}async n(v){const p=await this.g.getLanguagePacks();Object.keys(p).some(g=>p[g]&&p[g].extensions.some(n=>(0,b.$yp)(n.extensionIdentifier,v.identifier)))&&(this.j.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(p);return!(0,D.$ub)(Object.keys(v),Object.keys(g))}};e.$Xr=R,e.$Xr=R=$e([oe(0,h.$ap),oe(1,a.$Gi),oe(2,h.$0o),oe(3,y.$5j)],R);let d=class extends N.$Uc{constructor(v,p){super(),this.j=p,this.c={},this.f=(0,P.$jc)(v.userDataPath,"languagepacks.json"),this.g=new I.$Fh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(v){return this.s(p=>{Object.keys(p).forEach(g=>delete p[g]),this.m(p,...v)}).then(()=>this.c)}m(v,...p){for(const g of p)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n(v,g);Object.keys(v).forEach(g=>this.r(v[g]))}n(v,p){const g=p.identifier,n=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const r of n)if(p.location.scheme===A.Schemas.file&&l(r)){let t=v[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},v[r.languageId]=t);const i=t.extensions.filter(s=>(0,b.$yp)(s.extensionIdentifier,g))[0];i?i.version=p.manifest.version:t.extensions.push({extensionIdentifier:g,version:p.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,P.$jc)(p.location.fsPath,s.path)}}r(v){if(v){const p=(0,O.createHash)("md5");for(const g of v.extensions)p.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);v.hash=p.digest("hex")}}s(v=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(p=v(g),g)).then(g=>{for(const r of Object.keys(g))g[r]||delete g[r];this.c=g,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),u.Promises.writeFile(this.f,n)}).then(()=>p,g=>this.j.error(g))})}};d=$e([oe(0,a.$Gi),oe(1,y.$5j)],d);function l(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const v of c.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(se[151],re([0,1,86,9,27,41]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function u(h,b,y){const w=await(0,O.$_D)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,O.$_D)("@microsoft/1ds-post-js","dist/ms.post.js"),R=new w.AppInsightsCore,d=new $.PostChannel,l={instrumentationKey:h,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(y){l.extensionConfig={};const c={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:y};l.extensionConfig[d.identifier]=c}return R.initialize(l,[]),R.addTelemetryInitializer(c=>{c.ext=c.ext??{},c.ext.web=c.ext.web??{},c.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',b&&(c.ext.utc=c.ext.utc??{},c.ext.utc.flags=8462029)}),R}class a{constructor(b,y,w,$,R){this.e=b,this.f=y,this.g=w,this.h=R,this.c=A,this.d=P,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(b){if(this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(y=>{b(y)},y=>{(0,D.$1)(y),console.error(y)})}}log(b,y){if(!this.a)return;y=(0,I.$8n)(y,this.g),y=(0,N.$tp)(y);const w=this.f+"/"+b;try{this.i($=>{$.pluginVersionString=y?.properties.version??"Unknown",$.track({name:w,baseData:{name:w,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.$1P=a}),define(se[152],re([0,1,2,27,12,31,111,29,40,153,32,36,22,41]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,c,v){this.k=c,this.l=v,this.d={},this.i=new O.$Tc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,N.$bf)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$bf)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(y.$_l)||p.affectsConfiguration(y.$bm)||p.affectsConfiguration(y.$am))&&this.m()}))}setExperimentProperty(l,c){this.d[l]=c}m(){let l=(0,w.$sp)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const v=c.usage?3:c.error?2:0;l=Math.min(l,v)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,c,v){this.g<c||(v=(0,D.$8n)(v,this.d),v=(0,w.$xp)(v,this.j),v=(0,D.$8n)(v,this.c),this.b.forEach(p=>p.log(l,v)))}publicLog(l,c){this.n(l,3,c)}publicLog2(l,c){this.publicLog(l,c)}publicLogError(l,c){this.h&&this.n(l,2,c)}publicLogError2(l,c){this.publicLogError(l,c)}};e.$4r=$,e.$4r=$=$e([oe(1,P.$5i),oe(2,h.$lk)],$);function R(){const d=(0,A.localize)(0,null,a.default.nameLong),l=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=I.$o?"":(0,A.localize)(3,null),v=(0,A.localize)(4,null),p=(0,A.localize)(5,null),g=(0,A.localize)(6,null),n=(0,A.localize)(7,null),r=`
|       | ${v} | ${p} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${d} ${l} ${c}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}b.$fo.as(u.$ko.Configuration).registerConfiguration({id:y.$$l,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[y.$_l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:R(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$fo.as(u.$ko.Configuration).registerConfiguration({id:y.$$l,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[y.$bm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${y.$_l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[154],re([0,1,14,20,177,151]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=void 0;async function A(h,b){const y=await b.request(h,D.CancellationToken.None),w=(await(0,O.$Te)(y.stream)).toString(),$=y.res.statusCode??200;return{headers:y.res.headers,statusCode:$,responseData:w}}async function P(h){const b={method:h.type,headers:h.headers};return new Promise((w,$)=>{const R=I.request(h.url??"",b,d=>{d.on("data",function(l){w({headers:d.headers,statusCode:d.statusCode??200,responseData:l.toString()})}),d.on("error",function(l){$(l)})});R.write(h.data,d=>{d&&$(d)}),R.end()})}async function u(h,b,y){const w=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),$={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:w};try{const R=h?await A($,h):await P($);y(R.statusCode,R.headers,R.responseData)}catch{y(0,{})}}class a extends N.$1P{constructor(b,y,w,$,R){const d={sendPOST:(l,c)=>{u(b,l,c)}};super(y,w,$,R,d)}}e.$2P=a}),define(se[155],re([0,1,16,25]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=I;async function I(N,A){const P=Object.create(null),u=(h,b)=>{const y=JSON.parse(h);P[b]=y};if(A){const h=[],b=await D.Promises.readdir(A);for(const w of b)try{(await D.Promises.stat((0,O.$jc)(A,w))).isDirectory()&&h.push(w)}catch{}const y=[];for(const w of h)(await D.Promises.readdir((0,O.$jc)(A,w))).filter(R=>R==="telemetry.json").length===1&&y.push(w);for(const w of y){const $=(await D.Promises.readFile((0,O.$jc)(A,w,"telemetry.json"))).toString();u($,w)}}let a=(await D.Promises.readFile((0,O.$jc)(N,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await D.Promises.readFile((0,O.$jc)(N,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(P,null,4)}}),define(se[156],re([0,1,12,87,22]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=N,e.$_dc=A;async function N(P,u){let a=P.getItem(I.$9l);return(typeof a!="string"||O.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$Hn)(u.error.bind(u))),a}async function A(P,u){let a=P.getItem(I.$0l);return typeof a!="string"&&(a=await(0,D.$In)(u.error.bind(u))),a}}),define(se[23],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,O.$yi)("IUriIdentityService")}),define(se[157],re([0,1,23,121,13,17,78,5,2]),function(X,e,O,D,I,N,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;class a{static{this._clock=0}constructor(y){this.uri=y,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let h=class{constructor(y){this.g=y,this.c=new u.$Tc,this.f=2**16;const w=new Map,$=R=>{let d=w.get(R.scheme);return d===void 0&&(d=y.hasProvider(R)&&!this.g.hasCapability(R,1024),w.set(R.scheme,d)),d};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(R=>{w.delete(R.scheme)})),this.extUri=new N.$1g($),this.d=new A.$Ds((R,d)=>this.extUri.compare(R,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,N.$ah)(y));const w=this.d.get(y);return w?w.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new a(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort(($,R)=>$[1].time<R[1].time?1:$[1].time>R[1].time?-1:0);a._clock=0,this.d.clear();const w=this.f*.5;for(let $=0;$<w;$++)this.d.set(y[$][0],y[$][1].touch())}};e.$Es=h,e.$Es=h=$e([oe(0,I.$5k)],h),(0,D.$Bs)(O.$Cl,h,1)}),define(se[158],re([0,1,5,2,13,48,30]),function(X,e,O,D,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;class P extends D.$Uc{constructor(a,h,b,y,w,$){super(),this.f=a,this.g=h,this.h=b,this.j=y,this.m=w,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$fe),this.onDidChangeFile=this.a.event,this.b=N.$Ei.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(R=>this.m.extUri.getComparisonKey(this.t(R))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(R=>this.s(R)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,h){return this.g.open(this.t(a),h)}close(a){return this.g.close(a)}read(a,h,b,y,w){return this.g.read(a,h,b,y,w)}write(a,h,b,y,w){return this.g.write(a,h,b,y,w)}watch(a,h){this.b.set(a,a);const b=this.g.watch(this.t(a),h);return(0,D.$Sc)(()=>{this.b.delete(a),b.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,h,b){return this.g.rename(this.t(a),this.t(h),b)}readFile(a,h){return this.g.readFile(this.t(a),h)}readFileStream(a,h,b){return this.g.readFileStream(this.t(a),h,b)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,h,b){return this.g.writeFile(this.t(a),h,b)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,h){return this.g.delete(this.t(a),h)}copy(a,h,b){if((0,I.$9k)(this.g))return this.g.copy(this.t(a),this.t(h),b);throw new Error("copy not supported")}cloneFile(a,h){if((0,I.$0k)(this.g))return this.g.cloneFile(this.t(a),this.t(h));throw new Error("clone not supported")}s(a){const h=[];for(const b of a){if(b.resource.scheme!==this.f)continue;const y=this.u(b.resource);this.b.findSubstr(y)&&h.push({resource:y,type:b.type,cId:b.cId})}h.length&&(this.n.debug("User data changed"),this.a.fire(h))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$wec=P}),define(se[159],re([0,1,113,16,48,17,11,10,15]),function(X,e,O,D,I,N,A,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=a,e.$Ji=h,e.$Mi=b,e.$Ni=y,e.$Oi=w,e.$Pi=R,e.$Qi=d,e.$Ti=v,e.$Yi=p,e.$Zi=g,e.$2i=n,e.$3i=r,e.$4i=t,e.$Hi=(0,P.$yi)("contextService");function a(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}function h(i){return typeof i?.id=="string"&&!a(i)&&!y(i)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function b(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$nc)(i)}:s?e.$Ki:e.$Li;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function y(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}function w(i){const s=i;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var $;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function R(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function d(i){const s=i;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class l{constructor(s,o,f,S,k){this.h=s,this.j=f,this.k=S,this.l=k,this.c=I.$Ei.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=I.$Ei.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=l;class c{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,N.$_g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=c;function v(i){return new c({uri:i,index:0,name:(0,N.$8g)(i)},{uri:i.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,O.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function p(i,s){return N.$3g.isEqualOrParent(i,s.untitledWorkspacesHome)}function g(i){let s;return A.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===u.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.$1i}function r(i,s){return!p(i,s)&&!g(i)}function t(i){return(typeof i=="string"?(0,D.$oc)(i):(0,N.$0g)(i))===e.$Vi}}),define(se[24],re([0,1,43,5,2,17,11,112,18,13,10,6,159,30,23,8,28,31,3]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$,R,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=p,e.$Fl=g,e.$Gl=n;var v;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(v||(e.ProfileResourceType=v={}));function p(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$El=(0,h.$yi)("IUserDataProfilesService");function g(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:s}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function n(i,s,o,f,S,k){return{id:i,name:s,location:o,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:k&&S?.useDefaultFlags?.globalState?k.globalStorageHome:(0,N.$_g)(o,"globalStorage"),settingsResource:k&&S?.useDefaultFlags?.settings?k.settingsResource:(0,N.$_g)(o,"settings.json"),keybindingsResource:k&&S?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,N.$_g)(o,"keybindings.json"),tasksResource:k&&S?.useDefaultFlags?.tasks?k.tasksResource:(0,N.$_g)(o,"tasks.json"),snippetsHome:k&&S?.useDefaultFlags?.snippets?k.snippetsHome:(0,N.$_g)(o,"snippets"),extensionsResource:k&&S?.useDefaultFlags?.extensions?k.extensionsResource:(0,N.$_g)(o,"extensions.json"),cacheHome:(0,N.$_g)(f,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let r=class extends I.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,f,S){super(),this.t=s,this.u=o,this.w=f,this.y=S,this.f=!0,this.h=this.B(new D.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,c.$$f)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}o.push(n((0,N.$9g)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},s))}}catch(k){this.y.error(k)}const f=new w.$Ac,S=new Map;if(o.length)try{const k=this.Q();if(k.workspaces)for(const[j,L]of Object.entries(k.workspaces)){const q=A.URI.parse(j),C=o.find(J=>J.id===L);C&&f.set(q,C)}if(k.emptyWindows)for(const[j,L]of Object.entries(k.emptyWindows)){const q=o.find(C=>C.id===L);q&&S.set(j,q)}}catch(k){this.y.error(k)}this.z={profiles:o,workspaces:f,emptyWindows:S}}return this.z}D(){const s=n("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",f=new RegExp(`${(0,l.$bf)(o)}\\s(\\d+)`);let S=0;for(const j of this.profiles){const L=f.exec(j.name),q=L?parseInt(L[1]):0;S=q>S?q:S}const k=`${o} ${S+1}`;return this.createProfile((0,O.$mj)((0,d.$Ug)()).toString(16),k,{transient:!0},s)}async createNamedProfile(s,o,f){return this.createProfile((0,O.$mj)((0,d.$Ug)()).toString(16),s,o,f)}async createProfile(s,o,f,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(s,o,f);return S&&await this.setProfileForWorkspace(S,k),k}async F(s,o,f){if(!(0,c.$$f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(o);return S||(S=(async()=>{try{if(this.profiles.find(q=>q.name===o||q.id===s))throw new Error(`Profile with ${o} name already exists`);const j=n(s,o,(0,N.$_g)(this.profilesHome,s),this.g,f,this.defaultProfile);await this.u.createFolder(j.location);const L=[];return this.j.fire({profile:j,join(q){L.push(q)}}),await R.Promises.settled(L),this.I([j],[],[]),j}finally{this.r.delete(o)}})(),this.r.set(o,S)),S}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(S=>S.id===s.id);if(!f)throw new Error(`Profile '${s.name}' does not exist`);return f=n(f.id,o.name??f.name,f.location,this.g,{shortName:o.shortName??f.shortName,icon:o.icon===null?void 0:o.icon??f.icon,transient:o.transient??f.isTransient,useDefaultFlags:o.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.I([],[],[f]),f}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(S=>S.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const f=[];this.m.fire({profile:o,join(S){f.push(S)}});try{await Promise.allSettled(f)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(S){(0,a.$jl)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(S=>S.id===o.id);if(!f)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,f)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(f=>!this.w.extUri.isEqual(f.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,y.$Ii)(s)?s.uri:(0,y.$Ni)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,f){const S=[...this.profiles,...s],k=[];this.s.profiles=[];for(let j of S)j.isDefault||o.some(L=>j.id===L.id)||(j=f.find(L=>j.id===L.id)??j,j.isTransient?this.s.profiles.push(j):k.push({location:j.location,name:j.name,shortName:j.shortName,icon:j.icon,useDefaultFlags:j.useDefaultFlags}));this.P(k),this.z=void 0,this.J(s,o,f)}J(s,o,f){this.h.fire({added:s,removed:o,updated:f,all:this.profiles})}L(s,o,f){f=o?.isTransient?!0:f,f||this.L(s,void 0,!0);const S=this.G(s),k=f?this.s:this.C;A.URI.isUri(S)?(k.workspaces.delete(S),o&&k.workspaces.set(S,o)):(k.emptyWindows.delete(S),o&&k.emptyWindows.set(S,o)),f||this.M()}M(){const s={};for(const[f,S]of this.C.workspaces.entries())s[f.toString()]=S.id;const o={};for(const[f,S]of this.C.emptyWindows.entries())o[f.toString()]=S.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},f=this.D();if(s.workspaces)for(const[k,j]of Object.entries(s.workspaces)){const L=A.URI.parse(j);o[k]=this.w.extUri.isEqual(L,f.location)?f.id:this.w.extUri.basename(L)}const S={};if(s.emptyWindows)for(const[k,j]of Object.entries(s.emptyWindows)){const L=A.URI.parse(j);S[k]=this.w.extUri.isEqual(L,f.location)?f.id:this.w.extUri.basename(L)}return{workspaces:o,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Hl=r,e.$Hl=r=$e([oe(0,u.$Fi),oe(1,a.$5k),oe(2,$.$Cl),oe(3,b.$5j)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Il=t}),define(se[72],re([0,1,19,8,20,9,5,2,12,3,11,96,21,26,37,6,32,22,23,24]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$,R,d,l,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$pq=void 0,e.$qq=g;let p=class extends P.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,s,o,f,S,k){super(),this.z=i,this.C=s,this.D=o,this.F=f,this.G=S,this.H=k,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$fe),this.s=this.B(new A.$fe),this.t=this.B(new A.$fe),this.u=this.B(new A.$fe),this.w=this.B(new A.$fe),this.y=[],this.B((0,P.$Sc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,y.$8o)(o,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{const f=(await this.installGalleryExtensions([{extension:i,options:s}])).find(({identifier:S})=>(0,w.$yp)(S,i.identifier));if(f?.local)return f?.local;throw f?.error?f.error:new y.$_o(`Unknown error while installing extension ${i.identifier.id}`,"Unknown")}catch(o){throw g(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new y.$_o(b.localize(0,null),"NotAllowed");const s=[],o=[];return await Promise.allSettled(i.map(async({extension:f,options:S})=>{try{const k=await this.N(f,!!S?.installGivenVersion,!!S?.installPreReleaseVersion,S.productVersion??{version:this.G.version,date:this.G.date});o.push({...k,options:S})}catch(k){s.push({identifier:f.identifier,operation:2,source:f,error:k})}})),o.length&&s.push(...await this.I(o)),s}async uninstall(i,s={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,s)}async toggleAppliationScope(i,s){if((0,$.$Wm)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)||(o=await this.$(i,this.H.defaultProfile.extensionsResource,s));for(const f of this.H.profiles){const S=(await this.getInstalled(1,f.extensionsResource)).find(k=>(0,w.$yp)(k.identifier,i.identifier));S?this.w.fire(S):this.u.fire({identifier:i.identifier,profileLocation:f.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,s,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const s=new Map,o=new Map,f=[],S=(j,L)=>`${w.$zp.create(j).toString()}-${L.toString()}`,k=(j,L,q,C)=>{const J=this.Y(j,L,q),ne=`${(0,w.$Dp)(j.publisher,j.name)}-${q.profileLocation.toString()}`;o.set(ne,{task:J,root:C}),this.n.fire({identifier:J.identifier,source:L,profileLocation:q.profileLocation}),this.F.info("Installing extension:",J.identifier.id),h.URI.isUri(L)||this.j.set(S(L,q.profileLocation),{task:J,waitingTasks:[]})};try{for(const{manifest:j,extension:L,options:q}of i){const C=q.isApplicationScoped||q.isBuiltin||(0,$.$Wm)(j),J={...q,installOnlyNewlyAddedFromExtensionPack:q.installOnlyNewlyAddedFromExtensionPack??!h.URI.isUri(L),isApplicationScoped:C,profileLocation:C?this.H.defaultProfile.extensionsResource:q.profileLocation??this.X(),productVersion:q.productVersion??{version:this.G.version,date:this.G.date}},ne=h.URI.isUri(L)?void 0:this.j.get(S(L,J.profileLocation));ne?(this.F.info("Extension is already requested to install",ne.task.identifier.id),f.push(ne.task.waitUntilTaskIsFinished())):k(j,L,J,void 0)}return await Promise.all([...o.values()].map(async({task:j})=>{if(j.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",j.identifier.id);else try{const L=await this.M(j.identifier,j.manifest,!!j.options.installOnlyNewlyAddedFromExtensionPack,!!j.options.installPreReleaseVersion,j.options.profileLocation,j.options.productVersion),q=await this.getInstalled(void 0,j.options.profileLocation,j.options.productVersion),C={...j.options,context:{...j.options.context,[y.$2o]:!0}};for(const{gallery:J,manifest:ne}of(0,O.$Mb)(L,({gallery:ie})=>ie.identifier.id)){if(o.has(`${J.identifier.id.toLowerCase()}-${C.profileLocation.toString()}`))continue;const ie=this.j.get(S(J,C.profileLocation));if(ie){if(this.J(j,ie.task)){const ue=ie.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,j.identifier.id),ie.waitingTasks.push(j),f.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,le=>le.some(ce=>(0,w.$yp)(ce.identifier,ue)))).then(le=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,j.identifier.id),!le.find(V=>(0,w.$yp)(V.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else q.some(({identifier:ue})=>(0,w.$yp)(ue,J.identifier))||k(ne,J,C,j)}}catch(L){if(h.URI.isUri(j.source))(0,O.$Lb)(j.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",j.identifier.id,L.message),(0,O.$Lb)(j.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",j.identifier.id,L.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",j.identifier.id),L}})),await this.L([...o.entries()].map(async([j,{task:L}])=>{const q=new Date().getTime();let C;try{C=await L.run(),await this.L(this.y.map(J=>J.postInstall(C,L.source,L.options,I.CancellationToken.None)),"PostInstall")}catch(J){const ne=g(J);throw h.URI.isUri(L.source)||n(this.C,L.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Gp)(L.source),error:ne}),s.set(j,{error:ne,identifier:L.identifier,operation:L.operation,source:L.source,context:L.options.context,profileLocation:L.profileLocation,applicationScoped:L.options.isApplicationScoped}),this.F.error("Error while installing the extension",L.identifier.id,(0,N.$0)(ne)),ne}if(!h.URI.isUri(L.source)){const J=L.operation===3,ne=J?void 0:(new Date().getTime()-L.source.lastUpdated)/1e3;if(n(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Gp)(L.source),verificationStatus:L.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:ne}),u.$o&&L.operation!==3)try{await this.z.reportStatistic(C.manifest.publisher,C.manifest.name,C.manifest.version,"install")}catch{}}s.set(j,{local:C,identifier:L.identifier,operation:L.operation,source:L.source,context:L.options.context,profileLocation:L.profileLocation,applicationScoped:C.isApplicationScoped})})),f.length&&await this.L(f),[...s.values()]}catch(j){const L=(J,ne,ie)=>{const ue=[];J.manifest.extensionDependencies?.length&&ue.push(...J.manifest.extensionDependencies),J.manifest.extensionPack?.length&&ue.push(...J.manifest.extensionPack);for(const le of ue){if(ie.includes(le.toLowerCase()))continue;ie.push(le.toLowerCase());const ce=s.get(`${le.toLowerCase()}-${ne.toString()}`);ce?.local&&(ie=L(ce.local,ne,ie))}return ie},q=J=>({identifier:J.identifier,operation:2,source:J.source,context:J.options.context,profileLocation:J.profileLocation,error:j}),C=[];for(const[J,{task:ne,root:ie}]of o){const ue=s.get(J);ue?ue.local&&ie&&!s.get(`${ie.identifier.id.toLowerCase()}-${ne.profileLocation.toString()}`)?.local&&(C.push(this.Z(ue.local,{versionOnly:!0,profileLocation:ne.profileLocation})),s.set(J,q(ne))):(ne.cancel(),s.set(J,q(ne)))}for(const[J,{task:ne}]of o){const ie=s.get(J);if(!ie?.local||ne.options.donotIncludePackAndDependencies)continue;L(ie.local,ne.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(le=>o.has(`${le.toLowerCase()}-${ne.profileLocation.toString()}`)&&!s.get(`${le.toLowerCase()}-${ne.profileLocation.toString()}`)?.local)&&(C.push(this.Z(ie.local,{versionOnly:!0,profileLocation:ne.profileLocation})),s.set(J,q(ne)))}throw C.length&&await Promise.allSettled(C.map(async J=>{try{await J.run(),this.F.info("Rollback: Uninstalled extension",J.extension.identifier.id)}catch(ne){this.F.warn("Rollback: Error while uninstalling extension",J.extension.identifier.id,(0,N.$0)(ne))}})),j}finally{for(const{task:j}of o.values())j.source&&!h.URI.isUri(j.source)&&this.j.delete(S(j.source,j.profileLocation));if(s.size){const j=[...s.values()];for(const L of j)L.local&&this.F.info("Extension installed successfully:",L.identifier.id);this.s.fire(j)}}}J(i,s){for(const[,{task:o,waitingTasks:f}]of this.j.entries())if(o===i&&(f.includes(s)||f.some(S=>this.J(S,s)))||o===s&&f[0]&&!this.J(i,f[0]))return!1;return!0}async L(i,s){const o=[],f=[],S=await Promise.allSettled(i);for(const j of S)j.status==="fulfilled"?o.push(j.value):f.push(g(j.reason,s));if(!f.length)return o;if(f.length===1)throw f[0];let k=new y.$_o("","Unknown");for(const j of f)k=new y.$_o(k.message?`${k.message}, ${j.message}`:j.message,j.code!=="Unknown"&&j.code!=="Internal"?j.code:k.code);throw k}async M(i,s,o,f,S,k){if(!this.z.isEnabled())return[];const j=await this.getInstalled(void 0,S,k),L=[],q=[],C=async(J,ne)=>{L.push(J);const ie=ne.extensionDependencies||[],ue=[...ie];if(ne.extensionPack){const le=o?j.find(ce=>(0,w.$yp)(ce.identifier,J)):void 0;for(const ce of ne.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(V=>(0,w.$yp)({id:V},{id:ce}))||ue.every(V=>!(0,w.$yp)({id:V},{id:ce}))&&ue.push(ce)}if(ue.length){const le=ue.filter(ce=>L.every(V=>!(0,w.$yp)(V,{id:ce})));if(le.length){const ce=await this.z.getExtensions(le.map(V=>({id:V,preRelease:f})),I.CancellationToken.None);for(const V of ce){if(L.find(T=>(0,w.$yp)(T,V.identifier)))continue;const Z=ie.some(T=>(0,w.$yp)({id:T},V.identifier));let B;try{B=await this.N(V,!1,f,k)}catch(T){if(Z)throw T;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,N.$0)(T));continue}q.push({gallery:B.extension,manifest:B.manifest}),await C(B.extension.identifier,B.manifest)}}}};return await C(i,s),q}async N(i,s,o,f){let S;const k=await this.getExtensionsControlManifest();if(k.malicious.some(q=>(0,w.$yp)(i.identifier,q)))throw new y.$_o(b.localize(1,null,i.identifier.id),"Malicious");const j=k.deprecated[i.identifier.id.toLowerCase()];if(j?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${j.extension.id}' extension instead.`),S=(await this.z.getExtensions([{id:j.extension.id,preRelease:j.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:f},I.CancellationToken.None))[0],!S)throw new y.$_o(b.localize(2,null,i.identifier.id,j.extension.id),"Deprecated")}else{if(!await this.canInstall(i)){const q=await this.getTargetPlatform();throw new y.$_o(b.localize(3,null,i.identifier.id,this.G.nameLong,(0,y.$4o)(q)),"IncompatibleTargetPlatform")}if(S=await this.O(i,s,o,f),!S)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],I.CancellationToken.None))[0]?new y.$_o(b.localize(4,null,i.displayName??i.identifier.id),"ReleaseVersionNotFound"):new y.$_o(b.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),"Incompatible")}this.F.info("Getting Manifest...",S.identifier.id);const L=await this.z.getManifest(S,I.CancellationToken.None);if(L===null)throw new y.$_o(`Missing manifest for extension ${S.identifier.id}`,"Invalid");if(L.version!==S.version)throw new y.$_o(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,"Invalid");return{extension:S,manifest:L}}async O(i,s,o,f){const S=await this.getTargetPlatform();let k=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(k=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:S,compatible:!0,productVersion:f},I.CancellationToken.None))[0]||null),!k&&await this.z.isExtensionCompatible(i,o,S,f)&&(k=i),k||(s?k=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:S,compatible:!0,productVersion:f},I.CancellationToken.None))[0]||null:k=await this.z.getCompatibleExtension(i,o,S,f)),k}async P(i,s){const o={...s,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:s.profileLocation??this.X()},f=C=>`${C.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,S=this.m.get(f(i.identifier));if(S)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),S.waitUntilTaskIsFinished();const k=C=>{const J=this.Z(C,o);return this.m.set(f(J.extension.identifier),J),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${C.identifier.id}@${C.manifest.version}`),this.t.fire({identifier:C.identifier,profileLocation:o.profileLocation,applicationScoped:C.isApplicationScoped}),J},j=(C,J)=>{J?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString(),J.message):this.F.error("Failed to uninstall extension:",`${C.identifier.id}@${C.manifest.version}`,J.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${C.identifier.id}@${C.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,w.$Fp)(C),error:J}),this.u.fire({identifier:C.identifier,error:J?.code,profileLocation:o.profileLocation,applicationScoped:C.isApplicationScoped})},L=[],q=[];try{L.push(k(i));const C=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const J=this.S(i,C);for(const ne of J)this.m.has(f(ne.identifier))?this.F.info("Extensions is already requested to uninstall",ne.identifier.id):L.push(k(ne))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(L.map(J=>J.extension),C,i),await this.L(L.map(async J=>{try{if(await J.run(),await this.L(this.y.map(ne=>ne.postUninstall(J.extension,o,I.CancellationToken.None))),J.extension.identifier.uuid)try{await this.z.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}j(J.extension)}catch(ne){const ie=g(ne);throw j(J.extension,ie),ie}finally{q.push(J)}}))}catch(C){const J=g(C);for(const ne of L){try{ne.cancel()}catch{}q.includes(ne)||j(ne.extension,J)}throw J}finally{for(const C of L)this.m.delete(f(C.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",C.extension.identifier.id)}}Q(i,s,o){for(const f of i){const S=this.U(f,s);if(S.length){const k=S.filter(j=>!i.some(L=>(0,w.$yp)(L.identifier,j.identifier)));if(k.length)throw new Error(this.R(f,k,o))}}}R(i,s,o){return o===i?s.length===1?b.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?b.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}S(i,s,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const f=i.manifest.extensionPack?i.manifest.extensionPack:[];if(f.length){const S=s.filter(j=>!j.isBuiltin&&f.some(L=>(0,w.$yp)({id:L},j.identifier))),k=[];for(const j of S)k.push(...this.S(j,s,o));return[...S,...k]}return[]}U(i,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(f=>(0,w.$yp)({id:f},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,N.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$pq=p,e.$pq=p=$e([oe(0,y.$0o),oe(1,l.$4l),oe(2,c.$Cl),oe(3,R.$5j),oe(4,d.$lk),oe(5,v.$El)],p);function g(t,i){if(t instanceof y.$_o)return t;let s;return t instanceof y.$$o?s=new y.$_o(t.message,t.code==="DownloadFailedWriting"?"DownloadFailedWriting":"Gallery"):s=new y.$_o(t.message,(0,N.$4)(t)?"Cancelled":i??"Internal"),s.stack=t.stack,s}function n(t,i,{extensionData:s,verificationStatus:o,duration:f,error:S,durationSinceUpdate:k}){let j,L;(0,a.$gg)(o)&&(o===!0?o="Verified":(o===!1||(j="Signature",L=o),o="Unverified")),S&&(j=S.code,S.code==="Signature"&&(L=S.message)),t.publicLog(i,{...s,verificationStatus:o,success:!S,duration:f,errorcode:j,errorcodeDetail:L,durationSinceUpdate:k})}class r{constructor(){this.d=new D.$xh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,D.$lh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$lh)(i=>new Promise((s,o)=>{const f=i.onCancellationRequested(()=>{f.dispose(),o(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$rq=r}),define(se[42],re([0,1,8,14,2,5,30,11,21,26,13,10,6,24,23,3,9,22]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$,R,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.$sq=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class v extends Error{constructor(t,i){super(t),this.code=i}}e.$sq=v,e.$tq=(0,b.$yi)("IExtensionsProfileScannerService");let p=class extends I.$Uc{constructor(t,i,s,o,f,S){super(),this.j=t,this.m=i,this.n=s,this.r=o,this.s=f,this.t=S,this.b=this.B(new N.$fe),this.onAddExtensions=this.b.event,this.c=this.B(new N.$fe),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$fe),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$fe),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i,s){const o=[],f=[];try{return await this.u(i,S=>{const k=[];if(s)k.push(...S);else for(const j of S)t.some(([L])=>(0,a.$yp)(L.identifier,j.identifier)&&L.manifest.version!==j.version)?o.push(j):k.push(j);for(const[j,L]of t){const q=k.findIndex(J=>(0,a.$yp)(J.identifier,j.identifier)&&J.version===j.manifest.version),C={identifier:j.identifier,version:j.manifest.version,location:j.location,metadata:L};q===-1?(f.push(C),k.push(C)):k.splice(q,1,C)}return f.length&&this.b.fire({extensions:f,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),k}),f.length&&this.c.fire({extensions:f,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),f}catch(S){throw f.length&&this.c.fire({extensions:f,error:S,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:S,profileLocation:i}),S}}async updateMetadata(t,i){const s=[];return await this.u(i,o=>{const f=[];for(const S of o){const k=t.find(([j])=>(0,a.$yp)(j.identifier,S.identifier)&&j.manifest.version===S.version);k&&(S.metadata={...S.metadata,...k[1]},s.push(S)),f.push(S)}return f}),s}async removeExtensionFromProfile(t,i){const s=[];try{await this.u(i,o=>{const f=[];for(const S of o)(0,a.$yp)(S.identifier,t.identifier)?s.push(S):f.push(S);return s.length&&this.f.fire({extensions:s,profileLocation:i}),f}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async u(t,i,s){return this.F(t).queue(async()=>{let o=[],f;try{const S=await this.m.readFile(t);f=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,h.$jl)(S)!==1)throw S;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(f=await this.D()),!f&&s?.bailOutWhenFileNotFound)throw new v((0,d.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(f){Array.isArray(f)||this.w(t);let S=!1;for(const k of f){g(k)||this.w(t);let j;if((0,R.$$f)(k.relativeLocation)&&k.relativeLocation)j=this.z(k.relativeLocation);else if((0,R.$$f)(k.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${k.location}`);continue}else{j=P.URI.revive(k.location);const L=this.y(j);L&&(S=!0,k.relativeLocation=L)}(0,R.$fg)(k.metadata?.hasPreReleaseVersion)&&k.metadata?.preRelease&&(S=!0,k.metadata.hasPreReleaseVersion=!0),o.push({identifier:k.identifier,location:j,version:k.version,metadata:k.metadata})}S&&await this.m.writeFile(t,D.$He.fromString(JSON.stringify(f)))}if(i){o=i(o);const S=o.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.y(k.location),metadata:k.metadata}));await this.m.writeFile(t,D.$He.fromString(JSON.stringify(S)))}return o})}w(t){const i=new v(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(f){if((0,h.$jl)(f)===1)return;throw f}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const f=JSON.parse(s);Array.isArray(f)&&f.every(S=>g(S))?o=f:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.t.error(f)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$He.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(f){if((0,h.$jl)(f)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw f}try{await this.m.del(t)}catch(f){(0,h.$jl)(f)!==1&&this.t.error(f)}try{await this.m.del(i)}catch(f){(0,h.$jl)(f)!==1&&this.t.error(f)}return o})()),this.C}F(t){let i=this.h.get(t);return i||(i=new O.$Fh,this.h.set(t,i)),i}};e.$uq=p,e.$uq=p=$e([oe(1,h.$5k),oe(2,w.$El),oe(3,$.$Cl),oe(4,l.$4l),oe(5,y.$5j)],p);function g(r){return(0,R.$ag)(r)&&(0,u.$9o)(r.identifier)&&(n(r.location)||(0,R.$$f)(r.location)&&r.location)&&((0,R.$fg)(r.relativeLocation)||(0,R.$$f)(r.relativeLocation))&&r.version&&(0,R.$$f)(r.version)}function n(r){return r?(0,R.$$f)(r.path)&&(0,R.$$f)(r.scheme):!1}}),define(se[53],re([0,1,19,8,27,14,9,38,84,2,15,16,12,17,44,55,3,11,100,18,26,37,50,13,10,6,32,5,47,42,24,23,118]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$,R,d,l,c,v,p,g,n,r,t,i,s,o,f,S,k,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$zq=e.$yq=e.$xq=e.Translations=void 0,e.$Aq=ue;var q;(function(ce){function V(Z,B){if(Z===B)return!0;const T=Object.keys(Z),H=new Set;for(const Q of Object.keys(B))H.add(Q);if(T.length!==H.size)return!1;for(const Q of T){if(Z[Q]!==B[Q])return!1;H.delete(Q)}return H.size===0}ce.equals=V})(q||(e.Translations=q={})),e.$xq=(0,t.$yi)("IExtensionsScannerService");let C=class extends a.$Uc{constructor(V,Z,B,T,H,Q,Y,_,F,U,m,E){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=Z,this.r=B,this.s=T,this.t=H,this.u=Q,this.w=Y,this.y=_,this.z=F,this.C=U,this.D=m,this.F=E,this.g=this.B(new o.$fe),this.onDidChangeCache=this.g.event,this.h=(0,w.$_g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(ne,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Jp)(this.w,this.y)),this.G}async scanAllExtensions(V,Z,B){const[T,H]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(Z)]),Q=B?await this.scanExtensionsUnderDevelopment(V,[...T,...H]):[];return this.L(T,H,Q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const Z=[];Z.push(this.M(!!V.useCache,V.language)),Z.push(this.N(V.language,!!V.checkControlFile));const[B,T]=await Promise.all(Z);return this.J([...B,...T],0,V,!1)}async scanUserExtensions(V){const Z=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const B=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.P(Z,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,B,V.productVersion??this.R()),H=V.useCache&&!T.devMode&&T.excludeObsolete?this.m:this.n;let Q;try{Q=await H.scanExtensions(T)}catch(Y){if(Y instanceof S.$sq&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Q=await H.scanExtensions(T);else throw Y}return Q=await this.J(Q,1,V,!0),this.y.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(V,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(T=>T.scheme===h.Schemas.file).map(async T=>{const H=await this.P(T,!1,1,!0,V.language,!1,void 0,V.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(H)).map(Y=>(Y.type=Z.find(_=>(0,p.$yp)(_.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,H)))}))).flat();return this.J(B,"development",V,!0)}return[]}async scanExistingExtension(V,Z,B){const T=await this.P(V,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),H=await this.n.scanExtension(T);return!H||!B.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(V,Z,B){const T=await this.P(V,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),H=await this.n.scanOneOrMultipleExtensions(T);return this.J(H,Z,B,!0)}async scanMultipleExtensions(V,Z,B){const T=[];return await Promise.all(V.map(async H=>{const Q=await this.scanOneOrMultipleExtensions(H,Z,B);T.push(...Q)})),this.J(T,Z,B,!0)}async scanMetadata(V){const Z=(0,w.$_g)(V,"package.json"),B=(await this.w.readFile(Z)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(V,Z){const B=(0,w.$_g)(V,"package.json"),T=(await this.w.readFile(B)).value.toString(),H=JSON.parse(T);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,H.__metadata={...H.__metadata,...Z},await this.w.writeFile((0,w.$_g)(V,"package.json"),N.$He.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof S.$sq&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$He.fromString(JSON.stringify([])))}catch(Z){(0,r.$jl)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,Z,B,T){return B.includeAllVersions||(V=this.L(Z===0?V:void 0,Z===1?V:void 0,Z==="development"?V:void 0,await this.getTargetPlatform(),T)),B.includeInvalid||(V=V.filter(H=>H.isValid)),V.sort((H,Q)=>{const Y=b.$nc(H.location.fsPath),_=b.$nc(Q.location.fsPath);return Y<_?-1:Y>_?1:0})}L(V,Z,B,T,H){const Q=(_,F,U)=>{if(_.isValid&&!F.isValid)return!1;if(_.isValid===F.isValid){if(H&&$.gt(_.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if($.eq(_.manifest.version,F.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===T)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${_.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${F.location.path}.`),!0},Y=new g.$Vm;return V?.forEach(_=>{const F=Y.get(_.identifier.id);(!F||Q(F,_,!1))&&Y.set(_.identifier.id,_)}),Z?.forEach(_=>{const F=Y.get(_.identifier.id);if(!F&&V&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!F||Q(F,_,!1))&&Y.set(_.identifier.id,_)}),B?.forEach(_=>{const F=Y.get(_.identifier.id);(!F||Q(F,_,!0))&&Y.set(_.identifier.id,_),Y.set(_.identifier.id,_)}),[...Y.values()]}async M(V,Z){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0,this.R()),H=await(V&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",H.length),H}async N(V,Z){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const T=Z?await this.O():{},H=[],Q=l.URI.file(b.$hc(b.$jc(h.$Sg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of B){const F=T[_.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":H.push((0,w.$_g)(Q,_.name));break;default:H.push(l.URI.file(F));break}}const Y=await Promise.all(H.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,V,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,O.$Hb)(Y)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,Z,B,T,H,Q,Y,_){const F=await this.f(H??y.$w),U=await this.Q(V),m=Z&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=m?await this.Q(m):void 0;return new J(V,U,m,E,Z,Y,B,T,Q,_.version,_.date,this.C.commit,!this.z.isBuilt,H,F)}async Q(V){try{const Z=await this.w.stat(V);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$yq=C,e.$yq=C=$e([oe(4,k.$El),oe(5,S.$tq),oe(6,r.$5k),oe(7,i.$5j),oe(8,v.$Fi),oe(9,s.$lk),oe(10,j.$Cl),oe(11,t.$xi)],C);class J{constructor(V,Z,B,T,H,Q,Y,_,F,U,m,E,z,M,G){this.location=V,this.mtime=Z,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=T,this.profile=H,this.profileScanOptions=Q,this.type=Y,this.excludeObsolete=_,this.validate=F,this.productVersion=U,this.productDate=m,this.productCommit=E,this.devMode=z,this.language=M,this.translations=G}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,Z){return(0,w.$5g)(V.location,Z.location)&&V.mtime===Z.mtime&&(0,w.$5g)(V.applicationExtensionslocation,Z.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&V.profile===Z.profile&&I.$9n(V.profileScanOptions,Z.profileScanOptions)&&V.type===Z.type&&V.excludeObsolete===Z.excludeObsolete&&V.validate===Z.validate&&V.productVersion===Z.productVersion&&V.productDate===Z.productDate&&V.productCommit===Z.productCommit&&V.devMode===Z.devMode&&V.language===Z.language&&q.equals(V.translations,Z.translations)}}e.$zq=J;let ne=class extends a.$Uc{constructor(V,Z,B,T,H){super(),this.f=V,this.g=Z,this.h=B,this.j=T,this.m=H}async scanExtensions(V){const Z=V.profile?await this.r(V):await this.n(V);let B={};if(V.excludeObsolete&&V.type===1)try{const T=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(T)}catch{}return(0,d.$lg)(B)?Z:Z.filter(T=>!B[p.$zp.create(T).toString()])}async n(V){const Z=await this.j.resolve(V.location);if(!Z.children?.length)return[];const B=await Promise.all(Z.children.map(async T=>{if(!T.isDirectory||V.type===1&&(0,w.$9g)(T.resource).indexOf(".")===0)return null;const H=new J(T.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(H)}));return(0,O.$Hb)(B).sort((T,H)=>T.location.path<H.location.path?-1:1)}async r(V){let Z=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){Z=Z.filter(T=>!T.metadata?.isApplicationScoped);const B=await this.s(V.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,V);Z.push(...B)}return Z}async s(V,Z,B){const T=await this.g.scanProfileExtensions(V,B.profileScanOptions);if(!T.length)return[];const H=await Promise.all(T.map(async Q=>{if(Z(Q)){const Y=new J(Q.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Y,Q.metadata)}return null}));return(0,O.$Hb)(H)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,w.$_g)(V.location,"package.json"))){const Z=await this.scanExtension(V);return Z?[Z]:[]}else return await this.scanExtensions(V)}catch(Z){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,A.$0)(Z)),[]}}async scanExtension(V,Z){try{let B=await this.scanExtensionManifest(V.location);if(B){B.publisher||(B.publisher=g.$Pm),Z=Z??B.__metadata,delete B.__metadata;const T=(0,p.$Dp)(B.publisher,B.name),H=Z?.id?{id:T,uuid:Z.id}:{id:T},Q=Z?.isSystem?0:V.type,Y=Q===0||!!Z?.isBuiltin;B=await this.t(V.location,B,J.createNlsConfiguration(V));const _={type:Q,identifier:H,manifest:B,location:V.location,isBuiltin:Y,targetPlatform:Z?.targetPlatform??"undefined",publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return V.validate?this.validate(_,V):_}}catch(B){V.type!==0&&this.m.error(B)}return null}validate(V,Z){let B=!0;const T=(0,n.$Op)(Z.productVersion,Z.productDate,Z.location,V.manifest,V.isBuiltin);for(const[H,Q]of T)H===R.default.Error&&(B=!1,this.m.error(this.z(Z.location,Q)));return V.isValid=B,V.validations=T,V}async scanExtensionManifest(V){const Z=(0,w.$_g)(V,"package.json");let B;try{B=(await this.j.readFile(Z)).value.toString()}catch(H){return(0,r.$jl)(H)!==1&&this.m.error(this.z(V,(0,c.localize)(0,null,Z.path,H.message))),null}let T;try{T=JSON.parse(B)}catch{const Q=[];(0,P.$Ln)(B,Q);for(const Y of Q)this.m.error(this.z(V,(0,c.localize)(1,null,Z.path,Y.offset,Y.length,(0,u.$vq)(Y.error))));return null}return(0,P.$Un)(T)!=="object"?(this.m.error(this.z(V,(0,c.localize)(2,null,Z.path))),null):T}async t(V,Z,B){const T=await this.u(V,Z,B);if(T)try{const H=[],Q=await this.w(T.default,H);if(H.length>0)return H.forEach(_=>{this.m.error(this.z(V,(0,c.localize)(3,null,T.default?.path,(0,u.$vq)(_.error))))}),Z;if((0,P.$Un)(T)!=="object")return this.m.error(this.z(V,(0,c.localize)(4,null,T.default?.path))),Z;const Y=T.values||Object.create(null);return(0,L.$wq)(this.m,Z,Y,Q)}catch{}return Z}async u(V,Z,B){const T=(0,w.$_g)(V,"package.nls.json"),H=(F,U)=>{U.forEach(m=>{this.m.error(this.z(V,(0,c.localize)(5,null,F?.path,(0,u.$vq)(m.error))))})},Q=F=>{this.m.error(this.z(V,(0,c.localize)(6,null,F?.path)))},Y=`${Z.publisher}.${Z.name}`,_=B.translations[Y];if(_)try{const F=l.URI.file(_),U=(await this.j.readFile(F)).value.toString(),m=[],E=(0,P.$Ln)(U,m);return m.length>0?(H(F,m),{values:void 0,default:T}):(0,P.$Un)(E)!=="object"?(Q(F),{values:void 0,default:T}):{values:E.contents?E.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.j.exists(T))return;let U;try{U=await this.y(V,B)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const m=(await this.j.readFile(U.localized)).value.toString(),E=[],z=(0,P.$Ln)(m,E);return E.length>0?(H(U.localized,E),{values:void 0,default:U.original}):(0,P.$Un)(z)!=="object"?(Q(U.localized),{values:void 0,default:U.original}):{values:z,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(V,Z){if(V)try{const B=(await this.j.readFile(V)).value.toString();return(0,P.$Ln)(B,Z)}catch{}}y(V,Z){return new Promise((B,T)=>{const H=Q=>{const Y=(0,w.$_g)(V,`package.nls.${Q}.json`);this.j.exists(Y).then(_=>{_&&B({localized:Y,original:(0,w.$_g)(V,"package.nls.json")});const F=Q.lastIndexOf("-");F===-1?B({localized:(0,w.$_g)(V,"package.nls.json"),original:null}):(Q=Q.substring(0,F),H(Q))})};if(Z.devMode||Z.pseudo||!Z.language)return B({localized:(0,w.$_g)(V,"package.nls.json"),original:null});H(Z.language)})}z(V,Z){return`[${V.path}]: ${Z}`}};ne=$e([oe(1,S.$tq),oe(2,j.$Cl),oe(3,r.$5k),oe(4,i.$5j)],ne);let ie=class extends ne{constructor(V,Z,B,T,H,Q,Y){super(Z,T,H,Q,Y),this.G=V,this.H=B,this.D=this.B(new D.$wh(3e3)),this.F=this.B(new o.$fe),this.onDidChangeCache=this.F.event}async scanExtensions(V){const Z=this.M(V),B=await this.I(Z);if(this.C=V,B&&B.input&&J.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),B.result.map(H=>(H.location=l.URI.revive(H.location),H));const T=await super.scanExtensions(V);return await this.J(Z,{input:V,result:T}),T}async I(V){try{const Z=await this.j.readFile(V),B=JSON.parse(Z.value.toString());return{result:B.result,input:(0,f.$8h)(B.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",V.path,(0,A.$0)(Z))}return null}async J(V,Z){try{await this.j.writeFile(V,N.$He.fromString(JSON.stringify(Z)))}catch(B){this.m.debug("Error while writing the extension cache file:",V.path,(0,A.$0)(B))}}async L(){if(!this.C)return;const V=this.M(this.C),Z=await this.I(V);if(!Z)return;const B=Z.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!I.$9n(T,B))try{this.m.info("Invalidating Cache",B,T),await this.j.del(V),this.F.fire()}catch(H){this.m.error(H)}}M(V){const Z=this.N(V);return this.h.extUri.joinPath(Z.cacheHome,V.type===0?g.$Om:g.$Nm)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(V.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};ie=$e([oe(2,k.$El),oe(3,S.$tq),oe(4,j.$Cl),oe(5,r.$5k),oe(6,i.$5j)],ie);function ue(ce,V){const Z=(0,p.$Bp)(ce.manifest.publisher,ce.manifest.name);return{id:Z,identifier:new g.$Tm(Z),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:V,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class le extends C{constructor(V,Z,B,T,H,Q,Y,_,F,U,m,E){super(V,Z,(0,w.$_g)(B,".vscode-oss-dev","extensions","control.json"),T,H,Q,Y,_,F,U,m,E),this.S=(async()=>{if(y.$z)try{const z=await this.w.readFile(l.URI.file(y.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(V){return this.S}}e.$Bq=le}),define(se[160],re([0,1,8,9,2,15,17,44,3,28,25,49,29,18,72,21,26,71,13,6]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$,R,d,l,c,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;let g=class extends I.$Uc{static{p=this}static{this.c=".sigzip"}constructor(r,t,i,s,o,f){super(),this.h=t,this.j=i,this.m=s,this.n=o,this.r=f,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(r,t,i,s){await this.g;const o=(0,A.$_g)(this.extensionsDownloadDir,this.z(r));try{await this.w(r,o,S=>this.j.download(r,S,t))}catch(S){throw(0,$.$qq)(S,"Download")}let f=!1;if(i&&this.t(r)){let S;try{S=await this.u(r)}catch(k){try{await this.delete(o)}catch(j){this.r.error(j)}throw k}try{f=await this.n.verify(r.identifier.id,o.fsPath,S.fsPath,s)}catch(k){if(f=k.code,f==="PackageIsInvalidZip"||f==="SignatureArchiveIsInvalidZip"){try{await this.delete(o)}catch(j){this.r.error(j)}throw new R.$_o(b.$kq,"CorruptZip")}}finally{try{await this.delete(S)}catch(k){this.r.error(k)}}}return{location:o,verificationStatus:f}}t(r){if(!r.isSigned)return this.r.info(`Extension is not signed: ${r.identifier.id}`),!1;const t=this.m.getValue("extensions.verifySignature");return(0,u.$eg)(t)?t:!0}async u(r){await this.g;const t=(0,A.$_g)(this.extensionsDownloadDir,`.${(0,a.$Ug)()}`);try{await this.j.downloadSignatureArchive(r,t)}catch(i){throw(0,$.$qq)(i,"DownloadSignature")}return t}async w(r,t,i){if(await this.h.exists(t))return;if(t.scheme!==N.Schemas.file){await i(t);return}const s=(0,A.$_g)(this.extensionsDownloadDir,`.${(0,a.$Ug)()}`);try{await i(s)}catch(o){try{await this.h.del(s)}catch{}throw o}try{await h.Promises.rename(s.fsPath,t.fsPath,2*60*1e3)}catch(o){try{await this.h.del(s)}catch{}if(o.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",r.identifier.id,t.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(o)}. Deleted the file from downloaded location`,s.path),o}}async delete(r){await this.g,await this.h.del(r)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const r=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(r.children){const t=[],i=[],s=[];for(const S of r.children)if(S.name.endsWith(p.c))s.push(S.resource);else{const k=d.$zp.parse(S.name);k&&i.push([k,S])}const o=(0,d.$Ep)(i,([S])=>S),f=[];for(const S of o)S.sort((k,j)=>P.rcompare(k[0].version,j[0].version)),t.push(...S.slice(1).map(k=>k[1].resource)),f.push(S[0][1]);f.sort((S,k)=>S.mtime-k.mtime),t.push(...f.slice(0,Math.max(0,f.length-this.f)).map(S=>S.resource)),t.push(...s),await O.Promises.settled(t.map(S=>(this.r.trace("Deleting from cache",S.path),this.h.del(S))))}}catch(r){this.r.error(r)}}z(r){return this.f?d.$zp.create(r).toString().toLowerCase():(0,a.$Ug)()}};e.$Cq=g,e.$Cq=g=p=$e([oe(0,w.$Gi),oe(1,c.$5k),oe(2,R.$0o),oe(3,y.$5i),oe(4,l.$dq),oe(5,v.$5j)],g)}),define(se[161],re([0,1,59,8,34,5,2,15,16,25,6,24]),function(X,e,O,D,I,N,A,P,u,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;let y=class extends A.$Uc{constructor($,R){super(),this.b=$,this.f=R,this.a=new D.$Eh(5)}async postUninstall($){const R=this.g($,"uninstall");R&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(d)}}));try{await a.Promises.rm(this.m($))}catch(d){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(d)}}g($,R){const d=`vscode:${R}`;if($.location.scheme===P.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[d]=="string"){const l=$.manifest.scripts[d].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn($.identifier.id,$.manifest.version,`${d} should be a node script`),null):{script:(0,u.$jc)($.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h($,R,d,l,c){return new Promise((v,p)=>{const g=this.j($,R,d,c);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?p(t):v(void 0)};g.on("error",t=>{r((0,I.$jj)(t)||"Unknown")}),g.on("exit",(t,i)=>{r(t?`post-${R} process exited with code ${t}`:void 0)}),l&&(n=setTimeout(()=>{n=null,g.kill(),p("timed out")},5e3))})}j($,R,d,l){const c={silent:!0,execArgv:void 0},v=(0,O.fork)($,[`--type=extension-post-${R}`,...d],c);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const p=N.Event.fromNodeEventEmitter(v.stdout,"data"),g=N.Event.fromNodeEventEmitter(v.stderr,"data");this.B(p(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${R}`,t))),this.B(g(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${R}`,t)));const n=N.Event.any(N.Event.map(p,t=>({data:`%c${t}`,format:[""]}),this.q),N.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]}),this.q));return N.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),v}m($){return(0,u.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$Dq=y,e.$Dq=y=$e([oe(0,b.$El),oe(1,h.$5j)],y)}),define(se[162],re([0,1,8,14,20,34,9,5,43,2,30,15,16,17,44,3,11,28,25,49,101,61,18,72,21,26,42,53,160,161,119,141,148,50,13,10,6,32,22,23,24]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$,R,d,l,c,v,p,g,n,r,t,i,s,o,f,S,k,j,L,q,C,J,ne,ie,ue,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=e.$Hq=void 0,e.$Hq=(0,J.$zi)(t.$ap);const V=".vsctmp";let Z=class extends r.$pq{constructor(F,U,m,E,z,M,G,W,te,ae,he,pe){super(F,U,he,m,ae,pe),this.eb=z,this.fb=M,this.gb=G,this.hb=te,this.db=new Map,this.qb=new h.$Bc;const ye=this.B(W.createInstance(S.$Dq));this.ab=this.B(W.createInstance(B,me=>ye.postUninstall(me))),this.bb=this.B(new j.$Fq(pe,te,he,this,this.F)),this.cb=this.B(W.createInstance(f.$Cq));const fe=this.B(new L.$Gq(this,this.eb,pe,M,he,te,m));this.B(fe.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,i.$Jp)(this.hb,this.F)),this.ib}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const U=await this.ob(F),m=await(0,v.zip)((0,w.$_g)(this.cb.extensionsDownloadDir,(0,l.$Ug)()).fsPath,U);return d.URI.file(m)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:U,cleanup:m}=await this.kb(F),E=y.$kc(U.fsPath);try{return await(0,k.$Eq)(E)}finally{await m()}}getInstalled(F,U=this.H.defaultProfile.extensionsResource,m={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(F??null,U,m)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.ab.scanUserExtensionAtLocation(F)}async install(F,U={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:m,cleanup:E}=await this.kb(F);try{const z=await(0,k.$Eq)(y.$kc(m.fsPath)),M=(0,i.$Dp)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,q.$Qp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,M,this.G.version));const W=(await this.I([{manifest:z,extension:m,options:U}])).find(({identifier:te})=>(0,i.$yp)(te,{id:M}));if(W?.local)return W.local;throw W?.error?W.error:(0,r.$qq)(new Error(`Unknown error while installing extension ${M}`))}finally{await E()}}async installFromLocation(F,U){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const m=await this.ab.scanUserExtensionAtLocation(F);if(!m||!m.manifest.name||!m.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.tb([[m,{source:"resource"}]],U),this.F.info("Successfully installed extension",m.identifier.id,U.toString()),m}async installExtensionsFromProfile(F,U,m){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,U.toString(),m.toString());const E=(await this.getInstalled(1,U)).filter(z=>F.some(M=>(0,i.$yp)(M,z.identifier)));if(E.length){const z=await Promise.all(E.map(M=>this.ab.scanMetadata(M,U)));await this.tb(E.map((M,G)=>[M,z[G]]),m),this.F.info("Successfully installed extensions",E.map(M=>M.identifier.id),m.toString())}return E}async updateMetadata(F,U,m=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0,U.hasPreReleaseVersion=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),F=await this.ab.updateMetadata(F,U,m),this.bb.invalidate(m),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const U=await this.getTargetPlatform(),[m]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:U,compatible:!0},I.CancellationToken.None);if(!m)throw new Error(p.localize(2,null));await this.ab.setUninstalled(F);try{await this.ab.removeUninstalledExtension(F)}catch(E){throw new Error(p.localize(3,null,(0,N.$jj)(E)))}return this.installFromGallery(m)}$(F,U,m,E){return this.ab.copyExtension(F,U,m,E)}copyExtensions(F,U){return this.ab.copyExtensions(F,U,{version:this.G.version,date:this.G.date})}markAsUninstalled(...F){return this.ab.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(F){this.F.error(F)}}async download(F,U,m){const{location:E}=await this.cb.download(F,U,!m);return E}async kb(F){if(F.scheme===b.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const U=(0,w.$_g)(this.cb.extensionsDownloadDir,(0,l.$Ug)());return await this.gb.download(F,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.hb.del(U)}catch(E){this.F.error(E)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(F,U,m){if(d.URI.isUri(U))return new Q(F,U,m,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const E=i.$zp.create(U).toString();let z=this.db.get(E);return z||(this.db.set(E,z=new H(F,U,m,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(E))),z}Z(F,U){return new Y(F,U.profileLocation,this.fb)}async ob(F){const U=async E=>{let z=await c.Promises.readdir(E);z=z.map(W=>y.$jc(E,W));const M=await Promise.all(z.map(W=>c.Promises.stat(W)));let G=Promise.resolve([]);return M.forEach((W,te)=>{const ae=z[te];W.isFile()&&(G=G.then(he=>[...he,ae])),W.isDirectory()&&(G=G.then(he=>U(ae).then(pe=>[...he,...pe])))}),G};return(await U(F.location.fsPath)).map(E=>({path:`extension/${y.$lc(F.location.fsPath,E)}`,localPath:E}))}async pb({added:F,removed:U}){if(U){const m=F&&this.D.extUri.isEqual(U.profileLocation,F.profileLocation)?U.extensions.filter(E=>F.extensions.every(z=>!(0,i.$yp)(z,E))):U.extensions;for(const E of m)this.F.info("Extensions removed from another source",E.id,U.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:U.profileLocation})}if(F){const E=(await this.getInstalled(1,F.profileLocation)).filter(z=>F.extensions.some(M=>(0,i.$yp)(M,z.identifier)));this.s.fire(E.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,F.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:F.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(U=>this.qb.add(U)));const F=await this.hb.resolve(this.eb.userExtensionsLocation);for(const U of F.children??[])U.isDirectory&&this.qb.add(U.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(U=>this.sb(U)))}async sb(F){if(!F.affects(this.eb.userExtensionsLocation,1))return;const U=[];for(const m of F.rawAdded){if(this.qb.has(m)||!this.D.extUri.isEqual(this.D.extUri.dirname(m),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(m,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(m).startsWith(".")||!(await this.hb.stat(m)).isDirectory)continue;const E=await this.ab.scanUserExtensionAtLocation(m);E&&E.installedTimestamp===void 0&&(this.qb.add(m),U.push(E))}U.length&&(await this.tb(U.map(m=>[m,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(m=>m.identifier.id)))}async tb(F,U){const m=F.map(E=>E[0]);await this.ub(m),await this.fb.addExtensionsToProfile(F,U),this.s.fire(m.map(E=>({local:E,identifier:E.identifier,operation:1,profileLocation:U})))}async ub(F){const U=await this.ab.getUninstalledExtensions();for(const m of F){const E=i.$zp.create(m);U[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.ab.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$Iq=Z,e.$Iq=Z=$e([oe(0,t.$0o),oe(1,ue.$4l),oe(2,ne.$5j),oe(3,n.$Gi),oe(4,o.$xq),oe(5,s.$tq),oe(6,g.$No),oe(7,J.$xi),oe(8,C.$5k),oe(9,ie.$lk),oe(10,le.$Cl),oe(11,ce.$El)],Z);let B=class extends a.$Uc{constructor(F,U,m,E,z,M){super(),this.j=F,this.m=U,this.n=m,this.s=E,this.t=z,this.u=M,this.h=this.B(new P.$fe),this.onExtract=this.h.event,this.c=(0,w.$_g)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$Fh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,U,m){try{const E={includeInvalid:!0,profileLocation:U,productVersion:m};let z=[];return F===null||F===0?z.push(...await this.n.scanAllExtensions({includeInvalid:!0},E,!1)):F===1&&z.push(...await this.n.scanUserExtensions(E)),z=F!==null?z.filter(M=>M.type===F):z,await Promise.all(z.map(M=>this.F(M)))}catch(E){throw(0,r.$qq)(E,"Scanning")}}async scanAllUserExtensions(F){try{const U=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return await Promise.all(U.map(m=>this.F(m)))}catch(U){throw(0,r.$qq)(U,"Scanning")}}async scanUserExtensionAtLocation(F){try{const U=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(F,U,m,E,z){const M=F.toString(),G=d.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$Ug)()}`)),W=d.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,M));let te=await this.m.exists(W);if(te&&E){try{await this.y(F.id,W,"removeExisting")}catch{throw new t.$_o(p.localize(4,null,W.fsPath,F.id),"Delete")}te=!1}if(te)try{await this.n.updateMetadata(W,m)}catch(ae){throw(0,r.$qq)(ae,"UpdateMetadata")}else try{try{this.u.trace(`Started extracting the extension from ${U} to ${W.fsPath}`),await(0,v.$nq)(U,G.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${W}:`,F.id)}catch(ae){let he="Extract";throw ae instanceof v.$lq&&(ae.type==="CorruptZip"?he="CorruptZip":ae.type==="Incomplete"&&(he="IncompleteZip")),(0,r.$qq)(ae,he)}try{await this.n.updateMetadata(G,m)}catch(ae){throw(0,r.$qq)(ae,"UpdateMetadata")}try{this.u.trace(`Started renaming the extension from ${G.fsPath} to ${W.fsPath}`),await this.C(G.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ae)}. Deleted from extracted location`,G),ae}this.h.fire(W)}catch(ae){try{await this.m.del(G,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(F,U){return U?(await this.w(F,U))?.metadata:this.n.scanMetadata(F.location)}async w(F,U){return(await this.s.scanProfileExtensions(U)).find(E=>(0,i.$yp)(E.identifier,F.identifier))}async updateMetadata(F,U,m){try{m?await this.s.updateMetadata([[F,U]],m):await this.n.updateMetadata(F.location,U)}catch(E){throw(0,r.$qq)(E,"UpdateMetadata")}return this.D(F.location,F.type,m)}async getUninstalledExtensions(){try{return await this.z()}catch(F){throw(0,r.$qq)(F,"ReadUninstalled")}}async setUninstalled(...F){const U=F.map(m=>i.$zp.create(m));await this.z(m=>U.forEach(E=>{m[E.toString()]=!0,this.u.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(F){try{await this.z(U=>delete U[F.toString()])}catch(U){throw(0,r.$qq)(U,"UnsetUninstalled")}}async removeExtension(F,U){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,U)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(U=>delete U[i.$zp.create(F).toString()])}async copyExtension(F,U,m,E){const z=await this.w(F,U),M=await this.w(F,m);if(E={...z?.metadata,...E},M)if(this.t.extUri.isEqual(M.location,F.location))await this.s.updateMetadata([[F,{...M.metadata,...E}]],m);else{const G=await this.D(M.location,F.type,m);await this.s.removeExtensionFromProfile(G,m),await this.s.addExtensionsToProfile([[F,{...M.metadata,...E}]],m)}else await this.s.addExtensionsToProfile([[F,E]],m);return this.D(F.location,F.type,m)}async copyExtensions(F,U,m){const E=await this.scanExtensions(1,F,m),z=await Promise.all(E.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,F)]));await this.s.addExtensionsToProfile(z,U)}async y(F,U,m){this.u.trace(`Deleting ${m} extension from disk`,F,U.fsPath);const E=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,u.$mj)((0,l.$Ug)()).toString(16)}${V}`);await this.C(U.fsPath,E.fsPath),await this.m.del(E,{recursive:!0}),this.u.info(`Deleted ${m} extension from disk`,F,U.fsPath)}z(F){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,C.$jl)(E)!==1)throw E}let m={};if(U)try{m=JSON.parse(U)}catch{}return F&&(F(m),Object.keys(m).length?await this.m.writeFile(this.c,D.$He.fromString(JSON.stringify(m))):await this.m.del(this.c)),m})}async C(F,U){try{await c.Promises.rename(F,U,2*60*1e3)}catch(m){throw(0,r.$qq)(m,"Rename")}}async D(F,U,m){try{if(m){const z=(await this.n.scanUserExtensions({profileLocation:m})).find(M=>this.t.extUri.isEqual(M.location,F));if(z)return await this.F(z)}else{const E=await this.n.scanExistingExtension(F,U,{includeInvalid:!0});if(E)return await this.F(E)}throw new t.$_o(p.localize(5,null,F.path),"ScanningExtension")}catch(E){throw(0,r.$qq)(E,"ScanningExtension")}}async F(F){const U=await this.m.resolve(F.location);let m,E;return U.children&&(m=U.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,E=U.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:m,changelogUrl:E,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),m=new Set;for(const z of U)F[i.$zp.create(z).toString()]||m.add(z.identifier.id.toLowerCase());try{const z=(0,i.$Ep)(U,M=>M.identifier);await O.Promises.settled(z.map(async M=>{const G=M.sort((W,te)=>$.rcompare(W.manifest.version,te.manifest.version))[0];m.has(G.identifier.id.toLowerCase())||await this.j(await this.F(G))}))}catch(z){this.u.error(z)}const E=U.filter(z=>z.metadata&&F[i.$zp.create(z).toString()]);await Promise.allSettled(E.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,C.$jl)(U)!==1&&this.u.error(U);return}if(F?.children)try{await Promise.allSettled(F.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(m){(0,C.$jl)(m)!==1&&this.u.error(m)}}}))}catch{}}};e.$Jq=B,e.$Jq=B=$e([oe(1,C.$5k),oe(2,o.$xq),oe(3,s.$tq),oe(4,le.$Cl),oe(5,ne.$5j)],B);class T extends r.$rq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,R.$fg)(this.options.operation)?this.l:this.options.operation}constructor(F,U,m,E,z,M,G,W,te,ae){super(),this.manifest=F,this.identifier=U,this.source=m,this.options=E,this.m=z,this.n=M,this.o=G,this.p=W,this.q=te,this.s=ae,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[U,m]=await this.w(F);if(this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j))try{await this.p.initializeDefaultProfileExtensions()}catch(E){throw(0,r.$qq)(E,"IntializeDefaultProfile")}try{await this.q.addExtensionsToProfile([[U,m]],this.j,!U.isValid)}catch(E){throw(0,r.$qq)(E,"AddToProfile")}return U}async u({zipPath:F,key:U,metadata:m},E,z){let M=await this.v(U);return M?M=await this.m.updateMetadata(M,m):(this.s.trace("Extracting extension...",U.id),M=await this.m.extractUserExtension(U,F,m,E,z),this.s.info("Extracting extension completed.",U.id)),M}async v(F){return(await this.m.getUninstalledExtensions())[F.toString()]?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(E=>i.$zp.create(E).equals(F))):void 0}}class H extends T{constructor(F,U,m,E,z,M,G,W,te,ae,he){super(F,U.identifier,U,m,z,M,G,W,te,ae),this.x=U,this.y=E,this.z=he}async w(F){const m=(await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(G=>(0,i.$yp)(G.identifier,this.x.identifier));m&&(this.l=3);const E={id:this.x.identifier.uuid,publisherId:this.x.publisherId,publisherDisplayName:this.x.publisherDisplayName,targetPlatform:this.x.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||m?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||m?.isMachineScoped,isBuiltin:this.options.isBuiltin||m?.isBuiltin,isSystem:m?.type===0?!0:void 0,updated:!!m,isPreReleaseVersion:this.x.properties.isPreReleaseVersion,hasPreReleaseVersion:m?.hasPreReleaseVersion||this.x.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??m?.pinned,preRelease:(0,R.$eg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.x.properties.isPreReleaseVersion||m?.preRelease,source:"gallery"};if(m&&m.type!==0&&m.manifest.version===this.x.version)return[await this.m.updateMetadata(m,E),E];const{verificationStatus:z,location:M}=await this.B(E,F);try{return this.k=z,await this.C(M.fsPath),[await this.u({zipPath:M.fsPath,key:i.$zp.create(this.x),metadata:E},!1,F),E]}catch(G){try{await this.y.delete(M)}catch(W){this.s.warn("Error while deleting the downloaded file",M.toString(),(0,A.$0)(W))}throw G}}async B(F,U){try{return await this.y.download(this.x,this.l,!this.options.donotVerifySignature,this.options.context?.[t.$3o])}catch{this.s.info("Failed downloading. Retry again...",this.x.identifier.id);try{const E=await this.B(F,U);return this.z.publicLog2("extensiongallery:download:retry",{extensionId:this.x.identifier.id,succeeded:!0}),E}catch(E){throw this.z.publicLog2("extensiongallery:download:retry",{extensionId:this.x.identifier.id,succeeded:!1}),E}}}async C(F){try{await(0,k.$Eq)(F)}catch(U){throw(0,r.$qq)(U,"Invalid")}}}e.$Kq=H;class Q extends T{constructor(F,U,m,E,z,M,G,W,te,ae){super(F,{id:(0,i.$Dp)(F.publisher,F.name)},U,m,z,M,G,W,te,ae),this.x=U,this.y=E}async h(F){const U=await super.h(F);return this.B(U,F),U}async w(F){const U=new i.$zp(this.identifier,this.manifest.version),E=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,i.$yp)(this.identifier,G.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||E?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||E?.isMachineScoped,isBuiltin:this.options.isBuiltin||E?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??E?.pinned,source:"vsix"};if(E)if(this.l=3,U.equals(new i.$zp(E.identifier,E.manifest.version)))try{await this.m.removeExtension(E,"existing")}catch{throw new Error(p.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&$.gt(E.manifest.version,this.manifest.version)&&await this.m.setUninstalled(E);else{const G=await this.v(U);if(G)try{await this.m.removeExtension(G,"existing")}catch{throw new Error(p.localize(7,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:y.$kc(this.x.fsPath),key:U,metadata:z},!0,F),z]}async B(F,U){try{let[m]=await this.y.getExtensions([{id:F.identifier.id,version:F.manifest.version}],U);if(m||([m]=await this.y.getExtensions([{id:F.identifier.id}],U)),m){const E={id:m.identifier.uuid,publisherDisplayName:m.publisherDisplayName,publisherId:m.publisherId,isPreReleaseVersion:m.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||m.properties.isPreReleaseVersion,preRelease:m.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,E,this.options.profileLocation)}}catch{}}}class Y extends r.$rq{constructor(F,U,m){super(),this.extension=F,this.j=U,this.k=m}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(se[163],re([0,1,6,24,23,22,42,13,18,11]),function(X,e,O,D,I,N,A,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0;let h=class extends A.$uq{constructor(y,w,$,R,d,l){super(a.URI.file(y.extensionsPath),w,$,R,d,l)}};e.$aQ=h,e.$aQ=h=$e([oe(0,u.$Gi),oe(1,P.$5k),oe(2,D.$El),oe(3,I.$Cl),oe(4,N.$4l),oe(5,O.$5j)],h)}),define(se[164],re([0,1,11,18,42,53,13,10,6,32,23,24]),function(X,e,O,D,I,N,A,P,u,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;let y=class extends N.$Bq{constructor($,R,d,l,c,v,p,g){super(O.URI.file(c.builtinExtensionsPath),O.URI.file(c.extensionsPath),c.userHome,$.defaultProfile,$,R,d,l,c,v,p,g)}};e.$8dc=y,e.$8dc=y=$e([oe(0,b.$El),oe(1,I.$tq),oe(2,A.$5k),oe(3,u.$5j),oe(4,D.$Gi),oe(5,a.$lk),oe(6,h.$Cl),oe(7,P.$xi)],y)}),define(se[165],re([0,1,8,5,2,131,3,91,10,24]),function(X,e,O,D,I,N,A,P,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$7p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$5p=e.$4p=e.$3p=void 0,e.$6p=w,e.$8p=R,e.$0p=l,e.$3p="__$__isNewStorageMarker",e.$4p="__$__targetStorageMarker",e.$5p=(0,u.$yi)("storageService");var h;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(h||(e.WillSaveStateReason=h={}));var b;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var y;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function w(c){const v=c.get(e.$4p);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}class $ extends I.$Uc{static{this.a=60*1e3}constructor(v={flushInterval:$.a}){super(),this.m=v,this.b=this.B(new D.$ie),this.c=this.B(new D.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new O.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(v,p,g){return D.Event.filter(this.b.event,n=>n.scope===v&&(p===void 0||n.key===p),g)}n(){this.j.value=(0,O.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(v,p){const{key:g,external:n}=p;if(g===e.$4p){switch(v){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:g,target:this.J(v)[g],external:n})}w(v){this.f.fire({reason:v})}get(v,p,g){return this.P(p)?.get(v,g)}getBoolean(v,p,g){return this.P(p)?.getBoolean(v,g)}getNumber(v,p,g){return this.P(p)?.getNumber(v,g)}getObject(v,p,g){return this.P(p)?.getObject(v,g)}storeAll(v,p){this.y(()=>{for(const g of v)this.store(g.key,g.value,g.scope,g.target,p)})}store(v,p,g,n,r=!1){if((0,A.$hg)(p)){this.remove(v,g,r);return}this.y(()=>{this.z(v,g,n),this.P(g)?.set(v,p,r)})}remove(v,p,g=!1){this.y(()=>{this.z(v,p,void 0),this.P(p)?.delete(v,g)})}y(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,p){const g=[],n=this.J(v);for(const r of Object.keys(n))n[r]===p&&g.push(r);return g}z(v,p,g,n=!1){const r=this.J(p);typeof g=="number"?r[v]!==g&&(r[v]=g,this.P(p)?.set(e.$4p,JSON.stringify(r),n)):typeof r[v]=="number"&&(delete r[v],this.P(p)?.set(e.$4p,JSON.stringify(r),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(v){switch(v){case-1:return this.I;case 0:return this.G;default:return this.D}}L(v){const p=this.P(v);return p?w(p):Object.create(null)}isNew(v){return this.getBoolean(e.$3p,v)===!0}async flush(v=h.NONE){this.f.fire({reason:v});const p=this.P(-1),g=this.P(0),n=this.P(1);switch(v){case h.NONE:await O.Promises.settled([p?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case h.SHUTDOWN:await O.Promises.settled([p?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return l(v,p,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(v){return await this.flush(),this.P(v)?.optimize()}async switch(v,p){return this.w(h.NONE),(0,a.$Dl)(v)?this.R(v,p):this.S(v,p)}M(v,p){return!(v.id===p.id||R(p)&&R(v))}N(v,p,g){this.y(()=>{const n=new Set;for(const[r,t]of v)n.add(r),p.get(r)!==t&&this.u(g,{key:r,external:!0});for(const[r]of p.items)n.has(r)||this.u(g,{key:r,external:!0})})}}e.$7p=$;function R(c){return c.isDefault||!!c.useDefaultFlags?.globalState}class d extends ${constructor(){super(),this.U=this.B(new P.$1p(new P.$2p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$1p(new P.$2p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$1p(new P.$2p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(v=>this.u(1,v))),this.B(this.W.onDidChangeStorage(v=>this.u(0,v))),this.B(this.U.onDidChangeStorage(v=>this.u(-1,v)))}P(v){switch(v){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(v){return!1}}e.$9p=d;async function l(c,v,p,g,n,r){const t=q=>{try{return JSON.parse(q)}catch{return q}},i=new Map,s=new Map;c.forEach((q,C)=>{i.set(C,q),s.set(C,t(q))});const o=new Map,f=new Map;v.forEach((q,C)=>{o.set(C,q),f.set(C,t(q))});const S=new Map,k=new Map;p.forEach((q,C)=>{S.set(C,q),k.set(C,t(q))}),console.group(g!==n?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const j=[];if(i.forEach((q,C)=>{j.push({key:C,value:q})}),console.table(j),console.groupEnd(),console.log(s),g!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const q=[];o.forEach((C,J)=>{q.push({key:J,value:C})}),console.table(q),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${r})`);const L=[];S.forEach((q,C)=>{L.push({key:C,value:q})}),console.table(L),console.groupEnd(),console.log(k)}}),define(se[166],re([0,1,19,20,9,12,35,3,11,29,18,21,26,50,13,6,32,45,149,165,22,178]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$,R,d,l,c,v,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0,e.$aq=Q;const n=N.$o?"web":(0,b.$6o)(N.$u,A.$ec),r="X-Market-Search-Activity-Id";var t;(function(E){E[E.None=0]="None",E[E.IncludeVersions=1]="IncludeVersions",E[E.IncludeFiles=2]="IncludeFiles",E[E.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",E[E.IncludeSharedAccounts=8]="IncludeSharedAccounts",E[E.IncludeVersionProperties=16]="IncludeVersionProperties",E[E.ExcludeNonValidated=32]="ExcludeNonValidated",E[E.IncludeInstallationTargets=64]="IncludeInstallationTargets",E[E.IncludeAssetUri=128]="IncludeAssetUri",E[E.IncludeStatistics=256]="IncludeStatistics",E[E.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",E[E.Unpublished=4096]="Unpublished",E[E.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...E){return String(E.reduce((z,M)=>z|M,0))}var s;(function(E){E[E.Tag=1]="Tag",E[E.ExtensionId=4]="ExtensionId",E[E.Category=5]="Category",E[E.ExtensionName=7]="ExtensionName",E[E.Target=8]="Target",E[E.Featured=9]="Featured",E[E.SearchText=10]="SearchText",E[E.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class j{constructor(z=k){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,M=this.d.pageSize){return new j({...this.d,pageNumber:z,pageSize:M})}withFilter(z,...M){const G=[...this.d.criteria,...M.length?M.map(W=>({filterType:z,value:W})):[{filterType:z}]];return new j({...this.d,criteria:G})}withSortBy(z){return new j({...this.d,sortBy:z})}withSortOrder(z){return new j({...this.d,sortOrder:z})}withFlags(...z){return new j({...this.d,flags:z.reduce((M,G)=>M|G,0)})}withAssetTypes(...z){return new j({...this.d,assetTypes:z})}withSource(z){return new j({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:M,pageSize:G,sortBy:W,sortOrder:te,flags:ae,assetTypes:he}=this.d;return{filters:[{criteria:z,pageNumber:M,pageSize:G,sortBy:W,sortOrder:te}],assetTypes:he,flags:ae}}get searchText(){const z=this.d.criteria.filter(M=>M.filterType===s.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function L(E,z){const M=(E||[]).filter(G=>G.statisticName===z)[0];return M?M.value:0}function q(E){const z="Microsoft.VisualStudio.Code.Translation.";return E.files.filter(G=>G.assetType.indexOf(z)===0).reduce((G,W)=>{const te=ne(E,W.assetType);return te&&G.push([W.assetType.substring(z.length),te]),G},[])}function C(E){if(E.properties){const z=E.properties.filter(W=>W.key===o.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=z.filter(W=>M.test(W.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return ne(E,o.Repository)}function J(E){return{uri:`${E.fallbackAssetUri}/${o.VSIX}?redirect=true${E.targetPlatform?`&targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${o.VSIX}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}}function ne(E,z){return E.files.filter(G=>G.assetType===z)[0]?{uri:`${E.assetUri}/${z}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${z}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}:null}function ie(E,z){const M=E.properties?E.properties.filter(W=>W.key===z):[],G=M.length>0&&M[0].value;return G?G.split(",").map(W=>(0,y.$Cp)(W)):[]}function ue(E){const z=E.properties?E.properties.filter(M=>M.key===f.Engine):[];return z.length>0&&z[0].value||""}function le(E){const z=E.properties?E.properties.filter(M=>M.key===f.PreRelease):[];return z.length>0&&z[0].value==="true"}function ce(E){const z=E.properties?E.properties.filter(G=>G.key===f.LocalizedLanguages):[],M=z.length>0&&z[0].value||"";return M?M.split(","):[]}function V(E){return E.properties?.find(z=>z.key===f.SponsorLink)?.value}function Z(E){return E.properties?.find(z=>z.key===f.SupportLink)?.value}function B(E){return E.indexOf("preview")!==-1}function T(E){return E.targetPlatform?(0,b.$5o)(E.targetPlatform):"undefined"}function H(E){const z=(0,O.$Mb)(E.versions.map(T)),M=!!E.tags?.includes(b.$Yo),G=z.indexOf("web");return M?G===-1&&z.push("web"):G!==-1&&z.splice(G,1),z}function Q(E,z){for(let M=0;M<E.length;M++){const G=E[M];if(G.version===E[M-1]?.version){let W=M;if(T(G)===z)for(;W>0&&E[W-1].version===G.version;)W--;W!==M&&(E.splice(M,1),E.splice(W,0,G))}}return E}function Y(E,z,M){E.telemetryData={index:z,querySource:M,queryActivityId:E.queryContext?.[r]}}function _(E,z,M,G){const W=E.versions[0],te={manifest:ne(z,o.Manifest),readme:ne(z,o.Details),changelog:ne(z,o.Changelog),license:ne(z,o.License),repository:C(z),download:J(z),icon:ne(z,o.Icon),signature:ne(z,o.Signature),coreTranslations:q(z)};return{type:"gallery",identifier:{id:(0,y.$Dp)(E.publisher.publisherName,E.extensionName),uuid:E.extensionId},name:E.extensionName,version:z.version,displayName:E.displayName,publisherId:E.publisher.publisherId,publisher:E.publisher.publisherName,publisherDisplayName:E.publisher.displayName,publisherDomain:E.publisher.domain?{link:E.publisher.domain,verified:!!E.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(W),description:E.shortDescription??"",installCount:L(E.statistics,"install"),rating:L(E.statistics,"averagerating"),ratingCount:L(E.statistics,"ratingcount"),categories:E.categories||[],tags:E.tags||[],releaseDate:Date.parse(E.releaseDate),lastUpdated:Date.parse(E.lastUpdated),allTargetPlatforms:M,assets:te,properties:{dependencies:ie(z,f.Dependency),extensionPack:ie(z,f.ExtensionPack),engine:ue(z),localizedLanguages:ce(z),targetPlatform:T(z),isPreReleaseVersion:le(z)},hasPreReleaseVersion:le(W),hasReleaseVersion:!0,preview:B(E.flags),isSigned:!!te.signature,queryContext:G,supportLink:Z(W)}}let F=class{constructor(z,M,G,W,te,ae,he,pe){this.k=M,this.l=G,this.n=W,this.o=te,this.q=ae,this.u=he,this.w=pe;const ye=he.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,c.$_p)(he.version,he,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,M,G){const W=D.CancellationToken.isCancellationToken(M)?{}:M,te=D.CancellationToken.isCancellationToken(M)?M:G,ae=[],he=[],pe=[],ye=[];let fe=!0;for(const we of z){we.uuid?he.push(we.uuid):ae.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!he.length&&!ae.length)return[];let me=new j().withPage(1,z.length);he.length&&(me=me.withFilter(s.ExtensionId,...he)),ae.length&&(me=me.withFilter(s.ExtensionName,...ae)),(W.queryAllVersions||fe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),W.source&&(me=me.withSource(W.source));const{extensions:de}=await this.z(me,{targetPlatform:W.targetPlatform??n,includePreRelease:pe,versions:ye,compatible:!!W.compatible,productVersion:W.productVersion??{version:this.u.version,date:this.u.date}},te);return W.source&&de.forEach((we,Ee)=>Y(we,Ee,W.source)),de}async getCompatibleExtension(z,M,G,W={version:this.u.version,date:this.u.date}){if((0,b.$7o)(z.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(z,M,G))return z;const te=new j().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,z.identifier.uuid),{extensions:ae}=await this.z(te,{targetPlatform:G,compatible:!0,includePreRelease:M,productVersion:W},D.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(z,M,G,W={version:this.u.version,date:this.u.date}){if(!(0,b.$8o)(z.properties.targetPlatform,z.allTargetPlatforms,G)||!M&&z.properties.isPreReleaseVersion)return!1;let te=z.properties.engine;if(!te){const ae=await this.getManifest(z,D.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");te=ae.engines.vscode}return(0,w.$Qp)(te,W.version,W.date)}async y(z,M,G,W,te,ae,he={version:this.u.version,date:this.u.date}){if(!(0,b.$8o)(T(M),te,ae)||G!=="any"&&le(M)!==(G==="prerelease"))return!1;if(W)try{const pe=await this.E(z,M);if(!(0,w.$Qp)(pe,he.version,he.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,I.$0)(pe)),!1}return!0}async query(z,M){let G=z.text||"";const W=z.pageSize??50;let te=new j().withPage(1,W);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Category,de||me),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Tag,de||me),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),te=te.withFilter(s.SearchText,G)),te=te.withSortBy(0)):z.ids?te=te.withFilter(s.ExtensionId,...z.ids):z.names?te=te.withFilter(s.ExtensionName,...z.names):te=te.withSortBy(4),typeof z.sortBy=="number"&&(te=te.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(te=te.withSortOrder(z.sortOrder)),z.source&&(te=te.withSource(z.source));const ae=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:n,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,Ie)=>Y(Ee,(fe.pageNumber-1)*fe.pageSize+Ie,z.source)),{extensions:de,total:we}},{extensions:he,total:pe}=await ae(te,M),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new I.$5;const{extensions:de}=await ae(te.withPage(fe+1),me);return de};return{firstPage:he,total:pe,pageSize:te.pageSize,getPage:ye}}async z(z,M,G){const W=z.flags;z.flags&t.IncludeLatestVersionOnly&&z.flags&t.IncludeVersions&&(z=z.withFlags(z.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(z.flags&t.IncludeLatestVersionOnly)&&!(z.flags&t.IncludeVersions)&&(z=z.withFlags(z.flags,t.IncludeLatestVersionOnly)),M.versions?.length&&(z=z.withFlags(z.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),z=z.withFlags(z.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:ae,context:he}=await this.B(z,G);if(!(z.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of te){const we=await this.A(de,M,he);we&&me.push(we)}return{extensions:me,total:ae}}const ye=[],fe=new Map;for(let me=0;me<te.length;me++){const de=te[me],we={id:(0,y.$Dp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,P.$eg)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(x=>(0,y.$yp)(x,we))?.includePreRelease;if(M.compatible&&(0,b.$7o)(H(de),M.targetPlatform))continue;const Ie=await this.A(de,M,he);!Ie||Ie.properties.isPreReleaseVersion&&(!Ee||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==M.targetPlatform&&Ie.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,Ie])}if(fe.size){const me=new g.$be,de=new j().withFlags(W&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,M,G);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const Ie=fe.get(Ee.identifier.uuid);ye.push([Ie,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ae}}async A(z,M,G){const W={id:(0,y.$Dp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},te=M.versions?.find(ye=>(0,y.$yp)(ye,W))?.version,ae=(0,P.$eg)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ye=>(0,y.$yp)(ye,W))?.includePreRelease,he=H(z),pe=Q(z.versions,M.targetPlatform);if(M.compatible&&(0,b.$7o)(he,M.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(te&&fe.version!==te)){if(await this.y((0,y.$Dp)(z.publisher.publisherName,z.extensionName),fe,ae?"any":"release",M.compatible,he,M.targetPlatform,M.productVersion))return _(z,fe,he,G);if(te&&fe.version===te)return null}}return te||M.compatible?null:_(z,z.versions[0],he)}async B(z,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(t.Unpublished));const G=await this.j,W=JSON.stringify(z.raw),te={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)},ae=new g.$be;let he,pe,ye=0;try{if(he=await this.k.request({type:"POST",url:this.g&&z.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:W,headers:te},M),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,l.$Xp)(he);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:he.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,I.$4)(fe)?"Cancelled":(0,I.$0)(fe).startsWith("XHR timeout")?"Timeout":"Failed";throw pe=new b.$$o((0,I.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(W.length),duration:ae.elapsed(),success:!!he&&(0,l.$Tp)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(z,M,G,W){if(!this.isEnabled())return;const te=N.$o?this.x(`/itemName/${z}.${M}/version/${G}/statType/${W==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${M}/${G}/stats?statType=${W}`),ae=N.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:te,headers:pe},D.CancellationToken.None)}catch{}}async download(z,M,G){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const W=(0,y.$Gp)(z),te=new Date().getTime(),ae=G===2?"install":G===3?"update":"",he=ae?{uri:`${z.assets.download.uri}${u.URI.parse(z.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${z.assets.download.fallbackUri}${u.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:z.assets.download,pe=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,ye=await this.D(z.identifier.id,he,o.VSIX,pe?{headers:pe}:void 0);try{await this.q.writeFile(M,ye.stream)}catch(fe){try{await this.q.del(M)}catch(me){this.l.warn(`Error while deleting the file ${M.toString()}`,(0,I.$0)(me))}throw new b.$$o((0,I.$0)(fe),"DownloadFailedWriting")}this.o.publicLog("galleryService:downloadVSIX",{...W,duration:new Date().getTime()-te})}async downloadSignatureArchive(z,M){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const G=await this.D(z.identifier.id,z.assets.signature,o.Signature);try{await this.q.writeFile(M,G.stream)}catch(W){try{await this.q.del(M)}catch(te){this.l.warn(`Error while deleting the file ${M.toString()}`,(0,I.$0)(te))}throw new b.$$o((0,I.$0)(W),"DownloadFailedWriting")}}async getReadme(z,M){if(z.assets.readme){const G=await this.D(z.identifier.id,z.assets.readme,o.Details,{},M);return await(0,l.$Wp)(G)||""}return""}async getManifest(z,M){if(z.assets.manifest){const G=await this.D(z.identifier.id,z.assets.manifest,o.Manifest,{},M),W=await(0,l.$Wp)(G);return W?JSON.parse(W):null}return null}async C(z,M,G){const W=ne(M,o.Manifest);if(!W)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},ae=await this.D(z,W,o.Manifest,{headers:te});return await(0,l.$Xp)(ae)}async getCoreTranslation(z,M){const G=z.assets.coreTranslations.filter(W=>W[0]===M.toUpperCase())[0];if(G){const W=await this.D(z.identifier.id,G[1],G[0]),te=await(0,l.$Wp)(W);return te?JSON.parse(te):null}return null}async getChangelog(z,M){if(z.assets.changelog){const G=await this.D(z.identifier.id,z.assets.changelog,o.Changelog,{},M);return await(0,l.$Wp)(G)||""}return""}async getAllCompatibleVersions(z,M,G){let W=new j().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?W=W.withFilter(s.ExtensionId,z.identifier.uuid):W=W.withFilter(s.ExtensionName,z.identifier.id);const{galleryExtensions:te}=await this.B(W,D.CancellationToken.None);if(!te.length)return[];const ae=H(te[0]);if((0,b.$7o)(ae,G))return[];const he=[];await Promise.all(te[0].versions.map(async fe=>{try{await this.y(z.identifier.id,fe,M?"any":"release",!0,ae,G)&&he.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of Q(he,G))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:le(fe)}));return pe}async D(z,M,G,W={},te=D.CancellationToken.None){const ae=await this.j,he={type:"GET"},pe={...ae,...W.headers||{}};W={...W,...he,headers:pe};const ye=M.uri,fe=M.fallbackUri,me={...W,url:ye};try{const de=await this.k.request(me,te);if(de.res.statusCode===200)return de;const we=await(0,l.$Wp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,I.$4)(de))throw de;const we=(0,I.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:G,message:we});const Ee={...W,url:fe};return this.k.request(Ee,te)}}async E(z,M){let G=ue(M);if(!G){this.o.publicLog2("galleryService:engineFallback",{extension:z,version:M.version});const W=await this.C(z,M,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");G=W.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,l.$Xp)(z),G=[],W={},te=[];if(M){for(const ae of M.malicious)G.push({id:ae});if(M.migrateToPreRelease)for(const[ae,he]of Object.entries(M.migrateToPreRelease))(!he.engine||(0,w.$Qp)(he.engine,this.u.version,this.u.date))&&(W[ae.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ae,he]of Object.entries(M.deprecated))he&&(W[ae.toLowerCase()]=(0,P.$eg)(he)?{}:he);if(M.search)for(const ae of M.search)te.push(ae)}return{malicious:G,deprecated:W,search:te}}};F=$e([oe(1,l.$Rp),oe(2,R.$5j),oe(3,h.$Fi),oe(4,p.$4l),oe(5,$.$5k),oe(6,d.$lk),oe(7,a.$5i)],F);let U=class extends F{constructor(z,M,G,W,te,ae,he,pe){super(z,M,G,W,te,ae,he,pe)}};e.$bq=U,e.$bq=U=$e([oe(0,v.$5p),oe(1,l.$Rp),oe(2,R.$5j),oe(3,h.$Fi),oe(4,p.$4l),oe(5,$.$5k),oe(6,d.$lk),oe(7,a.$5i)],U);let m=class extends F{constructor(z,M,G,W,te,ae,he){super(void 0,z,M,G,W,te,ae,he)}};e.$cq=m,e.$cq=m=$e([oe(0,l.$Rp),oe(1,R.$5j),oe(2,h.$Fi),oe(3,p.$4l),oe(4,$.$5k),oe(5,d.$lk),oe(6,a.$5i)],m)}),define(se[167],re([0,1,11,18,13,6,146,23,24,3,69]),function(X,e,O,D,I,N,A,P,u,a,h){"use strict";var b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=e.$0P=void 0;let w=class extends u.$Hl{static{b=this}static{this.a="profileAssociationsMigration"}constructor(l,c,v,p,g){super(v,p,c,g),this.U=l,this.W=v}O(){return this.U.getItem(b.b,[]).map(c=>({...c,location:(0,a.$$f)(c.location)?this.w.extUri.joinPath(this.profilesHome,c.location):O.URI.revive(c.location)}))}Q(){const l=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?l:this.N(l)}S(){return this.w.extUri.joinPath(O.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$0P=w,e.$0P=w=b=$e([oe(0,A.$5P),oe(1,P.$Cl),oe(2,D.$Gi),oe(3,I.$5k),oe(4,N.$5j)],w);let $=y=class extends w{constructor(l,c,v,p,g){super(l,c,v,p,g),this.$=l}P(l){l.length?this.$.setItem(y.b,l.map(c=>({...c,location:this.w.extUri.basename(c.location)}))):this.$.removeItem(y.b)}O(){const l=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(l),this.$.setItem("userDataProfilesMigration",!0)),l}R(l){l.emptyWindows||l.workspaces?this.$.setItem(y.c,l):this.$.removeItem(y.c)}Q(){const l="workspaceAndProfileInfo",c=this.$.getItem(l,void 0);if(c){this.$.removeItem(l);const p=c.reduce((g,{workspace:n,profile:r})=>(g[O.URI.revive(n).toString()]=O.URI.revive(r).toString(),g),{});this.$.setItem(y.c,{workspaces:p})}const v=super.Q();return this.$.getItem(y.a,!1)||(this.R(v),this.$.setItem(y.a,!0)),v}};e.$$P=$,e.$$P=$=y=$e([oe(0,A.$6P),oe(1,P.$Cl),oe(2,D.$Gi),oe(3,I.$5k),oe(4,N.$5j)],$);let R=class extends ${constructor(l,c,v,p){super(new h.$9P(0,c,p,v),l,c,v,p)}async init(){return await this.$.init(),super.init()}};e.$_P=R,e.$_P=R=$e([oe(0,P.$Cl),oe(1,D.$Gi),oe(2,I.$5k),oe(3,N.$5j)],R)}),define(se[168],re([0,1,144,8,14,9,3,29,18,145,6,45,143,179]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0,e.$3r=d;let $=class extends b.$Sp{constructor(c,v,p,g){super(g),this.m=c,this.n=v,this.r=p,this.s(),this.B(c.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.s()}))}s(){const c=this.m.getValue("http");this.f=c?.proxy,this.g=!!c?.proxyStrictSSL,this.h=c?.proxyAuthorization}async request(c,v){const{f:p,g}=this;let n;try{n=await(0,a.$Im)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,N.$0)(i)))}const r={...process.env,...n},t=c.agent?c.agent:await(0,y.$1r)(c.url||"",r,{proxyUrl:p,strictSSL:g});return c.agent=t,c.strictSSL=g,this.h&&(c.headers={...c.headers||{},"Proxy-Authorization":this.h}),this.c(c.isChromiumNetwork?"electron":"node",c,()=>d(c,v))}async resolveProxy(c){}async loadCertificates(){return(await new Promise((v,p)=>{X(["@vscode/proxy-agent"],v,p)})).loadSystemCertificates({log:this.r})}};e.$2r=$,e.$2r=$=$e([oe(0,P.$5i),oe(1,u.$Gi),oe(2,h.$5j),oe(3,h.$6j)],$);async function R(l){return((0,O.parse)(l.url).protocol==="https:"?await new Promise((p,g)=>{X(["https"],p,g)}):await new Promise((p,g)=>{X(["http"],p,g)})).request}async function d(l,c){return D.Promises.withAsyncBody(async(v,p)=>{const g=(0,O.parse)(l.url),n=l.getRawRequest?l.getRawRequest(l):await R(l),r={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,A.$eg)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(r.auth=l.user+":"+l.password);const t=n(r,i=>{const s=(0,A.$cg)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)d({...l,url:i.headers.location,followRedirects:s-1},c).then(v,p);else{let o=i;!l.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,w.createGunzip)())),v({res:i,stream:(0,I.$We)(o)})}});t.on("error",p),l.timeout&&t.setTimeout(l.timeout),l.isChromiumNetwork&&t.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&t.write(l.data),t.end(),c.onCancellationRequested(()=>{t.abort(),p(new N.$5)})})}}),define(se[180],re([0,1,33,8,34,9,2,15,16,12,35,11,25,29,140,61,142,18,117,166,21,71,147,42,53,162,164,13,130,132,51,128,64,65,150,6,136,39,137,153,32,45,168,69,70,22,152,41,154,155,23,157,24,167,156,163,133,135,4,158,181]),function(X,e,O,D,I,N,A,P,u,a,h,b,y,w,$,R,d,l,c,v,p,g,n,r,t,i,s,o,f,S,k,j,L,q,C,J,ne,ie,ue,le,ce,V,Z,B,T,H,Q,Y,_,F,U,m,E,z,M,G,W,te,ae,he,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends A.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const Ie=Ee.get(J.$5j),x=Ee.get(o.$5k),K=Ee.get(l.$Gi),ee=Ee.get(E.$El);Ie.info("CLI main",this.b),this.h(Ie),await this.j(K,x,ee,de),await Promise.all(we.map(ge=>{(0,D.$ph)(ge.flush(),1e3)}))})}async f(){const de=new L.$wi,we={_serviceBrand:void 0,...le.default};de.set(ce.$lk,we);const Ee=new c.$$m(this.b,we);de.set(l.$Gi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:P.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(be=>be?y.Promises.mkdir(be,{recursive:!0}):void 0));const Ie=new te.$4P((0,J.$gk)(Ee),Ee.logsHome);de.set(J.$6j,Ie);const x=this.B(Ie.createLogger("cli",{name:(0,ae.localize)(0,null)})),K=[];Ie.getLogLevel()===J.LogLevel.Trace&&K.push(new J.$ak(Ie.getLogLevel()));const ee=this.B(new W.$bQ(x,K));de.set(J.$5j,ee);const ge=this.B(new f.$Mq(ee));de.set(o.$5k,ge);const ve=this.B(new S.$dr(ee));ge.registerProvider(P.Schemas.file,ve);const Oe=new m.$Es(ge);de.set(U.$Cl,Oe);const Se=new B.$8P(1,Ee,ee,ge),Le=new z.$0P(Se,Oe,Ee,ge,ee);de.set(E.$El,Le),ge.registerProvider(P.Schemas.vscodeUserData,new he.$wec(P.Schemas.file,ve,P.Schemas.vscodeUserData,Le,Oe,ee));const je=a.$i&&we.win32RegValueName?this.B(new ue.$uec(ee,we.win32RegValueName)):Ee.policyFile?this.B(new ne.$vec(Ee.policyFile,ge,ee)):new ie.$jo;de.set(ie.$ho,je);const Ae=this.B(new $.$Jo(Le.defaultProfile.settingsResource,ge,je,ee));de.set(w.$5i,Ae),await Promise.all([Se.init(),Ae.initialize()]);let qe;try{qe=await(0,M.$$dc)(Se,ee)}catch(be){be.code!=="ENOENT"&&ee.error(be)}const De=await(0,M.$_dc)(Se,ee);Le.init(),de.set(U.$Cl,new m.$Es(ge));const Ne=new Z.$2r(Ae,Ee,ee,Ie);de.set(V.$Rp,Ne),de.set(R.$No,new k.$vi(d.$qQ,void 0,!0)),de.set(r.$tq,new k.$vi(G.$aQ,void 0,!0)),de.set(t.$xq,new k.$vi(s.$8dc,void 0,!0)),de.set(g.$dq,new k.$vi(g.$fq,void 0,!0)),de.set(i.$Hq,new k.$vi(i.$Iq,void 0,!0)),de.set(p.$0o,new k.$vi(v.$cq,void 0,!0)),de.set(q.$Vr,new k.$vi(C.$Xr,void 0,!1));const ze=[],Fe=(0,Y.$vp)(we,Ae);if((0,Y.$qp)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&ze.push(new _.$2P(Ne,Fe,"monacoworkbench",null,we.aiConfig.ariaKey));const be={appenders:ze,sendErrorTelemetry:!1,commonProperties:(0,T.$hp)((0,O.release)(),(0,O.hostname)(),process.arch,we.commit,we.version,qe,De,Fe),piiPaths:(0,Y.$wp)(Ee)};de.set(H.$4l,new k.$vi(Q.$4r,[be],!1))}else de.set(H.$4l,Y.$lp);return[new j.$gr(de),ze]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,N.setUnexpectedErrorHandler)(we=>{const Ee=(0,I.$jj)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,N.$Z)(we)||(0,N.$1)(we)}),process.on("unhandledRejection",we=>(0,N.$1)(we))}async j(de,we,Ee,Ie){let x;if(de.args.profile&&(x=Ee.profiles.find(ee=>ee.name===de.args.profile),!x))throw new Error(`Profile '${de.args.profile}' not found.`);const K=(x??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,K);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:K};return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,K);if(this.b["update-extensions"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).updateExtensions(K);if(this.b["locate-extension"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$Uec)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?b.URI.file((0,u.$ic)(we)?we:(0,u.$jc)((0,h.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3028408922e78cc9ca15ee761372a7c0603fa375/core/vs/code/node/cliProcessMain.js.map
