/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/themables","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(he){for(var e=[],l=0,O=he.length;l<O;l++)e[l]=ke[he[l]];return e};define(ke[163],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class l{static get(){const L=new Map,A=new Map,M=new Map,b=new Map;function $(S,v){S.has(v.detail)||S.set(v.detail,-v.timestamp)}function E(S,v){const d=S.get(v.detail);d&&(d>=0||S.set(v.detail,d+v.timestamp))}let I=[];typeof he=="function"&&typeof he.getStats=="function"&&(I=he.getStats().slice(0).sort((S,v)=>S.timestamp-v.timestamp));for(const S of I)switch(S.type){case 10:$(L,S);break;case 11:case 12:E(L,S);break;case 21:$(A,S);break;case 22:E(A,S);break;case 33:$(M,S);break;case 34:E(M,S);break;case 31:$(b,S);break;case 32:E(b,S);break}let P=0;M.forEach(S=>P+=S);function p(S){const v=[];return S.forEach((d,f)=>v.push([f,d])),v}return{amdLoad:p(L),amdInvoke:p(A),nodeRequire:p(M),nodeEval:p(b),nodeRequireTotal:P}}static toMarkdownTable(L,A){let M="";const b=[];return L.forEach(($,E)=>{b[E]=$.length}),A.forEach($=>{$.forEach((E,I)=>{typeof E>"u"&&(E=$[I]="-");const P=E.toString().length;b[I]=Math.max(P,b[I])})}),L.forEach(($,E)=>{M+=`| ${$+" ".repeat(b[E]-$.toString().length)} `}),M+=`|
`,L.forEach(($,E)=>{M+=`| ${"-".repeat(b[E])} `}),M+=`|
`,A.forEach($=>{$.forEach((E,I)=>{typeof E<"u"&&(M+=`| ${E+" ".repeat(b[I]-E.toString().length)} `)}),M+=`|
`}),M}}e.$U=l}),define(ke[164],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=l,e.$gb=O,e.$hb=L,e.$ib=A,e.$jb=M,e.$kb=b,e.$lb=$,e.$nb=I,e.$ob=P,e.$pb=p,e.$qb=S,e.$rb=v;function l(d,f){const a=O(d,f);if(a!==-1)return d[a]}function O(d,f,a=d.length-1){for(let n=a;n>=0;n--){const i=d[n];if(f(i))return n}return-1}function L(d,f){const a=A(d,f);return a===-1?void 0:d[a]}function A(d,f,a=0,n=d.length){let i=a,c=n;for(;i<c;){const r=Math.floor((i+c)/2);f(d[r])?i=r+1:c=r}return i-1}function M(d,f){const a=b(d,f);return a===d.length?void 0:d[a]}function b(d,f,a=0,n=d.length){let i=a,c=n;for(;i<c;){const r=Math.floor((i+c)/2);f(d[r])?c=r:i=r+1}return i}function $(d,f,a=0,n=d.length){const i=b(d,f,a,n);return i===d.length?-1:i}class E{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(E.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!f(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const a=A(this.e,f,this.c);return this.c=a+1,a===-1?void 0:this.e[a]}}e.$mb=E;function I(d,f){if(d.length===0)return;let a=d[0];for(let n=1;n<d.length;n++){const i=d[n];f(i,a)>0&&(a=i)}return a}function P(d,f){if(d.length===0)return;let a=d[0];for(let n=1;n<d.length;n++){const i=d[n];f(i,a)>=0&&(a=i)}return a}function p(d,f){return I(d,(a,n)=>-f(a,n))}function S(d,f){if(d.length===0)return-1;let a=0;for(let n=1;n<d.length;n++){const i=d[n];f(i,d[a])>0&&(a=n)}return a}function v(d,f){for(const a of d){const n=f(a);if(n!==void 0)return n}}}),define(ke[74],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=l,e.$L=O,e.$M=L,e.$N=A;function l(M,b){const $=Object.create(null);for(const E of M){const I=b(E);let P=$[I];P||(P=$[I]=[]),P.push(E)}return $}function O(M,b){const $=[],E=[];for(const I of M)b.has(I)||$.push(I);for(const I of b)M.has(I)||E.push(I);return{removed:$,added:E}}function L(M,b){const $=[],E=[];for(const[I,P]of M)b.has(I)||$.push(P);for(const[I,P]of b)M.has(I)||E.push(P);return{removed:$,added:E}}function A(M,b){const $=new Set;for(const E of b)M.has(E)&&$.add(E);return $}}),define(ke[56],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=O,e.$4h=L,e.$5h=A;function l(M){return(b,$,E)=>{let I=null,P=null;if(typeof E.value=="function"?(I="value",P=E.value):typeof E.get=="function"&&(I="get",P=E.get),!P)throw new Error("not supported");E[I]=M(P,$)}}function O(M,b,$){let E=null,I=null;if(typeof $.value=="function"?(E="value",I=$.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(E="get",I=$.get),!I)throw new Error("not supported");const P=`$memoize$${b}`;$[E]=function(...p){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,p)}),this[P]}}function L(M,b,$){return l((E,I)=>{const P=`$debounce$${I}`,p=`$debounce$result$${I}`;return function(...S){this[p]||(this[p]=$?$():void 0),clearTimeout(this[P]),b&&(this[p]=b(this[p],...S),S=[this[p]]),this[P]=setTimeout(()=>{E.apply(this,S),this[p]=$?$():void 0},M)}})}function A(M,b,$){return l((E,I)=>{const P=`$throttle$timer$${I}`,p=`$throttle$result$${I}`,S=`$throttle$lastRun$${I}`,v=`$throttle$pending$${I}`;return function(...d){if(this[p]||(this[p]=$?$():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...d)),this[v])return;const f=this[S]+M;f<=Date.now()?(this[S]=Date.now(),E.apply(this,[this[p]]),this[p]=$?$():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[S]=Date.now(),E.apply(this,[this[p]]),this[p]=$?$():void 0},f-Date.now()))}})}}),define(ke[13],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=O,e.$Z=L,e.$1=A,e.$2=M,e.$3=b,e.$4=E,e.$6=P,e.$7=p,e.$8=S,e.$0=d;class l{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(u=>{u(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=l,e.$X=new l;function O(r){e.$X.setUnexpectedErrorHandler(r)}function L(r){if(!r||typeof r!="object")return!1;const t=r;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(r){E(r)||e.$X.onUnexpectedError(r)}function M(r){E(r)||e.$X.onUnexpectedExternalError(r)}function b(r){if(r instanceof Error){const{name:t,message:u}=r,s=r.stacktrace||r.stack;return{$isError:!0,name:t,message:u,stack:s,noTelemetry:i.isErrorNoTelemetry(r)}}return r}const $="Canceled";function E(r){return r instanceof I?!0:r instanceof Error&&r.name===$&&r.message===$}class I extends Error{constructor(){super($),this.name=this.message}}e.$5=I;function P(){const r=new Error($);return r.name=r.message,r}function p(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}function S(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function d(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class a extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=a;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const u=new i;return u.message=t.message,u.stack=t.stack,u}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class c extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(ke[19],De([1,0,13,164]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=L,e.$tb=A,e.$ub=M,e.$vb=b,e.$wb=$,e.$xb=E,e.$yb=I,e.$zb=P,e.$Ab=p,e.$Bb=S,e.$Cb=v,e.$Db=d,e.$Eb=f,e.top=a,e.$Gb=n,e.$Hb=c,e.$Ib=r,e.$Jb=t,e.$Kb=u,e.$Lb=s,e.$Mb=o,e.$Nb=h,e.$Ob=g,e.$Pb=w,e.$Qb=k,e.$Rb=m,e.$Sb=y,e.$Tb=D,e.$Ub=C,e.$Vb=R,e.$Wb=T,e.$Xb=j,e.$Yb=z,e.$Zb=N,e.$1b=F,e.$2b=B,e.$3b=Y,e.$4b=re,e.$5b=H,e.$6b=Z,e.$7b=$e,e.$0b=te;function L(ue,ce=0){return ue[ue.length-(1+ce)]}function A(ue){if(ue.length===0)throw new Error("Invalid tail call");return[ue.slice(0,ue.length-1),ue[ue.length-1]]}function M(ue,ce,ae=(le,J)=>le===J){if(ue===ce)return!0;if(!ue||!ce||ue.length!==ce.length)return!1;for(let le=0,J=ue.length;le<J;le++)if(!ae(ue[le],ce[le]))return!1;return!0}function b(ue,ce){const ae=ue.length-1;ce<ae&&(ue[ce]=ue[ae]),ue.pop()}function $(ue,ce,ae){return E(ue.length,le=>ae(ue[le],ce))}function E(ue,ce){let ae=0,le=ue-1;for(;ae<=le;){const J=(ae+le)/2|0,se=ce(J);if(se<0)ae=J+1;else if(se>0)le=J-1;else return J}return-(ae+1)}function I(ue,ce,ae){if(ue=ue|0,ue>=ce.length)throw new TypeError("invalid index");const le=ce[Math.floor(ce.length*Math.random())],J=[],se=[],pe=[];for(const ve of ce){const Re=ae(ve,le);Re<0?J.push(ve):Re>0?se.push(ve):pe.push(ve)}return ue<J.length?I(ue,J,ae):ue<J.length+pe.length?pe[0]:I(ue-(J.length+pe.length),se,ae)}function P(ue,ce){const ae=[];let le;for(const J of ue.slice(0).sort(ce))!le||ce(le[0],J)!==0?(le=[J],ae.push(le)):le.push(J);return ae}function*p(ue,ce){let ae,le;for(const J of ue)le!==void 0&&ce(le,J)?ae.push(J):(ae&&(yield ae),ae=[J]),le=J;ae&&(yield ae)}function S(ue,ce){for(let ae=0;ae<=ue.length;ae++)ce(ae===0?void 0:ue[ae-1],ae===ue.length?void 0:ue[ae])}function v(ue,ce){for(let ae=0;ae<ue.length;ae++)ce(ae===0?void 0:ue[ae-1],ue[ae],ae+1===ue.length?void 0:ue[ae+1])}function d(ue,ce,ae){const le=[];function J(ve,Re,me){if(Re===0&&me.length===0)return;const Ie=le[le.length-1];Ie&&Ie.start+Ie.deleteCount===ve?(Ie.deleteCount+=Re,Ie.toInsert.push(...me)):le.push({start:ve,deleteCount:Re,toInsert:me})}let se=0,pe=0;for(;;){if(se===ue.length){J(se,0,ce.slice(pe));break}if(pe===ce.length){J(se,ue.length-se,[]);break}const ve=ue[se],Re=ce[pe],me=ae(ve,Re);me===0?(se+=1,pe+=1):me<0?(J(se,1,[]),se+=1):me>0&&(J(se,0,[Re]),pe+=1)}return le}function f(ue,ce,ae){const le=d(ue,ce,ae),J=[],se=[];for(const pe of le)J.push(...ue.slice(pe.start,pe.start+pe.deleteCount)),se.push(...pe.toInsert);return{removed:J,added:se}}function a(ue,ce,ae){if(ae===0)return[];const le=ue.slice(0,ae).sort(ce);return i(ue,ce,le,ae,ue.length),le}function n(ue,ce,ae,le,J){return ae===0?Promise.resolve([]):new Promise((se,pe)=>{(async()=>{const ve=ue.length,Re=ue.slice(0,ae).sort(ce);for(let me=ae,Ie=Math.min(ae+le,ve);me<ve;me=Ie,Ie=Math.min(Ie+le,ve)){if(me>ae&&await new Promise(Ae=>setTimeout(Ae)),J&&J.isCancellationRequested)throw new l.$5;i(ue,ce,Re,me,Ie)}return Re})().then(se,pe)})}function i(ue,ce,ae,le,J){for(const se=ae.length;le<J;le++){const pe=ue[le];if(ce(pe,ae[se-1])<0){ae.pop();const ve=(0,O.$kb)(ae,Re=>ce(pe,Re)<0);ae.splice(ve,0,pe)}}}function c(ue){return ue.filter(ce=>!!ce)}function r(ue){let ce=0;for(let ae=0;ae<ue.length;ae++)ue[ae]&&(ue[ce]=ue[ae],ce+=1);ue.length=ce}function t(ue,ce,ae){ue.splice(ae,0,ue.splice(ce,1)[0])}function u(ue){return!Array.isArray(ue)||ue.length===0}function s(ue){return Array.isArray(ue)&&ue.length>0}function o(ue,ce=ae=>ae){const ae=new Set;return ue.filter(le=>{const J=ce(le);return ae.has(J)?!1:(ae.add(J),!0)})}function h(ue){const ce=new Set;return ae=>{const le=ue(ae);return ce.has(le)?!1:(ce.add(le),!0)}}function g(ue,ce){return ue.length>0?ue[0]:ce}function w(ue,ce){return ue.length>0?ue[ue.length-1]:ce}function k(ue,ce,ae=(le,J)=>le===J){let le=0;for(let J=0,se=Math.min(ue.length,ce.length);J<se&&ae(ue[J],ce[J]);J++)le++;return le}function m(ue,ce){let ae=typeof ce=="number"?ue:0;typeof ce=="number"?ae=ue:(ae=0,ce=ue);const le=[];if(ae<=ce)for(let J=ae;J<ce;J++)le.push(J);else for(let J=ae;J>ce;J--)le.push(J);return le}function y(ue,ce,ae){return ue.reduce((le,J)=>(le[ce(J)]=ae?ae(J):J,le),Object.create(null))}function D(ue,ce){return ue.push(ce),()=>C(ue,ce)}function C(ue,ce){const ae=ue.indexOf(ce);if(ae>-1)return ue.splice(ae,1),ce}function R(ue,ce,ae){const le=ue.slice(0,ce),J=ue.slice(ce);return le.concat(ae,J)}function T(ue,ce){let ae;if(typeof ce=="number"){let le=ce;ae=()=>{const J=Math.sin(le++)*179426549;return J-Math.floor(J)}}else ae=Math.random;for(let le=ue.length-1;le>0;le-=1){const J=Math.floor(ae()*(le+1)),se=ue[le];ue[le]=ue[J],ue[J]=se}}function j(ue,ce){const ae=ue.indexOf(ce);ae>-1&&(ue.splice(ae,1),ue.unshift(ce))}function z(ue,ce){const ae=ue.indexOf(ce);ae>-1&&(ue.splice(ae,1),ue.push(ce))}function N(ue,ce){for(const ae of ce)ue.push(ae)}function F(ue,ce){return Array.isArray(ue)?ue.map(ce):ce(ue)}function B(ue){return Array.isArray(ue)?ue:[ue]}function Y(ue){return ue[Math.floor(Math.random()*ue.length)]}function re(ue,ce,ae){const le=K(ue,ce),J=ue.length,se=ae.length;ue.length=J+se;for(let pe=J-1;pe>=le;pe--)ue[pe+se]=ue[pe];for(let pe=0;pe<se;pe++)ue[pe+le]=ae[pe]}function H(ue,ce,ae,le){const J=K(ue,ce);let se=ue.splice(J,ae);return se===void 0&&(se=[]),re(ue,J,le),se}function K(ue,ce){return ce<0?Math.max(ce+ue.length,0):Math.min(ce,ue.length)}var _;(function(ue){function ce(se){return se<0}ue.isLessThan=ce;function ae(se){return se<=0}ue.isLessThanOrEqual=ae;function le(se){return se>0}ue.isGreaterThan=le;function J(se){return se===0}ue.isNeitherLessOrGreaterThan=J,ue.greaterThan=1,ue.lessThan=-1,ue.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function Z(ue,ce){return(ae,le)=>ce(ue(ae),ue(le))}function $e(...ue){return(ce,ae)=>{for(const le of ue){const J=le(ce,ae);if(!_.isNeitherLessOrGreaterThan(J))return J}return _.neitherLessOrGreaterThan}}const oe=(ue,ce)=>ue-ce;e.$8b=oe;const Pe=(ue,ce)=>(0,e.$8b)(ue?1:0,ce?1:0);e.$9b=Pe;function te(ue){return(ce,ae)=>-ue(ce,ae)}class U{constructor(ce){this.g=ce,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ce){let ae=this.c;for(;ae<this.g.length&&ce(this.g[ae]);)ae++;const le=ae===this.c?null:this.g.slice(this.c,ae);return this.c=ae,le}takeFromEndWhile(ce){let ae=this.d;for(;ae>=0&&ce(this.g[ae]);)ae--;const le=ae===this.d?null:this.g.slice(ae+1,this.d+1);return this.d=ae,le}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ce=this.g[this.c];return this.c++,ce}removeLast(){const ce=this.g[this.d];return this.d--,ce}takeCount(ce){const ae=this.g.slice(this.c,this.c+ce);return this.c+=ce,ae}}e.$$b=U;class ee{static{this.empty=new ee(ce=>{})}constructor(ce){this.iterate=ce}forEach(ce){this.iterate(ae=>(ce(ae),!0))}toArray(){const ce=[];return this.iterate(ae=>(ce.push(ae),!0)),ce}filter(ce){return new ee(ae=>this.iterate(le=>ce(le)?ae(le):!0))}map(ce){return new ee(ae=>this.iterate(le=>ae(ce(le))))}some(ce){let ae=!1;return this.iterate(le=>(ae=ce(le),!ae)),ae}findFirst(ce){let ae;return this.iterate(le=>ce(le)?(ae=le,!1):!0),ae}findLast(ce){let ae;return this.iterate(le=>(ce(le)&&(ae=le),!0)),ae}findLastMaxBy(ce){let ae,le=!0;return this.iterate(J=>((le||_.isGreaterThan(ce(J,ae)))&&(le=!1,ae=J),!0)),ae}}e.$_b=ee;class be{constructor(ce){this.c=ce}static createSortPermutation(ce,ae){const le=Array.from(ce.keys()).sort((J,se)=>ae(ce[J],ce[se]));return new be(le)}apply(ce){return ce.map((ae,le)=>ce[this.c[le]])}inverse(){const ce=this.c.slice();for(let ae=0;ae<this.c.length;ae++)ce[this.c[ae]]=ae;return new be(ce)}}e.$ac=be}),define(ke[62],De([1,0,13]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=O,e.$ed=L,e.$fd=A,e.$gd=M,e.$hd=b,e.$id=$;function O(E,I){if(!E)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function L(E,I="Unreachable"){throw new Error(I)}function A(E,I="unexpected state"){if(!E)throw new l.$cb(`Assertion Failed: ${I}`)}function M(E){E||(0,l.$1)(new l.$cb("Soft Assertion Failed"))}function b(E){if(!E()){debugger;E(),(0,l.$1)(new l.$cb("Assertion Failed"))}}function $(E,I){let P=0;for(;P<E.length-1;){const p=E[P],S=E[P+1];if(!I(p,S))return!1;P++}return!0}}),define(ke[165],De([1,0,19]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=L,e.$8c=A,e.$9c=M,e.$0c=b,e.$$c=$,e.$_c=E;const O=(S,v)=>S===v;e.$6c=O;function L(S=e.$6c){return(v,d)=>l.$ub(v,d,S)}function A(){return(S,v)=>JSON.stringify(S)===JSON.stringify(v)}function M(){return(S,v)=>S.equals(v)}function b(S,v,d){return!S||!v?S===v:d(S,v)}function $(S,v){if(S===v)return!0;if(Array.isArray(S)&&Array.isArray(v)){if(S.length!==v.length)return!1;for(let d=0;d<S.length;d++)if(!$(S[d],v[d]))return!1;return!0}if(S&&typeof S=="object"&&v&&typeof v=="object"&&Object.getPrototypeOf(S)===Object.prototype&&Object.getPrototypeOf(v)===Object.prototype){const d=S,f=v,a=Object.keys(d),n=Object.keys(f),i=new Set(n);if(a.length!==n.length)return!1;for(const c of a)if(!i.has(c)||!$(d[c],f[c]))return!1;return!0}return!1}function E(S){return JSON.stringify(p(S))}let I=0;const P=new WeakMap;function p(S){if(Array.isArray(S))return S.map(p);if(S&&typeof S=="object")if(Object.getPrototypeOf(S)===Object.prototype){const v=S,d=Object.create(null);for(const f of Object.keys(v).sort())d[f]=p(v[f]);return d}else{let v=P.get(S);return v===void 0&&(v=I++,P.set(S,v)),v+"----2b76a038c20c4bcc"}return S}}),define(ke[75],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=l;function l(O,L){const A=this;let M=!1,b;return function(){if(M)return b;if(M=!0,L)try{b=O.apply(A,arguments)}finally{L()}else b=O.apply(A,arguments);return b}}}),define(ke[125],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TO=e.$SO=void 0;class l{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$SO=l,e.$TO=new l("id#")}),define(ke[39],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(O){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=L;const A=Object.freeze([]);function M(){return A}O.empty=M;function*b(t){yield t}O.single=b;function $(t){return L(t)?t:b(t)}O.wrap=$;function E(t){return t||A}O.from=E;function*I(t){for(let u=t.length-1;u>=0;u--)yield t[u]}O.reverse=I;function P(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=P;function p(t){return t[Symbol.iterator]().next().value}O.first=p;function S(t,u){for(const s of t)if(u(s))return!0;return!1}O.some=S;function v(t,u){for(const s of t)if(u(s))return s}O.find=v;function*d(t,u){for(const s of t)u(s)&&(yield s)}O.filter=d;function*f(t,u){let s=0;for(const o of t)yield u(o,s++)}O.map=f;function*a(...t){for(const u of t)yield*u}O.concat=a;function n(t,u,s){let o=s;for(const h of t)o=u(o,h);return o}O.reduce=n;function*i(t,u,s=t.length){for(u<0&&(u+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);u<s;u++)yield t[u]}O.slice=i;function c(t,u=Number.POSITIVE_INFINITY){const s=[];if(u===0)return[s,t];const o=t[Symbol.iterator]();for(let h=0;h<u;h++){const g=o.next();if(g.done)return[s,O.empty()];s.push(g.value)}return[s,{[Symbol.iterator](){return o}}]}O.consume=c;async function r(t){const u=[];for await(const s of t)u.push(s);return Promise.resolve(u)}O.asyncToArray=r})(l||(e.Iterable=l={}))}),define(ke[166],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=M,e.$Kn=P,e.$Ln=p,e.$Mn=S,e.$Nn=v,e.$On=d,e.$Pn=f,e.$Qn=a,e.$Rn=n,e.$Sn=i,e.$Tn=c,e.$Un=r;var l;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(l||(e.ScanError=l={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function M(t,u=!1){let s=0;const o=t.length;let h="",g=0,w=16,k=0;function m(z){let N=0,F=0;for(;N<z;){const B=t.charCodeAt(s);if(B>=48&&B<=57)F=F*16+B-48;else if(B>=65&&B<=70)F=F*16+B-65+10;else if(B>=97&&B<=102)F=F*16+B-97+10;else break;s++,N++}return N<z&&(F=-1),F}function y(z){s=z,h="",g=0,w=16,k=0}function D(){const z=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&E(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&E(t.charCodeAt(s)))for(s++;s<t.length&&E(t.charCodeAt(s));)s++;else return k=3,t.substring(z,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&E(t.charCodeAt(s))){for(s++;s<t.length&&E(t.charCodeAt(s));)s++;N=s}else k=3;return t.substring(z,N)}function C(){let z="",N=s;for(;;){if(s>=o){z+=t.substring(N,s),k=2;break}const F=t.charCodeAt(s);if(F===34){z+=t.substring(N,s),s++;break}if(F===92){if(z+=t.substring(N,s),s++,s>=o){k=2;break}switch(t.charCodeAt(s++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const Y=m(4);Y>=0?z+=String.fromCharCode(Y):k=4;break}default:k=5}N=s;continue}if(F>=0&&F<=31)if($(F)){z+=t.substring(N,s),k=2;break}else k=6;s++}return z}function R(){if(h="",k=0,g=s,s>=o)return g=o,w=17;let z=t.charCodeAt(s);if(b(z)){do s++,h+=String.fromCharCode(z),z=t.charCodeAt(s);while(b(z));return w=15}if($(z))return s++,h+=String.fromCharCode(z),z===13&&t.charCodeAt(s)===10&&(s++,h+=`
`),w=14;switch(z){case 123:return s++,w=1;case 125:return s++,w=2;case 91:return s++,w=3;case 93:return s++,w=4;case 58:return s++,w=6;case 44:return s++,w=5;case 34:return s++,h=C(),w=10;case 47:{const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<o&&!$(t.charCodeAt(s));)s++;return h=t.substring(N,s),w=12}if(t.charCodeAt(s+1)===42){s+=2;const F=o-1;let B=!1;for(;s<F;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,B=!0;break}s++}return B||(s++,k=1),h=t.substring(N,s),w=13}return h+=String.fromCharCode(z),s++,w=16}case 45:if(h+=String.fromCharCode(z),s++,s===o||!E(t.charCodeAt(s)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=D(),w=11;default:for(;s<o&&T(z);)s++,z=t.charCodeAt(s);if(g!==s){switch(h=t.substring(g,s),h){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return h+=String.fromCharCode(z),s++,w=16}}function T(z){if(b(z)||$(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let z;do z=R();while(z>=12&&z<=15);return z}return{setPosition:y,getPosition:()=>s,scan:u?j:R,getToken:()=>w,getTokenValue:()=>h,getTokenOffset:()=>g,getTokenLength:()=>s-g,getTokenError:()=>k}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function P(t,u){const s=[],o=new Object;let h;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function k(m,y,D,C){g.value=m,g.offset=y,g.length=D,g.type=C,g.colonOffset=void 0,h=g}try{i(t,{onObjectBegin:(m,y)=>{if(u<=m)throw o;h=void 0,w=u>m,s.push("")},onObjectProperty:(m,y,D)=>{if(u<y||(k(m,y,D,"property"),s[s.length-1]=m,u<=y+D))throw o},onObjectEnd:(m,y)=>{if(u<=m)throw o;h=void 0,s.pop()},onArrayBegin:(m,y)=>{if(u<=m)throw o;h=void 0,s.push(0)},onArrayEnd:(m,y)=>{if(u<=m)throw o;h=void 0,s.pop()},onLiteralValue:(m,y,D)=>{if(u<y||(k(m,y,D,r(m)),u<=y+D))throw o},onSeparator:(m,y,D)=>{if(u<=y)throw o;if(m===":"&&h&&h.type==="property")h.colonOffset=y,w=!1,h=void 0;else if(m===","){const C=s[s.length-1];typeof C=="number"?s[s.length-1]=C+1:(w=!0,s[s.length-1]=""),h=void 0}}})}catch(m){if(m!==o)throw m}return{path:s,previousNode:h,isAtPropertyKey:w,matches:m=>{let y=0;for(let D=0;y<m.length&&D<s.length;D++)if(m[y]===s[D]||m[y]==="*")y++;else if(m[y]!=="**")return!1;return y===m.length}}}function p(t,u=[],s=A.DEFAULT){let o=null,h=[];const g=[];function w(m){Array.isArray(h)?h.push(m):o!==null&&(h[o]=m)}return i(t,{onObjectBegin:()=>{const m={};w(m),g.push(h),h=m,o=null},onObjectProperty:m=>{o=m},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{const m=[];w(m),g.push(h),h=m,o=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:w,onError:(m,y,D)=>{u.push({error:m,offset:y,length:D})}},s),h[0]}function S(t,u=[],s=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(m){o.type==="property"&&(o.length=m-o.offset,o=o.parent)}function g(m){return o.children.push(m),m}i(t,{onObjectBegin:m=>{o=g({type:"object",offset:m,length:-1,parent:o,children:[]})},onObjectProperty:(m,y,D)=>{o=g({type:"property",offset:y,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:m,offset:y,length:D,parent:o})},onObjectEnd:(m,y)=>{o.length=m+y-o.offset,o=o.parent,h(m+y)},onArrayBegin:(m,y)=>{o=g({type:"array",offset:m,length:-1,parent:o,children:[]})},onArrayEnd:(m,y)=>{o.length=m+y-o.offset,o=o.parent,h(m+y)},onLiteralValue:(m,y,D)=>{g({type:r(m),offset:y,length:D,parent:o,value:m}),h(y+D)},onSeparator:(m,y,D)=>{o.type==="property"&&(m===":"?o.colonOffset=y:m===","&&h(y))},onError:(m,y,D)=>{u.push({error:m,offset:y,length:D})}},s);const k=o.children[0];return k&&delete k.parent,k}function v(t,u){if(!t)return;let s=t;for(const o of u)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let h=!1;for(const g of s.children)if(Array.isArray(g.children)&&g.children[0].value===o){s=g.children[1],h=!0;break}if(!h)return}else{const h=o;if(s.type!=="array"||h<0||!Array.isArray(s.children)||h>=s.children.length)return;s=s.children[h]}return s}function d(t){if(!t.parent||!t.parent.children)return[];const u=d(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;u.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&u.push(s)}return u}function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const u=Object.create(null);for(const s of t.children){const o=s.children[1];o&&(u[s.children[0].value]=f(o))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,u,s=!1){return u>=t.offset&&u<t.offset+t.length||s&&u===t.offset+t.length}function n(t,u,s=!1){if(a(t,u,s)){const o=t.children;if(Array.isArray(o))for(let h=0;h<o.length&&o[h].offset<=u;h++){const g=n(o[h],u,s);if(g)return g}return t}}function i(t,u,s=A.DEFAULT){const o=M(t,!1);function h($e){return $e?()=>$e(o.getTokenOffset(),o.getTokenLength()):()=>!0}function g($e){return $e?oe=>$e(oe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const w=h(u.onObjectBegin),k=g(u.onObjectProperty),m=h(u.onObjectEnd),y=h(u.onArrayBegin),D=h(u.onArrayEnd),C=g(u.onLiteralValue),R=g(u.onSeparator),T=h(u.onComment),j=g(u.onError),z=s&&s.disallowComments,N=s&&s.allowTrailingComma;function F(){for(;;){const $e=o.scan();switch(o.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:z||B(11);break;case 2:B(12);break;case 6:B(16);break}switch($e){case 12:case 13:z?B(10):T();break;case 16:B(1);break;case 15:case 14:break;default:return $e}}}function B($e,oe=[],Pe=[]){if(j($e),oe.length+Pe.length>0){let te=o.getToken();for(;te!==17;){if(oe.indexOf(te)!==-1){F();break}else if(Pe.indexOf(te)!==-1)break;te=F()}}}function Y($e){const oe=o.getTokenValue();return $e?C(oe):k(oe),F(),!0}function re(){switch(o.getToken()){case 11:{let $e=0;try{$e=JSON.parse(o.getTokenValue()),typeof $e!="number"&&(B(2),$e=0)}catch{B(2)}C($e);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return F(),!0}function H(){return o.getToken()!==10?(B(3,[],[2,5]),!1):(Y(!1),o.getToken()===6?(R(":"),F(),Z()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function K(){w(),F();let $e=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if($e||B(4,[],[]),R(","),F(),o.getToken()===2&&N)break}else $e&&B(6,[],[]);H()||B(4,[],[2,5]),$e=!0}return m(),o.getToken()!==2?B(7,[2],[]):F(),!0}function _(){y(),F();let $e=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if($e||B(4,[],[]),R(","),F(),o.getToken()===4&&N)break}else $e&&B(6,[],[]);Z()||B(4,[],[4,5]),$e=!0}return D(),o.getToken()!==4?B(8,[4],[]):F(),!0}function Z(){switch(o.getToken()){case 3:return _();case 1:return K();case 10:return Y(!0);default:return re()}}return F(),o.getToken()===17?s.allowEmptyContent?!0:(B(4,[],[]),!1):Z()?(o.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function c(t,u){const s=M(t),o=[];let h,g=0,w;do switch(w=s.getPosition(),h=s.scan(),h){case 12:case 13:case 17:g!==w&&o.push(t.substring(g,w)),u!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,u)),g=s.getPosition();break}while(h!==17);return o.join("")}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class l{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=l}),define(ke[76],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class l{static{this.Undefined=new l(void 0)}constructor(A){this.element=A,this.next=l.Undefined,this.prev=l.Undefined}}class O{constructor(){this.a=l.Undefined,this.b=l.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===l.Undefined}clear(){let A=this.a;for(;A!==l.Undefined;){const M=A.next;A.prev=l.Undefined,A.next=l.Undefined,A=M}this.a=l.Undefined,this.b=l.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,M){const b=new l(A);if(this.a===l.Undefined)this.a=b,this.b=b;else if(M){const E=this.b;this.b=b,b.prev=E,E.next=b}else{const E=this.a;this.a=b,b.next=E,E.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==l.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==l.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==l.Undefined&&A.next!==l.Undefined){const M=A.prev;M.next=A.next,A.next.prev=M}else A.prev===l.Undefined&&A.next===l.Undefined?(this.a=l.Undefined,this.b=l.Undefined):A.next===l.Undefined?(this.b=this.b.prev,this.b.next=l.Undefined):A.prev===l.Undefined&&(this.a=this.a.next,this.a.prev=l.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==l.Undefined;)yield A.element,A=A.next}}e.$5c=O}),define(ke[27],De([1,0]),function(he,e){"use strict";var l,O,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=A,e.$yc=M,e.$zc=b,e.$Ic=c;function A(r,t,u){let s=r.get(t);return s===void 0&&(s=u,r.set(t,s)),s}function M(r){const t=[];return r.forEach((u,s)=>{t.push(`${s} => ${u}`)}),`Map(${r.size}) {${t.join(", ")}}`}function b(r){const t=[];return r.forEach(u=>{t.push(u)}),`Set(${r.size}) {${t.join(", ")}}`}class ${constructor(t,u){this.uri=t,this.value=u}}function E(r){return Array.isArray(r)}class I{static{this.c=t=>t.toString()}constructor(t,u){if(this[l]="ResourceMap",t instanceof I)this.d=new Map(t.d),this.e=u??I.c;else if(E(t)){this.d=new Map,this.e=u??I.c;for(const[s,o]of t)this.set(s,o)}else this.d=new Map,this.e=t??I.c}set(t,u){return this.d.set(this.e(t),new $(t,u)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,u){typeof u<"u"&&(t=t.bind(u));for(const[s,o]of this.d)t(o.value,o.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(l=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=I;class P{constructor(t,u){this[O]="ResourceSet",!t||typeof t=="function"?this.c=new I(t):(this.c=new I(u),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,u){this.c.forEach((s,o)=>t.call(u,o,o,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=P;var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class S{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,u=0){const s=this.c.get(t);if(s)return u!==0&&this.m(s,u),s.value}set(t,u,s=0){let o=this.c.get(t);if(o)o.value=u,s!==0&&this.m(o,s);else{switch(o={key:t,value:u,next:void 0,previous:void 0},s){case 0:this.k(o);break;case 1:this.j(o);break;case 2:this.k(o);break;default:this.k(o);break}this.c.set(t,o),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const u=this.c.get(t);if(u)return this.c.delete(t),this.l(u),this.f--,u.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,u){const s=this.g;let o=this.d;for(;o;){if(u?t.bind(u)(o.value,o.key,this):t(o.value,o.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const t=this,u=this.g;let s=this.d;const o={[Symbol.iterator](){return o},next(){if(t.g!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.key,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return o}values(){const t=this,u=this.g;let s=this.d;const o={[Symbol.iterator](){return o},next(){if(t.g!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.value,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return o}entries(){const t=this,u=this.g;let s=this.d;const o={[Symbol.iterator](){return o},next(){if(t.g!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:[s.key,s.value],done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return o}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this.d,s=this.size;for(;u&&s>t;)this.c.delete(u.key),u=u.next,s--;this.d=u,this.f=s,u&&(u.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this.e,s=this.size;for(;u&&s>t;)this.c.delete(u.key),u=u.previous,s--;this.e=u,this.f=s,u&&(u.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const u=t.next,s=t.previous;if(!u||!s)throw new Error("Invalid list");u.previous=s,s.next=u}t.next=void 0,t.previous=void 0,this.g++}m(t,u){if(!this.d||!this.e)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(t===this.d)return;const s=t.next,o=t.previous;t===this.e?(o.next=void 0,this.e=o):(s.previous=o,o.next=s),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(u===2){if(t===this.e)return;const s=t.next,o=t.previous;t===this.d?(s.previous=void 0,this.d=s):(s.previous=o,o.next=s),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((u,s)=>{t.push([s,u])}),t}fromJSON(t){this.clear();for(const[u,s]of t)this.set(u,s)}}e.$Cc=S;class v extends S{constructor(t,u=1){super(),this.n=t,this.o=Math.min(Math.max(0,u),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,u=2){return super.get(t,u)}peek(t){return super.get(t,0)}set(t,u){return super.set(t,u,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class d extends v{constructor(t,u=1){super(t,u)}q(t){this.h(t)}set(t,u){return super.set(t,u),this.p(),this}}e.$Dc=d;class f extends v{constructor(t,u=1){super(t,u)}q(t){this.i(t)}set(t,u){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,u),this}}e.$Ec=f;class a{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let u=this.c.get(t)||0;return u===0?!1:(u--,u===0?this.c.delete(t):this.c.set(t,u),!0)}has(t){return this.c.has(t)}}e.$Fc=a;class n{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[u,s]of t)this.set(u,s)}clear(){this.c.clear(),this.d.clear()}set(t,u){this.c.set(t,u),this.d.set(u,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const u=this.c.get(t);return u===void 0?!1:(this.c.delete(t),this.d.delete(u),!0)}forEach(t,u){this.c.forEach((s,o)=>{t.call(u,s,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=n;class i{constructor(){this.c=new Map}add(t,u){let s=this.c.get(t);s||(s=new Set,this.c.set(t,s)),s.add(u)}delete(t,u){const s=this.c.get(t);s&&(s.delete(u),s.size===0&&this.c.delete(t))}forEach(t,u){const s=this.c.get(t);s&&s.forEach(u)}get(t){const u=this.c.get(t);return u||new Set}}e.$Hc=i;function c(r,t){if(r===t)return!0;if(r.size!==t.size)return!1;for(const[u,s]of r)if(!t.has(u)||t.get(u)!==s)return!1;for(const[u]of t)if(!r.has(u))return!1;return!0}}),define(ke[3],De([1,0,19,74,27,75,39]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=I,e.$Lc=P,e.$Mc=p,e.$Nc=d,e.$Oc=f,e.$Pc=a,e.$Qc=n,e.$Rc=i,e.$Sc=c,e.$3c=m;const b=!1;let $=null;class E{constructor(){this.b=new Map}static{this.a=0}c(C){let R=this.b.get(C);return R||(R={parent:null,source:null,isSingleton:!1,value:C,idx:E.a++},this.b.set(C,R)),R}trackDisposable(C){const R=this.c(C);R.source||(R.source=new Error().stack)}setParent(C,R){const T=this.c(C);T.parent=R}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,R){const T=R.get(C);if(T)return T;const j=C.parent?this.f(this.c(C.parent),R):C;return R.set(C,j),j}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,C).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(C=10,R){let T;if(R)T=R;else{const B=new Map,Y=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,B).isSingleton);if(Y.length===0)return;const re=new Set(Y.map(H=>H.value));if(T=Y.filter(H=>!(H.parent&&re.has(H.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function j(B){function Y(H,K){for(;H.length>0&&K.some(_=>typeof _=="string"?_===H[0]:H[0].match(_));)H.shift()}const re=B.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return Y(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const z=new L.$Hc;for(const B of T){const Y=j(B);for(let re=0;re<=Y.length;re++)z.add(Y.slice(0,re).join(`
`),B)}T.sort((0,l.$6b)(B=>B.idx,l.$8b));let N="",F=0;for(const B of T.slice(0,C)){F++;const Y=j(B),re=[];for(let H=0;H<Y.length;H++){let K=Y[H];K=`(shared with ${z.get(Y.slice(0,H+1).join(`
`)).size}/${T.length} leaks) at ${K}`;const Z=z.get(Y.slice(0,H).join(`
`)),$e=(0,O.$K)([...Z].map(oe=>j(oe)[H]),oe=>oe);delete $e[Y[H]];for(const[oe,Pe]of Object.entries($e))re.unshift(`    - stacktraces of ${Pe.length} other leaks continue with ${oe}`);re.unshift(K)}N+=`


==================== Leaking disposable ${F}/${T.length}: ${B.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return T.length>C&&(N+=`


... and ${T.length-C} more leaking disposables

`),{leaks:T,details:N}}}e.$Jc=E;function I(D){$=D}if(b){const D="__is_disposable_tracked__";I(new class{trackDisposable(C){const R=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[D]||console.log(R)},3e3)}setParent(C,R){if(C&&C!==t.None)try{C[D]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[D]=!0}catch{}}markAsSingleton(C){}})}function P(D){return $?.trackDisposable(D),D}function p(D){$?.markAsDisposed(D)}function S(D,C){$?.setParent(D,C)}function v(D,C){if($)for(const R of D)$.setParent(R,C)}function d(D){return $?.markAsSingleton(D),D}function f(D){return typeof D=="object"&&D!==null&&typeof D.dispose=="function"&&D.dispose.length===0}function a(D){if(M.Iterable.is(D)){const C=[];for(const R of D)if(R)try{R.dispose()}catch(T){C.push(T)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function n(D){for(const C of D)f(C)&&C.dispose();return[]}function i(...D){const C=c(()=>a(D));return v(D,C),C}function c(D){const C=P({dispose:(0,A.$db)(()=>{p(C),D()})});return C}class r{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{a(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return S(C,this),this.g?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),S(C,null))}}e.$Tc=r;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new r,P(this),S(this.q,this)}dispose(){p(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class u{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&S(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&S(C,null),C}}e.$Vc=u;class s{constructor(C){this.a=new u,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=s;class o{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=o;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(C){let R=C;return this.unset=()=>R=void 0,this.isset=()=>R!==void 0,this.dispose=()=>{R&&(R(),R=void 0,p(this))},this}}e.$Yc=h;class g{constructor(){this.a=new Map}acquire(C,...R){let T=this.a.get(C);T||(T={counter:0,object:this.b(C,...R)},this.a.set(C,T));const{object:j}=T,z=(0,A.$db)(()=>{--T.counter===0&&(this.c(C,T.object),this.a.delete(C))});return T.counter++,{object:j,dispose:z}}}e.$Zc=g;class w{constructor(C){this.a=C}async acquire(C,...R){const T=this.a.acquire(C,...R);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(j){throw T.dispose(),j}}}e.$1c=w;class k{constructor(C){this.object=C}dispose(){}}e.$2c=k;function m(D){const C=new r;try{D(C)}finally{C.dispose()}}class y{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{a(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,R,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(C)?.dispose(),this.a.set(C,R)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=y}),function(he,e){typeof define=="function"&&define.amd?define(ke[167],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(ce,ae){for(var le=0;le<ae.length;le++){var J=ae[le];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(ce,J.key,J)}}function l(ce,ae,le){return ae&&e(ce.prototype,ae),le&&e(ce,le),Object.defineProperty(ce,"prototype",{writable:!1}),ce}function O(ce,ae){if(ce){if(typeof ce=="string")return L(ce,ae);var le=Object.prototype.toString.call(ce).slice(8,-1);if(le==="Object"&&ce.constructor&&(le=ce.constructor.name),le==="Map"||le==="Set")return Array.from(ce);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return L(ce,ae)}}function L(ce,ae){(ae==null||ae>ce.length)&&(ae=ce.length);for(var le=0,J=new Array(ae);le<ae;le++)J[le]=ce[le];return J}function A(ce,ae){var le=typeof Symbol<"u"&&ce[Symbol.iterator]||ce["@@iterator"];if(le)return(le=le.call(ce)).next.bind(le);if(Array.isArray(ce)||(le=O(ce))||ae&&ce&&typeof ce.length=="number"){le&&(ce=le);var J=0;return function(){return J>=ce.length?{done:!0}:{done:!1,value:ce[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=M();function b(ce){he.defaults=ce}var $=/[&<>"']/,E=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(ae){return p[ae]};function v(ce,ae){if(ae){if($.test(ce))return ce.replace(E,S)}else if(I.test(ce))return ce.replace(P,S);return ce}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ce){return ce.replace(d,function(ae,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var a=/(^|[^\[])\^/g;function n(ce,ae){ce=typeof ce=="string"?ce:ce.source,ae=ae||"";var le={replace:function(se,pe){return pe=pe.source||pe,pe=pe.replace(a,"$1"),ce=ce.replace(se,pe),le},getRegex:function(){return new RegExp(ce,ae)}};return le}var i=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function r(ce,ae,le){if(ce){var J;try{J=decodeURIComponent(f(le)).replace(i,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ae&&!c.test(le)&&(le=h(ae,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var t={},u=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(ce,ae){t[" "+ce]||(u.test(ce)?t[" "+ce]=ce+"/":t[" "+ce]=m(ce,"/",!0)),ce=t[" "+ce];var le=ce.indexOf(":")===-1;return ae.substring(0,2)==="//"?le?ae:ce.replace(s,"$1")+ae:ae.charAt(0)==="/"?le?ae:ce.replace(o,"$1")+ae:ce+ae}var g={exec:function(){}};function w(ce){for(var ae=1,le,J;ae<arguments.length;ae++){le=arguments[ae];for(J in le)Object.prototype.hasOwnProperty.call(le,J)&&(ce[J]=le[J])}return ce}function k(ce,ae){var le=ce.replace(/\|/g,function(pe,ve,Re){for(var me=!1,Ie=ve;--Ie>=0&&Re[Ie]==="\\";)me=!me;return me?"|":" |"}),J=le.split(/ \|/),se=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ae)J.splice(ae);else for(;J.length<ae;)J.push("");for(;se<J.length;se++)J[se]=J[se].trim().replace(/\\\|/g,"|");return J}function m(ce,ae,le){var J=ce.length;if(J===0)return"";for(var se=0;se<J;){var pe=ce.charAt(J-se-1);if(pe===ae&&!le)se++;else if(pe!==ae&&le)se++;else break}return ce.slice(0,J-se)}function y(ce,ae){if(ce.indexOf(ae[1])===-1)return-1;for(var le=ce.length,J=0,se=0;se<le;se++)if(ce[se]==="\\")se++;else if(ce[se]===ae[0])J++;else if(ce[se]===ae[1]&&(J--,J<0))return se;return-1}function D(ce){ce&&ce.sanitize&&!ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(ce,ae){if(ae<1)return"";for(var le="";ae>1;)ae&1&&(le+=ce),ae>>=1,ce+=ce;return le+ce}function R(ce,ae,le,J){var se=ae.href,pe=ae.title?v(ae.title):null,ve=ce[1].replace(/\\([\[\]])/g,"$1");if(ce[0].charAt(0)!=="!"){J.state.inLink=!0;var Re={type:"link",raw:le,href:se,title:pe,text:ve,tokens:J.inlineTokens(ve)};return J.state.inLink=!1,Re}return{type:"image",raw:le,href:se,title:pe,text:v(ve)}}function T(ce,ae){var le=ce.match(/^(\s+)(?:```)/);if(le===null)return ae;var J=le[1];return ae.split(`
`).map(function(se){var pe=se.match(/^\s+/);if(pe===null)return se;var ve=pe[0];return ve.length>=J.length?se.slice(J.length):se}).join(`
`)}var j=function(){function ce(le){this.options=le||he.defaults}var ae=ce.prototype;return ae.space=function(J){var se=this.rules.block.newline.exec(J);if(se&&se[0].length>0)return{type:"space",raw:se[0]}},ae.code=function(J){var se=this.rules.block.code.exec(J);if(se){var pe=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:m(pe,`
`)}}},ae.fences=function(J){var se=this.rules.block.fences.exec(J);if(se){var pe=se[0],ve=T(pe,se[3]||"");return{type:"code",raw:pe,lang:se[2]?se[2].trim():se[2],text:ve}}},ae.heading=function(J){var se=this.rules.block.heading.exec(J);if(se){var pe=se[2].trim();if(/#$/.test(pe)){var ve=m(pe,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(pe=ve.trim())}return{type:"heading",raw:se[0],depth:se[1].length,text:pe,tokens:this.lexer.inline(pe)}}},ae.hr=function(J){var se=this.rules.block.hr.exec(J);if(se)return{type:"hr",raw:se[0]}},ae.blockquote=function(J){var se=this.rules.block.blockquote.exec(J);if(se){var pe=se[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},ae.list=function(J){var se=this.rules.block.list.exec(J);if(se){var pe,ve,Re,me,Ie,Ae,ze,q,W,X,Q,de,we=se[1].trim(),Te=we.length>1,qe={type:"list",raw:"",ordered:Te,start:Te?+we.slice(0,-1):"",loose:!1,items:[]};we=Te?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Te?we:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(de=!1,!(!(se=Xe.exec(J))||this.rules.block.hr.test(J)));){if(pe=se[0],J=J.substring(pe.length),q=se[2].split(`
`,1)[0],W=J.split(`
`,1)[0],this.options.pedantic?(me=2,Q=q.trimLeft()):(me=se[2].search(/[^ ]/),me=me>4?1:me,Q=q.slice(me),me+=se[1].length),Ae=!1,!q&&/^ *$/.test(W)&&(pe+=W+`
`,J=J.substring(W.length+1),de=!0),!de)for(var tt=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,me-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,me-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,me-1)+"}#");J&&(X=J.split(`
`,1)[0],q=X,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(q)||it.test(q)||tt.test(q)||et.test(J)));){if(q.search(/[^ ]/)>=me||!q.trim())Q+=`
`+q.slice(me);else if(!Ae)Q+=`
`+q;else break;!Ae&&!q.trim()&&(Ae=!0),pe+=X+`
`,J=J.substring(X.length+1)}qe.loose||(ze?qe.loose=!0:/\n *\n *$/.test(pe)&&(ze=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(Q),ve&&(Re=ve[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:pe,task:!!ve,checked:Re,loose:!1,text:Q}),qe.raw+=pe}qe.items[qe.items.length-1].raw=pe.trimRight(),qe.items[qe.items.length-1].text=Q.trimRight(),qe.raw=qe.raw.trimRight();var rt=qe.items.length;for(Ie=0;Ie<rt;Ie++){this.lexer.state.top=!1,qe.items[Ie].tokens=this.lexer.blockTokens(qe.items[Ie].text,[]);var at=qe.items[Ie].tokens.filter(function(ye){return ye.type==="space"}),Me=at.every(function(ye){for(var Ve=ye.raw.split(""),ne=0,ie=A(Ve),Ce;!(Ce=ie()).done;){var Ge=Ce.value;if(Ge===`
`&&(ne+=1),ne>1)return!0}return!1});!qe.loose&&at.length&&Me&&(qe.loose=!0,qe.items[Ie].loose=!0)}return qe}},ae.html=function(J){var se=this.rules.block.html.exec(J);if(se){var pe={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]);pe.type="paragraph",pe.text=ve,pe.tokens=this.lexer.inline(ve)}return pe}},ae.def=function(J){var se=this.rules.block.def.exec(J);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var pe=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:se[0],href:se[2],title:se[3]}}},ae.table=function(J){var se=this.rules.block.table.exec(J);if(se){var pe={type:"table",header:k(se[1]).map(function(ze){return{text:ze}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]&&se[3].trim()?se[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=se[0];var ve=pe.align.length,Re,me,Ie,Ae;for(Re=0;Re<ve;Re++)/^ *-+: *$/.test(pe.align[Re])?pe.align[Re]="right":/^ *:-+: *$/.test(pe.align[Re])?pe.align[Re]="center":/^ *:-+ *$/.test(pe.align[Re])?pe.align[Re]="left":pe.align[Re]=null;for(ve=pe.rows.length,Re=0;Re<ve;Re++)pe.rows[Re]=k(pe.rows[Re],pe.header.length).map(function(ze){return{text:ze}});for(ve=pe.header.length,me=0;me<ve;me++)pe.header[me].tokens=this.lexer.inline(pe.header[me].text);for(ve=pe.rows.length,me=0;me<ve;me++)for(Ae=pe.rows[me],Ie=0;Ie<Ae.length;Ie++)Ae[Ie].tokens=this.lexer.inline(Ae[Ie].text);return pe}}},ae.lheading=function(J){var se=this.rules.block.lheading.exec(J);if(se)return{type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:this.lexer.inline(se[1])}},ae.paragraph=function(J){var se=this.rules.block.paragraph.exec(J);if(se){var pe=se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1];return{type:"paragraph",raw:se[0],text:pe,tokens:this.lexer.inline(pe)}}},ae.text=function(J){var se=this.rules.block.text.exec(J);if(se)return{type:"text",raw:se[0],text:se[0],tokens:this.lexer.inline(se[0])}},ae.escape=function(J){var se=this.rules.inline.escape.exec(J);if(se)return{type:"escape",raw:se[0],text:v(se[1])}},ae.tag=function(J){var se=this.rules.inline.tag.exec(J);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):v(se[0]):se[0]}},ae.link=function(J){var se=this.rules.inline.link.exec(J);if(se){var pe=se[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var ve=m(pe.slice(0,-1),"\\");if((pe.length-ve.length)%2===0)return}else{var Re=y(se[2],"()");if(Re>-1){var me=se[0].indexOf("!")===0?5:4,Ie=me+se[1].length+Re;se[2]=se[2].substring(0,Re),se[0]=se[0].substring(0,Ie).trim(),se[3]=""}}var Ae=se[2],ze="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);q&&(Ae=q[1],ze=q[3])}else ze=se[3]?se[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(pe)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),R(se,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},ae.reflink=function(J,se){var pe;if((pe=this.rules.inline.reflink.exec(J))||(pe=this.rules.inline.nolink.exec(J))){var ve=(pe[2]||pe[1]).replace(/\s+/g," ");if(ve=se[ve.toLowerCase()],!ve||!ve.href){var Re=pe[0].charAt(0);return{type:"text",raw:Re,text:Re}}return R(pe,ve,pe[0],this.lexer)}},ae.emStrong=function(J,se,pe){pe===void 0&&(pe="");var ve=this.rules.inline.emStrong.lDelim.exec(J);if(ve&&!(ve[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Re=ve[1]||ve[2]||"";if(!Re||Re&&(pe===""||this.rules.inline.punctuation.exec(pe))){var me=ve[0].length-1,Ie,Ae,ze=me,q=0,W=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,se=se.slice(-1*J.length+me);(ve=W.exec(se))!=null;)if(Ie=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!Ie){if(Ae=Ie.length,ve[3]||ve[4]){ze+=Ae;continue}else if((ve[5]||ve[6])&&me%3&&!((me+Ae)%3)){q+=Ae;continue}if(ze-=Ae,!(ze>0)){if(Ae=Math.min(Ae,Ae+ze+q),Math.min(me,Ae)%2){var X=J.slice(1,me+ve.index+Ae);return{type:"em",raw:J.slice(0,me+ve.index+Ae+1),text:X,tokens:this.lexer.inlineTokens(X)}}var Q=J.slice(2,me+ve.index+Ae-1);return{type:"strong",raw:J.slice(0,me+ve.index+Ae+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},ae.codespan=function(J){var se=this.rules.inline.code.exec(J);if(se){var pe=se[2].replace(/\n/g," "),ve=/[^ ]/.test(pe),Re=/^ /.test(pe)&&/ $/.test(pe);return ve&&Re&&(pe=pe.substring(1,pe.length-1)),pe=v(pe,!0),{type:"codespan",raw:se[0],text:pe}}},ae.br=function(J){var se=this.rules.inline.br.exec(J);if(se)return{type:"br",raw:se[0]}},ae.del=function(J){var se=this.rules.inline.del.exec(J);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2])}},ae.autolink=function(J,se){var pe=this.rules.inline.autolink.exec(J);if(pe){var ve,Re;return pe[2]==="@"?(ve=v(this.options.mangle?se(pe[1]):pe[1]),Re="mailto:"+ve):(ve=v(pe[1]),Re=ve),{type:"link",raw:pe[0],text:ve,href:Re,tokens:[{type:"text",raw:ve,text:ve}]}}},ae.url=function(J,se){var pe;if(pe=this.rules.inline.url.exec(J)){var ve,Re;if(pe[2]==="@")ve=v(this.options.mangle?se(pe[0]):pe[0]),Re="mailto:"+ve;else{var me;do me=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(me!==pe[0]);ve=v(pe[0]),pe[1]==="www."?Re="http://"+ve:Re=ve}return{type:"link",raw:pe[0],text:ve,href:Re,tokens:[{type:"text",raw:ve,text:ve}]}}},ae.inlineText=function(J,se){var pe=this.rules.inline.text.exec(J);if(pe){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):v(pe[0]):pe[0]:ve=v(this.options.smartypants?se(pe[0]):pe[0]),{type:"text",raw:pe[0],text:ve}}},ce}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=w({},z),z.gfm=w({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=w({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=n(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=n(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=n(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=n(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=n(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=n(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=n(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=n(N.reflink).replace("label",N._label).replace("ref",z._label).getRegex(),N.nolink=n(N.nolink).replace("ref",z._label).getRegex(),N.reflinkSearch=n(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=w({},N),N.pedantic=w({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=w({},N.normal,{escape:n(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=n(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=w({},N.gfm,{br:n(N.br).replace("{2,}","*").getRegex(),text:n(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ce){return ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(ce){var ae="",le,J,se=ce.length;for(le=0;le<se;le++)J=ce.charCodeAt(le),Math.random()>.5&&(J="x"+J.toString(16)),ae+="&#"+J+";";return ae}var Y=function(){function ce(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||he.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:z.normal,inline:N.normal};this.options.pedantic?(J.block=z.pedantic,J.inline=N.pedantic):this.options.gfm&&(J.block=z.gfm,this.options.breaks?J.inline=N.breaks:J.inline=N.gfm),this.tokenizer.rules=J}ce.lex=function(J,se){var pe=new ce(se);return pe.lex(J)},ce.lexInline=function(J,se){var pe=new ce(se);return pe.inlineTokens(J)};var ae=ce.prototype;return ae.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},ae.blockTokens=function(J,se){var pe=this;se===void 0&&(se=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(ze,q,W){return q+"    ".repeat(W.length)});for(var ve,Re,me,Ie;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(ve=ze.call({lexer:pe},J,se))?(J=J.substring(ve.raw.length),se.push(ve),!0):!1}))){if(ve=this.tokenizer.space(J)){J=J.substring(ve.raw.length),ve.raw.length===1&&se.length>0?se[se.length-1].raw+=`
`:se.push(ve);continue}if(ve=this.tokenizer.code(J)){J=J.substring(ve.raw.length),Re=se[se.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):se.push(ve);continue}if(ve=this.tokenizer.fences(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.heading(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.hr(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.blockquote(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.list(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.html(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.def(J)){J=J.substring(ve.raw.length),Re=se[se.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.lheading(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(me=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,q=J.slice(1),W=void 0;pe.options.extensions.startBlock.forEach(function(X){W=X.call({lexer:this},q),typeof W=="number"&&W>=0&&(ze=Math.min(ze,W))}),ze<1/0&&ze>=0&&(me=J.substring(0,ze+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(me))){Re=se[se.length-1],Ie&&Re.type==="paragraph"?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):se.push(ve),Ie=me.length!==J.length,J=J.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(J)){J=J.substring(ve.raw.length),Re=se[se.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+ve.raw,Re.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):se.push(ve);continue}if(J){var Ae="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,se},ae.inline=function(J,se){return se===void 0&&(se=[]),this.inlineQueue.push({src:J,tokens:se}),se},ae.inlineTokens=function(J,se){var pe=this;se===void 0&&(se=[]);var ve,Re,me,Ie=J,Ae,ze,q;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)W.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(ze||(q=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(ve=Q.call({lexer:pe},J,se))?(J=J.substring(ve.raw.length),se.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.tag(J)){J=J.substring(ve.raw.length),Re=se[se.length-1],Re&&ve.type==="text"&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):se.push(ve);continue}if(ve=this.tokenizer.link(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(ve.raw.length),Re=se[se.length-1],Re&&ve.type==="text"&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):se.push(ve);continue}if(ve=this.tokenizer.emStrong(J,Ie,q)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.codespan(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.br(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.del(J)){J=J.substring(ve.raw.length),se.push(ve);continue}if(ve=this.tokenizer.autolink(J,B)){J=J.substring(ve.raw.length),se.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(J,B))){J=J.substring(ve.raw.length),se.push(ve);continue}if(me=J,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,de=J.slice(1),we=void 0;pe.options.extensions.startInline.forEach(function(Te){we=Te.call({lexer:this},de),typeof we=="number"&&we>=0&&(Q=Math.min(Q,we))}),Q<1/0&&Q>=0&&(me=J.substring(0,Q+1))}(),ve=this.tokenizer.inlineText(me,F)){J=J.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(q=ve.raw.slice(-1)),ze=!0,Re=se[se.length-1],Re&&Re.type==="text"?(Re.raw+=ve.raw,Re.text+=ve.text):se.push(ve);continue}if(J){var X="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return se},l(ce,null,[{key:"rules",get:function(){return{block:z,inline:N}}}]),ce}(),re=function(){function ce(le){this.options=le||he.defaults}var ae=ce.prototype;return ae.code=function(J,se,pe){var ve=(se||"").match(/\S*/)[0];if(this.options.highlight){var Re=this.options.highlight(J,ve);Re!=null&&Re!==J&&(pe=!0,J=Re)}return J=J.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+v(ve,!0)+'">'+(pe?J:v(J,!0))+`</code></pre>
`:"<pre><code>"+(pe?J:v(J,!0))+`</code></pre>
`},ae.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ae.html=function(J){return J},ae.heading=function(J,se,pe,ve){if(this.options.headerIds){var Re=this.options.headerPrefix+ve.slug(pe);return"<h"+se+' id="'+Re+'">'+J+"</h"+se+`>
`}return"<h"+se+">"+J+"</h"+se+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(J,se,pe){var ve=se?"ol":"ul",Re=se&&pe!==1?' start="'+pe+'"':"";return"<"+ve+Re+`>
`+J+"</"+ve+`>
`},ae.listitem=function(J){return"<li>"+J+`</li>
`},ae.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(J){return"<p>"+J+`</p>
`},ae.table=function(J,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+se+`</table>
`},ae.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ae.tablecell=function(J,se){var pe=se.header?"th":"td",ve=se.align?"<"+pe+' align="'+se.align+'">':"<"+pe+">";return ve+J+("</"+pe+`>
`)},ae.strong=function(J){return"<strong>"+J+"</strong>"},ae.em=function(J){return"<em>"+J+"</em>"},ae.codespan=function(J){return"<code>"+J+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(J){return"<del>"+J+"</del>"},ae.link=function(J,se,pe){if(J=r(this.options.sanitize,this.options.baseUrl,J),J===null)return pe;var ve='<a href="'+v(J)+'"';return se&&(ve+=' title="'+se+'"'),ve+=">"+pe+"</a>",ve},ae.image=function(J,se,pe){if(J=r(this.options.sanitize,this.options.baseUrl,J),J===null)return pe;var ve='<img src="'+J+'" alt="'+pe+'"';return se&&(ve+=' title="'+se+'"'),ve+=this.options.xhtml?"/>":">",ve},ae.text=function(J){return J},ce}(),H=function(){function ce(){}var ae=ce.prototype;return ae.strong=function(J){return J},ae.em=function(J){return J},ae.codespan=function(J){return J},ae.del=function(J){return J},ae.html=function(J){return J},ae.text=function(J){return J},ae.link=function(J,se,pe){return""+pe},ae.image=function(J,se,pe){return""+pe},ae.br=function(){return""},ce}(),K=function(){function ce(){this.seen={}}var ae=ce.prototype;return ae.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(J,se){var pe=J,ve=0;if(this.seen.hasOwnProperty(pe)){ve=this.seen[J];do ve++,pe=J+"-"+ve;while(this.seen.hasOwnProperty(pe))}return se||(this.seen[J]=ve,this.seen[pe]=0),pe},ae.slug=function(J,se){se===void 0&&(se={});var pe=this.serialize(J);return this.getNextSafeSlug(pe,se.dryrun)},ce}(),_=function(){function ce(le){this.options=le||he.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new K}ce.parse=function(J,se){var pe=new ce(se);return pe.parse(J)},ce.parseInline=function(J,se){var pe=new ce(se);return pe.parseInline(J)};var ae=ce.prototype;return ae.parse=function(J,se){se===void 0&&(se=!0);var pe="",ve,Re,me,Ie,Ae,ze,q,W,X,Q,de,we,Te,qe,Xe,tt,et,nt,it,rt=J.length;for(ve=0;ve<rt;ve++){if(Q=J[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(it=this.options.extensions.renderers[Q.type].call({parser:this},Q),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){pe+=it||"";continue}switch(Q.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,f(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(W="",q="",Ie=Q.header.length,Re=0;Re<Ie;Re++)q+=this.renderer.tablecell(this.parseInline(Q.header[Re].tokens),{header:!0,align:Q.align[Re]});for(W+=this.renderer.tablerow(q),X="",Ie=Q.rows.length,Re=0;Re<Ie;Re++){for(ze=Q.rows[Re],q="",Ae=ze.length,me=0;me<Ae;me++)q+=this.renderer.tablecell(this.parseInline(ze[me].tokens),{header:!1,align:Q.align[me]});X+=this.renderer.tablerow(q)}pe+=this.renderer.table(W,X);continue}case"blockquote":{X=this.parse(Q.tokens),pe+=this.renderer.blockquote(X);continue}case"list":{for(de=Q.ordered,we=Q.start,Te=Q.loose,Ie=Q.items.length,X="",Re=0;Re<Ie;Re++)Xe=Q.items[Re],tt=Xe.checked,et=Xe.task,qe="",Xe.task&&(nt=this.renderer.checkbox(tt),Te?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=nt+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=nt+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:nt}):qe+=nt),qe+=this.parse(Xe.tokens,Te),X+=this.renderer.listitem(qe,et,tt);pe+=this.renderer.list(X,de,we);continue}case"html":{pe+=this.renderer.html(Q.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(X=Q.tokens?this.parseInline(Q.tokens):Q.text;ve+1<rt&&J[ve+1].type==="text";)Q=J[++ve],X+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);pe+=se?this.renderer.paragraph(X):X;continue}default:{var at='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return pe},ae.parseInline=function(J,se){se=se||this.renderer;var pe="",ve,Re,me,Ie=J.length;for(ve=0;ve<Ie;ve++){if(Re=J[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(me=this.options.extensions.renderers[Re.type].call({parser:this},Re),me!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Re.type))){pe+=me||"";continue}switch(Re.type){case"escape":{pe+=se.text(Re.text);break}case"html":{pe+=se.html(Re.text);break}case"link":{pe+=se.link(Re.href,Re.title,this.parseInline(Re.tokens,se));break}case"image":{pe+=se.image(Re.href,Re.title,Re.text);break}case"strong":{pe+=se.strong(this.parseInline(Re.tokens,se));break}case"em":{pe+=se.em(this.parseInline(Re.tokens,se));break}case"codespan":{pe+=se.codespan(Re.text);break}case"br":{pe+=se.br();break}case"del":{pe+=se.del(this.parseInline(Re.tokens,se));break}case"text":{pe+=se.text(Re.text);break}default:{var Ae='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return pe},ce}();function Z(ce,ae,le){if(typeof ce>"u"||ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");if(typeof ae=="function"&&(le=ae,ae=null),ae=w({},Z.defaults,ae||{}),D(ae),le){var J=ae.highlight,se;try{se=Y.lex(ce,ae)}catch(Ie){return le(Ie)}var pe=function(Ae){var ze;if(!Ae)try{ae.walkTokens&&Z.walkTokens(se,ae.walkTokens),ze=_.parse(se,ae)}catch(q){Ae=q}return ae.highlight=J,Ae?le(Ae):le(null,ze)};if(!J||J.length<3||(delete ae.highlight,!se.length))return pe();var ve=0;Z.walkTokens(se,function(Ie){Ie.type==="code"&&(ve++,setTimeout(function(){J(Ie.text,Ie.lang,function(Ae,ze){if(Ae)return pe(Ae);ze!=null&&ze!==Ie.text&&(Ie.text=ze,Ie.escaped=!0),ve--,ve===0&&pe()})},0))}),ve===0&&pe();return}function Re(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+v(Ie.message+"",!0)+"</pre>";throw Ie}try{var me=Y.lex(ce,ae);if(ae.walkTokens){if(ae.async)return Promise.all(Z.walkTokens(me,ae.walkTokens)).then(function(){return _.parse(me,ae)}).catch(Re);Z.walkTokens(me,ae.walkTokens)}return _.parse(me,ae)}catch(Ie){Re(Ie)}}Z.options=Z.setOptions=function(ce){return w(Z.defaults,ce),b(Z.defaults),Z},Z.getDefaults=M,Z.defaults=he.defaults,Z.use=function(){for(var ce=arguments.length,ae=new Array(ce),le=0;le<ce;le++)ae[le]=arguments[le];var J=w.apply(void 0,[{}].concat(ae)),se=Z.defaults.extensions||{renderers:{},childTokens:{}},pe;ae.forEach(function(ve){if(ve.extensions&&(pe=!0,ve.extensions.forEach(function(me){if(!me.name)throw new Error("extension name required");if(me.renderer){var Ie=se.renderers?se.renderers[me.name]:null;Ie?se.renderers[me.name]=function(){for(var Ae=arguments.length,ze=new Array(Ae),q=0;q<Ae;q++)ze[q]=arguments[q];var W=me.renderer.apply(this,ze);return W===!1&&(W=Ie.apply(this,ze)),W}:se.renderers[me.name]=me.renderer}if(me.tokenizer){if(!me.level||me.level!=="block"&&me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");se[me.level]?se[me.level].unshift(me.tokenizer):se[me.level]=[me.tokenizer],me.start&&(me.level==="block"?se.startBlock?se.startBlock.push(me.start):se.startBlock=[me.start]:me.level==="inline"&&(se.startInline?se.startInline.push(me.start):se.startInline=[me.start]))}me.childTokens&&(se.childTokens[me.name]=me.childTokens)})),ve.renderer&&function(){var me=Z.defaults.renderer||new re,Ie=function(q){var W=me[q];me[q]=function(){for(var X=arguments.length,Q=new Array(X),de=0;de<X;de++)Q[de]=arguments[de];var we=ve.renderer[q].apply(me,Q);return we===!1&&(we=W.apply(me,Q)),we}};for(var Ae in ve.renderer)Ie(Ae);J.renderer=me}(),ve.tokenizer&&function(){var me=Z.defaults.tokenizer||new j,Ie=function(q){var W=me[q];me[q]=function(){for(var X=arguments.length,Q=new Array(X),de=0;de<X;de++)Q[de]=arguments[de];var we=ve.tokenizer[q].apply(me,Q);return we===!1&&(we=W.apply(me,Q)),we}};for(var Ae in ve.tokenizer)Ie(Ae);J.tokenizer=me}(),ve.walkTokens){var Re=Z.defaults.walkTokens;J.walkTokens=function(me){var Ie=[];return Ie.push(ve.walkTokens.call(this,me)),Re&&(Ie=Ie.concat(Re.call(this,me))),Ie}}pe&&(J.extensions=se),Z.setOptions(J)})},Z.walkTokens=function(ce,ae){for(var le=[],J=function(){var Re=pe.value;switch(le=le.concat(ae.call(Z,Re)),Re.type){case"table":{for(var me=A(Re.header),Ie;!(Ie=me()).done;){var Ae=Ie.value;le=le.concat(Z.walkTokens(Ae.tokens,ae))}for(var ze=A(Re.rows),q;!(q=ze()).done;)for(var W=q.value,X=A(W),Q;!(Q=X()).done;){var de=Q.value;le=le.concat(Z.walkTokens(de.tokens,ae))}break}case"list":{le=le.concat(Z.walkTokens(Re.items,ae));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[Re.type]?Z.defaults.extensions.childTokens[Re.type].forEach(function(we){le=le.concat(Z.walkTokens(Re[we],ae))}):Re.tokens&&(le=le.concat(Z.walkTokens(Re.tokens,ae)))}},se=A(ce),pe;!(pe=se()).done;)J();return le},Z.parseInline=function(ce,ae){if(typeof ce>"u"||ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ce)+", string expected");ae=w({},Z.defaults,ae||{}),D(ae);try{var le=Y.lexInline(ce,ae);return ae.walkTokens&&Z.walkTokens(le,ae.walkTokens),_.parseInline(le,ae)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+v(J.message+"",!0)+"</pre>";throw J}},Z.Parser=_,Z.parser=_.parse,Z.Renderer=re,Z.TextRenderer=H,Z.Lexer=Y,Z.lexer=Y.lex,Z.Tokenizer=j,Z.Slugger=K,Z.parse=Z;var $e=Z.options,oe=Z.setOptions,Pe=Z.use,te=Z.walkTokens,U=Z.parseInline,ee=Z,be=_.parse,ue=Y.lex;he.Lexer=Y,he.Parser=_,he.Renderer=re,he.Slugger=K,he.TextRenderer=H,he.Tokenizer=j,he.getDefaults=M,he.lexer=ue,he.marked=Z,he.options=$e,he.parse=ee,he.parseInline=U,he.parser=be,he.setOptions=oe,he.use=Pe,he.walkTokens=te,Object.defineProperty(he,"__esModule",{value:!0})}),define(ke[168],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=l;function l(d){const f=A(d);if(f&&f.length>0)return new Uint32Array(f)}let O=0;const L=new Uint32Array(10);function A(d){if(O=0,M(d,P,4352),O>0||(M(d,p,4449),O>0)||(M(d,S,4520),O>0)||(M(d,v,12593),O))return L.subarray(0,O);if(d>=44032&&d<=55203){const f=d-44032,a=f%588,n=Math.floor(f/588),i=Math.floor(a/28),c=a%28-1;if(n<P.length?M(n,P,0):4352+n-12593<v.length&&M(4352+n,v,12593),i<p.length?M(i,p,0):4449+i-12593<v.length&&M(4449+i-12593,v,12593),c>=0&&(c<S.length?M(c,S,0):4520+c-12593<v.length&&M(4520+c-12593,v,12593)),O>0)return L.subarray(0,O)}}function M(d,f,a){d>=a&&d<a+f.length&&b(f[d-a])}function b(d){d!==0&&(L[O++]=d&255,d>>8&&(L[O++]=d>>8&255),d>>16&&(L[O++]=d>>16&255))}var $;(function(d){d[d.InitialConsonant=4352]="InitialConsonant",d[d.Vowel=4449]="Vowel",d[d.FinalConsonant=4520]="FinalConsonant",d[d.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var E;(function(d){d[d.NUL=0]="NUL",d[d.A=65]="A",d[d.B=66]="B",d[d.C=67]="C",d[d.D=68]="D",d[d.E=69]="E",d[d.F=70]="F",d[d.G=71]="G",d[d.H=72]="H",d[d.I=73]="I",d[d.J=74]="J",d[d.K=75]="K",d[d.L=76]="L",d[d.M=77]="M",d[d.N=78]="N",d[d.O=79]="O",d[d.P=80]="P",d[d.Q=81]="Q",d[d.R=82]="R",d[d.S=83]="S",d[d.T=84]="T",d[d.U=85]="U",d[d.V=86]="V",d[d.W=87]="W",d[d.X=88]="X",d[d.Y=89]="Y",d[d.Z=90]="Z",d[d.a=97]="a",d[d.b=98]="b",d[d.c=99]="c",d[d.d=100]="d",d[d.e=101]="e",d[d.f=102]="f",d[d.g=103]="g",d[d.h=104]="h",d[d.i=105]="i",d[d.j=106]="j",d[d.k=107]="k",d[d.l=108]="l",d[d.m=109]="m",d[d.n=110]="n",d[d.o=111]="o",d[d.p=112]="p",d[d.q=113]="q",d[d.r=114]="r",d[d.s=115]="s",d[d.t=116]="t",d[d.u=117]="u",d[d.v=118]="v",d[d.w=119]="w",d[d.x=120]="x",d[d.y=121]="y",d[d.z=122]="z"})(E||(E={}));var I;(function(d){d[d.fa=24934]="fa",d[d.fg=26470]="fg",d[d.fq=29030]="fq",d[d.fr=29286]="fr",d[d.ft=29798]="ft",d[d.fv=30310]="fv",d[d.fx=30822]="fx",d[d.hk=27496]="hk",d[d.hl=27752]="hl",d[d.ho=28520]="ho",d[d.ml=27757]="ml",d[d.nj=27246]="nj",d[d.nl=27758]="nl",d[d.np=28782]="np",d[d.qt=29809]="qt",d[d.rt=29810]="rt",d[d.sg=26483]="sg",d[d.sw=30579]="sw"})(I||(I={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),S=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[77],De([1,0,27]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=void 0,e.$dm=L,e.$em=M;const O=new l.$Dc(1e4);function L(E){return $(E,"NFC",O)}const A=new l.$Dc(1e4);function M(E){return $(E,"NFD",A)}const b=/[^\u0000-\u0080]/;function $(E,I,P){if(!E)return E;const p=P.get(E);if(p)return p;let S;return b.test(E)?S=E.normalize(I):S=E,P.set(E,S),S}e.$fm=function(){const E=/[\u0300-\u036f]/g;return function(I){return M(I).replace(E,"")}}()}),define(ke[126],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=l,e.rot=O;function l(b,$,E){return Math.min(Math.max(b,$),E)}function O(b,$){return($+b%$)%$}class L{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=L;class A{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=A;class M{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const E=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=M}),define(ke[169],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=A,e.$cd=p;class l{constructor(v,d,f){this.owner=v,this.debugNameSource=d,this.referenceFn=f}getDebugName(v){return A(v,this)}}e.$ad=l;const O=new Map,L=new WeakMap;function A(S,v){const d=L.get(S);if(d)return d;const f=M(S,v);if(f){let a=O.get(f)??0;a++,O.set(f,a);const n=a===1?f:`${f}#${a}`;return L.set(S,n),n}}function M(S,v){const d=L.get(S);if(d)return d;const f=v.owner?I(v.owner)+".":"";let a;const n=v.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(a=n(),a!==void 0)return f+a}else return f+n;const i=v.referenceFn;if(i!==void 0&&(a=p(i),a!==void 0))return f+a;if(v.owner!==void 0){const c=b(v.owner,S);if(c!==void 0)return f+c}}function b(S,v){for(const d in S)if(S[d]===v)return d}const $=new Map,E=new WeakMap;function I(S){const v=E.get(S);if(v)return v;const d=P(S);let f=$.get(d)??0;f++,$.set(d,f);const a=f===1?d:`${d}#${f}`;return E.set(S,a),a}function P(S){const v=S.constructor;return v?v.name:"Object"}function p(S){const v=S.toString(),f=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(v);return(f?f[1]:void 0)?.trim()}}),define(ke[170],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=O,e.$Id=L;let l;function O(d){l=d}function L(){return l}class A{constructor(){this.a=0,this.d=new WeakMap}b(f){return M([b(S("|  ",this.a)),f])}c(f){return f.hadValue?f.didChange?[b(" "),E(I(f.oldValue,70),{color:"red",strikeThrough:!0}),b(" "),E(I(f.newValue,60),{color:"green"})]:[b(" (unchanged)")]:[b(" "),E(I(f.newValue,60),{color:"green"}),b(" (initial)")]}handleObservableChanged(f,a){console.log(...this.b([$("observable value changed"),E(f.debugName,{color:"BlueViolet"}),...this.c(a)]))}formatChanges(f){if(f.size!==0)return E(" (changed deps: "+[...f].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(f){const a=f.handleChange;this.d.set(f,new Set),f.handleChange=(n,i)=>(this.d.get(f).add(n),a.apply(f,[n,i]))}handleDerivedRecomputed(f,a){const n=this.d.get(f);console.log(...this.b([$("derived recomputed"),E(f.debugName,{color:"BlueViolet"}),...this.c(a),this.formatChanges(n),{data:[{fn:f._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(f,a){console.log(...this.b([$("observable from event triggered"),E(f.debugName,{color:"BlueViolet"}),...this.c(a),{data:[{fn:f._getValue}]}]))}handleAutorunCreated(f){const a=f.handleChange;this.d.set(f,new Set),f.handleChange=(n,i)=>(this.d.get(f).add(n),a.apply(f,[n,i]))}handleAutorunTriggered(f){const a=this.d.get(f);console.log(...this.b([$("autorun"),E(f.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:f._runFn}]}])),a.clear(),this.a++}handleAutorunFinished(f){this.a--}handleBeginTransaction(f){let a=f.getDebugName();a===void 0&&(a=""),console.log(...this.b([$("transaction"),E(a,{color:"BlueViolet"}),{data:[{fn:f._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=A;function M(d){const f=new Array,a=[];let n="";function i(r){if("length"in r)for(const t of r)t&&i(t);else"text"in r?(n+=`%c${r.text}`,f.push(r.style),r.data&&a.push(...r.data)):"data"in r&&a.push(...r.data)}i(d);const c=[n,...f];return c.push(...a),c}function b(d){return E(d,{color:"black"})}function $(d){return E(v(`${d}: `,10),{color:"black",bold:!0})}function E(d,f={color:"black"}){function a(i){return Object.entries(i).reduce((c,[r,t])=>`${c}${r}:${t};`,"")}const n={color:f.color};return f.strikeThrough&&(n["text-decoration"]="line-through"),f.bold&&(n["font-weight"]="bold"),{text:d,style:a(n)}}function I(d,f){switch(typeof d){case"number":return""+d;case"string":return d.length+2<=f?`"${d}"`:`"${d.substr(0,f-7)}"+...`;case"boolean":return d?"true":"false";case"undefined":return"undefined";case"object":return d===null?"null":Array.isArray(d)?P(d,f):p(d,f);case"symbol":return d.toString();case"function":return`[[Function${d.name?" "+d.name:""}]]`;default:return""+d}}function P(d,f){let a="[ ",n=!0;for(const i of d){if(n||(a+=", "),a.length-5>f){a+="...";break}n=!1,a+=`${I(i,f-a.length)}`}return a+=" ]",a}function p(d,f){let a="{ ",n=!0;for(const[i,c]of Object.entries(d)){if(n||(a+=", "),a.length-5>f){a+="...";break}n=!1,a+=`${i}: ${I(c,f-a.length)}`}return a+=" }",a}function S(d,f){let a="";for(let n=1;n<=f;n++)a+=d;return a}function v(d,f){for(;d.length<f;)d+=" ";return d}}),define(ke[171],De([1,0,165,169,170]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=M,e.$Td=$,e.$Ud=I,e.$Xd=S,e.$Yd=d,e.$Zd=f,e.$1d=a,e.$3d=i,e.$4d=c,e.$6d=t;let A;function M(s){A=s}let b;function $(s){b=s}let E;function I(s){E=s}class P{get TChange(){return null}reportChanges(){this.get()}read(o){return o?o.readObservable(this):this.get()}map(o,h){const g=h===void 0?void 0:o,w=h===void 0?o:h;return E({owner:g,debugName:()=>{const k=(0,O.$cd)(w);if(k!==void 0)return k;const y=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(w.toString());if(y)return`${this.debugName}.${y[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:w},k=>w(this.read(k),k))}recomputeInitiallyAndOnChange(o,h){return o.add(A(this,h)),this}keepObserved(o){return o.add(b(this)),this}get a(){return this.get()}}e.$Vd=P;class p extends P{constructor(){super(...arguments),this.b=new Set}addObserver(o){const h=this.b.size;this.b.add(o),h===0&&this.c()}removeObserver(o){this.b.delete(o)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=p;function S(s,o){const h=new n(s,o);try{s(h)}finally{h.finish()}}let v;function d(s){if(v)s(v);else{const o=new n(s,void 0);v=o;try{s(o)}finally{o.finish(),v=void 0}}}async function f(s,o){const h=new n(s,o);try{await s(h)}finally{h.finish()}}function a(s,o,h){s?o(s):S(o,h)}class n{constructor(o,h){this._fn=o,this.b=h,this.a=[],(0,L.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,O.$cd)(this._fn)}updateObserver(o,h){this.a.push({observer:o,observable:h}),o.beginUpdate(h)}finish(){const o=this.a;for(let h=0;h<o.length;h++){const{observer:g,observable:w}=o[h];g.endUpdate(w)}this.a=null,(0,L.$Id)()?.handleEndTransaction()}}e.$2d=n;function i(s,o){let h;return typeof s=="string"?h=new O.$ad(void 0,s,void 0):h=new O.$ad(s,void 0,void 0),new r(h,o,l.$6c)}function c(s,o){return new r(new O.$ad(s.owner,s.debugName,void 0),o,s.equalsFn??l.$6c)}class r extends p{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(o,h,g){super(),this.e=o,this.g=g,this.d=h}get(){return this.d}set(o,h,g){if(g===void 0&&this.g(this.d,o))return;let w;h||(h=w=new n(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(o),(0,L.$Id)()?.handleObservableChanged(this,{oldValue:k,newValue:o,change:g,didChange:!0,hadValue:!0});for(const m of this.b)h.updateObserver(m,this),m.handleChange(this,g)}finally{w&&w.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(o){this.d=o}}e.$5d=r;function t(s,o){let h;return typeof s=="string"?h=new O.$ad(void 0,s,void 0):h=new O.$ad(s,void 0,void 0),new u(h,o,l.$6c)}class u extends r{h(o){this.d!==o&&(this.d&&this.d.dispose(),this.d=o)}dispose(){this.d?.dispose()}}e.$7d=u}),function(){function he(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function M($){A.push($,Date.now())}function b(){const $=[];for(let E=0;E<A.length;E+=2)$.push({name:A[E],startTime:A[E+1]});return $}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))A.push({name:M.name,startTime:Math.round(L+M.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function l(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=l(O))}(),define(ke[172],De([1,0,39]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CO=void 0;const O=Symbol("unset");class L{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||l.Iterable.empty()}insert($,E,I){this.d($,P=>P._value=E,I)}mutate($,E){this.d($,I=>I._value=E(I._value===O?void 0:I._value))}mutatePath($,E){this.d($,()=>{},I=>E(I))}delete($){const E=this.c($);if(!E)return;let I=E.length-1;const P=E[I].node._value;if(P!==O){for(this.b--,E[I].node._value=O;I>0;I--){const{node:p,part:S}=E[I];if(p.children?.size||p._value!==O)break;E[I-1].node.children.delete(S)}return P}}*deleteRecursive($){const E=this.c($);if(!E)return;const I=E[E.length-1].node;for(let P=E.length-1;P>0;P--){const p=E[P-1];if(p.node.children.delete(E[P].part),p.node.children.size>0||p.node._value!==O)break}for(const P of A(I))P._value!==O&&(this.b--,yield P._value)}find($){let E=this.a;for(const I of $){const P=E.children?.get(I);if(!P)return;E=P}return E._value===O?void 0:E._value}hasKeyOrParent($){let E=this.a;for(const I of $){const P=E.children?.get(I);if(!P)return!1;if(P._value!==O)return!0;E=P}return!1}hasKeyOrChildren($){let E=this.a;for(const I of $){const P=E.children?.get(I);if(!P)return!1;E=P}return!0}hasKey($){let E=this.a;for(const I of $){const P=E.children?.get(I);if(!P)return!1;E=P}return E._value!==O}c($){const E=[{part:"",node:this.a}];let I=0;for(const P of $){const p=E[I].node.children?.get(P);if(!p)return;E.push({part:P,node:p}),I++}return E}d($,E,I){let P=this.a;for(const v of $){if(P.children)if(P.children.has(v))P=P.children.get(v);else{const d=new M;P.children.set(v,d),P=d}else{const d=new M;P.children=new Map([[v,d]]),P=d}I?.(P)}const p=P._value===O?0:1;E(P);const S=P._value===O?0:1;this.b+=S-p}*values(){for(const{_value:$}of A(this.a))$!==O&&(yield $)}}e.$CO=L;function*A(b){const $=[b];for(;$.length>0;){const E=$.pop();if(yield E,E.children)for(const I of E.children.values())$.push(I)}}class M{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value($){this._value=$===void 0?O:$}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var O in l)(typeof exports=="object"?exports:he)[O]=l[O]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function l(O){if(e[O])return e[O].exports;var L=e[O]={i:O,l:!1,exports:{}};return he[O].call(L.exports,L,L.exports,l),L.l=!0,L.exports}return l.m=he,l.c=e,l.d=function(O,L,A){l.o(O,L)||Object.defineProperty(O,L,{enumerable:!0,get:A})},l.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},l.t=function(O,L){if(1&L&&(O=l(O)),8&L||4&L&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(l.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&L&&typeof O!="string")for(var M in O)l.d(A,M,function(b){return O[b]}.bind(null,M));return A},l.n=function(O){var L=O&&O.__esModule?function(){return O.default}:function(){return O};return l.d(L,"a",L),L},l.o=function(O,L){return Object.prototype.hasOwnProperty.call(O,L)},l.p="",l(l.s=0)}([function(he,e,l){(function(O){var L;e=he.exports=Pe,L=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],E=0,I=E++;$[I]="0|[1-9]\\d*";var P=E++;$[P]="[0-9]+";var p=E++;$[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=E++;$[S]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var v=E++;$[v]="("+$[P]+")\\.("+$[P]+")\\.("+$[P]+")";var d=E++;$[d]="(?:"+$[I]+"|"+$[p]+")";var f=E++;$[f]="(?:"+$[P]+"|"+$[p]+")";var a=E++;$[a]="(?:-("+$[d]+"(?:\\."+$[d]+")*))";var n=E++;$[n]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var i=E++;$[i]="[0-9A-Za-z-]+";var c=E++;$[c]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var r=E++,t="v?"+$[S]+$[a]+"?"+$[c]+"?";$[r]="^"+t+"$";var u="[v=\\s]*"+$[v]+$[n]+"?"+$[c]+"?",s=E++;$[s]="^"+u+"$";var o=E++;$[o]="((?:<|>)?=?)";var h=E++;$[h]=$[P]+"|x|X|\\*";var g=E++;$[g]=$[I]+"|x|X|\\*";var w=E++;$[w]="[v=\\s]*("+$[g]+")(?:\\.("+$[g]+")(?:\\.("+$[g]+")(?:"+$[a]+")?"+$[c]+"?)?)?";var k=E++;$[k]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[n]+")?"+$[c]+"?)?)?";var m=E++;$[m]="^"+$[o]+"\\s*"+$[w]+"$";var y=E++;$[y]="^"+$[o]+"\\s*"+$[k]+"$";var D=E++;$[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;$[C]="(?:~>?)";var R=E++;$[R]="(\\s*)"+$[C]+"\\s+",b[R]=new RegExp($[R],"g");var T=E++;$[T]="^"+$[C]+$[w]+"$";var j=E++;$[j]="^"+$[C]+$[k]+"$";var z=E++;$[z]="(?:\\^)";var N=E++;$[N]="(\\s*)"+$[z]+"\\s+",b[N]=new RegExp($[N],"g");var F=E++;$[F]="^"+$[z]+$[w]+"$";var B=E++;$[B]="^"+$[z]+$[k]+"$";var Y=E++;$[Y]="^"+$[o]+"\\s*("+u+")$|^$";var re=E++;$[re]="^"+$[o]+"\\s*("+t+")$|^$";var H=E++;$[H]="(\\s*)"+$[o]+"\\s*("+u+"|"+$[w]+")",b[H]=new RegExp($[H],"g");var K=E++;$[K]="^\\s*("+$[w]+")\\s+-\\s+("+$[w]+")\\s*$";var _=E++;$[_]="^\\s*("+$[k]+")\\s+-\\s+("+$[k]+")\\s*$";var Z=E++;$[Z]="(<|>)?=?\\s*\\*";for(var $e=0;$e<35;$e++)L($e,$[$e]),b[$e]||(b[$e]=new RegExp($[$e]));function oe(W,X){if(W instanceof Pe)return W;if(typeof W!="string"||W.length>A||!(X?b[s]:b[r]).test(W))return null;try{return new Pe(W,X)}catch{return null}}function Pe(W,X){if(W instanceof Pe){if(W.loose===X)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Pe))return new Pe(W,X);L("SemVer",W,X),this.loose=X;var Q=W.trim().match(X?b[s]:b[r]);if(!Q)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var we=+de;if(we>=0&&we<M)return we}return de}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=oe,e.valid=function(W,X){var Q=oe(W,X);return Q?Q.version:null},e.clean=function(W,X){var Q=oe(W.trim().replace(/^[=v]+/,""),X);return Q?Q.version:null},e.SemVer=Pe,Pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Pe.prototype.toString=function(){return this.version},Pe.prototype.compare=function(W){return L("SemVer.compare",this.version,this.loose,W),W instanceof Pe||(W=new Pe(W,this.loose)),this.compareMain(W)||this.comparePre(W)},Pe.prototype.compareMain=function(W){return W instanceof Pe||(W=new Pe(W,this.loose)),U(this.major,W.major)||U(this.minor,W.minor)||U(this.patch,W.patch)},Pe.prototype.comparePre=function(W){if(W instanceof Pe||(W=new Pe(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var X=0;do{var Q=this.prerelease[X],de=W.prerelease[X];if(L("prerelease compare",X,Q,de),Q===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(Q===void 0)return-1;if(Q!==de)return U(Q,de)}while(++X)},Pe.prototype.inc=function(W,X){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,X,Q,de){typeof Q=="string"&&(de=Q,Q=void 0);try{return new Pe(W,Q).inc(X,de).version}catch{return null}},e.diff=function(W,X){if(ce(W,X))return null;var Q=oe(W),de=oe(X);if(Q.prerelease.length||de.prerelease.length){for(var we in Q)if((we==="major"||we==="minor"||we==="patch")&&Q[we]!==de[we])return"pre"+we;return"prerelease"}for(var we in Q)if((we==="major"||we==="minor"||we==="patch")&&Q[we]!==de[we])return we},e.compareIdentifiers=U;var te=/^[0-9]+$/;function U(W,X){var Q=te.test(W),de=te.test(X);return Q&&de&&(W=+W,X=+X),Q&&!de?-1:de&&!Q?1:W<X?-1:W>X?1:0}function ee(W,X,Q){return new Pe(W,Q).compare(new Pe(X,Q))}function be(W,X,Q){return ee(W,X,Q)>0}function ue(W,X,Q){return ee(W,X,Q)<0}function ce(W,X,Q){return ee(W,X,Q)===0}function ae(W,X,Q){return ee(W,X,Q)!==0}function le(W,X,Q){return ee(W,X,Q)>=0}function J(W,X,Q){return ee(W,X,Q)<=0}function se(W,X,Q,de){var we;switch(X){case"===":typeof W=="object"&&(W=W.version),typeof Q=="object"&&(Q=Q.version),we=W===Q;break;case"!==":typeof W=="object"&&(W=W.version),typeof Q=="object"&&(Q=Q.version),we=W!==Q;break;case"":case"=":case"==":we=ce(W,Q,de);break;case"!=":we=ae(W,Q,de);break;case">":we=be(W,Q,de);break;case">=":we=le(W,Q,de);break;case"<":we=ue(W,Q,de);break;case"<=":we=J(W,Q,de);break;default:throw new TypeError("Invalid operator: "+X)}return we}function pe(W,X){if(W instanceof pe){if(W.loose===X)return W;W=W.value}if(!(this instanceof pe))return new pe(W,X);L("comparator",W,X),this.loose=X,this.parse(W),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(W,X){return U(X,W)},e.major=function(W,X){return new Pe(W,X).major},e.minor=function(W,X){return new Pe(W,X).minor},e.patch=function(W,X){return new Pe(W,X).patch},e.compare=ee,e.compareLoose=function(W,X){return ee(W,X,!0)},e.rcompare=function(W,X,Q){return ee(X,W,Q)},e.sort=function(W,X){return W.sort(function(Q,de){return e.compare(Q,de,X)})},e.rsort=function(W,X){return W.sort(function(Q,de){return e.rcompare(Q,de,X)})},e.gt=be,e.lt=ue,e.eq=ce,e.neq=ae,e.gte=le,e.lte=J,e.cmp=se,e.Comparator=pe;var ve={};function Re(W,X){if(W instanceof Re)return W.loose===X?W:new Re(W.raw,X);if(W instanceof pe)return new Re(W.value,X);if(!(this instanceof Re))return new Re(W,X);if(this.loose=X,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function me(W){return!W||W.toLowerCase()==="x"||W==="*"}function Ie(W,X,Q,de,we,Te,qe,Xe,tt,et,nt,it,rt){return((X=me(Q)?"":me(de)?">="+Q+".0.0":me(we)?">="+Q+"."+de+".0":">="+X)+" "+(Xe=me(tt)?"":me(et)?"<"+(+tt+1)+".0.0":me(nt)?"<"+tt+"."+(+et+1)+".0":it?"<="+tt+"."+et+"."+nt+"-"+it:"<="+Xe)).trim()}function Ae(W,X){for(var Q=0;Q<W.length;Q++)if(!W[Q].test(X))return!1;if(X.prerelease.length){for(Q=0;Q<W.length;Q++)if(L(W[Q].semver),W[Q].semver!==ve&&W[Q].semver.prerelease.length>0){var de=W[Q].semver;if(de.major===X.major&&de.minor===X.minor&&de.patch===X.patch)return!0}return!1}return!0}function ze(W,X,Q){try{X=new Re(X,Q)}catch{return!1}return X.test(W)}function q(W,X,Q,de){var we,Te,qe,Xe,tt;switch(W=new Pe(W,de),X=new Re(X,de),Q){case">":we=be,Te=J,qe=ue,Xe=">",tt=">=";break;case"<":we=ue,Te=le,qe=be,Xe="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(W,X,de))return!1;for(var et=0;et<X.set.length;++et){var nt=X.set[et],it=null,rt=null;if(nt.forEach(function(at){at.semver===ve&&(at=new pe(">=0.0.0")),it=it||at,rt=rt||at,we(at.semver,it.semver,de)?it=at:qe(at.semver,rt.semver,de)&&(rt=at)}),it.operator===Xe||it.operator===tt||(!rt.operator||rt.operator===Xe)&&Te(W,rt.semver)||rt.operator===tt&&qe(W,rt.semver))return!1}return!0}pe.prototype.parse=function(W){var X=this.loose?b[Y]:b[re],Q=W.match(X);if(!Q)throw new TypeError("Invalid comparator: "+W);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new Pe(Q[2],this.loose):this.semver=ve},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(W){return L("Comparator.test",W,this.loose),this.semver===ve||(typeof W=="string"&&(W=new Pe(W,this.loose)),se(W,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(W,X){if(!(W instanceof pe))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Re(W.value,X),ze(this.value,Q,X);if(W.operator==="")return Q=new Re(this.value,X),ze(W.semver,Q,X);var de=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Te=this.semver.version===W.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Xe=se(this.semver,"<",W.semver,X)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),tt=se(this.semver,">",W.semver,X)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return de||we||Te&&qe||Xe||tt},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(W){var X=this.loose;W=W.trim(),L("range",W,X);var Q=X?b[_]:b[K];W=W.replace(Q,Ie),L("hyphen replace",W),W=W.replace(b[H],"$1$2$3"),L("comparator trim",W,b[H]),W=(W=(W=W.replace(b[R],"$1~")).replace(b[N],"$1^")).split(/\s+/).join(" ");var de=X?b[Y]:b[re],we=W.split(" ").map(function(Te){return function(qe,Xe){return L("comp",qe),qe=function(tt,et){return tt.trim().split(/\s+/).map(function(nt){return function(it,rt){L("caret",it,rt);var at=rt?b[B]:b[F];return it.replace(at,function(Me,ye,Ve,ne,ie){var Ce;return L("caret",it,Me,ye,Ve,ne,ie),me(ye)?Ce="":me(Ve)?Ce=">="+ye+".0.0 <"+(+ye+1)+".0.0":me(ne)?Ce=ye==="0"?">="+ye+"."+Ve+".0 <"+ye+"."+(+Ve+1)+".0":">="+ye+"."+Ve+".0 <"+(+ye+1)+".0.0":ie?(L("replaceCaret pr",ie),ie.charAt(0)!=="-"&&(ie="-"+ie),Ce=ye==="0"?Ve==="0"?">="+ye+"."+Ve+"."+ne+ie+" <"+ye+"."+Ve+"."+(+ne+1):">="+ye+"."+Ve+"."+ne+ie+" <"+ye+"."+(+Ve+1)+".0":">="+ye+"."+Ve+"."+ne+ie+" <"+(+ye+1)+".0.0"):(L("no pr"),Ce=ye==="0"?Ve==="0"?">="+ye+"."+Ve+"."+ne+" <"+ye+"."+Ve+"."+(+ne+1):">="+ye+"."+Ve+"."+ne+" <"+ye+"."+(+Ve+1)+".0":">="+ye+"."+Ve+"."+ne+" <"+(+ye+1)+".0.0"),L("caret return",Ce),Ce})}(nt,et)}).join(" ")}(qe,Xe),L("caret",qe),qe=function(tt,et){return tt.trim().split(/\s+/).map(function(nt){return function(it,rt){var at=rt?b[j]:b[T];return it.replace(at,function(Me,ye,Ve,ne,ie){var Ce;return L("tilde",it,Me,ye,Ve,ne,ie),me(ye)?Ce="":me(Ve)?Ce=">="+ye+".0.0 <"+(+ye+1)+".0.0":me(ne)?Ce=">="+ye+"."+Ve+".0 <"+ye+"."+(+Ve+1)+".0":ie?(L("replaceTilde pr",ie),ie.charAt(0)!=="-"&&(ie="-"+ie),Ce=">="+ye+"."+Ve+"."+ne+ie+" <"+ye+"."+(+Ve+1)+".0"):Ce=">="+ye+"."+Ve+"."+ne+" <"+ye+"."+(+Ve+1)+".0",L("tilde return",Ce),Ce})}(nt,et)}).join(" ")}(qe,Xe),L("tildes",qe),qe=function(tt,et){return L("replaceXRanges",tt,et),tt.split(/\s+/).map(function(nt){return function(it,rt){it=it.trim();var at=rt?b[y]:b[m];return it.replace(at,function(Me,ye,Ve,ne,ie,Ce){L("xRange",it,Me,ye,Ve,ne,ie,Ce);var Ge=me(Ve),Le=Ge||me(ne),st=Le||me(ie);return ye==="="&&st&&(ye=""),Ge?Me=ye===">"||ye==="<"?"<0.0.0":"*":ye&&st?(Le&&(ne=0),st&&(ie=0),ye===">"?(ye=">=",Le?(Ve=+Ve+1,ne=0,ie=0):st&&(ne=+ne+1,ie=0)):ye==="<="&&(ye="<",Le?Ve=+Ve+1:ne=+ne+1),Me=ye+Ve+"."+ne+"."+ie):Le?Me=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":st&&(Me=">="+Ve+"."+ne+".0 <"+Ve+"."+(+ne+1)+".0"),L("xRange return",Me),Me})}(nt,et)}).join(" ")}(qe,Xe),L("xrange",qe),qe=function(tt,et){return L("replaceStars",tt,et),tt.trim().replace(b[Z],"")}(qe,Xe),L("stars",qe),qe}(Te,X)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Te){return!!Te.match(de)})),we=we.map(function(Te){return new pe(Te,X)})},Re.prototype.intersects=function(W,X){if(!(W instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(de){return W.set.some(function(we){return we.every(function(Te){return de.intersects(Te,X)})})})})},e.toComparators=function(W,X){return new Re(W,X).set.map(function(Q){return Q.map(function(de){return de.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new Pe(W,this.loose));for(var X=0;X<this.set.length;X++)if(Ae(this.set[X],W))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(W,X,Q){var de=null,we=null;try{var Te=new Re(X,Q)}catch{return null}return W.forEach(function(qe){Te.test(qe)&&(de&&we.compare(qe)!==-1||(we=new Pe(de=qe,Q)))}),de},e.minSatisfying=function(W,X,Q){var de=null,we=null;try{var Te=new Re(X,Q)}catch{return null}return W.forEach(function(qe){Te.test(qe)&&(de&&we.compare(qe)!==1||(we=new Pe(de=qe,Q)))}),de},e.validRange=function(W,X){try{return new Re(W,X).range||"*"}catch{return null}},e.ltr=function(W,X,Q){return q(W,X,"<",Q)},e.gtr=function(W,X,Q){return q(W,X,">",Q)},e.outside=q,e.prerelease=function(W,X){var Q=oe(W,X);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(W,X,Q){return W=new Re(W,Q),X=new Re(X,Q),W.intersects(X)},e.coerce=function(W){if(W instanceof Pe)return W;if(typeof W!="string")return null;var X=W.match(b[D]);return X==null?null:oe((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,l(1))},function(he,e){var l,O,L=he.exports={};function A(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function b(f){if(l===setTimeout)return setTimeout(f,0);if((l===A||!l)&&setTimeout)return l=setTimeout,setTimeout(f,0);try{return l(f,0)}catch{try{return l.call(null,f,0)}catch{return l.call(this,f,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:A}catch{l=A}try{O=typeof clearTimeout=="function"?clearTimeout:M}catch{O=M}})();var $,E=[],I=!1,P=-1;function p(){I&&$&&(I=!1,$.length?E=$.concat(E):P=-1,E.length&&S())}function S(){if(!I){var f=b(p);I=!0;for(var a=E.length;a;){for($=E,E=[];++P<a;)$&&$[P].run();P=-1,a=E.length}$=null,I=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===M||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(f)}}function v(f,a){this.fun=f,this.array=a}function d(){}L.nextTick=function(f){var a=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)a[n-1]=arguments[n];E.push(new v(f,a)),E.length!==1||I||b(S)},v.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=d,L.addListener=d,L.once=d,L.off=d,L.removeListener=d,L.removeAllListeners=d,L.emit=d,L.prependListener=d,L.prependOnceListener=d,L.listeners=function(f){return[]},L.binding=function(f){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(f){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ke[40],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const l=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(A){return new O(A)}constructor(A){this.c=l&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=O}),define(ke[4],De([1,0,13,75,3,76,40]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=S;const b=!1,$=!1,E=!1;var I;(function(R){R.None=()=>L.$Uc.None;function T(Re){if(E){const{onDidAddListener:me}=Re,Ie=d.create();let Ae=0;Re.onDidAddListener=()=>{++Ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ie.print()),me?.()}}}function j(Re,me){return Z(Re,()=>{},0,void 0,!0,void 0,me)}R.defer=j;function z(Re){return(me,Ie=null,Ae)=>{let ze=!1,q;return q=Re(W=>{if(!ze)return q?q.dispose():ze=!0,me.call(Ie,W)},null,Ae),ze&&q.dispose(),q}}R.once=z;function N(Re,me,Ie){return K((Ae,ze=null,q)=>Re(W=>Ae.call(ze,me(W)),null,q),Ie)}R.map=N;function F(Re,me,Ie){return K((Ae,ze=null,q)=>Re(W=>{me(W),Ae.call(ze,W)},null,q),Ie)}R.forEach=F;function B(Re,me,Ie){return K((Ae,ze=null,q)=>Re(W=>me(W)&&Ae.call(ze,W),null,q),Ie)}R.filter=B;function Y(Re){return Re}R.signal=Y;function re(...Re){return(me,Ie=null,Ae)=>{const ze=(0,L.$Rc)(...Re.map(q=>q(W=>me.call(Ie,W))));return _(ze,Ae)}}R.any=re;function H(Re,me,Ie,Ae){let ze=Ie;return N(Re,q=>(ze=me(ze,q),ze),Ae)}R.reduce=H;function K(Re,me){let Ie;const Ae={onWillAddFirstListener(){Ie=Re(ze.fire,ze)},onDidRemoveLastListener(){Ie?.dispose()}};me||T(Ae);const ze=new r(Ae);return me?.add(ze),ze.event}function _(Re,me){return me instanceof Array?me.push(Re):me&&me.add(Re),Re}function Z(Re,me,Ie=100,Ae=!1,ze=!1,q,W){let X,Q,de,we=0,Te;const qe={leakWarningThreshold:q,onWillAddFirstListener(){X=Re(tt=>{we++,Q=me(Q,tt),Ae&&!de&&(Xe.fire(Q),Q=void 0),Te=()=>{const et=Q;Q=void 0,de=void 0,(!Ae||we>1)&&Xe.fire(et),we=0},typeof Ie=="number"?(clearTimeout(de),de=setTimeout(Te,Ie)):de===void 0&&(de=0,queueMicrotask(Te))})},onWillRemoveListener(){ze&&we>0&&Te?.()},onDidRemoveLastListener(){Te=void 0,X.dispose()}};W||T(qe);const Xe=new r(qe);return W?.add(Xe),Xe.event}R.debounce=Z;function $e(Re,me=0,Ie){return R.debounce(Re,(Ae,ze)=>Ae?(Ae.push(ze),Ae):[ze],me,void 0,!0,void 0,Ie)}R.accumulate=$e;function oe(Re,me=(Ae,ze)=>Ae===ze,Ie){let Ae=!0,ze;return B(Re,q=>{const W=Ae||!me(q,ze);return Ae=!1,ze=q,W},Ie)}R.latch=oe;function Pe(Re,me,Ie){return[R.filter(Re,me,Ie),R.filter(Re,Ae=>!me(Ae),Ie)]}R.split=Pe;function te(Re,me=!1,Ie=[],Ae){let ze=Ie.slice(),q=Re(Q=>{ze?ze.push(Q):X.fire(Q)});Ae&&Ae.add(q);const W=()=>{ze?.forEach(Q=>X.fire(Q)),ze=null},X=new r({onWillAddFirstListener(){q||(q=Re(Q=>X.fire(Q)),Ae&&Ae.add(q))},onDidAddFirstListener(){ze&&(me?setTimeout(W):W())},onDidRemoveLastListener(){q&&q.dispose(),q=null}});return Ae&&Ae.add(X),X.event}R.buffer=te;function U(Re,me){return(Ae,ze,q)=>{const W=me(new be);return Re(function(X){const Q=W.evaluate(X);Q!==ee&&Ae.call(ze,Q)},void 0,q)}}R.chain=U;const ee=Symbol("HaltChainable");class be{constructor(){this.f=[]}map(me){return this.f.push(me),this}forEach(me){return this.f.push(Ie=>(me(Ie),Ie)),this}filter(me){return this.f.push(Ie=>me(Ie)?Ie:ee),this}reduce(me,Ie){let Ae=Ie;return this.f.push(ze=>(Ae=me(Ae,ze),Ae)),this}latch(me=(Ie,Ae)=>Ie===Ae){let Ie=!0,Ae;return this.f.push(ze=>{const q=Ie||!me(ze,Ae);return Ie=!1,Ae=ze,q?ze:ee}),this}evaluate(me){for(const Ie of this.f)if(me=Ie(me),me===ee)break;return me}}function ue(Re,me,Ie=Ae=>Ae){const Ae=(...X)=>W.fire(Ie(...X)),ze=()=>Re.on(me,Ae),q=()=>Re.removeListener(me,Ae),W=new r({onWillAddFirstListener:ze,onDidRemoveLastListener:q});return W.event}R.fromNodeEventEmitter=ue;function ce(Re,me,Ie=Ae=>Ae){const Ae=(...X)=>W.fire(Ie(...X)),ze=()=>Re.addEventListener(me,Ae),q=()=>Re.removeEventListener(me,Ae),W=new r({onWillAddFirstListener:ze,onDidRemoveLastListener:q});return W.event}R.fromDOMEventEmitter=ce;function ae(Re){return new Promise(me=>z(Re)(me))}R.toPromise=ae;function le(Re){const me=new r;return Re.then(Ie=>{me.fire(Ie)},()=>{me.fire(void 0)}).finally(()=>{me.dispose()}),me.event}R.fromPromise=le;function J(Re,me,Ie){return me(Ie),Re(Ae=>me(Ae))}R.runAndSubscribe=J;class se{constructor(me,Ie){this._observable=me,this.f=0,this.g=!1;const Ae={onWillAddFirstListener:()=>{me.addObserver(this)},onDidRemoveLastListener:()=>{me.removeObserver(this)}};Ie||T(Ae),this.emitter=new r(Ae),Ie&&Ie.add(this.emitter)}beginUpdate(me){this.f++}handlePossibleChange(me){}handleChange(me,Ie){this.g=!0}endUpdate(me){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function pe(Re,me){return new se(Re,me).emitter.event}R.fromObservable=pe;function ve(Re){return(me,Ie,Ae)=>{let ze=0,q=!1;const W={beginUpdate(){ze++},endUpdate(){ze--,ze===0&&(Re.reportChanges(),q&&(q=!1,me.call(Ie)))},handlePossibleChange(){},handleChange(){q=!0}};Re.addObserver(W),Re.reportChanges();const X={dispose(){Re.removeObserver(W)}};return Ae instanceof L.$Tc?Ae.add(X):Array.isArray(Ae)&&Ae.push(X),X}}R.fromObservableLight=ve})(I||(e.Event=I={}));class P{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${P.f++}`,P.all.add(this)}start(T){this.g=new M.$be,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}e.$de=P;let p=-1;function S(R){const T=p;return p=R,{dispose(){p=T}}}class v{constructor(T,j=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=j,this.g=0}dispose(){this.f?.clear()}check(T,j){const z=this.threshold;if(z<=0||j<z)return;this.f||(this.f=new Map);const N=this.f.get(T.value)||0;if(this.f.set(T.value,N+1),this.g-=1,this.g<=0){this.g=z*.5;let F,B=0;for(const[Y,re]of this.f)(!F||B<re)&&(F=Y,B=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${j} listeners already. MOST frequent listener (${B}):`),console.warn(F)}return()=>{const F=this.f.get(T.value)||0;this.f.set(T.value,F-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class a{constructor(T){this.value=T,this.id=f++}}const n=2,i=(R,T)=>{if(R instanceof a)T(R);else for(let j=0;j<R.length;j++){const z=R[j];z&&T(z)}},c=b?new FinalizationRegistry(R=>{typeof R=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(R))}):void 0;class r{constructor(T){this.w=0,this.f=T,this.g=p>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const T=this.t;queueMicrotask(()=>{i(T,j=>j.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,j,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;j&&(T=T.bind(j));const N=new a(T);let F,B;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=d.create(),F=this.g.check(N.stack,this.w+1)),$&&(N.stack=B??d.create()),this.t?this.t instanceof a?(this.u??=new u,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const Y=(0,L.$Sc)(()=>{c?.unregister(Y),F?.(),this.x(N)});if(z instanceof L.$Tc?z.add(Y):Array.isArray(z)&&z.push(Y),c){const re=new Error().stack.split(`
`).slice(2).join(`
`).trim();c.register(Y,re,Y)}return Y},this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const j=this.t,z=j.indexOf(T);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,j[z]=void 0;const N=this.u.current===this;if(this.w*n<=j.length){let F=0;for(let B=0;B<j.length;B++)j[B]?j[F++]=j[B]:N&&(this.u.end--,F<this.u.i&&this.u.i--);j.length=F}}y(T,j){if(!T)return;const z=this.f?.onListenerError||l.$1;if(!z){T.value(j);return}try{T.value(j)}catch(N){z(N)}}z(T){const j=T.current.t;for(;T.i<T.end;)this.y(j[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,T);else{const j=this.u;j.enqueue(this,T,this.t.length),this.z(j)}this.j?.stop()}hasListeners(){return this.w>0}}e.$fe=r;const t=()=>new u;e.$ge=t;class u{constructor(){this.i=-1,this.end=0}enqueue(T,j,z){this.i=0,this.end=z,this.current=T,this.value=j}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends r{async fireAsync(T,j,z){if(this.t)for(this.h||(this.h=new A.$5c),i(this.t,N=>this.h.push([N.value,T]));this.h.size>0&&!j.isCancellationRequested;){const[N,F]=this.h.shift(),B=[],Y={...F,token:j,waitUntil:re=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");z&&(re=z(re,N)),B.push(re)}};try{N(Y)}catch(re){(0,l.$1)(re);continue}Object.freeze(B),await Promise.allSettled(B).then(re=>{for(const H of re)H.status==="rejected"&&(0,l.$1)(H.reason)})}}}e.$he=s;class o extends r{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new A.$5c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}e.$ie=o;class h extends o{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}e.$je=h;class g extends r{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(j=>super.fire(j)),this.h=[]}))}}e.$ke=g;class w{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const j={event:T,listener:null};this.h.push(j),this.g&&this.m(j);const z=()=>{this.g&&this.o(j);const N=this.h.indexOf(j);this.h.splice(N,1)};return(0,L.$Sc)((0,O.$db)(z))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(j=>this.f.fire(j))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}e.$le=w;class k{constructor(T,j,z,N){this.f=new L.$Tc;const F=this.f.add(new w),B=this.f.add(new L.$4c);function Y(re){B.set(re,F.add(N(re)))}for(const re of T)Y(re);this.f.add(j(re=>{Y(re)})),this.f.add(z(re=>{B.deleteAndDispose(re)})),this.event=F.event}dispose(){this.f.dispose()}}e.$me=k;class m{constructor(){this.f=[]}wrapEvent(T,j,z){return(N,F,B)=>T(Y=>{const re=this.f[this.f.length-1];if(!j){re?re.buffers.push(()=>N.call(F,Y)):N.call(F,Y);return}const H=re;if(!H){N.call(F,j(z,Y));return}H.items??=[],H.items.push(Y),H.buffers.length===0&&re.buffers.push(()=>{H.reducedResult??=z?H.items.reduce(j,z):H.items.reduce(j),N.call(F,H.reducedResult)})},void 0,B)}bufferEvents(T){const j={buffers:new Array};this.f.push(j);const z=T();return this.f.pop(),j.buffers.forEach(N=>N()),z}}e.$ne=m;class y{constructor(){this.f=!1,this.g=I.None,this.h=L.$Uc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$oe=y;class D{static const(T){return new C(T)}constructor(T){this.g=T,this.f=new r,this.onDidChange=this.f.event}get value(){return this.g}set value(T){T!==this.g&&(this.g=T,this.f.fire(void 0))}}e.$pe=D;class C{constructor(T){this.value=T,this.onDidChange=I.None}}}),define(ke[21],De([1,0,4]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=e.CancellationToken=void 0,e.$re=b;const O=Object.freeze(function($,E){const I=setTimeout($.bind(E),0);return{dispose(){clearTimeout(I)}}});var L;(function($){function E(I){return I===$.None||I===$.Cancelled||I instanceof A?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}$.isCancellationToken=E,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(L||(e.CancellationToken=L={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new l.$fe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=L.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=L.None}}e.$qe=M;function b($){const E=new M;return $.add({dispose(){E.cancel()}}),E.token}}),define(ke[173],De([1,0,21]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=e.$3e=void 0,e.$4e=L;class O{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new l.$qe,E=this.b($.token);return this.a={promise:E,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$3e=O;function L(b){return b}class A{constructor($,E){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=L):(this.c=E,this.d=$.getCacheKey)}get($){const E=this.d($);return this.b!==E&&(this.b=E,this.a=this.c($)),this.a}}e.$5e=A;class M{get cachedValues(){return this.a}constructor($,E){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=L):(this.c=E,this.d=$.getCacheKey)}get($){const E=this.d($);if(this.b.has(E))return this.b.get(E);const I=this.c($);return this.a.set($,I),this.b.set(E,I),I}}e.$6e=M}),define(ke[98],De([1,0,13,3]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=L,e.$te=A,e.$ue=M,e.$ve=b,e.$we=E,e.$xe=I,e.$ye=P,e.$ze=p,e.$Ae=S,e.$Be=v,e.$Ce=d,e.$De=f,e.$Ee=a,e.$Fe=n,e.$Ge=i;function L(c){const r=c;return r?typeof r.read=="function":!1}function A(c){const r=c;return r?[r.on,r.pause,r.resume,r.destroy].every(t=>typeof t=="function"):!1}function M(c){const r=c;return r?A(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}function b(c,r){return new $(c,r)}class ${constructor(r,t){this.e=r,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(r){if(!this.a.destroyed){if(this.a.flowing)this.g(r);else if(this.b.data.push(r),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(r){this.a.destroyed||(this.a.flowing?this.h(r):this.b.error.push(r))}end(r){this.a.destroyed||(typeof r<"u"&&this.write(r),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(r){this.c.data.slice(0).forEach(t=>t(r))}h(r){this.c.error.length===0?(0,l.$1)(r):this.c.error.slice(0).forEach(t=>t(r))}i(){this.c.end.slice(0).forEach(r=>r())}on(r,t){if(!this.a.destroyed)switch(r){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(r,t){if(this.a.destroyed)return;let u;switch(r){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const s=u.indexOf(t);s>=0&&u.splice(s,1)}}j(){if(this.b.data.length>0){const r=this.e(this.b.data);this.g(r),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const r of this.b.error)this.h(r);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,r){const t=[];let u;for(;(u=c.read())!==null;)t.push(u);return r(t)}function I(c,r,t){const u=[];let s;for(;(s=c.read())!==null&&u.length<t;)u.push(s);return s===null&&u.length>0?r(u):{read:()=>{if(u.length>0)return u.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return c.read()}}}function P(c,r){return new Promise((t,u)=>{const s=[];p(c,{onData:o=>{r&&s.push(o)},onError:o=>{r?u(o):t(void 0)},onEnd:()=>{t(r?r(s):void 0)}})})}function p(c,r,t){c.on("error",u=>{t?.isCancellationRequested||r.onError(u)}),c.on("end",()=>{t?.isCancellationRequested||r.onEnd()}),c.on("data",u=>{t?.isCancellationRequested||r.onData(u)})}function S(c,r){return new Promise((t,u)=>{const s=new O.$Tc,o=[],h=k=>{if(o.push(k),o.length>r)return s.dispose(),c.pause(),t({stream:c,buffer:o,ended:!1})},g=k=>(s.dispose(),u(k)),w=()=>(s.dispose(),t({stream:c,buffer:o,ended:!0}));s.add((0,O.$Sc)(()=>c.removeListener("error",g))),c.on("error",g),s.add((0,O.$Sc)(()=>c.removeListener("end",w))),c.on("end",w),s.add((0,O.$Sc)(()=>c.removeListener("data",h))),c.on("data",h)})}function v(c,r){const t=b(r);return t.end(c),t}function d(){const c=b(()=>{throw new Error("not supported")});return c.end(),c}function f(c){let r=!1;return{read:()=>r?null:(r=!0,c)}}function a(c,r,t){const u=b(t);return p(c,{onData:s=>u.write(r.data(s)),onError:s=>u.error(r.error?r.error(s):s),onEnd:()=>u.end()}),u}function n(c,r,t){let u=!1;return{read:()=>{const s=r.read();return u?s:(u=!0,s!==null?t([c,s]):c)}}}function i(c,r,t){let u=!1;const s=b(t);return p(r,{onData:o=>u?s.write(o):(u=!0,s.write(t([c,o]))),onError:o=>s.error(o),onEnd:()=>{u||(u=!0,s.write(c)),s.end()}}),s}}),define(ke[22],De([1,0,46,98]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=E,e.$Je=I,e.$Ke=P,e.$Le=p,e.$Me=S,e.$Ne=v,e.$Oe=d,e.$Pe=f,e.$Qe=a,e.$Re=n,e.$Se=i,e.$Te=c,e.$Ue=r,e.$Ve=t,e.$We=u,e.$Xe=s,e.$Ye=o,e.$Ze=h,e.$1e=g,e.$2e=m;const L=typeof Buffer<"u",A=new l.$V(()=>new Uint8Array(256));let M,b;class ${static alloc(D){return L?new $(Buffer.allocUnsafe(D)):new $(new Uint8Array(D))}static wrap(D){return L&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new $(D)}static fromString(D,C){return!(C?.dontUseNodeBuffer||!1)&&L?new $(Buffer.from(D)):(M||(M=new TextEncoder),new $(M.encode(D)))}static fromByteArray(D){const C=$.alloc(D.length);for(let R=0,T=D.length;R<T;R++)C.buffer[R]=D[R];return C}static concat(D,C){if(typeof C>"u"){C=0;for(let j=0,z=D.length;j<z;j++)C+=D[j].byteLength}const R=$.alloc(C);let T=0;for(let j=0,z=D.length;j<z;j++){const N=D[j];R.set(N,T),T+=N.byteLength}return R}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=$.alloc(this.byteLength);return D.set(this),D}toString(){return L?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(D,C){return new $(this.buffer.subarray(D,C))}set(D,C){if(D instanceof $)this.buffer.set(D.buffer,C);else if(D instanceof Uint8Array)this.buffer.set(D,C);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),C);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return p(this.buffer,D)}writeUInt32BE(D,C){S(this.buffer,D,C)}readUInt32LE(D){return v(this.buffer,D)}writeUInt32LE(D,C){d(this.buffer,D,C)}readUInt8(D){return f(this.buffer,D)}writeUInt8(D,C){a(this.buffer,D,C)}indexOf(D,C=0){return E(this.buffer,D instanceof $?D.buffer:D,C)}}e.$He=$;function E(y,D,C=0){const R=D.byteLength,T=y.byteLength;if(R===0)return 0;if(R===1)return y.indexOf(D[0]);if(R>T-C)return-1;const j=A.value;j.fill(D.length);for(let B=0;B<D.length;B++)j[D[B]]=D.length-B-1;let z=C+D.length-1,N=z,F=-1;for(;z<T;)if(y[z]===D[N]){if(N===0){F=z;break}z--,N--}else z+=Math.max(D.length-N,j[y[z]]),N=D.length-1;return F}function I(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0}function P(y,D,C){y[C+0]=D&255,D=D>>>8,y[C+1]=D&255}function p(y,D){return y[D]*2**24+y[D+1]*2**16+y[D+2]*2**8+y[D+3]}function S(y,D,C){y[C+3]=D,D=D>>>8,y[C+2]=D,D=D>>>8,y[C+1]=D,D=D>>>8,y[C]=D}function v(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0|y[D+2]<<16>>>0|y[D+3]<<24>>>0}function d(y,D,C){y[C+0]=D&255,D=D>>>8,y[C+1]=D&255,D=D>>>8,y[C+2]=D&255,D=D>>>8,y[C+3]=D&255}function f(y,D){return y[D]}function a(y,D,C){y[C]=D}function n(y){return O.$we(y,D=>$.concat(D))}function i(y){return O.$De(y)}function c(y){return O.$ye(y,D=>$.concat(D))}async function r(y){return y.ended?$.concat(y.buffer):$.concat([...y.buffer,await c(y.stream)])}function t(y){return O.$Be(y,D=>$.concat(D))}function u(y){return O.$Ee(y,{data:D=>typeof D=="string"?$.fromString(D):$.wrap(D)},D=>$.concat(D))}function s(y){return O.$ve(D=>$.concat(D),y)}function o(y,D){return O.$Fe(y,D,C=>$.concat(C))}function h(y,D){return O.$Ge(y,D,C=>$.concat(C))}function g(y){let D=0,C=0,R=0;const T=new Uint8Array(Math.floor(y.length/4*3)),j=N=>{switch(C){case 3:T[R++]=D|N,C=0;break;case 2:T[R++]=D|N>>>2,D=N<<6,C=3;break;case 1:T[R++]=D|N>>>4,D=N<<4,C=2;break;default:D=N<<2,C=1}};for(let N=0;N<y.length;N++){const F=y.charCodeAt(N);if(F>=65&&F<=90)j(F-65);else if(F>=97&&F<=122)j(F-97+26);else if(F>=48&&F<=57)j(F-48+52);else if(F===43||F===45)j(62);else if(F===47||F===95)j(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${y[N]}`)}}const z=R;for(;C>0;)j(0);return $.wrap(T).slice(0,z)}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:y},D=!0,C=!1){const R=C?k:w;let T="";const j=y.byteLength%3;let z=0;for(;z<y.byteLength-j;z+=3){const N=y[z+0],F=y[z+1],B=y[z+2];T+=R[N>>>2],T+=R[(N<<4|F>>>4)&63],T+=R[(F<<2|B>>>6)&63],T+=R[B&63]}if(j===1){const N=y[z+0];T+=R[N>>>2],T+=R[N<<4&63],D&&(T+="==")}else if(j===2){const N=y[z+0],F=y[z+1];T+=R[N>>>2],T+=R[(N<<4|F>>>4)&63],T+=R[F<<2&63],D&&(T+="=")}return T}}),define(ke[14],De([1,0,173,46]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.GraphemeBreakType=e.$Xf=e.$Pf=e.$If=e.$Hf=void 0,e.$9e=L,e.$0e=M,e.$$e=$,e.$_e=E,e.$af=I,e.$bf=P,e.$cf=p,e.$df=S,e.$ef=v,e.$ff=d,e.$gf=f,e.$hf=a,e.$if=n,e.$jf=i,e.$kf=c,e.$lf=r,e.$mf=t,e.$nf=u,e.$of=s,e.$pf=o,e.$qf=h,e.$rf=g,e.$sf=w,e.$tf=k,e.$uf=m,e.$vf=y,e.$wf=D,e.$xf=C,e.$yf=R,e.$zf=T,e.$Af=j,e.$Bf=z,e.$Cf=N,e.$Df=F,e.$Ef=B,e.$Ff=Y,e.$Gf=re,e.$Jf=Z,e.$Kf=$e,e.$Lf=oe,e.$Mf=Pe,e.$Nf=ee,e.$Of=ue,e.$Qf=ce,e.$Rf=ae,e.$Sf=le,e.$Tf=J,e.$Uf=pe,e.$Vf=ve,e.$Wf=me,e.$Yf=Ie,e.$Zf=Ae,e.$1f=ze,e.$2f=q,e.$3f=W,e.$4f=X,e.$5f=Q,e.$6f=de,e.$7f=tt;function L(Me){return!Me||typeof Me!="string"?!0:Me.trim().length===0}const A=/{(\d+)}/g;function M(Me,...ye){return ye.length===0?Me:Me.replace(A,function(Ve,ne){const ie=parseInt(ne,10);return isNaN(ie)||ie<0||ie>=ye.length?Ve:ye[ie]})}const b=/{([^}]+)}/g;function $(Me,ye){return Object.keys(ye).length===0?Me:Me.replace(b,(Ve,ne)=>ye[ne]??Ve)}function E(Me){return Me.replace(/[<>"'&]/g,ye=>{switch(ye){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ye})}function I(Me){return Me.replace(/[<>&]/g,function(ye){switch(ye){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ye}})}function P(Me){return Me.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Me,ye){let Ve=0,ne=Me.indexOf(ye);for(;ne!==-1;)Ve++,ne=Me.indexOf(ye,ne+ye.length);return Ve}function S(Me,ye,Ve="\u2026"){return Me.length<=ye?Me:`${Me.substr(0,ye)}${Ve}`}function v(Me,ye,Ve="\u2026"){if(Me.length<=ye)return Me;const ne=Math.ceil(ye/2)-Ve.length/2,ie=Math.floor(ye/2)-Ve.length/2;return`${Me.substr(0,ne)}${Ve}${Me.substr(Me.length-ie)}`}function d(Me,ye=" "){const Ve=f(Me,ye);return a(Ve,ye)}function f(Me,ye){if(!Me||!ye)return Me;const Ve=ye.length;if(Ve===0||Me.length===0)return Me;let ne=0;for(;Me.indexOf(ye,ne)===ne;)ne=ne+Ve;return Me.substring(ne)}function a(Me,ye){if(!Me||!ye)return Me;const Ve=ye.length,ne=Me.length;if(Ve===0||ne===0)return Me;let ie=ne,Ce=-1;for(;Ce=Me.lastIndexOf(ye,ie-1),!(Ce===-1||Ce+Ve!==ie);){if(Ce===0)return"";ie=Ce}return Me.substring(0,ie)}function n(Me){return Me.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Me){return Me.replace(/\*/g,"")}function c(Me,ye,Ve={}){if(!Me)throw new Error("Cannot create regex from empty string");ye||(Me=P(Me)),Ve.wholeWord&&(/\B/.test(Me.charAt(0))||(Me="\\b"+Me),/\B/.test(Me.charAt(Me.length-1))||(Me=Me+"\\b"));let ne="";return Ve.global&&(ne+="g"),Ve.matchCase||(ne+="i"),Ve.multiline&&(ne+="m"),Ve.unicode&&(ne+="u"),new RegExp(Me,ne)}function r(Me){return Me.source==="^"||Me.source==="^$"||Me.source==="$"||Me.source==="^\\s*$"?!1:!!(Me.exec("")&&Me.lastIndex===0)}function t(Me){return Me.split(/\r\n|\r|\n/)}function u(Me){const ye=[],Ve=Me.split(/(\r\n|\r|\n)/);for(let ne=0;ne<Math.ceil(Ve.length/2);ne++)ye.push(Ve[2*ne]+(Ve[2*ne+1]??""));return ye}function s(Me){for(let ye=0,Ve=Me.length;ye<Ve;ye++){const ne=Me.charCodeAt(ye);if(ne!==32&&ne!==9)return ye}return-1}function o(Me,ye=0,Ve=Me.length){for(let ne=ye;ne<Ve;ne++){const ie=Me.charCodeAt(ne);if(ie!==32&&ie!==9)return Me.substring(ye,ne)}return Me.substring(ye,Ve)}function h(Me,ye=Me.length-1){for(let Ve=ye;Ve>=0;Ve--){const ne=Me.charCodeAt(Ve);if(ne!==32&&ne!==9)return Ve}return-1}function g(Me,ye,Ve){const ne=[];let ie=0;for(const Ce of Me.matchAll(ye)){if(ne.push(Me.slice(ie,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");ie=Ce.index+Ce[0].length,ne.push(Ve(Ce[0],...Ce.slice(1),Ce.index,Me,Ce.groups))}return ne.push(Me.slice(ie)),Promise.all(ne).then(Ce=>Ce.join(""))}function w(Me,ye){return Me<ye?-1:Me>ye?1:0}function k(Me,ye,Ve=0,ne=Me.length,ie=0,Ce=ye.length){for(;Ve<ne&&ie<Ce;Ve++,ie++){const st=Me.charCodeAt(Ve),ut=ye.charCodeAt(ie);if(st<ut)return-1;if(st>ut)return 1}const Ge=ne-Ve,Le=Ce-ie;return Ge<Le?-1:Ge>Le?1:0}function m(Me,ye){return y(Me,ye,0,Me.length,0,ye.length)}function y(Me,ye,Ve=0,ne=Me.length,ie=0,Ce=ye.length){for(;Ve<ne&&ie<Ce;Ve++,ie++){let st=Me.charCodeAt(Ve),ut=ye.charCodeAt(ie);if(st===ut)continue;if(st>=128||ut>=128)return k(Me.toLowerCase(),ye.toLowerCase(),Ve,ne,ie,Ce);C(st)&&(st-=32),C(ut)&&(ut-=32);const mt=st-ut;if(mt!==0)return mt}const Ge=ne-Ve,Le=Ce-ie;return Ge<Le?-1:Ge>Le?1:0}function D(Me){return Me>=48&&Me<=57}function C(Me){return Me>=97&&Me<=122}function R(Me){return Me>=65&&Me<=90}function T(Me,ye){return Me.length===ye.length&&y(Me,ye)===0}function j(Me,ye){const Ve=ye.length;return ye.length>Me.length?!1:y(Me,ye,0,Ve)===0}function z(Me,ye){const Ve=Math.min(Me.length,ye.length);let ne;for(ne=0;ne<Ve;ne++)if(Me.charCodeAt(ne)!==ye.charCodeAt(ne))return ne;return Ve}function N(Me,ye){const Ve=Math.min(Me.length,ye.length);let ne;const ie=Me.length-1,Ce=ye.length-1;for(ne=0;ne<Ve;ne++)if(Me.charCodeAt(ie-ne)!==ye.charCodeAt(Ce-ne))return ne;return Ve}function F(Me){return 55296<=Me&&Me<=56319}function B(Me){return 56320<=Me&&Me<=57343}function Y(Me,ye){return(Me-55296<<10)+(ye-56320)+65536}function re(Me,ye,Ve){const ne=Me.charCodeAt(Ve);if(F(ne)&&Ve+1<ye){const ie=Me.charCodeAt(Ve+1);if(B(ie))return Y(ne,ie)}return ne}function H(Me,ye){const Ve=Me.charCodeAt(ye-1);if(B(Ve)&&ye>1){const ne=Me.charCodeAt(ye-2);if(F(ne))return Y(ne,Ve)}return Ve}class K{get offset(){return this.e}constructor(ye,Ve=0){this.c=ye,this.d=ye.length,this.e=Ve}setOffset(ye){this.e=ye}prevCodePoint(){const ye=H(this.c,this.e);return this.e-=ye>=65536?2:1,ye}nextCodePoint(){const ye=re(this.c,this.d,this.e);return this.e+=ye>=65536?2:1,ye}eol(){return this.e>=this.d}}e.$Hf=K;class _{get offset(){return this.c.offset}constructor(ye,Ve=0){this.c=new K(ye,Ve)}nextGraphemeLength(){const ye=qe.getInstance(),Ve=this.c,ne=Ve.offset;let ie=ye.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const Ce=Ve.offset,Ge=ye.getGraphemeBreakType(Ve.nextCodePoint());if(we(ie,Ge)){Ve.setOffset(Ce);break}ie=Ge}return Ve.offset-ne}prevGraphemeLength(){const ye=qe.getInstance(),Ve=this.c,ne=Ve.offset;let ie=ye.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const Ce=Ve.offset,Ge=ye.getGraphemeBreakType(Ve.prevCodePoint());if(we(Ge,ie)){Ve.setOffset(Ce);break}ie=Ge}return ne-Ve.offset}eol(){return this.c.eol()}}e.$If=_;function Z(Me,ye){return new _(Me,ye).nextGraphemeLength()}function $e(Me,ye){return new _(Me,ye).prevGraphemeLength()}function oe(Me,ye){ye>0&&B(Me.charCodeAt(ye))&&ye--;const Ve=ye+Z(Me,ye);return[Ve-$e(Me,Ve),Ve]}function Pe(Me){const ye=new _(Me);let Ve=0;for(;!ye.eol();)Ve++,ye.nextGraphemeLength();return Ve}let te;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ee(Me){return te||(te=U()),te.test(Me)}const be=/^[\t\n\r\x20-\x7E]*$/;function ue(Me){return be.test(Me)}e.$Pf=/[\u2028\u2029]/;function ce(Me){return e.$Pf.test(Me)}function ae(Me){return Me>=11904&&Me<=55215||Me>=63744&&Me<=64255||Me>=65281&&Me<=65374}function le(Me){return Me>=127462&&Me<=127487||Me===8986||Me===8987||Me===9200||Me===9203||Me>=9728&&Me<=10175||Me===11088||Me===11093||Me>=127744&&Me<=128591||Me>=128640&&Me<=128764||Me>=128992&&Me<=129008||Me>=129280&&Me<=129535||Me>=129648&&Me<=129782}function J(Me,ye,Ve=""){const ne=Me.trimStart();if(ne.length<ye)return ne;const ie=/\b/g;let Ce=0;for(;ie.test(ne)&&!(ne.length-ie.lastIndex<ye);)Ce=ie.lastIndex,ie.lastIndex+=1;return Ce===0?ne:Ve+ne.substring(Ce).trimStart()}const se=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(Me){let ye=0;for(const Ve of Me.matchAll(se))ye!==Ve.index&&(yield{isCode:!1,str:Me.substring(ye,Ve.index)}),yield{isCode:!0,str:Ve[0]},ye=Ve.index+Ve[0].length;ye!==Me.length&&(yield{isCode:!1,str:Me.substring(ye)})}function ve(Me){return Me&&(Me=Me.replace(se,"")),Me}const Re=/\\\[.*?\\\]/g;function me(Me){return ve(Me).replace(Re,"")}e.$Xf="\uFEFF";function Ie(Me){return!!(Me&&Me.length>0&&Me.charCodeAt(0)===65279)}function Ae(Me){return Ie(Me)?Me.substr(1):Me}function ze(Me,ye){if(!Me||!ye||Me.length<ye.length)return!1;const Ve=ye.length,ne=Me.toLowerCase();let ie=0,Ce=-1;for(;ie<Ve;){const Ge=ne.indexOf(ye[ie],Ce+1);if(Ge<0)return!1;Ce=Ge,ie++}return!0}function q(Me,ye=!1){return Me?(ye&&(Me=Me.replace(/\\./g,"")),Me.toLowerCase()!==Me):!1}function W(Me){return Me.charAt(0).toUpperCase()+Me.slice(1)}function X(Me,ye=1){if(ye===0)return"";let Ve=-1;do Ve=Me.indexOf(`
`,Ve+1),ye--;while(ye>0&&Ve>=0);return Ve===-1?Me:(Me[Ve-1]==="\r"&&Ve--,Me.substr(0,Ve))}function Q(Me){return Me=Me%(2*26),Me<26?String.fromCharCode(97+Me):String.fromCharCode(65+Me-26)}function de(Me){return qe.getInstance().getGraphemeBreakType(Me)}function we(Me,ye){return Me===0?ye!==5&&ye!==7:Me===2&&ye===3?!1:Me===4||Me===2||Me===3||ye===4||ye===2||ye===3?!0:!(Me===8&&(ye===8||ye===9||ye===11||ye===12)||(Me===11||Me===9)&&(ye===9||ye===10)||(Me===12||Me===10)&&ye===10||ye===5||ye===13||ye===7||Me===1||Me===13&&ye===14||Me===6&&ye===6)}var Te;(function(Me){Me[Me.Other=0]="Other",Me[Me.Prepend=1]="Prepend",Me[Me.CR=2]="CR",Me[Me.LF=3]="LF",Me[Me.Control=4]="Control",Me[Me.Extend=5]="Extend",Me[Me.Regional_Indicator=6]="Regional_Indicator",Me[Me.SpacingMark=7]="SpacingMark",Me[Me.L=8]="L",Me[Me.V=9]="V",Me[Me.T=10]="T",Me[Me.LV=11]="LV",Me[Me.LVT=12]="LVT",Me[Me.ZWJ=13]="ZWJ",Me[Me.Extended_Pictographic=14]="Extended_Pictographic"})(Te||(e.GraphemeBreakType=Te={}));class qe{static{this.c=null}static getInstance(){return qe.c||(qe.c=new qe),qe.c}constructor(){this.d=Xe()}getGraphemeBreakType(ye){if(ye<32)return ye===10?3:ye===13?2:4;if(ye<127)return 0;const Ve=this.d,ne=Ve.length/3;let ie=1;for(;ie<=ne;)if(ye<Ve[3*ie])ie=2*ie;else if(ye>Ve[3*ie+1])ie=2*ie+1;else return Ve[3*ie+2];return 0}}function Xe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(Me,ye){if(Me===0)return 0;const Ve=et(Me,ye);if(Ve!==void 0)return Ve;const ne=new K(ye,Me);return ne.prevCodePoint(),ne.offset}function et(Me,ye){const Ve=new K(ye,Me);let ne=Ve.prevCodePoint();for(;nt(ne)||ne===65039||ne===8419;){if(Ve.offset===0)return;ne=Ve.prevCodePoint()}if(!le(ne))return;let ie=Ve.offset;return ie>0&&Ve.prevCodePoint()===8205&&(ie=Ve.offset),ie}function nt(Me){return 127995<=Me&&Me<=127999}var it;(function(Me){Me[Me.zwj=8205]="zwj",Me[Me.emojiVariantSelector=65039]="emojiVariantSelector",Me[Me.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.$8f="\xA0";class rt{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new l.$5e({getCacheKey:JSON.stringify},ye=>{function Ve(mt){const Ct=new Map;for(let Pt=0;Pt<mt.length;Pt+=2)Ct.set(mt[Pt],mt[Pt+1]);return Ct}function ne(mt,Ct){const Pt=new Map(mt);for(const[Bt,Ut]of Ct)Pt.set(Bt,Ut);return Pt}function ie(mt,Ct){if(!mt)return Ct;const Pt=new Map;for(const[Bt,Ut]of mt)Ct.has(Bt)&&Pt.set(Bt,Ut);return Pt}const Ce=this.c.value;let Ge=ye.filter(mt=>!mt.startsWith("_")&&mt in Ce);Ge.length===0&&(Ge=["_default"]);let Le;for(const mt of Ge){const Ct=Ve(Ce[mt]);Le=ie(Le,Ct)}const st=Ve(Ce._common),ut=ne(st,Le);return new rt(ut)})}static getInstance(ye){return rt.d.get(Array.from(ye))}static{this.e=new O.$V(()=>Object.keys(rt.c.value).filter(ye=>!ye.startsWith("_")))}static getLocales(){return rt.e.value}constructor(ye){this.f=ye}isAmbiguous(ye){return this.f.has(ye)}getPrimaryConfusable(ye){return this.f.get(ye)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$9f=rt;class at{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(at.c())),this.d}static isInvisibleCharacter(ye){return at.e().has(ye)}static get codePoints(){return at.e()}}e.$0f=at}),define(ke[127],De([1,0,27,168,14]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.FuzzyScore=e.$Ak=e.$zk=void 0,e.or=A,e.$Bk=b,e.$Ck=$,e.$Dk=P,e.$Ek=g,e.$Fk=w,e.$Gk=R,e.$Hk=T,e.$Ik=j,e.$Jk=z,e.$Kk=ee,e.$Mk=ae,e.$Nk=se,e.$Ok=pe;function A(...me){return function(Ie,Ae){for(let ze=0,q=me.length;ze<q;ze++){const W=me[ze](Ie,Ae);if(W)return W}return null}}e.$zk=M.bind(void 0,!1),e.$Ak=M.bind(void 0,!0);function M(me,Ie,Ae){if(!Ae||Ae.length<Ie.length)return null;let ze;return me?ze=L.$Af(Ae,Ie):ze=Ae.indexOf(Ie)===0,ze?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function b(me,Ie){const Ae=Ie.toLowerCase().indexOf(me.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+me.length}]}function $(me,Ie){return E(me.toLowerCase(),Ie.toLowerCase(),0,0)}function E(me,Ie,Ae,ze){if(Ae===me.length)return[];if(ze===Ie.length)return null;if(me[Ae]===Ie[ze]){let q=null;return(q=E(me,Ie,Ae+1,ze+1))?c({start:ze,end:ze+1},q):null}return E(me,Ie,Ae,ze+1)}function I(me){return 97<=me&&me<=122}function P(me){return 65<=me&&me<=90}function p(me){return 48<=me&&me<=57}function S(me){return me===32||me===9||me===10||me===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(me=>v.add(me.charCodeAt(0)));function d(me){return S(me)||v.has(me)}function f(me,Ie){return me===Ie||d(me)&&d(Ie)}const a=new Map;function n(me){if(a.has(me))return a.get(me);let Ie;const Ae=(0,O.$xk)(me);return Ae&&(Ie=Ae),a.set(me,Ie),Ie}function i(me){return I(me)||P(me)||p(me)}function c(me,Ie){return Ie.length===0?Ie=[me]:me.end===Ie[0].start?Ie[0].start=me.start:Ie.unshift(me),Ie}function r(me,Ie){for(let Ae=Ie;Ae<me.length;Ae++){const ze=me.charCodeAt(Ae);if(P(ze)||p(ze)||Ae>0&&!i(me.charCodeAt(Ae-1)))return Ae}return me.length}function t(me,Ie,Ae,ze){if(Ae===me.length)return[];if(ze===Ie.length)return null;if(me[Ae]!==Ie[ze].toLowerCase())return null;{let q=null,W=ze+1;for(q=t(me,Ie,Ae+1,ze+1);!q&&(W=r(Ie,W))<Ie.length;)q=t(me,Ie,Ae+1,W),W++;return q===null?null:c({start:ze,end:ze+1},q)}}function u(me){let Ie=0,Ae=0,ze=0,q=0,W=0;for(let Te=0;Te<me.length;Te++)W=me.charCodeAt(Te),P(W)&&Ie++,I(W)&&Ae++,i(W)&&ze++,p(W)&&q++;const X=Ie/me.length,Q=Ae/me.length,de=ze/me.length,we=q/me.length;return{upperPercent:X,lowerPercent:Q,alphaPercent:de,numericPercent:we}}function s(me){const{upperPercent:Ie,lowerPercent:Ae}=me;return Ae===0&&Ie>.6}function o(me){const{upperPercent:Ie,lowerPercent:Ae,alphaPercent:ze,numericPercent:q}=me;return Ae>.2&&Ie<.8&&ze>.6&&q<.2}function h(me){let Ie=0,Ae=0,ze=0,q=0;for(let W=0;W<me.length;W++)ze=me.charCodeAt(W),P(ze)&&Ie++,I(ze)&&Ae++,S(ze)&&q++;return(Ie===0||Ae===0)&&q===0?me.length<=30:Ie<=5}function g(me,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!h(me))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Ae=u(Ie);if(!o(Ae)){if(!s(Ae))return null;Ie=Ie.toLowerCase()}let ze=null,q=0;for(me=me.toLowerCase();q<Ie.length&&(ze=t(me,Ie,0,q))===null;)q=r(Ie,q+1);return ze}function w(me,Ie,Ae=!1){if(!Ie||Ie.length===0)return null;let ze=null,q=0;for(me=me.toLowerCase(),Ie=Ie.toLowerCase();q<Ie.length&&(ze=k(me,Ie,0,q,Ae),ze===null);)q=m(Ie,q+1);return ze}function k(me,Ie,Ae,ze,q){let W=0;if(Ae===me.length)return[];if(ze===Ie.length)return null;if(!f(me.charCodeAt(Ae),Ie.charCodeAt(ze))){const de=n(me.charCodeAt(Ae));if(!de)return null;for(let we=0;we<de.length;we++)if(!f(de[we],Ie.charCodeAt(ze+we)))return null;W+=de.length-1}let X=null,Q=ze+W+1;if(X=k(me,Ie,Ae+1,Q,q),!q)for(;!X&&(Q=m(Ie,Q))<Ie.length;)X=k(me,Ie,Ae+1,Q,q),Q++;if(!X)return null;if(me.charCodeAt(Ae)!==Ie.charCodeAt(ze)){const de=n(me.charCodeAt(Ae));if(!de)return X;for(let we=0;we<de.length;we++)if(de[we]!==Ie.charCodeAt(ze+we))return X}return c({start:ze,end:ze+W+1},X)}function m(me,Ie){for(let Ae=Ie;Ae<me.length;Ae++)if(d(me.charCodeAt(Ae))||Ae>0&&d(me.charCodeAt(Ae-1)))return Ae;return me.length}const y=A(e.$Ak,g,b),D=A(e.$Ak,g,$),C=new l.$Dc(1e4);function R(me,Ie,Ae=!1){if(typeof me!="string"||typeof Ie!="string")return null;let ze=C.get(me);ze||(ze=new RegExp(L.$if(me),"i"),C.set(me,ze));const q=ze.exec(Ie);return q?[{start:q.index,end:q.index+q[0].length}]:Ae?D(me,Ie):y(me,Ie)}function T(me,Ie){const Ae=ae(me,me.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?z(Ae):null}function j(me,Ie,Ae,ze,q,W){const X=Math.min(13,me.length);for(;Ae<X;Ae++){const Q=ae(me,Ie,Ae,ze,q,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,W]}function z(me){if(typeof me>"u")return[];const Ie=[],Ae=me[1];for(let ze=me.length-1;ze>1;ze--){const q=me[ze]+Ae,W=Ie[Ie.length-1];W&&W.end===q?W.end=q+1:Ie.push({start:q,end:q+1})}return Ie}const N=128;function F(){const me=[],Ie=[];for(let Ae=0;Ae<=N;Ae++)Ie[Ae]=0;for(let Ae=0;Ae<=N;Ae++)me.push(Ie.slice(0));return me}function B(me){const Ie=[];for(let Ae=0;Ae<=me;Ae++)Ie[Ae]=0;return Ie}const Y=B(2*N),re=B(2*N),H=F(),K=F(),_=F(),Z=!1;function $e(me,Ie,Ae,ze,q){function W(Q,de,we=" "){for(;Q.length<de;)Q=we+Q;return Q}let X=` |   |${ze.split("").map(Q=>W(Q,3)).join("|")}
`;for(let Q=0;Q<=Ae;Q++)Q===0?X+=" |":X+=`${Ie[Q-1]}|`,X+=me[Q].slice(0,q+1).map(de=>W(de.toString(),3)).join("|")+`
`;return X}function oe(me,Ie,Ae,ze){me=me.substr(Ie),Ae=Ae.substr(ze),console.log($e(K,me,me.length,Ae,Ae.length)),console.log($e(_,me,me.length,Ae,Ae.length)),console.log($e(H,me,me.length,Ae,Ae.length))}function Pe(me,Ie){if(Ie<0||Ie>=me.length)return!1;const Ae=me.codePointAt(Ie);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Sf(Ae)}}function te(me,Ie){if(Ie<0||Ie>=me.length)return!1;switch(me.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function U(me,Ie,Ae){return Ie[me]!==Ae[me]}function ee(me,Ie,Ae,ze,q,W,X=!1){for(;Ie<Ae&&q<W;)me[Ie]===ze[q]&&(X&&(Y[Ie]=q),Ie+=1),q+=1;return Ie===Ae}var be;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(be||(be={}));var ue;(function(me){me.Default=[-100,0];function Ie(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}me.isDefault=Ie})(ue||(e.FuzzyScore=ue={}));class ce{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Ae){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Ae}}e.$Lk=ce;function ae(me,Ie,Ae,ze,q,W,X=ce.default){const Q=me.length>N?N:me.length,de=ze.length>N?N:ze.length;if(Ae>=Q||W>=de||Q-Ae>de-W||!ee(Ie,Ae,Q,q,W,de,!0))return;le(Q,de,Ae,W,Ie,q);let we=1,Te=1,qe=Ae,Xe=W;const tt=[!1];for(we=1,qe=Ae;qe<Q;we++,qe++){const at=Y[qe],Me=re[qe],ye=qe+1<Q?re[qe+1]:de;for(Te=at-W+1,Xe=at;Xe<ye;Te++,Xe++){let Ve=Number.MIN_SAFE_INTEGER,ne=!1;Xe<=Me&&(Ve=J(me,Ie,qe,Ae,ze,q,Xe,de,W,H[we-1][Te-1]===0,tt));let ie=0;Ve!==Number.MAX_SAFE_INTEGER&&(ne=!0,ie=Ve+K[we-1][Te-1]);const Ce=Xe>at,Ge=Ce?K[we][Te-1]+(H[we][Te-1]>0?-5:0):0,Le=Xe>at+1&&H[we][Te-1]>0,st=Le?K[we][Te-2]+(H[we][Te-2]>0?-5:0):0;if(Le&&(!Ce||st>=Ge)&&(!ne||st>=ie))K[we][Te]=st,_[we][Te]=3,H[we][Te]=0;else if(Ce&&(!ne||Ge>=ie))K[we][Te]=Ge,_[we][Te]=2,H[we][Te]=0;else if(ne)K[we][Te]=ie,_[we][Te]=1,H[we][Te]=H[we-1][Te-1]+1;else throw new Error("not possible")}}if(Z&&oe(me,Ae,ze,W),!tt[0]&&!X.firstMatchCanBeWeak)return;we--,Te--;const et=[K[we][Te],W];let nt=0,it=0;for(;we>=1;){let at=Te;do{const Me=_[we][at];if(Me===3)at=at-2;else if(Me===2)at=at-1;else break}while(at>=1);nt>1&&Ie[Ae+we-1]===q[W+Te-1]&&!U(at+W-1,ze,q)&&nt+1>H[we][at]&&(at=Te),at===Te?nt++:nt=1,it||(it=at),we--,Te=at-1,et.push(Te)}de-W===Q&&X.boostFullMatch&&(et[0]+=2);const rt=it-Q;return et[0]-=rt,et}function le(me,Ie,Ae,ze,q,W){let X=me-1,Q=Ie-1;for(;X>=Ae&&Q>=ze;)q[X]===W[Q]&&(re[X]=Q,X--),Q--}function J(me,Ie,Ae,ze,q,W,X,Q,de,we,Te){if(Ie[Ae]!==W[X])return Number.MIN_SAFE_INTEGER;let qe=1,Xe=!1;return X===Ae-ze?qe=me[Ae]===q[X]?7:5:U(X,q,W)&&(X===0||!U(X-1,q,W))?(qe=me[Ae]===q[X]?7:5,Xe=!0):Pe(W,X)&&(X===0||!Pe(W,X-1))?qe=5:(Pe(W,X-1)||te(W,X-1))&&(qe=5,Xe=!0),qe>1&&Ae===ze&&(Te[0]=!0),Xe||(Xe=U(X,q,W)||Pe(W,X-1)||te(W,X-1)),Ae===ze?X>de&&(qe-=Xe?3:5):we?qe+=Xe?2:0:qe+=Xe?0:1,X+1===Q&&(qe-=Xe?3:5),qe}function se(me,Ie,Ae,ze,q,W,X){return ve(me,Ie,Ae,ze,q,W,!0,X)}function pe(me,Ie,Ae,ze,q,W,X){return ve(me,Ie,Ae,ze,q,W,!1,X)}function ve(me,Ie,Ae,ze,q,W,X,Q){let de=ae(me,Ie,Ae,ze,q,W,Q);if(de&&!X)return de;if(me.length>=3){const we=Math.min(7,me.length-1);for(let Te=Ae+1;Te<we;Te++){const qe=Re(me,Te);if(qe){const Xe=ae(qe,qe.toLowerCase(),Ae,ze,q,W,Q);Xe&&(Xe[0]-=3,(!de||Xe[0]>de[0])&&(de=Xe))}}}return de}function Re(me,Ie){if(Ie+1>=me.length)return;const Ae=me[Ie],ze=me[Ie+1];if(Ae!==ze)return me.slice(0,Ie)+ze+Ae+me.slice(Ie+2)}}),define(ke[57],De([1,0,14]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$qj=void 0,e.$mj=O,e.$nj=L,e.$oj=A,e.$pj=b,e.$rj=d;function O(a){return L(a,0)}function L(a,n){switch(typeof a){case"object":return a===null?A(349,n):Array.isArray(a)?$(a,n):E(a,n);case"string":return b(a,n);case"boolean":return M(a,n);case"number":return A(a,n);case"undefined":return A(937,n);default:return A(617,n)}}function A(a,n){return(n<<5)-n+a|0}function M(a,n){return A(a?433:863,n)}function b(a,n){n=A(149417,n);for(let i=0,c=a.length;i<c;i++)n=A(a.charCodeAt(i),n);return n}function $(a,n){return n=A(104579,n),a.reduce((i,c)=>L(c,i),n)}function E(a,n){return n=A(181387,n),Object.keys(a).sort().reduce((i,c)=>(i=b(c,i),L(a[c],i)),n)}class I{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=L(n,this.g),this.g}}e.$qj=I;var P;(function(a){a[a.BLOCK_SIZE=64]="BLOCK_SIZE",a[a.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function p(a,n,i=32){const c=i-n,r=~((1<<c)-1);return(a<<n|(r&a)>>>c)>>>0}function S(a,n=0,i=a.byteLength,c=0){for(let r=0;r<i;r++)a[n+r]=c}function v(a,n,i="0"){for(;a.length<n;)a=i+a;return a}function d(a,n=32){return a instanceof ArrayBuffer?Array.from(new Uint8Array(a)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((a>>>0).toString(16),n/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const c=this.p;let r=this.r,t=this.u,u,s;for(t!==0?(u=t,s=-1,t=0):(u=n.charCodeAt(0),s=0);;){let o=u;if(l.$Df(u))if(s+1<i){const h=n.charCodeAt(s+1);l.$Ef(h)?(s++,o=l.$Ff(u,h)):o=65533}else{t=u;break}else l.$Ef(u)&&(o=65533);if(r=this.w(c,r,o),s++,s<i)u=n.charCodeAt(s);else break}this.r=r,this.u=t}w(n,i,c){return c<128?n[i++]=c:c<2048?(n[i++]=192|(c&1984)>>>6,n[i++]=128|(c&63)>>>0):c<65536?(n[i++]=224|(c&61440)>>>12,n[i++]=128|(c&4032)>>>6,n[i++]=128|(c&63)>>>0):(n[i++]=240|(c&1835008)>>>18,n[i++]=128|(c&258048)>>>12,n[i++]=128|(c&4032)>>>6,n[i++]=128|(c&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=f.g,i=this.q;for(let w=0;w<64;w+=4)n.setUint32(w,i.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)n.setUint32(w,p(n.getUint32(w-12,!1)^n.getUint32(w-32,!1)^n.getUint32(w-56,!1)^n.getUint32(w-64,!1),1),!1);let c=this.h,r=this.l,t=this.m,u=this.n,s=this.o,o,h,g;for(let w=0;w<80;w++)w<20?(o=r&t|~r&u,h=1518500249):w<40?(o=r^t^u,h=1859775393):w<60?(o=r&t|r&u|t&u,h=2400959708):(o=r^t^u,h=3395469782),g=p(c,5)+o+s+h+n.getUint32(w*4,!1)&4294967295,s=u,u=t,t=p(r,30),r=c,c=g;this.h=this.h+c&4294967295,this.l=this.l+r&4294967295,this.m=this.m+t&4294967295,this.n=this.n+u&4294967295,this.o=this.o+s&4294967295}}e.$sj=f}),define(ke[41],De([1,0,14]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(O||(O={})),function(L){const A="error",M="warning",b="warn",$="info",E="ignore";function I(p){return p?l.$zf(A,p)?L.Error:l.$zf(M,p)||l.$zf(b,p)?L.Warning:l.$zf($,p)?L.Info:L.Ignore:L.Ignore}L.fromValue=I;function P(p){switch(p){case L.Error:return A;case L.Warning:return M;case L.Info:return $;default:return E}}L.toString=P}(O||(O={})),e.default=O}),define(ke[174],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ke[78],De([1,0,19,14]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class L{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const v=S.charCodeAt(0),d=this.b.charCodeAt(this.c);return v-d}value(){return this.b[this.c]}}e.$Ai=L;class A{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,O.$tf)(S,this.b,0,S.length,this.c,this.d):(0,O.$vf)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Bi=A;class M{constructor(S=!0,v=!0){this.f=S,this.g=v}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let v=S.length-1;v>=0;v--,this.c--){const d=this.b.charCodeAt(v);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,O.$tf)(S,this.b,0,S.length,this.d,this.e):(0,O.$vf)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ci=M;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(S,v){this.f=S,this.g=v,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,O.$uf)(S,this.c.scheme);if(this.d[this.e]===2)return(0,O.$uf)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,O.$sf)(S,this.c.query);if(this.d[this.e]===5)return(0,O.$sf)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Di=$;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(I||(I={}));class P{static forUris(S=()=>!1,v=()=>!1){return new P(new $(S,v))}static forPaths(S=!1){return new P(new M(void 0,!S))}static forStrings(){return new P(new L)}static forConfigKeys(){return new P(new A)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,v){if(v){const d=v.slice(0);(0,l.$Wb)(d);for(const f of d)this.set(f,S)}else{const d=S.slice(0);(0,l.$Wb)(d);for(const f of d)this.set(f[0],f[1])}}set(S,v){const d=this.b.reset(S);let f;this.c||(this.c=new E,this.c.segment=d.value());const a=[];for(f=this.c;;){const i=d.cmp(f.segment);if(i>0)f.left||(f.left=new E,f.left.segment=d.value()),a.push([-1,f]),f=f.left;else if(i<0)f.right||(f.right=new E,f.right.segment=d.value()),a.push([1,f]),f=f.right;else if(d.hasNext())d.next(),f.mid||(f.mid=new E,f.mid.segment=d.value()),a.push([0,f]),f=f.mid;else break}const n=f.value;f.value=v,f.key=S;for(let i=a.length-1;i>=0;i--){const c=a[i][1];c.updateHeight();const r=c.balanceFactor();if(r<-1||r>1){const t=a[i][0],u=a[i+1][0];if(t===1&&u===1)a[i][1]=c.rotateLeft();else if(t===-1&&u===-1)a[i][1]=c.rotateRight();else if(t===1&&u===-1)c.right=a[i+1][1]=a[i+1][1].rotateRight(),a[i][1]=c.rotateLeft();else if(t===-1&&u===1)c.left=a[i+1][1]=a[i+1][1].rotateLeft(),a[i][1]=c.rotateRight();else throw new Error;if(i>0)switch(a[i-1][0]){case-1:a[i-1][1].left=a[i][1];break;case 1:a[i-1][1].right=a[i][1];break;case 0:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}return n}get(S){return this.d(S)?.value}d(S){const v=this.b.reset(S);let d=this.c;for(;d;){const f=v.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else break}return d}has(S){const v=this.d(S);return!(v?.value===void 0&&v?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,v){const d=this.b.reset(S),f=[];let a=this.c;for(;a;){const n=d.cmp(a.segment);if(n>0)f.push([-1,a]),a=a.left;else if(n<0)f.push([1,a]),a=a.right;else if(d.hasNext())d.next(),f.push([0,a]),a=a.mid;else break}if(a){if(v?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const n=this.f(a.right);if(n.key){const{key:i,value:c,segment:r}=n;this.e(n.key,!1),a.key=i,a.value=c,a.segment=r}}else{const n=a.left??a.right;if(f.length>0){const[i,c]=f[f.length-1];switch(i){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=f.length-1;n>=0;n--){const i=f[n][1];i.updateHeight();const c=i.balanceFactor();if(c>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),f[n][1]=i.rotateLeft()):c<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),f[n][1]=i.rotateRight()),n>0)switch(f[n-1][0]){case-1:f[n-1][1].left=f[n][1];break;case 1:f[n-1][1].right=f[n][1];break;case 0:f[n-1][1].mid=f[n][1];break}else this.c=f[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const v=this.b.reset(S);let d=this.c,f;for(;d;){const a=v.cmp(d.segment);if(a>0)d=d.left;else if(a<0)d=d.right;else if(v.hasNext())v.next(),f=d.value||f,d=d.mid;else break}return d&&d.value||f}findSuperstr(S){return this.g(S,!1)}g(S,v){const d=this.b.reset(S);let f=this.c;for(;f;){const a=d.cmp(f.segment);if(a>0)f=f.left;else if(a<0)f=f.right;else if(d.hasNext())d.next(),f=f.mid;else return f.mid?this.h(f.mid):v?f.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[v,d]of this)S(d,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const v=[];return this.j(S,v),v[Symbol.iterator]()}j(S,v){S&&(S.left&&this.j(S.left,v),S.value&&v.push([S.key,S.value]),S.mid&&this.j(S.mid,v),S.right&&this.j(S.right,v))}_isBalanced(){const S=v=>{if(!v)return!0;const d=v.balanceFactor();return d<-1||d>1?!1:S(v.left)&&S(v.right)};return S(this.c)}}e.$Ei=P}),define(ke[18],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=l,e.$_f=O,e.$ag=L,e.$bg=A,e.$cg=M,e.$dg=b,e.$eg=$,e.$fg=E,e.$gg=I,e.$hg=P,e.$ig=p,e.$jg=S,e.$kg=v,e.$lg=f,e.$mg=a,e.$ng=n,e.$og=i,e.$pg=c;function l(r){return typeof r=="string"}function O(r){return Array.isArray(r)&&r.every(t=>l(t))}function L(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}function A(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}function M(r){return typeof r=="number"&&!isNaN(r)}function b(r){return!!r&&typeof r[Symbol.iterator]=="function"}function $(r){return r===!0||r===!1}function E(r){return typeof r>"u"}function I(r){return!P(r)}function P(r){return E(r)||r===null}function p(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function S(r){if(P(r))throw new Error("Assertion Failed: argument is undefined or null");return r}function v(...r){const t=[];for(let u=0;u<r.length;u++){const s=r[u];if(P(s))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);t.push(s)}return t}const d=Object.prototype.hasOwnProperty;function f(r){if(!L(r))return!1;for(const t in r)if(d.call(r,t))return!1;return!0}function a(r){return typeof r=="function"}function n(...r){return r.length>0&&r.every(a)}function i(r,t){const u=Math.min(r.length,t.length);for(let s=0;s<u;s++)c(r[s],t[s])}function c(r,t){if(l(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(r instanceof t)return}catch{}if(!P(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],De([1,0,18]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=L,e.$Tj=A;const O=Object.create(null);function L(M,b){if((0,l.$$f)(b)){const $=O[b];if($===void 0)throw new Error(`${M} references an unknown codicon: ${b}`);b=$}return O[M]=b,{id:M}}function A(){return O}}),define(ke[175],De([1,0,99]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=void 0,e.$Uj={add:(0,l.$Sj)("add",6e4),plus:(0,l.$Sj)("plus",6e4),gistNew:(0,l.$Sj)("gist-new",6e4),repoCreate:(0,l.$Sj)("repo-create",6e4),lightbulb:(0,l.$Sj)("lightbulb",60001),lightBulb:(0,l.$Sj)("light-bulb",60001),repo:(0,l.$Sj)("repo",60002),repoDelete:(0,l.$Sj)("repo-delete",60002),gistFork:(0,l.$Sj)("gist-fork",60003),repoForked:(0,l.$Sj)("repo-forked",60003),gitPullRequest:(0,l.$Sj)("git-pull-request",60004),gitPullRequestAbandoned:(0,l.$Sj)("git-pull-request-abandoned",60004),recordKeys:(0,l.$Sj)("record-keys",60005),keyboard:(0,l.$Sj)("keyboard",60005),tag:(0,l.$Sj)("tag",60006),gitPullRequestLabel:(0,l.$Sj)("git-pull-request-label",60006),tagAdd:(0,l.$Sj)("tag-add",60006),tagRemove:(0,l.$Sj)("tag-remove",60006),person:(0,l.$Sj)("person",60007),personFollow:(0,l.$Sj)("person-follow",60007),personOutline:(0,l.$Sj)("person-outline",60007),personFilled:(0,l.$Sj)("person-filled",60007),gitBranch:(0,l.$Sj)("git-branch",60008),gitBranchCreate:(0,l.$Sj)("git-branch-create",60008),gitBranchDelete:(0,l.$Sj)("git-branch-delete",60008),sourceControl:(0,l.$Sj)("source-control",60008),mirror:(0,l.$Sj)("mirror",60009),mirrorPublic:(0,l.$Sj)("mirror-public",60009),star:(0,l.$Sj)("star",60010),starAdd:(0,l.$Sj)("star-add",60010),starDelete:(0,l.$Sj)("star-delete",60010),starEmpty:(0,l.$Sj)("star-empty",60010),comment:(0,l.$Sj)("comment",60011),commentAdd:(0,l.$Sj)("comment-add",60011),alert:(0,l.$Sj)("alert",60012),warning:(0,l.$Sj)("warning",60012),search:(0,l.$Sj)("search",60013),searchSave:(0,l.$Sj)("search-save",60013),logOut:(0,l.$Sj)("log-out",60014),signOut:(0,l.$Sj)("sign-out",60014),logIn:(0,l.$Sj)("log-in",60015),signIn:(0,l.$Sj)("sign-in",60015),eye:(0,l.$Sj)("eye",60016),eyeUnwatch:(0,l.$Sj)("eye-unwatch",60016),eyeWatch:(0,l.$Sj)("eye-watch",60016),circleFilled:(0,l.$Sj)("circle-filled",60017),primitiveDot:(0,l.$Sj)("primitive-dot",60017),closeDirty:(0,l.$Sj)("close-dirty",60017),debugBreakpoint:(0,l.$Sj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,l.$Sj)("debug-breakpoint-disabled",60017),debugHint:(0,l.$Sj)("debug-hint",60017),terminalDecorationSuccess:(0,l.$Sj)("terminal-decoration-success",60017),primitiveSquare:(0,l.$Sj)("primitive-square",60018),edit:(0,l.$Sj)("edit",60019),pencil:(0,l.$Sj)("pencil",60019),info:(0,l.$Sj)("info",60020),issueOpened:(0,l.$Sj)("issue-opened",60020),gistPrivate:(0,l.$Sj)("gist-private",60021),gitForkPrivate:(0,l.$Sj)("git-fork-private",60021),lock:(0,l.$Sj)("lock",60021),mirrorPrivate:(0,l.$Sj)("mirror-private",60021),close:(0,l.$Sj)("close",60022),removeClose:(0,l.$Sj)("remove-close",60022),x:(0,l.$Sj)("x",60022),repoSync:(0,l.$Sj)("repo-sync",60023),sync:(0,l.$Sj)("sync",60023),clone:(0,l.$Sj)("clone",60024),desktopDownload:(0,l.$Sj)("desktop-download",60024),beaker:(0,l.$Sj)("beaker",60025),microscope:(0,l.$Sj)("microscope",60025),vm:(0,l.$Sj)("vm",60026),deviceDesktop:(0,l.$Sj)("device-desktop",60026),file:(0,l.$Sj)("file",60027),fileText:(0,l.$Sj)("file-text",60027),more:(0,l.$Sj)("more",60028),ellipsis:(0,l.$Sj)("ellipsis",60028),kebabHorizontal:(0,l.$Sj)("kebab-horizontal",60028),mailReply:(0,l.$Sj)("mail-reply",60029),reply:(0,l.$Sj)("reply",60029),organization:(0,l.$Sj)("organization",60030),organizationFilled:(0,l.$Sj)("organization-filled",60030),organizationOutline:(0,l.$Sj)("organization-outline",60030),newFile:(0,l.$Sj)("new-file",60031),fileAdd:(0,l.$Sj)("file-add",60031),newFolder:(0,l.$Sj)("new-folder",60032),fileDirectoryCreate:(0,l.$Sj)("file-directory-create",60032),trash:(0,l.$Sj)("trash",60033),trashcan:(0,l.$Sj)("trashcan",60033),history:(0,l.$Sj)("history",60034),clock:(0,l.$Sj)("clock",60034),folder:(0,l.$Sj)("folder",60035),fileDirectory:(0,l.$Sj)("file-directory",60035),symbolFolder:(0,l.$Sj)("symbol-folder",60035),logoGithub:(0,l.$Sj)("logo-github",60036),markGithub:(0,l.$Sj)("mark-github",60036),github:(0,l.$Sj)("github",60036),terminal:(0,l.$Sj)("terminal",60037),console:(0,l.$Sj)("console",60037),repl:(0,l.$Sj)("repl",60037),zap:(0,l.$Sj)("zap",60038),symbolEvent:(0,l.$Sj)("symbol-event",60038),error:(0,l.$Sj)("error",60039),stop:(0,l.$Sj)("stop",60039),variable:(0,l.$Sj)("variable",60040),symbolVariable:(0,l.$Sj)("symbol-variable",60040),array:(0,l.$Sj)("array",60042),symbolArray:(0,l.$Sj)("symbol-array",60042),symbolModule:(0,l.$Sj)("symbol-module",60043),symbolPackage:(0,l.$Sj)("symbol-package",60043),symbolNamespace:(0,l.$Sj)("symbol-namespace",60043),symbolObject:(0,l.$Sj)("symbol-object",60043),symbolMethod:(0,l.$Sj)("symbol-method",60044),symbolFunction:(0,l.$Sj)("symbol-function",60044),symbolConstructor:(0,l.$Sj)("symbol-constructor",60044),symbolBoolean:(0,l.$Sj)("symbol-boolean",60047),symbolNull:(0,l.$Sj)("symbol-null",60047),symbolNumeric:(0,l.$Sj)("symbol-numeric",60048),symbolNumber:(0,l.$Sj)("symbol-number",60048),symbolStructure:(0,l.$Sj)("symbol-structure",60049),symbolStruct:(0,l.$Sj)("symbol-struct",60049),symbolParameter:(0,l.$Sj)("symbol-parameter",60050),symbolTypeParameter:(0,l.$Sj)("symbol-type-parameter",60050),symbolKey:(0,l.$Sj)("symbol-key",60051),symbolText:(0,l.$Sj)("symbol-text",60051),symbolReference:(0,l.$Sj)("symbol-reference",60052),goToFile:(0,l.$Sj)("go-to-file",60052),symbolEnum:(0,l.$Sj)("symbol-enum",60053),symbolValue:(0,l.$Sj)("symbol-value",60053),symbolRuler:(0,l.$Sj)("symbol-ruler",60054),symbolUnit:(0,l.$Sj)("symbol-unit",60054),activateBreakpoints:(0,l.$Sj)("activate-breakpoints",60055),archive:(0,l.$Sj)("archive",60056),arrowBoth:(0,l.$Sj)("arrow-both",60057),arrowDown:(0,l.$Sj)("arrow-down",60058),arrowLeft:(0,l.$Sj)("arrow-left",60059),arrowRight:(0,l.$Sj)("arrow-right",60060),arrowSmallDown:(0,l.$Sj)("arrow-small-down",60061),arrowSmallLeft:(0,l.$Sj)("arrow-small-left",60062),arrowSmallRight:(0,l.$Sj)("arrow-small-right",60063),arrowSmallUp:(0,l.$Sj)("arrow-small-up",60064),arrowUp:(0,l.$Sj)("arrow-up",60065),bell:(0,l.$Sj)("bell",60066),bold:(0,l.$Sj)("bold",60067),book:(0,l.$Sj)("book",60068),bookmark:(0,l.$Sj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,l.$Sj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,l.$Sj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,l.$Sj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,l.$Sj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,l.$Sj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,l.$Sj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,l.$Sj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,l.$Sj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,l.$Sj)("debug-breakpoint-log-disabled",60075),briefcase:(0,l.$Sj)("briefcase",60076),broadcast:(0,l.$Sj)("broadcast",60077),browser:(0,l.$Sj)("browser",60078),bug:(0,l.$Sj)("bug",60079),calendar:(0,l.$Sj)("calendar",60080),caseSensitive:(0,l.$Sj)("case-sensitive",60081),check:(0,l.$Sj)("check",60082),checklist:(0,l.$Sj)("checklist",60083),chevronDown:(0,l.$Sj)("chevron-down",60084),chevronLeft:(0,l.$Sj)("chevron-left",60085),chevronRight:(0,l.$Sj)("chevron-right",60086),chevronUp:(0,l.$Sj)("chevron-up",60087),chromeClose:(0,l.$Sj)("chrome-close",60088),chromeMaximize:(0,l.$Sj)("chrome-maximize",60089),chromeMinimize:(0,l.$Sj)("chrome-minimize",60090),chromeRestore:(0,l.$Sj)("chrome-restore",60091),circleOutline:(0,l.$Sj)("circle-outline",60092),circle:(0,l.$Sj)("circle",60092),debugBreakpointUnverified:(0,l.$Sj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,l.$Sj)("terminal-decoration-incomplete",60092),circleSlash:(0,l.$Sj)("circle-slash",60093),circuitBoard:(0,l.$Sj)("circuit-board",60094),clearAll:(0,l.$Sj)("clear-all",60095),clippy:(0,l.$Sj)("clippy",60096),closeAll:(0,l.$Sj)("close-all",60097),cloudDownload:(0,l.$Sj)("cloud-download",60098),cloudUpload:(0,l.$Sj)("cloud-upload",60099),code:(0,l.$Sj)("code",60100),collapseAll:(0,l.$Sj)("collapse-all",60101),colorMode:(0,l.$Sj)("color-mode",60102),commentDiscussion:(0,l.$Sj)("comment-discussion",60103),creditCard:(0,l.$Sj)("credit-card",60105),dash:(0,l.$Sj)("dash",60108),dashboard:(0,l.$Sj)("dashboard",60109),database:(0,l.$Sj)("database",60110),debugContinue:(0,l.$Sj)("debug-continue",60111),debugDisconnect:(0,l.$Sj)("debug-disconnect",60112),debugPause:(0,l.$Sj)("debug-pause",60113),debugRestart:(0,l.$Sj)("debug-restart",60114),debugStart:(0,l.$Sj)("debug-start",60115),debugStepInto:(0,l.$Sj)("debug-step-into",60116),debugStepOut:(0,l.$Sj)("debug-step-out",60117),debugStepOver:(0,l.$Sj)("debug-step-over",60118),debugStop:(0,l.$Sj)("debug-stop",60119),debug:(0,l.$Sj)("debug",60120),deviceCameraVideo:(0,l.$Sj)("device-camera-video",60121),deviceCamera:(0,l.$Sj)("device-camera",60122),deviceMobile:(0,l.$Sj)("device-mobile",60123),diffAdded:(0,l.$Sj)("diff-added",60124),diffIgnored:(0,l.$Sj)("diff-ignored",60125),diffModified:(0,l.$Sj)("diff-modified",60126),diffRemoved:(0,l.$Sj)("diff-removed",60127),diffRenamed:(0,l.$Sj)("diff-renamed",60128),diff:(0,l.$Sj)("diff",60129),diffSidebyside:(0,l.$Sj)("diff-sidebyside",60129),discard:(0,l.$Sj)("discard",60130),editorLayout:(0,l.$Sj)("editor-layout",60131),emptyWindow:(0,l.$Sj)("empty-window",60132),exclude:(0,l.$Sj)("exclude",60133),extensions:(0,l.$Sj)("extensions",60134),eyeClosed:(0,l.$Sj)("eye-closed",60135),fileBinary:(0,l.$Sj)("file-binary",60136),fileCode:(0,l.$Sj)("file-code",60137),fileMedia:(0,l.$Sj)("file-media",60138),filePdf:(0,l.$Sj)("file-pdf",60139),fileSubmodule:(0,l.$Sj)("file-submodule",60140),fileSymlinkDirectory:(0,l.$Sj)("file-symlink-directory",60141),fileSymlinkFile:(0,l.$Sj)("file-symlink-file",60142),fileZip:(0,l.$Sj)("file-zip",60143),files:(0,l.$Sj)("files",60144),filter:(0,l.$Sj)("filter",60145),flame:(0,l.$Sj)("flame",60146),foldDown:(0,l.$Sj)("fold-down",60147),foldUp:(0,l.$Sj)("fold-up",60148),fold:(0,l.$Sj)("fold",60149),folderActive:(0,l.$Sj)("folder-active",60150),folderOpened:(0,l.$Sj)("folder-opened",60151),gear:(0,l.$Sj)("gear",60152),gift:(0,l.$Sj)("gift",60153),gistSecret:(0,l.$Sj)("gist-secret",60154),gist:(0,l.$Sj)("gist",60155),gitCommit:(0,l.$Sj)("git-commit",60156),gitCompare:(0,l.$Sj)("git-compare",60157),compareChanges:(0,l.$Sj)("compare-changes",60157),gitMerge:(0,l.$Sj)("git-merge",60158),githubAction:(0,l.$Sj)("github-action",60159),githubAlt:(0,l.$Sj)("github-alt",60160),globe:(0,l.$Sj)("globe",60161),grabber:(0,l.$Sj)("grabber",60162),graph:(0,l.$Sj)("graph",60163),gripper:(0,l.$Sj)("gripper",60164),heart:(0,l.$Sj)("heart",60165),home:(0,l.$Sj)("home",60166),horizontalRule:(0,l.$Sj)("horizontal-rule",60167),hubot:(0,l.$Sj)("hubot",60168),inbox:(0,l.$Sj)("inbox",60169),issueReopened:(0,l.$Sj)("issue-reopened",60171),issues:(0,l.$Sj)("issues",60172),italic:(0,l.$Sj)("italic",60173),jersey:(0,l.$Sj)("jersey",60174),json:(0,l.$Sj)("json",60175),kebabVertical:(0,l.$Sj)("kebab-vertical",60176),key:(0,l.$Sj)("key",60177),law:(0,l.$Sj)("law",60178),lightbulbAutofix:(0,l.$Sj)("lightbulb-autofix",60179),linkExternal:(0,l.$Sj)("link-external",60180),link:(0,l.$Sj)("link",60181),listOrdered:(0,l.$Sj)("list-ordered",60182),listUnordered:(0,l.$Sj)("list-unordered",60183),liveShare:(0,l.$Sj)("live-share",60184),loading:(0,l.$Sj)("loading",60185),location:(0,l.$Sj)("location",60186),mailRead:(0,l.$Sj)("mail-read",60187),mail:(0,l.$Sj)("mail",60188),markdown:(0,l.$Sj)("markdown",60189),megaphone:(0,l.$Sj)("megaphone",60190),mention:(0,l.$Sj)("mention",60191),milestone:(0,l.$Sj)("milestone",60192),gitPullRequestMilestone:(0,l.$Sj)("git-pull-request-milestone",60192),mortarBoard:(0,l.$Sj)("mortar-board",60193),move:(0,l.$Sj)("move",60194),multipleWindows:(0,l.$Sj)("multiple-windows",60195),mute:(0,l.$Sj)("mute",60196),noNewline:(0,l.$Sj)("no-newline",60197),note:(0,l.$Sj)("note",60198),octoface:(0,l.$Sj)("octoface",60199),openPreview:(0,l.$Sj)("open-preview",60200),package:(0,l.$Sj)("package",60201),paintcan:(0,l.$Sj)("paintcan",60202),pin:(0,l.$Sj)("pin",60203),play:(0,l.$Sj)("play",60204),run:(0,l.$Sj)("run",60204),plug:(0,l.$Sj)("plug",60205),preserveCase:(0,l.$Sj)("preserve-case",60206),preview:(0,l.$Sj)("preview",60207),project:(0,l.$Sj)("project",60208),pulse:(0,l.$Sj)("pulse",60209),question:(0,l.$Sj)("question",60210),quote:(0,l.$Sj)("quote",60211),radioTower:(0,l.$Sj)("radio-tower",60212),reactions:(0,l.$Sj)("reactions",60213),references:(0,l.$Sj)("references",60214),refresh:(0,l.$Sj)("refresh",60215),regex:(0,l.$Sj)("regex",60216),remoteExplorer:(0,l.$Sj)("remote-explorer",60217),remote:(0,l.$Sj)("remote",60218),remove:(0,l.$Sj)("remove",60219),replaceAll:(0,l.$Sj)("replace-all",60220),replace:(0,l.$Sj)("replace",60221),repoClone:(0,l.$Sj)("repo-clone",60222),repoForcePush:(0,l.$Sj)("repo-force-push",60223),repoPull:(0,l.$Sj)("repo-pull",60224),repoPush:(0,l.$Sj)("repo-push",60225),report:(0,l.$Sj)("report",60226),requestChanges:(0,l.$Sj)("request-changes",60227),rocket:(0,l.$Sj)("rocket",60228),rootFolderOpened:(0,l.$Sj)("root-folder-opened",60229),rootFolder:(0,l.$Sj)("root-folder",60230),rss:(0,l.$Sj)("rss",60231),ruby:(0,l.$Sj)("ruby",60232),saveAll:(0,l.$Sj)("save-all",60233),saveAs:(0,l.$Sj)("save-as",60234),save:(0,l.$Sj)("save",60235),screenFull:(0,l.$Sj)("screen-full",60236),screenNormal:(0,l.$Sj)("screen-normal",60237),searchStop:(0,l.$Sj)("search-stop",60238),server:(0,l.$Sj)("server",60240),settingsGear:(0,l.$Sj)("settings-gear",60241),settings:(0,l.$Sj)("settings",60242),shield:(0,l.$Sj)("shield",60243),smiley:(0,l.$Sj)("smiley",60244),sortPrecedence:(0,l.$Sj)("sort-precedence",60245),splitHorizontal:(0,l.$Sj)("split-horizontal",60246),splitVertical:(0,l.$Sj)("split-vertical",60247),squirrel:(0,l.$Sj)("squirrel",60248),starFull:(0,l.$Sj)("star-full",60249),starHalf:(0,l.$Sj)("star-half",60250),symbolClass:(0,l.$Sj)("symbol-class",60251),symbolColor:(0,l.$Sj)("symbol-color",60252),symbolConstant:(0,l.$Sj)("symbol-constant",60253),symbolEnumMember:(0,l.$Sj)("symbol-enum-member",60254),symbolField:(0,l.$Sj)("symbol-field",60255),symbolFile:(0,l.$Sj)("symbol-file",60256),symbolInterface:(0,l.$Sj)("symbol-interface",60257),symbolKeyword:(0,l.$Sj)("symbol-keyword",60258),symbolMisc:(0,l.$Sj)("symbol-misc",60259),symbolOperator:(0,l.$Sj)("symbol-operator",60260),symbolProperty:(0,l.$Sj)("symbol-property",60261),wrench:(0,l.$Sj)("wrench",60261),wrenchSubaction:(0,l.$Sj)("wrench-subaction",60261),symbolSnippet:(0,l.$Sj)("symbol-snippet",60262),tasklist:(0,l.$Sj)("tasklist",60263),telescope:(0,l.$Sj)("telescope",60264),textSize:(0,l.$Sj)("text-size",60265),threeBars:(0,l.$Sj)("three-bars",60266),thumbsdown:(0,l.$Sj)("thumbsdown",60267),thumbsup:(0,l.$Sj)("thumbsup",60268),tools:(0,l.$Sj)("tools",60269),triangleDown:(0,l.$Sj)("triangle-down",60270),triangleLeft:(0,l.$Sj)("triangle-left",60271),triangleRight:(0,l.$Sj)("triangle-right",60272),triangleUp:(0,l.$Sj)("triangle-up",60273),twitter:(0,l.$Sj)("twitter",60274),unfold:(0,l.$Sj)("unfold",60275),unlock:(0,l.$Sj)("unlock",60276),unmute:(0,l.$Sj)("unmute",60277),unverified:(0,l.$Sj)("unverified",60278),verified:(0,l.$Sj)("verified",60279),versions:(0,l.$Sj)("versions",60280),vmActive:(0,l.$Sj)("vm-active",60281),vmOutline:(0,l.$Sj)("vm-outline",60282),vmRunning:(0,l.$Sj)("vm-running",60283),watch:(0,l.$Sj)("watch",60284),whitespace:(0,l.$Sj)("whitespace",60285),wholeWord:(0,l.$Sj)("whole-word",60286),window:(0,l.$Sj)("window",60287),wordWrap:(0,l.$Sj)("word-wrap",60288),zoomIn:(0,l.$Sj)("zoom-in",60289),zoomOut:(0,l.$Sj)("zoom-out",60290),listFilter:(0,l.$Sj)("list-filter",60291),listFlat:(0,l.$Sj)("list-flat",60292),listSelection:(0,l.$Sj)("list-selection",60293),selection:(0,l.$Sj)("selection",60293),listTree:(0,l.$Sj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,l.$Sj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,l.$Sj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,l.$Sj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,l.$Sj)("debug-stackframe-active",60297),circleSmallFilled:(0,l.$Sj)("circle-small-filled",60298),debugStackframeDot:(0,l.$Sj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,l.$Sj)("terminal-decoration-mark",60298),debugStackframe:(0,l.$Sj)("debug-stackframe",60299),debugStackframeFocused:(0,l.$Sj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,l.$Sj)("debug-breakpoint-unsupported",60300),symbolString:(0,l.$Sj)("symbol-string",60301),debugReverseContinue:(0,l.$Sj)("debug-reverse-continue",60302),debugStepBack:(0,l.$Sj)("debug-step-back",60303),debugRestartFrame:(0,l.$Sj)("debug-restart-frame",60304),debugAlt:(0,l.$Sj)("debug-alt",60305),callIncoming:(0,l.$Sj)("call-incoming",60306),callOutgoing:(0,l.$Sj)("call-outgoing",60307),menu:(0,l.$Sj)("menu",60308),expandAll:(0,l.$Sj)("expand-all",60309),feedback:(0,l.$Sj)("feedback",60310),gitPullRequestReviewer:(0,l.$Sj)("git-pull-request-reviewer",60310),groupByRefType:(0,l.$Sj)("group-by-ref-type",60311),ungroupByRefType:(0,l.$Sj)("ungroup-by-ref-type",60312),account:(0,l.$Sj)("account",60313),gitPullRequestAssignee:(0,l.$Sj)("git-pull-request-assignee",60313),bellDot:(0,l.$Sj)("bell-dot",60314),debugConsole:(0,l.$Sj)("debug-console",60315),library:(0,l.$Sj)("library",60316),output:(0,l.$Sj)("output",60317),runAll:(0,l.$Sj)("run-all",60318),syncIgnored:(0,l.$Sj)("sync-ignored",60319),pinned:(0,l.$Sj)("pinned",60320),githubInverted:(0,l.$Sj)("github-inverted",60321),serverProcess:(0,l.$Sj)("server-process",60322),serverEnvironment:(0,l.$Sj)("server-environment",60323),pass:(0,l.$Sj)("pass",60324),issueClosed:(0,l.$Sj)("issue-closed",60324),stopCircle:(0,l.$Sj)("stop-circle",60325),playCircle:(0,l.$Sj)("play-circle",60326),record:(0,l.$Sj)("record",60327),debugAltSmall:(0,l.$Sj)("debug-alt-small",60328),vmConnect:(0,l.$Sj)("vm-connect",60329),cloud:(0,l.$Sj)("cloud",60330),merge:(0,l.$Sj)("merge",60331),export:(0,l.$Sj)("export",60332),graphLeft:(0,l.$Sj)("graph-left",60333),magnet:(0,l.$Sj)("magnet",60334),notebook:(0,l.$Sj)("notebook",60335),redo:(0,l.$Sj)("redo",60336),checkAll:(0,l.$Sj)("check-all",60337),pinnedDirty:(0,l.$Sj)("pinned-dirty",60338),passFilled:(0,l.$Sj)("pass-filled",60339),circleLargeFilled:(0,l.$Sj)("circle-large-filled",60340),circleLarge:(0,l.$Sj)("circle-large",60341),circleLargeOutline:(0,l.$Sj)("circle-large-outline",60341),combine:(0,l.$Sj)("combine",60342),gather:(0,l.$Sj)("gather",60342),table:(0,l.$Sj)("table",60343),variableGroup:(0,l.$Sj)("variable-group",60344),typeHierarchy:(0,l.$Sj)("type-hierarchy",60345),typeHierarchySub:(0,l.$Sj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,l.$Sj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,l.$Sj)("git-pull-request-create",60348),runAbove:(0,l.$Sj)("run-above",60349),runBelow:(0,l.$Sj)("run-below",60350),notebookTemplate:(0,l.$Sj)("notebook-template",60351),debugRerun:(0,l.$Sj)("debug-rerun",60352),workspaceTrusted:(0,l.$Sj)("workspace-trusted",60353),workspaceUntrusted:(0,l.$Sj)("workspace-untrusted",60354),workspaceUnknown:(0,l.$Sj)("workspace-unknown",60355),terminalCmd:(0,l.$Sj)("terminal-cmd",60356),terminalDebian:(0,l.$Sj)("terminal-debian",60357),terminalLinux:(0,l.$Sj)("terminal-linux",60358),terminalPowershell:(0,l.$Sj)("terminal-powershell",60359),terminalTmux:(0,l.$Sj)("terminal-tmux",60360),terminalUbuntu:(0,l.$Sj)("terminal-ubuntu",60361),terminalBash:(0,l.$Sj)("terminal-bash",60362),arrowSwap:(0,l.$Sj)("arrow-swap",60363),copy:(0,l.$Sj)("copy",60364),personAdd:(0,l.$Sj)("person-add",60365),filterFilled:(0,l.$Sj)("filter-filled",60366),wand:(0,l.$Sj)("wand",60367),debugLineByLine:(0,l.$Sj)("debug-line-by-line",60368),inspect:(0,l.$Sj)("inspect",60369),layers:(0,l.$Sj)("layers",60370),layersDot:(0,l.$Sj)("layers-dot",60371),layersActive:(0,l.$Sj)("layers-active",60372),compass:(0,l.$Sj)("compass",60373),compassDot:(0,l.$Sj)("compass-dot",60374),compassActive:(0,l.$Sj)("compass-active",60375),azure:(0,l.$Sj)("azure",60376),issueDraft:(0,l.$Sj)("issue-draft",60377),gitPullRequestClosed:(0,l.$Sj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,l.$Sj)("git-pull-request-draft",60379),debugAll:(0,l.$Sj)("debug-all",60380),debugCoverage:(0,l.$Sj)("debug-coverage",60381),runErrors:(0,l.$Sj)("run-errors",60382),folderLibrary:(0,l.$Sj)("folder-library",60383),debugContinueSmall:(0,l.$Sj)("debug-continue-small",60384),beakerStop:(0,l.$Sj)("beaker-stop",60385),graphLine:(0,l.$Sj)("graph-line",60386),graphScatter:(0,l.$Sj)("graph-scatter",60387),pieChart:(0,l.$Sj)("pie-chart",60388),bracket:(0,l.$Sj)("bracket",60175),bracketDot:(0,l.$Sj)("bracket-dot",60389),bracketError:(0,l.$Sj)("bracket-error",60390),lockSmall:(0,l.$Sj)("lock-small",60391),azureDevops:(0,l.$Sj)("azure-devops",60392),verifiedFilled:(0,l.$Sj)("verified-filled",60393),newline:(0,l.$Sj)("newline",60394),layout:(0,l.$Sj)("layout",60395),layoutActivitybarLeft:(0,l.$Sj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,l.$Sj)("layout-activitybar-right",60397),layoutPanelLeft:(0,l.$Sj)("layout-panel-left",60398),layoutPanelCenter:(0,l.$Sj)("layout-panel-center",60399),layoutPanelJustify:(0,l.$Sj)("layout-panel-justify",60400),layoutPanelRight:(0,l.$Sj)("layout-panel-right",60401),layoutPanel:(0,l.$Sj)("layout-panel",60402),layoutSidebarLeft:(0,l.$Sj)("layout-sidebar-left",60403),layoutSidebarRight:(0,l.$Sj)("layout-sidebar-right",60404),layoutStatusbar:(0,l.$Sj)("layout-statusbar",60405),layoutMenubar:(0,l.$Sj)("layout-menubar",60406),layoutCentered:(0,l.$Sj)("layout-centered",60407),target:(0,l.$Sj)("target",60408),indent:(0,l.$Sj)("indent",60409),recordSmall:(0,l.$Sj)("record-small",60410),errorSmall:(0,l.$Sj)("error-small",60411),terminalDecorationError:(0,l.$Sj)("terminal-decoration-error",60411),arrowCircleDown:(0,l.$Sj)("arrow-circle-down",60412),arrowCircleLeft:(0,l.$Sj)("arrow-circle-left",60413),arrowCircleRight:(0,l.$Sj)("arrow-circle-right",60414),arrowCircleUp:(0,l.$Sj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,l.$Sj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,l.$Sj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,l.$Sj)("layout-sidebar-left-off",60418),blank:(0,l.$Sj)("blank",60419),heartFilled:(0,l.$Sj)("heart-filled",60420),map:(0,l.$Sj)("map",60421),mapHorizontal:(0,l.$Sj)("map-horizontal",60421),foldHorizontal:(0,l.$Sj)("fold-horizontal",60421),mapFilled:(0,l.$Sj)("map-filled",60422),mapHorizontalFilled:(0,l.$Sj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,l.$Sj)("fold-horizontal-filled",60422),circleSmall:(0,l.$Sj)("circle-small",60423),bellSlash:(0,l.$Sj)("bell-slash",60424),bellSlashDot:(0,l.$Sj)("bell-slash-dot",60425),commentUnresolved:(0,l.$Sj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,l.$Sj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,l.$Sj)("git-pull-request-new-changes",60428),searchFuzzy:(0,l.$Sj)("search-fuzzy",60429),commentDraft:(0,l.$Sj)("comment-draft",60430),send:(0,l.$Sj)("send",60431),sparkle:(0,l.$Sj)("sparkle",60432),insert:(0,l.$Sj)("insert",60433),mic:(0,l.$Sj)("mic",60434),thumbsdownFilled:(0,l.$Sj)("thumbsdown-filled",60435),thumbsupFilled:(0,l.$Sj)("thumbsup-filled",60436),coffee:(0,l.$Sj)("coffee",60437),snake:(0,l.$Sj)("snake",60438),game:(0,l.$Sj)("game",60439),vr:(0,l.$Sj)("vr",60440),chip:(0,l.$Sj)("chip",60441),piano:(0,l.$Sj)("piano",60442),music:(0,l.$Sj)("music",60443),micFilled:(0,l.$Sj)("mic-filled",60444),repoFetch:(0,l.$Sj)("repo-fetch",60445),copilot:(0,l.$Sj)("copilot",60446),lightbulbSparkle:(0,l.$Sj)("lightbulb-sparkle",60447),robot:(0,l.$Sj)("robot",60448),sparkleFilled:(0,l.$Sj)("sparkle-filled",60449),diffSingle:(0,l.$Sj)("diff-single",60450),diffMultiple:(0,l.$Sj)("diff-multiple",60451),surroundWith:(0,l.$Sj)("surround-with",60452),share:(0,l.$Sj)("share",60453),gitStash:(0,l.$Sj)("git-stash",60454),gitStashApply:(0,l.$Sj)("git-stash-apply",60455),gitStashPop:(0,l.$Sj)("git-stash-pop",60456),vscode:(0,l.$Sj)("vscode",60457),vscodeInsiders:(0,l.$Sj)("vscode-insiders",60458),codeOss:(0,l.$Sj)("code-oss",60459),runCoverage:(0,l.$Sj)("run-coverage",60460),runAllCoverage:(0,l.$Sj)("run-all-coverage",60461),coverage:(0,l.$Sj)("coverage",60462),githubProject:(0,l.$Sj)("github-project",60463),mapVertical:(0,l.$Sj)("map-vertical",60464),foldVertical:(0,l.$Sj)("fold-vertical",60464),mapVerticalFilled:(0,l.$Sj)("map-vertical-filled",60465),foldVerticalFilled:(0,l.$Sj)("fold-vertical-filled",60465),goToSearch:(0,l.$Sj)("go-to-search",60466),percentage:(0,l.$Sj)("percentage",60467),sortPercentage:(0,l.$Sj)("sort-percentage",60467)}}),define(ke[79],De([1,0,99,175]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=void 0,e.$Vj=L;function L(){return Object.values(e.$Xj)}e.$Wj={dialogError:(0,l.$Sj)("dialog-error","error"),dialogWarning:(0,l.$Sj)("dialog-warning","warning"),dialogInfo:(0,l.$Sj)("dialog-info","info"),dialogClose:(0,l.$Sj)("dialog-close","close"),treeItemExpanded:(0,l.$Sj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,l.$Sj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,l.$Sj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,l.$Sj)("tree-filter-clear","close"),treeItemLoading:(0,l.$Sj)("tree-item-loading","loading"),menuSelection:(0,l.$Sj)("menu-selection","check"),menuSubmenu:(0,l.$Sj)("menu-submenu","chevron-right"),menuBarMore:(0,l.$Sj)("menubar-more","more"),scrollbarButtonLeft:(0,l.$Sj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,l.$Sj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,l.$Sj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,l.$Sj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,l.$Sj)("toolbar-more","more"),quickInputBack:(0,l.$Sj)("quick-input-back","arrow-left"),dropDownButton:(0,l.$Sj)("drop-down-button",60084),symbolCustomColor:(0,l.$Sj)("symbol-customcolor",60252),exportIcon:(0,l.$Sj)("export",60332),workspaceUnspecified:(0,l.$Sj)("workspace-unspecified",60355),newLine:(0,l.$Sj)("newline",60394),thumbsDownFilled:(0,l.$Sj)("thumbsdown-filled",60435),thumbsUpFilled:(0,l.$Sj)("thumbsup-filled",60436),gitFetch:(0,l.$Sj)("git-fetch",60445),lightbulbSparkleAutofix:(0,l.$Sj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,l.$Sj)("debug-breakpoint-pending",60377)},e.$Xj={...O.$Uj,...e.$Wj}}),define(ke[24],De([1,0,18]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=O,e.$6n=L,e.$7n=M,e.$8n=$,e.$9n=E,e.$0n=I,e.$$n=P,e.$_n=p,e.$ao=S,e.$bo=v,e.$co=d,e.$do=f,e.$eo=a;function O(n){if(!n||typeof n!="object"||n instanceof RegExp)return n;const i=Array.isArray(n)?[]:{};return Object.entries(n).forEach(([c,r])=>{i[c]=r&&typeof r=="object"?O(r):r}),i}function L(n){if(!n||typeof n!="object")return n;const i=[n];for(;i.length>0;){const c=i.shift();Object.freeze(c);for(const r in c)if(A.call(c,r)){const t=c[r];typeof t=="object"&&!Object.isFrozen(t)&&!(0,l.$bg)(t)&&i.push(t)}}return n}const A=Object.prototype.hasOwnProperty;function M(n,i){return b(n,i,new Set)}function b(n,i,c){if((0,l.$hg)(n))return n;const r=i(n);if(typeof r<"u")return r;if(Array.isArray(n)){const t=[];for(const u of n)t.push(b(u,i,c));return t}if((0,l.$ag)(n)){if(c.has(n))throw new Error("Cannot clone recursive data-structure");c.add(n);const t={};for(const u in n)A.call(n,u)&&(t[u]=b(n[u],i,c));return c.delete(n),t}return n}function $(n,i,c=!0){return(0,l.$ag)(n)?((0,l.$ag)(i)&&Object.keys(i).forEach(r=>{r in n?c&&((0,l.$ag)(n[r])&&(0,l.$ag)(i[r])?$(n[r],i[r],c):n[r]=i[r]):n[r]=i[r]}),n):i}function E(n,i){if(n===i)return!0;if(n==null||i===null||i===void 0||typeof n!=typeof i||typeof n!="object"||Array.isArray(n)!==Array.isArray(i))return!1;let c,r;if(Array.isArray(n)){if(n.length!==i.length)return!1;for(c=0;c<n.length;c++)if(!E(n[c],i[c]))return!1}else{const t=[];for(r in n)t.push(r);t.sort();const u=[];for(r in i)u.push(r);if(u.sort(),!E(t,u))return!1;for(c=0;c<t.length;c++)if(!E(n[t[c]],i[t[c]]))return!1}return!0}function I(n){const i=new Set;return JSON.stringify(n,(c,r)=>{if((0,l.$ag)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return typeof r=="bigint"?`[BigInt ${r.toString()}]`:r})}function P(n,i){const c=Object.create(null);return!n||!i||Object.keys(i).forEach(t=>{const u=n[t],s=i[t];E(u,s)||(c[t]=s)}),c}function p(n,i){const c=i.toLowerCase(),r=Object.keys(n).find(t=>t.toLowerCase()===c);return r?n[r]:n[i]}function S(n,i){const c=Object.create(null);for(const[r,t]of Object.entries(n))i(r,t)&&(c[r]=t);return c}function v(n){let i=[];for(;Object.prototype!==n;)i=i.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return i}function d(n){const i=[];for(const c of v(n))typeof n[c]=="function"&&i.push(c);return i}function f(n,i){const c=t=>function(){const u=Array.prototype.slice.call(arguments,0);return i(t,u)},r={};for(const t of n)r[t]=c(t);return r}function a(n,i){const c={};for(const[r,t]of Object.entries(n))c[r]=i(t,r);return c}}),define(ke[50],De([1,0,79]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Yj=L;var O;(function(M){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}M.isThemeColor=b})(O||(e.ThemeColor=O={}));function L(M){return{id:M}}var A;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function $(n){const i=b.exec(n.id);if(!i)return $(l.$Xj.error);const[,c,r]=i,t=["codicon","codicon-"+c];return r&&t.push("codicon-modifier-"+r.substring(1)),t}M.asClassNameArray=$;function E(n){return $(n).join(" ")}M.asClassName=E;function I(n){return"."+$(n).join(".")}M.asCSSSelector=I;function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}M.isThemeIcon=P;const p=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function S(n){const i=p.exec(n);if(!i)return;const[,c]=i;return{id:c}}M.fromString=S;function v(n){return{id:n}}M.fromId=v;function d(n,i){let c=n.id;const r=c.lastIndexOf("~");return r!==-1&&(c=c.substring(0,r)),i&&(c=`${c}~${i}`),{id:c}}M.modify=d;function f(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}M.getModifier=f;function a(n,i){return n.id===i.id&&n.color?.id===i.color?.id}M.isEqual=a})(A||(e.ThemeIcon=A={}))}),define(ke[176],De([1,0,127,14,50]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=$,e.$Qk=I,e.$Rk=p,e.$Sk=S,e.$Tk=d,e.$Uk=f;const A="$(",M=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${M.source}`,"g");function $(a){return a.replace(b,(n,i)=>i?n:`\\${n}`)}const E=new RegExp(`\\\\${M.source}`,"g");function I(a){return a.replace(E,n=>`\\${n}`)}const P=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function p(a){return a.indexOf(A)===-1?a:a.replace(P,(n,i,c,r)=>c?n:i||r||"")}function S(a){return a?a.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(a){v.lastIndex=0;let n="";const i=[];let c=0;for(;;){const r=v.lastIndex,t=v.exec(a),u=a.substring(r,t?.index);if(u.length>0){n+=u;for(let s=0;s<u.length;s++)i.push(c)}if(!t)break;c+=t[0].length}return{text:n,iconOffsets:i}}function f(a,n,i=!1){const{text:c,iconOffsets:r}=n;if(!r||r.length===0)return(0,l.$Gk)(a,c,i);const t=(0,O.$gf)(c," "),u=c.length-t.length,s=(0,l.$Gk)(a,t,i);if(s)for(const o of s){const h=r[o.start+u]+u;o.start+=h,o.end+=h}return s}}),define(ke[128],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$7e=O,e.$8e=L;var l;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l||(e.Constants=l={}));function O(A){return A<0?0:A>255?255:A|0}function L(A){return A<0?0:A>4294967295?4294967295:A|0}}),define(ke[30],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=O;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(L){return l.test(L)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let $=0,E="";return E+=M[A[$++]],E+=M[A[$++]],E+=M[A[$++]],E+=M[A[$++]],E+="-",E+=M[A[$++]],E+=M[A[$++]],E+="-",E+=M[A[$++]],E+=M[A[$++]],E+="-",E+=M[A[$++]],E+=M[A[$++]],E+="-",E+=M[A[$++]],E+=M[A[$++]],E+=M[A[$++]],E+=M[A[$++]],E+=M[A[$++]],E+=M[A[$++]],E}}()}),define(ke[177],De([1,0,19,39,30]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=e.$au=void 0,e.$$t=A,e.$_t=M,e.$bu=E;function A(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}function M(P,p,S){const v={id:(0,L.$Ug)(),name:P,uri:p,data:S};return{asString:async()=>"",asFile:()=>v,value:void 0}}class b{constructor(){this.a=new Map}get size(){let p=0;for(const S of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const S=[...this.a.keys()];return O.Iterable.some(this,([v,d])=>d.asFile())&&S.push("files"),I($(p),S)}get(p){return this.a.get(this.b(p))?.[0]}append(p,S){const v=this.a.get(p);v?v.push(S):this.a.set(this.b(p),[S])}replace(p,S){this.a.set(this.b(p),[S])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,S]of this.a)for(const v of S)yield[p,v]}b(p){return $(p)}}e.$au=b;function $(P){return P.toLowerCase()}function E(P,p){return I($(P),p.map($))}function I(P,p){if(P==="*/*")return p.length>0;if(p.includes(P))return!0;const S=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[v,d,f]=S;return f==="*"?p.some(a=>a.startsWith(d+"/")):!1}e.$cu=Object.freeze({create:P=>(0,l.$Mb)(P.map(p=>p.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$cu.split(P).filter(p=>!p.startsWith("#"))})}),define(ke[178],De([1,0,63]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xg=void 0,e.$Wg=O,e.$Yg=A;function O(b,$,E,I=1){let P=!1;return new Promise(p=>{const S=setTimeout(()=>{if(!P)return P=!0,p(0)},E);L(b,$,I,v=>{if(!P)return P=!0,clearTimeout(S),p(v)})})}function L(b,$,E,I){if($===0)return I(0);const P=new l.Socket;P.once("connect",()=>(M(P),L(b+E,$-1,E,I))),P.once("data",()=>{}),P.once("error",p=>(M(P),p.code!=="ECONNREFUSED"?L(b+E,$-1,E,I):I(b))),P.connect(b,"127.0.0.1")}e.$Xg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(b,$,E,I="127.0.0.1"){let P=!1,p,S=1;const v=l.createServer({pauseOnConnect:!0});function d(f,a){P||(P=!0,v.removeAllListeners(),v.close(),p&&clearTimeout(p),a(f))}return new Promise(f=>{p=setTimeout(()=>{d(0,f)},E),v.on("listening",()=>{d(b,f)}),v.on("error",a=>{a&&(a.code==="EADDRINUSE"||a.code==="EACCES")&&S<$?(b++,S++,v.listen(b,I)):d(0,f)}),v.on("close",()=>{d(0,f)}),v.listen(b,I)})}function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(ke[129],De([1,0,128]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4t=e.$3t=void 0;class O{constructor(b){const $=(0,l.$7e)(b);this.c=$,this.a=O.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const E=(0,l.$7e)($);b>=0&&b<256?this.a[b]=E:this.b.set(b,E)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$3t=O;var L;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(L||(L={}));class A{constructor(){this.a=new O(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$4t=A}),define(ke[179],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$iu=O;var l;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(l||(e.StringEOL=l={}));function O(L){let A=0,M=0,b=0,$=0;for(let E=0,I=L.length;E<I;E++){const P=L.charCodeAt(E);P===13?(A===0&&(M=E),A++,E+1<I&&L.charCodeAt(E+1)===10?($|=2,E++):$|=3,b=E+1):P===10&&($|=1,A===0&&(M=E),A++,b=E+1)}return A===0&&(M=L.length),[A,M,L.length-b,$]}}),define(ke[51],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0;class l{constructor(L,A){this.lineNumber=L,this.column=A}with(L=this.lineNumber,A=this.column){return L===this.lineNumber&&A===this.column?this:new l(L,A)}delta(L=0,A=0){return this.with(this.lineNumber+L,this.column+A)}equals(L){return l.equals(this,L)}static equals(L,A){return!L&&!A?!0:!!L&&!!A&&L.lineNumber===A.lineNumber&&L.column===A.column}isBefore(L){return l.isBefore(this,L)}static isBefore(L,A){return L.lineNumber<A.lineNumber?!0:A.lineNumber<L.lineNumber?!1:L.column<A.column}isBeforeOrEqual(L){return l.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,A){return L.lineNumber<A.lineNumber?!0:A.lineNumber<L.lineNumber?!1:L.column<=A.column}static compare(L,A){const M=L.lineNumber|0,b=A.lineNumber|0;if(M===b){const $=L.column|0,E=A.column|0;return $-E}return M-b}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new l(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$xt=l}),define(ke[29],De([1,0,51]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=void 0;class O{constructor(A,M,b,$){A>b||A===b&&M>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=A,this.endColumn=M):(this.startLineNumber=A,this.startColumn=M,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return O.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return O.containsPosition(this,A)}static containsPosition(A,M){return!(M.lineNumber<A.startLineNumber||M.lineNumber>A.endLineNumber||M.lineNumber===A.startLineNumber&&M.column<A.startColumn||M.lineNumber===A.endLineNumber&&M.column>A.endColumn)}static strictContainsPosition(A,M){return!(M.lineNumber<A.startLineNumber||M.lineNumber>A.endLineNumber||M.lineNumber===A.startLineNumber&&M.column<=A.startColumn||M.lineNumber===A.endLineNumber&&M.column>=A.endColumn)}containsRange(A){return O.containsRange(this,A)}static containsRange(A,M){return!(M.startLineNumber<A.startLineNumber||M.endLineNumber<A.startLineNumber||M.startLineNumber>A.endLineNumber||M.endLineNumber>A.endLineNumber||M.startLineNumber===A.startLineNumber&&M.startColumn<A.startColumn||M.endLineNumber===A.endLineNumber&&M.endColumn>A.endColumn)}strictContainsRange(A){return O.strictContainsRange(this,A)}static strictContainsRange(A,M){return!(M.startLineNumber<A.startLineNumber||M.endLineNumber<A.startLineNumber||M.startLineNumber>A.endLineNumber||M.endLineNumber>A.endLineNumber||M.startLineNumber===A.startLineNumber&&M.startColumn<=A.startColumn||M.endLineNumber===A.endLineNumber&&M.endColumn>=A.endColumn)}plusRange(A){return O.plusRange(this,A)}static plusRange(A,M){let b,$,E,I;return M.startLineNumber<A.startLineNumber?(b=M.startLineNumber,$=M.startColumn):M.startLineNumber===A.startLineNumber?(b=M.startLineNumber,$=Math.min(M.startColumn,A.startColumn)):(b=A.startLineNumber,$=A.startColumn),M.endLineNumber>A.endLineNumber?(E=M.endLineNumber,I=M.endColumn):M.endLineNumber===A.endLineNumber?(E=M.endLineNumber,I=Math.max(M.endColumn,A.endColumn)):(E=A.endLineNumber,I=A.endColumn),new O(b,$,E,I)}intersectRanges(A){return O.intersectRanges(this,A)}static intersectRanges(A,M){let b=A.startLineNumber,$=A.startColumn,E=A.endLineNumber,I=A.endColumn;const P=M.startLineNumber,p=M.startColumn,S=M.endLineNumber,v=M.endColumn;return b<P?(b=P,$=p):b===P&&($=Math.max($,p)),E>S?(E=S,I=v):E===S&&(I=Math.min(I,v)),b>E||b===E&&$>I?null:new O(b,$,E,I)}equalsRange(A){return O.equalsRange(this,A)}static equalsRange(A,M){return!A&&!M?!0:!!A&&!!M&&A.startLineNumber===M.startLineNumber&&A.startColumn===M.startColumn&&A.endLineNumber===M.endLineNumber&&A.endColumn===M.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(A){return new l.$xt(A.endLineNumber,A.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(A){return new l.$xt(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,M){return new O(this.startLineNumber,this.startColumn,A,M)}setStartPosition(A,M){return new O(A,M,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(A){return new O(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(A){return new O(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new O(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,M=A){return new O(A.lineNumber,A.column,M.lineNumber,M.column)}static lift(A){return A?new O(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,M){return!(A.endLineNumber<M.startLineNumber||A.endLineNumber===M.startLineNumber&&A.endColumn<M.startColumn||M.endLineNumber<A.startLineNumber||M.endLineNumber===A.startLineNumber&&M.endColumn<A.startColumn)}static areIntersecting(A,M){return!(A.endLineNumber<M.startLineNumber||A.endLineNumber===M.startLineNumber&&A.endColumn<=M.startColumn||M.endLineNumber<A.startLineNumber||M.endLineNumber===A.startLineNumber&&M.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,M){if(A&&M){const E=A.startLineNumber|0,I=M.startLineNumber|0;if(E===I){const P=A.startColumn|0,p=M.startColumn|0;if(P===p){const S=A.endLineNumber|0,v=M.endLineNumber|0;if(S===v){const d=A.endColumn|0,f=M.endColumn|0;return d-f}return S-v}return P-p}return E-I}return(A?1:0)-(M?1:0)}static compareRangesUsingEnds(A,M){return A.endLineNumber===M.endLineNumber?A.endColumn===M.endColumn?A.startLineNumber===M.startLineNumber?A.startColumn-M.startColumn:A.startLineNumber-M.startLineNumber:A.endColumn-M.endColumn:A.endLineNumber-M.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$yt=O}),define(ke[180],De([1,0,29]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=void 0;class O{static insert(A,M){return{range:new l.$yt(A.lineNumber,A.column,A.lineNumber,A.column),text:M,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,M){return{range:A,text:M}}static replaceMove(A,M){return{range:A,text:M,forceMoveMarkers:!0}}}e.$zt=O}),define(ke[181],De([1,0,51,29]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.SelectionDirection=void 0;var L;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class A extends O.$yt{constructor(b,$,E,I){super(b,$,E,I),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=E,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return A.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,b,$):new A(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new l.$xt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.$xt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new A(b,$,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new A(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new A(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new A(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new A(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let E=0,I=b.length;E<I;E++)if(!this.selectionsEqual(b[E],$[E]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,E,I,P){return P===0?new A(b,$,E,I):new A(E,I,b,$)}}e.$At=A}),define(ke[182],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$8s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[183],De([1,0,27,129]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5t=e.WordCharacterClass=void 0,e.$6t=b;var L;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class A extends O.$3t{constructor(E,I){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=I,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let P=0,p=E.length;P<p;P++)this.set(E.charCodeAt(P),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(E,I){let P=null;for(const p of this.h(E)){if(p.index>I)break;P=p}return P}findNextIntlWordAtOrAfterOffset(E,I){for(const P of this.h(E))if(!(P.index<I))return P;return null}h(E){return this.e?this.f===E?this.g:(this.f=E,this.g=this.j(this.e.segment(E)),this.g):[]}j(E){const I=[];for(const P of E)this.k(P)&&I.push(P);return I}k(E){return!!E.isWordLike}}e.$5t=A;const M=new l.$Dc(10);function b($,E){const I=`${$}/${E.join(",")}`;let P=M.get(I);return P||(P=new A($,E),M.set(I,P)),P}}),define(ke[130],De([1,0,39,3,76]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.$9s=void 0,e.$$s=M,e.$_s=$,e.$at=E,e.$9s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(P=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$9s)P.indexOf(S)>=0||(p+="\\"+S);return p+="\\s]+)",new RegExp(p,"g")}e.$0s=A();function M(P){let p=e.$0s;if(P&&P instanceof RegExp)if(P.global)p=P;else{let S="g";P.ignoreCase&&(S+="i"),P.multiline&&(S+="m"),P.unicode&&(S+="u"),p=new RegExp(P.source,S)}return p.lastIndex=0,p}const b=new L.$5c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(P){const p=b.unshift(P);return(0,O.$Sc)(p)}function E(P,p,S,v,d){if(p=M(p),d||(d=l.Iterable.first(b)),S.length>d.maxLen){let c=P-d.maxLen/2;return c<0?c=0:v+=c,S=S.substring(c,P+d.maxLen/2),E(P,p,S,v,d)}const f=Date.now(),a=P-1-v;let n=-1,i=null;for(let c=1;!(Date.now()-f>=d.timeBudget);c++){const r=a-d.windowSize*c;p.lastIndex=Math.max(0,r);const t=I(p,S,a,n);if(!t&&i||(i=t,r<=0))break;n=r}if(i){const c={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return p.lastIndex=0,c}return null}function I(P,p,S,v){let d;for(;d=P.exec(p);){const f=d.index||0;if(f<=S&&P.lastIndex>=S)return d;if(v>0&&f>v)return null}return null}}),define(ke[184],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fu=e.$Eu=e.IndentAction=void 0;var l;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(l||(e.IndentAction=l={}));class O{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,E=b.notIn.length;$<E;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const E=b.findTokenIndexAtOffset($-2),I=b.getStandardTokenType(E);return this.isOK(I)}g(b,$){for(let E=b;E<=$;E++){const I=String.fromCharCode(E);if(!this.open.includes(I)&&!this.close.includes(I))return I}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Eu=O;class L{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)A(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),A(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),A(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),A(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&A(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Fu=L;function A(M,b,$){M.has(b)?M.get(b).push($):M.set(b,[$])}}),define(ke[185],De([1,0,129]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L2=e.$K2=e.State=void 0,e.$M2=p;var O;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class L{constructor(v,d,f){const a=new Uint8Array(v*d);for(let n=0,i=v*d;n<i;n++)a[n]=f;this.a=a,this.rows=v,this.cols=d}get(v,d){return this.a[v*this.cols+d]}set(v,d,f){this.a[v*this.cols+d]=f}}class A{constructor(v){let d=0,f=0;for(let n=0,i=v.length;n<i;n++){const[c,r,t]=v[n];r>d&&(d=r),c>f&&(f=c),t>f&&(f=t)}d++,f++;const a=new L(f,d,0);for(let n=0,i=v.length;n<i;n++){const[c,r,t]=v[n];a.set(c,r,t)}this.a=a,this.b=d}nextState(v,d){return d<0||d>=this.b?0:this.a.get(v,d)}}e.$K2=A;let M=null;function b(){return M===null&&(M=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var $;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})($||($={}));let E=null;function I(){if(E===null){E=new l.$3t(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<S.length;d++)E.set(S.charCodeAt(d),1);const v=".,;:";for(let d=0;d<v.length;d++)E.set(v.charCodeAt(d),2)}return E}class P{static a(v,d,f,a,n){let i=n-1;do{const c=d.charCodeAt(i);if(v.get(c)!==2)break;i--}while(i>a);if(a>0){const c=d.charCodeAt(a-1),r=d.charCodeAt(i);(c===40&&r===41||c===91&&r===93||c===123&&r===125)&&i--}return{range:{startLineNumber:f,startColumn:a+1,endLineNumber:f,endColumn:i+2},url:d.substring(a,i+1)}}static computeLinks(v,d=b()){const f=I(),a=[];for(let n=1,i=v.getLineCount();n<=i;n++){const c=v.getLineContent(n),r=c.length;let t=0,u=0,s=0,o=1,h=!1,g=!1,w=!1,k=!1;for(;t<r;){let m=!1;const y=c.charCodeAt(t);if(o===13){let D;switch(y){case 40:h=!0,D=0;break;case 41:D=h?0:1;break;case 91:w=!0,g=!0,D=0;break;case 93:w=!1,D=g?0:1;break;case 123:k=!0,D=0;break;case 125:D=k?0:1;break;case 39:case 34:case 96:s===y?D=1:s===39||s===34||s===96?D=0:D=1;break;case 42:D=s===42?1:0;break;case 124:D=s===124?1:0;break;case 32:D=w?0:1;break;default:D=f.get(y)}D===1&&(a.push(P.a(f,c,n,u,t)),m=!0)}else if(o===12){let D;y===91?(g=!0,D=0):D=f.get(y),D===1?m=!0:o=13}else o=d.nextState(o,y),o===0&&(m=!0);m&&(o=1,h=!1,g=!1,k=!1,u=t+1,s=y),t++}o===13&&a.push(P.a(f,c,n,u,r))}return a}}e.$L2=P;function p(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:P.computeLinks(S)}}),define(ke[80],De([1,0,24]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3v=e.$2v=e.$1v=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$Yv=e.$Xv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$Zv=v,e.$4v=c;var O;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var L;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var A;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var M;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(M||(e.MinimapSectionHeaderStyle=M={}));var b;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var $;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var E;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var I;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,l.$9n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$Xv=P;class p{constructor(t,u){this._findMatchBrand=void 0,this.range=t,this.matches=u}}e.$Yv=p;var S;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(S||(e.TrackedRangeStickiness=S={}));function v(r){return r&&typeof r.read=="function"}var d;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(d||(e.PositionAffinity=d={}));var f;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(f||(e.ModelConstants=f={}));class a{constructor(t,u,s,o,h,g){this.identifier=t,this.range=u,this.text=s,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=h,this._isTracked=g}}e.$1v=a;class n{constructor(t,u,s){this.regex=t,this.wordSeparators=u,this.simpleSearch=s}}e.$2v=n;class i{constructor(t,u,s){this.reverseEdits=t,this.changes=u,this.trimAutoWhitespaceLineNumbers=s}}e.$3v=i;function c(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}}),define(ke[186],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.NodeColor=e.$JC=void 0,e.$LC=L,e.$MC=A,e.$NC=E,e.$OC=I,e.$PC=P,e.$QC=p,e.$RC=S,e.$SC=v;class l{constructor(f,a){this.piece=f,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$KC)return L(this.right);let f=this;for(;f.parent!==e.$KC&&f.parent.left!==f;)f=f.parent;return f.parent===e.$KC?e.$KC:f.parent}prev(){if(this.left!==e.$KC)return A(this.left);let f=this;for(;f.parent!==e.$KC&&f.parent.right!==f;)f=f.parent;return f.parent===e.$KC?e.$KC:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$JC=l;var O;(function(d){d[d.Black=0]="Black",d[d.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$KC=new l(null,0),e.$KC.parent=e.$KC,e.$KC.left=e.$KC,e.$KC.right=e.$KC,e.$KC.color=0;function L(d){for(;d.left!==e.$KC;)d=d.left;return d}function A(d){for(;d.right!==e.$KC;)d=d.right;return d}function M(d){return d===e.$KC?0:d.size_left+d.piece.length+M(d.right)}function b(d){return d===e.$KC?0:d.lf_left+d.piece.lineFeedCnt+b(d.right)}function $(){e.$KC.parent=e.$KC}function E(d,f){const a=f.right;a.size_left+=f.size_left+(f.piece?f.piece.length:0),a.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=a.left,a.left!==e.$KC&&(a.left.parent=f),a.parent=f.parent,f.parent===e.$KC?d.root=a:f.parent.left===f?f.parent.left=a:f.parent.right=a,a.left=f,f.parent=a}function I(d,f){const a=f.left;f.left=a.right,a.right!==e.$KC&&(a.right.parent=f),a.parent=f.parent,f.size_left-=a.size_left+(a.piece?a.piece.length:0),f.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),f.parent===e.$KC?d.root=a:f===f.parent.right?f.parent.right=a:f.parent.left=a,a.right=f,f.parent=a}function P(d,f){let a,n;if(f.left===e.$KC?(n=f,a=n.right):f.right===e.$KC?(n=f,a=n.left):(n=L(f.right),a=n.right),n===d.root){d.root=a,a.color=0,f.detach(),$(),d.root.parent=e.$KC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=a:n.parent.right=a,n===f?(a.parent=n.parent,v(d,a)):(n.parent===f?a.parent=n:a.parent=n.parent,v(d,a),n.left=f.left,n.right=f.right,n.parent=f.parent,n.color=f.color,f===d.root?d.root=n:f===f.parent.left?f.parent.left=n:f.parent.right=n,n.left!==e.$KC&&(n.left.parent=n),n.right!==e.$KC&&(n.right.parent=n),n.size_left=f.size_left,n.lf_left=f.lf_left,v(d,n)),f.detach(),a.parent.left===a){const r=M(a),t=b(a);if(r!==a.parent.size_left||t!==a.parent.lf_left){const u=r-a.parent.size_left,s=t-a.parent.lf_left;a.parent.size_left=r,a.parent.lf_left=t,S(d,a.parent,u,s)}}if(v(d,a.parent),i){$();return}let c;for(;a!==d.root&&a.color===0;)a===a.parent.left?(c=a.parent.right,c.color===1&&(c.color=0,a.parent.color=1,E(d,a.parent),c=a.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,a=a.parent):(c.right.color===0&&(c.left.color=0,c.color=1,I(d,c),c=a.parent.right),c.color=a.parent.color,a.parent.color=0,c.right.color=0,E(d,a.parent),a=d.root)):(c=a.parent.left,c.color===1&&(c.color=0,a.parent.color=1,I(d,a.parent),c=a.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,a=a.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(d,c),c=a.parent.left),c.color=a.parent.color,a.parent.color=0,c.left.color=0,I(d,a.parent),a=d.root));a.color=0,$()}function p(d,f){for(v(d,f);f!==d.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const a=f.parent.parent.right;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,E(d,f)),f.parent.color=0,f.parent.parent.color=1,I(d,f.parent.parent))}else{const a=f.parent.parent.left;a.color===1?(f.parent.color=0,a.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,I(d,f)),f.parent.color=0,f.parent.parent.color=1,E(d,f.parent.parent))}d.root.color=0}function S(d,f,a,n){for(;f!==d.root&&f!==e.$KC;)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=n),f=f.parent}function v(d,f){let a=0,n=0;if(f!==d.root){for(;f!==d.root&&f===f.parent.right;)f=f.parent;if(f!==d.root)for(f=f.parent,a=M(f.left)-f.size_left,n=b(f.left)-f.lf_left,f.size_left+=a,f.lf_left+=n;f!==d.root&&(a!==0||n!==0);)f.parent.left===f&&(f.parent.size_left+=a,f.parent.lf_left+=n),f=f.parent}}}),define(ke[187],De([1,0,19,128]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.$7v=void 0;class L{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,E){$=(0,O.$8e)($);const I=this.a,P=this.b,p=E.length;return p===0?!1:(this.a=new Uint32Array(I.length+p),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($),$+p),this.a.set(E,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue($,E){return $=(0,O.$8e)($),E=(0,O.$8e)(E),this.a[$]===E?!1:(this.a[$]=E,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,E){$=(0,O.$8e)($),E=(0,O.$8e)(E);const I=this.a,P=this.b;if($>=I.length)return!1;const p=I.length-$;return E>=p&&(E=p),E===0?!1:(this.a=new Uint32Array(I.length-E),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($+E),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,O.$8e)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),$>=this.a.length&&($=this.a.length-1);for(let I=E;I<=$;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let E=0,I=this.a.length-1,P=0,p=0,S=0;for(;E<=I;)if(P=E+(I-E)/2|0,p=this.b[P],S=p-this.a[P],$<S)I=P-1;else if($>=p)E=P+1;else break;return new M(P,$-S)}}e.$7v=L;class A{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const E=this.e[$],I=E>0?this.d[E-1]:0;return new M(E,$-I)}removeValues($,E){this.a.splice($,E),this.f($)}insertValues($,E){this.a=(0,l.$Vb)(this.a,$,E),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,E=this.a.length;$<E;$++){const I=this.a[$],P=$>0?this.d[$-1]:0;this.d[$]=P+I;for(let p=0;p<I;p++)this.e[P+p]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,E){this.a[$]!==E&&(this.a[$]=E,this.f($))}}e.$8v=A;class M{constructor($,E){this.index=$,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=E}}e.$9v=M}),define(ke[188],De([1,0,14,51,187]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0v=void 0;class A{constructor(b,$,E,I){this.d=b,this.f=$,this.g=E,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const E of $)this.o(E.range),this.p(new O.$xt(E.range.startLineNumber,E.range.startColumn),E.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,E=new Uint32Array($);for(let I=0;I<$;I++)E[I]=this.f[I].length+b;this.j=new L.$7v(E)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const E=(0,l.$mf)($);if(E.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]+this.f[b.lineNumber-1].substring(b.column-1));return}E[E.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+E[0]);const I=new Uint32Array(E.length-1);for(let P=1;P<E.length;P++)this.f.splice(b.lineNumber+P-1,0,E[P]),I[P-1]=E[P].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,I)}}e.$0v=A}),define(ke[100],De([1,0,14,183,51,29,80]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YC=e.$WC=e.$TC=void 0,e.$UC=E,e.$VC=I,e.$XC=d;const b=999;class ${constructor(n,i,c,r){this.searchString=n,this.isRegex=i,this.matchCase=c,this.wordSeparators=r}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=E(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=l.$kf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let c=!this.isRegex&&!n;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new M.$2v(i,this.wordSeparators?(0,O.$6t)(this.wordSeparators,[]):null,c?this.searchString:null)}}e.$TC=$;function E(a){if(!a||a.length===0)return!1;for(let n=0,i=a.length;n<i;n++){const c=a.charCodeAt(n);if(c===10)return!0;if(c===92){if(n++,n>=i)break;const r=a.charCodeAt(n);if(r===110||r===114||r===87)return!0}}return!1}function I(a,n,i){if(!i)return new M.$Yv(a,null);const c=[];for(let r=0,t=n.length;r<t;r++)c[r]=n[r];return new M.$Yv(a,c)}class P{constructor(n){const i=[];let c=0;for(let r=0,t=n.length;r<t;r++)n.charCodeAt(r)===10&&(i[c++]=r);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let c=0,r=i.length-1;if(r===-1||n<=i[0])return 0;for(;c<r;){const t=c+((r-c)/2>>0);i[t]>=n?r=t-1:i[t+1]>=n?(c=t,r=t):c=t+1}return c+1}}class p{static findMatches(n,i,c,r,t){const u=i.parseSearchRequest();return u?u.regex.multiline?this.b(n,c,new f(u.wordSeparators,u.regex),r,t):this.c(n,c,u,r,t):[]}static a(n,i,c,r,t,u){let s,o=0;r?(o=r.findLineFeedCountBeforeOffset(t),s=i+t+o):s=i+t;let h;if(r){const m=r.findLineFeedCountBeforeOffset(t+u.length)-o;h=s+u.length+m}else h=s+u.length;const g=n.getPositionAt(s),w=n.getPositionAt(h);return new A.$yt(g.lineNumber,g.column,w.lineNumber,w.column)}static b(n,i,c,r,t){const u=n.getOffsetAt(i.getStartPosition()),s=n.getValueInRange(i,1),o=n.getEOL()===`\r
`?new P(s):null,h=[];let g=0,w;for(c.reset(0);w=c.next(s);)if(h[g++]=I(this.a(n,u,s,o,w.index,w[0]),w,r),g>=t)return h;return h}static c(n,i,c,r,t){const u=[];let s=0;if(i.startLineNumber===i.endLineNumber){const h=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return s=this.d(c,h,i.startLineNumber,i.startColumn-1,s,u,r,t),u}const o=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);s=this.d(c,o,i.startLineNumber,i.startColumn-1,s,u,r,t);for(let h=i.startLineNumber+1;h<i.endLineNumber&&s<t;h++)s=this.d(c,n.getLineContent(h),h,0,s,u,r,t);if(s<t){const h=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);s=this.d(c,h,i.endLineNumber,0,s,u,r,t)}return u}static d(n,i,c,r,t,u,s,o){const h=n.wordSeparators;if(!s&&n.simpleSearch){const k=n.simpleSearch,m=k.length,y=i.length;let D=-m;for(;(D=i.indexOf(k,D+m))!==-1;)if((!h||d(h,i,y,D,m))&&(u[t++]=new M.$Yv(new A.$yt(c,D+1+r,c,D+1+m+r),null),t>=o))return t;return t}const g=new f(n.wordSeparators,n.regex);let w;g.reset(0);do if(w=g.next(i),w&&(u[t++]=I(new A.$yt(c,w.index+1+r,c,w.index+1+w[0].length+r),w,s),t>=o))return t;while(w);return t}static findNextMatch(n,i,c,r){const t=i.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,c,u,r):this.f(n,c,u,r)}static e(n,i,c,r){const t=new L.$xt(i.lineNumber,1),u=n.getOffsetAt(t),s=n.getLineCount(),o=n.getValueInRange(new A.$yt(t.lineNumber,t.column,s,n.getLineMaxColumn(s)),1),h=n.getEOL()===`\r
`?new P(o):null;c.reset(i.column-1);const g=c.next(o);return g?I(this.a(n,u,o,h,g.index,g[0]),g,r):i.lineNumber!==1||i.column!==1?this.e(n,new L.$xt(1,1),c,r):null}static f(n,i,c,r){const t=n.getLineCount(),u=i.lineNumber,s=n.getLineContent(u),o=this.g(c,s,u,i.column,r);if(o)return o;for(let h=1;h<=t;h++){const g=(u+h-1)%t,w=n.getLineContent(g+1),k=this.g(c,w,g+1,1,r);if(k)return k}return null}static g(n,i,c,r,t){n.reset(r-1);const u=n.next(i);return u?I(new A.$yt(c,u.index+1,c,u.index+1+u[0].length),u,t):null}static findPreviousMatch(n,i,c,r){const t=i.parseSearchRequest();if(!t)return null;const u=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,c,u,r):this.j(n,c,u,r)}static h(n,i,c,r){const t=this.b(n,new A.$yt(1,1,i.lineNumber,i.column),c,r,10*b);if(t.length>0)return t[t.length-1];const u=n.getLineCount();return i.lineNumber!==u||i.column!==n.getLineMaxColumn(u)?this.h(n,new L.$xt(u,n.getLineMaxColumn(u)),c,r):null}static j(n,i,c,r){const t=n.getLineCount(),u=i.lineNumber,s=n.getLineContent(u).substring(0,i.column-1),o=this.k(c,s,u,r);if(o)return o;for(let h=1;h<=t;h++){const g=(t+u-h-1)%t,w=n.getLineContent(g+1),k=this.k(c,w,g+1,r);if(k)return k}return null}static k(n,i,c,r){let t=null,u;for(n.reset(0);u=n.next(i);)t=I(new A.$yt(c,u.index+1,c,u.index+1+u[0].length),u,r);return t}}e.$WC=p;function S(a,n,i,c,r){if(c===0)return!0;const t=n.charCodeAt(c-1);if(a.get(t)!==0||t===13||t===10)return!0;if(r>0){const u=n.charCodeAt(c);if(a.get(u)!==0)return!0}return!1}function v(a,n,i,c,r){if(c+r===i)return!0;const t=n.charCodeAt(c+r);if(a.get(t)!==0||t===13||t===10)return!0;if(r>0){const u=n.charCodeAt(c+r-1);if(a.get(u)!==0)return!0}return!1}function d(a,n,i,c,r){return S(a,n,i,c,r)&&v(a,n,i,c,r)}class f{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let c;do{if(this.b+this.c===i||(c=this.a.exec(n),!c))return null;const r=c.index,t=c[0].length;if(r===this.b&&t===this.c){if(t===0){l.$Gf(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=r,this.c=t,!this._wordSeparators||d(this._wordSeparators,n,i,r,t))return c}while(c);return null}}e.$YC=f}),define(ke[131],De([1,0,51,29,80,186,100]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.$3C=e.$2C=void 0,e.$ZC=I,e.$1C=P;const b=65535;function $(a){let n;return a[a.length-1]<65536?n=new Uint16Array(a.length):n=new Uint32Array(a.length),n.set(a,0),n}class E{constructor(n,i,c,r,t){this.lineStarts=n,this.cr=i,this.lf=c,this.crlf=r,this.isBasicASCII=t}}function I(a,n=!0){const i=[0];let c=1;for(let r=0,t=a.length;r<t;r++){const u=a.charCodeAt(r);u===13?r+1<t&&a.charCodeAt(r+1)===10?(i[c++]=r+2,r++):i[c++]=r+1:u===10&&(i[c++]=r+1)}return n?$(i):i}function P(a,n){a.length=0,a[0]=0;let i=1,c=0,r=0,t=0,u=!0;for(let o=0,h=n.length;o<h;o++){const g=n.charCodeAt(o);g===13?o+1<h&&n.charCodeAt(o+1)===10?(t++,a[i++]=o+2,o++):(c++,a[i++]=o+1):g===10?(r++,a[i++]=o+1):u&&g!==9&&(g<32||g>126)&&(u=!1)}const s=new E($(a),c,r,t,u);return a.length=0,s}class p{constructor(n,i,c,r,t){this.bufferIndex=n,this.start=i,this.end=c,this.lineFeedCnt=r,this.length=t}}e.$2C=p;class S{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$3C=S;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==A.$KC&&n.iterate(n.root,c=>(c!==A.$KC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class d{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const c=this.b[i];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const c=this.b;for(let r=0;r<c.length;r++){const t=c[r];if(t.node.parent===null||t.nodeStartOffset>=n){c[r]=null,i=!0;continue}}if(i){const r=[];for(const t of c)t!==null&&r.push(t);this.b=r}}}class f{constructor(n,i,c){this.create(n,i,c)}create(n,i,c){this.a=[new S("",[0])],this.g={line:0,column:0},this.root=A.$KC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=c;let r=null;for(let t=0,u=n.length;t<u;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=I(n[t].buffer));const s=new p(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),r=this.S(r,s)}this.h=new d(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,c=i-Math.floor(i/3),r=c*2;let t="",u=0;const s=[];if(this.iterate(this.root,o=>{const h=this.R(o),g=h.length;if(u<=c||u+g<r)return t+=h,u+=g,!0;const w=t.replace(/\r\n|\r|\n/g,n);return s.push(new S(w,I(w))),t=h,u=g,!0}),u>0){const o=t.replace(/\r\n|\r|\n/g,n);s.push(new S(o,I(o)))}this.create(s,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,r=>{if(r===A.$KC)return!0;const t=this.R(r),u=t.length,s=n.G(i),o=n.G(i+u),h=n.getValueInRange2(s,o);return i+=u,t===h})}getOffsetAt(n,i){let c=0,r=this.root;for(;r!==A.$KC;)if(r.left!==A.$KC&&r.lf_left+1>=n)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt+1>=n){c+=r.size_left;const t=this.B(r,n-r.lf_left-2);return c+=t+i-1}else n-=r.lf_left+r.piece.lineFeedCnt,c+=r.size_left+r.piece.length,r=r.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,c=0;const r=n;for(;i!==A.$KC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(c+=i.lf_left+t.index,t.index===0){const u=this.getOffsetAt(c+1,1),s=r-u;return new l.$xt(c+1,s+1)}return new l.$xt(c+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,c+=i.lf_left+i.piece.lineFeedCnt,i.right===A.$KC){const t=this.getOffsetAt(c+1,1),u=r-n-t;return new l.$xt(c+1,u+1)}else i=i.right;return new l.$xt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),r=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(c,r);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const s=n.node,o=this.a[s.piece.bufferIndex].buffer,h=this.u(s.piece.bufferIndex,s.piece.start);return o.substring(h+n.remainder,h+i.remainder)}let c=n.node;const r=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let u=r.substring(t+n.remainder,t+c.piece.length);for(c=c.next();c!==A.$KC;){const s=this.a[c.piece.bufferIndex].buffer,o=this.u(c.piece.bufferIndex,c.piece.start);if(c===i.node){u+=s.substring(o,o+i.remainder);break}else u+=s.substr(o,c.piece.length);c=c.next()}return u}getLinesContent(){const n=[];let i=0,c="",r=!1;return this.iterate(this.root,t=>{if(t===A.$KC)return!0;const u=t.piece;let s=u.length;if(s===0)return!0;const o=this.a[u.bufferIndex].buffer,h=this.a[u.bufferIndex].lineStarts,g=u.start.line,w=u.end.line;let k=h[g]+u.start.column;if(r&&(o.charCodeAt(k)===10&&(k++,s--),n[i++]=c,c="",r=!1,s===0))return!0;if(g===w)return!this.f&&o.charCodeAt(k+s-1)===13?(r=!0,c+=o.substr(k,s-1)):c+=o.substr(k,s),!0;c+=this.f?o.substring(k,Math.max(k,h[g+1]-this.e)):o.substring(k,h[g+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;for(let m=g+1;m<w;m++)c=this.f?o.substring(h[m],h[m+1]-this.e):o.substring(h[m],h[m+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=c;return!this.f&&o.charCodeAt(h[w]+u.end.column-1)===13?(r=!0,u.end.column===0?i--:c=o.substr(h[w],u.end.column-1)):c=o.substr(h[w],u.end.column),!0}),r&&(n[i++]=c,c=""),n[i++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const c=this.a[i.piece.bufferIndex],r=this.u(i.piece.bufferIndex,i.piece.start);return c.buffer.charCodeAt(r)}else{const i=this.a[n.node.piece.bufferIndex],r=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(r)}}getLineCharCode(n,i){const c=this.H(n,i+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,c,r,t,u,s,o,h,g,w){const k=this.a[n.piece.bufferIndex],m=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,t),D=this.u(n.piece.bufferIndex,u);let C;const R={line:0,column:0};let T,j;i._wordSeparators?(T=k.buffer.substring(y,D),j=z=>z+y,i.reset(0)):(T=k.buffer,j=z=>z,i.reset(y));do if(C=i.next(T),C){if(j(C.index)>=D)return g;this.s(n,j(C.index)-m,R);const z=this.t(n.piece.bufferIndex,t,R),N=R.line===t.line?R.column-t.column+r:R.column+1,F=N+C[0].length;if(w[g++]=(0,M.$VC)(new O.$yt(c+z,N,c+z,F),C,o),j(C.index)+C[0].length>=D||g>=h)return g}while(C);return g}findMatchesLineByLine(n,i,c,r){const t=[];let u=0;const s=new M.$YC(i.wordSeparators,i.regex);let o=this.H(n.startLineNumber,n.startColumn);if(o===null)return[];const h=this.H(n.endLineNumber,n.endColumn);if(h===null)return[];let g=this.s(o.node,o.remainder);const w=this.s(h.node,h.remainder);if(o.node===h.node)return this.findMatchesInNode(o.node,s,n.startLineNumber,n.startColumn,g,w,i,c,r,u,t),t;let k=n.startLineNumber,m=o.node;for(;m!==h.node;){const D=this.t(m.piece.bufferIndex,g,m.piece.end);if(D>=1){const R=this.a[m.piece.bufferIndex].lineStarts,T=this.u(m.piece.bufferIndex,m.piece.start),j=R[g.line+D],z=k===n.startLineNumber?n.startColumn:1;if(u=this.findMatchesInNode(m,s,k,z,g,this.s(m,j-T),i,c,r,u,t),u>=r)return t;k+=D}const C=k===n.startLineNumber?n.startColumn-1:0;if(k===n.endLineNumber){const R=this.getLineContent(k).substring(C,n.endColumn-1);return u=this.n(i,s,R,n.endLineNumber,C,u,t,c,r),t}if(u=this.n(i,s,this.getLineContent(k).substr(C),k,C,u,t,c,r),u>=r)return t;k++,o=this.H(k,1),m=o.node,g=this.s(o.node,o.remainder)}if(k===n.endLineNumber){const D=k===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(k).substring(D,n.endColumn-1);return u=this.n(i,s,C,n.endLineNumber,D,u,t,c,r),t}const y=k===n.startLineNumber?n.startColumn:1;return u=this.findMatchesInNode(h.node,s,k,y,g,w,i,c,r,u,t),t}n(n,i,c,r,t,u,s,o,h){const g=n.wordSeparators;if(!o&&n.simpleSearch){const k=n.simpleSearch,m=k.length,y=c.length;let D=-m;for(;(D=c.indexOf(k,D+m))!==-1;)if((!g||(0,M.$XC)(g,c,y,D,m))&&(s[u++]=new L.$Yv(new O.$yt(r,D+1+t,r,D+1+m+t),null),u>=h))return u;return u}let w;i.reset(0);do if(w=i.next(c),w&&(s[u++]=(0,M.$VC)(new O.$yt(r,w.index+1+t,r,w.index+1+w[0].length+t),w,o),u>=h))return u;while(w);return u}insert(n,i,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==A.$KC){const{node:r,remainder:t,nodeStartOffset:u}=this.G(n),s=r.piece,o=s.bufferIndex,h=this.s(r,t);if(r.piece.bufferIndex===0&&s.end.line===this.g.line&&s.end.column===this.g.column&&u+s.length===n&&i.length<b){this.F(r,i),this.y();return}if(u===n)this.o(i,r),this.h.validate(n);else if(u+r.piece.length>n){const g=[];let w=new p(s.bufferIndex,h,s.end,this.t(s.bufferIndex,h,s.end),this.u(o,s.end)-this.u(o,h));if(this.K()&&this.M(i)&&this.I(r,t)===10){const D={line:w.start.line+1,column:0};w=new p(w.bufferIndex,D,w.end,this.t(w.bufferIndex,D,w.end),w.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(r,t-1)===13){const D=this.s(r,t-1);this.C(r,D),i="\r"+i,r.piece.length===0&&g.push(r)}else this.C(r,h);else this.C(r,h);const k=this.w(i);w.length>0&&this.S(r,w);let m=r;for(let y=0;y<k.length;y++)m=this.S(m,k[y]);this.v(g)}else this.q(i,r)}else{const r=this.w(i);let t=this.T(null,r[0]);for(let u=1;u<r.length;u++)t=this.S(t,r[u])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===A.$KC)return;const c=this.G(n),r=this.G(n+i),t=c.node,u=r.node;if(t===u){const k=this.s(t,c.remainder),m=this.s(t,r.remainder);if(c.nodeStartOffset===n){if(i===t.piece.length){const y=t.next();(0,A.$PC)(this,t),this.N(y),this.y();return}this.D(t,m),this.h.validate(n),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===n+i){this.C(t,k),this.O(t),this.y();return}this.E(t,k,m),this.y();return}const s=[],o=this.s(t,c.remainder);this.C(t,o),this.h.validate(n),t.piece.length===0&&s.push(t);const h=this.s(u,r.remainder);this.D(u,h),u.piece.length===0&&s.push(u);const g=t.next();for(let k=g;k!==A.$KC&&k!==u;k=k.next())s.push(k);const w=t.piece.length===0?t.prev():t;this.v(s),this.O(w),this.y()}o(n,i){const c=[];if(this.K()&&this.M(n)&&this.L(i)){const u=i.piece,s={line:u.start.line+1,column:0},o=new p(u.bufferIndex,s,u.end,this.t(u.bufferIndex,s,u.end),u.length-1);i.piece=o,n+=`
`,(0,A.$RC)(this,i,-1,-1),i.piece.length===0&&c.push(i)}const r=this.w(n);let t=this.T(i,r[r.length-1]);for(let u=r.length-2;u>=0;u--)t=this.T(t,r[u]);this.N(t),this.v(c)}q(n,i){this.Q(n,i)&&(n+=`
`);const c=this.w(n),r=this.S(i,c[0]);let t=r;for(let u=1;u<c.length;u++)t=this.S(t,c[u]);this.N(r)}s(n,i,c){const r=n.piece,t=n.piece.bufferIndex,u=this.a[t].lineStarts,o=u[r.start.line]+r.start.column+i;let h=r.start.line,g=r.end.line,w=0,k=0,m=0;for(;h<=g&&(w=h+(g-h)/2|0,m=u[w],w!==g);)if(k=u[w+1],o<m)g=w-1;else if(o>=k)h=w+1;else break;return c?(c.line=w,c.column=o-m,null):{line:w,column:o-m}}t(n,i,c){if(c.column===0)return c.line-i.line;const r=this.a[n].lineStarts;if(c.line===r.length-1)return c.line-i.line;const t=r[c.line+1],u=r[c.line]+c.column;if(t>u+1)return c.line-i.line;const s=u-1;return this.a[n].buffer.charCodeAt(s)===13?c.line-i.line+1:c.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,A.$PC)(this,n[i])}w(n){if(n.length>b){const g=[];for(;n.length>b;){const k=n.charCodeAt(b-1);let m;k===13||k>=55296&&k<=56319?(m=n.substring(0,b-1),n=n.substring(b-1)):(m=n.substring(0,b),n=n.substring(b));const y=I(m);g.push(new p(this.a.length,{line:0,column:0},{line:y.length-1,column:m.length-y[y.length-1]},y.length-1,m.length)),this.a.push(new S(m,y))}const w=I(n);return g.push(new p(this.a.length,{line:0,column:0},{line:w.length-1,column:n.length-w[w.length-1]},w.length-1,n.length)),this.a.push(new S(n,w)),g}let i=this.a[0].buffer.length;const c=I(n,!1);let r=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},r=this.g;for(let g=0;g<c.length;g++)c[g]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let g=0;g<c.length;g++)c[g]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,u=this.a[0].lineStarts.length-1,s=t-this.a[0].lineStarts[u],o={line:u,column:s},h=new p(0,r,o,this.t(0,r,o),t-i);return this.g=o,[h]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let c=this.root,r="";const t=this.h.get2(n);if(t){c=t.node;const u=this.B(c,n-t.nodeStartLineNumber-1),s=this.a[c.piece.bufferIndex].buffer,o=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===n)r=s.substring(o+u,o+c.piece.length);else{const h=this.B(c,n-t.nodeStartLineNumber);return s.substring(o+u,o+h-i)}}else{let u=0;const s=n;for(;c!==A.$KC;)if(c.left!==A.$KC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const o=this.B(c,n-c.lf_left-2),h=this.B(c,n-c.lf_left-1),g=this.a[c.piece.bufferIndex].buffer,w=this.u(c.piece.bufferIndex,c.piece.start);return u+=c.size_left,this.h.set({node:c,nodeStartOffset:u,nodeStartLineNumber:s-(n-1-c.lf_left)}),g.substring(w+o,w+h-i)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const o=this.B(c,n-c.lf_left-2),h=this.a[c.piece.bufferIndex].buffer,g=this.u(c.piece.bufferIndex,c.piece.start);r=h.substring(g+o,g+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==A.$KC;){const u=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const s=this.B(c,0),o=this.u(c.piece.bufferIndex,c.piece.start);return r+=u.substring(o,o+s-i),r}else{const s=this.u(c.piece.bufferIndex,c.piece.start);r+=u.substr(s,c.piece.length)}c=c.next()}return r}y(){let n=this.root,i=1,c=0;for(;n!==A.$KC;)i+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=c,this.h.validate(this.c)}A(n,i){const c=n.piece,r=this.s(n,i),t=r.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===i){const u=this.t(n.piece.bufferIndex,c.start,r);if(u!==t)return{index:u,remainder:0}}return{index:t,remainder:r.column}}B(n,i){if(i<0)return 0;const c=n.piece,r=this.a[c.bufferIndex].lineStarts,t=c.start.line+i+1;return t>c.end.line?r[c.end.line]+c.end.column-r[c.start.line]-c.start.column:r[t]-r[c.start.line]-c.start.column}C(n,i){const c=n.piece,r=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),u=i,s=this.u(c.bufferIndex,u),o=this.t(c.bufferIndex,c.start,u),h=o-r,g=s-t,w=c.length+g;n.piece=new p(c.bufferIndex,c.start,u,o,w),(0,A.$RC)(this,n,g,h)}D(n,i){const c=n.piece,r=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),u=i,s=this.t(c.bufferIndex,u,c.end),o=this.u(c.bufferIndex,u),h=s-r,g=t-o,w=c.length+g;n.piece=new p(c.bufferIndex,u,c.end,s,w),(0,A.$RC)(this,n,g,h)}E(n,i,c){const r=n.piece,t=r.start,u=r.end,s=r.length,o=r.lineFeedCnt,h=i,g=this.t(r.bufferIndex,r.start,h),w=this.u(r.bufferIndex,i)-this.u(r.bufferIndex,t);n.piece=new p(r.bufferIndex,r.start,h,g,w),(0,A.$RC)(this,n,w-s,g-o);const k=new p(r.bufferIndex,c,u,this.t(r.bufferIndex,c,u),this.u(r.bufferIndex,u)-this.u(r.bufferIndex,c)),m=this.S(n,k);this.N(m)}F(n,i){this.Q(i,n)&&(i+=`
`);const c=this.K()&&this.L(i)&&this.M(n),r=this.a[0].buffer.length;this.a[0].buffer+=i;const t=I(i,!1);for(let m=0;m<t.length;m++)t[m]+=r;if(c){const m=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:r-m}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const u=this.a[0].lineStarts.length-1,s=this.a[0].buffer.length-this.a[0].lineStarts[u],o={line:u,column:s},h=n.piece.length+i.length,g=n.piece.lineFeedCnt,w=this.t(0,n.piece.start,o),k=w-g;n.piece=new p(n.piece.bufferIndex,n.piece.start,o,w,h),this.g=o,(0,A.$RC)(this,n,i.length,k)}G(n){let i=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let r=0;for(;i!==A.$KC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){r+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:r};return this.h.set(t),t}else n-=i.size_left+i.piece.length,r+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let c=this.root,r=0;for(;c!==A.$KC;)if(c.left!==A.$KC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const t=this.B(c,n-c.lf_left-2),u=this.B(c,n-c.lf_left-1);return r+=c.size_left,{node:c,remainder:Math.min(t+i-1,u),nodeStartOffset:r}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const t=this.B(c,n-c.lf_left-2);if(t+i-1<=c.piece.length)return{node:c,remainder:t+i-1,nodeStartOffset:r};i-=c.piece.length-t;break}else n-=c.lf_left+c.piece.lineFeedCnt,r+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==A.$KC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),u=this.J(c);return{node:c,remainder:Math.min(i-1,t),nodeStartOffset:u}}else if(c.piece.length>=i-1){const t=this.J(c);return{node:c,remainder:i-1,nodeStartOffset:t}}else i-=c.piece.length;c=c.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],r=this.u(n.piece.bufferIndex,n.piece.start)+i;return c.buffer.charCodeAt(r)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===A.$KC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,c=this.a[i.bufferIndex].lineStarts,r=i.start.line,t=c[r]+i.start.column;return r===c.length-1||c[r+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===A.$KC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const c=[],r=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:r[n.piece.end.line]-r[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const u=n.piece.length-1,s=n.piece.lineFeedCnt-1;n.piece=new p(n.piece.bufferIndex,n.piece.start,t,s,u),(0,A.$RC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const o={line:i.piece.start.line+1,column:0},h=i.piece.length-1,g=this.t(i.piece.bufferIndex,o,i.piece.end);i.piece=new p(i.piece.bufferIndex,o,i.piece.end,g,h),(0,A.$RC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const w=this.w(`\r
`);this.S(n,w[0]);for(let k=0;k<c.length;k++)(0,A.$PC)(this,c[k])}Q(n,i){if(this.K()&&this.M(n)){const c=i.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,A.$PC)(this,c);else{const r=c.piece,t={line:r.start.line+1,column:0},u=r.length-1,s=this.t(r.bufferIndex,t,r.end);c.piece=new p(r.bufferIndex,t,r.end,s,u),(0,A.$RC)(this,c,-1,-1)}return!0}}return!1}iterate(n,i){if(n===A.$KC)return i(A.$KC);const c=this.iterate(n.left,i);return c&&i(n)&&this.iterate(n.right,i)}R(n){if(n===A.$KC)return"";const i=this.a[n.piece.bufferIndex],c=n.piece,r=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return i.buffer.substring(r,t)}getPieceContent(n){const i=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),r=this.u(n.bufferIndex,n.end);return i.buffer.substring(c,r)}S(n,i){const c=new A.$JC(i,1);if(c.left=A.$KC,c.right=A.$KC,c.parent=A.$KC,c.size_left=0,c.lf_left=0,this.root===A.$KC)this.root=c,c.color=0;else if(n.right===A.$KC)n.right=c,c.parent=n;else{const t=(0,A.$LC)(n.right);t.left=c,c.parent=t}return(0,A.$QC)(this,c),c}T(n,i){const c=new A.$JC(i,1);if(c.left=A.$KC,c.right=A.$KC,c.parent=A.$KC,c.size_left=0,c.lf_left=0,this.root===A.$KC)this.root=c,c.color=0;else if(n.left===A.$KC)n.left=c,c.parent=n;else{const r=(0,A.$MC)(n.left);r.right=c,c.parent=r}return(0,A.$QC)(this,c),c}U(n){let i="";return this.iterate(n,c=>(i+=this.R(c),!0)),i}}e.$4C=f}),define(ke[189],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L0=e.$K0=void 0;class l{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const M=this.a.get(A);return this.a.delete(A),M}}addDragOperationTransfer(A,M){this.a.set(A,M)}}e.$K0=l;class O{constructor(A){this.identifier=A}}e.$L0=O}),define(ke[190],De([1,0,4,3]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hu=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new l.$fe,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,O.$Sc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const E=new A(this,b,$);return this.b.set(b,E),(0,O.$Sc)(()=>{const I=this.b.get(b);!I||I!==E||(this.b.delete(b),I.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const E=this.b.get(b);return!E||E.isResolved?null:(await E.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const E=this.b.get(b);return!!(!E||E.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$hu=L;class A extends O.$Uc{get isResolved(){return this.c}constructor(b,$,E){super(),this.f=b,this.g=$,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[191],De([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(ke[192],De([1,0,4,3,191]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=void 0,e.$ij=I;class A extends O.$Uc{constructor(p,S="",v="",d=!0,f){super(),this.h=this.B(new l.$fe),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=S,this.u=v,this.w=d,this.C=f}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,S){this.C&&await this.C(p)}}e.$dj=A;class M extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new l.$fe),this.onWillRun=this.f.event,this.m=this.B(new l.$fe),this.onDidRun=this.m.event}async run(p,S){if(!p.enabled)return;this.f.fire({action:p});let v;try{await this.u(p,S)}catch(d){v=d}this.m.fire({action:p,error:v})}async u(p,S){await p.run(S)}}e.$ej=M;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let S=[];for(const v of p)v.length&&(S.length?S=[...S,new b,...v]:S=v);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$fj=b;class ${get actions(){return this.a}constructor(p,S,v,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=S,this.class=d,this.a=v}async run(){}}e.$gj=$;class E extends A{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,L.localize(0,null),void 0,!1)}}e.$hj=E;function I(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...p)=>P.run(...p),tooltip:P.label}}}),define(ke[193],De([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(ke[194],De([1,0,193]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=E,e.$5m=I,e.$6m=P;const O=60,L=O*60,A=L*24,M=A*7,b=A*30,$=A*365;function E(p,S,v,d){typeof p!="number"&&(p=p.getTime());const f=Math.round((new Date().getTime()-p)/1e3);if(f<-30)return(0,l.localize)(0,null,E(new Date().getTime()+f*1e3,!1));if(!d&&f<30)return(0,l.localize)(1,null);let a;return f<O?(a=f,S?a===1?v?(0,l.localize)(2,null,a):(0,l.localize)(3,null,a):v?(0,l.localize)(4,null,a):(0,l.localize)(5,null,a):a===1?v?(0,l.localize)(6,null,a):(0,l.localize)(7,null,a):v?(0,l.localize)(8,null,a):(0,l.localize)(9,null,a)):f<L?(a=Math.floor(f/O),S?a===1?v?(0,l.localize)(10,null,a):(0,l.localize)(11,null,a):v?(0,l.localize)(12,null,a):(0,l.localize)(13,null,a):a===1?v?(0,l.localize)(14,null,a):(0,l.localize)(15,null,a):v?(0,l.localize)(16,null,a):(0,l.localize)(17,null,a)):f<A?(a=Math.floor(f/L),S?a===1?v?(0,l.localize)(18,null,a):(0,l.localize)(19,null,a):v?(0,l.localize)(20,null,a):(0,l.localize)(21,null,a):a===1?v?(0,l.localize)(22,null,a):(0,l.localize)(23,null,a):v?(0,l.localize)(24,null,a):(0,l.localize)(25,null,a)):f<M?(a=Math.floor(f/A),S?a===1?(0,l.localize)(26,null,a):(0,l.localize)(27,null,a):a===1?(0,l.localize)(28,null,a):(0,l.localize)(29,null,a)):f<b?(a=Math.floor(f/M),S?a===1?v?(0,l.localize)(30,null,a):(0,l.localize)(31,null,a):v?(0,l.localize)(32,null,a):(0,l.localize)(33,null,a):a===1?v?(0,l.localize)(34,null,a):(0,l.localize)(35,null,a):v?(0,l.localize)(36,null,a):(0,l.localize)(37,null,a)):f<$?(a=Math.floor(f/b),S?a===1?v?(0,l.localize)(38,null,a):(0,l.localize)(39,null,a):v?(0,l.localize)(40,null,a):(0,l.localize)(41,null,a):a===1?v?(0,l.localize)(42,null,a):(0,l.localize)(43,null,a):v?(0,l.localize)(44,null,a):(0,l.localize)(45,null,a)):(a=Math.floor(f/$),S?a===1?v?(0,l.localize)(46,null,a):(0,l.localize)(47,null,a):v?(0,l.localize)(48,null,a):(0,l.localize)(49,null,a):a===1?v?(0,l.localize)(50,null,a):(0,l.localize)(51,null,a):v?(0,l.localize)(52,null,a):(0,l.localize)(53,null,a))}function I(p,S){const v=Math.abs(p/1e3);return v<1?S?(0,l.localize)(54,null,p):(0,l.localize)(55,null,p):v<O?S?(0,l.localize)(56,null,Math.round(p)/1e3):(0,l.localize)(57,null,Math.round(p)/1e3):v<L?S?(0,l.localize)(58,null,Math.round(p/(1e3*O))):(0,l.localize)(59,null,Math.round(p/(1e3*O))):v<A?S?(0,l.localize)(60,null,Math.round(p/(1e3*L))):(0,l.localize)(61,null,Math.round(p/(1e3*L))):(0,l.localize)(62,null,Math.round(p/(1e3*A)))}function P(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[195],De([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(ke[47],De([1,0,19,18,195]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=$,e.$kj=E,e.$lj=I;function A(P,p){return p&&(P.stack||P.stacktrace)?L.localize(0,null,b(P),M(P.stack)||M(P.stacktrace)):b(P)}function M(P){return Array.isArray(P)?P.join(`
`):P}function b(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?L.localize(1,null,P.message):P.message||L.localize(2,null)}function $(P=null,p=!1){if(!P)return L.localize(3,null);if(Array.isArray(P)){const S=l.$Hb(P),v=$(S[0],p);return S.length>1?L.localize(4,null,v,S.length):v}if(O.$$f(P))return P;if(P.detail){const S=P.detail;if(S.error)return A(S.error,p);if(S.exception)return A(S.exception,p)}return P.stack?A(P,p):P.message?P.message:L.localize(5,null)}function E(P){const p=P;return p instanceof Error&&Array.isArray(p.actions)}function I(P,p){let S;return typeof P=="string"?S=new Error(P):S=P,S.actions=p,S}}),define(ke[196],De([9,10]),function(he,e){return he.create("vs/base/common/platform",e)}),define(ke[12],De([1,0,196]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=u,e.$D=k,e.$J=m,e.$g="en";let O=!1,L=!1,A=!1,M=!1,b=!1,$=!1,E=!1,I=!1,P=!1,p=!1,S,v=e.$g,d=e.$g,f,a;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const c=typeof i?.versions?.electron=="string",r=c&&i?.type==="renderer";if(typeof i=="object"){O=i.platform==="win32",L=i.platform==="darwin",A=i.platform==="linux",M=A&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,E=c,P=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.$g,v=e.$g;const y=i.env.VSCODE_NLS_CONFIG;if(y)try{const D=JSON.parse(y),C=D.availableLanguages["*"];S=D.locale,d=D.osLocale,v=C||e.$g,f=D._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!r?(a=navigator.userAgent,O=a.indexOf("Windows")>=0,L=a.indexOf("Macintosh")>=0,I=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=a.indexOf("Linux")>=0,p=a?.indexOf("Mobi")>=0,$=!0,S=l.getConfiguredDefaultLocale(l.localize(0,null))||e.$g,v=S,d=navigator.language):console.error("Unable to resolve platform.");var t;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(t||(e.Platform=t={}));function u(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;L?s=1:O?s=3:A&&(s=2),e.$i=O,e.$j=L,e.$k=A,e.$l=M,e.$m=b,e.$n=E,e.$o=$,e.$p=$&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=I,e.$s=p,e.$t=P,e.$u=s,e.$v=a,e.$w=v;var o;(function(y){function D(){return e.$w}y.value=D;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}y.isDefaultVariant=C;function R(){return e.$w==="en"}y.isDefault=R})(o||(e.Language=o={})),e.$x=S,e.$y=d,e.$z=f,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const y=[];n.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let R=0,T=y.length;R<T;R++){const j=y[R];if(j.id===C.data.vscodeScheduleAsyncWork){y.splice(R,1),j.callback();return}}});let D=0;return C=>{const R=++D;y.push({id:R,callback:C}),n.postMessage({vscodeScheduleAsyncWork:R},"*")}}return y=>setTimeout(y)})();var h;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(h||(e.OperatingSystem=h={})),e.OS=L||I?2:O?1:3;let g=!0,w=!1;function k(){if(!w){w=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,g=new Uint16Array(y.buffer)[0]===513}return g}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function m(y){return parseFloat(y)>=20}}),define(ke[52],De([1,0,12]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const A=L.process;O={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return l.$i?"win32":l.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$dc=O.platform,e.$ec=O.arch}),define(ke[16],De([1,0,52]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const O=65,L=97,A=90,M=122,b=46,$=47,E=92,I=58,P=63;class p extends Error{constructor(u,s,o){let h;typeof s=="string"&&s.indexOf("not ")===0?(h="must not be",s=s.replace(/^not /,"")):h="must be";const g=u.indexOf(".")!==-1?"property":"argument";let w=`The "${u}" ${g} ${h} of type ${s}`;w+=`. Received type ${typeof o}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,u){if(t===null||typeof t!="object")throw new p(u,"Object",t)}function v(t,u){if(typeof t!="string")throw new p(u,"string",t)}const d=l.$dc==="win32";function f(t){return t===$||t===E}function a(t){return t===$}function n(t){return t>=O&&t<=A||t>=L&&t<=M}function i(t,u,s,o){let h="",g=0,w=-1,k=0,m=0;for(let y=0;y<=t.length;++y){if(y<t.length)m=t.charCodeAt(y);else{if(o(m))break;m=$}if(o(m)){if(!(w===y-1||k===1))if(k===2){if(h.length<2||g!==2||h.charCodeAt(h.length-1)!==b||h.charCodeAt(h.length-2)!==b){if(h.length>2){const D=h.lastIndexOf(s);D===-1?(h="",g=0):(h=h.slice(0,D),g=h.length-1-h.lastIndexOf(s)),w=y,k=0;continue}else if(h.length!==0){h="",g=0,w=y,k=0;continue}}u&&(h+=h.length>0?`${s}..`:"..",g=2)}else h.length>0?h+=`${s}${t.slice(w+1,y)}`:h=t.slice(w+1,y),g=y-w-1;w=y,k=0}else m===b&&k!==-1?++k:k=-1}return h}function c(t,u){S(u,"pathObject");const s=u.dir||u.root,o=u.base||`${u.name||""}${u.ext||""}`;return s?s===u.root?`${s}${o}`:`${s}${t}${o}`:o}e.$fc={resolve(...t){let u="",s="",o=!1;for(let h=t.length-1;h>=-1;h--){let g;if(h>=0){if(g=t[h],v(g,"path"),g.length===0)continue}else u.length===0?g=l.cwd():(g=l.env[`=${u}`]||l.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==u.toLowerCase()&&g.charCodeAt(2)===E)&&(g=`${u}\\`));const w=g.length;let k=0,m="",y=!1;const D=g.charCodeAt(0);if(w===1)f(D)&&(k=1,y=!0);else if(f(D))if(y=!0,f(g.charCodeAt(1))){let C=2,R=C;for(;C<w&&!f(g.charCodeAt(C));)C++;if(C<w&&C!==R){const T=g.slice(R,C);for(R=C;C<w&&f(g.charCodeAt(C));)C++;if(C<w&&C!==R){for(R=C;C<w&&!f(g.charCodeAt(C));)C++;(C===w||C!==R)&&(m=`\\\\${T}\\${g.slice(R,C)}`,k=C)}}}else k=1;else n(D)&&g.charCodeAt(1)===I&&(m=g.slice(0,2),k=2,w>2&&f(g.charCodeAt(2))&&(y=!0,k=3));if(m.length>0)if(u.length>0){if(m.toLowerCase()!==u.toLowerCase())continue}else u=m;if(o){if(u.length>0)break}else if(s=`${g.slice(k)}\\${s}`,o=y,y&&u.length>0)break}return s=i(s,!o,"\\",f),o?`${u}\\${s}`:`${u}${s}`||"."},normalize(t){v(t,"path");const u=t.length;if(u===0)return".";let s=0,o,h=!1;const g=t.charCodeAt(0);if(u===1)return a(g)?"\\":t;if(f(g))if(h=!0,f(t.charCodeAt(1))){let k=2,m=k;for(;k<u&&!f(t.charCodeAt(k));)k++;if(k<u&&k!==m){const y=t.slice(m,k);for(m=k;k<u&&f(t.charCodeAt(k));)k++;if(k<u&&k!==m){for(m=k;k<u&&!f(t.charCodeAt(k));)k++;if(k===u)return`\\\\${y}\\${t.slice(m)}\\`;k!==m&&(o=`\\\\${y}\\${t.slice(m,k)}`,s=k)}}}else s=1;else n(g)&&t.charCodeAt(1)===I&&(o=t.slice(0,2),s=2,u>2&&f(t.charCodeAt(2))&&(h=!0,s=3));let w=s<u?i(t.slice(s),!h,"\\",f):"";return w.length===0&&!h&&(w="."),w.length>0&&f(t.charCodeAt(u-1))&&(w+="\\"),o===void 0?h?`\\${w}`:w:h?`${o}\\${w}`:`${o}${w}`},isAbsolute(t){v(t,"path");const u=t.length;if(u===0)return!1;const s=t.charCodeAt(0);return f(s)||u>2&&n(s)&&t.charCodeAt(1)===I&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,s;for(let g=0;g<t.length;++g){const w=t[g];v(w,"path"),w.length>0&&(u===void 0?u=s=w:u+=`\\${w}`)}if(u===void 0)return".";let o=!0,h=0;if(typeof s=="string"&&f(s.charCodeAt(0))){++h;const g=s.length;g>1&&f(s.charCodeAt(1))&&(++h,g>2&&(f(s.charCodeAt(2))?++h:o=!1))}if(o){for(;h<u.length&&f(u.charCodeAt(h));)h++;h>=2&&(u=`\\${u.slice(h)}`)}return e.$fc.normalize(u)},relative(t,u){if(v(t,"from"),v(u,"to"),t===u)return"";const s=e.$fc.resolve(t),o=e.$fc.resolve(u);if(s===o||(t=s.toLowerCase(),u=o.toLowerCase(),t===u))return"";let h=0;for(;h<t.length&&t.charCodeAt(h)===E;)h++;let g=t.length;for(;g-1>h&&t.charCodeAt(g-1)===E;)g--;const w=g-h;let k=0;for(;k<u.length&&u.charCodeAt(k)===E;)k++;let m=u.length;for(;m-1>k&&u.charCodeAt(m-1)===E;)m--;const y=m-k,D=w<y?w:y;let C=-1,R=0;for(;R<D;R++){const j=t.charCodeAt(h+R);if(j!==u.charCodeAt(k+R))break;j===E&&(C=R)}if(R!==D){if(C===-1)return o}else{if(y>D){if(u.charCodeAt(k+R)===E)return o.slice(k+R+1);if(R===2)return o.slice(k+R)}w>D&&(t.charCodeAt(h+R)===E?C=R:R===2&&(C=3)),C===-1&&(C=0)}let T="";for(R=h+C+1;R<=g;++R)(R===g||t.charCodeAt(R)===E)&&(T+=T.length===0?"..":"\\..");return k+=C,T.length>0?`${T}${o.slice(k,m)}`:(o.charCodeAt(k)===E&&++k,o.slice(k,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.$fc.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===E){if(u.charCodeAt(1)===E){const s=u.charCodeAt(2);if(s!==P&&s!==b)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(n(u.charCodeAt(0))&&u.charCodeAt(1)===I&&u.charCodeAt(2)===E)return`\\\\?\\${u}`;return t},dirname(t){v(t,"path");const u=t.length;if(u===0)return".";let s=-1,o=0;const h=t.charCodeAt(0);if(u===1)return f(h)?t:".";if(f(h)){if(s=o=1,f(t.charCodeAt(1))){let k=2,m=k;for(;k<u&&!f(t.charCodeAt(k));)k++;if(k<u&&k!==m){for(m=k;k<u&&f(t.charCodeAt(k));)k++;if(k<u&&k!==m){for(m=k;k<u&&!f(t.charCodeAt(k));)k++;if(k===u)return t;k!==m&&(s=o=k+1)}}}}else n(h)&&t.charCodeAt(1)===I&&(s=u>2&&f(t.charCodeAt(2))?3:2,o=s);let g=-1,w=!0;for(let k=u-1;k>=o;--k)if(f(t.charCodeAt(k))){if(!w){g=k;break}}else w=!1;if(g===-1){if(s===-1)return".";g=s}return t.slice(0,g)},basename(t,u){u!==void 0&&v(u,"ext"),v(t,"path");let s=0,o=-1,h=!0,g;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===I&&(s=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let w=u.length-1,k=-1;for(g=t.length-1;g>=s;--g){const m=t.charCodeAt(g);if(f(m)){if(!h){s=g+1;break}}else k===-1&&(h=!1,k=g+1),w>=0&&(m===u.charCodeAt(w)?--w===-1&&(o=g):(w=-1,o=k))}return s===o?o=k:o===-1&&(o=t.length),t.slice(s,o)}for(g=t.length-1;g>=s;--g)if(f(t.charCodeAt(g))){if(!h){s=g+1;break}}else o===-1&&(h=!1,o=g+1);return o===-1?"":t.slice(s,o)},extname(t){v(t,"path");let u=0,s=-1,o=0,h=-1,g=!0,w=0;t.length>=2&&t.charCodeAt(1)===I&&n(t.charCodeAt(0))&&(u=o=2);for(let k=t.length-1;k>=u;--k){const m=t.charCodeAt(k);if(f(m)){if(!g){o=k+1;break}continue}h===-1&&(g=!1,h=k+1),m===b?s===-1?s=k:w!==1&&(w=1):s!==-1&&(w=-1)}return s===-1||h===-1||w===0||w===1&&s===h-1&&s===o+1?"":t.slice(s,h)},format:c.bind(null,"\\"),parse(t){v(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const s=t.length;let o=0,h=t.charCodeAt(0);if(s===1)return f(h)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(f(h)){if(o=1,f(t.charCodeAt(1))){let C=2,R=C;for(;C<s&&!f(t.charCodeAt(C));)C++;if(C<s&&C!==R){for(R=C;C<s&&f(t.charCodeAt(C));)C++;if(C<s&&C!==R){for(R=C;C<s&&!f(t.charCodeAt(C));)C++;C===s?o=C:C!==R&&(o=C+1)}}}}else if(n(h)&&t.charCodeAt(1)===I){if(s<=2)return u.root=u.dir=t,u;if(o=2,f(t.charCodeAt(2))){if(s===3)return u.root=u.dir=t,u;o=3}}o>0&&(u.root=t.slice(0,o));let g=-1,w=o,k=-1,m=!0,y=t.length-1,D=0;for(;y>=o;--y){if(h=t.charCodeAt(y),f(h)){if(!m){w=y+1;break}continue}k===-1&&(m=!1,k=y+1),h===b?g===-1?g=y:D!==1&&(D=1):g!==-1&&(D=-1)}return k!==-1&&(g===-1||D===0||D===1&&g===k-1&&g===w+1?u.base=u.name=t.slice(w,k):(u.name=t.slice(w,g),u.base=t.slice(w,k),u.ext=t.slice(g,k))),w>0&&w!==o?u.dir=t.slice(0,w-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const r=(()=>{if(d){const t=/\\/g;return()=>{const u=l.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>l.cwd()})();e.$gc={resolve(...t){let u="",s=!1;for(let o=t.length-1;o>=-1&&!s;o--){const h=o>=0?t[o]:r();v(h,"path"),h.length!==0&&(u=`${h}/${u}`,s=h.charCodeAt(0)===$)}return u=i(u,!s,"/",a),s?`/${u}`:u.length>0?u:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===$,s=t.charCodeAt(t.length-1)===$;return t=i(t,!u,"/",a),t.length===0?u?"/":s?"./":".":(s&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let u;for(let s=0;s<t.length;++s){const o=t[s];v(o,"path"),o.length>0&&(u===void 0?u=o:u+=`/${o}`)}return u===void 0?".":e.$gc.normalize(u)},relative(t,u){if(v(t,"from"),v(u,"to"),t===u||(t=e.$gc.resolve(t),u=e.$gc.resolve(u),t===u))return"";const s=1,o=t.length,h=o-s,g=1,w=u.length-g,k=h<w?h:w;let m=-1,y=0;for(;y<k;y++){const C=t.charCodeAt(s+y);if(C!==u.charCodeAt(g+y))break;C===$&&(m=y)}if(y===k)if(w>k){if(u.charCodeAt(g+y)===$)return u.slice(g+y+1);if(y===0)return u.slice(g+y)}else h>k&&(t.charCodeAt(s+y)===$?m=y:y===0&&(m=0));let D="";for(y=s+m+1;y<=o;++y)(y===o||t.charCodeAt(y)===$)&&(D+=D.length===0?"..":"/..");return`${D}${u.slice(g+m)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===$;let s=-1,o=!0;for(let h=t.length-1;h>=1;--h)if(t.charCodeAt(h)===$){if(!o){s=h;break}}else o=!1;return s===-1?u?"/":".":u&&s===1?"//":t.slice(0,s)},basename(t,u){u!==void 0&&v(u,"ext"),v(t,"path");let s=0,o=-1,h=!0,g;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let w=u.length-1,k=-1;for(g=t.length-1;g>=0;--g){const m=t.charCodeAt(g);if(m===$){if(!h){s=g+1;break}}else k===-1&&(h=!1,k=g+1),w>=0&&(m===u.charCodeAt(w)?--w===-1&&(o=g):(w=-1,o=k))}return s===o?o=k:o===-1&&(o=t.length),t.slice(s,o)}for(g=t.length-1;g>=0;--g)if(t.charCodeAt(g)===$){if(!h){s=g+1;break}}else o===-1&&(h=!1,o=g+1);return o===-1?"":t.slice(s,o)},extname(t){v(t,"path");let u=-1,s=0,o=-1,h=!0,g=0;for(let w=t.length-1;w>=0;--w){const k=t.charCodeAt(w);if(k===$){if(!h){s=w+1;break}continue}o===-1&&(h=!1,o=w+1),k===b?u===-1?u=w:g!==1&&(g=1):u!==-1&&(g=-1)}return u===-1||o===-1||g===0||g===1&&u===o-1&&u===s+1?"":t.slice(u,o)},format:c.bind(null,"/"),parse(t){v(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const s=t.charCodeAt(0)===$;let o;s?(u.root="/",o=1):o=0;let h=-1,g=0,w=-1,k=!0,m=t.length-1,y=0;for(;m>=o;--m){const D=t.charCodeAt(m);if(D===$){if(!k){g=m+1;break}continue}w===-1&&(k=!1,w=m+1),D===b?h===-1?h=m:y!==1&&(y=1):h!==-1&&(y=-1)}if(w!==-1){const D=g===0&&s?1:g;h===-1||y===0||y===1&&h===w-1&&h===g+1?u.base=u.name=t.slice(D,w):(u.name=t.slice(D,h),u.base=t.slice(D,w),u.ext=t.slice(h,w))}return g>0?u.dir=t.slice(0,g-1):s&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=d?e.$fc.normalize:e.$gc.normalize,e.$ic=d?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=d?e.$fc.join:e.$gc.join,e.$kc=d?e.$fc.resolve:e.$gc.resolve,e.$lc=d?e.$fc.relative:e.$gc.relative,e.$mc=d?e.$fc.dirname:e.$gc.dirname,e.$nc=d?e.$fc.basename:e.$gc.basename,e.$oc=d?e.$fc.extname:e.$gc.extname,e.$pc=d?e.$fc.format:e.$gc.format,e.$qc=d?e.$fc.parse:e.$gc.parse,e.$rc=d?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=d?e.$fc.sep:e.$gc.sep,e.$tc=d?e.$fc.delimiter:e.$gc.delimiter}),define(ke[132],De([1,0,46,16]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=b,e.$lr=$,e.$mr=E,e.$nr=I,e.$or=P,e.$pr=p,e.$qr=S,e.$rr=v,e.$sr=d,e.$tr=f,e.$ur=h,e.$vr=g,e.$wr=w;const L=new l.$V(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),A=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(k,m,y=!1){const D=k||"",C=m||"",R=L.value.collator.compare(D,C);return L.value.collatorIsNumeric&&R===0&&D!==C?D<C?-1:1:R}function $(k,m){const y=A.value.collator;return k=k||"",m=m||"",c(y,k,m)}function E(k,m){const y=A.value.collator;return k=k||"",m=m||"",s(k,m)||c(y,k,m)}function I(k,m){const y=A.value.collator;return k=k||"",m=m||"",u(k,m)||c(y,k,m)}function P(k,m){return k=k||"",m=m||"",k===m?0:k<m?-1:1}function p(k,m){const[y,D]=n(k),[C,R]=n(m);let T=L.value.collator.compare(D,R);if(T===0){if(L.value.collatorIsNumeric&&D!==R)return D<R?-1:1;if(T=L.value.collator.compare(y,C),L.value.collatorIsNumeric&&T===0&&y!==C)return y<C?-1:1}return T}function S(k,m){k=k||"",m=m||"";const y=i(k),D=i(m),C=A.value.collator,R=M.value.collator;return c(R,y,D)||c(C,k,m)}function v(k,m){k=k||"",m=m||"";const y=i(k),D=i(m),C=A.value.collator,R=M.value.collator;return c(R,y,D)||s(k,m)||c(C,k,m)}function d(k,m){k=k||"",m=m||"";const y=i(k),D=i(m),C=A.value.collator,R=M.value.collator;return c(R,y,D)||u(k,m)||c(C,k,m)}function f(k,m){k=k||"",m=m||"";const y=i(k).toLowerCase(),D=i(m).toLowerCase();return y!==D?y<D?-1:1:k!==m?k<m?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function n(k,m=!1){const y=k?a.exec(k):[];let D=[y&&y[1]||"",y&&y[3]||""];return m&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function i(k){const m=k?a.exec(k):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function c(k,m,y){const D=k.compare(m,y);return D!==0?D:m.length!==y.length?m.length<y.length?-1:1:0}function r(k){const m=k.charAt(0);return m.toLocaleUpperCase()!==m}function t(k){const m=k.charAt(0);return m.toLocaleLowerCase()!==m}function u(k,m){return r(k)&&t(m)?-1:t(k)&&r(m)?1:0}function s(k,m){return t(k)&&r(m)?-1:r(k)&&t(m)?1:0}function o(k,m,y=!1){return y||(k=k&&k.toLowerCase(),m=m&&m.toLowerCase()),k===m?0:k<m?-1:1}function h(k,m,y=!1){const D=k.split(O.sep),C=m.split(O.sep),R=D.length-1,T=C.length-1;let j,z;for(let N=0;;N++){if(j=R===N,z=T===N,j&&z)return b(D[N],C[N],y);if(j)return-1;if(z)return 1;const F=o(D[N],C[N],y);if(F!==0)return F}}function g(k,m,y){const D=k.toLowerCase(),C=m.toLowerCase(),R=w(k,m,y);if(R)return R;const T=D.endsWith(y),j=C.endsWith(y);if(T!==j)return T?-1:1;const z=b(D,C);return z!==0?z:D.localeCompare(C)}function w(k,m,y){const D=k.toLowerCase(),C=m.toLowerCase(),R=D.startsWith(y),T=C.startsWith(y);if(R!==T)return R?-1:1;if(R&&T){if(D.length<C.length)return-1;if(D.length>C.length)return 1}return 0}}),define(ke[31],De([1,0,16,12,14,18]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=M,e.$rg=b,e.$sg=$,e.$tg=E,e.$ug=I,e.$vg=v,e.$wg=d,e.$xg=f,e.$yg=a,e.$zg=n,e.$Ag=i,e.$Bg=c,e.$Cg=r,e.$Dg=t,e.$Eg=u,e.$Fg=s,e.$Gg=g;function M(w){return w===47||w===92}function b(w){return w.replace(/[\\/]/g,l.$gc.sep)}function $(w){return w.indexOf("/")===-1&&(w=b(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function E(w,k=l.$gc.sep){if(!w)return"";const m=w.length,y=w.charCodeAt(0);if(M(y)){if(M(w.charCodeAt(1))&&!M(w.charCodeAt(2))){let C=3;const R=C;for(;C<m&&!M(w.charCodeAt(C));C++);if(R!==C&&!M(w.charCodeAt(C+1))){for(C+=1;C<m;C++)if(M(w.charCodeAt(C)))return w.slice(0,C+1).replace(/[\\/]/g,k)}}return k}else if(a(y)&&w.charCodeAt(1)===58)return M(w.charCodeAt(2))?w.slice(0,2)+k:w.slice(0,2);let D=w.indexOf("://");if(D!==-1){for(D+=3;D<m;D++)if(M(w.charCodeAt(D)))return w.slice(0,D+1)}return""}function I(w){if(!O.$i||!w||w.length<5)return!1;let k=w.charCodeAt(0);if(k!==92||(k=w.charCodeAt(1),k!==92))return!1;let m=2;const y=m;for(;m<w.length&&(k=w.charCodeAt(m),k!==92);m++);return!(y===m||(k=w.charCodeAt(m+1),isNaN(k)||k===92))}const P=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(w,k=O.$i){const m=k?P:p;return!(!w||w.length===0||/^\s+$/.test(w)||(m.lastIndex=0,m.test(w))||k&&S.test(w)||w==="."||w===".."||k&&w[w.length-1]==="."||k&&w.length!==w.trim().length||w.length>255)}function d(w,k,m){const y=w===k;return!m||y?y:!w||!k?!1:(0,L.$zf)(w,k)}function f(w,k,m,y=l.sep){if(w===k)return!0;if(!w||!k||k.length>w.length)return!1;if(m){if(!(0,L.$Af)(w,k))return!1;if(k.length===w.length)return!0;let C=k.length;return k.charAt(k.length-1)===y&&C--,w.charAt(C)===y}return k.charAt(k.length-1)!==y&&(k+=y),w.indexOf(k)===0}function a(w){return w>=65&&w<=90||w>=97&&w<=122}function n(w,k){return O.$i&&w.endsWith(":")&&(w+=l.sep),(0,l.$ic)(w)||(w=(0,l.$jc)(k,w)),w=(0,l.$hc)(w),i(w)}function i(w){return O.$i?(w=(0,L.$hf)(w,l.sep),w.endsWith(":")&&(w+=l.sep)):(w=(0,L.$hf)(w,l.sep),w||(w=l.sep)),w}function c(w){const k=(0,l.$hc)(w);return O.$i?w.length>3?!1:r(k)&&(w.length===2||k.charCodeAt(2)===92):k===l.$gc.sep}function r(w,k=O.$i){return k?a(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}function t(w,k=O.$i){return r(w,k)?w[0]:void 0}function u(w,k,m){return k.length>w.length?-1:w===k?0:(m&&(w=w.toLowerCase(),k=k.toLowerCase()),w.indexOf(k))}function s(w){const k=w.split(":");let m,y,D;for(const C of k){const R=Number(C);(0,A.$cg)(R)?y===void 0?y=R:D===void 0&&(D=R):m=m?[m,C].join(":"):C}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:y!==void 0?y:void 0,column:D!==void 0?D:y!==void 0?1:void 0}}const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(w,k,m=8){let y="";for(let C=0;C<m;C++){let R;C===0&&O.$i&&!k&&(m===3||m===4)?R=h:R=o,y+=R.charAt(Math.floor(Math.random()*R.length))}let D;return k?D=`${k}-${y}`:D=y,w?(0,l.$jc)(w,D):D}}),define(ke[133],De([1,0,132,127,57,16,12,14]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=I,e.$yr=f,e.$zr=s,e.$Ar=y,e.$Br=z,e.$Cr=F;const $=0,E=[$,[]];function I(B,Y,re,H){if(!B||!Y)return E;const K=B.length,_=Y.length;if(K<_)return E;const Z=B.toLowerCase();return P(Y,re,_,B,Z,K,H)}function P(B,Y,re,H,K,_,Z){const $e=[],oe=[];for(let ee=0;ee<re;ee++){const be=ee*_,ue=be-_,ce=ee>0,ae=B[ee],le=Y[ee];for(let J=0;J<_;J++){const se=J>0,pe=be+J,ve=pe-1,Re=ue+J-1,me=se?$e[ve]:0,Ie=ce&&se?$e[Re]:0,Ae=ce&&se?oe[Re]:0;let ze;!Ie&&ce?ze=0:ze=p(ae,le,H,K,J,Ae),ze&&Ie+ze>=me&&(Z||ce||K.startsWith(Y,J))?(oe[pe]=Ae+1,$e[pe]=Ie+ze):(oe[pe]=$,$e[pe]=me)}}const Pe=[];let te=re-1,U=_-1;for(;te>=0&&U>=0;){const ee=te*_+U;oe[ee]===$||(Pe.push(U),te--),U--}return[$e[re*_-1],Pe.reverse()]}function p(B,Y,re,H,K,_){let Z=0;if(!S(Y,H[K]))return Z;if(Z+=1,_>0&&(Z+=_*5),B===re[K]&&(Z+=1),K===0)Z+=8;else{const $e=v(re.charCodeAt(K-1));$e?Z+=$e:(0,O.$Dk)(re.charCodeAt(K))&&_===0&&(Z+=2)}return Z}function S(B,Y){return B===Y?!0:B==="/"||B==="\\"?Y==="/"||Y==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function f(B,Y,re=0,H=0){const K=Y;return K.values&&K.values.length>1?a(B,K.values,re,H):n(B,Y,re,H)}function a(B,Y,re,H){let K=0;const _=[];for(const Z of Y){const[$e,oe]=n(B,Z,re,H);if(typeof $e!="number")return d;K+=$e,_.push(...oe)}return[K,k(_)]}function n(B,Y,re,H){const K=(0,O.$Mk)(Y.original,Y.originalLowercase,re,B,B.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return K?[K[0],(0,O.$Jk)(K)]:d}const i=Object.freeze({score:0}),c=1<<18,r=1<<17,t=65536;function u(B,Y,re,H){const K=H.values?H.values:[H];return(0,L.$mj)({[H.normalized]:{values:K.map(Z=>({value:Z.normalized,expectContiguousMatch:Z.expectContiguousMatch})),label:B,description:Y,allowNonContiguousMatches:re}})}function s(B,Y,re,H,K){if(!B||!Y.normalized)return i;const _=H.getItemLabel(B);if(!_)return i;const Z=H.getItemDescription(B),$e=u(_,Z,re,Y),oe=K[$e];if(oe)return oe;const Pe=o(_,Z,H.getItemPath(B),Y,re);return K[$e]=Pe,Pe}function o(B,Y,re,H,K){const _=!re||!H.containsPathSeparator;return re&&(M.$k?H.pathNormalized===re:(0,b.$zf)(H.pathNormalized,re))?{score:c,labelMatch:[{start:0,end:B.length}],descriptionMatch:Y?[{start:0,end:Y.length}]:void 0}:H.values&&H.values.length>1?h(B,Y,re,H.values,_,K):g(B,Y,re,H,_,K)}function h(B,Y,re,H,K,_){let Z=0;const $e=[],oe=[];for(const Pe of H){const{score:te,labelMatch:U,descriptionMatch:ee}=g(B,Y,re,Pe,K,_);if(te===$)return i;Z+=te,U&&$e.push(...U),ee&&oe.push(...ee)}return{score:Z,labelMatch:k($e),descriptionMatch:k(oe)}}function g(B,Y,re,H,K,_){if(K||!Y){const[Z,$e]=I(B,H.normalized,H.normalizedLowercase,_&&!H.expectContiguousMatch);if(Z){const oe=(0,O.$Ak)(H.normalized,B);let Pe;if(oe){Pe=r;const te=Math.round(H.normalized.length/B.length*100);Pe+=te}else Pe=t;return{score:Pe+Z,labelMatch:oe||w($e)}}}if(Y){let Z=Y;re&&(Z=`${Y}${A.sep}`);const $e=Z.length,oe=`${Z}${B}`,[Pe,te]=I(oe,H.normalized,H.normalizedLowercase,_&&!H.expectContiguousMatch);if(Pe){const U=w(te),ee=[],be=[];return U.forEach(ue=>{ue.start<$e&&ue.end>$e?(ee.push({start:0,end:ue.end-$e}),be.push({start:ue.start,end:$e})):ue.start>=$e?ee.push({start:ue.start-$e,end:ue.end-$e}):be.push(ue)}),{score:Pe,labelMatch:ee,descriptionMatch:be}}}return i}function w(B){const Y=[];if(!B)return Y;let re;for(const H of B)re&&re.end===H?re.end+=1:(re={start:H,end:H+1},Y.push(re));return Y}function k(B){const Y=B.sort((K,_)=>K.start-_.start),re=[];let H;for(const K of Y)!H||!m(H,K)?(H=K,re.push(K)):(H.start=Math.min(H.start,K.start),H.end=Math.max(H.end,K.end));return re}function m(B,Y){return!(B.end<Y.start||Y.end<B.start)}function y(B,Y,re,H,K,_){const Z=s(B,re,H,K,_),$e=s(Y,re,H,K,_),oe=Z.score,Pe=$e.score;if((oe===c||Pe===c)&&oe!==Pe)return oe===c?-1:1;if(oe>t||Pe>t){if(oe!==Pe)return oe>Pe?-1:1;if(oe<r&&Pe<r){const ae=C(Z.labelMatch,$e.labelMatch);if(ae!==0)return ae}const ue=K.getItemLabel(B)||"",ce=K.getItemLabel(Y)||"";if(ue.length!==ce.length)return ue.length-ce.length}if(oe!==Pe)return oe>Pe?-1:1;const te=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0,U=Array.isArray($e.labelMatch)&&$e.labelMatch.length>0;if(te&&!U)return-1;if(U&&!te)return 1;const ee=D(B,Z,K),be=D(Y,$e,K);return ee&&be&&ee!==be?be>ee?-1:1:R(B,Y,re,K)}function D(B,Y,re){let H=-1,K=-1;if(Y.descriptionMatch&&Y.descriptionMatch.length?H=Y.descriptionMatch[0].start:Y.labelMatch&&Y.labelMatch.length&&(H=Y.labelMatch[0].start),Y.labelMatch&&Y.labelMatch.length){if(K=Y.labelMatch[Y.labelMatch.length-1].end,Y.descriptionMatch&&Y.descriptionMatch.length){const _=re.getItemDescription(B);_&&(K+=_.length)}}else Y.descriptionMatch&&Y.descriptionMatch.length&&(K=Y.descriptionMatch[Y.descriptionMatch.length-1].end);return K-H}function C(B,Y){if(!B&&!Y||(!B||!B.length)&&(!Y||!Y.length))return 0;if(!Y||!Y.length)return-1;if(!B||!B.length)return 1;const re=B[0].start,K=B[B.length-1].end-re,_=Y[0].start,$e=Y[Y.length-1].end-_;return K===$e?0:$e<K?1:-1}function R(B,Y,re,H){const K=H.getItemLabel(B)||"",_=H.getItemLabel(Y)||"",Z=H.getItemDescription(B),$e=H.getItemDescription(Y),oe=K.length+(Z?Z.length:0),Pe=_.length+($e?$e.length:0);if(oe!==Pe)return oe-Pe;const te=H.getItemPath(B),U=H.getItemPath(Y);return te&&U&&te.length!==U.length?te.length-U.length:K!==_?(0,l.$vr)(K,_,re.normalized):Z&&$e&&Z!==$e?(0,l.$vr)(Z,$e,re.normalized):te&&U&&te!==U?(0,l.$vr)(te,U,re.normalized):0}function T(B){return B.startsWith('"')&&B.endsWith('"')}const j=" ";function z(B){typeof B!="string"&&(B="");const Y=B.toLowerCase(),{pathNormalized:re,normalized:H,normalizedLowercase:K}=N(B),_=re.indexOf(A.sep)>=0,Z=T(B);let $e;const oe=B.split(j);if(oe.length>1)for(const Pe of oe){const te=T(Pe),{pathNormalized:U,normalized:ee,normalizedLowercase:be}=N(Pe);ee&&($e||($e=[]),$e.push({original:Pe,originalLowercase:Pe.toLowerCase(),pathNormalized:U,normalized:ee,normalizedLowercase:be,expectContiguousMatch:te}))}return{original:B,originalLowercase:Y,pathNormalized:re,normalized:H,normalizedLowercase:K,values:$e,containsPathSeparator:_,expectContiguousMatch:Z}}function N(B){let Y;M.$i?Y=B.replace(/\//g,A.sep):Y=B.replace(/\\/g,A.sep);const re=(0,b.$jf)(Y).replace(/\s|"/g,"");return{pathNormalized:Y,normalized:re,normalizedLowercase:re.toLowerCase()}}function F(B){return Array.isArray(B)?z(B.map(Y=>Y.original).join(j)):z(B.original)}}),define(ke[101],De([1,0,16]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Vs=A,e.$Ws=M,e.$Xs=b,e.$Ys=E,e.$Us=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const P=(0,l.$oc)(I),p=O[P.toLowerCase()];return p!==void 0?p:M(I)}function M(I){const P=(0,l.$oc)(I);return L[P.toLowerCase()]}function b(I){for(const P in L)if(L[P]===I)return P}const $=/^(.+)\/(.+?)(;.+)?$/;function E(I,P){const p=$.exec(I);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:P?void 0:I}}),define(ke[102],De([1,0,12]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=A,e.$pm=M;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O||(e.Source=O={}));var L;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(b,...$){const E=$.reduce((p,S)=>(p[S]=!0,p),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!E[p]).forEach(p=>{for(let S=0;S<I.length;S++)if(p.search(I[S])!==-1){delete b[p];break}})}function M(b){b&&(delete b.DEBUG,l.$j&&delete b.DYLD_LIBRARY_PATH,l.$k&&delete b.LD_PRELOAD)}}),define(ke[2],De([1,0,16,12]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=v,e.$wc=c;const L=/^\w[\w\d+.-]*$/,A=/^\//,M=/^\/\//;function b(o,h){if(!o.scheme&&h)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!L.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!A.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(o,h){return!o&&!h?"file":o}function E(o,h){switch(o){case"https":case"http":case"file":h?h[0]!==P&&(h=P+h):h=P;break}return h}const I="",P="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(h){return h instanceof S?!0:h?typeof h.authority=="string"&&typeof h.fragment=="string"&&typeof h.path=="string"&&typeof h.query=="string"&&typeof h.scheme=="string"&&typeof h.fsPath=="string"&&typeof h.with=="function"&&typeof h.toString=="function":!1}constructor(h,g,w,k,m,y=!1){typeof h=="object"?(this.scheme=h.scheme||I,this.authority=h.authority||I,this.path=h.path||I,this.query=h.query||I,this.fragment=h.fragment||I):(this.scheme=$(h,y),this.authority=g||I,this.path=E(this.scheme,w||I),this.query=k||I,this.fragment=m||I,b(this,y))}get fsPath(){return c(this,!1)}with(h){if(!h)return this;let{scheme:g,authority:w,path:k,query:m,fragment:y}=h;return g===void 0?g=this.scheme:g===null&&(g=I),w===void 0?w=this.authority:w===null&&(w=I),k===void 0?k=this.path:k===null&&(k=I),m===void 0?m=this.query:m===null&&(m=I),y===void 0?y=this.fragment:y===null&&(y=I),g===this.scheme&&w===this.authority&&k===this.path&&m===this.query&&y===this.fragment?this:new f(g,w,k,m,y)}static parse(h,g=!1){const w=p.exec(h);return w?new f(w[2]||I,s(w[4]||I),s(w[5]||I),s(w[7]||I),s(w[9]||I),g):new f(I,I,I,I,I)}static file(h){let g=I;if(O.$i&&(h=h.replace(/\\/g,P)),h[0]===P&&h[1]===P){const w=h.indexOf(P,2);w===-1?(g=h.substring(2),h=P):(g=h.substring(2,w),h=h.substring(w)||P)}return new f("file",g,h,I,I)}static from(h,g){return new f(h.scheme,h.authority,h.path,h.query,h.fragment,g)}static joinPath(h,...g){if(!h.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return O.$i&&h.scheme==="file"?w=S.file(l.$fc.join(c(h,!0),...g)).path:w=l.$gc.join(h.path,...g),h.with({path:w})}toString(h=!1){return r(this,h)}toJSON(){return this}static revive(h){if(h){if(h instanceof S)return h;{const g=new f(h);return g._formatted=h.external??null,g._fsPath=h._sep===d?h.fsPath??null:null,g}}else return h}}e.URI=S;function v(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}const d=O.$i?1:void 0;class f extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(h=!1){return h?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const h={$mid:1};return this._fsPath&&(h.fsPath=this._fsPath,h._sep=d),this._formatted&&(h.external=this._formatted),this.path&&(h.path=this.path),this.scheme&&(h.scheme=this.scheme),this.authority&&(h.authority=this.authority),this.query&&(h.query=this.query),this.fragment&&(h.fragment=this.fragment),h}}const a={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(o,h,g){let w,k=-1;for(let m=0;m<o.length;m++){const y=o.charCodeAt(m);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||h&&y===47||g&&y===91||g&&y===93||g&&y===58)k!==-1&&(w+=encodeURIComponent(o.substring(k,m)),k=-1),w!==void 0&&(w+=o.charAt(m));else{w===void 0&&(w=o.substr(0,m));const D=a[y];D!==void 0?(k!==-1&&(w+=encodeURIComponent(o.substring(k,m)),k=-1),w+=D):k===-1&&(k=m)}}return k!==-1&&(w+=encodeURIComponent(o.substring(k))),w!==void 0?w:o}function i(o){let h;for(let g=0;g<o.length;g++){const w=o.charCodeAt(g);w===35||w===63?(h===void 0&&(h=o.substr(0,g)),h+=a[w]):h!==void 0&&(h+=o[g])}return h!==void 0?h:o}function c(o,h){let g;return o.authority&&o.path.length>1&&o.scheme==="file"?g=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?h?g=o.path.substr(1):g=o.path[1].toLowerCase()+o.path.substr(2):g=o.path,O.$i&&(g=g.replace(/\//g,"\\")),g}function r(o,h){const g=h?i:n;let w="",{scheme:k,authority:m,path:y,query:D,fragment:C}=o;if(k&&(w+=k,w+=":"),(m||k==="file")&&(w+=P,w+=P),m){let R=m.indexOf("@");if(R!==-1){const T=m.substr(0,R);m=m.substr(R+1),R=T.lastIndexOf(":"),R===-1?w+=g(T,!1,!1):(w+=g(T.substr(0,R),!1,!1),w+=":",w+=g(T.substr(R+1),!1,!0)),w+="@"}m=m.toLowerCase(),R=m.lastIndexOf(":"),R===-1?w+=g(m,!1,!0):(w+=g(m.substr(0,R),!1,!0),w+=m.substr(R))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const R=y.charCodeAt(1);R>=65&&R<=90&&(y=`/${String.fromCharCode(R+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const R=y.charCodeAt(0);R>=65&&R<=90&&(y=`${String.fromCharCode(R+32)}:${y.substr(2)}`)}w+=g(y,!0,!1)}return D&&(w+="?",w+=g(D,!1,!1)),C&&(w+="#",w+=h?C:n(C,!1,!1)),w}function t(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+t(o.substr(3)):o}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(o){return o.match(u)?o.replace(u,h=>t(h)):o}}),define(ke[197],De([1,0,2]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=O,e.$1q=L,e.$2q=A,e.log=b;function O(E){const I=E;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function L(E){const I=[];let P;try{const p=JSON.parse(E.arguments),S=p[p.length-1];S&&S.__$stack&&(p.pop(),P=S.__$stack),I.push(...p)}catch{I.push("Unable to log remote console arguments",E.arguments)}return{args:I,stack:P}}function A(E){if(typeof E!="string")return A(L(E).stack);const I=E;if(I){const P=M(I),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(p&&p.length===4)return{uri:l.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function M(E){if(!E)return E;const I=E.indexOf(`
`);return I===-1?E:E.substring(0,I)}function b(E,I){const{args:P,stack:p}=L(E),S=typeof P[0]=="string"&&P.length===1;let v=M(p);v&&(v=`(${v.trim()})`);let d=[];if(typeof P[0]=="string"?v&&S?d=[`%c[${I}] %c${P[0]} %c${v}`,$("blue"),$(""),$("grey")]:d=[`%c[${I}] %c${P[0]}`,$("blue"),$(""),...P.slice(1)]:d=[`%c[${I}]%`,$("blue"),...P],v&&!S&&d.push(v),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,d)}function $(E){return`color: ${E}`}}),define(ke[58],De([1,0,22,2]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=L,e.$7h=A,e.$8h=b;function L($){return JSON.stringify($,M)}function A($){let E=JSON.parse($);return E=b(E),E}function M($,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function b($,E=0){if(!$||E>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return O.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof l.$He||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let I=0;I<$.length;++I)$[I]=b($[I],E+1);else for(const I in $)Object.hasOwnProperty.call($,I)&&($[I]=b($[I],E+1))}return $}}),define(ke[15],De([1,0,13,12,14,2,16]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Lg=e.$Kg=e.$Jg=e.Schemas=void 0,e.$Hg=$,e.$Ig=E,e.$Mg=P;var b;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting"})(b||(e.Schemas=b={}));function $(v,d){return A.URI.isUri(v)?(0,L.$zf)(v.scheme,d):(0,L.$Af)(v,d+":")}function E(v,...d){return d.some(f=>$(v,f))}e.$Jg="vscode-tkn",e.$Kg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d,f){this.f=P(d,f)}getServerRootPath(){return this.f}get g(){return M.$gc.join(this.f,b.vscodeRemoteResource)}set(d,f,a){this.a[d]=f,this.b[d]=a}setConnectionToken(d,f){this.c[d]=f}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(r){return l.$1(r),d}const f=d.authority;let a=this.a[f];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const n=this.b[f],i=this.c[f];let c=`path=${encodeURIComponent(d.path)}`;return typeof i=="string"&&(c+=`&${e.$Kg}=${encodeURIComponent(i)}`),A.URI.from({scheme:O.$o?this.d:b.vscodeRemoteResource,authority:`${a}:${n}`,path:this.g,query:c})}}e.$Lg=new I;function P(v,d){return M.$gc.join(d??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Ng="vs/../../extensions",e.$Og="vs/../../node_modules",e.$Pg="vs/../../node_modules.asar",e.$Qg="vs/../../node_modules.asar.unpacked",e.$Rg="vscode-app";class p{static{this.a=e.$Rg}asBrowserUri(d){const f=this.b(d,he);return this.uriToBrowserUri(f)}uriToBrowserUri(d){return d.scheme===b.vscodeRemote?e.$Lg.rewrite(d):d.scheme===b.file&&(O.$m||O.$q===`${b.vscodeFileResource}://${p.a}`)?d.with({scheme:b.vscodeFileResource,authority:d.authority||p.a,query:null,fragment:null}):d}asFileUri(d){const f=this.b(d,he);return this.uriToFileUri(f)}uriToFileUri(d){return d.scheme===b.vscodeFileResource?d.with({scheme:b.file,authority:d.authority!==p.a?d.authority:null,query:null,fragment:null}):d}b(d,f){return A.URI.isUri(d)?d:A.URI.parse(f.toUrl(d))}}e.$Sg=new p;var S;(function(v){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(d.get("3"));const f="vscode-coi";function a(i){let c;typeof i=="string"?c=new URL(i).searchParams:i instanceof URL?c=i.searchParams:A.URI.isUri(i)&&(c=new URL(i.toString(!0)).searchParams);const r=c?.get(f);if(r)return d.get(r)}v.getHeadersFromQuery=a;function n(i,c,r){if(!globalThis.crossOriginIsolated)return;const t=c&&r?"3":r?"2":"1";i instanceof URLSearchParams?i.set(f,t):i[f]=t}v.addSearchParam=n})(S||(e.COI=S={}))}),define(ke[198],De([1,0,163,15,12,2]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_D=I;class M{constructor(p,S,v){this.id=p,this.dependencies=S,this.callback=v}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,S,v)=>{typeof p!="string"&&(v=S,S=p,p=null),(typeof S!="object"||!Array.isArray(S))&&(v=S,S=null),this.c.push(new M(p,S,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const S=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!S)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(p){return new Promise((S,v)=>{const d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript");const f=()=>{d.removeEventListener("load",a),d.removeEventListener("error",n)},a=i=>{f(),S(this.c.pop())},n=i=>{f(),v(i)};d.addEventListener("load",a),d.addEventListener("error",n),this.f&&(p=this.f.createScriptURL(p)),d.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(d)})}i(p){return new Promise((S,v)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),S(this.c.pop())}catch(d){v(d)}})}async j(p){try{const S=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,d=globalThis._VSCODE_NODE_MODULES.module,f=A.URI.parse(p).fsPath,a=S.readFileSync(f).toString(),n=d.wrap(a.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const $=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function I(P,p,S){if(l.$T){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[P]&&(P=E[P]);const v=`${P}/${p}`;if($.has(v))return $.get(v);let d;if(/^\w[\w\d+.-]*:\/\//.test(v))d=v;else{const i=`${S&&!L.$o?O.$Pg:O.$Og}/${v}`;d=O.$Sg.asBrowserUri(i).toString(!0)}const f=b.INSTANCE.load(d);return $.set(v,f),f}else return await new Promise((v,d)=>{he([P],v,d)})}}),define(ke[23],De([1,0,31,15,16,12,14,2]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0,e.$Zg=$,e.$ih=I,e.$jh=p;function $(S){return(0,b.$wc)(S,!0)}class E{constructor(v){this.a=v}compare(v,d,f=!1){return v===d?0:(0,M.$sf)(this.getComparisonKey(v,f),this.getComparisonKey(d,f))}isEqual(v,d,f=!1){return v===d?!0:!v||!d?!1:this.getComparisonKey(v,f)===this.getComparisonKey(d,f)}getComparisonKey(v,d=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,d,f=!1){if(v.scheme===d.scheme){if(v.scheme===O.Schemas.file)return l.$xg($(v),$(d),this.a(v))&&v.query===d.query&&(f||v.fragment===d.fragment);if((0,e.$eh)(v.authority,d.authority))return l.$xg(v.path,d.path,this.a(v),"/")&&v.query===d.query&&(f||v.fragment===d.fragment)}return!1}joinPath(v,...d){return b.URI.joinPath(v,...d)}basenameOrAuthority(v){return(0,e.$9g)(v)||v.authority}basename(v){return L.$gc.basename(v.path)}extname(v){return L.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let d;return v.scheme===O.Schemas.file?d=b.URI.file(L.$mc($(v))).path:(d=L.$gc.dirname(v.path),v.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),d="/")),v.with({path:d})}normalizePath(v){if(!v.path.length)return v;let d;return v.scheme===O.Schemas.file?d=b.URI.file(L.$hc($(v))).path:d=L.$gc.normalize(v.path),v.with({path:d})}relativePath(v,d){if(v.scheme!==d.scheme||!(0,e.$eh)(v.authority,d.authority))return;if(v.scheme===O.Schemas.file){const n=L.$lc($(v),$(d));return A.$i?l.$rg(n):n}let f=v.path||"/";const a=d.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(f.length,a.length);n<i&&!(f.charCodeAt(n)!==a.charCodeAt(n)&&f.charAt(n).toLowerCase()!==a.charAt(n).toLowerCase());n++);f=a.substr(0,n)+f.substr(n)}return L.$gc.relative(f,a)}resolvePath(v,d){if(v.scheme===O.Schemas.file){const f=b.URI.file(L.$kc($(v),d));return v.with({authority:f.authority,path:f.path})}return d=l.$sg(d),v.with({path:L.$gc.resolve(v.path,d)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,d){return v===d||v!==void 0&&d!==void 0&&(0,M.$zf)(v,d)}hasTrailingPathSeparator(v,d=L.sep){if(v.scheme===O.Schemas.file){const f=$(v);return f.length>l.$tg(f).length&&f[f.length-1]===d}else{const f=v.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,d=L.sep){return(0,e.$fh)(v,d)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,d=L.sep){let f=!1;if(v.scheme===O.Schemas.file){const a=$(v);f=a!==void 0&&a.length===l.$tg(a).length&&a[a.length-1]===d}else{d="/";const a=v.path;f=a.length===1&&a.charCodeAt(a.length-1)===47}return!f&&!(0,e.$fh)(v,d)?v.with({path:v.path+"/"}):v}}e.$1g=E,e.$2g=new E(()=>!1),e.$3g=new E(S=>S.scheme===O.Schemas.file?!A.$k:!0),e.$4g=new E(S=>!0),e.$5g=e.$2g.isEqual.bind(e.$2g),e.$6g=e.$2g.isEqualOrParent.bind(e.$2g),e.$7g=e.$2g.getComparisonKey.bind(e.$2g),e.$8g=e.$2g.basenameOrAuthority.bind(e.$2g),e.$9g=e.$2g.basename.bind(e.$2g),e.$0g=e.$2g.extname.bind(e.$2g),e.$$g=e.$2g.dirname.bind(e.$2g),e.$_g=e.$2g.joinPath.bind(e.$2g),e.$ah=e.$2g.normalizePath.bind(e.$2g),e.$bh=e.$2g.relativePath.bind(e.$2g),e.$ch=e.$2g.resolvePath.bind(e.$2g),e.$dh=e.$2g.isAbsolutePath.bind(e.$2g),e.$eh=e.$2g.isEqualAuthority.bind(e.$2g),e.$fh=e.$2g.hasTrailingPathSeparator.bind(e.$2g),e.$gh=e.$2g.removeTrailingPathSeparator.bind(e.$2g),e.$hh=e.$2g.addTrailingPathSeparator.bind(e.$2g);function I(S,v){const d=[];for(let f=0;f<S.length;f++){const a=v(S[f]);S.some((n,i)=>i===f?!1:(0,e.$6g)(a,v(n)))||d.push(S[f])}return d}var P;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function v(d){const f=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(i=>{const[c,r]=i.split(":");c&&r&&f.set(c,r)});const n=d.path.substring(0,d.path.indexOf(";"));return n&&f.set(S.META_DATA_MIME,n),f}S.parseMetaData=v})(P||(e.DataUri=P={}));function p(S,v,d){if(v){let f=S.path;return f&&f[0]!==L.$gc.sep&&(f=L.$gc.sep+f),S.with({scheme:d,authority:v,path:f})}return S.with({scheme:d})}}),define(ke[7],De([1,0,21,13,4,3,23,12,174,46]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.Promises=e.$Vh=e.$Uh=e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0,e.$kh=I,e.$lh=P,e.$mh=p,e.$nh=S,e.$oh=v,e.$ph=d,e.$qh=f,e.$rh=a,e.$zh=g,e.$Ah=w,e.$Bh=k,e.$Ch=m,e.$Dh=y,e.$Sh=K,e.$1h=ce;function I(le){return!!le&&typeof le.then=="function"}function P(le){const J=new l.$qe,se=le(J.token),pe=new Promise((ve,Re)=>{const me=J.token.onCancellationRequested(()=>{me.dispose(),Re(new O.$5)});Promise.resolve(se).then(Ie=>{me.dispose(),J.dispose(),ve(Ie)},Ie=>{me.dispose(),J.dispose(),Re(Ie)})});return new class{cancel(){J.cancel(),J.dispose()}then(ve,Re){return pe.then(ve,Re)}catch(ve){return this.then(void 0,ve)}finally(ve){return pe.finally(ve)}}}function p(le,J,se){return new Promise((pe,ve)=>{const Re=J.onCancellationRequested(()=>{Re.dispose(),pe(se)});le.then(pe,ve).finally(()=>Re.dispose())})}function S(le,J){return new Promise((se,pe)=>{const ve=J.onCancellationRequested(()=>{ve.dispose(),pe(new O.$5)});le.then(se,pe).finally(()=>ve.dispose())})}async function v(le){let J=-1;const se=le.map((pe,ve)=>pe.then(Re=>(J=ve,Re)));try{return await Promise.race(se)}finally{le.forEach((pe,ve)=>{ve!==J&&pe.cancel()})}}function d(le,J,se){let pe;const ve=setTimeout(()=>{pe?.(void 0),se?.()},J);return Promise.race([le.finally(()=>clearTimeout(ve)),new Promise(Re=>pe=Re)])}function f(le){return new Promise((J,se)=>{const pe=le();I(pe)?pe.then(J,se):J(pe)})}function a(){let le,J;return{promise:new Promise((pe,ve)=>{le=pe,J=ve}),resolve:le,reject:J}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const se=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(se,se).then(pe)})}return new Promise((se,pe)=>{this.b.then(se,pe)})}return this.a=J(),new Promise((se,pe)=>{this.a.then(ve=>{this.a=null,se(ve)},ve=>{this.a=null,pe(ve)})})}dispose(){this.f=!0}}e.$sh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$th=i;class c{constructor(){this.a=new Map}queue(J,se){const ve=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(J)===ve&&this.a.delete(J)});return this.a.set(J,ve),ve}}e.$uh=c;const r=(le,J)=>{let se=!0;const pe=setTimeout(()=>{se=!1,J()},le);return{isTriggered:()=>se,dispose:()=>{clearTimeout(pe),se=!1}}},t=le=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,le())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class u{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,se=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((ve,Re)=>{this.d=ve,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=se===$.$ce?t(pe):r(se,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$vh=u;class s{constructor(J){this.a=new u(J),this.b=new n}trigger(J,se){return this.a.trigger(()=>this.b.queue(J),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$wh=s;class o{constructor(){this.a=!1,this.b=new Promise((J,se)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$xh=o;class h extends o{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$yh=h;function g(le,J){return J?new Promise((se,pe)=>{const ve=setTimeout(()=>{Re.dispose(),se()},le),Re=J.onCancellationRequested(()=>{clearTimeout(ve),Re.dispose(),pe(new O.$5)})}):P(se=>g(le,se))}function w(le,J=0,se){const pe=setTimeout(()=>{le(),se&&ve.dispose()},J),ve=(0,A.$Sc)(()=>{clearTimeout(pe),se?.deleteAndLeak(ve)});return se?.add(ve),ve}function k(le){const J=[];let se=0;const pe=le.length;function ve(){return se<pe?le[se++]():null}function Re(me){me!=null&&J.push(me);const Ie=ve();return Ie?Ie.then(Re):Promise.resolve(J)}return Promise.resolve(null).then(Re)}function m(le,J=pe=>!!pe,se=null){let pe=0;const ve=le.length,Re=()=>{if(pe>=ve)return Promise.resolve(se);const me=le[pe++];return Promise.resolve(me()).then(Ae=>J(Ae)?Promise.resolve(Ae):Re())};return Re()}function y(le,J=pe=>!!pe,se=null){if(le.length===0)return Promise.resolve(se);let pe=le.length;const ve=()=>{pe=-1;for(const Re of le)Re.cancel?.()};return new Promise((Re,me)=>{for(const Ie of le)Ie.then(Ae=>{--pe>=0&&J(Ae)?(ve(),Re(Ae)):pe===0&&Re(se)}).catch(Ae=>{--pe>=0&&(ve(),me(Ae))})})}class D{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new L.$fe}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,pe)=>{this.g.push({factory:J,c:se,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const se=J.factory();se.then(J.c,J.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Eh=D;class C extends D{constructor(){super(1)}}e.$Fh=C;class R{constructor(){this.a=new _,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Gh=R;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new oe;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,se=M.$2g){const pe=se.getComparisonKey(J);return this.a.get(pe)?.size??0}queueFor(J,se,pe=M.$2g){const ve=pe.getComparisonKey(J);let Re=this.a.get(ve);if(!Re){Re=new C;const me=this.f++,Ie=L.Event.once(Re.onDrained)(()=>{Re?.dispose(),this.a.delete(ve),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set(me,Ie),this.a.set(ve,Re)}return Re.queue(se)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Hh=T;class j{constructor(J,se){this.a=-1,typeof J=="function"&&typeof se=="number"&&this.setIfNotSet(J,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},se)}setIfNotSet(J,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},se))}}e.$Ih=j;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,se,pe=globalThis){this.cancel();const ve=pe.setInterval(()=>{J()},se);this.d=(0,A.$Sc)(()=>{pe.clearInterval(ve),this.d=void 0})}dispose(){this.cancel()}}e.$Jh=z;class N{constructor(J,se){this.b=-1,this.a=J,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Kh=N;class F{constructor(J,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=J,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Lh=F;class B extends N{constructor(J,se){super(J,se),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Mh=B;class Y extends A.$Uc{constructor(J,se){super(),this.g=J,this.h=se,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of J)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Nh=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ph=(le,J)=>{(0,b.$B)(()=>{if(se)return;const pe=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Ph=(le,J,se)=>{const pe=le.requestIdleCallback(J,typeof se=="number"?{timeout:se}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,le.cancelIdleCallback(pe))}}},e.$Oh=le=>(0,e.$Ph)(globalThis,le)}();class re{constructor(J,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Ph)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Qh=re;class H extends re{constructor(J){super(globalThis,J)}}e.$Rh=H;async function K(le,J,se){let pe;for(let ve=0;ve<se;ve++)try{return await le()}catch(Re){pe=Re,await g(J)}throw pe}class _{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,se,pe){return this.a={taskId:J,cancel:()=>pe?.(),promise:se},se.then(()=>this.d(J),()=>this.d(J)),se}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:se,resolve:pe,reject:ve}=a();this.b={run:J,promise:se,promiseResolve:pe,promiseReject:ve}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Th=_;class Z{constructor(J,se=()=>Date.now()){this.d=J,this.f=se,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Uh=Z;var $e;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})($e||($e={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,se)=>{this.a=J,this.b=se})}complete(J){return new Promise(se=>{this.a(J),this.d={outcome:0,value:J},se()})}error(J){return new Promise(se=>{this.b(J),this.d={outcome:1,value:J},se()})}cancel(){return this.error(new O.$5)}}e.$Vh=oe;var Pe;(function(le){async function J(pe){let ve;const Re=await Promise.all(pe.map(me=>me.then(Ie=>Ie,Ie=>{ve||(ve=Ie)})));if(typeof ve<"u")throw ve;return Re}le.settled=J;function se(pe){return new Promise(async(ve,Re)=>{try{await pe(ve,Re)}catch(me){Re(me)}})}le.withAsyncBody=se})(Pe||(e.Promises=Pe={}));class te{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Wh=te;class U{constructor(J){this.b=J,this.a=new E.$V(()=>new te(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Xh=U;var ee;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(ee||(ee={}));class be{static fromArray(J){return new be(se=>{se.emitMany(J)})}static fromPromise(J){return new be(async se=>{se.emitMany(await J)})}static fromPromises(J){return new be(async se=>{await Promise.all(J.map(async pe=>se.emitOne(await pe)))})}static merge(J){return new be(async se=>{await Promise.all(J.map(async pe=>{for await(const ve of pe)se.emitOne(ve)}))})}static{this.EMPTY=be.fromArray([])}constructor(J,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new L.$fe,queueMicrotask(async()=>{const pe={emitOne:ve=>this.h(ve),emitMany:ve=>this.j(ve),reject:ve=>this.l(ve)};try{await Promise.resolve(J(pe)),this.k()}catch(ve){this.l(ve)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,se){return new be(async pe=>{for await(const ve of J)pe.emitOne(se(ve))})}map(J){return be.map(this,J)}static filter(J,se){return new be(async pe=>{for await(const ve of J)se(ve)&&pe.emitOne(ve)})}filter(J){return be.filter(this,J)}static coalesce(J){return be.filter(J,se=>!!se)}coalesce(){return be.coalesce(this)}static async toPromise(J){const se=[];for await(const pe of J)se.push(pe);return se}toPromise(){return be.toPromise(this)}h(J){this.a===0&&(this.b.push(J),this.g.fire())}j(J){this.a===0&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(J){this.a===0&&(this.a=2,this.d=J,this.g.fire())}}e.$Yh=be;class ue extends be{constructor(J,se){super(se),this.m=J}cancel(){this.m.cancel()}}e.$Zh=ue;function ce(le){const J=new l.$qe,se=le(J.token);return new ue(J,async pe=>{const ve=J.token.onCancellationRequested(()=>{ve.dispose(),J.dispose(),pe.reject(new O.$5)});try{for await(const Re of se){if(J.token.isCancellationRequested)return;pe.emitOne(Re)}ve.dispose(),J.dispose()}catch(Re){ve.dispose(),J.dispose(),pe.reject(Re)}})}class ae{constructor(J){this.a=new oe,this.b=new be(ve=>{if(se){ve.reject(se);return}return pe&&ve.emitMany(pe),this.d=Re=>ve.reject(Re),this.f=Re=>ve.emitOne(Re),this.a.p},J);let se,pe;this.f=ve=>{pe||(pe=[]),pe.push(ve)},this.d=ve=>{se||(se=ve)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$2h=ae}),define(ke[35],De([1,0,19,7,31,27,16,12,14]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=void 0,e.$nk=E,e.$qk=v,e.$rk=C,e.$sk=R,e.$tk=T,e.$uk=j,e.$vk=z,e.$wk=Y;function E(){return Object.create(null)}e.$ok="**",e.$pk="/";const I="[/\\\\]",P="[^/\\\\]",p=/\//g;function S(re,H){switch(re){case 0:return"";case 1:return`${P}*?`;default:return`(?:${I}|${P}+${I}${H?`|${I}${P}+`:""})*?`}}function v(re,H){if(!re)return[];const K=[];let _=!1,Z=!1,$e="";for(const oe of re){switch(oe){case H:if(!_&&!Z){K.push($e),$e="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}$e+=oe}return $e&&K.push($e),K}function d(re){if(!re)return"";let H="";const K=v(re,e.$pk);if(K.every(_=>_===e.$ok))H=".*";else{let _=!1;K.forEach((Z,$e)=>{if(Z===e.$ok){if(_)return;H+=S(2,$e===K.length-1)}else{let oe=!1,Pe="",te=!1,U="";for(const ee of Z){if(ee!=="}"&&oe){Pe+=ee;continue}if(te&&(ee!=="]"||!U)){let be;ee==="-"?be=ee:(ee==="^"||ee==="!")&&!U?be="^":ee===e.$pk?be="":be=(0,$.$bf)(ee),U+=be;continue}switch(ee){case"{":oe=!0;continue;case"[":te=!0;continue;case"}":{const ue=`(?:${v(Pe,",").map(ce=>d(ce)).join("|")})`;H+=ue,oe=!1,Pe="";break}case"]":{H+="["+U+"]",te=!1,U="";break}case"?":H+=P;continue;case"*":H+=S(1);continue;default:H+=(0,$.$bf)(ee)}}$e<K.length-1&&(K[$e+1]!==e.$ok||$e+2<K.length)&&(H+=I)}_=Z===e.$ok})}return H}const f=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Dc(1e4),u=function(){return!1},s=function(){return null};function o(re,H){if(!re)return s;let K;typeof re!="string"?K=re.pattern:K=re,K=K.trim();const _=`${K}_${!!H.trimForExclusions}`;let Z=t.get(_);if(Z)return h(Z,re);let $e;return f.test(K)?Z=w(K.substr(4),K):($e=a.exec(g(K,H)))?Z=k($e[1],K):(H.trimForExclusions?i:n).test(K)?Z=m(K,H):($e=c.exec(g(K,H)))?Z=y($e[1].substr(1),K,!0):($e=r.exec(g(K,H)))?Z=y($e[1],K,!1):Z=D(K),t.set(_,Z),h(Z,re)}function h(re,H){if(typeof H=="string")return re;const K=function(_,Z){return(0,L.$xg)(_,H.base,!b.$k)?re((0,$.$gf)(_.substr(H.base.length),M.sep),Z):null};return K.allBasenames=re.allBasenames,K.allPaths=re.allPaths,K.basenames=re.basenames,K.patterns=re.patterns,K}function g(re,H){return H.trimForExclusions&&re.endsWith("/**")?re.substr(0,re.length-2):re}function w(re,H){return function(K,_){return typeof K=="string"&&K.endsWith(re)?H:null}}function k(re,H){const K=`/${re}`,_=`\\${re}`,Z=function(oe,Pe){return typeof oe!="string"?null:Pe?Pe===re?H:null:oe===re||oe.endsWith(K)||oe.endsWith(_)?H:null},$e=[re];return Z.basenames=$e,Z.patterns=[H],Z.allBasenames=$e,Z}function m(re,H){const K=B(re.slice(1,-1).split(",").map(Pe=>o(Pe,H)).filter(Pe=>Pe!==s),re),_=K.length;if(!_)return s;if(_===1)return K[0];const Z=function(Pe,te){for(let U=0,ee=K.length;U<ee;U++)if(K[U](Pe,te))return re;return null},$e=K.find(Pe=>!!Pe.allBasenames);$e&&(Z.allBasenames=$e.allBasenames);const oe=K.reduce((Pe,te)=>te.allPaths?Pe.concat(te.allPaths):Pe,[]);return oe.length&&(Z.allPaths=oe),Z}function y(re,H,K){const _=M.sep===M.$gc.sep,Z=_?re:re.replace(p,M.sep),$e=M.sep+Z,oe=M.$gc.sep+re;let Pe;return K?Pe=function(te,U){return typeof te=="string"&&(te===Z||te.endsWith($e)||!_&&(te===re||te.endsWith(oe)))?H:null}:Pe=function(te,U){return typeof te=="string"&&(te===Z||!_&&te===re)?H:null},Pe.allPaths=[(K?"*/":"./")+re],Pe}function D(re){try{const H=new RegExp(`^${d(re)}$`);return function(K){return H.lastIndex=0,typeof K=="string"&&H.test(K)?re:null}}catch{return s}}function C(re,H,K){return!re||typeof H!="string"?!1:R(re)(H,void 0,K)}function R(re,H={}){if(!re)return u;if(typeof re=="string"||T(re)){const K=o(re,H);if(K===s)return u;const _=function(Z,$e){return!!K(Z,$e)};return K.allBasenames&&(_.allBasenames=K.allBasenames),K.allPaths&&(_.allPaths=K.allPaths),_}return N(re,H)}function T(re){const H=re;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}function j(re){return re.allBasenames||[]}function z(re){return re.allPaths||[]}function N(re,H){const K=B(Object.getOwnPropertyNames(re).map(Pe=>F(Pe,re[Pe],H)).filter(Pe=>Pe!==s)),_=K.length;if(!_)return s;if(!K.some(Pe=>!!Pe.requiresSiblings)){if(_===1)return K[0];const Pe=function(ee,be){let ue;for(let ce=0,ae=K.length;ce<ae;ce++){const le=K[ce](ee,be);if(typeof le=="string")return le;(0,O.$kh)(le)&&(ue||(ue=[]),ue.push(le))}return ue?(async()=>{for(const ce of ue){const ae=await ce;if(typeof ae=="string")return ae}return null})():null},te=K.find(ee=>!!ee.allBasenames);te&&(Pe.allBasenames=te.allBasenames);const U=K.reduce((ee,be)=>be.allPaths?ee.concat(be.allPaths):ee,[]);return U.length&&(Pe.allPaths=U),Pe}const Z=function(Pe,te,U){let ee,be;for(let ue=0,ce=K.length;ue<ce;ue++){const ae=K[ue];ae.requiresSiblings&&U&&(te||(te=(0,M.$nc)(Pe)),ee||(ee=te.substr(0,te.length-(0,M.$oc)(Pe).length)));const le=ae(Pe,te,ee,U);if(typeof le=="string")return le;(0,O.$kh)(le)&&(be||(be=[]),be.push(le))}return be?(async()=>{for(const ue of be){const ce=await ue;if(typeof ce=="string")return ce}return null})():null},$e=K.find(Pe=>!!Pe.allBasenames);$e&&(Z.allBasenames=$e.allBasenames);const oe=K.reduce((Pe,te)=>te.allPaths?Pe.concat(te.allPaths):Pe,[]);return oe.length&&(Z.allPaths=oe),Z}function F(re,H,K){if(H===!1)return s;const _=o(re,K);if(_===s)return s;if(typeof H=="boolean")return _;if(H){const Z=H.when;if(typeof Z=="string"){const $e=(oe,Pe,te,U)=>{if(!U||!_(oe,Pe))return null;const ee=Z.replace("$(basename)",()=>te),be=U(ee);return(0,O.$kh)(be)?be.then(ue=>ue?re:null):be?re:null};return $e.requiresSiblings=!0,$e}}return _}function B(re,H){const K=re.filter(Pe=>!!Pe.basenames);if(K.length<2)return re;const _=K.reduce((Pe,te)=>{const U=te.basenames;return U?Pe.concat(U):Pe},[]);let Z;if(H){Z=[];for(let Pe=0,te=_.length;Pe<te;Pe++)Z.push(H)}else Z=K.reduce((Pe,te)=>{const U=te.patterns;return U?Pe.concat(U):Pe},[]);const $e=function(Pe,te){if(typeof Pe!="string")return null;if(!te){let ee;for(ee=Pe.length;ee>0;ee--){const be=Pe.charCodeAt(ee-1);if(be===47||be===92)break}te=Pe.substr(ee)}const U=_.indexOf(te);return U!==-1?Z[U]:null};$e.basenames=_,$e.patterns=Z,$e.allBasenames=_;const oe=re.filter(Pe=>!Pe.basenames);return oe.push($e),oe}function Y(re,H){return(0,l.$ub)(re,H,(K,_)=>typeof K=="string"&&typeof _=="string"?K===_:typeof K!="string"&&typeof _!="string"?K.base===_.base&&K.pattern===_.pattern:!1)}}),define(ke[81],De([1,0,13,176,23,14,2]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.MarkdownStringTextNewlineStyle=void 0,e.$Wk=E,e.$Xk=I,e.$Yk=P,e.$Zk=p,e.$1k=S,e.$2k=v,e.$3k=d,e.$4k=f;var b;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,l.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=p(this.supportThemeIcons?(0,O.$Pk)(n):n).replace(/([ \t]+)/g,(c,r)=>"&nbsp;".repeat(r.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${S(i,n)}
`,this}appendLink(n,i,c){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,i){const c=new RegExp((0,A.$bf)(i),"g");return n.replace(c,(r,t)=>n.charAt(t-1)!=="\\"?`\\${r}`:r)}}e.$Vk=$;function E(a){return I(a)?!a.value:Array.isArray(a)?a.every(E):!0}function I(a){return a instanceof $?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function P(a,n){return a===n?!0:!a||!n?!1:a.value===n.value&&a.isTrusted===n.isTrusted&&a.supportThemeIcons===n.supportThemeIcons&&a.supportHtml===n.supportHtml&&(a.baseUri===n.baseUri||!!a.baseUri&&!!n.baseUri&&(0,L.$5g)(M.URI.from(a.baseUri),M.URI.from(n.baseUri)))}function p(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(a,n){const i=a.match(/^`+/gm)?.reduce((r,t)=>r.length>t.length?r:t).length??0,c=i>=3?i+1:3;return[`${"`".repeat(c)}${n}`,a,`${"`".repeat(c)}`].join(`
`)}function v(a){return a.replace(/"/g,"&quot;")}function d(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function f(a){const n=[],i=a.split("|").map(r=>r.trim());a=i[0];const c=i[1];if(c){const r=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),u=r?r[1]:"",s=t?t[1]:"",o=isFinite(parseInt(s)),h=isFinite(parseInt(u));o&&n.push(`width="${s}"`),h&&n.push(`height="${u}"`)}return{href:a,dimensions:n}}}),define(ke[103],De([1,0,19,31,16,12,23,14]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=$,e.$Iw=I,e.$Jw=p,e.$Kw=S,e.$Lw=a,e.$Mw=i,e.$Nw=c,e.$Ow=r,e.$Pw=t,e.$Qw=u;function $(o,h){const{os:g,tildify:w,relative:k}=h;if(k){const D=E(o,k,g);if(typeof D=="string")return D}let m=o.fsPath;if(g===1&&!A.$i?m=m.replace(/\//g,"\\"):g!==1&&A.$i&&(m=m.replace(/\\/g,"/")),g!==1&&w?.userHome){const D=w.userHome.fsPath;let C;o.scheme!==w.userHome.scheme&&o.path[0]===L.$gc.sep&&o.path[1]!==L.$gc.sep?C=w.userHome.with({path:o.path}).fsPath:C=m,m=p(C,D,g)}return(g===1?L.$fc:L.$gc).normalize(I(m,g===1))}function E(o,h,g){const w=g===1?L.$fc:L.$gc,k=g===3?M.$2g:M.$4g,m=h.getWorkspace(),y=(0,l.$Ob)(m.folders);if(!y)return;o.scheme!==y.uri.scheme&&o.path[0]===L.$gc.sep&&o.path[1]!==L.$gc.sep&&(o=y.uri.with({path:o.path}));const D=h.getWorkspaceFolder(o);if(!D)return;let C;if(k.isEqual(D.uri,o)?C="":C=k.relativePath(D.uri,o)??"",C&&(C=w.normalize(C)),m.folders.length>1&&!h.noPrefix){const R=D.name?D.name:k.basenameOrAuthority(D.uri);C=C?`${R} \u2022 ${C}`:R}return C}function I(o,h=A.$i){return(0,O.$Cg)(o,h)?o.charAt(0).toUpperCase()+o.slice(1):o}let P=Object.create(null);function p(o,h,g=A.OS){if(g===1||!o||!h)return o;let w=P.original===h?P.normalized:void 0;w||(w=h,A.$i&&(w=(0,O.$rg)(w)),w=`${(0,b.$hf)(w,L.$gc.sep)}${L.$gc.sep}`,P={original:h,normalized:w});let k=o;return A.$i&&(k=(0,O.$rg)(k)),(g===3?k.startsWith(w):(0,b.$Af)(k,w))?`~/${k.substr(w.length)}`:o}function S(o,h){return o.replace(/^~($|\/|\\)/,`${h}$1`)}const v="\u2026",d="\\\\",f="~";function a(o,h=L.sep){const g=new Array(o.length);let w=!1;for(let k=0;k<o.length;k++){const m=o[k];if(m===""){g[k]=`.${h}`;continue}if(!m){g[k]=m;continue}w=!0;let y="",D=m;D.indexOf(d)===0?(y=D.substr(0,D.indexOf(d)+d.length),D=D.substr(D.indexOf(d)+d.length)):D.indexOf(h)===0?(y=D.substr(0,D.indexOf(h)+h.length),D=D.substr(D.indexOf(h)+h.length)):D.indexOf(f)===0&&(y=D.substr(0,D.indexOf(f)+f.length),D=D.substr(D.indexOf(f)+f.length));const C=D.split(h);for(let R=1;w&&R<=C.length;R++)for(let T=C.length-R;w&&T>=0;T--){w=!1;let j=C.slice(T,T+R).join(h);for(let z=0;!w&&z<o.length;z++)if(z!==k&&o[z]&&o[z].indexOf(j)>-1){const N=T+R===C.length,F=T>0&&o[z].indexOf(h)>-1?h+j:j,B=o[z].endsWith(F);w=!N||B}if(!w){let z="";(C[0].endsWith(":")||y!=="")&&(T===1&&(T=0,R++,j=C[0]+h+j),T>0&&(z=C[0]+h),z=y+z),T>0&&(z=z+v+h),z=z+j,T+R<C.length&&(z=z+h+v),g[k]=z}}w&&(g[k]=m)}return g}var n;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(o,h=Object.create(null)){const g=[];let w=!1,k="";for(const m of o)if(m==="$"||w&&m==="{")k&&g.push({value:k,type:n.TEXT}),k="",w=!0;else if(m==="}"&&w){const y=h[k];if(typeof y=="string")y.length&&g.push({value:y,type:n.VARIABLE});else if(y){const D=g[g.length-1];(!D||D.type!==n.SEPARATOR)&&g.push({value:y.label,type:n.SEPARATOR})}k="",w=!1}else k+=m;return k&&!w&&g.push({value:k,type:n.TEXT}),g.filter((m,y)=>{if(m.type===n.SEPARATOR){const D=g[y-1],C=g[y+1];return[D,C].every(R=>R&&(R.type===n.VARIABLE||R.type===n.TEXT)&&R.value.length>0)}return!0}).map(m=>m.value).join("")}function c(o,h){return A.$j||h?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):o.replace(/&&|&/g,g=>g==="&"?"&&":"&")}function r(o,h){return A.$j||h?o.replace(/\(&&\w\)|&&/g,""):A.$i?o.replace(/&&|&/g,g=>g==="&"?"&&":"&"):o.replace(/&&/g,"_")}function t(o){return o.replace(/&/g,"&&")}function u(o){if(o.endsWith("]")){const h=o.lastIndexOf(" [",o.length-2);if(h!==-1){const g=s(o.substring(0,h)),w=o.substring(h);return{name:g.name+w,parentPath:g.parentPath}}}return s(o)}function s(o){const h=o.indexOf("/")!==-1?L.$gc:L.$fc,g=h.basename(o),w=h.dirname(o);return g.length?{name:g,parentPath:w}:{name:w,parentPath:""}}}),define(ke[134],De([1,0,22,2]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0,e.$Cn=b,e.$Dn=E,e.$En=I;function L(P){return P.toJSON()}class A{constructor(p){this.a=p}transformIncoming(p){const S=this.a.transformIncoming(p);return S===p?p:L(O.URI.from(S))}transformOutgoing(p){const S=this.a.transformOutgoing(p);return S===p?p:L(O.URI.from(S))}transformOutgoingURI(p){const S=this.a.transformOutgoing(p);return S===p?p:O.URI.from(S)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$An=A,e.$Bn=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function M(P,p,S){if(!P||S>200)return null;if(typeof P=="object"){if(P instanceof O.URI)return p.transformOutgoing(P);for(const v in P)if(Object.hasOwnProperty.call(P,v)){const d=M(P[v],p,S+1);d!==null&&(P[v]=d)}}return null}function b(P,p){const S=M(P,p,0);return S===null?P:S}function $(P,p,S,v){if(!P||v>200)return null;if(typeof P=="object"){if(P.$mid===1)return S?O.URI.revive(p.transformIncoming(P)):p.transformIncoming(P);if(P instanceof l.$He)return null;for(const d in P)if(Object.hasOwnProperty.call(P,d)){const f=$(P[d],p,S,v+1);f!==null&&(P[d]=f)}}return null}function E(P,p){const S=$(P,p,!1,0);return S===null?P:S}function I(P,p){const S=$(P,p,!0,0);return S===null?P:S}}),define(ke[32],De([1,0,53,64,400,7,31,77,16,12,23,2]),function(he,e,l,O,L,A,M,b,$,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=g,e.writeFileSync=k;var p;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function S(F,B=p.UNLINK,Y){if((0,M.$Bg)(F))throw new Error("rimraf - will refuse to recursively delete root");return B===p.UNLINK?d(F):v(F,Y)}async function v(F,B=(0,M.$Gg)((0,O.tmpdir)())){try{try{await l.promises.rename(F,B)}catch(Y){return Y.code==="ENOENT"?void 0:d(F)}d(B).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function d(F){return(0,L.promisify)(l.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function f(F){if((0,M.$Bg)(F))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function a(F,B){return c(await(B?n(F):(0,L.promisify)(l.readdir)(F)))}async function n(F){try{return await(0,L.promisify)(l.readdir)(F,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const B=[],Y=await a(F);for(const re of Y){let H=!1,K=!1,_=!1;try{const Z=await e.Promises.lstat((0,$.$jc)(F,re));H=Z.isFile(),K=Z.isDirectory(),_=Z.isSymbolicLink()}catch(Z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Z)}B.push({name:re,isFile:()=>H,isDirectory:()=>K,isSymbolicLink:()=>_})}return B}function i(F){return c(l.readdirSync(F))}function c(F){return F.map(B=>typeof B=="string"?E.$j?(0,b.$dm)(B):B:(B.name=E.$j?(0,b.$dm)(B.name):B.name,B))}async function r(F){const B=await a(F),Y=[];for(const re of B)await u.existsDirectory((0,$.$jc)(F,re))&&Y.push(re);return Y}function t(F,B=1e3){return new Promise(Y=>{let re=!1;const H=setInterval(()=>{re||(re=!0,l.access(F,K=>{re=!1,K&&(clearInterval(H),Y(void 0))}))},B)})}var u;(function(F){async function B(H){let K;try{if(K=await e.Promises.lstat(H),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(E.$i&&_.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(Z){if(Z.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw Z}throw _}}F.stat=B;async function Y(H){try{const{stat:K,symbolicLink:_}=await F.stat(H);return K.isFile()&&_?.dangling!==!0}catch{}return!1}F.existsFile=Y;async function re(H){try{const{stat:K,symbolicLink:_}=await F.stat(H);return K.isDirectory()&&_?.dangling!==!0}catch{}return!1}F.existsDirectory=re})(u||(e.SymlinkSupport=u={}));const s=new A.$Hh;function o(F,B,Y){return s.queueFor(P.URI.file(F),()=>{const re=m(Y);return new Promise((H,K)=>w(F,B,re,_=>_?K(_):H()))},I.$3g)}let h=!0;function g(F){h=F}function w(F,B,Y,re){if(!h)return l.writeFile(F,B,{mode:Y.mode,flag:Y.flag},re);l.open(F,Y.flag,Y.mode,(H,K)=>{if(H)return re(H);l.writeFile(K,B,_=>{if(_)return l.close(K,()=>re(_));l.fdatasync(K,Z=>(Z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Z),g(!1)),l.close(K,$e=>re($e))))})})}function k(F,B,Y){const re=m(Y);if(!h)return l.writeFileSync(F,B,{mode:re.mode,flag:re.flag});const H=l.openSync(F,re.flag,re.mode);try{l.writeFileSync(H,B);try{l.fdatasyncSync(H)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),g(!1)}}finally{l.closeSync(H)}}function m(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function y(F,B,Y=6e4){if(F!==B)try{E.$i&&typeof Y=="number"?await D(F,B,Date.now(),Y):await(0,L.promisify)(l.rename)(F,B)}catch(re){if(F.toLowerCase()!==B.toLowerCase()&&re.code==="EXDEV"||F.endsWith("."))await C(F,B,{preserveSymlinks:!1}),await S(F,p.MOVE);else throw re}}async function D(F,B,Y,re,H=0){try{return await(0,L.promisify)(l.rename)(F,B)}catch(K){if(K.code!=="EACCES"&&K.code!=="EPERM"&&K.code!=="EBUSY")throw K;if(Date.now()-Y>=re)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${K}`),K;if(H===0){let _=!1;try{const{stat:Z}=await u.stat(B);Z.isFile()||(_=!0)}catch{}if(_)throw K}return await(0,A.$zh)(Math.min(100,H*10)),D(F,B,Y,re,H+1)}}async function C(F,B,Y){return T(F,B,{root:{source:F,target:B},options:Y,handledSourcePaths:new Set})}const R=511;async function T(F,B,Y){if(Y.handledSourcePaths.has(F))return;Y.handledSourcePaths.add(F);const{stat:re,symbolicLink:H}=await u.stat(F);if(H){if(Y.options.preserveSymlinks)try{return await N(F,B,Y)}catch{}if(H.dangling)return}return re.isDirectory()?j(F,B,re.mode&R,Y):z(F,B,re.mode&R)}async function j(F,B,Y,re){await e.Promises.mkdir(B,{recursive:!0,mode:Y});const H=await a(F);for(const K of H)await T((0,$.$jc)(F,K),(0,$.$jc)(B,K),re)}async function z(F,B,Y){await e.Promises.copyFile(F,B),await e.Promises.chmod(B,Y)}async function N(F,B,Y){let re=await e.Promises.readlink(F);(0,M.$xg)(re,Y.root.source,!E.$k)&&(re=(0,$.$jc)(Y.root.target,re.substr(Y.root.source.length+1))),await e.Promises.symlink(re,B)}e.Promises=new class{get access(){return(0,L.promisify)(l.access)}get stat(){return(0,L.promisify)(l.stat)}get lstat(){return(0,L.promisify)(l.lstat)}get utimes(){return(0,L.promisify)(l.utimes)}get read(){return(F,B,Y,re,H)=>new Promise((K,_)=>{l.read(F,B,Y,re,H,(Z,$e,oe)=>Z?_(Z):K({bytesRead:$e,buffer:oe}))})}get readFile(){return(0,L.promisify)(l.readFile)}get write(){return(F,B,Y,re,H)=>new Promise((K,_)=>{l.write(F,B,Y,re,H,(Z,$e,oe)=>Z?_(Z):K({bytesWritten:$e,buffer:oe}))})}get appendFile(){return(0,L.promisify)(l.appendFile)}get fdatasync(){return(0,L.promisify)(l.fdatasync)}get truncate(){return(0,L.promisify)(l.truncate)}get copyFile(){return(0,L.promisify)(l.copyFile)}get open(){return(0,L.promisify)(l.open)}get close(){return(0,L.promisify)(l.close)}get symlink(){return(0,L.promisify)(l.symlink)}get readlink(){return(0,L.promisify)(l.readlink)}get chmod(){return(0,L.promisify)(l.chmod)}get mkdir(){return(0,L.promisify)(l.mkdir)}get unlink(){return(0,L.promisify)(l.unlink)}get rmdir(){return(0,L.promisify)(l.rmdir)}get realpath(){return(0,L.promisify)(l.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return a}get readDirsInDir(){return r}get writeFile(){return o}get rm(){return S}get rename(){return y}get copy(){return C}}}),define(ke[104],De([1,0,53,16,12,14,32]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=b,e.$9q=$,e.$0q=E,e.$$q=I;function b(p){if(L.$k)return p;const S=(0,O.$mc)(p);if(p===S)return p;const v=((0,O.$nc)(p)||p).toLowerCase();try{const f=(0,M.readdirSync)(S).filter(a=>a.toLowerCase()===v);if(f.length===1){const a=b(S);if(a)return(0,O.$jc)(a,f[0])}else if(f.length>1){const a=f.indexOf(v);if(a>=0){const n=b(S);if(n)return(0,O.$jc)(n,f[a])}}}catch{}return null}async function $(p,S){if(L.$k)return p;const v=(0,O.$mc)(p);if(p===v)return p;const d=((0,O.$nc)(p)||p).toLowerCase();try{if(S?.isCancellationRequested)return null;const a=(await M.Promises.readdir(v)).filter(n=>n.toLowerCase()===d);if(a.length===1){const n=await $(v,S);if(n)return(0,O.$jc)(n,a[0])}else if(a.length>1){const n=a.indexOf(d);if(n>=0){const i=await $(v,S);if(i)return(0,O.$jc)(i,a[n])}}}catch{}return null}async function E(p){try{return await M.Promises.realpath(p)}catch{const v=P(p);return await M.Promises.access(v,l.constants.R_OK),v}}function I(p){try{return l.realpathSync(p)}catch{const v=P(p);return l.accessSync(v,l.constants.R_OK),v}}function P(p){return(0,A.$hf)((0,O.$hc)(p),O.sep)}}),define(ke[105],De([1,0,16,12,52,102,18,32]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$qm=$,e.$rm=E,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function $(P=L.env){return P.comspec||"cmd.exe"}function E(P){let p=[],S=!1;const v=function(d){if(S){p.push(d);return}(!P.send(d,a=>{if(a&&console.error(a),S=!1,p.length>0){const n=p.slice(0);p=[],n.forEach(i=>v(i))}})||O.$i)&&(S=!0)};return{send:v}}var I;(function(P){async function p(S,v,d){if(l.$ic(S))return S;if(v===void 0&&(v=L.cwd()),l.$mc(S)!=="."||(d===void 0&&M.$$f(L.env.PATH)&&(d=L.env.PATH.split(l.$tc)),d===void 0||d.length===0))return l.$jc(v,S);async function a(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(c){c.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of d){let i;if(l.$ic(n)?i=l.$jc(n,S):i=l.$jc(v,n,S),await a(i))return i;let c=i+".com";if(await a(c)||(c=i+".exe",await a(c)))return c}return l.$jc(v,S)}P.findExecutable=p})(I||(e.win32=I={}))});var Je=this&&this.__decorate||function(he,e,l,O){var L=arguments.length,A=L<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,l):O,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(he,e,l,O);else for(var b=he.length-1;b>=0;b--)(M=he[b])&&(A=(L<3?M(A):L>3?M(e,l,A):M(e,l))||A);return L>3&&A&&Object.defineProperty(e,l,A),A};define(ke[82],De([1,0,19,7,22,21,56,13,4,3,58,14,18]),function(he,e,l,O,L,A,M,b,$,E,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.ProxyChannel=e.$gi=e.$di=e.$ci=e.$bi=e.RequestInitiator=e.$ai=e.$0h=e.$9h=void 0,e.$$h=g,e.$_h=w,e.$ei=R,e.$fi=T;var S;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(S||(S={}));function v(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(d||(d={}));function f(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var a;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(a||(a={}));function n(H){let K=0;for(let _=0;;_+=7){const Z=H.read(1);if(K|=(Z.buffer[0]&127)<<_,!(Z.buffer[0]&128))return K}}const i=s(0);function c(H,K){if(K===0){H.write(i);return}let _=0;for(let $e=K;$e!==0;$e=$e>>>7)_++;const Z=L.$He.alloc(_);for(let $e=0;K!==0;$e++)Z.buffer[$e]=K&127,K=K>>>7,K>0&&(Z.buffer[$e]|=128);H.write(Z)}class r{constructor(K){this.b=K,this.a=0}read(K){const _=this.b.slice(this.a,this.a+K);return this.a+=_.byteLength,_}}e.$9h=r;class t{constructor(){this.a=[]}get buffer(){return L.$He.concat(this.a)}write(K){this.a.push(K)}}e.$0h=t;var u;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(u||(u={}));function s(H){const K=L.$He.alloc(1);return K.writeUInt8(H,0),K}const o={Undefined:s(u.Undefined),String:s(u.String),Buffer:s(u.Buffer),VSBuffer:s(u.VSBuffer),Array:s(u.Array),Object:s(u.Object),Uint:s(u.Int)},h=typeof Buffer<"u";function g(H,K){if(typeof K>"u")H.write(o.Undefined);else if(typeof K=="string"){const _=L.$He.fromString(K);H.write(o.String),c(H,_.byteLength),H.write(_)}else if(h&&Buffer.isBuffer(K)){const _=L.$He.wrap(K);H.write(o.Buffer),c(H,_.byteLength),H.write(_)}else if(K instanceof L.$He)H.write(o.VSBuffer),c(H,K.byteLength),H.write(K);else if(Array.isArray(K)){H.write(o.Array),c(H,K.length);for(const _ of K)g(H,_)}else if(typeof K=="number"&&(K|0)===K)H.write(o.Uint),c(H,K);else{const _=L.$He.fromString(JSON.stringify(K));H.write(o.Object),c(H,_.byteLength),H.write(_)}}function w(H){switch(H.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return H.read(n(H)).toString();case u.Buffer:return H.read(n(H)).buffer;case u.VSBuffer:return H.read(n(H));case u.Array:{const _=n(H),Z=[];for(let $e=0;$e<_;$e++)Z.push(w(H));return Z}case u.Object:return JSON.parse(H.read(n(H)).toString());case u.Int:return n(H)}}class k{constructor(K,_,Z=null,$e=1e3){this.h=K,this.j=_,this.k=Z,this.l=$e,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(K,_){this.b.set(K,_),setTimeout(()=>this.w(K),0)}m(K){switch(K.type){case 200:{const _=this.o([K.type]);this.k?.logOutgoing(_,0,1,f(K.type));return}case 201:case 202:case 204:case 203:{const _=this.o([K.type,K.id],K.data);this.k?.logOutgoing(_,K.id,1,f(K.type),K.data);return}}}o(K,_=void 0){const Z=new t;return g(Z,K),g(Z,_),this.p(Z.buffer)}p(K){try{return this.h.send(K),K.byteLength}catch{return 0}}q(K){const _=new r(K),Z=w(_),$e=w(_),oe=Z[0];switch(oe){case 100:return this.k?.logIncoming(K.byteLength,Z[1],1,`${v(oe)}: ${Z[2]}.${Z[3]}`,$e),this.s({type:oe,id:Z[1],channelName:Z[2],name:Z[3],arg:$e});case 102:return this.k?.logIncoming(K.byteLength,Z[1],1,`${v(oe)}: ${Z[2]}.${Z[3]}`,$e),this.t({type:oe,id:Z[1],channelName:Z[2],name:Z[3],arg:$e});case 101:return this.k?.logIncoming(K.byteLength,Z[1],1,`${v(oe)}`),this.u({type:oe,id:Z[1]});case 103:return this.k?.logIncoming(K.byteLength,Z[1],1,`${v(oe)}`),this.u({type:oe,id:Z[1]})}}s(K){const _=this.b.get(K.channelName);if(!_){this.v(K);return}const Z=new A.$qe;let $e;try{$e=_.call(this.j,K.name,K.arg,Z.token)}catch(te){$e=Promise.reject(te)}const oe=K.id;$e.then(te=>{this.m({id:oe,data:te,type:201})},te=>{te instanceof Error?this.m({id:oe,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.m({id:oe,data:te,type:203})}).finally(()=>{Pe.dispose(),this.d.delete(K.id)});const Pe=(0,E.$Sc)(()=>Z.cancel());this.d.set(K.id,Pe)}t(K){const _=this.b.get(K.channelName);if(!_){this.v(K);return}const Z=K.id,oe=_.listen(this.j,K.name,K.arg)(Pe=>this.m({id:Z,data:Pe,type:204}));this.d.set(K.id,oe)}u(K){const _=this.d.get(K.id);_&&(_.dispose(),this.d.delete(K.id))}v(K){let _=this.g.get(K.channelName);_||(_=[],this.g.set(K.channelName,_));const Z=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.m({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);_.push({request:K,timeoutTimer:Z})}w(K){const _=this.g.get(K);if(_){for(const Z of _)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(K)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Pc)(this.d.values()),this.d.clear()}}e.$ai=k;var m;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class y{constructor(K,_=null){this.l=K,this.a=!1,this.b=a.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$fe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=_}getChannel(K){const _=this;return{call(Z,$e,oe){return _.a?Promise.reject(new b.$5):_.m(K,Z,$e,oe)},listen(Z,$e){return _.a?$.Event.None:_.o(K,Z,$e)}}}m(K,_,Z,$e=A.CancellationToken.None){const oe=this.g++,te={id:oe,type:100,channelName:K,name:_,arg:Z};if($e.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise((be,ue)=>{if($e.isCancellationRequested)return ue(new b.$5);const ce=()=>{const se=pe=>{switch(pe.type){case 201:this.f.delete(oe),be(pe.data);break;case 202:{this.f.delete(oe);const ve=new Error(pe.data.message);ve.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ve.name=pe.data.name,ue(ve);break}case 203:this.f.delete(oe),ue(pe.data);break}};this.f.set(oe,se),this.p(te)};let ae=null;this.b===a.Idle?ce():(ae=(0,O.$lh)(se=>this.u()),ae.then(()=>{ae=null,ce()}));const le=()=>{ae?(ae.cancel(),ae=null):this.p({id:oe,type:101}),ue(new b.$5)},J=$e.onCancellationRequested(le);U=(0,E.$Rc)((0,E.$Sc)(le),J),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(K,_,Z){const $e=this.g++,Pe={id:$e,type:102,channelName:K,name:_,arg:Z};let te=null;const U=new $.$fe({onWillAddFirstListener:()=>{te=(0,O.$lh)(be=>this.u()),te.then(()=>{te=null,this.d.add(U),this.p(Pe)})},onDidRemoveLastListener:()=>{te?(te.cancel(),te=null):(this.d.delete(U),this.p({id:$e,type:103}))}}),ee=be=>U.fire(be.data);return this.f.set($e,ee),U.event}p(K){switch(K.type){case 100:case 102:{const _=this.q([K.type,K.id,K.channelName,K.name],K.arg);this.j?.logOutgoing(_,K.id,0,`${v(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const _=this.q([K.type,K.id]);this.j?.logOutgoing(_,K.id,0,v(K.type));return}}}q(K,_=void 0){const Z=new t;return g(Z,K),g(Z,_),this.r(Z.buffer)}r(K){try{return this.l.send(K),K.byteLength}catch{return 0}}s(K){const _=new r(K),Z=w(_),$e=w(_),oe=Z[0];switch(oe){case 200:return this.j?.logIncoming(K.byteLength,0,0,f(oe)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(K.byteLength,Z[1],0,f(oe),$e),this.t({type:Z[0],id:Z[1],data:$e})}}t(K){if(K.type===200){this.b=a.Idle,this.k.fire();return}this.f.get(K.id)?.(K)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===a.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Pc)(this.d.values()),this.d.clear()}}e.$bi=y,Je([M.$3h],y.prototype,"onDidInitializePromise",null);class D{get connections(){const K=[];return this.f.forEach(_=>K.push(_)),K}constructor(K,_,Z){this.a=new Map,this.f=new Set,this.g=new $.$fe,this.onDidAddConnection=this.g.event,this.h=new $.$fe,this.onDidRemoveConnection=this.h.event,this.j=new E.$Tc,this.j.add(K(({protocol:$e,onDidClientDisconnect:oe})=>{const Pe=$.Event.once($e.onMessage);this.j.add(Pe(te=>{const U=new r(te),ee=w(U),be=new k($e,ee,_,Z),ue=new y($e,_);this.a.forEach((ae,le)=>be.registerChannel(le,ae));const ce={channelServer:be,channelClient:ue,ctx:ee};this.f.add(ce),this.g.fire(ce),this.j.add(oe(()=>{be.dispose(),ue.dispose(),this.f.delete(ce),this.h.fire(ce)}))}))}))}getChannel(K,_){const Z=this;return{call($e,oe,Pe){let te;if((0,p.$mg)(_)){const ee=(0,l.$3b)(Z.connections.filter(_));te=ee?Promise.resolve(ee):$.Event.toPromise($.Event.filter(Z.onDidAddConnection,_))}else te=_.routeCall(Z,$e,oe);const U=te.then(ee=>ee.channelClient.getChannel(K));return R(U).call($e,oe,Pe)},listen($e,oe){if((0,p.$mg)(_))return Z.k(K,_,$e,oe);const Pe=_.routeEvent(Z,$e,oe).then(te=>te.channelClient.getChannel(K));return R(Pe).listen($e,oe)}}}k(K,_,Z,$e){const oe=this;let Pe;const te=new $.$fe({onWillAddFirstListener:()=>{Pe=new E.$Tc;const U=new $.$le,ee=new Map,be=ce=>{const le=ce.channelClient.getChannel(K).listen(Z,$e),J=U.add(le);ee.set(ce,J)},ue=ce=>{const ae=ee.get(ce);ae&&(ae.dispose(),ee.delete(ce))};oe.connections.filter(_).forEach(be),$.Event.filter(oe.onDidAddConnection,_)(be,void 0,Pe),oe.onDidRemoveConnection(ue,void 0,Pe),U.event(te.fire,te,Pe),Pe.add(U)},onDidRemoveLastListener:()=>{Pe?.dispose(),Pe=void 0}});return te.event}registerChannel(K,_){this.a.set(K,_);for(const Z of this.f)Z.channelServer.registerChannel(K,_)}dispose(){this.j.dispose();for(const K of this.f)K.channelClient.dispose(),K.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ci=D;class C{constructor(K,_,Z=null){const $e=new t;g($e,_),K.send($e.buffer),this.a=new y(K,Z),this.d=new k(K,_,Z)}getChannel(K){return this.a.getChannel(K)}registerChannel(K,_){this.d.registerChannel(K,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.$di=C;function R(H){return{call(K,_,Z){return H.then($e=>$e.call(K,_,Z))},listen(K,_){const Z=new $.$oe;return H.then($e=>Z.input=$e.listen(K,_)),Z.event}}}function T(H){let K=!1;return{call(_,Z,$e){return K?H.call(_,Z,$e):(0,O.$zh)(0).then(()=>K=!0).then(()=>H.call(_,Z,$e))},listen(_,Z){if(K)return H.listen(_,Z);const $e=new $.$oe;return(0,O.$zh)(0).then(()=>K=!0).then(()=>$e.input=H.listen(_,Z)),$e.event}}}class j{constructor(K){this.a=K}routeCall(K){return this.b(K)}routeEvent(K){return this.b(K)}async b(K){for(const _ of K.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await $.Event.toPromise(K.onDidAddConnection),await this.b(K)}}e.$gi=j;var z;(function(H){function K(oe,Pe,te){const U=oe,ee=te&&te.disableMarshalling,be=new Map;for(const ue in U)Z(ue)&&be.set(ue,$.Event.buffer(U[ue],!0,void 0,Pe));return new class{listen(ue,ce,ae){const le=be.get(ce);if(le)return le;const J=U[ce];if(typeof J=="function"){if($e(ce))return J.call(U,ae);if(Z(ce))return be.set(ce,$.Event.buffer(U[ce],!0,void 0,Pe)),be.get(ce)}throw new b.$bb(`Event not found: ${ce}`)}call(ue,ce,ae){const le=U[ce];if(typeof le=="function"){if(!ee&&Array.isArray(ae))for(let se=0;se<ae.length;se++)ae[se]=(0,I.$8h)(ae[se]);let J=le.apply(U,ae);return J instanceof Promise||(J=Promise.resolve(J)),J}throw new b.$bb(`Method not found: ${ce}`)}}}H.fromService=K;function _(oe,Pe){const te=Pe&&Pe.disableMarshalling;return new Proxy({},{get(U,ee){if(typeof ee=="string")return Pe?.properties?.has(ee)?Pe.properties.get(ee):$e(ee)?function(be){return oe.listen(ee,be)}:Z(ee)?oe.listen(ee):async function(...be){let ue;Pe&&!(0,p.$hg)(Pe.context)?ue=[Pe.context,...be]:ue=be;const ce=await oe.call(ee,ue);return te?ce:(0,I.$8h)(ce)};throw new b.$bb(`Property not found: ${String(ee)}`)}})}H.toService=_;function Z(oe){return oe[0]==="o"&&oe[1]==="n"&&P.$yf(oe.charCodeAt(2))}function $e(oe){return/^onDynamic/.test(oe)&&P.$yf(oe.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const K=H.toString();if(K!=="[object Object]")return K}return H}function B(H){return Array.isArray(H)?H.map(F):F(H)}function Y(H,K,_,Z,$e,oe,Pe){Pe=B(Pe);const te=N[$e],U=te[Z%te.length];let ee=[`%c[${H}]%c[${String(K).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(oe)?(ee=ee.concat(Pe),ee.push(")")):ee.push(Pe),console.log.apply(console,ee)}class re{constructor(K,_){this.d=K,this.f=_,this.a=0,this.b=0}logOutgoing(K,_,Z,$e,oe){this.b+=K,Y(this.d,this.b,K,_,Z,$e,oe)}logIncoming(K,_,Z,$e,oe){this.a+=K,Y(this.f,this.a,K,_,Z,$e,oe)}}e.$hi=re}),define(ke[83],De([1,0,22,4,3,82]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.ProtocolConstants=e.$ii=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var b;(function(o){o.enableDiagnostics=!1,o.records=[];const h=new WeakMap;let g=0;function w(m,y){if(!h.has(m)){const D=String(++g);h.set(m,D)}return h.get(m)}function k(m,y,D,C){if(!o.enableDiagnostics)return;const R=w(m,y);if(C instanceof l.$He||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const T=l.$He.alloc(C.byteLength);T.set(C),o.records.push({timestamp:Date.now(),id:R,label:y,type:D,buff:T})}else o.records.push({timestamp:Date.now(),id:R,label:y,type:D,data:C})}o.traceSocketEvent=k})(b||(e.SocketDiagnostics=b={}));var $;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let E=null;function I(){return E||(E=l.$He.alloc(0)),E}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(h){this.a.push(h),this.b+=h.byteLength}read(h){return this.c(h,!0)}peek(h){return this.c(h,!1)}c(h,g){if(h===0)return I();if(h>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===h){const y=this.a[0];return g&&(this.a.shift(),this.b-=h),y}if(this.a[0].byteLength>h){const y=this.a[0].slice(0,h);return g&&(this.a[0]=this.a[0].slice(h),this.b-=h),y}const w=l.$He.alloc(h);let k=0,m=0;for(;h>0;){const y=this.a[m];if(y.byteLength>h){const D=y.slice(0,h);w.set(D,k),k+=h,g&&(this.a[m]=y.slice(h),this.b-=h),h-=h}else w.set(y,k),k+=y.byteLength,g?(this.a.shift(),this.b-=y.byteLength):m++,h-=y.byteLength}return w}}e.$ii=P;var p;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(p||(p={}));function S(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",o[o.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class d{constructor(h,g,w,k){this.type=h,this.id=g,this.ack=w,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends L.$Uc{constructor(h){super(),this.f=this.B(new O.$fe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=h,this.b=!1,this.c=new P,this.B(this.a.onData(g=>this.acceptChunk(g))),this.lastReadTime=Date.now()}acceptChunk(h){if(!(!h||h.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(h);this.c.byteLength>=this.g.readLen;){const g=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=g.readUInt32BE(9),this.g.messageType=g.readUInt8(0),this.g.id=g.readUInt32BE(1),this.g.ack=g.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const w=this.g.messageType,k=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",g),this.f.fire(new d(w,k,m,g)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class a{constructor(h){this.k=null,this.a=!1,this.b=!1,this.c=h,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(h){if(this.a)return;h.writtenTime=Date.now(),this.lastWriteTime=Date.now();const g=l.$He.alloc(13);g.writeUInt8(h.type,0),g.writeUInt32BE(h.id,1),g.writeUInt32BE(h.ack,5),g.writeUInt32BE(h.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(h.type),id:h.id,ack:h.ack,messageSize:h.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",h.data),this.j(g,h.data)}g(h,g){const w=this.f===0;return this.d.push(h,g),this.f+=h.byteLength+g.byteLength,w}h(){const h=l.$He.concat(this.d,this.f);return this.d.length=0,this.f=0,h}j(h,g){this.g(h,g)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const h=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:h.byteLength}),this.c.write(h)}}class n extends L.$Uc{constructor(h){super(),this.f=new O.$fe,this.onMessage=this.f.event,this.g=new O.$fe,this.onDidDispose=this.g.event,this.a=h,this.b=this.B(new a(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(g=>{g.type===1&&this.f.fire(g.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(h){this.b.write(new d(1,0,0,h))}}e.$ji=n;class i extends A.$di{static fromSocket(h,g){return new i(new n(h),g)}get onDidDispose(){return this.b.onDidDispose}constructor(h,g,w=null){super(h,g,w),this.b=h}dispose(){super.dispose();const h=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),h.end()}}e.$ki=i;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$fe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(h){this.b?this.d.length>0?this.d.push(h):this.a.fire(h):this.d.push(h)}flushBuffer(){this.d=[]}}e.$li=c;class r{constructor(h){this.data=h,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let h=0,g=this.a;for(;g;)g=g.next,h++;return h}peek(){return this.a?this.a.data:null}toArray(){const h=[];let g=0,w=this.a;for(;w;)h[g++]=w.data,w=w.next;return h}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(h){const g=new r(h);if(!this.a){this.a=g,this.b=g;return}this.b.next=g,this.b=g}}class u{static{this.a=10}static{this.b=null}static getInstance(){return u.b||(u.b=new u),u.b}constructor(){this.c=[];const h=Date.now();for(let g=0;g<u.a;g++)this.c[g]=h-1e3*g;setInterval(()=>{for(let g=u.a;g>=1;g--)this.c[g]=this.c[g-1];this.c[0]=Date.now()},1e3)}d(){const h=Date.now(),g=(1+u.a)*1e3;let w=0;for(let k=0;k<u.a;k++)h-this.c[k]<=g&&w++;return 1-w/u.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(h){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=h.loadEstimator??u.getInstance(),this.t=h.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=h.socket,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),h.initialChunk&&this.q.acceptChunk(h.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const h=new d(5,0,0,I());this.p.write(h),this.p.flush()}sendPause(){const h=new d(7,0,0,I());this.p.write(h)}sendResume(){const h=new d(8,0,0,I());this.p.write(h)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(h,g){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=h,this.p=this.r.add(new a(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(w=>this.z(w))),this.r.add(this.o.onClose(w=>this.x.fire(w))),this.q.acceptChunk(g)}endAcceptReconnection(){this.a=!1,this.h=this.g;const h=new d(3,0,this.h,I());this.p.write(h);const g=this.b.toArray();for(let w=0,k=g.length;w<k;w++)this.p.write(g[w]);this.B()}acceptDisconnect(){this.w.fire()}z(h){if(h.ack>this.d){this.d=h.ack;do{const g=this.b.peek();if(g&&g.id<=h.ack)this.b.pop();else break}while(!0)}switch(h.type){case 0:break;case 1:{if(h.id>this.g)if(h.id!==this.g+1){const g=Date.now();g-this.m>1e4&&(this.m=g,this.p.write(new d(6,0,0,I())))}else this.g=h.id,this.j=Date.now(),this.A(),this.v.fire(h.data);break}case 2:{this.u.fire(h.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const g=this.b.toArray();for(let w=0,k=g.length;w<k;w++)this.p.write(g[w]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(h){const g=++this.c;this.h=this.g;const w=new d(1,g,this.h,h);this.b.push(w),this.a||(this.p.write(w),this.B())}sendControl(h){const g=new d(2,0,0,h);this.p.write(g)}A(){if(this.g<=this.h||this.k)return;const h=Date.now()-this.j;if(h>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-h+5)}B(){if(this.c<=this.d||this.f||this.a)return;const h=this.b.peek(),g=Date.now()-h.writtenTime,w=Date.now()-this.q.lastReadTime,k=Date.now()-this.n;if(g>=2e4&&w>=2e4&&k>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:g,timeSinceLastReceivedSomeData:w});return}const m=Math.max(2e4-g,2e4-w,2e4-k,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const h=new d(3,0,this.h,I());this.p.write(h)}D(){this.h=this.g;const h=new d(9,0,this.h,I());this.p.write(h)}}e.$mi=s}),define(ke[199],De([1,0,54,7,22,21,197,13,4,3,24,105,102,82]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;class v extends S.$ai{constructor(a){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",n=>L.$He.wrap(Buffer.from(n,"base64")))},a),process.once("disconnect",()=>this.dispose())}}e.$4q=v;class d{constructor(a,n){this.i=a,this.j=n,this.c=new Set,this.g=new Map,this.h=new $.$fe,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new O.$vh(i),this.d=null,this.f=null}getChannel(a){const n=this;return{call(i,c,r){return n.k(a,i,c,r)},listen(i,c){return n.l(a,i,c)}}}k(a,n,i,c=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const r=this.n(a),t=(0,O.$lh)(o=>r.call(n,i,o)),u=c.onCancellationRequested(()=>t.cancel()),s=(0,E.$Sc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{u.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(a,n,i){if(!this.b)return $.Event.None;this.b.cancel();let c;const r=new $.$fe({onWillAddFirstListener:()=>{c=this.n(a).listen(n,i)(r.fire,r),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return r.event}get m(){if(!this.f){const a=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,I.$5n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(g=>!/^--inspect(-brk)?=/.test(g)).filter(g=>!g.startsWith("--vscode-"))),(0,p.$pm)(n.env),this.d=(0,l.fork)(this.i,a,n);const i=new $.$fe,r=$.Event.fromNodeEventEmitter(this.d,"message",g=>g)(g=>{if((0,M.$Zq)(g)){(0,M.log)(g,`IPC Library: ${this.j.serverName}`);return}i.fire(L.$He.wrap(Buffer.from(g,"base64")))}),t=this.j.useQueue?(0,P.$rm)(this.d):this.d,u=g=>this.d&&this.d.connected&&t.send(g.buffer.toString("base64")),s=i.event,o={send:u,onMessage:s};this.f=new S.$bi(o);const h=()=>this.o();process.once("exit",h),this.d.on("error",g=>console.warn('IPC "'+this.j.serverName+'" errored with '+g)),this.d.on("exit",(g,w)=>{process.removeListener("exit",h),r.dispose(),this.c.forEach(k=>(0,E.$Pc)(k)),this.c.clear(),g!==0&&w!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+g+" and signal "+w),this.b?.cancel(),this.o(),this.h.fire({code:g,signal:w})})}return this.f}n(a){let n=this.g.get(a);return n||(n=this.m.getChannel(a),this.g.set(a,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$5q=d}),define(ke[200],De([1,0,7,4,3,58,18]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.StorageState=e.StorageHint=void 0,e.$Zp=$;var b;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(p){const S=p;return S?.changed instanceof Map||S?.deleted instanceof Set}var E;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(E||(e.StorageState=E={}));class I extends L.$Uc{static{this.a=100}constructor(S,v=Object.create(null)){super(),this.r=S,this.s=v,this.b=this.B(new O.$ie),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new l.$wh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((v,d)=>this.w(d,v)),S.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(S,v){if(this.c===E.Closed)return;let d=!1;(0,M.$hg)(v)?d=this.f.delete(S):this.f.get(S)!==v&&(this.f.set(S,v),d=!0),d&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,v){const d=this.f.get(S);return(0,M.$hg)(d)?v:d}getBoolean(S,v){const d=this.get(S);return(0,M.$hg)(d)?v:d==="true"}getNumber(S,v){const d=this.get(S);return(0,M.$hg)(d)?v:parseInt(d,10)}getObject(S,v){const d=this.get(S);return(0,M.$hg)(d)?v:(0,A.$7h)(d)}async set(S,v,d=!1){if(this.c===E.Closed)return;if((0,M.$hg)(v))return this.delete(S,d);const f=(0,M.$ag)(v)||Array.isArray(v)?(0,A.$6h)(v):String(v);if(this.f.get(S)!==f)return this.f.set(S,f),this.j.set(S,f),this.h.delete(S),this.b.fire({key:S,external:d}),this.D()}async delete(S,v=!1){if(!(this.c===E.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:v}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(!(this.c===E.Closed||this.m))return this.D(S)}async D(S){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$1p=I;class P{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((v,d)=>this.a.set(d,v)),S.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$2p=P}),define(ke[201],De([1,0,14,12,22]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=void 0,e.$Xt=I,e.$Yt=P;let A;function M(){return A||(A=new TextDecoder("UTF-16LE")),A}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let E;function I(){return E||(E=O.$D()?M():$()),E}function P(v,d,f){const a=new Uint16Array(v.buffer,d,f);return f>0&&(a[0]===65279||a[0]===65534)?p(v,d,f):M().decode(a)}function p(v,d,f){const a=[];let n=0;for(let i=0;i<f;i++){const c=L.$Je(v,d);d+=2,a[n++]=String.fromCharCode(c)}return a.join("")}class S{constructor(d){this.a=d|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const d=new Uint16Array(this.b.buffer,0,this.d);return I().decode(d)}f(){const d=this.e();this.d=0,this.c===null?this.c=[d]:this.c[this.c.length]=d}appendCharCode(d){const f=this.a-this.d;f<=1&&(f===0||l.$Df(d))&&this.f(),this.b[this.d++]=d}appendASCIICharCode(d){this.d===this.a&&this.f(),this.b[this.d++]=d}appendString(d){const f=d.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=d;return}for(let a=0;a<f;a++)this.b[this.d++]=d.charCodeAt(a)}}e.$Zt=S}),define(ke[202],De([1,0,22,201]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1t=void 0,e.$2t=M;function L($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,I,P,p){this.oldPosition=E,this.oldText=I,this.newPosition=P,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,I,P){const p=I.length;l.$Me(E,p,P),P+=4;for(let S=0;S<p;S++)l.$Ke(E,I.charCodeAt(S),P),P+=2;return P}static d(E,I){const P=l.$Le(E,I);return I+=4,(0,O.$Yt)(E,I,P)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(E,I){return l.$Me(E,this.oldPosition,I),I+=4,l.$Me(E,this.newPosition,I),I+=4,I=A.c(E,this.oldText,I),I=A.c(E,this.newText,I),I}static read(E,I,P){const p=l.$Le(E,I);I+=4;const S=l.$Le(E,I);I+=4;const v=A.d(E,I);I+=A.a(v);const d=A.d(E,I);return I+=A.a(d),P.push(new A(p,v,S,d)),I}}e.$1t=A;function M($,E){return $===null||$.length===0?E:new b($,E).compress()}class b{constructor(E,I){this.a=E,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,I=0,P=this.n(E),p=this.l(I);for(;E<this.f||I<this.h;){if(P===null){this.k(p),p=this.l(++I);continue}if(p===null){this.m(P),P=this.n(++E);continue}if(p.oldEnd<=P.newPosition){this.k(p),p=this.l(++I);continue}if(P.newEnd<=p.oldPosition){this.m(P),P=this.n(++E);continue}if(p.oldPosition<P.newPosition){const[a,n]=b.r(p,P.newPosition-p.oldPosition);this.k(a),p=n;continue}if(P.newPosition<p.oldPosition){const[a,n]=b.q(P,p.oldPosition-P.newPosition);this.m(a),P=n;continue}let d,f;if(p.oldEnd===P.newEnd)d=P,f=p,P=this.n(++E),p=this.l(++I);else if(p.oldEnd<P.newEnd){const[a,n]=b.q(P,p.oldLength);d=a,f=p,P=n,p=this.l(++I)}else{const[a,n]=b.r(p,P.newLength);d=P,f=a,P=this.n(++E),p=n}this.d[this.e++]=new A(d.oldPosition,d.oldText,f.newPosition,f.newText),this.g+=d.newLength-d.oldLength,this.j+=f.newLength-f.oldLength}const S=b.s(this.d);return b.t(S)}k(E){this.d[this.e++]=b.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=b.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,I){return new A(I.oldPosition-E,I.oldText,I.newPosition,I.newText)}static p(E,I){return new A(I.oldPosition,I.oldText,I.newPosition+E,I.newText)}static q(E,I){const P=E.newText.substr(0,I),p=E.newText.substr(I);return[new A(E.oldPosition,E.oldText,E.newPosition,P),new A(E.oldEnd,"",E.newPosition+I,p)]}static r(E,I){const P=E.oldText.substr(0,I),p=E.oldText.substr(I);return[new A(E.oldPosition,P,E.newPosition,E.newText),new A(E.oldPosition+I,p,E.newEnd,"")]}static s(E){if(E.length===0)return E;const I=[];let P=0,p=E[0];for(let S=1;S<E.length;S++){const v=E[S];p.oldEnd===v.oldPosition?p=new A(p.oldPosition,p.oldText+v.oldText,p.newPosition,p.newText+v.newText):(I[P++]=p,p=v)}return I[P++]=p,I}static t(E){if(E.length===0)return E;const I=[];let P=0;for(let p=0;p<E.length;p++){const S=E[p];S.oldText!==S.newText&&(I[P++]=S)}return I}}}),define(ke[203],De([1,0,35,16]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fu=L,e.$gu=A;function L(M,b,$,E,I,P){if(Array.isArray(M)){let p=0;for(const S of M){const v=L(S,b,$,E,I,P);if(v===10)return v;v>p&&(p=v)}return p}else{if(typeof M=="string")return E?M==="*"?5:M===$?10:0:0;if(M){const{language:p,pattern:S,scheme:v,hasAccessToAllModels:d,notebookType:f}=M;if(!E&&!d)return 0;f&&I&&(b=I);let a=0;if(v)if(v===b.scheme)a=10;else if(v==="*")a=5;else return 0;if(p)if(p===$)a=10;else if(p==="*")a=Math.max(a,5);else return 0;if(f)if(f===P)a=10;else if(f==="*"&&P!==void 0)a=Math.max(a,5);else return 0;if(S){let n;if(typeof S=="string"?n=S:n={...S,base:(0,O.$hc)(S.base)},n===b.fsPath||(0,l.$rk)(n,b.fsPath))a=10;else return 0}return a}else return 0}}function A(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(A):!!M.notebookType}}),define(ke[204],De([1,0,4,14,29,80,131,179,202,3]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=void 0;class I extends E.$Uc{constructor(p,S,v,d,f,a,n){super(),this.m=this.B(new l.$fe),this.onDidChangeContent=this.m.event,this.f=S,this.j=!a,this.g=d,this.h=f,this.c=new M.$4C(p,v,n)}equals(p){return!(p instanceof I)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,S){return this.c.getOffsetAt(p,S)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,S){const v=p+S,d=this.getPositionAt(p),f=this.getPositionAt(v);return new L.$yt(d.lineNumber,d.column,f.lineNumber,f.column)}getValueInRange(p,S=0){if(p.isEmpty())return"";const v=this.n(S);return this.c.getValueInRange(p,v)}getValueLengthInRange(p,S=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const v=this.getOffsetAt(p.startLineNumber,p.startColumn),d=this.getOffsetAt(p.endLineNumber,p.endColumn);let f=0;const a=this.n(S),n=this.getEOL();if(a.length!==n.length){const i=a.length-n.length,c=p.endLineNumber-p.startLineNumber;f=i*c}return d-v+f}getCharacterCountInRange(p,S=0){if(this.j){let v=0;const d=p.startLineNumber,f=p.endLineNumber;for(let a=d;a<=f;a++){const n=this.getLineContent(a),i=a===d?p.startColumn-1:0,c=a===f?p.endColumn-1:n.length;for(let r=i;r<c;r++)O.$Df(n.charCodeAt(r))?(v=v+1,r=r+1):v=v+1}return v+=this.n(S).length*(f-d),v}return this.getValueLengthInRange(p,S)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,S){return this.c.getLineCharCode(p,S)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const S=O.$of(this.getLineContent(p));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(p){const S=O.$qf(this.getLineContent(p));return S===-1?0:S+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,S,v){let d=this.g,f=this.h,a=this.j,n=!0,i=[];for(let h=0;h<p.length;h++){const g=p[h];n&&g._isTracked&&(n=!1);const w=g.range;if(g.text){let C=!0;a||(C=!O.$Of(g.text),a=C),!d&&C&&(d=O.$Nf(g.text)),!f&&C&&(f=O.$Qf(g.text))}let k="",m=0,y=0,D=0;if(g.text){let C;[m,y,D,C]=(0,b.$iu)(g.text);const R=this.getEOL();C===0||C===(R===`\r
`?2:1)?k=g.text:k=g.text.replace(/\r\n|\r|\n/g,R)}i[h]={sortIndex:h,identifier:g.identifier||null,range:w,rangeOffset:this.getOffsetAt(w.startLineNumber,w.startColumn),rangeLength:this.getValueLengthInRange(w),text:k,eolCount:m,firstLineLength:y,lastLineLength:D,forceMoveMarkers:!!g.forceMoveMarkers,isAutoWhitespaceEdit:g.isAutoWhitespaceEdit||!1}}i.sort(I.u);let c=!1;for(let h=0,g=i.length-1;h<g;h++){const w=i[h].range.getEndPosition(),k=i[h+1].range.getStartPosition();if(k.isBeforeOrEqual(w)){if(k.isBefore(w))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(i=this.s(i));const r=v||S?I._getInverseEditRanges(i):[],t=[];if(S)for(let h=0;h<i.length;h++){const g=i[h],w=r[h];if(g.isAutoWhitespaceEdit&&g.range.isEmpty())for(let k=w.startLineNumber;k<=w.endLineNumber;k++){let m="";k===w.startLineNumber&&(m=this.getLineContent(g.range.startLineNumber),O.$of(m)!==-1)||t.push({lineNumber:k,oldContent:m})}}let u=null;if(v){let h=0;u=[];for(let g=0;g<i.length;g++){const w=i[g],k=r[g],m=this.getValueInRange(w.range),y=w.rangeOffset+h;h+=w.text.length-m.length,u[g]={sortIndex:w.sortIndex,identifier:w.identifier,range:k,text:m,textChange:new $.$1t(w.rangeOffset,m,y,w.text)}}c||u.sort((g,w)=>g.sortIndex-w.sortIndex)}this.g=d,this.h=f,this.j=a;const s=this.t(i);let o=null;if(S&&t.length>0){t.sort((h,g)=>g.lineNumber-h.lineNumber),o=[];for(let h=0,g=t.length;h<g;h++){const w=t[h].lineNumber;if(h>0&&t[h-1].lineNumber===w)continue;const k=t[h].oldContent,m=this.getLineContent(w);m.length===0||m===k||O.$of(m)!==-1||o.push(w)}}return this.m.fire(),new A.$3v(u,s,o)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let S=!1;const v=p[0].range,d=p[p.length-1].range,f=new L.$yt(v.startLineNumber,v.startColumn,d.endLineNumber,d.endColumn);let a=v.startLineNumber,n=v.startColumn;const i=[];for(let s=0,o=p.length;s<o;s++){const h=p[s],g=h.range;S=S||h.forceMoveMarkers,i.push(this.getValueInRange(new L.$yt(a,n,g.startLineNumber,g.startColumn))),h.text.length>0&&i.push(h.text),a=g.endLineNumber,n=g.endColumn}const c=i.join(""),[r,t,u]=(0,b.$iu)(c);return{sortIndex:0,identifier:p[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:c,eolCount:r,firstLineLength:t,lastLineLength:u,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(p){p.sort(I.w);const S=[];for(let v=0;v<p.length;v++){const d=p[v],f=d.range.startLineNumber,a=d.range.startColumn,n=d.range.endLineNumber,i=d.range.endColumn;if(f===n&&a===i&&d.text.length===0)continue;d.text?(this.c.delete(d.rangeOffset,d.rangeLength),this.c.insert(d.rangeOffset,d.text,!0)):this.c.delete(d.rangeOffset,d.rangeLength);const c=new L.$yt(f,a,n,i);S.push({range:c,rangeLength:d.rangeLength,text:d.text,rangeOffset:d.rangeOffset,forceMoveMarkers:d.forceMoveMarkers})}return S}findMatchesLineByLine(p,S,v,d){return this.c.findMatchesLineByLine(p,S,v,d)}getPieceTree(){return this.c}static _getInverseEditRange(p,S){const v=p.startLineNumber,d=p.startColumn,[f,a,n]=(0,b.$iu)(S);let i;if(S.length>0){const c=f+1;c===1?i=new L.$yt(v,d,v,d+a):i=new L.$yt(v,d,v+c-1,n+1)}else i=new L.$yt(v,d,v,d);return i}static _getInverseEditRanges(p){const S=[];let v=0,d=0,f=null;for(let a=0,n=p.length;a<n;a++){const i=p[a];let c,r;f?f.range.endLineNumber===i.range.startLineNumber?(c=v,r=d+(i.range.startColumn-f.range.endColumn)):(c=v+(i.range.startLineNumber-f.range.endLineNumber),r=i.range.startColumn):(c=i.range.startLineNumber,r=i.range.startColumn);let t;if(i.text.length>0){const u=i.eolCount+1;u===1?t=new L.$yt(c,r,c,r+i.firstLineLength):t=new L.$yt(c,r,c+u-1,i.lastLineLength+1)}else t=new L.$yt(c,r,c,r);v=t.endLineNumber,d=t.endColumn,S.push(t),f=i}return S}static u(p,S){const v=L.$yt.compareRangesUsingEnds(p.range,S.range);return v===0?p.sortIndex-S.sortIndex:v}static w(p,S){const v=L.$yt.compareRangesUsingEnds(p.range,S.range);return v===0?S.sortIndex-p.sortIndex:-v}}e.$5C=I}),define(ke[205],De([1,0,14,131,204]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6C=void 0;class A{constructor($,E,I,P,p,S,v,d,f){this.a=$,this.b=E,this.c=I,this.d=P,this.e=p,this.f=S,this.g=v,this.h=d,this.j=f}k($){const E=this.c+this.d+this.e,I=this.c+this.e;return E===0?$===1?`
`:`\r
`:I>E/2?`\r
`:`
`}create($){const E=this.k($),I=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let p=0,S=I.length;p<S;p++){const v=I[p].buffer.replace(/\r\n|\r|\n/g,E),d=(0,O.$ZC)(v);I[p]=new O.$3C(v,d)}const P=new L.$5C(I,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&l.$Yf($)&&(this.b=l.$Xf,$=$.substr(1));const E=$.charCodeAt($.length-1);E===13||E>=55296&&E<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=E):(this.m($,!1),this.c=!1,this.d=E)}m($,E){!E&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const E=(0,O.$1C)(this.e,$);this.a.push(new O.$3C($,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=l.$Nf($)),this.k||(this.k=l.$Qf($)))}finish($=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const E=(0,O.$ZC)($.buffer);$.lineStarts=E,this.d===13&&this.f++}}}e.$6C=M}),define(ke[135],De([1,0,22,12]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbb=$,e.$Cbb=I;var L;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(L||(L={}));function A(P){for(let p=0,S=P.length;p<S;p+=4){const v=P[p+0],d=P[p+1],f=P[p+2],a=P[p+3];P[p+0]=a,P[p+1]=f,P[p+2]=d,P[p+3]=v}}function M(P){const p=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return O.$D()||A(p),l.$He.wrap(p)}function b(P){const p=P.buffer;if(O.$D()||A(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const S=new Uint8Array(p.byteLength);return S.set(p),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function $(P){const p=new Uint32Array(E(P));let S=0;if(p[S++]=P.id,P.type==="full")p[S++]=1,p[S++]=P.data.length,p.set(P.data,S),S+=P.data.length;else{p[S++]=2,p[S++]=P.deltas.length;for(const v of P.deltas)p[S++]=v.start,p[S++]=v.deleteCount,v.data?(p[S++]=v.data.length,p.set(v.data,S),S+=v.data.length):p[S++]=0}return M(p)}function E(P){let p=0;if(p+=2,P.type==="full")p+=1+P.data.length;else{p+=1,p+=3*P.deltas.length;for(const S of P.deltas)S.data&&(p+=S.data.length)}return p}function I(P){const p=b(P);let S=0;const v=p[S++];if(p[S++]===1){const n=p[S++],i=p.subarray(S,S+n);return S+=n,{id:v,type:"full",data:i}}const f=p[S++],a=[];for(let n=0;n<f;n++){const i=p[S++],c=p[S++],r=p[S++];let t;r>0&&(t=p.subarray(S,S+r),S+=r),a[n]={start:i,deleteCount:c,data:t}}return{id:v,type:"delta",deltas:a}}}),define(ke[206],De([9,10]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(ke[136],De([1,0,19,24,12,182,130,206]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=f,e.clampedInt=n,e.clampedFloat=c,e.stringSet=u,e.cursorStyleToString=D,e.filterValidationDecorations=ve;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(ie){this.c=ie}hasChanged(ie){return this.c[ie]}}e.ConfigurationChangedEvent=E;class I{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=I;class P{constructor(ie,Ce,Ge,Le){this.id=ie,this.name=Ce,this.defaultValue=Ge,this.schema=Le}applyUpdate(ie,Ce){return S(ie,Ce)}compute(ie,Ce,Ge){return Ge}}class p{constructor(ie,Ce){this.newValue=ie,this.didChange=Ce}}e.ApplyUpdateResult=p;function S(ne,ie){if(typeof ne!="object"||typeof ie!="object"||!ne||!ie)return new p(ie,ne!==ie);if(Array.isArray(ne)||Array.isArray(ie)){const Ge=Array.isArray(ne)&&Array.isArray(ie)&&l.$ub(ne,ie);return new p(ie,!Ge)}let Ce=!1;for(const Ge in ie)if(ie.hasOwnProperty(Ge)){const Le=S(ne[Ge],ie[Ge]);Le.didChange&&(ne[Ge]=Le.newValue,Ce=!0)}return new p(ne,Ce)}class v{constructor(ie){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0}applyUpdate(ie,Ce){return S(ie,Ce)}validate(ie){return this.defaultValue}}class d{constructor(ie,Ce,Ge,Le){this.id=ie,this.name=Ce,this.defaultValue=Ge,this.schema=Le}applyUpdate(ie,Ce){return S(ie,Ce)}validate(ie){return typeof ie>"u"?this.defaultValue:ie}compute(ie,Ce,Ge){return Ge}}function f(ne,ie){return typeof ne>"u"?ie:ne==="false"?!1:!!ne}class a extends d{constructor(ie,Ce,Ge,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ge),super(ie,Ce,Ge,Le)}validate(ie){return f(ie,this.defaultValue)}}function n(ne,ie,Ce,Ge){if(typeof ne>"u")return ie;let Le=parseInt(ne,10);return isNaN(Le)?ie:(Le=Math.max(Ce,Le),Le=Math.min(Ge,Le),Le|0)}class i extends d{static clampedInt(ie,Ce,Ge,Le){return n(ie,Ce,Ge,Le)}constructor(ie,Ce,Ge,Le,st,ut=void 0){typeof ut<"u"&&(ut.type="integer",ut.default=Ge,ut.minimum=Le,ut.maximum=st),super(ie,Ce,Ge,ut),this.minimum=Le,this.maximum=st}validate(ie){return i.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}function c(ne,ie,Ce,Ge){if(typeof ne>"u")return ie;const Le=r.float(ne,ie);return r.clamp(Le,Ce,Ge)}class r extends d{static clamp(ie,Ce,Ge){return ie<Ce?Ce:ie>Ge?Ge:ie}static float(ie,Ce){if(typeof ie=="number")return ie;if(typeof ie>"u")return Ce;const Ge=parseFloat(ie);return isNaN(Ge)?Ce:Ge}constructor(ie,Ce,Ge,Le,st){typeof st<"u"&&(st.type="number",st.default=Ge),super(ie,Ce,Ge,st),this.validationFn=Le}validate(ie){return this.validationFn(r.float(ie,this.defaultValue))}}class t extends d{static string(ie,Ce){return typeof ie!="string"?Ce:ie}constructor(ie,Ce,Ge,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ge),super(ie,Ce,Ge,Le)}validate(ie){return t.string(ie,this.defaultValue)}}function u(ne,ie,Ce,Ge){return typeof ne!="string"?ie:Ge&&ne in Ge?Ge[ne]:Ce.indexOf(ne)===-1?ie:ne}class s extends d{constructor(ie,Ce,Ge,Le,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Le,st.default=Ge),super(ie,Ce,Ge,st),this.c=Le}validate(ie){return u(ie,this.defaultValue,this.c)}}class o extends P{constructor(ie,Ce,Ge,Le,st,ut,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=st,mt.default=Le),super(ie,Ce,Ge,mt),this.c=st,this.d=ut}validate(ie){return typeof ie!="string"?this.defaultValue:this.c.indexOf(ie)===-1?this.defaultValue:this.d(ie)}}function h(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Ce,Ge){return Ge===0?ie.accessibilitySupport:Ge}}class w extends P{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{insertSpace:f(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function m(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function D(ne){switch(ne){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}function C(ne){switch(ne){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class R extends v{constructor(){super(142)}compute(ie,Ce,Ge){const Le=["monaco-editor"];return Ce.get(39)&&Le.push(Ce.get(39)),ie.extraEditorClassName&&Le.push(ie.extraEditorClassName),Ce.get(74)==="default"?Le.push("mouse-default"):Ce.get(74)==="copy"&&Le.push("mouse-copy"),Ce.get(111)&&Le.push("showUnused"),Ce.get(140)&&Le.push("showDeprecated"),Le.join(" ")}}class T extends a{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ie,Ce,Ge){return Ge&&ie.emptySelectionClipboard}}class j extends P{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ie.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:b.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:b.localize(18,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{cursorMoveOnType:f(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ie.seedSearchStringFromSelection=="boolean"?ie.seedSearchStringFromSelection?"always":"never":u(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":u(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Ce.loop,this.defaultValue.loop)}}}class z extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ie){return typeof ie>"u"?this.defaultValue:typeof ie=="string"?ie==="false"||ie.length===0?z.OFF:ie==="true"?z.ON:ie:ie?z.ON:z.OFF}}e.EditorFontLigatures=z;class N extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ie){return typeof ie>"u"?this.defaultValue:typeof ie=="string"?ie==="false"?N.OFF:ie==="true"?N.TRANSLATE:ie:ie?N.TRANSLATE:N.OFF}compute(ie,Ce,Ge){return ie.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class F extends v{constructor(){super(50)}compute(ie,Ce,Ge){return ie.fontInfo}}class B extends d{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ie){const Ce=r.float(ie,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:r.clamp(Ce,6,100)}compute(ie,Ce,Ge){return ie.fontInfo.fontSize}}class Y extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(i.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class re extends P{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Ge,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Ge,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Ge,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Ge,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Ge,description:b.localize(41,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{multiple:u(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??u(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??u(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??u(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??u(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??u(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends P{constructor(){const ie={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ie.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ie.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ie.above,description:b.localize(46,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{enabled:f(Ce.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:f(Ce.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Ce.above,this.defaultValue.above)}}}var K;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(K||(e.RenderMinimap=K={}));class _ extends v{constructor(){super(145)}compute(ie,Ce,Ge){return _.computeLayout(Ce,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio,glyphMarginDecorationLaneCount:ie.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ie){const Ce=ie.height/ie.lineHeight,Ge=Math.floor(ie.paddingTop/ie.lineHeight);let Le=Math.floor(ie.paddingBottom/ie.lineHeight);ie.scrollBeyondLastLine&&(Le=Math.max(Le,Ce-1));const st=(Ge+ie.viewLineCount+Le)/(ie.pixelRatio*ie.height),ut=Math.floor(ie.viewLineCount/st);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:Le,desiredRatio:st,minimapLineCount:ut}}static c(ie,Ce){const Ge=ie.outerWidth,Le=ie.outerHeight,st=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const ut=Ce.stableMinimapLayoutInput,mt=ut&&ie.outerHeight===ut.outerHeight&&ie.lineHeight===ut.lineHeight&&ie.typicalHalfwidthCharacterWidth===ut.typicalHalfwidthCharacterWidth&&ie.pixelRatio===ut.pixelRatio&&ie.scrollBeyondLastLine===ut.scrollBeyondLastLine&&ie.paddingTop===ut.paddingTop&&ie.paddingBottom===ut.paddingBottom&&ie.minimap.enabled===ut.minimap.enabled&&ie.minimap.side===ut.minimap.side&&ie.minimap.size===ut.minimap.size&&ie.minimap.showSlider===ut.minimap.showSlider&&ie.minimap.renderCharacters===ut.minimap.renderCharacters&&ie.minimap.maxColumn===ut.minimap.maxColumn&&ie.minimap.scale===ut.minimap.scale&&ie.verticalScrollbarWidth===ut.verticalScrollbarWidth&&ie.isViewportWrapping===ut.isViewportWrapping,Ct=ie.lineHeight,Pt=ie.typicalHalfwidthCharacterWidth,Bt=ie.scrollBeyondLastLine,Ut=ie.minimap.renderCharacters;let Et=st>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const Zt=ie.minimap.maxColumn,xt=ie.minimap.size,xe=ie.minimap.side,on=ie.verticalScrollbarWidth,Xt=ie.viewLineCount,ft=ie.remainingWidth,$t=ie.isViewportWrapping,_t=Ut?2:3;let Qt=Math.floor(st*Le);const jt=Qt/st;let gt=!1,Ht=!1,en=_t*Et,Wt=Et/st,Ye=1;if(xt==="fill"||xt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:tn,extraLinesBeyondLastLine:Gt,desiredRatio:an,minimapLineCount:Nt}=_.computeContainedMinimapLineCount({viewLineCount:Xt,scrollBeyondLastLine:Bt,paddingTop:ie.paddingTop,paddingBottom:ie.paddingBottom,height:Le,lineHeight:Ct,pixelRatio:st});if(Xt/Nt>1)gt=!0,Ht=!0,Et=1,en=1,Wt=Et/st;else{let Lt=!1,It=Et+1;if(xt==="fit"){const pt=Math.ceil((tn+Xt+Gt)*en);$t&&mt&&ft<=Ce.stableFitRemainingWidth?(Lt=!0,It=Ce.stableFitMaxMinimapScale):Lt=pt>Qt}if(xt==="fill"||Lt){gt=!0;const pt=Et;en=Math.min(Ct*st,Math.max(1,Math.floor(1/an))),$t&&mt&&ft<=Ce.stableFitRemainingWidth&&(It=Ce.stableFitMaxMinimapScale),Et=Math.min(It,Math.max(1,Math.floor(en/_t))),Et>pt&&(Ye=Math.min(2,Et/pt)),Wt=Et/st/Ye,Qt=Math.ceil(Math.max(Ot,tn+Xt+Gt)*en),$t?(Ce.stableMinimapLayoutInput=ie,Ce.stableFitRemainingWidth=ft,Ce.stableFitMaxMinimapScale=Et):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const ln=Math.floor(Zt*Wt),Yt=Math.min(ln,Math.max(0,Math.floor((ft-on-2)*Wt/(Pt+Wt)))+e.MINIMAP_GUTTER_WIDTH);let qt=Math.floor(st*Yt);const wt=qt/st;qt=Math.floor(qt*Ye);const Vt=Ut?1:2,Mt=xe==="left"?0:Ge-Yt-on;return{renderMinimap:Vt,minimapLeft:Mt,minimapWidth:Yt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Ht,minimapScale:Et,minimapLineHeight:en,minimapCanvasInnerWidth:qt,minimapCanvasInnerHeight:Qt,minimapCanvasOuterWidth:wt,minimapCanvasOuterHeight:jt}}static computeLayout(ie,Ce){const Ge=Ce.outerWidth|0,Le=Ce.outerHeight|0,st=Ce.lineHeight|0,ut=Ce.lineNumbersDigitCount|0,mt=Ce.typicalHalfwidthCharacterWidth,Ct=Ce.maxDigitWidth,Pt=Ce.pixelRatio,Bt=Ce.viewLineCount,Ut=ie.get(137),Et=Ut==="inherit"?ie.get(136):Ut,Zt=Et==="inherit"?ie.get(132):Et,xt=ie.get(135),xe=Ce.isDominatedByLongLines,on=ie.get(57),Xt=ie.get(68).renderType!==0,ft=ie.get(69),$t=ie.get(105),_t=ie.get(84),Qt=ie.get(73),jt=ie.get(103),gt=jt.verticalScrollbarSize,Ht=jt.verticalHasArrows,en=jt.arrowSize,Wt=jt.horizontalScrollbarSize,Ye=ie.get(43),ln=ie.get(110)!=="never";let Yt=ie.get(66);Ye&&ln&&(Yt+=16);let qt=0;if(Xt){const cn=Math.max(ut,ft);qt=Math.round(cn*Ct)}let wt=0;on&&(wt=st*Ce.glyphMarginDecorationLaneCount);let Vt=0,Mt=Vt+wt,Ot=Mt+qt,tn=Ot+Yt;const Gt=Ge-wt-qt-Yt;let an=!1,Nt=!1,Kt=-1;Et==="inherit"&&xe?(an=!0,Nt=!0):Zt==="on"||Zt==="bounded"?Nt=!0:Zt==="wordWrapColumn"&&(Kt=xt);const Lt=_.c({outerWidth:Ge,outerHeight:Le,lineHeight:st,typicalHalfwidthCharacterWidth:mt,pixelRatio:Pt,scrollBeyondLastLine:$t,paddingTop:_t.top,paddingBottom:_t.bottom,minimap:Qt,verticalScrollbarWidth:gt,viewLineCount:Bt,remainingWidth:Gt,isViewportWrapping:Nt},Ce.memory||new I);Lt.renderMinimap!==0&&Lt.minimapLeft===0&&(Vt+=Lt.minimapWidth,Mt+=Lt.minimapWidth,Ot+=Lt.minimapWidth,tn+=Lt.minimapWidth);const It=Gt-Lt.minimapWidth,pt=Math.max(1,Math.floor((It-gt-2)/mt)),kt=Ht?en:0;return Nt&&(Kt=Math.max(1,pt),Zt==="bounded"&&(Kt=Math.min(Kt,xt))),{width:Ge,height:Le,glyphMarginLeft:Vt,glyphMarginWidth:wt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Mt,lineNumbersWidth:qt,decorationsLeft:Ot,decorationsWidth:Yt,contentLeft:tn,contentWidth:It,minimap:Lt,viewportColumn:pt,isWordWrapMinified:an,isViewportWrapping:Nt,wrappingColumn:Kt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Wt,overviewRuler:{top:kt,width:gt,height:Le-2*kt,right:0}}}}e.EditorLayoutInfoComputer=_;class Z extends P{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ie){return u(ie,"simple",["simple","advanced"])}compute(ie,Ce,Ge){return Ce.get(2)===2?"advanced":Ge}}var $e;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})($e||(e.ShowLightbulbIconMode=$e={}));class oe extends P{constructor(){const ie={enabled:$e.On};super(65,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[$e.Off,$e.OnCode,$e.On],default:ie.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:u(ie.enabled,this.defaultValue.enabled,[$e.Off,$e.OnCode,$e.On])}}}class Pe extends P{constructor(){const ie={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ie,{"editor.stickyScroll.enabled":{type:"boolean",default:ie.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ie.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ie.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ie.scrollWithEditor,description:b.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{enabled:f(Ce.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:u(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class te extends P{constructor(){const ie={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"string",default:ie.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ie.padding,description:b.localize(65,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:u(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:f(Ce.padding,this.defaultValue.padding)}}}class U extends P{constructor(){super(66,"lineDecorationsWidth",10)}validate(ie){return typeof ie=="string"&&/^\d+(\.\d+)?ch$/.test(ie)?-parseFloat(ie.substring(0,ie.length-2)):i.clampedInt(ie,this.defaultValue,0,1e3)}compute(ie,Ce,Ge){return Ge<0?i.clampedInt(-Ge*ie.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ee extends r{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>r.clamp(ie,0,150),{markdownDescription:b.localize(66,null)})}compute(ie,Ce,Ge){return ie.fontInfo.lineHeight}}class be extends P{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ie.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ie.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ie.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ie.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ie.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{enabled:f(Ce.enabled,this.defaultValue.enabled),autohide:f(Ce.autohide,this.defaultValue.autohide),size:u(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:u(Ce.side,this.defaultValue.side,["right","left"]),showSlider:u(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ce.scale,1,1,3),maxColumn:i.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:f(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:f(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:r.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function ue(ne){return ne==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class ce extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{top:i.clampedInt(Ce.top,0,0,1e3),bottom:i.clampedInt(Ce.bottom,0,0,1e3)}}}class ae extends P{constructor(){const ie={enabled:!0,cycle:!0};super(86,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:b.localize(84,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{enabled:f(Ce.enabled,this.defaultValue.enabled),cycle:f(Ce.cycle,this.defaultValue.cycle)}}}class le extends v{constructor(){super(143)}compute(ie,Ce,Ge){return ie.pixelRatio}}class J extends P{constructor(){const ie={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",ie,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:ie.strings,description:b.localize(88,null)},comments:{anyOf:Ce,default:ie.comments,description:b.localize(89,null)},other:{anyOf:Ce,default:ie.other,description:b.localize(90,null)}},default:ie,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ie}validate(ie){if(typeof ie=="boolean"){const Pt=ie?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!ie||typeof ie!="object")return this.defaultValue;const{other:Ce,comments:Ge,strings:Le}=ie,st=["on","inline","off"];let ut,mt,Ct;return typeof Ce=="boolean"?ut=Ce?"on":"off":ut=u(Ce,this.defaultValue.other,st),typeof Ge=="boolean"?mt=Ge?"on":"off":mt=u(Ge,this.defaultValue.comments,st),typeof Le=="boolean"?Ct=Le?"on":"off":Ct=u(Le,this.defaultValue.strings,st),{other:ut,comments:mt,strings:Ct}}}var se;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(se||(e.RenderLineNumbersType=se={}));class pe extends P{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(ie){let Ce=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof ie<"u"&&(typeof ie=="function"?(Ce=4,Ge=ie):ie==="interval"?Ce=3:ie==="relative"?Ce=2:ie==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Ge}}}function ve(ne){const ie=ne.get(98);return ie==="editable"?ne.get(91):ie!=="on"}class Re extends P{constructor(){const ie=[],Ce={type:"number",description:b.localize(97,null)};super(102,"rulers",ie,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:ie,description:b.localize(99,null)})}validate(ie){if(Array.isArray(ie)){const Ce=[];for(const Ge of ie)if(typeof Ge=="number")Ce.push({column:i.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Le=Ge;Ce.push({column:i.clampedInt(Le.column,0,0,1e4),color:Le.color})}return Ce.sort((Ge,Le)=>Ge.column-Le.column),Ce}return this.defaultValue}}class me extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:ie}}function Ie(ne,ie){if(typeof ne!="string")return ie;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends P{constructor(){const ie={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ie.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie,Ge=i.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=i.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ce.vertical,this.defaultValue.vertical),horizontal:Ie(Ce.horizontal,this.defaultValue.horizontal),useShadows:f(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:i.clampedInt(Ce.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:i.clampedInt(Ce.verticalSliderSize,Le,0,1e3),scrollByPage:f(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends P{constructor(){const ie={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ie,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ie.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ie.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ie.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ie.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ie.allowedLocales,description:b.localize(118,null)}})}applyUpdate(ie,Ce){let Ge=!1;Ce.allowedCharacters&&ie&&(O.$9n(ie.allowedCharacters,Ce.allowedCharacters)||(ie={...ie,allowedCharacters:Ce.allowedCharacters},Ge=!0)),Ce.allowedLocales&&ie&&(O.$9n(ie.allowedLocales,Ce.allowedLocales)||(ie={...ie,allowedLocales:Ce.allowedLocales},Ge=!0));const Le=super.applyUpdate(ie,Ce);return Ge?new p(Le.newValue,!0):Le}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{nonBasicASCII:de(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ie.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ie.allowedLocales,this.defaultValue.allowedLocales)}}c(ie,Ce){if(typeof ie!="object"||!ie)return Ce;const Ge={};for(const[Le,st]of Object.entries(ie))st===!0&&(Ge[Le]=!0);return Ge}}class q extends P{constructor(){const ie={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ie.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ie.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ie.fontFamily,description:b.localize(125,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{enabled:f(Ce.enabled,this.defaultValue.enabled),mode:u(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:u(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class W extends P{constructor(){const ie={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ie,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ie.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ie.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ie.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ie.backgroundColoring,description:b.localize(132,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{enabled:f(Ce.enabled,this.defaultValue.enabled),showToolbar:u(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:f(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:f(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class X extends P{constructor(){const ie={enabled:A.$8s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$8s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ie,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ie.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ie.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{enabled:f(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends P{constructor(){const ie={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ie,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ie.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:ie.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ie.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ie.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ie.highlightActiveIndentation,description:b.localize(148,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{bracketPairs:de(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:de(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function de(ne,ie,Ce){const Ge=Ce.indexOf(ne);return Ge===-1?ie:Ce[Ge]}class we extends P{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:ie.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:ie.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{insertMode:u(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:u(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:f(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:f(Ce.preview,this.defaultValue.preview),previewMode:u(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Ce.showMethods,this.defaultValue.showMethods),showFunctions:f(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Ce.showFields,this.defaultValue.showFields),showVariables:f(Ce.showVariables,this.defaultValue.showVariables),showClasses:f(Ce.showClasses,this.defaultValue.showClasses),showStructs:f(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:f(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Ce.showModules,this.defaultValue.showModules),showProperties:f(Ce.showProperties,this.defaultValue.showProperties),showEvents:f(Ce.showEvents,this.defaultValue.showEvents),showOperators:f(Ce.showOperators,this.defaultValue.showOperators),showUnits:f(Ce.showUnits,this.defaultValue.showUnits),showValues:f(Ce.showValues,this.defaultValue.showValues),showConstants:f(Ce.showConstants,this.defaultValue.showConstants),showEnums:f(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Ce.showKeywords,this.defaultValue.showKeywords),showWords:f(Ce.showWords,this.defaultValue.showWords),showColors:f(Ce.showColors,this.defaultValue.showColors),showFiles:f(Ce.showFiles,this.defaultValue.showFiles),showReferences:f(Ce.showReferences,this.defaultValue.showReferences),showFolders:f(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:f(Ce.showUsers,this.defaultValue.showUsers),showIssues:f(Ce.showIssues,this.defaultValue.showIssues)}}}class Te extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(ie.selectSubwords,this.defaultValue.selectSubwords)}}}class qe extends P{constructor(){const ie=[];super(130,"wordSegmenterLocales",ie,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ie){if(typeof ie=="string"&&(ie=[ie]),Array.isArray(ie)){const Ce=[];for(const Ge of ie)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&Ce.push(Ge)}catch{}return Ce}return this.defaultValue}}var Xe;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(Xe||(e.WrappingIndent=Xe={}));class tt extends P{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(ie){switch(ie){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ie,Ce,Ge){return Ce.get(2)===2?0:Ge}}class et extends v{constructor(){super(146)}compute(ie,Ce,Ge){const Le=Ce.get(145);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class nt extends P{constructor(){const ie={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ie,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ie.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{enabled:f(Ce.enabled,this.defaultValue.enabled),showDropSelector:u(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends P{constructor(){const ie={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ie,{"editor.pasteAs.enabled":{type:"boolean",default:ie.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ce=ie;return{enabled:f(Ce.enabled,this.defaultValue.enabled),showPasteSelector:u(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",Me="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?at:L.$k?Me:rt,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ye(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Ve;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=89]="quickSuggestions",ne[ne.quickSuggestionsDelay=90]="quickSuggestionsDelay",ne[ne.readOnly=91]="readOnly",ne[ne.readOnlyMessage=92]="readOnlyMessage",ne[ne.renameOnType=93]="renameOnType",ne[ne.renderControlCharacters=94]="renderControlCharacters",ne[ne.renderFinalNewline=95]="renderFinalNewline",ne[ne.renderLineHighlight=96]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=98]="renderValidationDecorations",ne[ne.renderWhitespace=99]="renderWhitespace",ne[ne.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ne[ne.roundedSelection=101]="roundedSelection",ne[ne.rulers=102]="rulers",ne[ne.scrollbar=103]="scrollbar",ne[ne.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=105]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=106]="scrollPredominantAxis",ne[ne.selectionClipboard=107]="selectionClipboard",ne[ne.selectionHighlight=108]="selectionHighlight",ne[ne.selectOnLineNumbers=109]="selectOnLineNumbers",ne[ne.showFoldingControls=110]="showFoldingControls",ne[ne.showUnused=111]="showUnused",ne[ne.snippetSuggestions=112]="snippetSuggestions",ne[ne.smartSelect=113]="smartSelect",ne[ne.smoothScrolling=114]="smoothScrolling",ne[ne.stickyScroll=115]="stickyScroll",ne[ne.stickyTabStops=116]="stickyTabStops",ne[ne.stopRenderingLineAfter=117]="stopRenderingLineAfter",ne[ne.suggest=118]="suggest",ne[ne.suggestFontSize=119]="suggestFontSize",ne[ne.suggestLineHeight=120]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ne[ne.suggestSelection=122]="suggestSelection",ne[ne.tabCompletion=123]="tabCompletion",ne[ne.tabIndex=124]="tabIndex",ne[ne.unicodeHighlighting=125]="unicodeHighlighting",ne[ne.unusualLineTerminators=126]="unusualLineTerminators",ne[ne.useShadowDOM=127]="useShadowDOM",ne[ne.useTabStops=128]="useTabStops",ne[ne.wordBreak=129]="wordBreak",ne[ne.wordSegmenterLocales=130]="wordSegmenterLocales",ne[ne.wordSeparators=131]="wordSeparators",ne[ne.wordWrap=132]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=135]="wordWrapColumn",ne[ne.wordWrapOverride1=136]="wordWrapOverride1",ne[ne.wordWrapOverride2=137]="wordWrapOverride2",ne[ne.wrappingIndent=138]="wrappingIndent",ne[ne.wrappingStrategy=139]="wrappingStrategy",ne[ne.showDeprecated=140]="showDeprecated",ne[ne.inlayHints=141]="inlayHints",ne[ne.editorClassName=142]="editorClassName",ne[ne.pixelRatio=143]="pixelRatio",ne[ne.tabFocusMode=144]="tabFocusMode",ne[ne.layoutInfo=145]="layoutInfo",ne[ne.wrappingInfo=146]="wrappingInfo",ne[ne.defaultColorDecorators=147]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Ve||(e.EditorOption=Ve={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:ye(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:ye(new g),accessibilityPageSize:ye(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:ye(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:ye(new a(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ye(new a(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:ye(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:ye(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:ye(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:ye(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:ye(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:ye(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:ye(new a(13,"automaticLayout",!1)),autoSurround:ye(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:ye(new X),bracketPairGuides:ye(new Q),stickyTabStops:ye(new a(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:ye(new a(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:ye(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:ye(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:ye(new a(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:ye(new s(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:ye(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:ye(new a(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:ye(new w),contextmenu:ye(new a(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new a(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:ye(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:ye(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:ye(new o(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:b.localize(260,null)})),cursorSurroundingLines:ye(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:ye(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:ye(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:ye(new a(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new a(33,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new a(34,"domReadOnly",!1)),dragAndDrop:ye(new a(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:ye(new T),dropIntoEditor:ye(new nt),stickyScroll:ye(new Pe),experimentalWhitespaceRendering:ye(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:ye(new t(39,"extraEditorClassName","")),fastScrollSensitivity:ye(new r(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:b.localize(271,null)})),find:ye(new j),fixedOverflowWidgets:ye(new a(42,"fixedOverflowWidgets",!1)),folding:ye(new a(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:ye(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:ye(new a(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:ye(new a(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:ye(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:ye(new a(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:ye(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:ye(new F),fontLigatures2:ye(new z),fontSize:ye(new B),fontWeight:ye(new Y),fontVariations:ye(new N),formatOnPaste:ye(new a(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:ye(new a(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:ye(new a(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:ye(new re),hideCursorInOverviewRuler:ye(new a(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:ye(new H),inDiffEditor:ye(new a(61,"inDiffEditor",!1)),letterSpacing:ye(new r(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>r.clamp(ne,-5,20),{description:b.localize(285,null)})),lightbulb:ye(new oe),lineDecorationsWidth:ye(new U),lineHeight:ye(new ee),lineNumbers:ye(new pe),lineNumbersMinChars:ye(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new a(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:ye(new a(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:ye(new s(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:ye(new be),mouseStyle:ye(new s(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new r(75,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:ye(new a(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:ye(new a(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:ye(new o(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:ye(new s(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:ye(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:ye(new s(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:ye(new a(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:ye(new i(83,"overviewRulerLanes",3,0,3)),padding:ye(new ce),pasteAs:ye(new it),parameterHints:ye(new ae),peekWidgetDefaultFocus:ye(new s(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:ye(new a(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:ye(new J),quickSuggestionsDelay:ye(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:ye(new a(91,"readOnly",!1)),readOnlyMessage:ye(new me),renameOnType:ye(new a(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:ye(new a(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:ye(new s(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:ye(new s(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:ye(new a(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:ye(new s(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new s(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:ye(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ye(new a(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:ye(new Re),scrollbar:ye(new Ae),scrollBeyondLastColumn:ye(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:ye(new a(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:ye(new a(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:ye(new a(107,"selectionClipboard",!0,{description:b.localize(325,null),included:L.$k})),selectionHighlight:ye(new a(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:ye(new a(109,"selectOnLineNumbers",!0)),showFoldingControls:ye(new s(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:ye(new a(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:ye(new a(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:ye(new te),snippetSuggestions:ye(new s(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:ye(new Te),smoothScrolling:ye(new a(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:ye(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new we),inlineSuggest:ye(new q),inlineEdit:ye(new W),inlineCompletionsAccessibilityVerbose:ye(new a(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:ye(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ye(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ye(new a(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:ye(new s(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:ye(new s(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:ye(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:ye(new ze),unusualLineTerminators:ye(new s(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:ye(new a(127,"useShadowDOM",!0)),useTabStops:ye(new a(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:ye(new s(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:ye(new qe),wordSeparators:ye(new t(131,"wordSeparators",M.$9s,{description:b.localize(359,null)})),wordWrap:ye(new s(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:ye(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:ye(new s(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new s(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ye(new R),defaultColorDecorators:ye(new a(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:ye(new le),tabFocusMode:ye(new a(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:ye(new _),wrappingInfo:ye(new et),wrappingIndent:ye(new tt),wrappingStrategy:ye(new Z)}}),define(ke[207],De([9,10]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(ke[84],De([1,0,79,2,180,29,190,207]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$zu=e.$yu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$xu=e.$wu=e.SymbolKinds=e.SymbolTag=e.$uu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$su=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$ru=e.$qu=e.$pu=void 0,e.$tu=s,e.$vu=h;class ${constructor(K,_,Z){this.offset=K,this.type=_,this.language=Z,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$pu=$;class E{constructor(K,_){this.tokens=K,this.endState=_,this._tokenizationResultBrand=void 0}}e.$qu=E;class I{constructor(K,_){this.tokens=K,this.endState=_,this._encodedTokenizationResultBrand=void 0}}e.$ru=I;var P;(function(H){H[H.Increase=0]="Increase",H[H.Decrease=1]="Decrease"})(P||(e.HoverVerbosityAction=P={}));var p;(function(H){H[H.Method=0]="Method",H[H.Function=1]="Function",H[H.Constructor=2]="Constructor",H[H.Field=3]="Field",H[H.Variable=4]="Variable",H[H.Class=5]="Class",H[H.Struct=6]="Struct",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Event=10]="Event",H[H.Operator=11]="Operator",H[H.Unit=12]="Unit",H[H.Value=13]="Value",H[H.Constant=14]="Constant",H[H.Enum=15]="Enum",H[H.EnumMember=16]="EnumMember",H[H.Keyword=17]="Keyword",H[H.Text=18]="Text",H[H.Color=19]="Color",H[H.File=20]="File",H[H.Reference=21]="Reference",H[H.Customcolor=22]="Customcolor",H[H.Folder=23]="Folder",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue",H[H.Snippet=27]="Snippet"})(p||(e.CompletionItemKind=p={}));var S;(function(H){const K=new Map;K.set(0,l.$Xj.symbolMethod),K.set(1,l.$Xj.symbolFunction),K.set(2,l.$Xj.symbolConstructor),K.set(3,l.$Xj.symbolField),K.set(4,l.$Xj.symbolVariable),K.set(5,l.$Xj.symbolClass),K.set(6,l.$Xj.symbolStruct),K.set(7,l.$Xj.symbolInterface),K.set(8,l.$Xj.symbolModule),K.set(9,l.$Xj.symbolProperty),K.set(10,l.$Xj.symbolEvent),K.set(11,l.$Xj.symbolOperator),K.set(12,l.$Xj.symbolUnit),K.set(13,l.$Xj.symbolValue),K.set(15,l.$Xj.symbolEnum),K.set(14,l.$Xj.symbolConstant),K.set(15,l.$Xj.symbolEnum),K.set(16,l.$Xj.symbolEnumMember),K.set(17,l.$Xj.symbolKeyword),K.set(27,l.$Xj.symbolSnippet),K.set(18,l.$Xj.symbolText),K.set(19,l.$Xj.symbolColor),K.set(20,l.$Xj.symbolFile),K.set(21,l.$Xj.symbolReference),K.set(22,l.$Xj.symbolCustomColor),K.set(23,l.$Xj.symbolFolder),K.set(24,l.$Xj.symbolTypeParameter),K.set(25,l.$Xj.account),K.set(26,l.$Xj.issues);function _(oe){let Pe=K.get(oe);return Pe||(console.info("No codicon found for CompletionItemKind "+oe),Pe=l.$Xj.symbolProperty),Pe}H.toIcon=_;const Z=new Map;Z.set("method",0),Z.set("function",1),Z.set("constructor",2),Z.set("field",3),Z.set("variable",4),Z.set("class",5),Z.set("struct",6),Z.set("interface",7),Z.set("module",8),Z.set("property",9),Z.set("event",10),Z.set("operator",11),Z.set("unit",12),Z.set("value",13),Z.set("constant",14),Z.set("enum",15),Z.set("enum-member",16),Z.set("enumMember",16),Z.set("keyword",17),Z.set("snippet",27),Z.set("text",18),Z.set("color",19),Z.set("file",20),Z.set("reference",21),Z.set("customcolor",22),Z.set("folder",23),Z.set("type-parameter",24),Z.set("typeParameter",24),Z.set("account",25),Z.set("issue",26);function $e(oe,Pe){let te=Z.get(oe);return typeof te>"u"&&!Pe&&(te=9),te}H.fromString=$e})(S||(e.CompletionItemKinds=S={}));var v;(function(H){H[H.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var d;(function(H){H[H.None=0]="None",H[H.KeepWhitespace=1]="KeepWhitespace",H[H.InsertAsSnippet=4]="InsertAsSnippet"})(d||(e.CompletionItemInsertTextRule=d={}));var f;(function(H){H[H.Word=0]="Word",H[H.Line=1]="Line",H[H.Suggest=2]="Suggest"})(f||(e.PartialAcceptTriggerKind=f={}));var a;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(a||(e.CompletionTriggerKind=a={}));var n;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(n||(e.InlineCompletionTriggerKind=n={}));class i{constructor(K,_,Z,$e){this.range=K,this.text=_,this.completionKind=Z,this.isSnippetText=$e}equals(K){return A.$yt.lift(this.range).equalsRange(K.range)&&this.text===K.text&&this.completionKind===K.completionKind&&this.isSnippetText===K.isSnippetText}}e.$su=i;var c;(function(H){H[H.Invoke=1]="Invoke",H[H.Auto=2]="Auto"})(c||(e.CodeActionTriggerType=c={}));var r;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var t;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var u;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(u||(e.DocumentHighlightKind=u={}));function s(H){return H&&O.URI.isUri(H.uri)&&A.$yt.isIRange(H.range)&&(A.$yt.isIRange(H.originSelectionRange)||A.$yt.isIRange(H.targetSelectionRange))}var o;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(o||(e.SymbolKind=o={})),e.$uu={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function h(H,K){return(0,b.localize)(26,null,H,e.$uu[K])}var g;(function(H){H[H.Deprecated=1]="Deprecated"})(g||(e.SymbolTag=g={}));var w;(function(H){const K=new Map;K.set(0,l.$Xj.symbolFile),K.set(1,l.$Xj.symbolModule),K.set(2,l.$Xj.symbolNamespace),K.set(3,l.$Xj.symbolPackage),K.set(4,l.$Xj.symbolClass),K.set(5,l.$Xj.symbolMethod),K.set(6,l.$Xj.symbolProperty),K.set(7,l.$Xj.symbolField),K.set(8,l.$Xj.symbolConstructor),K.set(9,l.$Xj.symbolEnum),K.set(10,l.$Xj.symbolInterface),K.set(11,l.$Xj.symbolFunction),K.set(12,l.$Xj.symbolVariable),K.set(13,l.$Xj.symbolConstant),K.set(14,l.$Xj.symbolString),K.set(15,l.$Xj.symbolNumber),K.set(16,l.$Xj.symbolBoolean),K.set(17,l.$Xj.symbolArray),K.set(18,l.$Xj.symbolObject),K.set(19,l.$Xj.symbolKey),K.set(20,l.$Xj.symbolNull),K.set(21,l.$Xj.symbolEnumMember),K.set(22,l.$Xj.symbolStruct),K.set(23,l.$Xj.symbolEvent),K.set(24,l.$Xj.symbolOperator),K.set(25,l.$Xj.symbolTypeParameter);function _(Z){let $e=K.get(Z);return $e||(console.info("No codicon found for SymbolKind "+Z),$e=l.$Xj.symbolProperty),$e}H.toIcon=_})(w||(e.SymbolKinds=w={}));class k{static asEditOperation(K){return L.$zt.replace(A.$yt.lift(K.range),K.text)}}e.$wu=k;class m{static{this.Comment=new m("comment")}static{this.Imports=new m("imports")}static{this.Region=new m("region")}static fromValue(K){switch(K){case"comment":return m.Comment;case"imports":return m.Imports;case"region":return m.Region}return new m(K)}constructor(K){this.value=K}}e.$xu=m;var y;(function(H){H[H.AIGenerated=1]="AIGenerated"})(y||(e.NewSymbolNameTag=y={}));var D;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(D||(e.NewSymbolNameTriggerKind=D={}));var C;(function(H){function K(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}H.is=K})(C||(e.Command=C={}));var R;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(R||(e.CommentThreadCollapsibleState=R={}));var T;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(T||(e.CommentThreadState=T={}));var j;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(j||(e.CommentThreadApplicability=j={}));var z;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(z||(e.CommentMode=z={}));var N;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(N||(e.CommentState=N={}));var F;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class B{constructor(K){this.b=K,this.a=null}dispose(){this.a&&this.a.then(K=>{K&&K.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$yu=B,e.$zu=new M.$hu;var Y;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Y||(e.ExternalUriOpenerPriority=Y={}));var re;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(re||(e.InlineEditTriggerKind=re={}))}),define(ke[208],De([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[209],De([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[210],De([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(ke[211],De([9,10]),function(he,e){return he.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[212],De([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[213],De([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[214],De([9,10]),function(he,e){return he.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[215],De([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(ke[216],De([9,10]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(ke[217],De([9,10]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[218],De([9,10]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(ke[219],De([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(ke[220],De([9,10]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(ke[221],De([9,10]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[222],De([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[223],De([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(ke[224],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[225],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[226],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[227],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[228],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[229],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[230],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[231],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[232],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[233],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[234],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[235],De([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[236],De([9,10]),function(he,e){return he.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[237],De([9,10]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(ke[238],De([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(ke[239],De([9,10]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(ke[240],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[241],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[242],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[243],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[244],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[245],De([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[246],De([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[247],De([9,10]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[248],De([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[249],De([9,10]),function(he,e){return he.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[250],De([9,10]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[251],De([1,0,13,210]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var L;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(L||(e.TokenType=L={}));function A(...E){switch(E.length){case 1:return(0,O.localize)(0,null,E[0]);case 2:return(0,O.localize)(1,null,E[0],E[1]);case 3:return(0,O.localize)(2,null,E[0],E[1],E[2]);default:return}}const M=(0,O.localize)(3,null),b=(0,O.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(I){switch(I.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return I.isTripleEq?"===":"==";case 4:return I.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return I.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return I.lexeme;case 18:return I.lexeme;case 19:return I.lexeme;case 20:return"EOF";default:throw(0,l.$8)(`unhandled token type: ${JSON.stringify(I)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(I=>I.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(I){return this.c=I,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(I){return this.r()||this.c.charCodeAt(this.e)!==I?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(I){this.f.push({type:I,offset:this.d})}l(I){const P=this.d,p=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:p};this.g.push({offset:P,lexeme:p,additionalInfo:I}),this.f.push(S)}n(){this.m.lastIndex=this.d;const I=this.m.exec(this.c);if(I){this.e=this.d+I[0].length;const P=this.c.substring(this.d,this.e),p=$.b.get(P);p?this.k(p):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let I=this.e,P=!1,p=!1;for(;;){if(I>=this.c.length){this.e=I,this.l(b);return}const v=this.c.charCodeAt(I);if(P)P=!1;else if(v===47&&!p){I++;break}else v===91?p=!0:v===92?P=!0:v===93&&(p=!1);I++}for(;I<this.c.length&&$.a.has(this.c.charCodeAt(I));)I++;this.e=I;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=$}),define(ke[252],De([1,0,23,41,213,401]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=$,e.$Lp=E,e.$Mp=I,e.$Np=P,e.$Op=p,e.$Pp=S,e.$Qp=v;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(a){return a=a.trim(),a==="*"||M.test(a)}function E(a){if(!$(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=a.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function I(a){if(!a)return null;const n=a.majorBase,i=a.majorMustEqual,c=a.minorBase;let r=a.minorMustEqual;const t=a.patchBase;let u=a.patchMustEqual;a.hasCaret&&(n===0||(r=!1),u=!1);let s=0;if(a.preRelease){const o=b.exec(a.preRelease);if(o){const[,h,g,w]=o;s=Date.UTC(Number(h),Number(g)-1,Number(w))}}return{majorBase:n,majorMustEqual:i,minorBase:c,minorMustEqual:r,patchBase:t,patchMustEqual:u,isMinimum:a.hasGreaterEquals,notBefore:s}}function P(a,n,i){let c;typeof a=="string"?c=I(E(a)):c=a;let r;n instanceof Date?r=n.getTime():typeof n=="string"&&(r=new Date(n).getTime());let t;if(typeof i=="string"?t=I(E(i)):t=i,!c||!t)return!1;const u=c.majorBase,s=c.minorBase,o=c.patchBase;let h=t.majorBase,g=t.minorBase,w=t.patchBase;const k=t.notBefore;let m=t.majorMustEqual,y=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?u>h?!0:u<h?!1:s>g?!0:s<g||r&&r<k?!1:o>=w:(u===1&&h===0&&(!m||!y||!D)&&(h=1,g=0,w=0,m=!0,y=!1,D=!1),u<h?!1:u>h?!m:s<g?!1:s>g?!y:o<w?!1:o>w?!D:!(r&&r<k))}function p(a,n,i,c,r){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([O.default.Error,L.localize(0,null)]),t;if(typeof c.name!="string")return t.push([O.default.Error,L.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([O.default.Error,L.localize(2,null,"version")]),t;if(!c.engines)return t.push([O.default.Error,L.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([O.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!f(c.extensionDependencies))return t.push([O.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!f(c.activationEvents))return t.push([O.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([O.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([O.default.Warning,L.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([O.default.Error,L.localize(9,null,"main")]),t;{const o=(0,l.$_g)(i,c.main);(0,l.$6g)(o,i)||t.push([O.default.Warning,L.localize(10,null,o.path,i.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([O.default.Error,L.localize(11,null,"browser")]),t;{const o=(0,l.$_g)(i,c.browser);(0,l.$6g)(o,i)||t.push([O.default.Warning,L.localize(12,null,o.path,i.path)])}}if(!A.valid(c.version))return t.push([O.default.Error,L.localize(13,null)]),t;const u=[];if(!S(a,n,c,r,u))for(const o of u)t.push([O.default.Error,o]);return t}function S(a,n,i,c,r){return c||typeof i.main>"u"&&typeof i.browser>"u"?!0:d(a,n,i.engines.vscode,r)}function v(a,n,i){return a==="*"||d(n,i,a)}function d(a,n,i,c=[]){const r=I(E(i));if(!r)return c.push(L.localize(14,null,i)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return c.push(L.localize(15,null,i)),!1}else if(!r.majorMustEqual)return c.push(L.localize(16,null,i)),!1;return P(a,n,r)?!0:(c.push(L.localize(17,null,a,i)),!1)}function f(a){if(!Array.isArray(a))return!1;for(let n=0,i=a.length;n<i;n++)if(typeof a[n]!="string")return!1;return!0}}),define(ke[106],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class l{constructor(L,A=[],M=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=M}}e.$vi=l}),define(ke[85],De([1,0,106]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Bs=A,e.$Cs=M;const O=[];var L;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(b,$,E){$ instanceof l.$vi||($=new l.$vi($,[],!!E)),O.push([b,$])}function M(){return O}}),define(ke[253],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0;class l{constructor(A,M){this.key=A,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$er=l;class O{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const M of this.a.values())M.outgoing.size===0&&A.push(M);return A}insertEdge(A,M){const b=this.lookupOrInsertNode(A),$=this.lookupOrInsertNode(M);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(A){const M=this.b(A);this.a.delete(M);for(const b of this.a.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(A){const M=this.b(A);let b=this.a.get(M);return b||(b=new l(M,A),this.a.set(M,b)),b}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[M,b]of this.a)A.push(`${M}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,M]of this.a){const b=new Set([A]),$=this.c(M,b);if($)return $}}c(A,M){for(const[b,$]of A.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const E=this.c($,M);if(E)return E;M.delete(b)}}}e.$fr=O}),define(ke[5],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e._util=void 0,e.$yi=L,e.$zi=A;var l;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b($){return $[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(l||(e._util=l={})),e.$xi=L("instantiationService");function O(M,b,$){b[l.DI_TARGET]===b?b[l.DI_DEPENDENCIES].push({id:M,index:$}):(b[l.DI_DEPENDENCIES]=[{id:M,index:$}],b[l.DI_TARGET]=b)}function L(M){if(l.serviceIds.has(M))return l.serviceIds.get(M);const b=function($,E,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(b,$,I)};return b.toString=()=>M,l.serviceIds.set(M,b),b}function A(M){return M}}),define(ke[55],De([1,0,18,2,5]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=A,e.$7i=M,e.$8i=$,e.$9i=E,e.$0i=I,e.$$i=P,e.$_i=p,e.$aj=v,e.$bj=d,e.$cj=f,e.$5i=(0,L.$yi)("configurationService");function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof O.URI)}function M(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof O.URI)}var b;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function I(a,n){const i=Object.create(null);for(const c in a)P(i,c,a[c],n);return i}function P(a,n,i,c){const r=n.split("."),t=r.pop();let u=a;for(let s=0;s<r.length;s++){const o=r[s];let h=u[o];switch(typeof h){case"undefined":h=u[o]=Object.create(null);break;case"object":if(h===null){c(`Ignoring ${n} as ${r.slice(0,s+1).join(".")} is null`);return}break;default:c(`Ignoring ${n} as ${r.slice(0,s+1).join(".")} is ${JSON.stringify(h)}`);return}u=h}if(typeof u=="object"&&u!==null)try{u[t]=i}catch{c(`Ignoring ${n} as ${r.join(".")} is ${JSON.stringify(u)}`)}else c(`Ignoring ${n} as ${r.join(".")} is ${JSON.stringify(u)}`)}function p(a,n){const i=n.split(".");S(a,i)}function S(a,n){const i=n.shift();if(n.length===0){delete a[i];return}if(Object.keys(a).indexOf(i)!==-1){const c=a[i];typeof c=="object"&&!Array.isArray(c)&&(S(c,n),Object.keys(c).length===0&&delete a[i])}}function v(a,n,i){function c(u,s){let o=u;for(const h of s){if(typeof o!="object"||o===null)return;o=o[h]}return o}const r=n.split("."),t=c(a,r);return typeof t>"u"?i:t}function d(a,n,i){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in a?l.$ag(a[c])&&l.$ag(n[c])?d(a[c],n[c],i):i&&(a[c]=n[c]):a[c]=n[c])})}function f(a){return a.replace(/[\[\]]/g,"")}}),define(ke[38],De([1,0,12,14,251,5,209,13]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=E,e.$xj=u,e.$yj=s,e.$Rj=$e;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",l.$j),$.set("isLinux",l.$k),$.set("isWindows",l.$i),$.set("isWeb",l.$o),$.set("isMacNative",l.$j&&!l.$o),$.set("isEdge",l.$H),$.set("isFirefox",l.$F),$.set("isChrome",l.$E),$.set("isSafari",l.$G);function E(te,U){if($.get(te)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(te,U)}const I=Object.prototype.hasOwnProperty;var P;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const p={regexParsingWithErrorRecovery:!0},S=(0,M.localize)(0,null),v=(0,M.localize)(1,null),d=(0,M.localize)(2,null),f=(0,M.localize)(3,null),a=(0,M.localize)(4,null),n=(0,M.localize)(5,null),i=(0,M.localize)(6,null),c=(0,M.localize)(7,null);class r{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=p){this.k=U,this.d=new L.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ee=this.l();if(!this.E()){const be=this.D(),ue=be.type===17?n:void 0;throw this.h.push({message:a,offset:be.offset,lexeme:L.$tj.getLexeme(be),additionalInfo:ue}),r.c}return ee}catch(ee){if(ee!==r.c)throw ee;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ee=this.o();U.push(ee)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ee=this.s();U.push(ee)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),h.INSTANCE;case 12:return this.z(),g.INSTANCE;case 0:{this.z();const ee=this.l();return this.A(1,f),ee?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ee=this.l();return this.A(1,f),ee}case 17:{const ee=U.lexeme;if(this.z(),this.y(9)){const ue=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ue.type!==10)throw this.B("REGEX",ue);const ce=ue.lexeme,ae=ce.lastIndexOf("/"),le=ae===ce.length-1?void 0:this.w(ce.substring(ae+1));let J;try{J=new RegExp(ce.substring(1,ae),le)}catch{throw this.B("REGEX",ue)}return F.create(ee,J)}switch(ue.type){case 10:case 19:{const ce=[ue.lexeme];this.z();let ae=this.D(),le=0;for(let Re=0;Re<ue.lexeme.length;Re++)ue.lexeme.charCodeAt(Re)===40?le++:ue.lexeme.charCodeAt(Re)===41&&le--;for(;!this.E()&&ae.type!==15&&ae.type!==16;){switch(ae.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let Re=0;Re<ae.lexeme.length;Re++)ae.lexeme.charCodeAt(Re)===40?le++:ue.lexeme.charCodeAt(Re)===41&&le--}if(le<0)break;ce.push(L.$tj.getLexeme(ae)),this.z(),ae=this.D()}const J=ce.join(""),se=J.lastIndexOf("/"),pe=se===J.length-1?void 0:this.w(J.substring(se+1));let ve;try{ve=new RegExp(J.substring(1,se),pe)}catch{throw this.B("REGEX",ue)}return t.regex(ee,ve)}case 18:{const ce=ue.lexeme;this.z();let ae=null;if(!(0,O.$9e)(ce)){const le=ce.indexOf("/"),J=ce.lastIndexOf("/");if(le!==J&&le>=0){const se=ce.slice(le+1,J),pe=ce[J+1]==="i"?"i":"";try{ae=new RegExp(se,pe)}catch{throw this.B("REGEX",ue)}}}if(ae===null)throw this.B("REGEX",ue);return F.create(ee,ae)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,d);const ue=this.u();return t.notIn(ee,ue)}switch(this.D().type){case 3:{this.z();const ue=this.u();if(this.x().type===18)return t.equals(ee,ue);switch(ue){case"true":return t.has(ee);case"false":return t.not(ee);default:return t.equals(ee,ue)}}case 4:{this.z();const ue=this.u();if(this.x().type===18)return t.notEquals(ee,ue);switch(ue){case"true":return t.not(ee);case"false":return t.has(ee);default:return t.notEquals(ee,ue)}}case 5:return this.z(),z.create(ee,this.u());case 6:return this.z(),N.create(ee,this.u());case 7:return this.z(),T.create(ee,this.u());case 8:return this.z(),j.create(ee,this.u());case 13:return this.z(),t.in(ee,this.u());default:return t.has(ee)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:c}),r.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ee){if(this.C(U))return this.z();throw this.B(ee,this.D())}B(U,ee,be){const ue=(0,M.localize)(8,null,U,L.$tj.getLexeme(ee)),ce=ee.offset,ae=L.$tj.getLexeme(ee);return this.h.push({message:ue,offset:ce,lexeme:ae,additionalInfo:be}),r.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=r;class t{static false(){return h.INSTANCE}static true(){return g.INSTANCE}static has(U){return w.create(U)}static equals(U,ee){return k.create(U,ee)}static notEquals(U,ee){return D.create(U,ee)}static regex(U,ee){return F.create(U,ee)}static in(U,ee){return m.create(U,ee)}static notIn(U,ee){return y.create(U,ee)}static not(U){return C.create(U)}static and(...U){return re.create(U,null,!0)}static or(...U){return H.create(U,null,!0)}static greater(U,ee){return T.create(U,ee)}static greaterEquals(U,ee){return j.create(U,ee)}static smaller(U,ee){return z.create(U,ee)}static smallerEquals(U,ee){return N.create(U,ee)}static{this.c=new r({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$wj=t;function u(te){const U=new r({regexParsingWithErrorRecovery:!1});return te.map(ee=>(U.parse(ee),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,M.localize)(9,null,be.additionalInfo):(0,M.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function s(te,U){const ee=te?te.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ee&&!be?!0:!ee||!be?!1:ee.equals(be)}function o(te,U){return te.cmp(U)}class h{static{this.INSTANCE=new h}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return g.INSTANCE}}e.$zj=h;class g{static{this.INSTANCE=new g}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$Aj=g;class w{static create(U,ee=null){const be=$.get(U);return typeof be=="boolean"?be?g.INSTANCE:h.INSTANCE:new w(U,ee)}constructor(U,ee){this.key=U,this.c=ee,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:_(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?g.INSTANCE:h.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Bj=w;class k{static create(U,ee,be=null){if(typeof ee=="boolean")return ee?w.create(U,be):C.create(U,be);const ue=$.get(U);return typeof ue=="boolean"?ee===(ue?"true":"false")?g.INSTANCE:h.INSTANCE:new k(U,ee,be)}constructor(U,ee,be){this.c=U,this.d=ee,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ee=U?"true":"false";return this.d===ee?g.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Cj=k;class m{static create(U,ee){return new m(U,ee)}constructor(U,ee){this.d=U,this.f=ee,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ee=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ee)?ee.includes(be):typeof be=="string"&&typeof ee=="object"&&ee!==null?I.call(ee,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$Dj=m;class y{static create(U,ee){return new y(U,ee)}constructor(U,ee){this.d=U,this.f=ee,this.type=11,this.c=m.create(U,ee)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=y;class D{static create(U,ee,be=null){if(typeof ee=="boolean")return ee?C.create(U,be):w.create(U,be);const ue=$.get(U);return typeof ue=="boolean"?ee===(ue?"true":"false")?h.INSTANCE:g.INSTANCE:new D(U,ee,be)}constructor(U,ee,be){this.c=U,this.d=ee,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ee=U?"true":"false";return this.d===ee?h.INSTANCE:g.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Fj=D;class C{static create(U,ee=null){const be=$.get(U);return typeof be=="boolean"?be?h.INSTANCE:g.INSTANCE:new C(U,ee)}constructor(U,ee){this.c=U,this.d=ee,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?h.INSTANCE:g.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Gj=C;function R(te,U){if(typeof te=="string"){const ee=parseFloat(te);isNaN(ee)||(te=ee)}return typeof te=="string"||typeof te=="number"?U(te):h.INSTANCE}class T{static create(U,ee,be=null){return R(ee,ue=>new T(U,ue,be))}constructor(U,ee,be){this.c=U,this.d=ee,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Hj=T;class j{static create(U,ee,be=null){return R(ee,ue=>new j(U,ue,be))}constructor(U,ee,be){this.c=U,this.d=ee,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Ij=j;class z{static create(U,ee,be=null){return R(ee,ue=>new z(U,ue,be))}constructor(U,ee,be){this.c=U,this.d=ee,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Jj=z;class N{static create(U,ee,be=null){return R(ee,ue=>new N(U,ue,be))}constructor(U,ee,be){this.c=U,this.d=ee,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:Z(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Kj=N;class F{static create(U,ee){return new F(U,ee)}constructor(U,ee){this.d=U,this.f=ee,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ee=this.f?this.f.source:"",be=U.f?U.f.source:"";return ee<be?-1:ee>be?1:0}equals(U){if(U.type===this.type){const ee=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ee===be}return!1}substituteConstants(){return this}evaluate(U){const ee=U.getValue(this.d);return this.f?this.f.test(ee):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Lj=F;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Mj=B;function Y(te){let U=null;for(let ee=0,be=te.length;ee<be;ee++){const ue=te[ee].substituteConstants();if(te[ee]!==ue&&U===null){U=[];for(let ce=0;ce<ee;ce++)U[ce]=te[ce]}U!==null&&(U[ee]=ue)}return U===null?te:U}class re{static create(U,ee,be){return re.d(U,ee,be)}constructor(U,ee){this.expr=U,this.c=ee,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ee=0,be=this.expr.length;ee<be;ee++){const ue=o(this.expr[ee],U.expr[ee]);if(ue!==0)return ue}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ee=0,be=this.expr.length;ee<be;ee++)if(!this.expr[ee].equals(U.expr[ee]))return!1;return!0}return!1}substituteConstants(){const U=Y(this.expr);return U===this.expr?this:re.create(U,this.c,!1)}evaluate(U){for(let ee=0,be=this.expr.length;ee<be;ee++)if(!this.expr[ee].evaluate(U))return!1;return!0}static d(U,ee,be){const ue=[];let ce=!1;for(const ae of U)if(ae){if(ae.type===1){ce=!0;continue}if(ae.type===0)return h.INSTANCE;if(ae.type===6){ue.push(...ae.expr);continue}ue.push(ae)}if(ue.length===0&&ce)return g.INSTANCE;if(ue.length!==0){if(ue.length===1)return ue[0];ue.sort(o);for(let ae=1;ae<ue.length;ae++)ue[ae-1].equals(ue[ae])&&(ue.splice(ae,1),ae--);if(ue.length===1)return ue[0];for(;ue.length>1;){const ae=ue[ue.length-1];if(ae.type!==9)break;ue.pop();const le=ue.pop(),J=ue.length===0,se=H.create(ae.expr.map(pe=>re.create([pe,le],null,be)),null,J);se&&(ue.push(se),ue.sort(o))}if(ue.length===1)return ue[0];if(be){for(let ae=0;ae<ue.length;ae++)for(let le=ae+1;le<ue.length;le++)if(ue[ae].negate().equals(ue[le]))return h.INSTANCE;if(ue.length===1)return ue[0]}return new re(ue,ee)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ee of this.expr)U.push(...ee.keys());return U}map(U){return new re(this.expr.map(ee=>ee.map(U)),null)}negate(){if(!this.c){const U=[];for(const ee of this.expr)U.push(ee.negate());this.c=H.create(U,this,!0)}return this.c}}e.$Nj=re;class H{static create(U,ee,be){return H.d(U,ee,be)}constructor(U,ee){this.expr=U,this.c=ee,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ee=0,be=this.expr.length;ee<be;ee++){const ue=o(this.expr[ee],U.expr[ee]);if(ue!==0)return ue}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ee=0,be=this.expr.length;ee<be;ee++)if(!this.expr[ee].equals(U.expr[ee]))return!1;return!0}return!1}substituteConstants(){const U=Y(this.expr);return U===this.expr?this:H.create(U,this.c,!1)}evaluate(U){for(let ee=0,be=this.expr.length;ee<be;ee++)if(this.expr[ee].evaluate(U))return!0;return!1}static d(U,ee,be){let ue=[],ce=!1;if(U){for(let ae=0,le=U.length;ae<le;ae++){const J=U[ae];if(J){if(J.type===0){ce=!0;continue}if(J.type===1)return g.INSTANCE;if(J.type===9){ue=ue.concat(J.expr);continue}ue.push(J)}}if(ue.length===0&&ce)return h.INSTANCE;ue.sort(o)}if(ue.length!==0){if(ue.length===1)return ue[0];for(let ae=1;ae<ue.length;ae++)ue[ae-1].equals(ue[ae])&&(ue.splice(ae,1),ae--);if(ue.length===1)return ue[0];if(be){for(let ae=0;ae<ue.length;ae++)for(let le=ae+1;le<ue.length;le++)if(ue[ae].negate().equals(ue[le]))return g.INSTANCE;if(ue.length===1)return ue[0]}return new H(ue,ee)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ee of this.expr)U.push(...ee.keys());return U}map(U){return new H(this.expr.map(ee=>ee.map(U)),null)}negate(){if(!this.c){const U=[];for(const ee of this.expr)U.push(ee.negate());for(;U.length>1;){const ee=U.shift(),be=U.shift(),ue=[];for(const ce of Pe(ee))for(const ae of Pe(be))ue.push(re.create([ce,ae],null,!1));U.unshift(H.create(ue,null,!1))}this.c=H.create(U,this,!0)}return this.c}}e.$Oj=H;class K extends w{static{this.d=[]}static all(){return K.d.values()}constructor(U,ee,be){super(U,null),this.f=ee,typeof be=="object"?K.d.push({...be,key:U}):be!==!0&&K.d.push({key:U,description:be,type:ee!=null?typeof ee:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return k.create(this.key,U)}notEqualsTo(U){return D.create(this.key,U)}}e.$Pj=K,e.$Qj=(0,A.$yi)("contextKeyService");function _(te,U){return te<U?-1:te>U?1:0}function Z(te,U,ee,be){return te<ee?-1:te>ee?1:U<be?-1:U>be?1:0}function $e(te,U){if(te.type===0||U.type===1)return!0;if(te.type===9)return U.type===9?oe(te.expr,U.expr):!1;if(U.type===9){for(const ee of U.expr)if($e(te,ee))return!0;return!1}if(te.type===6){if(U.type===6)return oe(U.expr,te.expr);for(const ee of te.expr)if($e(ee,U))return!0;return!1}return te.equals(U)}function oe(te,U){let ee=0,be=0;for(;ee<te.length&&be<U.length;){const ue=te[ee].cmp(U[be]);if(ue<0)return!1;ue===0&&ee++,be++}return ee===te.length}function Pe(te){return te.type===9?te.expr:[te]}}),define(ke[254],De([1,0,23,41,211,5,103,12,24]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Tw=e.$Sw=e.$Rw=void 0,e.$Uw=S,e.$Vw=v,e.$Rw=(0,A.$yi)("dialogService");var E;(function(d){d[d.Confirmation=1]="Confirmation",d[d.Prompt=2]="Prompt",d[d.Input=3]="Input"})(E||(E={}));class I{a(f){return this.d(f,E.Confirmation)}b(f){return this.d(f,E.Prompt)}c(f){return this.d(f,E.Input)}d(f,a){const n=[];switch(a){case E.Confirmation:{const i=f;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(1,null));break}case E.Prompt:{const i=f;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(c=>c.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,L.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,L.localize)(3,null))),n.length===0&&n.push((0,L.localize)(4,null));break}case E.Input:{const i=f;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(6,null));break}}return n}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===O.default.Info?"info":f===O.default.Error?"error":f===O.default.Warning?"warning":"none"}f(f,a,n){const i=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&i.push(f.cancelButton);let c=i[a]?.run({checkboxChecked:n});return c instanceof Promise||(c=Promise.resolve(c)),{result:c,checkboxChecked:n}}}e.$Sw=I,e.$Tw=(0,A.$yi)("fileDialogService");var P;(function(d){d[d.SAVE=0]="SAVE",d[d.DONT_SAVE=1]="DONT_SAVE",d[d.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const p=10;function S(d){const f=[];return f.push(...d.slice(0,p).map(a=>typeof a=="string"?a:(0,l.$9g)(a))),d.length>p&&(d.length-p===1?f.push((0,L.localize)(7,null)):f.push((0,L.localize)(8,null,d.length-p))),f.push(""),f.join(`
`)}function v(d,f){const a=(0,$.$5n)(d);let n=(a.buttons??[]).map(t=>(0,M.$Ow)(t)),i=(d.buttons||[]).map((t,u)=>u),c=0,r=a.cancelId??n.length-1;if(n.length>1){const t=typeof r=="number"?n[r]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&r!==1){n.splice(r,1),n.splice(1,0,t);const u=i[r];i.splice(r,1),i.splice(1,0,u),r=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),c=n.length-1,typeof t=="string"&&(r=c-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&r!==n.length-1){n.splice(r,1),n.push(t);const u=i[r];i.splice(r,1),i.push(u),r=n.length-1}}return a.buttons=n,a.defaultId=c,a.cancelId=r,a.noLink=!0,a.title=a.title||f.nameLong,{options:a,buttonIndeces:i}}}),define(ke[137],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,l.$yi)("environmentService"),e.$Gi=(0,l.$zi)(e.$Fi)}),define(ke[138],De([1,0,212,5]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.ExtensionManagementErrorCode=e.$$o=e.ExtensionGalleryErrorCode=e.$0o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$4o=L,e.$5o=A,e.$6o=M,e.$7o=b,e.$8o=$,e.$9o=E,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionsSync",e.$2o="dependecyOrPackExtensionInstall",e.$3o="clientTargetPlatform";function L(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(n,i){switch(n){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(n,i){return i==="web"&&!n.includes("web")}function $(n,i,c){return b(i,c)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===c}function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var I;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var P;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var p;(function(n){n.Install="install",n.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var S;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$0o=(0,O.$yi)("extensionGalleryService");var v;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed",n.DownloadFailedWriting="DownloadFailedWriting"})(v||(e.ExtensionGalleryErrorCode=v={}));class d extends Error{constructor(i,c){super(i),this.code=c,this.name=c}}e.$$o=d;var f;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.DownloadFailedWriting="DownloadFailedWriting",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.ScanningExtension="ScanningExtension",n.ReadUninstalled="ReadUninstalled",n.UnsetUninstalled="UnsetUninstalled",n.Delete="Delete",n.Rename="Rename",n.IntializeDefaultProfile="IntializeDefaultProfile",n.AddToProfile="AddToProfile",n.PostInstall="PostInstall",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));class a extends Error{constructor(i,c){super(i),this.code=c,this.name=c}}e.$_o=a,e.$ap=(0,O.$yi)("extensionManagementService"),e.$bp="extensionsIdentifiers/disabled",e.$cp="extensionsIdentifiers/enabled",e.$dp=(0,O.$yi)("IGlobalExtensionEnablementService"),e.$ep=(0,O.$yi)("IExtensionTipsService"),e.$fp=(0,l.localize2)(0,"Extensions"),e.$gp=(0,l.localize2)(1,"Preferences")}),define(ke[255],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=e.$O7b=void 0,e.$O7b=(0,l.$yi)("externalTerminal"),e.$P7b="Terminal.app"}),define(ke[256],De([1,0,54,56,15,16,12,102,32,105,214,255]),function(he,e,l,O,L,A,M,b,$,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=e.$fdc=e.$edc=void 0;const p=I.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends S{static{this.b="cmd.exe"}openTerminal(r,t){return this.spawnTerminal(l,r,E.$qm(),t)}spawnTerminal(r,t,u,s){const o=t.windowsExec||v.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const h=A.$nc(o,".exe").toLowerCase();if(h==="cmder")return r.spawn(o,s?[s]:void 0),Promise.resolve(void 0);const g=["/c","start","/wait"];return o.indexOf(" ")>=0&&g.push('""'),g.push(o),h==="wt"&&g.push("-d ."),new Promise((w,k)=>{const m=a(process),y=r.spawn(u,g,{cwd:s,env:m,detached:!0});y.on("error",k),y.on("exit",()=>w())})}async runInTerminal(r,t,u,s,o){const h="windowsExec"in o&&o.windowsExec?o.windowsExec:v.getDefaultTerminalWindows(),g=await v.f();return new Promise((w,k)=>{const m=`"${t} - ${p}"`,y=`"${u.join('" "')}" & pause`,D=Object.assign({},a(process),s);Object.keys(D).filter(z=>D[z]===null).forEach(z=>delete D[z]);const C={cwd:t,env:D,windowsVerbatimArguments:!0};let R,T;A.$nc(h,".exe")==="wt"?(R=h,T=["-d",".",v.b,"/c",y]):g?(R=g,T=["-d",".",h,"/c",y]):(R=v.b,T=["/c","start",m,"/wait",h,"/c",`"${y}"`]),l.spawn(R,T,C).on("error",z=>{k(n(z))}),w(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const r=await E.win32.findExecutable("wt");return await $.Promises.exists(r)?r:void 0}catch{return}}}e.$edc=v,Je([O.$3h],v,"f",null);class d extends S{static{this.b="/usr/bin/osascript"}openTerminal(r,t){return this.spawnTerminal(l,r,t)}runInTerminal(r,t,u,s,o){const h=o.osxExec||P.$P7b;return new Promise((g,w)=>{if(h===P.$P7b||h==="iTerm.app"){const k=h===P.$P7b?"TerminalHelper":"iTermHelper",y=[L.$Sg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",r||p,"-w",t];for(const R of u)y.push("-a"),y.push(R);if(s){const R=Object.assign({},a(process),s);for(const T in R){const j=R[T];j===null?(y.push("-u"),y.push(T)):(y.push("-e"),y.push(`${T}=${j}`))}}let D="";const C=l.spawn(d.b,y);C.on("error",R=>{w(n(R))}),C.stderr.on("data",R=>{D+=R.toString()}),C.on("exit",R=>{if(R===0)g(void 0);else if(D){const T=D.split(`
`,1);w(new Error(T[0]))}else w(new Error(I.localize(1,null,k,R)))})}else w(new Error(I.localize(2,null,h)))})}spawnTerminal(r,t,u){const s=t.osxExec||P.$P7b;return new Promise((o,h)=>{const g=["-a",s];u&&g.push(u);const w=a(process),k=r.spawn("/usr/bin/open",g,{cwd:u,env:w});k.on("error",h),k.on("exit",()=>o())})}}e.$fdc=d;class f extends S{static{this.b=I.localize(3,null)}openTerminal(r,t){return this.spawnTerminal(l,r,t)}runInTerminal(r,t,u,s,o){const h=o.linuxExec?Promise.resolve(o.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((g,w)=>{const k=[];h.then(m=>{m.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const y=`${i(u)}; echo; read -p "${f.b}" -n1;`;k.push(`''${y}''`);const D=Object.assign({},a(process),s);Object.keys(D).filter(j=>D[j]===null).forEach(j=>delete D[j]);const C={cwd:t,env:D};let R="";const T=l.spawn(m,k,C);T.on("error",j=>{w(n(j))}),T.stderr.on("data",j=>{R+=j.toString()}),T.on("exit",j=>{if(j===0)g(void 0);else if(R){const z=R.split(`
`,1);w(new Error(z[0]))}else w(new Error(I.localize(4,null,m,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!M.$k)f.d=Promise.resolve("xterm");else{const r=await $.Promises.exists("/etc/debian_version");f.d=new Promise(t=>{r?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return f.d}spawnTerminal(r,t,u){const s=t.linuxExec?Promise.resolve(t.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((o,h)=>{s.then(g=>{const w=a(process),k=r.spawn(g,[],{cwd:u,env:w});k.on("error",h),k.on("exit",()=>o())})})}}e.$gdc=f;function a(c){const r={...c.env};return(0,b.$om)(r),r}function n(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(I.localize(5,null,c.path)):c}function i(c){let r="";for(const t of c)t.indexOf(" ")>=0?r+='"'+t+'"':r+=t,r+=" ";return r}}),define(ke[33],De([1,0,78,16,14,18,2,215,5,12,15,46]),function(he,e,l,O,L,A,M,b,$,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$xl=e.FileKind=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.FileOperationResult=e.$pl=e.$ol=e.$nl=e.$ll=e.FileChangeType=e.$kl=e.FileOperation=e.$el=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$5k=void 0,e.$6k=p,e.$7k=f,e.$8k=n,e.$9k=i,e.$0k=c,e.$$k=r,e.$_k=t,e.$al=u,e.$bl=s,e.$cl=o,e.$dl=h,e.$fl=k,e.$gl=m,e.$hl=y,e.$il=D,e.$jl=C,e.$ml=N,e.$yl=K,e.$zl=_,e.$Bl=$e,e.$5k=(0,$.$yi)("fileService");function p(oe){return oe.create===!0}var S;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var v;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(v||(e.FilePermission=v={}));var d;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(d||(e.FileChangeFilter=d={}));function f(oe){const Pe=oe;return!!Pe&&typeof Pe.onDidChange=="function"}var a;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function n(oe){return!!(oe.capabilities&2)}function i(oe){return!!(oe.capabilities&8)}function c(oe){return!!(oe.capabilities&131072)}function r(oe){return!!(oe.capabilities&4)}function t(oe){return!!(oe.capabilities&16)}function u(oe){return n(oe)?!!(oe.capabilities&16384):!1}function s(oe){return n(oe)?!!(oe.capabilities&32768):!1}function o(oe){return!!(oe.capabilities&65536)}function h(oe){return!!(oe.capabilities&2048)}var g;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(g||(e.FileSystemProviderErrorCode=g={}));class w extends Error{static create(Pe,te){const U=new w(Pe.toString(),te);return y(U,te),U}constructor(Pe,te){super(Pe),this.code=te}}e.$el=w;function k(oe,Pe){return w.create(oe,Pe)}function m(oe){return oe||k((0,b.localize)(0,null),g.Unknown)}function y(oe,Pe){return oe.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",oe}function D(oe){if(!oe)return g.Unknown;if(oe instanceof w)return oe.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!Pe)return g.Unknown;switch(Pe[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}function C(oe){if(oe instanceof F)return oe.fileOperationResult;switch(D(oe)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 9;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileTooLarge:return 7;default:return 10}}var R;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class T{constructor(Pe,te,U){this.resource=Pe,this.operation=te,this.target=U}isOperation(Pe){return this.operation===Pe}}e.$kl=T;var j;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class z{static{this.a=null}constructor(Pe,te){this.c=te,this.b=void 0,this.d=new P.$V(()=>{const U=l.$Ei.forUris(()=>this.c);return U.fill(this.rawAdded.map(ee=>[ee,!0])),U}),this.f=new P.$V(()=>{const U=l.$Ei.forUris(()=>this.c);return U.fill(this.rawUpdated.map(ee=>[ee,!0])),U}),this.g=new P.$V(()=>{const U=l.$Ei.forUris(()=>this.c);return U.fill(this.rawDeleted.map(ee=>[ee,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of Pe){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==z.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(Pe,...te){return this.h(Pe,{includeChildren:!1},...te)}affects(Pe,...te){return this.h(Pe,{includeChildren:!0},...te)}h(Pe,te,...U){if(!Pe)return!1;const ee=U.length>0;return!!((!ee||U.includes(1))&&(this.d.value.get(Pe)||te.includeChildren&&this.d.value.findSuperstr(Pe))||(!ee||U.includes(0))&&(this.f.value.get(Pe)||te.includeChildren&&this.f.value.findSuperstr(Pe))||(!ee||U.includes(2))&&(this.g.value.findSubstr(Pe)||te.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$ll=z;function N(oe,Pe,te){return!oe||!Pe||oe===Pe||Pe.length>oe.length?!1:(Pe.charAt(Pe.length-1)!==O.sep&&(Pe+=O.sep),te?(0,L.$Af)(oe,Pe):oe.indexOf(Pe)===0)}class F extends Error{constructor(Pe,te,U){super(Pe),this.fileOperationResult=te,this.options=U}}e.$nl=F;class B extends F{constructor(Pe,te,U,ee){super(Pe,te,ee),this.fileOperationResult=te,this.size=U}}e.$ol=B;class Y extends F{constructor(Pe,te,U){super(Pe,2,U),this.stat=te}}e.$pl=Y;var re;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$ql={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sl="files.associations",e.$tl="files.exclude",e.$ul="files.readonlyInclude",e.$vl="files.readonlyExclude",e.$wl="files.readonlyFromPermissions";var H;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$xl="";function K(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function _(oe,Pe){if(!Pe.hasProvider(M.URI.from({scheme:oe.scheme})))return new Promise(te=>{const U=Pe.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===oe.scheme&&ee.added&&(U.dispose(),te())})})}class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize(Pe){return(0,A.$cg)(Pe)||(Pe=0),Pe<Z.KB?(0,b.localize)(1,null,Pe.toFixed(0)):Pe<Z.MB?(0,b.localize)(2,null,(Pe/Z.KB).toFixed(2)):Pe<Z.GB?(0,b.localize)(3,null,(Pe/Z.MB).toFixed(2)):Pe<Z.TB?(0,b.localize)(4,null,(Pe/Z.GB).toFixed(2)):(0,b.localize)(5,null,(Pe/Z.TB).toFixed(2))}}e.$Al=Z;function $e(oe){const Pe=typeof oe=="string"||oe?.scheme===I.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===I.Schemas.file?1024*Z.MB:Pe?10*Z.MB:E.$o?50*Z.MB:1024*Z.MB}}),define(ke[257],De([1,0,22,13,216,33]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=M;async function M(I,P,p,S,v,d){let f;try{await b(I,P,p,S,v,d)}catch(a){f=a}finally{f&&v.errorTransformer&&(f=v.errorTransformer(f)),typeof f<"u"&&p.error(f),p.end()}}async function b(I,P,p,S,v,d){$(d);const f=await I.open(P,{create:!1});try{$(d);let a=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,c=l.$He.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),r=v&&typeof v.position=="number"?v.position:0,t=0;do n=await I.read(f,r,c.buffer,t,c.byteLength-t),r+=n,t+=n,a+=n,typeof i=="number"&&(i-=n),t===c.byteLength&&(await p.write(S(c)),c=l.$He.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&$(d)&&E(a,v));if(t>0){let u=t;typeof i=="number"&&(u=Math.min(t,i)),p.write(S(c.slice(0,u)))}}catch(a){throw(0,A.$gl)(a)}finally{await I.close(f)}}function $(I){if(I.isCancellationRequested)throw(0,O.$6)();return!0}function E(I,P){if(typeof P?.limits?.size=="number"&&I>P.limits.size)throw(0,A.$fl)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],De([1,0,35,3,16,12,2,33]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=e.$Pq=void 0,e.$Nq=$,e.$Oq=E,e.$Sq=S,e.$Tq=v,e.$Uq=d,e.$Vq=f,e.$Wq=n,e.$Xq=i;function $(c){return typeof c.correlationId=="number"}function E(c){return c.recursive===!0}class I extends O.$Uc{static{this.a=5}constructor(r,t,u,s){super(),this.h=r,this.j=t,this.m=u,this.n=s,this.c=this.B(new O.$Vc),this.f=void 0,this.g=0}s(){const r=new O.$Tc;this.c.value=r,this.b=this.r(r),this.b.setVerboseLogging(this.m),r.add(this.b.onDidChangeFile(t=>this.h(t))),r.add(this.b.onDidLogMessage(t=>this.j(t))),r.add(this.b.onDidError(t=>this.t(t)))}t(r){this.n.restartOnError?this.g<I.a&&this.f?(this.w(`restarting watcher after error: ${r}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${r}`):this.w(r)}u(r){this.g++,this.s(),this.watch(r)}async watch(r){this.f=r,await this.b?.watch(r)}async setVerboseLogging(r){this.m=r,await this.b?.setVerboseLogging(r)}w(r){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${r}`})}y(r){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${r}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Pq=I;class P extends I{constructor(r,t,u){super(r,t,u,{type:"node.js",restartOnError:!1})}}e.$Qq=P;class p extends I{constructor(r,t,u){super(r,t,u,{type:"universal",restartOnError:!0})}}e.$Rq=p;function S(c){return c.map(r=>({type:r.type,resource:M.URI.revive(r.resource),cId:r.cId}))}function v(c){const r=new a;for(const t of c)r.processEvent(t);return r.coalesce()}function d(c,r){return typeof r=="string"&&!r.startsWith(l.$ok)&&!(0,L.$ic)(r)?{base:c,pattern:r}:r}function f(c,r){const t=[];for(const u of r)t.push((0,l.$sk)(d(c,u)));return t}class a{constructor(){this.a=new Set,this.b=new Map}c(r){return A.$k?r.resource.fsPath:r.resource.fsPath.toLowerCase()}processEvent(r){const t=this.b.get(this.c(r));let u=!1;if(t){const s=t.type,o=r.type;t.resource.fsPath!==r.resource.fsPath&&(r.type===2||r.type===1)?u=!0:s===1&&o===2?(this.b.delete(this.c(r)),this.a.delete(t)):s===2&&o===1?t.type=0:s===1&&o===0||(t.type=o)}else u=!0;u&&(this.a.add(r),this.b.set(this.c(r),r))}coalesce(){const r=[],t=[];return Array.from(this.a).filter(u=>u.type!==2?(r.push(u),!1):!0).sort((u,s)=>u.resource.fsPath.length-s.resource.fsPath.length).filter(u=>t.some(s=>(0,b.$ml)(u.resource.fsPath,s,!A.$k))?!1:(t.push(u.resource.fsPath),!0)).concat(r)}}function n(c,r){if(typeof r=="number")switch(c.type){case 1:return(r&4)===0;case 2:return(r&8)===0;case 0:return(r&2)===0}return!1}function i(c){if(typeof c=="number"){const r=[];return c&4&&r.push("Added"),c&8&&r.push("Deleted"),c&2&&r.push("Updated"),r.length===0?"<all>":`[${r.join(", ")}]`}return"<none>"}}),define(ke[258],De([1,0,53,3,65,4,2,7]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;class $ extends O.$Uc{constructor(){super(),this.a=this.B(new A.$fe),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$fe),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$fe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new O.$4c),this.m=new Set,this.n=5007,this.r=new b.$Vh,this.P=!1,this.B(this.f(I=>this.s(I)))}s(I){this.t(I)&&this.w(I)}t(I){return(0,L.$Nq)(I)}async watch(I){this.r.isSettled||this.r.complete(),this.r=new b.$Vh;try{this.h.clear(),this.g.clear();for(const P of I)this.t(P)?this.h.set(P.correlationId,P):this.g.add(P);for(const[P]of this.j)this.h.has(P)||(this.j.deleteAndDispose(P),this.m.delete(P));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(I=>!this.j.has(I.correlationId))])}isSuspended(I){return typeof I.correlationId!="number"?!1:this.m.has(I.correlationId)?"polling":this.j.has(I.correlationId)}async w(I){if(this.j.has(I.correlationId))return;const P=new O.$Tc;this.j.set(I.correlationId,P),await this.r.p,!P.isDisposed&&(this.z(I,P),this.u())}y(I){this.j.deleteAndDispose(I.correlationId),this.m.delete(I.correlationId),this.u()}z(I,P){this.C(I,P)?(this.N(`reusing an existing recursive watcher to monitor ${I.path}`),this.m.delete(I.correlationId)):(this.D(I,P),this.m.add(I.correlationId))}C(I,P){const p=this.M?.subscribe(I.path,(S,v)=>{P.isDisposed||(S?this.z(I,P):v?.type===1&&this.F(I))});return p?(P.add(p),!0):!1}D(I,P){let p=!1;const S=(v,d)=>{if(P.isDisposed)return;const f=this.G(v),a=this.G(d),n=p;p=f,!f&&(a||n)&&this.F(I)};this.N(`starting fs.watchFile() on ${I.path} (correlationId: ${I.correlationId})`);try{(0,l.watchFile)(I.path,{persistent:!1,interval:this.n},S)}catch(v){this.O(`fs.watchFile() failed with error ${v} on path ${I.path} (correlationId: ${I.correlationId})`)}P.add((0,O.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${I.path} (correlationId: ${I.correlationId})`);try{(0,l.unwatchFile)(I.path,S)}catch(v){this.O(`fs.unwatchFile() failed with error ${v} on path ${I.path} (correlationId: ${I.correlationId})`)}}))}F(I){this.N(`detected ${I.path} exists again, resuming watcher (correlationId: ${I.correlationId})`);const P={resource:M.URI.file(I.path),type:1,cId:I.correlationId};this.a.fire([P]),this.H(P,I),this.y(I)}G(I){return I.ctimeMs===0&&I.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(I,P){if(this.P){const p=` >> normalized ${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.resource.fsPath}`;this.I(p,P)}}I(I,P){this.P&&this.N(`${I}${typeof P.correlationId=="number"?` <${P.correlationId}> `:""}`)}J(I){return`${I.path} (excludes: ${I.excludes.length>0?I.excludes:"<none>"}, includes: ${I.includes&&I.includes.length>0?JSON.stringify(I.includes):"<all>"}, filter: ${(0,L.$Xq)(I.filter)}, correlationId: ${typeof I.correlationId=="number"?I.correlationId:"<none>"})`}async setVerboseLogging(I){this.P=I}}e.$7q=$}),define(ke[259],De([1,0,53,7,21,31,3,77,16,12,23,2,104,32,65]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,e.$ar=f;class d extends M.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,i,c,r,t,u){super(),this.s=n,this.t=i,this.u=c,this.w=r,this.y=t,this.z=u,this.c=this.B(new O.$Nh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new O.$Mh(s=>this.M(s),d.b)),this.g=(0,v.$Vq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,v.$Vq)(this.s.path,this.s.includes):void 0,this.j=(0,v.$Nq)(this.s)?this.s.filter:void 0,this.m=new L.$qe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const i=await S.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let i=n.path;try{i=await S.Promises.realpath(n.path),n.path===i&&(i=await(0,p.$9q)(n.path,this.m.token)??n.path),n.path!==i&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async G(n,i){const c=new M.$Tc;return this.H(n,i,c)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,i,c)),c}H(n,i,c){if(i)return!1;const r=P.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(u,s)=>{if(!c.isDisposed)if(u){const o=await this.G(n,i);c.isDisposed?o.dispose():c.add(o)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:r,type:s.type,cId:this.s.correlationId},!0)});return t?(c.add(t),!0):!1}async I(n,i,c){if(E.$j&&(0,A.$xg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const r=new L.$qe(this.m.token);c.add((0,M.$Sc)(()=>r.dispose(!0)));const t=new M.$Tc;c.add(t);try{const u=P.URI.file(this.s.path),s=(0,$.$nc)(n),o=(0,l.watch)(n);t.add((0,M.$Sc)(()=>{o.removeAllListeners(),o.close()})),this.Q(`Started watching: '${n}'`);const h=new Set;if(i)try{for(const w of await S.Promises.readdir(n))h.add(w)}catch(w){this.O(w)}if(r.token.isCancellationRequested)return;const g=new Map;t.add((0,M.$Sc)(()=>{for(const[,w]of g)w.dispose();g.clear()})),o.on("error",(w,k)=>{r.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${w}, ${k})`),this.D())}),o.on("change",(w,k)=>{if(r.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${w}"] ${k}`);let m="";if(k&&(m=k.toString(),E.$j&&(m=(0,b.$dm)(m))),!(!m||w!=="change"&&w!=="rename"))if(i)if(w==="rename"){g.get(m)?.dispose();const y=setTimeout(async()=>{if(g.delete(m),m===s&&!await S.Promises.exists(n)){this.J(u);return}if(r.token.isCancellationRequested)return;const D=await this.N((0,$.$jc)(n,m));if(r.token.isCancellationRequested)return;let C;D?h.has(m)?C=0:(C=1,h.add(m)):(h.delete(m),C=2),this.L({resource:(0,I.$_g)(u,m),type:C,cId:this.s.correlationId})},d.a);g.set(m,(0,M.$Sc)(()=>clearTimeout(y)))}else{let y;h.has(m)?y=0:(y=1,h.add(m)),this.L({resource:(0,I.$_g)(u,m),type:y,cId:this.s.correlationId})}else if(w==="rename"||m!==s){const y=setTimeout(async()=>{const D=await S.Promises.exists(n);r.token.isCancellationRequested||(D?(this.L({resource:u,type:0,cId:this.s.correlationId},!0),t.add(await this.G(n,!1))):this.J(u))},d.a);t.clear(),t.add((0,M.$Sc)(()=>clearTimeout(y)))}else this.L({resource:u,type:0,cId:this.s.correlationId},!0)})}catch(u){r.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${u.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,i=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(c=>c(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(c=>c(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const i=(0,v.$Tq)(n),c=[];for(const t of i){if((0,v.$Wq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}c.push(t)}if(c.length===0)return;if(this.z)for(const t of c)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(c)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(E.$k)return S.Promises.exists(n);try{const i=(0,$.$nc)(n);return(await S.Promises.readdir((0,$.$mc)(n))).some(r=>r===i)}catch(i){return this.Q(i),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$_q=d;async function f(a,n,i,c,r=512){const t=await S.Promises.open(a,"r"),u=Buffer.allocUnsafe(r),s=new L.$qe(c);let o,h=!1;const g={path:a,excludes:[],recursive:!1},w=new d(g,void 0,k=>{(async()=>{for(const{type:m}of k)if(m===0){if(h)return;h=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:y}=await S.Promises.read(t,u,0,r,null);if(!y||s.token.isCancellationRequested)break;n(u.slice(0,y))}}catch(y){o=new Error(y),s.dispose(!0)}finally{h=!1}}})()});return await w.ready,i(),new Promise((k,m)=>{s.token.onCancellationRequested(async()=>{w.dispose();try{await S.Promises.close(t)}catch(y){o=new Error(y)}o?m(o):k()})})}}),define(ke[260],De([1,0,4,35,258,12,259,31]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class $ extends L.$7q{constructor(I){super(),this.M=I,this.onDidError=l.Event.None,this.watchers=new Set}async L(I){I=this.X(I);const P=[],p=new Set(Array.from(this.watchers));for(const S of I){const v=this.S(S);v&&(0,O.$wk)(v.request.excludes,S.excludes)&&(0,O.$wk)(v.request.includes,S.includes)?p.delete(v):P.push(S)}P.length&&this.N(`Request to start watching: ${P.map(S=>this.J(S)).join(",")}`),p.size&&this.N(`Request to stop watching: ${Array.from(p).map(S=>this.J(S.request)).join(",")}`);for(const S of p)this.W(S);for(const S of P)this.U(S)}S(I){for(const P of this.watchers)if(typeof I.correlationId=="number"||typeof P.request.correlationId=="number"){if(P.request.correlationId===I.correlationId)return P}else if((0,b.$wg)(P.request.path,I.path,!A.$k))return P}U(I){const P=new M.$_q(I,this.M,S=>this.a.fire(S),()=>this.c.fire(I),S=>this.b.fire(S),this.P),p={request:I,instance:P};this.watchers.add(p)}async stop(){await super.stop();for(const I of this.watchers)this.W(I)}W(I){this.N("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}X(I){const P=new Map;for(const p of I){const S=A.$k?p.path:p.path.toLowerCase();let v=P.get(p.correlationId);v||(v=new Map,P.set(p.correlationId,v)),v.has(S)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(p)}`),v.set(S,p)}return Array.from(P.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const P of this.watchers)P.instance.setVerboseLogging(I)}N(I,P){this.P&&this.b.fire({type:"trace",message:this.$(I,P)})}O(I){this.b.fire({type:"warn",message:this.$(I)})}$(I,P){return P?`[File Watcher (node.js)] ${I} (${this.J(P.request)})`:`[File Watcher (node.js)] ${I}`}}e.$br=$}),define(ke[261],De([1,0,65,260]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class L extends l.$Qq{constructor(M,b,$){super(M,b,$),this.s()}r(M){return M.add(new O.$br(void 0))}}e.$cr=L}),define(ke[262],De([1,0,15,82,199,65]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class M extends A.$Rq{constructor($,E,I){super($,E,I),this.s()}r($){const E=$.add(new L.$5q(l.$Sg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(E.onDidProcessExit(({code:I,signal:P})=>this.t(`terminated by itself with code ${I}, signal: ${P} (ETERM)`))),O.ProxyChannel.toService((0,O.$fi)(E.getChannel("watcher")))}}e.$6q=M}),define(ke[107],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class l{constructor(...L){this.a=new Map;for(const[A,M]of L)this.set(A,M)}set(L,A){const M=this.a.get(L);return this.a.set(L,A),M}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$wi=l}),define(ke[263],De([1,0,7,13,3,106,253,5,107,76]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;const I=!1;class P extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class p{constructor(f=new $.$wi,a=!1,n,i=I){this.i=f,this.j=a,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$xi,this),this._globalGraph=i?n?._globalGraph??new M.$fr(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const f of this.g)(0,L.$Oc)(f)&&f.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(f){this.m();const a=new class extends p{dispose(){this.h.delete(a),super.dispose()}}(f,this.j,this,this.l);return this.h.add(a),a}invokeFunction(f,...a){this.m();const n=v.traceInvocation(this.l,f);let i=!1;try{return f({get:r=>{if(i)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(r,n);if(!t)throw new Error(`[invokeFunction] unknown service '${r}'`);return t}},...a)}finally{i=!0,n.stop()}}createInstance(f,...a){this.m();let n,i;return f instanceof A.$vi?(n=v.traceCreation(this.l,f.ctor),i=this.o(f.ctor,f.staticArguments.concat(a),n)):(n=v.traceCreation(this.l,f),i=this.o(f,a,n)),n.stop(),i}o(f,a=[],n){const i=b._util.getServiceDependencies(f).sort((t,u)=>t.index-u.index),c=[];for(const t of i){const u=this.s(t.id,n);u||this.y(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(u)}const r=i.length>0?i[0].index:a.length;if(a.length!==r){console.trace(`[createInstance] First service dependency of ${f.name} at position ${r+1} conflicts with ${a.length} static arguments`);const t=r-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,r)}return Reflect.construct(f,a.concat(c))}q(f,a){if(this.i.get(f)instanceof A.$vi)this.i.set(f,a);else if(this.k)this.k.q(f,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(f){const a=this.i.get(f);return!a&&this.k?this.k.r(f):a}s(f,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const n=this.r(f);return n instanceof A.$vi?this.u(f,n,a.branch(f,!0)):(a.branch(f,!1),n)}u(f,a,n){if(this.t.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.t.add(f);try{return this.v(f,a,n)}finally{this.t.delete(f)}}v(f,a,n){const i=new M.$fr(t=>t.id.toString());let c=0;const r=[{id:f,desc:a,_trace:n}];for(;r.length;){const t=r.pop();if(i.lookupOrInsertNode(t),c++>1e3)throw new P(i);for(const u of b._util.getServiceDependencies(t.desc.ctor)){const s=this.r(u.id);if(s||this.y(`[createInstance] ${f} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),s instanceof A.$vi){const o={id:u.id,desc:s,_trace:t._trace.branch(u.id,!0)};i.insertEdge(t,o),r.push(o)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new P(i);break}for(const{data:u}of t){if(this.r(u.id)instanceof A.$vi){const o=this.w(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.q(u.id,o)}i.removeNode(u)}}return this.r(f)}w(f,a,n=[],i,c){if(this.i.get(f)instanceof A.$vi)return this.x(f,a,n,i,c,this.g);if(this.k)return this.k.w(f,a,n,i,c);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(f,a,n=[],i,c,r){if(i){const t=new p(void 0,this.j,this,this.l);t.c=String(f);const u=new Map,s=new l.$Rh(()=>{const o=t.o(a,n,c);for(const[h,g]of u){const w=o[h];if(typeof w=="function")for(const k of g)k.disposable=w.apply(o,k.listener)}return u.clear(),r.add(o),o});return new Proxy(Object.create(null),{get(o,h){if(!s.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let k=u.get(h);return k||(k=new E.$5c,u.set(h,k)),(y,D,C)=>{if(s.isInitialized)return s.value[h](y,D,C);{const R={listener:[y,D,C],disposable:void 0},T=k.push(R);return(0,L.$Sc)(()=>{T(),R.disposable?.dispose()})}}}if(h in o)return o[h];const g=s.value;let w=g[h];return typeof w!="function"||(w=w.bind(g),o[h]=w),w},set(o,h,g){return s.value[h]=g,!0},getPrototypeOf(o){return a.prototype}})}else{const t=this.o(a,n,c);return r.add(t),t}}y(f,a){if(a&&console.warn(f),this.j)throw new Error(f)}}e.$gr=p;var S;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(S||(S={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,a){return f?new v(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(f,a){return f?new v(1,a.name):v.c}static{this.f=0}constructor(f,a){this.type=f,this.name=a,this.g=Date.now(),this.h=[]}branch(f,a){const n=new v(3,f.toString());return this.h.push([f,a,n]),n}stop(){const f=Date.now()-this.g;v.f+=f;let a=!1;function n(c,r){const t=[],u=new Array(c+1).join("	");for(const[s,o,h]of r.h)if(o&&h){a=!0,t.push(`${u}CREATES -> ${s}`);const g=n(c+1,h);g&&t.push(g)}else t.push(`${u}uses -> ${s}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(f>2||a)&&v.all.add(i.join(`
`))}}e.$hr=v}),define(ke[11],De([1,0,218,47,4,57,3,27,12,23,18,2,38,5]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=d,e.log=a,e.$gk=w,e.$hk=k,e.$ik=m,e.$jk=y,e.$5j=(0,S.$yi)("logService"),e.$6j=(0,S.$yi)("loggerService");function v(){return new Date().toISOString()}function d(D){return(0,I.$cg)(D)}var f;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$8j=f.Info;function a(D,C,R){switch(C){case f.Trace:D.trace(R);break;case f.Debug:D.debug(R);break;case f.Info:D.info(R);break;case f.Warning:D.warn(R);break;case f.Error:D.error(R);break;case f.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(D,C=!1){let R="";for(let T=0;T<D.length;T++){let j=D[T];if(j instanceof Error&&(j=(0,O.$jj)(j,C)),typeof j=="object")try{j=JSON.stringify(j)}catch{}R+=(T>0?" ":"")+j}return R}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new L.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==f.Off&&this.b<=C}}e.$0j=i;class c extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...R){this.f(f.Trace)&&this.g(f.Trace,n([C,...R],!0))}debug(C,...R){this.f(f.Debug)&&this.g(f.Debug,n([C,...R]))}info(C,...R){this.f(f.Info)&&this.g(f.Info,n([C,...R]))}warn(C,...R){this.f(f.Warning)&&this.g(f.Warning,n([C,...R]))}error(C,...R){if(this.f(f.Error))if(C instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=C.stack,this.g(f.Error,n(T))}else this.g(f.Error,n([C,...R]))}flush(){}}e.$$j=c;class r extends i{constructor(C=e.$8j){super(),this.setLevel(C),this.g=!$.$i}trace(C,...R){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...R):console.log(`[main ${v()}]`,C,...R))}debug(C,...R){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...R):console.log(`[main ${v()}]`,C,...R))}info(C,...R){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...R):console.log(`[main ${v()}]`,C,...R))}warn(C,...R){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,C,...R):console.warn(`[main ${v()}]`,C,...R))}error(C,...R){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,C,...R):console.error(`[main ${v()}]`,C,...R))}flush(){}}e.$_j=r;class t extends i{constructor(C=e.$8j,R=!0){super(),this.g=R,this.setLevel(C)}trace(C,...R){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...R):console.log(C,...R))}debug(C,...R){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...R):console.log(C,...R))}info(C,...R){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...R):console.log(C,...R))}warn(C,...R){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...R):console.log(C,...R))}error(C,...R){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...R):console.error(C,...R))}flush(){}}e.$ak=t;class u extends i{constructor(C,R=e.$8j){super(),this.g=C,this.setLevel(R)}trace(C,...R){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(C),...R])}debug(C,...R){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(C),...R])}info(C,...R){this.f(f.Info)&&this.g.log(f.Info,[this.h(C),...R])}warn(C,...R){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(C),...R])}error(C,...R){this.f(f.Error)&&this.g.log(f.Error,[this.h(C),...R])}h(C){return typeof C=="string"?C:(0,O.$jj)(C,this.f(f.Trace))}flush(){}}e.$bk=u;class s extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const R of this.g)R.setLevel(C);super.setLevel(C)}trace(C,...R){for(const T of this.g)T.trace(C,...R)}debug(C,...R){for(const T of this.g)T.debug(C,...R)}info(C,...R){for(const T of this.g)T.info(C,...R)}warn(C,...R){for(const T of this.g)T.warn(C,...R)}error(C,...R){for(const T of this.g)T.error(C,...R)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ck=s;class o extends M.$Uc{constructor(C,R,T){if(super(),this.h=C,this.j=R,this.b=new b.$Ac,this.c=this.B(new L.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$fe),this.onDidChangeVisibility=this.g.event,T)for(const j of T)this.b.set(j.resource,{logger:void 0,info:j})}m(C){return(0,I.$$f)(C)?[...this.b.values()].find(R=>R.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,R){const T=this.n(C),j=(0,I.$$f)(C)?C:R?.id??(0,A.$mj)(T.toString()).toString(16);let z=this.b.get(T)?.logger;const N=R?.logLevel==="always"?f.Trace:R?.logLevel;z||(z=this.s(T,N??this.getLogLevel(T)??this.h,{...R,id:j}));const F={logger:z,info:{resource:T,id:j,logLevel:N,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(F.info),this.b.set(T,F),z}n(C){return(0,I.$$f)(C)?(0,E.$_g)(this.j,`${C}.log`):C}setLogLevel(C,R){if(P.URI.isUri(C)){const T=C,j=R,z=this.b.get(T);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([T,j]))}else{this.h=C;for(const[T,j]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,R){const T=this.m(C);T&&R!==!T.info.hidden&&(T.info.hidden=!R,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,R]))}getLogLevel(C){let R;return C&&(R=this.b.get(C)?.info.logLevel),R??this.h}registerLogger(C){const R=this.b.get(C.resource);R?R.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const R=this.b.get(C);R&&(R.logger&&R.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=o;class h{constructor(){this.onDidChangeLogLevel=new L.$fe().event}setLevel(C){}getLevel(){return f.Info}trace(C,...R){}debug(C,...R){}info(C,...R){}warn(C,...R){}error(C,...R){}critical(C,...R){}dispose(){}flush(){}}e.$ek=h;class g extends h{}e.$fk=g;function w(D){if(D.verbose)return f.Trace;if(typeof D.logLevel=="string"){const C=y(D.logLevel.toLowerCase());if(C!==void 0)return C}return e.$8j}function k(D){switch(D){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function m(D){switch(D){case f.Trace:return{original:"Trace",value:l.localize(0,null)};case f.Debug:return{original:"Debug",value:l.localize(1,null)};case f.Info:return{original:"Info",value:l.localize(2,null)};case f.Warning:return{original:"Warning",value:l.localize(3,null)};case f.Error:return{original:"Error",value:l.localize(4,null)};case f.Off:return{original:"Off",value:l.localize(5,null)}}}function y(D){switch(D){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$kk=new p.$Pj("logLevel",k(f.Info))}),define(ke[264],De([1,0,19,7,13,4,31,3,16,65,11]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class P extends b.$Uc{constructor(S,v){super(),this.a=S,this.b=v,this.c=this.B(new A.$fe),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$fe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$wh(0)),this.w=[],this.y=this.B(new O.$wh(0))}watch(S,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(S,v):this.z(S,v)}n(S,v){const d={path:this.J(S),excludes:v.excludes,includes:v.includes,recursive:v.recursive,filter:v.filter,correlationId:v.correlationId},f=(0,l.$Tb)(this.j,d);return this.r(),(0,b.$Sc)(()=>{f(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(S=>(0,L.$1)(S))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,E.$Sq)(v)),v=>this.G(v),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const S=this.b?.watcher?.recursive?.usePolling;if(S===!0)for(const v of this.j)(0,E.$Oq)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const v of this.j)(0,E.$Oq)(v)&&S.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(S,v){const d={path:this.J(S),excludes:v.excludes,includes:v.includes,recursive:!1,filter:v.filter,correlationId:v.correlationId},f=(0,l.$Tb)(this.w,d);return this.C(),(0,b.$Sc)(()=>{f(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(S=>(0,L.$1)(S))}D(){return this.u||(this.u=this.B(this.F(S=>this.c.fire((0,E.$Sq)(S)),S=>this.G(S),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(S){S.type==="error"&&this.g.fire(S.message),this.H(S)}H(S){this.a[S.type](S.message)}I(S){return(0,$.$hc)(S.fsPath)}J(S){const v=this.I(S);return(0,M.$Ag)(v)}}e.$Yq=P}),define(ke[265],De([1,0,53,402,7,27,22,4,31,3,16,12,23,98,32,217,33,257,264,47,262,261]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0,(()=>{try{(0,O.gracefulify)(l)}catch(u){console.error(`Error enabling graceful-fs: ${(0,i.$jj)(u)}`)}})();class t extends n.$Yq{static{this.L=!1}constructor(s,o){super(s,o),this.onDidChangeCapabilities=b.Event.None,this.P=new A.$Ac(h=>p.$3g.getComparisonKey(h)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,P.$k&&(this.M|=1024)),this.M}async stat(s){try{const{stat:o,symbolicLink:h}=await v.SymlinkSupport.stat(this.I(s));return{type:this.O(o,h),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size,permissions:o.mode&128?void 0:f.FilePermission.Locked}}catch(o){throw this.hb(o)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const o=await v.Promises.readdir(this.I(s),{withFileTypes:!0}),h=[];return await Promise.all(o.map(async g=>{try{let w;g.isSymbolicLink()?w=(await this.stat((0,p.$_g)(s,g.name))).type:w=this.O(g),h.push([g.name,w])}catch(w){this.a.trace(w)}})),h}catch(o){throw this.hb(o)}}O(s,o){let h;return o?.dangling?h=f.FileType.Unknown:s.isFile()?h=f.FileType.File:s.isDirectory()?h=f.FileType.Directory:h=f.FileType.Unknown,o&&(h|=f.FileType.SymbolicLink),h}async Q(s){const o=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let h;for(;h=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await h.wait();const g=new L.$xh;return this.P.set(s,g),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,E.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.P.get(s)===g&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),g.open()})}async readFile(s,o){let h;try{o?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),h=await this.Q(s));const g=this.I(s);return await v.Promises.readFile(g)}catch(g){throw this.hb(g)}finally{h?.dispose()}}R(s){t.L&&this.a.trace(s)}readFileStream(s,o,h){const g=(0,S.$ve)(w=>M.$He.concat(w.map(k=>M.$He.wrap(k))).buffer);return(0,a.$Lq)(this,s,g,w=>w.buffer,{...o,bufferSize:256*1024},h),g}async writeFile(s,o,h){return h?.atomic!==!1&&h?.atomic?.postfix&&await this.S(s)?this.U(s,(0,p.$_g)((0,p.$$g)(s),`${(0,p.$9g)(s)}${h.atomic.postfix}`),o,h):this.W(s,o,h)}async S(s){try{const o=this.I(s),{symbolicLink:h}=await v.SymlinkSupport.stat(o);if(h)return!1}catch{}return!0}async U(s,o,h,g){const w=new E.$Tc;try{w.add(await this.Q(s)),w.add(await this.Q(o)),await this.W(o,h,g,!0);try{await this.rename(o,s,{overwrite:!0})}catch(k){try{await this.delete(o,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{w.dispose()}}async W(s,o,h,g){let w;try{const k=this.I(s);if(!h.create||!h.overwrite){if(await v.Promises.exists(k)){if(!h.overwrite)throw(0,f.$fl)((0,d.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,f.$fl)((0,d.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(s,{create:!0,unlock:h.unlock},g),await this.write(w,0,o,0,o.byteLength)}catch(k){throw await this.ib(s,k)}finally{typeof w=="number"&&await this.close(w)}}static{this.$=!0}static configureFlushOnWrite(s){t.$=s}async open(s,o,h){const g=this.I(s);let w;(0,f.$6k)(o)&&!h&&(w=await this.Q(s));let k;try{if((0,f.$6k)(o)&&o.unlock)try{const{stat:y}=await v.SymlinkSupport.stat(g);y.mode&128||await v.Promises.chmod(g,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let m;if((0,f.$6k)(o)){if(P.$i)try{await v.Promises.truncate(g,0),m="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}m||(m="w")}else m="r";k=await v.Promises.open(g,m)}catch(m){throw w?.dispose(),(0,f.$6k)(o)?await this.ib(s,m):this.hb(m)}if(this.X.set(k,0),(0,f.$6k)(o)&&this.Z.set(k,s),w){const m=this.Y.get(k);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${g})`),this.Y.set(k,w),m&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${g})`),m.dispose())}return k}async close(s){const o=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&t.$)try{await v.Promises.fdatasync(s)}catch(h){t.configureFlushOnWrite(!1),this.a.error(h)}return await v.Promises.close(s)}catch(h){throw this.hb(h)}finally{o&&(this.Y.get(s)===o&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),o.dispose())}}async read(s,o,h,g,w){const k=this.ab(s,o);let m=null;try{m=(await v.Promises.read(s,h,g,w,k)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(s,k,m)}return m}ab(s,o){return o===this.X.get(s)?null:o}bb(s,o,h){const g=this.X.get(s);typeof g=="number"&&(typeof o=="number"||(typeof h=="number"?this.X.set(s,g+h):this.X.delete(s)))}async write(s,o,h,g,w){return(0,L.$Sh)(()=>this.cb(s,o,h,g,w),100,3)}async cb(s,o,h,g,w){const k=this.ab(s,o);let m=null;try{m=(await v.Promises.write(s,h,g,w,k)).bytesWritten}catch(y){throw await this.ib(this.Z.get(s),y)}finally{this.bb(s,k,m)}return m}async mkdir(s){try{await v.Promises.mkdir(this.I(s))}catch(o){throw this.hb(o)}}async delete(s,o){try{const h=this.I(s);if(o.recursive){let g;o?.atomic!==!1&&o.atomic.postfix&&(g=(0,I.$jc)((0,I.$mc)(h),`${(0,I.$nc)(h)}${o.atomic.postfix}`)),await v.Promises.rm(h,v.RimRafMode.MOVE,g)}else try{await v.Promises.unlink(h)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let w=!1;try{const{stat:k,symbolicLink:m}=await v.SymlinkSupport.stat(h);w=k.isDirectory()&&!m}catch{}if(w)await v.Promises.rmdir(h);else throw g}else throw g}}catch(h){throw this.hb(h)}}async rename(s,o,h){const g=this.I(s),w=this.I(o);if(g!==w)try{await this.db(s,o,"move",h.overwrite),await v.Promises.rename(g,w)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,d.localize)(2,null,(0,I.$nc)(g),(0,I.$nc)((0,I.$mc)(w)),k.toString()))),this.hb(k)}}async copy(s,o,h){const g=this.I(s),w=this.I(o);if(g!==w)try{await this.db(s,o,"copy",h.overwrite),await v.Promises.copy(g,w,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,d.localize)(3,null,(0,I.$nc)(g),(0,I.$nc)((0,I.$mc)(w)),k.toString()))),this.hb(k)}}async db(s,o,h,g){const w=this.I(s),k=this.I(o);let m=!1;if(!!(this.capabilities&1024)||(m=(0,$.$wg)(w,k,!0)),m){if(h==="copy")throw(0,f.$fl)((0,d.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(h==="move")return}const D=await this.N(s);if(!D)throw(0,f.$fl)((0,d.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(o);if(C){if(!g)throw(0,f.$fl)((0,d.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);D.type&f.FileType.File&&C.type&f.FileType.File||await this.delete(o,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,o){return this.eb(s,o,!1)}async eb(s,o,h){const g=this.I(s),w=this.I(o),k=!!(this.capabilities&1024);if((0,$.$wg)(g,w,!k))return;const m=new E.$Tc;try{m.add(await this.Q(s)),m.add(await this.Q(o)),h&&await v.Promises.mkdir((0,I.$mc)(w),{recursive:!0}),await v.Promises.copyFile(g,w)}catch(y){if(y.code==="ENOENT"&&!h)return this.eb(s,o,!0);throw this.hb(y)}finally{m.dispose()}}t(s,o,h){return new c.$6q(g=>s(g),g=>o(g),h)}F(s,o,h){return new r.$cr(g=>s(g),g=>o(g),h)}hb(s){if(s instanceof f.$el)return s;let o=s,h;switch(s.code){case"ENOENT":h=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":h=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":h=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":h=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":h=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":o=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,h=f.FileSystemProviderErrorCode.Unknown;break;default:h=f.FileSystemProviderErrorCode.Unknown}return(0,f.$fl)(o,h)}async ib(s,o){let h=this.hb(o);if(s&&h.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await v.SymlinkSupport.stat(this.I(s));g.mode&128||(h=(0,f.$fl)(o,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.a.trace(g)}return h}}e.$dr=t}),define(ke[266],De([1,0,3,11]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;class L extends l.$Uc{constructor(M,b=[]){super(),this.a=new O.$ck([M,...b]),this.B(M.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...b){this.a.trace(M,...b)}debug(M,...b){this.a.debug(M,...b)}info(M,...b){this.a.info(M,...b)}warn(M,...b){this.a.warn(M,...b)}error(M,...b){this.a.error(M,...b)}flush(){this.a.flush()}}e.$bQ=L}),define(ke[267],De([1,0,33,11]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;var L;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(L||(L={}));async function A(E,I,P,p,S){try{const v=await new Promise((f,a)=>{he(["@vscode/spdlog"],f,a)});v.setFlushOn(L.Trace);const d=await v.createAsyncRotatingLogger(E,I,P,p);return S?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(v){console.error(v)}return null}function M(E,I,P){switch(I){case O.LogLevel.Trace:E.trace(P);break;case O.LogLevel.Debug:E.debug(P);break;case O.LogLevel.Info:E.info(P);break;case O.LogLevel.Warning:E.warn(P);break;case O.LogLevel.Error:E.error(P);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function b(E,I){switch(I){case O.LogLevel.Trace:E.setLevel(L.Trace);break;case O.LogLevel.Debug:E.setLevel(L.Debug);break;case O.LogLevel.Info:E.setLevel(L.Info);break;case O.LogLevel.Warning:E.setLevel(L.Warning);break;case O.LogLevel.Error:E.setLevel(L.Error);break;case O.LogLevel.Off:E.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class $ extends O.$$j{constructor(I,P,p,S,v){super(),this.m=[],this.setLevel(v),this.n=this.s(I,P,p,S),this.B(this.onDidChangeLogLevel(d=>{this.r&&b(this.r,d)}))}async s(I,P,p,S){const v=p?6:1,d=30/v*l.$Al.MB,f=await A(I,P,d,v,S);if(f){this.r=f,b(this.r,this.getLevel());for(const{level:a,message:n}of this.m)M(this.r,a,n);this.m=[]}}g(I,P){this.r?M(this.r,I,P):this.getLevel()<=I&&this.m.push({level:I,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$3P=$}),define(ke[139],De([1,0,41,219,5]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var M;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function($){function E(v,d){return d-v}$.compare=E;const I=Object.create(null);I[$.Error]=(0,O.localize)(0,null),I[$.Warning]=(0,O.localize)(1,null),I[$.Info]=(0,O.localize)(2,null);function P(v){return I[v]||""}$.toString=P;function p(v){switch(v){case l.default.Error:return $.Error;case l.default.Warning:return $.Warning;case l.default.Info:return $.Info;case l.default.Ignore:return $.Hint}}$.fromSeverity=p;function S(v){switch(v){case $.Error:return l.default.Error;case $.Warning:return l.default.Warning;case $.Info:return l.default.Info;case $.Hint:return l.default.Ignore}}$.toSeverity=S}(M||(e.MarkerSeverity=M={}));var b;(function($){const E="";function I(p){return P(p,!0)}$.makeKey=I;function P(p,S){const v=[E];return p.source?v.push(p.source.replace("\xA6","\\\xA6")):v.push(E),p.code?typeof p.code=="string"?v.push(p.code.replace("\xA6","\\\xA6")):v.push(p.code.value.replace("\xA6","\\\xA6")):v.push(E),p.severity!==void 0&&p.severity!==null?v.push(M.toString(p.severity)):v.push(E),p.message&&S?v.push(p.message.replace("\xA6","\\\xA6")):v.push(E),p.startLineNumber!==void 0&&p.startLineNumber!==null?v.push(p.startLineNumber.toString()):v.push(E),p.startColumn!==void 0&&p.startColumn!==null?v.push(p.startColumn.toString()):v.push(E),p.endLineNumber!==void 0&&p.endLineNumber!==null?v.push(p.endLineNumber.toString()):v.push(E),p.endColumn!==void 0&&p.endColumn!==null?v.push(p.endColumn.toString()):v.push(E),v.push(E),v.join("\xA6")}$.makeKeyOptionalMessage=P})(b||(e.IMarkerData=b={})),e.$ou=(0,L.$yi)("markerService")}),define(ke[268],De([1,0,4,41,5]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$bw=e.Severity=void 0,e.$cw=b,e.Severity=O.default,e.$bw=(0,L.$yi)("notificationService");var A;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var M;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function b(P){if(P){const p=P;return typeof p.id=="string"&&typeof p.label=="string"}return!1}var $;(function(P){P[P.OFF=0]="OFF",P[P.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new I,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$dw=E;class I{infinite(){}done(){}total(p){}worked(p){}}e.$ew=I}),define(ke[269],De([1,0,52]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const A=L.context.configuration();if(A)O=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,l.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:A.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(ke[108],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,l.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"});var We=this&&this.__param||function(he,e){return function(l,O){e(l,O,he)}};define(ke[109],De([1,0,7,21,3,5]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.ProgressLocation=e.$fw=void 0,e.$fw=(0,A.$yi)("progressService");var M;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$gw=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$hw=b;class ${get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const S=this.d;this.d=()=>{S?.(),p()}}):Promise.resolve()}}e.$iw=$;let E=class extends L.$Uc{constructor(p,S){super(),this.a=new l.$Vh,S.withProgress(p,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,L.$Sc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$jw=E,e.$jw=E=Je([We(1,e.$fw)],E);class I extends L.$Uc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new L.$Tc)}start(p){this.stop();const S=++this.a,v=new O.$qe;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,L.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Sc)(()=>v.cancel())),this.b.add((0,L.$Sc)(()=>this.c?this.c.done():void 0)),{id:S,token:v.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$kw=I,e.$lw=(0,A.$yi)("editorProgressService")}),define(ke[36],De([1,0,62,18]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class L{constructor(){this.a=new Map}add(M,b){l.ok(O.$$f(M)),l.ok(O.$ag(b)),l.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,b)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$fo=new L}),define(ke[110],De([1,0,4,36]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function L(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this.b=new l.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,E){this.a[L($)]=E,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const M=new A;O.$fo.add(e.$go.JSONContribution,M)}),define(ke[66],De([1,0,19,4,18,208,55,110,36]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=d,e.$wo=f,e.$xo=a,e.$yo=i,e.$zo=c;var E;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$ko={Configuration:"base.contributions.configuration"};var I;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const P=$.$fo.as(b.$go.JSONContribution);class p{constructor(){this.h=new Set,this.i=new O.$fe,this.onDidSchemaChange=this.i.event,this.j=new O.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const s=new Set;this.n(t,u,s),P.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const u=new Set;this.o(t,u),P.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:t,remove:u}){const s=new Set;this.o(u,s),this.n(t,!1,s),P.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const u=new Set;this.k(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(t,u){const s=[];for(const{overrides:o,source:h}of t)for(const g in o)if(u.add(g),e.$uo.test(g)){const w=this.a.get(g),k=w?.valuesSources??new Map;if(h)for(const C of Object.keys(o[g]))k.set(C,h);const m={...w?.value||{},...o[g]};this.a.set(g,{source:h,value:m,valuesSources:k});const y=(0,M.$cj)(g),D={type:"object",default:m,description:A.localize(1,null,y),$ref:e.$ro,defaultDefaultValue:m,source:L.$$f(h)?void 0:h,defaultValueSource:h};s.push(...d(g)),this.d[g]=D,this.b.properties[g]=D}else{this.a.set(g,{value:o[g],source:h});const w=this.d[g];w&&(this.w(g,w),this.r(g,w))}this.m(s)}deregisterDefaultConfigurations(t){const u=new Set;this.l(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(t,u){for(const{overrides:s,source:o}of t)for(const h in s){const g=this.a.get(h),w=L.$$f(o)?o:o?.id,k=L.$$f(g?.source)?g?.source:g?.source?.id;if(w===k)if(u.add(h),this.a.delete(h),e.$uo.test(h))delete this.d[h],delete this.b.properties[h];else{const m=this.d[h];m&&(this.w(h,m),this.r(h,m))}}this.u()}deltaConfiguration(t){let u=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),u=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),u=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const u of t)this.h.add(u);this.u()}n(t,u,s){t.forEach(o=>{this.p(o,u,o.extensionInfo,o.restrictedProperties,void 0,s),this.c.push(o),this.q(o)})}o(t,u){const s=o=>{if(o.properties)for(const h in o.properties){u.add(h);const g=this.d[h];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[h],this.s(h,o.properties[h])}o.allOf?.forEach(h=>s(h))};for(const o of t){s(o);const h=this.c.indexOf(o);h!==-1&&this.c.splice(h,1)}}p(t,u=!0,s,o,h=3,g){h=L.$hg(t.scope)?h:t.scope;const w=t.properties;if(w)for(const m in w){const y=w[m];if(u&&i(m,y)){delete w[m];continue}if(y.source=s,y.defaultDefaultValue=w[m].default,this.w(m,y),e.$uo.test(m)?y.scope=void 0:(y.scope=L.$hg(y.scope)?h:y.scope,y.restricted=L.$hg(y.restricted)?!!o?.includes(m):y.restricted),w[m].hasOwnProperty("included")&&!w[m].included){this.f[m]=w[m],delete w[m];continue}else this.d[m]=w[m],w[m].policy?.name&&this.e.set(w[m].policy.name,m);!w[m].deprecationMessage&&w[m].markdownDeprecationMessage&&(w[m].deprecationMessage=w[m].markdownDeprecationMessage),g.add(m)}const k=t.allOf;if(k)for(const m of k)this.p(m,u,s,o,h,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const u=s=>{const o=s.properties;if(o)for(const g in o)this.r(g,o[g]);s.allOf?.forEach(u)};u(t)}r(t,u){switch(e.$lo.properties[t]=u,u.scope){case 1:e.$mo.properties[t]=u;break;case 2:e.$no.properties[t]=u;break;case 6:e.$oo.properties[t]=u;break;case 3:e.$po.properties[t]=u;break;case 4:e.$qo.properties[t]=u;break;case 5:e.$qo.properties[t]=u,this.g.properties[t]=u;break}}s(t,u){switch(delete e.$lo.properties[t],u.scope){case 1:delete e.$mo.properties[t];break;case 2:delete e.$no.properties[t];break;case 6:delete e.$oo.properties[t];break;case 3:delete e.$po.properties[t];break;case 4:case 5:delete e.$qo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const u=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$ro};this.w(u,s),e.$lo.properties[u]=s,e.$mo.properties[u]=s,e.$no.properties[u]=s,e.$oo.properties[u]=s,e.$po.properties[u]=s,e.$qo.properties[u]=s}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=t,e.$mo.patternProperties[e.$to]=t,e.$no.patternProperties[e.$to]=t,e.$oo.patternProperties[e.$to]=t,e.$po.patternProperties[e.$to]=t,e.$qo.patternProperties[e.$to]=t,this.i.fire()}w(t,u){const s=this.a.get(t);let o=s?.value,h=s?.source;L.$fg(o)&&(o=u.defaultDefaultValue,h=void 0),L.$fg(o)&&(o=a(u.type)),u.default=o,u.defaultValueSource=h}}const S="\\[([^\\]]+)\\]",v=new RegExp(S,"g");e.$to=`^(${S})+$`,e.$uo=new RegExp(e.$to);function d(r){const t=[];if(e.$uo.test(r)){let u=v.exec(r);for(;u?.length;){const s=u[1].trim();s&&t.push(s),u=v.exec(r)}}return(0,l.$Mb)(t)}function f(r){return r.reduce((t,u)=>`${t}[${u}]`,"")}function a(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new p;$.$fo.add(e.$ko.Configuration,n);function i(r,t){return r.trim()?e.$uo.test(r)?A.localize(7,null,r):n.getConfigurationProperties()[r]!==void 0?A.localize(8,null,r):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,r,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function c(){const r=[],t=n.getConfigurationProperties();for(const u of Object.keys(t))r.push([u,t[u].scope]);return r.push(["launch",4]),r.push(["task",4]),r}}),define(ke[270],De([1,0,19,4,166,3,27,24,18,2,55,66,36]),function(he,e,l,O,L,A,M,b,$,E,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=i;function S(u){return Object.isFrozen(u)?u:b.$6n(u)}class v{static createEmptyModel(s){return new v({},[],[],void 0,s)}constructor(s,o,h,g,w){this.b=s,this.c=o,this.d=h,this.raw=g,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof v)return o;const h=new d("",this.f);return h.parseRaw(o),h.configurationModel});this.g=s.reduce((o,h)=>h===o?h:o.merge(h),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,I.$aj)(this.contents,s):this.contents}inspect(s,o){const h=this;return{get value(){return S(h.rawConfiguration.getValue(s))},get override(){return o?S(h.rawConfiguration.getOverrideValue(s,o)):void 0},get merged(){return S(o?h.rawConfiguration.override(o).getValue(s):h.rawConfiguration.getValue(s))},get overrides(){const g=[];for(const{contents:w,identifiers:k,keys:m}of h.rawConfiguration.overrides){const y=new v(w,m,[],void 0,h.f).getValue(s);y!==void 0&&g.push({identifiers:k,value:y})}return g.length?S(g):void 0}}}getOverrideValue(s,o){const h=this.j(o);return h?s?(0,I.$aj)(h,s):h:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const h of this.overrides)h.identifiers.includes(s)&&o.push(...h.keys);return l.$Mb(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return l.$Mb(s)}override(s){let o=this.a.get(s);return o||(o=this.h(s),this.a.set(s,o)),o}merge(...s){const o=b.$5n(this.contents),h=b.$5n(this.overrides),g=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const k of s)if(w.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(o,k.contents);for(const m of k.overrides){const[y]=h.filter(D=>l.$ub(D.identifiers,m.identifiers));y?(this.i(y.contents,m.contents),y.keys.push(...m.keys),y.keys=l.$Mb(y.keys)):h.push(b.$5n(m))}for(const m of k.keys)g.indexOf(m)===-1&&g.push(m)}return new v(o,g,h,w.every(k=>k instanceof v)?void 0:w,this.f)}h(s){const o=this.j(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const h={};for(const g of l.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let w=this.contents[g];const k=o[g];k&&(typeof w=="object"&&typeof k=="object"?(w=b.$5n(w),this.i(w,k)):w=k),h[g]=w}return new v(h,this.keys,this.overrides,void 0,this.f)}i(s,o){for(const h of Object.keys(o)){if(h in s&&$.$ag(s[h])&&$.$ag(o[h])){this.i(s[h],o[h]);continue}s[h]=b.$5n(o[h])}}j(s){let o=null,h=null;const g=w=>{w&&(h?this.i(h,w):h=b.$5n(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===s?o=w.contents:w.identifiers.includes(s)&&g(w.contents);return g(o),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.k(s,o,!0)}setValue(s,o){this.k(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,I.$_i)(this.contents,s),P.$uo.test(s)&&this.overrides.splice(this.overrides.findIndex(h=>l.$ub(h.identifiers,(0,P.$vo)(s))),1))}k(s,o,h){(0,I.$$i)(this.contents,s,o,g=>this.f.error(g)),h=h||this.keys.indexOf(s)===-1,h&&this.keys.push(s),P.$uo.test(s)&&this.overrides.push({identifiers:(0,P.$vo)(s),keys:Object.keys(this.contents[s]),contents:(0,I.$0i)(this.contents[s],g=>this.f.error(g))})}}e.$Ao=v;class d{constructor(s,o){this.f=s,this.g=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||v.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!$.$hg(s)){const h=this.h(s);this.parseRaw(h,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:h,keys:g,overrides:w,restricted:k,hasExcludedProperties:m}=this.i(s,o);this.b=new v(h,g,w,m?[s]:void 0,this.g),this.c=k||[]}h(s){let o={},h=null,g=[];const w=[],k=[];function m(D){Array.isArray(g)?g.push(D):h!==null&&(g[h]=D)}const y={onObjectBegin:()=>{const D={};m(D),w.push(g),g=D,h=null},onObjectProperty:D=>{h=D},onObjectEnd:()=>{g=w.pop()},onArrayBegin:()=>{const D=[];m(D),w.push(g),g=D,h=null},onArrayEnd:()=>{g=w.pop()},onLiteralValue:m,onError:(D,C,R)=>{k.push({error:D,offset:C,length:R})}};if(s)try{L.$Sn(s,y),o=g[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return o}i(s,o){const h=p.$fo.as(P.$ko.Configuration).getConfigurationProperties(),g=this.j(s,h,!0,o);s=g.raw;const w=(0,I.$0i)(s,y=>this.g.error(`Conflict in settings file ${this.f}: ${y}`)),k=Object.keys(s),m=this.l(s,y=>this.g.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:w,keys:k,overrides:m,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}j(s,o,h,g){let w=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:w};const k={},m=[];for(const y in s)if(P.$uo.test(y)&&h){const D=this.j(s[y],o,!1,g);k[y]=D.raw,w=w||D.hasExcludedProperties,m.push(...D.restricted)}else{const D=o[y],C=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&m.push(y),!g.exclude?.includes(y)&&(g.include?.includes(y)||(C===void 0||g.scopes===void 0||g.scopes.includes(C))&&!(g.skipRestricted&&D?.restricted))?k[y]=s[y]:w=!0}return{raw:k,restricted:m,hasExcludedProperties:w}}l(s,o){const h=[];for(const g of Object.keys(s))if(P.$uo.test(g)){const w={};for(const k in s[g])w[k]=s[g][k];h.push({identifiers:(0,P.$vo)(g),keys:Object.keys(w),contents:(0,I.$0i)(w,o)})}return h}}e.$Bo=d;class f extends A.$Uc{constructor(s,o,h,g,w){super(),this.c=s,this.f=o,this.g=g,this.h=w,this.b=this.B(new O.$fe),this.onDidChange=this.b.event,this.a=new d(this.c.toString(),w),this.B(this.g.watch(h.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&h.isEqual(k.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return v.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=f;class a{constructor(s,o,h,g,w,k,m,y,D,C,R,T,j){this.a=s,this.b=o,this.c=h,this.overrideIdentifiers=g,this.d=w,this.f=k,this.g=m,this.h=y,this.i=D,this.j=C,this.k=R,this.l=T,this.m=j}get value(){return S(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(s,o,h,g,w,k,m,y,D,C){this.j=s,this.l=o,this.m=h,this.n=g,this.p=w,this.q=k,this.r=m,this.s=y,this.t=D,this.u=C,this.h=null,this.i=new M.$Ac,this.v=null}getValue(s,o,h){return this.w(s,o,h).getValue(s)}updateValue(s,o,h={}){let g;h.resource?(g=this.t.get(h.resource),g||(g=v.createEmptyModel(this.u),this.t.set(h.resource,g))):g=this.s,o===void 0?g.removeValue(s):g.setValue(s,o),h.resource||(this.h=null)}inspect(s,o,h){const g=this.w(s,o,h),w=this.A(o.resource,h),k=o.resource?this.t.get(o.resource)||this.s:this.s,m=new Set;for(const y of g.overrides)for(const D of y.identifiers)g.getOverrideValue(s,D)!==void 0&&m.add(D);return new a(s,o,g.getValue(s),m.size?[...m]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,h?this.q:void 0,w||void 0,k)}keys(s){const o=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,o){this.r.set(s,o),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const h=[];if(!o){const{added:g,updated:w,removed:k}=r(this.j,s);o=[...g,...w,...k]}for(const g of o)for(const w of(0,P.$vo)(g)){const k=this.j.getKeysForOverrideIdentifier(w),m=s.getKeysForOverrideIdentifier(w),y=[...m.filter(D=>k.indexOf(D)===-1),...k.filter(D=>m.indexOf(D)===-1),...k.filter(D=>!b.$9n(this.j.override(w).getValue(D),s.override(w).getValue(D)))];h.push([w,y])}return this.updateDefaultConfiguration(s),{keys:o,overrides:h}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:h,removed:g}=r(this.l,s),w=[...o,...h,...g];return w.length&&this.updatePolicyConfiguration(s),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:h,removed:g,overrides:w}=r(this.applicationConfiguration,s),k=[...o,...h,...g];return k.length&&this.updateApplicationConfiguration(s),{keys:k,overrides:w}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:h,removed:g,overrides:w}=r(this.localUserConfiguration,s),k=[...o,...h,...g];return k.length&&this.updateLocalUserConfiguration(s),{keys:k,overrides:w}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:h,removed:g,overrides:w}=r(this.remoteUserConfiguration,s),k=[...o,...h,...g];return k.length&&this.updateRemoteUserConfiguration(s),{keys:k,overrides:w}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:h,removed:g,overrides:w}=r(this.workspaceConfiguration,s),k=[...o,...h,...g];return k.length&&this.updateWorkspaceConfiguration(s),{keys:k,overrides:w}}compareAndUpdateFolderConfiguration(s,o){const h=this.folderConfigurations.get(s),{added:g,updated:w,removed:k,overrides:m}=r(h,o),y=[...g,...w,...k];return(y.length||!h)&&this.updateFolderConfiguration(s,o),{keys:y,overrides:m}}compareAndDeleteFolderConfiguration(s){const o=this.folderConfigurations.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:h,updated:g,removed:w,overrides:k}=r(o,void 0);return{keys:[...h,...g,...w],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,o,h){let g=this.x(o,h);return o.overrideIdentifier&&(g=g.override(o.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(g=g.merge(this.l)),g}x({resource:s},o){let h=this.y();if(o&&s){const g=o.getFolder(s);g&&(h=this.z(g.uri)||h);const w=this.t.get(s);w&&(h=h.merge(w))}return h}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let o=this.i.get(s);if(!o){const h=this.y(),g=this.r.get(s);g?(o=h.merge(g),this.i.set(s,o)):o=h}return o}A(s,o){if(o&&s){const h=o.getFolder(s);if(h)return this.r.get(h.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,o)=>{const{contents:h,overrides:g,keys:w}=this.r.get(o);return s.push([o,{contents:h,overrides:g,keys:w}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this.q.keys.forEach(o=>s.add(o)),this.r.forEach(o=>o.keys.forEach(h=>s.add(h))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.q.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.r.forEach(o=>o.getAllOverrideIdentifiers().forEach(h=>s.add(h))),[...s.values()]}D(s){const o=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(h=>o.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(h=>o.add(h)),this.q.getKeysForOverrideIdentifier(s).forEach(h=>o.add(h)),this.r.forEach(h=>h.getKeysForOverrideIdentifier(s).forEach(g=>o.add(g))),[...o.values()]}static parse(s,o){const h=this.E(s.defaults,o),g=this.E(s.policy,o),w=this.E(s.application,o),k=this.E(s.user,o),m=this.E(s.workspace,o),y=s.folders.reduce((D,C)=>(D.set(E.URI.revive(C[0]),this.E(C[1],o)),D),new M.$Ac);return new n(h,g,w,k,v.createEmptyModel(o),m,y,v.createEmptyModel(o),new M.$Ac,o)}static E(s,o){return new v(s.contents,s.keys,s.overrides,void 0,o)}}e.$Do=n;function i(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const s=new Set,o=new Map;for(const g of u)g.keys.forEach(w=>s.add(w)),g.overrides.forEach(([w,k])=>{const m=(0,M.$xc)(o,w,new Set);k.forEach(y=>m.add(y))});const h=[];return o.forEach((g,w)=>h.push([w,[...g.values()]])),{keys:[...s.values()],overrides:h}}class c{constructor(s,o,h,g,w){this.change=s,this.f=o,this.g=h,this.h=g,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of s.keys)this.affectedKeys.add(k);for(const[,k]of s.overrides)for(const m of k)this.affectedKeys.add(m);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,o){const h=this.a+s,g=this.d.indexOf(h);if(g<0)return!1;const w=g+h.length;if(w>=this.d.length)return!1;const k=this.d.charCodeAt(w);if(k!==this.b&&k!==this.c)return!1;if(o){const m=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,y=this.g.getValue(s,o,this.h);return!b.$9n(m,y)}return!0}}e.$Fo=c;function r(u,s){const{added:o,removed:h,updated:g}=t(s?.rawConfiguration,u?.rawConfiguration),w=[],k=u?.getAllOverrideIdentifiers()||[],m=s?.getAllOverrideIdentifiers()||[];if(s){const y=m.filter(D=>!k.includes(D));for(const D of y)w.push([D,s.getKeysForOverrideIdentifier(D)])}if(u){const y=k.filter(D=>!m.includes(D));for(const D of y)w.push([D,u.getKeysForOverrideIdentifier(D)])}if(s&&u){for(const y of k)if(m.includes(y)){const D=t({contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)},{contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)});w.push([y,[...D.added,...D.removed,...D.updated]])}}return{added:o,removed:h,updated:g,overrides:w}}function t(u,s){const o=u?s?u.keys.filter(w=>s.keys.indexOf(w)===-1):[...u.keys]:[],h=s?u?s.keys.filter(w=>u.keys.indexOf(w)===-1):[...s.keys]:[],g=[];if(u&&s){for(const w of s.keys)if(u.keys.indexOf(w)!==-1){const k=(0,I.$aj)(s.contents,w),m=(0,I.$aj)(u.contents,w);b.$9n(k,m)||g.push(w)}}return{added:o,removed:h,updated:g}}}),define(ke[271],De([1,0,22,4,3,83]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tvb=e.$Rvb=e.$Qvb=void 0,e.$Svb=b;const M=(E,I,P)=>{const p=new Uint8Array(16);for(let d=0;d<16;d++)p[d]=Math.round(Math.random()*256);const S=(0,l.$2e)(l.$He.wrap(p));return[`GET ws://localhost${E}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$Qvb=M,e.$Rvb=l.$He.fromString(`\r
\r
`);async function b(E,I,P,p,S){E.write(l.$He.fromString((0,e.$Qvb)(I,P,p)));const v=new L.$Tc;try{return await new Promise((d,f)=>{let a;v.add(E.onData(n=>{a?a=l.$He.concat([a,n],a.byteLength+n.byteLength):a=n;const i=a.indexOf(e.$Rvb);if(i===-1)return;d(E),E.pauseData();const c=a.slice(i+e.$Rvb.byteLength);c.byteLength&&S.onData.fire(c)})),v.add(E.onClose(n=>f(n??new Error("socket closed")))),v.add(E.onEnd(()=>f(new Error("socket ended"))))})}catch(d){throw E.dispose(),d}finally{v.dispose()}}class $ extends L.$Uc{constructor(I,P){super(),this.g=I,this.a=this.B(new O.$ie),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new O.$fe),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(p=>this.a.fire(p))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,P){A.SocketDiagnostics.traceSocketEvent(this,this.g,I,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Tvb=$}),define(ke[67],De([1,0,13,5]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.RemoteAuthorityResolverErrorCode=e.$Ll=e.$Kl=e.RemoteConnectionType=e.$Jl=void 0,e.$Nl=E,e.$Jl=(0,O.$yi)("remoteAuthorityResolverService");var L;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class A{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kl=A;class M{constructor(P,p){this.host=P,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ll=M;var b;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends l.$bb{static isNotAvailable(P){return P instanceof $&&P._code===b.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof $&&P._code===b.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof $&&P._code===b.NoResolverFound}static isInvalidAuthority(P){return P instanceof $&&P._code===b.InvalidAuthority}static isHandled(P){return P instanceof $&&P.isHandled}constructor(P,p=b.Unknown,S){super(P),this._message=P,this._code=p,this._detail=S,this.isHandled=p===b.NotAvailable&&S===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Ml=$;function E(I){const P=I.indexOf("+");return P===-1?I:I.substring(0,P)}}),define(ke[272],De([1,0,7,22,21,13,4,3,15,59,40,30,83,67]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Sl=k,e.$Tl=m,e.$Ul=D;const v=30*1e3;var d;(function(te){te[te.Management=1]="Management",te[te.ExtensionHost=2]="ExtensionHost",te[te.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function f(te){switch(te){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function a(te){const U=new L.$qe;return setTimeout(()=>U.cancel(),te),U.token}function n(te,U){if(te.isCancellationRequested||U.isCancellationRequested)return L.CancellationToken.Cancelled;const ee=new L.$qe;return te.onCancellationRequested(()=>ee.cancel()),U.onCancellationRequested(()=>ee.cancel()),ee.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,l.$rh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function c(te,U){const ee=new i(U);return ee.registerDisposable(te.onControlMessage(be=>{const ue=JSON.parse(be.toString()),ce=K(ue);ce?ee.reject(ce):ee.resolve(ue)})),ee.promise}function r(te,U,ee,be,ue,ce,ae,le){const J=new i(le),se=I.$be.create(!1);return te.info(`Creating a socket (${ae})...`),E.mark(`code/willCreateSocket/${ce}`),U.connect(ee,be,ue,ae).then(pe=>{J.didTimeout?(E.mark(`code/didCreateSocketError/${ce}`),te.info(`Creating a socket (${ae}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(E.mark(`code/didCreateSocketOK/${ce}`),te.info(`Creating a socket (${ae}) was successful after ${se.elapsed()} ms.`),J.resolve(pe))},pe=>{E.mark(`code/didCreateSocketError/${ce}`),te.info(`Creating a socket (${ae}) returned an error after ${se.elapsed()} ms.`),te.error(pe),J.reject(pe)}),J.promise}function t(te,U){const ee=new i(U);return te.then(be=>{ee.didTimeout||ee.resolve(be)},be=>{ee.didTimeout||ee.reject(be)}),ee.promise}async function u(te,U,ee,be){const ue=oe(te,U);te.logService.trace(`${ue} 1/6. invoking socketFactory.connect().`);let ce;try{ce=await r(te.logService,te.remoteSocketFactoryService,te.connectTo,$.$Lg.getServerRootPath(),`reconnectionToken=${te.reconnectionToken}&reconnection=${te.reconnectionProtocol?"true":"false"}`,f(U),`renderer-${f(U)}-${te.reconnectionToken}`,be)}catch(pe){throw te.logService.error(`${ue} socketFactory.connect() failed or timed out. Error:`),te.logService.error(pe),pe}te.logService.trace(`${ue} 2/6. socketFactory.connect() was successful.`);let ae,le;te.reconnectionProtocol?(te.reconnectionProtocol.beginAcceptReconnection(ce,null),ae=te.reconnectionProtocol,le=!1):(ae=new p.$mi({socket:ce}),le=!0),te.logService.trace(`${ue} 3/6. sending AuthRequest control message.`);const J=await t(te.signService.createNewMessage((0,P.$Ug)()),be),se={type:"auth",auth:te.connectionToken||"00000000000000000000",data:J.data};ae.sendControl(O.$He.fromString(JSON.stringify(se)));try{const pe=await c(ae,n(be,a(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(te.logService.trace(`${ue} 4/6. received SignRequest control message.`),!await t(te.signService.validate(J,pe.signedData),be)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const Re=await t(te.signService.sign(pe.data),be),me={type:"connectionType",commit:te.commit,signedData:Re,desiredConnectionType:U};return ee&&(me.args=ee),te.logService.trace(`${ue} 5/6. sending ConnectionTypeRequest control message.`),ae.sendControl(O.$He.fromString(JSON.stringify(me))),{protocol:ae,ownsProtocol:le}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&(te.logService.error(`${ue} the handshake timed out. Error:`),te.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&(te.logService.error(`${ue} received error control message when negotiating connection. Error:`),te.logService.error(pe)),le&&H(ae),pe}}async function s(te,U,ee,be){const ue=Date.now(),ce=oe(te,U),{protocol:ae,ownsProtocol:le}=await u(te,U,ee,be),J=new i(be);return J.registerDisposable(ae.onControlMessage(se=>{const pe=JSON.parse(se.toString()),ve=K(pe);ve?(te.logService.error(`${ce} received error control message when negotiating connection. Error:`),te.logService.error(ve),le&&H(ae),J.reject(ve)):(te.reconnectionProtocol?.endAcceptReconnection(),te.logService.trace(`${ce} 6/6. handshake finished, connection is up and running after ${Pe(ue)}!`),J.resolve({protocol:ae,firstMessage:pe}))})),J.promise}async function o(te,U){const{protocol:ee}=await s(te,1,void 0,U);return{protocol:ee}}async function h(te,U,ee){const{protocol:be,firstMessage:ue}=await s(te,2,U,ee),ce=ue&&ue.debugPort;return{protocol:be,debugPort:ce}}async function g(te,U,ee){const be=Date.now(),ue=oe(te,3),{protocol:ce}=await u(te,3,U,ee);return te.logService.trace(`${ue} 6/6. handshake finished, connection is up and running after ${Pe(be)}!`),ce}async function w(te,U,ee){const{connectTo:be,connectionToken:ue}=await te.addressProvider.getAddress();return{commit:te.commit,quality:te.quality,connectTo:be,connectionToken:ue,reconnectionToken:U,reconnectionProtocol:ee,remoteSocketFactoryService:te.remoteSocketFactoryService,signService:te.signService,logService:te.logService}}async function k(te,U,ee){return y(te,async be=>{const{protocol:ue}=await o(be,L.CancellationToken.None);return new Y(te,U,ee,be.reconnectionToken,ue)})}async function m(te,U){return y(te,async ee=>{const{protocol:be,debugPort:ue}=await h(ee,U,L.CancellationToken.None);return new re(te,U,ee.reconnectionToken,be,ue)})}async function y(te,U){for(let be=1;;be++)try{const ue=(0,P.$Ug)(),ce=await w(te,ue,null);return await U(ce)}catch(ue){if(be<5)te.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),te.logService.error(ue);else throw te.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),te.logService.error(ue),B.triggerPermanentFailure(0,0,S.$Ml.isHandled(ue)),ue}}async function D(te,U,ee){const be=await w(te,(0,P.$Ug)(),null);return await g(be,{host:U,port:ee},L.CancellationToken.None)}function C(te){return(0,l.$lh)(U=>new Promise((ee,be)=>{const ue=setTimeout(ee,te*1e3);U.onCancellationRequested(()=>{clearTimeout(ue),ee()})}))}var R;(function(te){te[te.ConnectionLost=0]="ConnectionLost",te[te.ReconnectionWait=1]="ReconnectionWait",te[te.ReconnectionRunning=2]="ReconnectionRunning",te[te.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",te[te.ConnectionGain=4]="ConnectionGain"})(R||(e.PersistentConnectionEventType=R={}));class T{constructor(U,ee){this.reconnectionToken=U,this.millisSinceLastIncomingData=ee,this.type=0}}e.$Vl=T;class j{constructor(U,ee,be,ue){this.reconnectionToken=U,this.millisSinceLastIncomingData=ee,this.durationSeconds=be,this.c=ue,this.type=1}skipWait(){this.c.cancel()}}e.$Wl=j;class z{constructor(U,ee,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ee,this.attempt=be,this.type=2}}e.$Xl=z;class N{constructor(U,ee,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ee,this.attempt=be,this.type=4}}e.$Yl=N;class F{constructor(U,ee,be,ue){this.reconnectionToken=U,this.millisSinceLastIncomingData=ee,this.attempt=be,this.handled=ue,this.type=3}}e.$Zl=F;class B extends b.$Uc{static triggerPermanentFailure(U,ee,be){this._permanentFailure=!0,this.f=U,this.g=ee,this.h=be,this.j.forEach(ue=>ue.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,ee,be,ue,ce){super(),this.t=U,this.u=ee,this.reconnectionToken=be,this.protocol=ue,this.w=ce,this.m=this.B(new M.$fe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(ue.onSocketClose(ae=>{const le=$e(this.t,this.reconnectionToken,!0);ae?ae.type===0?(this.u.logService.info(`${le} received socket close event (hadError: ${ae.hadError}).`),ae.error&&this.u.logService.error(ae.error)):(this.u.logService.info(`${le} received socket close event (wasClean: ${ae.wasClean}, code: ${ae.code}, reason: ${ae.reason}).`),ae.event&&this.u.logService.error(ae.event)):this.u.logService.info(`${le} received socket close event.`),this.y()})),this.B(ue.onSocketTimeout(ae=>{const le=$e(this.t,this.reconnectionToken,!0);this.u.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${ae.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ae.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ae.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,b.$Sc)(()=>{const ae=B.j.indexOf(this);ae>=0&&B.j.splice(ae,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=$e(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ee=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const ue=be<ee.length?ee[be]:ee[ee.length-1];try{if(ue>0){const ae=C(ue);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ue,ae)),this.u.logService.info(`${U} waiting for ${ue} seconds before reconnecting...`);try{await ae}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const ce=await w(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ce.connectTo}...`),await this.G(ce,a(v)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(ce){if(ce.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(S.$Ml.isTemporarilyNotAvailable(ce)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((ce.code==="ETIMEDOUT"||ce.code==="ENETUNREACH"||ce.code==="ECONNREFUSED"||ce.code==="ECONNRESET")&&ce.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if((0,A.$4)(ce)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ce);continue}if(ce instanceof S.$Ml){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,S.$Ml.isHandled(ce));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ce),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ee,be){this.w?B.triggerPermanentFailure(U,ee,be):this.D(U,ee,be)}D(U,ee,be){this.m.fire(new F(this.reconnectionToken,U,ee,be)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$1l=B;class Y extends B{constructor(U,ee,be,ue,ce){super(1,U,ue,ce,!0),this.client=this.B(new p.$ki(ce,{remoteAuthority:ee,clientId:be},U.ipcLogger))}async G(U,ee){await o(U,ee)}}e.$2l=Y;class re extends B{constructor(U,ee,be,ue,ce){super(2,U,be,ue,!1),this.H=ee,this.debugPort=ce}async G(U,ee){await h(U,this.H,ee)}}e.$3l=re;function H(te){try{te.acceptDisconnect();const U=te.getSocket();te.dispose(),U.dispose()}catch(U){(0,A.$1)(U)}}function K(te){if(te&&te.type==="error"){const U=new Error(`Connection error: ${te.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function _(te,U){for(;te.length<U;)te+=" ";return te}function Z(te,U){return`[remote-connection][${_(f(te),13)}][${U.substr(0,5)}\u2026]`}function $e(te,U,ee){return`${Z(te,U)}[${ee?"reconnect":"initial"}]`}function oe(te,U){return`${$e(U,te.reconnectionToken,!!te.reconnectionProtocol)}[${te.connectTo}]`}function Pe(te){return`${Date.now()-te} ms`}}),define(ke[86],De([1,0,15]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=O,e.$Km=L,e.$Lm=A,e.$Mm=M;function O($){return $.scheme===l.Schemas.vscodeRemote?$.authority:void 0}function L($){if(!$)return;const E=$.indexOf("+");return E<0?$:$.substr(0,E)}function A($){const{host:E,port:I}=b($);if(typeof I>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:I}}function M($,E){let{host:I,port:P}=b($);return typeof P>"u"&&(P=E),{host:I,port:P}}function b($){const E=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const I=$.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const P=$.match(/(.*):(\d+)$/);return P?{host:P[1],port:parseInt(P[2],10)}:{host:$,port:void 0}}}),define(ke[25],De([1,0,14,5,86]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=A,e.$Wm=P,e.$Xm=p,e.$Ym=S,e.$Zm=v,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function A(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(M||(e.ExtensionType=M={}));var b;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,a){if(typeof f>"u"||f===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof f=="string"||typeof a=="string"){const n=typeof f=="string"?f:f.value,i=typeof a=="string"?a:a.value;return l.$zf(n,i)}return f._lower===a._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$Tm=$;class E{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const a of f)this.add(a)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$Um=E;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,a){this.c.set($.toKey(f),a)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=I;function P(d){return p(d)}function p(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function S(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function v(d,f){if(f){const a=`onResolveRemoteAuthority:${(0,L.$Km)(f)}`;return!!d.activationEvents?.includes(a)}return!1}e.$1m=(0,O.$yi)("IBuiltinExtensionsScannerService")}),define(ke[140],De([1,0,13,25]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qG=e.$pG=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(M,b){this.a.set(M,b)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const b=Object.create(null);for(const $ of M){const E=this.readActivationEvents($);E.length>0&&(b[O.$Tm.toKey($.identifier)]=E)}return b}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const b=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${O.$Tm.toKey(M.identifier)}`);if(!M.contributes)return b;for(const $ in M.contributes){const E=this.a.get($);if(!E)continue;const I=M.contributes[$],P=Array.isArray(I)?I:[I];try{E(P,b)}catch(p){(0,l.$1)(p)}}return b}}e.$pG=L,e.$qG=new L}),define(ke[273],De([1,0,3,5]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol=(0,O.$yi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(M,b){return this.a[M]??=[],this.a[M].push(b),(0,l.$Sc)(()=>{const $=this.a[M]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[M]?.splice($,1)})}b(M){return(this.a[M.type]||[]).find($=>$.supports(M))}connect(M,b,$,E){const I=this.b(M);if(!I)throw new Error(`No socket factory found for ${M}`);return I.connect(M,b,$,E)}}e.$Pl=L}),define(ke[274],De([1,0,22,13,3,220,66,5,11,36]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0,e.$Tp=p,e.$Up=S,e.$Vp=v,e.$Wp=d,e.$Xp=f,e.$Yp=a,e.$Rp=(0,b.$yi)("requestService");class I{constructor(r){this.b=r}toJSON(){if(!this.a){const r=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?r[t]="*****":r[t]=this.b[t];this.a=r}return this.a}}class P extends L.$Uc{constructor(r){super(),this.b=0,this.a=r.createLogger("network",{name:(0,A.localize)(0,null),when:$.$kk.isEqualTo((0,$.$hk)($.LogLevel.Trace)).serialize()})}async c(r,t,u){const s=`${r} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new I(t.headers??{}));try{const o=await u();return this.a.trace(`${s} - end`,t.type,o.res.statusCode,o.res.headers),o}catch(o){throw this.a.error(`${s} - error`,t.type,(0,O.$0)(o)),o}}}e.$Sp=P;function p(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function S(c){return c.res.statusCode===204}async function v(c){return S(c)?null:(await(0,l.$Te)(c.stream)).toString()}async function d(c){if(!p(c))throw new Error("Server returned "+c.res.statusCode);return v(c)}async function f(c){if(!p(c))throw new Error("Server returned "+c.res.statusCode);if(S(c))return null;const t=(await(0,l.$Te)(c.stream)).toString();try{return JSON.parse(t)}catch(u){throw u.message+=`:
`+t,u}}function a(c){i(c)}let n;function i(c){const r=E.$fo.as(M.$ko.Configuration),t=n;n={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},r.updateConfigurations({add:[n],remove:t?[t]:[]})}i(1)}),define(ke[275],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x_b=void 0;class l{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const A=await this.c();if(A){const M=String(l.a++);return this.b.set(M,A),{id:M,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const M=this.b.get(L.id);if(!M)return!1;this.b.delete(L.id);try{return M.validate(A)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$x_b=l}),define(ke[111],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql="signService",e.$Rl=(0,l.$yi)(e.$Ql)}),define(ke[141],De([1,0,275]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;class O extends l.$x_b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(M=>new M.signer().sign(A))}h(){return new Promise((A,M)=>he(["vsda"],A,M))}}e.$tec=O}),define(ke[276],De([1,0,12,52,30]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=M,e.$ip=b;function A($){if(l.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function M($,E,I,P,p,S,v,d,f){const a=Object.create(null);a["common.machineId"]=S,a["common.sqmId"]=v,a.sessionID=(0,L.$Ug)()+Date.now(),a.commitHash=P,a.version=p,a["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,l.$h)(l.$u),a["common.nodePlatform"]=O.$dc,a["common.nodeArch"]=I,a["common.product"]=f||"desktop",d&&(a["common.msftInternal"]=d);let n=0;const i=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),l.$l&&(a["common.snap"]="true");const c=A(E);return c&&(a["common.platformDetail"]=c),a}function b($){const E=O.env.USERDNSDOMAIN;if(!E)return!1;const I=E.toLowerCase();return $.some(P=>I===P)}}),define(ke[277],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,l.$yi)("telemetryService"),e.$5l=(0,l.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ke[87],De([1,0,24,18,86,276,277]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$qp=I,e.$rp=P,e.$sp=p,e.$tp=S,e.$up=d,e.$vp=a,e.$wp=n,e.$xp=r;class b{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$jp=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$kp=$,e.$lp=new $;class E{async publicLog(u,s,o){}async publicLogError(u,s,o){}}e.$mp=E,e.$np="telemetry",e.$op="extensionTelemetryLog",e.$pp={log:()=>null,flush:()=>Promise.resolve(null)};function I(t,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!t.enableTelemetry)}function P(t,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function p(t){const u=t.getValue(M.$_l),s=t.getValue(M.$am);if(t.getValue(M.$bm)===!1||s===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function S(t){const u={},s={},o={};f(t,o);for(let h in o){h=h.length>150?h.substr(h.length-149):h;const g=o[h];typeof g=="number"?s[h]=g:typeof g=="boolean"?s[h]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${g.length}`),u[h]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(u[h]=g)}return{properties:u,measurements:s}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(t){if(!t)return"none";const u=(0,L.$Km)(t);return v.has(u)?u:"other"}function f(t,u,s=0,o){if(t)for(const h of Object.getOwnPropertyNames(t)){const g=t[h],w=o?o+h:h;Array.isArray(g)?u[w]=(0,l.$0n)(g):g instanceof Date?u[w]=g.toISOString():(0,O.$ag)(g)?s<2?f(g,u,s+1,w+"."):u[w]=(0,l.$0n)(g):u[w]=g}}function a(t,u){const s=t.msftInternalDomains||[],o=u.getValue("telemetry.internalTesting");return(0,A.$ip)(s)||o}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,u){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const o=[];for(const k of u)for(;;){const m=k.exec(t);if(!m)break;o.push([m.index,k.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(s="";;){const k=g.exec(t);if(!k)break;const m=o.some(([y,D])=>k.index<D&&y<g.lastIndex);!h.test(k[0])&&!m&&(s+=t.substring(w,k.index)+"<REDACTED: user-file-path>",w=g.lastIndex)}return w<t.length&&(s+=t.substr(w)),s}function c(t){if(!t)return t;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of u)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function r(t,u){return(0,l.$7n)(t,s=>{if(s instanceof b||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let o=s.replaceAll("%20"," ");o=i(o,u);for(const h of u)o=o.replace(h,"");return o=c(o),o}})}}),define(ke[278],De([1,0,14,138,25,12,2,13,52,87]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$zp=void 0,e.$yp=I,e.$Ap=v,e.$Bp=d,e.$Cp=f,e.$Dp=a,e.$Ep=n,e.$Fp=i,e.$Gp=c,e.$Ip=r,e.$Jp=u;function I(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,l.$uf)(s.id,o.id)===0}const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(o){const h=o.manifest?o.manifest.version:o.version,g=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new p(o.identifier,h,g)}static parse(o){const h=P.exec(o);return h&&h[1]&&h[2]?new p({id:h[1]},h[2],h[4]||void 0):null}constructor(o,h,g="undefined"){this.version=h,this.targetPlatform=g,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof p?I(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$zp=p;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(s){const o=S.exec(s);return o&&o[1]?[f(o[1]),o[2]]:[f(s),void 0]}function d(s,o){return`${s}.${o}`}function f(s){return s.toLowerCase()}function a(s,o){return f(d(s??L.$Pm,o))}function n(s,o){const h=[],g=w=>{for(const k of h)if(k.some(m=>I(o(m),o(w))))return k;return null};for(const w of s){const k=g(w);k?k.push(w):h.push([w])}return h}function i(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function c(s){return{id:new E.$jp(s.identifier.id),name:new E.$jp(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Hp=new L.$Tm("pprice.better-merge");function r(s,o){const h=[],g=o.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const w=g.shift();if(w&&h.every(k=>!I(k.identifier,{id:w}))){const k=s.filter(m=>I(m.identifier,{id:w}));k.length===1&&(h.push(k[0]),g.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function t(s,o){if(!A.$k)return!1;let h;try{h=(await s.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await s.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){o.debug("Error while getting the os-release file.",(0,b.$0)(w))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(s,o){const h=await t(s,o),g=(0,O.$6o)(h?"alpine":A.$u,$.$ec);return o.debug("ComputeTargetPlatform:",g),g}}),define(ke[279],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=l,e.$qs=O,e.$rs=L,e.$ss=A,e.$ts=M,e.$us=b;function l($){return[...$.entries()]}function O($){return $?[...$.entries()]:[]}function L($){return new Map($)}function A($){return new Map($??[])}function M($){return Array.from($.entries()).map(E=>[E[0],l(E[1].map),O(E[1].descriptionMap)])}function b($){return new Map($.map(E=>[E[0],{map:L(E[1]),descriptionMap:A(E[2])}]))}}),define(ke[280],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_vb=void 0;class l{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,A,M=5){const b=A($=>{const E=typeof $=="string"?$:$.data;let I=this.a.get(L);if(I){I.data.push(E);return}const P=setTimeout(()=>this.flushBuffer(L),M);I={data:[E],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(L),b.dispose()}},this.a.set(L,I)});return b}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const A=this.a.get(L);A&&(this.a.delete(L),this.b(L,A.data.join("")))}}e.$_vb=l}),define(ke[281],De([1,0,7,79,99,50,4,18,2,221,110,36]),function(he,e,l,O,L,A,M,b,$,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qx=e.$px=e.$ox=e.$nx=e.$mx=e.$lx=e.IconFontDefinition=e.IconContribution=e.$ix=void 0,e.$jx=f,e.$kx=a,e.$ix={IconContribution:"base.contributions.icons"};var p;(function(r){function t(u,s){let o=u.defaults;for(;A.ThemeIcon.isThemeIcon(o);){const h=d.getIcon(o.id);if(!h)return;o=h.defaults}return o}r.getDefinition=t})(p||(e.IconContribution=p={}));var S;(function(r){function t(s){return{weight:s.weight,style:s.style,src:s.src.map(o=>({format:o.format,location:o.location.toString()}))}}r.toJSONObject=t;function u(s){const o=h=>(0,b.$$f)(h)?h:void 0;if(s&&Array.isArray(s.src)&&s.src.every(h=>(0,b.$$f)(h.format)&&(0,b.$$f)(h.location)))return{weight:o(s.weight),style:o(s.style),src:s.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}r.fromJSONObject=u})(S||(e.IconFontDefinition=S={}));class v{constructor(){this.a=new M.$fe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,u,s,o){const h=this.b[t];if(h){if(s&&!h.description){h.description=s,this.d.properties[t].markdownDescription=`${s} $(${t})`;const k=this.e.enum.indexOf(t);k!==-1&&(this.e.enumDescriptions[k]=s),this.a.fire()}return h}const g={id:t,description:s,defaults:u,deprecationMessage:o};this.b[t]=g;const w={$ref:"#/definitions/icons"};return o&&(w.deprecationMessage=o),s&&(w.markdownDescription=`${s}: $(${t})`),this.d.properties[t]=w,this.e.enum.push(t),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const u=this.e.enum.indexOf(t);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,u){const s=this.f[t];return s||(this.f[t]=u,this.a.fire(),u)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(h,g)=>h.id.localeCompare(g.id),u=h=>{for(;A.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(h=>this.b[h]);for(const h of o.filter(g=>!!g.description).sort(t))s.push(`|<i class="${u(h)}"></i>|${h.id}|${A.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const h of o.filter(g=>!A.ThemeIcon.isThemeIcon(g.defaults)).sort(t))s.push(`|<i class="${u(h)}"></i>|${h.id}|`);return s.join(`
`)}}const d=new v;P.$fo.add(e.$ix.IconContribution,d);function f(r,t,u,s){return d.registerIcon(r,t,u,s)}function a(){return d}function n(){const r=(0,L.$Tj)();for(const t in r){const u="\\"+r[t].toString(16);d.registerIcon(t,{fontCharacter:u})}}n(),e.$lx="vscode://schemas/icons";const i=P.$fo.as(I.$go.JSONContribution);i.registerSchema(e.$lx,d.getIconSchema());const c=new l.$Kh(()=>i.notifySchemaChanged(e.$lx),200);d.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$mx=f("widget-close",O.$Xj.close,(0,E.localize)(2,null)),e.$nx=f("goto-previous-location",O.$Xj.arrowUp,(0,E.localize)(3,null)),e.$ox=f("goto-next-location",O.$Xj.arrowDown,(0,E.localize)(4,null)),e.$px=A.ThemeIcon.modify(O.$Xj.sync,"spin"),e.$qx=A.ThemeIcon.modify(O.$Xj.loading,"spin")}),define(ke[88],De([1,0,4,2,55,5,11]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xw=e.$ww=e.$tw=e.$rw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$nw=e.$mw=void 0,e.$ow=E,e.$pw=P,e.$qw=p,e.$sw=S,e.$uw=v,e.$vw=d,e.$mw=(0,A.$yi)("tunnelService"),e.$nw=(0,A.$yi)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(n){return!!n.forwardPort}var I;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(I||(e.ProvidedOnAutoForward=I={}));function P(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function p(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const c of i){const r=c.split("=")[1];if(/^https?:/.exec(r)){const t=P(O.URI.parse(r));if(t)return t}}}e.$rw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(n){return e.$rw.indexOf(n)>=0}e.$tw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$tw.indexOf(n)>=0}function d(n,i,c,r){if(c===1)return!1;if(c===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class f{constructor(i,c,r){this.remoteAddress=i,this.localAddress=c,this.b=r,this.a=new l.$fe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$ww=f;let a=class{constructor(i,c){this.k=i,this.l=c,this.a=new l.$fe,this.onTunnelOpened=this.a.event,this.b=new l.$fe,this.onTunnelClosed=this.b.event,this.c=new l.$fe,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],c=Array.from(this.e.values());for(const r of c){const t=Array.from(r.values());for(const u of t){const s=await u.value;s&&typeof s!="string"&&i.push(s)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(r=>typeof r!="string"?r?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,r,t,u){this.q(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:r,privacy:t,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(v(i)||S(i))&&(i=e.$rw[0]);const r=this.s(i,c);if(r)return++r.refcount,r.value}openTunnel(i,c,r,t,u,s=!1,o,h){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${r} on local port ${u}.`);const g=this.f??i;if(!g)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.t(g,c,r,t,u,s,o,h);return w?w.then(k=>{if(k){if(typeof k=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,r),k}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.o(k);return(k.tunnelRemoteHost!==c||k.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&k.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const r=c.get(i.tunnelRemotePort);r&&(r.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,r))}}}}async p(i,c,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const t=r.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),t}}async closeTunnel(i,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const r=this.e.get(i);if(r&&r.has(c)){const t=r.get(c);t.refcount=0,await this.p(i,c,t)}}q(i,c,r){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:r})}async r(i,c){const r=this.e.get(i);if(r){const t=r.get(c),u=t?await t.value:void 0;(!u||typeof u=="string")&&r.delete(c),r.size===0&&this.e.delete(i)}}s(i,c){const r=[i];S(i)?(r.push(...e.$rw),r.push(...e.$tw)):v(i)&&r.push(...e.$tw);const t=r.map(u=>this.e.get(u));for(const u of t){const s=u?.get(c);if(s)return s}}canTunnel(i){return!!P(i)}u(i,c,r,t,u,s,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${r} on local port ${t}.`);const h=r;this.j.add(h);const g=t===void 0?r:t,w={elevationRequired:u?this.isPortPrivileged(g):!1},k={remoteAddress:{host:c,port:r},localAddressPort:t,privacy:s,public:s?s!==$.Private:void 0,protocol:o},m=i.forwardPort(k,w);return m?(this.q(c,r,m),m.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(h)})):this.j.delete(h),m}};e.$xw=a,e.$xw=a=Je([We(0,M.$5j),We(1,L.$5i)],a)}),define(ke[282],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,l.$yi)("IUriIdentityService")}),define(ke[283],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$yw=void 0,e.$yw=(0,l.$yi)("editSessionIdentityService");var O;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(ke[284],De([1,0,15]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=O,e.$TL=L,e.$UL=A,e.$VL=M,e.$WL=b;function O($){return $.scheme!==l.Schemas.file&&$.scheme!==l.Schemas.vscodeRemote}function L($){if($.folders.length)return $.folders.every(E=>O(E.uri))?$.folders[0].uri:void 0;if($.configuration&&O($.configuration))return $.configuration}function A($){return L($)?.scheme}function M($){return L($)?.authority}function b($){return L($)!==void 0}}),define(ke[42],De([1,0,223,16,78,23,2,5,15]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=E,e.$Ji=I,e.$Mi=P,e.$Ni=p,e.$Oi=S,e.$Pi=d,e.$Qi=f,e.$Ti=i,e.$Yi=c,e.$Zi=r,e.$2i=t,e.$3i=u,e.$4i=s,e.$Hi=(0,b.$yi)("contextService");function E(o){const h=o;return typeof h?.id=="string"&&M.URI.isUri(h.uri)}function I(o){return typeof o?.id=="string"&&!E(o)&&!p(o)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function P(o,h){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,O.$nc)(o)}:h?e.$Ki:e.$Li;const g=o;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}function p(o){const h=o;return typeof h?.id=="string"&&M.URI.isUri(h.configPath)}function S(o){const h=o;if(h?.uri)return{id:h.id,uri:M.URI.revive(h.uri)};const g=o;if(g?.configPath)return{id:g.id,configPath:M.URI.revive(g.configPath)};if(o?.id)return{id:o.id}}var v;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function d(o){const h=o;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function f(o){const h=o;return!!(h&&typeof h=="object"&&M.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class a{constructor(h,g,w,k,m){this.h=h,this.j=w,this.k=k,this.l=m,this.c=L.$Ei.forUris(this.l,()=>!0),this.folders=g}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=L.$Ei.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=a;class n{constructor(h,g){this.raw=g,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,A.$_g)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=n;function i(o){return new n({uri:o,index:0,name:(0,A.$8g)(o)},{uri:o.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,l.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function c(o,h){return A.$3g.isEqualOrParent(o,h.untitledWorkspacesHome)}function r(o){let h;return M.URI.isUri(o)?h=o:h=o.configuration,h?.scheme===$.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(o){return o.id===e.$1i}function u(o,h){return!c(o,h)&&!r(o)}function s(o){return(typeof o=="string"?(0,O.$oc)(o):(0,A.$0g)(o))===e.$Vi}}),define(ke[285],De([1,0,57,4,3,23,2,222,137,33,5,11,42,27,282,7,30,14,18]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=c,e.$Fl=r,e.$Gl=t;var i;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function c(o){const h=o;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&M.URI.isUri(h.location)&&M.URI.isUri(h.globalStorageHome)&&M.URI.isUri(h.settingsResource)&&M.URI.isUri(h.keybindingsResource)&&M.URI.isUri(h.tasksResource)&&M.URI.isUri(h.snippetsHome)&&M.URI.isUri(h.extensionsResource))}e.$El=(0,I.$yi)("IUserDataProfilesService");function r(o,h){return{id:o.id,isDefault:o.isDefault,name:o.name,shortName:o.shortName,icon:o.icon,location:M.URI.revive(o.location).with({scheme:h}),globalStorageHome:M.URI.revive(o.globalStorageHome).with({scheme:h}),settingsResource:M.URI.revive(o.settingsResource).with({scheme:h}),keybindingsResource:M.URI.revive(o.keybindingsResource).with({scheme:h}),tasksResource:M.URI.revive(o.tasksResource).with({scheme:h}),snippetsHome:M.URI.revive(o.snippetsHome).with({scheme:h}),extensionsResource:M.URI.revive(o.extensionsResource).with({scheme:h}),cacheHome:M.URI.revive(o.cacheHome).with({scheme:h}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}function t(o,h,g,w,k,m){return{id:o,name:h,location:g,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:m&&k?.useDefaultFlags?.globalState?m.globalStorageHome:(0,A.$_g)(g,"globalStorage"),settingsResource:m&&k?.useDefaultFlags?.settings?m.settingsResource:(0,A.$_g)(g,"settings.json"),keybindingsResource:m&&k?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,A.$_g)(g,"keybindings.json"),tasksResource:m&&k?.useDefaultFlags?.tasks?m.tasksResource:(0,A.$_g)(g,"tasks.json"),snippetsHome:m&&k?.useDefaultFlags?.snippets?m.snippetsHome:(0,A.$_g)(g,"snippets"),extensionsResource:m&&k?.useDefaultFlags?.extensions?m.extensionsResource:(0,A.$_g)(g,"extensions.json"),cacheHome:(0,A.$_g)(w,o),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}let u=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,g,w,k){super(),this.t=h,this.u=g,this.w=w,this.y=k,this.f=!0,this.h=this.B(new O.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),g=[h];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,n.$$f)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}g.push(t((0,A.$9g)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},h))}}catch(m){this.y.error(m)}const w=new S.$Ac,k=new Map;if(g.length)try{const m=this.Q();if(m.workspaces)for(const[y,D]of Object.entries(m.workspaces)){const C=M.URI.parse(y),R=g.find(T=>T.id===D);R&&w.set(C,R)}if(m.emptyWindows)for(const[y,D]of Object.entries(m.emptyWindows)){const C=g.find(R=>R.id===D);C&&k.set(y,C)}}catch(m){this.y.error(m)}this.z={profiles:g,workspaces:w,emptyWindows:k}}return this.z}D(){const h=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const g="Temp",w=new RegExp(`${(0,a.$bf)(g)}\\s(\\d+)`);let k=0;for(const y of this.profiles){const D=w.exec(y.name),C=D?parseInt(D[1]):0;k=C>k?C:k}const m=`${g} ${k+1}`;return this.createProfile((0,l.$mj)((0,f.$Ug)()).toString(16),m,{transient:!0},h)}async createNamedProfile(h,g,w){return this.createProfile((0,l.$mj)((0,f.$Ug)()).toString(16),h,g,w)}async createProfile(h,g,w,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(h,g,w);return k&&await this.setProfileForWorkspace(k,m),m}async F(h,g,w){if(!(0,n.$$f)(g)||!g)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(g);return k||(k=(async()=>{try{if(this.profiles.find(C=>C.name===g||C.id===h))throw new Error(`Profile with ${g} name already exists`);const y=t(h,g,(0,A.$_g)(this.profilesHome,h),this.g,w,this.defaultProfile);await this.u.createFolder(y.location);const D=[];return this.j.fire({profile:y,join(C){D.push(C)}}),await d.Promises.settled(D),this.I([y],[],[]),y}finally{this.r.delete(g)}})(),this.r.set(g,k)),k}async updateProfile(h,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let w=this.profiles.find(k=>k.id===h.id);if(!w)throw new Error(`Profile '${h.name}' does not exist`);return w=t(w.id,g.name??w.name,w.location,this.g,{shortName:g.shortName??w.shortName,icon:g.icon===null?void 0:g.icon??w.icon,transient:g.transient??w.isTransient,useDefaultFlags:g.useDefaultFlags??w.useDefaultFlags},this.defaultProfile),this.I([],[],[w]),w}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const g=this.profiles.find(k=>k.id===h.id);if(!g)throw new Error(`Profile '${h.name}' does not exist`);const w=[];this.m.fire({profile:g,join(k){w.push(k)}});try{await Promise.allSettled(w)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])g.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])g.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[g],[]);try{await this.u.del(g.cacheHome,{recursive:!0})}catch(k){(0,E.$jl)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(h,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=this.profiles.find(k=>k.id===g.id);if(!w)throw new Error(`Profile '${g.name}' does not exist`);this.L(h,w)}unsetWorkspace(h,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,g)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(g=>g.isDirectory&&this.profiles.every(w=>!this.w.extUri.isEqual(w.location,g.resource))).map(g=>this.u.del(g.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(g=>!this.H(g));await Promise.allSettled(h.map(g=>this.removeProfile(g)))}getProfileForWorkspace(h){const g=this.G(h);return M.URI.isUri(g)?this.s.workspaces.get(g)??this.C.workspaces.get(g):this.s.emptyWindows.get(g)??this.C.emptyWindows.get(g)}G(h){return(0,p.$Ii)(h)?h.uri:(0,p.$Ni)(h)?h.configPath:h.id}H(h){return!!([...this.s.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,h.location))||[...this.s.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,h.location))||[...this.C.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,h.location))||[...this.C.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,h.location)))}I(h,g,w){const k=[...this.profiles,...h],m=[];this.s.profiles=[];for(let y of k)y.isDefault||g.some(D=>y.id===D.id)||(y=w.find(D=>y.id===D.id)??y,y.isTransient?this.s.profiles.push(y):m.push({location:y.location,name:y.name,shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags}));this.P(m),this.z=void 0,this.J(h,g,w)}J(h,g,w){this.h.fire({added:h,removed:g,updated:w,all:this.profiles})}L(h,g,w){w=g?.isTransient?!0:w,w||this.L(h,void 0,!0);const k=this.G(h),m=w?this.s:this.C;M.URI.isUri(k)?(m.workspaces.delete(k),g&&m.workspaces.set(k,g)):(m.emptyWindows.delete(k),g&&m.emptyWindows.set(k,g)),w||this.M()}M(){const h={};for(const[w,k]of this.C.workspaces.entries())h[w.toString()]=k.id;const g={};for(const[w,k]of this.C.emptyWindows.entries())g[w.toString()]=k.id;this.R({workspaces:h,emptyWindows:g}),this.z=void 0}N(h){const g={},w=this.D();if(h.workspaces)for(const[m,y]of Object.entries(h.workspaces)){const D=M.URI.parse(y);g[m]=this.w.extUri.isEqual(D,w.location)?w.id:this.w.extUri.basename(D)}const k={};if(h.emptyWindows)for(const[m,y]of Object.entries(h.emptyWindows)){const D=M.URI.parse(y);k[m]=this.w.extUri.isEqual(D,w.location)?w.id:this.w.extUri.basename(D)}return{workspaces:g,emptyWindows:k}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$Hl=u,e.$Hl=u=Je([We(0,$.$Fi),We(1,E.$5k),We(2,v.$Cl),We(3,P.$5j)],u);class s extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$Il=s}),define(ke[142],De([1,0,7,4,3,59,18,200,5,285]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$7p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$5p=e.$4p=e.$3p=void 0,e.$6p=S,e.$8p=d,e.$0p=a,e.$3p="__$__isNewStorageMarker",e.$4p="__$__targetStorageMarker",e.$5p=(0,$.$yi)("storageService");var I;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var P;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var p;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function S(n){const i=n.get(e.$4p);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends L.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new O.$ie),this.c=this.B(new O.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new l.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,c,r){return O.Event.filter(this.b.event,t=>t.scope===i&&(c===void 0||t.key===c),r)}n(){this.j.value=(0,l.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,c){const{key:r,external:t}=c;if(r===e.$4p){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:r,target:this.J(i)[r],external:t})}w(i){this.f.fire({reason:i})}get(i,c,r){return this.P(c)?.get(i,r)}getBoolean(i,c,r){return this.P(c)?.getBoolean(i,r)}getNumber(i,c,r){return this.P(c)?.getNumber(i,r)}getObject(i,c,r){return this.P(c)?.getObject(i,r)}storeAll(i,c){this.y(()=>{for(const r of i)this.store(r.key,r.value,r.scope,r.target,c)})}store(i,c,r,t,u=!1){if((0,M.$hg)(c)){this.remove(i,r,u);return}this.y(()=>{this.z(i,r,t),this.P(r)?.set(i,c,u)})}remove(i,c,r=!1){this.y(()=>{this.z(i,c,void 0),this.P(c)?.delete(i,r)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,c){const r=[],t=this.J(i);for(const u of Object.keys(t))t[u]===c&&r.push(u);return r}z(i,c,r,t=!1){const u=this.J(c);typeof r=="number"?u[i]!==r&&(u[i]=r,this.P(c)?.set(e.$4p,JSON.stringify(u),t)):typeof u[i]=="number"&&(delete u[i],this.P(c)?.set(e.$4p,JSON.stringify(u),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const c=this.P(i);return c?S(c):Object.create(null)}isNew(i){return this.getBoolean(e.$3p,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const c=this.P(-1),r=this.P(0),t=this.P(1);switch(i){case I.NONE:await l.Promises.settled([c?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await l.Promises.settled([c?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,r=this.P(1)?.items??new Map;return a(i,c,r,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,c){return this.w(I.NONE),(0,E.$Dl)(i)?this.R(i,c):this.S(i,c)}M(i,c){return!(i.id===c.id||d(c)&&d(i))}N(i,c,r){this.y(()=>{const t=new Set;for(const[u,s]of i)t.add(u),c.get(u)!==s&&this.u(r,{key:u,external:!0});for(const[u]of c.items)t.has(u)||this.u(r,{key:u,external:!0})})}}e.$7p=v;function d(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class f extends v{constructor(){super(),this.U=this.B(new b.$1p(new b.$2p,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$1p(new b.$2p,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$1p(new b.$2p,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$9p=f;async function a(n,i,c,r,t,u){const s=C=>{try{return JSON.parse(C)}catch{return C}},o=new Map,h=new Map;n.forEach((C,R)=>{o.set(R,C),h.set(R,s(C))});const g=new Map,w=new Map;i.forEach((C,R)=>{g.set(R,C),w.set(R,s(C))});const k=new Map,m=new Map;c.forEach((C,R)=>{k.set(R,C),m.set(R,s(C))}),console.group(r!==t?`Storage: Application (path: ${r})`:`Storage: Application & Profile (path: ${r}, default profile)`);const y=[];if(o.forEach((C,R)=>{y.push({key:R,value:C})}),console.table(y),console.groupEnd(),console.log(h),r!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];g.forEach((R,T)=>{C.push({key:T,value:R})}),console.table(C),console.groupEnd(),console.log(w)}console.group(`Storage: Workspace (path: ${u})`);const D=[];k.forEach((C,R)=>{D.push({key:R,value:C})}),console.table(D),console.groupEnd(),console.log(m)}}),define(ke[112],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;class l{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const A=this.c++;return this.b.set(A,L),this.e(),A}get(L,A){return this.b.has(L)?this.b.get(L)[A]:void 0}delete(L){this.b.delete(L),this.e()}e(){l.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$1lc=l}),define(ke[60],De([1,0,15,23,5]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=e.$6lc=void 0;class A{constructor(){this.a=new Set(Object.keys(l.Schemas)),this.b=new Map,this.extUri=new O.$1g(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$6lc=A,e.$7lc=(0,L.$yi)("IExtHostFileSystemInfo")}),define(ke[28],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=void 0,e.$4O=(0,l.$yi)("IExtHostInitDataService")}),define(ke[286],De([1,0,228,11,266,28]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=void 0;let M=class extends L.$bQ{constructor($,E,I){const P=I.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",p=I.remote.isRemote?(0,l.localize)(0,null):$?(0,l.localize)(1,null):(0,l.localize)(2,null);super(E.createLogger(P,{name:p}))}};e.$aoc=M,e.$aoc=M=Je([We(1,O.$6j),We(2,A.$4O)],M)}),define(ke[287],De([1,0,7]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=e.$Lmc=void 0;class O{constructor(M,b,$){this.h=new Map,this.a=M,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new l.$Kh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of E.values())I.complete()}catch(I){for(const P of E.values())P.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,b){let $=this.f[M];return typeof $>"u"&&($=b),$}update(M,b){this.f[M]=b;const $=this.h.get(M);if($!==void 0)return $.p;const E=new l.$Vh;return this.h.set(M,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Lmc=O;class L extends O{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,b){super(M.identifier.value,!0,b),this.j=M}}e.$Mmc=L}),define(ke[288],De([1,0,4,2]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=void 0;class L{constructor(M){this.c=M,this.a=new l.$fe,this.onDidSaveNotebookDocument=this.a.event,this.b=new l.$fe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,b,$,E){const P=this.c.getNotebookDocument(O.URI.revive(M)).acceptModelChanged(b.value,$,E);this.b.fire(P)}$acceptDirtyStateChanged(M,b){this.c.getNotebookDocument(O.URI.revive(M)).acceptDirty(b)}$acceptModelSaved(M){const b=this.c.getNotebookDocument(O.URI.revive(M));this.a.fire(b.apiNotebook)}}e.$Anc=L}),define(ke[20],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OO=e.$NO=void 0,e.$NO=(0,l.$yi)("IExtHostRpcService");class O{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$OO=O}),define(ke[289],De([1,0,25,4]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;class L{#e;constructor(M,b){this.b=new O.$fe,this.onDidChange=this.b.event,this.a=l.$Tm.toKey(M.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(M){return this.#e.get(this.a,M)}store(M,b){return this.#e.store(this.a,M,b)}delete(M){return this.#e.delete(this.a,M)}}e.$Vmc=L}),define(ke[68],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=e.$jmc=void 0,e.$jmc=(0,l.$yi)("IURITransformerService");class O{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$kmc=O}),define(ke[290],De([1,0,22]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$rb=L,e.$_rb=M;class O{constructor(){this.buffers=[]}add($){let E=this.buffers.indexOf($);return E<0&&(E=this.buffers.length,this.buffers.push($)),E}}function L(b,$){if($.serializeBuffersForPostMessage){const E=new O,P=JSON.stringify(b,(S,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(v)};if(ArrayBuffer.isView(v)){const d=A(v);if(d)return{$$vscode_array_buffer_reference$$:!0,index:E.add(v.buffer),view:{type:d,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),p=E.buffers.map(S=>{const v=new Uint8Array(S);return l.$He.wrap(v)});return{message:P,buffers:p}}else return{message:JSON.stringify(b),buffers:[]}}function A(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(b,$){const E=$.map(p=>{const S=new ArrayBuffer(p.byteLength);return new Uint8Array(S).set(p.buffer),S}),I=$.length?(p,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const v=S,{index:d}=v,f=E[d];if(v.view)switch(v.view.type){case 1:return new Int8Array(f,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return S}:void 0;return{message:JSON.parse(b,I),arrayBuffers:E}}}),define(ke[291],De([1,0,292,403,404,63,2,11,405]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ioc=I;const E=!1;function I(i,c,r,t,u,s){const o=s.environment.useHostProxy,h=typeof o=="boolean"?o:!s.remote.isRemote,g={resolveProxy:m=>i.resolveProxy(m),lookupProxyAuthorization:f.bind(void 0,t,u,c,{},s.remote.isRemote),getProxyURL:()=>c.getConfiguration("http").get("proxy"),getProxySupport:()=>c.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(c),addCertificatesV2:()=>S(c),log:t,getLogLevel:()=>{const m=t.getLevel();switch(m){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return y(m)}function y(D){return t.error("Unknown log level",D),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:h,loadAdditionalCertificates:async()=>{const m=[];if(s.remote.isRemote&&m.push((0,$.loadSystemCertificates)({log:t})),h){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const y=i.loadCertificates();y.then(D=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",D.length)),m.push(y)}return(await Promise.all(m)).flat()},env:process.env},w=(0,$.createProxyResolver)(g),k=P(g,w);return d(r,k)}function P(i,c){return{http:Object.assign(l,(0,$.createHttpPatch)(i,l,c)),https:Object.assign(O,(0,$.createHttpPatch)(i,O,c)),net:Object.assign(A,(0,$.createNetPatch)(i,A)),tls:Object.assign(L,(0,$.createTlsPatch)(i,L))}}function p(i){const c=i.getConfiguration("http");return!c.get("experimental.systemCertificatesV2",E)&&!!c.get("systemCertificates")}function S(i){const c=i.getConfiguration("http");return!!c.get("experimental.systemCertificatesV2",E)&&!!c.get("systemCertificates")}const v=new Map;function d(i,c){return i.getExtensionPathIndex().then(r=>{const t=globalThis._VSCODE_NODE_MODULES.module,u=t._load;t._load=function(o,h,g){if(o==="net")return c.net;if(o==="tls")return c.tls;if(o!=="http"&&o!=="https")return u.apply(this,arguments);const w=r.findSubstr(M.URI.file(h.filename));let k=v.get(w);if(k||v.set(w,k={}),!k[o]){const m=c[o];k[o]={...m}}return k[o]}})}async function f(i,c,r,t,u,s,o,h){const g=t[s];o&&(t[s]=o),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${o}`,`proxyAuthenticateCache:${g}`);const w=o||g,k=Array.isArray(w)?w:typeof w=="string"?[w]:[];if(n(c,k,u),k.some(m=>/^(Negotiate|Kerberos)( |$)/i.test(m))&&!h.kerberosRequested)try{h.kerberosRequested=!0;const m=await new Promise((T,j)=>{he(["kerberos"],T,j)}),y=new URL(s),D=r.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${y.hostname}`:`HTTP@${y.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${D}`),"Negotiate "+await(await m.initializeClient(D)).step("")}catch(m){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",m)}}let a=!1;function n(i,c,r){a||!c.length||(a=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:c.map(t=>t.split(" ")[0]).join(","),extensionHostType:r?"remote":"local"}))}}),define(ke[293],De([1,0,134]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=L;function O(A){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:A,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function L(A){return new l.$An(O(A))}}),define(ke[143],De([1,0,238,18,2,3,5,36,33,15,47,192,41]),function(he,e,l,O,L,A,M,b,$,E,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$VF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$MF=e.EditorInputCapabilities=e.$LF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=void 0,e.$CF=d,e.$DF=f,e.$EF=a,e.$FF=n,e.$GF=i,e.$HF=c,e.$IF=r,e.$JF=t,e.$KF=u,e.$NF=k,e.$OF=y,e.$PF=D,e.$QF=C,e.$RF=R,e.$SF=T,e.$TF=j,e.$UF=re,e.$WF=_,e.$XF=$e,e.$YF=oe,e.$ZF=Pe,e.$xF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$yF={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.$zF="workbench.editor.sidebysideEditor",e.$AF="workbench.editors.textDiffEditor",e.$BF="workbench.editors.binaryResourceDiffEditor";var S;(function(te){te[te.PROGRAMMATIC=1]="PROGRAMMATIC",te[te.USER=2]="USER",te[te.EDIT=3]="EDIT",te[te.NAVIGATION=4]="NAVIGATION",te[te.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var v;(function(te){te[te.IDENTICAL=1]="IDENTICAL",te[te.SIMILAR=2]="SIMILAR",te[te.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function d(te){const U=te;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function f(te){const U=te;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function a(te,U,ee){for(const be of ee.visibleEditorPanes)if(be.group.id===U&&te.matches(be.input))return be.getViewState()}function n(te){if(k(te))return!1;const U=te;return L.URI.isUri(U?.resource)}function i(te){if(k(te))return!1;const U=te;return U?.original!==void 0&&U.modified!==void 0}function c(te){if(k(te))return!1;const U=te;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function r(te){if(k(te)||i(te))return!1;const U=te;return U?.primary!==void 0&&U.secondary!==void 0}function t(te){if(k(te))return!1;const U=te;return U?U.resource===void 0||U.resource.scheme===E.Schemas.untitled||U.forceUntitled===!0:!1}function u(te){if(k(te))return!1;const U=te;return L.URI.isUri(U?.base?.resource)&&L.URI.isUri(U?.input1?.resource)&&L.URI.isUri(U?.input2?.resource)&&L.URI.isUri(U?.result?.resource)}var s;(function(te){te[te.SHORT=0]="SHORT",te[te.MEDIUM=1]="MEDIUM",te[te.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var o;(function(te){te[te.EXPLICIT=1]="EXPLICIT",te[te.AUTO=2]="AUTO",te[te.FOCUS_CHANGE=3]="FOCUS_CHANGE",te[te.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class h{constructor(){this.a=new Map}registerSource(U,ee){let be=this.a.get(U);return be||(be={source:U,label:ee},this.a.set(U,be)),be.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$LF=new h;var g;(function(te){te[te.None=0]="None",te[te.Readonly=2]="Readonly",te[te.Untitled=4]="Untitled",te[te.Singleton=8]="Singleton",te[te.RequiresTrust=16]="RequiresTrust",te[te.CanSplitInGroup=32]="CanSplitInGroup",te[te.ForceDescription=64]="ForceDescription",te[te.CanDropIntoEditor=128]="CanDropIntoEditor",te[te.MultipleEditors=256]="MultipleEditors",te[te.Scratchpad=512]="Scratchpad"})(g||(e.EditorInputCapabilities=g={}));class w extends A.$Uc{}e.$MF=w;function k(te){return te instanceof w}function m(te){const U=te;return L.URI.isUri(U?.preferredResource)}function y(te){const U=te;return k(U?.primary)&&k(U?.secondary)}function D(te){const U=te;return k(U?.modified)&&k(U?.original)}function C(te,U,ee,be,ue){return Pe(be,[(0,P.$ij)({id:"workbench.action.openLargeFile",label:(0,l.localize)(2,null),run:()=>{const ce={...ee,limits:{size:Number.MAX_VALUE}};te.openEditor(U,ce)}}),(0,P.$ij)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,l.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}function R(te){return k(te?.editor)}function T(te){const U=te;return R(te)&&U?.group!==void 0}function j(te){const U=te;return typeof U?.groupId=="number"&&k(U.editor)}var z;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.REPLACE=1]="REPLACE",te[te.MOVE=2]="MOVE",te[te.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var N;(function(te){te[te.GROUP_ACTIVE=0]="GROUP_ACTIVE",te[te.GROUP_INDEX=1]="GROUP_INDEX",te[te.GROUP_LABEL=2]="GROUP_LABEL",te[te.GROUP_LOCKED=3]="GROUP_LOCKED",te[te.EDITOR_OPEN=4]="EDITOR_OPEN",te[te.EDITOR_CLOSE=5]="EDITOR_CLOSE",te[te.EDITOR_MOVE=6]="EDITOR_MOVE",te[te.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",te[te.EDITOR_LABEL=8]="EDITOR_LABEL",te[te.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",te[te.EDITOR_PIN=10]="EDITOR_PIN",te[te.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",te[te.EDITOR_STICKY=12]="EDITOR_STICKY",te[te.EDITOR_DIRTY=13]="EDITOR_DIRTY",te[te.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var F;(function(te){te[te.PRIMARY=1]="PRIMARY",te[te.SECONDARY=2]="SECONDARY",te[te.BOTH=3]="BOTH",te[te.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class B{getOriginalUri(U,ee){if(!U)return;if(u(U))return e.$VF.getOriginalUri(U.result,ee);if(ee?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(U);if(ue&&ce){if(ee?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===F.ANY)return this.getOriginalUri(ue,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:ee.filterByScheme});U=ee.supportSideBySide===F.PRIMARY?ue:ce}}if(i(U)||c(U)||r(U)||u(U))return;const be=m(U)?U.preferredResource:U.resource;return!be||!ee||!ee.filterByScheme?be:this.b(be,ee.filterByScheme)}a(U){return y(U)||r(U)?{primary:U.primary,secondary:U.secondary}:D(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,ee){if(!U)return;if(u(U))return e.$VF.getCanonicalUri(U.result,ee);if(ee?.supportSideBySide){const{primary:ue,secondary:ce}=this.a(U);if(ue&&ce){if(ee?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===F.ANY)return this.getCanonicalUri(ue,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:ee.filterByScheme});U=ee.supportSideBySide===F.PRIMARY?ue:ce}}if(i(U)||c(U)||r(U)||u(U))return;const be=U.resource;return!be||!ee||!ee.filterByScheme?be:this.b(be,ee.filterByScheme)}b(U,ee){if(Array.isArray(ee)){if(ee.some(be=>U.scheme===be))return U}else if(ee===U.scheme)return U}}var Y;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.KEYBOARD=1]="KEYBOARD",te[te.MOUSE=2]="MOUSE"})(Y||(e.EditorCloseMethod=Y={}));function re(te,U,ee,be){if(!te.isSticky(U))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return ee===Y.MOUSE||ee===Y.KEYBOARD;case"mouse":return ee===Y.MOUSE;case"keyboard":return ee===Y.KEYBOARD}return!1}e.$VF=new B;var H;(function(te){te[te.LEFT=0]="LEFT",te[te.RIGHT=1]="RIGHT"})(H||(e.CloseDirection=H={}));class K{constructor(){this.c=new Map,this.d=new Map}start(U){const ee=this.a=U.get(M.$xi);for(const[be,ue]of this.c)this.e(be,ue,ee);this.c.clear()}e(U,ee,be){const ue=be.createInstance(ee);this.d.set(U,ue)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,O.$jg)(this.b)}registerEditorSerializer(U,ee){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,ee,this.a):this.c.set(U,ee),(0,A.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}b.$fo.add(e.$xF.EditorFactory,new K);async function _(te,U,ee){return!te||!te.length?[]:await Promise.all(te.map(async be=>{const ue=L.URI.revive(be.fileUri);if(!ue){ee.info("Cannot resolve the path because it is not valid.",be);return}if(!await U.canHandleResource(ue)){ee.info("Cannot resolve the path because it cannot be handled",be);return}let ae=be.exists,le=be.type;if(typeof ae!="boolean"||typeof le!="number")try{le=(await U.stat(ue)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ae=!0}catch(se){ee.error(se),ae=!1}if(!ae&&be.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",be);return}if(le===$.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",be);return}const J={...be.options,pinned:!0};return ae?{resource:ue,options:J}:{resource:ue,options:J,forceUntitled:!0}}))}var Z;(function(te){te[te.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",te[te.SEQUENTIAL=1]="SEQUENTIAL"})(Z||(e.EditorsOrder=Z={}));function $e(te){const U=te;if(!U)return!1;const ee=U;if(ee.modified)return $e(ee.modified);const be=U;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function oe(te){return(0,I.$kj)(te)}function Pe(te,U,ee){const be=(0,I.$lj)(te,U);return be.forceMessage=ee?.forceMessage,be.forceSeverity=ee?.forceSeverity,be.allowDialog=ee?.allowDialog,be}}),define(ke[294],De([1,0,4,239,5,3,27,36,24,79,281]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=e.$7F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$6F=e.ViewContentGroups=e.$4F=e.ViewContainerLocation=e.Extensions=e.$3F=e.$2F=e.$1F=void 0,e.$5F=S,e.$1F="views",e.$2F=(0,O.localize)(0,null),e.$3F=(0,I.$jx)("default-view-icon",E.$Xj.window,(0,O.localize)(1,null));var P;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(P||(e.Extensions=P={}));var p;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$4F=[0,1,2];function S(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class v extends A.$Uc{constructor(){super(...arguments),this.c=this.B(new l.$fe),this.onDidRegister=this.c.event,this.f=this.B(new l.$fe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(u,s,o){const h=this.get(u.id);if(h)return h;const g=u;return g.openCommandActionDescriptor=o?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,M.$xc)(this.g,s,[]).push(g),o?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:s}),g}deregisterViewContainer(u){for(const s of this.g.keys()){const o=this.g.get(s),h=o?.indexOf(u);if(h!==-1){o?.splice(h,1),o.length===0&&this.g.delete(s),this.f.fire({viewContainer:u,viewContainerLocation:s});return}}}get(u){return this.all.filter(s=>s.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(s=>this.getViewContainers(s).filter(o=>o?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(s=>this.getViewContainerLocation(s)===u)}}b.$fo.add(P.ViewContainersRegistry,new v);var d;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(d||(e.ViewContentGroups=d={}));function f(t,u){const s=t.group??d.More,o=u.group??d.More;return s!==o?s.localeCompare(o):(t.order??5)-(u.order??5)}class a extends A.$Uc{constructor(){super(...arguments),this.c=this.B(new l.$fe),this.onViewsRegistered=this.c.event,this.f=this.B(new l.$fe),this.onViewsDeregistered=this.f.event,this.g=this.B(new l.$fe),this.onDidChangeContainer=this.g.event,this.h=this.B(new l.$fe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(u,s){this.registerViews2([{views:u,viewContainer:s}])}registerViews2(u){u.forEach(({views:s,viewContainer:o})=>this.r(s,o)),this.c.fire(u)}deregisterViews(u,s){const o=this.s(u,s);o.length&&this.f.fire({views:o,viewContainer:s})}moveViews(u,s){for(const o of this.m.keys())if(o!==s){const h=this.s(u,o);h.length&&(this.r(h,s),this.g.fire({views:h,from:o,to:s}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const s of this.j){const o=(this.m.get(s)||[]).filter(h=>h.id===u)[0];if(o)return o}return null}getViewContainer(u){for(const s of this.j)if((this.m.get(s)||[]).filter(h=>h.id===u)[0])return s;return null}registerViewWelcomeContent(u,s){return this.n.add(u,s),this.h.fire(u),(0,A.$Sc)(()=>{this.n.delete(u,s),this.h.fire(u)})}registerViewWelcomeContent2(u,s){const o=new Map;for(const[h,g]of s)this.n.add(u,g),o.set(h,(0,A.$Sc)(()=>{this.n.delete(u,g),this.h.fire(u)}));return this.h.fire(u),o}getViewWelcomeContent(u){const s=[];return this.n.forEach(u,o=>s.push(o)),s.sort(f)}r(u,s){let o=this.m.get(s);o||(o=[],this.m.set(s,o),this.j.push(s));for(const h of u){if(this.getView(h.id)!==null)throw new Error((0,O.localize)(2,null,h.id));o.push(h)}}s(u,s){const o=this.m.get(s);if(!o)return[];const h=[],g=[];for(const w of o)u.includes(w)?h.push(w):g.push(w);return h.length&&(g.length?this.m.set(s,g):(this.m.delete(s),this.j.splice(this.j.indexOf(s),1))),h}}b.$fo.add(P.ViewsRegistry,new a),e.$6F=(0,L.$yi)("viewDescriptorService");var n;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var i;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class c{constructor(u,s){this.c=!1,this.d=!1,(0,$.$8n)(this,u),this.d=!!s,this.resolve=async o=>{if(s&&!this.c){const h=await s(o);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}o.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$7F=c;class r extends Error{constructor(u){super((0,O.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$8F=r}),define(ke[295],De([1,0,240,38]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=void 0,e.$_F=new O.$Pj("chatSessionResponseVote","",{type:"string",description:(0,l.localize)(0,null)}),e.$aG=new O.$Pj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,l.localize)(1,null)}),e.$bG=new O.$Pj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,l.localize)(2,null)}),e.$cG=new O.$Pj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,l.localize)(3,null)}),e.$dG=new O.$Pj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,l.localize)(4,null)}),e.$eG=new O.$Pj("chatResponse",!1,{type:"boolean",description:(0,l.localize)(5,null)}),e.$fG=new O.$Pj("chatRequest",!1,{type:"boolean",description:(0,l.localize)(6,null)}),e.$gG=new O.$Pj("chatEditApplied",!1,{type:"boolean",description:(0,l.localize)(7,null)}),e.$hG=new O.$Pj("chatInputHasText",!1,{type:"boolean",description:(0,l.localize)(8,null)}),e.$iG=new O.$Pj("chatInputHasFocus",!1,{type:"boolean",description:(0,l.localize)(9,null)}),e.$jG=new O.$Pj("inChatInput",!1,{type:"boolean",description:(0,l.localize)(10,null)}),e.$kG=new O.$Pj("inChat",!1,{type:"boolean",description:(0,l.localize)(11,null)}),e.$lG=new O.$Pj("chatIsEnabled",!1,{type:"boolean",description:(0,l.localize)(12,null)}),e.$mG=new O.$Pj("chatCursorAtTop",!1),e.$nG=new O.$Pj("chatInputHasAgent",!1),e.$oG=new O.$Pj("chatLocation",void 0)}),define(ke[296],De([1,0,7,21,4,39,3,171,14,38,5,11,108,274,142,295]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.ChatAgentLocation=void 0,e.$sH=r;var a;(function(t){t.Panel="panel",t.Terminal="terminal",t.Notebook="notebook",t.Editor="editor"})(a||(e.ChatAgentLocation=a={})),function(t){function u(s){switch(s){case"panel":return t.Panel;case"terminal":return t.Terminal;case"notebook":return t.Notebook;case"editor":return t.Editor}return t.Panel}t.fromRaw=u}(a||(e.ChatAgentLocation=a={})),e.$nH=(0,I.$yi)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(u){this.f=u,this.b=[],this.d=new L.$fe,this.onDidChangeAgents=this.d.event,this.e=d.$lG.bindTo(this.f)}registerAgent(u,s){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const h=this,g=s.slashCommands;s={...s,get slashCommands(){return g.filter(k=>!k.when||h.f.contextMatchesRules(E.$wj.deserialize(k.when)))}};const w={data:s};return this.b.push(w),(0,M.$Sc)(()=>{this.b=this.b.filter(k=>k!==w),this.d.fire(void 0)})}registerAgentImplementation(u,s){const o=this.g(u);if(!o)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(o.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return o.data.isDefault&&this.e.set(!0),o.impl=s,this.d.fire(new i(o.data,s)),(0,M.$Sc)(()=>{o.impl=void 0,this.d.fire(void 0),o.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(u,s){u.isDynamic=!0;const o={data:u,impl:s};return this.b.push(o),this.d.fire(new i(u,s)),(0,M.$Sc)(()=>{this.b=this.b.filter(h=>h!==o),this.d.fire(void 0)})}updateAgent(u,s){const o=this.g(u);if(!o?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);o.data.metadata={...o.data.metadata,...s},this.d.fire(new i(o.data,o.impl))}getDefaultAgent(u){return this.getActivatedAgents().find(s=>!!s.isDefault&&s.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(s=>!!s.isDefault&&s.locations.includes(u))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),u=>!!u.data.metadata.isSecondary)?.data}g(u){return this.b.find(s=>s.data.id===u)}getAgent(u){return this.g(u)?.data}getAgentByFullyQualifiedId(u){return this.b.find(s=>r(s.data)===u)?.data}getAgents(){return this.b.map(u=>u.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(u=>!!u.impl).map(u=>new i(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(s=>s.name===u)}async invokeAgent(u,s,o,h,g){const w=this.g(u);if(!w?.impl)throw new Error(`No activated agent with id ${u}`);return await w.impl.invoke(s,o,h,g)}async getFollowups(u,s,o,h,g){const w=this.g(u);if(!w?.impl)throw new Error(`No activated agent with id ${u}`);return w.impl?.provideFollowups?w.impl.provideFollowups(s,o,h,g):[]}};e.$oH=n,e.$oH=n=Je([We(0,E.$Qj)],n);class i{constructor(u,s){this.b=u,this.d=s}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(u,s,o,h){return this.d.invoke(u,s,o,h)}async provideFollowups(u,s,o,h){return this.d.provideFollowups?this.d.provideFollowups(u,s,o,h):[]}provideWelcomeMessage(u,s){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(u,s)}provideSampleQuestions(u,s){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(u,s)}}e.$pH=i,e.$qH=(0,I.$yi)("chatAgentNameService");let c=class{static{f=this}static{this.b="chat.participantNameRegistry"}constructor(u,s,o,h){if(this.g=s,this.h=o,this.i=h,this.e=(0,b.$3d)(this,Object.create(null)),this.f=!1,!u.chatParticipantRegistry)return;this.d=u.chatParticipantRegistry;const g=h.get(f.b,-1);try{this.e.set(JSON.parse(g??"{}"),void 0)}catch{h.remove(f.b,-1)}this.j()}j(){this.f||this.k().catch(u=>this.h.warn("Failed to fetch chat participant registry",u)).then(()=>(0,l.$zh)(5*60*1e3)).then(()=>this.j())}async k(){const u=await this.g.request({type:"GET",url:this.d},O.CancellationToken.None);if(u.res.statusCode!==200)throw new Error("Could not get extensions report.");const s=await(0,S.$Xp)(u);if(!s||s.version!==1)throw new Error("Unexpected chat participant registry response.");const o=s.restrictedChatParticipants;this.e.set(o,void 0),this.i.store(f.b,JSON.stringify(o),-1,1)}getAgentNameRestriction(u){return this.e.map(o=>o[u.name.toLowerCase()]).map(o=>o?o.some(h=>(0,$.$zf)(h,h.includes(".")?u.extensionId.value:u.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$rH=c,e.$rH=c=f=Je([We(0,p.$lk),We(1,S.$Rp),We(2,P.$5j),We(3,v.$5p)],c);function r(t){return`${t.extensionId.value}.${t.id}`}}),define(ke[297],De([1,0,2,29,5]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.$YG=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$WG=A,e.$XG=M;function A(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof l.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(O.$yt.isIRange)}function M(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(A)}var b;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(b||(e.ChatAgentVoteDirection=b={}));var $;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$YG=(0,L.$yi)("IChatService"),e.$ZG="accessibility.voice.keywordActivation"}),define(ke[144],De([1,0,4,7,241]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lsb=void 0;class A{constructor(){this.f=new Map,this.m=[],this.n=new l.$fe,this.o=new l.$fe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,$,E,I){const P={command:b};if($&&Object.keys($).length>0&&(P.arguments=$),this.u("request",P),typeof I=="number"){const p=setTimeout(()=>{clearTimeout(p);const S=this.f.get(P.seq);if(S){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:b,message:(0,L.localize)(0,null,I,b)};S(v)}},I)}return E&&this.f.set(P.seq,E),P.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,$){return b.type!=="event"||$.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,O.$zh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,E=this.f.get($.request_seq);E&&(this.f.delete($.request_seq),E($));break}}}}u(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,E)=>b.set(E,$)),await(0,O.$zh)(500),b.forEach(($,E)=>{$({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$lsb=A}),define(ke[298],De([1,0,2,242,38,5]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$IJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$GJ=e.MemoryRangeType=e.State=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=void 0,e.$FJ=$,e.$HJ=I,e.$tI="workbench.view.debug",e.$uI="workbench.debug.variablesView",e.$vI="workbench.debug.watchExpressionsView",e.$wI="workbench.debug.callStackView",e.$xI="workbench.debug.loadedScriptsView",e.$yI="workbench.debug.breakPointsView",e.$zI="workbench.debug.disassemblyView",e.$AI="workbench.panel.repl",e.$BI="workbench.panel.repl.view",e.$CI=new L.$Pj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$DI=new L.$Pj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$EI=new L.$Pj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$FI="debugUx",e.$GI=new L.$Pj(e.$FI,"default",{type:"string",description:O.localize(3,null)}),e.$HI=new L.$Pj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$II=new L.$Pj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$JI=new L.$Pj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$KI=new L.$Pj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$LI=new L.$Pj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$MI=new L.$Pj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$NI=new L.$Pj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$OI=new L.$Pj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$PI=new L.$Pj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$QI=new L.$Pj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$RI=new L.$Pj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$SI=new L.$Pj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$TI=new L.$Pj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$UI=new L.$Pj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$VI=new L.$Pj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$WI=new L.$Pj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$XI=new L.$Pj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$YI=new L.$Pj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$ZI=new L.$Pj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$1I=new L.$Pj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$2I=new L.$Pj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$3I=new L.$Pj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$4I=new L.$Pj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$5I=new L.$Pj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$6I=new L.$Pj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$7I=new L.$Pj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$8I=new L.$Pj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$9I=new L.$Pj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$0I=new L.$Pj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$$I=new L.$Pj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$_I=new L.$Pj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$aJ=new L.$Pj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$bJ=new L.$Pj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$cJ=new L.$Pj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$dJ=new L.$Pj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$eJ=new L.$Pj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$fJ=new L.$Pj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$gJ=new L.$Pj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$hJ=new L.$Pj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$iJ=new L.$Pj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$jJ=new L.$Pj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$kJ=new L.$Pj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$lJ=new L.$Pj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$mJ=new L.$Pj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$nJ=new L.$Pj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$oJ=new L.$Pj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$pJ=new L.$Pj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$qJ=new L.$Pj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$rJ=new L.$Pj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$sJ=new L.$Pj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$tJ=new L.$Pj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$uJ=new L.$Pj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$vJ=new L.$Pj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$wJ=new L.$Pj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$xJ=new L.$Pj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$yJ=new L.$Pj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$zJ=new L.$Pj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const M=i=>O.localize(61,null,i);e.$AJ=M,e.$BJ="editor.contrib.debug",e.$CJ="editor.contrib.breakpoint",e.$DJ="debug",e.$EJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var b;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(b||(e.State=b={}));function $(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$GJ="vscode-debug-memory";function I(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var P;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(P||(e.DataBreakpointSetType=P={}));var p;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var S;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$IJ=(0,A.$yi)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var d;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(d||(e.DebugVisualizationType=d={}));var f;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(f||(e.DebugTreeItemCollapsibleState=f={}));var a;(function(i){i.deserialize=c=>c,i.serialize=c=>c})(a||(e.IDebugVisualizationTreeItem=a={}));var n;(function(i){i.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:l.URI.revive(c.iconPath.light),dark:l.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),i.serialize=c=>c})(n||(e.IDebugVisualization=n={}))}),define(ke[299],De([1,0,14,2,16,24,15,29,21,19]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HH=void 0,e.$vH=P,e.$wH=p,e.$xH=S,e.$yH=v,e.$zH=d,e.$AH=f,e.$BH=a,e.$CH=i,e.$DH=t,e.$EH=u,e.$FH=o,e.$GH=g;const I=/{([^}]+)}/g;function P(k,m,y){return k.replace(I,function(D,C){return m&&C.length>0&&C[0]!=="_"?D:y&&y.hasOwnProperty(C)?y[C]:D})}function p(k){const m={};for(const y of Object.keys(k))y.startsWith("!")||(m[y]=k[y]);return m}function S(k){return k.configuration.request==="attach"&&!v(k)&&(!k.parentSession||S(k.parentSession))}function v(k){let m=k.configuration.type;if(m)return m==="vslsShare"&&(m=k.configuration.adapterProxy.configuration.type),(0,l.$zf)(m,"extensionhost")||(0,l.$zf)(m,"pwa-extensionhost")?k:k.parentSession?v(k.parentSession):void 0}function d(k){return k.type&&(k.label||k.program||k.runtime)}function f(k,m,y){let D,C=0;const R=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let T=null;for(;T=R.exec(k);){const j=T.index+1,z=j+T[0].length;if(j<=m&&z>=y){D=T[0],C=j;break}}if(D){const j=/\w+/g;let z=null;for(;(z=j.exec(D))&&!(z.index+1+C+z[0].length>=y););z&&(D=D.substring(0,j.lastIndex))}return D?{start:C,end:C+D.length-1}:{start:0,end:0}}async function a(k,m,y,D){if(k.evaluatableExpressionProvider.has(m)){const C=k.evaluatableExpressionProvider.ordered(m),R=(0,E.$Hb)(await Promise.all(C.map(async T=>{try{return await T.provideEvaluatableExpression(m,y,D??$.CancellationToken.None)}catch{return}})));if(R.length>0){let T=R[0].expression;const j=R[0].range;return T||(T=m.getLineContent(y.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:T}}}else{const C=m.getLineContent(y.lineNumber),{start:R,end:T}=f(C,y.column,y.column),j=C.substring(R-1,T);return{matchingExpression:j,range:new b.$yt(y.lineNumber,R,y.lineNumber,R+j.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(k){return!!(k&&k.match(n))}function c(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(i(k.path))return O.URI.parse(k.path);if((0,L.$ic)(k.path))return O.URI.file(k.path)}return k.path}function r(k){if(typeof k.path=="object"){const m=O.URI.revive(k.path);if(m)return m.scheme===M.Schemas.file?m.fsPath:m.toString()}return k.path}function t(k,m){const y=m?c:r,D=(0,A.$5n)(k);return s(D,(C,R)=>{C&&R&&(R.path=y(R))}),D}function u(k,m){const y=m?c:r,D=(0,A.$5n)(k);return s(D,(C,R)=>{!C&&R&&(R.path=y(R))}),D}function s(k,m){switch(k.type){case"event":{const y=k;switch(y.event){case"output":m(!1,y.body.source);break;case"loadedSource":m(!1,y.body.source);break;case"breakpoint":m(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=k;switch(y.command){case"setBreakpoints":m(!0,y.arguments.source);break;case"breakpointLocations":m(!0,y.arguments.source);break;case"source":m(!0,y.arguments.source);break;case"gotoTargets":m(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(D=>m(!1,D));break;default:break}break}case"response":{const y=k;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(D=>m(!1,D.source));break;case"loadedSources":y.body.sources.forEach(D=>m(!1,D));break;case"scopes":y.body.scopes.forEach(D=>m(!1,D.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(D=>m(!1,D.source));break;case"setBreakpoints":y.body.breakpoints.forEach(D=>m(!1,D.source));break;case"disassemble":y.body?.instructions.forEach(C=>m(!1,C.location));break;default:break}break}}}function o(k){return k.filter(m=>!m.presentation?.hidden).sort((m,y)=>m.presentation?y.presentation?m.presentation.group?y.presentation.group?m.presentation.group!==y.presentation.group?m.presentation.group.localeCompare(y.presentation.group):h(m.presentation.order,y.presentation.order):-1:y.presentation.group?1:h(m.presentation.order,y.presentation.order):-1:y.presentation?1:0)}function h(k,m){return typeof k!="number"?typeof m!="number"?0:1:typeof m!="number"?-1:k-m}async function g(k,m){const y=k.getValue("debug.saveBeforeStart",{overrideIdentifier:m.activeTextEditorLanguageId});if(y!=="none"&&(await m.saveAll(),y==="allEditorsInActiveGroup")){const D=m.activeEditorPane;D&&D.input.resource?.scheme===M.Schemas.untitled&&await m.save({editor:D.input,groupId:D.group.id})}await k.reloadConfiguration()}const w=(k,m)=>!k||!m?k===m:k.name===m.name&&k.path===m.path&&k.sourceReference===m.sourceReference;e.$HH=w}),define(ke[300],De([1,0,54,63,24,16,12,14,32,243,144]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=e.$joc=e.$ioc=e.$hoc=e.$goc=void 0;class P extends I.$lsb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(a,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,a.on("data",i=>this.v(i))}sendMessage(a){if(this.l){const n=JSON.stringify(a);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${P.a}${n}`,"utf8")}}v(a){for(this.p=Buffer.concat([this.p,a]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(P.a);if(n!==-1){const c=this.p.toString("utf8",0,n).split(P.b);for(const r of c){const t=r.split(P.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+P.a.length);continue}}break}}}e.$goc=P;class p extends P{startSession(){return new Promise((a,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),a(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",c=>{i?this.n.fire(c):n(c)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$hoc=p;class S extends p{constructor(a){super(),this.z=a}y(a){return O.createConnection(this.z.port,this.z.host||"127.0.0.1",a)}}e.$ioc=S;class v extends p{constructor(a){super(),this.z=a}y(a){return O.createConnection(this.z.path,a)}}e.$joc=v;class d extends P{constructor(a,n){super(),this.y=a,this.z=n}async startSession(){const a=this.y.command,n=this.y.args,i=this.y.options||{};try{if(a)if(A.$ic(a)){if(!await $.Promises.exists(a))throw new Error(E.localize(0,null,a))}else a.indexOf("/")<0&&a.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let c=process.env;if(i.env&&Object.keys(i.env).length>0&&(c=L.$8n(L.$5n(process.env),i.env)),a==="node")if(Array.isArray(n)&&n.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:c,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const u=l.fork(n[0],n.slice(1),t);if(!u.pid)throw new Error(E.localize(2,null,n[0]));this.x=u}else throw new Error(E.localize(3,null));else{const r={env:c};i.cwd&&(r.cwd=i.cwd),this.x=l.spawn(a,n,r)}this.x.on("error",r=>{this.n.fire(r)}),this.x.on("exit",(r,t)=>{this.o.fire(r)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",r=>{this.n.fire(r)}),this.x.stdin.on("error",r=>{this.n.fire(r)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(c){this.n.fire(c)}}async stopSession(){return this.x?(await this.w(),M.$i?new Promise((a,n)=>{const i=l.exec(`taskkill /F /T /PID ${this.x.pid}`,function(c,r,t){if(c)return n(c)});i.on("exit",a),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(a,n){if(!a)return;const i=Object.create(null);a.runtime&&(a.runtime.indexOf("./")===0?i.runtime=A.$jc(n,a.runtime):i.runtime=a.runtime),a.runtimeArgs&&(i.runtimeArgs=a.runtimeArgs),a.program&&(A.$ic(a.program)?i.program=a.program:i.program=A.$jc(n,a.program)),a.args&&(i.args=a.args);const c=a;return c.win&&(i.win=d.A(c.win,n)),c.winx86&&(i.winx86=d.A(c.winx86,n)),c.windows&&(i.windows=d.A(c.windows,n)),c.osx&&(i.osx=d.A(c.osx,n)),c.linux&&(i.linux=d.A(c.linux,n)),i}static platformAdapterExecutable(a,n){let i=Object.create(null);n=n.toLowerCase();for(const o of a)if(o.contributes){const h=o.contributes.debuggers;h&&h.length>0&&h.filter(g=>typeof g.type=="string"&&b.$zf(g.type,n)).forEach(g=>{const w=d.A(g,o.extensionLocation.fsPath);i=L.$8n(i,w,o.isBuiltin)})}let c;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?c=i.winx86||i.win||i.windows:M.$i?c=i.win||i.windows:M.$j?c=i.osx:M.$k&&(c=i.linux),c=c||i;const r=c.program||i.program,t=c.args||i.args,u=c.runtime||i.runtime,s=c.runtimeArgs||i.runtimeArgs;if(u)return{type:"executable",command:u,args:(s||[]).concat(typeof r=="string"?[r]:[]).concat(t||[])};if(r)return{type:"executable",command:r,args:t||[]}}}e.$koc=d}),define(ke[301],De([1,0,54,31,12]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=M,e.$moc=$;function A(E,I){return new Promise((P,p)=>{let S="";const v=l.spawn(E,I);v.pid&&v.stdout.on("data",d=>{S+=d.toString()}),v.on("error",d=>{p(d)}),v.on("close",d=>{P(S)})})}async function M(E){if(E)if(L.$i){const I=await new Promise((P,p)=>{he(["@vscode/windows-process-tree"],P,p)});return new Promise(P=>{I.getProcessTree(E,p=>{P(!!p&&p.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(E)]).then(I=>{const P=I.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var b;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(b||(b={}));function $(E,I,P,p,S){E=E.trim().toLowerCase();let v;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?v=1:E.indexOf("cmd.exe")>=0?v=0:E.indexOf("bash")>=0?v=2:L.$i?v=0:v=2;let d,f=" ";switch(v){case 1:if(d=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),p){const a=(0,O.$Dg)(p);a&&(f+=`${a}:; `),f+=`cd ${d(p)}; `}if(S)for(const a in S){const n=S[a];n===null?f+=`Remove-Item env:${a}; `:f+=`\${env:${a}}='${n}'; `}if(I.length>0){const a=I.shift(),n=P?a:d(a);f+=n[0]==="'"?`& ${n} `:`${n} `;for(const i of I)f+=i==="<"||i===">"||P?i:d(i),f+=" "}break;case 0:if(d=a=>(a=a.replace(/\"/g,'""'),a=a.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(n=>a.includes(n))||a.length===0?`"${a}"`:a),p){const a=(0,O.$Dg)(p);a&&(f+=`${a}: && `),f+=`cd ${d(p)} && `}if(S){f+='cmd /C "';for(const a in S){let n=S[a];n===null?f+=`set "${a}=" && `:(n=n.replace(/[&^|<>]/g,i=>`^${i}`),f+=`set "${a}=${n}" && `)}}for(const a of I)f+=a==="<"||a===">"||P?a:d(a),f+=" ";S&&(f+='"');break;case 2:{d=n=>(n=n.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),n.length===0?'""':n);const a=n=>/[^\w@%\/+=,.:^-]/.test(n)?`'${n.replace(/'/g,"'\\''")}'`:n;if(p&&(f+=`cd ${d(p)} ; `),S){f+="/usr/bin/env";for(const n in S){const i=S[n];i===null?f+=` -u ${a(n)}`:f+=` ${a(`${n}=${i}`)}`}f+=" "}for(const n of I)f+=n==="<"||n===">"||P?n:d(n),f+=" ";break}}return f}}),define(ke[302],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.CellExecutionUpdateType=void 0;var O;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$1J=(0,l.$yi)("INotebookExecutionService")}),define(ke[303],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wib=e.$Vib=e.ProxyKernelState=e.$Uib=void 0,e.$Uib=100;var O;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$Vib=(0,l.$yi)("INotebookKernelService"),e.$Wib=(0,l.$yi)("INotebookKernelHistoryService")}),define(ke[304],De([1,0,3,29,205,100]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EXb=void 0;class M extends l.$Uc{constructor($,E,I){super(),this._source=$,this.b=E,this.c=I,this.a=void 0}f($){const E=$.getLineCount();return new O.$yt(1,1,E,this.g($,E))}g($,E){if(E<1||E>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const $=new L.$6C;$.acceptChunk(this._source);const E=$.finish(!0),{textBuffer:I,disposable:P}=E.create(1);this.b=I,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const E=new L.$6C;E.acceptChunk($);const I=E.finish(!0),{textBuffer:P,disposable:p}=I.create(1);return this.B(p),P})),this.a}findInInputs($){const I=new A.$TC($,!1,!1,null).parseSearchRequest();if(!I)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,I,!0,5e3)}findInOutputs($){const I=new A.$TC($,!1,!1,null).parseSearchRequest();return I?this.outputTextBuffers.map(P=>{const p=P.findMatchesLineByLine(this.f(P),I,!0,5e3);if(p.length!==0)return{textBuffer:P,matches:p}}).filter(P=>!!P):[]}}e.$EXb=M}),define(ke[69],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(A){A.Delimiter="\0"})(l||(e.TestIdPathParts=l={}));var O;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class L{static fromExtHostTestItem(M,b,$=M.parent){if(M._isRoot)return new L([b]);const E=[M.id];for(let I=$;I&&I.id!==b;I=I.parent)E.push(I.id);return E.push(b),new L(E.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const b=M.indexOf("\0");return b===-1?M:M.slice(0,b)}static fromString(M){return new L(M.split("\0"))}static join(M,b){return new L([...M.path,b])}static joinToString(M,b){return M.toString()+"\0"+b}static parentId(M){const b=M.lastIndexOf("\0");return b===-1?void 0:M.slice(0,b)}static localId(M){const b=M.lastIndexOf("\0");return b===-1?M:M.slice(b+1)}static isChild(M,b){return b.startsWith(M)&&b[M.length]==="\0"}static compare(M,b){return M===b?0:L.isChild(M,b)?2:L.isChild(b,M)?3:1}static getLengthOfCommonPrefix(M,b){if(M===0)return 0;let $=0;for(;$<M-1;){for(let E=1;E<M;E++){const I=b(E-1),P=b(E);if(I.path[$]!==P.path[$])return $}$++}return $}constructor(M,b=M.length){if(this.path=M,this.d=b,M.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new L(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new L(this.path,M)}compare(M){if(typeof M=="string")return L.compare(this.toString(),M);for(let b=0;b<M.d&&b<this.d;b++)if(M.path[b]!==this.path[b])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$8K=L}),define(ke[89],De([1,0,2,51,29,69]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$dL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$cL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$bL=e.$aL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$_K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$$K=e.$0K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$9K=e.TestResultState=void 0;var M;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$9K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$0K=[2,4,8,16,32,64];const E=N=>"runId"in N;e.$$K=E;var I;(function(N){N.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),N.deserialize=(F,B)=>({range:L.$yt.lift(B.range),uri:F.asCanonicalUri(l.URI.revive(B.uri))})})(I||(e.IRichLocation=I={}));var P;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(P||(e.TestMessageType=P={}));var p;(function(N){N.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&I.serialize(F.location)}),N.deserialize=(F,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&I.deserialize(F,B.location)})})(p||(e.ITestErrorMessage=p={}));const S=(N,F)=>`${F?"s":"e"}${N}`;e.$_K=S;var v;(function(N){N.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&I.serialize(F.location)}),N.deserialize=(F,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&I.deserialize(F,B.location)})})(v||(e.ITestOutputMessage=v={}));var d;(function(N){N.serialize=F=>F.type===0?p.serialize(F):v.serialize(F),N.deserialize=(F,B)=>B.type===0?p.deserialize(F,B):v.deserialize(F,B)})(d||(e.ITestMessage=d={}));var f;(function(N){N.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),N.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(d.serialize)}),N.deserialize=(F,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(Y=>d.deserialize(F,Y))})})(f||(e.ITestTaskState=f={}));const a="\0",n=(N,F)=>N+a+F;e.$aL=n;const i=N=>{const F=N.indexOf(a);return{ctrlId:N.slice(0,F),tagId:N.slice(F+1)}};e.$bL=i;var c;(function(N){N.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),N.deserialize=(F,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?F.asCanonicalUri(l.URI.revive(B.uri)):void 0,range:B.range?L.$yt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(c||(e.ITestItem=c={}));var r;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(r||(e.TestItemExpandState=r={}));var t;(function(N){N.serialize=F=>({expand:F.expand,item:c.serialize(F.item)}),N.deserialize=(F,B)=>({controllerId:A.$8K.root(B.item.extId),expand:B.expand,item:c.deserialize(F,B.item)})})(t||(e.InternalTestItem=t={}));var u;(function(N){N.serialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.uri!==void 0&&(B.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(B.range=F.item.range?.toJSON()),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}},N.deserialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.range!==void 0&&(B.range=F.item.range?L.$yt.lift(F.item.range):null),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}}})(u||(e.ITestItemUpdate=u={}));const s=(N,F)=>{F.expand!==void 0&&(N.expand=F.expand),F.item!==void 0&&(N.item=N.item?Object.assign(N.item,F.item):F.item)};e.$cL=s;var o;(function(N){N.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.serializeWithoutMessages)}),N.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.serialize)}),N.deserialize=(F,B)=>({...t.deserialize(F,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(Y=>f.deserialize(F,Y)),retired:!0})})(o||(e.TestResultItem=o={}));var h;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(F,B)=>{F.covered+=B.covered,F.total+=B.total}})(h||(e.ICoverageCount=h={}));var g;(function(N){N.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testId:F.testId?.toString(),uri:F.uri.toJSON()}),N.deserialize=(F,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testId:B.testId?A.$8K.fromString(B.testId):void 0,uri:F.asCanonicalUri(l.URI.revive(B.uri))}),N.empty=(F,B)=>({id:F,uri:B,testId:void 0,statement:h.empty()})})(g||(e.IFileCoverage=g={}));function w(N){return{...N,location:N.location?.toJSON()}}function k(N){return N.location=N.location?O.$xt.isIPosition(N.location)?O.$xt.lift(N.location):L.$yt.lift(N.location):void 0,N}e.$dL=3;var m;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(m||(e.DetailType=m={}));var y;(function(N){N.serialize=F=>F.type===0?C.serialize(F):R.serialize(F),N.deserialize=F=>F.type===0?C.deserialize(F):R.deserialize(F)})(y||(e.CoverageDetails=y={}));var D;(function(N){N.serialize=w,N.deserialize=k})(D||(e.IBranchCoverage=D={}));var C;(function(N){N.serialize=w,N.deserialize=k})(C||(e.IDeclarationCoverage=C={}));var R;(function(N){N.serialize=F=>({...w(F),branches:F.branches?.map(D.serialize)}),N.deserialize=F=>({...k(F),branches:F.branches?.map(D.deserialize)})})(R||(e.IStatementCoverage=R={}));var T;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(T||(e.TestDiffOpType=T={}));var j;(function(N){N.deserialize=(F,B)=>B.op===0?{op:B.op,item:t.deserialize(F,B.item)}:B.op===1?{op:B.op,item:u.deserialize(B.item)}:B.op===2?{op:B.op,uri:F.asCanonicalUri(l.URI.revive(B.uri)),docv:B.docv}:B,N.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:u.serialize(F.item)}:F})(j||(e.TestsDiffOp=j={}));class z{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const B=this.v();for(const Y of F)switch(Y.op){case 0:this.l(t.deserialize(this.k,Y.item),B);break;case 1:this.o(u.deserialize(Y.item),B);break;case 3:this.p(Y.itemId,B);break;case 5:this.q(Y.itemId);break;case 4:this.updatePendingRoots(Y.amount);break;case 6:this.c.set(Y.tag.id,Y.tag);break;case 7:this.c.delete(Y.id);break}B.complete?.()}l(F,B){const Y=A.$8K.parentId(F.item.extId)?.toString();let re;if(!Y)re=this.w(F),this.g.add(re),this.f.set(F.item.extId,re);else if(this.f.has(Y)){const H=this.f.get(Y);H.children.add(F.item.extId),re=this.w(F,H),this.f.set(F.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return B.add?.(re),F.expand===2&&this.h++,re}o(F,B){const Y=this.f.get(F.extId);if(Y)return F.expand!==void 0&&(Y.expand===2&&this.h--,F.expand===2&&this.h++),(0,e.$cL)(Y,F),B.update?.(Y),Y}p(F,B){const Y=this.f.get(F);if(!Y)return;const re=A.$8K.parentId(Y.item.extId)?.toString();re?this.f.get(re).children.delete(Y.item.extId):this.g.delete(Y);const H=[[F]];for(;H.length;)for(const K of H.pop()){const _=this.f.get(K);_&&(H.push(_.children),this.f.delete(K),B.remove?.(_,_!==Y),_.expand===2&&this.h--)}}q(F){}updatePendingRoots(F){this.j+=F}v(){return{}}}e.$eL=z}),define(ke[113],De([1,0,7,4,3,62,89,69]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const E=(n,i)=>n===i,P=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(n,i)=>!(n.length!==i.length||n.some(c=>!i.includes(c)))}),p=(n,i)=>{let c;for(const[r,t]of P)t(n[r],i[r])||(c?c[r]=i[r]:c={[r]:i[r]});return c};class S extends L.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new l.$Kh(()=>this.flushDiff(),200)),this.g=this.B(new O.$fe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===i.uri){c.docv=i.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===i.item.extId){(0,M.$cL)(c.item,i.item);return}if(c.op===0&&c.item.item.extId===i.item.extId){(0,M.$cL)(c.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,c){const r=this.tree.get(i);if(r){if((r.expandLevels===void 0||c>r.expandLevels)&&(r.expandLevels=c),r.expand===1){const t=this.M(r);return t.isOpen()?this.L(r,c-1):t.wait().then(()=>this.L(r,c-1))}else if(r.expand===3)return r.resolveBarrier?.isOpen()===!1?r.resolveBarrier.wait().then(()=>this.L(r,c-1)):this.L(r,c-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,c){switch(c.op){case 3:this.O(b.$8K.joinToString(i.fullId,c.id));break;case 0:this.z(c.item,i);break;case 5:for(const r of c.ops)this.w(i,r);break;case 1:this.C(c.new,c.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:c.update}});break;case 6:this.y(i.actual.uri);break;default:(0,A.$ed)(c)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,c){const r=b.$8K.fromExtHostTestItem(i,this.root.id,c?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(i.id);let u=this.tree.get(r.toString());if(!u){u={fullId:r,actual:i,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(i,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(i)}}),this.I(i,u,c);return}if(u.actual===i){this.H(i,u,c);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.O(r.toString()),this.z(i,c);const s=this.s.getChildren(u.actual),o=u.actual,h=p(this.s.toITestItem(o),this.s.toITestItem(i));this.s.getApiFor(o).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=0,h&&(h.hasOwnProperty("tags")&&(this.C(i.tags,o.tags,r.toString()),delete h.tags),this.w(u,{op:4,update:h})),this.I(i,u,c);for(const[w,k]of s)this.s.getChildren(i).get(k.id)||this.O(b.$8K.joinToString(r,k.id));const g=u.expandLevels;g!==void 0&&queueMicrotask(()=>{u.expand===1&&(u.expandLevels=void 0,this.expand(r.toString(),g))}),this.y(u.actual.uri)}C(i,c,r){const t=new Set(c.map(u=>u.id));for(const u of i)t.delete(u.id)||this.D(u);this.pushDiff({op:1,item:{extId:r,item:{tags:i.map(u=>(0,M.$aL)(this.s.controllerId,u.id))}}}),t.forEach(this.F,this)}D(i){const c=this.j.get(i.id);c?c.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$aL)(this.s.controllerId,i.id)}}))}F(i){const c=this.j.get(i);c&&!--c.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$aL)(this.s.controllerId,i)}))}G(i,c){this.s.getApiFor(i).parent=c&&c.actual!==this.root?c.actual:void 0}H(i,c,r){this.G(i,r);const t=this.s.getApiFor(i);t.parent=r?.actual,t.listener=u=>this.w(c,u),this.J(c)}I(i,c,r){this.H(i,c,r);for(const[t,u]of this.s.getChildren(i))this.z(u,c)}J(i){let c;this.h?i.resolveBarrier?c=i.resolveBarrier.isOpen()?3:2:c=i.actual.canResolveChildren?1:0:c=0,c!==i.expand&&(i.expand=c,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:c}}),c===1&&i.expandLevels!==void 0&&this.M(i))}L(i,c){if(c<0)return;const r=[];for(const[t,u]of this.s.getChildren(i.actual)){const s=this.expand(b.$8K.joinToString(i.fullId,u.id),c);(0,l.$kh)(s)&&r.push(s)}if(r.length)return Promise.all(r).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const u=new l.$xh;return u.open(),u}i.expand=2,this.N(i);const c=i.resolveBarrier=new l.$xh,r=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(u){r(u)}return(0,l.$kh)(t)?t.catch(r).then(()=>{c.open(),this.J(i)}):(c.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const c=this.tree.get(i);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const r=[c];for(;r.length;){const t=r.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const u of t.actual.tags)this.F(u.id);this.tree.delete(t.fullId.toString());for(const[u,s]of this.s.getChildren(t.actual))r.push(this.tree.get(b.$8K.joinToString(t.fullId,s.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$DO=S;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$EO=v;class d extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$FO=d;class f extends Error{constructor(i,c,r){super(`TestItem with ID "${i}" is from controller "${c}" and cannot be added as a child of an item from controller "${r}".`)}}e.$GO=f;const a=(n,i,c)=>{let r=new Map;return{get size(){return r.size},forEach(t,u){for(const s of r.values())t.call(u,s,this)},[Symbol.iterator](){return r.entries()},replace(t){const u=new Map,s=new Set(r.keys()),o={op:5,ops:[]};for(const h of t){if(!(h instanceof c))throw new d(h.id);const g=i(h).controllerId;if(g!==n.controllerId)throw new f(h.id,g,n.controllerId);if(u.has(h.id))throw new v(h.id);u.set(h.id,h),s.delete(h.id),o.ops.push({op:0,item:h})}for(const h of s.keys())o.ops.push({op:3,id:h});n.listener?.(o),r=u},add(t){if(!(t instanceof c))throw new d(t.id);r.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){r.delete(t)&&n.listener?.({op:3,id:t})},get(t){return r.get(t)},toJSON(){return Array.from(r.values())}}};e.$HO=a}),define(ke[145],De([1,0,113]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=void 0;const O=new WeakMap,L=(M,b)=>{const $={controllerId:b};return O.set(M,$),$};e.$IO=L;const A=M=>{const b=O.get(M);if(!b)throw new l.$FO(M?.id||"<unknown>");return b};e.$JO=A}),define(ke[114],De([1,0,15,2]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aBb=e.$_Ab=e.$$Ab=void 0,e.$bBb=L,e.$cBb=M,e.$$Ab="vscode-cdn.net",e.$_Ab=`vscode-resource.${e.$$Ab}`,e.$aBb=`'self' https://*.${e.$$Ab}`;function L(b,$){return b.scheme===l.Schemas.http||b.scheme===l.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===l.Schemas.file&&(b=O.URI.from({scheme:l.Schemas.vscodeRemote,authority:$.authority,path:b.path})),O.URI.from({scheme:l.Schemas.https,authority:`${b.scheme}+${A(b.authority)}.${e.$_Ab}`,path:b.path,fragment:b.fragment,query:b.query}))}function A(b){return b.replace(/./g,$=>{const E=$.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?$:"-"+E.toString(16).padStart(4,"0")})}function M(b){return b.replace(/-([0-9a-f]{4})/g,($,E)=>String.fromCharCode(parseInt(E,16)))}}),define(ke[305],De([1,0,4,3,114]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=void 0;class A{constructor(b,$,E){this.d=b,this.e=$,this.f=E,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const I=$.getVisibleTextEditors();for(const P of this.c.values())I.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,E,I,P){let p;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){p=i;break}if(!p)throw new Error("not a visible editor");const S=this,v=this.a++,d=new l.$fe,f=new l.$fe,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,L.$bBb)(i,S.f)}get cspSource(){return L.$aBb}set options(i){this.b=i,S.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(i){return S.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=b,this.line=$,this.height=E,this.webview=a,this.onDidDispose=f.event}dispose(){S.c.has(v)&&(S.c.delete(v),S.d.$disposeEditorInset(v),f.fire(),f.dispose(),d.dispose())}};return this.d.$createEditorInset(v,p.id,p.value.document.uri,$+1,E,I||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:b,inset:n,onDidReceiveMessage:d}),n}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$hmc=A}),define(ke[146],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nL=e.$mL=e.$lL=void 0,e.$lL="__",e.$mL=(0,l.$yi)("IAuthenticationService"),e.$nL=(0,l.$yi)("IAuthenticationExtensionsService")}),define(ke[306],De([1,0,5]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=e.VariableKind=e.$BP=void 0,e.$BP=(0,l.$yi)("configurationResolverService");var O;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class L extends Error{constructor(M,b){super(b),this.variable=M}}e.$CP=L}),define(ke[307],De([1,0,16,52,18,24,12,103,246,306,14]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RP=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,v,d,f){this.h=new Map,this.a=S,this.b=v,this.g=d,f&&(this.c=f.then(a=>this.i(a)))}i(S){if(M.$i){const v=Object.create(null);return Object.keys(S).forEach(d=>{v[d.toLowerCase()]=S[d]}),v}return S}resolveWithEnvironment(S,v,d){return this.l({env:this.i(S),userHome:void 0},v?v.uri:void 0,d)}async resolveAsync(S,v){const d={env:await this.c,userHome:await this.g};return this.l(d,S?S.uri:void 0,v)}async j(S,v,d,f){const a=A.$5n(v);M.$i&&a.windows?Object.keys(a.windows).forEach(i=>a[i]=a.windows[i]):M.$j&&a.osx?Object.keys(a.osx).forEach(i=>a[i]=a.osx[i]):M.$k&&a.linux&&Object.keys(a.linux).forEach(i=>a[i]=a.linux[i]),delete a.windows,delete a.osx,delete a.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,S?S.uri:void 0,a,d,f)}async resolveAnyAsync(S,v,d){return this.j(S,v,d)}async resolveAnyMap(S,v,d){const f=new Map;return{newConfig:await this.j(S,v,d,f),resolvedVariables:f}}resolveWithInteractionReplace(S,v,d,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,v,d,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,v){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,v)}async l(S,v,d,f,a){if(L.$$f(d))return this.m(S,v,d,f,a);if(Array.isArray(d))return Promise.all(d.map(n=>this.l(S,v,n,f,a)));if(L.$ag(d)){const n=Object.create(null),i=await Promise.all(Object.keys(d).map(async c=>[await this.m(S,v,c,f,a),await this.l(S,v,d[c],f,a)]));for(const[c,r]of i)n[c]=r;return n}return d}m(S,v,d,f,a){return(0,I.$rf)(d,P.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(P.VARIABLE_LHS))return n;let c=await this.o(S,n,i,v,f);return a?.set(i,c),c!==n&&L.$$f(c)&&c.match(P.VARIABLE_REGEXP)&&(c=await this.m(S,v,c,f,a)),c})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,v,d,f,a){let n;const i=d.split(":");i.length>1&&(d=i[0],n=i[1]);const c=u=>{const s=this.a.getFilePath();if(s)return(0,b.$Iw)(s);throw new E.$CP(u,(0,$.localize)(0,null,v))},r=u=>{const s=c(u);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,b.$Iw)(o)}throw new E.$CP(u,(0,$.localize)(1,null,v,l.$nc(s)))},t=u=>{if(n){const s=this.a.getFolderUri(n);if(s)return s;throw new E.$CP(u,(0,$.localize)(2,null,v,n))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new E.$CP(u,(0,$.localize)(3,null,v)):new E.$CP(u,(0,$.localize)(4,null,v))};switch(d){case"env":if(n){if(S.env){const u=S.env[M.$i?n.toLowerCase():n];if(L.$$f(u))return u}return""}throw new E.$CP(E.VariableKind.Env,(0,$.localize)(5,null,v));case"config":if(n){const u=this.a.getConfigurationValue(f,n);if(L.$hg(u))throw new E.$CP(E.VariableKind.Config,(0,$.localize)(6,null,v,n));if(L.$ag(u))throw new E.$CP(E.VariableKind.Config,(0,$.localize)(7,null,v,n));return u}throw new E.$CP(E.VariableKind.Config,(0,$.localize)(8,null,v));case"command":return this.p(E.VariableKind.Command,v,n,a,"command");case"input":return this.p(E.VariableKind.Input,v,n,a,"input");case"extensionInstallFolder":if(n){const u=await this.a.getExtension(n);if(!u)throw new E.$CP(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,v,n));return this.n(u.extensionLocation)}throw new E.$CP(E.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,v));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,b.$Iw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return f||n?(0,b.$Iw)(this.n(t(E.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Iw)(l.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new E.$CP(E.VariableKind.UserHome,(0,$.localize)(11,null,v))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new E.$CP(E.VariableKind.LineNumber,(0,$.localize)(12,null,v))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new E.$CP(E.VariableKind.SelectedText,(0,$.localize)(13,null,v))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return r(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return l.$nc(r(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||n?l.$lc(this.n(t(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const u=l.$mc(c(E.VariableKind.RelativeFileDirname));if(f||n){const s=l.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),u);return s.length===0?".":s}return u}case"fileDirname":return l.$mc(c(E.VariableKind.FileDirname));case"fileExtname":return l.$oc(c(E.VariableKind.FileExtname));case"fileBasename":return l.$nc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=l.$nc(c(E.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-l.$oc(u).length)}case"fileDirnameBasename":return l.$nc(l.$mc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||v}case"execInstallFolder":{const u=this.a.getAppRoot();return u||v}case"pathSeparator":case"/":return l.sep;default:try{const u=n?`${d}:${n}`:d;return this.p(E.VariableKind.Unknown,v,u,a,void 0)}catch{return v}}}}p(S,v,d,f,a){if(d&&f){const n=a===void 0?f[d]:f[a+":"+d];if(typeof n=="string")return n;throw new E.$CP(S,(0,$.localize)(14,null,v))}return v}}e.$RP=P}),define(ke[147],De([1,0,5,143]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$3D=void 0,e.$4D=E,e.$5D=p,e.$6D=S,e.$3D=(0,l.$yi)("editorGroupsService");var L;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var M;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var b;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function E(v){const d=v;return(0,O.$NF)(d?.editor)&&(0,O.$NF)(d?.replacement)}var I;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function p(v){const d=v;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}function S(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[308],De([1,0,5,147]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0D=e.$9D=e.$8D=e.$7D=void 0,e.$$D=L,e.$7D=(0,l.$yi)("editorService"),e.$8D=-1,e.$9D=-2,e.$0D=-3;function L(A){const M=A;return typeof A=="number"||(0,O.$5D)(M)}}),define(ke[148],De([1,0,5,137]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GL=void 0,e.$GL=(0,l.$zi)(O.$Fi)}),define(ke[149],De([1,0,25,4,16,3,7]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=e.$zac=e.$yac=e.$xac=e.$wac=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$wac=b;class ${static isHostExtension(n,i,c){if(i.getExtensionDescription(n))return!1;const r=c.getExtensionDescription(n);return r?!!((r.main||r.browser)&&r.api==="none"):!1}constructor(n,i){this.j=n,this.c=new O.$fe,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(d),this.f=new l.$Vm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const c of i)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=f(this.e,i),this.e=this.e.concat(n);const c=$.l(this.e);return this.e=f(this.e,c.map(r=>r.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,c)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,o){this.addNode(s),this.addNode(o),this.c.has(s)?this.c.get(s).push(o):this.c.set(s,[o])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,o){const h=i.getArcs(s);for(let g=0;g<h.length;g++)if(!o.has(h[g]))return!1;return!0}getNodes(){return this.e}},c=new l.$Vm;for(const s of n)if(c.set(s.identifier,s),s.extensionDependencies)for(const o of s.extensionDependencies)i.addArc(l.$Tm.toKey(s.identifier),l.$Tm.toKey(o));const r=new Set;i.getNodes().filter(s=>i.getArcs(s).length===0).forEach(s=>r.add(s));const t=i.getNodes().filter(s=>!r.has(s));let u;do{u=!1;for(let s=0;s<t.length;s++){const o=t[s];i.hasOnlyGoodArcs(o,r)&&(t.splice(s,1),s--,r.add(o),u=!0)}}while(u);return t.map(s=>c.get(s))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$xac=$;class E{constructor(n,i){this.versionId=n,this.extensions=i}}e.$yac=E;class I{constructor(n){this.d=new S,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new P(this,i)}deltaExtensions(n,i,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$zac=I;class P extends A.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$Aac=P;class p{constructor(n){this.name=n;const i=(0,M.$rh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class S{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new p(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),r=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};n.resolve((0,A.$Sc)(r))}}var v;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(v||(v={}));function d(a,n){const i=a.isBuiltin?0:a.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==c)return i-c;const r=L.$gc.basename(a.extensionLocation.path),t=L.$gc.basename(n.extensionLocation.path);return r<t?-1:r>t?1:0}function f(a,n){const i=new l.$Um(n);return a.filter(c=>!i.has(c.identifier))}}),define(ke[309],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.ExtHostConnectionType=void 0,e.$pn=b,e.$qn=$;var l;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(l||(e.ExtHostConnectionType=l={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[O.ENV_KEY]=this.pipeName}}e.$mn=O;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[L.ENV_KEY]="1"}}e.$nn=L;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[A.ENV_KEY]="1"}}e.$on=A;function M(I){delete I[O.ENV_KEY],delete I[L.ENV_KEY],delete I[A.ENV_KEY]}function b(I,P){M(P),I.serialize(P)}function $(I){if(I[O.ENV_KEY])return E(I,new O(I[O.ENV_KEY]));if(I[L.ENV_KEY])return E(I,new L);if(I[A.ENV_KEY])return E(I,new A);throw new Error("No connection information defined in environment!")}function E(I,P){return M(I),P}}),define(ke[115],De([1,0,22]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$2m=M,e.$3m=b;var O;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(O||(e.UIKind=O={}));var L;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var A;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function M(E){const I=l.$He.alloc(1);switch(E){case 0:I.writeUInt8(1,0);break;case 1:I.writeUInt8(2,0);break;case 2:I.writeUInt8(3,0);break}return I}function b(E,I){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return I===0;case 2:return I===1;case 3:return I===2;default:return!1}}var $;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],De([1,0,5,4,11,28,115,86,87,24,2,3,231]),function(he,e,l,O,L,A,M,b,$,E,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8O=e.$6O=e.$5O=void 0,e.$7O=d;let S=class extends P.$Uc{constructor(a,n){super(),this.s=a,this.t=n,this.a=this.B(new O.$fe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$fe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=I.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$op,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,L.$7j)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,n,i){const c=this.getTelemetryDetails(),r=new v(n,i,a,this.n,this.j,this.getBuiltInCommonProperties(a),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(a.identifier.value)??[];return this.r.set(a.identifier.value,[...t,r]),r.apiTelemetryLogger}$initializeTelemetryLevel(a,n,i){this.f=a,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(a){const n=Object.create(null);switch(n["common.extname"]=`${a.publisher}.${a.name}`,n["common.extversion"]=a.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=d(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$Km)((0,$.$up)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const n=this.getTelemetryDetails();this.r.forEach((i,c)=>{const r=i.filter(t=>!t.isDisposed);r.length===0?this.r.delete(c):this.r.set(c,r)}),this.r.forEach(i=>{for(const c of i)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(a,n){const c=this.r.get(a.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(a.value),!1;let r=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(n),r=!0);return r}};e.$5O=S,e.$5O=S=Je([We(0,A.$4O),We(1,L.$6j)],S);class v{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,n,i,c,r,t,u){this.g=i,this.h=c,this.i=r,this.j=t,this.a=new O.$fe,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled}}updateTelemetryEnablements(a,n){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let n="properties"in a?a.properties??{}:a;return n=(0,$.$xp)(n,[]),this.c&&(n=(0,E.$8n)(n,this.c)),this.b||(n=(0,E.$8n)(n,this.j)),"properties"in a?a.properties=n:a=n,a}k(a,n){this.f&&(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(a,n),this.h.trace(a,n))}logUsage(a,n){this.d.isUsageEnabled&&this.k(a,n)}logError(a,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof a=="string")this.k(a,n);else{const i={name:a.name,message:a.message,stack:a.stack,cause:a.cause},c=(0,$.$xp)(i,[]),r=new Error(c.message,{cause:c.cause});r.stack=c.stack,r.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(r,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const a=this,n={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let a=this.f;this.f=void 0,Promise.resolve(a.flush()).then(a=void 0),this.e=void 0}else this.f=void 0}}e.$6O=v;function d(f){const a=Date.now()-new Date(f).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.$8O=(0,l.$yi)("IExtHostTelemetry")}),define(ke[26],De([1,0,4,2,278,140,25,5]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QG=e.ActivationKind=e.$NG=e.$MG=e.$JG=e.ExtensionHostStartup=e.$IG=e.$HG=e.$GG=e.$FG=void 0,e.$KG=p,e.$LG=S,e.$OG=a,e.$PG=n,e.$FG=Object.freeze({identifier:new M.$Tm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GG="extensions.webWorker",e.$HG=(0,b.$yi)("extensionService");class ${constructor(r){this.dependency=r}}e.$IG=$;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(r,t,u){this.c=r,this.d=t.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$qG.createActivationEventsMap(this.d)}}set(r,t,u){if(this.c>r)throw new Error(`ExtensionHostExtensions: invalid versionId ${r} (current: ${this.c})`);const s=[],o=[],h=[],g=[],w=P(this.d),k=P(t),m=(T,j)=>T.extensionLocation.toString()===j.extensionLocation.toString()||T.isBuiltin===j.isBuiltin||T.isUserBuiltin===j.isUserBuiltin||T.isUnderDevelopment===j.isUnderDevelopment;for(const T of this.d){const j=k.get(T.identifier);if(!j){s.push(T.identifier),w.delete(T.identifier);continue}if(!m(T,j)){s.push(T.identifier),w.delete(T.identifier);continue}}for(const T of t){const j=w.get(T.identifier);if(!j){o.push(T);continue}if(!m(j,T)){s.push(j.identifier),w.delete(j.identifier);continue}}const y=new M.$Um(this.e),D=new M.$Um(u);for(const T of this.e)D.has(T)||h.push(T);for(const T of u)y.has(T)||g.push(T);const C=A.$qG.createActivationEventsMap(o),R={versionId:r,toRemove:s,toAdd:o,addActivationEvents:C,myToRemove:h,myToAdd:g};return this.delta(R),R}delta(r){if(this.c>=r.versionId)return null;const{toRemove:t,toAdd:u,myToRemove:s,myToAdd:o}=r,h=new M.$Um(t),g=new M.$Um(s);for(let w=0;w<this.d.length;w++)h.has(this.d[w].identifier)&&(this.d.splice(w,1),w--);for(let w=0;w<this.e.length;w++)g.has(this.e[w])&&(this.e.splice(w,1),w--);for(const w of u)this.d.push(w);for(const w of o)this.e.push(w);return this.f=null,r}containsExtension(r){for(const t of this.e)if(M.$Tm.equals(t,r))return!0;return!1}containsActivationEvent(r){return this.f||(this.f=this.g()),this.f.has(r)}g(){const r=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const u=A.$qG.readActivationEvents(t);for(const s of u)r.add(s)}return r}}e.$JG=I;function P(c){const r=new M.$Vm;for(const t of c)r.set(t.identifier,t);return r}function p(c,r){return c.enabledApiProposals?c.enabledApiProposals.includes(r):!1}function S(c,r){if(!p(c,r))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${r}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${r}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class v{constructor(r,t,u,s){this.codeLoadingTime=r,this.activateCallTime=t,this.activateResolvedTime=u,this.activationReason=s}}e.$MG=v;class d{constructor(r,t){this.description=r,this.value=t}}e.$NG=d;var f;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function a(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,L.$Dp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function n(c,r){return{identifier:new M.$Tm((0,L.$Bp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!r,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None,this.onWillStop=l.Event.None,this.extensions=[]}activateByEvent(r){return Promise.resolve(void 0)}activateById(r,t){return Promise.resolve(void 0)}activationEventIsDone(r){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(r){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(r,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(r){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QG=i}),define(ke[310],De([1,0,13,149,25,26,11,7]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=e.$Hmc=e.$Gmc=e.$Fmc=e.$Emc=e.$Dmc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(a,n,i,c){this.startup=a,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=c}}e.$Dmc=$;class E{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,n){return a===-1||n===-1?-1:n-a}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Emc=E;class I{constructor(a,n,i,c,r,t){this.activationFailed=a,this.activationFailedError=n,this.activationTimes=i,this.module=c,this.exports=r,this.subscriptions=t}}e.$Fmc=I;class P extends I{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Gmc=P;class p extends I{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Hmc=p;class S extends I{constructor(a){super(!0,a,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(a,n,i,c){this.g=c,this.a=a,this.b=n,this.c=i,this.d=new L.$Vm,this.f=Object.create(null)}dispose(){for(const[a,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const a=[];for(const[n,i]of this.d)a.push(i.wait());await Promise.all(a)}isActivated(a){const n=this.d.get(a);return!!(n&&n.value)}getActivatedExtension(a){const n=this.d.get(a);if(!n||!n.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return n.value}async activateByEvent(a,n){if(this.f[a])return;const i=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(i.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,n){const i=this.a.getExtensionDescription(a);if(!i)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(a){const n=a.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const n=this.a.getExtensionDescription(a.id);if(!n){const r=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new S(r));return this.c.onExtensionActivationError(a.id,r,new A.$IG(a.id.value)),t}const i=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const r of c){if(this.m(r))continue;const t=this.d.get(r);if(t){i.push(t);continue}if(this.l(r)){i.push(this.j({id:this.b.getExtensionDescription(r).identifier,reason:a.reason}));continue}const u=this.a.getExtensionDescription(r);if(u){if(!u.main&&!u.browser)continue;i.push(this.j({id:u.identifier,reason:a.reason}));continue}const s=n.displayName||n.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${r}'`),h=this.k(a,n.displayName,[],new S(o));return this.c.onExtensionActivationError(n.identifier,o,new A.$IG(r)),h}return this.k(a,n.displayName,i,null)}k(a,n,i,c){const r=new d(a.id,n,a.reason,i,c,this.c,this.g);return this.d.set(a.id,r),r}l(a){return O.$xac.isHostExtension(a,this.a,this.b)}m(a){const n=this.b.getExtensionDescription(a);return n?!n.main&&!n.browser:!1}};e.$Imc=v,e.$Imc=v=Je([We(3,M.$5j)],v);let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,n,i,c,r,t,u){this.c=a,this.d=n,this.f=i,this.g=c,this.h=r,this.j=t,this.k=u,this.a=new b.$xh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const n=this.g[a];if(n.value&&!n.value.activationFailed){this.g.splice(a,1),a--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new S(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const n=new Error;if(a&&a.name&&(n.name=a.name),a&&a.message?n.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(n.stack=a.stack),this.h=new S(n),this.b&&l.$4(a))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};d=Je([We(6,M.$5j)],d)}),define(ke[311],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[312],De([1,0,248,13,41,138,110,36,25,311,108,140]),function(he,e,l,O,L,A,M,b,$,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=void 0;const p=b.$fo.as(M.$go.JSONContribution);class S{constructor(r,t,u){this.a=r,this.b=t,this.c=u}d(r,t){this.a({type:r,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(r){this.d(L.default.Error,r)}warn(r){this.d(L.default.Warning,r)}info(r){this.d(L.default.Info,r)}}e.$zG=S;class v{static a(r){const t=new $.$Um;for(let u=0,s=r.length;u<s;u++)t.add(r[u].description.identifier);return t}static compute(r,t){if(!r||!r.length)return new v(t,[]);if(!t||!t.length)return new v([],r);const u=this.a(r),s=this.a(t),o=t.filter(g=>!u.has(g.description.identifier)),h=r.filter(g=>!s.has(g.description.identifier));return new v(o,h)}constructor(r,t){this.added=r,this.removed=t}}e.$AG=v;class d{constructor(r,t){this.name=r,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(r){if(this.a!==null)throw new Error("Handler already set!");this.a=r,this.d()}acceptUsers(r){this.c=v.compute(this.b,r),this.b=r,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(r){(0,O.$1)(r)}}}e.$BG=d;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$CG={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Sm},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:l.localize(15,null),type:"string",enum:["none"],enumDescriptions:[l.localize(16,null)]},activationEvents:{description:l.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(32,null)},{label:"onUri",body:"onUri",description:l.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(37,null)},{label:"onRenderer",description:l.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:l.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:l.localize(42,null)},{label:"*",description:l.localize(43,null),body:"*"}]}},badges:{type:"array",description:l.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(45,null)},href:{type:"string",description:l.localize(46,null)},description:{type:"string",description:l.localize(47,null)}}}},markdown:{type:"string",description:l.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Wo}},extensionPack:{description:l.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Wo}},extensionKind:{description:l.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(53,null)},{body:["workspace"],description:l.localize(54,null)},{body:["ui","workspace"],description:l.localize(55,null)},{body:["workspace","ui"],description:l.localize(56,null)},{body:[],description:l.localize(57,null)}]},capabilities:{description:l.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(61,null),l.localize(62,null),l.localize(63,null)]},description:{type:"string",markdownDescription:l.localize(64,null)}}},untrustedWorkspaces:{description:l.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(67,null),l.localize(68,null),l.localize(69,null)]},restrictedConfigurations:{description:l.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(71,null)}}}}},sponsor:{description:l.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(74,null),type:"string"},"vscode:uninstall":{description:l.localize(75,null),type:"string"}}},icon:{type:"string",description:l.localize(76,null)},l10n:{type:"string",description:l.localize(77,null)},pricing:{type:"string",markdownDescription:l.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(r){if(this.a.has(r.extensionPoint))throw new Error("Duplicate extension point: "+r.extensionPoint);const t=new d(r.extensionPoint,r.defaultExtensionKind);return this.a.set(r.extensionPoint,t),r.activationEventsGenerator&&P.$qG.register(r.extensionPoint,r.activationEventsGenerator),e.$CG.properties.contributes.properties[r.extensionPoint]=r.jsonSchema,p.registerSchema(a,e.$CG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$DG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$fo.add(i.ExtensionsRegistry,new n),e.$EG=b.$fo.as(i.ExtensionsRegistry),p.registerSchema(a,e.$CG),p.registerSchema(I.$mk,{properties:{extensionEnabledApiProposals:{description:l.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(ke[313],De([1,0,244,18,24,312,38,4]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iI=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var E;(function(p){function S(v,d,f){if(!v)return;const a=O.$$f(v.type)?v.type:void 0;if(!a||a.length===0){f.error(l.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)O.$$f(i)&&n.push(i);return{extensionId:d.value,taskType:a,required:n,properties:v.properties?L.$5n(v.properties):{},when:v.when?M.$wj.deserialize(v.when):void 0}}p.from=S})(E||(E={}));const I=A.$EG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,S)=>{for(const v of p)v.type&&S.push(`onTaskType:${v.type}`)},jsonSchema:{description:l.localize(4,null),type:"array",items:$}});class P{constructor(){this.d=new b.$fe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,v)=>{I.setHandler((d,f)=>{this.c=void 0;try{for(const a of f.removed){const n=a.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const a of f.added){const n=a.value;for(const i of n){const c=E.from(i,a.description.identifier,a.collector);c&&(this.a[c.taskType]=c)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const v of this.all()){const d={type:"object",additionalProperties:!1};v.required.length>0&&(d.required=v.required.slice(0)),v.properties!==void 0?d.properties=L.$5n(v.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[v.taskType]},S.push(d)}this.c={oneOf:S}}return this.c}}e.$iI=new P}),define(ke[314],De([1,0,245,18,23,24,38,313]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$sI=e.JsonSchemaVersion=e.ExecutionEngine=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$mI=e.ShellQuoting=e.$lI=e.$kI=e.$jI=void 0,e.$jI="settings",e.$kI=new M.$Pj("taskRunning",!1,l.localize(0,null)),e.$lI=l.localize2(2,"Tasks");var $;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$mI="$customized",function(N){function F(B){if(!B)return N.Strong;switch(B.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=F}($||(e.ShellQuoting=$={}));var E;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var I;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(I||(e.RevealKind=I={})),function(N){function F(B){switch(B.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=F}(I||(e.RevealKind=I={}));var P;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(N){function F(B){switch(B.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=F}(P||(e.RevealProblemKind=P={}));var p;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(p||(e.PanelKind=p={})),function(N){function F(B){switch(B.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=F}(p||(e.PanelKind=p={}));var S;(function(N){N.defaults={echo:!0,reveal:I.Always,revealProblems:P.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var v;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(N){function F(Y){switch(Y.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=F;function B(Y){switch(Y){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=B}(v||(e.RuntimeType=v={}));var d;(function(N){function F(B){return O.$$f(B)?B:B.value}N.value=F})(d||(e.CommandString=d={}));var f;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function F(Y){return Y===N.Clean._id||Y===N.Build._id||Y===N.Rebuild._id||Y===N.Test._id}N.is=F;function B(Y){if(Y!==void 0)return O.$$f(Y)?F(Y)?{_id:Y,isDefault:!1}:void 0:Y}N.from=B})(f||(e.TaskGroup=f={}));var a;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(a||(e.TaskScope=a={}));var n;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function F(B){switch(B){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=F})(n||(e.TaskSourceKind=n={}));var i;(function(N){N.parallel="parallel",N.sequence="sequence"})(i||(e.DependsOrder=i={}));var c;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var r;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(r||(e.RunOptions=r={}));class t{constructor(F,B,Y,re,H,K){this._label="",this._id=F,B&&(this._label=B),Y&&(this.type=Y),this.runOptions=re,this.configurationProperties=H,this._source=K}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,B=!1){if(F===void 0)return!1;if(O.$$f(F))return F===this._label||F===this.configurationProperties.identifier||B&&F===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$nI=t;class u extends t{constructor(F,B,Y,re,H,K,_,Z){super(F,Y,void 0,_,Z,B),this.command={},this._source=B,this.hasDefinedMatchers=K,H&&(this.command=H)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(F){return F instanceof u}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$jI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const Y={type:e.$mI,folder:F,id:B};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$9g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new u(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$oI=u;class s extends t{constructor(F,B,Y,re,H,K,_){super(F,Y,re,K,_,B),this._source=B,this.configures=H}static is(F){return F instanceof s}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$9g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$jI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const Y={type:e.$mI,folder:F,id:B};return JSON.stringify(Y)}}e.$pI=s;class o extends t{constructor(F,B,Y,re,H,K,_,Z,$e){super(F,Y,re,Z,$e,B),this.defines=H,this.hasDefinedMatchers=_,this.command=K,this.icon=$e.icon,this.hide=$e.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof o}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new o(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$qI=o;class h extends t{constructor(F,B,Y,re,H,K){super(F,Y,re,H,K,B),this._source=B}clone(){return new h(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof h}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new h(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$rI=h;var g;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(N){N._default=N.Terminal}(g||(e.ExecutionEngine=g={}));var w;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class k{constructor(F){this.c=new Map;for(let B=0;B<F.length;B++)this.c.set(F[B].uri.toString(),B)}compare(F,B){const Y=F.getWorkspaceFolder(),re=B.getWorkspaceFolder();if(Y&&re){let H=this.c.get(Y.uri.toString());H=H===void 0?0:H+1;let K=this.c.get(re.uri.toString());return K=K===void 0?0:K+1,H===K?F._label.localeCompare(B._label):H-K}else return!Y&&re?-1:Y&&!re?1:0}}e.$sI=k;var m;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(m||(e.TaskEventKind=m={}));var y;(function(N){N.SingleRun="singleRun",N.Background="background"})(y||(e.TaskRunType=y={}));var D;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var C;(function(N){function F(Z){return{taskId:Z._id,taskName:Z.configurationProperties.name,runType:Z.configurationProperties.isBackground?"background":"singleRun",group:Z.configurationProperties.group,__task:Z}}function B(Z,$e,oe){return{...F(Z),kind:"start",terminalId:$e,resolvedVariables:oe}}N.start=B;function Y(Z,$e,oe){return{...F(Z),kind:"processStarted",terminalId:$e,processId:oe}}N.processStarted=Y;function re(Z,$e,oe){return{...F(Z),kind:"processEnded",terminalId:$e,exitCode:oe}}N.processEnded=re;function H(Z,$e,oe){return{...F(Z),kind:"terminated",exitReason:oe,terminalId:$e}}N.terminated=H;function K(Z,$e,oe){return{...F($e),kind:Z,terminalId:oe}}N.general=K;function _(){return{kind:"changed"}}N.changed=_})(C||(e.TaskEvent=C={}));var R;(function(N){function F(Y){const re=Object.keys(Y).sort();let H="";for(const K of re){let _=Y[K];_ instanceof Object?_=F(_):typeof _=="string"&&(_=_.replace(/,/g,",,")),H+=K+","+_+","}return H}function B(Y){const H={_key:F(Y),type:Y.taskType};return Object.assign(H,Y),H}N.create=B})(R||(e.KeyedTaskIdentifier=R={}));var T;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(T||(e.TaskSettingId=T={}));var j;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(N){function F(B,Y){const re=b.$iI.get(B.type);if(re===void 0){const Z=A.$5n(B);return delete Z._key,R.create(Z)}const H=Object.create(null);H.type=re.taskType;const K=new Set;re.required.forEach(Z=>K.add(Z));const _=re.properties;for(const Z of Object.keys(_)){const $e=B[Z];if($e!=null)H[Z]=$e;else if(K.has(Z)){const oe=_[Z];if(oe.default!==void 0)H[Z]=A.$5n(oe.default);else switch(oe.type){case"boolean":H[Z]=!1;break;case"number":case"integer":H[Z]=0;break;case"string":H[Z]="";break;default:Y.error(l.localize(1,null,JSON.stringify(B,void 0,0),Z));return}}}return R.create(H)}N.createTaskIdentifier=F})(z||(e.TaskDefinition=z={}))}),define(ke[315],De([1,0,13]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=e.$Bac=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,b)=>{this.b=M,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,l.$1)(M))}then(M,b){return this.j().then(M,b)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$Bac=O;class L extends O{constructor(){super(),this.h=!0,this.i=new l.$5}}e.$Cac=L}),define(ke[48],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fw=e.$Cw=void 0,e.$Dw=L,e.$Ew=A;class l{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++l.count}}e.$Cw=l;const O=[];function L(b){const $=new l(b);return O[$.nid]=$,$}function A(b){return O[b].sid}class M{constructor($){this.value=$}}e.$Fw=M}),define(ke[6],De([1,0,48]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$iM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var L;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput",d[d.ChatEditorInput=10]="ChatEditorInput",d[d.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var A;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var M;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var b;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var E;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var I;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output",d[d.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class P{static{this.a=0}static mixin(f){return f._id=P.a++,f}}e.$iM=P;var p;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var S;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$jM={MainThreadAuthentication:(0,l.$Dw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.$Dw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,l.$Dw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,l.$Dw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,l.$Dw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,l.$Dw)("MainThreadChatVariables"),MainThreadClipboard:(0,l.$Dw)("MainThreadClipboard"),MainThreadCommands:(0,l.$Dw)("MainThreadCommands"),MainThreadComments:(0,l.$Dw)("MainThreadComments"),MainThreadConfiguration:(0,l.$Dw)("MainThreadConfiguration"),MainThreadConsole:(0,l.$Dw)("MainThreadConsole"),MainThreadDebugService:(0,l.$Dw)("MainThreadDebugService"),MainThreadDecorations:(0,l.$Dw)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.$Dw)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.$Dw)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.$Dw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.$Dw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.$Dw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.$Dw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.$Dw)("MainThreadEditorTabs"),MainThreadErrors:(0,l.$Dw)("MainThreadErrors"),MainThreadTreeViews:(0,l.$Dw)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.$Dw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,l.$Dw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.$Dw)("MainThreadLanguages"),MainThreadLogger:(0,l.$Dw)("MainThreadLogger"),MainThreadMessageService:(0,l.$Dw)("MainThreadMessageService"),MainThreadOutputService:(0,l.$Dw)("MainThreadOutputService"),MainThreadProgress:(0,l.$Dw)("MainThreadProgress"),MainThreadQuickDiff:(0,l.$Dw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,l.$Dw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.$Dw)("MainThreadStatusBar"),MainThreadSecretState:(0,l.$Dw)("MainThreadSecretState"),MainThreadStorage:(0,l.$Dw)("MainThreadStorage"),MainThreadSpeech:(0,l.$Dw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,l.$Dw)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.$Dw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,l.$Dw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,l.$Dw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.$Dw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.$Dw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.$Dw)("MainThreadCustomEditors"),MainThreadUrls:(0,l.$Dw)("MainThreadUrls"),MainThreadUriOpeners:(0,l.$Dw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,l.$Dw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,l.$Dw)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.$Dw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,l.$Dw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,l.$Dw)("MainThreadExtensionService"),MainThreadSCM:(0,l.$Dw)("MainThreadSCM"),MainThreadSearch:(0,l.$Dw)("MainThreadSearch"),MainThreadShare:(0,l.$Dw)("MainThreadShare"),MainThreadTask:(0,l.$Dw)("MainThreadTask"),MainThreadWindow:(0,l.$Dw)("MainThreadWindow"),MainThreadLabelService:(0,l.$Dw)("MainThreadLabelService"),MainThreadNotebook:(0,l.$Dw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.$Dw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.$Dw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.$Dw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.$Dw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.$Dw)("MainThreadInteractive"),MainThreadTheming:(0,l.$Dw)("MainThreadTheming"),MainThreadTunnelService:(0,l.$Dw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,l.$Dw)("MainThreadManagedSockets"),MainThreadTimeline:(0,l.$Dw)("MainThreadTimeline"),MainThreadTesting:(0,l.$Dw)("MainThreadTesting"),MainThreadLocalization:(0,l.$Dw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,l.$Dw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,l.$Dw)("MainThreadAiEmbeddingVector")},e.$kM={ExtHostCommands:(0,l.$Dw)("ExtHostCommands"),ExtHostConfiguration:(0,l.$Dw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.$Dw)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.$Dw)("ExtHostDebugService"),ExtHostDecorations:(0,l.$Dw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.$Dw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.$Dw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.$Dw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.$Dw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.$Dw)("ExtHostEditors"),ExtHostTreeViews:(0,l.$Dw)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.$Dw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.$Dw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.$Dw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.$Dw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.$Dw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.$Dw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,l.$Dw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,l.$Dw)("ExtHostStatusBar"),ExtHostShare:(0,l.$Dw)("ExtHostShare"),ExtHostExtensionService:(0,l.$Dw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.$Dw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.$Dw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,l.$Dw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,l.$Dw)("ExtHostSCM"),ExtHostSearch:(0,l.$Dw)("ExtHostSearch"),ExtHostTask:(0,l.$Dw)("ExtHostTask"),ExtHostWorkspace:(0,l.$Dw)("ExtHostWorkspace"),ExtHostWindow:(0,l.$Dw)("ExtHostWindow"),ExtHostWebviews:(0,l.$Dw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.$Dw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.$Dw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.$Dw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.$Dw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.$Dw)("ExtHostEditorTabs"),ExtHostProgress:(0,l.$Dw)("ExtHostProgress"),ExtHostComments:(0,l.$Dw)("ExtHostComments"),ExtHostSecretState:(0,l.$Dw)("ExtHostSecretState"),ExtHostStorage:(0,l.$Dw)("ExtHostStorage"),ExtHostUrls:(0,l.$Dw)("ExtHostUrls"),ExtHostUriOpeners:(0,l.$Dw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,l.$Dw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,l.$Dw)("ExtHostOutputService"),ExtHostLabelService:(0,l.$Dw)("ExtHostLabelService"),ExtHostNotebook:(0,l.$Dw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.$Dw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.$Dw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.$Dw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.$Dw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,l.$Dw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,l.$Dw)("ExtHostInteractive"),ExtHostChatAgents2:(0,l.$Dw)("ExtHostChatAgents"),ExtHostChatVariables:(0,l.$Dw)("ExtHostChatVariables"),ExtHostChatProvider:(0,l.$Dw)("ExtHostChatProvider"),ExtHostSpeech:(0,l.$Dw)("ExtHostSpeech"),ExtHostEmbeddings:(0,l.$Dw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,l.$Dw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,l.$Dw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,l.$Dw)("ExtHostTheming"),ExtHostTunnelService:(0,l.$Dw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,l.$Dw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,l.$Dw)("ExtHostAuthentication"),ExtHostTimeline:(0,l.$Dw)("ExtHostTimeline"),ExtHostTesting:(0,l.$Dw)("ExtHostTesting"),ExtHostTelemetry:(0,l.$Dw)("ExtHostTelemetry"),ExtHostLocalization:(0,l.$Dw)("ExtHostLocalization")}}),define(ke[91],De([1,0,5,11,6,20]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=e.$4lc=e.$3lc=void 0,e.$3lc=(0,l.$yi)("IExtHostApiDeprecationService");let M=class{constructor($,E){this.c=E,this.a=new Set,this.b=$.getProxy(L.$jM.MainThreadTelemetry)}report($,E,I){const P=this.d($,E);this.a.has(P)||(this.a.add(P),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:$}))}d($,E){return`${$}-${E.identifier.value}`}};e.$4lc=M,e.$4lc=M=Je([We(0,A.$NO),We(1,O.$5j)],M),e.$5lc=Object.freeze(new class{report(b,$,E){}})}),define(ke[316],De([1,0,6]),function(he,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=void 0;class O{constructor(A){const M=A.getProxy(l.$jM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(b){return M.$writeText(b)}})}}e.$fmc=O}),define(ke[317],De([1,0,24,6,28,20]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=void 0;let M=class{constructor(I,P){this.a=I.getProxy(O.$jM.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,P){const p=this,S=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){p.e(I,P,S,arguments)}})}e(I,P,p,S){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:$(S,this.b)}),this.c&&this.f(I,p,S)}};e.$_nc=M,e.$_nc=M=Je([We(0,A.$NO),We(1,L.$4O)],M);const b=1e5;function $(E,I){const P=[];if(E.length)for(let p=0;p<E.length;p++){let S=E[p];if(typeof S>"u")S="undefined";else if(S instanceof Error){const v=S;v.stack?S=v.stack:S=v.toString()}P.push(S)}if(I){const p=new Error().stack;p&&P.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,l.$0n)(P);return p.length>b?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(ke[318],De([1,0,2,6,26]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0;class A{constructor(b){this.a=b.getProxy(O.$jM.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,L.$LG)(b,"showLocal"),this.a.$showOpenDialog($).then(E=>E?E.map(I=>l.URI.revive(I)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?l.URI.revive($):void 0)}}e.$cnc=A}),define(ke[319],De([1,0,21,4,3,6]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0;class M{constructor($){this.b=new Map,this.c=new O.$fe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(A.$jM.MainThreadEmbeddings)}registerEmbeddingsProvider($,E,I){if(this.d.has(E))throw new Error("An embeddings provider for this model is already registered");const P=this.e++;return this.a.$registerEmbeddingProvider(P,E),this.b.set(P,{id:E,provider:I}),(0,L.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(P),this.b.delete(P)})}async computeEmbeddings($,E,I){I??=l.CancellationToken.None;let P=!1;typeof E=="string"&&(E=[E],P=!0);const p=await this.a.$computeEmbeddings($,E,I);if(p.length!==E.length)throw new Error;if(P){if(p.length!==1)throw new Error;return p[0]}return p}async $provideEmbeddings($,E,I){const P=this.b.get($);if(!P)return[];const p=await P.provider.provideEmbeddings(E,I);return p||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$fnc=M}),define(ke[320],De([1,0,3,6]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=void 0;class L{constructor(M){this.b=0,this.a=M.getProxy(O.$jM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,M),(0,l.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$wnc=L}),define(ke[116],De([1,0,12,14,2,5,11,6,28,20]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=e.$Wmc=void 0;let I=class{constructor(p,S,v){this.f=v,this.d=new Map,this.a=S.getProxy(b.$jM.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===l.$g}getMessage(p,S){const{message:v,args:d,comment:f}=S;if(this.c)return(0,O.$$e)(v,d??{});let a=v;f&&f.length>0&&(a+=`/${Array.isArray(f)?f.join(""):f}`);const n=this.d.get(p)?.contents[a];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,O.$$e)(n??v,d??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let S;const v=await this.g(p);if(!v){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(v),f=JSON.parse(d);S=p.isBuiltin?f.contents?.bundle:f}catch(d){this.f.error(`Failed to load translations for ${p.identifier.value} from ${v}: ${d.message}`);return}S&&this.d.set(p.identifier.value,{contents:S,uri:v})}async g(p){if(p.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return L.URI.revive(S)}return p.l10n?L.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Wmc=I,e.$Wmc=I=Je([We(0,$.$4O),We(1,E.$NO),We(2,M.$5j)],I),e.$Xmc=(0,A.$yi)("IExtHostLocalizationService")}),define(ke[150],De([1,0,11,6,28,20,2,58]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;let $=class extends l.$dk{constructor(P,p){super(p.logLevel,p.logsLocation,p.loggers.map(S=>(0,b.$8h)(S))),this.r=P.getProxy(O.$jM.MainThreadLogger)}$setLogLevel(P,p){p?this.setLogLevel(M.URI.revive(p),P):this.setLogLevel(P)}setVisibility(P,p){super.setVisibility(P,p),this.r.$setVisibility(P,p)}s(P,p,S){return new E(this.r,P,p,S)}};e.$$nc=$,e.$$nc=$=Je([We(0,A.$NO),We(1,L.$4O)],$);class E extends l.$$j{constructor(P,p,S,v){super(v?.logLevel==="always"),this.r=P,this.s=p,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(p,v).then(()=>{this.u(this.n),this.m=!0})}g(P,p){const S=[[P,p]];this.m?this.u(S):this.n.push(...S)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[117],De([1,0,6,5,3,20,22]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=void 0,e.$Ymc=(0,O.$yi)("IExtHostManagedSockets");let b=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(l.$jM.MainThreadManagedSockets)}setFactory(P,p){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(P,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const p=++this.b,S=await this.c.makeConnection(),v=new L.$Tc;return this.d.set(p,new E(p,S,v)),v.add((0,L.$Sc)(()=>this.d.delete(p))),v.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),v.dispose()})),v.add(S.onDidClose(d=>{this.a.$onDidManagedSocketClose(p,d?.stack??d?.message),v.dispose()})),v.add(S.onDidReceiveMessage(d=>this.a.$onDidManagedSocketHaveData(p,M.$He.wrap(d)))),p}$remoteSocketWrite(P,p){this.d.get(P)?.actual.send(p.buffer)}$remoteSocketEnd(P){const p=this.d.get(P);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$Zmc=b,e.$Zmc=b=Je([We(0,A.$NO)],b);class ${constructor(P,p){this.socketFactoryId=P,this.makeConnection=p}}class E extends L.$Uc{constructor(P,p,S){super(),this.socketId=P,this.actual=p,this.B(S)}}}),define(ke[321],De([1,0,6,11,26]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=void 0;function A(b){return b&&b.title}let M=class{constructor($,E){this.b=E,this.a=$.getProxy(l.$jM.MainThreadMessageService)}showMessage($,E,I,P,p){const S={source:{identifier:$.identifier,label:$.displayName||$.name}};let v;typeof P=="string"||A(P)?v=[P,...p]:(S.modal=P?.modal,S.useCustom=P?.useCustom,S.detail=P?.detail,v=p),S.useCustom&&(0,L.$LG)($,"resolvers");const d=[];let f=!1;for(let a=0;a<v.length;a++){const n=v[a];if(typeof n=="string")d.push({title:n,handle:a,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:c}=n;d.push({title:i,isCloseAffordance:!!c,handle:a}),c&&(f?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):f=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(E,I,S,d).then(a=>{if(typeof a=="number")return v[a]})}};e.$ync=M,e.$ync=M=Je([We(1,O.$5j)],M)}),define(ke[322],De([1,0,3,18,2,26,6]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=void 0;class b{constructor(E){this.b=new Map,this.a=E.getProxy(M.$jM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,I,P){if((0,A.$LG)(E,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,P),this.a.$registerProfileContentHandler(I,P.name,P.description,E.identifier.value),(0,l.$Sc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(E,I,P,p){const S=this.b.get(E);if(!S)throw new Error(`Unknown handler with id: ${E}`);return S.saveProfile(I,P,p)}async $readProfile(E,I,P){const p=this.b.get(E);if(!p)throw new Error(`Unknown handler with id: ${E}`);return p.readProfile((0,O.$$f)(I)?I:L.URI.revive(I),P)}}e.$Hnc=b}),define(ke[118],De([1,0,6,4,5]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=e.$Tmc=void 0;class A{constructor(b){this.b=new O.$fe,this.onDidChangePassword=this.b.event,this.a=b.getProxy(l.$jM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,E){return this.a.$setPassword(b,$,E)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$Tmc=A,e.$Umc=(0,L.$yi)("IExtHostSecretState")}),define(ke[323],De([1,0,21,3,6]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=void 0;class A{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.f=new Map,this.b=b.getProxy(L.$jM.MainThreadSpeech)}async $createSpeechToTextSession(b,$,E){const I=this.c.get(b);if(!I)return;const P=new O.$Tc,p=new l.$qe;this.d.set($,p);const S=await I.provideSpeechToTextSession(p.token,E?{language:E}:void 0);S&&(P.add(S.onDidChange(v=>{p.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),P.add(p.token.onCancellationRequested(()=>P.dispose())))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createTextToSpeechSession(b,$,E){const I=this.c.get(b);if(!I)return;const P=new O.$Tc,p=new l.$qe;this.d.set($,p);const S=await I.provideTextToSpeechSession(p.token,E?{language:E}:void 0);S&&(this.f.set($,S),P.add(S.onDidChange(v=>{p.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,v)})),P.add(p.token.onCancellationRequested(()=>P.dispose())))}async $synthesizeSpeech(b,$){this.f.get(b)?.synthesize($)}async $cancelTextToSpeechSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b),this.f.delete(b)}async $createKeywordRecognitionSession(b,$){const E=this.c.get(b);if(!E)return;const I=new O.$Tc,P=new l.$qe;this.d.set($,P);const p=await E.provideKeywordRecognitionSession(P.token);p&&(I.add(p.onDidChange(S=>{P.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,S)})),I.add(P.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,E){const I=A.a++;return this.c.set(I,E),this.b.$registerProvider(I,$,{extension:b,displayName:b.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$Onc=A}),define(ke[119],De([1,0,6,4,5]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=e.$Jmc=void 0;class A{constructor(b,$){this.c=$,this.b=new O.$fe,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(l.$jM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,E){const I=await this.a.$initializeExtensionStorage(b,$);let P;return I&&(P=this.d(b,$,I)),P||E}setValue(b,$,E){return this.a.$setValue(b,$,E)}$acceptValue(b,$,E){const I=this.d(b,$,E);I&&this.b.fire({shared:b,key:$,value:I})}d(b,$,E){try{return JSON.parse(E)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${I}`)}}}e.$Jmc=A,e.$Kmc=(0,L.$yi)("IExtHostStorage")}),define(ke[324],De([1,0,3,15,2,6]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=void 0;class M{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(A.$jM.MainThreadUriOpeners)}registerExternalUriOpener($,E,I,P){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const p=P.schemes.find(S=>!M.a.has(S));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(E,I),this.b.$registerUriOpener(E,P.schemes,$,P.label),(0,l.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri($,E,I){const P=this.c.get($);if(!P)throw new Error(`Unknown opener with id: ${$}`);const p=L.URI.revive(E);return P.canOpenExternalUri(p,I)}async $openUri($,E,I){const P=this.c.get($);if(!P)throw new Error(`Unknown opener id: '${$}'`);return P.openExternalUri(L.URI.revive(E.resolvedUri),{sourceUri:L.URI.revive(E.sourceUri)},I)}}e.$5nc=M}),define(ke[325],De([1,0,6,2,3,13,25]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class b{static{this.a=0}constructor(E){this.c=new M.$Um,this.d=new Map,this.b=E.getProxy(l.$jM.MainThreadUrls)}registerUriHandler(E,I){const P=E.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const p=b.a++;return this.c.add(P),this.d.set(p,I),this.b.$registerUriHandler(p,P,E.displayName||E.name),(0,L.$Sc)(()=>{this.c.delete(P),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(E,I){const P=this.d.get(E);if(!P)return Promise.resolve(void 0);try{P.handleUri(O.URI.revive(I))}catch(p){(0,A.$1)(p)}return Promise.resolve(void 0)}async createAppUri(E){return O.URI.revive(await this.b.$createAppUri(E))}}e.$6nc=b}),define(ke[92],De([1,0,4,3,15,24,2,252,290,114,6]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=e.$umc=void 0,e.$vmc=p,e.$xmc=d,e.$ymc=f;class P{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,r,t,u,s,o,h){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new l.$fe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new l.$fe,this._onDidDispose=this.#h.event,this.#e=c,this.#t=r,this.#o=t,this.#i=u,this.#s=s,this.#r=o,this.#l=p(o),this.#d=S(o),this.#n=h}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,E.$bBb)(c,this.#i)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===L.Schemas.https||c.scheme===L.Schemas.http){let r=c.toString();return r.endsWith("/")||(r+="/"),r+" "+E.$aBb}return E.$aBb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#n.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),A.$9n(this.#o,c)||this.#t.$setOptions(this.#e,f(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const r=(0,$.$$rb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,r.message,...r.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const r=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,s,o,h,g,w)=>{const k=M.URI.from({scheme:h||"file",path:decodeURIComponent(g)}),m=(0,E.$bBb)(k,{isRemote:r,authority:t}).toString();return`${s}${m}${w}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,s,o,h,g,w)=>{const k=M.URI.from({scheme:h||"file",path:decodeURIComponent(g)}),m=(0,E.$bBb)(k,{isRemote:r,authority:t}).toString();return`${s}${m}${w}`})}}e.$umc=P;function p(i){try{const c=(0,b.$Mp)((0,b.$Lp)(i.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function S(i){try{const c=(0,b.$Mp)((0,b.$Lp)(i.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class v extends O.$Uc{constructor(c,r,t,u,s){super(),this.c=r,this.f=t,this.g=u,this.h=s,this.b=new Map,this.a=c.getProxy(I.$jM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,r,t){const u=this.j(c);if(u){const{message:s}=(0,$.$_rb)(r,t.value);u._onMessageEmitter.fire(s)}}$onMissingCsp(c,r){this.g.warn(`${r} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,r,t){const u=new P(c,this.a,a(r),this.c,this.f,t,this.h);this.b.set(c,u);const s=u._onDidDispose(()=>{s.dispose(),this.deleteWebview(c)});return u}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$wmc=v;function d(i){return{id:i.identifier,location:i.extensionLocation}}function f(i,c,r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots||n(i,c)}}function a(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(c=>M.URI.from(c))}}function n(i,c){return[...(c?.getWorkspaceFolders()||[]).map(r=>r.uri),i.extensionLocation]}}),define(ke[151],De([1,0,4,15,14,2,5,20,6]),function(he,e,l,O,L,A,M,b,$){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=e.$8nc=void 0;let I=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const p=this.d;return{get focused(){return p.focused},get active(){return p.active}}}constructor(p){this.c=new l.$fe,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=p.getProxy($.$jM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:v})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,S){S!==this.d[p]&&(this.d={...this.d,[p]:S},this.c.fire(this.d))}openUri(p,S){let v;if(typeof p=="string"){v=p;try{p=A.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,L.$9e)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,v,S)}async asExternalUri(p,S){if((0,L.$9e)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(p,S);return A.URI.from(v)}};e.$8nc=I,e.$8nc=I=E=Je([We(0,b.$NO)],I),e.$9nc=(0,M.$yi)("IExtHostWindow")}),define(ke[326],De([1,0,317,28,20]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=void 0;const A=1024*1024;let M=class extends l.$_nc{constructor($,E){super($,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,E,I){const P=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),E.apply(console,I),P.write(`
END_NATIVE_LOG
`),this.g=!1}j($,E){const I=process[$],P=I.write;let p="";Object.defineProperty(I,"write",{set:()=>{},get:()=>(S,v,d)=>{if(!this.g){p+=S.toString(v);const f=p.length>A?p.length:p.lastIndexOf(`
`);f!==-1&&(console[E](p.slice(0,f)),p=p.slice(f+1))}P.call(I,S,v,d)}})}};e.$Koc=M,e.$Koc=M=Je([We(0,L.$NO),We(1,O.$4O)],M)}),define(ke[327],De([1,0,150,15,267,30]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0;class M extends l.$$nc{s($,E,I){return $.scheme===O.Schemas.file?new L.$3P(I?.name||(0,A.$Ug)(),$.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,E):super.s($,E,I)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Woc=M}),define(ke[328],De([1,0,7,22,21,13,4,3,134,315,48]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=e.ResponsiveState=e.RequestInitiator=void 0,e.$Dac=f,e.$Eac=a;function p(D,C){try{return JSON.stringify(D,C)}catch{return"null"}}const S="$$ref$$",v={[S]:-1};class d{constructor(C,R){this.jsonString=C,this.referencedBuffers=R}}function f(D,C=null,R=!1){const T=[];return{jsonString:(R?p:JSON.stringify)(D,(z,N)=>{if(typeof N>"u")return v;if(typeof N=="object"){if(N instanceof O.$He){const F=T.push(N)-1;return{[S]:F}}if(C)return C(z,N)}return N}),referencedBuffers:T}}function a(D,C,R){return JSON.parse(D,(T,j)=>{if(j){const z=j[S];if(typeof z=="number")return C[z];if(R&&j.$mid===1)return R.transformIncoming(j)}return j})}function n(D,C){return JSON.stringify(D,C)}function i(D){return D?(C,R)=>R&&R.$mid===1?D.transformOutgoing(R):R:null}var c;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var r;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(r||(e.ResponsiveState=r={}));const t=()=>{},u=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends b.$Uc{static{P=u}static{this.a=3*1e3}constructor(C,R=null,T=null){super(),this[P]=!0,this.b=this.B(new M.$fe),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=R,this.g=T,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,z=I.$Cw.count;j<z;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new l.$Kh(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const R=this.w[C];delete this.w[C],R.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,$.$Dn)(C,this.g):C}getProxy(C){const{nid:R,sid:T}=C;return this.s[R]||(this.s[R]=this.J(R,T)),this.s[R]}J(C,R){const T={get:(j,z)=>(typeof z=="string"&&!j[z]&&z.charCodeAt(0)===36&&(j[z]=(...N)=>this.U(C,z,N)),z===s?R:j[z])};return new Proxy(Object.create(null),T)}set(C,R){return this.m[C.nid]=R,R}assertRegistered(C){for(let R=0,T=C.length;R<T;R++){const j=C[R];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(C){if(this.j)return;const R=C.byteLength,T=g.read(C,0),j=T.readUInt8(),z=T.readUInt32();switch(j){case 1:case 2:{let{rpcId:N,method:F,args:B}=k.deserializeRequestJSONArgs(T);this.g&&(B=(0,$.$Dn)(B,this.g)),this.M(R,z,N,F,B,j===2);break}case 3:case 4:{let{rpcId:N,method:F,args:B}=k.deserializeRequestMixedArgs(T);this.g&&(B=(0,$.$Dn)(B,this.g)),this.M(R,z,N,F,B,j===4);break}case 5:{this.f?.logIncoming(R,z,0,"ack"),this.G(z);break}case 6:{this.N(R,z);break}case 7:{this.O(R,z,void 0);break}case 9:{let N=k.deserializeReplyOKJSON(T);this.g&&(N=(0,$.$Dn)(N,this.g)),this.O(R,z,N);break}case 10:{const N=k.deserializeReplyOKJSONWithBuffers(T,this.g);this.O(R,z,N);break}case 8:{const N=k.deserializeReplyOKVSBuffer(T);this.O(R,z,N);break}case 11:{let N=k.deserializeReplyErrError(T);this.g&&(N=(0,$.$Dn)(N,this.g)),this.P(R,z,N);break}case 12:{this.P(R,z,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,R,T,j,z,N){this.f?.logIncoming(C,R,1,`receiveRequest ${(0,I.$Ew)(T)}.${j}(`,z);const F=String(R);let B,Y;if(N){const H=new L.$qe;z.push(H.token),B=this.Q(T,j,z),Y=()=>H.cancel()}else B=this.Q(T,j,z),Y=t;this.u[F]=Y;const re=k.serializeAcknowledged(R);this.f?.logOutgoing(re.byteLength,R,1,"ack"),this.c.send(re),B.then(H=>{delete this.u[F];const K=k.serializeReplyOK(R,H,this.h);this.f?.logOutgoing(K.byteLength,R,1,"reply:",H),this.c.send(K)},H=>{delete this.u[F];const K=k.serializeReplyErr(R,H);this.f?.logOutgoing(K.byteLength,R,1,"replyErr:",H),this.c.send(K)})}N(C,R){this.f?.logIncoming(C,R,1,"receiveCancel");const T=String(R);this.u[T]?.()}O(C,R,T){this.f?.logIncoming(C,R,0,"receiveReply:",T);const j=String(R);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j],z.resolveOk(T)}P(C,R,T){this.f?.logIncoming(C,R,0,"receiveReplyErr:",T);const j=String(R);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j];let N;T&&(T.$isError?(N=new Error,N.name=T.name,N.message=T.message,N.stack=T.stack):N=T),z.resolveErr(N)}Q(C,R,T){try{return Promise.resolve(this.S(C,R,T))}catch(j){return Promise.reject(j)}}S(C,R,T){const j=this.m[C];if(!j)throw new Error("Unknown actor "+(0,I.$Ew)(C));const z=j[R];if(typeof z!="function")throw new Error("Unknown method "+R+" on actor "+(0,I.$Ew)(C));return z.apply(j,T)}U(C,R,T){if(this.j)return new E.$Cac;let j=null;if(T.length>0&&L.CancellationToken.isCancellationToken(T[T.length-1])&&(j=T.pop()),j&&j.isCancellationRequested)return Promise.reject(A.$6());const z=k.serializeRequestArguments(T,this.h),N=++this.t,F=String(N),B=new E.$Bac,Y=new b.$Tc;j&&Y.add(j.onCancellationRequested(()=>{const H=k.serializeCancel(N);this.f?.logOutgoing(H.byteLength,N,0,"cancel"),this.c.send(k.serializeCancel(N))})),this.w[F]=new h(B,Y),this.F(N);const re=k.serializeRequest(N,C,R,z,!!j);return this.f?.logOutgoing(re.byteLength,N,0,`request: ${(0,I.$Ew)(C)}.${R}(`,T),this.c.send(re),B}}e.$Fac=o;class h{constructor(C,R){this.a=C,this.b=R}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class g{static alloc(C,R,T){const j=new g(O.$He.alloc(T+1+4),0);return j.writeUInt8(C),j.writeUInt32(R),j}static read(C,R){return new g(C,R)}get buffer(){return this.a}constructor(C,R){this.a=C,this.b=R}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const T=this.a.slice(this.b,this.b+C).toString();return this.b+=C,T}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+C).toString();return this.b+=C,T}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const R=this.a.slice(this.b,this.b+C);return this.b+=C,R}static sizeMixedArray(C){let R=0;R+=1;for(let T=0,j=C.length;T<j;T++){const z=C[T];switch(R+=1,z.type){case 1:R+=this.sizeLongString(z.value);break;case 2:R+=this.sizeVSBuffer(z.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(z.value);for(let N=0;N<z.buffers.length;++N)R+=this.sizeVSBuffer(z.buffers[N]);break;case 4:break}}return R}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let R=0,T=C.length;R<T;R++){const j=C[R];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let z=0;z<j.buffers.length;++z)this.writeBuffer(j.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const R=new Array(C);for(let T=0;T<C;T++)switch(this.readUInt8()){case 1:R[T]=this.readLongString();break;case 2:R[T]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),N=this.readLongString(),F=[];for(let B=0;B<z;++B)F.push(this.readVSBuffer());R[T]=new I.$Fw(a(N,F,null));break}case 4:R[T]=void 0;break}return R}}var w;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(w||(w={}));class k{static a(C){for(let R=0,T=C.length;R<T;R++)if(C[R]instanceof O.$He||C[R]instanceof I.$Fw||typeof C[R]>"u")return!0;return!1}static serializeRequestArguments(C,R){if(this.a(C)){const T=[];for(let j=0,z=C.length;j<z;j++){const N=C[j];if(N instanceof O.$He)T[j]={type:2,value:N};else if(typeof N>"u")T[j]={type:4};else if(N instanceof I.$Fw){const{jsonString:F,referencedBuffers:B}=f(N.value,R);T[j]={type:3,value:O.$He.fromString(F),buffers:B}}else T[j]={type:1,value:O.$He.fromString(n(N,R))}}return{type:1,args:T}}return{type:0,args:n(C,R)}}static serializeRequest(C,R,T,j,z){switch(j.type){case 0:return this.b(C,R,T,j.args,z);case 1:return this.c(C,R,T,j.args,z)}}static b(C,R,T,j,z){const N=O.$He.fromString(T),F=O.$He.fromString(j);let B=0;B+=g.sizeUInt8(),B+=g.sizeShortString(N),B+=g.sizeLongString(F);const Y=g.alloc(z?2:1,C,B);return Y.writeUInt8(R),Y.writeShortString(N),Y.writeLongString(F),Y.buffer}static deserializeRequestJSONArgs(C){const R=C.readUInt8(),T=C.readShortString(),j=C.readLongString();return{rpcId:R,method:T,args:JSON.parse(j)}}static c(C,R,T,j,z){const N=O.$He.fromString(T);let F=0;F+=g.sizeUInt8(),F+=g.sizeShortString(N),F+=g.sizeMixedArray(j);const B=g.alloc(z?4:3,C,F);return B.writeUInt8(R),B.writeShortString(N),B.writeMixedArray(j),B.buffer}static deserializeRequestMixedArgs(C){const R=C.readUInt8(),T=C.readShortString(),j=C.readMixedArray(),z=new Array(j.length);for(let N=0,F=j.length;N<F;N++){const B=j[N];typeof B=="string"?z[N]=JSON.parse(B):z[N]=B}return{rpcId:R,method:T,args:z}}static serializeAcknowledged(C){return g.alloc(5,C,0).buffer}static serializeCancel(C){return g.alloc(6,C,0).buffer}static serializeReplyOK(C,R,T){if(typeof R>"u")return this.d(C);if(R instanceof O.$He)return this.e(C,R);if(R instanceof I.$Fw){const{jsonString:j,referencedBuffers:z}=f(R.value,T,!0);return this.g(C,j,z)}else return this.f(C,p(R,T))}static d(C){return g.alloc(7,C,0).buffer}static e(C,R){let T=0;T+=g.sizeVSBuffer(R);const j=g.alloc(8,C,T);return j.writeVSBuffer(R),j.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,R){const T=O.$He.fromString(R);let j=0;j+=g.sizeLongString(T);const z=g.alloc(9,C,j);return z.writeLongString(T),z.buffer}static g(C,R,T){const j=O.$He.fromString(R);let z=0;z+=g.sizeUInt32,z+=g.sizeLongString(j);for(const F of T)z+=g.sizeVSBuffer(F);const N=g.alloc(10,C,z);N.writeUInt32(T.length),N.writeLongString(j);for(const F of T)N.writeBuffer(F);return N.buffer}static deserializeReplyOKJSON(C){const R=C.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(C,R){const T=C.readUInt32(),j=C.readLongString(),z=[];for(let N=0;N<T;++N)z.push(C.readVSBuffer());return new I.$Fw(a(j,z,R))}static serializeReplyErr(C,R){const T=R?p(A.$3(R),null):void 0;if(typeof T!="string")return this.h(C);const j=O.$He.fromString(T);let z=0;z+=g.sizeLongString(j);const N=g.alloc(11,C,z);return N.writeLongString(j),N.buffer}static deserializeReplyErrError(C){const R=C.readLongString();return JSON.parse(R)}static h(C){return g.alloc(12,C,0).buffer}}var m;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var y;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(y||(y={}))}),define(ke[329],De([1,0,22,27,15,85,5]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJ=e.$WJ=void 0,e.$XJ=I,e.$YJ=P,e.$WJ=(0,M.$yi)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${b.join("")}]+`),E=7;function I(S){if(S.scheme!==L.Schemas.vscodeNotebookCell)return;const v=S.fragment.indexOf("s");if(v<0)return;const d=parseInt(S.fragment.substring(0,v).replace($,""),E),f=(0,l.$1e)(S.fragment.substring(v+1)).toString();if(!isNaN(d))return{handle:d,notebook:S.with({scheme:f,fragment:null})}}function P(S,v){const d=v.toString(E),a=`${d.length<b.length?b[d.length-1]:"z"}${d}s${(0,l.$2e)(l.$He.fromString(S.scheme),!0,!0)}`;return S.with({scheme:L.Schemas.vscodeNotebookCell,fragment:a})}class p{constructor(){this.a=new O.$Ac}getNotebook(v){if(v.scheme===L.Schemas.vscodeNotebookCell){const d=I(v);if(d){const f=this.a.get(d.notebook);if(f)return f}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$ZJ=p,(0,A.$Bs)(e.$WJ,p,1)}),define(ke[120],De([1,0,22,35,39,101,15,16,12,38,329]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hK=e.$eK=e.CellStatusbarAlignment=e.$dK=e.NotebookEditorPriority=e.$aK=e.$_J=e.$0J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$9J=e.$8J=e.$7J=e.$6J=e.CellKind=e.$5J=e.$4J=e.$3J=void 0,e.$$J=u,e.$bK=o,e.$cK=h,e.$fK=k,e.$gK=y,e.$3J="workbench.editor.notebook",e.$4J="workbench.editor.notebookTextDiffEditor",e.$5J="workbench.editor.interactive";var P;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(P||(e.CellKind=P={})),e.$6J=["application/json","application/javascript","text/html","image/svg+xml",A.$Us.latex,A.$Us.markdown,"image/png","image/jpeg",A.$Us.text],e.$7J=[A.$Us.latex,A.$Us.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$Us.text],e.$8J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$9J="_notAvailable";var p;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var S;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var d;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(d||(e.NotebookRendererMatch=d={}));var f;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var a;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var c;(function(B){B.scheme=M.Schemas.vscodeNotebookCell;function Y($e,oe){return(0,I.$YJ)($e,oe)}B.generate=Y;function re($e){return(0,I.$XJ)($e)}B.parse=re;function H($e,oe){return $e.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${oe??""},${$e.scheme!==M.Schemas.file?$e.scheme:""}`})}B.generateCellOutputUri=H;function K($e){if($e.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const oe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!oe)return;const Pe=oe[1]&&oe[1]!==""?oe[1]:void 0,te=oe[2];return{outputId:Pe,notebook:$e.with({scheme:te||M.Schemas.file,fragment:null})}}B.parseCellOutputUri=K;function _($e,oe,Pe){return B.generate($e,oe).with({scheme:Pe})}B.generateCellPropertyUri=_;function Z($e,oe){if($e.scheme===oe)return B.parse($e.with({scheme:B.scheme}))}B.parseCellPropertyUri=Z})(c||(e.CellUri=c={}));const r=B=>$.$i?B.replace(/\//g,"\\"):B;class t{constructor(Y=[],re=e.$6J){this.e=re,this.d=[...new Set(Y)].map(H=>({pattern:H,matches:O.$sk(r(H))}))}sort(Y){const re=new Map(L.Iterable.map(Y,K=>[K,r(K)]));let H=[];for(const{matches:K}of this.d)for(const[_,Z]of re)if(K(Z)){H.push(_),re.delete(_);break}return re.size&&(H=H.concat([...re.keys()].sort((K,_)=>this.e.indexOf(K)-this.e.indexOf(_)))),H}prioritize(Y,re){const H=this.f(Y);if(H===-1){this.d.unshift({pattern:Y,matches:O.$sk(r(Y))});return}const K=new Set(re.map(Z=>this.f(Z,H)));K.delete(-1);const _=Array.from(K).sort();this.d.splice(H+1,0,..._.map(Z=>this.d[Z]));for(let Z=_.length-1;Z>=0;Z--)this.d.splice(_[Z],1)}toArray(){return this.d.map(Y=>Y.pattern)}f(Y,re=this.d.length){const H=r(Y);for(let K=0;K<re;K++)if(this.d[K].matches(H))return K;return-1}}e.$0J=t;function u(B,Y,re,H=(K,_)=>K===_){const K=[];function _(oe,Pe,te){if(Pe===0&&te.length===0)return;const U=K[K.length-1];U&&U.start+U.deleteCount===oe?(U.deleteCount+=Pe,U.toInsert.push(...te)):K.push({start:oe,deleteCount:Pe,toInsert:te})}let Z=0,$e=0;for(;;){if(Z===B.length){_(Z,0,Y.slice($e));break}if($e===Y.length){_(Z,B.length-Z,[]);break}const oe=B[Z],Pe=Y[$e];if(H(oe,Pe)){Z+=1,$e+=1;continue}re(Pe)?(_(Z,1,[]),Z+=1):(_(Z,0,[Pe]),$e+=1)}return K}e.$_J=new E.$Pj("notebookEditorCursorAtBoundary","none"),e.$aK=new E.$Pj("notebookEditorCursorAtLineBoundary","none");var s;(function(B){B.default="default",B.option="option"})(s||(e.NotebookEditorPriority=s={}));function o(B){const Y=B;return!!((typeof Y.include=="string"||O.$tk(Y.include))&&(typeof Y.exclude=="string"||O.$tk(Y.exclude)))}function h(B,Y,re){if(Array.isArray(B.viewType)&&B.viewType.indexOf(Y)>=0||B.viewType===Y)return!0;if(B.filenamePattern){const H=o(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,K=o(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(O.$rk(H,(0,b.$nc)(re.fsPath).toLowerCase()))return!(K&&O.$rk(K,(0,b.$nc)(re.fsPath).toLowerCase()))}return!1}e.$dK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var g;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(g||(e.CellStatusbarAlignment=g={}));class w{static{this.d="notebook/"}static create(Y){return`${w.d}${Y}`}static parse(Y){if(Y.startsWith(w.d))return Y.substring(w.d.length)}}e.$eK=w;function k(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const m=new TextDecoder;function y(B){const Y=[];let re=!1;for(const Z of B)(Y.length===0||re)&&(Y.push(Z),re=!0);let H=R(Y);const K=l.$He.concat(Y.map(Z=>l.$He.wrap(Z))),_=F(K);return H=H||_.byteLength!==K.byteLength,{data:_,didCompression:H}}e.$hK="\x1B[A";const D=e.$hK.split("").map(B=>B.charCodeAt(0)),C=10;function R(B){let Y=!1;return B.forEach((re,H)=>{if(H===0||re.length<e.$hK.length)return;const K=B[H-1],_=re.subarray(0,e.$hK.length);if(_[0]===D[0]&&_[1]===D[1]&&_[2]===D[2]){const Z=K.lastIndexOf(C);if(Z===-1)return;Y=!0,B[H-1]=K.subarray(0,Z),B[H]=re.subarray(e.$hK.length)}}),Y}function T(B){let Y=B;do B=Y,Y=B.replace(/[^\n]\x08/gm,"");while(Y.length<B.length);return B}function j(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const Y=B.match(/^(.*)\r+/m)[1];let re=B.match(/\r+(.*)$/m)[1];re=re+Y.slice(re.length,Y.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,re)}return B}const z=8,N=13;function F(B){return!B.buffer.includes(z)&&!B.buffer.includes(N)?B:l.$He.fromString(j(T(m.decode(B.buffer))))}}),define(ke[8],De([1,0,19,13,81,27,101,14,18,2,30,25,33,67,120]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v){"use strict";var d,f,a,n,i,c,r,t,u,s,o,h,g,w,k,m,y;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$BO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$hO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$7N=e.$6N=e.$5N=e.$4N=e.$2N=e.$1N=e.$ZN=e.$YN=e.TestRunProfileKind=e.TestResultState=e.$XN=e.$WN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$VN=e.NotebookVariablesRequestKind=e.$UN=e.$TN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$SN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.ColorThemeKind=e.$MN=e.$LN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$KN=e.$JN=e.DebugConsoleMode=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$DN=e.$CN=e.FileChangeType=e.$BN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$AN=e.$zN=e.$yN=e.$xN=e.InlineCompletionTriggerKind=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$kN=e.ConfigurationTarget=e.$jN=e.$iN=e.$hN=e.$gN=e.DocumentPasteTriggerKind=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$_M=e.ViewBadge=e.ProgressLocation=e.$$M=e.$0M=e.TaskScope=e.ShellQuoting=e.$9M=e.$8M=e.$7M=e.TaskPanelKind=e.TaskRevealKind=e.$6M=e.TerminalLocation=e.$5M=e.$4M=e.$3M=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$2M=e.$1M=e.$ZM=e.$YM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$WM=e.$VM=e.$UM=e.$TM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$SM=e.$RM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.LanguageStatusSeverity=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.CodeActionTriggerKind=e.$FM=e.$EM=e.SymbolTag=e.SymbolKind=e.$DM=e.$CM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.DiagnosticSeverity=e.DiagnosticTag=e.$wM=e.$vM=e.FileEditType=e.$uM=e.$tM=e.$sM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$XM=Ct,e.$lN=je,e.$3N=Si;function D(G){return Object.assign(G,{apply:function(...ge){if(ge.length===0)return Reflect.construct(G,[]);{const Ne=ge.length===1?[]:ge[1];return Reflect.construct(G,Ne,ge[0].constructor)}},call:function(...ge){if(ge.length===0)return Reflect.construct(G,[]);{const[Ne,...Qe]=ge;return Reflect.construct(G,Qe,Ne.constructor)}}})}var C;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var R;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(R||(e.TerminalQuickFixType=R={}));let T=d=class{static from(...V){let ge=V;return new d(function(){if(ge){for(const Ne of ge)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();ge=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$lM=T,e.$lM=T=d=Je([D],T);let j=f=class{static Min(...V){if(V.length===0)throw new TypeError;let ge=V[0];for(let Ne=1;Ne<V.length;Ne++){const Qe=V[Ne];Qe.isBefore(ge)&&(ge=Qe)}return ge}static Max(...V){if(V.length===0)throw new TypeError;let ge=V[0];for(let Ne=1;Ne<V.length;Ne++){const Qe=V[Ne];Qe.isAfter(ge)&&(ge=Qe)}return ge}static isPosition(V){if(!V)return!1;if(V instanceof f)return!0;const{line:ge,character:Ne}=V;return typeof ge=="number"&&typeof Ne=="number"}static of(V){if(V instanceof f)return V;if(this.isPosition(V))return new f(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(V,ge){if(V<0)throw(0,O.$7)("line must be non-negative");if(ge<0)throw(0,O.$7)("character must be non-negative");this.c=V,this.e=ge}isBefore(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<V.e}isBeforeOrEqual(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<=V.e}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this.c===V.c&&this.e===V.e}compareTo(V){return this.c<V.c?-1:this.c>V.line?1:this.e<V.e?-1:this.e>V.e?1:0}translate(V,ge=0){if(V===null||ge===null)throw(0,O.$7)();let Ne;return typeof V>"u"?Ne=0:typeof V=="number"?Ne=V:(Ne=typeof V.lineDelta=="number"?V.lineDelta:0,ge=typeof V.characterDelta=="number"?V.characterDelta:0),Ne===0&&ge===0?this:new f(this.line+Ne,this.character+ge)}with(V,ge=this.character){if(V===null||ge===null)throw(0,O.$7)();let Ne;return typeof V>"u"?Ne=this.line:typeof V=="number"?Ne=V:(Ne=typeof V.line=="number"?V.line:this.line,ge=typeof V.character=="number"?V.character:this.character),Ne===this.line&&ge===this.character?this:new f(Ne,ge)}toJSON(){return{line:this.line,character:this.character}}};e.$mM=j,e.$mM=j=f=Je([D],j);let z=a=class{static isRange(V){return V instanceof a?!0:V?j.isPosition(V.start)&&j.isPosition(V.end):!1}static of(V){if(V instanceof a)return V;if(this.isRange(V))return new a(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(V,ge,Ne,Qe){let _e,dt;if(typeof V=="number"&&typeof ge=="number"&&typeof Ne=="number"&&typeof Qe=="number"?(_e=new j(V,ge),dt=new j(Ne,Qe)):j.isPosition(V)&&j.isPosition(ge)&&(_e=j.of(V),dt=j.of(ge)),!_e||!dt)throw new Error("Invalid arguments");_e.isBefore(dt)?(this.c=_e,this.e=dt):(this.c=dt,this.e=_e)}contains(V){return a.isRange(V)?this.contains(V.start)&&this.contains(V.end):j.isPosition(V)?!(j.of(V).isBefore(this.c)||this.e.isBefore(V)):!1}isEqual(V){return this.c.isEqual(V.c)&&this.e.isEqual(V.e)}intersection(V){const ge=j.Max(V.start,this.c),Ne=j.Min(V.end,this.e);if(!ge.isAfter(Ne))return new a(ge,Ne)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const ge=j.Min(V.start,this.c),Ne=j.Max(V.end,this.end);return new a(ge,Ne)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(V,ge=this.end){if(V===null||ge===null)throw(0,O.$7)();let Ne;return V?j.isPosition(V)?Ne=V:(Ne=V.start||this.start,ge=V.end||this.end):Ne=this.start,Ne.isEqual(this.c)&&ge.isEqual(this.end)?this:new a(Ne,ge)}toJSON(){return[this.start,this.end]}};e.$nM=z,e.$nM=z=a=Je([D],z);let N=n=class extends z{static isSelection(V){return V instanceof n?!0:V?z.isRange(V)&&j.isPosition(V.anchor)&&j.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(V,ge,Ne,Qe){let _e,dt;if(typeof V=="number"&&typeof ge=="number"&&typeof Ne=="number"&&typeof Qe=="number"?(_e=new j(V,ge),dt=new j(Ne,Qe)):j.isPosition(V)&&j.isPosition(ge)&&(_e=j.of(V),dt=j.of(ge)),!_e||!dt)throw new Error("Invalid arguments");super(_e,dt),this.f=_e,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$oM=N,e.$oM=N=n=Je([D],N);const F=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,O.$7)("connectionToken")};class B{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ge,Ne){if(typeof V!="string"||V.length===0)throw(0,O.$7)("host");if(typeof ge!="number"||ge===0||Math.round(ge)!==ge)throw(0,O.$7)("port");typeof Ne<"u"&&F(Ne),this.host=V,this.port=Math.round(ge),this.connectionToken=Ne}}e.$pM=B;class Y{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ge){this.makeConnection=V,this.connectionToken=ge,typeof ge<"u"&&F(ge)}}e.$qM=Y;class re extends Error{static NotAvailable(V,ge){return new re(V,S.RemoteAuthorityResolverErrorCode.NotAvailable,ge)}static TemporarilyNotAvailable(V){return new re(V,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,ge=S.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(V),this._message=V,this._code=ge,this._detail=Ne,Object.setPrototypeOf(this,re.prototype)}}e.$rM=re;var H;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(H||(e.EndOfLine=H={}));var K;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(K||(e.EnvironmentVariableMutatorType=K={}));let _=i=class{static isTextEdit(V){return V instanceof i?!0:V?z.isRange(V)&&typeof V.newText=="string":!1}static replace(V,ge){return new i(V,ge)}static insert(V,ge){return i.replace(new z(V,V),ge)}static delete(V){return i.replace(V,"")}static setEndOfLine(V){const ge=new i(new z(new j(0,0),new j(0,0)),"");return ge.newEol=V,ge}get range(){return this.c}set range(V){if(V&&!z.isRange(V))throw(0,O.$7)("range");this.c=V}get newText(){return this.e||""}set newText(V){if(V&&typeof V!="string")throw(0,O.$7)("newText");this.e=V}get newEol(){return this.f}set newEol(V){if(V&&typeof V!="number")throw(0,O.$7)("newEol");this.f=V}constructor(V,ge){this.c=V,this.e=ge}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$sM=_,e.$sM=_=i=Je([D],_);let Z=c=class{static isNotebookCellEdit(V){return V instanceof c?!0:V?mn.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,ge){return new c(V,ge)}static insertCells(V,ge){return new c(new mn(V,V),ge)}static deleteCells(V){return new c(V,[])}static updateCellMetadata(V,ge){const Ne=new c(new mn(V,V),[]);return Ne.newCellMetadata=ge,Ne}static updateNotebookMetadata(V){const ge=new c(new mn(0,0),[]);return ge.newNotebookMetadata=V,ge}constructor(V,ge){this.range=V,this.newCells=ge}};e.$tM=Z,e.$tM=Z=c=Je([D],Z);class $e{static isSnippetTextEdit(V){return V instanceof $e?!0:V?z.isRange(V.range)&&te.isSnippetString(V.snippet):!1}static replace(V,ge){return new $e(V,ge)}static insert(V,ge){return $e.replace(new z(V,V),ge)}constructor(V,ge){this.range=V,this.snippet=ge}}e.$uM=$e;var oe;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(oe||(e.FileEditType=oe={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(V,ge,Ne,Qe){this.c.push({_type:1,from:V,to:ge,options:Ne,metadata:Qe})}createFile(V,ge,Ne){this.c.push({_type:1,from:void 0,to:V,options:ge,metadata:Ne})}deleteFile(V,ge,Ne){this.c.push({_type:1,from:V,to:void 0,options:ge,metadata:Ne})}e(V,ge,Ne){this.c.push({_type:3,metadata:Ne,uri:V,edit:{editType:5,metadata:ge},notebookMetadata:ge})}f(V,ge,Ne,Qe){const _e=ge.start,dt=ge.end;(_e!==dt||Ne.length>0)&&this.c.push({_type:5,uri:V,index:_e,count:dt-_e,cells:Ne,metadata:Qe})}g(V,ge,Ne,Qe){this.c.push({_type:3,metadata:Qe,uri:V,edit:{editType:3,index:ge,metadata:Ne}})}replace(V,ge,Ne,Qe){this.c.push({_type:2,uri:V,edit:new _(ge,Ne),metadata:Qe})}insert(V,ge,Ne,Qe){this.replace(V,new z(ge,ge),Ne,Qe)}delete(V,ge,Ne){this.replace(V,ge,"",Ne)}has(V){return this.c.some(ge=>ge._type===2&&ge.uri.toString()===V.toString())}set(V,ge){if(ge)for(const Ne of ge){if(!Ne)continue;let Qe,_e;Array.isArray(Ne)?(Qe=Ne[0],_e=Ne[1]):Qe=Ne,Z.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(V,Qe.range.start,Qe.newCellMetadata,_e):Qe.newNotebookMetadata?this.e(V,Qe.newNotebookMetadata,_e):this.f(V,Qe.range,Qe.newCells,_e):$e.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:V,range:Qe.range,edit:Qe.snippet,metadata:_e}):this.c.push({_type:2,uri:V,edit:Qe,metadata:_e})}else{for(let Ne=0;Ne<this.c.length;Ne++){const Qe=this.c[Ne];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===V.toString()&&(this.c[Ne]=void 0);break}}(0,l.$Ib)(this.c)}}get(V){const ge=[];for(const Ne of this.c)Ne._type===2&&Ne.uri.toString()===V.toString()&&ge.push(Ne.edit);return ge}entries(){const V=new A.$Ac;for(const ge of this.c)if(ge._type===2){let Ne=V.get(ge.uri);Ne||(Ne=[ge.uri,[]],V.set(ge.uri,Ne)),Ne[1].push(ge.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$vM=Pe,e.$vM=Pe=Je([D],Pe);let te=r=class{static isSnippetString(V){return V instanceof r?!0:V?typeof V.value=="string":!1}static c(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this.e=1,this.value=V||""}appendText(V){return this.value+=r.c(V),this}appendTabstop(V=this.e++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,ge=this.e++){if(typeof V=="function"){const Ne=new r;Ne.e=this.e,V(Ne),this.e=Ne.e,V=Ne.value}else V=r.c(V);return this.value+="${",this.value+=ge,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,ge=this.e++){const Ne=V.map(Qe=>Qe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ge,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(V,ge){if(typeof ge=="function"){const Ne=new r;Ne.e=this.e,ge(Ne),this.e=Ne.e,ge=Ne.value}else typeof ge=="string"&&(ge=ge.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,ge&&(this.value+=":",this.value+=ge),this.value+="}",this}};e.$wM=te,e.$wM=te=r=Je([D],te);var U;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ee;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let be=t=class{static isLocation(V){return V instanceof t?!0:V?z.isRange(V.range)&&E.URI.isUri(V.uri):!1}constructor(V,ge){if(this.uri=V,ge)if(z.isRange(ge))this.range=z.of(ge);else if(j.isPosition(ge))this.range=new z(ge,ge);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$xM=be,e.$xM=be=t=Je([D],be);let ue=class{static is(V){return V?typeof V.message=="string"&&V.location&&z.isRange(V.location.range)&&E.URI.isUri(V.location.uri):!1}constructor(V,ge){this.location=V,this.message=ge}static isEqual(V,ge){return V===ge?!0:!V||!ge?!1:V.message===ge.message&&V.location.range.isEqual(ge.location.range)&&V.location.uri.toString()===ge.location.uri.toString()}};e.$yM=ue,e.$yM=ue=Je([D],ue);let ce=class{constructor(V,ge,Ne=ee.Error){if(!z.isRange(V))throw new TypeError("range must be set");if(!ge)throw new TypeError("message must be set");this.range=V,this.message=ge,this.severity=Ne}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,ge){return V===ge?!0:!V||!ge?!1:V.message===ge.message&&V.severity===ge.severity&&V.code===ge.code&&V.severity===ge.severity&&V.source===ge.source&&V.range.isEqual(ge.range)&&(0,l.$ub)(V.tags,ge.tags)&&(0,l.$ub)(V.relatedInformation,ge.relatedInformation,ue.isEqual)}};e.$zM=ce,e.$zM=ce=Je([D],ce);let ae=class{constructor(V,ge){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=ge}};e.$AM=ae,e.$AM=ae=Je([D],ae);let le=class extends ae{constructor(V,ge,Ne,Qe){super(V,ge),this.canIncreaseHover=Ne,this.canDecreaseHover=Qe}};e.$BM=le,e.$BM=le=Je([D],le);var J;(function(G){G[G.Increase=0]="Increase",G[G.Decrease=1]="Decrease"})(J||(e.HoverVerbosityAction=J={}));var se;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let pe=class{constructor(V,ge=se.Text){this.range=V,this.kind=ge}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.$CM=pe,e.$CM=pe=Je([D],pe);let ve=class{constructor(V,ge){this.uri=V,this.highlights=ge}toJSON(){return{uri:this.uri,highlights:this.highlights.map(V=>V.toJSON())}}};e.$DM=ve,e.$DM=ve=Je([D],ve);var Re;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(Re||(e.SymbolKind=Re={}));var me;(function(G){G[G.Deprecated=1]="Deprecated"})(me||(e.SymbolTag=me={}));let Ie=u=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,ge,Ne,Qe,_e){this.name=V,this.kind=ge,this.containerName=_e,typeof Ne=="string"&&(this.containerName=Ne),Qe instanceof be?this.location=Qe:Ne instanceof z&&(this.location=new be(Qe,Ne)),u.validate(this)}toJSON(){return{name:this.name,kind:Re[this.kind],location:this.location,containerName:this.containerName}}};e.$EM=Ie,e.$EM=Ie=u=Je([D],Ie);let Ae=s=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(s.validate)}constructor(V,ge,Ne,Qe,_e){this.name=V,this.detail=ge,this.kind=Ne,this.range=Qe,this.selectionRange=_e,this.children=[],s.validate(this)}};e.$FM=Ae,e.$FM=Ae=s=Je([D],Ae);var ze;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(ze||(e.CodeActionTriggerKind=ze={}));let q=class{constructor(V,ge){this.title=V,this.kind=ge}};e.$GM=q,e.$GM=q=Je([D],q);let W=class{static{o=this}static{this.c="."}constructor(V){this.value=V}append(V){return new o(this.value?this.value+o.c+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+o.c)}};e.$HM=W,e.$HM=W=o=Je([D],W),W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorMove=W.Refactor.append("move"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll"),W.Notebook=W.Empty.append("notebook");let X=class{constructor(V,ge){if(this.range=V,this.parent=ge,ge&&!ge.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$IM=X,e.$IM=X=Je([D],X);class Q{constructor(V,ge,Ne,Qe,_e,dt){this.kind=V,this.name=ge,this.detail=Ne,this.uri=Qe,this.range=_e,this.selectionRange=dt}}e.$JM=Q;class de{constructor(V,ge){this.fromRanges=ge,this.from=V}}e.$KM=de;class we{constructor(V,ge){this.fromRanges=ge,this.to=V}}e.$LM=we;var Te;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Te||(e.LanguageStatusSeverity=Te={}));let qe=class{constructor(V,ge){this.range=V,this.command=ge}get isResolved(){return!!this.command}};e.$MM=qe,e.$MM=qe=Je([D],qe);let Xe=h=class{#e;static isMarkdownString(V){return V instanceof h?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,ge=!1){this.#e=new L.$Vk(V,{supportThemeIcons:ge})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,ge){return this.#e.appendCodeblock(ge??"",V),this}};e.$NM=Xe,e.$NM=Xe=h=Je([D],Xe);let tt=class{constructor(V,ge){this.label=V,this.documentation=ge}};e.$OM=tt,e.$OM=tt=Je([D],tt);let et=class{constructor(V,ge){this.label=V,this.documentation=ge,this.parameters=[]}};e.$PM=et,e.$PM=et=Je([D],et);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$QM=nt,e.$QM=nt=Je([D],nt);var it;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var rt;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let at=class{constructor(V){this.value=V}};e.$RM=at,e.$RM=at=Je([D],at);let Me=class{constructor(V,ge,Ne){this.position=V,this.label=ge,this.kind=Ne}};e.$SM=Me,e.$SM=Me=Je([D],Me);var ye;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ye||(e.CompletionTriggerKind=ye={}));var Ve;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ve||(e.CompletionItemKind=Ve={}));var ne;(function(G){G[G.Deprecated=1]="Deprecated"})(ne||(e.CompletionItemTag=ne={}));let ie=class{constructor(V,ge){this.label=V,this.kind=ge}toJSON(){return{label:this.label,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$TM=ie,e.$TM=ie=Je([D],ie);let Ce=class{constructor(V=[],ge=!1){this.items=V,this.isIncomplete=ge}};e.$UM=Ce,e.$UM=Ce=Je([D],Ce);let Ge=class{constructor(V,ge,Ne){this.insertText=V,this.range=ge,this.command=Ne}};e.$VM=Ge,e.$VM=Ge=Je([D],Ge);let Le=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.$WM=Le,e.$WM=Le=Je([D],Le);var st;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(st||(e.PartialAcceptTriggerKind=st={}));var ut;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(ut||(e.ViewColumn=ut={}));var mt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(mt||(e.StatusBarAlignment=mt={}));function Ct(G,V){return`${P.$Tm.toKey(G)}.${V}`}var Pt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Bt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Bt||(e.TextDocumentSaveReason=Bt={}));var Ut;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ut||(e.TextEditorRevealType=Ut={}));var Et;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Zt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var xt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(G){function V(ge){switch(ge){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=V}(Et||(e.TextEditorSelectionChangeKind=Et={}));var xe;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(xe||(e.SyntaxTokenType=xe={})),function(G){function V(ge){switch(ge){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=V}(xe||(e.SyntaxTokenType=xe={}));let on=class{constructor(V,ge){if(ge&&!E.URI.isUri(ge))throw(0,O.$7)("target");if(!z.isRange(V)||V.isEmpty)throw(0,O.$7)("range");this.range=V,this.target=ge}};e.$YM=on,e.$YM=on=Je([D],on);let Xt=class{constructor(V,ge,Ne,Qe){this.red=V,this.green=ge,this.blue=Ne,this.alpha=Qe}};e.$ZM=Xt,e.$ZM=Xt=Je([D],Xt);let ft=class{constructor(V,ge){if(ge&&!(ge instanceof Xt))throw(0,O.$7)("color");if(!z.isRange(V)||V.isEmpty)throw(0,O.$7)("range");this.range=V,this.color=ge}};e.$1M=ft,e.$1M=ft=Je([D],ft);let $t=class{constructor(V){if(!V||typeof V!="string")throw(0,O.$7)("label");this.label=V}};e.$2M=$t,e.$2M=$t=Je([D],$t);var _t;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(_t||(e.ColorFormat=_t={}));var Qt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Qt||(e.SourceControlInputBoxValidationType=Qt={}));var jt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(jt||(e.TerminalExitReason=jt={}));var gt;(function(G){G[G.Low=0]="Low",G[G.Medium=1]="Medium",G[G.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class Ht{constructor(V,ge,Ne){if(this.startIndex=V,this.length=ge,this.tooltip=Ne,typeof V!="number"||V<0)throw(0,O.$7)("startIndex");if(typeof ge!="number"||ge<1)throw(0,O.$7)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,O.$7)("tooltip")}}e.$3M=Ht;class en{constructor(V){this.uri=V}}e.$4M=en;class Wt{constructor(V){this.terminalCommand=V}}e.$5M=Wt;var Ye;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Ye||(e.TerminalLocation=Ye={}));class ln{constructor(V){if(this.options=V,typeof V!="object")throw(0,O.$7)("options")}}e.$6M=ln;var Yt;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Yt||(e.TaskRevealKind=Yt={}));var qt;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(qt||(e.TaskPanelKind=qt={}));let wt=class{static{g=this}static{this.Clean=new g("clean","Clean")}static{this.Build=new g("build","Build")}static{this.Rebuild=new g("rebuild","Rebuild")}static{this.Test=new g("test","Test")}static from(V){switch(V){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}constructor(V,ge){if(this.label=ge,typeof V!="string"||typeof ge!="string")throw(0,O.$7)("name");this.c=V}get id(){return this.c}};e.$7M=wt,e.$7M=wt=g=Je([D],wt);function Vt(G){let V="";for(let ge=0;ge<G.length;ge++)V+=G[ge].replace(/,/g,",,")+",";return V}let Mt=class{constructor(V,ge,Ne){if(typeof V!="string")throw(0,O.$7)("process");this.e=[],this.c=V,ge!==void 0&&(Array.isArray(ge)?(this.e=ge,this.f=Ne):this.f=ge)}get process(){return this.c}set process(V){if(typeof V!="string")throw(0,O.$7)("process");this.c=V}get args(){return this.e}set args(V){Array.isArray(V)||(V=[]),this.e=V}get options(){return this.f}set options(V){this.f=V}computeId(){const V=[];if(V.push("process"),this.c!==void 0&&V.push(this.c),this.e&&this.e.length>0)for(const ge of this.e)V.push(ge);return Vt(V)}};e.$8M=Mt,e.$8M=Mt=Je([D],Mt);let Ot=class{constructor(V,ge,Ne){if(this.f=[],Array.isArray(ge)){if(!V)throw(0,O.$7)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,O.$7)("command");this.e=V,this.f=ge,this.g=Ne}else{if(typeof V!="string")throw(0,O.$7)("commandLine");this.c=V,this.g=ge}}get commandLine(){return this.c}set commandLine(V){if(typeof V!="string")throw(0,O.$7)("commandLine");this.c=V}get command(){return this.e?this.e:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,O.$7)("command");this.e=V}get args(){return this.f}set args(V){this.f=V||[]}get options(){return this.g}set options(V){this.g=V}computeId(){const V=[];if(V.push("shell"),this.c!==void 0&&V.push(this.c),this.e!==void 0&&V.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ge of this.f)V.push(typeof ge=="string"?ge:ge.value);return Vt(V)}};e.$9M=Ot,e.$9M=Ot=Je([D],Ot);var tn;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(tn||(e.ShellQuoting=tn={}));var Gt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Gt||(e.TaskScope=Gt={}));class an{constructor(V){this.c=V}computeId(){return"customExecution"+(0,I.$Ug)()}set callback(V){this.c=V}get callback(){return this.c}}e.$0M=an;let Nt=class{static{w=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(V,ge,Ne,Qe,_e,dt){this.k=!1,this.l=this.definition=V;let bt;typeof ge=="string"?(this.o=this.name=ge,this.w=this.source=Ne,this.execution=Qe,bt=_e,this.k=!0):ge===Gt.Global||ge===Gt.Workspace?(this.target=ge,this.o=this.name=Ne,this.w=this.source=Qe,this.execution=_e,bt=dt):(this.target=ge,this.o=this.name=Ne,this.w=this.source=Qe,this.execution=_e,bt=dt),typeof bt=="string"?(this.r=[bt],this.t=!0):Array.isArray(bt)?(this.r=bt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(V){this.j=V}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Mt?this.l={type:w.e,id:this.q.computeId()}:this.q instanceof Ot?this.l={type:w.f,id:this.q.computeId()}:this.q instanceof an?this.l={type:w.c,id:this.q.computeId()}:this.l={type:w.g,id:(0,I.$Ug)()}}get definition(){return this.l}set definition(V){if(V==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=V}get scope(){return this.m}set target(V){this.B(),this.m=V}get name(){return this.o}set name(V){if(typeof V!="string")throw(0,O.$7)("name");this.B(),this.o=V}get execution(){return this.q}set execution(V){V===null&&(V=void 0),this.B(),this.q=V;const ge=this.l.type;(w.g===ge||w.e===ge||w.f===ge||w.c===ge)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(V){if(Array.isArray(V))this.B(),this.r=V,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.B(),this.u=V}get source(){return this.w}set source(V){if(typeof V!="string"||V.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=V}get group(){return this.x}set group(V){V===null&&(V=void 0),this.B(),this.x=V}get detail(){return this.A}set detail(V){V===null&&(V=void 0),this.A=V}get presentationOptions(){return this.y}set presentationOptions(V){V==null&&(V=Object.create(null)),this.B(),this.y=V}get runOptions(){return this.z}set runOptions(V){V==null&&(V=Object.create(null)),this.B(),this.z=V}};e.$$M=Nt,e.$$M=Nt=w=Je([D],Nt);var Kt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Kt||(e.ProgressLocation=Kt={}));var Lt;(function(G){function V(ge){const Ne=ge;return(0,$.$cg)(Ne.value)?Ne.tooltip&&!(0,$.$$f)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}G.isViewBadge=V})(Lt||(e.ViewBadge=Lt={}));let It=k=class{static isTreeItem(V,ge){const Ne=V;if(Ne.checkboxState!==void 0){const Qe=(0,$.$cg)(Ne.checkboxState)?Ne.checkboxState:(0,$.$ag)(Ne.checkboxState)&&(0,$.$cg)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,_e=!(0,$.$cg)(Ne.checkboxState)&&(0,$.$ag)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==kt.Checked&&Qe!==kt.Unchecked||_e!==void 0&&!(0,$.$$f)(_e))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(V instanceof k)return!0;if(Ne.label!==void 0&&!(0,$.$$f)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,$.$$f)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,$.$$f)(Ne.iconPath)&&!E.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,$.$$f)(Ne.iconPath.id))){const Qe=Ne.iconPath;if(!Qe||!(0,$.$$f)(Qe.light)&&!E.URI.isUri(Qe.light)&&!(0,$.$$f)(Qe.dark)&&!E.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,$.$$f)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!E.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,$.$$f)(Ne.tooltip)&&!(Ne.tooltip instanceof Xe)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<pt.None&&Ne.collapsibleState>pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,$.$$f)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(V,ge=pt.None){this.collapsibleState=ge,E.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.$_M=It,e.$_M=It=k=Je([D],It);var pt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(pt||(e.TreeItemCollapsibleState=pt={}));var kt;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(kt||(e.TreeItemCheckboxState=kt={}));let cn=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.$aN=cn,e.$aN=cn=Je([D],cn);class Dt extends cn{}e.$bN=Dt;class gn extends Dt{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.$cN=gn;class rn{constructor(V,ge,Ne,Qe){this.name=V,this.uri=ge,this._itemId=Ne,this.c=Qe}data(){return this.c()}}e.$dN=rn;let pn=class{#e=new Map;constructor(V){for(const[ge,Ne]of V??[]){const Qe=this.#e.get(this.#t(ge));Qe?Qe.push(Ne):this.#e.set(this.#t(ge),[Ne])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,ge){this.#e.set(this.#t(V),[ge])}forEach(V,ge){for(const[Ne,Qe]of this.#e)for(const _e of Qe)V.call(ge,_e,Ne,this)}*[Symbol.iterator](){for(const[V,ge]of this.#e)for(const Ne of ge)yield[V,Ne]}#t(V){return V.toLowerCase()}};e.$eN=pn,e.$eN=pn=Je([D],pn);let hn=class{constructor(V,ge,Ne){this.insertText=V,this.title=ge,this.kind=Ne}};e.$fN=hn,e.$fN=hn=Je([D],hn);var vn;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(vn||(e.DocumentPasteTriggerKind=vn={}));class At{static{this.c="."}constructor(V){this.value=V}append(...V){return new At((this.value?[this.value,...V]:V).join(At.c))}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+At.c)}}e.$gN=At,At.Empty=new At("");class En{constructor(V,ge,Ne){this.title=ge,this.insertText=V,this.kind=Ne}}e.$hN=En;let sn=class{constructor(V,ge){this.id=V,this.color=ge}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.$iN=sn,e.$iN=sn=Je([D],sn),sn.File=new sn("file"),sn.Folder=new sn("folder");let Oe=class{constructor(V){this.id=V}};e.$jN=Oe,e.$jN=Oe=Je([D],Oe);var Fe;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Fe||(e.ConfigurationTarget=Fe={}));let Ee=class{get base(){return this.c}set base(V){this.c=V,this.e=E.URI.file(V)}get baseUri(){return this.e}set baseUri(V){this.e=V,this.c=V.fsPath}constructor(V,ge){if(typeof V!="string"&&(!V||!E.URI.isUri(V)&&!E.URI.isUri(V.uri)))throw(0,O.$7)("base");if(typeof ge!="string")throw(0,O.$7)("pattern");typeof V=="string"?this.baseUri=E.URI.file(V):E.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=ge}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$kN=Ee,e.$kN=Ee=Je([D],Ee);const x=new WeakMap;function je(G,V){x.set(G,V)}let He=class{constructor(V,ge,Ne,Qe,_e){this.enabled=typeof V=="boolean"?V:!0,typeof ge=="string"&&(this.condition=ge),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Qe=="string"&&(this.logMessage=Qe),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=x.get(this)??(0,I.$Ug)()),this.c}};e.$mN=He,e.$mN=He=Je([D],He);let Ze=class extends He{constructor(V,ge,Ne,Qe,_e,dt){if(super(ge,Ne,Qe,_e,dt),V===null)throw(0,O.$7)("location");this.location=V}};e.$nN=Ze,e.$nN=Ze=Je([D],Ze);let Ke=class extends He{constructor(V,ge,Ne,Qe,_e,dt){super(ge,Ne,Qe,_e,dt),this.functionName=V}};e.$oN=Ke,e.$oN=Ke=Je([D],Ke);let ht=class extends He{constructor(V,ge,Ne,Qe,_e,dt,bt,Jt){if(super(Qe,_e,dt,bt,Jt),!ge)throw(0,O.$7)("dataId");this.label=V,this.dataId=ge,this.canPersist=Ne}};e.$pN=ht,e.$pN=ht=Je([D],ht);let St=class{constructor(V,ge,Ne){this.command=V,this.args=ge||[],this.options=Ne}};e.$qN=St,e.$qN=St=Je([D],St);let Ft=class{constructor(V,ge){this.port=V,this.host=ge}};e.$rN=Ft,e.$rN=Ft=Je([D],Ft);let lt=class{constructor(V){this.path=V}};e.$sN=lt,e.$sN=lt=Je([D],lt);let Tt=class{constructor(V){this.implementation=V}};e.$tN=Tt,e.$tN=Tt=Je([D],Tt);class zt{constructor(V,ge,Ne){this.session=V,this.threadId=ge,this.frameId=Ne}}e.$uN=zt;class kn{constructor(V,ge){this.session=V,this.threadId=ge}}e.$vN=kn;let Pn=class{constructor(V,ge){this.range=V,this.expression=ge}};e.$wN=Pn,e.$wN=Pn=Je([D],Pn);var Xn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Xn||(e.InlineCompletionTriggerKind=Xn={}));let On=class{constructor(V,ge){this.range=V,this.text=ge}};e.$xN=On,e.$xN=On=Je([D],On);let Nn=class{constructor(V,ge,Ne=!0){this.range=V,this.variableName=ge,this.caseSensitiveLookup=Ne}};e.$yN=Nn,e.$yN=Nn=Je([D],Nn);let In=class{constructor(V,ge){this.range=V,this.expression=ge}};e.$zN=In,e.$zN=In=Je([D],In);let Tn=class{constructor(V,ge){this.frameId=V,this.stoppedLocation=ge}};e.$AN=Tn,e.$AN=Tn=Je([D],Tn);var jn;(function(G){G[G.AIGenerated=1]="AIGenerated"})(jn||(e.NewSymbolNameTag=jn={}));var Qn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Qn||(e.NewSymbolNameTriggerKind=Qn={}));class Fn{constructor(V,ge){this.newSymbolName=V,this.tags=ge}}e.$BN=Fn;var An;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(An||(e.FileChangeType=An={}));let zn=m=class extends Error{static FileExists(V){return new m(V,p.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(V){return new m(V,p.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(V){return new m(V,p.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(V){return new m(V,p.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(V){return new m(V,p.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(V){return new m(V,p.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}constructor(V,ge=p.FileSystemProviderErrorCode.Unknown,Ne){super(E.URI.isUri(V)?V.toString(!0):V),this.code=Ne?.name??"Unknown",(0,p.$hl)(this,ge),Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.$CN=zn,e.$CN=zn=m=Je([D],zn);let Bn=class{constructor(V,ge,Ne){this.start=V,this.end=ge,this.kind=Ne}};e.$DN=Bn,e.$DN=Bn=Je([D],Bn);var yn;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(yn||(e.FoldingRangeKind=yn={}));var Yn;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Yn||(e.CommentThreadCollapsibleState=Yn={}));var Zn;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Zn||(e.CommentMode=Zn={}));var Rn;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Rn||(e.CommentState=Rn={}));var xn;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(xn||(e.CommentThreadState=xn={}));var Un;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(Un||(e.CommentThreadApplicability=Un={}));class gi{constructor(V,ge=[]){this.tokenTypes=V,this.tokenModifiers=ge}}e.$EN=gi;function _n(G){return typeof G>"u"||(0,$.$_f)(G)}class Wn{constructor(V){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,V){this.m=!0;for(let ge=0,Ne=V.tokenTypes.length;ge<Ne;ge++)this.k.set(V.tokenTypes[ge],ge);for(let ge=0,Ne=V.tokenModifiers.length;ge<Ne;ge++)this.l.set(V.tokenModifiers[ge],ge)}}push(V,ge,Ne,Qe,_e){if(typeof V=="number"&&typeof ge=="number"&&typeof Ne=="number"&&typeof Qe=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(V,ge,Ne,Qe,_e);if(z.isRange(V)&&typeof ge=="string"&&_n(Ne))return this.o(V,ge,Ne);throw(0,O.$7)()}o(V,ge,Ne){if(!this.m)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ge))throw new Error("`tokenType` is not in the provided legend");const Qe=V.start.line,_e=V.start.character,dt=V.end.character-V.start.character,bt=this.k.get(ge);let Jt=0;if(Ne)for(const un of Ne){if(!this.l.has(un))throw new Error("`tokenModifier` is not in the provided legend");const fn=this.l.get(un);Jt|=1<<fn>>>0}this.q(Qe,_e,dt,bt,Jt)}q(V,ge,Ne,Qe,_e){if(this.f&&(V<this.c||V===this.c&&ge<this.e)){this.f=!1;const Jt=this.g.length/5|0;let un=0,fn=0;for(let $n=0;$n<Jt;$n++){let wn=this.g[5*$n],Kn=this.g[5*$n+1];wn===0?(wn=un,Kn+=fn):wn+=un,this.g[5*$n]=wn,this.g[5*$n+1]=Kn,un=wn,fn=Kn}}let dt=V,bt=ge;this.f&&this.j>0&&(dt-=this.c,dt===0&&(bt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=bt,this.g[this.j++]=Ne,this.g[this.j++]=Qe,this.g[this.j++]=_e,this.c=V,this.e=ge}static r(V){const ge=[],Ne=V.length/5|0;for(let bt=0;bt<Ne;bt++)ge[bt]=bt;ge.sort((bt,Jt)=>{const un=V[5*bt],fn=V[5*Jt];if(un===fn){const $n=V[5*bt+1],wn=V[5*Jt+1];return $n-wn}return un-fn});const Qe=new Uint32Array(V.length);let _e=0,dt=0;for(let bt=0;bt<Ne;bt++){const Jt=5*ge[bt],un=V[Jt+0],fn=V[Jt+1],$n=V[Jt+2],wn=V[Jt+3],Kn=V[Jt+4],Fi=un-_e,br=Fi===0?fn-dt:fn,Jn=5*bt;Qe[Jn+0]=Fi,Qe[Jn+1]=br,Qe[Jn+2]=$n,Qe[Jn+3]=wn,Qe[Jn+4]=Kn,_e=un,dt=fn}return Qe}build(V){return this.f?new bn(new Uint32Array(this.g),V):new bn(Wn.r(this.g),V)}}e.$FN=Wn;class bn{constructor(V,ge){this.resultId=ge,this.data=V}}e.$GN=bn;class mi{constructor(V,ge,Ne){this.start=V,this.deleteCount=ge,this.data=Ne}}e.$HN=mi;class $i{constructor(V,ge){this.resultId=ge,this.edits=V}}e.$IN=$i;var ei;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(ei||(e.DebugConsoleMode=ei={}));class qn{constructor(V){this.name=V}}e.$JN=qn;let Mn=class{static{this.Back={iconPath:new sn("arrow-left")}}constructor(){}};e.$KN=Mn,e.$KN=Mn=Je([D],Mn);var Ue;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Ue||(e.QuickPickItemKind=Ue={}));var dn;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(dn||(e.InputBoxValidationSeverity=dn={}));var Vn;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Vn||(e.ExtensionKind=Vn={}));class ot{static validate(V){if(typeof V.badge=="string"){let ge=(0,b.$Jf)(V.badge,0);if(ge<V.badge.length&&(ge+=(0,b.$Jf)(V.badge,ge)),V.badge.length>ge)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!sn.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,ge,Ne){this.badge=V,this.tooltip=ge,this.color=Ne}}e.$LN=ot;let vt=class{constructor(V){this.kind=V}};e.$MN=vt,e.$MN=vt=Je([D],vt);var ti;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(ti||(e.ColorThemeKind=ti={}));class mn{static isNotebookRange(V){return V instanceof mn?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(V,ge){if(V<0)throw(0,O.$7)("start must be positive");if(ge<0)throw(0,O.$7)("end must be positive");V<=ge?(this.c=V,this.e=ge):(this.c=ge,this.e=V)}with(V){let ge=this.c,Ne=this.e;return V.start!==void 0&&(ge=V.start),V.end!==void 0&&(Ne=V.end),ge===this.c&&Ne===this.e?this:new mn(ge,Ne)}}e.$NN=mn;class Dn{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(ge=>Dn.isNotebookCellData(ge))}static isNotebookCellData(V){return!0}constructor(V,ge,Ne,Qe,_e,dt,bt){this.kind=V,this.value=ge,this.languageId=Ne,this.mime=Qe,this.outputs=_e??[],this.metadata=dt,this.executionSummary=bt,Dn.validate(this)}}e.$ON=Dn;class pi{constructor(V){this.cells=V}}e.$PN=pi;class nn{static isNotebookCellOutputItem(V){return V instanceof nn?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const ge={name:V.name,message:V.message,stack:V.stack};return nn.json(ge,"application/vnd.code.notebook.error")}static stdout(V){return nn.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return nn.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,ge="application/octet-stream"){return new nn(V,ge)}static#e=new TextEncoder;static text(V,ge=M.$Us.text){const Ne=nn.#e.encode(String(V));return new nn(Ne,ge)}static json(V,ge="text/x-json"){const Ne=JSON.stringify(V,void 0,"	");return nn.text(Ne,ge)}constructor(V,ge){this.data=V,this.mime=ge;const Ne=(0,M.$Ys)(ge,!0);if(!Ne)throw new Error(`INVALID mime type: ${ge}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.$QN=nn;class Ln{static isNotebookCellOutput(V){return V instanceof Ln?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,ge=!1){const Ne=new Set,Qe=new Set;for(let _e=0;_e<V.length;_e++){const dt=V[_e],bt=(0,M.$Ys)(dt.mime);if(!Ne.has(bt)||(0,v.$fK)(bt)){Ne.add(bt);continue}Qe.add(_e),ge&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Qe.size===0?V:V.filter((_e,dt)=>!Qe.has(dt))}constructor(V,ge,Ne){this.items=Ln.ensureUniqueMimeTypes(V,!0),typeof ge=="string"?(this.id=ge,this.metadata=Ne):(this.id=(0,I.$Ug)(),this.metadata=ge??Ne)}}e.$RN=Ln;var ni;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(ni||(e.NotebookCellKind=ni={}));var ii;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(ii||(e.NotebookCellExecutionState=ii={}));var Hn;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Hn||(e.NotebookCellStatusBarAlignment=Hn={}));var ri;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(ri||(e.NotebookEditorRevealType=ri={}));class bi{constructor(V,ge){this.text=V,this.alignment=ge}}e.$SN=bi;var si;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(si||(e.NotebookControllerAffinity=si={}));var oi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(oi||(e.NotebookControllerAffinity2=oi={}));class wi{constructor(V,ge=[]){this.uri=V,this.provides=(0,l.$2b)(ge)}}e.$TN=wi;class vi{constructor(V){this.label=V}}e.$UN=vi;var ai;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(ai||(e.NotebookVariablesRequestKind=ai={}));let Gn=class{constructor(V,ge){this.label=V,this.timestamp=ge}};e.$VN=Gn,e.$VN=Gn=Je([D],Gn);var ci;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(ci||(e.ExtensionMode=ci={}));var ui;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ui||(e.ExtensionRuntime=ui={}));var li;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(li||(e.StandardTokenType=li={}));class fe{constructor(V,ge){this.ranges=V,this.wordPattern=ge}}e.$WN=fe;class Se{constructor(V){this.c=V}get autoForwardAction(){return this.c}}e.$XN=Se;var Be;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(Be||(e.TestResultState=Be={}));var ct;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(ct||(e.TestRunProfileKind=ct={}));let yt=class{constructor(V=void 0,ge=void 0,Ne=void 0,Qe=!1,_e=!0){this.include=V,this.exclude=ge,this.profile=Ne,this.continuous=Qe,this.preserveFocus=_e}};e.$YN=yt,e.$YN=yt=Je([D],yt);let Rt=y=class{static diff(V,ge,Ne){const Qe=new y(V);return Qe.expectedOutput=ge,Qe.actualOutput=Ne,Qe}constructor(V){this.message=V}};e.$ZN=Rt,e.$ZN=Rt=y=Je([D],Rt);let Cn=class{constructor(V){this.id=V}};e.$1N=Cn,e.$1N=Cn=Je([D],Cn);class hi{constructor(V,ge){this.covered=V,this.total=ge,Si(this)}}e.$2N=hi;function Si(G){if(G){if(G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`);if(G.total<0)throw new Error(`The number of covered items (${G.total}) cannot be negative`)}}class yi{static fromDetails(V,ge){const Ne=new hi(0,0),Qe=new hi(0,0),_e=new hi(0,0);for(const bt of ge)if("branches"in bt){Ne.total+=1,Ne.covered+=bt.executed?1:0;for(const Jt of bt.branches)Qe.total+=1,Qe.covered+=Jt.executed?1:0}else _e.total+=1,_e.covered+=bt.executed?1:0;const dt=new yi(V,Ne,Qe.total>0?Qe:void 0,_e.total>0?_e:void 0);return dt.detailedCoverage=ge,dt}constructor(V,ge,Ne,Qe,_e){this.uri=V,this.statementCoverage=ge,this.branchCoverage=Ne,this.declarationCoverage=Qe,this.testItem=_e}}e.$4N=yi;class zi{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,ge,Ne=[]){this.executed=V,this.location=ge,this.branches=Ne}}e.$5N=zi;class Bi{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,ge,Ne){this.executed=V,this.location=ge,this.label=Ne}}e.$6N=Bi;class Ui{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,ge,Ne){this.name=V,this.executed=ge,this.location=Ne}}e.$7N=Ui;var Ei;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(Ei||(e.ExternalUriOpenerPriority=Ei={}));var ki;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(ki||(e.WorkspaceTrustState=ki={}));var Di;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Di||(e.PortAutoForwardAction=Di={}));class Wi{constructor(V,ge,Ne,Qe,_e,dt){this.kind=V,this.name=ge,this.detail=Ne,this.uri=Qe,this.range=_e,this.selectionRange=dt}}e.$8N=Wi;class qi{constructor(V){this.uri=V}}e.$9N=qi;class Vi{constructor(V,ge){this.original=V,this.modified=ge}}e.$0N=Vi;class Hi{constructor(V,ge,Ne,Qe){this.base=V,this.input1=ge,this.input2=Ne,this.result=Qe}}e.$$N=Hi;class Gi{constructor(V,ge){this.uri=V,this.viewType=ge}}e.$_N=Gi;class Ki{constructor(V){this.viewType=V}}e.$aO=Ki;class Ji{constructor(V,ge){this.uri=V,this.notebookType=ge}}e.$bO=Ji;class Xi{constructor(V,ge,Ne){this.original=V,this.modified=ge,this.notebookType=Ne}}e.$cO=Xi;class Qi{constructor(){}}e.$dO=Qi;class Yi{constructor(V,ge){this.uri=V,this.inputBoxUri=ge}}e.$eO=Yi;class Zi{constructor(){}}e.$fO=Zi;class xi{constructor(V){this.textDiffs=V}}e.$gO=xi;var Ci;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(Ci||(e.InteractiveSessionVoteDirection=Ci={}));var Pi;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(Pi||(e.ChatCopyKind=Pi={}));var Ii;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(Ii||(e.ChatVariableLevel=Ii={}));class _i{constructor(V,ge){this.label=V,this.values=ge}}e.$hO=_i;var Ai;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Ai||(e.InteractiveEditorResponseFeedbackKind=Ai={}));var Ri;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(Ri||(e.ChatResultFeedbackKind=Ri={}));class er{constructor(V){if(typeof V!="string"&&V.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof V=="string"?new Xe(V):V}}e.$iO=er;class tr{constructor(V,ge){if(typeof V!="string"&&V.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof V=="string"?new Xe(V):V,this.vulnerabilities=ge}}e.$jO=tr;class nr{constructor(V,ge){this.participant=V,this.command=ge}}e.$kO=nr;class ir{constructor(V,ge,Ne){this.title=V,this.message=ge,this.data=Ne}}e.$lO=ir;class rr{constructor(V,ge){this.value=V,this.baseUri=ge}}e.$mO=rr;class sr{constructor(V,ge){this.value=V,this.title=ge}}e.$nO=sr;class or{constructor(V){this.value=V}}e.$oO=or;class ar{constructor(V,ge){this.value=V,this.task=ge}}e.$pO=ar;class cr{constructor(V){if(typeof V!="string"&&V.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof V=="string"?new Xe(V):V}}e.$qO=cr;class ur{constructor(V){this.value=V}}e.$rO=ur;class lr{constructor(V,ge){this.value=V,this.iconPath=ge}}e.$sO=lr;class hr{constructor(V,ge){this.uri=V,this.edits=Array.isArray(ge)?ge:[ge]}}e.$tO=hr;class dr{constructor(V,ge,Ne,Qe){this.prompt=V,this.command=ge,this.variables=Ne,this.participant=Qe}}e.$uO=dr;class fr{constructor(V,ge,Ne,Qe){this.response=V,this.result=ge,this.participant=Ne,this.command=Qe}}e.$vO=fr;var Mi;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook",G[G.Editor=4]="Editor"})(Mi||(e.ChatLocation=Mi={}));var di;(function(G){G[G.User=1]="User",G[G.Assistant=2]="Assistant",G[G.System=3]="System"})(di||(e.LanguageModelChatMessageRole=di={}));class fi{static User(V,ge){return new fi(di.User,V,ge)}static Assistant(V,ge){return new fi(di.Assistant,V,ge)}constructor(V,ge,Ne){this.role=V,this.content=ge,this.name=Ne}}e.$wO=fi;class gr{constructor(V){this.content=V}}e.$xO=gr;class mr{constructor(V,ge){this.content=V,this.name=ge}}e.$yO=mr;class $r{constructor(V,ge){this.content=V,this.name=ge}}e.$zO=$r;class Sn extends Error{static NotFound(V){return new Sn(V,Sn.NotFound.name)}static NoPermissions(V){return new Sn(V,Sn.NoPermissions.name)}static Blocked(V){return new Sn(V,Sn.Blocked.name)}constructor(V,ge,Ne){super(V,{cause:Ne}),this.name="LanguageModelError",this.code=ge??""}}e.$AO=Sn;var Li;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Li||(e.RelatedInformationType=Li={}));var Oi;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped",G[G.Error=5]="Error"})(Oi||(e.SpeechToTextStatus=Oi={}));var Ni;(function(G){G[G.Started=1]="Started",G[G.Stopped=2]="Stopped",G[G.Error=3]="Error"})(Ni||(e.TextToSpeechStatus=Ni={}));var Ti;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Ti||(e.KeywordRecognitionStatus=Ti={}));class pr{constructor(V,ge){this.text=V,this.range=ge}}e.$BO=pr;var ji;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(ji||(e.InlineEditTriggerKind=ji={}))}),define(ke[330],De([1,0,6,8]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(l.$jM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(M);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(b,$)??[]}getRelatedInformation(M,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(M,b,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiRelatedInformationProvider(E,b),new O.$lM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$2lc=L}),define(ke[121],De([1,0,4,6,8,25,146,5,20]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0,e.$amc=(0,b.$yi)("IExtHostAuthentication");let E=class{constructor(p){this.b=new Map,this.c=new l.$fe,this.onDidChangeSessions=this.c.event,this.d=new I,this.f=new I,this.a=p.getProxy(O.$jM.MainThreadAuthentication)}async getSession(p,S,v,d={}){const f=A.$Tm.toKey(p.identifier),a=[...v].sort().join(" ");return await this.d.getOrCreate(`${f} ${S} ${a}`,async()=>{await this.a.$ensureProvider(S);const n=p.displayName||p.name;return this.a.$getSession(S,v,f,n,d)})}async getSessions(p,S,v){const d=A.$Tm.toKey(p.identifier),f=[...v].sort().join(" ");return await this.f.getOrCreate(`${d} ${f}`,async()=>{await this.a.$ensureProvider(S);const a=p.displayName||p.name;return this.a.$getSessions(S,v,d,a)})}async removeSession(p,S){const v=this.b.get(p);return v?v.provider.removeSession(S):this.a.$removeSession(p,S)}registerAuthenticationProvider(p,S,v,d){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:S,provider:v,options:d??{supportsMultipleAccounts:!1}});const f=v.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(p,a));return this.a.$registerAuthenticationProvider(p,S,d?.supportsMultipleAccounts??!1),new L.$lM(()=>{f.dispose(),this.b.delete(p),this.a.$unregisterAuthenticationProvider(p)})}async $createSession(p,S,v){const d=this.b.get(p);if(d)return await d.provider.createSession(S,v);throw new Error(`Unable to find authentication provider with handle: ${p}`)}async $removeSession(p,S){const v=this.b.get(p);if(v)return await v.provider.removeSession(S);throw new Error(`Unable to find authentication provider with handle: ${p}`)}async $getSessions(p,S){const v=this.b.get(p);if(v)return await v.provider.getSessions(S);throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,S){return p.startsWith(M.$lL)||this.c.fire({provider:{id:p,label:S}}),Promise.resolve()}};e.$bmc=E,e.$bmc=E=Je([We(0,$.$NO)],E);class I{constructor(){this.a=new Map}getOrCreate(p,S){const v=this.a.get(p);if(v)return v;const d=S().finally(()=>this.a.delete(p));return this.a.set(p,d),d}}}),define(ke[152],De([1,0,2,6,8,5,20,11,19,14,16,26]),function(he,e,l,O,L,A,M,b,$,E,I,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=e.$anc=void 0;let S=class{static{p=this}static{this.c=0}static{this.d=250}constructor(d,f){this.h=f,this.f=new Map,this.g=d.getProxy(O.$jM.MainThreadDecorations)}registerFileDecorationProvider(d,f){const a=p.c++;this.f.set(a,{provider:d,extensionDescription:f}),this.g.$registerDecorationProvider(a,f.identifier.value);const n=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(a,null);return}const c=(0,$.$2b)(i);if(c.length<=p.d){this.g.$onDidChange(a,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,c.length);const r=c.map(s=>({uri:s,rank:(0,E.$cf)(s.path,"/")})),t=(0,$.$zb)(r,(s,o)=>s.rank-o.rank||(0,E.$sf)(s.uri.path,o.uri.path)),u=[];e:for(const s of t){let o;for(const h of s){const g=(0,I.$mc)(h.uri.path);if(o!==g&&(o=g,u.push(h.uri)>=p.d))break e}}this.g.$onDidChange(a,u)});return new L.$lM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(d,f,a){if(!this.f.has(d))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:c}=this.f.get(d);return await Promise.all(f.map(async r=>{try{const{uri:t,id:u}=r,s=await Promise.resolve(i.provideFileDecoration(l.URI.revive(t),a));if(!s)return;try{L.$LN.validate(s),s.badge&&typeof s.badge!="string"&&(0,P.$LG)(c,"codiconDecoration"),n[u]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${o}`)}}catch(t){this.h.error(t)}})),n}};e.$anc=S,e.$anc=S=p=Je([We(0,M.$NO),We(1,b.$5j)],S),e.$bnc=(0,A.$yi)("IExtHostDecorations")}),define(ke[331],De([1,0,13,2,8,6,15,21,14]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=void 0;class E{static{this.a=0}constructor(P,p,S){this.d=p,this.e=S,this.b=new Map,this.c=P.getProxy(A.$jM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,p){if(Object.keys(M.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const S=E.a++;this.b.set(S,p),this.c.$registerTextContentProvider(S,P);let v;if(typeof p.onDidChange=="function"){let d;v=p.onDidChange(async f=>{if(f.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(f))return;d&&await d;const a=this.$provideTextDocumentContent(S,f).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(f);if(!i)return;const c=(0,$.$mf)(n);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(f,n)}).catch(l.$1).finally(()=>{d===a&&(d=void 0)});d=a})}return new L.$lM(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,p){const S=this.b.get(P);return S?Promise.resolve(S.provideTextDocumentContent(O.URI.revive(p),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$dnc=E}),define(ke[153],De([1,0,62,15,14,188,130,8,19]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$QO=void 0,e.$PO=I;const E=new Map;function I(v,d){d?E.set(v,d):E.delete(v)}function P(v){return E.get(v)}class p extends A.$0v{constructor(d,f,a,n,i,c,r){super(f,a,n,i),this.c=d,this.m=c,this.q=r,this.b=!1}dispose(){(0,l.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,$.$ub)(this.f,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.d},get fileName(){return d.d.fsPath},get isUntitled(){return d.d.scheme===O.Schemas.untitled},get languageId(){return d.m},get version(){return d.h},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(f){return f?d.s(f):d.getText()},get eol(){return d.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return d.f.length},lineAt(f){return d.t(f)},offsetAt(f){return d.u(f)},positionAt(f){return d.v(f)},validateRange(f){return d.w(f)},validatePosition(f){return d.x(f)},getWordRangeAtPosition(f,a){return d.y(f,a)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,l.ok)(!this.b),this.m=d}_acceptIsDirty(d){(0,l.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(d){const f=this.w(d);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const a=this.g,n=f.start.line,i=f.end.line,c=[];c.push(this.f[n].substring(f.start.character));for(let r=n+1;r<i;r++)c.push(this.f[r]);return c.push(this.f[i].substring(0,f.end.character)),c.join(a)}t(d){let f;if(d instanceof b.$mM?f=d.line:typeof d=="number"&&(f=d),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new S(f,this.f[f],f===this.f.length-1)}u(d){return d=this.x(d),this.l(),this.j.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.l();const f=this.j.getIndexOf(d),a=this.f[f.index].length;return new b.$mM(f.index,Math.min(f.remainder,a))}w(d){if(!(d instanceof b.$nM))throw new Error("Invalid argument");const f=this.x(d.start),a=this.x(d.end);return f===d.start&&a===d.end?d:new b.$nM(f.line,f.character,a.line,a.character)}x(d){if(!(d instanceof b.$mM))throw new Error("Invalid argument");if(this.f.length===0)return d.with(0,0);let{line:f,character:a}=d,n=!1;if(f<0)f=0,a=0,n=!0;else if(f>=this.f.length)f=this.f.length-1,a=this.f[f].length,n=!0;else{const i=this.f[f].length;a<0?(a=0,n=!0):a>i&&(a=i,n=!0)}return n?new b.$mM(f,a):d}y(d,f){const a=this.x(d);if(!f)f=P(this.m);else if((0,L.$lf)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const n=(0,M.$at)(a.character+1,(0,M.$$s)(f),this.f[a.line],0);if(n)return new b.$nM(a.line,n.startColumn-1,a.line,n.endColumn-1)}}e.$QO=p;class S{constructor(d,f,a){this.a=d,this.b=f,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$nM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$nM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$RO=S}),define(ke[332],De([1,0,6,8]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(l.$jM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(M);if(!E)throw new Error("Embedding vector provider not found");const I=await E.provideEmbeddingVector(b,$);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(M,b,$){const E=this.b;return this.b++,this.a.set(E,$),this.c.$registerAiEmbeddingVectorProvider(b,E),new O.$lM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$gnc=L}),define(ke[70],De([1,0,6,33,8,22,5,20,60,3,7,23,15]),function(he,e,l,O,L,A,M,b,$,E,I,P,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$rmc=e.$qmc=void 0;let v=S=class{constructor(f,a){this.b=new Map,this.c=new I.$Hh,this.a=f.getProxy(l.$jM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let c;const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),c=await r.impl.stat(i)):c=await n.a.$stat(i),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===O.FilePermission.Readonly?1:void 0}}catch(c){S.e(c)}},async readDirectory(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(c){return S.e(c)}},async createDirectory(i){try{const c=n.b.get(i.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(c.impl,c.extUri,i)):await n.a.$mkdir(i)}catch(c){return S.e(c)}},async readFile(i){try{const c=n.b.get(i.scheme);return c?(await n.a.$ensureActivation(i.scheme),(await c.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(c){return S.e(c)}},async writeFile(i,c){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(r.impl,r.extUri,r.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(r.impl.writeFile(i,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,A.$He.wrap(c))}catch(r){return S.e(r)}},async delete(i,c){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(i.scheme),await r.impl.delete(i,{recursive:!1,...c})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(r){return S.e(r)}},async rename(i,c,r){try{return await n.a.$rename(i,c,{overwrite:!1,...r})}catch(t){return S.e(t)}},async copy(i,c,r){try{return await n.a.$copy(i,c,{overwrite:!1,...r})}catch(t){return S.e(t)}},isWritableFileSystem(i){const c=a.getCapabilities(i);if(typeof c=="number")return!(c&2048)}})}async d(f,a,n){const i=[];for(;!a.isEqual(n,a.dirname(n));)try{if(!((await f.stat(n)).type&O.FileType.Directory))throw L.$CN.FileExists(`Unable to create folder '${n.scheme===p.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(O.$il(c)!==O.FileSystemProviderErrorCode.FileNotFound)throw c;i.push(a.basename(n)),n=a.dirname(n)}for(let c=i.length-1;c>=0;c--){n=a.joinPath(n,i[c]);try{await f.createDirectory(n)}catch(r){if(O.$il(r)!==O.FileSystemProviderErrorCode.FileExists)throw r}}}static e(f){if(f instanceof L.$CN)throw f;if(f instanceof O.$el)switch(f.code){case O.FileSystemProviderErrorCode.FileExists:throw L.$CN.FileExists(f.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.$CN.FileNotFound(f.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.$CN.FileNotADirectory(f.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.$CN.FileIsADirectory(f.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.$CN.NoPermissions(f.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.$CN.Unavailable(f.message);default:throw new L.$CN(f.message,f.name)}if(!(f instanceof Error))throw new L.$CN(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw L.$CN.Unavailable(f.message);switch(f.name){case O.FileSystemProviderErrorCode.FileExists:throw L.$CN.FileExists(f.message);case O.FileSystemProviderErrorCode.FileNotFound:throw L.$CN.FileNotFound(f.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw L.$CN.FileNotADirectory(f.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw L.$CN.FileIsADirectory(f.message);case O.FileSystemProviderErrorCode.NoPermissions:throw L.$CN.NoPermissions(f.message);case O.FileSystemProviderErrorCode.Unavailable:throw L.$CN.Unavailable(f.message);default:throw new L.$CN(f.message,f.name)}}addFileSystemProvider(f,a,n){return this.b.set(f,{impl:a,extUri:n?.isCaseSensitive?P.$2g:P.$4g,isReadonly:!!n?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??P.$2g}};e.$qmc=v,e.$qmc=v=S=Je([We(0,b.$NO),We(1,$.$7lc)],v),e.$rmc=(0,M.$yi)("IExtHostConsumerFileSystem")}),define(ke[93],De([1,0,5,28,11,70,2]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=e.$smc=void 0,e.$smc=(0,l.$yi)("IExtensionStoragePaths");let b=class{constructor(E,I,P){this.d=I,this.f=P,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(E){return M.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,I=await this.g(E);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(M.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(E){if(this.c)return M.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return M.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$tmc=b,e.$tmc=b=Je([We(0,O.$4O),We(1,L.$5j),We(2,A.$rmc)],b)}),define(ke[333],De([1,0,8,20,4]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=void 0;let A=class{constructor(b){this.a=new l.$MN(l.ColorThemeKind.Dark),this.b=new L.$fe}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=l.ColorThemeKind.Light;break;case"hcDark":$=l.ColorThemeKind.HighContrast;break;case"hcLight":$=l.ColorThemeKind.HighContrastLight;break;default:$=l.ColorThemeKind.Dark}this.a=new l.$MN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$1nc=A,e.$1nc=A=Je([We(0,O.$NO)],A)}),define(ke[71],De([1,0,21,4,3,234,5,11,88,6,28,20,8]),function(he,e,l,O,L,A,M,b,$,E,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VDb=e.$UDb=e.TunnelDtoConverter=void 0;class S extends $.$ww{}var v;(function(f){function a(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}f.fromApiTunnel=a;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}f.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$UDb=(0,M.$yi)("IExtHostTunnelService");let d=class extends L.$Uc{constructor(a,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$fe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(E.$jM.MainThreadTunnelService)}async openTunnel(a,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,a.displayName);if(i){const c=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,n){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:a,provider:n}),this.a.$registerPortsAttributesProvider(a,i),new p.$lM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(a,n,i,c,r){const t=[];for(const s of a){const o=this.r.get(s);if(!o)return[];t.push(...await Promise.all(n.map(async h=>{let g;try{g=await o.provider.providePortAttributes({port:h,pid:i,commandLine:c},r)}catch{g=await o.provider.providePortAttributes(h,i,c,r)}return{providedAttributes:g,port:h}})))}const u=t.filter(s=>!!s.providedAttributes);return u.length>0?u.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,r)=>await a.provideTunnel(c,r,l.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,L.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,n){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const i=a.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let c=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const r=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(r)}}else this.b=void 0;return(0,L.$Sc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,n){if(this.g.has(a.host)){const i=this.g.get(a.host);i.has(a.port)&&(n&&i.get(a.port).disposeListener.dispose(),await i.get(a.port).tunnel.dispose(),i.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(a,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const c=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const r=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:c,disposeListener:r}),v.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(a){const n=await Promise.all(a.map(c=>this.f(c.host,c.port,c.detail??""))),i=a.filter((c,r)=>n[r]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(c=>c.port).join(", ")} to ${i.map(c=>c.port).join(", ")}`),i}};e.$VDb=d,e.$VDb=d=Je([We(0,P.$NO),We(1,I.$4O),We(2,b.$5j)],d)}),define(ke[17],De([1,0,19,22,177,75,81,27,167,58,101,24,172,23,50,18,2,29,84,139,145,143,296,120,69,89,308,8]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c,r,t,u,s,o,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$KO=B,e.$LO=re,e.$MO=H;var w;(function(Oe){function Fe(x){const{selectionStartLineNumber:je,selectionStartColumn:He,positionLineNumber:Ze,positionColumn:Ke}=x,ht=new g.$mM(je-1,He-1),St=new g.$mM(Ze-1,Ke-1);return new g.$oM(ht,St)}Oe.to=Fe;function Ee(x){const{anchor:je,active:He}=x;return{selectionStartLineNumber:je.line+1,selectionStartColumn:je.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Oe.from=Ee})(w||(e.Selection=w={}));var k;(function(Oe){function Fe(x){if(!x)return;const{start:je,end:He}=x;return{startLineNumber:je.line+1,startColumn:je.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Oe.from=Fe;function Ee(x){if(!x)return;const{startLineNumber:je,startColumn:He,endLineNumber:Ze,endColumn:Ke}=x;return new g.$nM(je-1,He-1,Ze-1,Ke-1)}Oe.to=Ee})(k||(e.Range=k={}));var m;(function(Oe){function Fe(x){return{uri:x.uri,range:k.from(x.range)}}Oe.from=Fe;function Ee(x){return new g.$xM(f.URI.revive(x.uri),k.to(x.range))}Oe.to=Ee})(m||(e.Location=m={}));var y;(function(Oe){function Fe(Ee){switch(Ee){case 1:return g.StandardTokenType.Comment;case 0:return g.StandardTokenType.Other;case 3:return g.StandardTokenType.RegEx;case 2:return g.StandardTokenType.String}}Oe.to=Fe})(y||(e.TokenType=y={}));var D;(function(Oe){function Fe(x){return new g.$mM(x.lineNumber-1,x.column-1)}Oe.to=Fe;function Ee(x){return{lineNumber:x.line+1,column:x.character+1}}Oe.from=Ee})(D||(e.Position=D={}));var C;(function(Oe){function Fe(je,He,Ze){return(0,l.$Hb)((0,l.$2b)(je).map(Ke=>Ee(Ke,He,Ze)))}Oe.from=Fe;function Ee(je,He,Ze){if(typeof je=="string")return{$serialized:!0,language:je,isBuiltin:Ze?.isBuiltin};if(je)return{$serialized:!0,language:je.language,scheme:x(je.scheme,He),pattern:Ce.from(je.pattern)??void 0,exclusive:je.exclusive,notebookType:je.notebookType,isBuiltin:Ze?.isBuiltin}}function x(je,He){return He&&typeof je=="string"?He.transformOutgoingScheme(je):je}})(C||(e.DocumentSelector=C={}));var R;(function(Oe){function Fe(x){switch(x){case g.DiagnosticTag.Unnecessary:return 1;case g.DiagnosticTag.Deprecated:return 2}}Oe.from=Fe;function Ee(x){switch(x){case 1:return g.DiagnosticTag.Unnecessary;case 2:return g.DiagnosticTag.Deprecated;default:return}}Oe.to=Ee})(R||(e.DiagnosticTag=R={}));var T;(function(Oe){function Fe(x){let je;return x.code&&((0,d.$$f)(x.code)||(0,d.$cg)(x.code)?je=String(x.code):je={value:String(x.code.value),target:x.code.target}),{...k.from(x.range),message:x.message,source:x.source,code:je,severity:z.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(j.from),tags:Array.isArray(x.tags)?(0,l.$Hb)(x.tags.map(R.from)):void 0}}Oe.from=Fe;function Ee(x){const je=new g.$zM(k.to(x),x.message,z.to(x.severity));return je.source=x.source,je.code=(0,d.$$f)(x.code)?x.code:x.code?.value,je.relatedInformation=x.relatedInformation&&x.relatedInformation.map(j.to),je.tags=x.tags&&(0,l.$Hb)(x.tags.map(R.to)),je}Oe.to=Ee})(T||(e.Diagnostic=T={}));var j;(function(Oe){function Fe(x){return{...k.from(x.location.range),message:x.message,resource:x.location.uri}}Oe.from=Fe;function Ee(x){return new g.$yM(new g.$xM(x.resource,k.to(x)),x.message)}Oe.to=Ee})(j||(e.DiagnosticRelatedInformation=j={}));var z;(function(Oe){function Fe(x){switch(x){case g.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case g.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case g.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case g.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Oe.from=Fe;function Ee(x){switch(x){case i.MarkerSeverity.Info:return g.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return g.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return g.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return g.DiagnosticSeverity.Hint;default:return g.DiagnosticSeverity.Error}}Oe.to=Ee})(z||(e.DiagnosticSeverity=z={}));var N;(function(Oe){function Fe(x){return typeof x=="number"&&x>=g.ViewColumn.One?x-1:x===g.ViewColumn.Beside?h.$9D:h.$8D}Oe.from=Fe;function Ee(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}Oe.to=Ee})(N||(e.ViewColumn=N={}));function F(Oe){return typeof Oe.range<"u"}function B(Oe){return Oe.length===0?!0:!!F(Oe[0])}var Y;(function(Oe){function Fe(Ke){return Ke.map(Oe.from)}Oe.fromMany=Fe;function Ee(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function x(Ke){let ht;if(Ee(Ke)){const{language:Tt,value:zt}=Ke;ht={value:"```"+Tt+`
`+zt+"\n```\n"}}else g.$NM.isMarkdownString(Ke)?ht={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ht={value:Ke}:ht={value:""};const St=Object.create(null);ht.uris=St;const Ft=Tt=>{try{let zt=f.URI.parse(Tt,!0);zt=zt.with({query:je(zt.query,St)}),St[Tt]=zt}catch{}return""},lt=new $.marked.Renderer;return lt.link=Ft,lt.image=Tt=>typeof Tt=="string"?Ft(M.$4k(Tt).href):"",(0,$.marked)(ht.value,{renderer:lt}),ht}Oe.from=x;function je(Ke,ht){if(!Ke)return Ke;let St;try{St=(0,E.$7h)(Ke)}catch{}if(!St)return Ke;let Ft=!1;return St=(0,P.$7n)(St,lt=>{if(f.URI.isUri(lt)){const Tt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[Tt]=lt,Ft=!0,Tt}else return}),Ft?JSON.stringify(St):Ke}function He(Ke){const ht=new g.$NM(Ke.value,Ke.supportThemeIcons);return ht.isTrusted=Ke.isTrusted,ht.supportHtml=Ke.supportHtml,ht.baseUri=Ke.baseUri?f.URI.from(Ke.baseUri):void 0,ht}Oe.to=He;function Ze(Ke){if(Ke)return typeof Ke=="string"?Ke:Oe.from(Ke)}Oe.fromStrict=Ze})(Y||(e.MarkdownString=Y={}));function re(Oe){return B(Oe)?Oe.map(Fe=>({range:k.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?Y.fromMany(Fe.hoverMessage):Fe.hoverMessage?Y.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Oe.map(Fe=>({range:k.from(Fe)}))}function H(Oe){return typeof Oe>"u"?Oe:typeof Oe=="string"?f.URI.file(Oe):Oe}var K;(function(Oe){function Fe(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?H(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Oe.from=Fe})(K||(e.ThemableDecorationAttachmentRenderOptions=K={}));var _;(function(Oe){function Fe(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?H(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?K.from(Ee.before):void 0,after:Ee.after?K.from(Ee.after):void 0}}Oe.from=Fe})(_||(e.ThemableDecorationRenderOptions=_={}));var Z;(function(Oe){function Fe(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case g.DecorationRangeBehavior.OpenOpen:return 0;case g.DecorationRangeBehavior.ClosedClosed:return 1;case g.DecorationRangeBehavior.OpenClosed:return 2;case g.DecorationRangeBehavior.ClosedOpen:return 3}}Oe.from=Fe})(Z||(e.DecorationRangeBehavior=Z={}));var $e;(function(Oe){function Fe(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?Z.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?_.from(Ee.light):void 0,dark:Ee.dark?_.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?H(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?K.from(Ee.before):void 0,after:Ee.after?K.from(Ee.after):void 0}}Oe.from=Fe})($e||(e.DecorationRenderOptions=$e={}));var oe;(function(Oe){function Fe(x){return{text:x.newText,eol:x.newEol&&Me.from(x.newEol),range:k.from(x.range)}}Oe.from=Fe;function Ee(x){const je=new g.$sM(k.to(x.range),x.text);return je.newEol=typeof x.eol>"u"?void 0:Me.to(x.eol),je}Oe.to=Ee})(oe||(e.TextEdit=oe={}));var Pe;(function(Oe){function Fe(x,je){const He={edits:[]};if(x instanceof g.$vM){const Ze=new b.$Bc;for(const Ke of x._allEntries())Ke._type===1&&f.URI.isUri(Ke.to)&&Ke.from===void 0&&Ze.add(Ke.to);for(const Ke of x._allEntries())if(Ke._type===1){let ht;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ht={type:"base64",value:(0,O.$2e)(O.$He.wrap(Ke.options.contents))}:ht={type:"dataTransferItem",id:Ke.options.contents._itemId}),He.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ht},metadata:Ke.metadata})}else Ke._type===2?He.edits.push({resource:Ke.uri,textEdit:oe.from(Ke.edit),versionId:Ze.has(Ke.uri)?void 0:je?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?He.edits.push({resource:Ke.uri,textEdit:{range:k.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ke.uri)?void 0:je?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?He.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:je?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&He.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:je?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Bt.from)}})}return He}Oe.from=Fe;function Ee(x){const je=new g.$vM,He=new b.$Ac;for(const Ze of x.edits)if(Ze.textEdit){const Ke=Ze,ht=f.URI.revive(Ke.resource),St=k.to(Ke.textEdit.range),Ft=Ke.textEdit.text,lt=Ke.textEdit.insertAsSnippet;let Tt;lt?Tt=g.$uM.replace(St,new g.$wM(Ft)):Tt=g.$sM.replace(St,Ft);const zt=He.get(ht);zt?zt.push(Tt):He.set(ht,[Tt])}else je.renameFile(f.URI.revive(Ze.oldResource),f.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ke]of He)je.set(Ze,Ke);return je}Oe.to=Ee})(Pe||(e.WorkspaceEdit=Pe={}));var te;(function(Oe){const Fe=Object.create(null);Fe[g.SymbolKind.File]=0,Fe[g.SymbolKind.Module]=1,Fe[g.SymbolKind.Namespace]=2,Fe[g.SymbolKind.Package]=3,Fe[g.SymbolKind.Class]=4,Fe[g.SymbolKind.Method]=5,Fe[g.SymbolKind.Property]=6,Fe[g.SymbolKind.Field]=7,Fe[g.SymbolKind.Constructor]=8,Fe[g.SymbolKind.Enum]=9,Fe[g.SymbolKind.Interface]=10,Fe[g.SymbolKind.Function]=11,Fe[g.SymbolKind.Variable]=12,Fe[g.SymbolKind.Constant]=13,Fe[g.SymbolKind.String]=14,Fe[g.SymbolKind.Number]=15,Fe[g.SymbolKind.Boolean]=16,Fe[g.SymbolKind.Array]=17,Fe[g.SymbolKind.Object]=18,Fe[g.SymbolKind.Key]=19,Fe[g.SymbolKind.Null]=20,Fe[g.SymbolKind.EnumMember]=21,Fe[g.SymbolKind.Struct]=22,Fe[g.SymbolKind.Event]=23,Fe[g.SymbolKind.Operator]=24,Fe[g.SymbolKind.TypeParameter]=25;function Ee(je){return typeof Fe[je]=="number"?Fe[je]:6}Oe.from=Ee;function x(je){for(const He in Fe)if(Fe[He]===je)return Number(He);return g.SymbolKind.Property}Oe.to=x})(te||(e.SymbolKind=te={}));var U;(function(Oe){function Fe(x){switch(x){case g.SymbolTag.Deprecated:return 1}}Oe.from=Fe;function Ee(x){switch(x){case 1:return g.SymbolTag.Deprecated}}Oe.to=Ee})(U||(e.SymbolTag=U={}));var ee;(function(Oe){function Fe(x){return{name:x.name,kind:te.from(x.kind),tags:x.tags&&x.tags.map(U.from),containerName:x.containerName,location:le.from(x.location)}}Oe.from=Fe;function Ee(x){const je=new g.$EM(x.name,te.to(x.kind),x.containerName,le.to(x.location));return je.tags=x.tags&&x.tags.map(U.to),je}Oe.to=Ee})(ee||(e.WorkspaceSymbol=ee={}));var be;(function(Oe){function Fe(x){const je={name:x.name||"!!MISSING: name!!",detail:x.detail,range:k.from(x.range),selectionRange:k.from(x.selectionRange),kind:te.from(x.kind),tags:x.tags?.map(U.from)??[]};return x.children&&(je.children=x.children.map(Fe)),je}Oe.from=Fe;function Ee(x){const je=new g.$FM(x.name,x.detail,te.to(x.kind),k.to(x.range),k.to(x.selectionRange));return(0,l.$Lb)(x.tags)&&(je.tags=x.tags.map(U.to)),x.children&&(je.children=x.children.map(Ee)),je}Oe.to=Ee})(be||(e.DocumentSymbol=be={}));var ue;(function(Oe){function Fe(x){const je=new g.$JM(te.to(x.kind),x.name,x.detail||"",f.URI.revive(x.uri),k.to(x.range),k.to(x.selectionRange));return je._sessionId=x._sessionId,je._itemId=x._itemId,je}Oe.to=Fe;function Ee(x,je,He){if(je=je??x._sessionId,He=He??x._itemId,je===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:je,_itemId:He,name:x.name,detail:x.detail,kind:te.from(x.kind),uri:x.uri,range:k.from(x.range),selectionRange:k.from(x.selectionRange),tags:x.tags?.map(U.from)}}Oe.from=Ee})(ue||(e.CallHierarchyItem=ue={}));var ce;(function(Oe){function Fe(Ee){return new g.$KM(ue.to(Ee.from),Ee.fromRanges.map(x=>k.to(x)))}Oe.to=Fe})(ce||(e.CallHierarchyIncomingCall=ce={}));var ae;(function(Oe){function Fe(Ee){return new g.$LM(ue.to(Ee.to),Ee.fromRanges.map(x=>k.to(x)))}Oe.to=Fe})(ae||(e.CallHierarchyOutgoingCall=ae={}));var le;(function(Oe){function Fe(x){return{range:x.range&&k.from(x.range),uri:x.uri}}Oe.from=Fe;function Ee(x){return new g.$xM(f.URI.revive(x.uri),k.to(x.range))}Oe.to=Ee})(le||(e.location=le={}));var J;(function(Oe){function Fe(x){const je=x,He=x;return{originSelectionRange:je.originSelectionRange?k.from(je.originSelectionRange):void 0,uri:je.targetUri?je.targetUri:He.uri,range:k.from(je.targetRange?je.targetRange:He.range),targetSelectionRange:je.targetSelectionRange?k.from(je.targetSelectionRange):void 0}}Oe.from=Fe;function Ee(x){return{targetUri:f.URI.revive(x.uri),targetRange:k.to(x.range),targetSelectionRange:x.targetSelectionRange?k.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?k.to(x.originSelectionRange):void 0}}Oe.to=Ee})(J||(e.DefinitionLink=J={}));var se;(function(Oe){function Fe(x){return{range:k.from(x.range),contents:Y.fromMany(x.contents),canIncreaseVerbosity:x.canIncreaseVerbosity,canDecreaseVerbosity:x.canDecreaseVerbosity}}Oe.from=Fe;function Ee(x){const je=x.contents.map(Y.to),He=k.to(x.range),Ze=x.canIncreaseVerbosity,Ke=x.canDecreaseVerbosity;return new g.$BM(je,He,Ze,Ke)}Oe.to=Ee})(se||(e.Hover=se={}));var pe;(function(Oe){function Fe(x){return{range:k.from(x.range),expression:x.expression}}Oe.from=Fe;function Ee(x){return new g.$wN(k.to(x.range),x.expression)}Oe.to=Ee})(pe||(e.EvaluatableExpression=pe={}));var ve;(function(Oe){function Fe(x){if(x instanceof g.$xN)return{type:"text",range:k.from(x.range),text:x.text};if(x instanceof g.$yN)return{type:"variable",range:k.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof g.$zN)return{type:"expression",range:k.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}Oe.from=Fe;function Ee(x){switch(x.type){case"text":return{range:k.to(x.range),text:x.text};case"variable":return{range:k.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:k.to(x.range),expression:x.expression}}}Oe.to=Ee})(ve||(e.InlineValue=ve={}));var Re;(function(Oe){function Fe(x){return{frameId:x.frameId,stoppedLocation:k.from(x.stoppedLocation)}}Oe.from=Fe;function Ee(x){return new g.$AN(x.frameId,k.to(x.stoppedLocation))}Oe.to=Ee})(Re||(e.InlineValueContext=Re={}));var me;(function(Oe){function Fe(x){return{range:k.from(x.range),kind:x.kind}}Oe.from=Fe;function Ee(x){return new g.$CM(k.to(x.range),x.kind)}Oe.to=Ee})(me||(e.DocumentHighlight=me={}));var Ie;(function(Oe){function Fe(x){return{uri:x.uri,highlights:x.highlights.map(me.from)}}Oe.from=Fe;function Ee(x){return new g.$DM(f.URI.revive(x.uri),x.highlights.map(me.to))}Oe.to=Ee})(Ie||(e.MultiDocumentHighlight=Ie={}));var Ae;(function(Oe){function Fe(Ee){switch(Ee){case 1:return g.CompletionTriggerKind.TriggerCharacter;case 2:return g.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return g.CompletionTriggerKind.Invoke}}Oe.to=Fe})(Ae||(e.CompletionTriggerKind=Ae={}));var ze;(function(Oe){function Fe(Ee){return{triggerKind:Ae.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Oe.to=Fe})(ze||(e.CompletionContext=ze={}));var q;(function(Oe){function Fe(x){switch(x){case g.CompletionItemTag.Deprecated:return 1}}Oe.from=Fe;function Ee(x){switch(x){case 1:return g.CompletionItemTag.Deprecated}}Oe.to=Ee})(q||(e.CompletionItemTag=q={}));var W;(function(Oe){const Fe=new Map([[g.CompletionItemKind.Method,0],[g.CompletionItemKind.Function,1],[g.CompletionItemKind.Constructor,2],[g.CompletionItemKind.Field,3],[g.CompletionItemKind.Variable,4],[g.CompletionItemKind.Class,5],[g.CompletionItemKind.Interface,7],[g.CompletionItemKind.Struct,6],[g.CompletionItemKind.Module,8],[g.CompletionItemKind.Property,9],[g.CompletionItemKind.Unit,12],[g.CompletionItemKind.Value,13],[g.CompletionItemKind.Constant,14],[g.CompletionItemKind.Enum,15],[g.CompletionItemKind.EnumMember,16],[g.CompletionItemKind.Keyword,17],[g.CompletionItemKind.Snippet,27],[g.CompletionItemKind.Text,18],[g.CompletionItemKind.Color,19],[g.CompletionItemKind.File,20],[g.CompletionItemKind.Reference,21],[g.CompletionItemKind.Folder,23],[g.CompletionItemKind.Event,10],[g.CompletionItemKind.Operator,11],[g.CompletionItemKind.TypeParameter,24],[g.CompletionItemKind.Issue,26],[g.CompletionItemKind.User,25]]);function Ee(He){return Fe.get(He)??9}Oe.from=Ee;const x=new Map([[0,g.CompletionItemKind.Method],[1,g.CompletionItemKind.Function],[2,g.CompletionItemKind.Constructor],[3,g.CompletionItemKind.Field],[4,g.CompletionItemKind.Variable],[5,g.CompletionItemKind.Class],[7,g.CompletionItemKind.Interface],[6,g.CompletionItemKind.Struct],[8,g.CompletionItemKind.Module],[9,g.CompletionItemKind.Property],[12,g.CompletionItemKind.Unit],[13,g.CompletionItemKind.Value],[14,g.CompletionItemKind.Constant],[15,g.CompletionItemKind.Enum],[16,g.CompletionItemKind.EnumMember],[17,g.CompletionItemKind.Keyword],[27,g.CompletionItemKind.Snippet],[18,g.CompletionItemKind.Text],[19,g.CompletionItemKind.Color],[20,g.CompletionItemKind.File],[21,g.CompletionItemKind.Reference],[23,g.CompletionItemKind.Folder],[10,g.CompletionItemKind.Event],[11,g.CompletionItemKind.Operator],[24,g.CompletionItemKind.TypeParameter],[25,g.CompletionItemKind.User],[26,g.CompletionItemKind.Issue]]);function je(He){return x.get(He)??g.CompletionItemKind.Property}Oe.to=je})(W||(e.CompletionItemKind=W={}));var X;(function(Oe){function Fe(Ee,x){const je=new g.$TM(Ee.label);return je.insertText=Ee.insertText,je.kind=W.to(Ee.kind),je.tags=Ee.tags?.map(q.to),je.detail=Ee.detail,je.documentation=M.$Xk(Ee.documentation)?Y.to(Ee.documentation):Ee.documentation,je.sortText=Ee.sortText,je.filterText=Ee.filterText,je.preselect=Ee.preselect,je.commitCharacters=Ee.commitCharacters,a.$yt.isIRange(Ee.range)?je.range=k.to(Ee.range):typeof Ee.range=="object"&&(je.range={inserting:k.to(Ee.range.insert),replacing:k.to(Ee.range.replace)}),je.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?je.insertText=new g.$wM(Ee.insertText):(je.insertText=Ee.insertText,je.textEdit=je.range instanceof g.$nM?new g.$sM(je.range,je.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(je.additionalTextEdits=Ee.additionalTextEdits.map(He=>oe.to(He))),je.command=x&&Ee.command?x.fromInternal(Ee.command):void 0,je}Oe.to=Fe})(X||(e.CompletionItem=X={}));var Q;(function(Oe){function Fe(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:Y.fromStrict(x.documentation)}}Oe.from=Fe;function Ee(x){return{label:x.label,documentation:M.$Xk(x.documentation)?Y.to(x.documentation):x.documentation}}Oe.to=Ee})(Q||(e.ParameterInformation=Q={}));var de;(function(Oe){function Fe(x){return{label:x.label,documentation:Y.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(Q.from):[],activeParameter:x.activeParameter}}Oe.from=Fe;function Ee(x){return{label:x.label,documentation:M.$Xk(x.documentation)?Y.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(Q.to):[],activeParameter:x.activeParameter}}Oe.to=Ee})(de||(e.SignatureInformation=de={}));var we;(function(Oe){function Fe(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(de.from):[]}}Oe.from=Fe;function Ee(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(de.to):[]}}Oe.to=Ee})(we||(e.SignatureHelp=we={}));var Te;(function(Oe){function Fe(Ee,x){const je=new g.$SM(D.to(x.position),typeof x.label=="string"?x.label:x.label.map(qe.to.bind(void 0,Ee)),x.kind&&Xe.to(x.kind));return je.textEdits=x.textEdits&&x.textEdits.map(oe.to),je.tooltip=M.$Xk(x.tooltip)?Y.to(x.tooltip):x.tooltip,je.paddingLeft=x.paddingLeft,je.paddingRight=x.paddingRight,je}Oe.to=Fe})(Te||(e.InlayHint=Te={}));var qe;(function(Oe){function Fe(Ee,x){const je=new g.$RM(x.label);return je.tooltip=M.$Xk(x.tooltip)?Y.to(x.tooltip):x.tooltip,n.Command.is(x.command)&&(je.command=Ee.fromInternal(x.command)),x.location&&(je.location=le.to(x.location)),je}Oe.to=Fe})(qe||(e.InlayHintLabelPart=qe={}));var Xe;(function(Oe){function Fe(x){return x}Oe.from=Fe;function Ee(x){return x}Oe.to=Ee})(Xe||(e.InlayHintKind=Xe={}));var tt;(function(Oe){function Fe(x){return{range:k.from(x.range),url:x.target,tooltip:x.tooltip}}Oe.from=Fe;function Ee(x){let je;if(x.url)try{je=typeof x.url=="string"?f.URI.parse(x.url,!0):f.URI.revive(x.url)}catch{}return new g.$YM(k.to(x.range),je)}Oe.to=Ee})(tt||(e.DocumentLink=tt={}));var et;(function(Oe){function Fe(x){const je=new g.$2M(x.label);return x.textEdit&&(je.textEdit=oe.to(x.textEdit)),x.additionalTextEdits&&(je.additionalTextEdits=x.additionalTextEdits.map(He=>oe.to(He))),je}Oe.to=Fe;function Ee(x){return{label:x.label,textEdit:x.textEdit?oe.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(je=>oe.from(je)):void 0}}Oe.from=Ee})(et||(e.ColorPresentation=et={}));var nt;(function(Oe){function Fe(x){return new g.$ZM(x[0],x[1],x[2],x[3])}Oe.to=Fe;function Ee(x){return[x.red,x.green,x.blue,x.alpha]}Oe.from=Ee})(nt||(e.Color=nt={}));var it;(function(Oe){function Fe(x){return{range:k.from(x.range)}}Oe.from=Fe;function Ee(x){return new g.$IM(k.to(x.range))}Oe.to=Ee})(it||(e.SelectionRange=it={}));var rt;(function(Oe){function Fe(Ee){switch(Ee){case 2:return g.TextDocumentSaveReason.AfterDelay;case 1:return g.TextDocumentSaveReason.Manual;case 3:case 4:return g.TextDocumentSaveReason.FocusOut}}Oe.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var at;(function(Oe){function Fe(x){switch(x){case g.TextEditorLineNumbersStyle.Off:return 0;case g.TextEditorLineNumbersStyle.Relative:return 2;case g.TextEditorLineNumbersStyle.Interval:return 3;case g.TextEditorLineNumbersStyle.On:default:return 1}}Oe.from=Fe;function Ee(x){switch(x){case 0:return g.TextEditorLineNumbersStyle.Off;case 2:return g.TextEditorLineNumbersStyle.Relative;case 3:return g.TextEditorLineNumbersStyle.Interval;case 1:default:return g.TextEditorLineNumbersStyle.On}}Oe.to=Ee})(at||(e.TextEditorLineNumbersStyle=at={}));var Me;(function(Oe){function Fe(x){if(x===g.EndOfLine.CRLF)return 1;if(x===g.EndOfLine.LF)return 0}Oe.from=Fe;function Ee(x){if(x===1)return g.EndOfLine.CRLF;if(x===0)return g.EndOfLine.LF}Oe.to=Ee})(Me||(e.EndOfLine=Me={}));var ye;(function(Oe){function Fe(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case g.ProgressLocation.SourceControl:return 3;case g.ProgressLocation.Window:return 10;case g.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Oe.from=Fe})(ye||(e.ProgressLocation=ye={}));var Ve;(function(Oe){function Fe(x){const je={start:x.start+1,end:x.end+1};return x.kind&&(je.kind=ne.from(x.kind)),je}Oe.from=Fe;function Ee(x){const je={start:x.start-1,end:x.end-1};return x.kind&&(je.kind=ne.to(x.kind)),je}Oe.to=Ee})(Ve||(e.FoldingRange=Ve={}));var ne;(function(Oe){function Fe(x){if(x)switch(x){case g.FoldingRangeKind.Comment:return n.$xu.Comment;case g.FoldingRangeKind.Imports:return n.$xu.Imports;case g.FoldingRangeKind.Region:return n.$xu.Region}}Oe.from=Fe;function Ee(x){if(x)switch(x.value){case n.$xu.Comment.value:return g.FoldingRangeKind.Comment;case n.$xu.Imports.value:return g.FoldingRangeKind.Imports;case n.$xu.Region.value:return g.FoldingRangeKind.Region}}Oe.to=Ee})(ne||(e.FoldingRangeKind=ne={}));var ie;(function(Oe){function Fe(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?k.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?r.$yF.id:void 0}}Oe.from=Fe})(ie||(e.TextEditorOpenOptions=ie={}));var Ce;(function(Oe){function Fe(He){return He instanceof g.$kN?He.toJSON():typeof He=="string"?He:Ee(He)||x(He)?new g.$kN(He.baseUri??He.base,He.pattern).toJSON():He}Oe.from=Fe;function Ee(He){const Ze=He;return Ze?f.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function x(He){const Ze=He;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function je(He){return typeof He=="string"?He:new g.$kN(f.URI.revive(He.baseUri),He.pattern)}Oe.to=je})(Ce||(e.GlobPattern=Ce={}));var Ge;(function(Oe){function Fe(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Fe);if(typeof Ee=="string")return Ee;{const x=Ee;return{language:x.language,scheme:x.scheme,pattern:Ce.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}Oe.from=Fe})(Ge||(e.LanguageSelector=Ge={}));var Le;(function(Oe){function Fe(x){return!!x&&typeof x=="object"&&"documents"in x&&Array.isArray(x.documents)&&x.documents.every(je=>Array.isArray(je)&&je.every(He=>He&&typeof He=="object"&&"uri"in He&&f.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(Ze=>Ze instanceof g.$nM)))}Oe.is=Fe;function Ee(x){return{documents:x.documents.map(je=>je.map(He=>({uri:f.URI.from(He.uri),version:He.version,ranges:He.ranges.map(Ze=>k.from(Ze))})))}}Oe.from=Ee})(Le||(e.MappedEditsContext=Le={}));var st;(function(Oe){function Fe(x){return{start:x.start,end:x.end}}Oe.from=Fe;function Ee(x){return new g.$NN(x.start,x.end)}Oe.to=Ee})(st||(e.NotebookRange=st={}));var ut;(function(Oe){function Fe(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}Oe.to=Fe;function Ee(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}Oe.from=Ee})(ut||(e.NotebookCellExecutionSummary=ut={}));var mt;(function(Oe){function Fe(Ee){if(Ee===u.NotebookCellExecutionState.Unconfirmed)return g.NotebookCellExecutionState.Pending;if(Ee===u.NotebookCellExecutionState.Pending)return;if(Ee===u.NotebookCellExecutionState.Executing)return g.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Oe.to=Fe})(mt||(e.NotebookCellExecutionState=mt={}));var Ct;(function(Oe){function Fe(x){switch(x){case g.NotebookCellKind.Markup:return u.CellKind.Markup;case g.NotebookCellKind.Code:default:return u.CellKind.Code}}Oe.from=Fe;function Ee(x){switch(x){case u.CellKind.Markup:return g.NotebookCellKind.Markup;case u.CellKind.Code:default:return g.NotebookCellKind.Code}}Oe.to=Ee})(Ct||(e.NotebookCellKind=Ct={}));var Pt;(function(Oe){function Fe(x){const je={metadata:x.metadata??Object.create(null),cells:[]};for(const He of x.cells)g.$ON.validate(He),je.cells.push(Bt.from(He));return je}Oe.from=Fe;function Ee(x){const je=new g.$PN(x.cells.map(Bt.to));return(0,d.$lg)(x.metadata)||(je.metadata=x.metadata),je}Oe.to=Ee})(Pt||(e.NotebookData=Pt={}));var Bt;(function(Oe){function Fe(x){return{cellKind:Ct.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:ut.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(Et.from):[]}}Oe.from=Fe;function Ee(x){return new g.$ON(Ct.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(Et.to):void 0,x.metadata,x.internalMetadata?ut.to(x.internalMetadata):void 0)}Oe.to=Ee})(Bt||(e.NotebookCellData=Bt={}));var Ut;(function(Oe){function Fe(x){return{mime:x.mime,valueBytes:O.$He.wrap(x.data)}}Oe.from=Fe;function Ee(x){return new g.$QN(x.valueBytes.buffer,x.mime)}Oe.to=Ee})(Ut||(e.NotebookCellOutputItem=Ut={}));var Et;(function(Oe){function Fe(x){return{outputId:x.id,items:x.items.map(Ut.from),metadata:x.metadata}}Oe.from=Fe;function Ee(x){const je=x.items.map(Ut.to);return new g.$RN(je,x.outputId,x.metadata)}Oe.to=Ee})(Et||(e.NotebookCellOutput=Et={}));var Zt;(function(Oe){function Fe(je){return x(je)?{include:Ce.from(je.include)??void 0,exclude:Ce.from(je.exclude)??void 0}:Ce.from(je)??void 0}Oe.from=Fe;function Ee(je){return x(je)?{include:Ce.to(je.include),exclude:Ce.to(je.exclude)}:Ce.to(je)}Oe.to=Ee;function x(je){const He=je;return He?!(0,d.$hg)(He.include)&&!(0,d.$hg)(He.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var xt;(function(Oe){function Fe(Ee,x,je){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===g.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal(He,je),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Oe.from=Fe})(xt||(e.NotebookStatusBarItem=xt={}));var xe;(function(Oe){function Fe(Ee,x,je){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:x.toInternal(He,je),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Oe.from=Fe})(xe||(e.NotebookKernelSourceAction=xe={}));var on;(function(Oe){function Fe(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Oe.from=Fe})(on||(e.NotebookDocumentContentOptions=on={}));var Xt;(function(Oe){function Fe(x){return{uri:x.uri,provides:x.provides}}Oe.from=Fe;function Ee(x){return new g.$TN(f.URI.revive(x.uri),x.provides)}Oe.to=Ee})(Xt||(e.NotebookRendererScript=Xt={}));var ft;(function(Oe){function Fe(x){return{message:Y.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,contextValue:x.contextValue,location:x.location&&{range:k.from(x.location.range),uri:x.location.uri}}}Oe.from=Fe;function Ee(x){const je=new g.$ZN(typeof x.message=="string"?x.message:Y.to(x.message));return je.actualOutput=x.actual,je.expectedOutput=x.expected,je.contextValue=x.contextValue,je.location=x.location?le.to(x.location):void 0,je}Oe.to=Ee})(ft||(e.TestMessage=ft={}));var $t;(function(Oe){Oe.namespace=o.$aL,Oe.denamespace=o.$bL})($t||(e.TestTag=$t={}));var _t;(function(Oe){function Fe(x){const je=(0,c.$JO)(x).controllerId;return{extId:s.$8K.fromExtHostTestItem(x,je).toString(),label:x.label,uri:f.URI.revive(x.uri),busy:x.busy,tags:x.tags.map(He=>$t.namespace(je,He.id)),range:a.$yt.lift(k.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&Y.fromStrict(x.error)||null}}Oe.from=Fe;function Ee(x){return{parent:void 0,error:void 0,id:s.$8K.fromString(x.extId).localId,label:x.label,uri:f.URI.revive(x.uri),tags:(x.tags||[]).map(je=>{const{tagId:He}=$t.denamespace(je);return new g.$1N(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:k.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}Oe.toPlain=Ee})(_t||(e.TestItem=_t={})),function(Oe){function Fe(x){return{id:x.id}}Oe.from=Fe;function Ee(x){return new g.$1N(x.id)}Oe.to=Ee}($t||(e.TestTag=$t={}));var Qt;(function(Oe){const Fe=(x,je)=>{const He=x.value;if(!He)return;const Ze={..._t.toPlain(He.item),parent:je,taskStates:He.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ht=>ht.type===0).map(ft.to)})),children:[]};if(x.children)for(const Ke of x.children.values()){const ht=Fe(Ke,Ze);ht&&Ze.children.push(ht)}return Ze};function Ee(x){const je=new p.$CO;for(const Ke of x.items)je.insert(s.$8K.fromString(Ke.item.extId).path,Ke);const He=[je.nodes],Ze=[];for(;He.length;)for(const Ke of He.pop())Ke.value?Ze.push(Ke):Ke.children&&He.push(Ke.children.values());return{completedAt:x.completedAt,results:Ze.map(Ke=>Fe(Ke)).filter(d.$gg)}}Oe.to=Ee})(Qt||(e.TestResults=Qt={}));var jt;(function(Oe){function Fe(He){return{covered:He.covered,total:He.total}}function Ee(He){return"line"in He?D.from(He):k.from(He)}function x(He){if(typeof He.executed=="number"&&He.executed<0)throw new Error(`Invalid coverage count ${He.executed}`);return"branches"in He?{count:He.executed,location:Ee(He.location),type:1,branches:He.branches.length?He.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&Ee(Ze.location),label:Ze.label})):void 0}:{type:0,name:He.name,count:He.executed,location:Ee(He.location)}}Oe.fromDetails=x;function je(He,Ze,Ke){return g.$3N(Ke.statementCoverage),g.$3N(Ke.branchCoverage),g.$3N(Ke.declarationCoverage),{id:Ze,uri:Ke.uri,statement:Fe(Ke.statementCoverage),branch:Ke.branchCoverage&&Fe(Ke.branchCoverage),declaration:Ke.declarationCoverage&&Fe(Ke.declarationCoverage),testId:Ke instanceof g.$4N&&Ke.testItem?s.$8K.fromExtHostTestItem(Ke.testItem,He).toString():void 0}}Oe.fromFile=je})(jt||(e.TestCoverage=jt={}));var gt;(function(Oe){function Fe(Ee){switch(Ee){case 1:return g.CodeActionTriggerKind.Invoke;case 2:return g.CodeActionTriggerKind.Automatic}}Oe.to=Fe})(gt||(e.CodeActionTriggerKind=gt={}));var Ht;(function(Oe){function Fe(x){const je=new g.$8N(te.to(x.kind),x.name,x.detail||"",f.URI.revive(x.uri),k.to(x.range),k.to(x.selectionRange));return je._sessionId=x._sessionId,je._itemId=x._itemId,je}Oe.to=Fe;function Ee(x,je,He){if(je=je??x._sessionId,He=He??x._itemId,je===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:je,_itemId:He,kind:te.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:k.from(x.range),selectionRange:k.from(x.selectionRange),tags:x.tags?.map(U.from)}}Oe.from=Ee})(Ht||(e.TypeHierarchyItem=Ht={}));var en;(function(Oe){function Fe(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Oe.from=Fe})(en||(e.ViewBadge=en={}));var Wt;(function(Oe){function Fe(He,Ze,Ke){const ht=Ze.fileData;return ht?new g.$cN(new g.$dN(ht.name,f.URI.revive(ht.uri),ht.id,(0,A.$db)(()=>Ke(ht.id)))):He===I.$Us.uriList&&Ze.uriListData?new g.$bN(je(Ze.uriListData)):new g.$bN(Ze.asString)}Oe.to=Fe;async function Ee(He,Ze){const Ke=await Ze.asString();if(He===I.$Us.uriList)return{asString:Ke,fileData:void 0,uriListData:x(Ke)};const ht=Ze.asFile();return{asString:Ke,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Oe.from=Ee;function x(He){return L.$cu.split(He).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return f.URI.parse(Ze)}catch{}return Ze})}function je(He){return L.$cu.create(He.map(Ze=>typeof Ze=="string"?Ze:f.URI.revive(Ze)))}})(Wt||(e.DataTransferItem=Wt={}));var Ye;(function(Oe){function Fe(x,je){const He=x.items.map(([Ze,Ke])=>[Ze,Wt.to(Ze,Ke,je)]);return new g.$eN(He)}Oe.toDataTransfer=Fe;async function Ee(x){const je={items:[]},He=[];for(const[Ze,Ke]of x)He.push((async()=>{je.items.push([Ze,await Wt.from(Ze,Ke)])})());return await Promise.all(He),je}Oe.from=Ee})(Ye||(e.DataTransfer=Ye={}));var ln;(function(Oe){function Fe(x,je){return{kind:"reply",agentId:x.participant??je?.agentId??"",subCommand:x.command??je?.command,message:x.prompt,title:x.label}}Oe.from=Fe;function Ee(x){return{prompt:x.message,label:x.title,participant:x.agentId,command:x.subCommand}}Oe.to=Ee})(ln||(e.ChatFollowup=ln={}));var Yt;(function(Oe){function Fe(x){switch(x.role){case 0:return new g.$wO(g.LanguageModelChatMessageRole.System,x.content);case 1:return new g.$wO(g.LanguageModelChatMessageRole.User,x.content);case 2:return new g.$wO(g.LanguageModelChatMessageRole.Assistant,x.content)}}Oe.to=Fe;function Ee(x){switch(x.role){case g.LanguageModelChatMessageRole.System:return{role:0,content:x.content};case g.LanguageModelChatMessageRole.User:return{role:1,content:x.content};case g.LanguageModelChatMessageRole.Assistant:return{role:2,content:x.content}}}Oe.from=Ee})(Yt||(e.LanguageModelChatMessage=Yt={}));var qt;(function(Oe){function Fe(x){return{kind:"markdownContent",content:Y.from(x.value)}}Oe.from=Fe;function Ee(x){return new g.$iO(Y.to(x.content))}Oe.to=Ee})(qt||(e.ChatResponseMarkdownPart=qt={}));var wt;(function(Oe){function Fe(x){return{kind:"markdownVuln",content:Y.from(x.value),vulnerabilities:x.vulnerabilities}}Oe.from=Fe;function Ee(x){return new g.$jO(Y.to(x.content),x.vulnerabilities)}Oe.to=Ee})(wt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=wt={}));var Vt;(function(Oe){function Fe(x){return{kind:"agentDetection",agentId:x.participant,command:x.command}}Oe.from=Fe;function Ee(x){return new g.$kO(x.agentId,x.command)}Oe.to=Ee})(Vt||(e.ChatResponseDetectedParticipantPart=Vt={}));var Mt;(function(Oe){function Fe(Ee){return{kind:"confirmation",title:Ee.title,message:Ee.message,data:Ee.data}}Oe.from=Fe})(Mt||(e.ChatResponseConfirmationPart=Mt={}));var Ot;(function(Oe){function Fe(x){const{value:je,baseUri:He}=x;function Ze(Ke,ht){return Ke.map(St=>{const Ft=f.URI.joinPath(ht,St.name);return{label:St.name,uri:Ft,children:St.children&&Ze(St.children,Ft)}})}return{kind:"treeData",treeData:{label:(0,S.$9g)(He),uri:He,children:Ze(je,He)}}}Oe.from=Fe;function Ee(x){const je=(0,E.$8h)(x.treeData);function He(ht){return ht.map(St=>({name:St.label,children:St.children&&He(St.children)}))}const Ze=je.uri,Ke=je.children?He(je.children):[];return new g.$mO(Ke,Ze)}Oe.to=Ee})(Ot||(e.ChatResponseFilesPart=Ot={}));var tn;(function(Oe){function Fe(x){return{kind:"inlineReference",name:x.title,inlineReference:f.URI.isUri(x.value)?x.value:m.from(x.value)}}Oe.from=Fe;function Ee(x){const je=(0,E.$8h)(x);return new g.$nO(f.URI.isUri(je.inlineReference)?je.inlineReference:m.to(je.inlineReference),x.name)}Oe.to=Ee})(tn||(e.ChatResponseAnchorPart=tn={}));var Gt;(function(Oe){function Fe(x){return{kind:"progressMessage",content:Y.from(x.value)}}Oe.from=Fe;function Ee(x){return new g.$oO(x.content.value)}Oe.to=Ee})(Gt||(e.ChatResponseProgressPart=Gt={}));var an;(function(Oe){function Fe(x){return{kind:"warning",content:Y.from(x.value)}}Oe.from=Fe;function Ee(x){return new g.$qO(x.content.value)}Oe.to=Ee})(an||(e.ChatResponseWarningPart=an={}));var Nt;(function(Oe){function Fe(Ee){return{kind:"progressTask",content:Y.from(Ee.value)}}Oe.from=Fe})(Nt||(e.ChatTask=Nt={}));var Kt;(function(Oe){function Fe(Ee){return{kind:"progressTaskResult",content:typeof Ee=="string"?Y.from(Ee):void 0}}Oe.from=Fe})(Kt||(e.ChatTaskResult=Kt={}));var Lt;(function(Oe){function Fe(x,je,He){return{kind:"command",command:je.toInternal(x.value,He)??{command:x.value.command,title:x.value.title}}}Oe.from=Fe;function Ee(x,je){return new g.$rO(je.fromInternal(x.command)??{command:x.command.id,title:x.command.title})}Oe.to=Ee})(Lt||(e.ChatResponseCommandButtonPart=Lt={}));var It;(function(Oe){function Fe(x){return{kind:"textEdit",uri:x.uri,edits:x.edits.map(je=>oe.from(je))}}Oe.from=Fe;function Ee(x){return new g.$tO(f.URI.revive(x.uri),x.edits.map(je=>oe.to(je)))}Oe.to=Ee})(It||(e.ChatResponseTextEditPart=It={}));var pt;(function(Oe){function Fe(x){const je=v.ThemeIcon.isThemeIcon(x.iconPath)?x.iconPath:x.iconPath&&"light"in x.iconPath&&"dark"in x.iconPath&&f.URI.isUri(x.iconPath.light)&&f.URI.isUri(x.iconPath.dark)?{light:f.URI.revive(x.iconPath.light),dark:f.URI.revive(x.iconPath.dark)}:void 0;return"variableName"in x.value?{kind:"reference",reference:{variableName:x.value.variableName,value:f.URI.isUri(x.value.value)||!x.value.value?x.value.value:m.from(x.value.value)},iconPath:je}:{kind:"reference",reference:f.URI.isUri(x.value)?x.value:m.from(x.value),iconPath:je}}Oe.from=Fe;function Ee(x){const je=(0,E.$8h)(x),He=Ze=>f.URI.isUri(Ze)?Ze:m.to(Ze);return new g.$sO("variableName"in je.reference?{variableName:je.reference.variableName,value:je.reference.value&&He(je.reference.value)}:He(je.reference))}Oe.to=Ee})(pt||(e.ChatResponseReferencePart=pt={}));var kt;(function(Oe){function Fe(je,He,Ze){return je instanceof g.$iO?qt.from(je):je instanceof g.$nO?tn.from(je):je instanceof g.$sO?pt.from(je):je instanceof g.$oO?Gt.from(je):je instanceof g.$mO?Ot.from(je):je instanceof g.$rO?Lt.from(je,He,Ze):je instanceof g.$tO?It.from(je):je instanceof g.$jO?wt.from(je):je instanceof g.$kO?Vt.from(je):je instanceof g.$qO?an.from(je):{kind:"markdownContent",content:Y.from("")}}Oe.from=Fe;function Ee(je,He){switch(je.kind){case"reference":return pt.to(je);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return x(je,He)}}Oe.to=Ee;function x(je,He){switch(je.kind){case"markdownContent":return qt.to(je);case"inlineReference":return tn.to(je);case"progressMessage":return;case"treeData":return Ot.to(je);case"command":return Lt.to(je,He)}}Oe.toContent=x})(kt||(e.ChatResponsePart=kt={}));var cn;(function(Oe){function Fe(Ee){return{prompt:Ee.message,command:Ee.command,attempt:Ee.attempt??0,enableCommandDetection:Ee.enableCommandDetection??!0,variables:Ee.variables.variables.map(gn.to),location:Dt.to(Ee.location),acceptedConfirmationData:Ee.acceptedConfirmationData,rejectedConfirmationData:Ee.rejectedConfirmationData}}Oe.to=Fe})(cn||(e.ChatAgentRequest=cn={}));var Dt;(function(Oe){function Fe(Ee){switch(Ee){case t.ChatAgentLocation.Notebook:return g.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return g.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return g.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return g.ChatLocation.Editor}}Oe.to=Fe})(Dt||(e.ChatLocation=Dt={}));var gn;(function(Oe){function Fe(Ee){const x=Ee.value;if(!x)throw new Error("Invalid value reference");return{name:Ee.name,range:Ee.range&&[Ee.range.start,Ee.range.endExclusive],value:(0,f.$vc)(x)?f.URI.revive(x):x}}Oe.to=Fe})(gn||(e.ChatAgentValueReference=gn={}));var rn;(function(Oe){function Fe(Ee,x,je){return{label:Ee.label,value:Ee.values[0].value,insertText:Ee.insertText,detail:Ee.detail,documentation:Ee.documentation,command:x.toInternal(Ee.command,je)}}Oe.from=Fe})(rn||(e.ChatAgentCompletionItem=rn={}));var pn;(function(Oe){function Fe(Ee){return{errorDetails:Ee.errorDetails,metadata:Ee.metadata}}Oe.to=Fe})(pn||(e.ChatAgentResult=pn={}));var hn;(function(Oe){function Fe(Ee,x,je){if(x.action.kind==="vote")return;const He=pn.to(Ee);if(x.action.kind==="command"){const Ze=x.action.commandButton.command;return{action:{kind:"command",commandButton:{command:je.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:He}}else return x.action.kind==="followUp"?{action:{kind:"followUp",followup:ln.to(x.action.followup)},result:He}:x.action.kind==="inlineChat"?{action:{kind:"editor",accepted:x.action.action==="accepted"},result:He}:{action:x.action,result:He}}Oe.to=Fe})(hn||(e.ChatAgentUserActionEvent=hn={}));var vn;(function(Oe){function Fe(Ee,x,je){return"terminalCommand"in Ee?{terminalCommand:Ee.terminalCommand,shouldExecute:Ee.shouldExecute}:"uri"in Ee?{uri:Ee.uri}:x.toInternal(Ee,je)}Oe.from=Fe})(vn||(e.TerminalQuickFix=vn={}));var At;(function(Oe){function Fe(Ee){return{kind:En.to(Ee.kind)}}Oe.to=Fe})(At||(e.PartialAcceptInfo=At={}));var En;(function(Oe){function Fe(Ee){switch(Ee){case 0:return g.PartialAcceptTriggerKind.Word;case 1:return g.PartialAcceptTriggerKind.Line;case 2:return g.PartialAcceptTriggerKind.Suggest;default:return g.PartialAcceptTriggerKind.Unknown}}Oe.to=Fe})(En||(e.PartialAcceptTriggerKind=En={}));var sn;(function(Oe){function Fe(Ee,x){return{id:x,label:Ee.label,description:Ee.description,canEdit:Ee.canEdit,collapsibleState:Ee.collapsibleState||0,contextValue:Ee.contextValue}}Oe.from=Fe})(sn||(e.DebugTreeItem=sn={}))}),define(ke[334],De([1,0,6,20,17,48]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;let M=class{constructor($,E){this.a=$.getProxy(l.$jM.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>E.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,E,I){const P=new A.$Fw(L.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(P,void 0,I?.isRefactoring??!1)}};e.$cmc=M,e.$cmc=M=Je([We(0,O.$NO)],M)}),define(ke[335],De([1,0,19,7,47,4,39,3,40,18,2,25,6,17,8,297,26]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class a{constructor(r,t,u,s,o){this.j=r,this.k=t,this.l=u,this.m=s,this.n=o,this.b=$.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(s){if(r.c){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,s),o}};const r=this;this.b.reset();const u=(s,o)=>{typeof this.d>"u"&&"content"in s&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,s).then(h=>{h&&o?.({report:g=>{if(v.$NM.isMarkdownString(g.value)){this.l.$handleProgressChunk(this.k.requestId,S.ChatResponseWarningPart.from(g),h);return}else this.l.$handleProgressChunk(this.k.requestId,S.ChatResponseReferencePart.from(g),h)}}).then(g=>{typeof h=="number"&&this.l.$handleProgressChunk(this.k.requestId,S.ChatTaskResult.from(g),h)})})};this.g={markdown(s){t(this.markdown);const o=new v.$iO(s),h=S.ChatResponseMarkdownPart.from(o);return u(h),this},markdownWithVulnerabilities(s,o){t(this.markdown),o&&(0,f.$LG)(r.j,"chatParticipantAdditions");const h=new v.$jO(s,o),g=S.ChatResponseMarkdownWithVulnerabilitiesPart.from(h);return u(g),this},filetree(s,o){t(this.filetree);const h=new v.$mO(s,o),g=S.ChatResponseFilesPart.from(h);return u(g),this},anchor(s,o){t(this.anchor);const h=new v.$nO(s,o),g=S.ChatResponseAnchorPart.from(h);return u(g),this},button(s){t(this.anchor);const o=new v.$rO(s),h=S.ChatResponseCommandButtonPart.from(o,r.m,r.n);return u(h),this},progress(s,o){t(this.progress);const h=new v.$pO(s,o),g=o?S.ChatTask.from(h):S.ChatResponseProgressPart.from(h);return u(g,o),this},warning(s){t(this.progress),(0,f.$LG)(r.j,"chatParticipantAdditions");const o=new v.$qO(s),h=S.ChatResponseWarningPart.from(o);return u(h),this},reference(s,o){if(t(this.reference),"variableName"in s&&!s.value){const h=r.k.variables.variables.find(g=>g.name===s.variableName);if(h){let g;if(h.references?.length)g=h.references.map(w=>({kind:"reference",reference:{variableName:s.variableName,value:w.reference}}));else{const w=new v.$sO(s,o);g=[S.ChatResponseReferencePart.from(w)]}return g.forEach(w=>u(w)),this}}else{const h=new v.$sO(s,o),g=S.ChatResponseReferencePart.from(h);u(g)}return this},textEdit(s,o){t(this.textEdit),(0,f.$LG)(r.j,"chatParticipantAdditions");const h=new v.$tO(s,o),g=S.ChatResponseTextEditPart.from(h);return u(g),this},detectedParticipant(s,o){t(this.detectedParticipant),(0,f.$LG)(r.j,"chatParticipantAdditions");const h=new v.$kO(s,o),g=S.ChatResponseDetectedParticipantPart.from(h);return u(g),this},confirmation(s,o,h){t(this.confirmation),(0,f.$LG)(r.j,"chatParticipantAdditions");const g=new v.$lO(s,o,h),w=S.ChatResponseConfirmationPart.from(g);return u(w),this},push(s){if(t(this.push),(s instanceof v.$tO||s instanceof v.$jO||s instanceof v.$kO||s instanceof v.$qO||s instanceof v.$lO)&&(0,f.$LG)(r.j,"chatParticipantAdditions"),s instanceof v.$sO)this.reference(s.value,s.iconPath);else{const o=S.ChatResponsePart.from(s,r.m,r.n);u(o)}return this}}}return this.g}}class n extends b.$Uc{static{this.b=0}constructor(r,t,u){super(),this.n=t,this.s=u,this.c=new Map,this.j=this.B(new b.$4c),this.m=this.B(new b.$4c),this.g=r.getProxy(p.$jM.MainThreadChatAgents2)}transferActiveChat(r){this.g.$transferActiveChatSession(r)}createChatAgent(r,t,u){const s=n.b++,o=new i(r,t,this.g,s,u);return this.c.set(s,o),this.g.$registerAgent(s,r.identifier,t,{},void 0),o.apiAgent}createDynamicChatAgent(r,t,u,s){const o=n.b++,h=new i(r,t,this.g,o,s);return this.c.set(o,h),this.g.$registerAgent(o,r.identifier,t,{isSticky:!0},u),h.apiAgent}async $invokeAgent(r,t,u,s){const o=this.c.get(r);if(!o)throw new Error(`[CHAT](${r}) CANNOT invoke agent because the agent is not registered`);let h=this.j.get(t.sessionId);h||(h=new b.$Tc,this.j.set(t.sessionId,h));const g=new a(o.extension,t,this.g,this.s.converter,h);try{const w=await this.t(t.agentId,u),k=o.invoke(S.ChatAgentRequest.to(t),{history:w},g.apiObject,s);return await(0,O.$mh)(Promise.resolve(k).then(m=>{if(m?.metadata)try{JSON.stringify(m.metadata)}catch(y){const D=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.n.error(`[${o.extension.identifier.value}] [@${o.id}] ${D}`,o.extension),{errorDetails:{message:D},timings:g.timings}}return{errorDetails:m?.errorDetails,timings:g.timings,metadata:m?.metadata}}),s)}catch(w){return this.n.error(w,o.extension),{errorDetails:{message:(0,L.$jj)(w),responseIsIncomplete:!0}}}finally{g.close()}}async t(r,t){const u=[];for(const s of t.history){const o=S.ChatAgentResult.to(s.result),h=r===s.request.agentId?o:{...o,metadata:void 0};u.push(new v.$uO(s.request.message,s.request.command,s.request.variables.variables.map(S.ChatAgentValueReference.to),s.request.agentId));const g=(0,l.$Hb)(s.response.map(w=>S.ChatResponsePart.toContent(w,this.s.converter)));u.push(new v.$vO(g,h,s.request.agentId,s.request.command))}return u}$releaseSession(r){this.j.deleteAndDispose(r)}async $provideFollowups(r,t,u,s,o){const h=this.c.get(t);if(!h)return Promise.resolve([]);const g=await this.t(h.id,s),w=S.ChatAgentResult.to(u);return(await h.provideFollowups(w,{history:g},o)).filter(k=>{const m=!k.participant||M.Iterable.some(this.c.values(),y=>y.id===k.participant&&P.$Tm.equals(y.extension.identifier,h.extension.identifier));return m||this.n.warn(`[@${h.id}] ChatFollowup refers to an unknown participant: ${k.participant}`),m}).map(k=>S.ChatFollowup.from(k,r))}$acceptFeedback(r,t,u,s){const o=this.c.get(r);if(!o)return;const h=S.ChatAgentResult.to(t);let g;switch(u){case d.ChatAgentVoteDirection.Down:g=v.ChatResultFeedbackKind.Unhelpful;break;case d.ChatAgentVoteDirection.Up:g=v.ChatResultFeedbackKind.Helpful;break}o.acceptFeedback(Object.freeze(s?{result:h,kind:g,reportIssue:s}:{result:h,kind:g}))}$acceptAction(r,t,u){const s=this.c.get(r);if(!s||u.action.kind==="vote")return;const o=S.ChatAgentUserActionEvent.to(t,u,this.s.converter);o&&s.acceptAction(Object.freeze(o))}async $invokeCompletionProvider(r,t,u){const s=this.c.get(r);if(!s)return[];let o=this.m.get(r);return o?o.clear():(o=new b.$Tc,this.m.set(r,o)),(await s.invokeCompletionProvider(t,u)).map(g=>S.ChatAgentCompletionItem.from(g,this.s.converter,o))}async $provideWelcomeMessage(r,t,u){const s=this.c.get(r);if(s)return await s.provideWelcomeMessage(S.ChatLocation.to(t),u)}async $provideSampleQuestions(r,t,u){const s=this.c.get(r);if(s)return(await s.provideSampleQuestions(S.ChatLocation.to(t),u)).map(o=>S.ChatFollowup.from(o,void 0))}}e.$dmc=n;class i{constructor(r,t,u,s,o){this.extension=r,this.id=t,this.u=u,this.w=s,this.x=o,this.m=new A.$fe,this.n=new A.$fe}acceptFeedback(r){this.m.fire(r)}acceptAction(r){this.n.fire(r)}async invokeCompletionProvider(r,t){return this.q?await this.q.provider.provideCompletionItems(r,t)??[]:[]}async provideFollowups(r,t,u){if(!this.b)return[];const s=await this.b.provideFollowups(r,t,u);return s?s.filter(o=>!(o&&"commandId"in o)).filter(o=>!(o&&"message"in o)):[]}async provideWelcomeMessage(r,t){if(!this.s)return[];const u=await this.s.provideWelcomeMessage(r,t);return u?u.map(s=>typeof s=="string"?s:S.MarkdownString.from(s)):[]}async provideSampleQuestions(r,t){if(!this.s||!this.s.provideSampleQuestions)return[];const u=await this.s.provideSampleQuestions(r,t);return u||[]}get apiAgent(){let r=!1,t=!1;const u=()=>{r||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{icon:this.c?this.c instanceof I.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof v.$iN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:S.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:S.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:S.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t}),t=!1}))},s=this;return{get id(){return s.id},get iconPath(){return s.c},set iconPath(o){s.c=o,u()},get requestHandler(){return s.x},set requestHandler(o){(0,E.$ig)(typeof o=="function","Invalid request handler"),s.x=o},get followupProvider(){return s.b},set followupProvider(o){s.b=o,u()},get isDefault(){return(0,f.$LG)(s.extension,"defaultChatParticipant"),s.d},set isDefault(o){(0,f.$LG)(s.extension,"defaultChatParticipant"),s.d=o,u()},get helpTextPrefix(){return(0,f.$LG)(s.extension,"defaultChatParticipant"),s.g},set helpTextPrefix(o){(0,f.$LG)(s.extension,"defaultChatParticipant"),s.g=o,u()},get helpTextVariablesPrefix(){return(0,f.$LG)(s.extension,"defaultChatParticipant"),s.j},set helpTextVariablesPrefix(o){(0,f.$LG)(s.extension,"defaultChatParticipant"),s.j=o,u()},get helpTextPostfix(){return(0,f.$LG)(s.extension,"defaultChatParticipant"),s.k},set helpTextPostfix(o){(0,f.$LG)(s.extension,"defaultChatParticipant"),s.k=o,u()},get isSecondary(){return(0,f.$LG)(s.extension,"defaultChatParticipant"),s.l},set isSecondary(o){(0,f.$LG)(s.extension,"defaultChatParticipant"),s.l=o,u()},get supportIssueReporting(){return(0,f.$LG)(s.extension,"chatParticipantAdditions"),s.o},set supportIssueReporting(o){(0,f.$LG)(s.extension,"chatParticipantAdditions"),s.o=o,u()},get onDidReceiveFeedback(){return s.m.event},set participantVariableProvider(o){if((0,f.$LG)(s.extension,"chatParticipantAdditions"),s.q=o,o){if(!o.triggerCharacters.length)throw new Error("triggerCharacters are required");s.u.$registerAgentCompletionsProvider(s.w,o.triggerCharacters)}else s.u.$unregisterAgentCompletionsProvider(s.w)},get participantVariableProvider(){return(0,f.$LG)(s.extension,"chatParticipantAdditions"),s.q},set welcomeMessageProvider(o){(0,f.$LG)(s.extension,"defaultChatParticipant"),s.s=o,u()},get welcomeMessageProvider(){return(0,f.$LG)(s.extension,"defaultChatParticipant"),s.s},onDidPerformAction:(0,f.$KG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(o){s.t=o,u()},get requester(){return s.t},dispose(){r=!0,s.b=void 0,s.m.dispose(),s.u.$unregisterAgent(s.w)}}}invoke(r,t,u,s){return this.x(r,t,u,s)}}}),define(ke[336],De([1,0,13,3,6,17,8,26]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;class ${static{this.a=0}constructor(P){this.b=new Map,this.c=P.getProxy(L.$jM.MainThreadChatVariables)}async $resolveVariable(P,p,S,v){const d=this.b.get(P);if(d)try{if(d.resolver.resolve2){(0,b.$LG)(d.extension,"chatParticipantAdditions");const f=new E(p,this.c),a=await d.resolver.resolve2(d.data.name,{prompt:S},f.apiObject,v);if(a&&a[0])return a[0].value}else{const f=await d.resolver.resolve(d.data.name,{prompt:S},v);if(f&&f[0])return f[0].value}}catch(f){(0,l.$2)(f)}}registerVariableResolver(P,p,S,v){const d=$.a++;return this.b.set(d,{extension:P,data:{name:p,description:S},resolver:v}),this.c.$registerVariable(d,{name:p,description:S}),(0,O.$Sc)(()=>{this.b.delete(d),this.c.$unregisterVariable(d)})}}e.$emc=$;class E{constructor(P,p){this.c=P,this.d=p,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let p=function(v){if(P.a){const d=new Error("Response stream has been closed");throw Error.captureStackTrace(d,v),d}};const P=this,S=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){p(this.progress);const d=new M.$oO(v),f=A.ChatResponseProgressPart.from(d);return S(f),this},reference(v){p(this.reference);const d=new M.$sO(v),f=A.ChatResponseReferencePart.from(d);return S(f),this},push(v){return p(this.push),v instanceof M.$sO?S(A.ChatResponseReferencePart.from(v)):v instanceof M.$oO&&S(A.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(ke[337],De([1,0,7,56,4,3,2,84,25,17,8,6,26]),function(he,e,l,O,L,A,M,b,$,E,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=S;function S(v,d,f){const a=v.getProxy(P.$jM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Vm,d.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===6){const k=this.b.get(w.handle);return k?k.value:w}else if(w&&w.$mid===7){const k=w,m=this.b.get(k.commentControlHandle);if(!m)return k;const y=m.getCommentThread(k.commentThreadHandle);return y?y.value:k}else if(w&&(w.$mid===9||w.$mid===8)){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const m=k.getCommentThread(w.thread.commentThreadHandle);return m?w.$mid===8?m.value:{thread:m.value,text:w.text}:w}else if(w&&w.$mid===10){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const m=k.getCommentThread(w.thread.commentThreadHandle);if(!m)return w;const y=w.commentUniqueId,D=m.getCommentByUniqueId(y);return D||w}else if(w&&w.$mid===11){const k=this.b.get(w.thread.commentControlHandle);if(!k)return w;const m=k.getCommentThread(w.thread.commentThreadHandle);if(!m)return w;const y=w.text,D=w.commentUniqueId,C=m.getCommentByUniqueId(D);return C?(typeof C.body=="string"?C.body=y:C.body=new I.$NM(y),C):w}return w}})}createCommentController(w,k,m){const y=n.a++,D=new c(w,y,k,m);this.b.set(D.handle,D);const C=this.c.get(w.identifier)||[];return C.push(D),this.c.set(w.identifier,C),D.value}async $createCommentThreadTemplate(w,k,m,y){const D=this.b.get(w);D&&D.$createCommentThreadTemplate(k,m,y)}async $setActiveComment(w,k){const m=this.b.get(w);m&&m.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(w,k,m){const y=this.b.get(w);y&&y.$updateCommentThreadTemplate(k,m)}$deleteCommentThread(w,k){this.b.get(w)?.$deleteCommentThread(k)}async $provideCommentingRanges(w,k,m){const y=this.b.get(w);if(!y||!y.commentingRangeProvider)return Promise.resolve(void 0);const D=await f.ensureDocumentData(M.URI.revive(k));return(0,l.$qh)(async()=>{const C=await y.commentingRangeProvider.provideCommentingRanges(D.document,m);let R;return Array.isArray(C)?R={ranges:C,fileComments:!1}:C?R={ranges:C.ranges||[],fileComments:C.fileComments||!1}:R=C??void 0,R}).then(C=>{let R;return C&&(R={ranges:C.ranges.map(T=>E.Range.from(T)),fileComments:C.fileComments}),R})}$toggleReaction(w,k,m,y,D){const C=this.b.get(w);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,l.$qh)(()=>{const R=C.getCommentThread(k);if(R){const T=R.getCommentByUniqueId(y.uniqueIdInThread);if(C!==void 0&&T&&C.reactionHandler)return C.reactionHandler(T,u(D))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(w){this.n=w}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(w){(w===void 0!=(this.p===void 0)||!w||!this.p||!w.isEqual(this.p))&&(this.p=w,this.b.range=w,this.c.fire())}get range(){return this.p}set canReply(w){this.d!==w&&(this.d=w,this.b.canReply=w,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(w){this.e=w,this.b.label=w,this.c.fire()}get contextValue(){return this.f}set contextValue(w){this.f=w,this.b.contextValue=w,this.c.fire()}get comments(){return this.q}set comments(w){this.q=w,this.b.comments=w,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(w){this.g=w,this.b.collapsibleState=w,this.c.fire()}get state(){return this.h}set state(w){this.h=w,typeof w=="object"?((0,p.$LG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=w.resolved,this.b.applicability=w.applicability):this.b.state=w,this.c.fire()}get isDisposed(){return this.j}constructor(w,k,m,y,D,C,R,T,j){this.m=k,this.n=m,this.o=y,this.p=D,this.q=C,this.extensionDescription=R,this.r=T,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$fe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Vc,this.l.value=new A.$Tc,this.n===void 0&&(this.n=`${w}.${this.handle}`),a.$createCommentThread(k,this.handle,this.n,this.o,E.Range.from(this.p),R.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{a.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(N){z.range=N},get comments(){return z.comments},set comments(N){z.comments=N},get collapsibleState(){return z.collapsibleState},set collapsibleState(N){z.collapsibleState=N},get canReply(){return z.canReply},set canReply(N){z.canReply=N},get contextValue(){return z.contextValue},set contextValue(N){z.contextValue=N},get label(){return z.label},set label(N){z.label=N},get state(){return z.state},set state(N){z.state=N},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Tc);const w=m=>Object.prototype.hasOwnProperty.call(this.b,m),k={};w("range")&&(k.range=E.Range.from(this.p)),w("label")&&(k.label=this.label),w("contextValue")&&(k.contextValue=this.contextValue??null),w("comments")&&(k.comments=this.q.map(m=>r(this,m,this.k,this.extensionDescription))),w("collapsibleState")&&(k.collapseState=s(this.g)),w("canReply")&&(k.canReply=this.canReply),w("state")&&(k.state=o(this.h)),w("applicability")&&(k.applicability=h(this.h)),w("isTemplate")&&(k.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(w){for(const k of this.k){const m=k[0],y=k[1];if(w===y)return m}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(w=>w.dispose())}}Je([(0,O.$4h)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(w){this.b=w,w?.resourceHints&&(0,p.$LG)(this.h,"commentingRangeHint"),a.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(w){this.c=w,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this.d}set options(w){this.d=w,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,p.$LG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,p.$LG)(this.h,"activeComment"),this.f}constructor(w,k,m,y){this.h=w,this.i=k,this.j=m,this.k=y,this.a=new Map,a.$registerCommentController(this.handle,m,y,this.h.identifier.value);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(C){D.options=C},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(C){D.commentingRangeProvider=C},get reactionHandler(){return D.reactionHandler},set reactionHandler(C){D.reactionHandler=C},get activeCommentThread(){return D.activeCommentThread},createCommentThread(C,R,T){return D.createCommentThread(C,R,T).value},dispose:()=>{D.dispose()}}),this.g=[],this.g.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(w,k,m){k===void 0&&(0,p.$LG)(this.h,"fileComments");const y=new i(this.id,this.handle,void 0,w,k,m,this.h,!1);return this.a.set(y.handle,y),y}$setActiveComment(w){if(!w){this.e=void 0,this.f=void 0;return}const k=this.a.get(w.commentThreadHandle);k&&(this.e=w.uniqueIdInThread?k.getCommentByUniqueId(w.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(w,k,m){const y=new i(this.id,this.handle,void 0,M.URI.revive(w),E.Range.to(k),[],this.h,!0,m);return y.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(y.handle,y),y}$updateCommentThreadTemplate(w,k){const m=this.a.get(w);m&&(m.range=E.Range.to(k))}$deleteCommentThread(w){this.a.get(w)?.dispose(),this.a.delete(w)}getCommentThread(w){return this.a.get(w)}dispose(){this.a.forEach(w=>{w.dispose()}),this.g.forEach(w=>w.dispose())}}function r(g,w,k,m){let y=k.get(w);return y||(y=++g.commentHandle,k.set(w,y)),w.state!==void 0&&(0,p.$LG)(m,"commentsDraftState"),w.reactions?.some(D=>D.reactors!==void 0)&&(0,p.$LG)(m,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:y,body:typeof w.body=="string"?w.body:E.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(D=>t(D)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function t(g){return{label:g.label,iconPath:g.iconPath?E.$MO(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted,reactors:g.reactors&&g.reactors.length>0&&typeof g.reactors[0]!="string"?g.reactors.map(w=>w.name):g.reactors}}function u(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?M.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1,reactors:g.reactors?.map(w=>({name:w}))}}function s(g){if(g!==void 0)switch(g){case I.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case I.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function o(g){let w;if(typeof g=="object"?w=g.resolved:w=g,w!==void 0)switch(w){case I.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case I.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function h(g){let w;if(typeof g=="object"&&(w=g.applicability),w!==void 0)switch(w){case I.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case I.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(ke[338],De([1,0,21,57,3,15,23,2,17,92,112,6,8]),function(he,e,l,O,L,A,M,b,$,E,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=void 0;class S{constructor(u,s){this.document=u,this.b=s,this.a=1,this.c=new I.$1lc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,s){await this.f(u).undo(),s||this.disposeBackup()}async redo(u,s){await this.f(u).redo(),s||this.disposeBackup()}disposeEdits(u){for(const s of u)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=r(this.document.uri)+this.a++;return(0,M.$_g)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const s=this.c.get(u,0);if(!s)throw new Error("No edit found");return s}}class v{constructor(){this.a=new Map}get(u,s){return this.a.get(this.b(u,s))}add(u,s,o){const h=this.b(u,s.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${u} resource:${s.uri}`);const g=new S(s,o);return this.a.set(h,g),g}delete(u,s){const o=this.b(u,s.uri);this.a.delete(o)}b(u,s){return`${u}@@@${s}`}}var d;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(d||(d={}));class f{constructor(){this.a=new Map}addTextProvider(u,s,o){return this.b(u,{type:0,extension:s,provider:o})}addCustomProvider(u,s,o){return this.b(u,{type:1,extension:s,provider:o})}get(u){return this.a.get(u)}b(u,s){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,s),new p.$lM(()=>this.a.delete(u))}}class a{constructor(u,s,o,h,g){this.d=s,this.f=o,this.g=h,this.h=g,this.b=new f,this.c=new v,this.a=u.getProxy(P.$jM.MainThreadCustomEditors)}registerCustomEditorProvider(u,s,o,h){const g=new L.$Tc;return i(o)?(g.add(this.b.addTextProvider(s,u,o)),this.a.$registerTextEditorProvider((0,E.$xmc)(u),s,h.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,E.$vmc)(u))):(g.add(this.b.addCustomProvider(s,u,o)),n(o)&&g.add(o.onDidChangeCustomDocument(w=>{const k=this.i(s,w.document.uri);if(c(w)){const m=k.addEdit(w);this.a.$onDidEdit(w.document.uri,s,m,w.label)}else this.a.$onContentChange(w.document.uri,s)})),this.a.$registerCustomEditorProvider((0,E.$xmc)(u),s,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,E.$vmc)(u))),p.$lM.from(g,new p.$lM(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(u,s,o,h,g){const w=this.b.get(s);if(!w)throw new Error(`No provider found for '${s}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${s}'`);const k=b.URI.revive(u),m=await w.provider.openCustomDocument(k,{backupId:o,untitledDocumentData:h?.buffer},g);let y;return n(w.provider)&&this.f&&(y=this.f.workspaceValue(w.extension)??this.f.globalValue(w.extension)),this.c.add(s,m,y),{editable:n(w.provider)}}async $disposeCustomDocument(u,s){const o=this.b.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const h=b.URI.revive(u),{document:g}=this.i(s,h);this.c.delete(s,g),g.dispose()}async $resolveCustomEditor(u,s,o,h,g,w){const k=this.b.get(o);if(!k)throw new Error(`No provider found for '${o}'`);const m=$.ViewColumn.to(g),y=this.g.createNewWebview(s,h.contentOptions,k.extension),D=this.h.createNewWebviewPanel(s,o,h.title,m,h.options,y,h.active),C=b.URI.revive(u);switch(k.type){case 1:{const{document:R}=this.i(o,C);return k.provider.resolveCustomEditor(R,D,w)}case 0:{const R=this.d.getDocument(C);return k.provider.resolveCustomTextEditor(R,D,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,s,o){this.i(s,u).disposeEdits(o)}async $onMoveCustomEditor(u,s,o){const h=this.b.get(o);if(!h)throw new Error(`No provider found for '${o}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const g=this.h.getWebviewPanel(u);if(!g)throw new Error("No webview found");const w=b.URI.revive(s),k=this.d.getDocument(w);await h.provider.moveCustomTextEditor(k,g,l.CancellationToken.None)}async $undo(u,s,o,h){return this.i(s,u).undo(o,h)}async $redo(u,s,o,h){return this.i(s,u).redo(o,h)}async $revert(u,s,o){const h=this.i(s,u);await this.j(s).revertCustomDocument(h.document,o),h.disposeBackup()}async $onSave(u,s,o){const h=this.i(s,u);await this.j(s).saveCustomDocument(h.document,o),h.disposeBackup()}async $onSaveAs(u,s,o,h){const g=this.i(s,u);return this.j(s).saveCustomDocumentAs(g.document,b.URI.revive(o),h)}async $backup(u,s,o){const h=this.i(s,u),w=await this.j(s).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},o);return h.updateBackup(w),w.id}i(u,s){const o=this.c.get(u,b.URI.revive(s));if(!o)throw new Error("No custom document found");return o}j(u){const o=this.b.get(u)?.provider;if(!o||!n(o))throw new Error("Custom document is not editable");return o}}e.$Amc=a;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function r(t){const u=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,O.$mj)(u)+""}}),define(ke[339],De([1,0,224,139,2,6,8,17,4,11,27,60]),function(he,e,l,O,L,A,M,b,$,E,I,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=e.$8lc=void 0;class S{#e;#t;#n;constructor(f,a,n,i,c,r,t,u){this.d=f,this.e=a,this.f=n,this.g=i,this.h=c,this.c=!1,this.f=Math.max(i,n),this.#n=new I.$Ac(s=>r.getComparisonKey(s)),this.#e=t,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#n.keys()]),this.#e?.$clear(this.e),this.#n.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,a){if(!f){this.clear();return}this.j();let n=[];if(L.URI.isUri(f)){if(!a){this.delete(f);return}this.#n.set(f,a.slice()),n=[f]}else if(Array.isArray(f)){n=[];let r;f=[...f].sort(S.k);for(const t of f){const[u,s]=t;if((!r||u.toString()!==r.toString())&&(r&&this.#n.get(r).length===0&&this.#n.delete(r),r=u,n.push(u),this.#n.set(u,[])),s)this.#n.get(u)?.push(...s);else{const o=this.#n.get(u);o&&(o.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let c=0;for(const r of n){let t=[];const u=this.#n.get(r);if(u)if(u.length>this.g){t=[];const s=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const h of u)if(h.severity===s[o]&&t.push({...b.Diagnostic.from(h),modelVersionId:this.h(r)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,l.localize)(0,null,u.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=u.map(s=>({...b.Diagnostic.from(s),modelVersionId:this.h(r)}));if(i.push([r,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,i)}delete(f){this.j(),this.#t.fire([f]),this.#n.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#n.keys()]),this.#n.clear(),this.#e?.$clear(this.e)}forEach(f,a){this.j();for(const[n,i]of this)f.call(a,n,i,this)}*[Symbol.iterator](){this.j();for(const f of this.#n.keys())yield[f,this.get(f)]}get(f){this.j();const a=this.#n.get(f);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#n.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,a){return f[0].toString()<a[0].toString()?-1:f[0].toString()>a[0].toString()?1:0}}e.$8lc=S;let v=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(f){const a=new I.$Ac;for(const n of f)a.set(n,n);return{uris:Object.freeze(Array.from(a.values()))}}constructor(f,a,n,i){this.j=a,this.k=n,this.l=i,this.g=new Map,this.h=new $.$je({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,p._mapper),this.f=f.getProxy(A.$jM.MainThreadDiagnostics)}createDiagnosticCollection(f,a){const{g:n,f:i,h:c,j:r,k:t,l:u}=this,s=new class{$changeMany(g,w){i.$changeMany(g,w),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,g,w.length===0?"CLEARING":w)}$clear(g){i.$clear(g),r.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,g)}dispose(){i.dispose()}};let o;if(!a)a="_generated_diagnostic_collection_name_#"+p.c++,o=a;else if(!n.has(a))o=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do o=a+p.c++;while(n.has(o))}return new class extends S{constructor(){super(a,o,p.e,p.d,g=>u.getDocument(g)?.version,t.extUri,s,c),n.set(o,this)}dispose(){super.dispose(),n.delete(o)}}}getDiagnostics(f){if(f)return this.m(f);{const a=new Map,n=[];for(const i of this.g.values())i.forEach((c,r)=>{let t=a.get(c.toString());typeof t>"u"&&(t=n.length,a.set(c.toString(),t),n.push([c,[]])),n[t][1]=n[t][1].concat(...r)});return n}}m(f){let a=[];for(const n of this.g.values())n.has(f)&&(a=a.concat(n.get(f)));return a}$acceptMarkersChange(f){if(!this.n){const a="_generated_mirror",n=new S(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(a,n),this.n=n}for(const[a,n]of f)this.n.set(L.URI.revive(a),n.map(b.Diagnostic.to))}};e.$9lc=v,e.$9lc=v=p=Je([We(1,E.$5j),We(2,P.$7lc)],v)}),define(ke[340],De([1,0,2,13,8,17,76,48]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=void 0;class ${constructor(I,P,p,S={timeout:1500,errors:3}){this.c=I,this.d=P,this.f=p,this.g=S,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(P,p,S)=>{const d={dispose:this.a.push([P,p,I])};return Array.isArray(S)&&S.push(d),d}}async $participateInSave(I,P){const p=l.URI.revive(I);let S=!1;const v=setTimeout(()=>S=!0,this.g.timeout),d=[];try{for(const f of[...this.a]){if(S)break;const a=this.d.getDocument(p),n=await this.h(f,{document:a,reason:A.TextDocumentSaveReason.to(P)});d.push(n)}}finally{clearTimeout(v)}return d}h([I,P,p],S){const v=this.b.get(I);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(p,I,P,S).then(()=>!0,d=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' threw ERROR`),this.c.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const f=this.b.get(I);this.b.set(I,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,P,p,S){const v=[],d=Date.now(),{document:f,reason:a}=S,{version:n}=f,i=Object.freeze({document:f,reason:a,waitUntil(c){if(Object.isFrozen(v))throw(0,O.$8)("waitUntil can not be called async");v.push(Promise.resolve(c))}});try{P.apply(p,[i])}catch(c){return Promise.reject(c)}return Object.freeze(v),new Promise((c,r)=>{const t=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(v).then(u=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(t),c(u)}).catch(u=>{clearTimeout(t),r(u)})}).then(c=>{const r={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(u=>u instanceof L.$sM))for(const{newText:u,newEol:s,range:o}of t)r.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:o&&A.Range.from(o),text:u,eol:s&&A.EndOfLine.from(s)}});if(r.edits.length!==0)return n===f.version?this.f.$tryApplyWorkspaceEdit(new b.$Fw(r)):Promise.reject(new Error("concurrent_edits"))})}}e.$enc=$}),define(ke[341],De([1,0,4,3,2,6,153,17,18,24,8]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;class P{constructor(S,v){this.a=new l.$fe,this.b=new l.$fe,this.c=new l.$fe,this.d=new l.$fe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=S.getProxy(A.$jM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(d=>{for(const f of d)this.b.fire(f.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const f of d)this.a.fire(f.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const v=this.g.getDocument(S);if(v)return v}getDocument(S){const v=this.getDocumentData(S);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return v.document}ensureDocumentData(S){const v=this.g.getDocument(S);if(v)return Promise.resolve(v);let d=this.h.get(S.toString());return d||(d=this.f.$tryOpenDocument(S).then(f=>{this.h.delete(S.toString());const a=L.URI.revive(f);return(0,$.$jg)(this.g.getDocument(a))},f=>(this.h.delete(S.toString()),Promise.reject(f))),this.h.set(S.toString(),d)),d}createDocumentData(S){return this.f.$tryCreateDocument(S).then(v=>L.URI.revive(v))}$acceptModelLanguageChanged(S,v){const d=L.URI.revive(S),f=this.g.getDocument(d);if(!f)throw new Error("unknown document");this.b.fire(f.document),f._acceptLanguageId(v),this.a.fire(f.document)}$acceptModelSaved(S){const v=L.URI.revive(S),d=this.g.getDocument(v);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(S,v){const d=L.URI.revive(S),f=this.g.getDocument(d);if(!f)throw new Error("unknown document");f._acceptIsDirty(v),this.c.fire({document:f.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,v,d){const f=L.URI.revive(S),a=this.g.getDocument(f);if(!a)throw new Error("unknown document");a._acceptIsDirty(d),a.onEvents(v);let n;v.isUndoing?n=I.TextDocumentChangeReason.Undo:v.isRedoing&&(n=I.TextDocumentChangeReason.Redo),this.c.fire((0,E.$6n)({document:a.document,contentChanges:v.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(S,v){(0,M.$PO)(S,v)}}e.$0lc=P}),define(ke[72],De([1,0,74,4,18,2,5,6,20,17,8]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=e.$Bmc=void 0,e.$Bmc=(0,M.$yi)("IExtHostEditorTabs");class P{constructor(f,a,n){this.e=n,this.d=a,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,a={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new I.$9N(A.URI.revive(this.b.input.uri));case 2:return new I.$0N(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new I.$$N(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new I.$_N(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new I.$aO(this.b.input.viewType);case 4:return new I.$bO(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new I.$cO(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new I.$dO;case 9:return new I.$eO(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new I.$fO;case 11:return new I.$gO(this.b.input.diffEditors.map(f=>new I.$0N(A.URI.revive(f.original),A.URI.revive(f.modified))));default:return}}}class p{constructor(f,a){this.c=[],this.d="",this.b=f,this.e=a;for(const n of f.tabs)n.isActive&&(this.d=n.id),this.c.push(new P(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,a={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return E.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(n=>n.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(n=>n.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const n=new P(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,n),f.tabDto.isActive&&(this.d=n.tabId),n}else if(f.kind===1){const n=this.c.splice(f.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(f.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,n),n}const a=this.c.find(n=>n.tabId===f.tabDto.id);if(!a)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(f.tabDto),a}activeTabId(){return this.d}}let S=class{constructor(f){this.b=new O.$fe,this.c=new O.$fe,this.e=[],this.a=f.getProxy(b.$jM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,a={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(n=>n.apiObject))},get activeTabGroup(){const n=f.d;return(0,L.$jg)(f.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,i)=>{const c=Array.isArray(n)?n:[n];return c.length?v(c[0])?this.j(c,i):this.i(c,i):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(f){const a=new Set(this.e.map(s=>s.groupId)),n=new Set(f.map(s=>s.groupId)),i=(0,l.$L)(a,n),c=this.e.filter(s=>i.removed.includes(s.groupId)).map(s=>s.apiObject),r=[],t=[];this.e=f.map(s=>{const o=new p(s,()=>this.d);return i.added.includes(o.groupId)?r.push(o.apiObject):t.push(o.apiObject),o});const u=(0,L.$jg)(f.find(s=>s.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:r,closed:c,changed:t}))}$acceptTabGroupUpdate(f){const a=this.e.find(n=>n.groupId===f.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const a=this.e.find(i=>i.groupId===f.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const n=a.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(f){for(const a of this.e)for(const n of a.tabs)if(n.apiObject===f)return n}h(f){return this.e.find(a=>a.apiObject===f)}async i(f,a){const n=[];for(const i of f){const c=this.g(i);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,a)}async j(f,a){const n=[];for(const i of f){const c=this.h(i);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,a)}};e.$Cmc=S,e.$Cmc=S=Je([We(0,$.$NO)],S);function v(d){return d.tabs!==void 0}}),define(ke[342],De([1,0,2,6,3,8,17,185,14,22,26,81]),function(he,e,l,O,L,A,M,b,$,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;class p{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const f=this.a.indexOf(d);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),f=[];let a,n,i=14,c=14;for(const r of d){let t=a?(0,$.$Bf)(a,r):0;for(t===0?n=1:n=c;t<r.length;t++)t+1===r.length?(i=c,c=9):c+=1,f.push([n,r.toUpperCase().charCodeAt(t),c]),f.push([n,r.toLowerCase().charCodeAt(t),c]),n=c;a=r,c=i}f.push([9,58,10]),f.push([10,47,12]),this.b=new b.$K2(f)}}provideDocumentLinks(d){this.c();const f=[],a=b.$L2.computeLinks({getLineContent(n){return d.lineAt(n-1).text},getLineCount(){return d.lineCount}},this.b);for(const n of a){const i=M.DocumentLink.to(n);i.target&&f.push(i)}return f}}class S{constructor(d,f){this.i=f,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(O.$jM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,f,a,n={}){if(S.j(a),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const i=this.h++;this.b.add(f),this.d.add(f),this.c.set(i,a);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof a.copy=="function"&&(c+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&((0,I.$LG)(d,"fsChunks"),c+=4);let r;n.isReadonly&&(0,P.$Xk)(n.isReadonly)&&n.isReadonly.value!==""&&(r={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,f,c,r).catch(u=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${f}`),console.error(u)});const t=a.onDidChangeFile(u=>{const s=[];for(const o of u){const{uri:h,type:g}=o;if(h.scheme!==f)continue;let w;switch(g){case A.FileChangeType.Changed:w=0;break;case A.FileChangeType.Created:w=1;break;case A.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:h,type:w})}this.a.$onFileSystemChange(i,s)});return(0,L.$Sc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:f,ctime:a,mtime:n,size:i,permissions:c}=d;return{type:f,ctime:a,mtime:n,size:i,permissions:c}}$stat(d,f){return Promise.resolve(this.l(d).stat(l.URI.revive(f))).then(a=>S.k(a))}$readdir(d,f){return Promise.resolve(this.l(d).readDirectory(l.URI.revive(f)))}$readFile(d,f){return Promise.resolve(this.l(d).readFile(l.URI.revive(f))).then(a=>E.$He.wrap(a))}$writeFile(d,f,a,n){return Promise.resolve(this.l(d).writeFile(l.URI.revive(f),a.buffer,n))}$delete(d,f,a){return Promise.resolve(this.l(d).delete(l.URI.revive(f),a))}$rename(d,f,a,n){return Promise.resolve(this.l(d).rename(l.URI.revive(f),l.URI.revive(a),n))}$copy(d,f,a,n){const i=this.l(d);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(l.URI.revive(f),l.URI.revive(a),n))}$mkdir(d,f){return Promise.resolve(this.l(d).createDirectory(l.URI.revive(f)))}$watch(d,f,a,n){const i=this.l(d).watch(l.URI.revive(a),n);this.f.set(f,i)}$unwatch(d,f){const a=this.f.get(f);a&&(a.dispose(),this.f.delete(f))}$open(d,f,a){const n=this.l(d);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(l.URI.revive(f),a))}$close(d,f){const a=this.l(d);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(f))}$read(d,f,a,n){const i=this.l(d);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$He.alloc(n);return Promise.resolve(i.read(f,a,c.buffer,0,n)).then(r=>c.slice(0,r))}$write(d,f,a,n){const i=this.l(d);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(f,a,n.buffer,0,n.byteLength))}l(d){const f=this.c.get(d);if(!f){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return f}}e.$hnc=S}),define(ke[343],De([1,0,4,35,2,6,17,8,46]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(S,v,d,f,a,n){this.a=Math.random(),this.b=new l.$fe,this.c=new l.$fe,this.d=new l.$fe,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,O.$sk)(a),c=typeof a=="string",r=n?.correlate,t=f(u=>{if(!(typeof u.session=="number"&&u.session!==this.a)&&!(r&&typeof u.session>"u")){if(!n?.ignoreCreateEvents)for(const s of u.created){const o=L.URI.revive(s);i(o.fsPath)&&(!c||v.getWorkspaceFolder(o))&&this.b.fire(o)}if(!n?.ignoreChangeEvents)for(const s of u.changed){const o=L.URI.revive(s);i(o.fsPath)&&(!c||v.getWorkspaceFolder(o))&&this.c.fire(o)}if(!n?.ignoreDeleteEvents)for(const s of u.deleted){const o=L.URI.revive(s);i(o.fsPath)&&(!c||v.getWorkspaceFolder(o))&&this.d.fire(o)}}});this.g=b.$lM.from(this.i(S,d,a,n,n?.correlate),this.b,this.c,this.d,t)}i(S,v,d,f,a){const n=b.$lM.from();if(typeof d=="string"||f?.ignoreChangeEvents&&f?.ignoreCreateEvents&&f?.ignoreDeleteEvents)return n;const i=S.getProxy(A.$jM.MainThreadFileSystemEventService);let c=!1;(d.pattern.includes(O.$ok)||d.pattern.includes(O.$pk))&&(c=!0);let r;return a&&(f?.ignoreChangeEvents||f?.ignoreCreateEvents||f?.ignoreDeleteEvents)&&(r=14,f?.ignoreChangeEvents&&(r&=-3),f?.ignoreCreateEvents&&(r&=-5),f?.ignoreDeleteEvents&&(r&=-9)),i.$watch(v.identifier.value,this.a,d.baseUri,{recursive:c,excludes:f?.excludes??[],filter:r},!!a),b.$lM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class I{constructor(S){this.a=S,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(L.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(S,v,d){this.j=S,this.k=v,this.l=d,this.a=new l.$fe,this.b=new l.$fe,this.c=new l.$fe,this.d=new l.$fe,this.g=new l.$he,this.h=new l.$he,this.i=new l.$he,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,v,d,f){return new E(this.j,S,v,this.a.event,M.GlobPattern.from(d),f)}$onFileEvent(S){this.a.fire(new I(S))}$onDidRunFileOperation(S,v){switch(S){case 2:this.b.fire(Object.freeze({files:v.map(d=>({oldUri:L.URI.revive(d.source),newUri:L.URI.revive(d.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(d=>L.URI.revive(d.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(d=>L.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,v){return(d,f,a)=>{const n=function(c){d.call(f,c)};return n.extension=S,v.event(n,void 0,a)}}async $onWillRunFileOperation(S,v,d,f){switch(S){case 2:return await this.n(this.g,{files:v.map(a=>({oldUri:L.URI.revive(a.source),newUri:L.URI.revive(a.target)}))},d,f);case 1:return await this.n(this.i,{files:v.map(a=>L.URI.revive(a.target))},d,f);case 0:case 3:return await this.n(this.h,{files:v.map(a=>L.URI.revive(a.target))},d,f)}}async n(S,v,d,f){const a=new Set,n=[];if(await S.fireAsync(v,f,async(c,r)=>{const t=Date.now(),u=await Promise.resolve(c);u instanceof b.$vM&&(n.push([r.extension,u]),a.add(r.extension.displayName??r.extension.identifier.value)),Date.now()-t>d&&this.k.warn("SLOW file-participant",r.extension.identifier)}),f.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,c]of n){const{edits:r}=M.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(r)}return{edit:i,extensionNames:Array.from(a)}}}e.$inc=P}),define(ke[344],De([1,0,19,7,21,13,125,3,24,40,14,18,2,29,181,84,135,226,25,17,8,26,112,6]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c,r,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;class s{constructor(q,W){this.d=q,this.e=W}async provideDocumentSymbols(q,W){const X=this.d.getDocument(q),Q=await this.e.provideDocumentSymbols(X,W);if(!(0,l.$Kb)(Q))return Q[0]instanceof c.$FM?Q.map(i.DocumentSymbol.from):s.f(Q)}static f(q){q=q.slice(0).sort((Q,de)=>{let we=Q.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(Q.location.range.end)),we});const W=[],X=[];for(const Q of q){const de={name:Q.name||"!!MISSING: name!!",kind:i.SymbolKind.from(Q.kind),tags:Q.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:i.Range.from(Q.location.range),selectionRange:i.Range.from(Q.location.range),children:[]};for(;;){if(X.length===0){X.push(de),W.push(de);break}const we=X[X.length-1];if(S.$yt.containsRange(we.range,de.range)&&!S.$yt.equalsRange(we.range,de.range)){we.children?.push(de),X.push(de);break}X.pop()}}return W}}class o{constructor(q,W,X,Q,de,we){this.f=q,this.g=W,this.h=X,this.j=Q,this.k=de,this.l=we,this.d=new t.$1lc("CodeLens"),this.e=new Map}async provideCodeLenses(q,W){const X=this.f.getDocument(q),Q=await this.h.provideCodeLenses(X,W);if(!Q||W.isCancellationRequested)return;const de=this.d.add(Q),we=new b.$Tc;this.e.set(de,we);const Te={cacheId:de,lenses:[]};for(let qe=0;qe<Q.length;qe++)Te.lenses.push({cacheId:[de,qe],range:i.Range.from(Q[qe].range),command:this.g.toInternal(Q[qe].command,we)});return Te}async resolveCodeLens(q,W){const X=q.cacheId&&this.d.get(...q.cacheId);if(!X)return;let Q;if(typeof this.h.resolveCodeLens!="function"||X.isResolved?Q=X:Q=await this.h.resolveCodeLens(X,W),Q||(Q=X),W.isCancellationRequested)return;const de=q.cacheId&&this.e.get(q.cacheId[0]);if(de){if(!Q.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return q.command=this.g.toInternal(Q.command,de),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function h(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class g{constructor(q,W){this.d=q,this.e=W}async provideDefinition(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideDefinition(Q,de,X);return h(we)}}class w{constructor(q,W){this.d=q,this.e=W}async provideDeclaration(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideDeclaration(Q,de,X);return h(we)}}class k{constructor(q,W){this.d=q,this.e=W}async provideImplementation(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideImplementation(Q,de,X);return h(we)}}class m{constructor(q,W){this.d=q,this.e=W}async provideTypeDefinition(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideTypeDefinition(Q,de,X);return h(we)}}class y{static{this.f=10}constructor(q,W){this.g=q,this.h=W,this.d=0,this.e=new Map}async provideHover(q,W,X,Q){const de=this.g.getDocument(q),we=i.Position.to(W);let Te;if(X&&X.verbosityRequest){const et=X.verbosityRequest.previousHover.id,nt=this.e.get(et);if(!nt)throw new Error(`Hover with id ${et} not found`);const it={action:X.verbosityRequest.action,previousHover:nt};Te=await this.h.provideHover(de,we,Q,it)}else Te=await this.h.provideHover(de,we,Q);if(!Te||(0,l.$Kb)(Te.contents))return;Te.range||(Te.range=de.getWordRangeAtPosition(we)),Te.range||(Te.range=new c.$nM(we,we));const qe=i.Hover.from(Te),Xe=this.d;if(this.e.size===y.f){const et=Math.min(...this.e.keys());this.e.delete(et)}return this.e.set(Xe,Te),this.d+=1,{...qe,id:Xe}}releaseHover(q){this.e.delete(q)}}class D{constructor(q,W){this.d=q,this.e=W}async provideEvaluatableExpression(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideEvaluatableExpression(Q,de,X);if(we)return i.EvaluatableExpression.from(we)}}class C{constructor(q,W){this.d=q,this.e=W}async provideInlineValues(q,W,X,Q){const de=this.d.getDocument(q),we=await this.e.provideInlineValues(de,i.Range.to(W),i.InlineValueContext.to(X),Q);if(Array.isArray(we))return we.map(Te=>i.InlineValue.from(Te))}}class R{constructor(q,W){this.d=q,this.e=W}async provideDocumentHighlights(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideDocumentHighlights(Q,de,X);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class T{constructor(q,W){this.d=q,this.e=W}async provideMultiDocumentHighlights(q,W,X,Q){const de=this.d.getDocument(q),we=X.map(Xe=>this.d.getDocument(Xe)),Te=i.Position.to(W),qe=await this.e.provideMultiDocumentHighlights(de,Te,we,Q);if(Array.isArray(qe))return qe.map(i.MultiDocumentHighlight.from)}}class j{constructor(q,W){this.d=q,this.e=W}async provideLinkedEditingRanges(q,W,X){const Q=this.d.getDocument(q),de=i.Position.to(W),we=await this.e.provideLinkedEditingRanges(Q,de,X);if(we&&Array.isArray(we.ranges))return{ranges:(0,l.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class z{constructor(q,W){this.d=q,this.e=W}async provideReferences(q,W,X,Q){const de=this.d.getDocument(q),we=i.Position.to(W),Te=await this.e.provideReferences(de,we,X,Q);if(Array.isArray(Te))return Te.map(i.location.from)}}class N{static{this.d=1e3}constructor(q,W,X,Q,de,we,Te){this.g=q,this.h=W,this.j=X,this.k=Q,this.l=de,this.m=we,this.n=Te,this.e=new t.$1lc("CodeAction"),this.f=new Map}async provideCodeActions(q,W,X,Q){const de=this.g.getDocument(q),we=v.$At.isISelection(W)?i.Selection.to(W):i.Range.to(W),Te=[];for(const it of this.j.getDiagnostics(q))if(we.intersection(it.range)&&Te.push(it)>N.d)break;const qe={diagnostics:Te,only:X.only?new c.$HM(X.only):void 0,triggerKind:i.CodeActionTriggerKind.to(X.trigger)},Xe=await this.k.provideCodeActions(de,we,qe,Q);if(!(0,l.$Lb)(Xe)||Q.isCancellationRequested)return;const tt=this.e.add(Xe),et=new b.$Tc;this.f.set(tt,et);const nt=[];for(let it=0;it<Xe.length;it++){const rt=Xe[it];if(rt)if(N.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,et)});else{qe.only&&(rt.kind?qe.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=rt.ranges??[];nt.push({cacheId:[tt,it],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,et),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,r.$KG)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,r.$KG)(this.m,"codeActionRanges")?(0,l.$Hb)(at.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:tt,actions:nt}}async resolveCodeAction(q,W){const[X,Q]=q,de=this.e.get(X,Q);if(!de||N.o(de))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(de,W)??de;let Te;we.edit&&(Te=i.WorkspaceEdit.from(we.edit,void 0));let qe;if(we.command){const Xe=this.f.get(X);Xe&&(qe=this.h.toInternal(we.command,Xe))}return{edit:Te,command:qe}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class F{constructor(q,W,X,Q,de){this.e=q,this.f=W,this.g=X,this.h=Q,this.j=de,this.d=new t.$1lc("DocumentPasteEdit")}async prepareDocumentPaste(q,W,X,Q){if(!this.g.prepareDocumentPaste)return;const de=this.f.getDocument(q),we=W.map(Xe=>i.Range.to(Xe)),Te=i.DataTransfer.toDataTransfer(X,()=>{throw new A.$$});if(await this.g.prepareDocumentPaste(de,we,Te,Q),Q.isCancellationRequested)return;const qe=Array.from(Te).filter(([,Xe])=>!(Xe instanceof c.$bN));return i.DataTransfer.from(qe)}async providePasteEdits(q,W,X,Q,de,we){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(W),qe=X.map(nt=>i.Range.to(nt)),Xe=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolvePasteFileData(this.h,q,nt)).buffer),tt=await this.g.provideDocumentPasteEdits(Te,qe,Xe,{only:de.only?new c.$gN(de.only):void 0,triggerKind:de.triggerKind},we);if(!tt||we.isCancellationRequested)return[];const et=this.d.add(tt);return tt.map((nt,it)=>({_cacheId:[et,it],title:nt.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,W){const[X,Q]=q,de=this.d.get(X,Q);if(!de||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(de,W)??de;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class B{constructor(q,W){this.d=q,this.e=W}async provideDocumentFormattingEdits(q,W,X){const Q=this.d.getDocument(q),de=await this.e.provideDocumentFormattingEdits(Q,W,X);if(Array.isArray(de))return de.map(i.TextEdit.from)}}class Y{constructor(q,W){this.d=q,this.e=W}async provideDocumentRangeFormattingEdits(q,W,X,Q){const de=this.d.getDocument(q),we=i.Range.to(W),Te=await this.e.provideDocumentRangeFormattingEdits(de,we,X,Q);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,W,X,Q){(0,P.$ig)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const de=this.d.getDocument(q),we=W.map(i.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(de,we,X,Q);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}}class re{constructor(q,W){this.d=q,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,W,X,Q,de){const we=this.d.getDocument(q),Te=i.Position.to(W),qe=await this.e.provideOnTypeFormattingEdits(we,Te,X,Q,de);if(Array.isArray(qe))return qe.map(i.TextEdit.from)}}class H{constructor(q,W){this.e=q,this.f=W,this.d=new t.$1lc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,W){const X=await this.e.provideWorkspaceSymbols(q,W);if(!(0,l.$Lb)(X))return{symbols:[]};const Q=this.d.add(X),de={cacheId:Q,symbols:[]};for(let we=0;we<X.length;we++){const Te=X[we];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}de.symbols.push({...i.WorkspaceSymbol.from(Te),cacheId:[Q,we]})}return de}async resolveWorkspaceSymbol(q,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const X=this.d.get(...q.cacheId);if(X){const Q=await this.e.resolveWorkspaceSymbol(X,W);return Q&&(0,$.$8n)(q,i.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class K{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,W,X){this.d=q,this.e=W,this.f=X}async provideRenameEdits(q,W,X,Q){const de=this.d.getDocument(q),we=i.Position.to(W);try{const Te=await this.e.provideRenameEdits(de,we,X,Q);return Te?i.WorkspaceEdit.from(Te):void 0}catch(Te){const qe=K.g(Te);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(q,W,X){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(q),de=i.Position.to(W);try{const we=await this.e.prepareRename(Q,de,X);let Te,qe;if(c.$nM.isRange(we)?(Te=we,qe=Q.getText(we)):(0,P.$ag)(we)&&(Te=we.range,qe=we.placeholder),!Te||!qe)return;if(Te.start.line>de.line||Te.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Te),text:qe}}catch(we){const Te=K.g(we);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(we)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class _{static{this.d={[d.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[d.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(q,W,X){this.e=q,this.f=W,this.g=X}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(q,W,X,Q){const de=this.e.getDocument(q),we=i.Range.to(W);try{const Te=_.d[X],qe=await this.f.provideNewSymbolNames(de,we,Te,Q);return qe?qe.map(Xe=>typeof Xe=="string"?{newSymbolName:Xe}:{newSymbolName:Xe.newSymbolName,tags:Xe.tags}):void 0}catch(Te){this.g.error(_.h(Te)??JSON.stringify(Te,null,"	"));return}}static h(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Z{constructor(q,W){this.resultId=q,this.tokens=W}}class $e{constructor(q,W){this.f=q,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,W,X){const Q=this.f.getDocument(q),de=W!==0?this.d.get(W):null;let we=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,de.resultId,X):await this.g.provideDocumentSemanticTokens(Q,X);return de&&this.d.delete(W),we?(we=$e.h(we),this.o($e.n(de,we),we)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return $e.j(q)?$e.k(q)?q:new c.$GN(new Uint32Array(q.data),q.resultId):$e.l(q)?$e.m(q)?q:new c.$IN(q.edits.map(W=>new c.$HN(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const W of q.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(q,W){if(!$e.j(W)||!q||!q.tokens)return W;const X=q.tokens,Q=X.length,de=W.data,we=de.length;let Te=0;const qe=Math.min(Q,we);for(;Te<qe&&X[Te]===de[Te];)Te++;if(Te===Q&&Te===we)return new c.$IN([],W.resultId);let Xe=0;const tt=qe-Te;for(;Xe<tt&&X[Q-Xe-1]===de[we-Xe-1];)Xe++;return new c.$IN([{start:Te,deleteCount:Q-Te-Xe,data:de.subarray(Te,we-Xe)}],W.resultId)}o(q,W){if($e.j(q)){const X=this.e++;return this.d.set(X,new Z(q.resultId,q.data)),(0,f.$Bbb)({id:X,type:"full",data:q.data})}if($e.l(q)){const X=this.e++;return $e.j(W)?this.d.set(X,new Z(W.resultId,W.data)):this.d.set(X,new Z(q.resultId)),(0,f.$Bbb)({id:X,type:"delta",deltas:(q.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class oe{constructor(q,W){this.d=q,this.e=W}async provideDocumentRangeSemanticTokens(q,W,X){const Q=this.d.getDocument(q),de=await this.e.provideDocumentRangeSemanticTokens(Q,i.Range.to(W),X);return de?this.f(de):null}f(q){return(0,f.$Bbb)({id:0,type:"full",data:q.data})}}class Pe{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,W,X,Q,de){this.f=q,this.g=W,this.h=X,this.j=Q,this.k=de,this.d=new t.$1lc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,W,X,Q){const de=this.f.getDocument(q),we=i.Position.to(W),Te=de.getWordRangeAtPosition(we)||new c.$nM(we,we),qe=Te.with({end:we}),Xe=new E.$be,tt=await this.h.provideCompletionItems(de,we,Q,i.CompletionContext.to(X));if(!tt||Q.isCancellationRequested)return;const et=Array.isArray(tt)?new c.$UM(tt):tt,nt=Pe.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),it=new b.$Tc;this.e.set(nt,it);const rt=[],at={x:nt,b:rt,a:{replace:i.Range.from(Te),insert:i.Range.from(qe)},c:et.isIncomplete||void 0,d:Xe.elapsed()};for(let Me=0;Me<et.items.length;Me++){const ye=et.items[Me],Ve=this.l(ye,[nt,Me],qe,Te);rt.push(Ve)}return at}async resolveCompletionItem(q,W){if(typeof this.h.resolveCompletionItem!="function")return;const X=this.d.get(...q);if(!X)return;const Q=this.l(X,q),de=await this.h.resolveCompletionItem(X,W);if(!de)return;const we=this.l(de,q);return(Q.h!==we.h||Q.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==we.n||Q.o!==we.o||!(0,$.$9n)(Q.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,W,X,Q){const de=this.e.get(W[0]);if(!de)throw Error("DisposableStore is missing...");const we=this.g.toInternal(q.command,de),Te={x:W,a:q.label,b:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(i.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=q.textEdit.newText):typeof q.insertText=="string"?Te.h=q.insertText:q.insertText instanceof c.$wM&&(Te.h=q.insertText.value,Te.i|=4);let qe;return q.textEdit?qe=q.textEdit.range:q.range&&(qe=q.range),c.$nM.isRange(qe)?Te.j=i.Range.from(qe):qe&&(!X?.isEqual(qe.inserting)||!Q?.isEqual(qe.replacing))&&(Te.j={insert:i.Range.from(qe.inserting),replace:i.Range.from(qe.replacing)}),Te}}class te{async provideInlineCompletions(q,W,X,Q){}disposeCompletions(q){}handleDidShowCompletionItem(q,W,X){}handlePartialAccept(q,W,X,Q){}}class U extends te{constructor(q,W,X,Q){super(),this.f=q,this.g=W,this.h=X,this.j=Q,this.d=new be,this.e=(0,r.$KG)(this.f,"inlineCompletionsAdditions"),this.k={[d.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[d.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$KG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,W,X,Q){const de=this.g.getDocument(q),we=i.Position.to(W),Te=await this.h.provideInlineCompletionItems(de,we,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:i.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[X.triggerKind]},Q);if(!Te||Q.isCancellationRequested)return;const qe=Array.isArray(Te)?Te:Te.items,Xe=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],tt=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:qe}),items:qe.map((it,rt)=>{let at;it.command&&(et||(et=new b.$Tc),at=this.j.toInternal(it.command,et));const Me=it.insertText;return{insertText:typeof Me=="string"?Me:{snippet:Me.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:at,idx:rt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Xe.map(it=>(et||(et=new b.$Tc),this.j.toInternal(it,et))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,W,X){const Q=this.d.get(q)?.items[W];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,X)}handlePartialAccept(q,W,X,Q){const de=this.d.get(q)?.items[W];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(de,X),this.h.handleDidPartiallyAcceptCompletionItem(de,i.PartialAcceptInfo.to(Q)))}}class ee{async provideInlineEdits(q,W,X){const Q=this.f.getDocument(q),de=await this.g.provideInlineEdit(Q,{triggerKind:this.e[W.triggerKind]},X);if(!de||X.isCancellationRequested)return;let we;const Te=this.d.createReferenceId({dispose(){we?.dispose()},item:de});let qe;de.accepted&&(we||(we=new b.$Tc),qe=this.h.toInternal(de.accepted,we));let Xe;return de.rejected&&(we||(we=new b.$Tc),Xe=this.h.toInternal(de.rejected,we)),{pid:Te,text:de.text,range:i.Range.from(de.range),accepted:qe,rejected:Xe}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,W,X,Q){this.f=W,this.g=X,this.h=Q,this.d=new be,this.e={[d.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[d.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const W=this.e++;return this.d.set(W,q),W}disposeReferenceId(q){const W=this.d.get(q);return this.d.delete(q),W}get(q){return this.d.get(q)}}class ue{constructor(q,W){this.e=q,this.f=W,this.d=new t.$1lc("SignatureHelp")}async provideSignatureHelp(q,W,X,Q){const de=this.e.getDocument(q),we=i.Position.to(W),Te=this.g(X),qe=await this.f.provideSignatureHelp(de,we,Q,Te);if(qe){const Xe=this.d.add([qe]);return{...i.SignatureHelp.from(qe),id:Xe}}}g(q){let W;if(q.activeSignatureHelp){const X=i.SignatureHelp.to(q.activeSignatureHelp),Q=this.d.get(q.activeSignatureHelp.id,0);Q?(W=Q,W.activeSignature=X.activeSignature,W.activeParameter=X.activeParameter):W=X}return{...q,activeSignatureHelp:W}}releaseSignatureHelp(q){this.d.delete(q)}}class ce{constructor(q,W,X,Q,de){this.f=q,this.g=W,this.h=X,this.j=Q,this.k=de,this.d=new t.$1lc("InlayHints"),this.e=new Map}async provideInlayHints(q,W,X){const Q=this.f.getDocument(q),de=i.Range.to(W),we=await this.h.provideInlayHints(Q,de,X);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(X.isCancellationRequested)return;const Te=this.d.add(we);this.e.set(Te,new b.$Tc);const qe={hints:[],cacheId:Te};for(let Xe=0;Xe<we.length;Xe++)this.l(we[Xe],de)&&qe.hints.push(this.m(we[Xe],[Te,Xe]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),qe}async resolveInlayHint(q,W){if(typeof this.h.resolveInlayHint!="function")return;const X=this.d.get(...q);if(!X)return;const Q=await this.h.resolveInlayHint(X,W);if(Q&&this.l(Q))return this.m(Q,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,W){return q.label.length===0||Array.isArray(q.label)&&q.label.every(X=>X.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(W&&!W.contains(q.position))}m(q,W){const X=this.e.get(W[0]);if(!X)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:W,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")Q.label=q.label;else{const de=[];Q.label=de;for(const we of q.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};c.$xM.isLocation(we.location)&&(Te.location=i.location.from(we.location)),we.command&&(Te.command=this.g.toInternal(we.command,X)),de.push(Te)}}return Q}}class ae{constructor(q,W){this.e=q,this.f=W,this.d=new t.$1lc("DocumentLink")}async provideLinks(q,W){const X=this.e.getDocument(q),Q=await this.f.provideDocumentLinks(X,W);if(!(!Array.isArray(Q)||Q.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(ae.g).map(i.DocumentLink.from)};{const de=this.d.add(Q),we={links:[],cacheId:de};for(let Te=0;Te<Q.length;Te++){if(!ae.g(Q[Te]))continue;const qe=i.DocumentLink.from(Q[Te]);qe.cacheId=[de,Te],we.links.push(qe)}return we}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,W){if(typeof this.f.resolveDocumentLink!="function")return;const X=this.d.get(...q);if(!X)return;const Q=await this.f.resolveDocumentLink(X,W);if(!(!Q||!ae.g(Q)))return i.DocumentLink.from(Q)}releaseLinks(q){this.d.delete(q)}}class le{constructor(q,W){this.d=q,this.e=W}async provideColors(q,W){const X=this.d.getDocument(q),Q=await this.e.provideDocumentColors(X,W);return Array.isArray(Q)?Q.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(q,W,X){const Q=this.d.getDocument(q),de=i.Range.to(W.range),we=i.Color.to(W.color),Te=await this.e.provideColorPresentations(we,{document:Q,range:de},X);if(Array.isArray(Te))return Te.map(i.ColorPresentation.from)}}class J{constructor(q,W){this.d=q,this.e=W}async provideFoldingRanges(q,W,X){const Q=this.d.getDocument(q),de=await this.e.provideFoldingRanges(Q,W,X);if(Array.isArray(de))return de.map(i.FoldingRange.from)}}class se{constructor(q,W,X){this.d=q,this.e=W,this.f=X}async provideSelectionRanges(q,W,X){const Q=this.d.getDocument(q),de=W.map(i.Position.to),we=await this.e.provideSelectionRanges(Q,de,X);if(!(0,l.$Lb)(we))return[];if(we.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let qe=0;qe<de.length;qe++){const Xe=[];Te.push(Xe);let tt=de[qe],et=we[qe];for(;;){if(!et.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(i.SelectionRange.from(et)),!et.parent)break;tt=et.range,et=et.parent}}return Te}}class pe{constructor(q,W){this.f=q,this.g=W,this.d=new M.$SO(""),this.e=new Map}async prepareSession(q,W,X){const Q=this.f.getDocument(q),de=i.Position.to(W),we=await this.g.prepareCallHierarchy(Q,de,X);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(qe=>this.h(Te,qe)):[this.h(Te,we)]}async provideCallsTo(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(Q,X);if(de)return de.map(we=>({from:this.h(q,we.from),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}async provideCallsFrom(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(Q,X);if(de)return de.map(we=>({to:this.h(q,we.to),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}releaseSession(q){this.e.delete(q)}h(q,W){const X=this.e.get(q),Q=i.CallHierarchyItem.from(W,q,X.size.toString(36));return X.set(Q._itemId,W),Q}j(q,W){return this.e.get(q)?.get(W)}}class ve{constructor(q,W){this.f=q,this.g=W,this.d=new M.$SO(""),this.e=new Map}async prepareSession(q,W,X){const Q=this.f.getDocument(q),de=i.Position.to(W),we=await this.g.prepareTypeHierarchy(Q,de,X);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(qe=>this.h(Te,qe)):[this.h(Te,we)]}async provideSupertypes(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(Q,X);if(de)return de.map(we=>this.h(q,we))}async provideSubtypes(q,W,X){const Q=this.j(q,W);if(!Q)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(Q,X);if(de)return de.map(we=>this.h(q,we))}releaseSession(q){this.e.delete(q)}h(q,W){const X=this.e.get(q),Q=i.TypeHierarchyItem.from(W,q,X.size.toString(36));return X.set(Q._itemId,W),Q}j(q,W){return this.e.get(q)?.get(W)}}class Re{constructor(q,W,X,Q,de){this.e=q,this.f=W,this.g=X,this.h=Q,this.j=de,this.d=new t.$1lc("DocumentDropEdit")}async provideDocumentOnDropEdits(q,W,X,Q,de){const we=this.f.getDocument(W),Te=i.Position.to(X),qe=i.DataTransfer.toDataTransfer(Q,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,q,nt)).buffer),Xe=await this.g.provideDocumentDropEdits(we,Te,qe,de);if(!Xe)return;const tt=(0,l.$2b)(Xe),et=this.d.add(tt);return tt.map((nt,it)=>({_cacheId:[et,it],title:nt.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(q,W){const[X,Q]=q,de=this.d.get(X,Q);if(!de||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(de,W)??de;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(q){this.d.delete(q)}}class me{constructor(q,W){this.d=q,this.e=W}async provideMappedEdits(q,W,X,Q){const de=p.URI.revive(q),we=this.d.getDocument(de),Te=X.documents.map(tt=>tt.map(et=>({uri:p.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(nt=>i.Range.to(nt))}))),qe={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Xe=await this.e.provideMappedEdits(we,W,qe,Q);return Xe?i.WorkspaceEdit.from(Xe):null}}class Ie{constructor(q,W){this.adapter=q,this.extension=W}}class Ae{static{this.d=0}constructor(q,W,X,Q,de,we,Te,qe){this.g=W,this.h=X,this.j=Q,this.k=de,this.l=we,this.m=Te,this.n=qe,this.f=new Map,this.e=q.getProxy(u.$jM.MainThreadLanguageFeatures)}o(q,W){return i.DocumentSelector.from(q,this.g,W)}p(q){return new c.$lM(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Ae.d++}async s(q,W,X,Q,de,we=!1){const Te=this.f.get(q);if(!Te||!(Te.adapter instanceof W))return Q;const qe=Date.now();we||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${X.toString().replace(/[\r\n]/g,"")}'`);const Xe=X(Te.adapter,Te.extension);return Promise.resolve(Xe).catch(tt=>{(0,A.$4)(tt)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Te.extension.identifier,tt))}).finally(()=>{we||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),L.CancellationToken.isCancellationToken(de)?(0,O.$nh)(Xe,de):Xe}t(q,W){const X=this.q();return this.f.set(X,new Ie(q,W)),X}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,W,X,Q){const de=this.t(new s(this.h,X),q),we=Q&&Q.label||Ae.u(q);return this.e.$registerDocumentSymbolProvider(de,this.o(W,q),we),this.p(de)}$provideDocumentSymbols(q,W,X){return this.s(q,s,Q=>Q.provideDocumentSymbols(p.URI.revive(W),X),void 0,X)}registerCodeLensProvider(q,W,X){const Q=this.q(),de=typeof X.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new Ie(new o(this.h,this.j.converter,X,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(Q,this.o(W,q),de);let we=this.p(Q);if(de!==void 0){const Te=X.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(de));we=c.$lM.from(we,Te)}return we}$provideCodeLenses(q,W,X){return this.s(q,o,Q=>Q.provideCodeLenses(p.URI.revive(W),X),void 0,X)}$resolveCodeLens(q,W,X){return this.s(q,o,Q=>Q.resolveCodeLens(W,X),void 0,void 0)}$releaseCodeLenses(q,W){this.s(q,o,X=>Promise.resolve(X.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(q,W,X){const Q=this.t(new g(this.h,X),q);return this.e.$registerDefinitionSupport(Q,this.o(W,q)),this.p(Q)}$provideDefinition(q,W,X,Q){return this.s(q,g,de=>de.provideDefinition(p.URI.revive(W),X,Q),[],Q)}registerDeclarationProvider(q,W,X){const Q=this.t(new w(this.h,X),q);return this.e.$registerDeclarationSupport(Q,this.o(W,q)),this.p(Q)}$provideDeclaration(q,W,X,Q){return this.s(q,w,de=>de.provideDeclaration(p.URI.revive(W),X,Q),[],Q)}registerImplementationProvider(q,W,X){const Q=this.t(new k(this.h,X),q);return this.e.$registerImplementationSupport(Q,this.o(W,q)),this.p(Q)}$provideImplementation(q,W,X,Q){return this.s(q,k,de=>de.provideImplementation(p.URI.revive(W),X,Q),[],Q)}registerTypeDefinitionProvider(q,W,X){const Q=this.t(new m(this.h,X),q);return this.e.$registerTypeDefinitionSupport(Q,this.o(W,q)),this.p(Q)}$provideTypeDefinition(q,W,X,Q){return this.s(q,m,de=>de.provideTypeDefinition(p.URI.revive(W),X,Q),[],Q)}registerHoverProvider(q,W,X,Q){const de=this.t(new y(this.h,X),q);return this.e.$registerHoverProvider(de,this.o(W,q)),this.p(de)}$provideHover(q,W,X,Q,de){return this.s(q,y,we=>we.provideHover(p.URI.revive(W),X,Q,de),void 0,de)}$releaseHover(q,W){this.s(q,y,X=>Promise.resolve(X.releaseHover(W)),void 0,void 0)}registerEvaluatableExpressionProvider(q,W,X,Q){const de=this.t(new D(this.h,X),q);return this.e.$registerEvaluatableExpressionProvider(de,this.o(W,q)),this.p(de)}$provideEvaluatableExpression(q,W,X,Q){return this.s(q,D,de=>de.provideEvaluatableExpression(p.URI.revive(W),X,Q),void 0,Q)}registerInlineValuesProvider(q,W,X,Q){const de=typeof X.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new C(this.h,X),q);this.e.$registerInlineValuesProvider(we,this.o(W,q),de);let Te=this.p(we);if(de!==void 0){const qe=X.onDidChangeInlineValues(Xe=>this.e.$emitInlineValuesEvent(de));Te=c.$lM.from(Te,qe)}return Te}$provideInlineValues(q,W,X,Q,de){return this.s(q,C,we=>we.provideInlineValues(p.URI.revive(W),X,Q,de),void 0,de)}registerDocumentHighlightProvider(q,W,X){const Q=this.t(new R(this.h,X),q);return this.e.$registerDocumentHighlightProvider(Q,this.o(W,q)),this.p(Q)}registerMultiDocumentHighlightProvider(q,W,X){const Q=this.t(new T(this.h,X),q);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(W,q)),this.p(Q)}$provideDocumentHighlights(q,W,X,Q){return this.s(q,R,de=>de.provideDocumentHighlights(p.URI.revive(W),X,Q),void 0,Q)}$provideMultiDocumentHighlights(q,W,X,Q,de){return this.s(q,T,we=>we.provideMultiDocumentHighlights(p.URI.revive(W),X,Q.map(Te=>p.URI.revive(Te)),de),void 0,de)}registerLinkedEditingRangeProvider(q,W,X){const Q=this.t(new j(this.h,X),q);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(W,q)),this.p(Q)}$provideLinkedEditingRanges(q,W,X,Q){return this.s(q,j,async de=>{const we=await de.provideLinkedEditingRanges(p.URI.revive(W),X,Q);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ae.w(we.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(q,W,X){const Q=this.t(new z(this.h,X),q);return this.e.$registerReferenceSupport(Q,this.o(W,q)),this.p(Q)}$provideReferences(q,W,X,Q,de){return this.s(q,z,we=>we.provideReferences(p.URI.revive(W),X,Q,de),void 0,de)}registerCodeActionProvider(q,W,X,Q){const de=new b.$Tc,we=this.t(new N(this.h,this.j.converter,this.k,X,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(we,this.o(W,q),{providedKinds:Q?.providedCodeActionKinds?.map(Te=>Te.value),documentation:Q?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,de)}))},Ae.u(q),!!X.resolveCodeAction),de.add(this.p(we)),de}$provideCodeActions(q,W,X,Q,de){return this.s(q,N,we=>we.provideCodeActions(p.URI.revive(W),X,Q,de),void 0,de)}$resolveCodeAction(q,W,X){return this.s(q,N,Q=>Q.resolveCodeAction(W,X),{},void 0)}$releaseCodeActions(q,W){this.s(q,N,X=>Promise.resolve(X.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(q,W,X){const Q=this.t(new B(this.h,X),q);return this.e.$registerDocumentFormattingSupport(Q,this.o(W,q),q.identifier,q.displayName||q.name),this.p(Q)}$provideDocumentFormattingEdits(q,W,X,Q){return this.s(q,B,de=>de.provideDocumentFormattingEdits(p.URI.revive(W),X,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(q,W,X){const Q=typeof X.provideDocumentRangesFormattingEdits=="function",de=this.t(new Y(this.h,X),q);return this.e.$registerRangeFormattingSupport(de,this.o(W,q),q.identifier,q.displayName||q.name,Q),this.p(de)}$provideDocumentRangeFormattingEdits(q,W,X,Q,de){return this.s(q,Y,we=>we.provideDocumentRangeFormattingEdits(p.URI.revive(W),X,Q,de),void 0,de)}$provideDocumentRangesFormattingEdits(q,W,X,Q,de){return this.s(q,Y,we=>we.provideDocumentRangesFormattingEdits(p.URI.revive(W),X,Q,de),void 0,de)}registerOnTypeFormattingEditProvider(q,W,X,Q){const de=this.t(new re(this.h,X),q);return this.e.$registerOnTypeFormattingSupport(de,this.o(W,q),Q,q.identifier),this.p(de)}$provideOnTypeFormattingEdits(q,W,X,Q,de,we){return this.s(q,re,Te=>Te.provideOnTypeFormattingEdits(p.URI.revive(W),X,Q,de,we),void 0,we)}registerWorkspaceSymbolProvider(q,W){const X=this.t(new H(W,this.l),q);return this.e.$registerNavigateTypeSupport(X,typeof W.resolveWorkspaceSymbol=="function"),this.p(X)}$provideWorkspaceSymbols(q,W,X){return this.s(q,H,Q=>Q.provideWorkspaceSymbols(W,X),{symbols:[]},X)}$resolveWorkspaceSymbol(q,W,X){return this.s(q,H,Q=>Q.resolveWorkspaceSymbol(W,X),void 0,void 0)}$releaseWorkspaceSymbols(q,W){this.s(q,H,X=>X.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(q,W,X){const Q=this.t(new K(this.h,X,this.l),q);return this.e.$registerRenameSupport(Q,this.o(W,q),K.supportsResolving(X)),this.p(Q)}$provideRenameEdits(q,W,X,Q,de){return this.s(q,K,we=>we.provideRenameEdits(p.URI.revive(W),X,Q,de),void 0,de)}$resolveRenameLocation(q,W,X,Q){return this.s(q,K,de=>de.resolveRenameLocation(p.URI.revive(W),X,Q),void 0,Q)}registerNewSymbolNamesProvider(q,W,X){const Q=this.t(new _(this.h,X,this.l),q);return this.e.$registerNewSymbolNamesProvider(Q,this.o(W,q)),this.p(Q)}$supportsAutomaticNewSymbolNamesTriggerKind(q){return this.s(q,_,W=>W.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(q,W,X,Q,de){return this.s(q,_,we=>we.provideNewSymbolNames(p.URI.revive(W),X,Q,de),void 0,de)}registerDocumentSemanticTokensProvider(q,W,X,Q){const de=this.t(new $e(this.h,X),q),we=typeof X.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(W,q),Q,we);let Te=this.p(de);if(we){const qe=X.onDidChangeSemanticTokens(Xe=>this.e.$emitDocumentSemanticTokensEvent(we));Te=c.$lM.from(Te,qe)}return Te}$provideDocumentSemanticTokens(q,W,X,Q){return this.s(q,$e,de=>de.provideDocumentSemanticTokens(p.URI.revive(W),X,Q),null,Q)}$releaseDocumentSemanticTokens(q,W){this.s(q,$e,X=>X.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,W,X,Q){const de=this.t(new oe(this.h,X),q);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(W,q),Q),this.p(de)}$provideDocumentRangeSemanticTokens(q,W,X,Q){return this.s(q,oe,de=>de.provideDocumentRangeSemanticTokens(p.URI.revive(W),X,Q),null,Q)}registerCompletionItemProvider(q,W,X,Q){const de=this.t(new Pe(this.h,this.j.converter,X,this.m,q),q);return this.e.$registerCompletionsProvider(de,this.o(W,q),Q,Pe.supportsResolving(X),q.identifier),this.p(de)}$provideCompletionItems(q,W,X,Q,de){return this.s(q,Pe,we=>we.provideCompletionItems(p.URI.revive(W),X,Q,de),void 0,de)}$resolveCompletionItem(q,W,X){return this.s(q,Pe,Q=>Q.resolveCompletionItem(W,X),void 0,X)}$releaseCompletionItems(q,W){this.s(q,Pe,X=>X.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(q,W,X,Q){const de=new U(q,this.h,X,this.j.converter),we=this.t(de,q);return this.e.$registerInlineCompletionsSupport(we,this.o(W,q),de.supportsHandleEvents,n.$Tm.toKey(q.identifier.value),Q?.yieldTo?.map(Te=>n.$Tm.toKey(Te))||[]),this.p(we)}$provideInlineCompletions(q,W,X,Q,de){return this.s(q,te,we=>we.provideInlineCompletions(p.URI.revive(W),X,Q,de),void 0,de)}$handleInlineCompletionDidShow(q,W,X,Q){this.s(q,te,async de=>{de.handleDidShowCompletionItem(W,X,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,W,X,Q,de){this.s(q,te,async we=>{we.handlePartialAccept(W,X,Q,de)},void 0,void 0)}$freeInlineCompletionsList(q,W){this.s(q,te,async X=>{X.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(q,W,X){const Q=new ee(q,this.h,X,this.j.converter),de=this.t(Q,q);return this.e.$registerInlineEditProvider(de,this.o(W,q),q.identifier),this.p(de)}$provideInlineEdit(q,W,X,Q){return this.s(q,ee,de=>de.provideInlineEdits(p.URI.revive(W),X,Q),void 0,Q)}$freeInlineEdit(q,W){this.s(q,ee,async X=>{X.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(q,W,X,Q){const de=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,we=this.t(new ue(this.h,X),q);return this.e.$registerSignatureHelpProvider(we,this.o(W,q),de),this.p(we)}$provideSignatureHelp(q,W,X,Q,de){return this.s(q,ue,we=>we.provideSignatureHelp(p.URI.revive(W),X,Q,de),void 0,de)}$releaseSignatureHelp(q,W){this.s(q,ue,X=>X.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(q,W,X){const Q=typeof X.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ce(this.h,this.j.converter,X,this.l,q),q);this.e.$registerInlayHintsProvider(de,this.o(W,q),typeof X.resolveInlayHint=="function",Q,Ae.u(q));let we=this.p(de);if(Q!==void 0){const Te=X.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(Q));we=c.$lM.from(we,Te)}return we}$provideInlayHints(q,W,X,Q){return this.s(q,ce,de=>de.provideInlayHints(p.URI.revive(W),X,Q),void 0,Q)}$resolveInlayHint(q,W,X){return this.s(q,ce,Q=>Q.resolveInlayHint(W,X),void 0,X)}$releaseInlayHints(q,W){this.s(q,ce,X=>X.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(q,W,X){const Q=this.t(new ae(this.h,X),q);return this.e.$registerDocumentLinkProvider(Q,this.o(W,q),typeof X.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(q,W,X){return this.s(q,ae,Q=>Q.provideLinks(p.URI.revive(W),X),void 0,X,W.scheme==="output")}$resolveDocumentLink(q,W,X){return this.s(q,ae,Q=>Q.resolveLink(W,X),void 0,void 0,!0)}$releaseDocumentLinks(q,W){this.s(q,ae,X=>X.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(q,W,X){const Q=this.t(new le(this.h,X),q);return this.e.$registerDocumentColorProvider(Q,this.o(W,q)),this.p(Q)}$provideDocumentColors(q,W,X){return this.s(q,le,Q=>Q.provideColors(p.URI.revive(W),X),[],X)}$provideColorPresentations(q,W,X,Q){return this.s(q,le,de=>de.provideColorPresentations(p.URI.revive(W),X,Q),void 0,Q)}registerFoldingRangeProvider(q,W,X){const Q=this.q(),de=typeof X.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new Ie(new J(this.h,X),q)),this.e.$registerFoldingRangeProvider(Q,this.o(W,q),q.identifier,de);let we=this.p(Q);if(de!==void 0){const Te=X.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));we=c.$lM.from(we,Te)}return we}$provideFoldingRanges(q,W,X,Q){return this.s(q,J,de=>de.provideFoldingRanges(p.URI.revive(W),X,Q),void 0,Q)}registerSelectionRangeProvider(q,W,X){const Q=this.t(new se(this.h,X,this.l),q);return this.e.$registerSelectionRangeProvider(Q,this.o(W,q)),this.p(Q)}$provideSelectionRanges(q,W,X,Q){return this.s(q,se,de=>de.provideSelectionRanges(p.URI.revive(W),X,Q),[],Q)}registerCallHierarchyProvider(q,W,X){const Q=this.t(new pe(this.h,X),q);return this.e.$registerCallHierarchyProvider(Q,this.o(W,q)),this.p(Q)}$prepareCallHierarchy(q,W,X,Q){return this.s(q,pe,de=>Promise.resolve(de.prepareSession(p.URI.revive(W),X,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(q,W,X,Q){return this.s(q,pe,de=>de.provideCallsTo(W,X,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(q,W,X,Q){return this.s(q,pe,de=>de.provideCallsFrom(W,X,Q),void 0,Q)}$releaseCallHierarchy(q,W){this.s(q,pe,X=>Promise.resolve(X.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(q,W,X){const Q=this.t(new ve(this.h,X),q);return this.e.$registerTypeHierarchyProvider(Q,this.o(W,q)),this.p(Q)}$prepareTypeHierarchy(q,W,X,Q){return this.s(q,ve,de=>Promise.resolve(de.prepareSession(p.URI.revive(W),X,Q)),void 0,Q)}$provideTypeHierarchySupertypes(q,W,X,Q){return this.s(q,ve,de=>de.provideSupertypes(W,X,Q),void 0,Q)}$provideTypeHierarchySubtypes(q,W,X,Q){return this.s(q,ve,de=>de.provideSubtypes(W,X,Q),void 0,Q)}$releaseTypeHierarchy(q,W){this.s(q,ve,X=>Promise.resolve(X.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(q,W,X,Q){const de=this.q();return this.f.set(de,new Ie(new Re(this.e,this.h,X,de,q),q)),this.e.$registerDocumentOnDropEditProvider(de,this.o(W,q),(0,r.$KG)(q,"documentPaste")&&Q?{supportsResolve:!!X.resolveDocumentDropEdit,dropMimeTypes:Q.dropMimeTypes}:void 0),this.p(de)}$provideDocumentOnDropEdits(q,W,X,Q,de,we){return this.s(q,Re,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(W,p.URI.revive(X),Q,de,we)),void 0,void 0)}$resolveDropEdit(q,W,X){return this.s(q,Re,Q=>Q.resolveDropEdit(W,X),{},void 0)}$releaseDropEdits(q,W){this.s(q,Re,X=>Promise.resolve(X.releaseDropEdits(W)),void 0,void 0)}registerMappedEditsProvider(q,W,X){const Q=this.t(new me(this.h,X),q);return this.e.$registerMappedEditsProvider(Q,this.o(W,q)),this.p(Q)}$provideMappedEdits(q,W,X,Q,de){return this.s(q,me,we=>Promise.resolve(we.provideMappedEdits(W,X,Q,de)),null,de)}registerDocumentPasteEditProvider(q,W,X,Q){const de=this.q();return this.f.set(de,new Ie(new F(this.e,this.h,X,de,q),q)),this.e.$registerPasteEditProvider(de,this.o(W,q),{supportsCopy:!!X.prepareDocumentPaste,supportsPaste:!!X.provideDocumentPasteEdits,supportsResolve:!!X.resolveDocumentPasteEdit,providedPasteEditKinds:Q.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(de)}$prepareDocumentPaste(q,W,X,Q,de){return this.s(q,F,we=>we.prepareDocumentPaste(p.URI.revive(W),X,Q,de),void 0,de)}$providePasteEdits(q,W,X,Q,de,we,Te){return this.s(q,F,qe=>qe.providePasteEdits(W,p.URI.revive(X),Q,de,we,Te),void 0,Te)}$resolvePasteEdit(q,W,X){return this.s(q,F,Q=>Q.resolvePasteEdit(W,X),{},void 0)}$releasePasteEdits(q,W){this.s(q,F,X=>Promise.resolve(X.releasePasteEdits(W)),void 0,void 0)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Ae.w(q.decreaseIndentPattern),increaseIndentPattern:Ae.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ae.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ae.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Ae.w(q.beforeText),afterText:q.afterText?Ae.w(q.afterText):void 0,previousLineText:q.previousLineText?Ae.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Ae.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(W=>c.SyntaxTokenType.toString(W)):void 0}}static D(q){return q.map(Ae.C)}setLanguageConfiguration(q,W,X){const{wordPattern:Q}=X;if(Q&&(0,I.$lf)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(W,Q):this.h.setWordDefinitionFor(W,void 0),X.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),X.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const de=this.q(),we={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?Ae.w(X.wordPattern):void 0,indentationRules:X.indentationRules?Ae.y(X.indentationRules):void 0,onEnterRules:X.onEnterRules?Ae.B(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport,autoClosingPairs:X.autoClosingPairs?Ae.D(X.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(de,W,we),this.p(de)}$setWordDefinitions(q){for(const W of q)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$$lc=Ae}),define(ke[122],De([1,0,7,21,13,4,39,3,227,25,5,11,109,6,121,20,17,8,146,26]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=e.$Rmc=void 0,e.$Rmc=(0,I.$yi)("IExtHostLanguageModels");class r{constructor(o,h){this.option=o,this.stream=new l.$2h,this.stream=h??new l.$2h}}class t{constructor(){this.a=new Map,this.b=new l.$2h,this.c=!1,this.d=!1;const o=this;this.apiObject={stream:o.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,o]of this.a)yield o.stream;else yield this.b}handleFragment(o){if(this.c)return;this.d=!0;let h=this.a.get(o.index);h||(this.a.size===0?h=new r(o.index,this.b):h=new r(o.index),this.a.set(o.index,h)),h.stream.emitOne(o.part)}get isStreaming(){return this.d}reject(o){this.c=!0;for(const h of this.f())h.reject(o)}resolve(){this.c=!0;for(const o of this.f())o.resolve()}}let u=class{static{c=this}static{this.a=1}constructor(o,h,g){this.j=h,this.k=g,this.c=new A.$fe,this.d=new A.$fe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new E.$Vm,this.i=new Map,this.r=new Set,this.b=o.getProxy(S.$jM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(o,h,g,w){const k=c.a++;this.f.set(k,{extension:o.identifier,provider:g,languageModelId:h});let m;w.auth&&(m={providerLabel:o.displayName||o.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this.b.$registerLanguageModelProvider(k,`${E.$Tm.toKey(o.identifier)}/${k}/${h}`,{extension:o.identifier,id:h,vendor:w.vendor??E.$Tm.toKey(o.identifier),name:w.name??"",family:w.family??"",version:w.version,tokens:w.tokens,auth:m,targetExtensions:w.extensions});const y=g.onDidReceiveLanguageModelResponse2?.(({extensionId:D,participant:C,tokenCount:R})=>{this.b.$whenLanguageModelChatRequestMade(h,new E.$Tm(D),C,R)});return(0,b.$Sc)(()=>{this.f.delete(k),this.b.$unregisterProvider(k),y?.dispose()})}async $provideLanguageModelResponse(o,h,g,w,k,m){const y=this.f.get(o);if(!y)return;const D=new p.$hw(async C=>{if(m.isCancellationRequested){this.j.warn(`[CHAT](${y.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(h,{index:C.index,part:C.part})});return y.provider.provideLanguageModelResponse(w.map(f.LanguageModelChatMessage.to),k,E.$Tm.toKey(g),D,m)}$provideTokenLength(o,h,g){const w=this.f.get(o);return w?Promise.resolve(w.provider.provideTokenCount(h,g)):Promise.resolve(0)}$acceptChatModelMetadata(o){if(o.added)for(const{identifier:h,metadata:g}of o.added)this.g.set(h,{metadata:g,apiObjects:new E.$Vm});if(o.removed)for(const h of o.removed){this.g.delete(h);for(const[g,w]of this.i)w.languageModelId===h&&(w.res.reject(new L.$5),this.i.delete(g))}o.added?.forEach(h=>this.p(h.metadata)),this.d.fire(void 0)}async selectLanguageModels(o,h){const g=await this.b.$selectChatModels({...h,extension:o.identifier}),w=[],k=this;for(const m of g){const y=this.g.get(m);if(!y)continue;let D=y.apiObjects.get(o.identifier);D||(D={id:m,vendor:y.metadata.vendor,family:y.metadata.family,version:y.metadata.version,name:y.metadata.name,contextSize:y.metadata.tokens,countTokens(C,R){if(!k.g.has(m))throw a.$AO.NotFound(m);return k.q(m,C,R??O.CancellationToken.None)},sendRequest(C,R,T){if(!k.g.has(m))throw a.$AO.NotFound(m);return k.l(o,m,C,R??{},T??O.CancellationToken.None)}},Object.freeze(D),y.apiObjects.set(o.identifier,D)),w.push(D)}if(w.length!==0)return w}async l(o,h,g,w,k){const m=this.m(o,g),y=o.identifier,D=this.g.get(h)?.metadata;if(!D||!this.g.has(h))throw a.$AO.NotFound(`Language model '${h}' is unknown.`);if(this.o(y,D)&&(!await this.n(o,{identifier:D.extension,displayName:D.auth.providerLabel},w.justification,!1)||!this.h.get(y)?.has(D.extension)))throw a.$AO.NoPermissions(`Language model '${h}' cannot be used by '${y.value}'.`);const C=Math.random()*1e6|0,R=this.b.$fetchResponse(y,h,C,m,w.modelOptions??{},k),T=new l.$xh,j=new t;this.i.set(C,{languageModelId:h,res:j});let z;if(R.catch(N=>{T.isOpen()?j.reject(N):z=N}).finally(()=>{this.i.delete(C),j.resolve(),T.open()}),await T.wait(),z)throw z.name===a.$AO.name?z:new a.$AO(`Language model '${h}' errored, check cause for more details`,"Unknown",z);return j.apiObject}m(o,h){const g=[];for(const w of h)w.role===a.LanguageModelChatMessageRole.System&&(0,i.$LG)(o,"languageModelSystem"),g.push(f.LanguageModelChatMessage.from(w));return g}async $handleResponseFragment(o,h){const g=this.i.get(o);g&&g.res.handleFragment(h)}async n(o,h,g,w){const k=n.$lL+h.identifier.value;if(await this.k.getSession(o,k,[],{silent:!0}))return this.$updateModelAccesslist([{from:o.identifier,to:h.identifier,enabled:!0}]),!0;if(w)return!1;try{const y=g?(0,$.localize)(0,null,h.displayName,g):(0,$.localize)(1,null,h.displayName);return await this.k.getSession(o,k,[],{forceNewSession:{detail:y}}),this.$updateModelAccesslist([{from:o.identifier,to:h.identifier,enabled:!0}]),!0}catch{return!1}}o(o,h){return!!h.auth&&!E.$Tm.equals(h.extension,o)}async p(o){for(const h of this.r)try{await this.n(h,{identifier:o.extension,displayName:""},void 0,!0)}catch(g){this.j.error("Fake Auth request failed"),this.j.error(g)}}async q(o,h,g){if(!this.g.get(o))throw a.$AO.NotFound(`Language model '${o}' is unknown.`);const k=M.Iterable.find(this.f.values(),m=>m.languageModelId===o);return k?k.provider.provideTokenCount(h,g):this.b.$countTokens(o,typeof h=="string"?h:f.LanguageModelChatMessage.from(h),g)}$updateModelAccesslist(o){const h=new Array;for(const{from:g,to:w,enabled:k}of o){const m=this.h.get(g)??new E.$Um;if(m.has(w)!==k){k?m.add(w):m.delete(w),this.h.set(g,m);const D={from:g,to:w};h.push(D),this.c.fire(D)}}}createLanguageModelAccessInformation(o){this.r.add(o);const h=this,g=A.Event.signal(A.Event.filter(this.c.event,k=>E.$Tm.equals(k.from,o.identifier))),w=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(g,w)},canSendRequest(k){const m=h.g.get(k);if(!m)return;if(!h.o(o.identifier,m.metadata))return!0;const y=h.h.get(o.identifier);if(y)return y.has(m.metadata.extension)}}}};e.$Smc=u,e.$Smc=u=c=Je([We(0,d.$NO),We(1,P.$5j),We(2,v.$amc)],u)}),define(ke[345],De([1,0,6,17,8,41,7,3,26]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=void 0;class E{constructor(P,p,S,v){this.c=p,this.d=S,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(l.$jM.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,p){await this.a.$changeLanguage(P,p);const S=this.c.getDocumentData(P);if(!S)throw new Error(`document '${P.toString()}' NOT found`);return S.document}async tokenAtPosition(P,p){const S=P.version,v=O.Position.from(p),d=await this.a.$tokensAtPosition(P.uri,v),f={type:L.StandardTokenType.Other,range:P.getWordRangeAtPosition(p)??new L.$nM(p.line,p.character,p.line,p.character)};if(!d)return f;const a={range:O.Range.to(d.range),type:O.TokenType.to(d.type)};return!a.range.contains(p)||S!==P.version?f:a}createLanguageStatusItem(P,p,S){const v=this.f++,d=this.a,f=this.g,a=`${P.identifier.value}/${p}`;if(f.has(a))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);f.add(a);const n={selector:S,id:p,name:P.displayName??P.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const c=new b.$Tc,r=()=>{if(i?.dispose(),!f.has(a)){console.warn(`LanguageStatusItem (${p}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$Ah)(()=>{c.clear(),this.a.$setLanguageStatus(v,{id:a,name:n.name??P.displayName??P.name,source:P.displayName??P.name,selector:O.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===L.LanguageStatusSeverity.Error?A.default.Error:n.severity===L.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){c.dispose(),i?.dispose(),d.$removeLanguageStatus(v),f.delete(a)},get id(){return n.id},get name(){return n.name},set name(u){n.name=u,r()},get selector(){return n.selector},set selector(u){n.selector=u,r()},get text(){return n.text},set text(u){n.text=u,r()},set text2(u){(0,$.$LG)(P,"languageStatusText"),n.text=u,r()},get text2(){return(0,$.$LG)(P,"languageStatusText"),n.text},get detail(){return n.detail},set detail(u){n.detail=u,r()},get severity(){return n.severity},set severity(u){n.severity=u,r()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(u){n.accessibilityInformation=u,r()},get command(){return n.command},set command(u){n.command=u,r()},get busy(){return n.busy},set busy(u){n.busy=u,r()}};return r(),t}}e.$xnc=E}),define(ke[346],De([1,0,15,2,17,8,120]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=e.$jnc=void 0;class b{constructor(P,p,S,v){this.start=P,this.deletedCount=p,this.deletedItems=S,this.items=v}asApiEvent(){return{range:new A.$NN(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(P){return{EOL:P.eol,lines:P.source,languageId:P.language,uri:P.uri,isDirty:!1,versionId:1}}constructor(P,p,S){this.notebook=P,this.h=p,this.j=S,this.handle=S.handle,this.uri=O.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(L.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(S)}return this.f}setOutputs(P){this.a=P.map(L.NotebookCellOutput.to)}setOutputItems(P,p,S){const v=S.map(L.NotebookCellOutputItem.to),d=this.a.find(f=>f.id===P);if(d&&(p||(d.items.length=0),d.items.push(...v),d.items.length>1&&d.items.every(f=>M.$fK(f.mime)))){const f=new Map,a=[];d.items.forEach(n=>{let i;f.has(n.mime)?i=f.get(n.mime):(i=[],f.set(n.mime,i),a.push(n.mime)),i.push(n.data)}),d.items.length=0,a.forEach(n=>{const i=M.$gK(f.get(n));d.items.push({mime:n,data:i.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$jnc=$;class E{static{this.a=0}constructor(P,p,S,v,d){this.k=P,this.l=p,this.m=S,this.uri=v,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,p={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===l.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(S){return S=P.n(S),P.b[S].apiCell},getCells(S){return(S?P.p(S):P.b).map(d=>d.apiCell)},save(){return P.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,p,S){this.g=P.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:S});const v={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},d=[];for(const a of P.rawEvents)a.kind===M.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,v.contentChanges):a.kind===M.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,v.contentChanges):a.kind===M.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),d.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===M.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),d.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),d.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===M.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),d.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),d.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const f=new Map;for(let a=0;a<d.length;a++){const n=d[a],i=f.get(n.cell);if(i===void 0){const c=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});f.set(n.cell,c-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let p=P.start|0,S=P.end|0;return p<0&&(p=0),S>this.b.length&&(S=this.b.length),P.with({start:p,end:S})}p(P){P=this.o(P);const p=[];for(let S=P.start;S<P.end;S++)p.push(this.b[S]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,p,S){if(this.j)return;const v=[],d=[],f=[];if(P.reverse().forEach(a=>{const i=a[2].map(t=>{const u=new $(this,this.l,t);return p||d.push($.asModelAddData(t)),u}),c=new b(a[0],a[1],[],i),r=this.b.splice(a[0],a[1],...i);for(const t of r)f.push(t.uri),c.deletedItems.push(t.apiCell);v.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:f}),S)for(const a of v)S.push(a.asApiEvent())}s(P,p,S,v){const d=this.b.splice(P,p);this.b.splice(S,0,...d);const f=[new b(P,p,d.map(a=>a.apiCell),[]),new b(S,0,[],d)];for(const a of f)v.push(a.asApiEvent())}t(P,p){this.b[P].setOutputs(p)}u(P,p,S,v){this.b[P].setOutputItems(p,S,v)}v(P,p){const S=this.b[P];S.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(S.uri,p)}w(P,p){const S=this.b[P];S.apiCell.mime=p}x(P,p){this.b[P].setMetadata(p)}y(P,p){this.b[P].setInternalMetadata(p)}getCellFromApiCell(P){return this.b.find(p=>p.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(p=>p.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$knc=E}),define(ke[347],De([1,0,4,2,17,8,48]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;class b{constructor(E,I,P,p={timeout:1500,errors:3}){this.b=E,this.c=I,this.d=P,this.f=p,this.a=new l.$he}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(I,P,p)=>{const S=function(d){I.call(P,d)};return S.extension=E,this.a.event(S,void 0,p)}}async $participateInSave(E,I,P){const p=O.URI.revive(E),S=this.c.getNotebookDocument(p);if(!S)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:S.apiNotebook,reason:L.TextDocumentSaveReason.to(I)},P,async(f,a)=>{const n=Date.now(),i=await await Promise.resolve(f);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!P.isCancellationRequested&&i&&(i instanceof A.$vM?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(v.length===0)return!0;const d={edits:[]};for(const f of v){const{edits:a}=L.WorkspaceEdit.from(f);d.edits=d.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new M.$Fw(d))}}e.$znc=b}),define(ke[154],De([1,0,13,17,8]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,E,I,P,p){this.id=b,this.f=$,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=I,this.c=p}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(L.$NN.isNotebookRange))throw(0,l.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,E){b.f.$tryRevealRange(b.id,O.NotebookRange.from($),E??L.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(O.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$lnc=A}),define(ke[348],De([1,0,4,11,17]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=void 0;let A=class{constructor(b,$){this.c=b,this.d=$,this.a=new l.$fe,this.b=new l.$fe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const E=this.d.getEditorById(b);$.visibleRanges&&E._acceptVisibleRanges($.visibleRanges.ranges.map(L.NotebookRange.to)),$.selections&&E._acceptSelections($.selections.selections.map(L.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(L.ViewColumn.to(b[$]))}};e.$Bnc=A,e.$Bnc=A=Je([We(0,O.$5j)],A)}),define(ke[349],De([1,0,4,6,154]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=void 0;class A{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(O.$jM.MainThreadNotebookRenderers)}$postRendererMessage(b,$,E){const I=this.c.getEditorById(b);this.a.get($)?.fire({editor:I.apiEditor,message:E})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(I=>I.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(I,P,p)=>this.d($).event(I,P,p),postMessage:(I,P)=>{L.$lnc.apiEditorsToExtHost.has(I)&&([I,P]=[P,I]);const p=P&&L.$lnc.apiEditorsToExtHost.get(P);return this.b.$postMessage(p?.id,$,I)}}}d(b){let $=this.a.get(b);return $||($=new l.$fe({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$Enc=A}),define(ke[350],De([1,0,17,109,21,56,13]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Inc=void 0;class b{constructor(P){this.b=0,this.c=new Map,this.a=P}async withProgress(P,p,S){const v=this.b++,{title:d,location:f,cancellable:a}=p,n={label:P.displayName||P.name,id:P.identifier.value};return this.a.$startProgress(v,{location:l.ProgressLocation.from(f),title:d,source:n,cancellable:a},P.isUnderDevelopment?void 0:P.identifier.value).catch(M.$2),this.d(v,S,!!a)}d(P,p,S){let v;S&&(v=new L.$qe,this.c.set(P,v));const d=a=>{this.a.$progressEnd(a),this.c.delete(a),v?.dispose()};let f;try{f=p(new E(this.a,P),S&&v?v.token:L.CancellationToken.None)}catch(a){throw d(P),a}return f.then(a=>d(P),a=>d(P)),f}$acceptProgressCanceled(P){const p=this.c.get(P);p&&(p.cancel(),this.c.delete(P))}}e.$Inc=b;function $(I,P){return I.message=P.message,typeof P.increment=="number"&&(typeof I.increment=="number"?I.increment+=P.increment:I.increment=P.increment),I}class E extends O.$hw{constructor(P,p){super(S=>this.throttledReport(S)),this.c=P,this.d=p}throttledReport(P){this.c.$progressReport(this.d,P)}}Je([(0,A.$5h)(100,(I,P)=>$(I,P),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(ke[351],De([1,0,2,6,7,17]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0;class M{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(O.$jM.MainThreadQuickDiff)}$provideOriginalResource($,E,I){const P=l.URI.revive(E),p=this.c.get($);return p?(0,L.$qh)(()=>p.provideOriginalResource(P,I)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider($,E,I,P){const p=M.a++;return this.c.set(p,E),this.b.$registerQuickDiffProvider(p,A.DocumentSelector.from($,this.d),I,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$Jnc=M}),define(ke[352],De([1,0,21,4,3,6,2,8,13,19,41,50,26,17]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=v;function v(d,f,a){const n=d.getProxy(A.$jM.MainThreadQuickOpen);class i{constructor(w,k){this.e=new Map,this.f=0,this.a=w,this.b=k}showQuickPick(w,k,m,y=l.CancellationToken.None){this.c=void 0;const D=Promise.resolve(k),C=++this.f,R=n.$show(C,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},y),T={},j=R.then(()=>T);return Promise.race([j,D]).then(z=>{if(z===T)return;const N=(0,p.$KG)(w,"quickPickItemTooltip");return D.then(F=>{const B=[];for(let Y=0;Y<F.length;Y++){const re=F[Y];if(typeof re=="string")B.push({label:re,handle:Y});else if(re.kind===b.QuickPickItemKind.Separator)B.push({type:"separator",label:re.label});else{re.tooltip&&!N&&console.warn(`Extension '${w.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`);const H=re.iconPath?s(re.iconPath):void 0;B.push({label:re.label,iconPath:H?.iconPath,iconClass:H?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:N?S.MarkdownString.fromStrict(re.tooltip):void 0,handle:Y})}}return m&&typeof m.onDidSelectItem=="function"&&(this.c=Y=>{m.onDidSelectItem(F[Y])}),n.$setItems(C,B),R.then(Y=>{if(typeof Y=="number")return F[Y];if(Array.isArray(Y))return Y.map(re=>F[re])})})}).then(void 0,z=>{if(!(0,$.$4)(z))return n.$setError(C,z),Promise.reject(z)})}$onItemSelected(w){this.c?.(w)}showInput(w,k=l.CancellationToken.None){return this.d=w?.validateInput,n.$input(w,typeof this.d=="function",k).then(void 0,m=>{if(!(0,$.$4)(m))return Promise.reject(m)})}async $validateInput(w){if(!this.d)return;const k=await this.d(w);if(!k||typeof k=="string")return k;let m;switch(k.severity){case b.InputBoxValidationSeverity.Info:m=I.default.Info;break;case b.InputBoxValidationSeverity.Warning:m=I.default.Warning;break;case b.InputBoxValidationSeverity.Error:m=I.default.Error;break;default:m=k.message?I.default.Error:I.default.Ignore;break}return{content:k.message,severity:m}}async showWorkspaceFolderPick(w,k=l.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[w]);if(!m)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(D=>D.uri.toString()===m.uri.toString())}createQuickPick(w){const k=new o(w,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(w){const k=new h(w,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(w,k){this.e.get(w)?._fireDidChangeValue(k)}$onDidAccept(w){this.e.get(w)?._fireDidAccept()}$onDidChangeActive(w,k){const m=this.e.get(w);m instanceof o&&m._fireDidChangeActive(k)}$onDidChangeSelection(w,k){const m=this.e.get(w);m instanceof o&&m._fireDidChangeSelection(k)}$onDidTriggerButton(w,k){this.e.get(w)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(w,k,m){const y=this.e.get(w);y instanceof o&&y._fireDidTriggerItemButton(k,m)}$onDidHide(w){this.e.get(w)?._fireDidHide()}}class c{static{this.a=1}constructor(w,k){this.x=w,this.y=k,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$fe,this.q=new O.$fe,this.r=new O.$fe,this.s=new O.$fe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(w){this.b=w,this.z({title:w})}get step(){return this.c}set step(w){this.c=w,this.z({step:w})}get totalSteps(){return this.d}set totalSteps(w){this.d=w,this.z({totalSteps:w})}get enabled(){return this.g}set enabled(w){this.g=w,this.z({enabled:w})}get busy(){return this.j}set busy(w){this.j=w,this.z({busy:w})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(w){this.k=w,this.z({ignoreFocusOut:w})}get value(){return this.l}set value(w){this.l=w,this.z({value:w})}get placeholder(){return this.m}set placeholder(w){this.m=w,this.z({placeholder:w})}get buttons(){return this.n}set buttons(w){this.n=w.slice(),this.o.clear(),w.forEach((k,m)=>{const y=k===b.$KN.Back?-1:m;this.o.set(y,k)}),this.z({buttons:w.map((k,m)=>({...s(k.iconPath),tooltip:k.tooltip,handle:k===b.$KN.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(w){this.l=w,this.q.fire(w)}_fireDidTriggerButton(w){const k=this.o.get(w);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(w){if(!this.v){for(const k of Object.keys(w)){const m=w[k];this.u[k]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function r(g){if(g instanceof b.$iN)return{id:g.id};const w=u(g),k=t(g);return{dark:typeof w=="string"?M.URI.file(w):w,light:typeof k=="string"?M.URI.file(k):k}}function t(g){return typeof g=="object"&&"light"in g?g.light:g}function u(g){return typeof g=="object"&&"dark"in g?g.dark:g}function s(g){const w=r(g);let k,m;return"id"in w?m=P.ThemeIcon.asClassName(w):k=w,{iconPath:k,iconClass:m}}class o extends c{constructor(w,k){super(w.identifier,k),this.O=w,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$fe,this.L=[],this.M=new O.$fe,this.N=new O.$fe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(w){this.B=w.slice(),this.C.clear(),this.D.clear(),w.forEach((y,D)=>{this.C.set(D,y),this.D.set(y,D)});const k=(0,p.$KG)(this.O,"quickPickItemTooltip"),m=[];for(let y=0;y<w.length;y++){const D=w[y];if(D.kind===b.QuickPickItemKind.Separator)m.push({type:"separator",label:D.label});else{D.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=D.iconPath?s(D.iconPath):void 0;m.push({handle:y,label:D.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:k?S.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((R,T)=>({...s(R.iconPath),tooltip:R.tooltip,handle:T}))})}}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(w){this.E=w,this.z({canSelectMany:w})}get matchOnDescription(){return this.F}set matchOnDescription(w){this.F=w,this.z({matchOnDescription:w})}get matchOnDetail(){return this.G}set matchOnDetail(w){this.G=w,this.z({matchOnDetail:w})}get sortByLabel(){return this.H}set sortByLabel(w){this.H=w,this.z({sortByLabel:w})}get keepScrollPosition(){return this.I}set keepScrollPosition(w){this.I=w,this.z({keepScrollPosition:w})}get activeItems(){return this.J}set activeItems(w){this.J=w.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(w){this.L=w.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(w){const k=(0,E.$Hb)(w.map(m=>this.C.get(m)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(w){const k=(0,E.$Hb)(w.map(m=>this.C.get(m)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(w,k){const m=this.C.get(w);if(!m||!m.buttons||!m.buttons.length)return;const y=m.buttons[k];y&&this.N.fire({button:y,item:m})}}class h extends c{constructor(w,k){super(w.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(w){this.B=w,this.z({password:w})}get prompt(){return this.C}set prompt(w){this.C=w,this.z({prompt:w})}get valueSelection(){return this.D}set valueSelection(w){this.D=w,this.z({valueSelection:w})}get validationMessage(){return this.E}set validationMessage(w){this.E=w,w?typeof w=="string"?this.z({validationMessage:w,severity:I.default.Error}):this.z({validationMessage:w.message,severity:w.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(f,a)}}),define(ke[353],De([1,0,2,4,56,3,7,6,19,132,11,25,50,17,26,15,12]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=e.$Lnc=void 0;function n(C){return C instanceof l.URI}function i(C,R){return C.scheme===d.Schemas.file&&R.scheme===d.Schemas.file&&f.$k?C.toString()===R.toString():C.toString().toLowerCase()===R.toString().toLowerCase()}function c(C){if(C)return typeof C.iconPath=="string"?l.URI.file(C.iconPath):l.URI.isUri(C.iconPath)||p.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function r(C){if(C.icon){if(l.URI.isUri(C.icon))return C.icon;if(p.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const R=C.icon;return{light:R.light,dark:R.dark}}}else return}function t(C,R){if(!C.iconPath&&!R.iconPath)return 0;if(C.iconPath){if(!R.iconPath)return 1}else return-1;const T=typeof C.iconPath=="string"?C.iconPath:l.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,j=typeof R.iconPath=="string"?R.iconPath:l.URI.isUri(R.iconPath)?R.iconPath.fsPath:R.iconPath.id;return(0,E.$ur)(T,j)}function u(C,R){let T=0;if(C.strikeThrough!==R.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==R.faded)return C.faded?1:-1;if(C.tooltip!==R.tooltip)return(C.tooltip||"").localeCompare(R.tooltip||"");if(T=t(C,R),T!==0)return T;if(C.light&&R.light)T=t(C.light,R.light);else{if(C.light)return 1;if(R.light)return-1}if(T!==0)return T;if(C.dark&&R.dark)T=t(C.dark,R.dark);else{if(C.dark)return 1;if(R.dark)return-1}return T}function s(C,R){if(C.command!==R.command)return C.command<R.command?-1:1;if(C.title!==R.title)return C.title<R.title?-1:1;if(C.tooltip!==R.tooltip){if(C.tooltip!==void 0&&R.tooltip!==void 0)return C.tooltip<R.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(R.tooltip!==void 0)return-1}if(C.arguments===R.arguments)return 0;if(C.arguments)if(R.arguments){if(C.arguments.length!==R.arguments.length)return C.arguments.length-R.arguments.length}else return 1;else return-1;for(let T=0;T<C.arguments.length;T++){const j=C.arguments[T],z=R.arguments[T];if(j!==z&&!(n(j)&&n(z)&&i(j,z)))return j<z?-1:1}return 0}function o(C,R){let T=(0,E.$ur)(C.resourceUri.fsPath,R.resourceUri.fsPath,!0);if(T!==0)return T;if(C.command&&R.command)T=s(C.command,R.command);else{if(C.command)return 1;if(R.command)return-1}if(T!==0)return T;if(C.decorations&&R.decorations)T=u(C.decorations,R.decorations);else{if(C.decorations)return 1;if(R.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&R.multiFileDiffEditorModifiedUri)T=(0,E.$ur)(C.multiFileDiffEditorModifiedUri.fsPath,R.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(R.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&R.multiDiffEditorOriginalUri)T=(0,E.$ur)(C.multiDiffEditorOriginalUri.fsPath,R.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(R.multiDiffEditorOriginalUri)return-1}return T}function h(C,R){for(let T=0;T<C.length;T++)if(C[T]!==R[T])return!1;return!0}function g(C,R){return C.command===R.command&&C.title===R.title&&C.tooltip===R.tooltip&&(C.arguments&&R.arguments?h(C.arguments,R.arguments):C.arguments===R.arguments)}function w(C,R){return(0,$.$ub)(C,R,g)}class k{#e;#t;get value(){return this.d}set value(R){R=R??"",this.#e.$setInputBoxValue(this.l,R),this.n(R)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(R){this.#e.$setInputBoxPlaceholder(this.l,R),this.f=R}get validateInput(){return(0,v.$LG)(this.k,"scmValidation"),this.g}set validateInput(R){if((0,v.$LG)(this.k,"scmValidation"),R&&typeof R!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=R,this.#e.$setValidationProviderIsEnabled(this.l,!!R)}get enabled(){return this.h}set enabled(R){R=!!R,this.h!==R&&(this.h=R,this.#e.$setInputBoxEnablement(this.l,R))}get visible(){return this.j}set visible(R){R=!!R,this.j!==R&&(this.j=R,this.#e.$setInputBoxVisibility(this.l,R))}get document(){return(0,v.$LG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(R,T,j,z,N){this.k=R,this.l=z,this.m=N,this.d="",this.e=new O.$fe,this.f="",this.h=!0,this.j=!0,this.#t=T,this.#e=j}showValidationMessage(R,T){(0,v.$LG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,R,T)}$onInputBoxValueChange(R){this.n(R)}n(R){this.d=R,this.e.fire(R)}}e.$Lnc=k;class m{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(R){this.v=R,this.q.$updateGroupLabel(this.t,this.handle,R)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(R){this.p=R,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(R){this.f=[...R],this.k.fire()}constructor(R,T,j,z,N,F,B){this.q=R,this.s=T,this.t=j,this.u=z,this.v=N,this.multiDiffEditorEnableViewChanges=F,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$fe,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$fe,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=m.d++}getResourceState(R){return this.g.get(R)}$executeResourceCommand(R,T){const j=this.h.get(R);return j?(0,M.$qh)(()=>this.s.executeCommand(j.command,...j.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const R=[...this.f].sort(o),j=(0,$.$Db)(this.o,R,o).map(F=>{const B=F.toInsert.map(Y=>{const re=this.e++;this.g.set(re,Y);const H=Y.resourceUri;let K;if(Y.command)if(Y.command.command==="vscode.open"||Y.command.command==="vscode.diff"||Y.command.command==="vscode.changes"){const le=new A.$Tc;K=this.s.converter.toInternal(Y.command,le),this.j.set(re,le)}else this.h.set(re,Y.command);const _=(0,v.$KG)(this.w,"scmMultiDiffEditor"),Z=_?Y.multiDiffEditorOriginalUri:void 0,$e=_?Y.multiFileDiffEditorModifiedUri:void 0,oe=c(Y.decorations),Pe=Y.decorations&&c(Y.decorations.light)||oe,te=Y.decorations&&c(Y.decorations.dark)||oe,U=[Pe,te],ee=Y.decorations&&Y.decorations.tooltip||"",be=Y.decorations&&!!Y.decorations.strikeThrough,ue=Y.decorations&&!!Y.decorations.faded,ce=Y.contextValue||"";return{rawResource:[re,H,U,ee,be,ue,ce,K,Z,$e],handle:re}});return{start:F.start,deleteCount:F.deleteCount,toInsert:B}}),z=j.map(({start:F,deleteCount:B,toInsert:Y})=>[F,B,Y.map(re=>re.rawResource)]),N=j.reverse();for(const{start:F,deleteCount:B,toInsert:Y}of N){const re=Y.map(K=>K.handle),H=this.n.splice(F,B,...re);for(const K of H)this.g.delete(K),this.h.delete(K),this.j.get(K)?.dispose(),this.j.delete(K)}return this.o=R,z}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(R){this.g!==R&&(this.g=R,this.#e.$updateSourceControl(this.w,{count:R}))}get quickDiffProvider(){return this.h}set quickDiffProvider(R){this.h=R;let T;(0,v.$KG)(this.x,"quickDiffProvider")&&(T=R?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!R,quickDiffLabel:T})}get historyProvider(){return(0,v.$LG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(R){(0,v.$LG)(this.x,"scmHistoryProvider"),this.j=R,this.k.value=new A.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!R}),R&&this.k.value.add(R.onDidChangeCurrentHistoryItemGroup(()=>{this.l=R?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(R){R!==this.m&&(this.m=R,this.#e.$updateSourceControl(this.w,{commitTemplate:R}))}get acceptInputCommand(){return this.o}set acceptInputCommand(R){this.n.value=new A.$Tc,this.o=R;const T=this.y.converter.toInternal(R,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:T})}get actionButton(){return(0,v.$LG)(this.x,"scmActionButton"),this.q}set actionButton(R){(0,v.$LG)(this.x,"scmActionButton"),this.p.value=new A.$Tc,this.q=R;const T=R!==void 0?{command:this.y.converter.toInternal(R.command,this.p.value),secondaryCommands:R.secondaryCommands?.map(j=>j.map(z=>this.y.converter.toInternal(z,this.p.value))),description:R.description,enabled:R.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:T??null})}get statusBarCommands(){return this.t}set statusBarCommands(R){if(this.t&&R&&w(this.t,R))return;this.s.value=new A.$Tc,this.t=R;const T=(R||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:T})}get selected(){return this.u}constructor(R,T,j,z,N,F,B){this.x=R,this.y=z,this.z=N,this.A=F,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Vc,this.m=void 0,this.n=new A.$Vc,this.o=void 0,this.p=new A.$Vc,this.s=new A.$Vc,this.t=void 0,this.u=!1,this.v=new O.$fe,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=j;const Y=l.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new k(R,T,this.#e,this.w,Y),this.#e.$registerSourceControl(this.w,N,F,B,Y)}createResourceGroup(R,T,j){const z=(0,v.$KG)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,N=new m(this.#e,this.y,this.w,R,T,z,this.x),F=O.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,F),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const R=[],T=[];for(const[j,z]of this.C){z.dispose();const N=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});O.Event.once(j.onDidDispose)(()=>{this.D.delete(j),N.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),R.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const F=j._takeResourceStateSnapshot();F.length>0&&T.push([j.handle,F]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,R,T),this.C.clear()}eventuallyUpdateResourceStates(){const R=[];this.D.forEach(T=>{const j=T._takeResourceStateSnapshot();j.length!==0&&R.push([T.handle,j])}),R.length>0&&this.#e.$spliceResourceStates(this.w,R),this.D.clear()}getResourceGroup(R){return this.e.get(R)}setSelectionState(R){this.u=R,this.v.fire(R)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(R=>R.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,L.$4h)(100)],y.prototype,"eventuallyAddResourceGroups",null),Je([(0,L.$4h)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{a=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(R,T,j,z){this.l=T,this.m=j,this.n=z,this.g=new Map,this.h=new P.$Vm,this.j=new O.$fe,this.e=R.getProxy(b.$jM.MainThreadSCM),this.f=R.getProxy(b.$jM.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const F=this.g.get(N.sourceControlHandle);if(!F)return N;const B=F.getResourceGroup(N.groupHandle);return B?B.getResourceState(N.handle):N}else if(N&&N.$mid===4){const F=this.g.get(N.sourceControlHandle);return F?F.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const F=this.g.get(N.handle);return F||N}return N}})}createSourceControl(R,T,j,z){this.n.trace("ExtHostSCM#createSourceControl",R.identifier.value,T,j,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:R.identifier.value});const N=a.d++,F=new y(R,this.m,this.e,this.l,T,j,z);this.g.set(N,F);const B=this.h.get(R.identifier)||[];return B.push(F),this.h.set(R.identifier,B),F}getLastInputBox(R){this.n.trace("ExtHostSCM#getLastInputBox",R.identifier.value);const T=this.h.get(R.identifier),j=T&&T[T.length-1];return j&&j.inputBox}$provideOriginalResource(R,T,j){const z=l.URI.revive(T);this.n.trace("ExtHostSCM#$provideOriginalResource",R,z.toString());const N=this.g.get(R);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$qh)(()=>N.quickDiffProvider.provideOriginalResource(z,j)).then(F=>F||null)}$onInputBoxValueChange(R,T){this.n.trace("ExtHostSCM#$onInputBoxValueChange",R);const j=this.g.get(R);return j&&j.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(R,T,j,z){this.n.trace("ExtHostSCM#$executeResourceCommand",R,T,j);const N=this.g.get(R);if(!N)return Promise.resolve(void 0);const F=N.getResourceGroup(T);return F?F.$executeResourceCommand(j,z):Promise.resolve(void 0)}$validateInput(R,T,j){this.n.trace("ExtHostSCM#$validateInput",R);const z=this.g.get(R);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,M.$qh)(()=>z.inputBox.validateInput(T,j)).then(N=>{if(!N)return Promise.resolve(void 0);const F=S.MarkdownString.fromStrict(N.message);return F?Promise.resolve([F,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(R){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",R),R!==void 0&&this.g.get(R)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=R,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(R,T,j,z){return await this.g.get(R)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(T,j,z)??void 0}async $provideHistoryItems(R,T,j,z){return(await this.g.get(R)?.historyProvider?.provideHistoryItems(T,j,z))?.map(B=>({...B,icon:r(B)}))??void 0}async $provideHistoryItemSummary(R,T,j,z){const N=this.g.get(R)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const F=await N.provideHistoryItemSummary(T,j,z);return F?{...F,icon:r(F)}:void 0}async $provideHistoryItemChanges(R,T,j,z){return await this.g.get(R)?.historyProvider?.provideHistoryItemChanges(T,j,z)??void 0}};e.$Mnc=D,e.$Mnc=D=a=Je([We(3,I.$5j)],D)}),define(ke[354],De([1,0,6,17,2]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=void 0;class A{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(l.$jM.MainThreadShare)}async $provideShare(b,$,E){return await this.c.get(b)?.provideShare({selection:O.Range.to($.selection),resourceUri:L.URI.revive($.resourceUri)},E)??void 0}registerShareProvider(b,$){const E=A.a++;return this.c.set(E,$),this.b.$registerShareProvider(E,O.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Nnc=A}),define(ke[355],De([1,0,8,6,230,3,17,18]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=e.$Pnc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new l.$jN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.$jN("statusBarItem.warningForeground")]])}#e;#t;constructor(p,S,v,d,f,a=l.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new A.$Tc,this.#e=p,this.#t=S,f&&d){this.c=(0,l.$XM)(d.identifier,f);const i=v.get(this.c);i&&(a=i.alignLeft?l.StatusBarAlignment.Left:l.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=d,this.f=f,this.g=a,this.h=this.u(n)}u(p){if((0,b.$cg)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!$.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new A.$Tc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let S;this.m?S=this.m:S=(0,L.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=$.b.get(this.o.id));const d=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,S,this.k,d,this.r?.internal,v,this.o,this.g===l.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Pnc=$;class E{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const S={message:p};return this.b.unshift(S),this.c(),new l.$lM(()=>{const v=this.b.indexOf(S);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(p,S){this.e=new Map,this.a=p.getProxy(O.$jM.MainThreadStatusBar),this.b=S,this.c=new E(this)}$acceptStaticEntries(p){for(const S of p)this.e.set(S.entryId,S)}createStatusBarEntry(p,S,v,d){return new $(this.a,this.b,this.e,p,S,v,d)}setStatusBarMessage(p,S){const v=this.c.setMessage(p);let d;return typeof S=="number"?d=setTimeout(()=>v.dispose(),S):typeof S<"u"&&S.then(()=>v.dispose(),()=>v.dispose()),new l.$lM(()=>{v.dispose(),clearTimeout(d)})}}e.$Qnc=I}),define(ke[155],De([1,0,29,145,69,113,89,17,2]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=e.$2O=e.$1O=e.$ZO=void 0;const E=(i,c,r,t)=>{let u=c;return{enumerable:!0,configurable:!1,get(){return u},set(s){if(!r(u,s)){const o=u;u=s,i.listener?.(t(s,o))}}}},I=(i,c)=>i===c,P={range:(i,c)=>i===c?!0:!i||!c?!1:i.isEqual(c),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,c)=>!(i.length!==c.length||i.some(r=>!c.find(t=>r.id===t.id)))},p=i=>c=>({op:4,update:i(c)}),S=(i,c)=>({range:(()=>{let r;const t=p(u=>({range:l.$yt.lift(b.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return r},set(u){i.listener?.({op:6}),P.range(r,u)||(r=u,i.listener?.(t(u)))}}})(),label:E(i,c,P.label,p(r=>({label:r}))),description:E(i,void 0,P.description,p(r=>({description:r}))),sortText:E(i,void 0,P.sortText,p(r=>({sortText:r}))),canResolveChildren:E(i,!1,P.canResolveChildren,r=>({op:2,state:r})),busy:E(i,!1,P.busy,p(r=>({busy:r}))),error:E(i,void 0,P.error,p(r=>({error:b.MarkdownString.fromStrict(r)||null}))),tags:E(i,[],P.tags,(r,t)=>({op:1,new:r.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),v=i=>{const c=L.$8K.fromString(i.extId),r=new f(c.controllerId,c.localId,i.label,$.URI.revive(i.uri)||void 0);return r.range=b.Range.to(i.range||void 0),r.description=i.description||void 0,r.sortText=i.sortText||void 0,r.tags=i.tags.map(t=>b.TestTag.to({id:(0,M.$bL)(t).tagId})),r},d=i=>{let c;for(const r of i.tests){const t=v(r.item);(0,O.$JO)(t).parent=c,c=t}return c};e.$ZO=d;class f{constructor(c,r,t,u){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const s=(0,O.$IO)(this,c);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof a?void 0:s.parent}},children:{value:(0,A.$HO)(s,O.$JO,f),enumerable:!0,writable:!1},...S(s,t)})}}e.$1O=f;class a extends f{constructor(c,r){super(c,c,r,void 0),this._isRoot=!0}}e.$2O=a;class n extends A.$DO{constructor(c,r,t){super({controllerId:c,getDocumentVersion:u=>u&&t.getDocument(u)?.version,getApiFor:O.$JO,getChildren:u=>u.children,root:new a(c,r),toITestItem:b.TestItem.from})}}e.$3O=n}),define(ke[34],De([1,0,18,8,17,24,6,19,11,58,29,51,2,3,5,20,155,22,48,47,40,87,90,30]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c,r,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=void 0;let s=class{#e;#t;#n;constructor(m,y,D){this.b=new Map,this.c=new Map,this.#e=m.getProxy(M.$jM.MainThreadCommands),this.d=y,this.#n=D,this.#t=m.getProxy(M.$jM.MainThreadTelemetry),this.converter=new o(this,C=>{const R=this.c.get(C);return R?.result===g.Void?R:void 0},y),this.f=[{processArgument(C){return(0,E.$8h)(C)}},{processArgument(C){return(0,A.$7n)(C,function(R){if(I.$yt.isIRange(R))return L.Range.to(R);if(P.$xt.isIPosition(R))return L.Position.to(R);if(I.$yt.isIRange(R.range)&&p.URI.isUri(R.uri))return L.location.to(R);if(R instanceof a.$He)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(m){this.f.push(m)}registerApiCommand(m){const y=this.registerCommand(!1,m.id,async(...D)=>{const C=m.args.map((T,j)=>{if(!T.validate(D[j]))throw new Error(`Invalid argument '${T.name}' when running '${m.id}', received: ${typeof D[j]=="object"?JSON.stringify(D[j],null,"	"):D[j]} `);return T.convert(D[j])}),R=await this.executeCommand(m.internalId,...C);return m.result.convert(R,D,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this.c.set(m.id,m),new O.$lM(()=>{y.dispose(),this.c.delete(m.id)})}registerCommand(m,y,D,C,R,T){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:D,thisArg:C,metadata:R,extension:T}),m&&this.#e.$registerCommand(y),new O.$lM(()=>{this.b.delete(y)&&m&&this.#e.$unregisterCommand(y)})}executeCommand(m,...y){return this.d.trace("ExtHostCommands#executeCommand",m),this.g(m,y,!0)}async g(m,y,D){if(this.b.has(m))return this.#e.$fireCommandActivationEvent(m),this.h(m,y,!1);{let C=!1;const R=(0,A.$7n)(y,function(T){if(T instanceof O.$mM)return L.Position.from(T);if(T instanceof O.$nM)return L.Range.from(T);if(T instanceof O.$xM)return L.location.from(T);if(O.$NN.isNotebookRange(T))return L.NotebookRange.from(T);if(T instanceof ArrayBuffer)return C=!0,a.$He.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return C=!0,a.$He.wrap(T);if(T instanceof a.$He)return C=!0,T;if(!Array.isArray(T))return T});try{const T=await this.#e.$executeCommand(m,C?new n.$Fw(R):R,D);return(0,E.$8h)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this.g(m,y,!1);throw T}}}async h(m,y,D){const C=this.b.get(m);if(!C)throw new Error("Unknown command");const{callback:R,thisArg:T,metadata:j}=C;if(j?.args)for(let N=0;N<j.args.length;N++)try{(0,l.$pg)(y[N],j.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${j.args[N].name}' - ${j.args[N].description}`)}const z=c.$be.create();try{return await R.apply(T,y)}catch(N){if(m===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...y);F&&(m=F.command)}if(this.d.error(N,m,C.extension?.identifier),!D)throw N;if(C.extension?.identifier){const F=this.#n.onExtensionError(C.extension.identifier,N);this.d.trace("forwarded error to extension?",F,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$jj)(N)),this.id=m,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,m,z.elapsed())}}j(m,y,D){m.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new r.$jp(y),duration:D})}$executeContributedCommand(m,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",m);const D=this.b.get(m);return D?(y=y.map(C=>this.f.reduce((R,T)=>T.processArgument(R,D.extension?.identifier),C)),this.h(m,y,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this.d.trace("ExtHostCommands#getCommands",m),this.#e.$getCommands().then(y=>(m&&(y=y.filter(D=>D[0]!=="_")),y))}$getContributedCommandMetadata(){const m=Object.create(null);for(const[y,D]of this.b){const{metadata:C}=D;C&&(m[y]=C)}return Promise.resolve(m)}};e.$9O=s,e.$9O=s=Je([We(0,d.$NO),We(1,$.$5j),We(2,t.$8O)],s),e.$0O=(0,v.$yi)("IExtHostCommands");class o{constructor(m,y,D){this.d=m,this.f=y,this.g=D,this.delegatingCommandId=`__vsc${(0,u.$Ug)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(m,y){if(!m)return;const D={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return D;const C=this.f(m.command);if(C)D.id=C.internalId,D.arguments=C.args.map((R,T)=>R.convert(m.arguments&&m.arguments[T]));else if((0,b.$Lb)(m.arguments)){const R=`${m.command} /${++this.c}`;this.b.set(R,m),y.add((0,S.$Sc)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),D.$ident=R,D.id=this.delegatingCommandId,D.arguments=[R],this.g.trace("CommandsConverter#CREATE",m.command,R)}return D}fromInternal(m){return typeof m.$ident=="string"?this.b.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this.b.get(m[0])}h(...m){const y=this.getActualCommand(...m);return this.g.trace("CommandsConverter#EXECUTE",m[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.$$O=o;class h{static{this.Uri=new h("uri","Uri of a text document",m=>p.URI.isUri(m),m=>m)}static{this.Position=new h("position","A position in a text document",m=>O.$mM.isPosition(m),L.Position.from)}static{this.Range=new h("range","A range in a text document",m=>O.$nM.isRange(m),L.Range.from)}static{this.Selection=new h("selection","A selection in a text document",m=>O.$oM.isSelection(m),L.Selection.from)}static{this.Number=new h("number","",m=>typeof m=="number",m=>m)}static{this.String=new h("string","",m=>typeof m=="string",m=>m)}static{this.StringArray=h.Arr(h.String)}static Arr(m){return new h(`${m.name}_array`,`Array of ${m.name}, ${m.description}`,y=>Array.isArray(y)&&y.every(D=>m.validate(D)),y=>y.map(D=>m.convert(D)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",m=>m instanceof O.$JM,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",m=>m instanceof O.$8N,L.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",m=>m instanceof f.$1O,L.TestItem.from)}constructor(m,y,D,C){this.name=m,this.description=y,this.validate=D,this.convert=C}optional(){return new h(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,y){return new h(m??this.name,y??this.description,this.validate,this.convert)}}e.$_O=h;class g{static{this.Void=new g("no result",m=>m)}constructor(m,y){this.description=m,this.convert=y}}e.$aP=g;class w{constructor(m,y,D,C,R){this.id=m,this.internalId=y,this.description=D,this.args=C,this.result=R}}e.$bP=w}),define(ke[356],De([1,0,19,15,2,84,135,38,34,17,8]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;const P=[new $.$bP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$_O.Uri,$.$_O.Position],new $.$aP("A promise that resolves to an array of DocumentHighlight-instances.",S(E.DocumentHighlight.to))),new $.$bP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$_O.Uri],new $.$aP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,f)=>{if((0,l.$Kb)(d))return;class a extends I.$EM{static to(i){const c=new a(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new I.$xM(f[0],E.Range.to(i.range)));return c.detail=i.detail,c.range=c.location.range,c.selectionRange=E.Range.to(i.selectionRange),c.children=i.children?i.children.map(a.to):[],c}}return d.map(a.to)})),new $.$bP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$_O.Uri,new $.$_O("options","Formatting options",d=>!0,d=>d)],new $.$aP("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new $.$bP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$_O.Uri,$.$_O.Range,new $.$_O("options","Formatting options",d=>!0,d=>d)],new $.$aP("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new $.$bP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$_O.Uri,$.$_O.Position,new $.$_O("ch","Trigger character",d=>typeof d=="string",d=>d),new $.$_O("options","Formatting options",d=>!0,d=>d)],new $.$aP("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new $.$bP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$_O.Uri,$.$_O.Position],new $.$aP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$bP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$_O.Uri,$.$_O.Position],new $.$aP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$bP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$_O.Uri,$.$_O.Position],new $.$aP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$bP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$_O.Uri,$.$_O.Position],new $.$aP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$bP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$_O.Uri,$.$_O.Position],new $.$aP("A promise that resolves to an array of Location-instances.",S(E.location.to))),new $.$bP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$_O.Uri,$.$_O.Position],new $.$aP("A promise that resolves to an array of Hover-instances.",S(E.Hover.to))),new $.$bP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$_O.Uri,new $.$_O("position","A position in a text document",d=>Array.isArray(d)&&d.every(f=>I.$mM.isPosition(f)),d=>d.map(E.Position.from))],new $.$aP("A promise that resolves to an array of ranges.",d=>d.map(f=>{let a;for(const n of f.reverse())a=new I.$IM(E.Range.to(n),a);return a}))),new $.$bP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$_O.String.with("query","Search string")],new $.$aP("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(E.WorkspaceSymbol.to))),new $.$bP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$_O.Uri,$.$_O.Position],new $.$aP("A promise that resolves to an array of CallHierarchyItem-instances",d=>d.map(E.CallHierarchyItem.to))),new $.$bP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$_O.CallHierarchyItem],new $.$aP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",d=>d.map(E.CallHierarchyIncomingCall.to))),new $.$bP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$_O.CallHierarchyItem],new $.$aP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",d=>d.map(E.CallHierarchyOutgoingCall.to))),new $.$bP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$_O.Uri,$.$_O.Position],new $.$aP("A promise that resolves to a range and placeholder text.",d=>{if(d)return{range:E.Range.to(d.range),placeholder:d.text}})),new $.$bP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$_O.Uri,$.$_O.Position,$.$_O.String.with("newName","The new symbol name")],new $.$aP("A promise that resolves to a WorkspaceEdit.",d=>{if(d){if(d.rejectReason)throw new Error(d.rejectReason);return E.WorkspaceEdit.to(d)}})),new $.$bP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$_O.Uri,$.$_O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$aP("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(E.DocumentLink.to))),new $.$bP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$_O.Uri],new $.$aP("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new I.$EN(d.tokenTypes,d.tokenModifiers)})),new $.$bP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$_O.Uri],new $.$aP("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const f=(0,M.$Cbb)(d);if(f.type==="full")return new I.$GN(f.data,void 0)})),new $.$bP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$_O.Uri,$.$_O.Range.optional()],new $.$aP("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new I.$EN(d.tokenTypes,d.tokenModifiers)})),new $.$bP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$_O.Uri,$.$_O.Range],new $.$aP("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const f=(0,M.$Cbb)(d);if(f.type==="full")return new I.$GN(f.data,void 0)})),new $.$bP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$_O.Uri,$.$_O.Position,$.$_O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$_O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$aP("A promise that resolves to a CompletionList-instance.",(d,f,a)=>{if(!d)return new I.$UM([]);const n=d.suggestions.map(i=>E.CompletionItem.to(i,a));return new I.$UM(n,d.incomplete)})),new $.$bP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$_O.Uri,$.$_O.Position,$.$_O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$aP("A promise that resolves to SignatureHelp.",d=>{if(d)return E.SignatureHelp.to(d)})),new $.$bP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$_O.Uri,$.$_O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$aP("A promise that resolves to an array of CodeLens-instances.",(d,f,a)=>S(n=>new I.$MM(E.Range.to(n.range),n.command&&a.fromInternal(n.command)))(d))),new $.$bP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$_O.Uri,new $.$_O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>I.$nM.isRange(d),d=>I.$oM.isSelection(d)?E.Selection.from(d):E.Range.from(d)),$.$_O.String.with("kind","Code action kind to return code actions for").optional(),$.$_O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$aP("A promise that resolves to an array of Command-instances.",(d,f,a)=>S(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(n.command)}else{const i=new I.$GM(n.title,n.kind?new I.$HM(n.kind):void 0);return n.edit&&(i.edit=E.WorkspaceEdit.to(n.edit)),n.command&&(i.command=a.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(d))),new $.$bP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$_O.Uri],new $.$aP("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(f=>new I.$1M(E.Range.to(f.range),E.Color.to(f.color))):[])),new $.$bP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$_O("color","The color to show and insert",d=>d instanceof I.$ZM,E.Color.from),new $.$_O("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:E.Range.from(d.range)}))],new $.$aP("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(E.ColorPresentation.to):[])),new $.$bP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$_O.Uri,$.$_O.Range],new $.$aP("A promise that resolves to an array of Inlay objects",(d,f,a)=>d.map(E.InlayHint.to.bind(void 0,a)))),new $.$bP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$_O.Uri],new $.$aP("A promise that resolves to an array of FoldingRange objects",(d,f)=>{if(d)return d.map(E.FoldingRange.to)})),new $.$bP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$aP("A promise that resolves to an array of NotebookContentProvider static info objects.",S(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(f=>E.NotebookExclusiveDocumentPattern.to(f))})))),new $.$bP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$_O.Uri,$.$_O.Range,new $.$_O("context","An InlineValueContext",d=>d&&typeof d.frameId=="number"&&d.stoppedLocation instanceof I.$nM,d=>E.InlineValueContext.from(d))],new $.$aP("A promise that resolves to an array of InlineValue objects",d=>d.map(E.InlineValue.to))),new $.$bP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$_O("uriOrString","Uri-instance or string (only http/https)",d=>L.URI.isUri(d)||typeof d=="string"&&(0,O.$Ig)(d,O.Schemas.http,O.Schemas.https),d=>d),new $.$_O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[E.ViewColumn.from(d),void 0]:[E.ViewColumn.from(d.viewColumn),E.TextEditorOpenOptions.from(d)])).optional(),$.$_O.String.with("label","").optional()],$.$aP.Void),new $.$bP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$_O.Uri.with("resource","Resource to open"),$.$_O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$_O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[E.ViewColumn.from(d),void 0]:[E.ViewColumn.from(d.viewColumn),E.TextEditorOpenOptions.from(d)])).optional()],$.$aP.Void),new $.$bP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$_O.Uri.with("left","Left-hand side resource of the diff editor"),$.$_O.Uri.with("right","Right-hand side resource of the diff editor"),$.$_O.String.with("title","Human readable title for the diff editor").optional(),new $.$_O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[E.ViewColumn.from(d.viewColumn),E.TextEditorOpenOptions.from(d)]).optional()],$.$aP.Void),new $.$bP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$_O.String.with("title","Human readable title for the changes editor"),new $.$_O("resourceList","List of resources to compare",d=>{for(const f of d){if(f.length!==3)return!1;const[a,n,i]=f;if(!L.URI.isUri(a)||!L.URI.isUri(n)&&n!==void 0&&n!==null||!L.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},d=>d)],$.$aP.Void),new $.$bP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$_O.Uri,$.$_O.Position],new $.$aP("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(E.TypeHierarchyItem.to))),new $.$bP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$_O.TypeHierarchyItem],new $.$aP("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(E.TypeHierarchyItem.to))),new $.$bP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$_O.TypeHierarchyItem],new $.$aP("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(E.TypeHierarchyItem.to))),new $.$bP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$_O.TestItem],$.$aP.Void),new $.$bP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$_O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$aP.Void),new $.$bP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$_O.String.with("name","The context key name"),new $.$_O("value","The context key value",()=>!0,d=>d)],$.$aP.Void),new $.$bP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$_O.Uri,$.$_O.StringArray,new $.$_O("MappedEditsContext","Mapped Edits Context",d=>E.MappedEditsContext.is(d),d=>E.MappedEditsContext.from(d))],new $.$aP("A promise that resolves to a workspace edit or null",d=>d?E.WorkspaceEdit.to(d):null)),new $.$bP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$_O("Run arguments","",d=>!0,d=>{if(d)return{initialRange:d.initialRange?E.Range.from(d.initialRange):void 0,initialSelection:I.$oM.isSelection(d.initialSelection)?E.Selection.from(d.initialSelection):void 0,message:d.message,autoSend:d.autoSend,position:d.position?E.Position.from(d.position):void 0}})],$.$aP.Void)];class p{static register(f){P.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",b.$xj)}}e.$_lc=p;function S(d){return f=>{if(Array.isArray(f))return f.map(d)}}function v(d){if(!Array.isArray(d))return;const f=[];for(const a of d)A.$tu(a)?f.push(E.DefinitionLink.to(a)):f.push(E.location.to(a));return f}}),define(ke[357],De([1,0,2,34]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;class L{constructor(M,b,$,E,I){this.a=b,this.b=$,this.c=E;const P=new O.$bP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$_O("showOptions","Show Options",p=>!0,p=>p),new O.$_O("resource","Interactive resource Uri",p=>!0,p=>p),new O.$_O("controllerId","Notebook controller Id",p=>!0,p=>p),new O.$_O("title","Interactive editor title",p=>!0,p=>p)],new O.$aP("Notebook and input URI",p=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const S=this.a.getEditorById(p.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:l.URI.revive(p.notebookUri),inputUri:l.URI.revive(p.inputUri),notebookEditor:S.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:l.URI.revive(p.notebookUri),inputUri:l.URI.revive(p.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(M,b,$,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$vnc=L}),define(ke[358],De([1,0,19,7,21,4,3,27,2,25,11,6,34,17,8,114,302,26,48,303]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=void 0,e.$Dnc=h;let c=class{constructor(w,k,m,y,D){this.m=k,this.n=m,this.o=y,this.q=D,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$fe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=w.getProxy(P.$jM.MainThreadNotebookKernels);const C=new p.$bP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$_O("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const j=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:j}}else if(T&&"notebookEditor"in T){const j=this.n.getIdByEditor(T.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return T})],p.$aP.Void),R=new p.$bP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[p.$_O.Uri],new p.$aP("A promise that resolves to an array of variables",(T,j)=>T.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(R)}createNotebookController(w,k,m,y,D,C){for(const oe of this.j.values())if(oe.controller.id===k&&E.$Tm.equals(w.identifier,oe.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const R=this.k++,T=this;this.q.trace(`NotebookController[${R}], CREATED by ${w.identifier.value}, ${k}`);const j=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${w.identifier}'`);let z=!1;const N=new A.$fe,F=new A.$fe,B={id:h(w.identifier,k),notebookType:m,extensionId:w.identifier,extensionLocation:w.extensionLocation,label:y||w.identifier.value,preloads:C?C.map(S.NotebookRendererScript.from):[]};let Y=D??j,re,H;this.a.$addKernel(R,B).catch(oe=>{console.log(oe),z=!0});let K=0;const _=()=>{if(z)return;const oe=++K;Promise.resolve().then(()=>{oe===K&&this.a.$updateKernel(R,B)})},Z=new b.$Ac,$e={get id(){return k},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return B.label},set label(oe){B.label=oe??w.displayName??w.name,_()},get detail(){return B.detail??""},set detail(oe){B.detail=oe,_()},get description(){return B.description??""},set description(oe){B.description=oe,_()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(oe){B.supportedLanguages=oe,_()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){B.supportsExecutionOrder=oe,_()},get rendererScripts(){return B.preloads?B.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(oe){Y=oe??j},get interruptHandler(){return re},set interruptHandler(oe){re=oe,B.supportsInterrupt=!!oe,_()},set variableProvider(oe){(0,a.$LG)(w,"notebookVariableProvider"),H=oe,B.hasVariableProvider=!!oe,oe?.onDidChangeVariables(Pe=>T.a.$variablesUpdated(Pe.uri)),_()},get variableProvider(){return H},createNotebookCellExecution(oe){if(z)throw new Error("notebook controller is DISPOSED");if(!Z.has(oe.notebook.uri))throw T.q.trace(`NotebookController[${R}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return T._createNotebookCellExecution(oe,h(w.identifier,this.id))},createNotebookExecution(oe){if((0,a.$LG)(w,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!Z.has(oe.uri))throw T.q.trace(`NotebookController[${R}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return T._createNotebookExecution(oe,h(w.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${R}], DISPOSED`),z=!0,this.j.delete(R),N.dispose(),F.dispose(),this.a.$removeKernel(R))},updateNotebookAffinity(oe,Pe){Pe===v.NotebookControllerAffinity2.Hidden&&(0,a.$LG)(w,"notebookControllerAffinityHidden"),T.a.$updateNotebookPriority(R,oe.uri,Pe)},onDidReceiveMessage:F.event,postMessage(oe,Pe){return(0,a.$LG)(w,"notebookMessaging"),T.a.$postMessage(R,Pe&&T.n.getIdByEditor(Pe),oe)},asWebviewUri(oe){return(0,a.$LG)(w,"notebookMessaging"),(0,d.$bBb)(oe,T.m.remote)}};return this.j.set(R,{extensionId:w.identifier,controller:$e,onDidReceiveMessage:F,onDidChangeSelection:N,associatedNotebooks:Z}),$e}getIdByController(w){for(const[k,m]of this.j)if(m.controller===w)return h(m.extensionId,w.id);return null}createNotebookControllerDetectionTask(w,k){const m=this.g++,y=this;this.q.trace(`NotebookControllerDetectionTask[${m}], CREATED by ${w.identifier.value}`),this.a.$addKernelDetectionTask(m,k);const D={dispose:()=>{this.f.delete(m),y.a.$removeKernelDetectionTask(m)}};return this.f.set(m,D),D}registerKernelSourceActionProvider(w,k,m){const y=this.i++,D=typeof m.onDidChangeNotebookKernelSourceActions=="function"?y:void 0,C=this;this.h.set(y,m),this.q.trace(`NotebookKernelSourceActionProvider[${y}], CREATED by ${w.identifier.value}`),this.a.$addKernelSourceActionProvider(y,y,k);let R;return D!==void 0&&(R=m.onDidChangeNotebookKernelSourceActions(T=>this.a.$emitNotebookKernelSourceActionsChangeEvent(D))),{dispose:()=>{this.h.delete(y),C.a.$removeKernelSourceActionProvider(y,y),R?.dispose()}}}async $provideKernelSourceActions(w,k){const m=this.h.get(w);if(m){const y=new M.$Tc;return(await m.provideNotebookKernelSourceActions(k)??[]).map(C=>S.NotebookKernelSourceAction.from(C,this.o.converter,y))}return[]}$acceptNotebookAssociation(w,k,m){const y=this.j.get(w);if(y){const D=this.n.getNotebookDocument($.URI.revive(k));m?y.associatedNotebooks.set(D.uri,!0):y.associatedNotebooks.delete(D.uri),this.q.trace(`NotebookController[${w}] ASSOCIATE notebook`,D.uri.toString(),m),y.onDidChangeSelection.fire({selected:m,notebook:D.apiNotebook})}}async $executeCells(w,k,m){const y=this.j.get(w);if(!y)return;const D=this.n.getNotebookDocument($.URI.revive(k)),C=[];for(const R of m){const T=D.getCell(R);T&&C.push(T.apiCell)}try{this.q.trace(`NotebookController[${w}] EXECUTE cells`,D.uri.toString(),C.length),await y.controller.executeHandler.call(y.controller,C,D.apiNotebook,y.controller)}catch(R){this.q.error(`NotebookController[${w}] execute cells FAILED`,R),console.error(R)}}async $cancelCells(w,k,m){const y=this.j.get(w);if(!y)return;const D=this.n.getNotebookDocument($.URI.revive(k));if(y.controller.interruptHandler)await y.controller.interruptHandler.call(y.controller,D.apiNotebook);else for(const C of m){const R=D.getCell(C);R&&this.b.get(R.uri)?.cancel()}if(y.controller.interruptHandler){const C=this.c.get(D.uri);this.c.delete(D.uri),m.length&&Array.isArray(C)&&C.length&&C.forEach(R=>R.dispose())}}async $provideVariables(w,k,m,y,D,C,R){const T=this.j.get(w);if(!T)return;const j=this.n.getNotebookDocument($.URI.revive(m)),z=T.controller.variableProvider;if(!z)return;let N;if(y!==void 0){if(N=this.s[y],!N)return}else this.s={};const F=D==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,B=z.provideVariables(j.apiNotebook,N,F,C,R);let Y=0;for await(const re of B){if(R.isCancellationRequested)return;const H={id:this.r++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:T.extensionId.value};if(this.s[H.id]=re.variable,this.a.$receiveVariable(k,H),Y++>=i.$Uib)return}}$acceptKernelMessageFromRenderer(w,k,m){const y=this.j.get(w);if(!y)return;const D=this.n.getEditorById(k);y.onDidReceiveMessage.fire(Object.freeze({editor:D.apiEditor,message:m}))}$cellExecutionChanged(w,k,m){const D=this.n.getNotebookDocument($.URI.revive(w)).getCell(k);if(D){const C=m?S.NotebookCellExecutionState.to(m):v.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:D.apiCell,state:C})}}_createNotebookCellExecution(w,k){if(w.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const y=this.n.getNotebookDocument(w.notebook.uri).getCellFromApiCell(w);if(!y)throw new Error("invalid cell");if(this.b.has(y.uri))throw new Error(`duplicate execution for ${y.uri}`);const D=new t(k,y,this.a);this.b.set(y.uri,D);const C=D.onDidChangeState(()=>{D.state===r.Resolved&&(D.dispose(),C.dispose(),this.b.delete(y.uri))});return D.asApiObject()}_createNotebookExecution(w,k){const m=this.n.getNotebookDocument(w.uri),y=w.getCells().find(R=>{const T=m.getCellFromApiCell(R);return T&&this.b.has(T.uri)});if(y)throw new Error(`duplicate cell execution for ${y.document.uri}`);if(this.c.has(m.uri))throw new Error(`duplicate notebook execution for ${m.uri}`);const D=new s(k,m,this.a),C=D.onDidChangeState(()=>{D.state===u.Resolved&&(D.dispose(),C.dispose(),this.c.delete(m.uri))});return this.c.set(m.uri,[D,C]),D.asApiObject()}};e.$Cnc=c,e.$Cnc=c=Je([We(4,I.$5j)],c);var r;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(r||(r={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(w,k,m){super(),this.m=k,this.n=m,this.b=t.a++,this.c=new A.$fe,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new L.$qe),this.h=new o(10,y=>this.s(y)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,w,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(w){await this.h.addItem(w)}async s(w){const k=Array.isArray(w)?w:[w];return this.n.$updateExecution(this.b,new n.$Fw(k))}t(){if(this.f===r.Init)throw new Error("Must call start before modifying cell output");if(this.f===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(w){let k=this.m;if(w&&(k=this.m.notebook.getCellFromApiCell(w)),!k)throw new Error("INVALID cell");return k.handle}y(w){return w.map(k=>{const m=v.$RN.ensureUniqueMimeTypes(k.items,!0);return m===k.items?S.NotebookCellOutput.from(k):S.NotebookCellOutput.from({items:m,id:k.id,metadata:k.metadata})})}async z(w,k,m){const y=this.w(k),D=this.y((0,l.$2b)(w));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:y,append:m,outputs:D})}async C(w,k,m){return w=v.$RN.ensureUniqueMimeTypes((0,l.$2b)(w),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:w.map(S.NotebookCellOutputItem.from),outputId:k.id,append:m})}asApiObject(){const w=this;return Object.freeze({get token(){return w.g.token},get cell(){return w.m.apiCell},get executionOrder(){return w.j},set executionOrder(m){w.j=m,w.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:w.j}])},start(m){if(w.f===r.Resolved||w.f===r.Started)throw new Error("Cannot call start again");w.f=r.Started,w.c.fire(),w.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:m})},end(m,y,D){if(w.f===r.Resolved)throw new Error("Cannot call resolve twice");w.f=r.Resolved,w.c.fire(),w.h.flush();const C=D?{message:D.message,stack:D.stack,location:D?.location?{startLineNumber:D.location.start.line,startColumn:D.location.start.character,endLineNumber:D.location.end.line,endColumn:D.location.end.character}:void 0,uri:D.uri}:void 0;w.n.$completeExecution(w.b,new n.$Fw({runEndTime:y,lastRunSuccess:m,error:C}))},clearOutput(m){return w.t(),w.z([],m,!1)},appendOutput(m,y){return w.t(),w.z(m,y,!0)},replaceOutput(m,y){return w.t(),w.z(m,y,!1)},appendOutputItems(m,y){return w.t(),w.C(m,y,!0)},replaceOutputItems(m,y){return w.t(),w.C(m,y,!1)}})}}var u;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(u||(u={}));class s extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(w,k,m){super(),this.h=k,this.j=m,this.b=s.a++,this.c=new A.$fe,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new L.$qe),this.j.$createNotebookExecution(this.b,w,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===u.Resolved||this.f===u.Started)throw new Error("Cannot call start again");this.f=u.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===u.Resolved)throw new Error("Cannot call resolve twice");this.f=u.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(w,k){this.f=w,this.g=k,this.a=[],this.b=Date.now()}addItem(w){return this.a.push(w),this.c||(this.c=new O.$Vh,this.b=Date.now(),(0,O.$zh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const w=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>w.complete())}}function h(g,w){return`${g.value}/${w}`}}),define(ke[43],De([1,0,4,6,5,2,20,3,8,232,13,279,21,30,280,50,7,17,34]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=e.$Omc=e.$Nmc=void 0,e.$Nmc=(0,L.$yi)("IExtHostTerminalService");class i extends b.$Uc{constructor(m,y,D,C){super(),this.u=m,this._id=y,this.w=D,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new l.$fe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(T=>this.g=T);const R=this;this.value={get name(){return R.y||""},get processId(){return R.b},get creationOptions(){return R.w},get exitStatus(){return R.j},get state(){return R.m},get selection(){return R.n},get shellIntegration(){return R.shellIntegration},sendText(T,j=!0){R.C(),R.u.$sendText(R._id,T,j)},show(T){R.C(),R.u.$show(R._id,T)},hide(){R.C(),R.u.$hide(R._id)},dispose(){R.a||(R.a=!0,R.u.$dispose(R._id))},get dimensions(){if(!(R.f===void 0||R.h===void 0))return{columns:R.f,rows:R.h}}}}dispose(){this.s.fire(),super.dispose()}async create(m,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??y?.cwd??void 0,env:m.env??void 0,icon:h(m.iconPath)??void 0,color:d.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,forceShellIntegration:y?.forceShellIntegration??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.z(m.location,y?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,y,D,C,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:d.ThemeColor.isThemeColor(R)?R.id:void 0,location:y?.location||this.z(m,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(m,y){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in m?{viewColumn:a.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.y=m}setExitStatus(m,y){this.j=Object.freeze({code:m,reason:y})}setDimensions(m,y){return m===this.f&&y===this.h||m===0||y===0?!1:(this.f=m,this.h=y,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(m){this.n=m}_setProcessId(m){this.g?(this.g(m),this.g=void 0):this.b.then(y=>{y!==m&&(this.b=Promise.resolve(m))})}}e.$Omc=i;class c{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new l.$fe,this.onProcessData=this.a.event,this.b=new l.$fe,this.d=new l.$fe,this.onDidChangeProperty=this.d.event,this.f=new l.$fe,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,y){this.g.setDimensions?.({columns:m,rows:y})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let r=1,t=class extends b.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,y,D){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new l.$fe,this.onDidCloseTerminal=this.H.event,this.I=new l.$fe,this.onDidOpenTerminal=this.I.event,this.J=new l.$fe,this.onDidChangeActiveTerminal=this.J.event,this.L=new l.$fe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new l.$fe,this.onDidChangeTerminalState=this.M.event,this.N=new l.$fe,this.onDidChangeShell=this.N.event,this.O=new l.$fe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new l.$fe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(O.$jM.MainThreadTerminalService),this.y=new v.$_vb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:C=>{const R=T=>{const j=T;return this.getTerminalById(j.instanceId)?.value};switch(C?.$mid){case 15:return R(C);default:{if(Array.isArray(C))for(let T=0;T<C.length&&C[T].$mid===15;T++)C[T]=R(C[T]);return C}}}}),this.B({dispose:()=>{for(const[C,R]of this.g)R.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,y){const D=new i(this.a,(0,S.$Ug)(),m,m.name),C=new c(m.pty);return D.createExtensionTerminal(m.location,y,this.R(m,y).resolvedExtHostIdentifier,h(m.iconPath),g(m.color)).then(R=>{const T=this.S(R,C);this.h[R]=T}),this.f.push(D),D.value}R(m,y){if(y=y||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const D=m.location.parentTerminal;if(D){const C=this.f.find(R=>R.value===D);C&&(y.resolvedExtHostIdentifier=C._id)}}else m.location&&typeof m.location!="object"?y.location=m.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(m,y){if(!this.getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const C=new c(y),R=this.S(m,C);this.h[m]=R}async $acceptActiveTerminalChanged(m){const y=this.b;if(m===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const D=this.getTerminalById(m);D&&(this.b=D,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,y){const D=this.getTerminalById(m);D&&this.O.fire({terminal:D.value,data:y})}async $acceptTerminalDimensions(m,y,D){const C=this.getTerminalById(m);C&&C.setDimensions(y,D)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(m,y){const D=this.getTerminalById(m);D&&this.P.fire({terminal:D.value,...y})}async $acceptTerminalMaximumDimensions(m,y,D){this.g.get(m)?.resize(y,D)}async $acceptTerminalTitleChange(m,y){const D=this.getTerminalById(m);D&&(D.name=y)}async $acceptTerminalClosed(m,y,D){const C=this.X(this.f,m);if(C!==null){const R=this.f.splice(C,1)[0];R.setExitStatus(y,D),this.H.fire(R.value)}}$acceptTerminalOpened(m,y,D,C){if(y){const j=this.X(this.f,y);if(j!==null){this.f[j]._id=m,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const R={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:A.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},T=new i(this.a,m,R,D);this.f.push(T),this.I.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(m,y){this.getTerminalById(m)?._setProcessId(y)}async $startExtensionTerminal(m,y){const D=this.getTerminalById(m);if(!D)return{message:(0,E.localize)(0,null,m)};D.isOpen||await new Promise(R=>{const T=this.onDidOpenTerminal(async j=>{j===D.value&&(T.dispose(),R())})});const C=this.g.get(m);C?C.startSendingEvents(y):this.j[m]={initialDimensions:y}}S(m,y){const D=new b.$Tc;D.add(y.onProcessReady(R=>this.a.$sendProcessReady(m,R.pid,R.cwd,R.windowsPty))),D.add(y.onDidChangeProperty(R=>this.a.$sendProcessProperty(m,R))),this.y.startBuffering(m,y.onProcessData),D.add(y.onProcessExit(R=>this.U(m,R))),this.g.set(m,y);const C=this.j[m];return C&&y instanceof c&&(y.startSendingEvents(C.initialDimensions),delete this.j[m]),D}$acceptProcessAckDataEvent(m,y){this.g.get(m)?.acknowledgeDataEvent(y)}$acceptProcessInput(m,y){this.g.get(m)?.input(y)}$acceptTerminalInteraction(m){const y=this.getTerminalById(m);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(m,y){this.getTerminalById(m)?.setSelection(y)}$acceptProcessResize(m,y,D){try{this.g.get(m)?.resize(y,D)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(m,y){this.g.get(m)?.shutdown(y)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(m,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(y=>this.a.$sendProcessProperty(m,{type:"cwd",value:y}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new $.$lM(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,y,D){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,D),this.a.$registerProfileProvider(y,m.identifier.value),new $.$lM(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(m,y,D){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,D),this.a.$registerQuickFixProvider(m,y),new $.$lM(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,y){const D=new p.$qe().token;if(D.isCancellationRequested)return;const C=this.D.get(m);if(!C)return;const R=await C.provideTerminalQuickFixes(y,D);if(R===null||Array.isArray(R)&&R.length===0)return;const T=new b.$Tc;if(this.w.value=T,!Array.isArray(R))return R?a.TerminalQuickFix.from(R,this.Q.converter,T):void 0;const j=[];for(const z of R){const N=a.TerminalQuickFix.from(z,this.Q.converter,T);N&&j.push(N)}return j}async $createContributedProfileTerminal(m,y){const D=new p.$qe().token;let C=await this.C.get(m)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,y);return}this.createTerminalFromOptions(C.options,y)}}async $provideLinks(m,y){const D=this.getTerminalById(m);if(!D)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const R=new p.$qe;this.G.set(m,R);const T=[],j={terminal:D.value,line:y},z=[];for(const B of this.z)z.push(f.Promises.withAsyncBody(async Y=>{R.token.onCancellationRequested(()=>Y({provider:B,links:[]}));const re=await B.provideTerminalLinks(j,R.token)||[];R.token.isCancellationRequested||Y({provider:B,links:re})}));const N=await Promise.all(z);if(R.token.isCancellationRequested)return[];const F=new Map;for(const B of N)B&&B.links.length>0&&T.push(...B.links.map(Y=>{const re={id:r++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return F.set(re.id,{provider:B.provider,link:Y}),re}));return this.F.set(m,F),T}$activateLink(m,y){const D=this.F.get(m)?.get(y);D&&D.provider.handleTerminalLink(D.link)}U(m,y){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const D=this.h[m];D&&(D.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,y)}getTerminalById(m){return this.W(this.f,m)}getTerminalIdByApiObject(m){const y=this.f.findIndex(D=>D.value===m);return y>=0?y:null}W(m,y){const D=this.X(m,y);return D!==null?m[D]:null}X(m,y){const D=m.findIndex(C=>C._id===y);return D>=0?D:null}getEnvironmentVariableCollection(m){let y=this.n.get(m.identifier.value);return y||(y=new u,this.Z(m.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Y(m,y){const D=(0,P.$ps)(y.map),C=(0,P.$qs)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(m,y.persistent,D.length===0?void 0:D,C)}$initEnvironmentVariableCollections(m){m.forEach(y=>{const D=y[0],C=new u(y[1]);this.Z(D,C)})}$acceptDefaultProfile(m,y){const D=this.s;this.s=m,this.u=y,D?.path!==m.path&&this.N.fire(m.path)}Z(m,y){this.n.set(m,y),y.onDidChangeCollection(()=>{this.Y(m,y)})}};e.$Pmc=t,e.$Pmc=t=Je([We(1,n.$0O),We(2,M.$NO)],t);class u{get persistent(){return this.b}set persistent(m){this.b=m,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(m){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new l.$fe,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const y=this.h(m);let D=this.a.get(y);return D||(D=new s(this,m),this.a.set(y,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(m,y,D,C){this.f(m,{value:y,type:$.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:C})}append(m,y,D,C){this.f(m,{value:y,type:$.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:C})}prepend(m,y,D,C){this.f(m,{value:y,type:$.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:C})}f(m,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(m,y.scope),C=this.map.get(D),R=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==y.value||C.type!==y.type||C.options?.applyAtProcessCreation!==R.applyAtProcessCreation||C.options?.applyAtShellIntegration!==R.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const T=this.g(m,y.scope),j={variable:m,...y,options:R};this.map.set(T,j),this.d.fire()}}get(m,y){const D=this.g(m,y),C=this.map.get(D);return C?w(C):void 0}g(m,y){const D=this.h(y);return D.length?`${m}:::${D}`:m}h(m){return this.j(m?.workspaceFolder)??""}j(m){return m?m.uri.toString():void 0}getVariableMap(m){const y=new Map;for(const[D,C]of this.map)this.h(C.scope)===this.h(m)&&y.set(C.variable,w(C));return y}delete(m,y){const D=this.g(m,y);this.map.delete(D),this.d.fire()}clear(m){if(m?.workspaceFolder){for(const[y,D]of this.map)D.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(y);this.k(m)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(m,y){const D=this.h(y),C=this.descriptionMap.get(D);if(!C||C.description!==m){let R;typeof m=="string"?R=m:R=m?.value.split(`

`)[0];const T={description:R,scope:y};this.descriptionMap.set(D,T),this.d.fire()}}getDescription(m){const y=this.h(m);return this.descriptionMap.get(y)?.description}k(m){const y=this.h(m);this.descriptionMap.delete(y)}}class s{get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,y){this.b=m,this.d=y,this.a=new l.$fe}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,y,D){this.b.replace(m,y,D,this.d)}append(m,y,D){this.b.append(m,y,D,this.d)}prepend(m,y,D){this.b.prepend(m,y,D,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,y){this.b.getVariableMap(this.d).forEach((D,C)=>m.call(y,C,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends t{constructor(m,y){super(!1,m,y)}createTerminal(m,y,D){throw new I.$_}createTerminalFromOptions(m,y){throw new I.$_}};e.$Qmc=o,e.$Qmc=o=Je([We(0,n.$0O),We(1,M.$NO)],o);function h(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function g(k){return d.ThemeColor.isThemeColor(k)?k:void 0}function w(k){const m={...k};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(ke[156],De([1,0,8,3,5,6,20,43,4,2,7]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=e.$Unc=void 0,e.$Unc=(0,L.$yi)("IExtHostTerminalShellIntegration");let P=class extends O.$Uc{constructor(f,a){super(),this.h=a,this.b=new Map,this.c=new $.$fe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$fe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$fe,this.onDidEndTerminalShellExecution=this.g.event,this.a=f.getProxy(A.$jM.MainThreadTerminalShellIntegration),this.B((0,O.$Sc)(()=>{for(const[n,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(f){const a=this.h.getTerminalById(f);if(!a)return;const n=a.value;let i=this.b.get(f);i||(i=new p(a.value,this.f),this.b.set(f,i),i.store.add(a.onWillDispose(()=>this.b.get(f)?.dispose())),i.store.add(i.onDidRequestShellExecution(c=>this.a.$executeCommand(f,c))),i.store.add(i.onDidRequestEndExecution(c=>this.g.fire(c))),i.store.add(i.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),a.shellIntegration=i.value),this.c.fire({terminal:n,shellIntegration:i.value})}$shellExecutionStart(f,a,n,i,c){this.b.has(f)||this.$shellIntegrationChange(f);const r={value:a,confidence:n,isTrusted:i};this.b.get(f)?.startShellExecution(r,c)}$shellExecutionEnd(f,a,n,i,c){const r={value:a,confidence:n,isTrusted:i};this.b.get(f)?.endShellExecution(r,c)}$shellExecutionData(f,a){this.b.get(f)?.emitData(a)}$cwdChange(f,a){this.b.get(f)?.setCwd((0,E.$vc)(a)?E.URI.revive(a):a)}$closeTerminal(f){this.b.get(f)?.dispose(),this.b.delete(f)}};e.$Vnc=P,e.$Vnc=P=Je([We(0,M.$NO),We(1,b.$Nmc)],P);class p extends O.$Uc{get currentExecution(){return this.a}constructor(f,a){super(),this.j=f,this.m=a,this.b=!1,this.store=this.B(new O.$Tc),this.f=this.B(new $.$fe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$fe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$fe),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(i,c){let r=i;c&&(r+=` "${c.map(s=>`${s.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(r);const t={value:r,confidence:l.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=n.startShellExecution(t,n.c,!0).value;return n.b=!0,u}}}startShellExecution(f,a,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new S(f,a);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(f){this.currentExecution?.emitData(f)}endShellExecution(f,a){this.a&&(this.a.endExecution(f),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(f){let a=!1;E.URI.isUri(this.c)?a=!E.URI.isUri(f)||this.c.toString()!==f.toString():this.c!==f&&(a=!0),a&&(this.c=f,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class S{constructor(f,a){this.c=f,this.cwd=a,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return I.$Yh.EMPTY;this.a=new v}return this.a.createIterable()}emitData(f){this.a?.emitData(f)}endExecution(f){f&&(this.c=f),this.a?.endExecution(),this.a=void 0,this.b=!0}}class v extends O.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$xh);const f=this.a;return new I.$Yh(async n=>{this.b.push(n),await f.wait()})}emitData(f){for(const a of this.b)a.emitOne(f)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[359],De([1,0,7,22,21,4,75,57,3,18,30,11,6,20,155,17,8,69,113,89,26]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=e.$Ync=e.$Xnc=e.$Wnc=void 0;let r=class extends $.$Uc{constructor(T,j,z,N){super(),this.w=N,this.f=this.B(new A.$fe),this.g=new Map,this.s=this.B(new A.$fe),this.onResultsChanged=this.f.event,this.results=[],this.h=T.getProxy(p.$jM.MainThreadTesting),this.m=new m(this.h),this.j=new o(this.h,j),z.registerArgumentProcessor({processArgument:F=>{switch(F?.$mid){case 16:{const B=F,Y=B.tests[B.tests.length-1].item.extId;return this.g.get(a.$8K.root(Y))?.collection.tree.get(Y)?.actual??(0,v.$ZO)(F)}case 18:{const{test:B,message:Y}=F,re=B.item.extId;return{test:this.g.get(a.$8K.root(re))?.collection.tree.get(re)?.actual??(0,v.$ZO)({$mid:16,tests:[B]}),message:d.TestMessage.to(Y)}}default:return F}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const F=await z.executeCommand("_testing.getExplorerSelection"),B=Y=>{const re=this.g.get(a.$8K.root(Y));if(re)return a.$8K.isRoot(Y)?re.controller:re.collection.tree.get(Y)?.actual};return{include:F?.include.map(B).filter(E.$gg)||[],exclude:F?.exclude.map(B).filter(E.$gg)||[]}})}createTestController(T,j,z,N){if(this.g.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const F=new $.$Tc,B=F.add(new v.$3O(j,z,this.w));B.root.label=z;const Y=new Map,re=new Set,H=this.h,K={items:B.root.children,get label(){return z},set label(Z){z=Z,B.root.label=Z,H.$updateController(j,{label:z})},get refreshHandler(){return N},set refreshHandler(Z){N=Z,H.$updateController(j,{canRefresh:!!Z})},get id(){return j},createRunProfile:(Z,$e,oe,Pe,te,U)=>{let ee=(0,b.$mj)(Z);for(;Y.has(ee);)ee++;return new D(this.h,Y,re,this.s.event,j,ee,Z,$e,oe,Pe,te,U)},createTestItem(Z,$e,oe){return new v.$1O(j,Z,$e,oe)},createTestRun:(Z,$e,oe=!0)=>this.j.createTestRun(T,j,B,Z,$e,oe),invalidateTestResults:Z=>{if(Z===void 0)this.h.$markTestRetired(void 0);else{const $e=Z instanceof Array?Z:[Z];this.h.$markTestRetired($e.map(oe=>a.$8K.fromExtHostTestItem(oe,j).toString()))}},set resolveHandler(Z){B.resolveHandler=Z},get resolveHandler(){return B.resolveHandler},dispose:()=>{F.dispose()}};H.$registerTestController(j,z,!!N),F.add((0,$.$Sc)(()=>H.$unregisterTestController(j)));const _={controller:K,collection:B,profiles:Y,extension:T,activeProfiles:re};return this.g.set(j,_),F.add((0,$.$Sc)(()=>this.g.delete(j))),F.add(B.onDidGenerateDiff(Z=>H.$publishDiff(j,Z.map(i.TestsDiffOp.serialize)))),K}createTestObserver(){return this.m.checkout()}async runTests(T,j=L.CancellationToken.None){const z=h(T);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.g.get(z.controllerId);if(!N)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:T.preserveFocus??!0,targets:[{testIds:T.include?.map(F=>a.$8K.fromExtHostTestItem(F,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:C[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:T.exclude?.map(F=>F.id)},j)}$syncTests(){for(const{collection:T}of this.g.values())T.flushDiff();return Promise.resolve()}async $getCoverageDetails(T,j){return(await this.j.getCoverageDetails(T,j))?.map(d.TestCoverage.fromDetails)}async $disposeRun(T){this.j.disposeTestRun(T)}$configureRunProfile(T,j){this.g.get(T)?.profiles.get(j)?.configureHandler?.()}$setDefaultRunProfiles(T){const j=new Map;for(const[z,N]of Object.entries(T)){const F=this.g.get(z);if(!F)continue;const B=new Map,Y=N.filter(H=>!F.activeProfiles.has(H)),re=[...F.activeProfiles].filter(H=>!N.includes(H));for(const H of Y)B.set(H,!0),F.activeProfiles.add(H);for(const H of re)B.set(H,!1),F.activeProfiles.delete(H);B.size&&j.set(z,B)}this.s.fire(j)}async $refreshTests(T,j){await this.g.get(T)?.controller.refreshHandler?.(j)}$publishTestResults(T){this.results=Object.freeze(T.map(d.TestResults.to).concat(this.results).sort((j,z)=>z.completedAt-j.completedAt).slice(0,32)),this.f.fire()}async $expandTest(T,j){const z=this.g.get(a.$8K.fromString(T).controllerId)?.collection;z&&(await z.expand(T,j<0?1/0:j),z.flushDiff())}$acceptDiff(T){this.m.applyDiff(T.map(j=>i.TestsDiffOp.deserialize({asCanonicalUri:z=>z},j)))}async $runControllerTests(T,j){return Promise.all(T.map(z=>this.y(z,!1,j)))}async $startContinuousRun(T,j){const z=new L.$qe(j),N=await Promise.all(T.map(F=>this.y(F,!0,z.token)));return!j.isCancellationRequested&&!N.some(F=>F.error)&&await new Promise(F=>j.onCancellationRequested(F)),z.dispose(!0),N}async y(T,j,z){const N=this.g.get(T.controllerId);if(!N)return{};const{collection:F,profiles:B,extension:Y}=N,re=B.get(T.profileId);if(!re)return{};const H=T.testIds.map($e=>F.tree.get($e)).filter(E.$gg),K=T.excludeExtIds.map($e=>N.collection.tree.get($e)).filter(E.$gg).filter($e=>H.some(oe=>oe.fullId.compare($e.fullId)===2));if(!H.length)return{};const _=new f.$YN(H.some($e=>$e.actual instanceof v.$2O)?void 0:H.map($e=>$e.actual),K.map($e=>$e.actual),re,j),Z=(0,i.$$K)(T)&&this.j.prepareForMainThreadTestRun(Y,_,g.fromInternal(T,N.collection),re,z);try{return await re.runHandler(_,z),{}}catch($e){return{error:String($e)}}finally{Z&&Z.hasRunningTasks&&!z.isCancellationRequested&&await A.Event.toPromise(Z.onEnd)}}$cancelExtensionTestRun(T){T===void 0?this.j.cancelAllRuns():this.j.cancelRunById(T)}};e.$Wnc=r,e.$Wnc=r=Je([We(0,S.$NO),We(1,P.$5j)],r);const t=1e4;var u;(function(R){R[R.Running=0]="Running",R[R.Cancelling=1]="Cancelling",R[R.Ended=2]="Ended"})(u||(u={}));class s extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(T,j,z,N,F,B){super(),this.y=T,this.z=j,this.C=z,this.D=N,this.F=F,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$fe),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new L.$qe(B));const Y=this.B(new l.$Kh(()=>this.G(),t));this.B(this.j.token.onCancellationRequested(()=>Y.schedule()));const re=new A.$fe;this.s=re.event,this.B((0,$.$Sc)(()=>{re.fire(),re.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.G()}getCoverageDetails(T,j){const[,z]=a.$8K.fromString(T).path,N=this.w.get(T);if(!N)return[];const F=this.g.get(z);if(!F)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(F.run,N,j)??[]}createRun(T){const j=this.y.id,z=this.y.controllerId,N=(0,I.$Ug)(),F=K=>(_,...Z)=>{if(Y){this.C.warn(`Setting the state of test "${_.id}" is a no-op after the run ends.`);return}this.y.isIncluded(_)&&(this.I(_),K(_,...Z))},B=(K,_)=>{const Z=_ instanceof Array?_.map(d.TestMessage.from):[d.TestMessage.from(_)];if(K.uri&&K.range){const $e={range:d.Range.from(K.range),uri:K.uri};for(const oe of Z)oe.location=oe.location||$e}this.z.$appendTestMessagesInRun(j,N,a.$8K.fromExtHostTestItem(K,z).toString(),Z)};let Y=!1;const re=new Map,H={isPersisted:this.y.isPersisted,token:this.j.token,name:T,onDidDispose:this.s,addCoverage:K=>{if(Y)return;const _=K instanceof f.$4N?K.testItem:void 0;let Z;if(_){if((0,c.$LG)(this.F,"attributableCoverage"),!this.y.isIncluded(_))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.I(_),Z=re.get(_),Z===void 0&&(Z=re.size,re.set(_,Z))}const $e=K.uri.toString(),oe=new a.$8K(Z!==void 0?[j,N,$e,String(Z)]:[j,N,$e]).toString();this.w.set(oe,K),this.z.$appendCoverage(j,N,d.TestCoverage.fromFile(z,oe,K))},enqueued:F(K=>{this.z.$updateTestStateInRun(j,N,a.$8K.fromExtHostTestItem(K,z).toString(),1)}),skipped:F(K=>{this.z.$updateTestStateInRun(j,N,a.$8K.fromExtHostTestItem(K,z).toString(),5)}),started:F(K=>{this.z.$updateTestStateInRun(j,N,a.$8K.fromExtHostTestItem(K,z).toString(),2)}),errored:F((K,_,Z)=>{B(K,_),this.z.$updateTestStateInRun(j,N,a.$8K.fromExtHostTestItem(K,z).toString(),6,Z)}),failed:F((K,_,Z)=>{B(K,_),this.z.$updateTestStateInRun(j,N,a.$8K.fromExtHostTestItem(K,z).toString(),4,Z)}),passed:F((K,_)=>{this.z.$updateTestStateInRun(j,N,a.$8K.fromExtHostTestItem(K,this.y.controllerId).toString(),3,_)}),appendOutput:(K,_,Z)=>{Y||(Z&&(this.y.isIncluded(Z)?this.I(Z):Z=void 0),this.z.$appendOutputToRun(j,N,O.$He.fromString(K),_&&d.location.from(_),Z&&a.$8K.fromExtHostTestItem(Z,z).toString()))},end:()=>{Y||(Y=!0,re.clear(),this.z.$finishedTestRunTask(j,N),--this.f||this.H())}};return this.f++,this.g.set(N,{run:H}),this.z.$startedTestRunTask(j,{id:N,name:T,running:!0}),H}G(){for(const{run:T}of this.g.values())T.end()}H(){this.c!==2&&(this.c=2,this.m.fire())}I(T){if(!(T instanceof v.$1O))throw new n.$FO(T.id);if(this.h.has(a.$8K.fromExtHostTestItem(T,this.y.controllerId).toString()))return;const j=[],z=this.y.colllection.root;for(;;){const N=d.TestItem.from(T);if(j.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),T===z))break;T=T.parent||z}this.z.$addTestsToRun(this.y.controllerId,this.y.id,j)}dispose(){this.H(),super.dispose()}}class o{get trackers(){return this.c.values()}constructor(T,j){this.g=T,this.h=j,this.c=new Map,this.f=new Map}getCoverageDetails(T,j){const z=a.$8K.root(T);return this.f.get(z)?.getCoverageDetails(T,j)||[]}disposeTestRun(T){this.f.get(T)?.dispose(),this.f.delete(T);for(const[j,{id:z}]of this.c)z===T&&this.c.delete(j)}prepareForMainThreadTestRun(T,j,z,N,F){return this.j(j,z,N,T,F)}cancelRunById(T){this.f.get(T)?.cancel()}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,j,z,N,F,B){const Y=this.c.get(N);if(Y)return Y.createRun(F);const re=g.fromPublic(j,z,N,B),H=h(N);this.g.$startedExtensionTestRun({controllerId:j,continuous:!!N.continuous,profile:H&&{group:C[H.kind],id:H.profileId},exclude:N.exclude?.map(_=>a.$8K.fromExtHostTestItem(_,z.root.id).toString())??[],id:re.id,include:N.include?.map(_=>a.$8K.fromExtHostTestItem(_,z.root.id).toString())??[z.root.id],preserveFocus:N.preserveFocus??!0,persist:B});const K=this.j(N,re,N.profile,T);return A.Event.once(K.onEnd)(()=>{this.g.$finishedExtensionTestRun(re.id)}),K.createRun(F)}j(T,j,z,N,F){const B=new s(j,this.g,this.h,z,N,F);return this.c.set(T,B),this.f.set(B.id,B),B}}e.$Xnc=o;const h=R=>{if(R.profile){if(!(R.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class g{static fromPublic(T,j,z,N){return new g(T,(0,I.$Ug)(),z.include?.map(F=>a.$8K.fromExtHostTestItem(F,T).toString())??[T],z.exclude?.map(F=>a.$8K.fromExtHostTestItem(F,T).toString())??[],N,j)}static fromInternal(T,j){return new g(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,j)}constructor(T,j,z,N,F,B){this.controllerId=T,this.id=j,this.isPersisted=F,this.colllection=B,this.c=z.map(Y=>Y+"\0"),this.f=N.map(Y=>Y+"\0")}isIncluded(T){const j=a.$8K.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const z of this.f)if(j===z||j.startsWith(z))return!1;for(const z of this.c)if(j===z||j.startsWith(z))return!0;return!1}}e.$Ync=g;class w{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(T){this.j=T,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,d.TestItem.toPlain(T.item)),this.c.has(T)||this.f.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.f.delete(T);const j=a.$8K.parentId(T.item.extId);if(j&&this.h.has(j.toString())){this.h.add(T.item.extId);return}this.g.add(T)}getChangeEvent(){const{c:T,f:j,g:z}=this;return{get added(){return[...T].map(N=>N.revived)},get updated(){return[...j].map(N=>N.revived)},get removed(){return[...z].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class k extends i.$eL{constructor(){super(...arguments),this.s=new A.$fe,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(T){return this.f.get(T)}getMirroredTestDataByReference(T){return this.f.get(T.id)}w(T,j){return{...T,revived:d.TestItem.toPlain(T.item),depth:j?j.depth+1:0,children:new Set}}v(){return new w(this.s)}}class m{constructor(T){this.f=T}checkout(){this.c||(this.c=this.g());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(j=>j.revived)},dispose:(0,M.$db)(()=>{--T.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}g(){const T=new k({asCanonicalUri:j=>j});return this.f.$subscribeToDiffs(),{observers:0,tests:T}}}const y=(R,T,j,z)=>{j?Object.assign(j,z):T.$updateTestRunConfig(R.controllerId,R.profileId,z)};class D{#e;#t;#n;#i;#s;get label(){return this.f}set label(T){T!==this.f&&(this.f=T,y(this,this.#e,this.#i,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,y(this,this.#e,this.#i,{supportsContinuousRun:T}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(T){T!==this.isDefault&&(T?this.#t.add(this.profileId):this.#t.delete(this.profileId),y(this,this.#e,this.#i,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,y(this,this.#e,this.#i,{tag:T?d.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,y(this,this.#e,this.#i,{hasConfigurationHandler:!!T}))}get onDidChangeDefault(){return A.Event.chain(this.#n,T=>T.map(j=>j.get(this.controllerId)?.get(this.profileId)).filter(E.$gg))}constructor(T,j,z,N,F,B,Y,re,H,K=!1,_=void 0,Z=!1){this.controllerId=F,this.profileId=B,this.f=Y,this.kind=re,this.runHandler=H,this._tag=_,this.g=Z,this.#e=T,this.#s=j,this.#t=z,this.#n=N,j.set(B,this);const $e=C[re];if(typeof $e!="number")throw new Error(`Unknown TestRunProfile.group ${re}`);K&&z.add(B),this.#i={profileId:B,controllerId:F,tag:_?d.TestTag.namespace(this.controllerId,_.id):null,label:Y,group:$e,isDefault:K,hasConfigurationHandler:!1,supportsContinuousRun:Z},queueMicrotask(()=>{this.#i&&(this.#e.$publishTestRunProfile(this.#i),this.#i=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#i=void 0}}e.$Znc=D;const C={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(ke[157],De([1,0,62,13,125,17,8]),function(he,e,l,O,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=e.$VO=e.$UO=void 0;class b{static{this.c=new L.$SO("TextEditorDecorationType")}constructor(p,S,v){const d=b.c.nextId();p.$registerTextEditorDecorationType(S.identifier,d,A.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:d,dispose(){p.$removeTextEditorDecorationType(d)}})}}e.$UO=b;class ${constructor(p,S){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,S){this.k();let v=null;if(p instanceof M.$mM)v=new M.$nM(p,p);else if(p instanceof M.$nM)v=p;else throw new Error("Unrecognized location");this.l(v,S,!1)}insert(p,S){this.k(),this.l(new M.$nM(p,p),S,!0)}delete(p){this.k();let S=null;if(p instanceof M.$nM)S=p;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(p,S,v){const d=this.c.validateRange(p);this.g.push({range:d,text:S,forceMoveMarkers:v})}setEndOfLine(p){if(this.k(),p!==M.EndOfLine.LF&&p!==M.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=p}}class E{constructor(p,S,v,d){this.c=p,this.d=S,this._accept(v),this.e=d;const f=this;this.value={get tabSize(){return f.f},set tabSize(a){f.n(a)},get indentSize(){return f.g},set indentSize(a){f.p(a)},get insertSpaces(){return f.j},set insertSpaces(a){f.s(a)},get cursorStyle(){return f.k},set cursorStyle(a){f.t(a)},get lineNumbers(){return f.l},set lineNumbers(a){f.u(a)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}n(p){const S=this.m(p);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}p(p){const S=this.o(p);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const S=this.q(p);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(p)})))}assign(p){const S={};let v=!1;if(typeof p.tabSize<"u"){const d=this.m(p.tabSize);d==="auto"?(v=!0,S.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,v=!0,S.tabSize=d)}if(typeof p.indentSize<"u"){const d=this.o(p.indentSize);d==="tabSize"?(v=!0,S.indentSize=d):typeof d=="number"&&this.h!==d&&(this.g=d,this.h=d,v=!0,S.indentSize=d)}if(typeof p.insertSpaces<"u"){const d=this.q(p.insertSpaces);d==="auto"?(v=!0,S.insertSpaces=d):this.j!==d&&(this.j=d,v=!0,S.insertSpaces=d)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,v=!0,S.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,v=!0,S.lineNumbers=A.TextEditorLineNumbersStyle.from(p.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(p,S){S.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(v)})}}e.$VO=E;class I{constructor(p,S,v,d,f,a,n,i){this.id=p,this.j=S,this.k=v,this.g=!1,this.h=new Set,this.c=f,this.d=new E(this.j,this.id,a,v),this.e=n,this.f=i;const c=this;this.value=Object.freeze({get document(){return d.value},set document(r){throw new O.$9("document")},get selection(){return c.c&&c.c[0]},set selection(r){if(!(r instanceof M.$oM))throw(0,O.$7)("selection");c.c=[r],c.l()},get selections(){return c.c},set selections(r){if(!Array.isArray(r)||r.some(t=>!(t instanceof M.$oM)))throw(0,O.$7)("selections");c.c=r,c.l()},get visibleRanges(){return c.e},set visibleRanges(r){throw new O.$9("visibleRanges")},get options(){return c.d.value},set options(r){c.g||c.d.assign(r)},get viewColumn(){return c.f},set viewColumn(r){throw new O.$9("viewColumn")},edit(r,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new $(d.value,t);return r(u),c.m(u)},insertSnippet(r,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=c.c.map(o=>A.Range.from(o));else if(t instanceof M.$mM){const{lineNumber:o,column:h}=A.Position.from(t);s=[{startLineNumber:o,startColumn:h,endLineNumber:o,endColumn:h}]}else if(t instanceof M.$nM)s=[A.Range.from(t)];else{s=[];for(const o of t)if(o instanceof M.$nM)s.push(A.Range.from(o));else{const{lineNumber:h,column:g}=A.Position.from(o);s.push({startLineNumber:h,startColumn:g,endLineNumber:h,endColumn:g})}}return S.$tryInsertSnippet(p,d.value.version,r.value,s,u)},setDecorations(r,t){const u=t.length===0;u&&!c.h.has(r.key)||(u?c.h.delete(r.key):c.h.add(r.key),c.n(()=>{if(A.$KO(t))return S.$trySetDecorations(p,r.key,A.$LO(t));{const s=new Array(4*t.length);for(let o=0,h=t.length;o<h;o++){const g=t[o];s[4*o]=g.start.line+1,s[4*o+1]=g.start.character+1,s[4*o+2]=g.end.line+1,s[4*o+3]=g.end.character+1}return S.$trySetDecorationsFast(p,r.key,s)}}))},revealRange(r,t){c.n(()=>S.$tryRevealRange(p,A.Range.from(r),t||M.TextEditorRevealType.Default))},show(r){S.$tryShowEditor(p,A.ViewColumn.from(r))},hide(){S.$tryHideEditor(p)}})}dispose(){(0,l.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,l.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,l.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,l.ok)(!this.g),this.f=p}_acceptSelections(p){(0,l.ok)(!this.g),this.c=p}async l(){const p=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const S=p.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const v=S.edits.map(f=>f.range);v.sort((f,a)=>f.end.line===a.end.line?f.end.character===a.end.character?f.start.line===a.start.line?f.start.character-a.start.character:f.start.line-a.start.line:f.end.character-a.end.character:f.end.line-a.end.line);for(let f=0,a=v.length-1;f<a;f++){const n=v[f].end;if(v[f+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=S.edits.map(f=>({range:A.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,d,{setEndOfLine:typeof S.setEndOfLine=="number"?A.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$WO=I}),define(ke[73],De([1,0,62,4,3,2,5,6,153,20,157,17,11,27,15,39,46]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=e.$XO=void 0;class a{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,r){this.h=c,this.i=r,this.a=null,this.b=new Map,this.c=new S.$Ac,this.d=new O.$fe,this.e=new O.$fe,this.f=new O.$fe,this.g=new O.$fe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const r=[],t=[],u=[];if(c.removedDocuments)for(const s of c.removedDocuments){const o=A.URI.revive(s),h=this.c.get(o);h?.unref()&&(this.c.delete(o),r.push(h.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const o=A.URI.revive(s.uri);let h=this.c.get(o);if(h&&o.scheme!==v.Schemas.vscodeNotebookCell&&o.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);h||(h=new a(new $.$QO(this.h.getProxy(b.$jM.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty)),this.c.set(o,h),t.push(h.value)),h.ref()}if(c.removedEditors)for(const s of c.removedEditors){const o=this.b.get(s);this.b.delete(s),o&&u.push(o)}if(c.addedEditors)for(const s of c.addedEditors){const o=A.URI.revive(s.documentUri);l.ok(this.c.has(o),`document '${o}' does not exist`),l.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const h=this.c.get(o).value,g=new I.$WO(s.id,this.h.getProxy(b.$jM.MainThreadTextEditors),this.i,new f.$V(()=>h.document),s.selections.map(P.Selection.to),s.options,s.visibleRanges.map(w=>P.Range.to(w)),typeof s.editorPosition=="number"?P.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,g)}c.newActiveEditor!==void 0&&(l.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,L.$Pc)(r),(0,L.$Pc)(u),c.removedDocuments&&this.e.fire(r),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return d.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const r=this.b.get(this.a);return c?r:r?.value}allEditors(){return[...this.b.values()]}};e.$XO=n,e.$XO=n=Je([We(0,E.$NO),We(1,p.$5j)],n),e.$YO=(0,M.$yi)("IExtHostDocumentsAndEditors")}),define(ke[360],De([1,0,19,4,6,157,17,8]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;class ${constructor(I,P){this.i=P,this.a=new O.$fe,this.b=new O.$fe,this.c=new O.$fe,this.d=new O.$fe,this.f=new O.$fe,this.g=new O.$fe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(L.$jM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const P=this.i.allEditors();return I?P:P.map(p=>p.value)}async showTextDocument(I,P,p){let S;typeof P=="number"?S={position:M.ViewColumn.from(P),preserveFocus:p}:typeof P=="object"?S={position:M.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?M.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:S={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(I.uri,S),d=v&&this.i.getEditor(v);if(d)return d.value;throw v?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,P){return new A.$UO(this.h,I,P).value}$acceptEditorPropertiesChanged(I,P){const p=this.i.getEditor(I);if(!p)throw new Error("unknown text editor");if(P.options&&p._acceptOptions(P.options),P.selections){const S=P.selections.selections.map(M.Selection.to);p._acceptSelections(S)}if(P.visibleRanges){const S=l.$Hb(P.visibleRanges.map(M.Range.to));p._acceptVisibleRanges(S)}if(P.options&&this.b.fire({textEditor:p.value,options:{...P.options,lineNumbers:M.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const S=b.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(M.Selection.to);this.a.fire({textEditor:p.value,selections:v,kind:S})}if(P.visibleRanges){const S=l.$Hb(P.visibleRanges.map(M.Range.to));this.c.fire({textEditor:p.value,visibleRanges:S})}}$acceptEditorPositionData(I){for(const P in I){const p=this.i.getEditor(P);if(!p)throw new Error("Unknown text editor");const S=M.ViewColumn.to(I[P]);p.value.viewColumn!==S&&(p._acceptViewColumn(S),this.d.fire({textEditor:p.value,viewColumn:S}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$gmc=$}),define(ke[361],De([1,0,2,5,6,3,8,17,25,18]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=e.$2nc=void 0,e.$2nc=(0,O.$yi)("IExtHostTimeline");class I{constructor(S,v){this.b=new Map,this.c=new Map,this.a=S.getProxy(L.$jM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(d,f)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&$.$Tm.equals(f,this.b.get(d.source)?.extension)){const a=d.uri===void 0?void 0:l.URI.revive(d.uri);return this.c.get(d.source)?.get(P(a))?.get(d.handle)}else return;return d}})}async $getTimeline(S,v,d,f){return this.b.get(S)?.provider.provideTimeline(l.URI.revive(v),d,f)}registerTimelineProvider(S,v,d,f){const a=new A.$Tc,n=this.d(v.id,f,a).bind(this);let i;v.onDidChange&&(i=v.onDidChange(r=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...r,id:v.id}),this));const c=this.c;return this.f({...v,scheme:S,onDidChange:void 0,async provideTimeline(r,t,u){t?.resetCache&&(a.clear(),c.get(v.id)?.clear());const s=await v.provideTimeline(r,t,u);if(s==null)return;const o=n(r,t);return{...s,source:v.id,items:s.items.map(o)}},dispose(){for(const r of c.values())r.get(v.id)?.clear();i?.dispose(),a.dispose()}},d)}d(S,v,d){return(f,a)=>{let n;if(a?.cacheResults){let i=this.c.get(S);i===void 0&&(i=new Map,this.c.set(S,i));const c=P(f);n=i.get(c),n===void 0&&(n=new Map,i.set(c,n))}return i=>{const{iconPath:c,...r}=i,t=`${S}|${i.id??i.timestamp}`;n?.set(t,i);let u,s,o;i.iconPath&&(c instanceof M.$iN?o={id:c.id,color:c.color}:l.URI.isUri(c)?(u=c,s=c):{light:u,dark:s}=c);let h;return M.$NM.isMarkdownString(r.tooltip)?h=b.MarkdownString.from(r.tooltip):(0,E.$$f)(r.tooltip)?h=r.tooltip:M.$NM.isMarkdownString(r.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=b.MarkdownString.from(r.detail)):(0,E.$$f)(r.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=r.detail),{...r,id:r.id??void 0,handle:t,source:S,command:i.command?v.toInternal(i.command,d):void 0,icon:u,iconDark:s,themeIcon:o,tooltip:h,accessibilityInformation:i.accessibilityInformation}}}}f(S,v){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:v}),(0,A.$Sc)(()=>{for(const f of this.c.values())f.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$3nc=I;function P(p){return p?.toString()}}),define(ke[362],De([1,0,233,23,2,4,3,294,7,8,18,19,17,81,21,189,26]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=void 0;function a(c,r){if((0,I.$$f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class n extends M.$Uc{constructor(r,t,u){super(),this.f=r,this.g=t,this.h=u,this.a=new Map,this.b=new d.$K0;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:o=>s(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(h=>s(h)?this.r(h):h):o})}registerTreeDataProvider(r,t,u){const s=this.createTreeView(r,{treeDataProvider:t},u);return{dispose:()=>s.dispose()}}createTreeView(r,t,u){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],o=t.dragAndDropController?.dragMimeTypes??[],h=!!t.dragAndDropController?.handleDrag,g=!!t.dragAndDropController?.handleDrop,w=this.m(r,t,u),k={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:h,hasHandleDrop:g,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},m=this.f.$registerTreeViewDataProvider(r,k),y={get onDidCollapseElement(){return w.onDidCollapseElement},get onDidExpandElement(){return w.onDidExpandElement},get selection(){return w.selectedElements},get onDidChangeSelection(){return w.onDidChangeSelection},get activeItem(){return(0,f.$LG)(u,"treeViewActiveItem"),w.focusedElement},get onDidChangeActiveItem(){return(0,f.$LG)(u,"treeViewActiveItem"),w.onDidChangeActiveItem},get visible(){return w.visible},get onDidChangeVisibility(){return w.onDidChangeVisibility},get onDidChangeCheckboxState(){return w.onDidChangeCheckboxState},get message(){return w.message},set message(D){(0,S.$Xk)(D)&&(0,f.$LG)(u,"treeViewMarkdownMessage"),w.message=D},get title(){return w.title},set title(D){w.title=D},get description(){return w.description},set description(D){w.description=D},get badge(){return w.badge},set badge(D){D!==void 0&&E.ViewBadge.isViewBadge(D)?w.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(w.badge=void 0)},reveal:(D,C)=>w.reveal(D,C),dispose:async()=>{await m,this.a.delete(r),w.dispose()}};return this.B(y),y}$getChildren(r,t){const u=this.a.get(r);return u?u.getChildren(t):Promise.reject(new b.$8F(r))}async $handleDrop(r,t,u,s,o,h,g,w){const k=this.a.get(r);if(!k)return Promise.reject(new b.$8F(r));const m=p.DataTransfer.toDataTransfer(u,async y=>(await this.f.$resolveDropFileData(r,t,y)).buffer);return g===r&&w&&await this.j(m,k,w,o,h),k.onDrop(m,s,o)}async j(r,t,u,s,o){const h=this.b.removeDragOperationTransfer(o);if(h)(await h)?.forEach((g,w)=>{g&&r.set(w,g)});else if(o&&t.handleDrag){const g=t.handleDrag(u,r,s);this.b.addDragOperationTransfer(o,g),await g}return r}async $handleDrag(r,t,u,s){const o=this.a.get(r);if(!o)return Promise.reject(new b.$8F(r));const h=await this.j(new E.$eN,o,t,s,u);if(!(!h||s.isCancellationRequested))return p.DataTransfer.from(h)}async $hasResolve(r){const t=this.a.get(r);if(!t)throw new b.$8F(r);return t.hasResolve}$resolve(r,t,u){const s=this.a.get(r);if(!s)throw new b.$8F(r);return s.resolveTreeItem(t,u)}$setExpanded(r,t,u){const s=this.a.get(r);if(!s)throw new b.$8F(r);s.setExpanded(t,u)}$setSelectionAndFocus(r,t,u){const s=this.a.get(r);if(!s)throw new b.$8F(r);s.setSelectionAndFocus(t,u)}$setVisible(r,t){const u=this.a.get(r);if(!u){if(!t)return;throw new b.$8F(r)}u.setVisible(t)}$changeCheckboxState(r,t){const u=this.a.get(r);if(!u)throw new b.$8F(r);u.setCheckboxState(t)}m(r,t,u){const s=this.B(new i(r,t,this.f,this.g.converter,this.h,u));return this.a.set(r,s),s}r(r){const t=this.a.get(r.$treeViewId);return t&&"$treeItemHandle"in r?t.getExtensionElement(r.$treeItemHandle):t&&"$focusedTreeItem"in r&&r.$focusedTreeItem?t.focusedElement:null}}e.$4nc=n;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(r=>this.getExtensionElement(r)).filter(r=>!(0,I.$hg)(r))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(r,t,u,s,o,h){if(super(),this.I=r,this.J=u,this.L=s,this.M=o,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$fe),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$fe),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$fe),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$fe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$fe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$fe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$fe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$qe,h.contributes&&h.contributes.views)for(const m in h.contributes.views)for(const y of h.contributes.views[m])y.id===r&&(this.P=y.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(m=>{Array.isArray(m)&&m.length===0||this.F.fire({message:!1,element:m})}));let g,w;const k=A.Event.debounce(this.F.event,(m,y)=>(m||(m={message:!1,elements:[]}),y.element!==!1&&(g||(g=new Promise(D=>w=D),this.G=this.G.then(()=>g)),Array.isArray(y.element)?m.elements.push(...y.element):m.elements.push(y.element)),y.message&&(m.message=!0),m),200,!0);this.B(k(({message:m,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const D=w;return g=null,this.$(y).then(()=>D())})),m&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(r){const t=r?this.getExtensionElement(r):void 0;if(r&&!t)return this.M.error(`No tree item with id '${r}' found.`),Promise.resolve([]);let u=this.X(r);return u||(u=await this.Y(t)),u?u.map(s=>s.item):void 0}getExtensionElement(r){return this.j.get(r)}reveal(r,t){t=t||{select:!0,focus:!1};const u=(0,I.$hg)(t.select)?!0:t.select,s=(0,I.$hg)(t.focus)?!1:t.focus,o=(0,I.$hg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):r?this.G.then(()=>this.S(r)).then(h=>this.W(r,h[h.length-1]).then(g=>this.J.$reveal(this.I,{item:g.item,parentChain:h.map(w=>w.item)},{select:u,focus:s,expand:o})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:u,focus:s,expand:o})}get message(){return this.O}set message(r){this.O=r,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(r){this.P=r,this.J.$setTitle(this.I,r,this.Q)}get description(){return this.Q}set description(r){this.Q=r,this.J.$setTitle(this.I,this.P,r)}get badge(){return this.R}set badge(r){this.R?.value===r?.value&&this.R?.tooltip===r?.tooltip||(this.R=p.ViewBadge.from(r),this.J.$setBadge(this.I,r))}setExpanded(r,t){const u=this.getExtensionElement(r);u&&(t?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(r,t){const u=!(0,P.$ub)(this.s,r);this.s=r;const s=this.t!==t;this.t=t,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(r){r!==this.r&&(this.r=r,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(r){const t=(await Promise.all(r.map(async u=>{const s=this.getExtensionElement(u.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:u.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);t.forEach(u=>{u.treeItem.checkboxState=u.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(u=>[u.extensionItem,u.newState])})}async handleDrag(r,t,u){const s=[];for(const o of r){const h=this.getExtensionElement(o);h&&s.push(h)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,u),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(r,t,u){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,$.$qh)(()=>this.g?.handleDrop?this.g.handleDrop(s,r,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(r,t){if(!this.f.resolveTreeItem)return;const u=this.j.get(r);if(u){const s=this.m.get(u);if(s){const o=await this.f.resolveTreeItem(s.extensionItem,u,t)??s.extensionItem;return this.hb(o),s.item.tooltip=this.eb(o.tooltip),s.item.command=this.fb(s.disposableStore,o.command),s.item}}}S(r){return this.U(r).then(t=>t?this.S(t).then(u=>this.W(t,u[u.length-1]).then(s=>(u.push(s),u))):Promise.resolve([]))}U(r){const t=this.m.get(r);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$qh)(()=>this.f.getParent(r))}W(r,t){const u=this.m.get(r);return u?Promise.resolve(u):(0,$.$qh)(()=>this.f.getTreeItem(r)).then(s=>this.kb(r,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const h=this.m.get(o);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(r){if(r){let t;if(typeof r=="string"){const u=this.getExtensionElement(r);t=u?this.m.get(u):void 0}else t=r;return t&&t.children||void 0}return this.h}async Y(r){this.rb(r);const t=new v.$qe(this.Z.token);try{const u=r?this.m.get(r):void 0,s=await this.f.getChildren(r);if(t.token.isCancellationRequested)return;const o=(0,P.$Hb)(s||[]),h=await Promise.all((0,P.$Hb)(o).map(w=>this.f.getTreeItem(w)));if(t.token.isCancellationRequested)return;const g=h.map((w,k)=>w?this.db(o[k],w,u):null);return(0,P.$Hb)(g)}finally{t.dispose()}}$(r){if(r.some(u=>!u))return this.Z.dispose(!0),this.Z=new v.$qe,this.tb(),this.J.$refresh(this.I);{const u=this.ab(r);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(r){const t=new Set,u=r.map(o=>this.m.get(o));for(const o of u)if(o&&!t.has(o.item.handle)){let h=o;for(;h&&h.parent&&u.findIndex(g=>h&&h.parent&&g&&g.item.handle===h.parent.item.handle)===-1;){const g=this.j.get(h.parent.item.handle);h=g?this.m.get(g):void 0}h&&!h.parent&&t.add(o.item.handle)}const s=[];return t.forEach(o=>{const h=this.j.get(o);if(h){const g=this.m.get(h);g&&(!g.parent||!t.has(g.parent.item.handle))&&s.push(o)}}),s}bb(r){const t={};return Promise.all(r.map(u=>this.cb(u).then(s=>{s&&(t[u]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(r){const t=this.getExtensionElement(r);if(t){const u=this.m.get(t);if(u)return this.rb(t),(0,$.$qh)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const o=this.ib(t,s,u.parent);return this.pb(t,o,u,u.parent),u.dispose(),o}return null})}return Promise.resolve(null)}db(r,t,u){const s=this.ib(r,t,u);if(t.id&&this.j.has(s.item.handle))throw new Error((0,l.localize)(0,null,t.id));return this.ob(r,s),this.qb(s,u),s}eb(r){return E.$NM.isMarkdownString(r)?p.MarkdownString.from(r):r}fb(r,t){return t?{...this.L.toInternal(t,r),originalId:t.command}:void 0}gb(r){if(r.checkboxState===void 0)return;let t,u,s;return typeof r.checkboxState=="number"?t=r.checkboxState:(t=r.checkboxState.state,u=r.checkboxState.tooltip,s=r.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:s}}hb(r){if(!E.$_M.isTreeItem(r,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(r,t,u){this.hb(t);const s=this.B(new M.$Tc),o=this.kb(r,t,u),h=this.lb(t);return{item:{handle:o,parentHandle:u?u.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:h,iconDark:this.mb(t)||h,themeIcon:this.jb(t),collapsibleState:(0,I.$hg)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:u,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(r){return r.iconPath instanceof E.$iN?r.iconPath:void 0}kb(r,{id:t,label:u,resourceUri:s},o,h){if(t)return`${i.b}/${t}`;const g=a(u,this.N),w=o?o.item.handle:i.a;let k=g?g.label:s?(0,O.$9g)(s):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const m=this.m.has(r)?this.m.get(r).item.handle:void 0,y=this.X(o)||[];let D,C=0;do{if(D=`${w}/${C}:${k}`,h||!this.j.has(D)||m===D)break;C++}while(C<=y.length);return D}lb(r){if(r.iconPath&&!(r.iconPath instanceof E.$iN))return typeof r.iconPath=="string"||L.URI.isUri(r.iconPath)?this.nb(r.iconPath):this.nb(r.iconPath.light)}mb(r){if(r.iconPath&&!(r.iconPath instanceof E.$iN)&&r.iconPath.dark)return this.nb(r.iconPath.dark)}nb(r){return L.URI.isUri(r)?r:L.URI.file(r)}ob(r,t){this.j.set(t.item.handle,r),this.m.set(r,t)}pb(r,t,u,s){this.j.delete(t.item.handle),this.m.delete(r),t.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(r,t);const o=this.X(s)||[],h=o.filter(g=>g.item.handle===u.item.handle)[0];h&&o.splice(o.indexOf(h),1,t)}qb(r,t){t?(t.children||(t.children=[]),t.children.push(r)):(this.h||(this.h=[]),this.h.push(r))}rb(r){if(r){const t=this.m.get(r);if(t){if(t.children)for(const u of t.children){const s=this.j.get(u.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(r){const t=this.m.get(r);if(t){if(t.children)for(const u of t.children){const s=this.j.get(u.item.handle);s&&this.sb(s)}this.m.delete(r),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(r=>r.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[363],De([1,0,4,3,2,30,17,92,6,8]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;class I extends O.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,d,f,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new l.$fe),this.onDidDispose=this.#d.event,this.#h=this.B(new l.$fe),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=d,this.#i=f,this.#n=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#i.dispose(),super.dispose())}get webview(){return this.c(),this.#i}get viewType(){return this.c(),this.#n}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,L.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,d){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:M.ViewColumn.from(v),preserveFocus:!!d})}c(){if(this.#l)throw new Error("Webview is disposed")}}class P extends O.$Uc{static c(){return(0,A.$Ug)()}constructor(v,d,f){super(),this.j=d,this.m=f,this.g=new Map,this.h=new Map,this.f=v.getProxy($.$jM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,d,f,a,n={}){const i=typeof a=="object"?a.viewColumn:a,c={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof a=="object"&&!!a.preserveFocus},r=(0,b.$vmc)(v),t=P.c();this.f.$createWebviewPanel((0,b.$xmc)(v),t,d,{title:f,panelOptions:p(n),webviewOptions:(0,b.$ymc)(v,this.m,n),serializeBuffersForPostMessage:r},c);const u=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,d,f,i,n,u,!0)}$onDidChangeWebviewPanelViewStates(v){const d=Object.keys(v);d.sort((f,a)=>{const n=v[f],i=v[a];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const f of d){const a=this.getWebviewPanel(f);if(!a)continue;const n=v[f];a._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,d,f){if(this.h.has(d))throw new Error(`Serializer for '${d}' already registered`);return this.h.set(d,{serializer:f,extension:v}),this.f.$registerSerializer(d,{serializeBuffersForPostMessage:(0,b.$vmc)(v)}),new E.$lM(()=>{this.h.delete(d),this.f.$unregisterSerializer(d)})}async $deserializeWebviewPanel(v,d,f,a){const n=this.h.get(d);if(!n)throw new Error(`No serializer found for '${d}'`);const{serializer:i,extension:c}=n,r=this.j.createNewWebview(v,f.webviewOptions,c),t=this.createNewWebviewPanel(v,d,f.title,a,f.panelOptions,r,f.active);await i.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(v,d,f,a,n,i,c){const r=new I(v,this.f,i,{viewType:d,title:f,viewColumn:a,panelOptions:n,active:c});return this.g.set(v,r),r}getWebviewPanel(v){return this.g.get(v)}}e.$zmc=P;function p(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(ke[364],De([1,0,4,3,92,17,6,8]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=void 0;class $ extends O.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;constructor(P,p,S,v,d,f){super(),this.#s=!1,this.#u=this.B(new l.$fe),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new l.$fe),this.onDidDispose=this.#l.event,this.#n=S,this.#a=v,this.#e=P,this.#t=p,this.#i=d,this.#r=f}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#i.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(P){this.a(),this.#a!==P&&(this.#a=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#o}set description(P){this.a(),this.#o!==P&&(this.#o=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#r}get webview(){return this.#i}get viewType(){return this.#n}_setVisible(P){P===this.#r||this.#s||(this.#r=P,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(P){this.a(),!(P?.value===this.#c?.value&&P?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(P,p){this.d=p,this.b=new Map,this.c=new Map,this.a=P.getProxy(M.$jM.MainThreadWebviewViews)}registerWebviewViewProvider(P,p,S,v){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:S,extension:P}),this.a.$registerWebviewViewProvider((0,L.$xmc)(P),p,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$vmc)(P)}),new b.$lM(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(P,p,S,v,d){const f=this.b.get(p);if(!f)throw new Error(`No view provider found for '${p}'`);const{provider:a,extension:n}=f,i=this.d.createNewWebview(P,{},n),c=new $(P,this.a,p,S,i,!0);this.c.set(P,c),await a.resolveWebviewView(c,{state:v},d)}async $onDidChangeWebviewViewVisibility(P,p){this.e(P)._setVisible(p)}async $disposeWebviewView(P){const p=this.e(P);this.c.delete(P),p.dispose(),this.d.deleteWebview(P)}e(P){const p=this.c.get(P);if(!p)throw new Error("No webview found");return p}}e.$7nc=E}),define(ke[365],De([1,0,70,15,11,265,33,12]),function(he,e,l,O,L,A,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=void 0;let $=class{constructor(P,p){P.addFileSystemProvider(O.Schemas.file,new E(p),{isCaseSensitive:b.$k})}};e.$Loc=$,e.$Loc=$=Je([We(0,l.$rmc),We(1,L.$5j)],$);class E{constructor(P){this.b=P,this.a=new A.$dr(this.b)}async stat(P){const p=await this.a.stat(P);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,p,S){return this.a.writeFile(P,p,{...S,unlock:!1,atomic:!1})}delete(P,p){return this.a.delete(P,{...p,useTrash:!1,atomic:!1})}rename(P,p,S){return this.a.rename(P,p,S)}copy(P,p,S){return this.a.copy(P,p,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,p){throw new Error("Method not implemented.")}}}),define(ke[366],De([1,0,16,64,30,34,3,6,2,20]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=void 0;let I=class extends M.$Uc{constructor(p,S){super();const v=p.getProxy(b.$jM.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async d=>{const f=$.URI.file((0,l.$jc)((0,O.tmpdir)(),(0,L.$Ug)()));return await v.$download(d,f),f})}};e.$Joc=I,e.$Joc=I=Je([We(0,E.$NO),We(1,A.$0O)],I)}),define(ke[367],De([1,0,53,16,2,93,3,15,7,32]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;class I extends A.$tmc{constructor(){super(...arguments),this.i=null}async g(t){const u=await super.g(t);if(u.scheme!==b.Schemas.file)return u;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const s=u.fsPath;let o=0;do{let h;o===0?h=s:h=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${o}`:`${s}-${o}`,await P(h);const g=O.$jc(h,"vscode.lock"),w=await d(this.d,g,!1);if(w)return this.i=w,process.on("exit",()=>{w.dispose()}),L.URI.file(h);o++}while(o<10);return u}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Voc=I;async function P(r){try{await E.Promises.stat(r);return}catch{}try{await E.Promises.mkdir(r,{recursive:!0})}catch{}}const p=1e3,S=10*60*1e3;class v extends M.$Uc{constructor(t,u){super(),this.b=t,this.c=u,this.a=this.B(new $.$Jh),this.a.cancelAndSet(async()=>{const s=await f(t,u);(!s||s.pid!==process.pid)&&(t.info(`Lock '${u}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(u,new Date,new Date)}catch(o){t.error(o),t.info(`Lock '${u}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{l.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(u),{flag:"w"})}catch(u){this.b.error(u)}}}async function d(r,t,u){try{const o={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(o),{flag:"wx"})}catch(o){r.error(o)}const s=await f(r,t);return!s||s.pid!==process.pid?u?(r.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(r.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(r,t)):(r.info(`Lock '${t}': Lock acquired.`),new v(r,t))}async function f(r,t){let u;try{u=await E.Promises.readFile(t)}catch(s){return r.error(s),null}try{return JSON.parse(String(u))}catch(s){return r.error(s),null}}async function a(r,t){let u;try{u=await E.Promises.stat(t)}catch(s){return r.error(s),0}return u.mtime.getTime()}function n(r){try{return process.kill(r,0),!0}catch{return!1}}async function i(r,t){const u=await f(r,t);if(!u)return r.info(`Lock '${t}': Could not read pid of lock holder.`),c(r,t);if(u.willReleaseAt){let w=u.willReleaseAt-Date.now();if(w<5e3){for(w>0?r.info(`Lock '${t}': The lockfile is scheduled to be released in ${w} ms.`):r.info(`Lock '${t}': The lockfile is scheduled to have been released.`);w>0;){if(await(0,$.$zh)(Math.min(100,w)),await a(r,t)===0)return c(r,t);w=u.willReleaseAt-Date.now()}return c(r,t)}}if(!n(u.pid))return r.info(`Lock '${t}': The pid ${u.pid} appears to be gone.`),c(r,t);const s=await a(r,t),o=Date.now()-s;if(o<=S)return r.info(`Lock '${t}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;r.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$zh)(2e3);const h=await a(r,t),g=Date.now()-h;return g<=S?(r.info(`Lock '${t}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(r.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),c(r,t))}async function c(r,t){r.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return d(r,t,!0)}}),define(ke[368],De([1,0,30,20,43,34]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=void 0;let M=class extends L.$Pmc{constructor($,E){super(!0,$,E)}createTerminal($,E,I){return this.createTerminalFromOptions({name:$,shellPath:E,shellArgs:I})}createTerminalFromOptions($,E){const I=new L.$Omc(this.a,(0,l.$Ug)(),$,$.name);return this.f.push(I),I.create($,this.R($,E)),I.value}};e.$eoc=M,e.$eoc=M=Je([We(0,A.$0O),We(1,O.$NO)],M)}),define(ke[369],De([1,0,4,36,38,5]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.$EL=e.OutputChannelUpdateMode=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=void 0,e.$rL="text/x-code-output",e.$sL="output",e.$tL="Log",e.$uL="text/x-code-log-output",e.$vL="log",e.$wL="workbench.panel.output",e.$xL=new L.$Pj("inOutput",!1),e.$yL=new L.$Pj("activeLogOutput",!1),e.$zL=new L.$Pj("activeLogOutput.levelSettable",!1),e.$AL=new L.$Pj("activeLogOutput.level",""),e.$BL=new L.$Pj("activeLogOutput.levelIsDefault",!1),e.$CL=new L.$Pj("outputView.scrollLock",!1),e.$DL=(0,A.$yi)("outputService");var M;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$EL={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new l.$fe,this.onDidRegisterChannel=this.b.event,this.c=new l.$fe,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(I=>E.push(I)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}O.$fo.add(e.$EL.OutputChannels,new b),e.$FL=new L.$Pj("activeOutputChannel","")}),define(ke[158],De([1,0,6,5,20,25,11,369,70,28,60,194,22,18,33,4,3]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=e.$Fnc=void 0;class a extends M.$$j{get disposed(){return this.n}constructor(r,t,u,s,o){super(),this.id=r,this.name=t,this.r=u,this.s=s,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(r){this.append(r+`
`)}append(r){this.info(r)}clear(){const r=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,r)}replace(r){const t=this.m;this.info(r),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(r,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof r=="boolean"?r:t))}hide(){this.s.$close(this.id)}g(r,t){this.m+=p.$He.fromString(t).byteLength,(0,M.log)(this.r,r,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends a{appendLine(r){this.append(r)}}let i=class{constructor(r,t,u,s,o,h){this.i=t,this.j=u,this.k=s,this.l=o,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=r.getProxy(l.$jM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(r){this.h=r;for(const[t,u]of this.g)u.visible=t===this.h}createOutputChannel(r,t,u){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,o=(0,S.$$f)(t)?t:void 0;if((0,S.$$f)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const g=this.i.environment.extensionLogLevel?.find(([k])=>A.$Tm.equals(u.identifier,k))?.[1];g&&(h=(0,M.$jk)(g));const w=s?this.o(r,h,u):this.n(r,o,u);return w.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),s?this.r(r,h??this.m.getLevel(),w):this.q(r,w)}async n(r,t,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,o=this.k.extUri.joinPath(s,`${this.f++}-${r.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(r,o,t,u.identifier.value);return new a(g,r,h,this.a,u)}async o(r,t,u){const s=await this.p(u),o=r.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath(s,`${o}.log`),g=`${u.identifier.value}.${o}`,w=this.l.createLogger(h,{id:g,name:r,logLevel:t,extensionId:u.identifier.value});return new n(g,r,w,this.a,u)}p(r){let t=this.d.get(r.identifier.value);if(!t){const u=this.k.extUri.joinPath(this.i.logsLocation,r.identifier.value);this.d.set(r.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(u)}catch(s){if((0,v.$il)(s)!==v.FileSystemProviderErrorCode.FileExists)throw s}return u})())}return t}q(r,t){let u=!1;const s=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return r},append(o){s(),t.then(h=>h.append(o))},appendLine(o){s(),t.then(h=>h.appendLine(o))},clear(){s(),t.then(o=>o.clear())},replace(o){s(),t.then(h=>h.replace(o))},show(o,h){s(),t.then(g=>g.show(o,h))},hide(){s(),t.then(o=>o.hide())},dispose(){u=!0,t.then(o=>o.dispose())}}}r(r,t,u){const s=new f.$Tc,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},h=s.add(new d.$fe);function g(w){t=w,h.fire(w)}return u.then(w=>{s.add(w),w.logLevel!==t&&g(w.logLevel),s.add(w.onDidChangeLogLevel(k=>g(k)))}),{...this.q(r,u),get logLevel(){return t},onDidChangeLogLevel:h.event,trace(w,...k){o(),u.then(m=>m.trace(w,...k))},debug(w,...k){o(),u.then(m=>m.debug(w,...k))},info(w,...k){o(),u.then(m=>m.info(w,...k))},warn(w,...k){o(),u.then(m=>m.warn(w,...k))},error(w,...k){o(),u.then(m=>m.error(w,...k))},dispose(){s.dispose()}}}};e.$Fnc=i,e.$Fnc=i=Je([We(0,L.$NO),We(1,E.$4O),We(2,$.$rmc),We(3,I.$7lc),We(4,M.$6j),We(5,M.$5j)],i),e.$Gnc=(0,O.$yi)("IExtHostOutputService")}),define(ke[159],De([1,0,5,7]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$in=(0,l.$yi)("remoteAgentService"),e.$jn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let A=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await L.getRoundTripTime();if($===void 0)return;A=Math.min(A,$/2),await(0,O.$zh)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(A):M=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:M,current:A,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:typeof M>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[370],De([1,0,237,66,36,42,55,3,4,159,12,24,7]),function(he,e,l,O,L,A,M,b,$,E,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgb=e.$Rgb=e.$Qgb=e.$Pgb=e.$Ogb=e.$Ngb=e.$Mgb=void 0,e.$Mgb=Object.freeze({id:"application",order:100,title:(0,l.localize)(0,null),type:"object"}),e.$Ngb=Object.freeze({id:"workbench",order:7,title:(0,l.localize)(1,null),type:"object"}),e.$Ogb=Object.freeze({id:"security",scope:1,title:(0,l.localize)(2,null),type:"object",order:7}),e.$Pgb=Object.freeze({id:"problems",title:(0,l.localize)(3,null),type:"object",order:101}),e.$Qgb={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new $.$fe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new S;L.$fo.add(e.$Qgb.ConfigurationMigration,v);let d=class extends b.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const r of c.added)await this.f(r,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(c=>this.g(c,n?.uri))])}async g(n,i){const c=this.a.inspect(n.key,{resource:i}),r=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,u]of r){const s=c[t];if(!s)continue;const o=[];if(s.value!==void 0){const h=await this.h(n,t,s.value,i,void 0);for(const g of h??[])o.push([g,[]])}for(const{identifiers:h,value:g}of s.overrides??[])if(g!==void 0){const w=await this.h(n,t,g,i,h);for(const k of w??[])o.push([k,h])}o.length&&await Promise.allSettled(o.map(async([[h,g],w])=>this.a.updateValue(h,g.value,{resource:i,overrideIdentifiers:w},u)))}}async h(n,i,c,r,t){const u=o=>{const g=this.a.inspect(o,{resource:r})[i];if(g)return t?g.overrides?.find(({identifiers:w})=>(0,P.$9n)(w,t))?.value:g.value},s=await n.migrateFn(c,u);return Array.isArray(s)?s:[[n.key,s]]}};e.$Rgb=d,e.$Rgb=d=Je([We(0,M.$5i),We(1,A.$Hi)],d);let f=class extends b.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new p.$Vh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$fo.as(O.$ko.Configuration).registerConfiguration({...e.$Ogb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,l.localize)(4,null)},default:[],markdownDescription:(0,l.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,l.localize)(6,null),scope:2}}})}};e.$Sgb=f,e.$Sgb=f=Je([We(0,E.$in)],f)}),define(ke[371],De([1,0,35,15,16,23,247,370,66,5,36]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Ugb=e.$Tgb=void 0,e.$Vgb=d,e.$Wgb=f,e.$Tgb=(0,E.$yi)("editorResolverService"),e.$Ugb="workbench.editorAssociations";const P=I.$fo.as($.$ko.Configuration),p={...b.$Ngb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration(p);var S;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(S||(e.RegisteredEditorPriority=S={}));var v;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function d(a){switch(a){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function f(a,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const r=typeof a=="string"&&a.indexOf(L.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,A.$9g)(n);return l.$rk(typeof a=="string"?a.toLowerCase():a,r.toLowerCase())}}),define(ke[372],De([1,0,31,15,16,12,23,2,5,284,42,148,159]),function(he,e,l,O,L,A,M,b,$,E,I,P,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=e.$XL=void 0,e.$XL=(0,$.$yi)("pathService");let v=S=class{constructor(f,a,n,i){this.d=f,this.e=a,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??f})()}hasValidBasename(f,a,n){return typeof a=="string"||typeof a>"u"?this.a.then(i=>this.h(f,i,a)):this.h(f,a,n)}h(f,a,n){return f.scheme===O.Schemas.file||f.scheme===O.Schemas.vscodeRemote?(0,l.$vg)(n??(0,M.$9g)(f),a===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,a){if(f.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,E.$UL)(a.getWorkspace());if(n)return n;const i=a.getWorkspace().folders[0];if(i)return i.uri.scheme;const c=a.getWorkspace().configuration;return c?c.scheme:O.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?L.$fc:L.$gc)}async fileURI(f){let a="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const i=f.indexOf("/",2);i===-1?(a=f.substring(2),f="/"):(a=f.substring(2,i),f=f.substring(i)||"/")}return b.URI.from({scheme:O.Schemas.file,authority:a,path:f,query:"",fragment:""})}};e.$YL=v,e.$YL=v=S=Je([We(1,p.$in),We(2,P.$GL),We(3,I.$Hi)],v)}),define(ke[373],De([1,0,249,56,4,57,3,2,55,254,11,67,142,88,42,148,26,21,18,24,38]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=e.$QL=e.OnPortForward=e.$LL=e.$KL=e.TunnelSource=e.TunnelCloseReason=e.$IL=e.$HL=void 0,e.$JL=o,e.$ML=w,e.$NL=k,e.$OL=m,e.$PL=D;const r=10*1e3,t="remote.tunnels.toRestore",u="remote.tunnels.toRestoreExpiration",s=1e3*60*60*24*14;e.$HL="onTunnel",e.$IL=new c.$Pj("forwardedPortsViewEnabled",!1,l.localize(0,null));function o(T){const j=T.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(j)return{host:j[1]?.substring(0,j[1].length-1)||"localhost",port:Number(j[2])}}var h;(function(T){T.Other="Other",T.User="User",T.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var g;(function(T){T[T.User=0]="User",T[T.Auto=1]="Auto",T[T.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$KL={source:g.User,description:l.localize(1,null)},e.$LL={source:g.Auto,description:l.localize(2,null)};function w(T,j,z){const N=T.get(m(j,z));if(N)return N;if((0,S.$sw)(j))for(const F of S.$rw){const B=m(F,z);if(T.has(B))return T.get(B)}else if((0,S.$uw)(j))for(const F of S.$tw){const B=m(F,z);if(T.has(B))return T.get(B)}}function k(T,j,z){const N=w(T,j,z);if(N)return N;const F=(0,S.$uw)(j)?"localhost":(0,S.$sw)(j)?"0.0.0.0":void 0;if(F)return w(T,F,z)}function m(T,j){return T+":"+j}var y;(function(T){T.Notify="notify",T.OpenBrowser="openBrowser",T.OpenBrowserOnce="openBrowserOnce",T.OpenPreview="openPreview",T.Silent="silent",T.Ignore="ignore"})(y||(e.OnPortForward=y={}));function D(T){return T&&"host"in T&&typeof T.host=="string"&&"port"in T&&typeof T.port=="number"&&(!("detail"in T)||typeof T.detail=="string")&&(!("pid"in T)||typeof T.pid=="string")}class C extends M.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(j){super(),this.r=j,this.j=[],this.n=new L.$fe,this.onDidChangeAttributes=this.n.event,this.B(j.onDidChangeConfiguration(z=>{(z.affectsConfiguration(C.c)||z.affectsConfiguration(C.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(j,z,N){let F=this.w(j,z,N,this.j,0);const B={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const Y=this.j[F];Y.key===j?(B.onAutoForward=Y.onAutoForward??B.onAutoForward,B.elevateIfNeeded=Y.elevateIfNeeded!==void 0?Y.elevateIfNeeded:B.elevateIfNeeded,B.label=Y.label??B.label,B.requireLocalPort=Y.requireLocalPort,B.protocol=Y.protocol):(B.onAutoForward=B.onAutoForward??Y.onAutoForward,B.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:Y.elevateIfNeeded,B.label=B.label??Y.label,B.requireLocalPort=B.requireLocalPort!==void 0?B.requireLocalPort:void 0,B.protocol=B.protocol??Y.protocol),F=this.w(j,z,N,this.j,F+1)}return B.onAutoForward!==void 0||B.elevateIfNeeded!==void 0||B.label!==void 0||B.requireLocalPort!==void 0||B.protocol!==void 0?B:this.C()}t(j){return j.start!==void 0&&j.end!==void 0}u(j){return j.host!==void 0&&j.port!==void 0&&(0,n.$$f)(j.host)&&(0,n.$cg)(j.port)}w(j,z,N,F,B){if(B>=F.length)return-1;const Y=!(0,S.$sw)(z)&&!(0,S.$uw)(z),H=F.slice(B).findIndex(K=>(0,n.$cg)(K.key)?Y?!1:K.key===j:this.t(K.key)?Y?!1:j>=K.key.start&&j<=K.key.end:this.u(K.key)?j===K.key.port&&z===K.key.host:N?K.key.test(N):!1);return H>=0?H+B:-1}y(){const j=this.r.getValue(C.c);if(!j||!(0,n.$ag)(j))return[];const z=[];for(const F in j){if(F===void 0)continue;const B=j[F];let Y;if(Number(F))Y=Number(F);else if((0,n.$$f)(F))if(C.g.test(F)){const re=F.match(C.g);Y={start:Number(re[1]),end:Number(re[2])}}else if(C.h.test(F)){const re=F.match(C.h);Y={host:re[1],port:Number(re[2])}}else{let re;try{re=RegExp(F)}catch{}re&&(Y=re)}Y&&z.push({key:Y,elevateIfNeeded:B.elevateIfNeeded,onAutoForward:B.onAutoForward,label:B.label,requireLocalPort:B.requireLocalPort,protocol:B.protocol})}const N=this.r.getValue(C.f);return N&&(this.m={elevateIfNeeded:N.elevateIfNeeded,label:N.label,onAutoForward:N.onAutoForward,requireLocalPort:N.requireLocalPort,protocol:N.protocol}),this.z(z)}z(j){function z(N,F){return(0,n.$cg)(N.key)?N.key:F.t(N.key)?N.key.start:F.u(N.key)?N.key.port:Number.MAX_VALUE}return j.sort((N,F)=>z(N,this)-z(F,this))}C(){return this.m}static providedActionToAction(j){switch(j){case S.ProvidedOnAutoForward.Notify:return y.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case S.ProvidedOnAutoForward.Silent:return y.Silent;case S.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(j,z,N){const B=this.r.inspect(C.c).userRemoteValue;let Y;!B||!(0,n.$ag)(B)?Y={}:Y=(0,i.$5n)(B),Y[`${j}`]||(Y[`${j}`]={});for(const re in z)Y[`${j}`][re]=z[re];return this.r.updateValue(C.c,Y,N)}}e.$QL=C;let R=class extends M.$Uc{constructor(j,z,N,F,B,Y,re,H,K,_){super(),this.H=j,this.I=z,this.J=N,this.L=F,this.M=B,this.N=Y,this.O=re,this.P=H,this.Q=K,this.R=_,this.c=new Map,this.g=new L.$fe,this.onForwardPort=this.g.event,this.h=new L.$fe,this.onClosePort=this.h.event,this.j=new L.$fe,this.onPortName=this.j.event,this.n=new L.$fe,this.onCandidatesChanged=this.n.event,this.t=new L.$fe,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$fe,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new C(N),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Z=>{const $e=await this.getAttributes(Z.map(oe=>({port:oe.tunnelRemotePort,host:oe.tunnelRemoteHost})));for(const oe of Z)if(oe.localAddress){const Pe=m(oe.tunnelRemoteHost,oe.tunnelRemotePort),te=k(this.m??new Map,oe.tunnelRemoteHost,oe.tunnelRemotePort);this.forwarded.set(Pe,{remotePort:oe.tunnelRemotePort,remoteHost:oe.tunnelRemoteHost,localAddress:oe.localAddress,protocol:$e?.get(oe.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(oe.localAddress,$e?.get(oe.tunnelRemotePort)),localPort:oe.tunnelLocalPort,runningProcess:te?.detail,hasRunningProcess:!!te,pid:te?.pid,privacy:oe.privacy,source:e.$KL}),this.f.set(Pe,oe)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Z=>{const $e=m(Z.tunnelRemoteHost,Z.tunnelRemotePort);if(!k(this.forwarded,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!k(this.detected,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!k(this.c,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&Z.localAddress){const oe=k(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort),Pe=(await this.getAttributes([{port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost}]))?.get(Z.tunnelRemotePort);this.forwarded.set($e,{remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localAddress:Z.localAddress,protocol:Pe?.protocol??S.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,Pe),localPort:Z.tunnelLocalPort,closeable:!0,runningProcess:oe?.detail,hasRunningProcess:!!oe,pid:oe?.pid,privacy:Z.privacy,source:e.$KL})}await this.cb(),this.f.set($e,Z),this.g.fire(this.forwarded.get($e))})),this.B(this.H.onTunnelClosed(Z=>this.W(Z,h.Other))),this.U()}S(){return this.Q.extensions.find(j=>j.activationEvents?.includes(e.$HL))?(this.R.createKey(e.$IL.key,!0),!0):!1}U(){if(this.S())return;const j=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&j.dispose()}))}async W(j,z){const N=m(j.host,j.port);this.forwarded.has(N)&&(this.forwarded.delete(N),await this.cb(),this.h.fire(j))}X(j,z){if(j.startsWith("http"))return b.URI.parse(j);const N=z?.protocol??"http";return b.URI.parse(`${N}://${j}`)}async Y(j){const z=this.N.getWorkspace(),N=z.configuration?(0,A.$mj)(z.configuration.path):z.folders.length>0?(0,A.$mj)(z.folders[0].uri.path):void 0;if(N===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${j}.${this.L.remoteAuthority}.${N}`}async Z(){return this.Y(t)}async $(){return this.Y(u)}async ab(){const j=this.I.get(t,1);if(j)return this.I.remove(t,1),await this.cb(),j;const z=await this.Z();if(z)return this.I.get(z,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const j=await this.s;if(j&&j!==this.y){const z=JSON.parse(j)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${z.map(N=>N.remotePort).join(", ")}`);for(const N of z){const F=k(this.detected,N.remoteHost,N.remotePort);N.source.source!==g.Extension&&!F||N.source.source===g.Extension&&F?await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,elevateIfNeeded:!0,source:N.source}):N.source.source===g.Extension&&!F&&this.D.set(m(N.remoteHost,N.remotePort),N)}}}if(this.z=!0,this.C.fire(),!this.w){const j=await this.Z();this.w=this.B(new M.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async z=>{z.key===j&&(this.s=Promise.resolve(this.I.get(j,0)),await this.restoreForwarded())}))}}bb(){const j=this.I.keys(0,0).filter(z=>z.startsWith(u));for(const z of j){const N=this.I.getNumber(z,0);if(N&&N<Date.now()){this.s=Promise.resolve(void 0);const F=z.replace(u,t);this.I.remove(z,0),this.I.remove(F,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=Array.from(this.forwarded.values()),z=j.map(Y=>({remoteHost:Y.remoteHost,remotePort:Y.remotePort,localPort:Y.localPort,name:Y.name,localAddress:Y.localAddress,localUri:Y.localUri,protocol:Y.protocol,source:Y.source}));let N;j.length>0&&(N=JSON.stringify(z));const F=await this.Z(),B=await this.$();!N&&F&&B?(this.I.remove(F,0),this.I.remove(B,0)):N!==this.y&&F&&B&&(this.I.store(F,N,0,0),this.I.store(B,Date.now()+s,0,0)),this.y=N}}async eb(j,z,N){if(!j.tunnelLocalPort||!N?.requireLocalPort||j.tunnelLocalPort===z)return;const F=new Date;if(this.db.getTime()+r>F.getTime())return;this.db=F;const B=l.localize(3,null,z,j.tunnelRemotePort,j.tunnelLocalPort);return this.P.info(B)}async forward(j,z){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.fb(j,z)}async fb(j,z){await this.Q.activateByEvent(e.$HL);const N=k(this.forwarded,j.remote.host,j.remote.port);z=z??(z!==null?(await this.getAttributes([j.remote]))?.get(j.remote.port):void 0);const F=j.local!==void 0?j.local:j.remote.port;let B;if(N)return this.hb(N,j,z);{const Y=this.L.remoteAuthority,re=Y?{getAddress:async()=>(await this.M.resolveAuthority(Y)).authority}:void 0,H=m(j.remote.host,j.remote.port);this.c.set(H,!0),j=this.gb(H,j);const K=await this.H.openTunnel(re,j.remote.host,j.remote.port,void 0,F,j.elevateIfNeeded?j.elevateIfNeeded:z?.elevateIfNeeded,j.privacy,z?.protocol);if(typeof K=="string")B=K;else if(K&&K.localAddress){const _=k(this.m??new Map,j.remote.host,j.remote.port),Z=K.protocol?K.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:z?.protocol??S.TunnelProtocol.Http,$e={remoteHost:K.tunnelRemoteHost,remotePort:K.tunnelRemotePort,localPort:K.tunnelLocalPort,name:z?.label??j.name,closeable:!0,localAddress:K.localAddress,protocol:Z,localUri:await this.X(K.localAddress,z),runningProcess:_?.detail,hasRunningProcess:!!_,pid:_?.pid,source:j.source??e.$KL,privacy:K.privacy};return this.forwarded.set(H,$e),this.f.set(H,K),this.c.delete(H),await this.cb(),await this.eb(K,F,z),this.g.fire($e),K}this.c.delete(H)}return B}gb(j,z){const N=this.D.has(j)?this.D:this.F.has(j)?this.F:void 0;if(N){const F=N.get(j);N.delete(j),F&&(z.name=F.name??z.name,z.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??z.local,z.privacy=z.privacy)}return z}async hb(j,z,N){const F=N?.label??z.name;let B;(function(re){re[re.None=0]="None",re[re.Fire=1]="Fire",re[re.Reopen=2]="Reopen"})(B||(B={}));let Y=B.None;switch(F!==j.name&&(j.name=F,Y=B.Fire),(N?.protocol||j.protocol!==S.TunnelProtocol.Http)&&N?.protocol!==j.protocol&&(z.source=j.source,Y=B.Reopen),z.privacy&&j.privacy!==z.privacy&&(Y=B.Reopen),Y){case B.Fire:{this.g.fire();break}case B.Reopen:await this.close(j.remoteHost,j.remotePort,h.User),await this.fb(z,N)}return k(this.f,z.remote.host,z.remote.port)}async name(j,z,N){const F=k(this.forwarded,j,z),B=m(j,z);if(F){F.name=N,await this.cb(),this.j.fire({host:j,port:z});return}else this.detected.has(B)&&(this.detected.get(B).name=N,this.j.fire({host:j,port:z}))}async close(j,z,N){const F=m(j,z),B=this.forwarded.get(F);return N===h.AutoForwardEnd&&B&&B.source.source===g.Auto&&this.F.set(F,{local:B.localPort,name:B.name,privacy:B.privacy}),await this.H.closeTunnel(j,z),this.W({host:j,port:z},N)}address(j,z){const N=m(j,z);return(this.forwarded.get(N)||this.detected.get(N))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(j){if(j)for(const z of j){const N=k(this.m??new Map,z.remoteAddress.host,z.remoteAddress.port),F=typeof z.localAddress=="string"?z.localAddress:m(z.localAddress.host,z.localAddress.port);this.detected.set(m(z.remoteAddress.host,z.remoteAddress.port),{remoteHost:z.remoteAddress.host,remotePort:z.remoteAddress.port,localAddress:F,protocol:S.TunnelProtocol.Http,localUri:this.X(F),closeable:!1,runningProcess:N?.detail,hasRunningProcess:!!N,pid:N?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:l.localize(4,null)}}),this.H.setEnvironmentTunnel(z.remoteAddress.host,z.remoteAddress.port,F,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(j){this.r=j}async setCandidates(j){let z=j;this.r&&(z=await this.r(j));const N=this.ib(z);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(N.values()).map(F=>F.port).join(", ")}`),this.n.fire(N)}ib(j){const z=this.m??new Map,N=new Map;return this.m=N,j.forEach(F=>{const B=m(F.host,F.port);N.set(B,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),z.has(B)&&z.delete(B);const Y=k(this.forwarded,F.host,F.port);Y&&(Y.runningProcess=F.detail,Y.hasRunningProcess=!0,Y.pid=F.pid)}),z.forEach((F,B)=>{const Y=o(B);if(!Y)return;const re=k(this.forwarded,Y.host,Y.port);re&&(re.runningProcess=void 0,re.hasRunningProcess=!1,re.pid=void 0);const H=k(this.detected,Y.host,Y.port);H&&(H.runningProcess=void 0,H.hasRunningProcess=!1,H.pid=void 0)}),z}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const j=Array.from(this.forwarded.values()),z=await this.getAttributes(j.map(N=>({port:N.remotePort,host:N.remoteHost})),!1);if(z)for(const N of j){const F=z.get(N.remotePort);(F?.protocol||N.protocol!==S.TunnelProtocol.Http)&&F?.protocol!==N.protocol&&await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,source:N.source},F),F&&F.label&&F.label!==N.name&&await this.name(N.remoteHost,N.remotePort,F.label)}}async getAttributes(j,z=!0){const N=new Map,F=new Map;j.forEach(K=>{const _=k(this.m??new Map,S.$rw[0],K.port)??K;if(_){N.set(K.port,_);const Z=D(_)?_.pid:void 0;F.has(Z)||F.set(Z,[]),F.get(Z)?.push(K.port)}});const B=new Map;if(j.forEach(K=>{const _=this.configPortsAttributes.getAttributes(K.port,K.host,N.get(K.port)?.detail);_&&B.set(K.port,_)}),this.G.length===0||!z)return B.size>0?B:void 0;const Y=await Promise.all(this.G.flatMap(K=>Array.from(F.entries()).map(_=>{const Z=_[1],$e=N.get(Z[0]);return K.providePortAttributes(Z,$e?.pid,$e?.detail,a.CancellationToken.None)}))),re=new Map;if(Y.forEach(K=>K.forEach(_=>{_&&re.set(_.port,_)})),!B&&!re)return;const H=new Map;return j.forEach(K=>{const _=B.get(K.port),Z=re.get(K.port);H.set(K.port,{elevateIfNeeded:_?.elevateIfNeeded,label:_?.label,onAutoForward:_?.onAutoForward??C.providedActionToAction(Z?.autoForwardAction),requireLocalPort:_?.requireLocalPort,protocol:_?.protocol})}),H}addAttributesProvider(j){this.G.push(j)}};e.$RL=R,Je([(0,O.$4h)(1e3)],R.prototype,"cb",null),e.$RL=R=Je([We(0,S.$mw),We(1,p.$5p),We(2,$.$5i),We(3,d.$GL),We(4,P.$Jl),We(5,v.$Hi),We(6,I.$5j),We(7,E.$Rw),We(8,f.$HG),We(9,c.$Qj)],R)}),define(ke[94],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$qK=e.$pK=void 0;class l{constructor(M,b){this.line=M,this.character=b}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,b){return new l(0,0)}with(M){return new l(0,0)}}e.$pK=l;class O{constructor(M,b,$,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(M,b),this.end=new l($,E)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new O(0,0,0,0)}with(M){return new O(0,0,0,0)}}e.$qK=O;var L;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(ke[37],De([1,0,19,35,24,31,14,5,16,13,94,7]),function(he,e,l,O,L,A,M,b,$,E,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$NK=e.$GK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$DK=e.$CK=e.$BK=e.$AK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.TextSearchCompleteMessageType=void 0,e.$xK=a,e.$yK=n,e.$zK=i,e.$EK=w,e.$FK=k,e.$HK=D,e.$IK=C,e.$JK=R,e.$KK=T,e.$LK=j,e.$MK=z,e.$OK=F,e.$QK=re,e.$RK=H,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$rK="workbench.view.search",e.$sK="workbench.panel.search",e.$tK="workbench.view.search",e.$uK="search-result",e.$vK="search.exclude";const p="\u27EA ",S=" characters skipped \u27EB",v=(p.length+S.length+5)*2;e.$wK=(0,b.$yi)("searchService");var d;(function(_){_[_.file=0]="file",_[_.text=1]="text",_[_.aiText=2]="aiText"})(d||(e.SearchProviderType=d={}));var f;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.aiText=3]="aiText"})(f||(e.QueryType=f={}));function a(_){return!!_.preview}function n(_){return!!_.resource}function i(_){return!!_.message}var c;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class r{constructor(Z){this.resource=Z,this.results=[]}}e.$AK=r;class t{constructor(Z,$e,oe,Pe){this.ranges=$e,this.webviewIndex=Pe;const te=Array.isArray($e)?$e:[$e];if(oe&&oe.matchLines===1&&u(te)){Z=(0,M.$4f)(Z,oe.matchLines);let U="",ee=0,be=0;const ue=Math.floor(oe.charsPerLine/5),ce=[];for(const ae of te){const le=Math.max(ae.startColumn-ue,0),J=ae.startColumn+oe.charsPerLine;if(le>be+ue+v){const se=p+(le-be)+S;U+=se+Z.slice(le,J),ee+=le-(be+se.length)}else U+=Z.slice(be,J);ce.push(new o(0,ae.startColumn-ee,ae.endColumn-ee)),be=J}this.preview={text:U,matches:Array.isArray(this.ranges)?ce:ce[0]}}else{const U=Array.isArray($e)?$e[0].startLineNumber:$e.startLineNumber;this.preview={text:Z,matches:(0,l.$1b)($e,ee=>new s(ee.startLineNumber-U,ee.startColumn,ee.endLineNumber-U,ee.endColumn))}}}}e.$BK=t;function u(_){const Z=_[0].startLineNumber;for(const $e of _)if($e.startLineNumber!==Z||$e.endLineNumber!==Z)return!1;return!0}class s{constructor(Z,$e,oe,Pe){this.startLineNumber=Z,this.startColumn=$e,this.endLineNumber=oe,this.endColumn=Pe}}e.$CK=s;class o extends s{constructor(Z,$e,oe){super(Z,$e,Z,oe)}}e.$DK=o;var h;(function(_){_.List="list",_.Tree="tree"})(h||(e.ViewMode=h={}));var g;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function w(_,Z=!0){const $e=_&&_.files&&_.files.exclude,oe=Z&&_&&_.search&&_.search.exclude;if(!$e&&!oe)return;if(!$e||!oe)return $e||oe;let Pe=Object.create(null);return Pe=L.$8n(Pe,L.$5n($e)),Pe=L.$8n(Pe,L.$5n(oe),!0),Pe}function k(_,Z){return _.excludePattern&&O.$rk(_.excludePattern,Z)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&O.$rk(_.includePattern,Z)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some($e=>{const oe=$e.folder.fsPath;if(A.$xg(Z,oe)){const Pe=$.$lc(oe,Z);return!$e.includePattern||!!O.$rk($e.includePattern,Pe)}else return!1}):!1:!0}var m;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class y extends Error{constructor(Z,$e){super(Z),this.code=$e}}e.$GK=y;function D(_){const Z=_.message;if((0,E.$4)(_))return new y(Z,m.canceled);try{const $e=JSON.parse(Z);return new y($e.message,$e.code)}catch{return new y(Z,m.other)}}function C(_){const Z={message:_.message,code:_.code};return new Error(JSON.stringify(Z))}function R(_){return _.type==="error"?!0:_.type==="success"}function T(_){return _.type==="success"}function j(_){return!!_.path}function z(_,Z,$e=!0){const oe=_.searchPath?_.searchPath:_.relativePath;return $e?(0,M.$1f)(oe,Z):O.$rk(Z,oe)}class N{constructor(Z){this.path=Z,this.results=[]}addMatch(Z){this.results.push(Z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$NK=N;function F(_,Z){const $e={..._||{},...Z||{}};return Object.keys($e).filter(oe=>{const Pe=$e[oe];return typeof Pe=="boolean"&&Pe})}class B{constructor(Z,$e){this.c=null,this.a={...Z.excludePattern||{},...$e.excludePattern||{}},this.b=O.$sk(this.a);let oe=Z.includePattern;$e.includePattern&&(oe?oe={...oe,...$e.includePattern}:oe=$e.includePattern),oe&&(this.c=O.$sk(oe))}matchesExcludesSync(Z,$e,oe){return!!(this.b&&this.b(Z,$e,oe))}includedInQuerySync(Z,$e,oe){return!(this.b&&this.b(Z,$e,oe)||this.c&&!this.c(Z,$e,oe))}includedInQuery(Z,$e,oe){const Pe=this.b(Z,$e,oe),te=()=>this.c?!!this.c(Z,$e,oe):!0;return(0,P.$kh)(Pe)?Pe.then(U=>U?!1:te()):te()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$PK=B;function Y(_){for(const Z in _)if(typeof _[Z]!="boolean")return!0;return!1}function re(_){if(!_)return;let Z;return $e=>(Z||(Z=(_()||Promise.resolve([])).then(oe=>oe?K(oe):{})),Z.then(oe=>!!oe[$e]))}function H(_){if(!_)return;let Z;return $e=>{if(!Z){const oe=_();Z=oe?K(oe):{}}return!!Z[$e]}}function K(_){const Z={};for(const $e of _)Z[$e]=!0;return Z}}),define(ke[44],De([1,0,19,7,21,4,3,78,15,126,23,14,2,235,5,11,268,42,60,28,20,17,8,68,37,6,58]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c,r,t,u,s,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=e.$lmc=void 0;function g(T,j,z){return new I.$1g(N=>y(N,z)).isEqual(T,j)}function w(T,j,z){return g(T.uri,j.uri,z)?0:(0,P.$sf)(T.uri.toString(),j.uri.toString())}function k(T,j,z){return T.index!==j.index?T.index<j.index?-1:1:g(T.uri,j.uri,z)?(0,P.$sf)(T.name,j.name):(0,P.$sf)(T.uri.toString(),j.uri.toString())}function m(T,j,z,N){const F=T.slice(0).sort((Y,re)=>z(Y,re,N)),B=j.slice(0).sort((Y,re)=>z(Y,re,N));return(0,l.$Eb)(F,B,(Y,re)=>z(Y,re,N))}function y(T,j){const z=j.getCapabilities(T.scheme);return!(z&&z&1024)}class D extends a.$Ri{static toExtHostWorkspace(j,z,N,F){if(!j)return{workspace:null,added:[],removed:[]};const{id:B,name:Y,folders:re,configuration:H,transient:K,isUntitled:_}=j,Z=[],$e=z;z?re.forEach((U,ee)=>{const be=p.URI.revive(U.uri),ue=D.o(N||z,be,F);ue?(ue.name=U.name,ue.index=U.index,Z.push(ue)):Z.push({uri:be,name:U.name,index:ee})}):Z.push(...re.map(({uri:U,name:ee,index:be})=>({uri:p.URI.revive(U),name:ee,index:be}))),Z.sort((U,ee)=>U.index<ee.index?-1:1);const oe=new D(B,Y,Z,!!K,H?p.URI.revive(H):null,!!_,U=>y(U,F)),{added:Pe,removed:te}=m($e?$e.workspaceFolders:[],oe.workspaceFolders,w,F);return{workspace:oe,added:Pe,removed:te}}static o(j,z,N){for(let F=0;F<j.folders.length;F++){const B=j.workspaceFolders[F];if(g(B.uri,z,N))return B}}constructor(j,z,N,F,B,Y,re){super(j,N.map(H=>new a.$Si(H)),F,B,re),this.t=z,this.u=Y,this.q=[],this.s=b.$Ei.forUris(re),N.forEach(H=>{this.q.push(H),this.s.set(H.uri,H)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,I.$$g)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let C=class{constructor(j,z,N,F,B){this.c=new A.$fe,this.onDidChangeWorkspace=this.c.event,this.g=new A.$fe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new A.$he,this.C=new Map,this.h=F,this.s=N,this.t=B,this.j=new E.$Fm,this.k=new O.$xh,this.o=j.getProxy(o.$jM.MainThreadWorkspace),this.q=j.getProxy(o.$jM.MainThreadMessageService);const Y=z.workspace;this.l=Y?new D(Y.id,Y.name,[],!!Y.transient,Y.configuration?p.URI.revive(Y.configuration):null,!!Y.isUntitled,re=>y(re,N)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:$.Schemas.untitled,path:(0,I.$9g)((0,I.$$g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,N,...F){const B=[];if(Array.isArray(F)&&F.forEach(_=>{p.URI.isUri(_.uri)&&!B.some(Z=>g(Z.uri,_.uri,this.s))&&B.push({uri:_.uri,name:_.name||(0,I.$8g)(_.uri)})}),this.n||[z,N].some(_=>typeof _!="number"||_<0)||N===0&&B.length===0)return!1;const Y=this.x?this.x.workspaceFolders:[];if(z+N>Y.length)return!1;const re=Y.slice(0);re.splice(z,N,...B.map(_=>({uri:_.uri,name:_.name||(0,I.$8g)(_.uri),index:void 0})));for(let _=0;_<re.length;_++){const Z=re[_];if(re.some(($e,oe)=>oe!==_&&g(Z.uri,$e.uri,this.s)))return!1}re.forEach((_,Z)=>_.index=Z);const{added:H,removed:K}=m(Y,re,k,this.s);if(H.length===0&&K.length===0)return!1;if(this.o){const _=j.displayName||j.name;this.o.$updateWorkspaceFolders(_,z,N,B).then(void 0,Z=>{this.n=void 0;const $e={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(f.Severity.Error,(0,S.localize)(0,null,_,Z.toString()),$e,[])})}return this.y(re),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let N,F="";if(typeof j=="string"?(N=p.URI.file(j),F=j):typeof j<"u"&&(N=j,F=j.fsPath),!N)return F;const B=this.getWorkspaceFolder(N,!0);if(!B)return F;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let Y=(0,I.$bh)(B.uri,N);return z&&B.name&&(Y=`${B.name}/${Y}`),Y}y(j){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:N,removed:F}=D.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:F}))}findFiles(j,z,N,F,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let Y="",re=!0;return z===null?re=!1:z!==void 0&&(typeof z=="string"?Y=z:Y=z.pattern),this.z(j,void 0,{exclude:Y,maxResults:N,useDefaultExcludes:re,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(j,z={},N,F=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,j,z,F)}async z(j,z,N,F=L.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const B=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,Y={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:B,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let re;if(j){const{includePattern:H,folder:K}=R(r.GlobPattern.from(j));re=K,Y.includePattern=H}else{const{includePattern:H,folder:K}=R(r.GlobPattern.from(z));re=K,Y.filePattern=H}return this.o.$startFileSearch(re??null,Y,F).then(H=>Array.isArray(H)?H.map(K=>p.URI.revive(K)):[])}async findTextInFiles(j,z,N,F,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const Y=this.j.getNext(),re=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:H,folder:K}=R(r.GlobPattern.from(z.include)),_=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,Z={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:re,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:H,excludePattern:_},$e=!1;if(this.u[Y]=oe=>{if($e)return;const Pe=p.URI.revive(oe.resource);oe.results.forEach(te=>{const U=(0,h.$8h)(te);(0,s.$xK)(U)?N({uri:Pe,preview:{text:U.preview.text,matches:(0,l.$1b)(U.preview.matches,ee=>new t.$nM(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,l.$1b)(U.ranges,ee=>new t.$nM(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):N({uri:Pe,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const oe=await this.o.$startTextSearch(j,K??null,Z,Y,B);return delete this.u[Y],oe||{}}catch(oe){throw delete this.u[Y],oe}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return p.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return p.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const N=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,N),(0,M.$Sc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const N=await this.resolveWorkspaceFolder(p.URI.revive(j));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const F=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!F),!F)return;const B=await F.provideEditSessionIdentity(N,z);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(j,z,N,F){this.h.info("Getting edit session identifier for workspaceFolder",j);const B=await this.resolveWorkspaceFolder(p.URI.revive(j));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const Y=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!Y),!Y)return;const re=await Y.provideEditSessionIdentityMatch?.(z,N,F);if(this.h.info("Provider returned edit session identifier match result: ",re),!!re)return re}getOnWillCreateEditSessionIdentityEvent(j){return(z,N,F)=>{const B=function(re){z.call(N,re)};return B.extension=j,this.B.event(B,void 0,F)}}async $onWillCreateEditSessionIdentity(j,z,N){const F=await this.resolveWorkspaceFolder(p.URI.revive(j));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},z,async(B,Y)=>{const re=Date.now();await Promise.resolve(B),Date.now()-re>N&&this.h.warn("SLOW edit session create-participant",Y.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const N=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerCanonicalUriProvider(F,N),(0,M.$Sc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(j,z,N){const F=this.C.get(j.scheme);if(!F)return;const B=await F.provideCanonicalUri?.(p.URI.revive(j),z,N);if(B)return B}async $provideCanonicalUri(j,z,N){return this.provideCanonicalUri(p.URI.revive(j),{targetScheme:z},N)}};e.$lmc=C,e.$lmc=C=Je([We(0,c.$NO),We(1,i.$4O),We(2,n.$7lc),We(3,d.$5j),We(4,u.$jmc)],C),e.$mmc=(0,v.$yi)("IExtHostWorkspace");function R(T){let j,z;return T&&(typeof T=="string"?j=T:(j=T.pattern,z=p.URI.revive(T.baseUri))),{includePattern:j,folder:z}}}),define(ke[45],De([1,0,24,4,44,6,8,270,66,18,7,5,20,11,2]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=e.$omc=e.$nmc=void 0;function d(u,s){if(s){const o=s.split(".");let h=u;for(let g=0;h&&g<o.length;g++)h=h[o[g]];return h}}function f(u){return u instanceof v.URI}function a(u){return u&&u.uri instanceof v.URI&&u.languageId&&typeof u.languageId=="string"}function n(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function i(u){return u&&u.uri instanceof v.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function c(u){if(f(u))return{resource:u};if(a(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(n(u))return{overrideIdentifier:u.languageId};if(i(u))return{resource:u.uri};if(u===null)return{resource:null}}let r=class{constructor(s,o,h){this.a=s.getProxy(A.$jM.MainThreadConfiguration),this.c=o,this.b=h,this.d=new I.$xh,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(h=>h.$acceptConfigurationChanged(s,o))}};e.$nmc=r,e.$nmc=r=Je([We(0,p.$NO),We(1,L.$mmc),We(2,S.$5j)],r);class t{constructor(s,o,h,g){this.a=new O.$fe,this.b=s,this.f=g,this.c=o,this.e=b.$Do.parse(h,g),this.d=this.k(h.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,o){const h={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Do.parse(s,this.f),this.d=this.k(s.configurationScopes),this.a.fire(this.j(o,h))}getConfiguration(s,o,h){const g=c(o)||{},w=this.g(s?d(this.e.getValue(void 0,g,this.c.workspace),s):this.e.getValue(void 0,g,this.c.workspace));s&&this.h(s,g,h?.identifier);function k(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(y){return typeof d(w,y)<"u"},get:(y,D)=>{this.h(s?`${s}.${y}`:y,g,h?.identifier);let C=d(w,y);if(typeof C>"u")C=D;else{let R;const T=(j,z)=>{if((0,E.$ag)(j)){let N;const F=()=>{R=R||(0,l.$5n)(w),N=N||d(R,z)};return new Proxy(j,{get:(B,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return F(),()=>N;if(R)return N=N||d(R,z),N[Y];const re=B[Y];return typeof Y=="string"?T(re,`${z}.${Y}`):re},set:(B,Y,re)=>(F(),N&&(N[Y]=re),!0),deleteProperty:(B,Y)=>(F(),N&&delete N[Y],!0),defineProperty:(B,Y,re)=>(F(),N&&Object.defineProperty(N,Y,re),!0)})}return Array.isArray(j)?(0,l.$5n)(j):j};C=T(C,y)}return C},update:(y,D,C,R)=>{y=s?`${s}.${y}`:y;const T=k(C);return D!==void 0?this.b.$updateConfigurationOption(T,y,D,g,R):this.b.$removeConfigurationOption(T,y,g,R)},inspect:y=>{y=s?`${s}.${y}`:y;const D=this.e.inspect(y,g,this.c.workspace);if(D)return{key:y,defaultValue:(0,l.$5n)(D.policy?.value??D.default?.value),globalValue:(0,l.$5n)(D.user?.value??D.application?.value),workspaceValue:(0,l.$5n)(D.workspace?.value),workspaceFolderValue:(0,l.$5n)(D.workspaceFolder?.value),defaultLanguageValue:(0,l.$5n)(D.default?.override),globalLanguageValue:(0,l.$5n)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,l.$5n)(D.workspace?.override),workspaceFolderLanguageValue:(0,l.$5n)(D.workspaceFolder?.override),languageIds:(0,l.$5n)(D.overrideIdentifiers)}}};return typeof w=="object"&&(0,l.$8n)(m,w,!1),Object.freeze(m)}g(s){const o=h=>(0,E.$ag)(h)?new Proxy(h,{get:(g,w)=>o(g[w]),set:(g,w,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(g,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(g,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):h;return o(s)}h(s,o,h){const g=$.$uo.test(s)?4:this.d.get(s),w=h?`[${h.value}] `:"";if(g===4){typeof o?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){o?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,o){const h=new b.$Fo(s,o,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(g,w)=>h.affectsConfiguration(g,c(w))})}k(s){return s.reduce((o,h)=>(o.set(h[0],h[1]),o),new Map)}}e.$omc=t,e.$pmc=(0,P.$yi)("IExtHostConfiguration")}),define(ke[95],De([1,0,2,7,4,6,8,44,73,45,21,43,20,28,5,15,12,11,91,314,13]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnc=e.$Snc=e.$Rnc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var r;(function(T){function j(N){if(N!=null)return N}T.from=j;function z(N){if(N!=null)return N}T.to=z})(r||(r={}));var t;(function(T){function j(N){if(N!=null)return N}T.from=j;function z(N){if(N!=null)return N}T.to=z})(t||(t={}));var u;(function(T){function j(N){if(N!=null)return N}T.from=j;function z(N){if(N!=null)return N}T.to=z})(u||(u={}));var s;(function(T){function j(F){if(F){const B=F;return B&&!!B.process}else return!1}T.is=j;function z(F){if(F==null)return;const B={process:F.process,args:F.args};return F.options&&(B.options=u.from(F.options)),B}T.from=z;function N(F){if(F!=null)return new M.$8M(F.process,F.args,F.options)}T.to=N})(s||(s={}));var o;(function(T){function j(N){if(N!=null)return N}T.from=j;function z(N){if(N!=null)return N}T.to=z})(o||(o={}));var h;(function(T){function j(F){if(F){const B=F;return B&&(!!B.commandLine||!!B.command)}else return!1}T.is=j;function z(F){if(F==null)return;const B={};return F.commandLine!==void 0?B.commandLine=F.commandLine:(B.command=F.command,B.args=F.args),F.options&&(B.options=o.from(F.options)),B}T.from=z;function N(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new M.$9M(F.commandLine,F.options):new M.$9M(F.command,F.args?F.args:[],F.options)}T.to=N})(h||(h={}));var g;(function(T){function j(F){if(F){const B=F;return B&&B.customExecution==="customExecution"}else return!1}T.is=j;function z(F){return{customExecution:"customExecution"}}T.from=z;function N(F,B){return B.get(F)}T.to=N})(g||(e.CustomExecutionDTO=g={}));var w;(function(T){function j(z,N){let F;return z.scope!==void 0&&typeof z.scope!="number"?F=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===M.TaskScope.Workspace&&N&&N.workspaceFile?F=N.workspaceFile:F=i.$jI),{id:z._id,workspaceFolder:F}}T.from=j})(w||(e.TaskHandleDTO=w={}));var k;(function(T){function j(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}T.from=j})(k||(k={}));var m;(function(T){function j(F,B){if(F==null)return[];const Y=[];for(const re of F){const H=z(re,B);H&&Y.push(H)}return Y}T.fromMany=j;function z(F,B){if(F==null)return;let Y;F.execution instanceof M.$8M?Y=s.from(F.execution):F.execution instanceof M.$9M?Y=h.from(F.execution):F.execution&&F.execution instanceof M.$0M&&(Y=g.from(F.execution));const re=r.from(F.definition);let H;return F.scope?typeof F.scope=="number"?H=F.scope:H=F.scope.uri:H=M.TaskScope.Workspace,!re||!H?void 0:{_id:F._id,definition:re,name:F.name,source:{extensionId:B.identifier.value,label:F.source,scope:H},execution:Y,isBackground:F.isBackground,group:k.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}T.from=z;async function N(F,B,Y){if(F==null)return;let re;s.is(F.execution)?re=s.to(F.execution):h.is(F.execution)?re=h.to(F.execution):g.is(F.execution)&&(re=g.to(F._id,Y));const H=r.to(F.definition);let K;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?K=F.source.scope:K=await B.resolveWorkspaceFolder(l.URI.revive(F.source.scope)):K=M.TaskScope.Workspace),!H||!K)return;const _=new M.$$M(H,K,F.name,F.source.label,re,F.problemMatchers);return F.isBackground!==void 0&&(_.isBackground=F.isBackground),F.group!==void 0&&(_.group=M.$7M.from(F.group._id),_.group&&F.group.isDefault&&(_.group=new M.$7M(_.group.id,_.group.label),F.group.isDefault===!0&&(_.group.isDefault=F.group.isDefault))),F.presentationOptions&&(_.presentationOptions=t.to(F.presentationOptions)),F._id&&(_._id=F._id),F.detail&&(_.detail=F.detail),_}T.to=N})(m||(e.TaskDTO=m={}));var y;(function(T){function j(N){return N}T.from=j;function z(N){if(N)return Object.assign(Object.create(null),N)}T.to=z})(y||(y={}));class D{#e;constructor(j,z,N){this._id=z,this.a=N,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let C=class{constructor(j,z,N,F,B,Y,re,H){this.q=new L.$fe,this.r=new L.$fe,this.s=new L.$fe,this.u=new L.$fe,this.a=j.getProxy(A.$jM.MainThreadTask),this.b=N,this.c=F,this.d=B,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=re,this.g=H,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,z,N){if(!N)return new M.$lM(()=>{});const F=this.x();return this.j.set(F,{type:z,provider:N,extension:j}),this.a.$registerTaskProvider(F,z),new M.$lM(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(j,z){this.a.$registerTaskSystem(j,z)}fetchTasks(j){return this.a.$fetchTasks(y.from(j)).then(async z=>{const N=[];for(const F of z){const B=await m.to(F,this.b,this.m);B&&N.push(B)}return N})}get taskExecutions(){const j=[];return this.k.forEach(z=>j.push(z)),j}terminateTask(j){if(!(j instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,z,N){const F=this.m.get(j.id);F&&(this.o.set(j.id,F),this.e.attachPtyToTerminal(z,await F.callback(N))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const z=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const z=await this.z(j.id);this.s.fire({execution:z,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const z=await this.z(j.id);this.u.fire({execution:z,exitCode:j.exitCode})}$provideTasks(j,z){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));const F=[],B=(0,O.$qh)(()=>N.provider.provideTasks(I.CancellationToken.None)).then(Y=>this.v(z,F,N,Y));return new Promise(Y=>{B.then(re=>{Promise.all(F).then(()=>{Y(re)})})})}async $resolveTask(j,z){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));if(z.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${N.type}].`);const F=await m.to(z,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const B=await N.provider.resolveTask(F,I.CancellationToken.None);if(!B)return;this.A(B,N);const Y=m.from(B,N.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(Y.execution)&&await this.y(Y,B,!0),await this.w(Y)}x(){return this.h++}async y(j,z,N){const F=await this.a.$createTaskId(j);!N&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,z.execution)),this.m.set(F,z.execution)}async z(j,z){if(typeof j=="string"){const B=this.l.get(j);if(!B)throw new c.$bb("Unexpected: The specified task is missing an execution");return B}const N=this.l.get(j.id);if(N)return N;let F;return z?F=Promise.resolve(new D(this,j.id,z)):F=m.to(j.task,this.b,this.m).then(B=>{if(!B)throw new c.$bb("Unexpected: Task does not exist.");return new D(this,j.id,B)}),this.l.set(j.id,F),F.then(B=>(this.k.set(j.id,B),B))}A(j,z){j._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const N=this.n.values();let F=N.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=N.next()}};e.$Rnc=C,e.$Rnc=C=Je([We(0,p.$NO),We(1,S.$4O),We(2,b.$mmc),We(3,$.$YO),We(4,E.$pmc),We(5,P.$Nmc),We(6,a.$5j),We(7,n.$3lc)],C);let R=class extends C{constructor(j,z,N,F,B,Y,re,H){super(j,z,N,F,B,Y,re,H),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(j,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const N=m.from(z,j);if(N===void 0)throw new Error("Task is not valid");if(g.is(N.execution))await this.y(N,z,!1);else throw new c.$_;const F=await this.z(await this.a.$getTaskExecution(N),z);return this.a.$executeTask(N).catch(B=>{throw new Error(B)}),F}v(j,z,N,F){const B=[];if(F)for(const Y of F){if(this.A(Y,N),!Y.definition||!j[Y.definition.type]){const H=Y.source?Y.source:"No task source";this.f.warn(`The task [${H}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const re=m.from(Y,N.extension);re&&g.is(re.execution)?(B.push(re),z.push(this.y(re,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:N.extension}}async w(j){if(g.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,z,N){}};e.$Snc=R,e.$Snc=R=Je([We(0,p.$NO),We(1,S.$4O),We(2,b.$mmc),We(3,$.$YO),We(4,E.$pmc),We(5,P.$Nmc),We(6,a.$5j),We(7,n.$3lc)],R),e.$Tnc=(0,v.$yi)("IExtHostTask")}),define(ke[374],De([1,0,37,29]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=void 0,e.$XK=L,e.$ZK=A;function L(M){return"cellResults"in M}e.$YK="rawCell#";function A(M,b){let $=-1;const E=[];let I=[];return M.forEach(p=>{p.range.startLineNumber!==$&&I.length>0&&(E.push([...I]),I=[]),I.push(p),$=p.range.endLineNumber}),I.length>0&&E.push([...I]),E.map(p=>{const S=[],v=p[0].range.startLineNumber,d=p[p.length-1].range.endLineNumber;for(let f=v;f<=d;f++)S.push(b.getLineContent(f));return new l.$BK(S.join(`
`)+`
`,p.map(f=>new O.$yt(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}}),define(ke[375],De([1,0,229,22,4,3,27,14,18,2,33,112,6,34,17,8,48,346,154,24,15,304,374,371]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c,r,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;class s{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,g,w,k,m,y){this.q=w,this.r=k,this.s=m,this.t=y,this.f=new Map,this.g=new M.$Ac,this.h=new Map,this.j=new L.$fe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$fe,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$fe,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$fe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$1lc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy(p.$jM.MainThreadNotebook),this.c=h.getProxy(p.$jM.MainThreadNotebookDocuments),this.d=h.getProxy(p.$jM.MainThreadNotebookEditors),this.i=g.converter,g.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const C=D.notebookEditor?.notebookUri,R=D.cell.handle,j=this.g.get(C)?.getCell(R);if(j)return j.apiCell}if(D&&D.$mid===14){const C=D.uri,R=this.g.get(C);if(R)return R.apiNotebook}return D}}),s.B(g)}getEditorById(h){const g=this.h.get(h);if(!g)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return g}getIdByEditor(h){for(const[g,w]of this.h)if(w.apiEditor===h)return g}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,g){const w=this.g.get(h);if(!w&&!g)throw new Error(`NO notebook document for '${h}'`);return w}static u(h,g){if(!g)return;const w=g.filenamePattern.map(k=>v.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(g.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:g.displayName,filenamePattern:w,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,g,w){const k=s.a++,m=typeof w.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(k,w),this.b.$registerNotebookCellStatusBarItemProvider(k,m,g);let y;return m!==void 0&&(y=w.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(m))),new d.$lM(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,m),y?.dispose()})}async createNotebookDocument(h){const g=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&v.NotebookData.from(h.content)});return E.URI.revive(g)}async openNotebookDocument(h){const g=this.g.get(h);if(g)return g.apiNotebook;const w=await this.c.$tryOpenNotebook(h),k=this.g.get(E.URI.revive(w));return(0,$.$jg)(k?.apiNotebook)}async showNotebookDocument(h,g){E.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let w;typeof g=="object"?w={position:v.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(v.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:w={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,w),m=k&&this.h.get(k)?.apiEditor;if(m)return m;throw k?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,g,w,k){const m=this.f.get(h),y=E.URI.revive(g),D=this.g.get(y);if(!D||!m)return;const C=D.getCellFromIndex(w);if(!C)return;const R=await m.provideCellStatusBarItems(C.apiCell,k);if(!R)return;const T=new A.$Tc,j=this.p.add([T]),N=(Array.isArray(R)?R:[R]).map(F=>v.NotebookStatusBarItem.from(F,this.i,T));return{cacheId:j,items:N}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,g,w,k,m){if((0,b.$9e)(g))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:g,serializer:w,options:k}),this.b.$registerNotebookSerializer(y,{id:h.identifier,location:h.extensionLocation},g,v.NotebookDocumentContentOptions.from(k),s.u(h,m)),(0,A.$Sc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(h,g,w){const k=this.x.get(h);if(!k)throw new Error("NO serializer found");const m=await k.serializer.deserializeNotebook(g.buffer,w);return new f.$Fw(v.NotebookData.from(m))}async $notebookToData(h,g,w){const k=this.x.get(h);if(!k)throw new Error("NO serializer found");const m=await k.serializer.serializeNotebook(v.NotebookData.to(g.value),w);return O.$He.wrap(m)}async $saveNotebook(h,g,w,k,m){const y=E.URI.revive(g),D=this.x.get(h);if(!D)throw new Error("NO serializer found");const C=this.g.get(y);if(!C)throw new Error("Document NOT found");if(C.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new I.$nl((0,l.localize)(0,null,this.z(y)),6);const R={metadata:(0,i.$ao)(C.apiNotebook.metadata,F=>!(D.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of C.apiNotebook.getCells()){const B=new d.$ON(F.kind,F.document.getText(),F.document.languageId,F.mime,D.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);B.metadata=(0,i.$ao)(F.metadata,Y=>!(D.options?.transientCellMetadata??{})[Y]),R.cells.push(B)}await this.y(y,k);const T=await D.serializer.serializeNotebook(R,m);await this.s.value.writeFile(y,T);const j=this.s.getFileSystemProviderExtUri(y.scheme),z=await this.s.value.stat(y);return{name:j.basename(y),isFile:(z.type&I.FileType.File)!==0,isDirectory:(z.type&I.FileType.Directory)!==0,isSymbolicLink:(z.type&I.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&I.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((z.permissions??0)&I.FilePermission.Locked),etag:I.$yl({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(h,g,w,k,m){const y=this.x.get(h)?.serializer;if(!y)return{limitHit:!1,results:[]};const D=new M.$Bc;await(async(z,N,F)=>{await Promise.all(z.map(async B=>await Promise.all(B.filenamePatterns.map(Y=>{const re={_reason:F._reason,folderQueries:F.folderQueries,includePattern:F.includePattern,excludePattern:F.excludePattern,maxResults:F.maxResults,type:1,filePattern:Y};return this.t.doInternalFileSearchWithCustomCallback(re,N,H=>{H.forEach(K=>{D.has(K)||k.some(Z=>B.isFromSettings&&!Z.isFromSettings?!1:Z.filenamePatterns.some($e=>(0,u.$Wgb)($e,K)))||D.add(K)})}).catch(H=>{if(H.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw H})}))))})(w,m,g);const R=new M.$Ac;let T=!1;const j=Array.from(D).map(async z=>{const N=[];try{if(m.isCancellationRequested)return;if(g.maxResults&&[...R.values()].reduce((re,H)=>re+H.cellResults.length,0)>g.maxResults){T=!0;return}const F=[],B=this.g.get(z);if(B)B.apiNotebook.getCells().forEach(H=>F.push({input:H.document.getText(),outputs:H.outputs.flatMap(K=>K.items.map(_=>_.data.toString()))}));else{const re=await this.s.value.readFile(z),H=O.$He.fromString(re.toString()),K=await y.deserializeNotebook(H.buffer,m);if(m.isCancellationRequested)return;v.NotebookData.from(K).cells.forEach(Z=>F.push({input:Z.source,outputs:Z.outputs.flatMap($e=>$e.items.map(oe=>oe.valueBytes.toString()))}))}if(m.isCancellationRequested)return;F.forEach((re,H)=>{const K=g.contentPattern.pattern,_=new r.$EXb(re.input,void 0,re.outputs),Z=_.findInInputs(K),$e=_.findInOutputs(K),oe=$e.flatMap(Pe=>(0,t.$ZK)(Pe.matches,Pe.textBuffer)).map((Pe,te)=>(Pe.webviewIndex=te,Pe));if(Z.length>0||$e.length>0){const Pe={index:H,contentResults:(0,t.$ZK)(Z,_.inputTextBuffer),webviewResults:oe};N.push(Pe)}});const Y={resource:z,cellResults:N};R.set(z,Y);return}catch{return}});return await Promise.all(j),{limitHit:T,results:[...R.values()]}}async y(h,g){const w=await this.s.value.stat(h);if(typeof g?.mtime=="number"&&typeof g.etag=="string"&&g.etag!==I.$xl&&typeof w.mtime=="number"&&typeof w.size=="number"&&g.mtime<w.mtime&&g.etag!==I.$yl({mtime:g.mtime,size:w.size}))throw new I.$nl((0,l.localize)(1,null),3,g)}z(h){return h.scheme===c.Schemas.file?h.fsPath:h.toString()}A(h,g,w){if(this.h.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const k=new n.$lnc(g,this.d,h,w.visibleRanges.map(v.NotebookRange.to),w.selections.map(v.NotebookRange.to),typeof w.viewColumn=="number"?v.ViewColumn.to(w.viewColumn):void 0);this.h.set(g,k)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const w of h.value.removedDocuments){const k=E.URI.revive(w),m=this.g.get(k);m&&(m.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(m.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===k.toString()&&this.h.delete(y.id)}if(h.value.addedDocuments){const w=[];for(const k of h.value.addedDocuments){const m=E.URI.revive(k.uri);if(this.g.has(m))throw new Error(`adding EXISTING notebook ${m} `);const y=new a.$knc(this.c,this.q,this.r,m,k);w.push(...k.cells.map(D=>a.$jnc.asModelAddData(D))),this.g.get(m)?.dispose(),this.g.set(m,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(y.apiNotebook)}}if(h.value.addedEditors)for(const w of h.value.addedEditors){if(this.h.has(w.id))return;const k=E.URI.revive(w.documentUri),m=this.g.get(k);m&&this.A(m,w.id,w)}const g=[];if(h.value.removedEditors)for(const w of h.value.removedEditors){const k=this.h.get(w);k&&(this.h.delete(w),this.k?.id===k.id&&(this.k=void 0),g.push(k))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const w=new Set;this.l.forEach(k=>w.add(k.id));for(const k of this.h.values()){const m=w.has(k.id);k._acceptVisibility(m)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const g=S.$_O.String.with("notebookType","A notebook type"),w=new S.$bP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new S.$_O("data","Bytes to convert to data",m=>m instanceof Uint8Array,m=>O.$He.wrap(m))],new S.$aP("Notebook Data",m=>v.NotebookData.to(m.value))),k=new S.$bP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new S.$_O("NotebookData","Notebook data to convert to bytes",m=>!0,m=>new f.$Fw(v.NotebookData.from(m)))],new S.$aP("Bytes",m=>m.buffer));h.registerApiCommand(w),h.registerApiCommand(k)}}e.$unc=s}),define(ke[376],De([1,0,16,21,47,35,23,40,37]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;class E{constructor(p,S,v){this.k=p,this.l=S,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&A.$sk(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&A.$sk(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const S=this.k.folderQueries||[];return new Promise((v,d)=>{const f=a=>{this.f++,p(a)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const n=a.toString(),i=l.$nc(n);this.j&&this.j(n,i)||this.v(f,{base:a,basename:i})}),Promise.all(S.map(a=>this.p(a,f))).then(a=>{v({limitHit:this.e,stats:a[0]||void 0})},a=>{d(new Error((0,L.$jj)(a)))})})}async p(p,S){const v=new O.$qe,d=this.q(p),f=this.r(),a=new $.$PK(this.k,p),n=!a.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=b.$be.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,v.token),r=i.elapsed(),t=b.$be.create();return this.g&&!this.e||(c&&c.forEach(u=>{const s=l.$gc.relative(p.folder.path,u.path);if(n){const o=l.$nc(u.path);this.v(S,{base:p.folder,relativePath:s,basename:o});return}this.s(f,p.folder,s,S)}),this.g&&!this.e)?null:(this.u(f,a,S),{providerTime:r,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(p){const S=(0,$.$OK)(this.k.includePattern,p.includePattern),v=(0,$.$OK)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:v,includes:S,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},S,v,d){if(v===this.a){const a=l.$nc(this.a);this.v(d,{base:S,relativePath:this.a,basename:a})}function f(a){const n=l.$nc(a),i=l.$mc(a);let c=p[i];c||(c=p[i]=[],f(i)),c.push({base:S,relativePath:a,basename:n})}f(v)}u({rootEntries:p,pathToEntries:S},v,d){const f=this,a=this.a;function n(i){const c=(0,$.$RK)(()=>i.map(r=>r.basename));for(let r=0,t=i.length;r<t;r++){const u=i[r],{relativePath:s,basename:o}=u;if(v.matchesExcludesSync(s,o,a!==o?c:void 0))continue;const h=S[s];if(h)n(h);else{if(s===a)continue;f.v(d,u)}if(f.e)break}}n(p)}v(p,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(S))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,S,v,d){const f=this.c(p.cacheKey),a=new E(p,S,f&&f.token);let n=0;const i=c=>{n+=c.length,v(c.map(r=>this.d(r)))};return this.e(a,I.a,i,d).then(c=>({limitHit:c.limitHit,stats:c.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}:void 0,messages:[]}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new O.$qe),this.b.get(p)}d(p){return p.relativePath?{resource:M.$_g(p.base,p.relativePath)}:{resource:p.base}}e(p,S,v,d){const f=d.onCancellationRequested(()=>{p.cancel()}),a=i=>{i&&(n.push(i),S>0&&n.length>=S&&(v(n),n=[]))};let n=[];return p.search(a).then(i=>(n.length&&v(n),f.dispose(),i),i=>(n.length&&v(n),f.dispose(),Promise.reject(i)))}}e.$mnc=I}),define(ke[377],De([1,0,19,74,35,103,27,15,16,23,14,18,2,100,250,55,11,42,147,372,37]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZL=void 0,e.$1L=k;let r=class{constructor(y,D,C,R,T){this.a=y,this.b=D,this.c=C,this.d=R,this.e=T}text(y,D,C={}){y=this.f(y,C);const R=this.a.getValue(),T=D&&D.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(D?.map(a.$Ti),C),type:2,contentPattern:y,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:R.search.usePCRE2||T||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(y,D){const C=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const R={...y,wordSeparators:C.editor.wordSeparators};return this.j(y,D)&&(R.isCaseSensitive=!0),this.k(y)&&(R.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(R.notebookInfo||(R.notebookInfo={}),R.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(R.notebookInfo||(R.notebookInfo={}),R.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(R.notebookInfo||(R.notebookInfo={}),R.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(R.notebookInfo||(R.notebookInfo={}),R.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),R}file(y,D={}){return{...this.h(y,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey,shouldGlobMatchFilePattern:D.shouldGlobSearch}}g(y,D){return y?(y=Array.isArray(y)?y.map(h):h(y),D?this.parseSearchPaths(y):{pattern:u(...Array.isArray(y)?y:[y])}):{}}h(y=[],D={}){const C=this.g(D.includePattern,D.expandPatterns),R=this.g(D.excludePattern,D.expandPatterns),T=y.length>1,j=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(F=>this.q(F,D,R)):y.map(F=>this.r(F,D,R,T))).filter(F=>!!F),z={_reason:D._reason,folderQueries:j,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:R.pattern,includePattern:C.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const F=l.$Hb(this.c.groups.flatMap(re=>re.editors.map(H=>H.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(re=>(0,c.$FK)(z,re.fsPath)),Y=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...z,...Y}}const N=D.extraFileResources&&D.extraFileResources.filter(F=>(0,c.$FK)(z,F.fsPath));return z.extraFileResources=N&&N.length?N:void 0,z}i(y){const D=[],C=new M.$Ac,R={};let T=!1;return y.forEach(j=>{if(j.scheme===b.Schemas.walkThrough)return;if((0,E.$dh)(j)){const N=this.b.getWorkspaceFolder(j)?.uri??j.with({path:$.$mc(j.fsPath)});let F=C.get(N);F||(T=!0,F={folder:N,includePattern:{}},D.push(F),C.set(N,F));const B=$.$lc(N.fsPath,j.fsPath);(0,P.$jg)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else j.fsPath&&(T=!0,R[j.fsPath]=!0)}),{folderQueries:D,includePattern:R,usingSearchPaths:!0,excludePattern:T?void 0:{"**/*":!0}}}j(y,D){if(D.isSmartCase){if(y.isRegExp){if(I.$2f(y.pattern,!0))return!0}else if(I.$2f(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,S.$UC)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const D=Y=>$.$ic(Y)||/^\.\.?([\/\\]|$)/.test(Y),R=(Array.isArray(y)?y:s(y)).map(Y=>{const re=this.e.resolvedUserHome;return re?(0,A.$Kw)(Y,re.scheme===b.Schemas.file?re.fsPath:re.path):Y}),T=O.$K(R,Y=>D(Y)?"searchPaths":"exprSegments"),j=(T.exprSegments||[]).map(Y=>I.$hf(Y,"/")).map(Y=>I.$hf(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),o(Y))),z={},N=this.m(T.searchPaths||[]);N&&N.length&&(z.searchPaths=N);const F=j.flat(),B=u(...F);return B&&(z.pattern=B),z}l(y,D){return D.disregardExcludeSettings?void 0:(0,c.$EK)(y,!D.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const D=y.flatMap(R=>{let{pathPortion:T,globPortion:j}=t(R);return j&&(j=g(j)),this.n(T).flatMap(N=>this.o(N,j))}),C=new Map;return D.forEach(R=>{const T=R.searchPath.toString(),j=C.get(T);j?R.pattern&&(j.pattern=j.pattern||{},j.pattern[R.pattern]=!0):C.set(T,{searchPath:R.searchPath,pattern:R.pattern?u(R.pattern):void 0})}),Array.from(C.values())}n(y){if($.$ic(y)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==b.Schemas.file?[{searchPath:D[0].uri.with({path:y})}]:[{searchPath:p.URI.file($.$hc(y))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(y=h(y),y.startsWith("../")||y===".."){const R=$.$gc.resolve(D.path,y);return[{searchPath:D.with({path:R})}]}const C=g(y);return[{searchPath:D,pattern:C}]}else{if(y==="./"||y===".\\")return[];{const D=y.replace(/^\.[\/\\]/,""),R=this.b.getWorkspace().folders.map(T=>{const j=D.match(new RegExp(`^${I.$bf(T.name)}(?:/(.*)|$)`));return j?{match:j,folder:T}:null}).filter(P.$gg);if(R.length)return R.map(T=>{const j=T.match[1];return{searchPath:T.folder.uri,pattern:j&&g(j)}});{const T=y.match(/\.[\/\\](.+)[\/\\]?/),j=T?T[1]:y,z=v.localize(0,null,j);throw new Error(z)}}}}o(y,D){const C=y.pattern&&D?`${y.pattern}/${D}`:y.pattern||D,R=[{searchPath:y.searchPath,pattern:C}];return C&&!C.endsWith("**")&&R.push({searchPath:y.searchPath,pattern:C+"/**"}),R}q(y,D,C){const R=this.r((0,a.$Ti)(y.searchPath),D,C,!1);return R?{...R,includePattern:y.pattern}:null}r(y,D,C,R){let T;const j=p.URI.isUri(y)?y:y.uri;if(C.searchPaths){const Y=C.searchPaths.filter(re=>(0,E.$5g)(re.searchPath,j))[0];if(Y&&!Y.pattern)return null;Y&&(T=Y.pattern)}const z=this.a.getValue({resource:j}),F={...this.l(z,D)||{},...T||{}},B=p.URI.isUri(y)?(0,E.$9g)(y):y.name;return{folder:j,folderName:R?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!z.search.followSymlinks}}};e.$ZL=r,e.$ZL=r=Je([We(0,d.$5i),We(1,a.$Hi),We(2,n.$3D),We(3,f.$5j),We(4,i.$XL)],r);function t(m){const y=m.match(/[\*\{\}\(\)\[\]\?]/);if(y){const D=y.index,C=m.substr(0,D).match(/[/|\\][^/\\]*$/);if(C){let R=m.substr(0,C.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:m.substr((C.index||0)+1)}}}return{pathPortion:m}}function u(...m){return m.length?m.reduce((y,D)=>(y[D]=!0,y),Object.create(null)):void 0}function s(m){return L.$qk(m,",").map(y=>y.trim()).filter(y=>!!y.length)}function o(m){return[`**/${m}/**`,`**/${m}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function h(m){return m.replace(/\\/g,"/")}function g(m){return h(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(m){return m.replace(/([?*[\]])/g,"[$1]")}function k(m,y){m=l.$Mb(m,R=>R.toString());const D=[],C=y.getWorkspace();return m&&m.forEach(R=>{let T;if(y.getWorkbenchState()===2)T=(0,E.$bh)(C.folders[0].uri,R),T&&T!=="."&&(T="./"+T);else{const j=y.getWorkspaceFolder(R);if(j){const z=j.name;if(C.folders.filter(F=>F.name===z).length===1){const F=(0,E.$bh)(j.uri,R);F===""?T=`./${j.name}`:T=`./${j.name}/${F}`}else T=R.fsPath}}T&&D.push(w(T))}),D}}),define(ke[378],De([1,0,23,2,21,13,5,377,37,42,7]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rwb=p,e.$Swb=d;const P=7e3;function p(f,a){const n=a.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],c=[];for(const h of n)if(/^workspaceContains:/.test(h)){const g=h.substr(18);g.indexOf("*")>=0||g.indexOf("?")>=0||f.forceUsingSearch?c.push(g):i.push(g)}if(i.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:r,resolve:t}=(0,I.$rh)(),u=h=>t({activationEvent:h}),s=Promise.all(i.map(h=>S(f,h,u))).then(()=>{}),o=v(f,a.identifier,c,u);return Promise.all([s,o]).then(()=>{t(void 0)}),r}async function S(f,a,n){for(const i of f.folders)if(await f.exists(l.$_g(O.URI.revive(i),a))){n(`workspaceContains:${a}`);return}}async function v(f,a,n,i){if(n.length===0)return Promise.resolve(void 0);const c=new L.$qe,r=f.checkExists(f.folders,n,c.token),t=setTimeout(async()=>{c.cancel(),f.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},P);let u=!1;try{u=await r}catch(s){A.$4(s)||A.$1(s)}c.dispose(),clearTimeout(t),u&&i(`workspaceContains:${n.join(",")}`)}function d(f,a,n,i){const c=f.get(M.$xi),r=f.get($.$wK),u=c.createInstance(b.$ZL).file(a.map(s=>(0,E.$Ti)(O.URI.revive(s))),{_reason:"checkExists",includePattern:n,exists:!0});return r.fileSearch(u,i).then(s=>!!s.limitHit,s=>A.$4(s)?!1:Promise.reject(s))}}),define(ke[49],De([1,0,225,16,59,23,7,3,78,2,11,6,45,310,119,44,26,149,13,25,22,287,8,67,5,28,93,20,107,71,43,122,4,378,118,289,15,116,40,12,117]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c,r,t,u,s,o,h,g,w,k,m,y,D,C,R,T,j,z,N,F,B){"use strict";var Y;Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=e.$4mc=e.$3mc=e.$2mc=e.$1mc=void 0,e.$1mc=(0,s.$yi)("IHostUtils");let re=Y=class extends b.$Uc{constructor(U,ee,be,ue,ce,ae,le,J,se,pe,ve,Re,me){super(),this.Y=Re,this.Z=me,this.a=this.B(new D.$fe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ee,this.g=be,this.f=le,this.j=ue,this.m=ce,this.s=ae,this.t=se,this.u=pe,this.w=ve,this.y=this.g.getProxy(P.$jM.MainThreadWorkspace),this.z=this.g.getProxy(P.$jM.MainThreadTelemetry),this.C=this.g.getProxy(P.$jM.MainThreadExtensionService),this.D=new M.$xh,this.F=new M.$xh,this.G=new M.$xh,this.H=new M.$xh,this.I=new Pe(this.f.extensions.activationEvents),this.L=new a.$xac(this.I,this.f.extensions.allExtensions);const Ie=new i.$Um(this.f.extensions.myExtensions);this.J=new a.$xac(this.I,$e(this.L,Ie)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${_(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${_(this.J)}`)),this.M=new v.$Jmc(this.g,this.s),this.N=new R.$Tmc(this.g),this.O=J,this.h=U.createChild(new w.$wi([v.$Kmc,this.M],[R.$Umc,this.N])),this.P=this.B(new S.$Imc(this.J,this.L,{onExtensionActivationError:(Ae,ze,q)=>{this.C.$onExtensionActivationError(Ae,n.$3(ze),q)},actualActivateExtension:async(Ae,ze)=>{if(a.$xac.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,ze),new S.$Hmc;const q=this.J.getExtensionDescription(Ae);return this.fb(q,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(ce=>ce.identifier).filter(ce=>this.isActivated(ce)).map(ce=>this.eb(ce))}catch{}await Promise.all(U)}terminate(U,ee=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(ue=>{this.s.error(ue)}),this.g.dispose();const be=this.$();Promise.race([(0,M.$zh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ee}`):this.s.info(`Extension host exiting with code ${ee}`),this.s.flush(),this.s.dispose(),this.c.exit(ee)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ee=await this.C.$getExtension(U);return ee&&{...ee,identifier:new i.$Tm(ee.identifier.value),extensionLocation:E.URI.revive(ee.extensionLocation)}}ab(U,ee){return this.P.activateByEvent(U,ee)}bb(U,ee){return this.P.activateById(U,ee)}activateByIdWithErrors(U,ee){return this.bb(U,ee).then(()=>{const be=this.P.getActivatedExtension(U);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===j.Schemas.file&&this.c.fsRealpath){const ee=U.fsPath;this.R.has(ee)||this.R.set(ee,this.c.fsRealpath(ee));const be=await this.R.get(ee);return E.URI.file(be)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new oe(U))),this.Q}async db(U){const ee=$.$Ei.forUris(be=>A.$3g.ignorePathCasing(be));return await Promise.all(U.map(async be=>{if(this.wb(be)){const ue=await this.cb(be.extensionLocation);ee.set(ue,be)}})),ee}eb(U){let ee=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ee;const be=this.P.getActivatedExtension(U);if(!be)return ee;try{typeof be.module.deactivate=="function"&&(ee=Promise.resolve(be.module.deactivate()).then(void 0,ue=>(this.s.error(ue),Promise.resolve(void 0))))}catch(ue){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(ue)}try{(0,b.$Pc)(be.subscriptions)}catch(ue){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(ue)}return ee}async fb(U,ee){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,ee).then(be=>{const ue=be.activationTimes;return this.C.$onDidActivateExtension(U.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,ee),this.gb(U,ee,"success",ue),be},be=>{throw this.gb(U,ee,"failure"),be})}gb(U,ee,be,ue){const ce=K(U,ee);this.z.$publicLog2("extensionActivationTimes",{...ce,...ue||{},outcome:be})}hb(U,ee){const be=K(U,ee);this.z.$publicLog2("activatePlugin",be);const ue=this.wb(U);if(!ue)return Promise.resolve(new S.$Gmc(S.$Dmc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ee.startup}, activationEvent: '${ee.activationEvent}'${U.identifier.value!==ee.extensionId.value?`, root cause: ${ee.extensionId.value}`:""}`),this.s.flush();const ce=new S.$Emc(ee.startup);return Promise.all([this.xb(U,(0,A.$_g)(U.extensionLocation,ue),ce),this.ib(U)]).then(ae=>(L.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),Y.jb(this.s,U.identifier,ae[0],ae[1],ce))).then(ae=>(L.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),ae))}ib(U){const ee=this.Z.createLanguageModelAccessInformation(U),be=new r.$Mmc(U,this.M),ue=new r.$Lmc(U.identifier.value,!1,this.M),ce=new T.$Vmc(U,this.N),ae=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([be.whenReady,ue.whenReady,this.O.whenReady]).then(()=>{const J=this;let se,pe;const ve=(0,f.$KG)(U,"ipc")?this.f.messagePorts?.get(i.$Tm.toKey(U.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:ue,secrets:ce,subscriptions:[],get languageModelAccessInformation(){return ee},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Re){return O.$jc(U.extensionLocation.fsPath,Re)},get storagePath(){return J.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return J.O.globalValue(U).fsPath},get logPath(){return O.$jc(J.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return E.URI.joinPath(J.f.logsLocation,U.identifier.value)},get storageUri(){return J.O.workspaceValue(U)},get globalStorageUri(){return J.O.globalValue(U)},get extensionMode(){return ae},get extension(){return se===void 0&&(se=new Z(J,U.identifier,U,le,!1)),se},get extensionRuntime(){return(0,f.$LG)(U,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!pe){if(!ve)return;const Re=D.Event.buffer(D.Event.fromDOMEventEmitter(ve,"message",me=>me.data));ve.start(),pe={onDidReceiveMessage:Re,postMessage:ve.postMessage.bind(ve)}}return pe}})})}static jb(U,ee,be,ue,ce){return be=be||{activate:void 0,deactivate:void 0},this.kb(U,ee,be,ue,ce).then(ae=>new S.$Fmc(!1,null,ce.build(),be,ae,ue.subscriptions))}static kb(U,ee,be,ue,ce){if(typeof be.activate=="function")try{ce.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const ae=typeof global=="object"?global:self,le=be.activate.apply(ae,[ue]);return ce.activateCallStop(),ce.activateResolveStart(),Promise.resolve(le).then(J=>(ce.activateResolveStop(),J))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(be)}lb(U,ee){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ee}).then(void 0,be=>{this.s.error(be)})}mb(U,ee=0){const ue=Date.now();(0,F.$B)(()=>{for(let ce=ee;ce<U.length;ce+=1){const ae=U[ce];for(const le of ae.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-ue>50){this.mb(U,ce);break}else this.lb(ae,le)}})}nb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(U=>{const ee=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(ee)this.mb(be);else for(const ue of be)if(ue.activationEvents)for(const ce of ue.activationEvents)ce==="onStartupFinished"&&this.lb(ue,ce)})}ob(){const U=this.ab("*",!0).then(void 0,ae=>{this.s.error(ae)});this.B(this.j.onDidChangeWorkspace(ae=>this.pb(ae.added)));const ee=this.j.workspace?this.j.workspace.folders:[],be=this.pb(ee),ue=this.rb(),ce=Promise.all([ue,U,be]).then(()=>{});return Promise.race([ce,(0,M.$zh)(1e4)]).then(()=>{this.nb()}),ce}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ee=>this.qb(U,ee))).then(()=>{})}async qb(U,ee){if(this.isActivated(ee.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,ue={logService:this.s,folders:U.map(ae=>ae.uri),forceUsingSearch:be||!this.c.fsExists,exists:ae=>this.c.fsExists(ae.fsPath),checkExists:(ae,le,J)=>this.y.$checkExists(ae,le,J)},ce=await(0,C.$Rwb)(ue,ee);if(ce)return this.bb(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:ce.activationEvent}).then(void 0,ae=>this.s.error(ae))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ee}=this.f.environment;if(!U||!ee)throw new Error(l.localize(0,null));const be=await this.xb(null,ee,new S.$Emc(!1));if(!be||typeof be.run!="function")throw new Error(l.localize(1,null,ee.toString()));return new Promise((ue,ce)=>{const ae=(se,pe)=>{se?(F.$t&&this.s.error("Test runner called back with error",se),ce(se)):(F.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ue(typeof pe=="number"&&pe>0?1:0))},le=(0,A.$Zg)(ee),J=be.run(le,ae);J&&J.then&&J.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),ue(0)}).catch(se=>{F.$t&&this.s.error("Test runner finished with error",se),ce(se instanceof Error&&se.stack?se.stack:String(se))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$zh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ee){return this.S[U]=ee,(0,b.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:ee}=await this.ub(U);return ee?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const ee=U.indexOf("+");if(ee===-1)throw new t.$rM("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=U.substr(0,ee);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(U,ee){const be=N.$be.create(!1),ue=()=>`[resolveAuthority(${(0,u.$Nl)(U)},${ee})][${be.elapsed()}ms] `,ce=W=>this.s.info(`${ue()}${W}`),ae=W=>this.s.warn(`${ue()}${W}`),le=(W,X=void 0)=>this.s.error(`${ue()}${W}`,X),J=W=>{if(W instanceof t.$rM)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},se=async W=>{ce(`activating resolver for ${W}...`);const{resolver:X,authorityPrefix:Q}=await this.ub(W);if(!X)throw le(`no resolver for ${Q}`),new t.$rM(`No remote extension installed to resolve ${Q}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:X,authorityPrefix:Q,remoteAuthority:W}},pe=U.split(/@|%40/g).reverse();ce(`activating remote resolvers ${pe.join(" -> ")}`);let ve;try{ve=await Promise.all(pe.map(se)).catch(async W=>{if(!(W instanceof t.$rM)||W._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return ae(`resolving nested authorities failed: ${W.message}`),[await se(U)]})}catch(W){return J(W)}const Re=new M.$Jh;Re.cancelAndSet(()=>ce("waiting..."),1e3);let me,Ie;for(const[W,{authorityPrefix:X,resolver:Q,remoteAuthority:de}]of ve.entries())try{if(W===ve.length-1)ce("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${X}`),me=await Q.resolve(de,{resolveAttempt:ee,execServer:Ie}),L.mark(`code/extHost/didResolveAuthorityOK/${X}`),ce("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,t.$qM.isManagedResolvedAuthority(me)?me:void 0));else{if(ce(`invoking resolveExecServer() for ${de}`),L.mark(`code/extHost/willResolveExecServer/${X}`),Ie=await Q.resolveExecServer?.(de,{resolveAttempt:ee,execServer:Ie}),!Ie)throw new t.$rM(`Exec server was not available for ${de}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${X}`)}}catch(we){return L.mark(`code/extHost/didResolveAuthorityError/${X}`),le("returned an error",we),Re.dispose(),J(we)}Re.dispose();const Ae={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures?{elevation:me.tunnelFeatures.elevation,privacyOptions:me.tunnelFeatures.privacyOptions,protocol:me.tunnelFeatures.protocol===void 0?!0:me.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};ce(`returned ${t.$qM.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let q;if(t.$qM.isManagedResolvedAuthority(me)){const W=ee;this.Y.setFactory(W,me.makeConnection),q={authority:U,connectTo:new u.$Kl(W),connectionToken:me.connectionToken}}else q={authority:U,connectTo:new u.$Ll(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:q,options:ze,tunnelInformation:Ae}}}async $getCanonicalURI(U,ee){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$Nl)(U)})`);const{resolver:be}=await this.ub(U);if(!be)return null;const ue=E.URI.revive(ee);if(typeof be.getCanonicalURI>"u")return ue;const ce=await(0,M.$qh)(()=>be.getCanonicalURI(ue));return ce||ue}async $startExtensionHost(U){U.toAdd.forEach(ae=>ae.extensionLocation=E.URI.revive(ae.extensionLocation));const{globalRegistry:ee,myExtensions:be}=H(this.I,this.L,this.J,U),ue=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(ee.getAllExtensionDescriptions()),this.J.set(be),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${_(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${_(this.J)}`)),this.tb()}$activateByEvent(U,ee){return ee===1?this.D.wait().then(be=>this.ab(U,!1)):this.G.wait().then(be=>this.ab(U,!1))}async $activate(U,ee){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,ee),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(ae=>ae.extensionLocation=E.URI.revive(ae.extensionLocation));const{globalRegistry:ee,myExtensions:be}=H(this.I,this.L,this.J,U),ue=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(ee.getAllExtensionDescriptions()),this.J.set(be),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${_(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${_(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ee=c.$He.alloc(U),be=Math.random()%256;for(let ue=0;ue<U;ue++)ee.writeUInt8(be,ue);return ee}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$2mc=re,e.$2mc=re=Y=Je([We(0,s.$xi),We(1,e.$1mc),We(2,g.$NO),We(3,d.$mmc),We(4,p.$pmc),We(5,I.$5j),We(6,o.$4O),We(7,h.$smc),We(8,k.$UDb),We(9,m.$Nmc),We(10,z.$Xmc),We(11,B.$Ymc),We(12,y.$Rmc)],re);function H(te,U,ee,be){te.addActivationEvents(be.addActivationEvents);const ue=new a.$xac(te,U.getAllExtensionDescriptions());ue.deltaExtensions(be.toAdd,be.toRemove);const ce=new i.$Um(ee.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of be.myToRemove)ce.delete(le);for(const le of be.myToAdd)ce.add(le);const ae=$e(ue,ce);return{globalRegistry:ue,myExtensions:ae}}function K(te,U){return{id:te.identifier.value,name:te.name,extensionVersion:te.version,publisherDisplayName:te.publisher,activationEvents:te.activationEvents?te.activationEvents.join(","):null,isBuiltin:te.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function _(te){return te.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$3mc=(0,s.$yi)("IExtHostExtensionService");class Z{#e;#t;#n;constructor(U,ee,be,ue,ce){this.#e=U,this.#t=ee,this.#n=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=O.$hc((0,A.$Zg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=ue,this.isFromDifferentExtensionHost=ce}get isActive(){return this.#e.isActivated(this.#n)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#n)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#n,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$4mc=Z;function $e(te,U){return te.getAllExtensionDescriptions().filter(ee=>U.has(ee.identifier))}class oe{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$5mc=oe;class Pe{constructor(U){this.a=new i.$Vm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ee of Object.keys(U))this.a.set(ee,U[ee])}}}),define(ke[379],De([1,0,59,2,6,45,26,25,20,28,5,49,11,14]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=void 0;let d=class{constructor(c,r,t,u,s,o,h){this.c=c,this.d=r,this.e=t,this.f=u,this.g=s,this.h=o,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),l.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new a(this.c,r,this.d,c,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,r,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const r of c.nodeModuleName)this.a.set(r,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(r=>c.alternativeModuleName(r))}};e.$boc=d,e.$boc=d=Je([We(2,I.$xi),We(3,A.$pmc),We(4,P.$3mc),We(5,E.$4O),We(6,p.$5j)],d);let f=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&v.a.size){const r=(0,S.$bf)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",u=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${s}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const r=this.b.exec(this.c(c));if(!r)return;const[,t,u,s]=r,o=v.a.get(u);if(o!==void 0)return console.warn(`${u} as been renamed to ${o}, please update your imports`),t+o+s}c(c){return c.replace(/\\/g,"/")}};f=v=Je([We(0,E.$4O)],f);class a{constructor(c,r,t,u,s){this.c=c,this.d=r,this.e=t,this.f=u,this.g=s,this.nodeModuleName="vscode",this.a=new b.$Vm}load(c,r){const t=this.d.findSubstr(r);if(t){let u=this.a.get(t.identifier);return u||(u=this.c(t,this.e,this.f),this.a.set(t.identifier,u)),u}if(!this.b){let u="";this.d.forEach((s,o)=>u+=`	${o} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${u}`),this.b=this.c(M.$FG,this.e,this.f)}return this.b}}let n=class{constructor(c,r,t){this.e=c,this.f=r,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$jM.MainThreadTelemetry);const u=t.getProxy(L.$jM.MainThreadWindow);this.c=(s,o)=>{const h=O.URI.parse(s);return o?this.g(s,o):h.scheme==="http"||h.scheme==="https"?u.$openUri(h,s,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?u.$openUri(h,s,{}):this.g(s,o)}}load(c,r,t){const u=this.e.findSubstr(r);return u&&(this.a=u.identifier.value,this.h()),this.b=t(c),this.c}g(c,r){return this.i(),this.b(c,r)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([We(2,$.$NO)],n)}),define(ke[61],De([1,0,46,3,16,52,5,73,72,49,8,44,307,45]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=e.$6mc=void 0,e.$6mc=(0,M.$yi)("IExtHostVariableResolverProvider");class v extends p.$RP{constructor(a,n,i,c,r,t,u){function s(){if(i){const o=i.activeEditor();if(o)return o.document.uri;const h=c.tabGroups.all.find(g=>g.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof I.$0N||h.input instanceof I.$cO)return h.input.modified;if(h.input instanceof I.$9N||h.input instanceof I.$bO||h.input instanceof I.$_N)return h.input.uri}}}super({getFolderUri:o=>{const h=t.folders.filter(g=>g.name===o);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(o,h)=>r.getConfiguration(void 0,o).get(h),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return L.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const o=s();if(o){const h=n.getWorkspaceFolder(o);if(h)return L.$hc(h.uri.fsPath)}}},getSelectedText:()=>{if(i){const o=i.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(i){const o=i.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>a.getExtension(o)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(A.env))}}let d=class extends O.$Uc{constructor(a,n,i,c,r){super(),this.b=a,this.c=n,this.g=i,this.h=c,this.j=r,this.a=new l.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$7mc=d,e.$7mc=d=Je([We(0,E.$3mc),We(1,P.$mmc),We(2,b.$YO),We(3,S.$pmc),We(4,$.$Bmc)],d)}),define(ke[96],De([1,0,7,4,2,25,5,6,72,49,20,8,44,144,299,45,61,3,50,34,17,19]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=e.$$mc=e.$0mc=e.$9mc=e.$8mc=void 0,e.$8mc=(0,M.$yi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(k,m,y,D,C,R,T){this.N=m,this.O=y,this.P=D,this.Q=C,this.R=R,this.S=T,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$fe,this.o=new O.$fe,this.q=new O.$fe,this.w=new O.$fe,this.l=k.getProxy(b.$jM.MainThreadDebugService),this.A=new O.$fe,this.C=new O.$fe,this.y=new s(this.l),this.z=new Map,this.O.getExtensionRegistry().then(j=>{j.onDidChange(z=>{this.V(j)}),this.V(j)})}async $getVisualizerTreeItem(k,m){const y=this.W(m);if(!y)return;const D=await this.H.get(k)?.getTreeItem?.(y);return D?this.U(k,D):void 0}registerDebugVisualizationTree(k,m,y){const D=A.$Tm.toKey(k.identifier),C=this.jb(D,m);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${m}' is already registered`);return this.H.set(C,y),this.l.$registerDebugVisualizerTree(C,!!y.editItem),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(C),this.H.delete(m)})}async $getVisualizerTreeItemChildren(k,m){const y=this.J.get(m)?.item;return y?(await this.H.get(k)?.getChildren?.(y))?.map(C=>this.U(k,C))||[]:[]}async $editVisualizerTreeItem(k,m){const y=this.J.get(k);if(!y)return;const D=await this.H.get(y.provider)?.editItem?.(y.item,m);return this.U(y.provider,D||y.item)}$disposeVisualizedTree(k){const m=this.J.get(k);if(!m)return;const y=[m.children];for(const D of y)if(D)for(const C of D)y.push(this.J.get(C)?.children),this.J.delete(C)}U(k,m){let y=this.I.get(m);return y||(y=this.F++,this.I.set(m,y),this.J.set(y,{provider:k,item:m})),c.DebugTreeItem.from(m,y)}asDebugSourceUri(k,m){const y=k;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let D=`debug:${encodeURIComponent(y.path||"")}`,C="?";return m&&(D+=`${C}session=${encodeURIComponent(m.id)}`,C="&"),D+=`${C}ref=${y.sourceReference}`,L.URI.parse(D)}else{if(y.path)return L.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(k){const m=[];for(const y of k.getAllExtensionDescriptions())if(y.contributes){const D=y.contributes.debuggers;if(D&&D.length>0)for(const C of D)(0,v.$zH)(C)&&m.push(C.type)}this.l.$registerDebugTypes(m)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const k=[];return this.z.forEach(m=>k.push(m)),k}async $resolveDebugVisualizer(k,m){const y=this.L.get(k);if(!y)throw new Error(`No debug visualizer found with id '${k}'`);let{v:D,provider:C,extensionId:R}=y;if(D.visualization||(D=await C.resolveDebugVisualization?.(D,m)||D,y.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${C}'`);return this.kb(R,D.visualization)}async $executeDebugVisualizerCommand(k){const m=this.L.get(k);if(!m)throw new Error(`No debug visualizer found with id '${k}'`);const y=m.v.visualization;y&&"command"in y&&this.S.executeCommand(y.command,...y.arguments||[])}W(k){const m=this.m.get(k.sessionId);return m&&{session:m.api,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId}}async $provideDebugVisualizers(k,m,y,D){const C=this.W(y),R=this.jb(k,m),T=this.G.get(R);if(!C||!T)return[];const j=await T.provideDebugVisualization(C,D);return j?j.map(z=>{const N=++this.M;this.L.set(N,{v:z,provider:T,extensionId:k});const F=z.iconPath?this.lb(z.iconPath):void 0;return{id:N,name:z.name,iconClass:F?.iconClass,iconPath:F?.iconPath,visualization:this.kb(k,z.visualization)}}):[]}$disposeDebugVisualizers(k){for(const m of k)this.L.delete(m)}registerDebugVisualizationProvider(k,m,y){if(!k.contributes?.debugVisualizers?.some(R=>R.id===m))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${m})`);const D=A.$Tm.toKey(k.identifier),C=this.jb(D,m);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${m}' is already registered`);return this.G.set(C,y),this.l.$registerDebugVisualizer(D,m),(0,a.$Sc)(()=>{this.l.$unregisterDebugVisualizer(D,m),this.G.delete(m)})}addBreakpoints(k){const m=k.filter(C=>{const R=C.id;return this.z.has(R)?!1:(this.z.set(R,C),!0)});this.gb(m,[],[]);const y=[],D=new Map;for(const C of m)if(C instanceof P.$nN){let R=D.get(C.location.uri.toString());R||(R={type:"sourceMulti",uri:C.location.uri,lines:[]},D.set(C.location.uri.toString(),R),y.push(R)),R.lines.push({id:C.id,enabled:C.enabled,condition:C.condition,hitCondition:C.hitCondition,logMessage:C.logMessage,line:C.location.range.start.line,character:C.location.range.start.character,mode:C.mode})}else C instanceof P.$oN&&y.push({type:"function",id:C.id,enabled:C.enabled,hitCondition:C.hitCondition,logMessage:C.logMessage,condition:C.condition,functionName:C.functionName,mode:C.mode});return this.l.$registerBreakpoints(y)}removeBreakpoints(k){const m=k.filter(R=>this.z.delete(R.id));this.gb([],m,[]);const y=m.filter(R=>R instanceof P.$nN).map(R=>R.id),D=m.filter(R=>R instanceof P.$oN).map(R=>R.id),C=m.filter(R=>R instanceof P.$pN).map(R=>R.id);return this.l.$unregisterBreakpoints(y,D,C)}startDebugging(k,m,y){return this.l.$startDebugging(k?k.uri:void 0,m,{parentSessionID:y.parentSession?y.parentSession.id:void 0,lifecycleManagedByParent:y.lifecycleManagedByParent,repl:y.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact,suppressSaveBeforeStart:y.suppressSaveBeforeStart,suppressDebugStatusbar:y.suppressDebugStatusbar??y.debugUI?.simple,suppressDebugToolbar:y.suppressDebugToolbar??y.debugUI?.simple,suppressDebugView:y.suppressDebugView??y.debugUI?.simple})}stopDebugging(k){return this.l.$stopDebugging(k?k.id:void 0)}registerDebugConfigurationProvider(k,m,y){if(!m)return new P.$lM(()=>{});const D=this.d++;return this.f.push({type:k,handle:D,provider:m}),this.l.$registerDebugConfigurationProvider(k,y,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,D),new P.$lM(()=>{this.f=this.f.filter(C=>C.provider!==m),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(k,m,y){if(!y)return new P.$lM(()=>{});if(!this.cb(k,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.$(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:m,handle:D,factory:y}),this.l.$registerDebugAdapterDescriptorFactory(m,D),new P.$lM(()=>{this.h=this.h.filter(C=>C.factory!==y),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(k,m){if(!m)return new P.$lM(()=>{});const y=this.j++;return this.k.push({type:k,handle:y,factory:m}),new P.$lM(()=>{this.k=this.k.filter(D=>D.factory!==m)})}async $runInTerminal(k,m){return Promise.resolve(void 0)}async $substituteVariables(k,m){let y;const D=await this.ib(k);return D&&(y={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(y,m)}X(k,m){if(k.type==="implementation")return new h(k.implementation)}Y(){}async $startDASession(k,m){const y=this,D=await this.hb(m);return this.eb(this.$(D.type),D).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const R=this.Z(C),T=this.X(R,D);if(!T)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const j=T;return this.D.set(k,j),this.db(D).then(z=>(z&&this.E.set(k,z),j.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const F=N,B={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const Y=await this.K.sign(F.arguments.value);B.body={signature:Y},j.sendResponse(B)}else throw new Error("no signer")}catch(Y){B.success=!1,B.message=Y.message,j.sendResponse(B)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(N),N=(0,v.$EH)(N,!0),y.l.$acceptDAMessage(k,N)}),j.onError(N=>{z&&z.onError&&z.onError(N),this.l.$acceptDAError(k,N.name,N.message,N.stack)}),j.onExit(N=>{z&&z.onExit&&z.onExit(N??void 0,void 0),this.l.$acceptDAExit(k,N??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),j.startSession()))})}$sendDAMessage(k,m){m=(0,v.$DH)(m,!1);const y=this.E.get(k);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(m),this.D.get(k)?.sendMessage(m)}$stopDASession(k){const m=this.E.get(k);this.E.delete(k),m&&m.onWillStopSession&&m.onWillStopSession();const y=this.D.get(k);return this.D.delete(k),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(k){const m=[],y=[],D=[];if(k.added)for(const C of k.added){const R=C.id;if(R&&!this.z.has(R)){let T;if(C.type==="function")T=new P.$oN(C.functionName,C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode);else if(C.type==="data")T=new P.$pN(C.label,C.dataId,C.canPersist,C.enabled,C.hitCondition,C.condition,C.logMessage,C.mode);else{const j=L.URI.revive(C.uri);T=new P.$nN(new P.$xM(j,new P.$mM(C.line,C.character)),C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode)}(0,P.$lN)(T,R),this.z.set(R,T),m.push(T)}}if(k.removed)for(const C of k.removed){const R=this.z.get(C);R&&(this.z.delete(C),y.push(R))}if(k.changed){for(const C of k.changed)if(C.id){const R=this.z.get(C.id);if(R){if(R instanceof P.$oN&&C.type==="function"){const T=R;T.enabled=C.enabled,T.condition=C.condition,T.hitCondition=C.hitCondition,T.logMessage=C.logMessage,T.functionName=C.functionName}else if(R instanceof P.$nN&&C.type==="source"){const T=R;T.enabled=C.enabled,T.condition=C.condition,T.hitCondition=C.hitCondition,T.logMessage=C.logMessage,T.location=new P.$xM(L.URI.revive(C.uri),new P.$mM(C.line,C.character))}D.push(R)}}}this.gb(m,y,D)}async $acceptStackFrameFocus(k){let m;if(k){const y=await this.hb(k.sessionId);k.kind==="thread"?m=new P.$vN(y.api,k.threadId):m=new P.$uN(y.api,k.threadId,k.frameId)}this.B=m,this.C.fire(this.B)}$provideDebugConfigurations(k,m,y){return(0,l.$qh)(async()=>{const D=this.bb(k);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const C=await this.ib(m);return D.provideDebugConfigurations(C,y)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(k,m,y,D){return(0,l.$qh)(async()=>{const C=this.bb(k);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.ib(m);return C.resolveDebugConfiguration(R,y,D)})}$resolveDebugConfigurationWithSubstitutedVariables(k,m,y,D){return(0,l.$qh)(async()=>{const C=this.bb(k);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.ib(m);return C.resolveDebugConfigurationWithSubstitutedVariables(R,y,D)})}async $provideDebugAdapter(k,m){const y=this.ab(k);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(m);return this.eb(y,D).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(C)})}async $acceptDebugSessionStarted(k){const m=await this.hb(k);this.n.fire(m.api)}async $acceptDebugSessionTerminated(k){const m=await this.hb(k);m&&(this.o.fire(m.api),this.m.delete(m.id))}async $acceptDebugSessionActiveChanged(k){this.u=k?await this.hb(k):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(k,m){(await this.hb(k))?._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(k,m){const D={session:(await this.hb(k)).api,event:m.event,body:m.body};this.w.fire(D)}Z(k){if(k instanceof P.$qN)return{type:"executable",command:k.command,args:k.args,options:k.options};if(k instanceof P.$rN)return{type:"server",port:k.port,host:k.host};if(k instanceof P.$sN)return{type:"pipeServer",path:k.path};if(k instanceof P.$tN)return{type:"implementation",implementation:k.implementation};throw new Error("convertToDto unexpected type")}$(k){const m=this.h.filter(y=>y.type===k);if(m.length>0)return m[0].factory}ab(k){const m=this.h.filter(y=>y.handle===k);if(m.length>0)return m[0].factory}bb(k){const m=this.f.filter(y=>y.handle===k);if(m.length>0)return m[0].provider}cb(k,m){if(k.contributes){const y=k.contributes.debuggers;if(y&&y.length>0){for(const D of y)if(D.label&&D.type&&D.type===m)return!0}}return!1}db(k){const y=k.configuration.type,D=this.k.filter(C=>C.type===y||C.type==="*").map(C=>(0,l.$qh)(()=>C.factory.createDebugAdapterTracker(k.api)).then(R=>R,R=>null));return Promise.race([Promise.all(D).then(C=>{const R=(0,r.$Hb)(C);if(R.length>0)return new o(R)}),new Promise(C=>setTimeout(()=>C(void 0),1e3))]).catch(C=>{})}async eb(k,m){const y=m.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new P.$rN(y));if(k){const C=await this.O.getExtensionRegistry();return(0,l.$qh)(()=>k.createDebugAdapterDescriptor(m.api,this.fb(m,C))).then(R=>{if(R)return R})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(m,D))}fb(k,m){}gb(k,m,y){(k.length>0||m.length>0||y.length>0)&&this.A.fire(Object.freeze({added:k,removed:m,changed:y}))}async hb(k){if(k)if(typeof k=="string"){const m=this.m.get(k);if(m)return m}else{let m=this.m.get(k.id);if(!m){const y=await this.ib(k.folderUri),D=k.parent?this.m.get(k.parent):void 0;m=new u(this.l,k.id,k.type,k.name,y,k.configuration,D?.api),this.m.set(m.id,m),this.l.$sessionCached(m.id)}return m}throw new Error("cannot find session")}ib(k){if(k){const m=L.URI.revive(k);return this.N.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}jb(k,m){return`${k}\0${m}`}kb(k,m){if(m){if("title"in m&&"command"in m)return{type:0};if("treeId"in m)return{type:1,id:`${k}\0${m.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(k){const m=this.mb(k);let y,D;return"id"in m?D=n.ThemeIcon.asClassName(m):y=m,{iconPath:y,iconClass:D}}mb(k){if(k instanceof P.$iN)return{id:k.id};const m=typeof k=="object"&&"dark"in k?k.dark:k,y=typeof k=="object"&&"light"in k?k.light:k;return{dark:typeof m=="string"?L.URI.file(m):m,light:typeof y=="string"?L.URI.file(y):y}}};e.$9mc=t,e.$9mc=t=Je([We(0,I.$NO),We(1,p.$mmc),We(2,E.$3mc),We(3,d.$pmc),We(4,$.$Bmc),We(5,f.$6mc),We(6,i.$0O)],t);class u{constructor(k,m,y,D,C,R,T){this.f=k,this.g=m,this.h=y,this.j=D,this.k=C,this.l=R,this.m=T}get api(){const k=this;return this.d??=Object.freeze({id:k.g,type:k.h,get name(){return k.j},set name(m){k.j=m,k.f.$setDebugSessionName(k.g,m)},parentSession:k.m,workspaceFolder:k.k,configuration:k.l,customRequest(m,y){return k.f.$customDebugAdapterRequest(k.g,m,y)},getDebugProtocolBreakpoint(m){return k.f.$getDebugProtocolBreakpoint(k.g,m.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(k){this.j=k}get configuration(){return this.l}}e.$0mc=u;class s{constructor(k){this.value=Object.freeze({append(m){k.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.$$mc=s;class o{constructor(k){this.d=k}onWillStartSession(){this.d.forEach(k=>k.onWillStartSession?k.onWillStartSession():void 0)}onWillReceiveMessage(k){this.d.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(k):void 0)}onDidSendMessage(k){this.d.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(k):void 0)}onWillStopSession(){this.d.forEach(k=>k.onWillStopSession?k.onWillStopSession():void 0)}onError(k){this.d.forEach(m=>m.onError?m.onError(k):void 0)}onExit(k,m){this.d.forEach(y=>y.onExit?y.onExit(k,m):void 0)}}class h extends S.$lsb{constructor(k){super(),this.h=k,k.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(k){this.h.handleMessage(k)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let g=class extends t{constructor(k,m,y,D,C,R,T){super(k,m,y,D,C,R,T)}};e.$_mc=g,e.$_mc=g=Je([We(0,I.$NO),We(1,p.$mmc),We(2,E.$3mc),We(3,d.$pmc),We(4,$.$Bmc),We(5,f.$6mc),We(6,i.$0O)],g)}),define(ke[380],De([1,0,13,59,2,6,328,11,85,107,28,263,20,68,49,90]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=e.$coc=void 0;class f{static async installEarlyHandler(i){Error.stackTraceLimit=100;const c=i.get(b.$5j),t=i.get(p.$NO).getProxy(A.$jM.MainThreadErrors);l.setUnexpectedErrorHandler(u=>{c.error(u);const s=l.$3(u);t.$onUnexpectedError(s)})}static async installFullHandler(i){const c=i.get(b.$5j),r=i.get(p.$NO),t=i.get(v.$3mc),u=i.get(d.$8O),s=r.getProxy(A.$jM.MainThreadExtensionService),o=r.getProxy(A.$jM.MainThreadErrors),h=await t.getExtensionPathIndex(),g=new WeakMap;function w(y,D){if(g.has(y))return g.get(y).stack;let C="",R,T;for(const z of D)C+=`
	at ${z.toString()}`,T=z.getFileName(),!R&&T&&(R=h.findSubstr(L.URI.file(T)));const j=`${y.name||"Error"}: ${y.message||""}${C}`;return g.set(y,{extensionIdentifier:R?.identifier,stack:j}),j}const k=Symbol("prepareStackTrace wrapped");let m=w;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return m},set(y){if(y===w||!y||y[k]){m=y||w;return}m=function(D,C){return w(D,C),y.call(Error,D,C)},Object.assign(m,{[k]:!0})}}),l.setUnexpectedErrorHandler(y=>{c.error(y);const D=l.$3(y),C=g.get(y);if(!C?.extensionIdentifier){o.$onUnexpectedError(D);return}s.$onExtensionRuntimeError(C.extensionIdentifier,D);const R=u.onExtensionError(C.extensionIdentifier,y);c.trace("forwarded error to extension?",R,C)})}}e.$coc=f;class a{constructor(i,c,r,t,u){this.a=r,this.b=new M.$Fac(i,null,t),c=a.e(c,this.b);const s=new E.$wi(...(0,$.$Cs)());s.set(I.$4O,{_serviceBrand:void 0,...c,messagePorts:u}),s.set(p.$NO,new p.$OO(this.b)),s.set(S.$jmc,new S.$kmc(t)),s.set(v.$1mc,r);const o=new P.$gr(s,!0);o.invokeFunction(f.installEarlyHandler),this.d=o.invokeFunction(h=>h.get(b.$5j)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=o.invokeFunction(h=>h.get(v.$3mc)),this.c.initialize(),o.invokeFunction(f.installFullHandler)}async asBrowserUri(i){const c=this.b.getProxy(A.$jM.MainThreadExtensionService);return L.URI.revive(await c.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,c){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=L.URI.revive(c.transformIncomingURIs(i.environment.appRoot));const r=i.environment.extensionDevelopmentLocationURI;return r&&(i.environment.extensionDevelopmentLocationURI=r.map(t=>L.URI.revive(c.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=L.URI.revive(c.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=L.URI.revive(c.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=L.URI.revive(c.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=L.URI.revive(c.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=L.URI.revive(c.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=L.URI.revive(c.transformIncomingURIs(i.logsLocation)),i.workspace=c.transformIncomingURIs(i.workspace),i}}e.$doc=a}),define(ke[381],De([1,0,7,12,236,256,141,96,72,49,20,43,8,61,44,300,301,45,34]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=void 0;let i=class extends b.$9mc{constructor(s,o,h,g,w,k,m,y){super(s,o,h,g,k,m,y),this.pb=w,this.nb=new t}X(s,o){switch(s.type){case"server":return new d.$ioc(s);case"pipeServer":return new d.$joc(s);case"executable":return new d.$koc(s,o.type)}return super.X(s,o)}fb(s,o){const h=d.$koc.platformAdapterExecutable(o.getAllExtensionDescriptions(),s.type);if(h)return new p.$qN(h.command,h.args,h.options)}Y(){return new M.$tec}async $runInTerminal(s,o){if(s.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(z=>{this.nb.onTerminalClosed(z)}));const h=await this.P.getConfigProvider(),g=this.pb.getDefaultShell(!0),w=this.pb.getDefaultShellArgs(!0),k=s.title||L.localize(0,null),m=JSON.stringify({shell:g,shellArgs:w});let y=await this.nb.checkout(m,k),D,C=!1;if(y)D=s.cwd;else{const z={shellPath:g,shellArgs:w,cwd:s.cwd,name:k,iconPath:new p.$iN("debug")};C=!0,y=this.pb.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(y,m)}y.show(!0);const R=await y.processId;C?await new Promise(z=>setTimeout(z,1e3)):(y.state.isInteractedWith&&(y.sendText(""),await(0,l.$zh)(200)),h.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0||g.indexOf("cmd.exe")>=0?y.sendText("cls"):g.indexOf("bash")>=0?y.sendText("clear"):O.$i?y.sendText("cls"):y.sendText("clear")));const T=(0,f.$moc)(g,s.args,!!s.argsCanBeInterpretedByShell,D,s.env);y.sendText(T);const j=this.onDidTerminateDebugSession(z=>{z.id===o&&(this.nb.free(y),j.dispose())});return R}else if(s.kind==="external")return r(s,await this.P.getConfigProvider());return super.$runInTerminal(s,o)}};e.$noc=i,e.$noc=i=Je([We(0,I.$NO),We(1,v.$mmc),We(2,E.$3mc),We(3,a.$pmc),We(4,P.$Nmc),We(5,$.$Bmc),We(6,S.$6mc),We(7,n.$0O)],i);let c;function r(u,s){if(!c)if(O.$i)c=new A.$edc;else if(O.$j)c=new A.$fdc;else if(O.$k)c=new A.$gdc;else throw new Error("external terminals not supported on this platform");const o=s.getConfiguration("terminal");return c.runInTerminal(u.title,u.cwd,u.args,u.env||{},o.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(s,o,h=!1){const w=[...this.b.entries()].map(([k,m])=>(0,l.$lh)(async y=>{if(k.name!==o||m.lastUsedAt!==-1&&await(0,f.$loc)(await k.processId))return null;const D=Date.now();return m.lastUsedAt+t.a>D||y.isCancellationRequested?null:m.config!==s?(h&&k.dispose(),null):(m.lastUsedAt=D,k)}));return await(0,l.$Dh)(w,k=>!!k)}insert(s,o){this.b.set(s,{lastUsedAt:Date.now(),config:o})}free(s){const o=this.b.get(s);o&&(o.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}}),define(ke[382],De([1,0,16,2,105,44,73,45,42,43,20,28,95,15,11,91,23,64,61]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$foc=void 0;let i=class extends p.$Rnc{constructor(r,t,u,s,o,h,g,w,k){super(r,t,u,s,o,h,g,w),this.C=u,this.D=k,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(r,t){const u=t;if(!t.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const s=p.TaskHandleDTO.from(u,this.C),o=await this.a.$getTaskExecution(s);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const h=await this.z(o,t);return this.a.$executeTask(s).catch(()=>{}),h}else{const s=p.TaskDTO.from(t,r);if(s===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(s.execution)&&await this.y(s,t,!1);const o=await this.z(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),o}}v(r,t,u,s){const o=[];if(s)for(const h of s){this.A(h,u),(!h.definition||!r[h.definition.type])&&this.f.warn(`The task [${h.source}, ${h.name}] uses an undefined task type. The task will be ignored in the future.`);const g=p.TaskDTO.from(h,u.extension);g&&(o.push(g),p.CustomExecutionDTO.is(g.execution)&&t.push(this.y(g,h,!0)))}return{tasks:o,extension:u.extension}}async w(r){return r}async G(r){let t=r&&r.length>0?r[0]:void 0;if(!t){const u=O.URI.file((0,a.homedir)());t=new $.$Si({uri:u,name:f.$9g(u),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(r,t){const u=O.URI.revive(r),s={process:void 0,variables:Object.create(null)},o=await this.b.resolveWorkspaceFolder(u),h=await this.b.getWorkspaceFolders2()??[],g=await this.D.getResolver(),w=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(h);for(const k of t.variables)s.variables[k]=await g.resolveAsync(w,k);if(t.process!==void 0){let k;if(t.process.path!==void 0){k=t.process.path.split(l.$tc);for(let m=0;m<k.length;m++)k[m]=await g.resolveAsync(w,k[m])}s.process=await L.win32.findExecutable(await g.resolveAsync(w,t.process.name),t.process.cwd!==void 0?await g.resolveAsync(w,t.process.cwd):void 0,k)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(r,t,u){return L.win32.findExecutable(r,t,u)}};e.$foc=i,e.$foc=i=Je([We(0,I.$NO),We(1,P.$4O),We(2,A.$mmc),We(3,M.$YO),We(4,b.$pmc),We(5,E.$Nmc),We(6,v.$5j),We(7,d.$3lc),We(8,n.$6mc)],i)}),define(ke[383],De([1,0,64,61]),function(he,e,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=void 0;class L extends O.$7mc{m(){return(0,l.homedir)()}}e.$Xoc=L}),define(ke[160],De([1,0,19,7,21,47,15,16,23,2,37]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=e.$onc=e.$nnc=void 0,e.$pnc=d;class P{constructor(n,i,c){this.d=n,this.e=i,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const c=this.g.folderQueries||[],r=new L.$qe(i);return new Promise((t,u)=>{this.a=new S(n);let s=!1;const o=(h,g)=>{if(!s&&!this.b){const w=this.h(h);d(h)&&typeof this.g.maxResults=="number"&&this.c+w>this.g.maxResults&&(this.b=!0,s=!0,r.cancel(),h=this.j(h,this.g.maxResults-this.c));const k=this.h(h);this.c+=k,(k>0||!d(h))&&this.a.add(h,g)}};Promise.all(c.map((h,g)=>this.k(h,w=>o(w,g),r.token))).then(h=>{r.dispose(),this.a.flush();const g=h.some(w=>!!w&&!!w.limitHit);t({limitHit:this.b||g,messages:h.flatMap(w=>w?.message?Array.isArray(w.message)?w.message:[w.message]:[]),stats:{type:this.f}})},h=>{r.dispose();const g=(0,A.$jj)(h);u(new Error(g))})})}h(n){return d(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],r=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,i),preview:{matches:r.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,c){const r=new I.$PK(this.g,n),t=[],u={report:h=>{if(!this.l(h))return;const g=n.folder.scheme===M.Schemas.file?(0,I.$QK)(()=>this.e.readdir($.$$g(h.uri))):void 0,w=$.$bh(n.folder,h.uri);if(w){const k=r.includedInQuery(w,b.$nc(w),g);(0,O.$kh)(k)?t.push(k.then(m=>{m&&i(h)})):k&&i(h)}}},s=this.n(n);let o;return this.d.query.type===3?o=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,s,u,c):o=await this.d.provider.provideTextSearchResults(p(this.d.query.contentPattern),s,u,c),t.length&&await Promise.all(t),o}l(n){if(d(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,I.$OK)(this.g.includePattern,n.includePattern),c=(0,I.$OK)(this.g.excludePattern,n.excludePattern),r={folder:E.URI.from(n.folder),excludes:c,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(r.usePCRE2=this.g.usePCRE2),r}}e.$nnc=P;function p(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class S{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new f(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$5g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$onc=S;function v(a){return d(a)?{preview:{matches:(0,l.$1b)(a.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:a.preview.text},ranges:(0,l.$1b)(a.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function d(a){return!!a.preview}class f{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$qnc=f}),define(ke[97],De([1,0,3,6,5,376,20,68,11,2,160]),function(he,e,l,O,L,A,M,b,$,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=e.$rnc=void 0,e.$tnc=p,e.$rnc=(0,L.$yi)("IExtHostSearch");let P=class{constructor(d,f,a){this.n=d,this.o=f,this.q=a,this.c=this.n.getProxy(O.$jM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new A.$mnc}s(d){return this.o.transformOutgoingScheme(d)}registerTextSearchProvider(d,f){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const a=this.d++;return this.e.set(a,f),this.c.$registerTextSearchProvider(a,this.s(d)),(0,l.$Sc)(()=>{this.g.delete(d),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(d,f){if(this.i.has(d))throw new Error(`an AI text search provider for the scheme '${d}'is already registered`);this.i.add(d);const a=this.d++;return this.h.set(a,f),this.c.$registerAITextSearchProvider(a,this.s(d)),(0,l.$Sc)(()=>{this.i.delete(d),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(d,f){if(this.k.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.k.add(d);const a=this.d++;return this.j.set(a,f),this.c.$registerFileSearchProvider(a,this.s(d)),(0,l.$Sc)(()=>{this.k.delete(d),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(d,f,a,n){const i=p(a),c=this.j.get(d);if(c)return this.l.fileSearch(i,c,r=>{this.c.$handleFileMatch(d,f,r.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+d)}async doInternalFileSearchWithCustomCallback(d,f,a){return{messages:[]}}$clearCache(d){return this.l.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,f,a,n){const i=this.e.get(d);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${d}`);const c=p(a);return this.t(c,i).search(t=>this.c.$handleTextMatch(d,f,t),n)}$provideAITextSearchResults(d,f,a,n){const i=this.h.get(d);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${d}`);const c=p(a);return this.v(c,i).search(t=>this.c.$handleTextMatch(d,f,t),n)}$enableExtensionHostSearch(){}t(d,f){return new I.$nnc({query:d,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(d,f){return new I.$nnc({query:d,provider:f},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$snc=P,e.$snc=P=Je([We(0,M.$NO),We(1,b.$jmc),We(2,$.$5j)],P);function p(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(S),extraFileResources:v.extraFileResources&&v.extraFileResources.map(d=>E.URI.revive(d))}}function S(v){return{...v,folder:E.URI.revive(v.folder)}}}),define(ke[384],De([1,0,21,13,4,3,15,41,2,136,203,184,80,25,33,11,86,87,283,6,330,356,91,121,334,335,336,316,305,34,337,45,338,96,152,339,318,331,340,341,73,72,319,332,49,342,70,343,60,28,357,320,344,122,345,116,117,321,375,347,288,348,358,349,158,322,350,351,352,20,353,97,118,354,323,355,119,93,95,90,43,156,359,360,333,361,362,71,17,8,324,68,325,92,363,364,151,44,298,115,26,94]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c,r,t,u,s,o,h,g,w,k,m,y,D,C,R,T,j,z,N,F,B,Y,re,H,K,_,Z,$e,oe,Pe,te,U,ee,be,ue,ce,ae,le,J,se,pe,ve,Re,me,Ie,Ae,ze,q,W,X,Q,de,we,Te,qe,Xe,tt,et,nt,it,rt,at,Me,ye,Ve,ne,ie,Ce,Ge,Le,st,ut,mt,Ct,Pt,Bt,Ut,Et,Zt,xt,xe,on){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=Xt;function Xt(ft){const $t=ft.get(Pe.$4O),_t=ft.get(oe.$7lc),Qt=ft.get(Z.$rmc),jt=ft.get(K.$3mc),gt=ft.get(Et.$mmc),Ht=ft.get(it.$8O),en=ft.get(y.$pmc),Wt=ft.get(ut.$jmc),Ye=ft.get(X.$NO),ln=ft.get(tt.$Kmc),Yt=ft.get(et.$smc),qt=ft.get(d.$6j),wt=ft.get(d.$5j),Vt=ft.get(Ce.$UDb),Mt=ft.get(t.$3lc),Ot=ft.get(Ut.$9nc),tn=ft.get(we.$Umc),Gt=ft.get(Y.$Bmc),an=ft.get(ae.$Ymc),Nt=ft.get(u.$amc),Kt=ft.get(be.$Rmc);Ye.set(i.$kM.ExtHostFileSystemInfo,_t),Ye.set(i.$kM.ExtHostLogLevelServiceShape,qt),Ye.set(i.$kM.ExtHostWorkspace,gt),Ye.set(i.$kM.ExtHostConfiguration,en),Ye.set(i.$kM.ExtHostExtensionService,jt),Ye.set(i.$kM.ExtHostStorage,ln),Ye.set(i.$kM.ExtHostTunnelService,Vt),Ye.set(i.$kM.ExtHostWindow,Ot),Ye.set(i.$kM.ExtHostSecretState,tn),Ye.set(i.$kM.ExtHostTelemetry,Ht),Ye.set(i.$kM.ExtHostEditorTabs,Gt),Ye.set(i.$kM.ExtHostManagedSockets,an),Ye.set(i.$kM.ExtHostAuthentication,Nt),Ye.set(i.$kM.ExtHostChatProvider,Kt);const Lt=Ye.set(i.$kM.ExtHostDecorations,ft.get(R.$bnc)),It=Ye.set(i.$kM.ExtHostDocumentsAndEditors,ft.get(B.$YO)),pt=Ye.set(i.$kM.ExtHostCommands,ft.get(k.$0O)),kt=Ye.set(i.$kM.ExtHostTerminalService,ft.get(rt.$Nmc)),cn=Ye.set(i.$kM.ExtHostTerminalShellIntegration,ft.get(at.$Unc)),Dt=Ye.set(i.$kM.ExtHostDebugService,ft.get(C.$8mc)),gn=Ye.set(i.$kM.ExtHostSearch,ft.get(de.$rnc)),rn=Ye.set(i.$kM.ExtHostTask,ft.get(nt.$Tnc)),pn=Ye.set(i.$kM.ExtHostOutputService,ft.get(Ie.$Gnc)),hn=Ye.set(i.$kM.ExtHostLocalization,ft.get(ce.$Xmc)),vn=Ye.set(i.$kM.ExtHostUrls,new mt.$6nc(Ye)),At=Ye.set(i.$kM.ExtHostDocuments,new F.$0lc(Ye,It)),En=Ye.set(i.$kM.ExtHostDocumentContentProviders,new z.$dnc(Ye,It,wt)),sn=Ye.set(i.$kM.ExtHostDocumentSaveParticipant,new N.$enc(wt,At,Ye.getProxy(i.$jM.MainThreadBulkEdits))),Oe=Ye.set(i.$kM.ExtHostNotebook,new J.$unc(Ye,pt,It,At,Qt,gn)),Fe=Ye.set(i.$kM.ExtHostNotebookDocuments,new pe.$Anc(Oe)),Ee=Ye.set(i.$kM.ExtHostNotebookEditors,new ve.$Bnc(wt,Oe)),x=Ye.set(i.$kM.ExtHostNotebookKernels,new Re.$Cnc(Ye,$t,Oe,pt,wt)),je=Ye.set(i.$kM.ExtHostNotebookRenderers,new me.$Enc(Ye,Oe)),He=Ye.set(i.$kM.ExtHostNotebookDocumentSaveParticipant,new se.$znc(wt,Oe,Ye.getProxy(i.$jM.MainThreadBulkEdits))),Ze=Ye.set(i.$kM.ExtHostEditors,new ye.$gmc(Ye,It)),Ke=Ye.set(i.$kM.ExtHostTreeViews,new ie.$4nc(Ye.getProxy(i.$jM.MainThreadTreeViews),pt,wt)),ht=Ye.set(i.$kM.ExtHostEditorInsets,new w.$hmc(Ye.getProxy(i.$jM.MainThreadEditorInsets),Ze,$t.remote)),St=Ye.set(i.$kM.ExtHostDiagnostics,new T.$9lc(Ye,wt,_t,It)),Ft=Ye.set(i.$kM.ExtHostLanguages,new ue.$xnc(Ye,At,pt.converter,Wt)),lt=Ye.set(i.$kM.ExtHostLanguageFeatures,new ee.$$lc(Ye,Wt,At,pt,St,wt,Mt,Ht)),Tt=Ye.set(i.$kM.ExtHostFileSystem,new _.$hnc(Ye,lt)),zt=Ye.set(i.$kM.ExtHostFileSystemEventService,new $e.$inc(Ye,wt,It)),kn=Ye.set(i.$kM.ExtHostQuickOpen,(0,W.$Knc)(Ye,gt,pt)),Pn=Ye.set(i.$kM.ExtHostSCM,new Q.$Mnc(Ye,pt,At,wt)),Xn=Ye.set(i.$kM.ExtHostQuickDiff,new q.$Jnc(Ye,Wt)),On=Ye.set(i.$kM.ExtHostShare,new Te.$Nnc(Ye,Wt)),Nn=Ye.set(i.$kM.ExtHostComments,(0,m.$imc)(Ye,pt,At)),In=Ye.set(i.$kM.ExtHostProgress,new ze.$Inc(Ye.getProxy(i.$jM.MainThreadProgress))),Tn=Ye.set(i.$kM.ExtHostLabelService,new U.$wnc(Ye)),jn=Ye.set(i.$kM.ExtHostTheming,new Ve.$1nc(Ye)),Qn=Ye.set(i.$kM.ExtHostTimeline,new ne.$3nc(Ye,pt)),Fn=Ye.set(i.$kM.ExtHostWebviews,new Ct.$wmc(Ye,$t.remote,gt,wt,Mt)),An=Ye.set(i.$kM.ExtHostWebviewPanels,new Pt.$zmc(Ye,Fn,gt)),zn=Ye.set(i.$kM.ExtHostCustomEditors,new D.$Amc(Ye,At,Yt,Fn,An)),Bn=Ye.set(i.$kM.ExtHostWebviewViews,new Bt.$7nc(Ye,Fn)),yn=Ye.set(i.$kM.ExtHostTesting,new Me.$Wnc(Ye,wt,pt,It)),Yn=Ye.set(i.$kM.ExtHostUriOpeners,new st.$5nc(Ye)),Zn=Ye.set(i.$kM.ExtHostProfileContentHandlers,new Ae.$Hnc(Ye));Ye.set(i.$kM.ExtHostInteractive,new te.$vnc(Ye,Oe,It,pt,wt));const Rn=Ye.set(i.$kM.ExtHostChatAgents2,new o.$dmc(Ye,wt,pt)),xn=Ye.set(i.$kM.ExtHostChatVariables,new h.$emc(Ye)),Un=Ye.set(i.$kM.ExtHostAiRelatedInformation,new c.$2lc(Ye)),gi=Ye.set(i.$kM.ExtHostAiEmbeddingVector,new H.$gnc(Ye)),_n=Ye.set(i.$kM.ExtHostStatusBar,new Xe.$Qnc(Ye,pt.converter)),Wn=Ye.set(i.$kM.ExtHostSpeech,new qe.$Onc(Ye)),bn=Ye.set(i.$kM.ExtHostEmbeddings,new re.$fnc(Ye)),mi=Object.values(i.$kM);Ye.assertRegistered(mi);const $i=new s.$cmc(Ye,It),ei=new g.$fmc(Ye),qn=new le.$ync(Ye,wt),Mn=new j.$cnc(Ye);return r.$_lc.register(pt),function(Ue,dn,Vn){function ot(fe){return(Se,Be,ct)=>{const yt=fe(Rt=>{try{Se.call(Be,Rt)}catch(Cn){O.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Cn.toString()}`,{cause:Cn})),Ht.onExtensionError(Ue.identifier,Cn)}});return ct?.push(yt),yt}}const vt=function(){let fe=!Ue.isUnderDevelopment;function Se(){fe||(wt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),fe=!0)}return function Be(ct){if(Array.isArray(ct))ct.forEach(Be);else if(typeof ct=="string")Se();else{const yt=ct;typeof yt.scheme>"u"&&Se(),typeof yt.exclusive=="boolean"&&(0,xe.$LG)(Ue,"documentFiltersExclusive")}return ct}}(),ti={getSession(fe,Se,Be){return typeof Be?.forceNewSession=="object"&&Be.forceNewSession.learnMore&&(0,xe.$LG)(Ue,"authLearnMore"),Nt.getSession(Ue,fe,Se,Be)},getSessions(fe,Se){return(0,xe.$LG)(Ue,"authGetSessions"),Nt.getSessions(Ue,fe,Se)},async hasSession(fe,Se){return(0,xe.$LG)(Ue,"authSession"),!!await Nt.getSession(Ue,fe,Se,{silent:!0})},get onDidChangeSessions(){return ot(Nt.onDidChangeSessions)},registerAuthenticationProvider(fe,Se,Be,ct){return Nt.registerAuthenticationProvider(fe,Se,Be,ct)}},mn={registerCommand(fe,Se,Be){return pt.registerCommand(!0,fe,Se,Be,void 0,Ue)},registerTextEditorCommand(fe,Se,Be){return pt.registerCommand(!0,fe,(...ct)=>{const yt=Ze.getActiveTextEditor();if(!yt){wt.warn("Cannot execute "+fe+" because there is no active text editor.");return}return yt.edit(Rt=>{Se.apply(Be,[yt,Rt,...ct])}).then(Rt=>{Rt||wt.warn("Edits from command "+fe+" were not applied.")},Rt=>{wt.warn("An error occurred while running command "+fe,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(fe,Se,Be)=>((0,xe.$LG)(Ue,"diffCommand"),pt.registerCommand(!0,fe,async(...ct)=>{const yt=It.activeEditor(!0);if(!yt){wt.warn("Cannot execute "+fe+" because there is no active text editor.");return}const Rt=await Ze.getDiffInformation(yt.id);Se.apply(Be,[Rt,...ct])},void 0,void 0,Ue)),executeCommand(fe,...Se){return pt.executeCommand(fe,...Se)},getCommands(fe=!1){return pt.getCommands(fe)}},Dn={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return ei.value},get shell(){return kt.getDefaultShell(!1)},get onDidChangeShell(){return ot(kt.onDidChangeShell)},get isTelemetryEnabled(){return Ht.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Ht.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$LG)(Ue,"telemetry"),Ht.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$LG)(Ue,"telemetry"),ot(Ht.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$7O)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(fe,Se){return it.$6O.validateSender(fe),Ht.instantiateLogger(Ue,fe,Se)},openExternal(fe,Se){return Ot.openUri(fe,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(fe){if(fe.scheme===$t.environment.appUriScheme)return vn.createAppUri(fe);try{return await Ot.asExternalUri(fe,{allowTunneling:!!$t.remote.authority})}catch(Se){if((0,M.$Hg)(fe,M.Schemas.http)||(0,M.$Hg)(fe,M.Schemas.https))return fe;throw Se}},get remoteName(){return(0,f.$Km)($t.remote.authority)},get remoteAuthority(){return(0,xe.$LG)(Ue,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return ot(wt.onDidChangeLogLevel)},get appQuality(){return(0,xe.$LG)(Ue,"resolvers"),$t.quality},get appCommit(){return(0,xe.$LG)(Ue,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Dn);const pi={createTestController(fe,Se,Be){return yn.createTestController(Ue,fe,Se,Be)},createTestObserver(){return(0,xe.$LG)(Ue,"testObserver"),yn.createTestObserver()},runTests(fe){return(0,xe.$LG)(Ue,"testObserver"),yn.runTests(fe)},get onDidChangeTestResults(){return(0,xe.$LG)(Ue,"testObserver"),ot(yn.onResultsChanged)},get testResults(){return(0,xe.$LG)(Ue,"testObserver"),yn.results}},nn=$t.remote.isRemote?Le.ExtensionKind.Workspace:Le.ExtensionKind.UI,Ln={getExtension(fe,Se){(0,xe.$KG)(Ue,"extensionsAny")||(Se=!1);const Be=dn.mine.getExtensionDescription(fe);if(Be)return new K.$4mc(jt,Ue.identifier,Be,nn,!1);if(Se){const ct=dn.all.getExtensionDescription(fe);if(ct)return new K.$4mc(jt,Ue.identifier,ct,nn,!0)}},get all(){const fe=[];for(const Se of dn.mine.getAllExtensionDescriptions())fe.push(new K.$4mc(jt,Ue.identifier,Se,nn,!1));return fe},get allAcrossExtensionHosts(){(0,xe.$LG)(Ue,"extensionsAny");const fe=new S.$Um(dn.mine.getAllExtensionDescriptions().map(Be=>Be.identifier)),Se=[];for(const Be of dn.all.getAllExtensionDescriptions()){const ct=!fe.has(Be.identifier);Se.push(new K.$4mc(jt,Ue.identifier,Be,nn,ct))}return Se},get onDidChange(){return(0,xe.$KG)(Ue,"extensionsAny")?ot(L.Event.any(dn.mine.onDidChange,dn.all.onDidChange)):ot(dn.mine.onDidChange)}},ni={createDiagnosticCollection(fe){return St.createDiagnosticCollection(Ue.identifier,fe)},get onDidChangeDiagnostics(){return ot(St.onDidChangeDiagnostics)},getDiagnostics:fe=>St.getDiagnostics(fe),getLanguages(){return Ft.getLanguages()},setTextDocumentLanguage(fe,Se){return Ft.changeLanguage(fe.uri,Se)},match(fe,Se){const Be=Ge.LanguageSelector.from(fe);let ct;return(0,I.$gu)(Be)&&(ct=Oe.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Rt=>Rt.document===Se))?.apiNotebook),(0,I.$fu)(Be,Se.uri,Se.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(fe,Se,Be){return lt.registerCodeActionProvider(Ue,vt(fe),Se,Be)},registerDocumentPasteEditProvider(fe,Se,Be){return(0,xe.$LG)(Ue,"documentPaste"),lt.registerDocumentPasteEditProvider(Ue,vt(fe),Se,Be)},registerCodeLensProvider(fe,Se){return lt.registerCodeLensProvider(Ue,vt(fe),Se)},registerDefinitionProvider(fe,Se){return lt.registerDefinitionProvider(Ue,vt(fe),Se)},registerDeclarationProvider(fe,Se){return lt.registerDeclarationProvider(Ue,vt(fe),Se)},registerImplementationProvider(fe,Se){return lt.registerImplementationProvider(Ue,vt(fe),Se)},registerTypeDefinitionProvider(fe,Se){return lt.registerTypeDefinitionProvider(Ue,vt(fe),Se)},registerHoverProvider(fe,Se){return lt.registerHoverProvider(Ue,vt(fe),Se,Ue.identifier)},registerEvaluatableExpressionProvider(fe,Se){return lt.registerEvaluatableExpressionProvider(Ue,vt(fe),Se,Ue.identifier)},registerInlineValuesProvider(fe,Se){return lt.registerInlineValuesProvider(Ue,vt(fe),Se,Ue.identifier)},registerDocumentHighlightProvider(fe,Se){return lt.registerDocumentHighlightProvider(Ue,vt(fe),Se)},registerMultiDocumentHighlightProvider(fe,Se){return lt.registerMultiDocumentHighlightProvider(Ue,vt(fe),Se)},registerLinkedEditingRangeProvider(fe,Se){return lt.registerLinkedEditingRangeProvider(Ue,vt(fe),Se)},registerReferenceProvider(fe,Se){return lt.registerReferenceProvider(Ue,vt(fe),Se)},registerRenameProvider(fe,Se){return lt.registerRenameProvider(Ue,vt(fe),Se)},registerNewSymbolNamesProvider(fe,Se){return(0,xe.$LG)(Ue,"newSymbolNamesProvider"),lt.registerNewSymbolNamesProvider(Ue,vt(fe),Se)},registerDocumentSymbolProvider(fe,Se,Be){return lt.registerDocumentSymbolProvider(Ue,vt(fe),Se,Be)},registerWorkspaceSymbolProvider(fe){return lt.registerWorkspaceSymbolProvider(Ue,fe)},registerDocumentFormattingEditProvider(fe,Se){return lt.registerDocumentFormattingEditProvider(Ue,vt(fe),Se)},registerDocumentRangeFormattingEditProvider(fe,Se){return lt.registerDocumentRangeFormattingEditProvider(Ue,vt(fe),Se)},registerOnTypeFormattingEditProvider(fe,Se,Be,...ct){return lt.registerOnTypeFormattingEditProvider(Ue,vt(fe),Se,[Be].concat(ct))},registerDocumentSemanticTokensProvider(fe,Se,Be){return lt.registerDocumentSemanticTokensProvider(Ue,vt(fe),Se,Be)},registerDocumentRangeSemanticTokensProvider(fe,Se,Be){return lt.registerDocumentRangeSemanticTokensProvider(Ue,vt(fe),Se,Be)},registerSignatureHelpProvider(fe,Se,Be,...ct){return typeof Be=="object"?lt.registerSignatureHelpProvider(Ue,vt(fe),Se,Be):lt.registerSignatureHelpProvider(Ue,vt(fe),Se,typeof Be>"u"?[]:[Be,...ct])},registerCompletionItemProvider(fe,Se,...Be){return lt.registerCompletionItemProvider(Ue,vt(fe),Se,Be)},registerInlineCompletionItemProvider(fe,Se,Be){return Se.handleDidShowCompletionItem&&(0,xe.$LG)(Ue,"inlineCompletionsAdditions"),Se.handleDidPartiallyAcceptCompletionItem&&(0,xe.$LG)(Ue,"inlineCompletionsAdditions"),Be&&(0,xe.$LG)(Ue,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Ue,vt(fe),Se,Be)},registerInlineEditProvider(fe,Se){return(0,xe.$LG)(Ue,"inlineEdit"),lt.registerInlineEditProvider(Ue,vt(fe),Se)},registerDocumentLinkProvider(fe,Se){return lt.registerDocumentLinkProvider(Ue,vt(fe),Se)},registerColorProvider(fe,Se){return lt.registerColorProvider(Ue,vt(fe),Se)},registerFoldingRangeProvider(fe,Se){return lt.registerFoldingRangeProvider(Ue,vt(fe),Se)},registerSelectionRangeProvider(fe,Se){return lt.registerSelectionRangeProvider(Ue,fe,Se)},registerCallHierarchyProvider(fe,Se){return lt.registerCallHierarchyProvider(Ue,fe,Se)},registerTypeHierarchyProvider(fe,Se){return lt.registerTypeHierarchyProvider(Ue,fe,Se)},setLanguageConfiguration:(fe,Se)=>lt.setLanguageConfiguration(Ue,fe,Se),getTokenInformationAtPosition(fe,Se){return(0,xe.$LG)(Ue,"tokenInformation"),Ft.tokenAtPosition(fe,Se)},registerInlayHintsProvider(fe,Se){return lt.registerInlayHintsProvider(Ue,fe,Se)},createLanguageStatusItem(fe,Se){return Ft.createLanguageStatusItem(Ue,fe,Se)},registerDocumentDropEditProvider(fe,Se,Be){return lt.registerDocumentOnDropEditProvider(Ue,fe,Se,(0,xe.$KG)(Ue,"documentPaste")?Be:void 0)}},ii={get activeTextEditor(){return Ze.getActiveTextEditor()},get visibleTextEditors(){return Ze.getVisibleTextEditors()},get activeTerminal(){return kt.activeTerminal},get terminals(){return kt.terminals},async showTextDocument(fe,Se,Be){$.URI.isUri(fe)&&fe.scheme===M.Schemas.vscodeRemote&&!fe.authority&&Mt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await($.URI.isUri(fe)?Promise.resolve(Hn.openTextDocument(fe)):Promise.resolve(fe));return Ze.showTextDocument(ct,Se,Be)},createTextEditorDecorationType(fe){return Ze.createTextEditorDecorationType(Ue,fe)},onDidChangeActiveTextEditor(fe,Se,Be){return ot(Ze.onDidChangeActiveTextEditor)(fe,Se,Be)},onDidChangeVisibleTextEditors(fe,Se,Be){return ot(Ze.onDidChangeVisibleTextEditors)(fe,Se,Be)},onDidChangeTextEditorSelection(fe,Se,Be){return ot(Ze.onDidChangeTextEditorSelection)(fe,Se,Be)},onDidChangeTextEditorOptions(fe,Se,Be){return ot(Ze.onDidChangeTextEditorOptions)(fe,Se,Be)},onDidChangeTextEditorVisibleRanges(fe,Se,Be){return ot(Ze.onDidChangeTextEditorVisibleRanges)(fe,Se,Be)},onDidChangeTextEditorViewColumn(fe,Se,Be){return ot(Ze.onDidChangeTextEditorViewColumn)(fe,Se,Be)},onDidCloseTerminal(fe,Se,Be){return ot(kt.onDidCloseTerminal)(fe,Se,Be)},onDidOpenTerminal(fe,Se,Be){return ot(kt.onDidOpenTerminal)(fe,Se,Be)},onDidChangeActiveTerminal(fe,Se,Be){return ot(kt.onDidChangeActiveTerminal)(fe,Se,Be)},onDidChangeTerminalDimensions(fe,Se,Be){return(0,xe.$LG)(Ue,"terminalDimensions"),ot(kt.onDidChangeTerminalDimensions)(fe,Se,Be)},onDidChangeTerminalState(fe,Se,Be){return ot(kt.onDidChangeTerminalState)(fe,Se,Be)},onDidWriteTerminalData(fe,Se,Be){return(0,xe.$LG)(Ue,"terminalDataWriteEvent"),ot(kt.onDidWriteTerminalData)(fe,Se,Be)},onDidExecuteTerminalCommand(fe,Se,Be){return(0,xe.$LG)(Ue,"terminalExecuteCommandEvent"),ot(kt.onDidExecuteTerminalCommand)(fe,Se,Be)},onDidChangeTerminalShellIntegration(fe,Se,Be){return(0,xe.$LG)(Ue,"terminalShellIntegration"),ot(cn.onDidChangeTerminalShellIntegration)(fe,Se,Be)},onDidStartTerminalShellExecution(fe,Se,Be){return(0,xe.$LG)(Ue,"terminalShellIntegration"),ot(cn.onDidStartTerminalShellExecution)(fe,Se,Be)},onDidEndTerminalShellExecution(fe,Se,Be){return(0,xe.$LG)(Ue,"terminalShellIntegration"),ot(cn.onDidEndTerminalShellExecution)(fe,Se,Be)},get state(){return Ot.getState()},onDidChangeWindowState(fe,Se,Be){return ot(Ot.onDidChangeWindowState)(fe,Se,Be)},showInformationMessage(fe,...Se){return qn.showMessage(Ue,b.default.Info,fe,Se[0],Se.slice(1))},showWarningMessage(fe,...Se){return qn.showMessage(Ue,b.default.Warning,fe,Se[0],Se.slice(1))},showErrorMessage(fe,...Se){return qn.showMessage(Ue,b.default.Error,fe,Se[0],Se.slice(1))},showQuickPick(fe,Se,Be){return kn.showQuickPick(Ue,fe,Se,Be)},showWorkspaceFolderPick(fe){return kn.showWorkspaceFolderPick(fe)},showInputBox(fe,Se){return kn.showInput(fe,Se)},showOpenDialog(fe){return Mn.showOpenDialog(Ue,fe)},showSaveDialog(fe){return Mn.showSaveDialog(fe)},createStatusBarItem(fe,Se,Be){let ct,yt,Rt;return typeof fe=="string"?(ct=fe,yt=Se,Rt=Be):(yt=fe,Rt=Se),_n.createStatusBarEntry(Ue,ct,yt,Rt)},setStatusBarMessage(fe,Se){return _n.setStatusBarMessage(fe,Se)},withScmProgress(fe){return Mt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),In.withProgress(Ue,{location:Le.ProgressLocation.SourceControl},(Se,Be)=>fe({report(ct){}}))},withProgress(fe,Se){return In.withProgress(Ue,fe,Se)},createOutputChannel(fe,Se){return pn.createOutputChannel(fe,Se,Ue)},createWebviewPanel(fe,Se,Be,ct){return An.createWebviewPanel(Ue,fe,Se,Be,ct)},createWebviewTextEditorInset(fe,Se,Be,ct){return(0,xe.$LG)(Ue,"editorInsets"),ht.createWebviewEditorInset(fe,Se,Be,ct,Ue)},createTerminal(fe,Se,Be){return typeof fe=="object"?"pty"in fe?kt.createExtensionTerminal(fe):kt.createTerminalFromOptions(fe):kt.createTerminal(fe,Se,Be)},registerTerminalLinkProvider(fe){return kt.registerLinkProvider(fe)},registerTerminalProfileProvider(fe,Se){return kt.registerProfileProvider(Ue,fe,Se)},registerTerminalQuickFixProvider(fe,Se){return(0,xe.$LG)(Ue,"terminalQuickFixProvider"),kt.registerTerminalQuickFixProvider(fe,Ue.identifier.value,Se)},registerTreeDataProvider(fe,Se){return Ke.registerTreeDataProvider(fe,Se,Ue)},createTreeView(fe,Se){return Ke.createTreeView(fe,Se,Ue)},registerWebviewPanelSerializer:(fe,Se)=>An.registerWebviewPanelSerializer(Ue,fe,Se),registerCustomEditorProvider:(fe,Se,Be={})=>zn.registerCustomEditorProvider(Ue,fe,Se,Be),registerFileDecorationProvider(fe){return Lt.registerFileDecorationProvider(fe,Ue)},registerUriHandler(fe){return vn.registerUriHandler(Ue,fe)},createQuickPick(){return kn.createQuickPick(Ue)},createInputBox(){return kn.createInputBox(Ue)},get activeColorTheme(){return jn.activeColorTheme},onDidChangeActiveColorTheme(fe,Se,Be){return ot(jn.onDidChangeActiveColorTheme)(fe,Se,Be)},registerWebviewViewProvider(fe,Se,Be){return Bn.registerWebviewViewProvider(Ue,fe,Se,Be?.webviewOptions)},get activeNotebookEditor(){return Oe.activeNotebookEditor},onDidChangeActiveNotebookEditor(fe,Se,Be){return ot(Oe.onDidChangeActiveNotebookEditor)(fe,Se,Be)},get visibleNotebookEditors(){return Oe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Oe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(fe,Se,Be){return ot(Ee.onDidChangeNotebookEditorSelection)(fe,Se,Be)},onDidChangeNotebookEditorVisibleRanges(fe,Se,Be){return ot(Ee.onDidChangeNotebookEditorVisibleRanges)(fe,Se,Be)},showNotebookDocument(fe,Se){return Oe.showNotebookDocument(fe,Se)},registerExternalUriOpener(fe,Se,Be){return(0,xe.$LG)(Ue,"externalUriOpener"),Yn.registerExternalUriOpener(Ue.identifier,fe,Se,Be)},registerProfileContentHandler(fe,Se){return(0,xe.$LG)(Ue,"profileContentHandlers"),Zn.registerProfileContentHandler(Ue,fe,Se)},registerQuickDiffProvider(fe,Se,Be,ct){return(0,xe.$LG)(Ue,"quickDiffProvider"),Xn.registerQuickDiffProvider(vt(fe),Se,Be,ct)},get tabGroups(){return Gt.tabGroups},registerShareProvider(fe,Se){return(0,xe.$LG)(Ue,"shareProvider"),On.registerShareProvider(vt(fe),Se)}},Hn={get rootPath(){return Mt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(fe){throw new O.$9("rootPath")},getWorkspaceFolder(fe){return gt.getWorkspaceFolder(fe)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(fe){throw new O.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(fe){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(fe,Se,...Be)=>gt.updateWorkspaceFolders(Ue,fe,Se||0,...Be),onDidChangeWorkspaceFolders:function(fe,Se,Be){return ot(gt.onDidChangeWorkspace)(fe,Se,Be)},asRelativePath:(fe,Se)=>gt.getRelativePath(fe,Se),findFiles:(fe,Se,Be,ct)=>gt.findFiles(fe,Se,Be,Ue.identifier,ct),findFiles2:(fe,Se,Be)=>((0,xe.$LG)(Ue,"findFiles2"),gt.findFiles2(fe,Se,Ue.identifier,Be)),findTextInFiles:(fe,Se,Be,ct)=>{(0,xe.$LG)(Ue,"findTextInFiles");let yt,Rt;return typeof Se=="object"?(yt=Se,Rt=Be):(yt={},Rt=Se,ct=Be),gt.findTextInFiles(fe,yt||{},Rt,Ue.identifier,ct)},save:fe=>gt.save(fe),saveAs:fe=>gt.saveAs(fe),saveAll:fe=>gt.saveAll(fe),applyEdit(fe,Se){return $i.applyWorkspaceEdit(fe,Ue,Se)},createFileSystemWatcher:(fe,Se,Be,ct)=>{let yt;return typeof Se=="boolean"?yt={ignoreCreateEvents:!!Se,ignoreChangeEvents:!!Be,ignoreDeleteEvents:!!ct,correlate:!1}:Se&&((0,xe.$LG)(Ue,"createFileSystemWatcher"),yt={...Se,correlate:!0}),zt.createFileSystemWatcher(gt,Ue,fe,yt)},get textDocuments(){return At.getAllDocumentData().map(fe=>fe.document)},set textDocuments(fe){throw new O.$9("textDocuments")},openTextDocument(fe){let Se;const Be=fe;if(typeof fe=="string")Se=Promise.resolve($.URI.file(fe));else if($.URI.isUri(fe))Se=Promise.resolve(fe);else if(!Be||typeof Be=="object")Se=At.createDocumentData(Be);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(ct=>(ct.scheme===M.Schemas.vscodeRemote&&!ct.authority&&Mt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),At.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(fe,Se,Be)=>ot(At.onDidAddDocument)(fe,Se,Be),onDidCloseTextDocument:(fe,Se,Be)=>ot(At.onDidRemoveDocument)(fe,Se,Be),onDidChangeTextDocument:(fe,Se,Be)=>ot(At.onDidChangeDocument)(fe,Se,Be),onDidSaveTextDocument:(fe,Se,Be)=>ot(At.onDidSaveDocument)(fe,Se,Be),onWillSaveTextDocument:(fe,Se,Be)=>ot(sn.getOnWillSaveTextDocumentEvent(Ue))(fe,Se,Be),get notebookDocuments(){return Oe.notebookDocuments.map(fe=>fe.apiNotebook)},async openNotebookDocument(fe,Se){let Be;if($.URI.isUri(fe))Be=fe,await Oe.openNotebookDocument(fe);else if(typeof fe=="string")Be=$.URI.revive(await Oe.createNotebookDocument({viewType:fe,content:Se}));else throw new Error("Invalid arguments");return Oe.getNotebookDocument(Be).apiNotebook},onDidSaveNotebookDocument(fe,Se,Be){return ot(Fe.onDidSaveNotebookDocument)(fe,Se,Be)},onDidChangeNotebookDocument(fe,Se,Be){return ot(Fe.onDidChangeNotebookDocument)(fe,Se,Be)},onWillSaveNotebookDocument(fe,Se,Be){return ot(He.getOnWillSaveNotebookDocumentEvent(Ue))(fe,Se,Be)},get onDidOpenNotebookDocument(){return ot(Oe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Oe.onDidCloseNotebookDocument)},registerNotebookSerializer(fe,Se,Be,ct){return Oe.registerNotebookSerializer(Ue,fe,Se,Be,(0,xe.$KG)(Ue,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(fe,Se,Be)=>ot(Vn.onDidChangeConfiguration)(fe,Se,Be),getConfiguration(fe,Se){return Se=arguments.length===1?void 0:Se,Vn.getConfiguration(fe,Se,Ue)},registerTextDocumentContentProvider(fe,Se){return En.registerTextDocumentContentProvider(fe,Se)},registerTaskProvider:(fe,Se)=>(Mt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),rn.registerTaskProvider(Ue,fe,Se)),registerFileSystemProvider(fe,Se,Be){return(0,A.$Rc)(Tt.registerFileSystemProvider(Ue,fe,Se,Be),Qt.addFileSystemProvider(fe,Se,Be))},get fs(){return Qt.value},registerFileSearchProvider:(fe,Se)=>((0,xe.$LG)(Ue,"fileSearchProvider"),gn.registerFileSearchProvider(fe,Se)),registerTextSearchProvider:(fe,Se)=>((0,xe.$LG)(Ue,"textSearchProvider"),gn.registerTextSearchProvider(fe,Se)),registerAITextSearchProvider:(fe,Se)=>((0,xe.$LG)(Ue,"aiTextSearchProvider"),(0,xe.$LG)(Ue,"textSearchProvider"),gn.registerAITextSearchProvider(fe,Se)),registerRemoteAuthorityResolver:(fe,Se)=>((0,xe.$LG)(Ue,"resolvers"),jt.registerRemoteAuthorityResolver(fe,Se)),registerResourceLabelFormatter:fe=>((0,xe.$LG)(Ue,"resolvers"),Tn.$registerResourceLabelFormatter(fe)),getRemoteExecServer:fe=>((0,xe.$LG)(Ue,"resolvers"),jt.getRemoteExecServer(fe)),onDidCreateFiles:(fe,Se,Be)=>ot(zt.onDidCreateFile)(fe,Se,Be),onDidDeleteFiles:(fe,Se,Be)=>ot(zt.onDidDeleteFile)(fe,Se,Be),onDidRenameFiles:(fe,Se,Be)=>ot(zt.onDidRenameFile)(fe,Se,Be),onWillCreateFiles:(fe,Se,Be)=>ot(zt.getOnWillCreateFileEvent(Ue))(fe,Se,Be),onWillDeleteFiles:(fe,Se,Be)=>ot(zt.getOnWillDeleteFileEvent(Ue))(fe,Se,Be),onWillRenameFiles:(fe,Se,Be)=>ot(zt.getOnWillRenameFileEvent(Ue))(fe,Se,Be),openTunnel:fe=>((0,xe.$LG)(Ue,"tunnels"),Vt.openTunnel(Ue,fe).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,xe.$LG)(Ue,"tunnels"),Vt.getTunnels()},onDidChangeTunnels:(fe,Se,Be)=>((0,xe.$LG)(Ue,"tunnels"),ot(Vt.onDidChangeTunnels)(fe,Se,Be)),registerPortAttributesProvider:(fe,Se)=>((0,xe.$LG)(Ue,"portsAttributes"),Vt.registerPortsAttributesProvider(fe,Se)),registerTunnelProvider:(fe,Se)=>((0,xe.$LG)(Ue,"tunnelFactory"),Vt.registerTunnelProvider(fe,Se)),registerTimelineProvider:(fe,Se)=>((0,xe.$LG)(Ue,"timeline"),Qn.registerTimelineProvider(fe,Se,Ue.identifier,pt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:fe=>((0,xe.$LG)(Ue,"workspaceTrust"),gt.requestWorkspaceTrust(fe)),onDidGrantWorkspaceTrust:(fe,Se,Be)=>ot(gt.onDidGrantWorkspaceTrust)(fe,Se,Be),registerEditSessionIdentityProvider:(fe,Se)=>((0,xe.$LG)(Ue,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(fe,Se)),onWillCreateEditSessionIdentity:(fe,Se,Be)=>((0,xe.$LG)(Ue,"editSessionIdentityProvider"),ot(gt.getOnWillCreateEditSessionIdentityEvent(Ue))(fe,Se,Be)),registerCanonicalUriProvider:(fe,Se)=>((0,xe.$LG)(Ue,"canonicalUriProvider"),gt.registerCanonicalUriProvider(fe,Se)),getCanonicalUri:(fe,Se,Be)=>((0,xe.$LG)(Ue,"canonicalUriProvider"),gt.provideCanonicalUri(fe,Se,Be))},ri={get inputBox(){return Mt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Pn.getLastInputBox(Ue)},createSourceControl(fe,Se,Be){return Pn.createSourceControl(Ue,fe,Se,Be)}},bi={createCommentController(fe,Se){return Nn.createCommentController(Ue,fe,Se)}},si={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){return Dt.activeStackItem},registerDebugVisualizationProvider(fe,Se){return(0,xe.$LG)(Ue,"debugVisualization"),Dt.registerDebugVisualizationProvider(Ue,fe,Se)},registerDebugVisualizationTreeProvider(fe,Se){return(0,xe.$LG)(Ue,"debugVisualization"),Dt.registerDebugVisualizationTree(Ue,fe,Se)},onDidStartDebugSession(fe,Se,Be){return ot(Dt.onDidStartDebugSession)(fe,Se,Be)},onDidTerminateDebugSession(fe,Se,Be){return ot(Dt.onDidTerminateDebugSession)(fe,Se,Be)},onDidChangeActiveDebugSession(fe,Se,Be){return ot(Dt.onDidChangeActiveDebugSession)(fe,Se,Be)},onDidReceiveDebugSessionCustomEvent(fe,Se,Be){return ot(Dt.onDidReceiveDebugSessionCustomEvent)(fe,Se,Be)},onDidChangeBreakpoints(fe,Se,Be){return ot(Dt.onDidChangeBreakpoints)(fe,Se,Be)},onDidChangeActiveStackItem(fe,Se,Be){return ot(Dt.onDidChangeActiveStackItem)(fe,Se,Be)},registerDebugConfigurationProvider(fe,Se,Be){return Dt.registerDebugConfigurationProvider(fe,Se,Be||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(fe,Se){return Dt.registerDebugAdapterDescriptorFactory(Ue,fe,Se)},registerDebugAdapterTrackerFactory(fe,Se){return Dt.registerDebugAdapterTrackerFactory(fe,Se)},startDebugging(fe,Se,Be){return!Be||typeof Be=="object"&&"configuration"in Be?Dt.startDebugging(fe,Se,{parentSession:Be}):Dt.startDebugging(fe,Se,Be||{})},stopDebugging(fe){return Dt.stopDebugging(fe)},addBreakpoints(fe){return Dt.addBreakpoints(fe)},removeBreakpoints(fe){return Dt.removeBreakpoints(fe)},asDebugSourceUri(fe,Se){return Dt.asDebugSourceUri(fe,Se)}},oi={registerTaskProvider:(fe,Se)=>rn.registerTaskProvider(Ue,fe,Se),fetchTasks:fe=>rn.fetchTasks(fe),executeTask:fe=>rn.executeTask(Ue,fe),get taskExecutions(){return rn.taskExecutions},onDidStartTask:(fe,Se,Be)=>ot(rn.onDidStartTask)(fe,Se,Be),onDidEndTask:(fe,Se,Be)=>ot(rn.onDidEndTask)(fe,Se,Be),onDidStartTaskProcess:(fe,Se,Be)=>ot(rn.onDidStartTaskProcess)(fe,Se,Be),onDidEndTaskProcess:(fe,Se,Be)=>ot(rn.onDidEndTaskProcess)(fe,Se,Be)},wi={createNotebookController(fe,Se,Be,ct,yt){return x.createNotebookController(Ue,fe,Se,Be,ct,(0,xe.$KG)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(fe,Se)=>Oe.registerNotebookCellStatusBarItemProvider(Ue,fe,Se),createRendererMessaging(fe){return je.createRendererMessaging(Ue,fe)},createNotebookControllerDetectionTask(fe){return(0,xe.$LG)(Ue,"notebookKernelSource"),x.createNotebookControllerDetectionTask(Ue,fe)},registerKernelSourceActionProvider(fe,Se){return(0,xe.$LG)(Ue,"notebookKernelSource"),x.registerKernelSourceActionProvider(Ue,fe,Se)},onDidChangeNotebookCellExecutionState(fe,Se,Be){return(0,xe.$LG)(Ue,"notebookCellExecutionState"),ot(x.onDidChangeNotebookCellExecutionState)(fe,Se,Be)}},vi={t(...fe){if(typeof fe[0]=="string"){const Se=fe.shift(),Be=!fe||typeof fe[0]!="object"?fe:fe[0];return hn.getMessage(Ue.identifier.value,{message:Se,args:Be})}return hn.getMessage(Ue.identifier.value,fe[0])},get bundle(){return hn.getBundle(Ue.identifier.value)},get uri(){return hn.getBundleUri(Ue.identifier.value)}},ai={_version:1,transferActiveChat(fe){return(0,xe.$LG)(Ue,"interactive"),Rn.transferActiveChat(fe)}},Gn={getRelatedInformation(fe,Se){return(0,xe.$LG)(Ue,"aiRelatedInformation"),Un.getRelatedInformation(Ue,fe,Se)},registerRelatedInformationProvider(fe,Se){return(0,xe.$LG)(Ue,"aiRelatedInformation"),Un.registerRelatedInformationProvider(Ue,fe,Se)},registerEmbeddingVectorProvider(fe,Se){return(0,xe.$LG)(Ue,"aiRelatedInformation"),gi.registerEmbeddingVectorProvider(Ue,fe,Se)}},ci={_version:1,registerChatResponseProvider(fe,Se,Be){return(0,xe.$LG)(Ue,"chatProvider"),Kt.registerLanguageModel(Ue,fe,Se,Be)},registerChatVariableResolver(fe,Se,Be){return(0,xe.$LG)(Ue,"chatVariableResolver"),xn.registerVariableResolver(Ue,fe,Se,Be)},registerMappedEditsProvider(fe,Se){return(0,xe.$LG)(Ue,"mappedEditsProvider"),lt.registerMappedEditsProvider(Ue,fe,Se)},createChatParticipant(fe,Se){return(0,xe.$LG)(Ue,"chatParticipant"),Rn.createChatAgent(Ue,fe,Se)},createDynamicChatParticipant(fe,Se,Be){return(0,xe.$LG)(Ue,"chatParticipantAdditions"),Rn.createDynamicChatAgent(Ue,fe,Se,Be)}},ui={selectChatModels:fe=>((0,xe.$LG)(Ue,"languageModels"),Kt.selectLanguageModels(Ue,fe??{})),onDidChangeChatModels:(fe,Se,Be)=>((0,xe.$LG)(Ue,"languageModels"),Kt.onDidChangeProviders(fe,Se,Be)),get embeddingModels(){return(0,xe.$LG)(Ue,"embeddings"),bn.embeddingsModels},onDidChangeEmbeddingModels:(fe,Se,Be)=>((0,xe.$LG)(Ue,"embeddings"),bn.onDidChange(fe,Se,Be)),registerEmbeddingsProvider(fe,Se){return(0,xe.$LG)(Ue,"embeddings"),bn.registerEmbeddingsProvider(Ue,fe,Se)},async computeEmbeddings(fe,Se,Be){return(0,xe.$LG)(Ue,"embeddings"),bn.computeEmbeddings(fe,Se,Be)}},li={registerSpeechProvider(fe,Se){return(0,xe.$LG)(Ue,"speech"),Wn.registerProvider(Ue.identifier,fe,Se)}};return{version:$t.version,ai:Gn,authentication:ti,commands:mn,comments:bi,chat:ci,debug:si,env:Dn,extensions:Ln,interactive:ai,l10n:vi,languages:ni,lm:ui,notebooks:wi,scm:ri,speech:li,tasks:oi,tests:pi,window:ii,workspace:Hn,Breakpoint:Le.$mN,TerminalOutputAnchor:Le.TerminalOutputAnchor,ChatResultFeedbackKind:Le.ChatResultFeedbackKind,ChatVariableLevel:Le.ChatVariableLevel,ChatCompletionItem:Le.$hO,CallHierarchyIncomingCall:Le.$KM,CallHierarchyItem:Le.$JM,CallHierarchyOutgoingCall:Le.$LM,CancellationError:O.$5,CancellationTokenSource:l.$qe,CandidatePortSource:i.CandidatePortSource,CodeAction:Le.$GM,CodeActionKind:Le.$HM,CodeActionTriggerKind:Le.CodeActionTriggerKind,CodeLens:Le.$MM,Color:Le.$ZM,ColorInformation:Le.$1M,ColorPresentation:Le.$2M,ColorThemeKind:Le.ColorThemeKind,CommentMode:Le.CommentMode,CommentState:Le.CommentState,CommentThreadCollapsibleState:Le.CommentThreadCollapsibleState,CommentThreadState:Le.CommentThreadState,CommentThreadApplicability:Le.CommentThreadApplicability,CompletionItem:Le.$TM,CompletionItemKind:Le.CompletionItemKind,CompletionItemTag:Le.CompletionItemTag,CompletionList:Le.$UM,CompletionTriggerKind:Le.CompletionTriggerKind,ConfigurationTarget:Le.ConfigurationTarget,CustomExecution:Le.$0M,DebugAdapterExecutable:Le.$qN,DebugAdapterInlineImplementation:Le.$tN,DebugAdapterNamedPipeServer:Le.$sN,DebugAdapterServer:Le.$rN,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Le.DebugConsoleMode,DebugVisualization:Le.$JN,DecorationRangeBehavior:Le.DecorationRangeBehavior,Diagnostic:Le.$zM,DiagnosticRelatedInformation:Le.$yM,DiagnosticSeverity:Le.DiagnosticSeverity,DiagnosticTag:Le.DiagnosticTag,Disposable:Le.$lM,DocumentHighlight:Le.$CM,DocumentHighlightKind:Le.DocumentHighlightKind,MultiDocumentHighlight:Le.$DM,DocumentLink:Le.$YM,DocumentSymbol:Le.$FM,EndOfLine:Le.EndOfLine,EnvironmentVariableMutatorType:Le.EnvironmentVariableMutatorType,EvaluatableExpression:Le.$wN,InlineValueText:Le.$xN,InlineValueVariableLookup:Le.$yN,InlineValueEvaluatableExpression:Le.$zN,InlineCompletionTriggerKind:Le.InlineCompletionTriggerKind,EventEmitter:L.$fe,ExtensionKind:Le.ExtensionKind,ExtensionMode:Le.ExtensionMode,ExternalUriOpenerPriority:Le.ExternalUriOpenerPriority,FileChangeType:Le.FileChangeType,FileDecoration:Le.$LN,FileDecoration2:Le.$LN,FileSystemError:Le.$CN,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Le.$DN,FoldingRangeKind:Le.FoldingRangeKind,FunctionBreakpoint:Le.$oN,InlineCompletionItem:Le.$VM,InlineCompletionList:Le.$WM,Hover:Le.$AM,VerboseHover:Le.$BM,HoverVerbosityAction:Le.HoverVerbosityAction,IndentAction:P.IndentAction,Location:Le.$xM,MarkdownString:Le.$NM,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Le.$OM,PortAutoForwardAction:Le.PortAutoForwardAction,Position:Le.$mM,ProcessExecution:Le.$8M,ProgressLocation:Le.ProgressLocation,QuickInputButtons:Le.$KN,Range:Le.$nM,RelativePattern:Le.$kN,Selection:Le.$oM,SelectionRange:Le.$IM,SemanticTokens:Le.$GN,SemanticTokensBuilder:Le.$FN,SemanticTokensEdit:Le.$HN,SemanticTokensEdits:Le.$IN,SemanticTokensLegend:Le.$EN,ShellExecution:Le.$9M,ShellQuoting:Le.ShellQuoting,SignatureHelp:Le.$QM,SignatureHelpTriggerKind:Le.SignatureHelpTriggerKind,SignatureInformation:Le.$PM,SnippetString:Le.$wM,SourceBreakpoint:Le.$nN,StandardTokenType:Le.StandardTokenType,StatusBarAlignment:Le.StatusBarAlignment,SymbolInformation:Le.$EM,SymbolKind:Le.SymbolKind,SymbolTag:Le.SymbolTag,Task:Le.$$M,TaskGroup:Le.$7M,TaskPanelKind:Le.TaskPanelKind,TaskRevealKind:Le.TaskRevealKind,TaskScope:Le.TaskScope,TerminalLink:Le.$3M,TerminalQuickFixTerminalCommand:Le.$5M,TerminalQuickFixOpener:Le.$4M,TerminalLocation:Le.TerminalLocation,TerminalProfile:Le.$6M,TerminalExitReason:Le.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Le.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Le.TextDocumentSaveReason,TextEdit:Le.$sM,SnippetTextEdit:Le.$uM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Le.TextEditorLineNumbersStyle,TextEditorRevealType:Le.TextEditorRevealType,TextEditorSelectionChangeKind:Le.TextEditorSelectionChangeKind,SyntaxTokenType:Le.SyntaxTokenType,TextDocumentChangeReason:Le.TextDocumentChangeReason,ThemeColor:Le.$jN,ThemeIcon:Le.$iN,TreeItem:Le.$_M,TreeItemCheckboxState:Le.TreeItemCheckboxState,TreeItemCollapsibleState:Le.TreeItemCollapsibleState,TypeHierarchyItem:Le.$8N,UIKind:xt.UIKind,Uri:$.URI,ViewColumn:Le.ViewColumn,WorkspaceEdit:Le.$vM,DocumentPasteTriggerKind:Le.DocumentPasteTriggerKind,DocumentDropEdit:Le.$fN,DocumentDropOrPasteEditKind:Le.$gN,DocumentPasteEdit:Le.$hN,InlayHint:Le.$SM,InlayHintLabelPart:Le.$RM,InlayHintKind:Le.InlayHintKind,RemoteAuthorityResolverError:Le.$rM,ResolvedAuthority:Le.$pM,ManagedResolvedAuthority:Le.$qM,SourceControlInputBoxValidationType:Le.SourceControlInputBoxValidationType,ExtensionRuntime:Le.ExtensionRuntime,TimelineItem:Le.$VN,NotebookRange:Le.$NN,NotebookCellKind:Le.NotebookCellKind,NotebookCellExecutionState:Le.NotebookCellExecutionState,NotebookCellData:Le.$ON,NotebookData:Le.$PN,NotebookRendererScript:Le.$TN,NotebookCellStatusBarAlignment:Le.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Le.NotebookEditorRevealType,NotebookCellOutput:Le.$RN,NotebookCellOutputItem:Le.$QN,NotebookCellStatusBarItem:Le.$SN,NotebookControllerAffinity:Le.NotebookControllerAffinity,NotebookControllerAffinity2:Le.NotebookControllerAffinity2,NotebookEdit:Le.$tM,NotebookKernelSourceAction:Le.$UN,NotebookVariablesRequestKind:Le.NotebookVariablesRequestKind,PortAttributes:Le.$XN,LinkedEditingRanges:Le.$WN,TestResultState:Le.TestResultState,TestRunRequest:Le.$YN,TestMessage:Le.$ZN,TestTag:Le.$1N,TestRunProfileKind:Le.TestRunProfileKind,TextSearchCompleteMessageType:on.TextSearchCompleteMessageType,DataTransfer:Le.$eN,DataTransferItem:Le.$aN,TestCoverageCount:Le.$2N,FileCoverage:Le.$4N,FileCoverage2:Le.$4N,StatementCoverage:Le.$5N,BranchCoverage:Le.$6N,DeclarationCoverage:Le.$7N,WorkspaceTrustState:Le.WorkspaceTrustState,LanguageStatusSeverity:Le.LanguageStatusSeverity,QuickPickItemKind:Le.QuickPickItemKind,InputBoxValidationSeverity:Le.InputBoxValidationSeverity,TabInputText:Le.$9N,TabInputTextDiff:Le.$0N,TabInputTextMerge:Le.$$N,TabInputCustom:Le.$_N,TabInputNotebook:Le.$bO,TabInputNotebookDiff:Le.$cO,TabInputWebview:Le.$aO,TabInputTerminal:Le.$dO,TabInputInteractiveWindow:Le.$eO,TabInputChat:Le.$fO,TabInputTextMultiDiff:Le.$gO,TelemetryTrustedValue:a.$jp,LogLevel:d.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Le.InteractiveSessionVoteDirection,ChatCopyKind:Le.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Le.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Le.$uN,DebugThread:Le.$vN,RelatedInformationType:Le.RelatedInformationType,SpeechToTextStatus:Le.SpeechToTextStatus,TextToSpeechStatus:Le.TextToSpeechStatus,PartialAcceptTriggerKind:Le.PartialAcceptTriggerKind,KeywordRecognitionStatus:Le.KeywordRecognitionStatus,ChatResponseMarkdownPart:Le.$iO,ChatResponseFileTreePart:Le.$mO,ChatResponseAnchorPart:Le.$nO,ChatResponseProgressPart:Le.$oO,ChatResponseProgressPart2:Le.$pO,ChatResponseReferencePart:Le.$sO,ChatResponseWarningPart:Le.$qO,ChatResponseTextEditPart:Le.$tO,ChatResponseMarkdownWithVulnerabilitiesPart:Le.$jO,ChatResponseCommandButtonPart:Le.$rO,ChatResponseDetectedParticipantPart:Le.$kO,ChatResponseConfirmationPart:Le.$lO,ChatRequestTurn:Le.$uO,ChatResponseTurn:Le.$vO,ChatLocation:Le.ChatLocation,LanguageModelChatMessageRole:Le.LanguageModelChatMessageRole,LanguageModelChatMessage:Le.$wO,LanguageModelChatMessage2:Le.$wO,LanguageModelChatSystemMessage:Le.$xO,LanguageModelChatUserMessage:Le.$yO,LanguageModelChatAssistantMessage:Le.$zO,LanguageModelError:Le.$AO,NewSymbolName:Le.$BN,NewSymbolNameTag:Le.NewSymbolNameTag,NewSymbolNameTriggerKind:Le.NewSymbolNameTriggerKind,InlineEdit:Le.$BO,InlineEditTriggerKind:Le.InlineEditTriggerKind}}}}),define(ke[385],De([1,0,85,158,44,152,45,34,73,43,95,96,97,119,71,91,151,70,60,118,90,72,150,11,61,116,117,121,122,156]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c,r,t,u,s,o,h,g,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$Bs)(o.$Xmc,o.$Wmc,1),(0,l.$Bs)(u.$6j,t.$$nc,1),(0,l.$Bs)(d.$3lc,d.$4lc,1),(0,l.$Bs)(b.$0O,b.$9O,0),(0,l.$Bs)(g.$amc,g.$bmc,0),(0,l.$Bs)(w.$Rmc,w.$Smc,0),(0,l.$Bs)(M.$pmc,M.$nmc,0),(0,l.$Bs)(a.$rmc,a.$qmc,0),(0,l.$Bs)(P.$8mc,P.$_mc,0),(0,l.$Bs)(A.$bnc,A.$anc,0),(0,l.$Bs)($.$YO,$.$XO,0),(0,l.$Bs)(h.$Ymc,h.$Zmc,0),(0,l.$Bs)(n.$7lc,n.$6lc,0),(0,l.$Bs)(O.$Gnc,O.$Fnc,1),(0,l.$Bs)(p.$rnc,p.$snc,0),(0,l.$Bs)(S.$Kmc,S.$Jmc,0),(0,l.$Bs)(I.$Tnc,I.$Snc,0),(0,l.$Bs)(E.$Nmc,E.$Qmc,0),(0,l.$Bs)(k.$Unc,k.$Vnc,0),(0,l.$Bs)(v.$UDb,v.$VDb,0),(0,l.$Bs)(f.$9nc,f.$8nc,0),(0,l.$Bs)(L.$mmc,L.$lmc,0),(0,l.$Bs)(i.$Umc,i.$Tmc,0),(0,l.$Bs)(c.$8O,c.$5O,0),(0,l.$Bs)(r.$Bmc,r.$Cmc,0),(0,l.$Bs)(s.$6mc,s.$7mc,0)}),define(ke[123],De([1,0,19,11,37,94]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0,e.$ooc=M,e.$poc=b;function M(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}function b(P,p,S,v){const d=(0,l.$1b)(S,$),f=new L.$BK(p,d,v),a=f.preview.matches;return{ranges:(0,l.$1b)(d,E),uri:P,preview:{text:f.preview.text,matches:(0,l.$1b)(a,E)}}}function $(P){return new L.$CK(P.start.line,P.start.character,P.end.line,P.end.character)}function E(P){return new A.$qK(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let I=class{constructor(p,S){this.a=p,this.b=S}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$qoc=I,e.$qoc=I=Je([We(1,O.$5j)],I)}),define(ke[386],De([1,0,54,16,77,31,12,14,123,387]),function(he,e,l,O,L,A,M,b,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=P,e.$soc=f,e.$toc=n;const I=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(i,c,r,t){const u=p(i,c,r,t),s=c.folder.fsPath;return{cmd:l.spawn(I,u.args,{cwd:s}),rgDiskPath:I,siblingClauses:u.siblingClauses,rgArgs:u,cwd:s}}function p(i,c,r,t){const u=["--files","--hidden","--case-sensitive","--no-require-git"];v([c],r,!1).forEach(o=>{const h=(0,$.$ooc)(o);if(u.push("-g",h),M.$j){const g=(0,L.$em)(h);g!==h&&u.push("-g",g)}});const s=S([c],t,void 0,!1);return s.globArgs.forEach(o=>{const h=`!${(0,$.$ooc)(o)}`;if(u.push("-g",h),M.$j){const g=(0,L.$em)(h);g!==h&&u.push("-g",g)}}),c.disregardIgnoreFiles!==!1?u.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),c.ignoreSymlinks||u.push("--follow"),i.exists&&u.push("--quiet"),u.push("--no-config"),c.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:s.siblingClauses}}function S(i,c,r,t=!0){const u=[];let s={};return i.forEach(o=>{const h=Object.assign({},o.excludePattern||{},c||{}),g=d(h,t?o.folder.fsPath:void 0,r);u.push(...g.globArgs),g.siblingClauses&&(s=Object.assign(s,g.siblingClauses))}),{globArgs:u,siblingClauses:s}}function v(i,c,r=!0){const t=[];return i.forEach(u=>{const s=Object.assign({},c||{},u.includePattern||{}),o=d(s,r?u.folder.fsPath:void 0);t.push(...o.globArgs)}),t}function d(i,c,r){const t=[],u={};return Object.keys(i).forEach(s=>{if(r&&r.has(s)||!s)return;const o=i[s];s=a(c?f(c,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof o=="boolean"&&o?(s.startsWith("\\\\")&&(s+="**"),t.push(n(s))):o&&o.when&&(u[s]=o)}),{globArgs:t,siblingClauses:u}}function f(i,c){return O.$ic(c)?c:O.$jc(i,c)}function a(i){return i=b.$hf(i,"\\"),b.$hf(i,"/")}function n(i){return A.$tg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[388],De([1,0,54,53,16,389,19,47,35,77,31,12,40,14,18,32,37,386,133]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=e.$uoc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(s=>s())});class c{constructor(o){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=o,this.b=o.filePattern||"",this.d=o.includePattern&&$.$sk(o.includePattern),this.f=o.maxResults||null,this.g=!!o.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=o.shouldGlobMatchFilePattern?null:(0,n.$Br)(this.b).normalizedLowercase),this.u=o.excludePattern&&$.$sk(o.excludePattern),this.t=new Map,o.folderQueries.forEach(h=>{const g=Object.assign({},h.excludePattern||{},this.a.excludePattern||{}),w=h.folder.fsPath;o.folderQueries.map(k=>k.folder.fsPath).filter(k=>k!==w).forEach(k=>{(0,I.$xg)(k,w)&&(g[L.$lc(w,k)]=!0)}),this.t.set(w,new t(g,w))})}cancel(){this.l=!0,i.forEach(o=>o())}walk(o,h,g,w,k){if(this.m=p.$be.create(!1),this.l)return k(null,this.j);h.forEach(m=>{const y=L.$nc(m.fsPath);this.u&&this.u(m.fsPath,y)||this.J(g,{relativePath:m.fsPath,searchPath:void 0})}),this.r=p.$be.create(!1),this.w(o,(m,y)=>{this.x(this.y,this,m,g,w,D=>{if(D){const C=(0,b.$jj)(D);console.error(C),this.q.push(C),y(D,void 0)}else y(null,void 0)})},(m,y)=>{this.m.stop();const D=m?M.$Hb(m)[0]:null;k(D,this.j)})}w(o,h,g){const w=new Array(o.length),k=new Array(o.length);let m=!1,y=0;if(o.length===0)return g(null,[]);o.forEach((D,C)=>{h(D,(R,T)=>{if(R?(m=!0,w[C]=null,k[C]=R):(w[C]=T,k[C]=null),++y===o.length)return g(m?k:null,w)})})}x(o,h,...g){try{o.apply(h,g)}catch(w){g[g.length-1](w)}}y(o,h,g,w){const k=o.folder.fsPath,m=P.$j,y=()=>j&&j.kill();i.add(y);let D=B=>{i.delete(y),D=()=>{},w(B)},C="";const R=this.D(),T=(0,a.$roc)(this.a,o,this.a.includePattern,this.t.get(o.folder.fsPath).expression),j=T.cmd,z=!Object.keys(T.siblingClauses).length,N=T.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let F=`${T.rgDiskPath} ${N}
 - cwd: ${T.cwd}`;T.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(T.rgArgs.siblingClauses)}`),g({message:F}),this.s=0,this.z(j,"utf8",g,(B,Y,re)=>{if(B){D(B);return}if(this.j){D();return}const K=(C+(m?E.$dm(Y||""):Y)).split(`
`);if(re){const _=K.length;K[_-1]=K[_-1].trim(),K[_-1]||K.pop()}else C=K.pop()||"";if(K.length&&K[0].indexOf(`
`)!==-1){D(new Error("Splitting up files failed"));return}if(this.s+=K.length,z){for(const _ of K)if(this.J(h,{base:k,relativePath:_,searchPath:this.N(o,_)}),this.j){y();break}(re||this.j)&&D();return}this.G(o,R,k,K,h),re&&(this.H(R,k,h),D())})}spawnFindCmd(o){const h=this.t.get(o.folder.fsPath),g=h.getBasenameTerms(),w=h.getPathTerms(),k=["-L","."];if(g.length||w.length){k.push("-not","(","(");for(const m of g)k.push("-name",m),k.push("-o");for(const m of w)k.push("-path",m),k.push("-o");k.pop(),k.push(")","-prune",")")}return k.push("-type","f"),l.spawn("find",k,{cwd:o.folder.fsPath})}readStdout(o,h,g){let w="";this.z(o,h,()=>{},(k,m,y)=>{if(k){g(k);return}w+=m,y&&g(null,w)})}z(o,h,g,w){let k=(D,C,R)=>{(D||R)&&(k=()=>{},this.r?.stop()),w(D,C,R)},m=!1;o.stdout?(this.A(o.stdout,h,k),o.stdout.once("data",()=>m=!0)):g({message:"stdout is null"});let y;o.stderr?y=this.B(o.stderr):g({message:"stderr is null"}),o.on("error",D=>{k(D)}),o.on("close",D=>{let C;!m&&(C=this.C(y,h))&&u(C)?k(new Error(`command failed with error code ${D}: ${this.C(y,h)}`)):(this.g&&D===0&&(this.j=!0),k(null,"",!0))})}A(o,h,g){const w=new A.StringDecoder(h);return o.on("data",k=>{g(null,w.write(k))}),w}B(o){const h=[];return o.on("data",g=>{h.push(g)}),h}C(o,h){const g=new A.StringDecoder(h);return o.map(w=>g.write(w)).join("")}D(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}G(o,{pathToEntries:h},g,w,k){w.indexOf(this.b)!==-1&&this.J(k,{base:g,relativePath:this.b,searchPath:this.N(o,this.b)});const m=y=>{const D=L.$nc(y),C=L.$mc(y);let R=h[C];R||(R=h[C]=[],m(C)),R.push({base:g,relativePath:y,basename:D,searchPath:this.N(o,y)})};w.forEach(m)}H({rootEntries:o,pathToEntries:h},g,w){const k=this,m=this.t.get(g),y=this.b;function D(C){k.o++;const R=(0,f.$RK)(()=>C.map(T=>T.basename));for(let T=0,j=C.length;T<j;T++){const z=C[T],{relativePath:N,basename:F}=z;if(m.test(N,F,y!==F?R:void 0))continue;const B=h[N];if(B)D(B);else{if(k.p++,N===y)continue;k.J(w,z)}if(k.j)break}}D(o)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(o,h,g,w,k){const m=o.folder,y=(0,f.$RK)(()=>g);this.w(g,(D,C)=>{if(this.l||this.j)return C(null);const R=h?[h,D].join(L.sep):D;if(this.t.get(o.folder.fsPath).test(R,D,this.a.filePattern!==D?y:void 0))return C(null);const T=[m.fsPath,R].join(L.sep);O.lstat(T,(j,z)=>{if(j||this.l||this.j)return C(null);this.L(T,z,(N,F)=>N||this.l||this.j?C(null):F.isDirectory()?(this.o++,this.M(T,z,(B,Y)=>B||this.l||this.j||(Y=Y||"",this.v[Y])?C(null):(this.v[Y]=!0,d.Promises.readdir(T).then(re=>{if(this.l||this.j)return C(null);this.I(o,R,re,w,H=>C(H||null))},re=>{C(null)})))):(this.p++,R===this.b||this.h&&v.$cg(F.size)&&F.size>this.h||this.J(w,{base:m.fsPath,relativePath:R,searchPath:this.N(o,R)}),C(null,void 0)))})},D=>{const C=D&&M.$Hb(D);return k(C&&C.length>0?C[0]:void 0)})}J(o,h){this.K(h)&&(!this.d||this.d(h.relativePath,L.$nc(h.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||o(h))}K(o){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$MK)(o,this.c);if(this.b)return(0,f.$MK)(o,this.b,!1)}return!0}L(o,h,g){return h.isSymbolicLink()?O.stat(o,g):g(null,h)}M(o,h,g){return h.isSymbolicLink()?O.realpath(o,(w,k)=>w?g(w):g(null,k)):g(null,o)}N(o,h){return o.folderName?L.$jc(o.folderName,h):h}}e.$uoc=c;class r{constructor(o){this.a=o.folderQueries,this.b=o.extraFileResources||[],this.c=new c(o)}search(o,h,g){this.c.walk(this.a,this.b,o,h,(w,k)=>{g(w,{limitHit:k,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$voc=r;class t{constructor(o,h){this.expression=o,this.c=h,this.d(o)}d(o){let h,g;Object.keys(o).filter(w=>o[w]).forEach(w=>{L.$ic(w)?(h=h||$.$nk(),h[w]=o[w]):(g=g||$.$nk(),g[w]=o[w])}),this.a=h&&$.$sk(h,{trimForExclusions:!0}),this.b=g&&$.$sk(g,{trimForExclusions:!0})}test(o,h,g){return this.b&&this.b(o,h,g)||this.a&&this.a(L.$jc(this.c,o),h,g)}getBasenameTerms(){const o=[];return this.a&&o.push(...$.$uk(this.a)),this.b&&o.push(...$.$uk(this.b)),o}getPathTerms(){const o=[];return this.a&&o.push(...$.$vk(this.a)),this.b&&o.push(...$.$vk(this.b)),o}}function u(s){const o=s.trim().split(`
`),h=o[0].trim();if(h.startsWith("Error parsing regex"))return h;if(h.startsWith("regex parse error"))return S.$3f(o[o.length-1].trim());if(h.startsWith("error parsing glob")||h.startsWith("unsupported encoding"))return h.charAt(0).toUpperCase()+h.substr(1);if(h==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(h.startsWith("Literal "))return h}}),define(ke[390],De([1,0,98,22,198,21]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qE=e.$iE=e.DecodeStreamErrorKind=e.$hE=e.$gE=e.$fE=e.$dE=e.$cE=e.$bE=e.$aE=void 0,e.$eE=M,e.$jE=v,e.$kE=d,e.$lE=f,e.$mE=a,e.$nE=n,e.$oE=s,e.$pE=o,e.$aE="utf8",e.$bE="utf8bom",e.$cE="utf16be",e.$dE="utf16le";function M(h){return[e.$aE,e.$bE,e.$cE,e.$dE].some(g=>g===h)}e.$fE=[254,255],e.$gE=[255,254],e.$hE=[239,187,191];const b=512,$=512,E=512*8,I=512*128;var P;(function(h){h[h.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class p extends Error{constructor(g,w){super(g),this.decodeStreamErrorKind=w}}e.$iE=p;class S{static async create(g){let w;if(g!==e.$aE)w=(await(0,L.$_D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(a(g));else{const k=new TextDecoder;w={write(m){return k.decode(m,{stream:!0})},end(){return k.decode()}}}return new S(w)}constructor(g){this.a=g}write(g){return this.a.write(g)}end(){return this.a.end()}}function v(h,g){const w=g.minBytesRequiredForDetection??g.guessEncoding?E:$;return new Promise((k,m)=>{const y=(0,l.$ve)(z=>z.join("")),D=[];let C=0,R;const T=new A.$qe,j=async()=>{try{const z=await o({buffer:O.$He.concat(D),bytesRead:C},g.guessEncoding);if(z.seemsBinary&&g.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);z.encoding=await g.overwriteEncoding(z.encoding),R=await S.create(z.encoding);const N=R.write(O.$He.concat(D).buffer);y.write(N),D.length=0,C=0,k({stream:y,detected:z})}catch(z){T.cancel(),y.destroy(),m(z)}};(0,l.$ze)(h,{onData:async z=>{R?y.write(R.write(z.buffer)):(D.push(z),C+=z.byteLength,C>=w&&(h.pause(),await j(),setTimeout(()=>h.resume())))},onError:z=>y.error(z),onEnd:async()=>{R||await j(),y.end(R?.end())}},T.token)})}async function d(h,g,w){const m=(await(0,L.$_D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(a(g),w);let y=!1,D=!1;return{read(){if(D)return null;const C=h.read();if(typeof C!="string"){if(D=!0,!y&&w?.addBOM)switch(g){case e.$aE:case e.$bE:return O.$He.wrap(Uint8Array.from(e.$hE));case e.$cE:return O.$He.wrap(Uint8Array.from(e.$fE));case e.$dE:return O.$He.wrap(Uint8Array.from(e.$gE))}const R=m.end();return R&&R.length>0?(y=!0,O.$He.wrap(R)):null}return y=!0,O.$He.wrap(m.write(C))}}}async function f(h){return(await(0,L.$_D)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(a(h))}function a(h){return h===e.$bE||h===null?e.$aE:h}function n(h,g){if(!h||g<e.$fE.length)return null;const w=h.readUInt8(0),k=h.readUInt8(1);if(w===e.$fE[0]&&k===e.$fE[1])return e.$cE;if(w===e.$gE[0]&&k===e.$gE[1])return e.$dE;if(g<e.$hE.length)return null;const m=h.readUInt8(2);return w===e.$hE[0]&&k===e.$hE[1]&&m===e.$hE[2]?e.$bE:null}const i=["ascii","utf-16","utf-32"];async function c(h){const g=await(0,L.$_D)("jschardet","dist/jschardet.min.js"),w=h.slice(0,I),k=u(w.buffer),m=g.detect(k);if(!m||!m.encoding)return null;const y=m.encoding.toLowerCase();return 0<=i.indexOf(y)?null:t(m.encoding)}const r={ibm866:"cp866",big5:"cp950"};function t(h){const g=h.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return r[g]||g}function u(h){let g="";for(let w=0;w<h.length;w++)g+=String.fromCharCode(h[w]);return g}function s(h){switch(h){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const g=h.match(/windows(\d+)/);return g?"windows-"+g[1]:h}}}function o({buffer:h,bytesRead:g},w){let k=n(h,g),m=!1;if(k!==e.$cE&&k!==e.$dE&&h){let y=!0,D=!0,C=!1;for(let R=0;R<g&&R<b;R++){const T=R%2===1,j=h.readUInt8(R)===0;if(j&&(C=!0),y&&(T&&!j||!T&&j)&&(y=!1),D&&(T&&j||!T&&!j)&&(D=!1),j&&!y&&!D)break}C&&(y?k=e.$dE:D?k=e.$cE:m=!0)}return w&&!m&&!k&&h?c(h.slice(0,g)).then(y=>({seemsBinary:!1,encoding:y})):{seemsBinary:m,encoding:k}}e.$qE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[161],De([1,0,390,32,160]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=void 0;class A extends L.$nnc{constructor(b,$,E=O,I="searchProcess"){super({query:b,provider:$},{readdir:P=>E.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,l.$oE)(P)},I)}}e.$Doc=A}),define(ke[162],De([1,0,54,406,389,19,74,35,14,2,37,94,407,387,123]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=e.$woc=void 0,e.$yoc=t,e.$zoc=s,e.$Aoc=h,e.$Boc=g,e.$Coc=k;const d=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(y){this.a=y}provideTextSearchResults(y,D,C,R){return this.a.appendLine(`provideTextSearchResults ${y.pattern}, ${JSON.stringify({...D,folder:D.folder.toString()})}`),new Promise((T,j)=>{R.onCancellationRequested(()=>K());const z=t(y,D),N=D.folder.fsPath,F=z.map(Pe=>Pe.match(/^-/)?Pe:`'${Pe}'`).join(" ");this.a.appendLine(`${d} ${F}
 - cwd: ${N}`);let B=l.spawn(d,z,{cwd:N});B.on("error",Pe=>{console.error(Pe),this.a.appendLine("Error: "+(Pe&&Pe.message)),j((0,I.$IK)(new I.$GK(Pe&&Pe.message,I.SearchErrorCode.rgProcessError)))});let Y=!1;const re=new i(D.maxResults,D.folder,D.previewOptions);re.on("result",Pe=>{Y=!0,Z="",C.report(Pe)});let H=!1;const K=()=>{H=!0,B?.kill(),re?.cancel()};let _=!1;re.on("hitLimit",()=>{_=!0,K()});let Z="";B.stdout.on("data",Pe=>{re.handleData(Pe),Y||(Z+=Pe)});let $e=!1;B.stdout.once("data",()=>$e=!0);let oe="";B.stderr.on("data",Pe=>{const te=Pe.toString();this.a.appendLine(te),oe.length+te.length<1e6&&(oe+=te)}),B.on("close",()=>{if(this.a.appendLine($e?"Got data from stdout":"No data from stdout"),this.a.appendLine(Y?"Got result from parser":"No result from parser"),Z&&this.a.appendLine(`Got data without result: ${Z}`),this.a.appendLine(""),H)T({limitHit:_});else{re.flush(),B=null;let Pe;oe&&!$e&&(Pe=a(oe))?j((0,I.$IK)(new I.$GK(Pe.message,Pe.code))):T({limitHit:_})}})})}}e.$woc=f;function a(m){const y=m.split(`
`),D=y[0].trim();if(y.some(R=>R.startsWith("regex parse error")))return new I.$GK(n(y),I.SearchErrorCode.regexParseError);const C=D.match(/grep config error: unknown encoding: (.*)/);if(C)return new I.$GK(`Unknown encoding: ${C[1]}`,I.SearchErrorCode.unknownEncoding);if(D.startsWith("error parsing glob"))return new I.$GK(D.charAt(0).toUpperCase()+D.substr(1),I.SearchErrorCode.globParseError);if(D.startsWith("the literal"))return new I.$GK(D.charAt(0).toUpperCase()+D.substr(1),I.SearchErrorCode.invalidLiteral);if(D.startsWith("PCRE2: error compiling pattern"))return new I.$GK(D,I.SearchErrorCode.regexParseError)}function n(m){const y=["Regex parse error"],D=m.filter(C=>C.startsWith("PCRE2:"));if(D.length>=1){const C=D[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const R=C.split(":")[1];y.push(":"+R)}}return y.join("")}class i extends O.EventEmitter{constructor(y,D,C){super(),this.g=y,this.h=D,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(y,D){return super.on(y,D),this}handleData(y){if(this.b)return;const D=typeof y=="string"?y:this.d.write(y);this.k(D)}k(y){let D=y.indexOf(`
`);const C=this.a+y;if(D>=0)D+=this.a.length;else{this.a=C;return}let R=0;for(;D>=0;)this.m(C.substring(R,D).trim()),R=D+1,D=C.indexOf(`
`,R);this.a=C.substring(R)}m(y){if(this.b||!y)return;let D;try{D=JSON.parse(y)}catch{throw new Error(`malformed line from rg: ${y}`)}if(D.type==="match"){const C=c(D.data.path),R=E.URI.joinPath(this.h,C),T=this.n(D.data,R);this.p(T),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(D.type==="context"){const C=c(D.data.path),R=E.URI.joinPath(this.h,C);this.o(D.data,R).forEach(j=>this.p(j))}}n(y,D){const C=y.line_number-1,R=c(y.lines),T=Buffer.from(R);let j=0,z=0,N=C;y.submatches.length===0&&y.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const F=(0,A.$Hb)(y.submatches.map((B,Y)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const re=c(B.match),H=T.slice(j,B.start).toString(),K=r(H),_=K.numLines>0?K.lastLineLength:K.lastLineLength+z,Z=r(re),$e=K.numLines+N,oe=Z.numLines+$e,Pe=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+_;return j=B.end,z=Pe,N=oe,new P.$qK($e,_,oe,Pe)}));return(0,v.$poc)(D,R,F,this.j)}o(y,D){const C=c(y.lines),R=y.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((T,j)=>({text:T,uri:D,lineNumber:R+j}))}p(y){this.emit("result",y)}}e.$xoc=i;function c(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function r(m){const y=/\n/g;let D=0,C=-1,R;for(;R=y.exec(m);)D++,C=R.index;const T=C>=0?m.length-C-1:m.length;return{numLines:D,lastLineLength:T}}function t(m,y){const D=["--hidden","--no-require-git"];D.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:R}=(0,M.$K)(y.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const j=new Set;R.forEach(z=>{j.add(z)}),D.push("-g","!*"),j.forEach(z=>{u(z).map(v.$ooc).forEach(N=>{D.push("-g",N)})})}C&&C.length&&C.forEach(j=>{D.push("-g",j)}),y.excludes.map(v.$ooc).forEach(j=>D.push("-g",`!${j}`)),y.maxFileSize&&D.push("--max-filesize",y.maxFileSize+""),y.useIgnoreFiles?y.useParentIgnoreFiles||D.push("--no-ignore-parent"):D.push("--no-ignore"),y.followSymlinks&&D.push("--follow"),y.encoding&&y.encoding!=="utf8"&&D.push("--encoding",y.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,$.$bf)(m.pattern),m.isRegExp=!0),y.usePCRE2&&D.push("--pcre2"),D.push("--crlf"),m.isRegExp&&(m.pattern=s(m.pattern),D.push("--engine","auto"));let T;if(m.isWordMatch){const z=(0,$.$kf)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");D.push("--regexp",z)}else if(m.isRegExp){let j=h(m.pattern);j=g(j),D.push("--regexp",j)}else T=m.pattern,D.push("--fixed-strings");return D.push("--no-config"),y.useGlobalIgnoreFiles||D.push("--no-ignore-global"),D.push("--json"),m.isMultiline&&D.push("--multiline"),y.beforeContext&&D.push("--before-context",y.beforeContext+""),y.afterContext&&D.push("--after-context",y.afterContext+""),D.push("--"),T&&D.push(T),D.push("."),D}function u(m){return k(m).flatMap(D=>{const C=(0,b.$qk)(D,"/");return C.map((R,T)=>C.slice(0,T+1).join("/"))})}function s(m){const y=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(y);)m=m.replace(y,"$1\\x{$2}");const D=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(D);)m=m.replace(D,"$1\\x{$2}");return m}const o=m=>m.type==="Assertion"&&m.kind==="lookbehind";function h(m){let y;try{y=new p.RegExpParser().parsePattern(m)}catch{return m}let D="",C=0;const R=(z,N,F)=>{D+=m.slice(C,z)+F,C=N},T=[];return new p.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const N=T[0];if(!N)R(z.start,z.end,"\\r?\\n");else if(!T.some(o))if(N.type==="CharacterClass")if(N.negate){const F=m.slice(N.start+2,z.start)+m.slice(z.end,N.end-1);N.parent?.type==="Quantifier"?R(N.start,N.end,F?`[^${F}]`:"."):R(N.start,N.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=m.slice(N.start+1,z.start)+m.slice(z.end,N.end-1);R(N.start,N.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else N.type==="Quantifier"&&R(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){T.unshift(z)},onQuantifierLeave(){T.shift()},onCharacterClassRangeEnter(z){T.unshift(z)},onCharacterClassRangeLeave(){T.shift()},onCharacterClassEnter(z){T.unshift(z)},onCharacterClassLeave(){T.shift()},onAssertionEnter(z){o(z)&&T.push(z)},onAssertionLeave(z){T[0]===z&&T.shift()}}).visit(y),D+=m.slice(C),D}function g(m){return m.replace(/\n/g,"\\r?\\n")}function w(m){let y=!1,D=!1,C="",R="";for(let T=0;T<m.length;T++){const j=m[T];switch(j){case"\\":D?(y?R+="\\"+j:C+="\\"+j,D=!1):D=!0;break;case"{":if(D)y?R+=j:C+=j,D=!1;else{if(y)return{strInBraces:C+"{"+R+"{"+m.substring(T+1)};y=!0}break;case"}":if(D)y?R+=j:C+=j,D=!1;else{if(y)return{fixedStart:C,strInBraces:R,fixedEnd:m.substring(T+1)};C+=j}break;default:y?R+=(D?"\\":"")+j:C+=(D?"\\":"")+j,D=!1;break}}return{strInBraces:C+(y?"{"+R:"")}}function k(m){const{fixedStart:y,strInBraces:D,fixedEnd:C}=w(m);if(y===void 0||C===void 0)return[D];let R=(0,b.$qk)(D,",");R.length||(R=[""]);const T=k(C);return R.flatMap(j=>{const z=y+j;return T.map(N=>z+N)})}}),define(ke[391],De([1,0,21,162,109,15]),function(he,e,l,O,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=void 0;class M{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,I,P,p){const S=new O.$woc(this.b);if(I.folder.scheme===A.Schemas.vscodeUserData){const v={...I,folder:I.folder.with({scheme:A.Schemas.file})},d=new L.$hw(f=>P.report({...f,uri:f.uri.with({scheme:I.folder.scheme})}));return this.c(p,f=>S.provideTextSearchResults(E,v,d,f))}else return this.c(p,v=>S.provideTextSearchResults(E,I,P,v))}async c(E,I){const P=b(E);this.a.add(P);const p=await I(P.token);return this.a.delete(P),p}d(){this.a.forEach(E=>E.cancel())}}e.$Goc=M;function b($){const E=new l.$qe;return $.onCancellationRequested(()=>E.cancel()),E}}),define(ke[392],De([1,0,32,162,161]),function(he,e,l,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0;class A{constructor($){this.a=$}search($,E,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const P={appendLine(S){I({message:S})}},p=new L.$Doc(this.a,new O.$woc(P),l);return new Promise((S,v)=>p.search(d=>{E(d.map(M))},$).then(d=>S({limitHit:d.limitHit??!1,type:"success",stats:d.stats,messages:[]}),v))}}e.$Eoc=A;function M(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,E)=>{if(E.ranges){const I=E;return $+(Array.isArray(I.ranges)?I.ranges.length:1)}else return $+1},0)}}}),define(ke[393],De([1,0,19,7,13,4,133,16,40,2,33,37,388,392]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=void 0;class v{static{this.a=512}constructor(c="searchProcess"){this.d=c,this.b=Object.create(null)}fileSearch(c){let r;const t=a(c),u=new A.$fe({onDidAddFirstListener:()=>{r=(0,O.$lh)(s=>this.doFileSearchWithEngine(p.$voc,t,o=>u.fire(o),s)),r.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{r.cancel()}});return u.event}textSearch(c){let r;const t=a(c),u=new A.$fe({onDidAddFirstListener:()=>{r=(0,O.$lh)(s=>this.f(t,o=>u.fire(o),s)),r.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{r.cancel()}});return u.event}f(c,r,t){return c.maxFileSize=this.g().maxFileSize,new S.$Eoc(c).search(t,r,r)}g(){return{maxFileSize:16*I.$Al.GB}}doFileSearch(c,r,t){return this.doFileSearchWithEngine(p.$voc,c,r,t)}doFileSearchWithEngine(c,r,t,u,s=v.a){let o=0;const h=w=>{Array.isArray(w)?(o+=w.length,t(w.map(k=>this.h(k)))):w.relativePath?(o++,t(this.h(w))):t(w)};if(r.sortByScore){let w=this.l(r,h,u);if(!w){const k=r.maxResults?Object.assign({},r,{maxResults:null}):r,m=new c(k);w=this.j(m,r,t,h,u)}return new Promise((k,m)=>{w.then(([y,D])=>{const C=D.map(R=>this.h(R));this.o(C,t,s),k(y)},m)})}const g=new c(r);return this.r(g,h,s,u).then(w=>({limitHit:w.limitHit,type:"success",stats:{detailStats:w.stats,type:this.d,fromCache:!1,resultCount:o,sortingTime:void 0},messages:[]}))}h(c){return{path:c.base?(0,b.$jc)(c.base,c.relativePath):c.relativePath}}j(c,r,t,u,s){const o=new A.$fe;let h=(0,O.$lh)(w=>{let k=[];const m=y=>{Array.isArray(y)?k=y:(u(y),o.fire(y))};return this.r(c,m,-1,w).then(y=>[y,k])}),g;if(r.cacheKey){g=this.k(r.cacheKey);const w={promise:h,event:o.event,resolved:!1};g.resultsToSearchCache[r.filePattern||""]=w,h.then(()=>{w.resolved=!0},k=>{delete g.resultsToSearchCache[r.filePattern||""]}),h=this.s(h)}return h.then(([w,k])=>{const m=g?g.scorerCache:Object.create(null),y=(typeof r.maxResults!="number"||r.maxResults>0)&&$.$be.create(!1);return this.n(r,k,m,s).then(D=>{const C=y?y.elapsed():-1;return[{type:"success",stats:{detailStats:w.stats,sortingTime:C,fromCache:!1,type:this.d,resultCount:D.length},messages:w.messages,limitHit:w.limitHit||typeof r.maxResults=="number"&&k.length>r.maxResults},D]})})}k(c){const r=this.b[c];return r||(this.b[c]=new d)}l(c,r,t){const u=c.cacheKey&&this.b[c.cacheKey];if(!u)return;const s=this.q(u,c.filePattern||"",r,t);if(s)return s.then(([o,h,g])=>{const w=$.$be.create(!1);return this.n(c,h,u.scorerCache,t).then(k=>{const m=w.elapsed(),y={fromCache:!0,detailStats:g,type:this.d,resultCount:h.length,sortingTime:m};return[{type:"success",limitHit:o.limitHit||typeof c.maxResults=="number"&&h.length>c.maxResults,stats:y,messages:[]},k]})})}n(c,r,t,u){const s=(0,M.$Br)(c.filePattern||""),o=(g,w)=>(0,M.$Ar)(g,w,s,!0,f,t),h=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return l.$Gb(r,o,h,1e4,u)}o(c,r,t){if(t&&t>0)for(let u=0;u<c.length;u+=t)r(c.slice(u,u+t));else r(c)}q(c,r,t,u){const s=$.$be.create(!1),o=r.indexOf(b.sep)>=0;let h;for(const m in c.resultsToSearchCache)if(r.startsWith(m)){if(o&&m.indexOf(b.sep)<0&&m!=="")continue;const y=c.resultsToSearchCache[m];h={promise:this.s(y.promise),event:y.event,resolved:y.resolved};break}if(!h)return null;const g=s.elapsed(),w=$.$be.create(!1),k=h.event(t);return u&&u.onCancellationRequested(()=>{k.dispose()}),h.promise.then(([m,y])=>{if(u&&u.isCancellationRequested)throw(0,L.$6)();const D=[],C=(0,M.$Br)(r).normalizedLowercase;for(const R of y)(0,P.$MK)(R,C)&&D.push(R);return[m,D,{cacheWasResolved:h.resolved,cacheLookupTime:g,cacheFilterTime:w.elapsed(),cacheEntryCount:y.length}]})}r(c,r,t,u){return new Promise((s,o)=>{let h=[];u?.onCancellationRequested(()=>c.cancel()),c.search(g=>{g&&(t?(h.push(g),t>0&&h.length>=t&&(r(h),h=[])):r(g))},g=>{r(g)},(g,w)=>{h.length&&r(h),g?(r({message:"Search finished. Error: "+g.message}),o(g)):(r({message:"Search finished. Stats: "+JSON.stringify(w.stats)}),s(w))})})}clearCache(c){return delete this.b[c],Promise.resolve(void 0)}s(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,t){return c.then(r,t)}catch(r){return this.then(void 0,r)}finally(r){return c.finally(r)}}}}e.$Foc=v;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(i){return(0,b.$nc)(i.relativePath)}getItemDescription(i){return(0,b.$mc)(i.relativePath)}getItemPath(i){return i.relativePath}};function a(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(c=>E.URI.revive(c))}}function n(i){return{...i,folder:E.URI.revive(i.folder)}}}),define(ke[394],De([1,0,3,15,2,32,11,28,20,97,68,37,393,391,123,161]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hoc=void 0;let f=class extends E.$snc{constructor(n,i,c,r){super(n,c,r),this.w=A,this.x=-1,this.y=null,this.z=!1,this.A=new l.$Tc;const t=new v.$qoc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new S.$Goc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$qoc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(O.Schemas.file,new S.$Goc(n))),this.A.add(this.C(O.Schemas.file,new p.$Foc("fileSearchProvider")))}C(n,i){const c=this.d++;return this.y=i,this.x=c,this.c.$registerFileSearchProvider(c,this.s(n)),(0,l.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(c)})}$provideFileSearchResults(n,i,c,r){const t=(0,E.$tnc)(c);if(n===this.x){const u=Date.now();return this.D(n,i,t,r).then(s=>{const o=Date.now()-u;return this.q.debug(`Ext host file search time: ${o}ms`),s})}return super.$provideFileSearchResults(n,i,c,r)}doInternalFileSearchWithCustomCallback(n,i,c){const r=t=>{if((0,P.$LK)(t)&&(t=[t]),Array.isArray(t)){c(t.map(u=>L.URI.file(u.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,r,i)}async D(n,i,c,r){return this.doInternalFileSearchWithCustomCallback(c,r,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new d.$Doc(n,i,void 0,"textSearchProvider")}};e.$Hoc=f,e.$Hoc=f=Je([We(0,$.$NO),We(1,b.$4O),We(2,I.$jmc),We(3,M.$5j)],f)}),define(ke[124],De([1,0,408,63,64,409,22,13,4,3,16,12,30,82,83]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$pi=e.$oi=e.$ni=void 0,e.$qi=s,e.$ri=o,e.$ti=w,e.$ui=k;class d{traceSocketEvent(y,D){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,y,D)}constructor(y,D=""){this.f=!0,this.debugLabel=D,this.socket=y,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,b.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(y){const D=C=>{this.traceSocketEvent("read",C),y(M.$He.wrap(C))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(y){const D=C=>{y({type:0,hadError:C,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(y){const D=()=>{y()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(y){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",y),this.socket.write(y.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,b.$1)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,b.$1)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((y,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),y();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),y()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$ni=d;var f;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var a;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(a||(a={}));class n extends E.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(y,D){this.socket.traceSocketEvent(y,D)}constructor(y,D,C,R){super(),this.f=this.B(new $.$fe),this.g=this.B(new $.$fe),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=y,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:C?.byteLength||0,recordInflateBytes:R}),this.a=this.B(new i(this,D,C,R,this.f,(T,j)=>this.m(T,j))),this.B(this.a.onError(T=>{console.error(T),(0,b.$1)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new v.$ii,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this.f.event(y)}onClose(y){return this.g.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){let D=0;for(;D<y.byteLength;)this.a.writeMessage(y.slice(D,Math.min(D+262144,y.byteLength)),{compressed:!0,opcode:2}),D+=262144}m(y,{compressed:D,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",y);let R=2;y.byteLength<126?R+=0:y.byteLength<2**16?R+=2:R+=8;const T=M.$He.alloc(R),j=D?64:0,z=C&15;if(T.writeUInt8(128|j|z,0),y.byteLength<126)T.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){T.writeUInt8(126,1);let N=1;T.writeUInt8(y.byteLength>>>8&255,++N),T.writeUInt8(y.byteLength>>>0&255,++N)}else{T.writeUInt8(127,1);let N=1;T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(0,++N),T.writeUInt8(y.byteLength>>>24&255,++N),T.writeUInt8(y.byteLength>>>16&255,++N),T.writeUInt8(y.byteLength>>>8&255,++N),T.writeUInt8(y.byteLength>>>0&255,++N)}this.socket.write(M.$He.concat([T,y]))}end(){this.h=!0,this.socket.end()}n(y){if(y.byteLength!==0){for(this.b.acceptChunk(y);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const D=this.b.peek(this.j.readLen),C=D.readUInt8(0),R=(C&128)>>>7,T=(C&64)>>>6,j=C&15,z=D.readUInt8(1),N=(z&128)>>>7,F=z&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=R,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!R,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const D=this.b.read(this.j.readLen),C=D.readUInt8(1),R=(C&128)>>>7;let T=C&127,j=1;T===126?T=D.readUInt8(++j)*2**8+D.readUInt8(++j):T===127&&(T=D.readUInt8(++j)*0+D.readUInt8(++j)*0+D.readUInt8(++j)*0+D.readUInt8(++j)*0+D.readUInt8(++j)*2**24+D.readUInt8(++j)*2**16+D.readUInt8(++j)*2**8+D.readUInt8(++j));let z=0;R&&(z=D.readUInt8(++j)*2**24+D.readUInt8(++j)*2**16+D.readUInt8(++j)*2**8+D.readUInt8(++j)),this.j.state=3,this.j.readLen=T,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const D=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),t(D,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(D,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(D,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$oi=n;class i extends E.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$He.alloc(0)}constructor(y,D,C,R,T,j){super(),this.n=y,this.r=T,this.s=j,this.a=this.B(new $.$fe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$fe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$fe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,D?(this.b=this.B(new c(this.n,R,C,{windowBits:15})),this.f=this.B(new r(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(y,D){this.g.push({data:y,options:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:y,options:D}=this.g.shift();if(this.f&&D.compressed){const C=await this.w(this.f,y);this.s(C,D)}else this.s(y,{...D,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(y,D){return new Promise((C,R)=>{y.write(D),y.flush(T=>C(T))})}acceptFrame(y,D,C){this.h.push({data:y,isCompressed:D,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const y=this.h.shift();if(this.b&&y.isCompressed){const D=await this.C(this.b,y.data,y.isLastFrameOfMessage);this.r.fire(D)}else this.r.fire(y.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(y,D,C){return new Promise((R,T)=>{y.write(D),C&&y.write(M.$He.fromByteArray([0,0,255,255])),y.flush(j=>R(j))})}}class c extends E.$Uc{get recordedInflateBytes(){return this.j?M.$He.concat(this.f):M.$He.alloc(0)}constructor(y,D,C,R){super(),this.h=y,this.j=D,this.a=this.B(new $.$fe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(R),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(M.$He.wrap(T))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(y){this.j&&this.f.push(y.clone()),this.h.traceSocketEvent("zlibInflateWrite",y),this.b.write(y.buffer)}flush(y){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const D=M.$He.concat(this.g);this.g.length=0,y(D)})}}class r extends E.$Uc{constructor(y,D){super(),this.g=y,this.a=this.B(new $.$fe),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(M.$He.wrap(C))})}write(y){this.g.traceSocketEvent("zlibDeflateWrite",y.buffer),this.b.write(y.buffer)}flush(y){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let D=M.$He.concat(this.f);this.f.length=0,D=D.slice(0,D.byteLength-4),y(D)})}}function t(m,y){if(y===0)return;const D=m.byteLength>>>2;for(let N=0;N<D;N++){const F=m.readUInt32BE(N*4);m.writeUInt32BE(F^y,N*4)}const C=D*4,R=m.byteLength-C,T=y>>>24&255,j=y>>>16&255,z=y>>>8&255;R>=1&&m.writeUInt8(m.readUInt8(C)^T,C),R>=2&&m.writeUInt8(m.readUInt8(C+1)^j,C+1),R>=3&&m.writeUInt8(m.readUInt8(C+2)^z,C+2)}e.$pi=process.env.XDG_RUNTIME_DIR;const u={2:107,1:103};function s(){const m=(0,p.$Ug)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const y=process.platform!=="darwin"&&e.$pi?e.$pi:(0,L.tmpdir)(),D=(0,I.$jc)(y,`vscode-ipc-${m}.sock`);return h(D),D}function o(m,y,D){const R=(0,l.createHash)("sha256").update(m).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${D}-${y}-sock`;const T=D.substr(0,4),j=y.substr(0,6);let z;return process.platform!=="darwin"&&e.$pi&&!process.env.VSCODE_PORTABLE?z=(0,I.$jc)(e.$pi,`vscode-${R}-${T}-${j}.sock`):z=(0,I.$jc)(m,`${T}-${j}.sock`),h(z),z}function h(m){const y=u[P.$u];typeof y=="number"&&m.length>=y&&console.warn(`WARNING: IPC handle "${m}" is longer than ${y} chars, try a shorter --user-data-dir`)}class g extends S.$ci{static b(y){const D=$.Event.fromNodeEventEmitter(y,"connection");return $.Event.map(D,C=>({protocol:new v.$ji(new d(C,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(C,"close"))}))}constructor(y){super(g.b(y)),this.d=y}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$si=g;function w(m){return new Promise((y,D)=>{const C=(0,O.createServer)();C.on("error",D),C.listen(m,()=>{C.removeListener("error",D),y(new g(C))})})}function k(m,y){return new Promise((D,C)=>{const R=(0,O.createConnection)(m,()=>{R.removeListener("error",C),D(v.$ki.fromSocket(new d(R,`ipc-client${y}`),y))});R.once("error",C)})}}),define(ke[395],De([1,0,63,64,178,124,7,3,12,55,11,108,272,273,111,88,22]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=e.$qec=e.$pec=e.$oec=void 0;async function a(t,u,s,o,h){let g;for(let w=3;w&&(g?.dispose(),g=await new n(t,u,s,o,h).waitForReady(),!(h&&L.$Xg[h]||!L.$Xg[g.tunnelLocalPort]));w--);return g}class n extends b.$Uc{constructor(u,s,o,h,g){super(),this.m=s,this.n=g,this.privacy=d.TunnelPrivacyId.Private,this.j=new Map,this.a=u,this.b=l.createServer(),this.c=new M.$xh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=w=>this.r(w),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=h,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const u=this.n??this.tunnelRemotePort,s=(0,d.$uw)(this.m)?"0.0.0.0":"127.0.0.1";let o=await(0,L.$Yg)(u,2,1e3,s),h=null;return this.b.listen(o,this.m),await this.c.wait(),h=this.b.address(),h||(o=0,this.b.listen(o,this.m),await this.c.wait(),h=this.b.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async r(u){u.pause();const s=(0,d.$sw)(this.tunnelRemoteHost)||(0,d.$uw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,p.$Ul)(this.a,s,this.tunnelRemotePort),h=o.getSocket(),g=o.readEntireBuffer();o.dispose(),g.byteLength>0&&u.write(g.buffer),u.on("end",()=>{u.localAddress&&this.j.delete(u.localAddress),h.end()}),u.on("close",()=>h.end()),u.on("error",()=>{u.localAddress&&this.j.delete(u.localAddress),h instanceof A.$ni?h.socket.destroy():h.end()}),h instanceof A.$ni?this.t(u,h):this.s(u,h),u.localAddress&&this.j.set(u.localAddress,()=>{u.end(),h.end()})}s(u,s){s.onClose(()=>u.destroy()),s.onEnd(()=>u.end()),s.onData(o=>u.write(o.buffer)),u.on("data",o=>s.write(f.$He.wrap(o))),u.resume()}t(u,s){const o=s.socket;o.on("end",()=>u.end()),o.on("close",()=>u.end()),o.on("error",()=>{u.destroy()}),o.pipe(u),u.pipe(o)}}e.$oec=n;let i=class extends d.$xw{constructor(u,s,o,h,g){super(s,g),this.v=u,this.w=o,this.y=h}isPortPrivileged(u){return(0,d.$vw)(u,this.m,$.OS,O.release())}t(u,s,o,h,g,w,k,m){const y=this.s(s,o);if(y)return++y.refcount,y.value;if((0,d.$ow)(u))return this.u(u,s,o,g,w,k,m);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${o} on local port ${g}.`);const D={commit:this.y.commit,quality:this.y.quality,addressProvider:u,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=a(D,h,s,o,g);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,o,C),C}}};e.$pec=i,e.$pec=i=Je([We(0,S.$Ol),We(1,I.$5j),We(2,v.$Rl),We(3,P.$lk),We(4,E.$5i)],i);let c=class extends i{constructor(u,s,o,h,g){super(u,s,o,h,g)}};e.$qec=c,e.$qec=c=Je([We(0,S.$Ol),We(1,I.$5j),We(2,v.$Rl),We(3,P.$lk),We(4,E.$5i)],c);let r=class extends b.$Uc{constructor(u,s,o,h,g){super(),this.b=u,this.c=s,this.f=o,this.g=h,this.h=g,this.a=new Map}async openTunnel(u,s,o,h,g,w,k,m,y){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${h} on local port ${w}.`),!this.a.has(u)){const D=new c(this.b,this.c,this.g,this.f,this.h);this.B(D),this.a.set(u,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this.a.delete(u))})}return this.a.get(u).openTunnel(s,o,h,g,w,k,m,y)}};e.$rec=r,e.$rec=r=Je([We(0,S.$Ol),We(1,I.$5j),We(2,P.$lk),We(3,v.$Rl),We(4,E.$5i)],r)}),define(ke[396],De([1,0,124,292,53,34,2,11,42]),function(he,e,l,O,L,A,M,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=e.$cP=void 0;class E{constructor(p,S,v){this.b=p,this.c=S,this.f=v,this.a=O.createServer((d,f)=>this.h(d,f)),this.g().catch(d=>(S.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,S){const v=(f,a)=>{S.writeHead(f,{"content-type":"application/json"}),S.end(JSON.stringify(a||null),n=>n&&this.c.error(n))},d=[];p.setEncoding("utf8"),p.on("data",f=>d.push(f)),p.on("end",async()=>{try{const f=JSON.parse(d.join(""));let a;switch(f.type){case"open":a=await this.i(f);break;case"openExternal":a=await this.j(f);break;case"status":a=await this.l(f);break;case"extensionManagement":a=await this.k(f);break;default:v(404,`Unknown message type: ${f.type}`);break}v(200,a)}catch(f){const a=f instanceof Error?f.message:JSON.stringify(f);v(500,a),this.c.error("Error while processing pipe request",f)}})}async i(p){const{fileURIs:S,folderURIs:v,forceNewWindow:d,diffMode:f,mergeMode:a,addMode:n,forceReuseWindow:i,gotoLineMode:c,waitMarkerFilePath:r,remoteAuthority:t}=p,u=[];if(Array.isArray(v))for(const g of v)try{u.push({folderUri:M.URI.parse(g)})}catch{}if(Array.isArray(S))for(const g of S)try{(0,$.$4i)(g)?u.push({workspaceUri:M.URI.parse(g)}):u.push({fileUri:M.URI.parse(g)})}catch{}const s=r?M.URI.file(r):void 0,h={forceNewWindow:d,diffMode:f,mergeMode:a,addMode:n,gotoLineMode:c,forceReuseWindow:i,preferNewWindow:!i&&!s&&!n,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",u,h)}async j(p){for(const S of p.uris){const v=M.URI.parse(S),d=v.scheme==="file"?v:S;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(p){const S=d=>d?.map(f=>/\.vsix$/i.test(f)?M.URI.parse(f):f),v={list:p.list,install:S(p.install),uninstall:S(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$cP=E;let I=class extends E{constructor(p,S){super(p,S,(0,l.$qi)())}};e.$dP=I,e.$dP=I=Je([We(0,A.$0O),We(1,b.$5j)],I)}),define(ke[397],De([1,0,59,384,379,291,49,366,2,15,8,396,104,326,365]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=void 0;class d extends L.$boc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,c=i._load;i._load=function(s,o,h){return s=t(s),n.a.has(s)?n.a.get(s).load(s,$.URI.file((0,p.$$q)(o.filename)),g=>c.apply(this,[g,o,h])):c.apply(this,arguments)};const r=i._resolveLookupPaths;i._resolveLookupPaths=(u,s)=>r.call(this,t(u),s);const t=u=>{for(const s of n.b){const o=s(u);if(o){u=o;break}}return u}}}class f extends M.$2mc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(S.$Koc);const n=this.h.invokeFunction(O.$0nc);if(this.h.createInstance(b.$Joc),this.f.remote.isRemote&&this.f.remote.authority){const r=this.h.createInstance(P.$dP);process.env.VSCODE_IPC_HOOK_CLI=r.ipcHandlePath}this.h.createInstance(v.$Loc),await this.h.createInstance(d,n,{mine:this.J,all:this.L}).install(),l.mark("code/extHost/didInitAPI");const c=await this.m.getConfigProvider();await(0,A.$Ioc)(this.j,c,this,this.s,this.z,this.f),l.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,c){if(i.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let r=null;c.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&l.mark(`code/extHost/willLoadExtensionCode/${t}`),r=he.__$__nodeRequire(i.fsPath)}finally{t&&l.mark(`code/extHost/didLoadExtensionCode/${t}`),c.codeLoadingStop()}return r}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const c=n[i];c===null?delete process.env[i]:process.env[i]=c}}}e.$Moc=f}),define(ke[398],De([1,0,54,22,4,3,126,12,23,2,32,11,271,67,111,88,395,28,20,71,373]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uoc=void 0,e.$Noc=r,e.$Ooc=t,e.$Poc=u,e.$Qoc=s,e.$Roc=h,e.$Soc=g,e.$Toc=w;function r(y){const D=y.trim().split(`
`),C=[];return D.forEach(T=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);j&&j.length>=3&&C.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),C.reduce((T,j)=>(T[j.socket]=j,T),{})}function t(...y){const D=[].concat(...y.map(s));return[...new Map(D.filter(C=>C.st==="0A").map(C=>{const R=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:u(R[0]),port:parseInt(R[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function u(y){let D="";if(y.length===8)for(let C=y.length-2;C>=0;C-=2)D+=parseInt(y.substr(C,2),16),C!==0&&(D+=".");else for(let C=0;C<y.length;C+=8){const R=y.substring(C,C+8);let T="";for(let j=8;j>=2;j-=2)T+=R.substring(j-2,j),(j===6||j===2)&&(T=parseInt(T,16).toString(16),D+=`${T}`,T="",C+j!==y.length-6&&(D+=":"))}return D}function s(y){const D=y.trim().split(`
`),C=D.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return D.map(T=>T.trim().split(/\s+/).reduce((j,z,N)=>(j[C[N]||N]=z,j),{}))}function o(y){return!!y.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||y.indexOf("out/server-main.js")!==-1||y.indexOf("_productName=VSCode")!==-1}function h(y){const D=y.trim().split(`
`),C=[];return D.forEach(R=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(R);T&&T.length>=4&&C.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),C}async function g(y,D,C){const R=C.reduce((j,z)=>(j[z.pid]=z,j),{}),T=[];return y.forEach(({socket:j,ip:z,port:N})=>{const F=D[j]?D[j].pid:void 0,B=F?R[F]?.cmd:void 0;F&&B&&!o(B)&&T.push({host:z,port:N,detail:B,pid:F})}),T}function w(y,D,C){const R=new Map,T=h(D);for(const j of y){const z=C.get(j.port);if(z){R.set(j.port,z);continue}const N=T.find(F=>F.cmd.includes(`${j.port}`));if(N){let F=N,B;do B=T.find(Y=>Y.ppid===F.pid),B&&(F=B);while(B);R.set(j.port,{host:j.ip,port:j.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else R.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return R}let k=class extends i.$VDb{constructor(D,C,R,T){super(D,C,R),this.D=C,this.F=T,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(D){if(D&&this.C)return;this.C=D;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const R=new M.$Gm;let T=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(B=>(0,d.$sw)(B.host)||(0,d.$uw)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(B=>B.port).join(", ")}`);const N=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),T++>3&&R.update(N),(!C||JSON.stringify(C)!==JSON.stringify(z))&&(C=z,await this.a.$onFoundNewCandidates(C));const F=this.G(R.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(B=>setTimeout(()=>B(),F))}}G(D){return Math.max(D*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(D=>D.port).join(", ")}`)}async I(){let D="",C="";try{D=await I.Promises.readFile("/proc/net/tcp","utf8"),C=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const R=t(D,C),T=await new Promise(H=>{(0,l.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(K,_,Z)=>{H(_)})}),j=r(T),z=await I.Promises.readdir("/proc"),N=[];for(const H of z)try{const K=Number(H),_=$.$_g(E.URI.file("/proc"),H);if((await I.Promises.stat(_.fsPath)).isDirectory()&&!isNaN(K)){const $e=await I.Promises.readlink($.$_g(_,"cwd").fsPath),oe=await I.Promises.readFile($.$_g(_,"cmdline").fsPath,"utf8");N.push({pid:K,cwd:$e,cmd:oe})}}catch{}const F=[],B=R.filter(H=>{const K=j[H.socket];return K||F.push(H),K}),Y=g(B,j,N);let re;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const H=await new Promise(K=>{(0,l.exec)("ps -F -A -l | grep root",(_,Z,$e)=>{K(Z)})});this.z=w(F,H,this.z),re=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${re.map(K=>K.port).join(", ")}`)}return Y.then(H=>re?H.concat(re):H)}w(D){return async C=>{const R=new f.$oec({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,N,F){const B=await D.makeConnection();return m.connect(B,z,N,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$Kl(0),connectionToken:D.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await R.waitForReady();const T=new L.$fe;return{localAddress:(0,c.$JL)(R.localAddress)??R.localAddress,remoteAddress:{port:R.tunnelRemotePort,host:R.tunnelRemoteHost},onDidDispose:T.event,dispose:()=>{R.dispose(),T.fire(),T.dispose()}}}}};e.$Uoc=k,e.$Uoc=k=Je([We(0,n.$NO),We(1,a.$4O),We(2,P.$5j),We(3,v.$Rl)],k);class m extends p.$Tvb{static connect(D,C,R,T){const j=new A.$Tc,z={onClose:j.add(new L.$fe),onData:j.add(new L.$fe),onEnd:j.add(new L.$fe)};j.add(D.onDidReceiveMessage(F=>z.onData.fire(O.$He.wrap(F)))),j.add(D.onDidEnd(()=>z.onEnd.fire())),j.add(D.onDidClose(F=>z.onClose.fire({type:0,error:F,hadError:!!F})));const N=new m(D,T,z);return N.B(j),(0,p.$Svb)(N,C,R,T,z)}constructor(D,C,R){super(C,R),this.n=D}write(D){this.n.send(D.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[399],De([1,0,85,368,382,381,394,397,398,96,49,97,95,43,71,93,367,327,11,383,61,286,106,111,141]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a,n,i,c,r,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$Bs)(I.$3mc,b.$Moc,0),(0,l.$Bs)(n.$6j,a.$Woc,1),(0,l.$Bs)(n.$5j,new t.$vi(r.$aoc,[!1],!0)),(0,l.$Bs)(u.$Rl,s.$tec,1),(0,l.$Bs)(d.$smc,f.$Voc,0),(0,l.$Bs)(E.$8mc,A.$noc,0),(0,l.$Bs)(P.$rnc,M.$Hoc,0),(0,l.$Bs)(p.$Tnc,L.$foc,0),(0,l.$Bs)(S.$Nmc,O.$eoc,0),(0,l.$Bs)(v.$UDb,$.$Uoc,0),(0,l.$Bs)(c.$6mc,i.$Xoc,0)}),define(ke[410],De([1,0,63,411,59,13,83,124,269,115,380,22,32,104,7,136,293,309,385,399]),function(he,e,l,O,L,A,M,b,$,E,I,P,p,S,v,d,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let w=0;w<process.execArgv.length;w++)process.execArgv[w]==="--inspect-port=0"&&(process.execArgv.splice(w,1),w--)}();const n=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const g=globalThis._VSCODE_NODE_MODULES.module,w=g._load;g._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return w.apply(this,arguments)}})();const i=process.exit.bind(process),c=process.on.bind(process);function r(g){process.exit=function(w){if(g)i(w);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const w=new Error("An extension called process.crash() and this was prevented.");console.warn(w.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(w,k){w==="uncaughtException"&&(k=function(){try{return k.call(void 0,arguments)}catch{}}),c(w,k)}}let t=function(g){i()};function u(){const g=(0,a.$qn)(process.env);if(g.type===3)return new Promise((w,k)=>{const m=y=>{const D=y[0],C=new M.$li;D.on("message",R=>C.fire(P.$He.wrap(R.data))),D.on("close",()=>{t("renderer closed the MessagePort")}),D.start(),w({onMessage:C.event,send:R=>D.postMessage(R.buffer)})};process.parentPort.on("message",y=>m(y.ports))});if(g.type===2)return new Promise((w,k)=>{let m=null;const y=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),D=108e5,C=3e5,R=new v.$Lh(()=>t("renderer disconnected for too long (1)"),D),T=new v.$Lh(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(z,N)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const F=P.$He.wrap(Buffer.from(z.initialDataChunk,"base64"));let B;if(z.skipWebSocketFrames)B=new b.$ni(N,"extHost-socket");else{const Y=P.$He.wrap(Buffer.from(z.inflateBytes,"base64"));B=new b.$oi(new b.$ni(N,"extHost-socket"),z.permessageDeflate,Y,!1)}m?(R.cancel(),T.cancel(),m.beginAcceptReconnection(B,F),m.endAcceptReconnection(),m.sendResume()):(clearTimeout(y),m=new M.$mi({socket:B,initialChunk:F}),m.sendResume(),m.onDidDispose(()=>t("renderer disconnected")),w(m),m.onSocketClose(()=>{R.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;R.isScheduled()&&T.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const w=g.pipeName;return new Promise((k,m)=>{const y=l.createConnection(w,()=>{y.removeListener("error",m);const D=new M.$mi({socket:new b.$ni(y,"extHost-renderer")});D.sendResume(),k(D)});y.once("error",m),y.on("close",()=>{t("renderer closed the socket")})})}}async function s(){const g=await u();return new class{constructor(){this.a=new M.$li,this.onMessage=this.a.event,this.b=!1,g.onMessage(w=>{(0,E.$3m)(w,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(w)})}send(w){this.b||g.send(w)}async drain(){if(g.drain)return g.drain()}}}function o(g){return new Promise(w=>{const k=g.onMessage(m=>{k.dispose();const y=JSON.parse(m.toString()),D=y.commit,C=$.default.commit;if(D&&C&&D!==C&&i(55),y.parentPid){let R=0;setInterval(function(){try{process.kill(y.parentPid,0),R=0}catch(j){j&&j.code==="EPERM"?(R++,R>=3&&t(`parent process ${y.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${y.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let T;try{T=globalThis._VSCODE_NODE_MODULES["native-watchdog"],T.start(y.parentPid)}catch(j){(0,A.$1)(j)}}g.send((0,E.$2m)(0)),w({protocol:g,initData:y})});g.send((0,E.$2m)(1))})}async function h(){const g=[];process.on("unhandledRejection",(R,T)=>{g.push(T),setTimeout(()=>{const j=g.indexOf(T);j>=0&&T.catch(z=>{g.splice(j,1),(0,A.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),R&&(0,A.$1)(R))})},1e3)}),process.on("rejectionHandled",R=>{const T=g.indexOf(R);T>=0&&g.splice(T,1)}),process.on("uncaughtException",function(R){(0,A.$Z)(R)||(0,A.$1)(R)}),L.mark("code/extHost/willConnectToRenderer");const w=await s();L.mark("code/extHost/didConnectToRenderer");const k=await o(w);L.mark("code/extHost/didWaitForInitData");const{initData:m}=k;r(!!m.environment.extensionTestsLocationURI),m.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,m.environment.skipWorkspaceStorageLock=(0,d.boolean)(n.skipWorkspaceStorageLock,!1);const y=new class{constructor(){this.pid=process.pid}exit(T){i(T)}fsExists(T){return p.Promises.exists(T)}fsRealpath(T){return(0,S.$0q)(T)}};let D=null;m.remote.authority&&n.transformURIs&&(D=(0,f.$Fs)(m.remote.authority));const C=new I.$doc(k.protocol,m,y,D);t=R=>C.terminate(R)}h().catch(g=>console.log(g))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3028408922e78cc9ca15ee761372a7c0603fa375/core/vs/workbench/api/node/extensionHostProcess.js.map
