/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/marshalling","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(le){for(var e=[],C=0,O=le.length;C<O;C++)e[C]=Se[le[C]];return e};define(Se[69],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=O,e.$4h=M,e.$5h=T;function C(A){return(b,m,D)=>{let N=null,S=null;if(typeof D.value=="function"?(N="value",S=D.value):typeof D.get=="function"&&(N="get",S=D.get),!S)throw new Error("not supported");D[N]=A(S,m)}}function O(A,b,m){let D=null,N=null;if(typeof m.value=="function"?(D="value",N=m.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(D="get",N=m.get),!N)throw new Error("not supported");const S=`$memoize$${b}`;m[D]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,l)}),this[S]}}function M(A,b,m){return C((D,N)=>{const S=`$debounce$${N}`,l=`$debounce$result$${N}`;return function(...w){this[l]||(this[l]=m?m():void 0),clearTimeout(this[S]),b&&(this[l]=b(this[l],...w),w=[this[l]]),this[S]=setTimeout(()=>{D.apply(this,w),this[l]=m?m():void 0},A)}})}function T(A,b,m){return C((D,N)=>{const S=`$throttle$timer$${N}`,l=`$throttle$result$${N}`,w=`$throttle$lastRun$${N}`,g=`$throttle$pending$${N}`;return function(...r){if(this[l]||(this[l]=m?m():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),b&&(this[l]=b(this[l],...r)),this[g])return;const s=this[w]+A;s<=Date.now()?(this[w]=Date.now(),D.apply(this,[this[l]]),this[l]=m?m():void 0):(this[g]=!0,this[S]=setTimeout(()=>{this[g]=!1,this[w]=Date.now(),D.apply(this,[this[l]]),this[l]=m?m():void 0},s-Date.now()))}})}}),define(Se[125],Ie([1,0,18]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=M,e.$8c=T,e.$9c=A,e.$0c=b,e.$$c=m,e.$_c=D;const O=(w,g)=>w===g;e.$6c=O;function M(w=e.$6c){return(g,r)=>C.$ub(g,r,w)}function T(){return(w,g)=>JSON.stringify(w)===JSON.stringify(g)}function A(){return(w,g)=>w.equals(g)}function b(w,g,r){return!w||!g?w===g:r(w,g)}function m(w,g){if(w===g)return!0;if(Array.isArray(w)&&Array.isArray(g)){if(w.length!==g.length)return!1;for(let r=0;r<w.length;r++)if(!m(w[r],g[r]))return!1;return!0}if(w&&typeof w=="object"&&g&&typeof g=="object"&&Object.getPrototypeOf(w)===Object.prototype&&Object.getPrototypeOf(g)===Object.prototype){const r=w,s=g,o=Object.keys(r),i=Object.keys(s),n=new Set(i);if(o.length!==i.length)return!1;for(const c of o)if(!n.has(c)||!m(r[c],s[c]))return!1;return!0}return!1}function D(w){return JSON.stringify(l(w))}let N=0;const S=new WeakMap;function l(w){if(Array.isArray(w))return w.map(l);if(w&&typeof w=="object")if(Object.getPrototypeOf(w)===Object.prototype){const g=w,r=Object.create(null);for(const s of Object.keys(g).sort())r[s]=l(g[s]);return r}else{let g=S.get(w);return g===void 0&&(g=N++,S.set(w,g)),g+"----2b76a038c20c4bcc"}return w}}),define(Se[91],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TO=e.$SO=void 0;class C{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$SO=C,e.$TO=new C("id#")}),define(Se[126],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=A,e.$Kn=S,e.$Ln=l,e.$Mn=w,e.$Nn=g,e.$On=r,e.$Pn=s,e.$Qn=o,e.$Rn=i,e.$Sn=n,e.$Tn=c,e.$Un=u;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function A(t,f=!1){let a=0;const d=t.length;let $="",p=0,v=16,y=0;function h(q){let R=0,z=0;for(;R<q;){const G=t.charCodeAt(a);if(G>=48&&G<=57)z=z*16+G-48;else if(G>=65&&G<=70)z=z*16+G-65+10;else if(G>=97&&G<=102)z=z*16+G-97+10;else break;a++,R++}return R<q&&(z=-1),z}function E(q){a=q,$="",p=0,v=16,y=0}function k(){const q=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&D(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&D(t.charCodeAt(a)))for(a++;a<t.length&&D(t.charCodeAt(a));)a++;else return y=3,t.substring(q,a);let R=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&D(t.charCodeAt(a))){for(a++;a<t.length&&D(t.charCodeAt(a));)a++;R=a}else y=3;return t.substring(q,R)}function I(){let q="",R=a;for(;;){if(a>=d){q+=t.substring(R,a),y=2;break}const z=t.charCodeAt(a);if(z===34){q+=t.substring(R,a),a++;break}if(z===92){if(q+=t.substring(R,a),a++,a>=d){y=2;break}switch(t.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=h(4);ie>=0?q+=String.fromCharCode(ie):y=4;break}default:y=5}R=a;continue}if(z>=0&&z<=31)if(m(z)){q+=t.substring(R,a),y=2;break}else y=6;a++}return q}function P(){if($="",y=0,p=a,a>=d)return p=d,v=17;let q=t.charCodeAt(a);if(b(q)){do a++,$+=String.fromCharCode(q),q=t.charCodeAt(a);while(b(q));return v=15}if(m(q))return a++,$+=String.fromCharCode(q),q===13&&t.charCodeAt(a)===10&&(a++,$+=`
`),v=14;switch(q){case 123:return a++,v=1;case 125:return a++,v=2;case 91:return a++,v=3;case 93:return a++,v=4;case 58:return a++,v=6;case 44:return a++,v=5;case 34:return a++,$=I(),v=10;case 47:{const R=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<d&&!m(t.charCodeAt(a));)a++;return $=t.substring(R,a),v=12}if(t.charCodeAt(a+1)===42){a+=2;const z=d-1;let G=!1;for(;a<z;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,G=!0;break}a++}return G||(a++,y=1),$=t.substring(R,a),v=13}return $+=String.fromCharCode(q),a++,v=16}case 45:if($+=String.fromCharCode(q),a++,a===d||!D(t.charCodeAt(a)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return $+=k(),v=11;default:for(;a<d&&V(q);)a++,q=t.charCodeAt(a);if(p!==a){switch($=t.substring(p,a),$){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return $+=String.fromCharCode(q),a++,v=16}}function V(q){if(b(q)||m(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:E,getPosition:()=>a,scan:f?W:P,getToken:()=>v,getTokenValue:()=>$,getTokenOffset:()=>p,getTokenLength:()=>a-p,getTokenError:()=>y}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function D(t){return t>=48&&t<=57}var N;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(N||(N={}));function S(t,f){const a=[],d=new Object;let $;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function y(h,E,k,I){p.value=h,p.offset=E,p.length=k,p.type=I,p.colonOffset=void 0,$=p}try{n(t,{onObjectBegin:(h,E)=>{if(f<=h)throw d;$=void 0,v=f>h,a.push("")},onObjectProperty:(h,E,k)=>{if(f<E||(y(h,E,k,"property"),a[a.length-1]=h,f<=E+k))throw d},onObjectEnd:(h,E)=>{if(f<=h)throw d;$=void 0,a.pop()},onArrayBegin:(h,E)=>{if(f<=h)throw d;$=void 0,a.push(0)},onArrayEnd:(h,E)=>{if(f<=h)throw d;$=void 0,a.pop()},onLiteralValue:(h,E,k)=>{if(f<E||(y(h,E,k,u(h)),f<=E+k))throw d},onSeparator:(h,E,k)=>{if(f<=E)throw d;if(h===":"&&$&&$.type==="property")$.colonOffset=E,v=!1,$=void 0;else if(h===","){const I=a[a.length-1];typeof I=="number"?a[a.length-1]=I+1:(v=!0,a[a.length-1]=""),$=void 0}}})}catch(h){if(h!==d)throw h}return{path:a,previousNode:$,isAtPropertyKey:v,matches:h=>{let E=0;for(let k=0;E<h.length&&k<a.length;k++)if(h[E]===a[k]||h[E]==="*")E++;else if(h[E]!=="**")return!1;return E===h.length}}}function l(t,f=[],a=T.DEFAULT){let d=null,$=[];const p=[];function v(h){Array.isArray($)?$.push(h):d!==null&&($[d]=h)}return n(t,{onObjectBegin:()=>{const h={};v(h),p.push($),$=h,d=null},onObjectProperty:h=>{d=h},onObjectEnd:()=>{$=p.pop()},onArrayBegin:()=>{const h=[];v(h),p.push($),$=h,d=null},onArrayEnd:()=>{$=p.pop()},onLiteralValue:v,onError:(h,E,k)=>{f.push({error:h,offset:E,length:k})}},a),$[0]}function w(t,f=[],a=T.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function $(h){d.type==="property"&&(d.length=h-d.offset,d=d.parent)}function p(h){return d.children.push(h),h}n(t,{onObjectBegin:h=>{d=p({type:"object",offset:h,length:-1,parent:d,children:[]})},onObjectProperty:(h,E,k)=>{d=p({type:"property",offset:E,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:h,offset:E,length:k,parent:d})},onObjectEnd:(h,E)=>{d.length=h+E-d.offset,d=d.parent,$(h+E)},onArrayBegin:(h,E)=>{d=p({type:"array",offset:h,length:-1,parent:d,children:[]})},onArrayEnd:(h,E)=>{d.length=h+E-d.offset,d=d.parent,$(h+E)},onLiteralValue:(h,E,k)=>{p({type:u(h),offset:E,length:k,parent:d,value:h}),$(E+k)},onSeparator:(h,E,k)=>{d.type==="property"&&(h===":"?d.colonOffset=E:h===","&&$(E))},onError:(h,E,k)=>{f.push({error:h,offset:E,length:k})}},a);const y=d.children[0];return y&&delete y.parent,y}function g(t,f){if(!t)return;let a=t;for(const d of f)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let $=!1;for(const p of a.children)if(Array.isArray(p.children)&&p.children[0].value===d){a=p.children[1],$=!0;break}if(!$)return}else{const $=d;if(a.type!=="array"||$<0||!Array.isArray(a.children)||$>=a.children.length)return;a=a.children[$]}return a}function r(t){if(!t.parent||!t.parent.children)return[];const f=r(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;f.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&f.push(a)}return f}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const f=Object.create(null);for(const a of t.children){const d=a.children[1];d&&(f[a.children[0].value]=s(d))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,f,a=!1){return f>=t.offset&&f<t.offset+t.length||a&&f===t.offset+t.length}function i(t,f,a=!1){if(o(t,f,a)){const d=t.children;if(Array.isArray(d))for(let $=0;$<d.length&&d[$].offset<=f;$++){const p=i(d[$],f,a);if(p)return p}return t}}function n(t,f,a=T.DEFAULT){const d=A(t,!1);function $(Ce){return Ce?()=>Ce(d.getTokenOffset(),d.getTokenLength()):()=>!0}function p(Ce){return Ce?se=>Ce(se,d.getTokenOffset(),d.getTokenLength()):()=>!0}const v=$(f.onObjectBegin),y=p(f.onObjectProperty),h=$(f.onObjectEnd),E=$(f.onArrayBegin),k=$(f.onArrayEnd),I=p(f.onLiteralValue),P=p(f.onSeparator),V=$(f.onComment),W=p(f.onError),q=a&&a.disallowComments,R=a&&a.allowTrailingComma;function z(){for(;;){const Ce=d.scan();switch(d.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:q||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(Ce){case 12:case 13:q?G(10):V();break;case 16:G(1);break;case 15:case 14:break;default:return Ce}}}function G(Ce,se=[],Oe=[]){if(W(Ce),se.length+Oe.length>0){let ne=d.getToken();for(;ne!==17;){if(se.indexOf(ne)!==-1){z();break}else if(Oe.indexOf(ne)!==-1)break;ne=z()}}}function ie(Ce){const se=d.getTokenValue();return Ce?I(se):y(se),z(),!0}function de(){switch(d.getToken()){case 11:{let Ce=0;try{Ce=JSON.parse(d.getTokenValue()),typeof Ce!="number"&&(G(2),Ce=0)}catch{G(2)}I(Ce);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return z(),!0}function ye(){return d.getToken()!==10?(G(3,[],[2,5]),!1):(ie(!1),d.getToken()===6?(P(":"),z(),ue()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function De(){v(),z();let Ce=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(Ce||G(4,[],[]),P(","),z(),d.getToken()===2&&R)break}else Ce&&G(6,[],[]);ye()||G(4,[],[2,5]),Ce=!0}return h(),d.getToken()!==2?G(7,[2],[]):z(),!0}function ge(){E(),z();let Ce=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(Ce||G(4,[],[]),P(","),z(),d.getToken()===4&&R)break}else Ce&&G(6,[],[]);ue()||G(4,[],[4,5]),Ce=!0}return k(),d.getToken()!==4?G(8,[4],[]):z(),!0}function ue(){switch(d.getToken()){case 3:return ge();case 1:return De();case 10:return ie(!0);default:return de()}}return z(),d.getToken()===17?a.allowEmptyContent?!0:(G(4,[],[]),!1):ue()?(d.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}function c(t,f){const a=A(t),d=[];let $,p=0,v;do switch(v=a.getPosition(),$=a.scan(),$){case 12:case 13:case 17:p!==v&&d.push(t.substring(p,v)),f!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,f)),p=a.getPosition();break}while($!==17);return d.join("")}function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(le,e){typeof define=="function"&&define.amd?define(Se[127],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(ke,be){for(var me=0;me<be.length;me++){var Q=be[me];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(ke,Q.key,Q)}}function C(ke,be,me){return be&&e(ke.prototype,be),me&&e(ke,me),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function O(ke,be){if(ke){if(typeof ke=="string")return M(ke,be);var me=Object.prototype.toString.call(ke).slice(8,-1);if(me==="Object"&&ke.constructor&&(me=ke.constructor.name),me==="Map"||me==="Set")return Array.from(ke);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return M(ke,be)}}function M(ke,be){(be==null||be>ke.length)&&(be=ke.length);for(var me=0,Q=new Array(be);me<be;me++)Q[me]=ke[me];return Q}function T(ke,be){var me=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(me)return(me=me.call(ke)).next.bind(me);if(Array.isArray(ke)||(me=O(ke))||be&&ke&&typeof ke.length=="number"){me&&(ke=me);var Q=0;return function(){return Q>=ke.length?{done:!0}:{done:!1,value:ke[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=A();function b(ke){le.defaults=ke}var m=/[&<>"']/,D=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(be){return l[be]};function g(ke,be){if(be){if(m.test(ke))return ke.replace(D,w)}else if(N.test(ke))return ke.replace(S,w);return ke}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(ke){return ke.replace(r,function(be,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(ke,be){ke=typeof ke=="string"?ke:ke.source,be=be||"";var me={replace:function(Y,he){return he=he.source||he,he=he.replace(o,"$1"),ke=ke.replace(Y,he),me},getRegex:function(){return new RegExp(ke,be)}};return me}var n=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(ke,be,me){if(ke){var Q;try{Q=decodeURIComponent(s(me)).replace(n,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}be&&!c.test(me)&&(me=$(be,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var t={},f=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(ke,be){t[" "+ke]||(f.test(ke)?t[" "+ke]=ke+"/":t[" "+ke]=h(ke,"/",!0)),ke=t[" "+ke];var me=ke.indexOf(":")===-1;return be.substring(0,2)==="//"?me?be:ke.replace(a,"$1")+be:be.charAt(0)==="/"?me?be:ke.replace(d,"$1")+be:ke+be}var p={exec:function(){}};function v(ke){for(var be=1,me,Q;be<arguments.length;be++){me=arguments[be];for(Q in me)Object.prototype.hasOwnProperty.call(me,Q)&&(ke[Q]=me[Q])}return ke}function y(ke,be){var me=ke.replace(/\|/g,function(he,ce,Te){for(var fe=!1,Pe=ce;--Pe>=0&&Te[Pe]==="\\";)fe=!fe;return fe?"|":" |"}),Q=me.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>be)Q.splice(be);else for(;Q.length<be;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function h(ke,be,me){var Q=ke.length;if(Q===0)return"";for(var Y=0;Y<Q;){var he=ke.charAt(Q-Y-1);if(he===be&&!me)Y++;else if(he!==be&&me)Y++;else break}return ke.slice(0,Q-Y)}function E(ke,be){if(ke.indexOf(be[1])===-1)return-1;for(var me=ke.length,Q=0,Y=0;Y<me;Y++)if(ke[Y]==="\\")Y++;else if(ke[Y]===be[0])Q++;else if(ke[Y]===be[1]&&(Q--,Q<0))return Y;return-1}function k(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(ke,be){if(be<1)return"";for(var me="";be>1;)be&1&&(me+=ke),be>>=1,ke+=ke;return me+ke}function P(ke,be,me,Q){var Y=be.href,he=be.title?g(be.title):null,ce=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){Q.state.inLink=!0;var Te={type:"link",raw:me,href:Y,title:he,text:ce,tokens:Q.inlineTokens(ce)};return Q.state.inLink=!1,Te}return{type:"image",raw:me,href:Y,title:he,text:g(ce)}}function V(ke,be){var me=ke.match(/^(\s+)(?:```)/);if(me===null)return be;var Q=me[1];return be.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var ce=he[0];return ce.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var W=function(){function ke(me){this.options=me||le.defaults}var be=ke.prototype;return be.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},be.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:h(he,`
`)}}},be.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var he=Y[0],ce=V(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:ce}}},be.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var ce=h(he,"#");(this.options.pedantic||!ce||/ $/.test(ce))&&(he=ce.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},be.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},be.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},be.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var he,ce,Te,fe,Pe,Re,Ue,B,F,H,K,te,re=Y[1].trim(),Ne=re.length>1,Be={type:"list",raw:"",ordered:Ne,start:Ne?+re.slice(0,-1):"",loose:!1,items:[]};re=Ne?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Ne?re:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(te=!1,!(!(Y=Ke.exec(Q))||this.rules.block.hr.test(Q)));){if(he=Y[0],Q=Q.substring(he.length),B=Y[2].split(`
`,1)[0],F=Q.split(`
`,1)[0],this.options.pedantic?(fe=2,K=B.trimLeft()):(fe=Y[2].search(/[^ ]/),fe=fe>4?1:fe,K=B.slice(fe),fe+=Y[1].length),Re=!1,!B&&/^ *$/.test(F)&&(he+=F+`
`,Q=Q.substring(F.length+1),te=!0),!te)for(var _e=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");Q&&(H=Q.split(`
`,1)[0],B=H,this.options.pedantic&&(B=B.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(B)||tt.test(B)||_e.test(B)||xe.test(Q)));){if(B.search(/[^ ]/)>=fe||!B.trim())K+=`
`+B.slice(fe);else if(!Re)K+=`
`+B;else break;!Re&&!B.trim()&&(Re=!0),he+=H+`
`,Q=Q.substring(H.length+1)}Be.loose||(Ue?Be.loose=!0:/\n *\n *$/.test(he)&&(Ue=!0)),this.options.gfm&&(ce=/^\[[ xX]\] /.exec(K),ce&&(Te=ce[0]!=="[ ] ",K=K.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!ce,checked:Te,loose:!1,text:K}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=K.trimRight(),Be.raw=Be.raw.trimRight();var it=Be.items.length;for(Pe=0;Pe<it;Pe++){this.lexer.state.top=!1,Be.items[Pe].tokens=this.lexer.blockTokens(Be.items[Pe].text,[]);var ot=Be.items[Pe].tokens.filter(function(je){return je.type==="space"}),gt=ot.every(function(je){for(var rt=je.raw.split(""),Z=0,X=T(rt),$e;!($e=X()).done;){var He=$e.value;if(He===`
`&&(Z+=1),Z>1)return!0}return!1});!Be.loose&&ot.length&&gt&&(Be.loose=!0,Be.items[Pe].loose=!0)}return Be}},be.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var ce=this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]);he.type="paragraph",he.text=ce,he.tokens=this.lexer.inline(ce)}return he}},be.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},be.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var he={type:"table",header:y(Y[1]).map(function(Ue){return{text:Ue}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var ce=he.align.length,Te,fe,Pe,Re;for(Te=0;Te<ce;Te++)/^ *-+: *$/.test(he.align[Te])?he.align[Te]="right":/^ *:-+: *$/.test(he.align[Te])?he.align[Te]="center":/^ *:-+ *$/.test(he.align[Te])?he.align[Te]="left":he.align[Te]=null;for(ce=he.rows.length,Te=0;Te<ce;Te++)he.rows[Te]=y(he.rows[Te],he.header.length).map(function(Ue){return{text:Ue}});for(ce=he.header.length,fe=0;fe<ce;fe++)he.header[fe].tokens=this.lexer.inline(he.header[fe].text);for(ce=he.rows.length,fe=0;fe<ce;fe++)for(Re=he.rows[fe],Pe=0;Pe<Re.length;Pe++)Re[Pe].tokens=this.lexer.inline(Re[Pe].text);return he}}},be.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},be.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},be.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},be.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:g(Y[1])}},be.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]):Y[0]}},be.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var ce=h(he.slice(0,-1),"\\");if((he.length-ce.length)%2===0)return}else{var Te=E(Y[2],"()");if(Te>-1){var fe=Y[0].indexOf("!")===0?5:4,Pe=fe+Y[1].length+Te;Y[2]=Y[2].substring(0,Te),Y[0]=Y[0].substring(0,Pe).trim(),Y[3]=""}}var Re=Y[2],Ue="";if(this.options.pedantic){var B=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);B&&(Re=B[1],Ue=B[3])}else Ue=Y[3]?Y[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(he)?Re=Re.slice(1):Re=Re.slice(1,-1)),P(Y,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Ue&&Ue.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},be.reflink=function(Q,Y){var he;if((he=this.rules.inline.reflink.exec(Q))||(he=this.rules.inline.nolink.exec(Q))){var ce=(he[2]||he[1]).replace(/\s+/g," ");if(ce=Y[ce.toLowerCase()],!ce||!ce.href){var Te=he[0].charAt(0);return{type:"text",raw:Te,text:Te}}return P(he,ce,he[0],this.lexer)}},be.emStrong=function(Q,Y,he){he===void 0&&(he="");var ce=this.rules.inline.emStrong.lDelim.exec(Q);if(ce&&!(ce[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=ce[1]||ce[2]||"";if(!Te||Te&&(he===""||this.rules.inline.punctuation.exec(he))){var fe=ce[0].length-1,Pe,Re,Ue=fe,B=0,F=ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(F.lastIndex=0,Y=Y.slice(-1*Q.length+fe);(ce=F.exec(Y))!=null;)if(Pe=ce[1]||ce[2]||ce[3]||ce[4]||ce[5]||ce[6],!!Pe){if(Re=Pe.length,ce[3]||ce[4]){Ue+=Re;continue}else if((ce[5]||ce[6])&&fe%3&&!((fe+Re)%3)){B+=Re;continue}if(Ue-=Re,!(Ue>0)){if(Re=Math.min(Re,Re+Ue+B),Math.min(fe,Re)%2){var H=Q.slice(1,fe+ce.index+Re);return{type:"em",raw:Q.slice(0,fe+ce.index+Re+1),text:H,tokens:this.lexer.inlineTokens(H)}}var K=Q.slice(2,fe+ce.index+Re-1);return{type:"strong",raw:Q.slice(0,fe+ce.index+Re+1),text:K,tokens:this.lexer.inlineTokens(K)}}}}}},be.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var he=Y[2].replace(/\n/g," "),ce=/[^ ]/.test(he),Te=/^ /.test(he)&&/ $/.test(he);return ce&&Te&&(he=he.substring(1,he.length-1)),he=g(he,!0),{type:"codespan",raw:Y[0],text:he}}},be.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},be.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},be.autolink=function(Q,Y){var he=this.rules.inline.autolink.exec(Q);if(he){var ce,Te;return he[2]==="@"?(ce=g(this.options.mangle?Y(he[1]):he[1]),Te="mailto:"+ce):(ce=g(he[1]),Te=ce),{type:"link",raw:he[0],text:ce,href:Te,tokens:[{type:"text",raw:ce,text:ce}]}}},be.url=function(Q,Y){var he;if(he=this.rules.inline.url.exec(Q)){var ce,Te;if(he[2]==="@")ce=g(this.options.mangle?Y(he[0]):he[0]),Te="mailto:"+ce;else{var fe;do fe=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(fe!==he[0]);ce=g(he[0]),he[1]==="www."?Te="http://"+ce:Te=ce}return{type:"link",raw:he[0],text:ce,href:Te,tokens:[{type:"text",raw:ce,text:ce}]}}},be.inlineText=function(Q,Y){var he=this.rules.inline.text.exec(Q);if(he){var ce;return this.lexer.state.inRawBlock?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):g(he[0]):he[0]:ce=g(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:ce}}},ke}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=i(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=i(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=i(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=i(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=i(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=v({},q),q.gfm=v({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=i(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=i(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=v({},q.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:i(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=i(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=i(q._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=i(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=i(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=i(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=i(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=i(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=i(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=i(R.reflink).replace("label",R._label).replace("ref",q._label).getRegex(),R.nolink=i(R.nolink).replace("ref",q._label).getRegex(),R.reflinkSearch=i(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=v({},R),R.pedantic=v({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=v({},R.normal,{escape:i(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=i(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=v({},R.gfm,{br:i(R.br).replace("{2,}","*").getRegex(),text:i(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(ke){var be="",me,Q,Y=ke.length;for(me=0;me<Y;me++)Q=ke.charCodeAt(me),Math.random()>.5&&(Q="x"+Q.toString(16)),be+="&#"+Q+";";return be}var ie=function(){function ke(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||le.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:R.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=R.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=R.breaks:Q.inline=R.gfm),this.tokenizer.rules=Q}ke.lex=function(Q,Y){var he=new ke(Y);return he.lex(Q)},ke.lexInline=function(Q,Y){var he=new ke(Y);return he.inlineTokens(Q)};var be=ke.prototype;return be.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},be.blockTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(Ue,B,F){return B+"    ".repeat(F.length)});for(var ce,Te,fe,Pe;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ue){return(ce=Ue.call({lexer:he},Q,Y))?(Q=Q.substring(ce.raw.length),Y.push(ce),!0):!1}))){if(ce=this.tokenizer.space(Q)){Q=Q.substring(ce.raw.length),ce.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(ce);continue}if(ce=this.tokenizer.code(Q)){Q=Q.substring(ce.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ce.raw,Te.text+=`
`+ce.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(ce);continue}if(ce=this.tokenizer.fences(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.heading(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.hr(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.blockquote(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.list(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.html(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.def(Q)){Q=Q.substring(ce.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ce.raw,Te.text+=`
`+ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[ce.tag]||(this.tokens.links[ce.tag]={href:ce.href,title:ce.title});continue}if(ce=this.tokenizer.table(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.lheading(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(fe=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ue=1/0,B=Q.slice(1),F=void 0;he.options.extensions.startBlock.forEach(function(H){F=H.call({lexer:this},B),typeof F=="number"&&F>=0&&(Ue=Math.min(Ue,F))}),Ue<1/0&&Ue>=0&&(fe=Q.substring(0,Ue+1))}(),this.state.top&&(ce=this.tokenizer.paragraph(fe))){Te=Y[Y.length-1],Pe&&Te.type==="paragraph"?(Te.raw+=`
`+ce.raw,Te.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(ce),Pe=fe.length!==Q.length,Q=Q.substring(ce.raw.length);continue}if(ce=this.tokenizer.text(Q)){Q=Q.substring(ce.raw.length),Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+ce.raw,Te.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(ce);continue}if(Q){var Re="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,Y},be.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},be.inlineTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]);var ce,Te,fe,Pe=Q,Re,Ue,B;if(this.tokens.links){var F=Object.keys(this.tokens.links);if(F.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)F.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Re.index)+"["+I("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"["+I("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(Ue||(B=""),Ue=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(K){return(ce=K.call({lexer:he},Q,Y))?(Q=Q.substring(ce.raw.length),Y.push(ce),!0):!1}))){if(ce=this.tokenizer.escape(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.tag(Q)){Q=Q.substring(ce.raw.length),Te=Y[Y.length-1],Te&&ce.type==="text"&&Te.type==="text"?(Te.raw+=ce.raw,Te.text+=ce.text):Y.push(ce);continue}if(ce=this.tokenizer.link(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ce.raw.length),Te=Y[Y.length-1],Te&&ce.type==="text"&&Te.type==="text"?(Te.raw+=ce.raw,Te.text+=ce.text):Y.push(ce);continue}if(ce=this.tokenizer.emStrong(Q,Pe,B)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.codespan(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.br(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.del(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.autolink(Q,G)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(!this.state.inLink&&(ce=this.tokenizer.url(Q,G))){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(fe=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var K=1/0,te=Q.slice(1),re=void 0;he.options.extensions.startInline.forEach(function(Ne){re=Ne.call({lexer:this},te),typeof re=="number"&&re>=0&&(K=Math.min(K,re))}),K<1/0&&K>=0&&(fe=Q.substring(0,K+1))}(),ce=this.tokenizer.inlineText(fe,z)){Q=Q.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(B=ce.raw.slice(-1)),Ue=!0,Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=ce.raw,Te.text+=ce.text):Y.push(ce);continue}if(Q){var H="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return Y},C(ke,null,[{key:"rules",get:function(){return{block:q,inline:R}}}]),ke}(),de=function(){function ke(me){this.options=me||le.defaults}var be=ke.prototype;return be.code=function(Q,Y,he){var ce=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(Q,ce);Te!=null&&Te!==Q&&(he=!0,Q=Te)}return Q=Q.replace(/\n$/,"")+`
`,ce?'<pre><code class="'+this.options.langPrefix+g(ce,!0)+'">'+(he?Q:g(Q,!0))+`</code></pre>
`:"<pre><code>"+(he?Q:g(Q,!0))+`</code></pre>
`},be.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},be.html=function(Q){return Q},be.heading=function(Q,Y,he,ce){if(this.options.headerIds){var Te=this.options.headerPrefix+ce.slug(he);return"<h"+Y+' id="'+Te+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(Q,Y,he){var ce=Y?"ol":"ul",Te=Y&&he!==1?' start="'+he+'"':"";return"<"+ce+Te+`>
`+Q+"</"+ce+`>
`},be.listitem=function(Q){return"<li>"+Q+`</li>
`},be.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(Q){return"<p>"+Q+`</p>
`},be.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},be.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},be.tablecell=function(Q,Y){var he=Y.header?"th":"td",ce=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return ce+Q+("</"+he+`>
`)},be.strong=function(Q){return"<strong>"+Q+"</strong>"},be.em=function(Q){return"<em>"+Q+"</em>"},be.codespan=function(Q){return"<code>"+Q+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(Q){return"<del>"+Q+"</del>"},be.link=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ce='<a href="'+g(Q)+'"';return Y&&(ce+=' title="'+Y+'"'),ce+=">"+he+"</a>",ce},be.image=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ce='<img src="'+Q+'" alt="'+he+'"';return Y&&(ce+=' title="'+Y+'"'),ce+=this.options.xhtml?"/>":">",ce},be.text=function(Q){return Q},ke}(),ye=function(){function ke(){}var be=ke.prototype;return be.strong=function(Q){return Q},be.em=function(Q){return Q},be.codespan=function(Q){return Q},be.del=function(Q){return Q},be.html=function(Q){return Q},be.text=function(Q){return Q},be.link=function(Q,Y,he){return""+he},be.image=function(Q,Y,he){return""+he},be.br=function(){return""},ke}(),De=function(){function ke(){this.seen={}}var be=ke.prototype;return be.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(Q,Y){var he=Q,ce=0;if(this.seen.hasOwnProperty(he)){ce=this.seen[Q];do ce++,he=Q+"-"+ce;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[Q]=ce,this.seen[he]=0),he},be.slug=function(Q,Y){Y===void 0&&(Y={});var he=this.serialize(Q);return this.getNextSafeSlug(he,Y.dryrun)},ke}(),ge=function(){function ke(me){this.options=me||le.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new De}ke.parse=function(Q,Y){var he=new ke(Y);return he.parse(Q)},ke.parseInline=function(Q,Y){var he=new ke(Y);return he.parseInline(Q)};var be=ke.prototype;return be.parse=function(Q,Y){Y===void 0&&(Y=!0);var he="",ce,Te,fe,Pe,Re,Ue,B,F,H,K,te,re,Ne,Be,Ke,_e,xe,et,tt,it=Q.length;for(ce=0;ce<it;ce++){if(K=Q[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[K.type]&&(tt=this.options.extensions.renderers[K.type].call({parser:this},K),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(K.type))){he+=tt||"";continue}switch(K.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(K.tokens),K.depth,s(this.parseInline(K.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(K.text,K.lang,K.escaped);continue}case"table":{for(F="",B="",Pe=K.header.length,Te=0;Te<Pe;Te++)B+=this.renderer.tablecell(this.parseInline(K.header[Te].tokens),{header:!0,align:K.align[Te]});for(F+=this.renderer.tablerow(B),H="",Pe=K.rows.length,Te=0;Te<Pe;Te++){for(Ue=K.rows[Te],B="",Re=Ue.length,fe=0;fe<Re;fe++)B+=this.renderer.tablecell(this.parseInline(Ue[fe].tokens),{header:!1,align:K.align[fe]});H+=this.renderer.tablerow(B)}he+=this.renderer.table(F,H);continue}case"blockquote":{H=this.parse(K.tokens),he+=this.renderer.blockquote(H);continue}case"list":{for(te=K.ordered,re=K.start,Ne=K.loose,Pe=K.items.length,H="",Te=0;Te<Pe;Te++)Ke=K.items[Te],_e=Ke.checked,xe=Ke.task,Be="",Ke.task&&(et=this.renderer.checkbox(_e),Ne?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=et+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=et+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(Ke.tokens,Ne),H+=this.renderer.listitem(Be,xe,_e);he+=this.renderer.list(H,te,re);continue}case"html":{he+=this.renderer.html(K.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(K.tokens));continue}case"text":{for(H=K.tokens?this.parseInline(K.tokens):K.text;ce+1<it&&Q[ce+1].type==="text";)K=Q[++ce],H+=`
`+(K.tokens?this.parseInline(K.tokens):K.text);he+=Y?this.renderer.paragraph(H):H;continue}default:{var ot='Token with "'+K.type+'" type was not found.';if(this.options.silent){console.error(ot);return}else throw new Error(ot)}}}return he},be.parseInline=function(Q,Y){Y=Y||this.renderer;var he="",ce,Te,fe,Pe=Q.length;for(ce=0;ce<Pe;ce++){if(Te=Q[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(fe=this.options.extensions.renderers[Te.type].call({parser:this},Te),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){he+=fe||"";continue}switch(Te.type){case"escape":{he+=Y.text(Te.text);break}case"html":{he+=Y.html(Te.text);break}case"link":{he+=Y.link(Te.href,Te.title,this.parseInline(Te.tokens,Y));break}case"image":{he+=Y.image(Te.href,Te.title,Te.text);break}case"strong":{he+=Y.strong(this.parseInline(Te.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Te.tokens,Y));break}case"codespan":{he+=Y.codespan(Te.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Te.tokens,Y));break}case"text":{he+=Y.text(Te.text);break}default:{var Re='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return he},ke}();function ue(ke,be,me){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof be=="function"&&(me=be,be=null),be=v({},ue.defaults,be||{}),k(be),me){var Q=be.highlight,Y;try{Y=ie.lex(ke,be)}catch(Pe){return me(Pe)}var he=function(Re){var Ue;if(!Re)try{be.walkTokens&&ue.walkTokens(Y,be.walkTokens),Ue=ge.parse(Y,be)}catch(B){Re=B}return be.highlight=Q,Re?me(Re):me(null,Ue)};if(!Q||Q.length<3||(delete be.highlight,!Y.length))return he();var ce=0;ue.walkTokens(Y,function(Pe){Pe.type==="code"&&(ce++,setTimeout(function(){Q(Pe.text,Pe.lang,function(Re,Ue){if(Re)return he(Re);Ue!=null&&Ue!==Pe.text&&(Pe.text=Ue,Pe.escaped=!0),ce--,ce===0&&he()})},0))}),ce===0&&he();return}function Te(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+g(Pe.message+"",!0)+"</pre>";throw Pe}try{var fe=ie.lex(ke,be);if(be.walkTokens){if(be.async)return Promise.all(ue.walkTokens(fe,be.walkTokens)).then(function(){return ge.parse(fe,be)}).catch(Te);ue.walkTokens(fe,be.walkTokens)}return ge.parse(fe,be)}catch(Pe){Te(Pe)}}ue.options=ue.setOptions=function(ke){return v(ue.defaults,ke),b(ue.defaults),ue},ue.getDefaults=A,ue.defaults=le.defaults,ue.use=function(){for(var ke=arguments.length,be=new Array(ke),me=0;me<ke;me++)be[me]=arguments[me];var Q=v.apply(void 0,[{}].concat(be)),Y=ue.defaults.extensions||{renderers:{},childTokens:{}},he;be.forEach(function(ce){if(ce.extensions&&(he=!0,ce.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var Pe=Y.renderers?Y.renderers[fe.name]:null;Pe?Y.renderers[fe.name]=function(){for(var Re=arguments.length,Ue=new Array(Re),B=0;B<Re;B++)Ue[B]=arguments[B];var F=fe.renderer.apply(this,Ue);return F===!1&&(F=Pe.apply(this,Ue)),F}:Y.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[fe.level]?Y[fe.level].unshift(fe.tokenizer):Y[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?Y.startBlock?Y.startBlock.push(fe.start):Y.startBlock=[fe.start]:fe.level==="inline"&&(Y.startInline?Y.startInline.push(fe.start):Y.startInline=[fe.start]))}fe.childTokens&&(Y.childTokens[fe.name]=fe.childTokens)})),ce.renderer&&function(){var fe=ue.defaults.renderer||new de,Pe=function(B){var F=fe[B];fe[B]=function(){for(var H=arguments.length,K=new Array(H),te=0;te<H;te++)K[te]=arguments[te];var re=ce.renderer[B].apply(fe,K);return re===!1&&(re=F.apply(fe,K)),re}};for(var Re in ce.renderer)Pe(Re);Q.renderer=fe}(),ce.tokenizer&&function(){var fe=ue.defaults.tokenizer||new W,Pe=function(B){var F=fe[B];fe[B]=function(){for(var H=arguments.length,K=new Array(H),te=0;te<H;te++)K[te]=arguments[te];var re=ce.tokenizer[B].apply(fe,K);return re===!1&&(re=F.apply(fe,K)),re}};for(var Re in ce.tokenizer)Pe(Re);Q.tokenizer=fe}(),ce.walkTokens){var Te=ue.defaults.walkTokens;Q.walkTokens=function(fe){var Pe=[];return Pe.push(ce.walkTokens.call(this,fe)),Te&&(Pe=Pe.concat(Te.call(this,fe))),Pe}}he&&(Q.extensions=Y),ue.setOptions(Q)})},ue.walkTokens=function(ke,be){for(var me=[],Q=function(){var Te=he.value;switch(me=me.concat(be.call(ue,Te)),Te.type){case"table":{for(var fe=T(Te.header),Pe;!(Pe=fe()).done;){var Re=Pe.value;me=me.concat(ue.walkTokens(Re.tokens,be))}for(var Ue=T(Te.rows),B;!(B=Ue()).done;)for(var F=B.value,H=T(F),K;!(K=H()).done;){var te=K.value;me=me.concat(ue.walkTokens(te.tokens,be))}break}case"list":{me=me.concat(ue.walkTokens(Te.items,be));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Te.type]?ue.defaults.extensions.childTokens[Te.type].forEach(function(re){me=me.concat(ue.walkTokens(Te[re],be))}):Te.tokens&&(me=me.concat(ue.walkTokens(Te.tokens,be)))}},Y=T(ke),he;!(he=Y()).done;)Q();return me},ue.parseInline=function(ke,be){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");be=v({},ue.defaults,be||{}),k(be);try{var me=ie.lexInline(ke,be);return be.walkTokens&&ue.walkTokens(me,be.walkTokens),ge.parseInline(me,be)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+g(Q.message+"",!0)+"</pre>";throw Q}},ue.Parser=ge,ue.parser=ge.parse,ue.Renderer=de,ue.TextRenderer=ye,ue.Lexer=ie,ue.lexer=ie.lex,ue.Tokenizer=W,ue.Slugger=De,ue.parse=ue;var Ce=ue.options,se=ue.setOptions,Oe=ue.use,ne=ue.walkTokens,j=ue.parseInline,x=ue,ve=ge.parse,Le=ie.lex;le.Lexer=ie,le.Parser=ge,le.Renderer=de,le.Slugger=De,le.TextRenderer=ye,le.Tokenizer=W,le.getDefaults=A,le.lexer=Le,le.marked=ue,le.options=Ce,le.parse=x,le.parseInline=j,le.parser=ve,le.setOptions=se,le.use=Oe,le.walkTokens=ne,Object.defineProperty(le,"__esModule",{value:!0})}),define(Se[128],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=C;function C(r){const s=T(r);if(s&&s.length>0)return new Uint32Array(s)}let O=0;const M=new Uint32Array(10);function T(r){if(O=0,A(r,S,4352),O>0||(A(r,l,4449),O>0)||(A(r,w,4520),O>0)||(A(r,g,12593),O))return M.subarray(0,O);if(r>=44032&&r<=55203){const s=r-44032,o=s%588,i=Math.floor(s/588),n=Math.floor(o/28),c=o%28-1;if(i<S.length?A(i,S,0):4352+i-12593<g.length&&A(4352+i,g,12593),n<l.length?A(n,l,0):4449+n-12593<g.length&&A(4449+n-12593,g,12593),c>=0&&(c<w.length?A(c,w,0):4520+c-12593<g.length&&A(4520+c-12593,g,12593)),O>0)return M.subarray(0,O)}}function A(r,s,o){r>=o&&r<o+s.length&&b(s[r-o])}function b(r){r!==0&&(M[O++]=r&255,r>>8&&(M[O++]=r>>8&255),r>>16&&(M[O++]=r>>16&255))}var m;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var D;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(D||(D={}));var N;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(N||(N={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),g=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[129],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=C,e.rot=O;function C(b,m,D){return Math.min(Math.max(b,m),D)}function O(b,m){return(m+b%m)%m}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=M;class T{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=T;class A{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const D=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=A}),define(Se[130],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=T,e.$cd=l;class C{constructor(g,r,s){this.owner=g,this.debugNameSource=r,this.referenceFn=s}getDebugName(g){return T(g,this)}}e.$ad=C;const O=new Map,M=new WeakMap;function T(w,g){const r=M.get(w);if(r)return r;const s=A(w,g);if(s){let o=O.get(s)??0;o++,O.set(s,o);const i=o===1?s:`${s}#${o}`;return M.set(w,i),i}}function A(w,g){const r=M.get(w);if(r)return r;const s=g.owner?N(g.owner)+".":"";let o;const i=g.debugNameSource;if(i!==void 0)if(typeof i=="function"){if(o=i(),o!==void 0)return s+o}else return s+i;const n=g.referenceFn;if(n!==void 0&&(o=l(n),o!==void 0))return s+o;if(g.owner!==void 0){const c=b(g.owner,w);if(c!==void 0)return s+c}}function b(w,g){for(const r in w)if(w[r]===g)return r}const m=new Map,D=new WeakMap;function N(w){const g=D.get(w);if(g)return g;const r=S(w);let s=m.get(r)??0;s++,m.set(r,s);const o=s===1?r:`${r}#${s}`;return D.set(w,o),o}function S(w){const g=w.constructor;return g?g.name:"Object"}function l(w){const g=w.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(g);return(s?s[1]:void 0)?.trim()}}),define(Se[131],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=O,e.$Id=M;let C;function O(r){C=r}function M(){return C}class T{constructor(){this.a=0,this.d=new WeakMap}b(s){return A([b(w("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[b(" "),D(N(s.oldValue,70),{color:"red",strikeThrough:!0}),b(" "),D(N(s.newValue,60),{color:"green"})]:[b(" (unchanged)")]:[b(" "),D(N(s.newValue,60),{color:"green"}),b(" (initial)")]}handleObservableChanged(s,o){console.log(...this.b([m("observable value changed"),D(s.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(s){if(s.size!==0)return D(" (changed deps: "+[...s].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(i,n)=>(this.d.get(s).add(i),o.apply(s,[i,n]))}handleDerivedRecomputed(s,o){const i=this.d.get(s);console.log(...this.b([m("derived recomputed"),D(s.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(i),{data:[{fn:s._computeFn}]}])),i.clear()}handleFromEventObservableTriggered(s,o){console.log(...this.b([m("observable from event triggered"),D(s.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const o=s.handleChange;this.d.set(s,new Set),s.handleChange=(i,n)=>(this.d.get(s).add(i),o.apply(s,[i,n]))}handleAutorunTriggered(s){const o=this.d.get(s);console.log(...this.b([m("autorun"),D(s.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:s._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let o=s.getDebugName();o===void 0&&(o=""),console.log(...this.b([m("transaction"),D(o,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=T;function A(r){const s=new Array,o=[];let i="";function n(u){if("length"in u)for(const t of u)t&&n(t);else"text"in u?(i+=`%c${u.text}`,s.push(u.style),u.data&&o.push(...u.data)):"data"in u&&o.push(...u.data)}n(r);const c=[i,...s];return c.push(...o),c}function b(r){return D(r,{color:"black"})}function m(r){return D(g(`${r}: `,10),{color:"black",bold:!0})}function D(r,s={color:"black"}){function o(n){return Object.entries(n).reduce((c,[u,t])=>`${c}${u}:${t};`,"")}const i={color:s.color};return s.strikeThrough&&(i["text-decoration"]="line-through"),s.bold&&(i["font-weight"]="bold"),{text:r,style:o(i)}}function N(r,s){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=s?`"${r}"`:`"${r.substr(0,s-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?S(r,s):l(r,s);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function S(r,s){let o="[ ",i=!0;for(const n of r){if(i||(o+=", "),o.length-5>s){o+="...";break}i=!1,o+=`${N(n,s-o.length)}`}return o+=" ]",o}function l(r,s){let o="{ ",i=!0;for(const[n,c]of Object.entries(r)){if(i||(o+=", "),o.length-5>s){o+="...";break}i=!1,o+=`${n}: ${N(c,s-o.length)}`}return o+=" }",o}function w(r,s){let o="";for(let i=1;i<=s;i++)o+=r;return o}function g(r,s){for(;r.length<s;)r+=" ";return r}}),define(Se[132],Ie([1,0,125,130,131]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=A,e.$Td=m,e.$Ud=N,e.$Xd=w,e.$Yd=r,e.$Zd=s,e.$1d=o,e.$3d=n,e.$4d=c,e.$6d=t;let T;function A(a){T=a}let b;function m(a){b=a}let D;function N(a){D=a}class S{get TChange(){return null}reportChanges(){this.get()}read(d){return d?d.readObservable(this):this.get()}map(d,$){const p=$===void 0?void 0:d,v=$===void 0?d:$;return D({owner:p,debugName:()=>{const y=(0,O.$cd)(v);if(y!==void 0)return y;const E=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(v.toString());if(E)return`${this.debugName}.${E[2]}`;if(!p)return`${this.debugName} (mapped)`},debugReferenceFn:v},y=>v(this.read(y),y))}recomputeInitiallyAndOnChange(d,$){return d.add(T(this,$)),this}keepObserved(d){return d.add(b(this)),this}get a(){return this.get()}}e.$Vd=S;class l extends S{constructor(){super(...arguments),this.b=new Set}addObserver(d){const $=this.b.size;this.b.add(d),$===0&&this.c()}removeObserver(d){this.b.delete(d)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=l;function w(a,d){const $=new i(a,d);try{a($)}finally{$.finish()}}let g;function r(a){if(g)a(g);else{const d=new i(a,void 0);g=d;try{a(d)}finally{d.finish(),g=void 0}}}async function s(a,d){const $=new i(a,d);try{await a($)}finally{$.finish()}}function o(a,d,$){a?d(a):w(d,$)}class i{constructor(d,$){this._fn=d,this.b=$,this.a=[],(0,M.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,O.$cd)(this._fn)}updateObserver(d,$){this.a.push({observer:d,observable:$}),d.beginUpdate($)}finish(){const d=this.a;for(let $=0;$<d.length;$++){const{observer:p,observable:v}=d[$];p.endUpdate(v)}this.a=null,(0,M.$Id)()?.handleEndTransaction()}}e.$2d=i;function n(a,d){let $;return typeof a=="string"?$=new O.$ad(void 0,a,void 0):$=new O.$ad(a,void 0,void 0),new u($,d,C.$6c)}function c(a,d){return new u(new O.$ad(a.owner,a.debugName,void 0),d,a.equalsFn??C.$6c)}class u extends l{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(d,$,p){super(),this.e=d,this.g=p,this.d=$}get(){return this.d}set(d,$,p){if(p===void 0&&this.g(this.d,d))return;let v;$||($=v=new i(()=>{},()=>`Setting ${this.debugName}`));try{const y=this.d;this.h(d),(0,M.$Id)()?.handleObservableChanged(this,{oldValue:y,newValue:d,change:p,didChange:!0,hadValue:!0});for(const h of this.b)$.updateObserver(h,this),h.handleChange(this,p)}finally{v&&v.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(d){this.d=d}}e.$5d=u;function t(a,d){let $;return typeof a=="string"?$=new O.$ad(void 0,a,void 0):$=new O.$ad(a,void 0,void 0),new f($,d,C.$6c)}class f extends u{h(d){this.d!==d&&(this.d&&this.d.dispose(),this.d=d)}dispose(){this.d?.dispose()}}e.$7d=f}),function(){function le(M){const T=[];typeof M=="number"&&T.push("code/timeOrigin",M);function A(m){T.push(m,Date.now())}function b(){const m=[];for(let D=0;D<T.length;D+=2)m.push({name:T[D],startTime:T[D+1]});return m}return{mark:A,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(M+A.startTime)});return T}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function C(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=C(O))}(),define(Se[133],Ie([1,0,42]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CO=void 0;const O=Symbol("unset");class M{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||C.Iterable.empty()}insert(m,D,N){this.d(m,S=>S._value=D,N)}mutate(m,D){this.d(m,N=>N._value=D(N._value===O?void 0:N._value))}mutatePath(m,D){this.d(m,()=>{},N=>D(N))}delete(m){const D=this.c(m);if(!D)return;let N=D.length-1;const S=D[N].node._value;if(S!==O){for(this.b--,D[N].node._value=O;N>0;N--){const{node:l,part:w}=D[N];if(l.children?.size||l._value!==O)break;D[N-1].node.children.delete(w)}return S}}*deleteRecursive(m){const D=this.c(m);if(!D)return;const N=D[D.length-1].node;for(let S=D.length-1;S>0;S--){const l=D[S-1];if(l.node.children.delete(D[S].part),l.node.children.size>0||l.node._value!==O)break}for(const S of T(N))S._value!==O&&(this.b--,yield S._value)}find(m){let D=this.a;for(const N of m){const S=D.children?.get(N);if(!S)return;D=S}return D._value===O?void 0:D._value}hasKeyOrParent(m){let D=this.a;for(const N of m){const S=D.children?.get(N);if(!S)return!1;if(S._value!==O)return!0;D=S}return!1}hasKeyOrChildren(m){let D=this.a;for(const N of m){const S=D.children?.get(N);if(!S)return!1;D=S}return!0}hasKey(m){let D=this.a;for(const N of m){const S=D.children?.get(N);if(!S)return!1;D=S}return D._value!==O}c(m){const D=[{part:"",node:this.a}];let N=0;for(const S of m){const l=D[N].node.children?.get(S);if(!l)return;D.push({part:S,node:l}),N++}return D}d(m,D,N){let S=this.a;for(const g of m){if(S.children)if(S.children.has(g))S=S.children.get(g);else{const r=new A;S.children.set(g,r),S=r}else{const r=new A;S.children=new Map([[g,r]]),S=r}N?.(S)}const l=S._value===O?0:1;D(S);const w=S._value===O?0:1;this.b+=w-l}*values(){for(const{_value:m}of T(this.a))m!==O&&(yield m)}}e.$CO=M;function*T(b){const m=[b];for(;m.length>0;){const D=m.pop();if(yield D,D.children)for(const N of D.children.values())m.push(N)}}class A{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(m){this._value=m===void 0?O:m}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var O in C)(typeof exports=="object"?exports:le)[O]=C[O]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function C(O){if(e[O])return e[O].exports;var M=e[O]={i:O,l:!1,exports:{}};return le[O].call(M.exports,M,M.exports,C),M.l=!0,M.exports}return C.m=le,C.c=e,C.d=function(O,M,T){C.o(O,M)||Object.defineProperty(O,M,{enumerable:!0,get:T})},C.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},C.t=function(O,M){if(1&M&&(O=C(O)),8&M||4&M&&typeof O=="object"&&O&&O.__esModule)return O;var T=Object.create(null);if(C.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:O}),2&M&&typeof O!="string")for(var A in O)C.d(T,A,function(b){return O[b]}.bind(null,A));return T},C.n=function(O){var M=O&&O.__esModule?function(){return O.default}:function(){return O};return C.d(M,"a",M),M},C.o=function(O,M){return Object.prototype.hasOwnProperty.call(O,M)},C.p="",C(C.s=0)}([function(le,e,C){(function(O){var M;e=le.exports=Oe,M=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],m=e.src=[],D=0,N=D++;m[N]="0|[1-9]\\d*";var S=D++;m[S]="[0-9]+";var l=D++;m[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=D++;m[w]="("+m[N]+")\\.("+m[N]+")\\.("+m[N]+")";var g=D++;m[g]="("+m[S]+")\\.("+m[S]+")\\.("+m[S]+")";var r=D++;m[r]="(?:"+m[N]+"|"+m[l]+")";var s=D++;m[s]="(?:"+m[S]+"|"+m[l]+")";var o=D++;m[o]="(?:-("+m[r]+"(?:\\."+m[r]+")*))";var i=D++;m[i]="(?:-?("+m[s]+"(?:\\."+m[s]+")*))";var n=D++;m[n]="[0-9A-Za-z-]+";var c=D++;m[c]="(?:\\+("+m[n]+"(?:\\."+m[n]+")*))";var u=D++,t="v?"+m[w]+m[o]+"?"+m[c]+"?";m[u]="^"+t+"$";var f="[v=\\s]*"+m[g]+m[i]+"?"+m[c]+"?",a=D++;m[a]="^"+f+"$";var d=D++;m[d]="((?:<|>)?=?)";var $=D++;m[$]=m[S]+"|x|X|\\*";var p=D++;m[p]=m[N]+"|x|X|\\*";var v=D++;m[v]="[v=\\s]*("+m[p]+")(?:\\.("+m[p]+")(?:\\.("+m[p]+")(?:"+m[o]+")?"+m[c]+"?)?)?";var y=D++;m[y]="[v=\\s]*("+m[$]+")(?:\\.("+m[$]+")(?:\\.("+m[$]+")(?:"+m[i]+")?"+m[c]+"?)?)?";var h=D++;m[h]="^"+m[d]+"\\s*"+m[v]+"$";var E=D++;m[E]="^"+m[d]+"\\s*"+m[y]+"$";var k=D++;m[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=D++;m[I]="(?:~>?)";var P=D++;m[P]="(\\s*)"+m[I]+"\\s+",b[P]=new RegExp(m[P],"g");var V=D++;m[V]="^"+m[I]+m[v]+"$";var W=D++;m[W]="^"+m[I]+m[y]+"$";var q=D++;m[q]="(?:\\^)";var R=D++;m[R]="(\\s*)"+m[q]+"\\s+",b[R]=new RegExp(m[R],"g");var z=D++;m[z]="^"+m[q]+m[v]+"$";var G=D++;m[G]="^"+m[q]+m[y]+"$";var ie=D++;m[ie]="^"+m[d]+"\\s*("+f+")$|^$";var de=D++;m[de]="^"+m[d]+"\\s*("+t+")$|^$";var ye=D++;m[ye]="(\\s*)"+m[d]+"\\s*("+f+"|"+m[v]+")",b[ye]=new RegExp(m[ye],"g");var De=D++;m[De]="^\\s*("+m[v]+")\\s+-\\s+("+m[v]+")\\s*$";var ge=D++;m[ge]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var ue=D++;m[ue]="(<|>)?=?\\s*\\*";for(var Ce=0;Ce<35;Ce++)M(Ce,m[Ce]),b[Ce]||(b[Ce]=new RegExp(m[Ce]));function se(F,H){if(F instanceof Oe)return F;if(typeof F!="string"||F.length>T||!(H?b[a]:b[u]).test(F))return null;try{return new Oe(F,H)}catch{return null}}function Oe(F,H){if(F instanceof Oe){if(F.loose===H)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Oe))return new Oe(F,H);M("SemVer",F,H),this.loose=H;var K=F.trim().match(H?b[a]:b[u]);if(!K)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(te){if(/^[0-9]+$/.test(te)){var re=+te;if(re>=0&&re<A)return re}return te}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=se,e.valid=function(F,H){var K=se(F,H);return K?K.version:null},e.clean=function(F,H){var K=se(F.trim().replace(/^[=v]+/,""),H);return K?K.version:null},e.SemVer=Oe,Oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Oe.prototype.toString=function(){return this.version},Oe.prototype.compare=function(F){return M("SemVer.compare",this.version,this.loose,F),F instanceof Oe||(F=new Oe(F,this.loose)),this.compareMain(F)||this.comparePre(F)},Oe.prototype.compareMain=function(F){return F instanceof Oe||(F=new Oe(F,this.loose)),j(this.major,F.major)||j(this.minor,F.minor)||j(this.patch,F.patch)},Oe.prototype.comparePre=function(F){if(F instanceof Oe||(F=new Oe(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],te=F.prerelease[H];if(M("prerelease compare",H,K,te),K===void 0&&te===void 0)return 0;if(te===void 0)return 1;if(K===void 0)return-1;if(K!==te)return j(K,te)}while(++H)},Oe.prototype.inc=function(F,H){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},e.inc=function(F,H,K,te){typeof K=="string"&&(te=K,K=void 0);try{return new Oe(F,K).inc(H,te).version}catch{return null}},e.diff=function(F,H){if(ke(F,H))return null;var K=se(F),te=se(H);if(K.prerelease.length||te.prerelease.length){for(var re in K)if((re==="major"||re==="minor"||re==="patch")&&K[re]!==te[re])return"pre"+re;return"prerelease"}for(var re in K)if((re==="major"||re==="minor"||re==="patch")&&K[re]!==te[re])return re},e.compareIdentifiers=j;var ne=/^[0-9]+$/;function j(F,H){var K=ne.test(F),te=ne.test(H);return K&&te&&(F=+F,H=+H),K&&!te?-1:te&&!K?1:F<H?-1:F>H?1:0}function x(F,H,K){return new Oe(F,K).compare(new Oe(H,K))}function ve(F,H,K){return x(F,H,K)>0}function Le(F,H,K){return x(F,H,K)<0}function ke(F,H,K){return x(F,H,K)===0}function be(F,H,K){return x(F,H,K)!==0}function me(F,H,K){return x(F,H,K)>=0}function Q(F,H,K){return x(F,H,K)<=0}function Y(F,H,K,te){var re;switch(H){case"===":typeof F=="object"&&(F=F.version),typeof K=="object"&&(K=K.version),re=F===K;break;case"!==":typeof F=="object"&&(F=F.version),typeof K=="object"&&(K=K.version),re=F!==K;break;case"":case"=":case"==":re=ke(F,K,te);break;case"!=":re=be(F,K,te);break;case">":re=ve(F,K,te);break;case">=":re=me(F,K,te);break;case"<":re=Le(F,K,te);break;case"<=":re=Q(F,K,te);break;default:throw new TypeError("Invalid operator: "+H)}return re}function he(F,H){if(F instanceof he){if(F.loose===H)return F;F=F.value}if(!(this instanceof he))return new he(F,H);M("comparator",F,H),this.loose=H,this.parse(F),this.semver===ce?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(F,H){return j(H,F)},e.major=function(F,H){return new Oe(F,H).major},e.minor=function(F,H){return new Oe(F,H).minor},e.patch=function(F,H){return new Oe(F,H).patch},e.compare=x,e.compareLoose=function(F,H){return x(F,H,!0)},e.rcompare=function(F,H,K){return x(H,F,K)},e.sort=function(F,H){return F.sort(function(K,te){return e.compare(K,te,H)})},e.rsort=function(F,H){return F.sort(function(K,te){return e.rcompare(K,te,H)})},e.gt=ve,e.lt=Le,e.eq=ke,e.neq=be,e.gte=me,e.lte=Q,e.cmp=Y,e.Comparator=he;var ce={};function Te(F,H){if(F instanceof Te)return F.loose===H?F:new Te(F.raw,H);if(F instanceof he)return new Te(F.value,H);if(!(this instanceof Te))return new Te(F,H);if(this.loose=H,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function fe(F){return!F||F.toLowerCase()==="x"||F==="*"}function Pe(F,H,K,te,re,Ne,Be,Ke,_e,xe,et,tt,it){return((H=fe(K)?"":fe(te)?">="+K+".0.0":fe(re)?">="+K+"."+te+".0":">="+H)+" "+(Ke=fe(_e)?"":fe(xe)?"<"+(+_e+1)+".0.0":fe(et)?"<"+_e+"."+(+xe+1)+".0":tt?"<="+_e+"."+xe+"."+et+"-"+tt:"<="+Ke)).trim()}function Re(F,H){for(var K=0;K<F.length;K++)if(!F[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<F.length;K++)if(M(F[K].semver),F[K].semver!==ce&&F[K].semver.prerelease.length>0){var te=F[K].semver;if(te.major===H.major&&te.minor===H.minor&&te.patch===H.patch)return!0}return!1}return!0}function Ue(F,H,K){try{H=new Te(H,K)}catch{return!1}return H.test(F)}function B(F,H,K,te){var re,Ne,Be,Ke,_e;switch(F=new Oe(F,te),H=new Te(H,te),K){case">":re=ve,Ne=Q,Be=Le,Ke=">",_e=">=";break;case"<":re=Le,Ne=me,Be=ve,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(F,H,te))return!1;for(var xe=0;xe<H.set.length;++xe){var et=H.set[xe],tt=null,it=null;if(et.forEach(function(ot){ot.semver===ce&&(ot=new he(">=0.0.0")),tt=tt||ot,it=it||ot,re(ot.semver,tt.semver,te)?tt=ot:Be(ot.semver,it.semver,te)&&(it=ot)}),tt.operator===Ke||tt.operator===_e||(!it.operator||it.operator===Ke)&&Ne(F,it.semver)||it.operator===_e&&Be(F,it.semver))return!1}return!0}he.prototype.parse=function(F){var H=this.loose?b[ie]:b[de],K=F.match(H);if(!K)throw new TypeError("Invalid comparator: "+F);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new Oe(K[2],this.loose):this.semver=ce},he.prototype.toString=function(){return this.value},he.prototype.test=function(F){return M("Comparator.test",F,this.loose),this.semver===ce||(typeof F=="string"&&(F=new Oe(F,this.loose)),Y(F,this.operator,this.semver,this.loose))},he.prototype.intersects=function(F,H){if(!(F instanceof he))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new Te(F.value,H),Ue(this.value,K,H);if(F.operator==="")return K=new Te(this.value,H),Ue(F.semver,K,H);var te=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ne=this.semver.version===F.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Ke=Y(this.semver,"<",F.semver,H)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),_e=Y(this.semver,">",F.semver,H)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return te||re||Ne&&Be||Ke||_e},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(F){var H=this.loose;F=F.trim(),M("range",F,H);var K=H?b[ge]:b[De];F=F.replace(K,Pe),M("hyphen replace",F),F=F.replace(b[ye],"$1$2$3"),M("comparator trim",F,b[ye]),F=(F=(F=F.replace(b[P],"$1~")).replace(b[R],"$1^")).split(/\s+/).join(" ");var te=H?b[ie]:b[de],re=F.split(" ").map(function(Ne){return function(Be,Ke){return M("comp",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){M("caret",tt,it);var ot=it?b[G]:b[z];return tt.replace(ot,function(gt,je,rt,Z,X){var $e;return M("caret",tt,gt,je,rt,Z,X),fe(je)?$e="":fe(rt)?$e=">="+je+".0.0 <"+(+je+1)+".0.0":fe(Z)?$e=je==="0"?">="+je+"."+rt+".0 <"+je+"."+(+rt+1)+".0":">="+je+"."+rt+".0 <"+(+je+1)+".0.0":X?(M("replaceCaret pr",X),X.charAt(0)!=="-"&&(X="-"+X),$e=je==="0"?rt==="0"?">="+je+"."+rt+"."+Z+X+" <"+je+"."+rt+"."+(+Z+1):">="+je+"."+rt+"."+Z+X+" <"+je+"."+(+rt+1)+".0":">="+je+"."+rt+"."+Z+X+" <"+(+je+1)+".0.0"):(M("no pr"),$e=je==="0"?rt==="0"?">="+je+"."+rt+"."+Z+" <"+je+"."+rt+"."+(+Z+1):">="+je+"."+rt+"."+Z+" <"+je+"."+(+rt+1)+".0":">="+je+"."+rt+"."+Z+" <"+(+je+1)+".0.0"),M("caret return",$e),$e})}(et,xe)}).join(" ")}(Be,Ke),M("caret",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){var ot=it?b[W]:b[V];return tt.replace(ot,function(gt,je,rt,Z,X){var $e;return M("tilde",tt,gt,je,rt,Z,X),fe(je)?$e="":fe(rt)?$e=">="+je+".0.0 <"+(+je+1)+".0.0":fe(Z)?$e=">="+je+"."+rt+".0 <"+je+"."+(+rt+1)+".0":X?(M("replaceTilde pr",X),X.charAt(0)!=="-"&&(X="-"+X),$e=">="+je+"."+rt+"."+Z+X+" <"+je+"."+(+rt+1)+".0"):$e=">="+je+"."+rt+"."+Z+" <"+je+"."+(+rt+1)+".0",M("tilde return",$e),$e})}(et,xe)}).join(" ")}(Be,Ke),M("tildes",Be),Be=function(_e,xe){return M("replaceXRanges",_e,xe),_e.split(/\s+/).map(function(et){return function(tt,it){tt=tt.trim();var ot=it?b[E]:b[h];return tt.replace(ot,function(gt,je,rt,Z,X,$e){M("xRange",tt,gt,je,rt,Z,X,$e);var He=fe(rt),we=He||fe(Z),st=we||fe(X);return je==="="&&st&&(je=""),He?gt=je===">"||je==="<"?"<0.0.0":"*":je&&st?(we&&(Z=0),st&&(X=0),je===">"?(je=">=",we?(rt=+rt+1,Z=0,X=0):st&&(Z=+Z+1,X=0)):je==="<="&&(je="<",we?rt=+rt+1:Z=+Z+1),gt=je+rt+"."+Z+"."+X):we?gt=">="+rt+".0.0 <"+(+rt+1)+".0.0":st&&(gt=">="+rt+"."+Z+".0 <"+rt+"."+(+Z+1)+".0"),M("xRange return",gt),gt})}(et,xe)}).join(" ")}(Be,Ke),M("xrange",Be),Be=function(_e,xe){return M("replaceStars",_e,xe),_e.trim().replace(b[ue],"")}(Be,Ke),M("stars",Be),Be}(Ne,H)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Ne){return!!Ne.match(te)})),re=re.map(function(Ne){return new he(Ne,H)})},Te.prototype.intersects=function(F,H){if(!(F instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(te){return F.set.some(function(re){return re.every(function(Ne){return te.intersects(Ne,H)})})})})},e.toComparators=function(F,H){return new Te(F,H).set.map(function(K){return K.map(function(te){return te.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new Oe(F,this.loose));for(var H=0;H<this.set.length;H++)if(Re(this.set[H],F))return!0;return!1},e.satisfies=Ue,e.maxSatisfying=function(F,H,K){var te=null,re=null;try{var Ne=new Te(H,K)}catch{return null}return F.forEach(function(Be){Ne.test(Be)&&(te&&re.compare(Be)!==-1||(re=new Oe(te=Be,K)))}),te},e.minSatisfying=function(F,H,K){var te=null,re=null;try{var Ne=new Te(H,K)}catch{return null}return F.forEach(function(Be){Ne.test(Be)&&(te&&re.compare(Be)!==1||(re=new Oe(te=Be,K)))}),te},e.validRange=function(F,H){try{return new Te(F,H).range||"*"}catch{return null}},e.ltr=function(F,H,K){return B(F,H,"<",K)},e.gtr=function(F,H,K){return B(F,H,">",K)},e.outside=B,e.prerelease=function(F,H){var K=se(F,H);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(F,H,K){return F=new Te(F,K),H=new Te(H,K),F.intersects(H)},e.coerce=function(F){if(F instanceof Oe)return F;if(typeof F!="string")return null;var H=F.match(b[k]);return H==null?null:se((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,C(1))},function(le,e){var C,O,M=le.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function b(s){if(C===setTimeout)return setTimeout(s,0);if((C===T||!C)&&setTimeout)return C=setTimeout,setTimeout(s,0);try{return C(s,0)}catch{try{return C.call(null,s,0)}catch{return C.call(this,s,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:T}catch{C=T}try{O=typeof clearTimeout=="function"?clearTimeout:A}catch{O=A}})();var m,D=[],N=!1,S=-1;function l(){N&&m&&(N=!1,m.length?D=m.concat(D):S=-1,D.length&&w())}function w(){if(!N){var s=b(l);N=!0;for(var o=D.length;o;){for(m=D,D=[];++S<o;)m&&m[S].run();S=-1,o=D.length}m=null,N=!1,function(i){if(O===clearTimeout)return clearTimeout(i);if((O===A||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(i);try{O(i)}catch{try{return O.call(null,i)}catch{return O.call(this,i)}}}(s)}}function g(s,o){this.fun=s,this.array=o}function r(){}M.nextTick=function(s){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];D.push(new g(s,o)),D.length!==1||N||b(w)},g.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=r,M.addListener=r,M.once=r,M.off=r,M.removeListener=r,M.removeAllListeners=r,M.emit=r,M.prependListener=r,M.prependOnceListener=r,M.listeners=function(s){return[]},M.binding=function(s){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(s){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(Se[134],Ie([1,0,14,6]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=M,e.$te=T,e.$ue=A,e.$ve=b,e.$we=D,e.$xe=N,e.$ye=S,e.$ze=l,e.$Ae=w,e.$Be=g,e.$Ce=r,e.$De=s,e.$Ee=o,e.$Fe=i,e.$Ge=n;function M(c){const u=c;return u?typeof u.read=="function":!1}function T(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}function A(c){const u=c;return u?T(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function b(c,u){return new m(c,u)}class m{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,C.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let f;switch(u){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const a=f.indexOf(t);a>=0&&f.splice(a,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(c,u){const t=[];let f;for(;(f=c.read())!==null;)t.push(f);return u(t)}function N(c,u,t){const f=[];let a;for(;(a=c.read())!==null&&f.length<t;)f.push(a);return a===null&&f.length>0?u(f):{read:()=>{if(f.length>0)return f.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return c.read()}}}function S(c,u){return new Promise((t,f)=>{const a=[];l(c,{onData:d=>{u&&a.push(d)},onError:d=>{u?f(d):t(void 0)},onEnd:()=>{t(u?u(a):void 0)}})})}function l(c,u,t){c.on("error",f=>{t?.isCancellationRequested||u.onError(f)}),c.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),c.on("data",f=>{t?.isCancellationRequested||u.onData(f)})}function w(c,u){return new Promise((t,f)=>{const a=new O.$Tc,d=[],$=y=>{if(d.push(y),d.length>u)return a.dispose(),c.pause(),t({stream:c,buffer:d,ended:!1})},p=y=>(a.dispose(),f(y)),v=()=>(a.dispose(),t({stream:c,buffer:d,ended:!0}));a.add((0,O.$Sc)(()=>c.removeListener("error",p))),c.on("error",p),a.add((0,O.$Sc)(()=>c.removeListener("end",v))),c.on("end",v),a.add((0,O.$Sc)(()=>c.removeListener("data",$))),c.on("data",$)})}function g(c,u){const t=b(u);return t.end(c),t}function r(){const c=b(()=>{throw new Error("not supported")});return c.end(),c}function s(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}function o(c,u,t){const f=b(t);return l(c,{onData:a=>f.write(u.data(a)),onError:a=>f.error(u.error?u.error(a):a),onEnd:()=>f.end()}),f}function i(c,u,t){let f=!1;return{read:()=>{const a=u.read();return f?a:(f=!0,a!==null?t([c,a]):c)}}}function n(c,u,t){let f=!1;const a=b(t);return l(u,{onData:d=>f?a.write(d):(f=!0,a.write(t([c,d]))),onError:d=>a.error(d),onEnd:()=>{f||(f=!0,a.write(c)),a.end()}}),a}}),define(Se[22],Ie([1,0,43,134]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=D,e.$Je=N,e.$Ke=S,e.$Le=l,e.$Me=w,e.$Ne=g,e.$Oe=r,e.$Pe=s,e.$Qe=o,e.$Re=i,e.$Se=n,e.$Te=c,e.$Ue=u,e.$Ve=t,e.$We=f,e.$Xe=a,e.$Ye=d,e.$Ze=$,e.$1e=p,e.$2e=h;const M=typeof Buffer<"u",T=new C.$V(()=>new Uint8Array(256));let A,b;class m{static alloc(k){return M?new m(Buffer.allocUnsafe(k)):new m(new Uint8Array(k))}static wrap(k){return M&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new m(k)}static fromString(k,I){return!(I?.dontUseNodeBuffer||!1)&&M?new m(Buffer.from(k)):(A||(A=new TextEncoder),new m(A.encode(k)))}static fromByteArray(k){const I=m.alloc(k.length);for(let P=0,V=k.length;P<V;P++)I.buffer[P]=k[P];return I}static concat(k,I){if(typeof I>"u"){I=0;for(let W=0,q=k.length;W<q;W++)I+=k[W].byteLength}const P=m.alloc(I);let V=0;for(let W=0,q=k.length;W<q;W++){const R=k[W];P.set(R,V),V+=R.byteLength}return P}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=m.alloc(this.byteLength);return k.set(this),k}toString(){return M?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(k,I){return new m(this.buffer.subarray(k,I))}set(k,I){if(k instanceof m)this.buffer.set(k.buffer,I);else if(k instanceof Uint8Array)this.buffer.set(k,I);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),I);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,I){w(this.buffer,k,I)}readUInt32LE(k){return g(this.buffer,k)}writeUInt32LE(k,I){r(this.buffer,k,I)}readUInt8(k){return s(this.buffer,k)}writeUInt8(k,I){o(this.buffer,k,I)}indexOf(k,I=0){return D(this.buffer,k instanceof m?k.buffer:k,I)}}e.$He=m;function D(E,k,I=0){const P=k.byteLength,V=E.byteLength;if(P===0)return 0;if(P===1)return E.indexOf(k[0]);if(P>V-I)return-1;const W=T.value;W.fill(k.length);for(let G=0;G<k.length;G++)W[k[G]]=k.length-G-1;let q=I+k.length-1,R=q,z=-1;for(;q<V;)if(E[q]===k[R]){if(R===0){z=q;break}q--,R--}else q+=Math.max(k.length-R,W[E[q]]),R=k.length-1;return z}function N(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0}function S(E,k,I){E[I+0]=k&255,k=k>>>8,E[I+1]=k&255}function l(E,k){return E[k]*2**24+E[k+1]*2**16+E[k+2]*2**8+E[k+3]}function w(E,k,I){E[I+3]=k,k=k>>>8,E[I+2]=k,k=k>>>8,E[I+1]=k,k=k>>>8,E[I]=k}function g(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0|E[k+2]<<16>>>0|E[k+3]<<24>>>0}function r(E,k,I){E[I+0]=k&255,k=k>>>8,E[I+1]=k&255,k=k>>>8,E[I+2]=k&255,k=k>>>8,E[I+3]=k&255}function s(E,k){return E[k]}function o(E,k,I){E[I]=k}function i(E){return O.$we(E,k=>m.concat(k))}function n(E){return O.$De(E)}function c(E){return O.$ye(E,k=>m.concat(k))}async function u(E){return E.ended?m.concat(E.buffer):m.concat([...E.buffer,await c(E.stream)])}function t(E){return O.$Be(E,k=>m.concat(k))}function f(E){return O.$Ee(E,{data:k=>typeof k=="string"?m.fromString(k):m.wrap(k)},k=>m.concat(k))}function a(E){return O.$ve(k=>m.concat(k),E)}function d(E,k){return O.$Fe(E,k,I=>m.concat(I))}function $(E,k){return O.$Ge(E,k,I=>m.concat(I))}function p(E){let k=0,I=0,P=0;const V=new Uint8Array(Math.floor(E.length/4*3)),W=R=>{switch(I){case 3:V[P++]=k|R,I=0;break;case 2:V[P++]=k|R>>>2,k=R<<6,I=3;break;case 1:V[P++]=k|R>>>4,k=R<<4,I=2;break;default:k=R<<2,I=1}};for(let R=0;R<E.length;R++){const z=E.charCodeAt(R);if(z>=65&&z<=90)W(z-65);else if(z>=97&&z<=122)W(z-97+26);else if(z>=48&&z<=57)W(z-48+52);else if(z===43||z===45)W(62);else if(z===47||z===95)W(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${E[R]}`)}}const q=P;for(;I>0;)W(0);return m.wrap(V).slice(0,q)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:E},k=!0,I=!1){const P=I?y:v;let V="";const W=E.byteLength%3;let q=0;for(;q<E.byteLength-W;q+=3){const R=E[q+0],z=E[q+1],G=E[q+2];V+=P[R>>>2],V+=P[(R<<4|z>>>4)&63],V+=P[(z<<2|G>>>6)&63],V+=P[G&63]}if(W===1){const R=E[q+0];V+=P[R>>>2],V+=P[R<<4&63],k&&(V+="==")}else if(W===2){const R=E[q+0],z=E[q+1];V+=P[R>>>2],V+=P[(R<<4|z>>>4)&63],V+=P[z<<2&63],k&&(V+="=")}return V}}),define(Se[135],Ie([1,0,28,128,13]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.FuzzyScore=e.$Ak=e.$zk=void 0,e.or=T,e.$Bk=b,e.$Ck=m,e.$Dk=S,e.$Ek=p,e.$Fk=v,e.$Gk=P,e.$Hk=V,e.$Ik=W,e.$Jk=q,e.$Kk=x,e.$Mk=be,e.$Nk=Y,e.$Ok=he;function T(...fe){return function(Pe,Re){for(let Ue=0,B=fe.length;Ue<B;Ue++){const F=fe[Ue](Pe,Re);if(F)return F}return null}}e.$zk=A.bind(void 0,!1),e.$Ak=A.bind(void 0,!0);function A(fe,Pe,Re){if(!Re||Re.length<Pe.length)return null;let Ue;return fe?Ue=M.$Af(Re,Pe):Ue=Re.indexOf(Pe)===0,Ue?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function b(fe,Pe){const Re=Pe.toLowerCase().indexOf(fe.toLowerCase());return Re===-1?null:[{start:Re,end:Re+fe.length}]}function m(fe,Pe){return D(fe.toLowerCase(),Pe.toLowerCase(),0,0)}function D(fe,Pe,Re,Ue){if(Re===fe.length)return[];if(Ue===Pe.length)return null;if(fe[Re]===Pe[Ue]){let B=null;return(B=D(fe,Pe,Re+1,Ue+1))?c({start:Ue,end:Ue+1},B):null}return D(fe,Pe,Re,Ue+1)}function N(fe){return 97<=fe&&fe<=122}function S(fe){return 65<=fe&&fe<=90}function l(fe){return 48<=fe&&fe<=57}function w(fe){return fe===32||fe===9||fe===10||fe===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>g.add(fe.charCodeAt(0)));function r(fe){return w(fe)||g.has(fe)}function s(fe,Pe){return fe===Pe||r(fe)&&r(Pe)}const o=new Map;function i(fe){if(o.has(fe))return o.get(fe);let Pe;const Re=(0,O.$xk)(fe);return Re&&(Pe=Re),o.set(fe,Pe),Pe}function n(fe){return N(fe)||S(fe)||l(fe)}function c(fe,Pe){return Pe.length===0?Pe=[fe]:fe.end===Pe[0].start?Pe[0].start=fe.start:Pe.unshift(fe),Pe}function u(fe,Pe){for(let Re=Pe;Re<fe.length;Re++){const Ue=fe.charCodeAt(Re);if(S(Ue)||l(Ue)||Re>0&&!n(fe.charCodeAt(Re-1)))return Re}return fe.length}function t(fe,Pe,Re,Ue){if(Re===fe.length)return[];if(Ue===Pe.length)return null;if(fe[Re]!==Pe[Ue].toLowerCase())return null;{let B=null,F=Ue+1;for(B=t(fe,Pe,Re+1,Ue+1);!B&&(F=u(Pe,F))<Pe.length;)B=t(fe,Pe,Re+1,F),F++;return B===null?null:c({start:Ue,end:Ue+1},B)}}function f(fe){let Pe=0,Re=0,Ue=0,B=0,F=0;for(let Ne=0;Ne<fe.length;Ne++)F=fe.charCodeAt(Ne),S(F)&&Pe++,N(F)&&Re++,n(F)&&Ue++,l(F)&&B++;const H=Pe/fe.length,K=Re/fe.length,te=Ue/fe.length,re=B/fe.length;return{upperPercent:H,lowerPercent:K,alphaPercent:te,numericPercent:re}}function a(fe){const{upperPercent:Pe,lowerPercent:Re}=fe;return Re===0&&Pe>.6}function d(fe){const{upperPercent:Pe,lowerPercent:Re,alphaPercent:Ue,numericPercent:B}=fe;return Re>.2&&Pe<.8&&Ue>.6&&B<.2}function $(fe){let Pe=0,Re=0,Ue=0,B=0;for(let F=0;F<fe.length;F++)Ue=fe.charCodeAt(F),S(Ue)&&Pe++,N(Ue)&&Re++,w(Ue)&&B++;return(Pe===0||Re===0)&&B===0?fe.length<=30:Pe<=5}function p(fe,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!$(fe))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Re=f(Pe);if(!d(Re)){if(!a(Re))return null;Pe=Pe.toLowerCase()}let Ue=null,B=0;for(fe=fe.toLowerCase();B<Pe.length&&(Ue=t(fe,Pe,0,B))===null;)B=u(Pe,B+1);return Ue}function v(fe,Pe,Re=!1){if(!Pe||Pe.length===0)return null;let Ue=null,B=0;for(fe=fe.toLowerCase(),Pe=Pe.toLowerCase();B<Pe.length&&(Ue=y(fe,Pe,0,B,Re),Ue===null);)B=h(Pe,B+1);return Ue}function y(fe,Pe,Re,Ue,B){let F=0;if(Re===fe.length)return[];if(Ue===Pe.length)return null;if(!s(fe.charCodeAt(Re),Pe.charCodeAt(Ue))){const te=i(fe.charCodeAt(Re));if(!te)return null;for(let re=0;re<te.length;re++)if(!s(te[re],Pe.charCodeAt(Ue+re)))return null;F+=te.length-1}let H=null,K=Ue+F+1;if(H=y(fe,Pe,Re+1,K,B),!B)for(;!H&&(K=h(Pe,K))<Pe.length;)H=y(fe,Pe,Re+1,K,B),K++;if(!H)return null;if(fe.charCodeAt(Re)!==Pe.charCodeAt(Ue)){const te=i(fe.charCodeAt(Re));if(!te)return H;for(let re=0;re<te.length;re++)if(te[re]!==Pe.charCodeAt(Ue+re))return H}return c({start:Ue,end:Ue+F+1},H)}function h(fe,Pe){for(let Re=Pe;Re<fe.length;Re++)if(r(fe.charCodeAt(Re))||Re>0&&r(fe.charCodeAt(Re-1)))return Re;return fe.length}const E=T(e.$Ak,p,b),k=T(e.$Ak,p,m),I=new C.$Dc(1e4);function P(fe,Pe,Re=!1){if(typeof fe!="string"||typeof Pe!="string")return null;let Ue=I.get(fe);Ue||(Ue=new RegExp(M.$if(fe),"i"),I.set(fe,Ue));const B=Ue.exec(Pe);return B?[{start:B.index,end:B.index+B[0].length}]:Re?k(fe,Pe):E(fe,Pe)}function V(fe,Pe){const Re=be(fe,fe.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?q(Re):null}function W(fe,Pe,Re,Ue,B,F){const H=Math.min(13,fe.length);for(;Re<H;Re++){const K=be(fe,Pe,Re,Ue,B,F,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(K)return K}return[0,F]}function q(fe){if(typeof fe>"u")return[];const Pe=[],Re=fe[1];for(let Ue=fe.length-1;Ue>1;Ue--){const B=fe[Ue]+Re,F=Pe[Pe.length-1];F&&F.end===B?F.end=B+1:Pe.push({start:B,end:B+1})}return Pe}const R=128;function z(){const fe=[],Pe=[];for(let Re=0;Re<=R;Re++)Pe[Re]=0;for(let Re=0;Re<=R;Re++)fe.push(Pe.slice(0));return fe}function G(fe){const Pe=[];for(let Re=0;Re<=fe;Re++)Pe[Re]=0;return Pe}const ie=G(2*R),de=G(2*R),ye=z(),De=z(),ge=z(),ue=!1;function Ce(fe,Pe,Re,Ue,B){function F(K,te,re=" "){for(;K.length<te;)K=re+K;return K}let H=` |   |${Ue.split("").map(K=>F(K,3)).join("|")}
`;for(let K=0;K<=Re;K++)K===0?H+=" |":H+=`${Pe[K-1]}|`,H+=fe[K].slice(0,B+1).map(te=>F(te.toString(),3)).join("|")+`
`;return H}function se(fe,Pe,Re,Ue){fe=fe.substr(Pe),Re=Re.substr(Ue),console.log(Ce(De,fe,fe.length,Re,Re.length)),console.log(Ce(ge,fe,fe.length,Re,Re.length)),console.log(Ce(ye,fe,fe.length,Re,Re.length))}function Oe(fe,Pe){if(Pe<0||Pe>=fe.length)return!1;const Re=fe.codePointAt(Pe);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Sf(Re)}}function ne(fe,Pe){if(Pe<0||Pe>=fe.length)return!1;switch(fe.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function j(fe,Pe,Re){return Pe[fe]!==Re[fe]}function x(fe,Pe,Re,Ue,B,F,H=!1){for(;Pe<Re&&B<F;)fe[Pe]===Ue[B]&&(H&&(ie[Pe]=B),Pe+=1),B+=1;return Pe===Re}var ve;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Le;(function(fe){fe.Default=[-100,0];function Pe(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}fe.isDefault=Pe})(Le||(e.FuzzyScore=Le={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Re){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Re}}e.$Lk=ke;function be(fe,Pe,Re,Ue,B,F,H=ke.default){const K=fe.length>R?R:fe.length,te=Ue.length>R?R:Ue.length;if(Re>=K||F>=te||K-Re>te-F||!x(Pe,Re,K,B,F,te,!0))return;me(K,te,Re,F,Pe,B);let re=1,Ne=1,Be=Re,Ke=F;const _e=[!1];for(re=1,Be=Re;Be<K;re++,Be++){const ot=ie[Be],gt=de[Be],je=Be+1<K?de[Be+1]:te;for(Ne=ot-F+1,Ke=ot;Ke<je;Ne++,Ke++){let rt=Number.MIN_SAFE_INTEGER,Z=!1;Ke<=gt&&(rt=Q(fe,Pe,Be,Re,Ue,B,Ke,te,F,ye[re-1][Ne-1]===0,_e));let X=0;rt!==Number.MAX_SAFE_INTEGER&&(Z=!0,X=rt+De[re-1][Ne-1]);const $e=Ke>ot,He=$e?De[re][Ne-1]+(ye[re][Ne-1]>0?-5:0):0,we=Ke>ot+1&&ye[re][Ne-1]>0,st=we?De[re][Ne-2]+(ye[re][Ne-2]>0?-5:0):0;if(we&&(!$e||st>=He)&&(!Z||st>=X))De[re][Ne]=st,ge[re][Ne]=3,ye[re][Ne]=0;else if($e&&(!Z||He>=X))De[re][Ne]=He,ge[re][Ne]=2,ye[re][Ne]=0;else if(Z)De[re][Ne]=X,ge[re][Ne]=1,ye[re][Ne]=ye[re-1][Ne-1]+1;else throw new Error("not possible")}}if(ue&&se(fe,Re,Ue,F),!_e[0]&&!H.firstMatchCanBeWeak)return;re--,Ne--;const xe=[De[re][Ne],F];let et=0,tt=0;for(;re>=1;){let ot=Ne;do{const gt=ge[re][ot];if(gt===3)ot=ot-2;else if(gt===2)ot=ot-1;else break}while(ot>=1);et>1&&Pe[Re+re-1]===B[F+Ne-1]&&!j(ot+F-1,Ue,B)&&et+1>ye[re][ot]&&(ot=Ne),ot===Ne?et++:et=1,tt||(tt=ot),re--,Ne=ot-1,xe.push(Ne)}te-F===K&&H.boostFullMatch&&(xe[0]+=2);const it=tt-K;return xe[0]-=it,xe}function me(fe,Pe,Re,Ue,B,F){let H=fe-1,K=Pe-1;for(;H>=Re&&K>=Ue;)B[H]===F[K]&&(de[H]=K,H--),K--}function Q(fe,Pe,Re,Ue,B,F,H,K,te,re,Ne){if(Pe[Re]!==F[H])return Number.MIN_SAFE_INTEGER;let Be=1,Ke=!1;return H===Re-Ue?Be=fe[Re]===B[H]?7:5:j(H,B,F)&&(H===0||!j(H-1,B,F))?(Be=fe[Re]===B[H]?7:5,Ke=!0):Oe(F,H)&&(H===0||!Oe(F,H-1))?Be=5:(Oe(F,H-1)||ne(F,H-1))&&(Be=5,Ke=!0),Be>1&&Re===Ue&&(Ne[0]=!0),Ke||(Ke=j(H,B,F)||Oe(F,H-1)||ne(F,H-1)),Re===Ue?H>te&&(Be-=Ke?3:5):re?Be+=Ke?2:0:Be+=Ke?0:1,H+1===K&&(Be-=Ke?3:5),Be}function Y(fe,Pe,Re,Ue,B,F,H){return ce(fe,Pe,Re,Ue,B,F,!0,H)}function he(fe,Pe,Re,Ue,B,F,H){return ce(fe,Pe,Re,Ue,B,F,!1,H)}function ce(fe,Pe,Re,Ue,B,F,H,K){let te=be(fe,Pe,Re,Ue,B,F,K);if(te&&!H)return te;if(fe.length>=3){const re=Math.min(7,fe.length-1);for(let Ne=Re+1;Ne<re;Ne++){const Be=Te(fe,Ne);if(Be){const Ke=be(Be,Be.toLowerCase(),Re,Ue,B,F,K);Ke&&(Ke[0]-=3,(!te||Ke[0]>te[0])&&(te=Ke))}}}return te}function Te(fe,Pe){if(Pe+1>=fe.length)return;const Re=fe[Pe],Ue=fe[Pe+1];if(Re!==Ue)return fe.slice(0,Pe)+Ue+Re+fe.slice(Pe+2)}}),define(Se[32],Ie([1,0,13]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(O||(O={})),function(M){const T="error",A="warning",b="warn",m="info",D="ignore";function N(l){return l?C.$zf(T,l)?M.Error:C.$zf(A,l)||C.$zf(b,l)?M.Warning:C.$zf(m,l)?M.Info:M.Ignore:M.Ignore}M.fromValue=N;function S(l){switch(l){case M.Error:return T;case M.Warning:return A;case M.Info:return m;default:return D}}M.toString=S}(O||(O={})),e.default=O}),define(Se[136],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(Se[54],Ie([1,0,18,13]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class M{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const g=w.charCodeAt(0),r=this.b.charCodeAt(this.c);return g-r}value(){return this.b[this.c]}}e.$Ai=M;class T{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,O.$tf)(w,this.b,0,w.length,this.c,this.d):(0,O.$vf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Bi=T;class A{constructor(w=!0,g=!0){this.f=w,this.g=g}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let g=w.length-1;g>=0;g--,this.c--){const r=this.b.charCodeAt(g);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,O.$tf)(w,this.b,0,w.length,this.d,this.e):(0,O.$vf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ci=A;var b;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(b||(b={}));class m{constructor(w,g){this.f=w,this.g=g,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,O.$uf)(w,this.c.scheme);if(this.d[this.e]===2)return(0,O.$uf)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,O.$sf)(w,this.c.query);if(this.d[this.e]===5)return(0,O.$sf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Di=m;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(N||(N={}));class S{static forUris(w=()=>!1,g=()=>!1){return new S(new m(w,g))}static forPaths(w=!1){return new S(new A(void 0,!w))}static forStrings(){return new S(new M)}static forConfigKeys(){return new S(new T)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,g){if(g){const r=g.slice(0);(0,C.$Wb)(r);for(const s of r)this.set(s,w)}else{const r=w.slice(0);(0,C.$Wb)(r);for(const s of r)this.set(s[0],s[1])}}set(w,g){const r=this.b.reset(w);let s;this.c||(this.c=new D,this.c.segment=r.value());const o=[];for(s=this.c;;){const n=r.cmp(s.segment);if(n>0)s.left||(s.left=new D,s.left.segment=r.value()),o.push([-1,s]),s=s.left;else if(n<0)s.right||(s.right=new D,s.right.segment=r.value()),o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),s.mid||(s.mid=new D,s.mid.segment=r.value()),o.push([0,s]),s=s.mid;else break}const i=s.value;s.value=g,s.key=w;for(let n=o.length-1;n>=0;n--){const c=o[n][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const t=o[n][0],f=o[n+1][0];if(t===1&&f===1)o[n][1]=c.rotateLeft();else if(t===-1&&f===-1)o[n][1]=c.rotateRight();else if(t===1&&f===-1)c.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=c.rotateLeft();else if(t===-1&&f===1)c.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=c.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const g=this.b.reset(w);let r=this.c;for(;r;){const s=g.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(g.hasNext())g.next(),r=r.mid;else break}return r}has(w){const g=this.d(w);return!(g?.value===void 0&&g?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,g){const r=this.b.reset(w),s=[];let o=this.c;for(;o;){const i=r.cmp(o.segment);if(i>0)s.push([-1,o]),o=o.left;else if(i<0)s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),s.push([0,o]),o=o.mid;else break}if(o){if(g?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:c,segment:u}=i;this.e(i.key,!1),o.key=n,o.value=c,o.segment=u}}else{const i=o.left??o.right;if(s.length>0){const[n,c]=s[s.length-1];switch(n){case-1:c.left=i;break;case 0:c.mid=i;break;case 1:c.right=i;break}}else this.c=i}for(let i=s.length-1;i>=0;i--){const n=s[i][1];n.updateHeight();const c=n.balanceFactor();if(c>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),s[i][1]=n.rotateLeft()):c<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),s[i][1]=n.rotateRight()),i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const g=this.b.reset(w);let r=this.c,s;for(;r;){const o=g.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(g.hasNext())g.next(),s=r.value||s,r=r.mid;else break}return r&&r.value||s}findSuperstr(w){return this.g(w,!1)}g(w,g){const r=this.b.reset(w);let s=this.c;for(;s;){const o=r.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else return s.mid?this.h(s.mid):g?s.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[g,r]of this)w(r,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const g=[];return this.j(w,g),g[Symbol.iterator]()}j(w,g){w&&(w.left&&this.j(w.left,g),w.value&&g.push([w.key,w.value]),w.mid&&this.j(w.mid,g),w.right&&this.j(w.right,g))}_isBalanced(){const w=g=>{if(!g)return!0;const r=g.balanceFactor();return r<-1||r>1?!1:w(g.left)&&w(g.right)};return w(this.c)}}e.$Ei=S}),define(Se[36],Ie([1,0,92]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Yj=M;var O;(function(A){function b(m){return m&&typeof m=="object"&&typeof m.id=="string"}A.isThemeColor=b})(O||(e.ThemeColor=O={}));function M(A){return{id:A}}var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function m(i){const n=b.exec(i.id);if(!n)return m(C.$Xj.error);const[,c,u]=n,t=["codicon","codicon-"+c];return u&&t.push("codicon-modifier-"+u.substring(1)),t}A.asClassNameArray=m;function D(i){return m(i).join(" ")}A.asClassName=D;function N(i){return"."+m(i).join(".")}A.asCSSSelector=N;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||O.isThemeColor(i.color))}A.isThemeIcon=S;const l=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function w(i){const n=l.exec(i);if(!n)return;const[,c]=n;return{id:c}}A.fromString=w;function g(i){return{id:i}}A.fromId=g;function r(i,n){let c=i.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),n&&(c=`${c}~${n}`),{id:c}}A.modify=r;function s(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}A.getModifier=s;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}A.isEqual=o})(T||(e.ThemeIcon=T={}))}),define(Se[137],Ie([1,0,135,13,36]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=m,e.$Qk=N,e.$Rk=l,e.$Sk=w,e.$Tk=r,e.$Uk=s;const T="$(",A=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${A.source}`,"g");function m(o){return o.replace(b,(i,n)=>n?i:`\\${i}`)}const D=new RegExp(`\\\\${A.source}`,"g");function N(o){return o.replace(D,i=>`\\${i}`)}const S=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function l(o){return o.indexOf(T)===-1?o:o.replace(S,(i,n,c,u)=>c?i:n||u||"")}function w(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const g=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(o){g.lastIndex=0;let i="";const n=[];let c=0;for(;;){const u=g.lastIndex,t=g.exec(o),f=o.substring(u,t?.index);if(f.length>0){i+=f;for(let a=0;a<f.length;a++)n.push(c)}if(!t)break;c+=t[0].length}return{text:i,iconOffsets:n}}function s(o,i,n=!1){const{text:c,iconOffsets:u}=i;if(!u||u.length===0)return(0,C.$Gk)(o,c,n);const t=(0,O.$gf)(c," "),f=c.length-t.length,a=(0,C.$Gk)(o,t,n);if(a)for(const d of a){const $=u[d.start+f]+f;d.start+=$,d.end+=$}return a}}),define(Se[33],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=O;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(M){return C.test(M)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(b){for(let m=0;m<b.length;m++)b[m]=Math.floor(Math.random()*256);return b};const T=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));return function(){M(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let m=0,D="";return D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D+="-",D+=A[T[m++]],D+=A[T[m++]],D+="-",D+=A[T[m++]],D+=A[T[m++]],D+="-",D+=A[T[m++]],D+=A[T[m++]],D+="-",D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D}}()}),define(Se[138],Ie([1,0,18,42,33]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=e.$au=void 0,e.$$t=T,e.$_t=A,e.$bu=D;function T(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function A(S,l,w){const g={id:(0,M.$Ug)(),name:S,uri:l,data:w};return{asString:async()=>"",asFile:()=>g,value:void 0}}class b{constructor(){this.a=new Map}get size(){let l=0;for(const w of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const w=[...this.a.keys()];return O.Iterable.some(this,([g,r])=>r.asFile())&&w.push("files"),N(m(l),w)}get(l){return this.a.get(this.b(l))?.[0]}append(l,w){const g=this.a.get(l);g?g.push(w):this.a.set(this.b(l),[w])}replace(l,w){this.a.set(this.b(l),[w])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,w]of this.a)for(const g of w)yield[l,g]}b(l){return m(l)}}e.$au=b;function m(S){return S.toLowerCase()}function D(S,l){return N(m(S),l.map(m))}function N(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const w=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[g,r,s]=w;return s==="*"?l.some(o=>o.startsWith(r+"/")):!1}e.$cu=Object.freeze({create:S=>(0,C.$Mb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$cu.split(S).filter(l=>!l.startsWith("#"))})}),define(Se[139],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$iu=O;var C;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function O(M){let T=0,A=0,b=0,m=0;for(let D=0,N=M.length;D<N;D++){const S=M.charCodeAt(D);S===13?(T===0&&(A=D),T++,D+1<N&&M.charCodeAt(D+1)===10?(m|=2,D++):m|=3,b=D+1):S===10&&(m|=1,T===0&&(A=D),T++,b=D+1)}return T===0&&(A=M.length),[T,A,M.length-b,m]}}),define(Se[140],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0,e.$8s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[141],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fu=e.$Eu=e.IndentAction=void 0;var C;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class O{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let m=0,D=b.notIn.length;m<D;m++)switch(b.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,m){if(b.getTokenCount()===0)return!0;const D=b.findTokenIndexAtOffset(m-2),N=b.getStandardTokenType(D);return this.isOK(N)}g(b,m){for(let D=b;D<=m;D++){const N=String.fromCharCode(D);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Eu=O;class M{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of b)T(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),T(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),T(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),T(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&T(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$Fu=M;function T(A,b,m){A.has(b)?A.get(b).push(m):A.set(b,[m])}}),define(Se[142],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.NodeColor=e.$JC=void 0,e.$LC=M,e.$MC=T,e.$NC=D,e.$OC=N,e.$PC=S,e.$QC=l,e.$RC=w,e.$SC=g;class C{constructor(s,o){this.piece=s,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$KC)return M(this.right);let s=this;for(;s.parent!==e.$KC&&s.parent.left!==s;)s=s.parent;return s.parent===e.$KC?e.$KC:s.parent}prev(){if(this.left!==e.$KC)return T(this.left);let s=this;for(;s.parent!==e.$KC&&s.parent.right!==s;)s=s.parent;return s.parent===e.$KC?e.$KC:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$JC=C;var O;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$KC=new C(null,0),e.$KC.parent=e.$KC,e.$KC.left=e.$KC,e.$KC.right=e.$KC,e.$KC.color=0;function M(r){for(;r.left!==e.$KC;)r=r.left;return r}function T(r){for(;r.right!==e.$KC;)r=r.right;return r}function A(r){return r===e.$KC?0:r.size_left+r.piece.length+A(r.right)}function b(r){return r===e.$KC?0:r.lf_left+r.piece.lineFeedCnt+b(r.right)}function m(){e.$KC.parent=e.$KC}function D(r,s){const o=s.right;o.size_left+=s.size_left+(s.piece?s.piece.length:0),o.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=o.left,o.left!==e.$KC&&(o.left.parent=s),o.parent=s.parent,s.parent===e.$KC?r.root=o:s.parent.left===s?s.parent.left=o:s.parent.right=o,o.left=s,s.parent=o}function N(r,s){const o=s.left;s.left=o.right,o.right!==e.$KC&&(o.right.parent=s),o.parent=s.parent,s.size_left-=o.size_left+(o.piece?o.piece.length:0),s.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),s.parent===e.$KC?r.root=o:s===s.parent.right?s.parent.right=o:s.parent.left=o,o.right=s,s.parent=o}function S(r,s){let o,i;if(s.left===e.$KC?(i=s,o=i.right):s.right===e.$KC?(i=s,o=i.left):(i=M(s.right),o=i.right),i===r.root){r.root=o,o.color=0,s.detach(),m(),r.root.parent=e.$KC;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===s?(o.parent=i.parent,g(r,o)):(i.parent===s?o.parent=i:o.parent=i.parent,g(r,o),i.left=s.left,i.right=s.right,i.parent=s.parent,i.color=s.color,s===r.root?r.root=i:s===s.parent.left?s.parent.left=i:s.parent.right=i,i.left!==e.$KC&&(i.left.parent=i),i.right!==e.$KC&&(i.right.parent=i),i.size_left=s.size_left,i.lf_left=s.lf_left,g(r,i)),s.detach(),o.parent.left===o){const u=A(o),t=b(o);if(u!==o.parent.size_left||t!==o.parent.lf_left){const f=u-o.parent.size_left,a=t-o.parent.lf_left;o.parent.size_left=u,o.parent.lf_left=t,w(r,o.parent,f,a)}}if(g(r,o.parent),n){m();return}let c;for(;o!==r.root&&o.color===0;)o===o.parent.left?(c=o.parent.right,c.color===1&&(c.color=0,o.parent.color=1,D(r,o.parent),c=o.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.right.color===0&&(c.left.color=0,c.color=1,N(r,c),c=o.parent.right),c.color=o.parent.color,o.parent.color=0,c.right.color=0,D(r,o.parent),o=r.root)):(c=o.parent.left,c.color===1&&(c.color=0,o.parent.color=1,N(r,o.parent),c=o.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.left.color===0&&(c.right.color=0,c.color=1,D(r,c),c=o.parent.left),c.color=o.parent.color,o.parent.color=0,c.left.color=0,N(r,o.parent),o=r.root));o.color=0,m()}function l(r,s){for(g(r,s);s!==r.root&&s.parent.color===1;)if(s.parent===s.parent.parent.left){const o=s.parent.parent.right;o.color===1?(s.parent.color=0,o.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,D(r,s)),s.parent.color=0,s.parent.parent.color=1,N(r,s.parent.parent))}else{const o=s.parent.parent.left;o.color===1?(s.parent.color=0,o.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,N(r,s)),s.parent.color=0,s.parent.parent.color=1,D(r,s.parent.parent))}r.root.color=0}function w(r,s,o,i){for(;s!==r.root&&s!==e.$KC;)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=i),s=s.parent}function g(r,s){let o=0,i=0;if(s!==r.root){for(;s!==r.root&&s===s.parent.right;)s=s.parent;if(s!==r.root)for(s=s.parent,o=A(s.left)-s.size_left,i=b(s.left)-s.lf_left,s.size_left+=o,s.lf_left+=i;s!==r.root&&(o!==0||i!==0);)s.parent.left===s&&(s.parent.size_left+=o,s.parent.lf_left+=i),s=s.parent}}}),define(Se[93],Ie([1,0,94,30,95,142,96]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4C=e.$3C=e.$2C=void 0,e.$ZC=N,e.$1C=S;const b=65535;function m(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class D{constructor(i,n,c,u,t){this.lineStarts=i,this.cr=n,this.lf=c,this.crlf=u,this.isBasicASCII=t}}function N(o,i=!0){const n=[0];let c=1;for(let u=0,t=o.length;u<t;u++){const f=o.charCodeAt(u);f===13?u+1<t&&o.charCodeAt(u+1)===10?(n[c++]=u+2,u++):n[c++]=u+1:f===10&&(n[c++]=u+1)}return i?m(n):n}function S(o,i){o.length=0,o[0]=0;let n=1,c=0,u=0,t=0,f=!0;for(let d=0,$=i.length;d<$;d++){const p=i.charCodeAt(d);p===13?d+1<$&&i.charCodeAt(d+1)===10?(t++,o[n++]=d+2,d++):(c++,o[n++]=d+1):p===10?(u++,o[n++]=d+1):f&&p!==9&&(p<32||p>126)&&(f=!1)}const a=new D(m(o),c,u,t,f);return o.length=0,a}class l{constructor(i,n,c,u,t){this.bufferIndex=i,this.start=n,this.end=c,this.lineFeedCnt=u,this.length=t}}e.$2C=l;class w{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$3C=w;class g{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==T.$KC&&i.iterate(i.root,c=>(c!==T.$KC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartOffset<=i&&c.nodeStartOffset+c.node.piece.length>=i)return c}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<i&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=i)return c}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const c=this.b;for(let u=0;u<c.length;u++){const t=c[u];if(t.node.parent===null||t.nodeStartOffset>=i){c[u]=null,n=!0;continue}}if(n){const u=[];for(const t of c)t!==null&&u.push(t);this.b=u}}}class s{constructor(i,n,c){this.create(i,n,c)}create(i,n,c){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=T.$KC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=c;let u=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=N(i[t].buffer));const a=new l(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),u=this.S(u,a)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,c=n-Math.floor(n/3),u=c*2;let t="",f=0;const a=[];if(this.iterate(this.root,d=>{const $=this.R(d),p=$.length;if(f<=c||f+p<u)return t+=$,f+=p,!0;const v=t.replace(/\r\n|\r|\n/g,i);return a.push(new w(v,N(v))),t=$,f=p,!0}),f>0){const d=t.replace(/\r\n|\r|\n/g,i);a.push(new w(d,N(d)))}this.create(a,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new g(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,u=>{if(u===T.$KC)return!0;const t=this.R(u),f=t.length,a=i.G(n),d=i.G(n+f),$=i.getValueInRange2(a,d);return n+=f,t===$})}getOffsetAt(i,n){let c=0,u=this.root;for(;u!==T.$KC;)if(u.left!==T.$KC&&u.lf_left+1>=i)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=i){c+=u.size_left;const t=this.B(u,i-u.lf_left-2);return c+=t+n-1}else i-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right;return c}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,c=0;const u=i;for(;n!==T.$KC;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(c+=n.lf_left+t.index,t.index===0){const f=this.getOffsetAt(c+1,1),a=u-f;return new C.$xt(c+1,a+1)}return new C.$xt(c+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,c+=n.lf_left+n.piece.lineFeedCnt,n.right===T.$KC){const t=this.getOffsetAt(c+1,1),f=u-i-t;return new C.$xt(c+1,f+1)}else n=n.right;return new C.$xt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const c=this.H(i.startLineNumber,i.startColumn),u=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(c,u);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const a=i.node,d=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);return d.substring($+i.remainder,$+n.remainder)}let c=i.node;const u=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let f=u.substring(t+i.remainder,t+c.piece.length);for(c=c.next();c!==T.$KC;){const a=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===n.node){f+=a.substring(d,d+n.remainder);break}else f+=a.substr(d,c.piece.length);c=c.next()}return f}getLinesContent(){const i=[];let n=0,c="",u=!1;return this.iterate(this.root,t=>{if(t===T.$KC)return!0;const f=t.piece;let a=f.length;if(a===0)return!0;const d=this.a[f.bufferIndex].buffer,$=this.a[f.bufferIndex].lineStarts,p=f.start.line,v=f.end.line;let y=$[p]+f.start.column;if(u&&(d.charCodeAt(y)===10&&(y++,a--),i[n++]=c,c="",u=!1,a===0))return!0;if(p===v)return!this.f&&d.charCodeAt(y+a-1)===13?(u=!0,c+=d.substr(y,a-1)):c+=d.substr(y,a),!0;c+=this.f?d.substring(y,Math.max(y,$[p+1]-this.e)):d.substring(y,$[p+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;for(let h=p+1;h<v;h++)c=this.f?d.substring($[h],$[h+1]-this.e):d.substring($[h],$[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;return!this.f&&d.charCodeAt($[v]+f.end.column-1)===13?(u=!0,f.end.column===0?n--:c=d.substr($[v],f.end.column-1)):c=d.substr($[v],f.end.column),!0}),u&&(i[n++]=c,c=""),i[n++]=c,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const c=this.a[n.piece.bufferIndex],u=this.u(n.piece.bufferIndex,n.piece.start);return c.buffer.charCodeAt(u)}else{const n=this.a[i.node.piece.bufferIndex],u=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(u)}}getLineCharCode(i,n){const c=this.H(i,n+1);return this.l(c)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,c,u,t,f,a,d,$,p,v){const y=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start),E=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,f);let I;const P={line:0,column:0};let V,W;n._wordSeparators?(V=y.buffer.substring(E,k),W=q=>q+E,n.reset(0)):(V=y.buffer,W=q=>q,n.reset(E));do if(I=n.next(V),I){if(W(I.index)>=k)return p;this.s(i,W(I.index)-h,P);const q=this.t(i.piece.bufferIndex,t,P),R=P.line===t.line?P.column-t.column+u:P.column+1,z=R+I[0].length;if(v[p++]=(0,A.$VC)(new O.$yt(c+q,R,c+q,z),I,d),W(I.index)+I[0].length>=k||p>=$)return p}while(I);return p}findMatchesLineByLine(i,n,c,u){const t=[];let f=0;const a=new A.$YC(n.wordSeparators,n.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const $=this.H(i.endLineNumber,i.endColumn);if($===null)return[];let p=this.s(d.node,d.remainder);const v=this.s($.node,$.remainder);if(d.node===$.node)return this.findMatchesInNode(d.node,a,i.startLineNumber,i.startColumn,p,v,n,c,u,f,t),t;let y=i.startLineNumber,h=d.node;for(;h!==$.node;){const k=this.t(h.piece.bufferIndex,p,h.piece.end);if(k>=1){const P=this.a[h.piece.bufferIndex].lineStarts,V=this.u(h.piece.bufferIndex,h.piece.start),W=P[p.line+k],q=y===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(h,a,y,q,p,this.s(h,W-V),n,c,u,f,t),f>=u)return t;y+=k}const I=y===i.startLineNumber?i.startColumn-1:0;if(y===i.endLineNumber){const P=this.getLineContent(y).substring(I,i.endColumn-1);return f=this.n(n,a,P,i.endLineNumber,I,f,t,c,u),t}if(f=this.n(n,a,this.getLineContent(y).substr(I),y,I,f,t,c,u),f>=u)return t;y++,d=this.H(y,1),h=d.node,p=this.s(d.node,d.remainder)}if(y===i.endLineNumber){const k=y===i.startLineNumber?i.startColumn-1:0,I=this.getLineContent(y).substring(k,i.endColumn-1);return f=this.n(n,a,I,i.endLineNumber,k,f,t,c,u),t}const E=y===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode($.node,a,y,E,p,v,n,c,u,f,t),t}n(i,n,c,u,t,f,a,d,$){const p=i.wordSeparators;if(!d&&i.simpleSearch){const y=i.simpleSearch,h=y.length,E=c.length;let k=-h;for(;(k=c.indexOf(y,k+h))!==-1;)if((!p||(0,A.$XC)(p,c,E,k,h))&&(a[f++]=new M.$Yv(new O.$yt(u,k+1+t,u,k+1+h+t),null),f>=$))return f;return f}let v;n.reset(0);do if(v=n.next(c),v&&(a[f++]=(0,A.$VC)(new O.$yt(u,v.index+1+t,u,v.index+1+v[0].length+t),v,d),f>=$))return f;while(v);return f}insert(i,n,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==T.$KC){const{node:u,remainder:t,nodeStartOffset:f}=this.G(i),a=u.piece,d=a.bufferIndex,$=this.s(u,t);if(u.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&f+a.length===i&&n.length<b){this.F(u,n),this.y();return}if(f===i)this.o(n,u),this.h.validate(i);else if(f+u.piece.length>i){const p=[];let v=new l(a.bufferIndex,$,a.end,this.t(a.bufferIndex,$,a.end),this.u(d,a.end)-this.u(d,$));if(this.K()&&this.M(n)&&this.I(u,t)===10){const k={line:v.start.line+1,column:0};v=new l(v.bufferIndex,k,v.end,this.t(v.bufferIndex,k,v.end),v.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(u,t-1)===13){const k=this.s(u,t-1);this.C(u,k),n="\r"+n,u.piece.length===0&&p.push(u)}else this.C(u,$);else this.C(u,$);const y=this.w(n);v.length>0&&this.S(u,v);let h=u;for(let E=0;E<y.length;E++)h=this.S(h,y[E]);this.v(p)}else this.q(n,u)}else{const u=this.w(n);let t=this.T(null,u[0]);for(let f=1;f<u.length;f++)t=this.S(t,u[f])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===T.$KC)return;const c=this.G(i),u=this.G(i+n),t=c.node,f=u.node;if(t===f){const y=this.s(t,c.remainder),h=this.s(t,u.remainder);if(c.nodeStartOffset===i){if(n===t.piece.length){const E=t.next();(0,T.$PC)(this,t),this.N(E),this.y();return}this.D(t,h),this.h.validate(i),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===i+n){this.C(t,y),this.O(t),this.y();return}this.E(t,y,h),this.y();return}const a=[],d=this.s(t,c.remainder);this.C(t,d),this.h.validate(i),t.piece.length===0&&a.push(t);const $=this.s(f,u.remainder);this.D(f,$),f.piece.length===0&&a.push(f);const p=t.next();for(let y=p;y!==T.$KC&&y!==f;y=y.next())a.push(y);const v=t.piece.length===0?t.prev():t;this.v(a),this.O(v),this.y()}o(i,n){const c=[];if(this.K()&&this.M(i)&&this.L(n)){const f=n.piece,a={line:f.start.line+1,column:0},d=new l(f.bufferIndex,a,f.end,this.t(f.bufferIndex,a,f.end),f.length-1);n.piece=d,i+=`
`,(0,T.$RC)(this,n,-1,-1),n.piece.length===0&&c.push(n)}const u=this.w(i);let t=this.T(n,u[u.length-1]);for(let f=u.length-2;f>=0;f--)t=this.T(t,u[f]);this.N(t),this.v(c)}q(i,n){this.Q(i,n)&&(i+=`
`);const c=this.w(i),u=this.S(n,c[0]);let t=u;for(let f=1;f<c.length;f++)t=this.S(t,c[f]);this.N(u)}s(i,n,c){const u=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,d=f[u.start.line]+u.start.column+n;let $=u.start.line,p=u.end.line,v=0,y=0,h=0;for(;$<=p&&(v=$+(p-$)/2|0,h=f[v],v!==p);)if(y=f[v+1],d<h)p=v-1;else if(d>=y)$=v+1;else break;return c?(c.line=v,c.column=d-h,null):{line:v,column:d-h}}t(i,n,c){if(c.column===0)return c.line-n.line;const u=this.a[i].lineStarts;if(c.line===u.length-1)return c.line-n.line;const t=u[c.line+1],f=u[c.line]+c.column;if(t>f+1)return c.line-n.line;const a=f-1;return this.a[i].buffer.charCodeAt(a)===13?c.line-n.line+1:c.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,T.$PC)(this,i[n])}w(i){if(i.length>b){const p=[];for(;i.length>b;){const y=i.charCodeAt(b-1);let h;y===13||y>=55296&&y<=56319?(h=i.substring(0,b-1),i=i.substring(b-1)):(h=i.substring(0,b),i=i.substring(b));const E=N(h);p.push(new l(this.a.length,{line:0,column:0},{line:E.length-1,column:h.length-E[E.length-1]},E.length-1,h.length)),this.a.push(new w(h,E))}const v=N(i);return p.push(new l(this.a.length,{line:0,column:0},{line:v.length-1,column:i.length-v[v.length-1]},v.length-1,i.length)),this.a.push(new w(i,v)),p}let n=this.a[0].buffer.length;const c=N(i,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let p=0;p<c.length;p++)c[p]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let p=0;p<c.length;p++)c[p]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[f],d={line:f,column:a},$=new l(0,u,d,this.t(0,u,d),t-n);return this.g=d,[$]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let c=this.root,u="";const t=this.h.get2(i);if(t){c=t.node;const f=this.B(c,i-t.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===i)u=a.substring(d+f,d+c.piece.length);else{const $=this.B(c,i-t.nodeStartLineNumber);return a.substring(d+f,d+$-n)}}else{let f=0;const a=i;for(;c!==T.$KC;)if(c.left!==T.$KC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const d=this.B(c,i-c.lf_left-2),$=this.B(c,i-c.lf_left-1),p=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);return f+=c.size_left,this.h.set({node:c,nodeStartOffset:f,nodeStartLineNumber:a-(i-1-c.lf_left)}),p.substring(v+d,v+$-n)}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const d=this.B(c,i-c.lf_left-2),$=this.a[c.piece.bufferIndex].buffer,p=this.u(c.piece.bufferIndex,c.piece.start);u=$.substring(p+d,p+c.piece.length);break}else i-=c.lf_left+c.piece.lineFeedCnt,f+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==T.$KC;){const f=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return u+=f.substring(d,d+a-n),u}else{const a=this.u(c.piece.bufferIndex,c.piece.start);u+=f.substr(a,c.piece.length)}c=c.next()}return u}y(){let i=this.root,n=1,c=0;for(;i!==T.$KC;)n+=i.lf_left+i.piece.lineFeedCnt,c+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=c,this.h.validate(this.c)}A(i,n){const c=i.piece,u=this.s(i,n),t=u.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===n){const f=this.t(i.piece.bufferIndex,c.start,u);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:u.column}}B(i,n){if(n<0)return 0;const c=i.piece,u=this.a[c.bufferIndex].lineStarts,t=c.start.line+n+1;return t>c.end.line?u[c.end.line]+c.end.column-u[c.start.line]-c.start.column:u[t]-u[c.start.line]-c.start.column}C(i,n){const c=i.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),f=n,a=this.u(c.bufferIndex,f),d=this.t(c.bufferIndex,c.start,f),$=d-u,p=a-t,v=c.length+p;i.piece=new l(c.bufferIndex,c.start,f,d,v),(0,T.$RC)(this,i,p,$)}D(i,n){const c=i.piece,u=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),f=n,a=this.t(c.bufferIndex,f,c.end),d=this.u(c.bufferIndex,f),$=a-u,p=t-d,v=c.length+p;i.piece=new l(c.bufferIndex,f,c.end,a,v),(0,T.$RC)(this,i,p,$)}E(i,n,c){const u=i.piece,t=u.start,f=u.end,a=u.length,d=u.lineFeedCnt,$=n,p=this.t(u.bufferIndex,u.start,$),v=this.u(u.bufferIndex,n)-this.u(u.bufferIndex,t);i.piece=new l(u.bufferIndex,u.start,$,p,v),(0,T.$RC)(this,i,v-a,p-d);const y=new l(u.bufferIndex,c,f,this.t(u.bufferIndex,c,f),this.u(u.bufferIndex,f)-this.u(u.bufferIndex,c)),h=this.S(i,y);this.N(h)}F(i,n){this.Q(n,i)&&(n+=`
`);const c=this.K()&&this.L(n)&&this.M(i),u=this.a[0].buffer.length;this.a[0].buffer+=n;const t=N(n,!1);for(let h=0;h<t.length;h++)t[h]+=u;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[f],d={line:f,column:a},$=i.piece.length+n.length,p=i.piece.lineFeedCnt,v=this.t(0,i.piece.start,d),y=v-p;i.piece=new l(i.piece.bufferIndex,i.piece.start,d,v,$),this.g=d,(0,T.$RC)(this,i,n.length,y)}G(i){let n=this.root;const c=this.h.get(i);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:i-c.nodeStartOffset};let u=0;for(;n!==T.$KC;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){u+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:u};return this.h.set(t),t}else i-=n.size_left+n.piece.length,u+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let c=this.root,u=0;for(;c!==T.$KC;)if(c.left!==T.$KC&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const t=this.B(c,i-c.lf_left-2),f=this.B(c,i-c.lf_left-1);return u+=c.size_left,{node:c,remainder:Math.min(t+n-1,f),nodeStartOffset:u}}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const t=this.B(c,i-c.lf_left-2);if(t+n-1<=c.piece.length)return{node:c,remainder:t+n-1,nodeStartOffset:u};n-=c.piece.length-t;break}else i-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==T.$KC;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),f=this.J(c);return{node:c,remainder:Math.min(n-1,t),nodeStartOffset:f}}else if(c.piece.length>=n-1){const t=this.J(c);return{node:c,remainder:n-1,nodeStartOffset:t}}else n-=c.piece.length;c=c.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const c=this.a[i.piece.bufferIndex],u=this.u(i.piece.bufferIndex,i.piece.start)+n;return c.buffer.charCodeAt(u)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===T.$KC||i.piece.lineFeedCnt===0)return!1;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,u=n.start.line,t=c[u]+n.start.column;return u===c.length-1||c[u+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===T.$KC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const c=[],u=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:u[i.piece.end.line]-u[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,a=i.piece.lineFeedCnt-1;i.piece=new l(i.piece.bufferIndex,i.piece.start,t,a,f),(0,T.$RC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const d={line:n.piece.start.line+1,column:0},$=n.piece.length-1,p=this.t(n.piece.bufferIndex,d,n.piece.end);n.piece=new l(n.piece.bufferIndex,d,n.piece.end,p,$),(0,T.$RC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const v=this.w(`\r
`);this.S(i,v[0]);for(let y=0;y<c.length;y++)(0,T.$PC)(this,c[y])}Q(i,n){if(this.K()&&this.M(i)){const c=n.next();if(this.L(c)){if(i+=`
`,c.piece.length===1)(0,T.$PC)(this,c);else{const u=c.piece,t={line:u.start.line+1,column:0},f=u.length-1,a=this.t(u.bufferIndex,t,u.end);c.piece=new l(u.bufferIndex,t,u.end,a,f),(0,T.$RC)(this,c,-1,-1)}return!0}}return!1}iterate(i,n){if(i===T.$KC)return n(T.$KC);const c=this.iterate(i.left,n);return c&&n(i)&&this.iterate(i.right,n)}R(i){if(i===T.$KC)return"";const n=this.a[i.piece.bufferIndex],c=i.piece,u=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return n.buffer.substring(u,t)}getPieceContent(i){const n=this.a[i.bufferIndex],c=this.u(i.bufferIndex,i.start),u=this.u(i.bufferIndex,i.end);return n.buffer.substring(c,u)}S(i,n){const c=new T.$JC(n,1);if(c.left=T.$KC,c.right=T.$KC,c.parent=T.$KC,c.size_left=0,c.lf_left=0,this.root===T.$KC)this.root=c,c.color=0;else if(i.right===T.$KC)i.right=c,c.parent=i;else{const t=(0,T.$LC)(i.right);t.left=c,c.parent=t}return(0,T.$QC)(this,c),c}T(i,n){const c=new T.$JC(n,1);if(c.left=T.$KC,c.right=T.$KC,c.parent=T.$KC,c.size_left=0,c.lf_left=0,this.root===T.$KC)this.root=c,c.color=0;else if(i.left===T.$KC)i.left=c,c.parent=i;else{const u=(0,T.$MC)(i.left);u.right=c,c.parent=u}return(0,T.$QC)(this,c),c}U(i){let n="";return this.iterate(i,c=>(n+=this.R(c),!0)),n}}e.$4C=s}),define(Se[143],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L0=e.$K0=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const A=this.a.get(T);return this.a.delete(T),A}}addDragOperationTransfer(T,A){this.a.set(T,A)}}e.$K0=C;class O{constructor(T){this.identifier=T}}e.$L0=O}),define(Se[144],Ie([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(Se[145],Ie([1,0,5,6,144]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=void 0,e.$ij=N;class T extends O.$Uc{constructor(l,w="",g="",r=!0,s){super(),this.h=this.B(new C.$fe),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=w,this.u=g,this.w=r,this.C=s}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,w){this.C&&await this.C(l)}}e.$dj=T;class A extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new C.$fe),this.onWillRun=this.f.event,this.m=this.B(new C.$fe),this.onDidRun=this.m.event}async run(l,w){if(!l.enabled)return;this.f.fire({action:l});let g;try{await this.u(l,w)}catch(r){g=r}this.m.fire({action:l,error:g})}async u(l,w){await l.run(w)}}e.$ej=A;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let w=[];for(const g of l)g.length&&(w.length?w=[...w,new b,...g]:w=g);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$fj=b;class m{get actions(){return this.a}constructor(l,w,g,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=w,this.class=r,this.a=g}async run(){}}e.$gj=m;class D extends T{static{this.ID="vs.actions.empty"}constructor(){super(D.ID,M.localize(0,null),void 0,!1)}}e.$hj=D;function N(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...l)=>S.run(...l),tooltip:S.label}}}),define(Se[146],Ie([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(Se[147],Ie([1,0,146]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=D,e.$5m=N,e.$6m=S;const O=60,M=O*60,T=M*24,A=T*7,b=T*30,m=T*365;function D(l,w,g,r){typeof l!="number"&&(l=l.getTime());const s=Math.round((new Date().getTime()-l)/1e3);if(s<-30)return(0,C.localize)(0,null,D(new Date().getTime()+s*1e3,!1));if(!r&&s<30)return(0,C.localize)(1,null);let o;return s<O?(o=s,w?o===1?g?(0,C.localize)(2,null,o):(0,C.localize)(3,null,o):g?(0,C.localize)(4,null,o):(0,C.localize)(5,null,o):o===1?g?(0,C.localize)(6,null,o):(0,C.localize)(7,null,o):g?(0,C.localize)(8,null,o):(0,C.localize)(9,null,o)):s<M?(o=Math.floor(s/O),w?o===1?g?(0,C.localize)(10,null,o):(0,C.localize)(11,null,o):g?(0,C.localize)(12,null,o):(0,C.localize)(13,null,o):o===1?g?(0,C.localize)(14,null,o):(0,C.localize)(15,null,o):g?(0,C.localize)(16,null,o):(0,C.localize)(17,null,o)):s<T?(o=Math.floor(s/M),w?o===1?g?(0,C.localize)(18,null,o):(0,C.localize)(19,null,o):g?(0,C.localize)(20,null,o):(0,C.localize)(21,null,o):o===1?g?(0,C.localize)(22,null,o):(0,C.localize)(23,null,o):g?(0,C.localize)(24,null,o):(0,C.localize)(25,null,o)):s<A?(o=Math.floor(s/T),w?o===1?(0,C.localize)(26,null,o):(0,C.localize)(27,null,o):o===1?(0,C.localize)(28,null,o):(0,C.localize)(29,null,o)):s<b?(o=Math.floor(s/A),w?o===1?g?(0,C.localize)(30,null,o):(0,C.localize)(31,null,o):g?(0,C.localize)(32,null,o):(0,C.localize)(33,null,o):o===1?g?(0,C.localize)(34,null,o):(0,C.localize)(35,null,o):g?(0,C.localize)(36,null,o):(0,C.localize)(37,null,o)):s<m?(o=Math.floor(s/b),w?o===1?g?(0,C.localize)(38,null,o):(0,C.localize)(39,null,o):g?(0,C.localize)(40,null,o):(0,C.localize)(41,null,o):o===1?g?(0,C.localize)(42,null,o):(0,C.localize)(43,null,o):g?(0,C.localize)(44,null,o):(0,C.localize)(45,null,o)):(o=Math.floor(s/m),w?o===1?g?(0,C.localize)(46,null,o):(0,C.localize)(47,null,o):g?(0,C.localize)(48,null,o):(0,C.localize)(49,null,o):o===1?g?(0,C.localize)(50,null,o):(0,C.localize)(51,null,o):g?(0,C.localize)(52,null,o):(0,C.localize)(53,null,o))}function N(l,w){const g=Math.abs(l/1e3);return g<1?w?(0,C.localize)(54,null,l):(0,C.localize)(55,null,l):g<O?w?(0,C.localize)(56,null,Math.round(l)/1e3):(0,C.localize)(57,null,Math.round(l)/1e3):g<M?w?(0,C.localize)(58,null,Math.round(l/(1e3*O))):(0,C.localize)(59,null,Math.round(l/(1e3*O))):g<T?w?(0,C.localize)(60,null,Math.round(l/(1e3*M))):(0,C.localize)(61,null,Math.round(l/(1e3*M))):(0,C.localize)(62,null,Math.round(l/(1e3*T)))}function S(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[148],Ie([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(Se[44],Ie([1,0,18,15,148]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=m,e.$kj=D,e.$lj=N;function T(S,l){return l&&(S.stack||S.stacktrace)?M.localize(0,null,b(S),A(S.stack)||A(S.stacktrace)):b(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function b(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?M.localize(1,null,S.message):S.message||M.localize(2,null)}function m(S=null,l=!1){if(!S)return M.localize(3,null);if(Array.isArray(S)){const w=C.$Hb(S),g=m(w[0],l);return w.length>1?M.localize(4,null,g,w.length):g}if(O.$$f(S))return S;if(S.detail){const w=S.detail;if(w.error)return T(w.error,l);if(w.exception)return T(w.exception,l)}return S.stack?T(S,l):S.message?S.message:M.localize(5,null)}function D(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}function N(S,l){let w;return typeof S=="string"?w=new Error(S):w=S,w.actions=l,w}}),define(Se[149],Ie([1,0,43,19]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=b,e.$lr=m,e.$mr=D,e.$nr=N,e.$or=S,e.$pr=l,e.$qr=w,e.$rr=g,e.$sr=r,e.$tr=s,e.$ur=$,e.$vr=p,e.$wr=v;const M=new C.$V(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),T=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(y,h,E=!1){const k=y||"",I=h||"",P=M.value.collator.compare(k,I);return M.value.collatorIsNumeric&&P===0&&k!==I?k<I?-1:1:P}function m(y,h){const E=T.value.collator;return y=y||"",h=h||"",c(E,y,h)}function D(y,h){const E=T.value.collator;return y=y||"",h=h||"",a(y,h)||c(E,y,h)}function N(y,h){const E=T.value.collator;return y=y||"",h=h||"",f(y,h)||c(E,y,h)}function S(y,h){return y=y||"",h=h||"",y===h?0:y<h?-1:1}function l(y,h){const[E,k]=i(y),[I,P]=i(h);let V=M.value.collator.compare(k,P);if(V===0){if(M.value.collatorIsNumeric&&k!==P)return k<P?-1:1;if(V=M.value.collator.compare(E,I),M.value.collatorIsNumeric&&V===0&&E!==I)return E<I?-1:1}return V}function w(y,h){y=y||"",h=h||"";const E=n(y),k=n(h),I=T.value.collator,P=A.value.collator;return c(P,E,k)||c(I,y,h)}function g(y,h){y=y||"",h=h||"";const E=n(y),k=n(h),I=T.value.collator,P=A.value.collator;return c(P,E,k)||a(y,h)||c(I,y,h)}function r(y,h){y=y||"",h=h||"";const E=n(y),k=n(h),I=T.value.collator,P=A.value.collator;return c(P,E,k)||f(y,h)||c(I,y,h)}function s(y,h){y=y||"",h=h||"";const E=n(y).toLowerCase(),k=n(h).toLowerCase();return E!==k?E<k?-1:1:y!==h?y<h?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function i(y,h=!1){const E=y?o.exec(y):[];let k=[E&&E[1]||"",E&&E[3]||""];return h&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function n(y){const h=y?o.exec(y):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(y,h,E){const k=y.compare(h,E);return k!==0?k:h.length!==E.length?h.length<E.length?-1:1:0}function u(y){const h=y.charAt(0);return h.toLocaleUpperCase()!==h}function t(y){const h=y.charAt(0);return h.toLocaleLowerCase()!==h}function f(y,h){return u(y)&&t(h)?-1:t(y)&&u(h)?1:0}function a(y,h){return t(y)&&u(h)?-1:u(y)&&t(h)?1:0}function d(y,h,E=!1){return E||(y=y&&y.toLowerCase(),h=h&&h.toLowerCase()),y===h?0:y<h?-1:1}function $(y,h,E=!1){const k=y.split(O.sep),I=h.split(O.sep),P=k.length-1,V=I.length-1;let W,q;for(let R=0;;R++){if(W=P===R,q=V===R,W&&q)return b(k[R],I[R],E);if(W)return-1;if(q)return 1;const z=d(k[R],I[R],E);if(z!==0)return z}}function p(y,h,E){const k=y.toLowerCase(),I=h.toLowerCase(),P=v(y,h,E);if(P)return P;const V=k.endsWith(E),W=I.endsWith(E);if(V!==W)return V?-1:1;const q=b(k,I);return q!==0?q:k.localeCompare(I)}function v(y,h,E){const k=y.toLowerCase(),I=h.toLowerCase(),P=k.startsWith(E),V=I.startsWith(E);if(P!==V)return P?-1:1;if(P&&V){if(k.length<I.length)return-1;if(k.length>I.length)return 1}return 0}}),define(Se[48],Ie([1,0,19,23,13,15]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=A,e.$rg=b,e.$sg=m,e.$tg=D,e.$ug=N,e.$vg=g,e.$wg=r,e.$xg=s,e.$yg=o,e.$zg=i,e.$Ag=n,e.$Bg=c,e.$Cg=u,e.$Dg=t,e.$Eg=f,e.$Fg=a,e.$Gg=p;function A(v){return v===47||v===92}function b(v){return v.replace(/[\\/]/g,C.$gc.sep)}function m(v){return v.indexOf("/")===-1&&(v=b(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function D(v,y=C.$gc.sep){if(!v)return"";const h=v.length,E=v.charCodeAt(0);if(A(E)){if(A(v.charCodeAt(1))&&!A(v.charCodeAt(2))){let I=3;const P=I;for(;I<h&&!A(v.charCodeAt(I));I++);if(P!==I&&!A(v.charCodeAt(I+1))){for(I+=1;I<h;I++)if(A(v.charCodeAt(I)))return v.slice(0,I+1).replace(/[\\/]/g,y)}}return y}else if(o(E)&&v.charCodeAt(1)===58)return A(v.charCodeAt(2))?v.slice(0,2)+y:v.slice(0,2);let k=v.indexOf("://");if(k!==-1){for(k+=3;k<h;k++)if(A(v.charCodeAt(k)))return v.slice(0,k+1)}return""}function N(v){if(!O.$i||!v||v.length<5)return!1;let y=v.charCodeAt(0);if(y!==92||(y=v.charCodeAt(1),y!==92))return!1;let h=2;const E=h;for(;h<v.length&&(y=v.charCodeAt(h),y!==92);h++);return!(E===h||(y=v.charCodeAt(h+1),isNaN(y)||y===92))}const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(v,y=O.$i){const h=y?S:l;return!(!v||v.length===0||/^\s+$/.test(v)||(h.lastIndex=0,h.test(v))||y&&w.test(v)||v==="."||v===".."||y&&v[v.length-1]==="."||y&&v.length!==v.trim().length||v.length>255)}function r(v,y,h){const E=v===y;return!h||E?E:!v||!y?!1:(0,M.$zf)(v,y)}function s(v,y,h,E=C.sep){if(v===y)return!0;if(!v||!y||y.length>v.length)return!1;if(h){if(!(0,M.$Af)(v,y))return!1;if(y.length===v.length)return!0;let I=y.length;return y.charAt(y.length-1)===E&&I--,v.charAt(I)===E}return y.charAt(y.length-1)!==E&&(y+=E),v.indexOf(y)===0}function o(v){return v>=65&&v<=90||v>=97&&v<=122}function i(v,y){return O.$i&&v.endsWith(":")&&(v+=C.sep),(0,C.$ic)(v)||(v=(0,C.$jc)(y,v)),v=(0,C.$hc)(v),n(v)}function n(v){return O.$i?(v=(0,M.$hf)(v,C.sep),v.endsWith(":")&&(v+=C.sep)):(v=(0,M.$hf)(v,C.sep),v||(v=C.sep)),v}function c(v){const y=(0,C.$hc)(v);return O.$i?v.length>3?!1:u(y)&&(v.length===2||y.charCodeAt(2)===92):y===C.$gc.sep}function u(v,y=O.$i){return y?o(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}function t(v,y=O.$i){return u(v,y)?v[0]:void 0}function f(v,y,h){return y.length>v.length?-1:v===y?0:(h&&(v=v.toLowerCase(),y=y.toLowerCase()),v.indexOf(y))}function a(v){const y=v.split(":");let h,E,k;for(const I of y){const P=Number(I);(0,T.$cg)(P)?E===void 0?E=P:k===void 0&&(k=P):h=h?[h,I].join(":"):I}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:E!==void 0?E:void 0,column:k!==void 0?k:E!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(v,y,h=8){let E="";for(let I=0;I<h;I++){let P;I===0&&O.$i&&!y&&(h===3||h===4)?P=$:P=d,E+=P.charAt(Math.floor(Math.random()*P.length))}let k;return y?k=`${y}-${E}`:k=E,v?(0,C.$jc)(v,k):k}}),define(Se[70],Ie([1,0,19]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Vs=T,e.$Ws=A,e.$Xs=b,e.$Ys=D,e.$Us=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(N){const S=(0,C.$oc)(N),l=O[S.toLowerCase()];return l!==void 0?l:A(N)}function A(N){const S=(0,C.$oc)(N);return M[S.toLowerCase()]}function b(N){for(const S in M)if(M[S]===N)return S}const m=/^(.+)\/(.+?)(;.+)?$/;function D(N,S){const l=m.exec(N);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:N}}),define(Se[49],Ie([1,0,22,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=M,e.$7h=T,e.$8h=b;function M(m){return JSON.stringify(m,A)}function T(m){let D=JSON.parse(m);return D=b(D),D}function A(m,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:D.flags}:D}function b(m,D=0){if(!m||D>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return O.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof C.$He||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let N=0;N<m.length;++N)m[N]=b(m[N],D+1);else for(const N in m)Object.hasOwnProperty.call(m,N)&&(m[N]=b(m[N],D+1))}return m}}),define(Se[16],Ie([1,0,14,23,13,2,19]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Lg=e.$Kg=e.$Jg=e.Schemas=void 0,e.$Hg=m,e.$Ig=D,e.$Mg=S;var b;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatCodeBlock="vscode-chat-code-block",g.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm",g.commentsInput="comment",g.codeSetting="code-setting"})(b||(e.Schemas=b={}));function m(g,r){return T.URI.isUri(g)?(0,M.$zf)(g.scheme,r):(0,M.$Af)(g,r+":")}function D(g,...r){return r.some(s=>m(g,s))}e.$Jg="vscode-tkn",e.$Kg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,s){this.f=S(r,s)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,b.vscodeRemoteResource)}set(r,s,o){this.a[r]=s,this.b[r]=o}setConnectionToken(r,s){this.c[r]=s}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(u){return C.$1(u),r}const s=r.authority;let o=this.a[s];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const i=this.b[s],n=this.c[s];let c=`path=${encodeURIComponent(r.path)}`;return typeof n=="string"&&(c+=`&${e.$Kg}=${encodeURIComponent(n)}`),T.URI.from({scheme:O.$o?this.d:b.vscodeRemoteResource,authority:`${o}:${i}`,path:this.g,query:c})}}e.$Lg=new N;function S(g,r){return A.$gc.join(r??"/",`${g.quality??"oss"}-${g.commit??"dev"}`)}e.$Ng="vs/../../extensions",e.$Og="vs/../../node_modules",e.$Pg="vs/../../node_modules.asar",e.$Qg="vs/../../node_modules.asar.unpacked",e.$Rg="vscode-app";class l{static{this.a=e.$Rg}asBrowserUri(r){const s=this.b(r,le);return this.uriToBrowserUri(s)}uriToBrowserUri(r){return r.scheme===b.vscodeRemote?e.$Lg.rewrite(r):r.scheme===b.file&&(O.$m||O.$q===`${b.vscodeFileResource}://${l.a}`)?r.with({scheme:b.vscodeFileResource,authority:r.authority||l.a,query:null,fragment:null}):r}asFileUri(r){const s=this.b(r,le);return this.uriToFileUri(s)}uriToFileUri(r){return r.scheme===b.vscodeFileResource?r.with({scheme:b.file,authority:r.authority!==l.a?r.authority:null,query:null,fragment:null}):r}b(r,s){return T.URI.isUri(r)?r:T.URI.parse(s.toUrl(r))}}e.$Sg=new l;var w;(function(g){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(r.get("3"));const s="vscode-coi";function o(n){let c;typeof n=="string"?c=new URL(n).searchParams:n instanceof URL?c=n.searchParams:T.URI.isUri(n)&&(c=new URL(n.toString(!0)).searchParams);const u=c?.get(s);if(u)return r.get(u)}g.getHeadersFromQuery=o;function i(n,c,u){if(!globalThis.crossOriginIsolated)return;const t=c&&u?"3":u?"2":"1";n instanceof URLSearchParams?n.set(s,t):n[s]=t}g.addSearchParam=i})(w||(e.COI=w={}))}),define(Se[24],Ie([1,0,48,16,19,23,13,2]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0,e.$Zg=m,e.$ih=N,e.$jh=l;function m(w){return(0,b.$wc)(w,!0)}class D{constructor(g){this.a=g}compare(g,r,s=!1){return g===r?0:(0,A.$sf)(this.getComparisonKey(g,s),this.getComparisonKey(r,s))}isEqual(g,r,s=!1){return g===r?!0:!g||!r?!1:this.getComparisonKey(g,s)===this.getComparisonKey(r,s)}getComparisonKey(g,r=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,r,s=!1){if(g.scheme===r.scheme){if(g.scheme===O.Schemas.file)return C.$xg(m(g),m(r),this.a(g))&&g.query===r.query&&(s||g.fragment===r.fragment);if((0,e.$eh)(g.authority,r.authority))return C.$xg(g.path,r.path,this.a(g),"/")&&g.query===r.query&&(s||g.fragment===r.fragment)}return!1}joinPath(g,...r){return b.URI.joinPath(g,...r)}basenameOrAuthority(g){return(0,e.$9g)(g)||g.authority}basename(g){return M.$gc.basename(g.path)}extname(g){return M.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let r;return g.scheme===O.Schemas.file?r=b.URI.file(M.$mc(m(g))).path:(r=M.$gc.dirname(g.path),g.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),r="/")),g.with({path:r})}normalizePath(g){if(!g.path.length)return g;let r;return g.scheme===O.Schemas.file?r=b.URI.file(M.$hc(m(g))).path:r=M.$gc.normalize(g.path),g.with({path:r})}relativePath(g,r){if(g.scheme!==r.scheme||!(0,e.$eh)(g.authority,r.authority))return;if(g.scheme===O.Schemas.file){const i=M.$lc(m(g),m(r));return T.$i?C.$rg(i):i}let s=g.path||"/";const o=r.path||"/";if(this.a(g)){let i=0;for(const n=Math.min(s.length,o.length);i<n&&!(s.charCodeAt(i)!==o.charCodeAt(i)&&s.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);s=o.substr(0,i)+s.substr(i)}return M.$gc.relative(s,o)}resolvePath(g,r){if(g.scheme===O.Schemas.file){const s=b.URI.file(M.$kc(m(g),r));return g.with({authority:s.authority,path:s.path})}return r=C.$sg(r),g.with({path:M.$gc.resolve(g.path,r)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,r){return g===r||g!==void 0&&r!==void 0&&(0,A.$zf)(g,r)}hasTrailingPathSeparator(g,r=M.sep){if(g.scheme===O.Schemas.file){const s=m(g);return s.length>C.$tg(s).length&&s[s.length-1]===r}else{const s=g.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,r=M.sep){return(0,e.$fh)(g,r)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,r=M.sep){let s=!1;if(g.scheme===O.Schemas.file){const o=m(g);s=o!==void 0&&o.length===C.$tg(o).length&&o[o.length-1]===r}else{r="/";const o=g.path;s=o.length===1&&o.charCodeAt(o.length-1)===47}return!s&&!(0,e.$fh)(g,r)?g.with({path:g.path+"/"}):g}}e.$1g=D,e.$2g=new D(()=>!1),e.$3g=new D(w=>w.scheme===O.Schemas.file?!T.$k:!0),e.$4g=new D(w=>!0),e.$5g=e.$2g.isEqual.bind(e.$2g),e.$6g=e.$2g.isEqualOrParent.bind(e.$2g),e.$7g=e.$2g.getComparisonKey.bind(e.$2g),e.$8g=e.$2g.basenameOrAuthority.bind(e.$2g),e.$9g=e.$2g.basename.bind(e.$2g),e.$0g=e.$2g.extname.bind(e.$2g),e.$$g=e.$2g.dirname.bind(e.$2g),e.$_g=e.$2g.joinPath.bind(e.$2g),e.$ah=e.$2g.normalizePath.bind(e.$2g),e.$bh=e.$2g.relativePath.bind(e.$2g),e.$ch=e.$2g.resolvePath.bind(e.$2g),e.$dh=e.$2g.isAbsolutePath.bind(e.$2g),e.$eh=e.$2g.isEqualAuthority.bind(e.$2g),e.$fh=e.$2g.hasTrailingPathSeparator.bind(e.$2g),e.$gh=e.$2g.removeTrailingPathSeparator.bind(e.$2g),e.$hh=e.$2g.addTrailingPathSeparator.bind(e.$2g);function N(w,g){const r=[];for(let s=0;s<w.length;s++){const o=g(w[s]);w.some((i,n)=>n===s?!1:(0,e.$6g)(o,g(i)))||r.push(w[s])}return r}var S;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function g(r){const s=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(n=>{const[c,u]=n.split(":");c&&u&&s.set(c,u)});const i=r.path.substring(0,r.path.indexOf(";"));return i&&s.set(w.META_DATA_MIME,i),s}w.parseMetaData=g})(S||(e.DataUri=S={}));function l(w,g,r){if(g){let s=w.path;return s&&s[0]!==M.$gc.sep&&(s=M.$gc.sep+s),w.with({scheme:r,authority:g,path:s})}return w.with({scheme:r})}}),define(Se[11],Ie([1,0,20,14,5,6,24,23,136,43]),function(le,e,C,O,M,T,A,b,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.Promises=e.$Vh=e.$Uh=e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0,e.$kh=N,e.$lh=S,e.$mh=l,e.$nh=w,e.$oh=g,e.$ph=r,e.$qh=s,e.$rh=o,e.$zh=p,e.$Ah=v,e.$Bh=y,e.$Ch=h,e.$Dh=E,e.$Sh=De,e.$1h=ke;function N(me){return!!me&&typeof me.then=="function"}function S(me){const Q=new C.$qe,Y=me(Q.token),he=new Promise((ce,Te)=>{const fe=Q.token.onCancellationRequested(()=>{fe.dispose(),Te(new O.$5)});Promise.resolve(Y).then(Pe=>{fe.dispose(),Q.dispose(),ce(Pe)},Pe=>{fe.dispose(),Q.dispose(),Te(Pe)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ce,Te){return he.then(ce,Te)}catch(ce){return this.then(void 0,ce)}finally(ce){return he.finally(ce)}}}function l(me,Q,Y){return new Promise((he,ce)=>{const Te=Q.onCancellationRequested(()=>{Te.dispose(),he(Y)});me.then(he,ce).finally(()=>Te.dispose())})}function w(me,Q){return new Promise((Y,he)=>{const ce=Q.onCancellationRequested(()=>{ce.dispose(),he(new O.$5)});me.then(Y,he).finally(()=>ce.dispose())})}async function g(me){let Q=-1;const Y=me.map((he,ce)=>he.then(Te=>(Q=ce,Te)));try{return await Promise.race(Y)}finally{me.forEach((he,ce)=>{ce!==Q&&he.cancel()})}}function r(me,Q,Y){let he;const ce=setTimeout(()=>{he?.(void 0),Y?.()},Q);return Promise.race([me.finally(()=>clearTimeout(ce)),new Promise(Te=>he=Te)])}function s(me){return new Promise((Q,Y)=>{const he=me();N(he)?he.then(Q,Y):Q(he)})}function o(){let me,Q;return{promise:new Promise((he,ce)=>{me=he,Q=ce}),resolve:me,reject:Q}}class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=Q(),new Promise((Y,he)=>{this.a.then(ce=>{this.a=null,Y(ce)},ce=>{this.a=null,he(ce)})})}dispose(){this.f=!0}}e.$sh=i;class n{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$th=n;class c{constructor(){this.a=new Map}queue(Q,Y){const ce=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===ce&&this.a.delete(Q)});return this.a.set(Q,ce),ce}}e.$uh=c;const u=(me,Q)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,Q()},me);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},t=me=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,me())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class f{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ce,Te)=>{this.d=ce,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const ce=this.g;return this.g=null,ce()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===m.$ce?t(he):u(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$vh=f;class a{constructor(Q){this.a=new f(Q),this.b=new i}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$wh=a;class d{constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$xh=d;class $ extends d{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$yh=$;function p(me,Q){return Q?new Promise((Y,he)=>{const ce=setTimeout(()=>{Te.dispose(),Y()},me),Te=Q.onCancellationRequested(()=>{clearTimeout(ce),Te.dispose(),he(new O.$5)})}):S(Y=>p(me,Y))}function v(me,Q=0,Y){const he=setTimeout(()=>{me(),Y&&ce.dispose()},Q),ce=(0,T.$Sc)(()=>{clearTimeout(he),Y?.deleteAndLeak(ce)});return Y?.add(ce),ce}function y(me){const Q=[];let Y=0;const he=me.length;function ce(){return Y<he?me[Y++]():null}function Te(fe){fe!=null&&Q.push(fe);const Pe=ce();return Pe?Pe.then(Te):Promise.resolve(Q)}return Promise.resolve(null).then(Te)}function h(me,Q=he=>!!he,Y=null){let he=0;const ce=me.length,Te=()=>{if(he>=ce)return Promise.resolve(Y);const fe=me[he++];return Promise.resolve(fe()).then(Re=>Q(Re)?Promise.resolve(Re):Te())};return Te()}function E(me,Q=he=>!!he,Y=null){if(me.length===0)return Promise.resolve(Y);let he=me.length;const ce=()=>{he=-1;for(const Te of me)Te.cancel?.()};return new Promise((Te,fe)=>{for(const Pe of me)Pe.then(Re=>{--he>=0&&Q(Re)?(ce(),Te(Re)):he===0&&Te(Y)}).catch(Re=>{--he>=0&&(ce(),fe(Re))})})}class k{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new M.$fe}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:Q,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Eh=k;class I extends k{constructor(){super(1)}}e.$Fh=I;class P{constructor(){this.a=new ge,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Gh=P;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new se;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=A.$2g){const he=Y.getComparisonKey(Q);return this.a.get(he)?.size??0}queueFor(Q,Y,he=A.$2g){const ce=he.getComparisonKey(Q);let Te=this.a.get(ce);if(!Te){Te=new I;const fe=this.f++,Pe=M.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$4c),this.d.set(fe,Pe),this.a.set(ce,Te)}return Te.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Hh=V;class W{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$Ih=W;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,he=globalThis){this.cancel();const ce=he.setInterval(()=>{Q()},Y);this.d=(0,T.$Sc)(()=>{he.clearInterval(ce),this.d=void 0})}dispose(){this.cancel()}}e.$Jh=q;class R{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Kh=R;class z{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Lh=z;class G extends R{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Mh=G;class ie extends T.$Uc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new T.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Nh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ph=(me,Q)=>{(0,b.$B)(()=>{if(Y)return;const he=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Ph=(me,Q,Y)=>{const he=me.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,me.cancelIdleCallback(he))}}},e.$Oh=me=>(0,e.$Ph)(globalThis,me)}();class de{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Ph)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Qh=de;class ye extends de{constructor(Q){super(globalThis,Q)}}e.$Rh=ye;async function De(me,Q,Y){let he;for(let ce=0;ce<Y;ce++)try{return await me()}catch(Te){he=Te,await p(Q)}throw he}class ge{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,he){return this.a={taskId:Q,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:he,reject:ce}=o();this.b={run:Q,promise:Y,promiseResolve:he,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Th=ge;class ue{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Uh=ue;var Ce;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(Ce||(Ce={}));class se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new O.$5)}}e.$Vh=se;var Oe;(function(me){async function Q(he){let ce;const Te=await Promise.all(he.map(fe=>fe.then(Pe=>Pe,Pe=>{ce||(ce=Pe)})));if(typeof ce<"u")throw ce;return Te}me.settled=Q;function Y(he){return new Promise(async(ce,Te)=>{try{await he(ce,Te)}catch(fe){Te(fe)}})}me.withAsyncBody=Y})(Oe||(e.Promises=Oe={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Wh=ne;class j{constructor(Q){this.b=Q,this.a=new D.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Xh=j;var x;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(x||(x={}));class ve{static fromArray(Q){return new ve(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new ve(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new ve(async Y=>{await Promise.all(Q.map(async he=>Y.emitOne(await he)))})}static merge(Q){return new ve(async Y=>{await Promise.all(Q.map(async he=>{for await(const ce of he)Y.emitOne(ce)}))})}static{this.EMPTY=ve.fromArray([])}constructor(Q,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new M.$fe,queueMicrotask(async()=>{const he={emitOne:ce=>this.h(ce),emitMany:ce=>this.j(ce),reject:ce=>this.l(ce)};try{await Promise.resolve(Q(he)),this.k()}catch(ce){this.l(ce)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,Y){return new ve(async he=>{for await(const ce of Q)he.emitOne(Y(ce))})}map(Q){return ve.map(this,Q)}static filter(Q,Y){return new ve(async he=>{for await(const ce of Q)Y(ce)&&he.emitOne(ce)})}filter(Q){return ve.filter(this,Q)}static coalesce(Q){return ve.filter(Q,Y=>!!Y)}coalesce(){return ve.coalesce(this)}static async toPromise(Q){const Y=[];for await(const he of Q)Y.push(he);return Y}toPromise(){return ve.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Yh=ve;class Le extends ve{constructor(Q,Y){super(Y),this.m=Q}cancel(){this.m.cancel()}}e.$Zh=Le;function ke(me){const Q=new C.$qe,Y=me(Q.token);return new Le(Q,async he=>{const ce=Q.token.onCancellationRequested(()=>{ce.dispose(),Q.dispose(),he.reject(new O.$5)});try{for await(const Te of Y){if(Q.token.isCancellationRequested)return;he.emitOne(Te)}ce.dispose(),Q.dispose()}catch(Te){ce.dispose(),Q.dispose(),he.reject(Te)}})}class be{constructor(Q){this.a=new se,this.b=new ve(ce=>{if(Y){ce.reject(Y);return}return he&&ce.emitMany(he),this.d=Te=>ce.reject(Te),this.f=Te=>ce.emitOne(Te),this.a.p},Q);let Y,he;this.f=ce=>{he||(he=[]),he.push(ce)},this.d=ce=>{Y||(Y=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$2h=be}),define(Se[37],Ie([1,0,18,11,48,28,19,23,13]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=void 0,e.$nk=D,e.$qk=g,e.$rk=I,e.$sk=P,e.$tk=V,e.$uk=W,e.$vk=q,e.$wk=ie;function D(){return Object.create(null)}e.$ok="**",e.$pk="/";const N="[/\\\\]",S="[^/\\\\]",l=/\//g;function w(de,ye){switch(de){case 0:return"";case 1:return`${S}*?`;default:return`(?:${N}|${S}+${N}${ye?`|${N}${S}+`:""})*?`}}function g(de,ye){if(!de)return[];const De=[];let ge=!1,ue=!1,Ce="";for(const se of de){switch(se){case ye:if(!ge&&!ue){De.push(Ce),Ce="";continue}break;case"{":ge=!0;break;case"}":ge=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Ce+=se}return Ce&&De.push(Ce),De}function r(de){if(!de)return"";let ye="";const De=g(de,e.$pk);if(De.every(ge=>ge===e.$ok))ye=".*";else{let ge=!1;De.forEach((ue,Ce)=>{if(ue===e.$ok){if(ge)return;ye+=w(2,Ce===De.length-1)}else{let se=!1,Oe="",ne=!1,j="";for(const x of ue){if(x!=="}"&&se){Oe+=x;continue}if(ne&&(x!=="]"||!j)){let ve;x==="-"?ve=x:(x==="^"||x==="!")&&!j?ve="^":x===e.$pk?ve="":ve=(0,m.$bf)(x),j+=ve;continue}switch(x){case"{":se=!0;continue;case"[":ne=!0;continue;case"}":{const Le=`(?:${g(Oe,",").map(ke=>r(ke)).join("|")})`;ye+=Le,se=!1,Oe="";break}case"]":{ye+="["+j+"]",ne=!1,j="";break}case"?":ye+=S;continue;case"*":ye+=w(1);continue;default:ye+=(0,m.$bf)(x)}}Ce<De.length-1&&(De[Ce+1]!==e.$ok||Ce+2<De.length)&&(ye+=N)}ge=ue===e.$ok})}return ye}const s=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.$Dc(1e4),f=function(){return!1},a=function(){return null};function d(de,ye){if(!de)return a;let De;typeof de!="string"?De=de.pattern:De=de,De=De.trim();const ge=`${De}_${!!ye.trimForExclusions}`;let ue=t.get(ge);if(ue)return $(ue,de);let Ce;return s.test(De)?ue=v(De.substr(4),De):(Ce=o.exec(p(De,ye)))?ue=y(Ce[1],De):(ye.trimForExclusions?n:i).test(De)?ue=h(De,ye):(Ce=c.exec(p(De,ye)))?ue=E(Ce[1].substr(1),De,!0):(Ce=u.exec(p(De,ye)))?ue=E(Ce[1],De,!1):ue=k(De),t.set(ge,ue),$(ue,de)}function $(de,ye){if(typeof ye=="string")return de;const De=function(ge,ue){return(0,M.$xg)(ge,ye.base,!b.$k)?de((0,m.$gf)(ge.substr(ye.base.length),A.sep),ue):null};return De.allBasenames=de.allBasenames,De.allPaths=de.allPaths,De.basenames=de.basenames,De.patterns=de.patterns,De}function p(de,ye){return ye.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function v(de,ye){return function(De,ge){return typeof De=="string"&&De.endsWith(de)?ye:null}}function y(de,ye){const De=`/${de}`,ge=`\\${de}`,ue=function(se,Oe){return typeof se!="string"?null:Oe?Oe===de?ye:null:se===de||se.endsWith(De)||se.endsWith(ge)?ye:null},Ce=[de];return ue.basenames=Ce,ue.patterns=[ye],ue.allBasenames=Ce,ue}function h(de,ye){const De=G(de.slice(1,-1).split(",").map(Oe=>d(Oe,ye)).filter(Oe=>Oe!==a),de),ge=De.length;if(!ge)return a;if(ge===1)return De[0];const ue=function(Oe,ne){for(let j=0,x=De.length;j<x;j++)if(De[j](Oe,ne))return de;return null},Ce=De.find(Oe=>!!Oe.allBasenames);Ce&&(ue.allBasenames=Ce.allBasenames);const se=De.reduce((Oe,ne)=>ne.allPaths?Oe.concat(ne.allPaths):Oe,[]);return se.length&&(ue.allPaths=se),ue}function E(de,ye,De){const ge=A.sep===A.$gc.sep,ue=ge?de:de.replace(l,A.sep),Ce=A.sep+ue,se=A.$gc.sep+de;let Oe;return De?Oe=function(ne,j){return typeof ne=="string"&&(ne===ue||ne.endsWith(Ce)||!ge&&(ne===de||ne.endsWith(se)))?ye:null}:Oe=function(ne,j){return typeof ne=="string"&&(ne===ue||!ge&&ne===de)?ye:null},Oe.allPaths=[(De?"*/":"./")+de],Oe}function k(de){try{const ye=new RegExp(`^${r(de)}$`);return function(De){return ye.lastIndex=0,typeof De=="string"&&ye.test(De)?de:null}}catch{return a}}function I(de,ye,De){return!de||typeof ye!="string"?!1:P(de)(ye,void 0,De)}function P(de,ye={}){if(!de)return f;if(typeof de=="string"||V(de)){const De=d(de,ye);if(De===a)return f;const ge=function(ue,Ce){return!!De(ue,Ce)};return De.allBasenames&&(ge.allBasenames=De.allBasenames),De.allPaths&&(ge.allPaths=De.allPaths),ge}return R(de,ye)}function V(de){const ye=de;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function W(de){return de.allBasenames||[]}function q(de){return de.allPaths||[]}function R(de,ye){const De=G(Object.getOwnPropertyNames(de).map(Oe=>z(Oe,de[Oe],ye)).filter(Oe=>Oe!==a)),ge=De.length;if(!ge)return a;if(!De.some(Oe=>!!Oe.requiresSiblings)){if(ge===1)return De[0];const Oe=function(x,ve){let Le;for(let ke=0,be=De.length;ke<be;ke++){const me=De[ke](x,ve);if(typeof me=="string")return me;(0,O.$kh)(me)&&(Le||(Le=[]),Le.push(me))}return Le?(async()=>{for(const ke of Le){const be=await ke;if(typeof be=="string")return be}return null})():null},ne=De.find(x=>!!x.allBasenames);ne&&(Oe.allBasenames=ne.allBasenames);const j=De.reduce((x,ve)=>ve.allPaths?x.concat(ve.allPaths):x,[]);return j.length&&(Oe.allPaths=j),Oe}const ue=function(Oe,ne,j){let x,ve;for(let Le=0,ke=De.length;Le<ke;Le++){const be=De[Le];be.requiresSiblings&&j&&(ne||(ne=(0,A.$nc)(Oe)),x||(x=ne.substr(0,ne.length-(0,A.$oc)(Oe).length)));const me=be(Oe,ne,x,j);if(typeof me=="string")return me;(0,O.$kh)(me)&&(ve||(ve=[]),ve.push(me))}return ve?(async()=>{for(const Le of ve){const ke=await Le;if(typeof ke=="string")return ke}return null})():null},Ce=De.find(Oe=>!!Oe.allBasenames);Ce&&(ue.allBasenames=Ce.allBasenames);const se=De.reduce((Oe,ne)=>ne.allPaths?Oe.concat(ne.allPaths):Oe,[]);return se.length&&(ue.allPaths=se),ue}function z(de,ye,De){if(ye===!1)return a;const ge=d(de,De);if(ge===a)return a;if(typeof ye=="boolean")return ge;if(ye){const ue=ye.when;if(typeof ue=="string"){const Ce=(se,Oe,ne,j)=>{if(!j||!ge(se,Oe))return null;const x=ue.replace("$(basename)",()=>ne),ve=j(x);return(0,O.$kh)(ve)?ve.then(Le=>Le?de:null):ve?de:null};return Ce.requiresSiblings=!0,Ce}}return ge}function G(de,ye){const De=de.filter(Oe=>!!Oe.basenames);if(De.length<2)return de;const ge=De.reduce((Oe,ne)=>{const j=ne.basenames;return j?Oe.concat(j):Oe},[]);let ue;if(ye){ue=[];for(let Oe=0,ne=ge.length;Oe<ne;Oe++)ue.push(ye)}else ue=De.reduce((Oe,ne)=>{const j=ne.patterns;return j?Oe.concat(j):Oe},[]);const Ce=function(Oe,ne){if(typeof Oe!="string")return null;if(!ne){let x;for(x=Oe.length;x>0;x--){const ve=Oe.charCodeAt(x-1);if(ve===47||ve===92)break}ne=Oe.substr(x)}const j=ge.indexOf(ne);return j!==-1?ue[j]:null};Ce.basenames=ge,Ce.patterns=ue,Ce.allBasenames=ge;const se=de.filter(Oe=>!Oe.basenames);return se.push(Ce),se}function ie(de,ye){return(0,C.$ub)(de,ye,(De,ge)=>typeof De=="string"&&typeof ge=="string"?De===ge:typeof De!="string"&&typeof ge!="string"?De.base===ge.base&&De.pattern===ge.pattern:!1)}}),define(Se[55],Ie([1,0,14,137,24,13,2]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.MarkdownStringTextNewlineStyle=void 0,e.$Wk=D,e.$Xk=N,e.$Yk=S,e.$Zk=l,e.$1k=w,e.$2k=g,e.$3k=r,e.$4k=s;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class m{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,C.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=l(this.supportThemeIcons?(0,O.$Pk)(i):i).replace(/([ \t]+)/g,(c,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${w(n,i)}
`,this}appendLink(i,n,c){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,n){const c=new RegExp((0,T.$bf)(n),"g");return i.replace(c,(u,t)=>i.charAt(t-1)!=="\\"?`\\${u}`:u)}}e.$Vk=m;function D(o){return N(o)?!o.value:Array.isArray(o)?o.every(D):!0}function N(o){return o instanceof m?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function S(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,M.$5g)(A.URI.from(o.baseUri),A.URI.from(i.baseUri)))}function l(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(o,i){const n=o.match(/^`+/gm)?.reduce((u,t)=>u.length>t.length?u:t).length??0,c=n>=3?n+1:3;return[`${"`".repeat(c)}${i}`,o,`${"`".repeat(c)}`].join(`
`)}function g(o){return o.replace(/"/g,"&quot;")}function r(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(o){const i=[],n=o.split("|").map(u=>u.trim());o=n[0];const c=n[1];if(c){const u=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),f=u?u[1]:"",a=t?t[1]:"",d=isFinite(parseInt(a)),$=isFinite(parseInt(f));d&&i.push(`width="${a}"`),$&&i.push(`height="${f}"`)}return{href:o,dimensions:i}}}),define(Se[97],Ie([1,0,18,48,19,23,24,13]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=m,e.$Iw=N,e.$Jw=l,e.$Kw=w,e.$Lw=o,e.$Mw=n,e.$Nw=c,e.$Ow=u,e.$Pw=t,e.$Qw=f;function m(d,$){const{os:p,tildify:v,relative:y}=$;if(y){const k=D(d,y,p);if(typeof k=="string")return k}let h=d.fsPath;if(p===1&&!T.$i?h=h.replace(/\//g,"\\"):p!==1&&T.$i&&(h=h.replace(/\\/g,"/")),p!==1&&v?.userHome){const k=v.userHome.fsPath;let I;d.scheme!==v.userHome.scheme&&d.path[0]===M.$gc.sep&&d.path[1]!==M.$gc.sep?I=v.userHome.with({path:d.path}).fsPath:I=h,h=l(I,k,p)}return(p===1?M.$fc:M.$gc).normalize(N(h,p===1))}function D(d,$,p){const v=p===1?M.$fc:M.$gc,y=p===3?A.$2g:A.$4g,h=$.getWorkspace(),E=(0,C.$Ob)(h.folders);if(!E)return;d.scheme!==E.uri.scheme&&d.path[0]===M.$gc.sep&&d.path[1]!==M.$gc.sep&&(d=E.uri.with({path:d.path}));const k=$.getWorkspaceFolder(d);if(!k)return;let I;if(y.isEqual(k.uri,d)?I="":I=y.relativePath(k.uri,d)??"",I&&(I=v.normalize(I)),h.folders.length>1&&!$.noPrefix){const P=k.name?k.name:y.basenameOrAuthority(k.uri);I=I?`${P} \u2022 ${I}`:P}return I}function N(d,$=T.$i){return(0,O.$Cg)(d,$)?d.charAt(0).toUpperCase()+d.slice(1):d}let S=Object.create(null);function l(d,$,p=T.OS){if(p===1||!d||!$)return d;let v=S.original===$?S.normalized:void 0;v||(v=$,T.$i&&(v=(0,O.$rg)(v)),v=`${(0,b.$hf)(v,M.$gc.sep)}${M.$gc.sep}`,S={original:$,normalized:v});let y=d;return T.$i&&(y=(0,O.$rg)(y)),(p===3?y.startsWith(v):(0,b.$Af)(y,v))?`~/${y.substr(v.length)}`:d}function w(d,$){return d.replace(/^~($|\/|\\)/,`${$}$1`)}const g="\u2026",r="\\\\",s="~";function o(d,$=M.sep){const p=new Array(d.length);let v=!1;for(let y=0;y<d.length;y++){const h=d[y];if(h===""){p[y]=`.${$}`;continue}if(!h){p[y]=h;continue}v=!0;let E="",k=h;k.indexOf(r)===0?(E=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length)):k.indexOf($)===0?(E=k.substr(0,k.indexOf($)+$.length),k=k.substr(k.indexOf($)+$.length)):k.indexOf(s)===0&&(E=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length));const I=k.split($);for(let P=1;v&&P<=I.length;P++)for(let V=I.length-P;v&&V>=0;V--){v=!1;let W=I.slice(V,V+P).join($);for(let q=0;!v&&q<d.length;q++)if(q!==y&&d[q]&&d[q].indexOf(W)>-1){const R=V+P===I.length,z=V>0&&d[q].indexOf($)>-1?$+W:W,G=d[q].endsWith(z);v=!R||G}if(!v){let q="";(I[0].endsWith(":")||E!=="")&&(V===1&&(V=0,P++,W=I[0]+$+W),V>0&&(q=I[0]+$),q=E+q),V>0&&(q=q+g+$),q=q+W,V+P<I.length&&(q=q+$+g),p[y]=q}}v&&(p[y]=h)}return p}var i;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(d,$=Object.create(null)){const p=[];let v=!1,y="";for(const h of d)if(h==="$"||v&&h==="{")y&&p.push({value:y,type:i.TEXT}),y="",v=!0;else if(h==="}"&&v){const E=$[y];if(typeof E=="string")E.length&&p.push({value:E,type:i.VARIABLE});else if(E){const k=p[p.length-1];(!k||k.type!==i.SEPARATOR)&&p.push({value:E.label,type:i.SEPARATOR})}y="",v=!1}else y+=h;return y&&!v&&p.push({value:y,type:i.TEXT}),p.filter((h,E)=>{if(h.type===i.SEPARATOR){const k=p[E-1],I=p[E+1];return[k,I].every(P=>P&&(P.type===i.VARIABLE||P.type===i.TEXT)&&P.value.length>0)}return!0}).map(h=>h.value).join("")}function c(d,$){return T.$j||$?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$j?"&":"&&"):d.replace(/&&|&/g,p=>p==="&"?"&&":"&")}function u(d,$){return T.$j||$?d.replace(/\(&&\w\)|&&/g,""):T.$i?d.replace(/&&|&/g,p=>p==="&"?"&&":"&"):d.replace(/&&/g,"_")}function t(d){return d.replace(/&/g,"&&")}function f(d){if(d.endsWith("]")){const $=d.lastIndexOf(" [",d.length-2);if($!==-1){const p=a(d.substring(0,$)),v=d.substring($);return{name:p.name+v,parentPath:p.parentPath}}}return a(d)}function a(d){const $=d.indexOf("/")!==-1?M.$gc:M.$fc,p=$.basename(d),v=$.dirname(d);return p.length?{name:p,parentPath:v}:{name:v,parentPath:""}}}),define(Se[150],Ie([1,0,22,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0,e.$Cn=b,e.$Dn=D,e.$En=N;function M(S){return S.toJSON()}class T{constructor(l){this.a=l}transformIncoming(l){const w=this.a.transformIncoming(l);return w===l?l:M(O.URI.from(w))}transformOutgoing(l){const w=this.a.transformOutgoing(l);return w===l?l:M(O.URI.from(w))}transformOutgoingURI(l){const w=this.a.transformOutgoing(l);return w===l?l:O.URI.from(w)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$An=T,e.$Bn=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function A(S,l,w){if(!S||w>200)return null;if(typeof S=="object"){if(S instanceof O.URI)return l.transformOutgoing(S);for(const g in S)if(Object.hasOwnProperty.call(S,g)){const r=A(S[g],l,w+1);r!==null&&(S[g]=r)}}return null}function b(S,l){const w=A(S,l,0);return w===null?S:w}function m(S,l,w,g){if(!S||g>200)return null;if(typeof S=="object"){if(S.$mid===1)return w?O.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof C.$He)return null;for(const r in S)if(Object.hasOwnProperty.call(S,r)){const s=m(S[r],l,w,g+1);s!==null&&(S[r]=s)}}return null}function D(S,l){const w=m(S,l,!1,0);return w===null?S:w}function N(S,l){const w=m(S,l,!0,0);return w===null?S:w}}),define(Se[151],Ie([1,0,11,5,6,49,15]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.StorageState=e.StorageHint=void 0,e.$Zp=m;var b;(function(l){l[l.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",l[l.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function m(l){const w=l;return w?.changed instanceof Map||w?.deleted instanceof Set}var D;(function(l){l[l.None=0]="None",l[l.Initialized=1]="Initialized",l[l.Closed=2]="Closed"})(D||(e.StorageState=D={}));class N extends M.$Uc{static{this.a=100}constructor(w,g=Object.create(null)){super(),this.r=w,this.s=g,this.b=this.B(new O.$ie),this.onDidChangeStorage=this.b.event,this.c=D.None,this.f=new Map,this.g=this.B(new C.$wh(N.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((g,r)=>this.w(r,g)),w.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(w,g){if(this.c===D.Closed)return;let r=!1;(0,A.$hg)(g)?r=this.f.delete(w):this.f.get(w)!==g&&(this.f.set(w,g),r=!0),r&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===D.None&&(this.c=D.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,g){const r=this.f.get(w);return(0,A.$hg)(r)?g:r}getBoolean(w,g){const r=this.get(w);return(0,A.$hg)(r)?g:r==="true"}getNumber(w,g){const r=this.get(w);return(0,A.$hg)(r)?g:parseInt(r,10)}getObject(w,g){const r=this.get(w);return(0,A.$hg)(r)?g:(0,T.$7h)(r)}async set(w,g,r=!1){if(this.c===D.Closed)return;if((0,A.$hg)(g))return this.delete(w,r);const s=(0,A.$ag)(g)||Array.isArray(g)?(0,T.$6h)(g):String(g);if(this.f.get(w)!==s)return this.f.set(w,s),this.j.set(w,s),this.h.delete(w),this.b.fire({key:w,external:r}),this.D()}async delete(w,g=!1){if(!(this.c===D.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:g}),this.D()}async optimize(){if(this.c!==D.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=D.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===D.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$1p=N;class S{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((g,r)=>this.a.set(r,g)),w.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$2p=S}),define(Se[152],Ie([1,0,13,23,22]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=void 0,e.$Xt=N,e.$Yt=S;let T;function A(){return T||(T=new TextDecoder("UTF-16LE")),T}let b;function m(){return b||(b=new TextDecoder("UTF-16BE")),b}let D;function N(){return D||(D=O.$D()?A():m()),D}function S(g,r,s){const o=new Uint16Array(g.buffer,r,s);return s>0&&(o[0]===65279||o[0]===65534)?l(g,r,s):A().decode(o)}function l(g,r,s){const o=[];let i=0;for(let n=0;n<s;n++){const c=M.$Je(g,r);r+=2,o[i++]=String.fromCharCode(c)}return o.join("")}class w{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return N().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const s=this.a-this.d;s<=1&&(s===0||C.$Df(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const s=r.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=r;return}for(let o=0;o<s;o++)this.b[this.d++]=r.charCodeAt(o)}}e.$Zt=w}),define(Se[153],Ie([1,0,22,152]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1t=void 0,e.$2t=A;function M(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class T{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(D,N,S,l){this.oldPosition=D,this.oldText=N,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(D){return 4+2*D.length}static c(D,N,S){const l=N.length;C.$Me(D,l,S),S+=4;for(let w=0;w<l;w++)C.$Ke(D,N.charCodeAt(w),S),S+=2;return S}static d(D,N){const S=C.$Le(D,N);return N+=4,(0,O.$Yt)(D,N,S)}writeSize(){return 8+T.a(this.oldText)+T.a(this.newText)}write(D,N){return C.$Me(D,this.oldPosition,N),N+=4,C.$Me(D,this.newPosition,N),N+=4,N=T.c(D,this.oldText,N),N=T.c(D,this.newText,N),N}static read(D,N,S){const l=C.$Le(D,N);N+=4;const w=C.$Le(D,N);N+=4;const g=T.d(D,N);N+=T.a(g);const r=T.d(D,N);return N+=T.a(r),S.push(new T(l,g,w,r)),N}}e.$1t=T;function A(m,D){return m===null||m.length===0?D:new b(m,D).compress()}class b{constructor(D,N){this.a=D,this.c=N,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let D=0,N=0,S=this.n(D),l=this.l(N);for(;D<this.f||N<this.h;){if(S===null){this.k(l),l=this.l(++N);continue}if(l===null){this.m(S),S=this.n(++D);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++N);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++D);continue}if(l.oldPosition<S.newPosition){const[o,i]=b.r(l,S.newPosition-l.oldPosition);this.k(o),l=i;continue}if(S.newPosition<l.oldPosition){const[o,i]=b.q(S,l.oldPosition-S.newPosition);this.m(o),S=i;continue}let r,s;if(l.oldEnd===S.newEnd)r=S,s=l,S=this.n(++D),l=this.l(++N);else if(l.oldEnd<S.newEnd){const[o,i]=b.q(S,l.oldLength);r=o,s=l,S=i,l=this.l(++N)}else{const[o,i]=b.r(l,S.newLength);r=S,s=o,S=this.n(++D),l=i}this.d[this.e++]=new T(r.oldPosition,r.oldText,s.newPosition,s.newText),this.g+=r.newLength-r.oldLength,this.j+=s.newLength-s.oldLength}const w=b.s(this.d);return b.t(w)}k(D){this.d[this.e++]=b.o(this.g,D),this.j+=D.newLength-D.oldLength}l(D){return D<this.h?this.c[D]:null}m(D){this.d[this.e++]=b.p(this.j,D),this.g+=D.newLength-D.oldLength}n(D){return D<this.f?this.a[D]:null}static o(D,N){return new T(N.oldPosition-D,N.oldText,N.newPosition,N.newText)}static p(D,N){return new T(N.oldPosition,N.oldText,N.newPosition+D,N.newText)}static q(D,N){const S=D.newText.substr(0,N),l=D.newText.substr(N);return[new T(D.oldPosition,D.oldText,D.newPosition,S),new T(D.oldEnd,"",D.newPosition+N,l)]}static r(D,N){const S=D.oldText.substr(0,N),l=D.oldText.substr(N);return[new T(D.oldPosition,S,D.newPosition,D.newText),new T(D.oldPosition+N,l,D.newEnd,"")]}static s(D){if(D.length===0)return D;const N=[];let S=0,l=D[0];for(let w=1;w<D.length;w++){const g=D[w];l.oldEnd===g.oldPosition?l=new T(l.oldPosition,l.oldText+g.oldText,l.newPosition,l.newText+g.newText):(N[S++]=l,l=g)}return N[S++]=l,N}static t(D){if(D.length===0)return D;const N=[];let S=0;for(let l=0;l<D.length;l++){const w=D[l];w.oldText!==w.newText&&(N[S++]=w)}return N}}}),define(Se[154],Ie([1,0,37,19]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fu=M,e.$gu=T;function M(A,b,m,D,N,S){if(Array.isArray(A)){let l=0;for(const w of A){const g=M(w,b,m,D,N,S);if(g===10)return g;g>l&&(l=g)}return l}else{if(typeof A=="string")return D?A==="*"?5:A===m?10:0:0;if(A){const{language:l,pattern:w,scheme:g,hasAccessToAllModels:r,notebookType:s}=A;if(!D&&!r)return 0;s&&N&&(b=N);let o=0;if(g)if(g===b.scheme)o=10;else if(g==="*")o=5;else return 0;if(l)if(l===m)o=10;else if(l==="*")o=Math.max(o,5);else return 0;if(s)if(s===S)o=10;else if(s==="*"&&S!==void 0)o=Math.max(o,5);else return 0;if(w){let i;if(typeof w=="string"?i=w:i={...w,base:(0,O.$hc)(w.base)},i===b.fsPath||(0,C.$rk)(i,b.fsPath))o=10;else return 0}return o}else return 0}}function T(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(T):!!A.notebookType}}),define(Se[155],Ie([1,0,5,13,30,95,93,139,153,6]),function(le,e,C,O,M,T,A,b,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=void 0;class N extends D.$Uc{constructor(l,w,g,r,s,o,i){super(),this.m=this.B(new C.$fe),this.onDidChangeContent=this.m.event,this.f=w,this.j=!o,this.g=r,this.h=s,this.c=new A.$4C(l,g,i)}equals(l){return!(l instanceof N)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,w){return this.c.getOffsetAt(l,w)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,w){const g=l+w,r=this.getPositionAt(l),s=this.getPositionAt(g);return new M.$yt(r.lineNumber,r.column,s.lineNumber,s.column)}getValueInRange(l,w=0){if(l.isEmpty())return"";const g=this.n(w);return this.c.getValueInRange(l,g)}getValueLengthInRange(l,w=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const g=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let s=0;const o=this.n(w),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,c=l.endLineNumber-l.startLineNumber;s=n*c}return r-g+s}getCharacterCountInRange(l,w=0){if(this.j){let g=0;const r=l.startLineNumber,s=l.endLineNumber;for(let o=r;o<=s;o++){const i=this.getLineContent(o),n=o===r?l.startColumn-1:0,c=o===s?l.endColumn-1:i.length;for(let u=n;u<c;u++)O.$Df(i.charCodeAt(u))?(g=g+1,u=u+1):g=g+1}return g+=this.n(w).length*(s-r),g}return this.getValueLengthInRange(l,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,w){return this.c.getLineCharCode(l,w)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const w=O.$of(this.getLineContent(l));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(l){const w=O.$qf(this.getLineContent(l));return w===-1?0:w+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,w,g){let r=this.g,s=this.h,o=this.j,i=!0,n=[];for(let $=0;$<l.length;$++){const p=l[$];i&&p._isTracked&&(i=!1);const v=p.range;if(p.text){let I=!0;o||(I=!O.$Of(p.text),o=I),!r&&I&&(r=O.$Nf(p.text)),!s&&I&&(s=O.$Qf(p.text))}let y="",h=0,E=0,k=0;if(p.text){let I;[h,E,k,I]=(0,b.$iu)(p.text);const P=this.getEOL();I===0||I===(P===`\r
`?2:1)?y=p.text:y=p.text.replace(/\r\n|\r|\n/g,P)}n[$]={sortIndex:$,identifier:p.identifier||null,range:v,rangeOffset:this.getOffsetAt(v.startLineNumber,v.startColumn),rangeLength:this.getValueLengthInRange(v),text:y,eolCount:h,firstLineLength:E,lastLineLength:k,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}n.sort(N.u);let c=!1;for(let $=0,p=n.length-1;$<p;$++){const v=n[$].range.getEndPosition(),y=n[$+1].range.getStartPosition();if(y.isBeforeOrEqual(v)){if(y.isBefore(v))throw new Error("Overlapping ranges are not allowed!");c=!0}}i&&(n=this.s(n));const u=g||w?N._getInverseEditRanges(n):[],t=[];if(w)for(let $=0;$<n.length;$++){const p=n[$],v=u[$];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let y=v.startLineNumber;y<=v.endLineNumber;y++){let h="";y===v.startLineNumber&&(h=this.getLineContent(p.range.startLineNumber),O.$of(h)!==-1)||t.push({lineNumber:y,oldContent:h})}}let f=null;if(g){let $=0;f=[];for(let p=0;p<n.length;p++){const v=n[p],y=u[p],h=this.getValueInRange(v.range),E=v.rangeOffset+$;$+=v.text.length-h.length,f[p]={sortIndex:v.sortIndex,identifier:v.identifier,range:y,text:h,textChange:new m.$1t(v.rangeOffset,h,E,v.text)}}c||f.sort((p,v)=>p.sortIndex-v.sortIndex)}this.g=r,this.h=s,this.j=o;const a=this.t(n);let d=null;if(w&&t.length>0){t.sort(($,p)=>p.lineNumber-$.lineNumber),d=[];for(let $=0,p=t.length;$<p;$++){const v=t[$].lineNumber;if($>0&&t[$-1].lineNumber===v)continue;const y=t[$].oldContent,h=this.getLineContent(v);h.length===0||h===y||O.$of(h)!==-1||d.push(v)}}return this.m.fire(),new T.$3v(f,a,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let w=!1;const g=l[0].range,r=l[l.length-1].range,s=new M.$yt(g.startLineNumber,g.startColumn,r.endLineNumber,r.endColumn);let o=g.startLineNumber,i=g.startColumn;const n=[];for(let a=0,d=l.length;a<d;a++){const $=l[a],p=$.range;w=w||$.forceMoveMarkers,n.push(this.getValueInRange(new M.$yt(o,i,p.startLineNumber,p.startColumn))),$.text.length>0&&n.push($.text),o=p.endLineNumber,i=p.endColumn}const c=n.join(""),[u,t,f]=(0,b.$iu)(c);return{sortIndex:0,identifier:l[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,0),text:c,eolCount:u,firstLineLength:t,lastLineLength:f,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(l){l.sort(N.w);const w=[];for(let g=0;g<l.length;g++){const r=l[g],s=r.range.startLineNumber,o=r.range.startColumn,i=r.range.endLineNumber,n=r.range.endColumn;if(s===i&&o===n&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new M.$yt(s,o,i,n);w.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return w}findMatchesLineByLine(l,w,g,r){return this.c.findMatchesLineByLine(l,w,g,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,w){const g=l.startLineNumber,r=l.startColumn,[s,o,i]=(0,b.$iu)(w);let n;if(w.length>0){const c=s+1;c===1?n=new M.$yt(g,r,g,r+o):n=new M.$yt(g,r,g+c-1,i+1)}else n=new M.$yt(g,r,g,r);return n}static _getInverseEditRanges(l){const w=[];let g=0,r=0,s=null;for(let o=0,i=l.length;o<i;o++){const n=l[o];let c,u;s?s.range.endLineNumber===n.range.startLineNumber?(c=g,u=r+(n.range.startColumn-s.range.endColumn)):(c=g+(n.range.startLineNumber-s.range.endLineNumber),u=n.range.startColumn):(c=n.range.startLineNumber,u=n.range.startColumn);let t;if(n.text.length>0){const f=n.eolCount+1;f===1?t=new M.$yt(c,u,c,u+n.firstLineLength):t=new M.$yt(c,u,c+f-1,n.lastLineLength+1)}else t=new M.$yt(c,u,c,u);g=t.endLineNumber,r=t.endColumn,w.push(t),s=n}return w}static u(l,w){const g=M.$yt.compareRangesUsingEnds(l.range,w.range);return g===0?l.sortIndex-w.sortIndex:g}static w(l,w){const g=M.$yt.compareRangesUsingEnds(l.range,w.range);return g===0?w.sortIndex-l.sortIndex:-g}}e.$5C=N}),define(Se[156],Ie([1,0,13,93,155]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6C=void 0;class T{constructor(m,D,N,S,l,w,g,r,s){this.a=m,this.b=D,this.c=N,this.d=S,this.e=l,this.f=w,this.g=g,this.h=r,this.j=s}k(m){const D=this.c+this.d+this.e,N=this.c+this.e;return D===0?m===1?`
`:`\r
`:N>D/2?`\r
`:`
`}create(m){const D=this.k(m),N=this.a;if(this.j&&(D===`\r
`&&(this.c>0||this.d>0)||D===`
`&&(this.c>0||this.e>0)))for(let l=0,w=N.length;l<w;l++){const g=N[l].buffer.replace(/\r\n|\r|\n/g,D),r=(0,O.$ZC)(g);N[l]=new O.$3C(g,r)}const S=new M.$5C(N,this.b,D,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&C.$Yf(m)&&(this.b=C.$Xf,m=m.substr(1));const D=m.charCodeAt(m.length-1);D===13||D>=55296&&D<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=D):(this.m(m,!1),this.c=!1,this.d=D)}m(m,D){!D&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const D=(0,O.$1C)(this.e,m);this.a.push(new O.$3C(m,D.lineStarts)),this.f+=D.cr,this.g+=D.lf,this.h+=D.crlf,D.isBasicASCII||(this.l=!1,this.j||(this.j=C.$Nf(m)),this.k||(this.k=C.$Qf(m)))}finish(m=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const D=(0,O.$ZC)(m.buffer);m.lineStarts=D,this.d===13&&this.f++}}}e.$6C=A}),define(Se[98],Ie([1,0,22,23]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbb=m,e.$Cbb=N;var M;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(M||(M={}));function T(S){for(let l=0,w=S.length;l<w;l+=4){const g=S[l+0],r=S[l+1],s=S[l+2],o=S[l+3];S[l+0]=o,S[l+1]=s,S[l+2]=r,S[l+3]=g}}function A(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return O.$D()||T(l),C.$He.wrap(l)}function b(S){const l=S.buffer;if(O.$D()||T(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const w=new Uint8Array(l.byteLength);return w.set(l),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function m(S){const l=new Uint32Array(D(S));let w=0;if(l[w++]=S.id,S.type==="full")l[w++]=1,l[w++]=S.data.length,l.set(S.data,w),w+=S.data.length;else{l[w++]=2,l[w++]=S.deltas.length;for(const g of S.deltas)l[w++]=g.start,l[w++]=g.deleteCount,g.data?(l[w++]=g.data.length,l.set(g.data,w),w+=g.data.length):l[w++]=0}return A(l)}function D(S){let l=0;if(l+=2,S.type==="full")l+=1+S.data.length;else{l+=1,l+=3*S.deltas.length;for(const w of S.deltas)w.data&&(l+=w.data.length)}return l}function N(S){const l=b(S);let w=0;const g=l[w++];if(l[w++]===1){const i=l[w++],n=l.subarray(w,w+i);return w+=i,{id:g,type:"full",data:n}}const s=l[w++],o=[];for(let i=0;i<s;i++){const n=l[w++],c=l[w++],u=l[w++];let t;u>0&&(t=l.subarray(w,w+u),w+=u),o[i]={start:n,deleteCount:c,data:t}}return{id:g,type:"delta",deltas:o}}}),define(Se[157],Ie([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(Se[158],Ie([1,0,18,26,23,140,159,157]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=s,e.clampedInt=i,e.clampedFloat=c,e.stringSet=f,e.cursorStyleToString=k,e.filterValidationDecorations=ce;var m;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=D;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class S{constructor(X,$e,He,we){this.id=X,this.name=$e,this.defaultValue=He,this.schema=we}applyUpdate(X,$e){return w(X,$e)}compute(X,$e,He){return He}}class l{constructor(X,$e){this.newValue=X,this.didChange=$e}}e.ApplyUpdateResult=l;function w(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new l(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const He=Array.isArray(Z)&&Array.isArray(X)&&C.$ub(Z,X);return new l(X,!He)}let $e=!1;for(const He in X)if(X.hasOwnProperty(He)){const we=w(Z[He],X[He]);we.didChange&&(Z[He]=we.newValue,$e=!0)}return new l(Z,$e)}class g{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,$e){return w(X,$e)}validate(X){return this.defaultValue}}class r{constructor(X,$e,He,we){this.id=X,this.name=$e,this.defaultValue=He,this.schema=we}applyUpdate(X,$e){return w(X,$e)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,$e,He){return He}}function s(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}class o extends r{constructor(X,$e,He,we=void 0){typeof we<"u"&&(we.type="boolean",we.default=He),super(X,$e,He,we)}validate(X){return s(X,this.defaultValue)}}function i(Z,X,$e,He){if(typeof Z>"u")return X;let we=parseInt(Z,10);return isNaN(we)?X:(we=Math.max($e,we),we=Math.min(He,we),we|0)}class n extends r{static clampedInt(X,$e,He,we){return i(X,$e,He,we)}constructor(X,$e,He,we,st,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=He,dt.minimum=we,dt.maximum=st),super(X,$e,He,dt),this.minimum=we,this.maximum=st}validate(X){return n.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function c(Z,X,$e,He){if(typeof Z>"u")return X;const we=u.float(Z,X);return u.clamp(we,$e,He)}class u extends r{static clamp(X,$e,He){return X<$e?$e:X>He?He:X}static float(X,$e){if(typeof X=="number")return X;if(typeof X>"u")return $e;const He=parseFloat(X);return isNaN(He)?$e:He}constructor(X,$e,He,we,st){typeof st<"u"&&(st.type="number",st.default=He),super(X,$e,He,st),this.validationFn=we}validate(X){return this.validationFn(u.float(X,this.defaultValue))}}class t extends r{static string(X,$e){return typeof X!="string"?$e:X}constructor(X,$e,He,we=void 0){typeof we<"u"&&(we.type="string",we.default=He),super(X,$e,He,we)}validate(X){return t.string(X,this.defaultValue)}}function f(Z,X,$e,He){return typeof Z!="string"?X:He&&Z in He?He[Z]:$e.indexOf(Z)===-1?X:Z}class a extends r{constructor(X,$e,He,we,st=void 0){typeof st<"u"&&(st.type="string",st.enum=we,st.default=He),super(X,$e,He,st),this.c=we}validate(X){return f(X,this.defaultValue,this.c)}}class d extends S{constructor(X,$e,He,we,st,dt,Ct=void 0){typeof Ct<"u"&&(Ct.type="string",Ct.enum=st,Ct.default=we),super(X,$e,He,Ct),this.c=st,this.d=dt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function $(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,$e,He){return He===0?X.accessibilitySupport:He}}class v extends S{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:b.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{insertSpace:s($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var y;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(y||(e.TextEditorCursorBlinkingStyle=y={}));function h(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function k(Z){switch(Z){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function I(Z){switch(Z){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class P extends g{constructor(){super(142)}compute(X,$e,He){const we=["monaco-editor"];return $e.get(39)&&we.push($e.get(39)),X.extraEditorClassName&&we.push(X.extraEditorClassName),$e.get(74)==="default"?we.push("mouse-default"):$e.get(74)==="copy"&&we.push("mouse-copy"),$e.get(111)&&we.push("showUnused"),$e.get(140)&&we.push("showDeprecated"),we.join(" ")}}class V extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(X,$e,He){return He&&X.emptySelectionClipboard}}class W extends S{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:b.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:b.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{cursorMoveOnType:s($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":f($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":f($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s($e.loop,this.defaultValue.loop)}}}class q extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?q.OFF:X==="true"?q.ON:X:X?q.ON:q.OFF}}e.EditorFontLigatures=q;class R extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?R.OFF:X==="true"?R.TRANSLATE:X:X?R.TRANSLATE:R.OFF}compute(X,$e,He){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=R;class z extends g{constructor(){super(50)}compute(X,$e,He){return X.fontInfo}}class G extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(X){const $e=u.float(X,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp($e,6,100)}compute(X,$e,He){return X.fontInfo.fontSize}}class ie extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(n.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class de extends S{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:He,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:He,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:He,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:He,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:He,description:b.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{multiple:f($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??f($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??f($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??f($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??f($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??f($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends S{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:b.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),delay:n.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:s($e.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:s($e.above,this.defaultValue.above)}}}var De;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(De||(e.RenderMinimap=De={}));class ge extends g{constructor(){super(145)}compute(X,$e,He){return ge.computeLayout($e,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const $e=X.height/X.lineHeight,He=Math.floor(X.paddingTop/X.lineHeight);let we=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(we=Math.max(we,$e-1));const st=(He+X.viewLineCount+we)/(X.pixelRatio*X.height),dt=Math.floor(X.viewLineCount/st);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:we,desiredRatio:st,minimapLineCount:dt}}static c(X,$e){const He=X.outerWidth,we=X.outerHeight,st=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*we),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:we};const dt=$e.stableMinimapLayoutInput,Ct=dt&&X.outerHeight===dt.outerHeight&&X.lineHeight===dt.lineHeight&&X.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&X.pixelRatio===dt.pixelRatio&&X.scrollBeyondLastLine===dt.scrollBeyondLastLine&&X.paddingTop===dt.paddingTop&&X.paddingBottom===dt.paddingBottom&&X.minimap.enabled===dt.minimap.enabled&&X.minimap.side===dt.minimap.side&&X.minimap.size===dt.minimap.size&&X.minimap.showSlider===dt.minimap.showSlider&&X.minimap.renderCharacters===dt.minimap.renderCharacters&&X.minimap.maxColumn===dt.minimap.maxColumn&&X.minimap.scale===dt.minimap.scale&&X.verticalScrollbarWidth===dt.verticalScrollbarWidth&&X.isViewportWrapping===dt.isViewportWrapping,Vt=X.lineHeight,Qt=X.typicalHalfwidthCharacterWidth,ii=X.scrollBeyondLastLine,Xt=X.minimap.renderCharacters;let Dt=st>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Zt=X.minimap.maxColumn,Yt=X.minimap.size,Ze=X.minimap.side,si=X.verticalScrollbarWidth,Kt=X.viewLineCount,ht=X.remainingWidth,mt=X.isViewportWrapping,xt=Xt?2:3;let Gt=Math.floor(st*we);const Tt=Gt/st;let ft=!1,Bt=!1,_t=xt*Dt,zt=Dt/st,Qe=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:At,extraLinesBeforeFirstLine:ei,extraLinesBeyondLastLine:Wt,desiredRatio:oi,minimapLineCount:Ot}=ge.computeContainedMinimapLineCount({viewLineCount:Kt,scrollBeyondLastLine:ii,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:we,lineHeight:Vt,pixelRatio:st});if(Kt/Ot>1)ft=!0,Bt=!0,Dt=1,_t=1,zt=Dt/st;else{let Rt=!1,St=Dt+1;if(Yt==="fit"){const $t=Math.ceil((ei+Kt+Wt)*_t);mt&&Ct&&ht<=$e.stableFitRemainingWidth?(Rt=!0,St=$e.stableFitMaxMinimapScale):Rt=$t>Gt}if(Yt==="fill"||Rt){ft=!0;const $t=Dt;_t=Math.min(Vt*st,Math.max(1,Math.floor(1/oi))),mt&&Ct&&ht<=$e.stableFitRemainingWidth&&(St=$e.stableFitMaxMinimapScale),Dt=Math.min(St,Math.max(1,Math.floor(_t/xt))),Dt>$t&&(Qe=Math.min(2,Dt/$t)),zt=Dt/st/Qe,Gt=Math.ceil(Math.max(At,ei+Kt+Wt)*_t),mt?($e.stableMinimapLayoutInput=X,$e.stableFitRemainingWidth=ht,$e.stableFitMaxMinimapScale=Dt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const ui=Math.floor(Zt*zt),Jt=Math.min(ui,Math.max(0,Math.floor((ht-si-2)*zt/(Qt+zt)))+e.MINIMAP_GUTTER_WIDTH);let jt=Math.floor(st*Jt);const bt=jt/st;jt=Math.floor(jt*Qe);const Ut=Xt?1:2,Mt=Ze==="left"?0:He-Jt-si;return{renderMinimap:Ut,minimapLeft:Mt,minimapWidth:Jt,minimapHeightIsEditorHeight:ft,minimapIsSampling:Bt,minimapScale:Dt,minimapLineHeight:_t,minimapCanvasInnerWidth:jt,minimapCanvasInnerHeight:Gt,minimapCanvasOuterWidth:bt,minimapCanvasOuterHeight:Tt}}static computeLayout(X,$e){const He=$e.outerWidth|0,we=$e.outerHeight|0,st=$e.lineHeight|0,dt=$e.lineNumbersDigitCount|0,Ct=$e.typicalHalfwidthCharacterWidth,Vt=$e.maxDigitWidth,Qt=$e.pixelRatio,ii=$e.viewLineCount,Xt=X.get(137),Dt=Xt==="inherit"?X.get(136):Xt,Zt=Dt==="inherit"?X.get(132):Dt,Yt=X.get(135),Ze=$e.isDominatedByLongLines,si=X.get(57),Kt=X.get(68).renderType!==0,ht=X.get(69),mt=X.get(105),xt=X.get(84),Gt=X.get(73),Tt=X.get(103),ft=Tt.verticalScrollbarSize,Bt=Tt.verticalHasArrows,_t=Tt.arrowSize,zt=Tt.horizontalScrollbarSize,Qe=X.get(43),ui=X.get(110)!=="never";let Jt=X.get(66);Qe&&ui&&(Jt+=16);let jt=0;if(Kt){const ai=Math.max(dt,ht);jt=Math.round(ai*Vt)}let bt=0;si&&(bt=st*$e.glyphMarginDecorationLaneCount);let Ut=0,Mt=Ut+bt,At=Mt+jt,ei=At+Jt;const Wt=He-bt-jt-Jt;let oi=!1,Ot=!1,qt=-1;Dt==="inherit"&&Ze?(oi=!0,Ot=!0):Zt==="on"||Zt==="bounded"?Ot=!0:Zt==="wordWrapColumn"&&(qt=Yt);const Rt=ge.c({outerWidth:He,outerHeight:we,lineHeight:st,typicalHalfwidthCharacterWidth:Ct,pixelRatio:Qt,scrollBeyondLastLine:mt,paddingTop:xt.top,paddingBottom:xt.bottom,minimap:Gt,verticalScrollbarWidth:ft,viewLineCount:ii,remainingWidth:Wt,isViewportWrapping:Ot},$e.memory||new N);Rt.renderMinimap!==0&&Rt.minimapLeft===0&&(Ut+=Rt.minimapWidth,Mt+=Rt.minimapWidth,At+=Rt.minimapWidth,ei+=Rt.minimapWidth);const St=Wt-Rt.minimapWidth,$t=Math.max(1,Math.floor((St-ft-2)/Ct)),Et=Bt?_t:0;return Ot&&(qt=Math.max(1,$t),Zt==="bounded"&&(qt=Math.min(qt,Yt))),{width:He,height:we,glyphMarginLeft:Ut,glyphMarginWidth:bt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Mt,lineNumbersWidth:jt,decorationsLeft:At,decorationsWidth:Jt,contentLeft:ei,contentWidth:St,minimap:Rt,viewportColumn:$t,isWordWrapMinified:oi,isViewportWrapping:Ot,wrappingColumn:qt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:zt,overviewRuler:{top:Et,width:ft,height:we-2*Et,right:0}}}}e.EditorLayoutInfoComputer=ge;class ue extends S{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(X){return f(X,"simple",["simple","advanced"])}compute(X,$e,He){return $e.get(2)===2?"advanced":He}}var Ce;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(Ce||(e.ShowLightbulbIconMode=Ce={}));class se extends S{constructor(){const X={enabled:Ce.On};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ce.Off,Ce.OnCode,Ce.On],default:X.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:f(X.enabled,this.defaultValue.enabled,[Ce.Off,Ce.OnCode,Ce.On])}}}class Oe extends S{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:b.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:s($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends S{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:b.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:f($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),padding:s($e.padding,this.defaultValue.padding)}}}class j extends S{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):n.clampedInt(X,this.defaultValue,0,1e3)}compute(X,$e,He){return He<0?n.clampedInt(-He*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class x extends u{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>u.clamp(X,0,150),{markdownDescription:b.localize(66,null)})}compute(X,$e,He){return X.fontInfo.lineHeight}}class ve extends S{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:X.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),autohide:s($e.autohide,this.defaultValue.autohide),size:f($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:f($e.side,this.defaultValue.side,["right","left"]),showSlider:f($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s($e.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt($e.scale,1,1,3),maxColumn:n.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:s($e.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:s($e.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp($e.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Le(Z){return Z==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class ke extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{top:n.clampedInt($e.top,0,0,1e3),bottom:n.clampedInt($e.bottom,0,0,1e3)}}}class be extends S{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:b.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),cycle:s($e.cycle,this.defaultValue.cycle)}}}class me extends g{constructor(){super(143)}compute(X,$e,He){return X.pixelRatio}}class Q extends S{constructor(){const X={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:X.strings,description:b.localize(88,null)},comments:{anyOf:$e,default:X.comments,description:b.localize(89,null)},other:{anyOf:$e,default:X.other,description:b.localize(90,null)}},default:X,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Qt=X?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!X||typeof X!="object")return this.defaultValue;const{other:$e,comments:He,strings:we}=X,st=["on","inline","off"];let dt,Ct,Vt;return typeof $e=="boolean"?dt=$e?"on":"off":dt=f($e,this.defaultValue.other,st),typeof He=="boolean"?Ct=He?"on":"off":Ct=f(He,this.defaultValue.comments,st),typeof we=="boolean"?Vt=we?"on":"off":Vt=f(we,this.defaultValue.strings,st),{other:dt,comments:Ct,strings:Vt}}}var Y;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends S{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(X){let $e=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?($e=4,He=X):X==="interval"?$e=3:X==="relative"?$e=2:X==="on"?$e=1:$e=0),{renderType:$e,renderFn:He}}}function ce(Z){const X=Z.get(98);return X==="editable"?Z.get(91):X!=="on"}class Te extends S{constructor(){const X=[],$e={type:"number",description:b.localize(97,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:X,description:b.localize(99,null)})}validate(X){if(Array.isArray(X)){const $e=[];for(const He of X)if(typeof He=="number")$e.push({column:n.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const we=He;$e.push({column:n.clampedInt(we.column,0,0,1e4),color:we.color})}return $e.sort((He,we)=>He.column-we.column),$e}return this.defaultValue}}class fe extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Pe(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends S{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X,He=n.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),we=n.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe($e.vertical,this.defaultValue.vertical),horizontal:Pe($e.horizontal,this.defaultValue.horizontal),useShadows:s($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:s($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:n.clampedInt($e.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:we,verticalSliderSize:n.clampedInt($e.verticalSliderSize,we,0,1e3),scrollByPage:s($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:s($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Ue extends S{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:b.localize(118,null)}})}applyUpdate(X,$e){let He=!1;$e.allowedCharacters&&X&&(O.$9n(X.allowedCharacters,$e.allowedCharacters)||(X={...X,allowedCharacters:$e.allowedCharacters},He=!0)),$e.allowedLocales&&X&&(O.$9n(X.allowedLocales,$e.allowedLocales)||(X={...X,allowedLocales:$e.allowedLocales},He=!0));const we=super.applyUpdate(X,$e);return He?new l(we.newValue,!0):we}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{nonBasicASCII:te($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:te($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:te($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,$e){if(typeof X!="object"||!X)return $e;const He={};for(const[we,st]of Object.entries(X))st===!0&&(He[we]=!0);return He}}class B extends S{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:b.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),mode:f($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:s($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:s($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily)}}}class F extends S{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:b.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),showToolbar:f($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:s($e.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:s($e.backgroundColoring,this.defaultValue.backgroundColoring)}}}class H extends S{constructor(){const X={enabled:T.$8s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$8s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends S{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:X.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:X.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:X.highlightActiveIndentation,description:b.localize(148,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{bracketPairs:te($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:te($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:te($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function te(Z,X,$e){const He=$e.indexOf(Z);return He===-1?X:$e[He]}class re extends S{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:X.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:X.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{insertMode:f($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s($e.showIcons,this.defaultValue.showIcons),showStatusBar:s($e.showStatusBar,this.defaultValue.showStatusBar),preview:s($e.preview,this.defaultValue.preview),previewMode:f($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s($e.showMethods,this.defaultValue.showMethods),showFunctions:s($e.showFunctions,this.defaultValue.showFunctions),showConstructors:s($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:s($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s($e.showFields,this.defaultValue.showFields),showVariables:s($e.showVariables,this.defaultValue.showVariables),showClasses:s($e.showClasses,this.defaultValue.showClasses),showStructs:s($e.showStructs,this.defaultValue.showStructs),showInterfaces:s($e.showInterfaces,this.defaultValue.showInterfaces),showModules:s($e.showModules,this.defaultValue.showModules),showProperties:s($e.showProperties,this.defaultValue.showProperties),showEvents:s($e.showEvents,this.defaultValue.showEvents),showOperators:s($e.showOperators,this.defaultValue.showOperators),showUnits:s($e.showUnits,this.defaultValue.showUnits),showValues:s($e.showValues,this.defaultValue.showValues),showConstants:s($e.showConstants,this.defaultValue.showConstants),showEnums:s($e.showEnums,this.defaultValue.showEnums),showEnumMembers:s($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s($e.showKeywords,this.defaultValue.showKeywords),showWords:s($e.showWords,this.defaultValue.showWords),showColors:s($e.showColors,this.defaultValue.showColors),showFiles:s($e.showFiles,this.defaultValue.showFiles),showReferences:s($e.showReferences,this.defaultValue.showReferences),showFolders:s($e.showFolders,this.defaultValue.showFolders),showTypeParameters:s($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s($e.showSnippets,this.defaultValue.showSnippets),showUsers:s($e.showUsers,this.defaultValue.showUsers),showIssues:s($e.showIssues,this.defaultValue.showIssues)}}}class Ne extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:s(X.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends S{constructor(){const X=[];super(130,"wordSegmenterLocales",X,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const $e=[];for(const He of X)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&$e.push(He)}catch{}return $e}return this.defaultValue}}var Ke;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Ke||(e.WrappingIndent=Ke={}));class _e extends S{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,$e,He){return $e.get(2)===2?0:He}}class xe extends g{constructor(){super(146)}compute(X,$e,He){const we=$e.get(145);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:we.isWordWrapMinified,isViewportWrapping:we.isViewportWrapping,wrappingColumn:we.wrappingColumn}}}class et extends S{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),showDropSelector:f($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends S{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:s($e.enabled,this.defaultValue.enabled),showPasteSelector:f($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",ot="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?ot:M.$k?gt:it,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var rt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(rt||(e.EditorOption=rt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:je(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:je(new p),accessibilityPageSize:je(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:je(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:je(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:je(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:je(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:je(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:je(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],$,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:je(new o(13,"automaticLayout",!1)),autoSurround:je(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:je(new H),bracketPairGuides:je(new K),stickyTabStops:je(new o(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:je(new o(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:je(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:je(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:je(new o(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:je(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:je(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:je(new o(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:je(new v),contextmenu:je(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:je(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:je(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:je(new d(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:b.localize(260,null)})),cursorSurroundingLines:je(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:je(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:je(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:je(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new o(34,"domReadOnly",!1)),dragAndDrop:je(new o(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:je(new V),dropIntoEditor:je(new et),stickyScroll:je(new Oe),experimentalWhitespaceRendering:je(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:je(new t(39,"extraEditorClassName","")),fastScrollSensitivity:je(new u(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:b.localize(271,null)})),find:je(new W),fixedOverflowWidgets:je(new o(42,"fixedOverflowWidgets",!1)),folding:je(new o(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:je(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:je(new o(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:je(new o(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:je(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:je(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:je(new z),fontLigatures2:je(new q),fontSize:je(new G),fontWeight:je(new ie),fontVariations:je(new R),formatOnPaste:je(new o(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:je(new o(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:je(new o(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:je(new de),hideCursorInOverviewRuler:je(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:je(new ye),inDiffEditor:je(new o(61,"inDiffEditor",!1)),letterSpacing:je(new u(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>u.clamp(Z,-5,20),{description:b.localize(285,null)})),lightbulb:je(new se),lineDecorationsWidth:je(new j),lineHeight:je(new x),lineNumbers:je(new he),lineNumbersMinChars:je(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new o(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:je(new o(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:je(new a(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:je(new ve),mouseStyle:je(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new u(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:je(new o(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:je(new o(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:je(new d(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Le,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:je(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:je(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:je(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:je(new o(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:je(new n(83,"overviewRulerLanes",3,0,3)),padding:je(new ke),pasteAs:je(new tt),parameterHints:je(new be),peekWidgetDefaultFocus:je(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:je(new o(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:je(new o(91,"readOnly",!1)),readOnlyMessage:je(new fe),renameOnType:je(new o(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:je(new o(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:je(new a(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:je(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:je(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:je(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new o(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:je(new Te),scrollbar:je(new Re),scrollBeyondLastColumn:je(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:je(new o(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:je(new o(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:je(new o(107,"selectionClipboard",!0,{description:b.localize(325,null),included:M.$k})),selectionHighlight:je(new o(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:je(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:je(new o(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:je(new o(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:je(new ne),snippetSuggestions:je(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:je(new Ne),smoothScrolling:je(new o(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:je(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new re),inlineSuggest:je(new B),inlineEdit:je(new F),inlineCompletionsAccessibilityVerbose:je(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:je(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new o(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:je(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:je(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:je(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new Ue),unusualLineTerminators:je(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:je(new o(127,"useShadowDOM",!0)),useTabStops:je(new o(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:je(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new t(131,"wordSeparators",A.$9s,{description:b.localize(359,null)})),wordWrap:je(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:je(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:je(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new P),defaultColorDecorators:je(new o(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:je(new me),tabFocusMode:je(new o(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:je(new ge),wrappingInfo:je(new xe),wrappingIndent:je(new _e),wrappingStrategy:je(new ue)}}),define(Se[160],Ie([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[161],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[162],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(Se[163],Ie([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[164],Ie([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[165],Ie([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(Se[166],Ie([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(Se[167],Ie([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(Se[168],Ie([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(Se[169],Ie([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[170],Ie([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[171],Ie([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(Se[172],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[173],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[174],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[175],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[176],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[177],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[178],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[179],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[180],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[181],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[182],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[183],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[184],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(Se[185],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(Se[186],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(Se[187],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[188],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[189],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[190],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[191],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[192],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[193],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[194],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[195],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[196],Ie([1,0,14,162]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var M;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(M||(e.TokenType=M={}));function T(...D){switch(D.length){case 1:return(0,O.localize)(0,null,D[0]);case 2:return(0,O.localize)(1,null,D[0],D[1]);case 3:return(0,O.localize)(2,null,D[0],D[1],D[2]);default:return}}const A=(0,O.localize)(3,null),b=(0,O.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(N){switch(N.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return N.isTripleEq?"===":"==";case 4:return N.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return N.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return N.lexeme;case 18:return N.lexeme;case 19:return N.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(N)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(N=>N.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(N){return this.c=N,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(T("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(T("&&"));break;case 124:this.h(124)?this.k(16):this.l(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(N){return this.r()||this.c.charCodeAt(this.e)!==N?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(N){this.f.push({type:N,offset:this.d})}l(N){const S=this.d,l=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:N}),this.f.push(w)}n(){this.m.lastIndex=this.d;const N=this.m.exec(this.c);if(N){this.e=this.d+N[0].length;const S=this.c.substring(this.d,this.e),l=m.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let N=this.e,S=!1,l=!1;for(;;){if(N>=this.c.length){this.e=N,this.l(b);return}const g=this.c.charCodeAt(N);if(S)S=!1;else if(g===47&&!l){N++;break}else g===91?l=!0:g===92?S=!0:g===93&&(l=!1);N++}for(;N<this.c.length&&m.a.has(this.c.charCodeAt(N));)N++;this.e=N;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=m}),define(Se[197],Ie([1,0,24,32,164,311]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=m,e.$Lp=D,e.$Mp=N,e.$Np=S,e.$Op=l,e.$Pp=w,e.$Qp=g;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function m(o){return o=o.trim(),o==="*"||A.test(o)}function D(o){if(!m(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function N(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,c=o.minorBase;let u=o.minorMustEqual;const t=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(i===0||(u=!1),f=!1);let a=0;if(o.preRelease){const d=b.exec(o.preRelease);if(d){const[,$,p,v]=d;a=Date.UTC(Number($),Number(p)-1,Number(v))}}return{majorBase:i,majorMustEqual:n,minorBase:c,minorMustEqual:u,patchBase:t,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:a}}function S(o,i,n){let c;typeof o=="string"?c=N(D(o)):c=o;let u;i instanceof Date?u=i.getTime():typeof i=="string"&&(u=new Date(i).getTime());let t;if(typeof n=="string"?t=N(D(n)):t=n,!c||!t)return!1;const f=c.majorBase,a=c.minorBase,d=c.patchBase;let $=t.majorBase,p=t.minorBase,v=t.patchBase;const y=t.notBefore;let h=t.majorMustEqual,E=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?f>$?!0:f<$?!1:a>p?!0:a<p||u&&u<y?!1:d>=v:(f===1&&$===0&&(!h||!E||!k)&&($=1,p=0,v=0,h=!0,E=!1,k=!1),f<$?!1:f>$?!h:a<p?!1:a>p?!E:d<v?!1:d>v?!k:!(u&&u<y))}function l(o,i,n,c,u){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([O.default.Error,M.localize(0,null)]),t;if(typeof c.name!="string")return t.push([O.default.Error,M.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([O.default.Error,M.localize(2,null,"version")]),t;if(!c.engines)return t.push([O.default.Error,M.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([O.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!s(c.extensionDependencies))return t.push([O.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!s(c.activationEvents))return t.push([O.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([O.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([O.default.Warning,M.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([O.default.Error,M.localize(9,null,"main")]),t;{const d=(0,C.$_g)(n,c.main);(0,C.$6g)(d,n)||t.push([O.default.Warning,M.localize(10,null,d.path,n.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([O.default.Error,M.localize(11,null,"browser")]),t;{const d=(0,C.$_g)(n,c.browser);(0,C.$6g)(d,n)||t.push([O.default.Warning,M.localize(12,null,d.path,n.path)])}}if(!T.valid(c.version))return t.push([O.default.Error,M.localize(13,null)]),t;const f=[];if(!w(o,i,c,u,f))for(const d of f)t.push([O.default.Error,d]);return t}function w(o,i,n,c,u){return c||typeof n.main>"u"&&typeof n.browser>"u"?!0:r(o,i,n.engines.vscode,u)}function g(o,i,n){return o==="*"||r(i,n,o)}function r(o,i,n,c=[]){const u=N(D(n));if(!u)return c.push(M.localize(14,null,n)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(M.localize(15,null,n)),!1}else if(!u.majorMustEqual)return c.push(M.localize(16,null,n)),!1;return S(o,i,u)?!0:(c.push(M.localize(17,null,o,n)),!1)}function s(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(Se[71],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class C{constructor(M,T=[],A=!1){this.ctor=M,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.$vi=C}),define(Se[56],Ie([1,0,71]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Bs=T,e.$Cs=A;const O=[];var M;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function T(b,m,D){m instanceof C.$vi||(m=new C.$vi(m,[],!!D)),O.push([b,m])}function A(){return O}}),define(Se[198],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0;class C{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$er=C;class O{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const A of this.a.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const b=this.lookupOrInsertNode(T),m=this.lookupOrInsertNode(A);b.outgoing.set(m.key,m),m.incoming.set(b.key,b)}removeNode(T){const A=this.b(T);this.a.delete(A);for(const b of this.a.values())b.outgoing.delete(A),b.incoming.delete(A)}lookupOrInsertNode(T){const A=this.b(T);let b=this.a.get(A);return b||(b=new C(A,T),this.a.set(A,b)),b}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[A,b]of this.a)T.push(`${A}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this.a){const b=new Set([T]),m=this.c(A,b);if(m)return m}}c(T,A){for(const[b,m]of T.outgoing){if(A.has(b))return[...A,b].join(" -> ");A.add(b);const D=this.c(m,A);if(D)return D;A.delete(b)}}}e.$fr=O}),define(Se[3],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e._util=void 0,e.$yi=M,e.$zi=T;var C;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function b(m){return m[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=b})(C||(e._util=C={})),e.$xi=M("instantiationService");function O(A,b,m){b[C.DI_TARGET]===b?b[C.DI_DEPENDENCIES].push({id:A,index:m}):(b[C.DI_DEPENDENCIES]=[{id:A,index:m}],b[C.DI_TARGET]=b)}function M(A){if(C.serviceIds.has(A))return C.serviceIds.get(A);const b=function(m,D,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(b,m,N)};return b.toString=()=>A,C.serviceIds.set(A,b),b}function T(A){return A}}),define(Se[50],Ie([1,0,15,2,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=T,e.$7i=A,e.$8i=m,e.$9i=D,e.$0i=N,e.$$i=S,e.$_i=l,e.$aj=g,e.$bj=r,e.$cj=s,e.$5i=(0,M.$yi)("configurationService");function T(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function m(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function D(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function N(o,i){const n=Object.create(null);for(const c in o)S(n,c,o[c],i);return n}function S(o,i,n,c){const u=i.split("."),t=u.pop();let f=o;for(let a=0;a<u.length;a++){const d=u[a];let $=f[d];switch(typeof $){case"undefined":$=f[d]=Object.create(null);break;case"object":if($===null){c(`Ignoring ${i} as ${u.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${i} as ${u.slice(0,a+1).join(".")} is ${JSON.stringify($)}`);return}f=$}if(typeof f=="object"&&f!==null)try{f[t]=n}catch{c(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(f)}`)}else c(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(f)}`)}function l(o,i){const n=i.split(".");w(o,n)}function w(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const c=o[n];typeof c=="object"&&!Array.isArray(c)&&(w(c,i),Object.keys(c).length===0&&delete o[n])}}function g(o,i,n){function c(f,a){let d=f;for(const $ of a){if(typeof d!="object"||d===null)return;d=d[$]}return d}const u=i.split("."),t=c(o,u);return typeof t>"u"?n:t}function r(o,i,n){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in o?C.$ag(o[c])&&C.$ag(i[c])?r(o[c],i[c],n):n&&(o[c]=i[c]):o[c]=i[c])})}function s(o){return o.replace(/[\[\]]/g,"")}}),define(Se[31],Ie([1,0,23,13,196,3,161,14]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=D,e.$xj=f,e.$yj=a,e.$Rj=Ce;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",C.$j),m.set("isLinux",C.$k),m.set("isWindows",C.$i),m.set("isWeb",C.$o),m.set("isMacNative",C.$j&&!C.$o),m.set("isEdge",C.$H),m.set("isFirefox",C.$F),m.set("isChrome",C.$E),m.set("isSafari",C.$G);function D(ne,j){if(m.get(ne)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(ne,j)}const N=Object.prototype.hasOwnProperty;var S;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},w=(0,A.localize)(0,null),g=(0,A.localize)(1,null),r=(0,A.localize)(2,null),s=(0,A.localize)(3,null),o=(0,A.localize)(4,null),i=(0,A.localize)(5,null),n=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=l){this.k=j,this.d=new M.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const ve=this.D(),Le=ve.type===17?i:void 0;throw this.h.push({message:o,offset:ve.offset,lexeme:M.$tj.getLexeme(ve),additionalInfo:Le}),u.c}return x}catch(x){if(x!==u.c)throw x;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const x=this.o();j.push(x)}return j.length===1?j[0]:t.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const x=this.s();j.push(x)}return j.length===1?j[0]:t.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),$.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,s),x?.negate()}case 17:return this.z(),I.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,s),x}case 17:{const x=j.lexeme;if(this.z(),this.y(9)){const Le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Le.type!==10)throw this.B("REGEX",Le);const ke=Le.lexeme,be=ke.lastIndexOf("/"),me=be===ke.length-1?void 0:this.w(ke.substring(be+1));let Q;try{Q=new RegExp(ke.substring(1,be),me)}catch{throw this.B("REGEX",Le)}return z.create(x,Q)}switch(Le.type){case 10:case 19:{const ke=[Le.lexeme];this.z();let be=this.D(),me=0;for(let Te=0;Te<Le.lexeme.length;Te++)Le.lexeme.charCodeAt(Te)===40?me++:Le.lexeme.charCodeAt(Te)===41&&me--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:me++;break;case 1:me--;break;case 10:case 18:for(let Te=0;Te<be.lexeme.length;Te++)be.lexeme.charCodeAt(Te)===40?me++:Le.lexeme.charCodeAt(Te)===41&&me--}if(me<0)break;ke.push(M.$tj.getLexeme(be)),this.z(),be=this.D()}const Q=ke.join(""),Y=Q.lastIndexOf("/"),he=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let ce;try{ce=new RegExp(Q.substring(1,Y),he)}catch{throw this.B("REGEX",Le)}return t.regex(x,ce)}case 18:{const ke=Le.lexeme;this.z();let be=null;if(!(0,O.$9e)(ke)){const me=ke.indexOf("/"),Q=ke.lastIndexOf("/");if(me!==Q&&me>=0){const Y=ke.slice(me+1,Q),he=ke[Q+1]==="i"?"i":"";try{be=new RegExp(Y,he)}catch{throw this.B("REGEX",Le)}}}if(be===null)throw this.B("REGEX",Le);return z.create(x,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Le=this.u();return t.notIn(x,Le)}switch(this.D().type){case 3:{this.z();const Le=this.u();if(this.x().type===18)return t.equals(x,Le);switch(Le){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Le)}}case 4:{this.z();const Le=this.u();if(this.x().type===18)return t.notEquals(x,Le);switch(Le){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Le)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),R.create(x,this.u());case 7:return this.z(),V.create(x,this.u());case 8:return this.z(),W.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:n,offset:j.offset,lexeme:"",additionalInfo:c}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,x){if(this.C(j))return this.z();throw this.B(x,this.D())}B(j,x,ve){const Le=(0,A.localize)(8,null,j,M.$tj.getLexeme(x)),ke=x.offset,be=M.$tj.getLexeme(x);return this.h.push({message:Le,offset:ke,lexeme:be,additionalInfo:ve}),u.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=u;class t{static false(){return $.INSTANCE}static true(){return p.INSTANCE}static has(j){return v.create(j)}static equals(j,x){return y.create(j,x)}static notEquals(j,x){return k.create(j,x)}static regex(j,x){return z.create(j,x)}static in(j,x){return h.create(j,x)}static notIn(j,x){return E.create(j,x)}static not(j){return I.create(j)}static and(...j){return de.create(j,null,!0)}static or(...j){return ye.create(j,null,!0)}static greater(j,x){return V.create(j,x)}static greaterEquals(j,x){return W.create(j,x)}static smaller(j,x){return q.create(j,x)}static smallerEquals(j,x){return R.create(j,x)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$wj=t;function f(ne){const j=new u({regexParsingWithErrorRecovery:!1});return ne.map(x=>(j.parse(x),j.lexingErrors.length>0?j.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,A.localize)(9,null,ve.additionalInfo):(0,A.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function a(ne,j){const x=ne?ne.substituteConstants():void 0,ve=j?j.substituteConstants():void 0;return!x&&!ve?!0:!x||!ve?!1:x.equals(ve)}function d(ne,j){return ne.cmp(j)}class ${static{this.INSTANCE=new $}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return p.INSTANCE}}e.$zj=$;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return $.INSTANCE}}e.$Aj=p;class v{static create(j,x=null){const ve=m.get(j);return typeof ve=="boolean"?ve?p.INSTANCE:$.INSTANCE:new v(j,x)}constructor(j,x){this.key=j,this.c=x,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:ge(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=m.get(this.key);return typeof j=="boolean"?j?p.INSTANCE:$.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$Bj=v;class y{static create(j,x,ve=null){if(typeof x=="boolean")return x?v.create(j,ve):I.create(j,ve);const Le=m.get(j);return typeof Le=="boolean"?x===(Le?"true":"false")?p.INSTANCE:$.INSTANCE:new y(j,x,ve)}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=m.get(this.c);if(typeof j=="boolean"){const x=j?"true":"false";return this.d===x?p.INSTANCE:$.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Cj=y;class h{static create(j,x){return new h(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const x=j.getValue(this.f),ve=j.getValue(this.d);return Array.isArray(x)?x.includes(ve):typeof ve=="string"&&typeof x=="object"&&x!==null?N.call(x,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Dj=h;class E{static create(j,x){return new E(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=11,this.c=h.create(j,x)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=E;class k{static create(j,x,ve=null){if(typeof x=="boolean")return x?I.create(j,ve):v.create(j,ve);const Le=m.get(j);return typeof Le=="boolean"?x===(Le?"true":"false")?$.INSTANCE:p.INSTANCE:new k(j,x,ve)}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=m.get(this.c);if(typeof j=="boolean"){const x=j?"true":"false";return this.d===x?$.INSTANCE:p.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Fj=k;class I{static create(j,x=null){const ve=m.get(j);return typeof ve=="boolean"?ve?$.INSTANCE:p.INSTANCE:new I(j,x)}constructor(j,x){this.c=j,this.d=x,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:ge(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=m.get(this.c);return typeof j=="boolean"?j?$.INSTANCE:p.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Gj=I;function P(ne,j){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?j(ne):$.INSTANCE}class V{static create(j,x,ve=null){return P(x,Le=>new V(j,Le,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Hj=V;class W{static create(j,x,ve=null){return P(x,Le=>new W(j,Le,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Ij=W;class q{static create(j,x,ve=null){return P(x,Le=>new q(j,Le,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Jj=q;class R{static create(j,x,ve=null){return P(x,Le=>new R(j,Le,ve))}constructor(j,x,ve){this.c=j,this.d=x,this.f=ve,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:ue(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Kj=R;class z{static create(j,x){return new z(j,x)}constructor(j,x){this.d=j,this.f=x,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const x=this.f?this.f.source:"",ve=j.f?j.f.source:"";return x<ve?-1:x>ve?1:0}equals(j){if(j.type===this.type){const x=this.f?this.f.source:"",ve=j.f?j.f.source:"";return this.d===j.d&&x===ve}return!1}substituteConstants(){return this}evaluate(j){const x=j.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$Lj=z;class G{static create(j){return new G(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new G(this.c.map(j))}negate(){return this.c}}e.$Mj=G;function ie(ne){let j=null;for(let x=0,ve=ne.length;x<ve;x++){const Le=ne[x].substituteConstants();if(ne[x]!==Le&&j===null){j=[];for(let ke=0;ke<x;ke++)j[ke]=ne[ke]}j!==null&&(j[x]=Le)}return j===null?ne:j}class de{static create(j,x,ve){return de.d(j,x,ve)}constructor(j,x){this.expr=j,this.c=x,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Le=d(this.expr[x],j.expr[x]);if(Le!==0)return Le}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(j.expr[x]))return!1;return!0}return!1}substituteConstants(){const j=ie(this.expr);return j===this.expr?this:de.create(j,this.c,!1)}evaluate(j){for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].evaluate(j))return!1;return!0}static d(j,x,ve){const Le=[];let ke=!1;for(const be of j)if(be){if(be.type===1){ke=!0;continue}if(be.type===0)return $.INSTANCE;if(be.type===6){Le.push(...be.expr);continue}Le.push(be)}if(Le.length===0&&ke)return p.INSTANCE;if(Le.length!==0){if(Le.length===1)return Le[0];Le.sort(d);for(let be=1;be<Le.length;be++)Le[be-1].equals(Le[be])&&(Le.splice(be,1),be--);if(Le.length===1)return Le[0];for(;Le.length>1;){const be=Le[Le.length-1];if(be.type!==9)break;Le.pop();const me=Le.pop(),Q=Le.length===0,Y=ye.create(be.expr.map(he=>de.create([he,me],null,ve)),null,Q);Y&&(Le.push(Y),Le.sort(d))}if(Le.length===1)return Le[0];if(ve){for(let be=0;be<Le.length;be++)for(let me=be+1;me<Le.length;me++)if(Le[be].negate().equals(Le[me]))return $.INSTANCE;if(Le.length===1)return Le[0]}return new de(Le,x)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const x of this.expr)j.push(...x.keys());return j}map(j){return new de(this.expr.map(x=>x.map(j)),null)}negate(){if(!this.c){const j=[];for(const x of this.expr)j.push(x.negate());this.c=ye.create(j,this,!0)}return this.c}}e.$Nj=de;class ye{static create(j,x,ve){return ye.d(j,x,ve)}constructor(j,x){this.expr=j,this.c=x,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Le=d(this.expr[x],j.expr[x]);if(Le!==0)return Le}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(j.expr[x]))return!1;return!0}return!1}substituteConstants(){const j=ie(this.expr);return j===this.expr?this:ye.create(j,this.c,!1)}evaluate(j){for(let x=0,ve=this.expr.length;x<ve;x++)if(this.expr[x].evaluate(j))return!0;return!1}static d(j,x,ve){let Le=[],ke=!1;if(j){for(let be=0,me=j.length;be<me;be++){const Q=j[be];if(Q){if(Q.type===0){ke=!0;continue}if(Q.type===1)return p.INSTANCE;if(Q.type===9){Le=Le.concat(Q.expr);continue}Le.push(Q)}}if(Le.length===0&&ke)return $.INSTANCE;Le.sort(d)}if(Le.length!==0){if(Le.length===1)return Le[0];for(let be=1;be<Le.length;be++)Le[be-1].equals(Le[be])&&(Le.splice(be,1),be--);if(Le.length===1)return Le[0];if(ve){for(let be=0;be<Le.length;be++)for(let me=be+1;me<Le.length;me++)if(Le[be].negate().equals(Le[me]))return p.INSTANCE;if(Le.length===1)return Le[0]}return new ye(Le,x)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const x of this.expr)j.push(...x.keys());return j}map(j){return new ye(this.expr.map(x=>x.map(j)),null)}negate(){if(!this.c){const j=[];for(const x of this.expr)j.push(x.negate());for(;j.length>1;){const x=j.shift(),ve=j.shift(),Le=[];for(const ke of Oe(x))for(const be of Oe(ve))Le.push(de.create([ke,be],null,!1));j.unshift(ye.create(Le,null,!1))}this.c=ye.create(j,this,!0)}return this.c}}e.$Oj=ye;class De extends v{static{this.d=[]}static all(){return De.d.values()}constructor(j,x,ve){super(j,null),this.f=x,typeof ve=="object"?De.d.push({...ve,key:j}):ve!==!0&&De.d.push({key:j,description:ve,type:x!=null?typeof x:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return y.create(this.key,j)}notEqualsTo(j){return k.create(this.key,j)}}e.$Pj=De,e.$Qj=(0,T.$yi)("contextKeyService");function ge(ne,j){return ne<j?-1:ne>j?1:0}function ue(ne,j,x,ve){return ne<x?-1:ne>x?1:j<ve?-1:j>ve?1:0}function Ce(ne,j){if(ne.type===0||j.type===1)return!0;if(ne.type===9)return j.type===9?se(ne.expr,j.expr):!1;if(j.type===9){for(const x of j.expr)if(Ce(ne,x))return!0;return!1}if(ne.type===6){if(j.type===6)return se(j.expr,ne.expr);for(const x of ne.expr)if(Ce(x,j))return!0;return!1}return ne.equals(j)}function se(ne,j){let x=0,ve=0;for(;x<ne.length&&ve<j.length;){const Le=ne[x].cmp(j[ve]);if(Le<0)return!1;Le===0&&x++,ve++}return x===ne.length}function Oe(ne){return ne.type===9?ne.expr:[ne]}}),define(Se[99],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,C.$yi)("environmentService"),e.$Gi=(0,C.$zi)(e.$Fi)}),define(Se[100],Ie([1,0,163,3]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.ExtensionManagementErrorCode=e.$$o=e.ExtensionGalleryErrorCode=e.$0o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$4o=M,e.$5o=T,e.$6o=A,e.$7o=b,e.$8o=m,e.$9o=D,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionsSync",e.$2o="dependecyOrPackExtensionInstall",e.$3o="clientTargetPlatform";function M(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function T(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,n){return n==="web"&&!i.includes("web")}function m(i,n,c){return b(n,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var N;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(N||(e.SortBy=N={}));var S;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(i){i.Install="install",i.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var w;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$0o=(0,O.$yi)("extensionGalleryService");var g;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(g||(e.ExtensionGalleryErrorCode=g={}));class r extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$$o=r;var s;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(s||(e.ExtensionManagementErrorCode=s={}));class o extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$_o=o,e.$ap=(0,O.$yi)("extensionManagementService"),e.$bp="extensionsIdentifiers/disabled",e.$cp="extensionsIdentifiers/enabled",e.$dp=(0,O.$yi)("IGlobalExtensionEnablementService"),e.$ep=(0,O.$yi)("IExtensionTipsService"),e.$fp=(0,C.localize2)(0,"Extensions"),e.$gp=(0,C.localize2)(1,"Preferences")}),define(Se[38],Ie([1,0,54,19,13,15,2,165,3,23,16,43]),function(le,e,C,O,M,T,A,b,m,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$xl=e.FileKind=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.FileOperationResult=e.$pl=e.$ol=e.$nl=e.$ll=e.FileChangeType=e.$kl=e.FileOperation=e.$el=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$5k=void 0,e.$6k=l,e.$7k=s,e.$8k=i,e.$9k=n,e.$0k=c,e.$$k=u,e.$_k=t,e.$al=f,e.$bl=a,e.$cl=d,e.$dl=$,e.$fl=y,e.$gl=h,e.$hl=E,e.$il=k,e.$jl=I,e.$ml=R,e.$yl=De,e.$zl=ge,e.$Bl=Ce,e.$5k=(0,m.$yi)("fileService");function l(se){return se.create===!0}var w;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var g;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(g||(e.FilePermission=g={}));var r;(function(se){se[se.UPDATED=2]="UPDATED",se[se.ADDED=4]="ADDED",se[se.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function s(se){const Oe=se;return!!Oe&&typeof Oe.onDidChange=="function"}var o;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function i(se){return!!(se.capabilities&2)}function n(se){return!!(se.capabilities&8)}function c(se){return!!(se.capabilities&131072)}function u(se){return!!(se.capabilities&4)}function t(se){return!!(se.capabilities&16)}function f(se){return i(se)?!!(se.capabilities&16384):!1}function a(se){return i(se)?!!(se.capabilities&32768):!1}function d(se){return!!(se.capabilities&65536)}function $(se){return!!(se.capabilities&2048)}var p;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class v extends Error{static create(Oe,ne){const j=new v(Oe.toString(),ne);return E(j,ne),j}constructor(Oe,ne){super(Oe),this.code=ne}}e.$el=v;function y(se,Oe){return v.create(se,Oe)}function h(se){return se||y((0,b.localize)(0,null),p.Unknown)}function E(se,Oe){return se.name=Oe?`${Oe} (FileSystemError)`:"FileSystemError",se}function k(se){if(!se)return p.Unknown;if(se instanceof v)return se.code;const Oe=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!Oe)return p.Unknown;switch(Oe[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}function I(se){if(se instanceof z)return se.fileOperationResult;switch(k(se)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}var P;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class V{constructor(Oe,ne,j){this.resource=Oe,this.operation=ne,this.target=j}isOperation(Oe){return this.operation===Oe}}e.$kl=V;var W;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class q{static{this.a=null}constructor(Oe,ne){this.c=ne,this.b=void 0,this.d=new S.$V(()=>{const j=C.$Ei.forUris(()=>this.c);return j.fill(this.rawAdded.map(x=>[x,!0])),j}),this.f=new S.$V(()=>{const j=C.$Ei.forUris(()=>this.c);return j.fill(this.rawUpdated.map(x=>[x,!0])),j}),this.g=new S.$V(()=>{const j=C.$Ei.forUris(()=>this.c);return j.fill(this.rawDeleted.map(x=>[x,!0])),j}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const j of Oe){switch(j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}this.b!==q.a&&(typeof j.cId=="number"?this.b===void 0?this.b=j.cId:this.b!==j.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Oe,...ne){return this.h(Oe,{includeChildren:!1},...ne)}affects(Oe,...ne){return this.h(Oe,{includeChildren:!0},...ne)}h(Oe,ne,...j){if(!Oe)return!1;const x=j.length>0;return!!((!x||j.includes(1))&&(this.d.value.get(Oe)||ne.includeChildren&&this.d.value.findSuperstr(Oe))||(!x||j.includes(0))&&(this.f.value.get(Oe)||ne.includeChildren&&this.f.value.findSuperstr(Oe))||(!x||j.includes(2))&&(this.g.value.findSubstr(Oe)||ne.includeChildren&&this.g.value.findSuperstr(Oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Oe){return this.b===Oe}hasCorrelation(){return typeof this.b=="number"}}e.$ll=q;function R(se,Oe,ne){return!se||!Oe||se===Oe||Oe.length>se.length?!1:(Oe.charAt(Oe.length-1)!==O.sep&&(Oe+=O.sep),ne?(0,M.$Af)(se,Oe):se.indexOf(Oe)===0)}class z extends Error{constructor(Oe,ne,j){super(Oe),this.fileOperationResult=ne,this.options=j}}e.$nl=z;class G extends z{constructor(Oe,ne,j,x){super(Oe,ne,x),this.fileOperationResult=ne,this.size=j}}e.$ol=G;class ie extends z{constructor(Oe,ne,j){super(Oe,2,j),this.stat=ne}}e.$pl=ie;var de;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(de||(e.FileOperationResult=de={})),e.$ql={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sl="files.associations",e.$tl="files.exclude",e.$ul="files.readonlyInclude",e.$vl="files.readonlyExclude",e.$wl="files.readonlyFromPermissions";var ye;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(e.FileKind=ye={})),e.$xl="";function De(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}async function ge(se,Oe){if(!Oe.hasProvider(A.URI.from({scheme:se.scheme})))return new Promise(ne=>{const j=Oe.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===se.scheme&&x.added&&(j.dispose(),ne())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(Oe){return(0,T.$cg)(Oe)||(Oe=0),Oe<ue.KB?(0,b.localize)(1,null,Oe.toFixed(0)):Oe<ue.MB?(0,b.localize)(2,null,(Oe/ue.KB).toFixed(2)):Oe<ue.GB?(0,b.localize)(3,null,(Oe/ue.MB).toFixed(2)):Oe<ue.TB?(0,b.localize)(4,null,(Oe/ue.GB).toFixed(2)):(0,b.localize)(5,null,(Oe/ue.TB).toFixed(2))}}e.$Al=ue;function Ce(se){const Oe=typeof se=="string"||se?.scheme===N.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===N.Schemas.file?1024*ue.MB:Oe?10*ue.MB:D.$o?50*ue.MB:1024*ue.MB}}),define(Se[72],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class C{constructor(...M){this.a=new Map;for(const[T,A]of M)this.set(T,A)}set(M,T){const A=this.a.get(M);return this.a.set(M,T),A}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$wi=C}),define(Se[199],Ie([1,0,11,14,6,71,198,3,72,200]),function(le,e,C,O,M,T,A,b,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;const N=!1;class S extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class l{constructor(s=new m.$wi,o=!1,i,n=N){this.i=s,this.j=o,this.k=i,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(b.$xi,this),this._globalGraph=n?i?._globalGraph??new A.$fr(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,M.$Pc)(this.h),this.h.clear();for(const s of this.g)(0,M.$Oc)(s)&&s.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(s){this.m();const o=new class extends l{dispose(){this.h.delete(o),super.dispose()}}(s,this.j,this,this.l);return this.h.add(o),o}invokeFunction(s,...o){this.m();const i=g.traceInvocation(this.l,s);let n=!1;try{return s({get:u=>{if(n)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(u,i);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(s,...o){this.m();let i,n;return s instanceof T.$vi?(i=g.traceCreation(this.l,s.ctor),n=this.o(s.ctor,s.staticArguments.concat(o),i)):(i=g.traceCreation(this.l,s),n=this.o(s,o,i)),i.stop(),n}o(s,o=[],i){const n=b._util.getServiceDependencies(s).sort((t,f)=>t.index-f.index),c=[];for(const t of n){const f=this.s(t.id,i);f||this.y(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(f)}const u=n.length>0?n[0].index:o.length;if(o.length!==u){console.trace(`[createInstance] First service dependency of ${s.name} at position ${u+1} conflicts with ${o.length} static arguments`);const t=u-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,u)}return Reflect.construct(s,o.concat(c))}q(s,o){if(this.i.get(s)instanceof T.$vi)this.i.set(s,o);else if(this.k)this.k.q(s,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(s){const o=this.i.get(s);return!o&&this.k?this.k.r(s):o}s(s,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const i=this.r(s);return i instanceof T.$vi?this.u(s,i,o.branch(s,!0)):(o.branch(s,!1),i)}u(s,o,i){if(this.t.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.t.add(s);try{return this.v(s,o,i)}finally{this.t.delete(s)}}v(s,o,i){const n=new A.$fr(t=>t.id.toString());let c=0;const u=[{id:s,desc:o,_trace:i}];for(;u.length;){const t=u.pop();if(n.lookupOrInsertNode(t),c++>1e3)throw new S(n);for(const f of b._util.getServiceDependencies(t.desc.ctor)){const a=this.r(f.id);if(a||this.y(`[createInstance] ${s} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),a instanceof T.$vi){const d={id:f.id,desc:a,_trace:t._trace.branch(f.id,!0)};n.insertEdge(t,d),u.push(d)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new S(n);break}for(const{data:f}of t){if(this.r(f.id)instanceof T.$vi){const d=this.w(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.q(f.id,d)}n.removeNode(f)}}return this.r(s)}w(s,o,i=[],n,c){if(this.i.get(s)instanceof T.$vi)return this.x(s,o,i,n,c,this.g);if(this.k)return this.k.w(s,o,i,n,c);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(s,o,i=[],n,c,u){if(n){const t=new l(void 0,this.j,this,this.l);t.c=String(s);const f=new Map,a=new C.$Rh(()=>{const d=t.o(o,i,c);for(const[$,p]of f){const v=d[$];if(typeof v=="function")for(const y of p)y.disposable=v.apply(d,y.listener)}return f.clear(),u.add(d),d});return new Proxy(Object.create(null),{get(d,$){if(!a.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let y=f.get($);return y||(y=new D.$5c,f.set($,y)),(E,k,I)=>{if(a.isInitialized)return a.value[$](E,k,I);{const P={listener:[E,k,I],disposable:void 0},V=y.push(P);return(0,M.$Sc)(()=>{V(),P.disposable?.dispose()})}}}if($ in d)return d[$];const p=a.value;let v=p[$];return typeof v!="function"||(v=v.bind(p),d[$]=v),v},set(d,$,p){return a.value[$]=p,!0},getPrototypeOf(d){return o.prototype}})}else{const t=this.o(o,i,c);return u.add(t),t}}y(s,o){if(o&&console.warn(s),this.j)throw new Error(s)}}e.$gr=l;var w;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(w||(w={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(s,o){return s?new g(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(s,o){return s?new g(1,o.name):g.c}static{this.f=0}constructor(s,o){this.type=s,this.name=o,this.g=Date.now(),this.h=[]}branch(s,o){const i=new g(3,s.toString());return this.h.push([s,o,i]),i}stop(){const s=Date.now()-this.g;g.f+=s;let o=!1;function i(c,u){const t=[],f=new Array(c+1).join("	");for(const[a,d,$]of u.h)if(d&&$){o=!0,t.push(`${f}CREATES -> ${a}`);const p=i(c+1,$);p&&t.push(p)}else t.push(`${f}uses -> ${a}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(s>2||o)&&g.all.add(n.join(`
`))}}e.$hr=g}),define(Se[12],Ie([1,0,166,44,5,73,6,28,23,24,15,2,31,3]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=r,e.log=o,e.$gk=v,e.$hk=y,e.$ik=h,e.$jk=E,e.$5j=(0,w.$yi)("logService"),e.$6j=(0,w.$yi)("loggerService");function g(){return new Date().toISOString()}function r(k){return(0,N.$cg)(k)}var s;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$8j=s.Info;function o(k,I,P){switch(I){case s.Trace:k.trace(P);break;case s.Debug:k.debug(P);break;case s.Info:k.info(P);break;case s.Warning:k.warn(P);break;case s.Error:k.error(P);break;case s.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function i(k,I=!1){let P="";for(let V=0;V<k.length;V++){let W=k[V];if(W instanceof Error&&(W=(0,O.$jj)(W,I)),typeof W=="object")try{W=JSON.stringify(W)}catch{}P+=(V>0?" ":"")+W}return P}class n extends A.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new M.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==s.Off&&this.b<=I}}e.$0j=n;class c extends n{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...P){this.f(s.Trace)&&this.g(s.Trace,i([I,...P],!0))}debug(I,...P){this.f(s.Debug)&&this.g(s.Debug,i([I,...P]))}info(I,...P){this.f(s.Info)&&this.g(s.Info,i([I,...P]))}warn(I,...P){this.f(s.Warning)&&this.g(s.Warning,i([I,...P]))}error(I,...P){if(this.f(s.Error))if(I instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=I.stack,this.g(s.Error,i(V))}else this.g(s.Error,i([I,...P]))}flush(){}}e.$$j=c;class u extends n{constructor(I=e.$8j){super(),this.setLevel(I),this.g=!m.$i}trace(I,...P){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,I,...P):console.log(`[main ${g()}]`,I,...P))}debug(I,...P){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,I,...P):console.log(`[main ${g()}]`,I,...P))}info(I,...P){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,I,...P):console.log(`[main ${g()}]`,I,...P))}warn(I,...P){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,I,...P):console.warn(`[main ${g()}]`,I,...P))}error(I,...P){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,I,...P):console.error(`[main ${g()}]`,I,...P))}flush(){}}e.$_j=u;class t extends n{constructor(I=e.$8j,P=!0){super(),this.g=P,this.setLevel(I)}trace(I,...P){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...P):console.log(I,...P))}debug(I,...P){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...P):console.log(I,...P))}info(I,...P){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...P):console.log(I,...P))}warn(I,...P){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...P):console.log(I,...P))}error(I,...P){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...P):console.error(I,...P))}flush(){}}e.$ak=t;class f extends n{constructor(I,P=e.$8j){super(),this.g=I,this.setLevel(P)}trace(I,...P){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(I),...P])}debug(I,...P){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(I),...P])}info(I,...P){this.f(s.Info)&&this.g.log(s.Info,[this.h(I),...P])}warn(I,...P){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(I),...P])}error(I,...P){this.f(s.Error)&&this.g.log(s.Error,[this.h(I),...P])}h(I){return typeof I=="string"?I:(0,O.$jj)(I,this.f(s.Trace))}flush(){}}e.$bk=f;class a extends n{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const P of this.g)P.setLevel(I);super.setLevel(I)}trace(I,...P){for(const V of this.g)V.trace(I,...P)}debug(I,...P){for(const V of this.g)V.debug(I,...P)}info(I,...P){for(const V of this.g)V.info(I,...P)}warn(I,...P){for(const V of this.g)V.warn(I,...P)}error(I,...P){for(const V of this.g)V.error(I,...P)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$ck=a;class d extends A.$Uc{constructor(I,P,V){if(super(),this.h=I,this.j=P,this.b=new b.$Ac,this.c=this.B(new M.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$fe),this.onDidChangeVisibility=this.g.event,V)for(const W of V)this.b.set(W.resource,{logger:void 0,info:W})}m(I){return(0,N.$$f)(I)?[...this.b.values()].find(P=>P.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,P){const V=this.n(I),W=(0,N.$$f)(I)?I:P?.id??(0,T.$mj)(V.toString()).toString(16);let q=this.b.get(V)?.logger;const R=P?.logLevel==="always"?s.Trace:P?.logLevel;q||(q=this.s(V,R??this.getLogLevel(V)??this.h,{...P,id:W}));const z={logger:q,info:{resource:V,id:W,logLevel:R,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(z.info),this.b.set(V,z),q}n(I){return(0,N.$$f)(I)?(0,D.$_g)(this.j,`${I}.log`):I}setLogLevel(I,P){if(S.URI.isUri(I)){const V=I,W=P,q=this.b.get(V);q&&W!==q.info.logLevel&&(q.info.logLevel=W===this.h?void 0:W,q.logger?.setLevel(W),this.b.set(q.info.resource,q),this.f.fire([V,W]))}else{this.h=I;for(const[V,W]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,P){const V=this.m(I);V&&P!==!V.info.hidden&&(V.info.hidden=!P,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,P]))}getLogLevel(I){let P;return I&&(P=this.b.get(I)?.info.logLevel),P??this.h}registerLogger(I){const P=this.b.get(I.resource);P?P.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const P=this.b.get(I);P&&(P.logger&&P.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=d;class ${constructor(){this.onDidChangeLogLevel=new M.$fe().event}setLevel(I){}getLevel(){return s.Info}trace(I,...P){}debug(I,...P){}info(I,...P){}warn(I,...P){}error(I,...P){}critical(I,...P){}dispose(){}flush(){}}e.$ek=$;class p extends ${}e.$fk=p;function v(k){if(k.verbose)return s.Trace;if(typeof k.logLevel=="string"){const I=E(k.logLevel.toLowerCase());if(I!==void 0)return I}return e.$8j}function y(k){switch(k){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function h(k){switch(k){case s.Trace:return{original:"Trace",value:C.localize(0,null)};case s.Debug:return{original:"Debug",value:C.localize(1,null)};case s.Info:return{original:"Info",value:C.localize(2,null)};case s.Warning:return{original:"Warning",value:C.localize(3,null)};case s.Error:return{original:"Error",value:C.localize(4,null)};case s.Off:return{original:"Off",value:C.localize(5,null)}}}function E(k){switch(k){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$kk=new l.$Pj("logLevel",y(s.Info))}),define(Se[201],Ie([1,0,6,12]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;class M extends C.$Uc{constructor(A,b=[]){super(),this.a=new O.$ck([A,...b]),this.B(A.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...b){this.a.trace(A,...b)}debug(A,...b){this.a.debug(A,...b)}info(A,...b){this.a.info(A,...b)}warn(A,...b){this.a.warn(A,...b)}error(A,...b){this.a.error(A,...b)}flush(){this.a.flush()}}e.$bQ=M}),define(Se[101],Ie([1,0,32,167,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var A;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(m){function D(g,r){return r-g}m.compare=D;const N=Object.create(null);N[m.Error]=(0,O.localize)(0,null),N[m.Warning]=(0,O.localize)(1,null),N[m.Info]=(0,O.localize)(2,null);function S(g){return N[g]||""}m.toString=S;function l(g){switch(g){case C.default.Error:return m.Error;case C.default.Warning:return m.Warning;case C.default.Info:return m.Info;case C.default.Ignore:return m.Hint}}m.fromSeverity=l;function w(g){switch(g){case m.Error:return C.default.Error;case m.Warning:return C.default.Warning;case m.Info:return C.default.Info;case m.Hint:return C.default.Ignore}}m.toSeverity=w}(A||(e.MarkerSeverity=A={}));var b;(function(m){const D="";function N(l){return S(l,!0)}m.makeKey=N;function S(l,w){const g=[D];return l.source?g.push(l.source.replace("\xA6","\\\xA6")):g.push(D),l.code?typeof l.code=="string"?g.push(l.code.replace("\xA6","\\\xA6")):g.push(l.code.value.replace("\xA6","\\\xA6")):g.push(D),l.severity!==void 0&&l.severity!==null?g.push(A.toString(l.severity)):g.push(D),l.message&&w?g.push(l.message.replace("\xA6","\\\xA6")):g.push(D),l.startLineNumber!==void 0&&l.startLineNumber!==null?g.push(l.startLineNumber.toString()):g.push(D),l.startColumn!==void 0&&l.startColumn!==null?g.push(l.startColumn.toString()):g.push(D),l.endLineNumber!==void 0&&l.endLineNumber!==null?g.push(l.endLineNumber.toString()):g.push(D),l.endColumn!==void 0&&l.endColumn!==null?g.push(l.endColumn.toString()):g.push(D),g.push(D),g.join("\xA6")}m.makeKeyOptionalMessage=S})(b||(e.IMarkerData=b={})),e.$ou=(0,M.$yi)("markerService")}),define(Se[202],Ie([1,0,5,32,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$dw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$bw=e.Severity=void 0,e.$cw=b,e.Severity=O.default,e.$bw=(0,M.$yi)("notificationService");var T;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var A;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function b(S){if(S){const l=S;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var m;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class D{constructor(){this.progress=new N,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$dw=D;class N{infinite(){}done(){}total(l){}worked(l){}}e.$ew=N}),define(Se[102],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,C.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(le,e,C,O){var M=arguments.length,T=M<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,C):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(le,e,C,O);else for(var b=le.length-1;b>=0;b--)(A=le[b])&&(T=(M<3?A(T):M>3?A(e,C,T):A(e,C))||T);return M>3&&T&&Object.defineProperty(e,C,T),T},We=this&&this.__param||function(le,e){return function(C,O){e(C,O,le)}};define(Se[103],Ie([1,0,11,20,6,3]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lw=e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.ProgressLocation=e.$fw=void 0,e.$fw=(0,T.$yi)("progressService");var A;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$gw=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$hw=b;class m{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const w=this.d;this.d=()=>{w?.(),l()}}):Promise.resolve()}}e.$iw=m;let D=class extends M.$Uc{constructor(l,w){super(),this.a=new C.$Vh,w.withProgress(l,g=>(this.b=g,this.c&&g.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$jw=D,e.$jw=D=Je([We(1,e.$fw)],D);class N extends M.$Uc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new M.$Tc)}start(l){this.stop();const w=++this.a,g=new O.$qe;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>g.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:w,token:g.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$kw=N,e.$lw=(0,T.$yi)("editorProgressService")}),define(Se[29],Ie([1,0,57,15]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class M{constructor(){this.a=new Map}add(A,b){C.ok(O.$$f(A)),C.ok(O.$ag(b)),C.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,b)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$fo=new M}),define(Se[74],Ie([1,0,5,29]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function M(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class T{constructor(){this.b=new C.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,D){this.a[M(m)]=D,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const A=new T;O.$fo.add(e.$go.JSONContribution,A)}),define(Se[51],Ie([1,0,18,5,15,160,50,74,29]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=r,e.$wo=s,e.$xo=o,e.$yo=n,e.$zo=c;var D;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(D||(e.EditPresentationTypes=D={})),e.$ko={Configuration:"base.contributions.configuration"};var N;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N||(e.ConfigurationScope=N={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const S=m.$fo.as(b.$go.JSONContribution);class l{constructor(){this.h=new Set,this.i=new O.$fe,this.onDidSchemaChange=this.i.event,this.j=new O.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const a=new Set;this.n(t,f,a),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const f=new Set;this.o(t,f),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const a=new Set;this.o(f,a),this.n(t,!1,a),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const a=[];for(const{overrides:d,source:$}of t)for(const p in d)if(f.add(p),e.$uo.test(p)){const v=this.a.get(p),y=v?.valuesSources??new Map;if($)for(const I of Object.keys(d[p]))y.set(I,$);const h={...v?.value||{},...d[p]};this.a.set(p,{source:$,value:h,valuesSources:y});const E=(0,A.$cj)(p),k={type:"object",default:h,description:T.localize(1,null,E),$ref:e.$ro,defaultDefaultValue:h,source:M.$$f($)?void 0:$,defaultValueSource:$};a.push(...r(p)),this.d[p]=k,this.b.properties[p]=k}else{this.a.set(p,{value:d[p],source:$});const v=this.d[p];v&&(this.w(p,v),this.r(p,v))}this.m(a)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:a,source:d}of t)for(const $ in a){const p=this.a.get($),v=M.$$f(d)?d:d?.id,y=M.$$f(p?.source)?p?.source:p?.source?.id;if(v===y)if(f.add($),this.a.delete($),e.$uo.test($))delete this.d[$],delete this.b.properties[$];else{const h=this.d[$];h&&(this.w($,h),this.r($,h))}}this.u()}deltaConfiguration(t){let f=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,a){t.forEach(d=>{this.p(d,f,d.extensionInfo,d.restrictedProperties,void 0,a),this.c.push(d),this.q(d)})}o(t,f){const a=d=>{if(d.properties)for(const $ in d.properties){f.add($);const p=this.d[$];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[$],this.s($,d.properties[$])}d.allOf?.forEach($=>a($))};for(const d of t){a(d);const $=this.c.indexOf(d);$!==-1&&this.c.splice($,1)}}p(t,f=!0,a,d,$=3,p){$=M.$hg(t.scope)?$:t.scope;const v=t.properties;if(v)for(const h in v){const E=v[h];if(f&&n(h,E)){delete v[h];continue}if(E.source=a,E.defaultDefaultValue=v[h].default,this.w(h,E),e.$uo.test(h)?E.scope=void 0:(E.scope=M.$hg(E.scope)?$:E.scope,E.restricted=M.$hg(E.restricted)?!!d?.includes(h):E.restricted),v[h].hasOwnProperty("included")&&!v[h].included){this.f[h]=v[h],delete v[h];continue}else this.d[h]=v[h],v[h].policy?.name&&this.e.set(v[h].policy.name,h);!v[h].deprecationMessage&&v[h].markdownDeprecationMessage&&(v[h].deprecationMessage=v[h].markdownDeprecationMessage),p.add(h)}const y=t.allOf;if(y)for(const h of y)this.p(h,f,a,d,$,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=a=>{const d=a.properties;if(d)for(const p in d)this.r(p,d[p]);a.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$lo.properties[t]=f,f.scope){case 1:e.$mo.properties[t]=f;break;case 2:e.$no.properties[t]=f;break;case 6:e.$oo.properties[t]=f;break;case 3:e.$po.properties[t]=f;break;case 4:e.$qo.properties[t]=f;break;case 5:e.$qo.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$lo.properties[t],f.scope){case 1:delete e.$mo.properties[t];break;case 2:delete e.$no.properties[t];break;case 6:delete e.$oo.properties[t];break;case 3:delete e.$po.properties[t];break;case 4:case 5:delete e.$qo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,a={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$ro};this.w(f,a),e.$lo.properties[f]=a,e.$mo.properties[f]=a,e.$no.properties[f]=a,e.$oo.properties[f]=a,e.$po.properties[f]=a,e.$qo.properties[f]=a}}v(){const t={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=t,e.$mo.patternProperties[e.$to]=t,e.$no.patternProperties[e.$to]=t,e.$oo.patternProperties[e.$to]=t,e.$po.patternProperties[e.$to]=t,e.$qo.patternProperties[e.$to]=t,this.i.fire()}w(t,f){const a=this.a.get(t);let d=a?.value,$=a?.source;M.$fg(d)&&(d=f.defaultDefaultValue,$=void 0),M.$fg(d)&&(d=o(f.type)),f.default=d,f.defaultValueSource=$}}const w="\\[([^\\]]+)\\]",g=new RegExp(w,"g");e.$to=`^(${w})+$`,e.$uo=new RegExp(e.$to);function r(u){const t=[];if(e.$uo.test(u)){let f=g.exec(u);for(;f?.length;){const a=f[1].trim();a&&t.push(a),f=g.exec(u)}}return(0,C.$Mb)(t)}function s(u){return u.reduce((t,f)=>`${t}[${f}]`,"")}function o(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new l;m.$fo.add(e.$ko.Configuration,i);function n(u,t){return u.trim()?e.$uo.test(u)?T.localize(7,null,u):i.getConfigurationProperties()[u]!==void 0?T.localize(8,null,u):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?T.localize(9,null,u,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:T.localize(6,null)}function c(){const u=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))u.push([f,t[f].scope]);return u.push(["launch",4]),u.push(["task",4]),u}}),define(Se[203],Ie([1,0,18,5,126,6,28,26,15,2,50,51,29]),function(le,e,C,O,M,T,A,b,m,D,N,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=n;function w(f){return Object.isFrozen(f)?f:b.$6n(f)}class g{static createEmptyModel(a){return new g({},[],[],void 0,a)}constructor(a,d,$,p,v){this.b=a,this.c=d,this.d=$,this.raw=p,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(d=>{if(d instanceof g)return d;const $=new r("",this.f);return $.parseRaw(d),$.configurationModel});this.g=a.reduce((d,$)=>$===d?$:d.merge($),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,N.$aj)(this.contents,a):this.contents}inspect(a,d){const $=this;return{get value(){return w($.rawConfiguration.getValue(a))},get override(){return d?w($.rawConfiguration.getOverrideValue(a,d)):void 0},get merged(){return w(d?$.rawConfiguration.override(d).getValue(a):$.rawConfiguration.getValue(a))},get overrides(){const p=[];for(const{contents:v,identifiers:y,keys:h}of $.rawConfiguration.overrides){const E=new g(v,h,[],void 0,$.f).getValue(a);E!==void 0&&p.push({identifiers:y,value:E})}return p.length?w(p):void 0}}}getOverrideValue(a,d){const $=this.j(d);return $?a?(0,N.$aj)($,a):$:void 0}getKeysForOverrideIdentifier(a){const d=[];for(const $ of this.overrides)$.identifiers.includes(a)&&d.push(...$.keys);return C.$Mb(d)}getAllOverrideIdentifiers(){const a=[];for(const d of this.overrides)a.push(...d.identifiers);return C.$Mb(a)}override(a){let d=this.a.get(a);return d||(d=this.h(a),this.a.set(a,d)),d}merge(...a){const d=b.$5n(this.contents),$=b.$5n(this.overrides),p=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const y of a)if(v.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(d,y.contents);for(const h of y.overrides){const[E]=$.filter(k=>C.$ub(k.identifiers,h.identifiers));E?(this.i(E.contents,h.contents),E.keys.push(...h.keys),E.keys=C.$Mb(E.keys)):$.push(b.$5n(h))}for(const h of y.keys)p.indexOf(h)===-1&&p.push(h)}return new g(d,p,$,v.every(y=>y instanceof g)?void 0:v,this.f)}h(a){const d=this.j(a);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const $={};for(const p of C.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let v=this.contents[p];const y=d[p];y&&(typeof v=="object"&&typeof y=="object"?(v=b.$5n(v),this.i(v,y)):v=y),$[p]=v}return new g($,this.keys,this.overrides,void 0,this.f)}i(a,d){for(const $ of Object.keys(d)){if($ in a&&m.$ag(a[$])&&m.$ag(d[$])){this.i(a[$],d[$]);continue}a[$]=b.$5n(d[$])}}j(a){let d=null,$=null;const p=v=>{v&&($?this.i($,v):$=b.$5n(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===a?d=v.contents:v.identifiers.includes(a)&&p(v.contents);return p(d),$}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,d){this.k(a,d,!0)}setValue(a,d){this.k(a,d,!1)}removeValue(a){const d=this.keys.indexOf(a);d!==-1&&(this.keys.splice(d,1),(0,N.$_i)(this.contents,a),S.$uo.test(a)&&this.overrides.splice(this.overrides.findIndex($=>C.$ub($.identifiers,(0,S.$vo)(a))),1))}k(a,d,$){(0,N.$$i)(this.contents,a,d,p=>this.f.error(p)),$=$||this.keys.indexOf(a)===-1,$&&this.keys.push(a),S.$uo.test(a)&&this.overrides.push({identifiers:(0,S.$vo)(a),keys:Object.keys(this.contents[a]),contents:(0,N.$0i)(this.contents[a],p=>this.f.error(p))})}}e.$Ao=g;class r{constructor(a,d){this.f=a,this.g=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||g.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,d){if(!m.$hg(a)){const $=this.h(a);this.parseRaw($,d)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,d){this.a=a;const{contents:$,keys:p,overrides:v,restricted:y,hasExcludedProperties:h}=this.i(a,d);this.b=new g($,p,v,h?[a]:void 0,this.g),this.c=y||[]}h(a){let d={},$=null,p=[];const v=[],y=[];function h(k){Array.isArray(p)?p.push(k):$!==null&&(p[$]=k)}const E={onObjectBegin:()=>{const k={};h(k),v.push(p),p=k,$=null},onObjectProperty:k=>{$=k},onObjectEnd:()=>{p=v.pop()},onArrayBegin:()=>{const k=[];h(k),v.push(p),p=k,$=null},onArrayEnd:()=>{p=v.pop()},onLiteralValue:h,onError:(k,I,P)=>{y.push({error:k,offset:I,length:P})}};if(a)try{M.$Sn(a,E),d=p[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return d}i(a,d){const $=l.$fo.as(S.$ko.Configuration).getConfigurationProperties(),p=this.j(a,$,!0,d);a=p.raw;const v=(0,N.$0i)(a,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),y=Object.keys(a),h=this.l(a,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:v,keys:y,overrides:h,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}j(a,d,$,p){let v=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:v};const y={},h=[];for(const E in a)if(S.$uo.test(E)&&$){const k=this.j(a[E],d,!1,p);y[E]=k.raw,v=v||k.hasExcludedProperties,h.push(...k.restricted)}else{const k=d[E],I=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&h.push(E),!p.exclude?.includes(E)&&(p.include?.includes(E)||(I===void 0||p.scopes===void 0||p.scopes.includes(I))&&!(p.skipRestricted&&k?.restricted))?y[E]=a[E]:v=!0}return{raw:y,restricted:h,hasExcludedProperties:v}}l(a,d){const $=[];for(const p of Object.keys(a))if(S.$uo.test(p)){const v={};for(const y in a[p])v[y]=a[p][y];$.push({identifiers:(0,S.$vo)(p),keys:Object.keys(v),contents:(0,N.$0i)(v,d)})}return $}}e.$Bo=r;class s extends T.$Uc{constructor(a,d,$,p,v){super(),this.c=a,this.f=d,this.g=p,this.h=v,this.b=this.B(new O.$fe),this.onDidChange=this.b.event,this.a=new r(this.c.toString(),v),this.B(this.g.watch($.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&$.isEqual(y.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return g.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=s;class o{constructor(a,d,$,p,v,y,h,E,k,I,P,V,W){this.a=a,this.b=d,this.c=$,this.overrideIdentifiers=p,this.d=v,this.f=y,this.g=h,this.h=E,this.i=k,this.j=I,this.k=P,this.l=V,this.m=W}get value(){return w(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(a,d,$,p,v,y,h,E,k,I){this.j=a,this.l=d,this.m=$,this.n=p,this.p=v,this.q=y,this.r=h,this.s=E,this.t=k,this.u=I,this.h=null,this.i=new A.$Ac,this.v=null}getValue(a,d,$){return this.w(a,d,$).getValue(a)}updateValue(a,d,$={}){let p;$.resource?(p=this.t.get($.resource),p||(p=g.createEmptyModel(this.u),this.t.set($.resource,p))):p=this.s,d===void 0?p.removeValue(a):p.setValue(a,d),$.resource||(this.h=null)}inspect(a,d,$){const p=this.w(a,d,$),v=this.A(d.resource,$),y=d.resource?this.t.get(d.resource)||this.s:this.s,h=new Set;for(const E of p.overrides)for(const k of E.identifiers)p.getOverrideValue(a,k)!==void 0&&h.add(k);return new o(a,d,p.getValue(a),h.size?[...h]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,$?this.q:void 0,v||void 0,y)}keys(a){const d=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,d){this.r.set(a,d),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,d){const $=[];if(!d){const{added:p,updated:v,removed:y}=u(this.j,a);d=[...p,...v,...y]}for(const p of d)for(const v of(0,S.$vo)(p)){const y=this.j.getKeysForOverrideIdentifier(v),h=a.getKeysForOverrideIdentifier(v),E=[...h.filter(k=>y.indexOf(k)===-1),...y.filter(k=>h.indexOf(k)===-1),...y.filter(k=>!b.$9n(this.j.override(v).getValue(k),a.override(v).getValue(k)))];$.push([v,E])}return this.updateDefaultConfiguration(a),{keys:d,overrides:$}}compareAndUpdatePolicyConfiguration(a){const{added:d,updated:$,removed:p}=u(this.l,a),v=[...d,...$,...p];return v.length&&this.updatePolicyConfiguration(a),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:d,updated:$,removed:p,overrides:v}=u(this.applicationConfiguration,a),y=[...d,...$,...p];return y.length&&this.updateApplicationConfiguration(a),{keys:y,overrides:v}}compareAndUpdateLocalUserConfiguration(a){const{added:d,updated:$,removed:p,overrides:v}=u(this.localUserConfiguration,a),y=[...d,...$,...p];return y.length&&this.updateLocalUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateRemoteUserConfiguration(a){const{added:d,updated:$,removed:p,overrides:v}=u(this.remoteUserConfiguration,a),y=[...d,...$,...p];return y.length&&this.updateRemoteUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateWorkspaceConfiguration(a){const{added:d,updated:$,removed:p,overrides:v}=u(this.workspaceConfiguration,a),y=[...d,...$,...p];return y.length&&this.updateWorkspaceConfiguration(a),{keys:y,overrides:v}}compareAndUpdateFolderConfiguration(a,d){const $=this.folderConfigurations.get(a),{added:p,updated:v,removed:y,overrides:h}=u($,d),E=[...p,...v,...y];return(E.length||!$)&&this.updateFolderConfiguration(a,d),{keys:E,overrides:h}}compareAndDeleteFolderConfiguration(a){const d=this.folderConfigurations.get(a);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:$,updated:p,removed:v,overrides:y}=u(d,void 0);return{keys:[...$,...p,...v],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,d,$){let p=this.x(d,$);return d.overrideIdentifier&&(p=p.override(d.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(p=p.merge(this.l)),p}x({resource:a},d){let $=this.y();if(d&&a){const p=d.getFolder(a);p&&($=this.z(p.uri)||$);const v=this.t.get(a);v&&($=$.merge(v))}return $}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let d=this.i.get(a);if(!d){const $=this.y(),p=this.r.get(a);p?(d=$.merge(p),this.i.set(a,d)):d=$}return d}A(a,d){if(d&&a){const $=d.getFolder(a);if($)return this.r.get($.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,d)=>{const{contents:$,overrides:p,keys:v}=this.r.get(d);return a.push([d,{contents:$,overrides:p,keys:v}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(d=>a.add(d)),this.userConfiguration.keys.forEach(d=>a.add(d)),this.q.keys.forEach(d=>a.add(d)),this.r.forEach(d=>d.keys.forEach($=>a.add($))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.q.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.r.forEach(d=>d.getAllOverrideIdentifiers().forEach($=>a.add($))),[...a.values()]}D(a){const d=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach($=>d.add($)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach($=>d.add($)),this.q.getKeysForOverrideIdentifier(a).forEach($=>d.add($)),this.r.forEach($=>$.getKeysForOverrideIdentifier(a).forEach(p=>d.add(p))),[...d.values()]}static parse(a,d){const $=this.E(a.defaults,d),p=this.E(a.policy,d),v=this.E(a.application,d),y=this.E(a.user,d),h=this.E(a.workspace,d),E=a.folders.reduce((k,I)=>(k.set(D.URI.revive(I[0]),this.E(I[1],d)),k),new A.$Ac);return new i($,p,v,y,g.createEmptyModel(d),h,E,g.createEmptyModel(d),new A.$Ac,d)}static E(a,d){return new g(a.contents,a.keys,a.overrides,void 0,d)}}e.$Do=i;function n(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const a=new Set,d=new Map;for(const p of f)p.keys.forEach(v=>a.add(v)),p.overrides.forEach(([v,y])=>{const h=(0,A.$xc)(d,v,new Set);y.forEach(E=>h.add(E))});const $=[];return d.forEach((p,v)=>$.push([v,[...p.values()]])),{keys:[...a.values()],overrides:$}}class c{constructor(a,d,$,p,v){this.change=a,this.f=d,this.g=$,this.h=p,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of a.keys)this.affectedKeys.add(y);for(const[,y]of a.overrides)for(const h of y)this.affectedKeys.add(h);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,d){const $=this.a+a,p=this.d.indexOf($);if(p<0)return!1;const v=p+$.length;if(v>=this.d.length)return!1;const y=this.d.charCodeAt(v);if(y!==this.b&&y!==this.c)return!1;if(d){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,d,this.f?.workspace):void 0,E=this.g.getValue(a,d,this.h);return!b.$9n(h,E)}return!0}}e.$Fo=c;function u(f,a){const{added:d,removed:$,updated:p}=t(a?.rawConfiguration,f?.rawConfiguration),v=[],y=f?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const E=h.filter(k=>!y.includes(k));for(const k of E)v.push([k,a.getKeysForOverrideIdentifier(k)])}if(f){const E=y.filter(k=>!h.includes(k));for(const k of E)v.push([k,f.getKeysForOverrideIdentifier(k)])}if(a&&f){for(const E of y)if(h.includes(E)){const k=t({contents:f.getOverrideValue(void 0,E)||{},keys:f.getKeysForOverrideIdentifier(E)},{contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)});v.push([E,[...k.added,...k.removed,...k.updated]])}}return{added:d,removed:$,updated:p,overrides:v}}function t(f,a){const d=f?a?f.keys.filter(v=>a.keys.indexOf(v)===-1):[...f.keys]:[],$=a?f?a.keys.filter(v=>f.keys.indexOf(v)===-1):[...a.keys]:[],p=[];if(f&&a){for(const v of a.keys)if(f.keys.indexOf(v)!==-1){const y=(0,N.$aj)(a.contents,v),h=(0,N.$aj)(f.contents,v);b.$9n(y,h)||p.push(v)}}return{added:d,removed:$,updated:p}}}),define(Se[104],Ie([1,0,14,3]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.RemoteAuthorityResolverErrorCode=e.$Ll=e.$Kl=e.RemoteConnectionType=e.$Jl=void 0,e.$Nl=D,e.$Jl=(0,O.$yi)("remoteAuthorityResolverService");var M;(function(N){N[N.WebSocket=0]="WebSocket",N[N.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class T{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kl=T;class A{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ll=A;var b;(function(N){N.Unknown="Unknown",N.NotAvailable="NotAvailable",N.TemporarilyNotAvailable="TemporarilyNotAvailable",N.NoResolverFound="NoResolverFound",N.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class m extends C.$bb{static isNotAvailable(S){return S instanceof m&&S._code===b.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof m&&S._code===b.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof m&&S._code===b.NoResolverFound}static isInvalidAuthority(S){return S instanceof m&&S._code===b.InvalidAuthority}static isHandled(S){return S instanceof m&&S.isHandled}constructor(S,l=b.Unknown,w){super(S),this._message=S,this._code=l,this._detail=w,this.isHandled=l===b.NotAvailable&&w===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Ml=m;function D(N){const S=N.indexOf("+");return S===-1?N:N.substring(0,S)}}),define(Se[58],Ie([1,0,16]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=O,e.$Km=M,e.$Lm=T,e.$Mm=A;function O(m){return m.scheme===C.Schemas.vscodeRemote?m.authority:void 0}function M(m){if(!m)return;const D=m.indexOf("+");return D<0?m:m.substr(0,D)}function T(m){const{host:D,port:N}=b(m);if(typeof N>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:D,port:N}}function A(m,D){let{host:N,port:S}=b(m);return typeof S>"u"&&(S=D),{host:N,port:S}}function b(m){const D=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const N=m.match(/^(\[[0-9a-z:]+\])$/);if(N)return{host:N[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(Se[21],Ie([1,0,13,3,58]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=T,e.$Wm=S,e.$Xm=l,e.$Ym=w,e.$Zm=g,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function T(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var b;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class m{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,o){if(typeof s>"u"||s===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof s=="string"||typeof o=="string"){const i=typeof s=="string"?s:s.value,n=typeof o=="string"?o:o.value;return C.$zf(i,n)}return s._lower===o._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.$Tm=m;class D{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const o of s)this.add(o)}add(s){this.c.add(m.toKey(s))}delete(s){return this.c.delete(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}}e.$Um=D;class N{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(m.toKey(s))}get(s){return this.c.get(m.toKey(s))}has(s){return this.c.has(m.toKey(s))}set(s,o){this.c.set(m.toKey(s),o)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=N;function S(r){return l(r)}function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function w(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function g(r,s){if(s){const o=`onResolveRemoteAuthority:${(0,M.$Km)(s)}`;return!!r.activationEvents?.includes(o)}return!1}e.$1m=(0,O.$yi)("IBuiltinExtensionsScannerService")}),define(Se[105],Ie([1,0,14,21]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qG=e.$pG=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(A,b){this.a.set(A,b)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const b=Object.create(null);for(const m of A){const D=this.readActivationEvents(m);D.length>0&&(b[O.$Tm.toKey(m.identifier)]=D)}return b}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const b=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let m=0;m<b.length;m++)b[m]==="onUri"&&(b[m]=`onUri:${O.$Tm.toKey(A.identifier)}`);if(!A.contributes)return b;for(const m in A.contributes){const D=this.a.get(m);if(!D)continue;const N=A.contributes[m],S=Array.isArray(N)?N:[N];try{D(S,b)}catch(l){(0,C.$1)(l)}}return b}}e.$pG=M,e.$qG=new M}),define(Se[204],Ie([1,0,22,14,6,168,51,3,12,29]),function(le,e,C,O,M,T,A,b,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0,e.$Tp=l,e.$Up=w,e.$Vp=g,e.$Wp=r,e.$Xp=s,e.$Yp=o,e.$Rp=(0,b.$yi)("requestService");class N{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class S extends M.$Uc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,T.localize)(0,null),when:m.$kk.isEqualTo((0,m.$hk)(m.LogLevel.Trace)).serialize()})}async c(u,t,f){const a=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${a} - begin`,t.type,new N(t.headers??{}));try{const d=await f();return this.a.trace(`${a} - end`,t.type,d.res.statusCode,d.res.headers),d}catch(d){throw this.a.error(`${a} - error`,t.type,(0,O.$0)(d)),d}}}e.$Sp=S;function l(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function w(c){return c.res.statusCode===204}async function g(c){return w(c)?null:(await(0,C.$Te)(c.stream)).toString()}async function r(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);return g(c)}async function s(c){if(!l(c))throw new Error("Server returned "+c.res.statusCode);if(w(c))return null;const t=(await(0,C.$Te)(c.stream)).toString();try{return JSON.parse(t)}catch(f){throw f.message+=`:
`+t,f}}function o(c){n(c)}let i;function n(c){const u=D.$fo.as(A.$ko.Configuration),t=i;i={id:"http",order:15,title:(0,T.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(6,null),(0,T.localize)(7,null),(0,T.localize)(8,null),(0,T.localize)(9,null)],default:"override",description:(0,T.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[i],remove:t?[t]:[]})}n(1)}),define(Se[205],Ie([1,0,23,75,33]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=A,e.$ip=b;function T(m){if(C.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function A(m,D,N,S,l,w,g,r,s){const o=Object.create(null);o["common.machineId"]=w,o["common.sqmId"]=g,o.sessionID=(0,M.$Ug)()+Date.now(),o.commitHash=S,o.version=l,o["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$h)(C.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=N,o["common.product"]=s||"desktop",r&&(o["common.msftInternal"]=r);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),C.$l&&(o["common.snap"]="true");const c=T(D);return c&&(o["common.platformDetail"]=c),o}function b(m){const D=O.env.USERDNSDOMAIN;if(!D)return!1;const N=D.toLowerCase();return m.some(S=>N===S)}}),define(Se[206],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,C.$yi)("telemetryService"),e.$5l=(0,C.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var O;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var M;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(Se[59],Ie([1,0,26,15,58,205,206]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$qp=N,e.$rp=S,e.$sp=l,e.$tp=w,e.$up=r,e.$vp=o,e.$wp=i,e.$xp=u;class b{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$jp=b;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$kp=m,e.$lp=new m;class D{async publicLog(f,a,d){}async publicLogError(f,a,d){}}e.$mp=D,e.$np="telemetry",e.$op="extensionTelemetryLog",e.$pp={log:()=>null,flush:()=>Promise.resolve(null)};function N(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function S(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function l(t){const f=t.getValue(A.$_l),a=t.getValue(A.$am);if(t.getValue(A.$bm)===!1||a===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const f={},a={},d={};s(t,d);for(let $ in d){$=$.length>150?$.substr($.length-149):$;const p=d[$];typeof p=="number"?a[$]=p:typeof p=="boolean"?a[$]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${p.length}`),f[$]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(f[$]=p)}return{properties:f,measurements:a}}const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const f=(0,M.$Km)(t);return g.has(f)?f:"other"}function s(t,f,a=0,d){if(t)for(const $ of Object.getOwnPropertyNames(t)){const p=t[$],v=d?d+$:$;Array.isArray(p)?f[v]=(0,C.$0n)(p):p instanceof Date?f[v]=p.toISOString():(0,O.$ag)(p)?a<2?s(p,f,a+1,v+"."):f[v]=(0,C.$0n)(p):f[v]=p}}function o(t,f){const a=t.msftInternalDomains||[],d=f.getValue("telemetry.internalTesting");return(0,T.$ip)(a)||d}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const d=[];for(const y of f)for(;;){const h=y.exec(t);if(!h)break;d.push([h.index,y.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(a="";;){const y=p.exec(t);if(!y)break;const h=d.some(([E,k])=>y.index<k&&E<p.lastIndex);!$.test(y[0])&&!h&&(a+=t.substring(v,y.index)+"<REDACTED: user-file-path>",v=p.lastIndex)}return v<t.length&&(a+=t.substr(v)),a}function c(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of f)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function u(t,f){return(0,C.$7n)(t,a=>{if(a instanceof b||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let d=a.replaceAll("%20"," ");d=n(d,f);for(const $ of f)d=d.replace($,"");return d=c(d),d}})}}),define(Se[207],Ie([1,0,13,100,21,23,2,14,75,59]),function(le,e,C,O,M,T,A,b,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$zp=void 0,e.$yp=N,e.$Ap=g,e.$Bp=r,e.$Cp=s,e.$Dp=o,e.$Ep=i,e.$Fp=n,e.$Gp=c,e.$Ip=u,e.$Jp=f;function N(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,C.$uf)(a.id,d.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const $=d.manifest?d.manifest.version:d.version,p=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,$,p)}static parse(d){const $=S.exec(d);return $&&$[1]&&$[2]?new l({id:$[1]},$[2],$[4]||void 0):null}constructor(d,$,p="undefined"){this.version=$,this.targetPlatform=p,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?N(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$zp=l;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(a){const d=w.exec(a);return d&&d[1]?[s(d[1]),d[2]]:[s(a),void 0]}function r(a,d){return`${a}.${d}`}function s(a){return a.toLowerCase()}function o(a,d){return s(r(a??M.$Pm,d))}function i(a,d){const $=[],p=v=>{for(const y of $)if(y.some(h=>N(d(h),d(v))))return y;return null};for(const v of a){const y=p(v);y?y.push(v):$.push([v])}return $}function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new D.$jp(a.identifier.id),name:new D.$jp(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Hp=new M.$Tm("pprice.better-merge");function u(a,d){const $=[],p=d.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const v=p.shift();if(v&&$.every(y=>!N(y.identifier,{id:v}))){const y=a.filter(h=>N(h.identifier,{id:v}));y.length===1&&($.push(y[0]),p.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function t(a,d){if(!T.$k)return!1;let $;try{$=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){d.debug("Error while getting the os-release file.",(0,b.$0)(v))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(a,d){const $=await t(a,d),p=(0,O.$6o)($?"alpine":T.$u,m.$ec);return d.debug("ComputeTargetPlatform:",p),p}}),define(Se[208],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=C,e.$qs=O,e.$rs=M,e.$ss=T,e.$ts=A,e.$us=b;function C(m){return[...m.entries()]}function O(m){return m?[...m.entries()]:[]}function M(m){return new Map(m)}function T(m){return new Map(m??[])}function A(m){return Array.from(m.entries()).map(D=>[D[0],C(D[1].map),O(D[1].descriptionMap)])}function b(m){return new Map(m.map(D=>[D[0],{map:M(D[1]),descriptionMap:T(D[2])}]))}}),define(Se[209],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_vb=void 0;class C{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,T,A=5){const b=T(m=>{const D=typeof m=="string"?m:m.data;let N=this.a.get(M);if(N){N.data.push(D);return}const S=setTimeout(()=>this.flushBuffer(M),A);N={data:[D],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(M),b.dispose()}},this.a.set(M,N)});return b}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const T=this.a.get(M);T&&(this.a.delete(M),this.b(M,T.data.join("")))}}e.$_vb=C}),define(Se[210],Ie([1,0,11,92,312,36,5,15,2,169,74,29]),function(le,e,C,O,M,T,A,b,m,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qx=e.$px=e.$ox=e.$nx=e.$mx=e.$lx=e.IconFontDefinition=e.IconContribution=e.$ix=void 0,e.$jx=s,e.$kx=o,e.$ix={IconContribution:"base.contributions.icons"};var l;(function(u){function t(f,a){let d=f.defaults;for(;T.ThemeIcon.isThemeIcon(d);){const $=r.getIcon(d.id);if(!$)return;d=$.defaults}return d}u.getDefinition=t})(l||(e.IconContribution=l={}));var w;(function(u){function t(a){return{weight:a.weight,style:a.style,src:a.src.map(d=>({format:d.format,location:d.location.toString()}))}}u.toJSONObject=t;function f(a){const d=$=>(0,b.$$f)($)?$:void 0;if(a&&Array.isArray(a.src)&&a.src.every($=>(0,b.$$f)($.format)&&(0,b.$$f)($.location)))return{weight:d(a.weight),style:d(a.style),src:a.src.map($=>({format:$.format,location:m.URI.parse($.location)}))}}u.fromJSONObject=f})(w||(e.IconFontDefinition=w={}));class g{constructor(){this.a=new A.$fe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${T.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,a,d){const $=this.b[t];if($){if(a&&!$.description){$.description=a,this.d.properties[t].markdownDescription=`${a} $(${t})`;const y=this.e.enum.indexOf(t);y!==-1&&(this.e.enumDescriptions[y]=a),this.a.fire()}return $}const p={id:t,description:a,defaults:f,deprecationMessage:d};this.b[t]=p;const v={$ref:"#/definitions/icons"};return d&&(v.deprecationMessage=d),a&&(v.markdownDescription=`${a}: $(${t})`),this.d.properties[t]=v,this.e.enum.push(t),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const a=this.f[t];return a||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=($,p)=>$.id.localeCompare(p.id),f=$=>{for(;T.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map($=>this.b[$]);for(const $ of d.filter(p=>!!p.description).sort(t))a.push(`|<i class="${f($)}"></i>|${$.id}|${T.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const $ of d.filter(p=>!T.ThemeIcon.isThemeIcon(p.defaults)).sort(t))a.push(`|<i class="${f($)}"></i>|${$.id}|`);return a.join(`
`)}}const r=new g;S.$fo.add(e.$ix.IconContribution,r);function s(u,t,f,a){return r.registerIcon(u,t,f,a)}function o(){return r}function i(){const u=(0,M.$Tj)();for(const t in u){const f="\\"+u[t].toString(16);r.registerIcon(t,{fontCharacter:f})}}i(),e.$lx="vscode://schemas/icons";const n=S.$fo.as(N.$go.JSONContribution);n.registerSchema(e.$lx,r.getIconSchema());const c=new C.$Kh(()=>n.notifySchemaChanged(e.$lx),200);r.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$mx=s("widget-close",O.$Xj.close,(0,D.localize)(2,null)),e.$nx=s("goto-previous-location",O.$Xj.arrowUp,(0,D.localize)(3,null)),e.$ox=s("goto-next-location",O.$Xj.arrowDown,(0,D.localize)(4,null)),e.$px=T.ThemeIcon.modify(O.$Xj.sync,"spin"),e.$qx=T.ThemeIcon.modify(O.$Xj.loading,"spin")}),define(Se[211],Ie([1,0,5,2,50,3,12]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xw=e.$ww=e.$tw=e.$rw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$nw=e.$mw=void 0,e.$ow=D,e.$pw=S,e.$qw=l,e.$sw=w,e.$uw=g,e.$vw=r,e.$mw=(0,T.$yi)("tunnelService"),e.$nw=(0,T.$yi)("sharedTunnelsService");var b;(function(i){i.Http="http",i.Https="https"})(b||(e.TunnelProtocol=b={}));var m;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(m||(e.TunnelPrivacyId=m={}));function D(i){return!!i.forwardPort}var N;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(N||(e.ProvidedOnAutoForward=N={}));function S(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function l(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const c of n){const u=c.split("=")[1];if(/^https?:/.exec(u)){const t=S(O.URI.parse(u));if(t)return t}}}e.$rw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(i){return e.$rw.indexOf(i)>=0}e.$tw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(i){return e.$tw.indexOf(i)>=0}function r(i,n,c,u){if(c===1)return!1;if(c===2&&g(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class s{constructor(n,c,u){this.remoteAddress=n,this.localAddress=c,this.b=u,this.a=new C.$fe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$ww=s;let o=class{constructor(n,c){this.k=n,this.l=c,this.a=new C.$fe,this.onTunnelOpened=this.a.event,this.b=new C.$fe,this.onTunnelClosed=this.b.event,this.c=new C.$fe,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],c=Array.from(this.e.values());for(const u of c){const t=Array.from(u.values());for(const f of t){const a=await f.value;a&&typeof a!="string"&&n.push(a)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:c}of n.values())await c.then(u=>typeof u!="string"?u?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,c,u,t,f){this.q(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:u,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(g(n)||w(n))&&(n=e.$rw[0]);const u=this.s(n,c);if(u)return++u.refcount,u.value}openTunnel(n,c,u,t,f,a=!1,d,$){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${u} on local port ${f}.`);const p=this.f??n;if(!p)return;if(c||(c="localhost"),t||(t=this.m),this.f&&this.j.has(u)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.t(p,c,u,t,f,a,d,$);return v?v.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,u),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,u);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==u)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),d&&y.privacy!==d&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(h),h}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this.e.get(n.tunnelRemoteHost);if(c){const u=c.get(n.tunnelRemotePort);u&&(u.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,u))}}}}async p(n,c,u){if(u.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const t=u.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(c),t}}async closeTunnel(n,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const u=this.e.get(n);if(u&&u.has(c)){const t=u.get(c);t.refcount=0,await this.p(n,c,t)}}q(n,c,u){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(c,{refcount:1,value:u})}async r(n,c){const u=this.e.get(n);if(u){const t=u.get(c),f=t?await t.value:void 0;(!f||typeof f=="string")&&u.delete(c),u.size===0&&this.e.delete(n)}}s(n,c){const u=[n];w(n)?(u.push(...e.$rw),u.push(...e.$tw)):g(n)&&u.push(...e.$tw);const t=u.map(f=>this.e.get(f));for(const f of t){const a=f?.get(c);if(a)return a}}canTunnel(n){return!!S(n)}u(n,c,u,t,f,a,d){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${u} on local port ${t}.`);const $=u;this.j.add($);const p=t===void 0?u:t,v={elevationRequired:f?this.isPortPrivileged(p):!1},y={remoteAddress:{host:c,port:u},localAddressPort:t,privacy:a,public:a?a!==m.Private:void 0,protocol:d},h=n.forwardPort(y,v);return h?(this.q(c,u,h),h.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete($)})):this.j.delete($),h}};e.$xw=o,e.$xw=o=Je([We(0,A.$5j),We(1,M.$5i)],o)}),define(Se[212],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,C.$yi)("IUriIdentityService")}),define(Se[213],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$yw=void 0,e.$yw=(0,C.$yi)("editSessionIdentityService");var O;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Se[214],Ie([1,0,16]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=O,e.$TL=M,e.$UL=T,e.$VL=A,e.$WL=b;function O(m){return m.scheme!==C.Schemas.file&&m.scheme!==C.Schemas.vscodeRemote}function M(m){if(m.folders.length)return m.folders.every(D=>O(D.uri))?m.folders[0].uri:void 0;if(m.configuration&&O(m.configuration))return m.configuration}function T(m){return M(m)?.scheme}function A(m){return M(m)?.authority}function b(m){return M(m)!==void 0}}),define(Se[45],Ie([1,0,171,19,54,24,2,3,16]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=D,e.$Ji=N,e.$Mi=S,e.$Ni=l,e.$Oi=w,e.$Pi=r,e.$Qi=s,e.$Ti=n,e.$Yi=c,e.$Zi=u,e.$2i=t,e.$3i=f,e.$4i=a,e.$Hi=(0,b.$yi)("contextService");function D(d){const $=d;return typeof $?.id=="string"&&A.URI.isUri($.uri)}function N(d){return typeof d?.id=="string"&&!D(d)&&!l(d)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function S(d,$){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,O.$nc)(d)}:$?e.$Ki:e.$Li;const p=d;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}function l(d){const $=d;return typeof $?.id=="string"&&A.URI.isUri($.configPath)}function w(d){const $=d;if($?.uri)return{id:$.id,uri:A.URI.revive($.uri)};const p=d;if(p?.configPath)return{id:p.id,configPath:A.URI.revive(p.configPath)};if(d?.id)return{id:d.id}}var g;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function r(d){const $=d;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function s(d){const $=d;return!!($&&typeof $=="object"&&A.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class o{constructor($,p,v,y,h){this.h=$,this.j=v,this.k=y,this.l=h,this.c=M.$Ei.forUris(this.l,()=>!0),this.folders=p}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=M.$Ei.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=o;class i{constructor($,p){this.raw=p,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,T.$_g)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=i;function n(d){return new i({uri:d,index:0,name:(0,T.$8g)(d)},{uri:d.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,C.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function c(d,$){return T.$3g.isEqualOrParent(d,$.untitledWorkspacesHome)}function u(d){let $;return A.URI.isUri(d)?$=d:$=d.configuration,$?.scheme===m.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(d){return d.id===e.$1i}function f(d,$){return!c(d,$)&&!u(d)}function a(d){return(typeof d=="string"?(0,O.$oc)(d):(0,T.$0g)(d))===e.$Vi}}),define(Se[215],Ie([1,0,73,5,6,24,2,170,99,38,3,12,45,28,212,11,33,13,15]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=c,e.$Fl=u,e.$Gl=t;var n;(function(d){d.Settings="settings",d.Keybindings="keybindings",d.Snippets="snippets",d.Tasks="tasks",d.Extensions="extensions",d.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function c(d){const $=d;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&A.URI.isUri($.location)&&A.URI.isUri($.globalStorageHome)&&A.URI.isUri($.settingsResource)&&A.URI.isUri($.keybindingsResource)&&A.URI.isUri($.tasksResource)&&A.URI.isUri($.snippetsHome)&&A.URI.isUri($.extensionsResource))}e.$El=(0,N.$yi)("IUserDataProfilesService");function u(d,$){return{id:d.id,isDefault:d.isDefault,name:d.name,shortName:d.shortName,icon:d.icon,location:A.URI.revive(d.location).with({scheme:$}),globalStorageHome:A.URI.revive(d.globalStorageHome).with({scheme:$}),settingsResource:A.URI.revive(d.settingsResource).with({scheme:$}),keybindingsResource:A.URI.revive(d.keybindingsResource).with({scheme:$}),tasksResource:A.URI.revive(d.tasksResource).with({scheme:$}),snippetsHome:A.URI.revive(d.snippetsHome).with({scheme:$}),extensionsResource:A.URI.revive(d.extensionsResource).with({scheme:$}),cacheHome:A.URI.revive(d.cacheHome).with({scheme:$}),useDefaultFlags:d.useDefaultFlags,isTransient:d.isTransient}}function t(d,$,p,v,y,h){return{id:d,name:$,location:p,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:h&&y?.useDefaultFlags?.globalState?h.globalStorageHome:(0,T.$_g)(p,"globalStorage"),settingsResource:h&&y?.useDefaultFlags?.settings?h.settingsResource:(0,T.$_g)(p,"settings.json"),keybindingsResource:h&&y?.useDefaultFlags?.keybindings?h.keybindingsResource:(0,T.$_g)(p,"keybindings.json"),tasksResource:h&&y?.useDefaultFlags?.tasks?h.tasksResource:(0,T.$_g)(p,"tasks.json"),snippetsHome:h&&y?.useDefaultFlags?.snippets?h.snippetsHome:(0,T.$_g)(p,"snippets"),extensionsResource:h&&y?.useDefaultFlags?.extensions?h.extensionsResource:(0,T.$_g)(p,"extensions.json"),cacheHome:(0,T.$_g)(v,d),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let f=class extends M.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,p,v,y){super(),this.t=$,this.u=p,this.w=v,this.y=y,this.f=!0,this.h=this.B(new O.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,T.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,T.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),p=[$];if(this.f)try{for(const h of this.O()){if(!h.name||!(0,i.$$f)(h.name)||!h.location){this.y.warn("Skipping the invalid stored profile",h.location||h.name);continue}p.push(t((0,T.$9g)(h.location),h.name,h.location,this.g,{shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags},$))}}catch(h){this.y.error(h)}const v=new w.$Ac,y=new Map;if(p.length)try{const h=this.Q();if(h.workspaces)for(const[E,k]of Object.entries(h.workspaces)){const I=A.URI.parse(E),P=p.find(V=>V.id===k);P&&v.set(I,P)}if(h.emptyWindows)for(const[E,k]of Object.entries(h.emptyWindows)){const I=p.find(P=>P.id===k);I&&y.set(E,I)}}catch(h){this.y.error(h)}this.z={profiles:p,workspaces:v,emptyWindows:y}}return this.z}D(){const $=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const p="Temp",v=new RegExp(`${(0,o.$bf)(p)}\\s(\\d+)`);let y=0;for(const E of this.profiles){const k=v.exec(E.name),I=k?parseInt(k[1]):0;y=I>y?I:y}const h=`${p} ${y+1}`;return this.createProfile((0,C.$mj)((0,s.$Ug)()).toString(16),h,{transient:!0},$)}async createNamedProfile($,p,v){return this.createProfile((0,C.$mj)((0,s.$Ug)()).toString(16),$,p,v)}async createProfile($,p,v,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.F($,p,v);return y&&await this.setProfileForWorkspace(y,h),h}async F($,p,v){if(!(0,i.$$f)(p)||!p)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(p);return y||(y=(async()=>{try{if(this.profiles.find(I=>I.name===p||I.id===$))throw new Error(`Profile with ${p} name already exists`);const E=t($,p,(0,T.$_g)(this.profilesHome,$),this.g,v,this.defaultProfile);await this.u.createFolder(E.location);const k=[];return this.j.fire({profile:E,join(I){k.push(I)}}),await r.Promises.settled(k),this.I([E],[],[]),E}finally{this.r.delete(p)}})(),this.r.set(p,y)),y}async updateProfile($,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(y=>y.id===$.id);if(!v)throw new Error(`Profile '${$.name}' does not exist`);return v=t(v.id,p.name??v.name,v.location,this.g,{shortName:p.shortName??v.shortName,icon:p.icon===null?void 0:p.icon??v.icon,transient:p.transient??v.isTransient,useDefaultFlags:p.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const p=this.profiles.find(y=>y.id===$.id);if(!p)throw new Error(`Profile '${$.name}' does not exist`);const v=[];this.m.fire({profile:p,join(y){v.push(y)}});try{await Promise.allSettled(v)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])p.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])p.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[p],[]);try{await this.u.del(p.cacheHome,{recursive:!0})}catch(y){(0,D.$jl)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace($,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(y=>y.id===p.id);if(!v)throw new Error(`Profile '${p.name}' does not exist`);this.L($,v)}unsetWorkspace($,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,p)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(p=>p.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,p.resource))).map(p=>this.u.del(p.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(p=>!this.H(p));await Promise.allSettled($.map(p=>this.removeProfile(p)))}getProfileForWorkspace($){const p=this.G($);return A.URI.isUri(p)?this.s.workspaces.get(p)??this.C.workspaces.get(p):this.s.emptyWindows.get(p)??this.C.emptyWindows.get(p)}G($){return(0,l.$Ii)($)?$.uri:(0,l.$Ni)($)?$.configPath:$.id}H($){return!!([...this.s.emptyWindows.values()].some(p=>this.w.extUri.isEqual(p.location,$.location))||[...this.s.workspaces.values()].some(p=>this.w.extUri.isEqual(p.location,$.location))||[...this.C.emptyWindows.values()].some(p=>this.w.extUri.isEqual(p.location,$.location))||[...this.C.workspaces.values()].some(p=>this.w.extUri.isEqual(p.location,$.location)))}I($,p,v){const y=[...this.profiles,...$],h=[];this.s.profiles=[];for(let E of y)E.isDefault||p.some(k=>E.id===k.id)||(E=v.find(k=>E.id===k.id)??E,E.isTransient?this.s.profiles.push(E):h.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(h),this.z=void 0,this.J($,p,v)}J($,p,v){this.h.fire({added:$,removed:p,updated:v,all:this.profiles})}L($,p,v){v=p?.isTransient?!0:v,v||this.L($,void 0,!0);const y=this.G($),h=v?this.s:this.C;A.URI.isUri(y)?(h.workspaces.delete(y),p&&h.workspaces.set(y,p)):(h.emptyWindows.delete(y),p&&h.emptyWindows.set(y,p)),v||this.M()}M(){const $={};for(const[v,y]of this.C.workspaces.entries())$[v.toString()]=y.id;const p={};for(const[v,y]of this.C.emptyWindows.entries())p[v.toString()]=y.id;this.R({workspaces:$,emptyWindows:p}),this.z=void 0}N($){const p={},v=this.D();if($.workspaces)for(const[h,E]of Object.entries($.workspaces)){const k=A.URI.parse(E);p[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}const y={};if($.emptyWindows)for(const[h,E]of Object.entries($.emptyWindows)){const k=A.URI.parse(E);y[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}return{workspaces:p,emptyWindows:y}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Hl=f,e.$Hl=f=Je([We(0,m.$Fi),We(1,D.$5k),We(2,g.$Cl),We(3,S.$5j)],f);class a extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Il=a}),define(Se[216],Ie([1,0,11,5,6,60,15,151,3,215]),function(le,e,C,O,M,T,A,b,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$7p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$5p=e.$4p=e.$3p=void 0,e.$6p=w,e.$8p=r,e.$0p=o,e.$3p="__$__isNewStorageMarker",e.$4p="__$__targetStorageMarker",e.$5p=(0,m.$yi)("storageService");var N;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(N||(e.WillSaveStateReason=N={}));var S;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var l;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(l||(e.StorageTarget=l={}));function w(i){const n=i.get(e.$4p);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class g extends M.$Uc{static{this.a=60*1e3}constructor(n={flushInterval:g.a}){super(),this.m=n,this.b=this.B(new O.$ie),this.c=this.B(new O.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new C.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new M.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,c,u){return O.Event.filter(this.b.event,t=>t.scope===n&&(c===void 0||t.key===c),u)}n(){this.j.value=(0,C.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,M.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.O()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,c){const{key:u,external:t}=c;if(u===e.$4p){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:u,target:this.J(n)[u],external:t})}w(n){this.f.fire({reason:n})}get(n,c,u){return this.P(c)?.get(n,u)}getBoolean(n,c,u){return this.P(c)?.getBoolean(n,u)}getNumber(n,c,u){return this.P(c)?.getNumber(n,u)}getObject(n,c,u){return this.P(c)?.getObject(n,u)}storeAll(n,c){this.y(()=>{for(const u of n)this.store(u.key,u.value,u.scope,u.target,c)})}store(n,c,u,t,f=!1){if((0,A.$hg)(c)){this.remove(n,u,f);return}this.y(()=>{this.z(n,u,t),this.P(u)?.set(n,c,f)})}remove(n,c,u=!1){this.y(()=>{this.z(n,c,void 0),this.P(c)?.delete(n,u)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,c){const u=[],t=this.J(n);for(const f of Object.keys(t))t[f]===c&&u.push(f);return u}z(n,c,u,t=!1){const f=this.J(c);typeof u=="number"?f[n]!==u&&(f[n]=u,this.P(c)?.set(e.$4p,JSON.stringify(f),t)):typeof f[n]=="number"&&(delete f[n],this.P(c)?.set(e.$4p,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const c=this.P(n);return c?w(c):Object.create(null)}isNew(n){return this.getBoolean(e.$3p,n)===!0}async flush(n=N.NONE){this.f.fire({reason:n});const c=this.P(-1),u=this.P(0),t=this.P(1);switch(n){case N.NONE:await C.Promises.settled([c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case N.SHUTDOWN:await C.Promises.settled([c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return o(n,c,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,c){return this.w(N.NONE),(0,D.$Dl)(n)?this.R(n,c):this.S(n,c)}M(n,c){return!(n.id===c.id||r(c)&&r(n))}N(n,c,u){this.y(()=>{const t=new Set;for(const[f,a]of n)t.add(f),c.get(f)!==a&&this.u(u,{key:f,external:!0});for(const[f]of c.items)t.has(f)||this.u(u,{key:f,external:!0})})}}e.$7p=g;function r(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class s extends g{constructor(){super(),this.U=this.B(new b.$1p(new b.$2p,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$1p(new b.$2p,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$1p(new b.$2p,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$9p=s;async function o(i,n,c,u,t,f){const a=I=>{try{return JSON.parse(I)}catch{return I}},d=new Map,$=new Map;i.forEach((I,P)=>{d.set(P,I),$.set(P,a(I))});const p=new Map,v=new Map;n.forEach((I,P)=>{p.set(P,I),v.set(P,a(I))});const y=new Map,h=new Map;c.forEach((I,P)=>{y.set(P,I),h.set(P,a(I))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const E=[];if(d.forEach((I,P)=>{E.push({key:P,value:I})}),console.table(E),console.groupEnd(),console.log($),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const I=[];p.forEach((P,V)=>{I.push({key:V,value:P})}),console.table(I),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${f})`);const k=[];y.forEach((I,P)=>{k.push({key:P,value:I})}),console.table(k),console.groupEnd(),console.log(h)}}),define(Se[76],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1lc=void 0;class C{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const T=this.c++;return this.b.set(T,M),this.e(),T}get(M,T){return this.b.has(M)?this.b.get(M)[T]:void 0}delete(M){this.b.delete(M),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$1lc=C}),define(Se[46],Ie([1,0,16,24,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=e.$6lc=void 0;class T{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new O.$1g(b=>{const m=this.b.get(b.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(b,m){m===null?this.b.delete(b.scheme):this.b.set(b.scheme,m)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$6lc=T,e.$7lc=(0,M.$yi)("IExtHostFileSystemInfo")}),define(Se[27],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=void 0,e.$4O=(0,C.$yi)("IExtHostInitDataService")}),define(Se[217],Ie([1,0,176,12,201,27]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=void 0;let A=class extends M.$bQ{constructor(m,D,N){const S=N.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",l=N.remote.isRemote?(0,C.localize)(0,null):m?(0,C.localize)(1,null):(0,C.localize)(2,null);super(D.createLogger(S,{name:l}))}};e.$aoc=A,e.$aoc=A=Je([We(1,O.$6j),We(2,T.$4O)],A)}),define(Se[218],Ie([1,0,11]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=e.$Lmc=void 0;class O{constructor(A,b,m){this.h=new Map,this.a=A,this.b=b,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new C.$Kh(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of D.values())N.complete()}catch(N){for(const S of D.values())S.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,b){let m=this.f[A];return typeof m>"u"&&(m=b),m}update(A,b){this.f[A]=b;const m=this.h.get(A);if(m!==void 0)return m.p;const D=new C.$Vh;return this.h.set(A,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.$Lmc=O;class M extends O{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,b){super(A.identifier.value,!0,b),this.j=A}}e.$Mmc=M}),define(Se[219],Ie([1,0,5,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=void 0;class M{constructor(A){this.c=A,this.a=new C.$fe,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$fe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,b,m,D){const S=this.c.getNotebookDocument(O.URI.revive(A)).acceptModelChanged(b.value,m,D);this.b.fire(S)}$acceptDirtyStateChanged(A,b){this.c.getNotebookDocument(O.URI.revive(A)).acceptDirty(b)}$acceptModelSaved(A){const b=this.c.getNotebookDocument(O.URI.revive(A));this.a.fire(b.apiNotebook)}}e.$Anc=M}),define(Se[17],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OO=e.$NO=void 0,e.$NO=(0,C.$yi)("IExtHostRpcService");class O{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$OO=O}),define(Se[220],Ie([1,0,21,5]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;class M{#e;constructor(A,b){this.b=new O.$fe,this.onDidChange=this.b.event,this.a=C.$Tm.toKey(A.identifier),this.#e=b,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(A){return this.#e.get(this.a,A)}store(A,b){return this.#e.store(this.a,A,b)}delete(A){return this.#e.delete(this.a,A)}}e.$Vmc=M}),define(Se[61],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=e.$jmc=void 0,e.$jmc=(0,C.$yi)("IURITransformerService");class O{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$kmc=O}),define(Se[221],Ie([1,0,22]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$rb=M,e.$_rb=A;class O{constructor(){this.buffers=[]}add(m){let D=this.buffers.indexOf(m);return D<0&&(D=this.buffers.length,this.buffers.push(m)),D}}function M(b,m){if(m.serializeBuffersForPostMessage){const D=new O,S=JSON.stringify(b,(w,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:D.add(g)};if(ArrayBuffer.isView(g)){const r=T(g);if(r)return{$$vscode_array_buffer_reference$$:!0,index:D.add(g.buffer),view:{type:r,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),l=D.buffers.map(w=>{const g=new Uint8Array(w);return C.$He.wrap(g)});return{message:S,buffers:l}}else return{message:JSON.stringify(b),buffers:[]}}function T(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(b,m){const D=m.map(l=>{const w=new ArrayBuffer(l.byteLength);return new Uint8Array(w).set(l.buffer),w}),N=m.length?(l,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const g=w,{index:r}=g,s=D[r];if(g.view)switch(g.view.type){case 1:return new Int8Array(s,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return w}:void 0;return{message:JSON.parse(b,N),arrayBuffers:D}}}),define(Se[106],Ie([1,0,185,15,2,6,3,29,38,16,44,145,32]),function(le,e,C,O,M,T,A,b,m,D,N,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$VF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$MF=e.EditorInputCapabilities=e.$LF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=void 0,e.$CF=r,e.$DF=s,e.$EF=o,e.$FF=i,e.$GF=n,e.$HF=c,e.$IF=u,e.$JF=t,e.$KF=f,e.$NF=y,e.$OF=E,e.$PF=k,e.$QF=I,e.$RF=P,e.$SF=V,e.$TF=W,e.$UF=de,e.$WF=ge,e.$XF=Ce,e.$YF=se,e.$ZF=Oe,e.$xF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$yF={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$zF="workbench.editor.sidebysideEditor",e.$AF="workbench.editors.textDiffEditor",e.$BF="workbench.editors.binaryResourceDiffEditor";var w;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var g;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function r(ne){const j=ne;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}function s(ne){const j=ne;return!!j&&typeof j.getScrollPosition=="function"&&typeof j.setScrollPosition=="function"&&!!j.onDidChangeScroll}function o(ne,j,x){for(const ve of x.visibleEditorPanes)if(ve.group.id===j&&ne.matches(ve.input))return ve.getViewState()}function i(ne){if(y(ne))return!1;const j=ne;return M.URI.isUri(j?.resource)}function n(ne){if(y(ne))return!1;const j=ne;return j?.original!==void 0&&j.modified!==void 0}function c(ne){if(y(ne))return!1;const j=ne;return!j||j.resources&&!Array.isArray(j.resources)?!1:!!j.resources||!!j.multiDiffSource}function u(ne){if(y(ne)||n(ne))return!1;const j=ne;return j?.primary!==void 0&&j.secondary!==void 0}function t(ne){if(y(ne))return!1;const j=ne;return j?j.resource===void 0||j.resource.scheme===D.Schemas.untitled||j.forceUntitled===!0:!1}function f(ne){if(y(ne))return!1;const j=ne;return M.URI.isUri(j?.base?.resource)&&M.URI.isUri(j?.input1?.resource)&&M.URI.isUri(j?.input2?.resource)&&M.URI.isUri(j?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var d;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class ${constructor(){this.a=new Map}registerSource(j,x){let ve=this.a.get(j);return ve||(ve={source:j,label:x},this.a.set(j,ve)),ve.source}getSourceLabel(j){return this.a.get(j)?.label??j}}e.$LF=new $;var p;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(p||(e.EditorInputCapabilities=p={}));class v extends T.$Uc{}e.$MF=v;function y(ne){return ne instanceof v}function h(ne){const j=ne;return M.URI.isUri(j?.preferredResource)}function E(ne){const j=ne;return y(j?.primary)&&y(j?.secondary)}function k(ne){const j=ne;return y(j?.modified)&&y(j?.original)}function I(ne,j,x,ve,Le){return Oe(ve,[(0,S.$ij)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const ke={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(j,ke)}}),(0,S.$ij)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>Le.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function P(ne){return y(ne?.editor)}function V(ne){const j=ne;return P(ne)&&j?.group!==void 0}function W(ne){const j=ne;return typeof j?.groupId=="number"&&y(j.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var R;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var z;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class G{getOriginalUri(j,x){if(!j)return;if(f(j))return e.$VF.getOriginalUri(j.result,x);if(x?.supportSideBySide){const{primary:Le,secondary:ke}=this.a(j);if(Le&&ke){if(x?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(Le,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getOriginalUri(Le,{filterByScheme:x.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:x.filterByScheme});j=x.supportSideBySide===z.PRIMARY?Le:ke}}if(n(j)||c(j)||u(j)||f(j))return;const ve=h(j)?j.preferredResource:j.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}a(j){return E(j)||u(j)?{primary:j.primary,secondary:j.secondary}:k(j)||n(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,x){if(!j)return;if(f(j))return e.$VF.getCanonicalUri(j.result,x);if(x?.supportSideBySide){const{primary:Le,secondary:ke}=this.a(j);if(Le&&ke){if(x?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(Le,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getCanonicalUri(Le,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme});j=x.supportSideBySide===z.PRIMARY?Le:ke}}if(n(j)||c(j)||u(j)||f(j))return;const ve=j.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}b(j,x){if(Array.isArray(x)){if(x.some(ve=>j.scheme===ve))return j}else if(x===j.scheme)return j}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function de(ne,j,x,ve){if(!ne.isSticky(j))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$VF=new G;var ye;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ye||(e.CloseDirection=ye={}));class De{constructor(){this.c=new Map,this.d=new Map}start(j){const x=this.a=j.get(A.$xi);for(const[ve,Le]of this.c)this.e(ve,Le,x);this.c.clear()}e(j,x,ve){const Le=ve.createInstance(x);this.d.set(j,Le)}registerFileEditorFactory(j){if(this.b)throw new Error("Can only register one file editor factory.");this.b=j}getFileEditorFactory(){return(0,O.$jg)(this.b)}registerEditorSerializer(j,x){if(this.c.has(j)||this.d.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.a?this.e(j,x,this.a):this.c.set(j,x),(0,T.$Sc)(()=>{this.c.delete(j),this.d.delete(j)})}getEditorSerializer(j){return this.d.get(typeof j=="string"?j:j.typeId)}}b.$fo.add(e.$xF.EditorFactory,new De);async function ge(ne,j,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async ve=>{const Le=M.URI.revive(ve.fileUri);if(!Le){x.info("Cannot resolve the path because it is not valid.",ve);return}if(!await j.canHandleResource(Le)){x.info("Cannot resolve the path because it cannot be handled",ve);return}let be=ve.exists,me=ve.type;if(typeof be!="boolean"||typeof me!="number")try{me=(await j.stat(Le)).isDirectory?m.FileType.Directory:m.FileType.Unknown,be=!0}catch(Y){x.error(Y),be=!1}if(!be&&ve.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",ve);return}if(me===m.FileType.Directory){x.info("Cannot resolve the path because it is a directory",ve);return}const Q={...ve.options,pinned:!0};return be?{resource:Le,options:Q}:{resource:Le,options:Q,forceUntitled:!0}}))}var ue;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function Ce(ne){const j=ne;if(!j)return!1;const x=j;if(x.modified)return Ce(x.modified);const ve=j;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function se(ne){return(0,N.$kj)(ne)}function Oe(ne,j,x){const ve=(0,N.$lj)(ne,j);return ve.forceMessage=x?.forceMessage,ve.forceSeverity=x?.forceSeverity,ve.allowDialog=x?.allowDialog,ve}}),define(Se[222],Ie([1,0,5,186,3,6,28,29,26,92,210]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=e.$7F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$6F=e.ViewContentGroups=e.$4F=e.ViewContainerLocation=e.Extensions=e.$3F=e.$2F=e.$1F=void 0,e.$5F=w,e.$1F="views",e.$2F=(0,O.localize)(0,null),e.$3F=(0,N.$jx)("default-view-icon",D.$Xj.window,(0,O.localize)(1,null));var S;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var l;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(l||(e.ViewContainerLocation=l={})),e.$4F=[0,1,2];function w(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class g extends T.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$fe),this.onDidRegister=this.c.event,this.f=this.B(new C.$fe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(f,a,d){const $=this.get(f.id);if($)return $;const p=f;return p.openCommandActionDescriptor=d?.doNotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,A.$xc)(this.g,a,[]).push(p),d?.isDefault&&this.h.push(p),this.c.fire({viewContainer:p,viewContainerLocation:a}),p}deregisterViewContainer(f){for(const a of this.g.keys()){const d=this.g.get(a),$=d?.indexOf(f);if($!==-1){d?.splice($,1),d.length===0&&this.g.delete(a),this.f.fire({viewContainer:f,viewContainerLocation:a});return}}}get(f){return this.all.filter(a=>a.id===f)[0]}getViewContainers(f){return[...this.g.get(f)||[]]}getViewContainerLocation(f){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(d=>d?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.h.find(a=>this.getViewContainerLocation(a)===f)}}b.$fo.add(S.ViewContainersRegistry,new g);var r;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(r||(e.ViewContentGroups=r={}));function s(t,f){const a=t.group??r.More,d=f.group??r.More;return a!==d?a.localeCompare(d):(t.order??5)-(f.order??5)}class o extends T.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$fe),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$fe),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$fe),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$fe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(f,a){this.registerViews2([{views:f,viewContainer:a}])}registerViews2(f){f.forEach(({views:a,viewContainer:d})=>this.r(a,d)),this.c.fire(f)}deregisterViews(f,a){const d=this.s(f,a);d.length&&this.f.fire({views:d,viewContainer:a})}moveViews(f,a){for(const d of this.m.keys())if(d!==a){const $=this.s(f,d);$.length&&(this.r($,a),this.g.fire({views:$,from:d,to:a}))}}getViews(f){return this.m.get(f)||[]}getView(f){for(const a of this.j){const d=(this.m.get(a)||[]).filter($=>$.id===f)[0];if(d)return d}return null}getViewContainer(f){for(const a of this.j)if((this.m.get(a)||[]).filter($=>$.id===f)[0])return a;return null}registerViewWelcomeContent(f,a){return this.n.add(f,a),this.h.fire(f),(0,T.$Sc)(()=>{this.n.delete(f,a),this.h.fire(f)})}registerViewWelcomeContent2(f,a){const d=new Map;for(const[$,p]of a)this.n.add(f,p),d.set($,(0,T.$Sc)(()=>{this.n.delete(f,p),this.h.fire(f)}));return this.h.fire(f),d}getViewWelcomeContent(f){const a=[];return this.n.forEach(f,d=>a.push(d)),a.sort(s)}r(f,a){let d=this.m.get(a);d||(d=[],this.m.set(a,d),this.j.push(a));for(const $ of f){if(this.getView($.id)!==null)throw new Error((0,O.localize)(2,null,$.id));d.push($)}}s(f,a){const d=this.m.get(a);if(!d)return[];const $=[],p=[];for(const v of d)f.includes(v)?$.push(v):p.push(v);return $.length&&(p.length?this.m.set(a,p):(this.m.delete(a),this.j.splice(this.j.indexOf(a),1))),$}}b.$fo.add(S.ViewsRegistry,new o),e.$6F=(0,M.$yi)("viewDescriptorService");var i;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class c{constructor(f,a){this.c=!1,this.d=!1,(0,m.$8n)(this,f),this.d=!!a,this.resolve=async d=>{if(a&&!this.c){const $=await a(d);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}d.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$7F=c;class u extends Error{constructor(f){super((0,O.localize)(3,null,f)),this.name="NoTreeViewError"}static is(f){return f.name==="NoTreeViewError"}}e.$8F=u}),define(Se[223],Ie([1,0,187,31]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=void 0,e.$_F=new O.$Pj("chatSessionResponseVote","",{type:"string",description:(0,C.localize)(0,null)}),e.$aG=new O.$Pj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,C.localize)(1,null)}),e.$bG=new O.$Pj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,C.localize)(2,null)}),e.$cG=new O.$Pj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,C.localize)(3,null)}),e.$dG=new O.$Pj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,C.localize)(4,null)}),e.$eG=new O.$Pj("chatResponse",!1,{type:"boolean",description:(0,C.localize)(5,null)}),e.$fG=new O.$Pj("chatRequest",!1,{type:"boolean",description:(0,C.localize)(6,null)}),e.$gG=new O.$Pj("chatEditApplied",!1,{type:"boolean",description:(0,C.localize)(7,null)}),e.$hG=new O.$Pj("chatInputHasText",!1,{type:"boolean",description:(0,C.localize)(8,null)}),e.$iG=new O.$Pj("chatInputHasFocus",!1,{type:"boolean",description:(0,C.localize)(9,null)}),e.$jG=new O.$Pj("inChatInput",!1,{type:"boolean",description:(0,C.localize)(10,null)}),e.$kG=new O.$Pj("inChat",!1,{type:"boolean",description:(0,C.localize)(11,null)}),e.$lG=new O.$Pj("chatIsEnabled",!1,{type:"boolean",description:(0,C.localize)(12,null)}),e.$mG=new O.$Pj("chatCursorAtTop",!1),e.$nG=new O.$Pj("chatInputHasAgent",!1),e.$oG=new O.$Pj("chatLocation",void 0)}),define(Se[224],Ie([1,0,11,20,5,42,6,132,13,31,3,12,102,204,216,223]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.ChatAgentLocation=void 0,e.$sH=u;var o;(function(t){t.Panel="panel",t.Terminal="terminal",t.Notebook="notebook",t.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(t){function f(a){switch(a){case"panel":return t.Panel;case"terminal":return t.Terminal;case"notebook":return t.Notebook;case"editor":return t.Editor}return t.Panel}t.fromRaw=f}(o||(e.ChatAgentLocation=o={})),e.$nH=(0,N.$yi)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(f){this.f=f,this.b=[],this.d=new M.$fe,this.onDidChangeAgents=this.d.event,this.e=r.$lG.bindTo(this.f)}registerAgent(f,a){if(this.getAgent(f))throw new Error(`Agent already registered: ${JSON.stringify(f)}`);const $=this,p=a.slashCommands;a={...a,get slashCommands(){return p.filter(y=>!y.when||$.f.contextMatchesRules(D.$wj.deserialize(y.when)))}};const v={data:a};return this.b.push(v),(0,A.$Sc)(()=>{this.b=this.b.filter(y=>y!==v),this.d.fire(void 0)})}registerAgentImplementation(f,a){const d=this.g(f);if(!d)throw new Error(`Unknown agent: ${JSON.stringify(f)}`);if(d.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(f)}`);return d.data.isDefault&&this.e.set(!0),d.impl=a,this.d.fire(new n(d.data,a)),(0,A.$Sc)(()=>{d.impl=void 0,this.d.fire(void 0),d.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(f,a){f.isDynamic=!0;const d={data:f,impl:a};return this.b.push(d),this.d.fire(new n(f,a)),(0,A.$Sc)(()=>{this.b=this.b.filter($=>$!==d),this.d.fire(void 0)})}updateAgent(f,a){const d=this.g(f);if(!d?.impl)throw new Error(`No activated agent with id ${JSON.stringify(f)} registered`);d.data.metadata={...d.data.metadata,...a},this.d.fire(new n(d.data,d.impl))}getDefaultAgent(f){return this.getActivatedAgents().find(a=>!!a.isDefault&&a.locations.includes(f))}getContributedDefaultAgent(f){return this.getAgents().find(a=>!!a.isDefault&&a.locations.includes(f))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),f=>!!f.data.metadata.isSecondary)?.data}g(f){return this.b.find(a=>a.data.id===f)}getAgent(f){return this.g(f)?.data}getAgentByFullyQualifiedId(f){return this.b.find(a=>u(a.data)===f)?.data}getAgents(){return this.b.map(f=>f.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(f=>!!f.impl).map(f=>new n(f.data,f.impl))}getAgentsByName(f){return this.getAgents().filter(a=>a.name===f)}async invokeAgent(f,a,d,$,p){const v=this.g(f);if(!v?.impl)throw new Error(`No activated agent with id ${f}`);return await v.impl.invoke(a,d,$,p)}async getFollowups(f,a,d,$,p){const v=this.g(f);if(!v?.impl)throw new Error(`No activated agent with id ${f}`);return v.impl?.provideFollowups?v.impl.provideFollowups(a,d,$,p):[]}};e.$oH=i,e.$oH=i=Je([We(0,D.$Qj)],i);class n{constructor(f,a){this.b=f,this.d=a}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(f,a,d,$){return this.d.invoke(f,a,d,$)}async provideFollowups(f,a,d,$){return this.d.provideFollowups?this.d.provideFollowups(f,a,d,$):[]}provideWelcomeMessage(f,a){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(f,a)}provideSampleQuestions(f,a){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(f,a)}}e.$pH=n,e.$qH=(0,N.$yi)("chatAgentNameService");let c=class{static{s=this}static{this.b="chat.participantNameRegistry"}constructor(f,a,d,$){if(this.g=a,this.h=d,this.i=$,this.e=(0,b.$3d)(this,Object.create(null)),this.f=!1,!f.chatParticipantRegistry)return;this.d=f.chatParticipantRegistry;const p=$.get(s.b,-1);try{this.e.set(JSON.parse(p??"{}"),void 0)}catch{$.remove(s.b,-1)}this.j()}j(){this.f||this.k().catch(f=>this.h.warn("Failed to fetch chat participant registry",f)).then(()=>(0,C.$zh)(5*60*1e3)).then(()=>this.j())}async k(){const f=await this.g.request({type:"GET",url:this.d},O.CancellationToken.None);if(f.res.statusCode!==200)throw new Error("Could not get extensions report.");const a=await(0,w.$Xp)(f);if(!a||a.version!==1)throw new Error("Unexpected chat participant registry response.");const d=a.restrictedChatParticipants;this.e.set(d,void 0),this.i.store(s.b,JSON.stringify(d),-1,1)}getAgentNameRestriction(f){return this.e.map(d=>d[f.name.toLowerCase()]).map(d=>d?d.some($=>(0,m.$zf)($,$.includes(".")?f.extensionId.value:f.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$rH=c,e.$rH=c=s=Je([We(0,l.$lk),We(1,w.$Rp),We(2,S.$5j),We(3,g.$5p)],c);function u(t){return`${t.extensionId.value}.${t.id}`}}),define(Se[225],Ie([1,0,2,30,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZG=e.$YG=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$WG=T,e.$XG=A;function T(D){return!!D&&typeof D=="object"&&"uri"in D&&D.uri instanceof C.URI&&"version"in D&&typeof D.version=="number"&&"ranges"in D&&Array.isArray(D.ranges)&&D.ranges.every(O.$yt.isIRange)}function A(D){return!!D&&typeof D=="object"&&"documents"in D&&Array.isArray(D.documents)&&D.documents.every(T)}var b;(function(D){D[D.Down=0]="Down",D[D.Up=1]="Up"})(b||(e.ChatAgentVoteDirection=b={}));var m;(function(D){D[D.Action=1]="Action",D[D.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$YG=(0,M.$yi)("IChatService"),e.$ZG="accessibility.voice.keywordActivation"}),define(Se[226],Ie([1,0,5,11,188]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lsb=void 0;class T{constructor(){this.f=new Map,this.m=[],this.n=new C.$fe,this.o=new C.$fe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,m,D,N){const S={command:b};if(m&&Object.keys(m).length>0&&(S.arguments=m),this.u("request",S),typeof N=="number"){const l=setTimeout(()=>{clearTimeout(l);const w=this.f.get(S.seq);if(w){this.f.delete(S.seq);const g={type:"response",seq:0,request_seq:S.seq,success:!1,command:b,message:(0,M.localize)(0,null,N,b)};w(g)}},N)}return D&&this.f.set(S.seq,D),S.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,m){return b.type!=="event"||m.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,O.$zh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const m=b,D=this.f.get(m.request_seq);D&&(this.f.delete(m.request_seq),D(m));break}}}}u(b,m){m.type=b,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((m,D)=>b.set(D,m)),await(0,O.$zh)(500),b.forEach((m,D)=>{m({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$lsb=T}),define(Se[227],Ie([1,0,2,189,31,3]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$IJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$GJ=e.MemoryRangeType=e.State=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=void 0,e.$FJ=m,e.$HJ=N,e.$tI="workbench.view.debug",e.$uI="workbench.debug.variablesView",e.$vI="workbench.debug.watchExpressionsView",e.$wI="workbench.debug.callStackView",e.$xI="workbench.debug.loadedScriptsView",e.$yI="workbench.debug.breakPointsView",e.$zI="workbench.debug.disassemblyView",e.$AI="workbench.panel.repl",e.$BI="workbench.panel.repl.view",e.$CI=new M.$Pj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$DI=new M.$Pj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$EI=new M.$Pj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$FI="debugUx",e.$GI=new M.$Pj(e.$FI,"default",{type:"string",description:O.localize(3,null)}),e.$HI=new M.$Pj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$II=new M.$Pj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$JI=new M.$Pj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$KI=new M.$Pj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$LI=new M.$Pj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$MI=new M.$Pj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$NI=new M.$Pj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$OI=new M.$Pj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$PI=new M.$Pj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$QI=new M.$Pj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$RI=new M.$Pj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$SI=new M.$Pj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$TI=new M.$Pj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$UI=new M.$Pj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$VI=new M.$Pj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$WI=new M.$Pj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$XI=new M.$Pj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$YI=new M.$Pj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$ZI=new M.$Pj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$1I=new M.$Pj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$2I=new M.$Pj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$3I=new M.$Pj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$4I=new M.$Pj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$5I=new M.$Pj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$6I=new M.$Pj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$7I=new M.$Pj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$8I=new M.$Pj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$9I=new M.$Pj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$0I=new M.$Pj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$$I=new M.$Pj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$_I=new M.$Pj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$aJ=new M.$Pj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$bJ=new M.$Pj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$cJ=new M.$Pj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$dJ=new M.$Pj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$eJ=new M.$Pj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$fJ=new M.$Pj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$gJ=new M.$Pj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$hJ=new M.$Pj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$iJ=new M.$Pj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$jJ=new M.$Pj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$kJ=new M.$Pj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$lJ=new M.$Pj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$mJ=new M.$Pj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$nJ=new M.$Pj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$oJ=new M.$Pj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$pJ=new M.$Pj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$qJ=new M.$Pj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$rJ=new M.$Pj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$sJ=new M.$Pj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$tJ=new M.$Pj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$uJ=new M.$Pj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$vJ=new M.$Pj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$wJ=new M.$Pj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$xJ=new M.$Pj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$yJ=new M.$Pj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$zJ=new M.$Pj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const A=n=>O.localize(61,null,n);e.$AJ=A,e.$BJ="editor.contrib.debug",e.$CJ="editor.contrib.breakpoint",e.$DJ="debug",e.$EJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var b;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(b||(e.State=b={}));function m(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var D;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$GJ="vscode-debug-memory";function N(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var S;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var l;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var w;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$IJ=(0,T.$yi)("debugService");var g;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(g||(e.BreakpointWidgetContext=g={}));var r;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var s;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var o;(function(n){n.deserialize=c=>c,n.serialize=c=>c})(o||(e.IDebugVisualizationTreeItem=o={}));var i;(function(n){n.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:C.URI.revive(c.iconPath.light),dark:C.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),n.serialize=c=>c})(i||(e.IDebugVisualization=i={}))}),define(Se[228],Ie([1,0,13,2,19,26,16,30,20,18]),function(le,e,C,O,M,T,A,b,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HH=void 0,e.$vH=S,e.$wH=l,e.$xH=w,e.$yH=g,e.$zH=r,e.$AH=s,e.$BH=o,e.$CH=n,e.$DH=t,e.$EH=f,e.$FH=d,e.$GH=p;const N=/{([^}]+)}/g;function S(y,h,E){return y.replace(N,function(k,I){return h&&I.length>0&&I[0]!=="_"?k:E&&E.hasOwnProperty(I)?E[I]:k})}function l(y){const h={};for(const E of Object.keys(y))E.startsWith("!")||(h[E]=y[E]);return h}function w(y){return y.configuration.request==="attach"&&!g(y)&&(!y.parentSession||w(y.parentSession))}function g(y){let h=y.configuration.type;if(h)return h==="vslsShare"&&(h=y.configuration.adapterProxy.configuration.type),(0,C.$zf)(h,"extensionhost")||(0,C.$zf)(h,"pwa-extensionhost")?y:y.parentSession?g(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function s(y,h,E){let k,I=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=P.exec(y);){const W=V.index+1,q=W+V[0].length;if(W<=h&&q>=E){k=V[0],I=W;break}}if(k){const W=/\w+/g;let q=null;for(;(q=W.exec(k))&&!(q.index+1+I+q[0].length>=E););q&&(k=k.substring(0,W.lastIndex))}return k?{start:I,end:I+k.length-1}:{start:0,end:0}}async function o(y,h,E,k){if(y.evaluatableExpressionProvider.has(h)){const I=y.evaluatableExpressionProvider.ordered(h),P=(0,D.$Hb)(await Promise.all(I.map(async V=>{try{return await V.provideEvaluatableExpression(h,E,k??m.CancellationToken.None)}catch{return}})));if(P.length>0){let V=P[0].expression;const W=P[0].range;return V||(V=h.getLineContent(E.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:V}}}else{const I=h.getLineContent(E.lineNumber),{start:P,end:V}=s(I,E.column,E.column),W=I.substring(P-1,V);return{matchingExpression:W,range:new b.$yt(E.lineNumber,P,E.lineNumber,P+W.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(y){return!!(y&&y.match(i))}function c(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(n(y.path))return O.URI.parse(y.path);if((0,M.$ic)(y.path))return O.URI.file(y.path)}return y.path}function u(y){if(typeof y.path=="object"){const h=O.URI.revive(y.path);if(h)return h.scheme===A.Schemas.file?h.fsPath:h.toString()}return y.path}function t(y,h){const E=h?c:u,k=(0,T.$5n)(y);return a(k,(I,P)=>{I&&P&&(P.path=E(P))}),k}function f(y,h){const E=h?c:u,k=(0,T.$5n)(y);return a(k,(I,P)=>{!I&&P&&(P.path=E(P))}),k}function a(y,h){switch(y.type){case"event":{const E=y;switch(E.event){case"output":h(!1,E.body.source);break;case"loadedSource":h(!1,E.body.source);break;case"breakpoint":h(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=y;switch(E.command){case"setBreakpoints":h(!0,E.arguments.source);break;case"breakpointLocations":h(!0,E.arguments.source);break;case"source":h(!0,E.arguments.source);break;case"gotoTargets":h(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(k=>h(!1,k));break;default:break}break}case"response":{const E=y;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(k=>h(!1,k.source));break;case"loadedSources":E.body.sources.forEach(k=>h(!1,k));break;case"scopes":E.body.scopes.forEach(k=>h(!1,k.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(k=>h(!1,k.source));break;case"setBreakpoints":E.body.breakpoints.forEach(k=>h(!1,k.source));break;case"disassemble":E.body?.instructions.forEach(I=>h(!1,I.location));break;default:break}break}}}function d(y){return y.filter(h=>!h.presentation?.hidden).sort((h,E)=>h.presentation?E.presentation?h.presentation.group?E.presentation.group?h.presentation.group!==E.presentation.group?h.presentation.group.localeCompare(E.presentation.group):$(h.presentation.order,E.presentation.order):-1:E.presentation.group?1:$(h.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function $(y,h){return typeof y!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:y-h}async function p(y,h){const E=y.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(E!=="none"&&(await h.saveAll(),E==="allEditorsInActiveGroup")){const k=h.activeEditorPane;k&&k.input.resource?.scheme===A.Schemas.untitled&&await h.save({editor:k.input,groupId:k.group.id})}await y.reloadConfiguration()}const v=(y,h)=>!y||!h?y===h:y.name===h.name&&y.path===h.path&&y.sourceReference===h.sourceReference;e.$HH=v}),define(Se[229],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.CellExecutionUpdateType=void 0;var O;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$1J=(0,C.$yi)("INotebookExecutionService")}),define(Se[230],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wib=e.$Vib=e.ProxyKernelState=e.$Uib=void 0,e.$Uib=100;var O;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$Vib=(0,C.$yi)("INotebookKernelService"),e.$Wib=(0,C.$yi)("INotebookKernelHistoryService")}),define(Se[231],Ie([1,0,6,30,156,96]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EXb=void 0;class A extends C.$Uc{constructor(m,D,N){super(),this._source=m,this.b=D,this.c=N,this.a=void 0}f(m){const D=m.getLineCount();return new O.$yt(1,1,D,this.g(m,D))}g(m,D){if(D<1||D>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(D)+1}get inputTextBuffer(){if(!this.b){const m=new M.$6C;m.acceptChunk(this._source);const D=m.finish(!0),{textBuffer:N,disposable:S}=D.create(1);this.b=N,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const D=new M.$6C;D.acceptChunk(m);const N=D.finish(!0),{textBuffer:S,disposable:l}=N.create(1);return this.B(l),S})),this.a}findInInputs(m){const N=new T.$TC(m,!1,!1,null).parseSearchRequest();if(!N)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,N,!0,5e3)}findInOutputs(m){const N=new T.$TC(m,!1,!1,null).parseSearchRequest();return N?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),N,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$EXb=A}),define(Se[52],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(T){T.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var O;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class M{static fromExtHostTestItem(A,b,m=A.parent){if(A._isRoot)return new M([b]);const D=[A.id];for(let N=m;N&&N.id!==b;N=N.parent)D.push(N.id);return D.push(b),new M(D.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const b=A.indexOf("\0");return b===-1?A:A.slice(0,b)}static fromString(A){return new M(A.split("\0"))}static join(A,b){return new M([...A.path,b])}static joinToString(A,b){return A.toString()+"\0"+b}static parentId(A){const b=A.lastIndexOf("\0");return b===-1?void 0:A.slice(0,b)}static localId(A){const b=A.lastIndexOf("\0");return b===-1?A:A.slice(b+1)}static isChild(A,b){return b.startsWith(A)&&b[A.length]==="\0"}static compare(A,b){return A===b?0:M.isChild(A,b)?2:M.isChild(b,A)?3:1}static getLengthOfCommonPrefix(A,b){if(A===0)return 0;let m=0;for(;m<A-1;){for(let D=1;D<A;D++){const N=b(D-1),S=b(D);if(N.path[m]!==S.path[m])return m}m++}return m}constructor(A,b=A.length){if(this.path=A,this.d=b,A.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new M(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new M(this.path,A)}compare(A){if(typeof A=="string")return M.compare(this.toString(),A);for(let b=0;b<A.d&&b<this.d;b++)if(A.path[b]!==this.path[b])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$8K=M}),define(Se[62],Ie([1,0,2,94,30,52]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$dL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$cL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$bL=e.$aL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$_K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$$K=e.$0K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$9K=e.TestResultState=void 0;var A;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$9K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var m;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$0K=[2,4,8,16,32,64];const D=R=>"runId"in R;e.$$K=D;var N;(function(R){R.serialize=z=>({range:z.range.toJSON(),uri:z.uri.toJSON()}),R.deserialize=(z,G)=>({range:M.$yt.lift(G.range),uri:z.asCanonicalUri(C.URI.revive(G.uri))})})(N||(e.IRichLocation=N={}));var S;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(S||(e.TestMessageType=S={}));var l;(function(R){R.serialize=z=>({message:z.message,type:0,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&N.serialize(z.location)}),R.deserialize=(z,G)=>({message:G.message,type:0,expected:G.expected,actual:G.actual,contextValue:G.contextValue,location:G.location&&N.deserialize(z,G.location)})})(l||(e.ITestErrorMessage=l={}));const w=(R,z)=>`${z?"s":"e"}${R}`;e.$_K=w;var g;(function(R){R.serialize=z=>({message:z.message,type:1,offset:z.offset,length:z.length,location:z.location&&N.serialize(z.location)}),R.deserialize=(z,G)=>({message:G.message,type:1,offset:G.offset,length:G.length,location:G.location&&N.deserialize(z,G.location)})})(g||(e.ITestOutputMessage=g={}));var r;(function(R){R.serialize=z=>z.type===0?l.serialize(z):g.serialize(z),R.deserialize=(z,G)=>G.type===0?l.deserialize(z,G):g.deserialize(z,G)})(r||(e.ITestMessage=r={}));var s;(function(R){R.serializeWithoutMessages=z=>({state:z.state,duration:z.duration,messages:[]}),R.serialize=z=>({state:z.state,duration:z.duration,messages:z.messages.map(r.serialize)}),R.deserialize=(z,G)=>({state:G.state,duration:G.duration,messages:G.messages.map(ie=>r.deserialize(z,ie))})})(s||(e.ITestTaskState=s={}));const o="\0",i=(R,z)=>R+o+z;e.$aL=i;const n=R=>{const z=R.indexOf(o);return{ctrlId:R.slice(0,z),tagId:R.slice(z+1)}};e.$bL=n;var c;(function(R){R.serialize=z=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?.toJSON(),range:z.range?.toJSON()||null,description:z.description,error:z.error,sortText:z.sortText}),R.deserialize=(z,G)=>({extId:G.extId,label:G.label,tags:G.tags,busy:G.busy,children:void 0,uri:G.uri?z.asCanonicalUri(C.URI.revive(G.uri)):void 0,range:G.range?M.$yt.lift(G.range):null,description:G.description,error:G.error,sortText:G.sortText})})(c||(e.ITestItem=c={}));var u;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var t;(function(R){R.serialize=z=>({expand:z.expand,item:c.serialize(z.item)}),R.deserialize=(z,G)=>({controllerId:T.$8K.root(G.item.extId),expand:G.expand,item:c.deserialize(z,G.item)})})(t||(e.InternalTestItem=t={}));var f;(function(R){R.serialize=z=>{let G;return z.item&&(G={},z.item.label!==void 0&&(G.label=z.item.label),z.item.tags!==void 0&&(G.tags=z.item.tags),z.item.busy!==void 0&&(G.busy=z.item.busy),z.item.uri!==void 0&&(G.uri=z.item.uri?.toJSON()),z.item.range!==void 0&&(G.range=z.item.range?.toJSON()),z.item.description!==void 0&&(G.description=z.item.description),z.item.error!==void 0&&(G.error=z.item.error),z.item.sortText!==void 0&&(G.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:G}},R.deserialize=z=>{let G;return z.item&&(G={},z.item.label!==void 0&&(G.label=z.item.label),z.item.tags!==void 0&&(G.tags=z.item.tags),z.item.busy!==void 0&&(G.busy=z.item.busy),z.item.range!==void 0&&(G.range=z.item.range?M.$yt.lift(z.item.range):null),z.item.description!==void 0&&(G.description=z.item.description),z.item.error!==void 0&&(G.error=z.item.error),z.item.sortText!==void 0&&(G.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:G}}})(f||(e.ITestItemUpdate=f={}));const a=(R,z)=>{z.expand!==void 0&&(R.expand=z.expand),z.item!==void 0&&(R.item=R.item?Object.assign(R.item,z.item):z.item)};e.$cL=a;var d;(function(R){R.serializeWithoutMessages=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(s.serializeWithoutMessages)}),R.serialize=z=>({...t.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(s.serialize)}),R.deserialize=(z,G)=>({...t.deserialize(z,G),ownComputedState:G.ownComputedState,computedState:G.computedState,tasks:G.tasks.map(ie=>s.deserialize(z,ie)),retired:!0})})(d||(e.TestResultItem=d={}));var $;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(z,G)=>{z.covered+=G.covered,z.total+=G.total}})($||(e.ICoverageCount=$={}));var p;(function(R){R.serialize=z=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,testId:z.testId?.toString(),uri:z.uri.toJSON()}),R.deserialize=(z,G)=>({id:G.id,statement:G.statement,branch:G.branch,declaration:G.declaration,testId:G.testId?T.$8K.fromString(G.testId):void 0,uri:z.asCanonicalUri(C.URI.revive(G.uri))}),R.empty=(z,G)=>({id:z,uri:G,testId:void 0,statement:$.empty()})})(p||(e.IFileCoverage=p={}));function v(R){return{...R,location:R.location?.toJSON()}}function y(R){return R.location=R.location?O.$xt.isIPosition(R.location)?O.$xt.lift(R.location):M.$yt.lift(R.location):void 0,R}e.$dL=3;var h;(function(R){R[R.Declaration=0]="Declaration",R[R.Statement=1]="Statement",R[R.Branch=2]="Branch"})(h||(e.DetailType=h={}));var E;(function(R){R.serialize=z=>z.type===0?I.serialize(z):P.serialize(z),R.deserialize=z=>z.type===0?I.deserialize(z):P.deserialize(z)})(E||(e.CoverageDetails=E={}));var k;(function(R){R.serialize=v,R.deserialize=y})(k||(e.IBranchCoverage=k={}));var I;(function(R){R.serialize=v,R.deserialize=y})(I||(e.IDeclarationCoverage=I={}));var P;(function(R){R.serialize=z=>({...v(z),branches:z.branches?.map(k.serialize)}),R.deserialize=z=>({...y(z),branches:z.branches?.map(k.deserialize)})})(P||(e.IStatementCoverage=P={}));var V;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var W;(function(R){R.deserialize=(z,G)=>G.op===0?{op:G.op,item:t.deserialize(z,G.item)}:G.op===1?{op:G.op,item:f.deserialize(G.item)}:G.op===2?{op:G.op,uri:z.asCanonicalUri(C.URI.revive(G.uri)),docv:G.docv}:G,R.serialize=z=>z.op===0?{op:z.op,item:t.serialize(z.item)}:z.op===1?{op:z.op,item:f.serialize(z.item)}:z})(W||(e.TestsDiffOp=W={}));class q{constructor(z){this.k=z,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(z){const G=this.v();for(const ie of z)switch(ie.op){case 0:this.l(t.deserialize(this.k,ie.item),G);break;case 1:this.o(f.deserialize(ie.item),G);break;case 3:this.p(ie.itemId,G);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}G.complete?.()}l(z,G){const ie=T.$8K.parentId(z.item.extId)?.toString();let de;if(!ie)de=this.w(z),this.g.add(de),this.f.set(z.item.extId,de);else if(this.f.has(ie)){const ye=this.f.get(ie);ye.children.add(z.item.extId),de=this.w(z,ye),this.f.set(z.item.extId,de)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(z)}`);return}return G.add?.(de),z.expand===2&&this.h++,de}o(z,G){const ie=this.f.get(z.extId);if(ie)return z.expand!==void 0&&(ie.expand===2&&this.h--,z.expand===2&&this.h++),(0,e.$cL)(ie,z),G.update?.(ie),ie}p(z,G){const ie=this.f.get(z);if(!ie)return;const de=T.$8K.parentId(ie.item.extId)?.toString();de?this.f.get(de).children.delete(ie.item.extId):this.g.delete(ie);const ye=[[z]];for(;ye.length;)for(const De of ye.pop()){const ge=this.f.get(De);ge&&(ye.push(ge.children),this.f.delete(De),G.remove?.(ge,ge!==ie),ge.expand===2&&this.h--)}}q(z){}updatePendingRoots(z){this.j+=z}v(){return{}}}e.$eL=q}),define(Se[77],Ie([1,0,11,5,6,57,62,52]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.TestItemEventOp=void 0;var m;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const D=(i,n)=>i===n,S=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:D,label:D,description:D,error:D,sortText:D,tags:(i,n)=>!(i.length!==n.length||i.some(c=>!n.includes(c)))}),l=(i,n)=>{let c;for(const[u,t]of S)t(i[u],n[u])||(c?c[u]=n[u]:c={[u]:n[u]});return c};class w extends M.$Uc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new C.$Kh(()=>this.flushDiff(),200)),this.g=this.B(new O.$fe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===n.uri){c.docv=n.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===n.item.extId){(0,A.$cL)(c.item,n.item);return}if(c.op===0&&c.item.item.extId===n.item.extId){(0,A.$cL)(c.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,c){const u=this.tree.get(n);if(u){if((u.expandLevels===void 0||c>u.expandLevels)&&(u.expandLevels=c),u.expand===1){const t=this.M(u);return t.isOpen()?this.L(u,c-1):t.wait().then(()=>this.L(u,c-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,c-1)):this.L(u,c-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,c){switch(c.op){case 3:this.O(b.$8K.joinToString(n.fullId,c.id));break;case 0:this.z(c.item,n);break;case 5:for(const u of c.ops)this.w(n,u);break;case 1:this.C(c.new,c.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:c.update}});break;case 6:this.y(n.actual.uri);break;default:(0,T.$ed)(c)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,c){const u=b.$8K.fromExtHostTestItem(n,this.root.id,c?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(n.id);let f=this.tree.get(u.toString());if(!f){f={fullId:u,actual:n,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(n,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(n)}}),this.I(n,f,c);return}if(f.actual===n){this.H(n,f,c);return}if(f.actual.uri?.toString()!==n.uri?.toString())return this.O(u.toString()),this.z(n,c);const a=this.s.getChildren(f.actual),d=f.actual,$=l(this.s.toITestItem(d),this.s.toITestItem(n));this.s.getApiFor(d).listener=void 0,f.actual=n,f.resolveBarrier=void 0,f.expand=0,$&&($.hasOwnProperty("tags")&&(this.C(n.tags,d.tags,u.toString()),delete $.tags),this.w(f,{op:4,update:$})),this.I(n,f,c);for(const[v,y]of a)this.s.getChildren(n).get(y.id)||this.O(b.$8K.joinToString(u,y.id));const p=f.expandLevels;p!==void 0&&queueMicrotask(()=>{f.expand===1&&(f.expandLevels=void 0,this.expand(u.toString(),p))}),this.y(f.actual.uri)}C(n,c,u){const t=new Set(c.map(f=>f.id));for(const f of n)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:u,item:{tags:n.map(f=>(0,A.$aL)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(n){const c=this.j.get(n.id);c?c.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$aL)(this.s.controllerId,n.id)}}))}F(n){const c=this.j.get(n);c&&!--c.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,A.$aL)(this.s.controllerId,n)}))}G(n,c){this.s.getApiFor(n).parent=c&&c.actual!==this.root?c.actual:void 0}H(n,c,u){this.G(n,u);const t=this.s.getApiFor(n);t.parent=u?.actual,t.listener=f=>this.w(c,f),this.J(c)}I(n,c,u){this.H(n,c,u);for(const[t,f]of this.s.getChildren(n))this.z(f,c)}J(n){let c;this.h?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:c}}),c===1&&n.expandLevels!==void 0&&this.M(n))}L(n,c){if(c<0)return;const u=[];for(const[t,f]of this.s.getChildren(n.actual)){const a=this.expand(b.$8K.joinToString(n.fullId,f.id),c);(0,C.$kh)(a)&&u.push(a)}if(u.length)return Promise.all(u).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const f=new C.$xh;return f.open(),f}n.expand=2,this.N(n);const c=n.resolveBarrier=new C.$xh,u=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(f){u(f)}return(0,C.$kh)(t)?t.catch(u).then(()=>{c.open(),this.J(n)}):(c.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const u=[c];for(;u.length;){const t=u.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,a]of this.s.getChildren(t.actual))u.push(this.tree.get(b.$8K.joinToString(t.fullId,a.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$DO=w;class g extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$EO=g;class r extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$FO=r;class s extends Error{constructor(n,c,u){super(`TestItem with ID "${n}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.$GO=s;const o=(i,n,c)=>{let u=new Map;return{get size(){return u.size},forEach(t,f){for(const a of u.values())t.call(f,a,this)},[Symbol.iterator](){return u.entries()},replace(t){const f=new Map,a=new Set(u.keys()),d={op:5,ops:[]};for(const $ of t){if(!($ instanceof c))throw new r($.id);const p=n($).controllerId;if(p!==i.controllerId)throw new s($.id,p,i.controllerId);if(f.has($.id))throw new g($.id);f.set($.id,$),a.delete($.id),d.ops.push({op:0,item:$})}for(const $ of a.keys())d.ops.push({op:3,id:$});i.listener?.(d),u=f},add(t){if(!(t instanceof c))throw new r(t.id);u.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){u.delete(t)&&i.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.$HO=o}),define(Se[107],Ie([1,0,77]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=void 0;const O=new WeakMap,M=(A,b)=>{const m={controllerId:b};return O.set(A,m),m};e.$IO=M;const T=A=>{const b=O.get(A);if(!b)throw new C.$FO(A?.id||"<unknown>");return b};e.$JO=T}),define(Se[78],Ie([1,0,16,2]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aBb=e.$_Ab=e.$$Ab=void 0,e.$bBb=M,e.$cBb=A,e.$$Ab="vscode-cdn.net",e.$_Ab=`vscode-resource.${e.$$Ab}`,e.$aBb=`'self' https://*.${e.$$Ab}`;function M(b,m){return b.scheme===C.Schemas.http||b.scheme===C.Schemas.https?b:(m&&m.authority&&m.isRemote&&b.scheme===C.Schemas.file&&(b=O.URI.from({scheme:C.Schemas.vscodeRemote,authority:m.authority,path:b.path})),O.URI.from({scheme:C.Schemas.https,authority:`${b.scheme}+${T(b.authority)}.${e.$_Ab}`,path:b.path,fragment:b.fragment,query:b.query}))}function T(b){return b.replace(/./g,m=>{const D=m.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?m:"-"+D.toString(16).padStart(4,"0")})}function A(b){return b.replace(/-([0-9a-f]{4})/g,(m,D)=>String.fromCharCode(parseInt(D,16)))}}),define(Se[232],Ie([1,0,5,6,78]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=void 0;class T{constructor(b,m,D){this.d=b,this.e=m,this.f=D,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const N=m.getVisibleTextEditors();for(const S of this.c.values())N.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,m,D,N,S){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){l=n;break}if(!l)throw new Error("not a visible editor");const w=this,g=this.a++,r=new C.$fe,s=new C.$fe,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,M.$bBb)(n,w.f)}get cspSource(){return M.$aBb}set options(n){this.b=n,w.d.$setOptions(g,n)}get options(){return this.b}set html(n){this.a=n,w.d.$setHtml(g,n)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(n){return w.d.$postMessage(g,n)}},i=new class{constructor(){this.editor=b,this.line=m,this.height=D,this.webview=o,this.onDidDispose=s.event}dispose(){w.c.has(g)&&(w.c.delete(g),w.d.$disposeEditorInset(g),s.fire(),s.dispose(),r.dispose())}};return this.d.$createEditorInset(g,l.id,l.value.document.uri,m+1,D,N||{},S.identifier,S.extensionLocation),this.c.set(g,{editor:b,inset:i,onDidReceiveMessage:r}),i}$onDidDispose(b){const m=this.c.get(b);m&&m.inset.dispose()}$onDidReceiveMessage(b,m){this.c.get(b)?.onDidReceiveMessage.fire(m)}}e.$hmc=T}),define(Se[108],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nL=e.$mL=e.$lL=void 0,e.$lL="__",e.$mL=(0,C.$yi)("IAuthenticationService"),e.$nL=(0,C.$yi)("IAuthenticationExtensionsService")}),define(Se[233],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=e.VariableKind=e.$BP=void 0,e.$BP=(0,C.$yi)("configurationResolverService");var O;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class M extends Error{constructor(A,b){super(b),this.variable=A}}e.$CP=M}),define(Se[234],Ie([1,0,19,75,15,26,23,97,192,233,13]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RP=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,g,r,s){this.h=new Map,this.a=w,this.b=g,this.g=r,s&&(this.c=s.then(o=>this.i(o)))}i(w){if(A.$i){const g=Object.create(null);return Object.keys(w).forEach(r=>{g[r.toLowerCase()]=w[r]}),g}return w}resolveWithEnvironment(w,g,r){return this.l({env:this.i(w),userHome:void 0},g?g.uri:void 0,r)}async resolveAsync(w,g){const r={env:await this.c,userHome:await this.g};return this.l(r,w?w.uri:void 0,g)}async j(w,g,r,s){const o=T.$5n(g);A.$i&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):A.$j&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):A.$k&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,w?w.uri:void 0,o,r,s)}async resolveAnyAsync(w,g,r){return this.j(w,g,r)}async resolveAnyMap(w,g,r){const s=new Map;return{newConfig:await this.j(w,g,r,s),resolvedVariables:s}}resolveWithInteractionReplace(w,g,r,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,g,r,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,g){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,g)}async l(w,g,r,s,o){if(M.$$f(r))return this.m(w,g,r,s,o);if(Array.isArray(r))return Promise.all(r.map(i=>this.l(w,g,i,s,o)));if(M.$ag(r)){const i=Object.create(null),n=await Promise.all(Object.keys(r).map(async c=>[await this.m(w,g,c,s,o),await this.l(w,g,r[c],s,o)]));for(const[c,u]of n)i[c]=u;return i}return r}m(w,g,r,s,o){return(0,N.$rf)(r,S.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(S.VARIABLE_LHS))return i;let c=await this.o(w,i,n,g,s);return o?.set(n,c),c!==i&&M.$$f(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m(w,g,c,s,o)),c})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,g,r,s,o){let i;const n=r.split(":");n.length>1&&(r=n[0],i=n[1]);const c=f=>{const a=this.a.getFilePath();if(a)return(0,b.$Iw)(a);throw new D.$CP(f,(0,m.localize)(0,null,g))},u=f=>{const a=c(f);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,b.$Iw)(d)}throw new D.$CP(f,(0,m.localize)(1,null,g,C.$nc(a)))},t=f=>{if(i){const a=this.a.getFolderUri(i);if(a)return a;throw new D.$CP(f,(0,m.localize)(2,null,g,i))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new D.$CP(f,(0,m.localize)(3,null,g)):new D.$CP(f,(0,m.localize)(4,null,g))};switch(r){case"env":if(i){if(w.env){const f=w.env[A.$i?i.toLowerCase():i];if(M.$$f(f))return f}return""}throw new D.$CP(D.VariableKind.Env,(0,m.localize)(5,null,g));case"config":if(i){const f=this.a.getConfigurationValue(s,i);if(M.$hg(f))throw new D.$CP(D.VariableKind.Config,(0,m.localize)(6,null,g,i));if(M.$ag(f))throw new D.$CP(D.VariableKind.Config,(0,m.localize)(7,null,g,i));return f}throw new D.$CP(D.VariableKind.Config,(0,m.localize)(8,null,g));case"command":return this.p(D.VariableKind.Command,g,i,o,"command");case"input":return this.p(D.VariableKind.Input,g,i,o,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new D.$CP(D.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,g,i));return this.n(f.extensionLocation)}throw new D.$CP(D.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,g));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,b.$Iw)(this.n(t(D.VariableKind.WorkspaceFolder)));case"cwd":return s||i?(0,b.$Iw)(this.n(t(D.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Iw)(C.$nc(this.n(t(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new D.$CP(D.VariableKind.UserHome,(0,m.localize)(11,null,g))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new D.$CP(D.VariableKind.LineNumber,(0,m.localize)(12,null,g))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new D.$CP(D.VariableKind.SelectedText,(0,m.localize)(13,null,g))}case"file":return c(D.VariableKind.File);case"fileWorkspaceFolder":return u(D.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return C.$nc(u(D.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||i?C.$lc(this.n(t(D.VariableKind.RelativeFile)),c(D.VariableKind.RelativeFile)):c(D.VariableKind.RelativeFile);case"relativeFileDirname":{const f=C.$mc(c(D.VariableKind.RelativeFileDirname));if(s||i){const a=C.$lc(this.n(t(D.VariableKind.RelativeFileDirname)),f);return a.length===0?".":a}return f}case"fileDirname":return C.$mc(c(D.VariableKind.FileDirname));case"fileExtname":return C.$oc(c(D.VariableKind.FileExtname));case"fileBasename":return C.$nc(c(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=C.$nc(c(D.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-C.$oc(f).length)}case"fileDirnameBasename":return C.$nc(C.$mc(c(D.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||g}case"execInstallFolder":{const f=this.a.getAppRoot();return f||g}case"pathSeparator":case"/":return C.sep;default:try{const f=i?`${r}:${i}`:r;return this.p(D.VariableKind.Unknown,g,f,o,void 0)}catch{return g}}}}p(w,g,r,s,o){if(r&&s){const i=o===void 0?s[r]:s[o+":"+r];if(typeof i=="string")return i;throw new D.$CP(w,(0,m.localize)(14,null,g))}return g}}e.$RP=S}),define(Se[109],Ie([1,0,3,106]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$3D=void 0,e.$4D=D,e.$5D=l,e.$6D=w,e.$3D=(0,C.$yi)("editorGroupsService");var M;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var T;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var b;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EXPAND=1]="EXPAND",g[g.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var m;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function D(g){const r=g;return(0,O.$NF)(r?.editor)&&(0,O.$NF)(r?.replacement)}var N;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N||(e.GroupsOrder=N={}));var S;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(g){const r=g;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function w(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Se[235],Ie([1,0,3,109]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0D=e.$9D=e.$8D=e.$7D=void 0,e.$$D=M,e.$7D=(0,C.$yi)("editorService"),e.$8D=-1,e.$9D=-2,e.$0D=-3;function M(T){const A=T;return typeof T=="number"||(0,O.$5D)(A)}}),define(Se[236],Ie([1,0,3,99]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GL=void 0,e.$GL=(0,C.$zi)(O.$Fi)}),define(Se[110],Ie([1,0,21,5,19,6,11]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=e.$zac=e.$yac=e.$xac=e.$wac=void 0;class b{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$wac=b;class m{static isHostExtension(i,n,c){if(n.getExtensionDescription(i))return!1;const u=c.getExtensionDescription(i);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(i,n){this.j=i,this.c=new O.$fe,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(r),this.f=new C.$Vm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const c of n)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=s(this.e,n),this.e=this.e.concat(i);const c=m.l(this.e);return this.e=s(this.e,c.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,c)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,d){this.addNode(a),this.addNode(d),this.c.has(a)?this.c.get(a).push(d):this.c.set(a,[d])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,d){const $=n.getArcs(a);for(let p=0;p<$.length;p++)if(!d.has($[p]))return!1;return!0}getNodes(){return this.e}},c=new C.$Vm;for(const a of i)if(c.set(a.identifier,a),a.extensionDependencies)for(const d of a.extensionDependencies)n.addArc(C.$Tm.toKey(a.identifier),C.$Tm.toKey(d));const u=new Set;n.getNodes().filter(a=>n.getArcs(a).length===0).forEach(a=>u.add(a));const t=n.getNodes().filter(a=>!u.has(a));let f;do{f=!1;for(let a=0;a<t.length;a++){const d=t[a];n.hasOnlyGoodArcs(d,u)&&(t.splice(a,1),a--,u.add(d),f=!0)}}while(f);return t.map(a=>c.get(a))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$xac=m;class D{constructor(i,n){this.versionId=i,this.extensions=n}}e.$yac=D;class N{constructor(i){this.d=new w,this.c=new m(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new S(this,n)}deltaExtensions(i,n,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$zac=N;class S extends T.$Uc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$Aac=S;class l{constructor(i){this.name=i;const n=(0,A.$rh)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class w{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new l(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const c=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{n&&(clearTimeout(c),n=!1,this.d=!1,this.e())};i.resolve((0,T.$Sc)(u))}}var g;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(g||(g={}));function r(o,i){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==c)return n-c;const u=M.$gc.basename(o.extensionLocation.path),t=M.$gc.basename(i.extensionLocation.path);return u<t?-1:u>t?1:0}function s(o,i){const n=new C.$Um(i);return o.filter(c=>!n.has(c.identifier))}}),define(Se[79],Ie([1,0,22]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$2m=A,e.$3m=b;var O;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(O||(e.UIKind=O={}));var M;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var T;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function A(D){const N=C.$He.alloc(1);switch(D){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}function b(D,N){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}var m;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Se[63],Ie([1,0,3,5,12,27,79,58,59,26,2,6,179]),function(le,e,C,O,M,T,A,b,m,D,N,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8O=e.$6O=e.$5O=void 0,e.$7O=r;let w=class extends S.$Uc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new O.$fe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$fe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=N.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:m.$op,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,M.$7j)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const c=this.getTelemetryDetails(),u=new g(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$Km)((0,m.$up)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,c)=>{const u=n.filter(t=>!t.isDisposed);u.length===0?this.r.delete(c):this.r.set(c,u)}),this.r.forEach(n=>{for(const c of n)c.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const c=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(o.value),!1;let u=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(i),u=!0);return u}};e.$5O=w,e.$5O=w=Je([We(0,T.$4O),We(1,M.$6j)],w);class g{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,c,u,t,f){this.g=n,this.h=c,this.i=u,this.j=t,this.a=new O.$fe,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,m.$xp)(i,[]),this.c&&(i=(0,D.$8n)(i,this.c)),this.b||(i=(0,D.$8n)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},c=(0,m.$xp)(n,[]),u=new Error(c.message,{cause:c.cause});u.stack=c.stack,u.name=c.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(u,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$6O=g;function r(s){const o=Date.now()-new Date(s).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$8O=(0,C.$yi)("IExtHostTelemetry")}),define(Se[25],Ie([1,0,5,2,207,105,21,3]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QG=e.ActivationKind=e.$NG=e.$MG=e.$JG=e.ExtensionHostStartup=e.$IG=e.$HG=e.$GG=e.$FG=void 0,e.$KG=l,e.$LG=w,e.$OG=o,e.$PG=i,e.$FG=Object.freeze({identifier:new A.$Tm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GG="extensions.webWorker",e.$HG=(0,b.$yi)("extensionService");class m{constructor(u){this.dependency=u}}e.$IG=m;var D;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(D||(e.ExtensionHostStartup=D={}));class N{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,t,f){this.c=u,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$qG.createActivationEventsMap(this.d)}}set(u,t,f){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const a=[],d=[],$=[],p=[],v=S(this.d),y=S(t),h=(V,W)=>V.extensionLocation.toString()===W.extensionLocation.toString()||V.isBuiltin===W.isBuiltin||V.isUserBuiltin===W.isUserBuiltin||V.isUnderDevelopment===W.isUnderDevelopment;for(const V of this.d){const W=y.get(V.identifier);if(!W){a.push(V.identifier),v.delete(V.identifier);continue}if(!h(V,W)){a.push(V.identifier),v.delete(V.identifier);continue}}for(const V of t){const W=v.get(V.identifier);if(!W){d.push(V);continue}if(!h(W,V)){a.push(W.identifier),v.delete(W.identifier);continue}}const E=new A.$Um(this.e),k=new A.$Um(f);for(const V of this.e)k.has(V)||$.push(V);for(const V of f)E.has(V)||p.push(V);const I=T.$qG.createActivationEventsMap(d),P={versionId:u,toRemove:a,toAdd:d,addActivationEvents:I,myToRemove:$,myToAdd:p};return this.delta(P),P}delta(u){if(this.c>=u.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:a,myToAdd:d}=u,$=new A.$Um(t),p=new A.$Um(a);for(let v=0;v<this.d.length;v++)$.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)p.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of f)this.d.push(v);for(const v of d)this.e.push(v);return this.f=null,u}containsExtension(u){for(const t of this.e)if(A.$Tm.equals(t,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=T.$qG.readActivationEvents(t);for(const a of f)u.add(a)}return u}}e.$JG=N;function S(c){const u=new A.$Vm;for(const t of c)u.set(t.identifier,t);return u}function l(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}function w(c,u){if(!l(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class g{constructor(u,t,f,a){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=a}}e.$MG=g;class r{constructor(u,t){this.description=u,this.value=t}}e.$NG=r;var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function o(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,M.$Dp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function i(c,u){return{identifier:new A.$Tm((0,M.$Bp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,t){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QG=n}),define(Se[237],Ie([1,0,14,110,21,25,12,11]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=e.$Hmc=e.$Gmc=e.$Fmc=e.$Emc=e.$Dmc=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(o,i,n,c){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=c}}e.$Dmc=m;class D{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Emc=D;class N{constructor(o,i,n,c,u,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=c,this.exports=u,this.subscriptions=t}}e.$Fmc=N;class S extends N{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Gmc=S;class l extends N{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Hmc=l;class w extends N{constructor(o){super(!0,o,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(o,i,n,c){this.g=c,this.a=o,this.b=i,this.c=n,this.d=new M.$Vm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(c=>({id:c.identifier,reason:{startup:i,extensionId:c.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const u=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new w(u));return this.c.onExtensionActivationError(o.id,u,new T.$IG(o.id.value)),t}const n=[],c=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const u of c){if(this.m(u))continue;const t=this.d.get(u);if(t){n.push(t);continue}if(this.l(u)){n.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:o.reason}));continue}const f=this.a.getExtensionDescription(u);if(f){if(!f.main&&!f.browser)continue;n.push(this.j({id:f.identifier,reason:o.reason}));continue}const a=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${u}'`),$=this.k(o,i.displayName,[],new w(d));return this.c.onExtensionActivationError(i.identifier,d,new T.$IG(u)),$}return this.k(o,i.displayName,n,null)}k(o,i,n,c){const u=new r(o.id,i,o.reason,n,c,this.c,this.g);return this.d.set(o.id,u),u}l(o){return O.$xac.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$Imc=g,e.$Imc=g=Je([We(3,A.$5j)],g);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,c,u,t,f){this.c=o,this.d=i,this.f=n,this.g=c,this.h=u,this.j=t,this.k=f,this.a=new b.$xh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new w(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new w(i),this.b&&C.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};r=Je([We(6,A.$5j)],r)}),define(Se[238],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[239],Ie([1,0,194,14,32,100,74,29,21,238,102,105]),function(le,e,C,O,M,T,A,b,m,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=void 0;const l=b.$fo.as(A.$go.JSONContribution);class w{constructor(u,t,f){this.a=u,this.b=t,this.c=f}d(u,t){this.a({type:u,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(M.default.Error,u)}warn(u){this.d(M.default.Warning,u)}info(u){this.d(M.default.Info,u)}}e.$zG=w;class g{static a(u){const t=new m.$Um;for(let f=0,a=u.length;f<a;f++)t.add(u[f].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new g(t,[]);if(!t||!t.length)return new g([],u);const f=this.a(u),a=this.a(t),d=t.filter(p=>!f.has(p.description.identifier)),$=u.filter(p=>!a.has(p.description.identifier));return new g(d,$)}constructor(u,t){this.added=u,this.removed=t}}e.$AG=g;class r{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=g.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,O.$1)(u)}}}e.$BG=r;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$CG={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Sm},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:C.localize(42,null)},{label:"*",description:C.localize(43,null),body:"*"}]}},badges:{type:"array",description:C.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(45,null)},href:{type:"string",description:C.localize(46,null)},description:{type:"string",description:C.localize(47,null)}}}},markdown:{type:"string",description:C.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Wo}},extensionPack:{description:C.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Wo}},extensionKind:{description:C.localize(52,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(53,null)},{body:["workspace"],description:C.localize(54,null)},{body:["ui","workspace"],description:C.localize(55,null)},{body:["workspace","ui"],description:C.localize(56,null)},{body:[],description:C.localize(57,null)}]},capabilities:{description:C.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(61,null),C.localize(62,null),C.localize(63,null)]},description:{type:"string",markdownDescription:C.localize(64,null)}}},untrustedWorkspaces:{description:C.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(67,null),C.localize(68,null),C.localize(69,null)]},restrictedConfigurations:{description:C.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(71,null)}}}}},sponsor:{description:C.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(74,null),type:"string"},"vscode:uninstall":{description:C.localize(75,null),type:"string"}}},icon:{type:"string",description:C.localize(76,null)},l10n:{type:"string",description:C.localize(77,null)},pricing:{type:"string",markdownDescription:C.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new r(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,t),u.activationEventsGenerator&&S.$qG.register(u.extensionPoint,u.activationEventsGenerator),e.$CG.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,l.registerSchema(o,e.$CG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$DG=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$fo.add(n.ExtensionsRegistry,new i),e.$EG=b.$fo.as(n.ExtensionsRegistry),l.registerSchema(o,e.$CG),l.registerSchema(N.$mk,{properties:{extensionEnabledApiProposals:{description:C.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(Se[240],Ie([1,0,190,15,26,239,31,5]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iI=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var D;(function(l){function w(g,r,s){if(!g)return;const o=O.$$f(g.type)?g.type:void 0;if(!o||o.length===0){s.error(C.localize(3,null));return}const i=[];if(Array.isArray(g.required))for(const n of g.required)O.$$f(n)&&i.push(n);return{extensionId:r.value,taskType:o,required:i,properties:g.properties?M.$5n(g.properties):{},when:g.when?A.$wj.deserialize(g.when):void 0}}l.from=w})(D||(D={}));const N=T.$EG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,w)=>{for(const g of l)g.type&&w.push(`onTaskType:${g.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:m}});class S{constructor(){this.d=new b.$fe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,g)=>{N.setHandler((r,s)=>{this.c=void 0;try{for(const o of s.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of s.added){const i=o.value;for(const n of i){const c=D.from(n,o.description.identifier,o.collector);c&&(this.a[c.taskType]=c)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const g of this.all()){const r={type:"object",additionalProperties:!1};g.required.length>0&&(r.required=g.required.slice(0)),g.properties!==void 0?r.properties=M.$5n(g.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[g.taskType]},w.push(r)}this.c={oneOf:w}}return this.c}}e.$iI=new S}),define(Se[241],Ie([1,0,191,15,24,26,31,240]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$sI=e.JsonSchemaVersion=e.ExecutionEngine=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$mI=e.ShellQuoting=e.$lI=e.$kI=e.$jI=void 0,e.$jI="settings",e.$kI=new A.$Pj("taskRunning",!1,C.localize(0,null)),e.$lI=C.localize2(2,"Tasks");var m;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$mI="$customized",function(R){function z(G){if(!G)return R.Strong;switch(G.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=z}(m||(e.ShellQuoting=m={}));var D;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(D||(e.CommandOptions=D={}));var N;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(N||(e.RevealKind=N={})),function(R){function z(G){switch(G.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=z}(N||(e.RevealKind=N={}));var S;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(R){function z(G){switch(G.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=z}(S||(e.RevealProblemKind=S={}));var l;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(l||(e.PanelKind=l={})),function(R){function z(G){switch(G.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=z}(l||(e.PanelKind=l={}));var w;(function(R){R.defaults={echo:!0,reveal:N.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var g;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(R){function z(ie){switch(ie.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=z;function G(ie){switch(ie){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=G}(g||(e.RuntimeType=g={}));var r;(function(R){function z(G){return O.$$f(G)?G:G.value}R.value=z})(r||(e.CommandString=r={}));var s;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function z(ie){return ie===R.Clean._id||ie===R.Build._id||ie===R.Rebuild._id||ie===R.Test._id}R.is=z;function G(ie){if(ie!==void 0)return O.$$f(ie)?z(ie)?{_id:ie,isDefault:!1}:void 0:ie}R.from=G})(s||(e.TaskGroup=s={}));var o;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function z(G){switch(G){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=z})(i||(e.TaskSourceKind=i={}));var n;(function(R){R.parallel="parallel",R.sequence="sequence"})(n||(e.DependsOrder=n={}));var c;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var u;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(z,G,ie,de,ye,De){this._label="",this._id=z,G&&(this._label=G),ie&&(this.type=ie),this.runOptions=de,this.configurationProperties=ye,this._source=De}getDefinition(z){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,G=!1){if(z===void 0)return!1;if(O.$$f(z))return z===this._label||z===this.configurationProperties.identifier||G&&z===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$nI=t;class f extends t{constructor(z,G,ie,de,ye,De,ge,ue){super(z,ie,void 0,ge,ue,G),this.command={},this._source=G,this.hasDefinedMatchers=De,ye&&(this.command=ye)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let G;switch(this.command?this.command.runtime:void 0){case g.Shell:G="shell";break;case g.Process:G="process";break;case g.CustomExecution:G="customExecution";break;case void 0:G="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:G,_key:this._id,id:this._id}}}static is(z){return z instanceof f}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$jI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const z=this.d();if(!z)return;let G=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(G+=this._source.kind);const ie={type:e.$mI,folder:z,id:G};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$9g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new f(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$oI=f;class a extends t{constructor(z,G,ie,de,ye,De,ge){super(z,ie,de,De,ge,G),this._source=G,this.configures=ye}static is(z){return z instanceof a}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$9g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$jI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const z=this.d();if(!z)return;let G=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(G+=this._source.kind);const ie={type:e.$mI,folder:z,id:G};return JSON.stringify(ie)}}e.$pI=a;class d extends t{constructor(z,G,ie,de,ye,De,ge,ue,Ce){super(z,ie,de,ue,Ce,G),this.defines=ye,this.hasDefinedMatchers=ge,this.command=De,this.icon=Ce.icon,this.hide=Ce.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof d}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new d(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$qI=d;class $ extends t{constructor(z,G,ie,de,ye,De){super(z,ie,de,ye,De,G),this._source=G}clone(){return new $(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof $}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new $(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$rI=$;var p;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(R){R._default=R.Terminal}(p||(e.ExecutionEngine=p={}));var v;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class y{constructor(z){this.c=new Map;for(let G=0;G<z.length;G++)this.c.set(z[G].uri.toString(),G)}compare(z,G){const ie=z.getWorkspaceFolder(),de=G.getWorkspaceFolder();if(ie&&de){let ye=this.c.get(ie.uri.toString());ye=ye===void 0?0:ye+1;let De=this.c.get(de.uri.toString());return De=De===void 0?0:De+1,ye===De?z._label.localeCompare(G._label):ye-De}else return!ie&&de?-1:ie&&!de?1:0}}e.$sI=y;var h;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(h||(e.TaskEventKind=h={}));var E;(function(R){R.SingleRun="singleRun",R.Background="background"})(E||(e.TaskRunType=E={}));var k;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var I;(function(R){function z(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function G(ue,Ce,se){return{...z(ue),kind:"start",terminalId:Ce,resolvedVariables:se}}R.start=G;function ie(ue,Ce,se){return{...z(ue),kind:"processStarted",terminalId:Ce,processId:se}}R.processStarted=ie;function de(ue,Ce,se){return{...z(ue),kind:"processEnded",terminalId:Ce,exitCode:se}}R.processEnded=de;function ye(ue,Ce,se){return{...z(ue),kind:"terminated",exitReason:se,terminalId:Ce}}R.terminated=ye;function De(ue,Ce,se){return{...z(Ce),kind:ue,terminalId:se}}R.general=De;function ge(){return{kind:"changed"}}R.changed=ge})(I||(e.TaskEvent=I={}));var P;(function(R){function z(ie){const de=Object.keys(ie).sort();let ye="";for(const De of de){let ge=ie[De];ge instanceof Object?ge=z(ge):typeof ge=="string"&&(ge=ge.replace(/,/g,",,")),ye+=De+","+ge+","}return ye}function G(ie){const ye={_key:z(ie),type:ie.taskType};return Object.assign(ye,ie),ye}R.create=G})(P||(e.KeyedTaskIdentifier=P={}));var V;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var W;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var q;(function(R){function z(G,ie){const de=b.$iI.get(G.type);if(de===void 0){const ue=T.$5n(G);return delete ue._key,P.create(ue)}const ye=Object.create(null);ye.type=de.taskType;const De=new Set;de.required.forEach(ue=>De.add(ue));const ge=de.properties;for(const ue of Object.keys(ge)){const Ce=G[ue];if(Ce!=null)ye[ue]=Ce;else if(De.has(ue)){const se=ge[ue];if(se.default!==void 0)ye[ue]=T.$5n(se.default);else switch(se.type){case"boolean":ye[ue]=!1;break;case"number":case"integer":ye[ue]=0;break;case"string":ye[ue]="";break;default:ie.error(C.localize(1,null,JSON.stringify(G,void 0,0),ue));return}}}return P.create(ye)}R.createTaskIdentifier=z})(q||(e.TaskDefinition=q={}))}),define(Se[242],Ie([1,0,14]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=e.$Bac=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,b)=>{this.b=A,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,C.$1)(A))}then(A,b){return this.j().then(A,b)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Bac=O;class M extends O{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$Cac=M}),define(Se[34],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fw=e.$Cw=void 0,e.$Dw=M,e.$Ew=T;class C{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++C.count}}e.$Cw=C;const O=[];function M(b){const m=new C(b);return O[m.nid]=m,m}function T(b){return O[b].sid}class A{constructor(m){this.value=m}}e.$Fw=A}),define(Se[4],Ie([1,0,34]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$iM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var M;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(M||(e.TabInputKind=M={}));var T;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var b;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var m;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var D;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(D||(e.NotebookEditorRevealType=D={}));var N;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(N||(e.CandidatePortSource=N={}));class S{static{this.a=0}static mixin(s){return s._id=S.a++,s}}e.$iM=S;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var w;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var g;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$jM={MainThreadAuthentication:(0,C.$Dw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$Dw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,C.$Dw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,C.$Dw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,C.$Dw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$Dw)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$Dw)("MainThreadClipboard"),MainThreadCommands:(0,C.$Dw)("MainThreadCommands"),MainThreadComments:(0,C.$Dw)("MainThreadComments"),MainThreadConfiguration:(0,C.$Dw)("MainThreadConfiguration"),MainThreadConsole:(0,C.$Dw)("MainThreadConsole"),MainThreadDebugService:(0,C.$Dw)("MainThreadDebugService"),MainThreadDecorations:(0,C.$Dw)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$Dw)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$Dw)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$Dw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$Dw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$Dw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$Dw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$Dw)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$Dw)("MainThreadErrors"),MainThreadTreeViews:(0,C.$Dw)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$Dw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$Dw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$Dw)("MainThreadLanguages"),MainThreadLogger:(0,C.$Dw)("MainThreadLogger"),MainThreadMessageService:(0,C.$Dw)("MainThreadMessageService"),MainThreadOutputService:(0,C.$Dw)("MainThreadOutputService"),MainThreadProgress:(0,C.$Dw)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$Dw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$Dw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$Dw)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$Dw)("MainThreadSecretState"),MainThreadStorage:(0,C.$Dw)("MainThreadStorage"),MainThreadSpeech:(0,C.$Dw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$Dw)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$Dw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,C.$Dw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,C.$Dw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$Dw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$Dw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$Dw)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$Dw)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$Dw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$Dw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$Dw)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$Dw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$Dw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$Dw)("MainThreadExtensionService"),MainThreadSCM:(0,C.$Dw)("MainThreadSCM"),MainThreadSearch:(0,C.$Dw)("MainThreadSearch"),MainThreadShare:(0,C.$Dw)("MainThreadShare"),MainThreadTask:(0,C.$Dw)("MainThreadTask"),MainThreadWindow:(0,C.$Dw)("MainThreadWindow"),MainThreadLabelService:(0,C.$Dw)("MainThreadLabelService"),MainThreadNotebook:(0,C.$Dw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$Dw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$Dw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$Dw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$Dw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$Dw)("MainThreadInteractive"),MainThreadTheming:(0,C.$Dw)("MainThreadTheming"),MainThreadTunnelService:(0,C.$Dw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$Dw)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$Dw)("MainThreadTimeline"),MainThreadTesting:(0,C.$Dw)("MainThreadTesting"),MainThreadLocalization:(0,C.$Dw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$Dw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$Dw)("MainThreadAiEmbeddingVector")},e.$kM={ExtHostCommands:(0,C.$Dw)("ExtHostCommands"),ExtHostConfiguration:(0,C.$Dw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$Dw)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$Dw)("ExtHostDebugService"),ExtHostDecorations:(0,C.$Dw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$Dw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$Dw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$Dw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$Dw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$Dw)("ExtHostEditors"),ExtHostTreeViews:(0,C.$Dw)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$Dw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$Dw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$Dw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$Dw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$Dw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$Dw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$Dw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$Dw)("ExtHostStatusBar"),ExtHostShare:(0,C.$Dw)("ExtHostShare"),ExtHostExtensionService:(0,C.$Dw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$Dw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$Dw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,C.$Dw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,C.$Dw)("ExtHostSCM"),ExtHostSearch:(0,C.$Dw)("ExtHostSearch"),ExtHostTask:(0,C.$Dw)("ExtHostTask"),ExtHostWorkspace:(0,C.$Dw)("ExtHostWorkspace"),ExtHostWindow:(0,C.$Dw)("ExtHostWindow"),ExtHostWebviews:(0,C.$Dw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$Dw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$Dw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$Dw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$Dw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$Dw)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$Dw)("ExtHostProgress"),ExtHostComments:(0,C.$Dw)("ExtHostComments"),ExtHostSecretState:(0,C.$Dw)("ExtHostSecretState"),ExtHostStorage:(0,C.$Dw)("ExtHostStorage"),ExtHostUrls:(0,C.$Dw)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$Dw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$Dw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$Dw)("ExtHostOutputService"),ExtHostLabelService:(0,C.$Dw)("ExtHostLabelService"),ExtHostNotebook:(0,C.$Dw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$Dw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$Dw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$Dw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$Dw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$Dw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$Dw)("ExtHostInteractive"),ExtHostChatAgents2:(0,C.$Dw)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$Dw)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$Dw)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$Dw)("ExtHostSpeech"),ExtHostEmbeddings:(0,C.$Dw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,C.$Dw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$Dw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$Dw)("ExtHostTheming"),ExtHostTunnelService:(0,C.$Dw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$Dw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$Dw)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$Dw)("ExtHostTimeline"),ExtHostTesting:(0,C.$Dw)("ExtHostTesting"),ExtHostTelemetry:(0,C.$Dw)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$Dw)("ExtHostLocalization")}}),define(Se[80],Ie([1,0,3,12,4,17]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=e.$4lc=e.$3lc=void 0,e.$3lc=(0,C.$yi)("IExtHostApiDeprecationService");let A=class{constructor(m,D){this.c=D,this.a=new Set,this.b=m.getProxy(M.$jM.MainThreadTelemetry)}report(m,D,N){const S=this.d(m,D);this.a.has(S)||(this.a.add(S),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:m}))}d(m,D){return`${m}-${D.identifier.value}`}};e.$4lc=A,e.$4lc=A=Je([We(0,T.$NO),We(1,O.$5j)],A),e.$5lc=Object.freeze(new class{report(b,m,D){}})}),define(Se[243],Ie([1,0,4]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmc=void 0;class O{constructor(T){const A=T.getProxy(C.$jM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(b){return A.$writeText(b)}})}}e.$fmc=O}),define(Se[244],Ie([1,0,26,4,27,17]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=void 0;let A=class{constructor(N,S){this.a=N.getProxy(O.$jM.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(N,S){const l=this,w=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){l.e(N,S,w,arguments)}})}e(N,S,l,w){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:m(w,this.b)}),this.c&&this.f(N,l,w)}};e.$_nc=A,e.$_nc=A=Je([We(0,T.$NO),We(1,M.$4O)],A);const b=1e5;function m(D,N){const S=[];if(D.length)for(let l=0;l<D.length;l++){let w=D[l];if(typeof w>"u")w="undefined";else if(w instanceof Error){const g=w;g.stack?w=g.stack:w=g.toString()}S.push(w)}if(N){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,C.$0n)(S);return l.length>b?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Se[245],Ie([1,0,2,4,25]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=void 0;class T{constructor(b){this.a=b.getProxy(O.$jM.MainThreadDialogs)}showOpenDialog(b,m){return m?.allowUIResources&&(0,M.$LG)(b,"showLocal"),this.a.$showOpenDialog(m).then(D=>D?D.map(N=>C.URI.revive(N)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(m=>m?C.URI.revive(m):void 0)}}e.$cnc=T}),define(Se[246],Ie([1,0,20,5,6,4]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0;class A{constructor(m){this.b=new Map,this.c=new O.$fe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=m.getProxy(T.$jM.MainThreadEmbeddings)}registerEmbeddingsProvider(m,D,N){if(this.d.has(D))throw new Error("An embeddings provider for this model is already registered");const S=this.e++;return this.a.$registerEmbeddingProvider(S,D),this.b.set(S,{id:D,provider:N}),(0,M.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(S),this.b.delete(S)})}async computeEmbeddings(m,D,N){N??=C.CancellationToken.None;let S=!1;typeof D=="string"&&(D=[D],S=!0);const l=await this.a.$computeEmbeddings(m,D,N);if(l.length!==D.length)throw new Error;if(S){if(l.length!==1)throw new Error;return l[0]}return l}async $provideEmbeddings(m,D,N){const S=this.b.get(m);if(!S)return[];const l=await S.provider.provideEmbeddings(D,N);return l||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(m){this.d=new Set(m),this.c.fire()}}e.$fnc=A}),define(Se[247],Ie([1,0,6,4]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=void 0;class M{constructor(A){this.b=0,this.a=A.getProxy(O.$jM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,A),(0,C.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$wnc=M}),define(Se[81],Ie([1,0,23,13,2,3,12,4,27,17]),function(le,e,C,O,M,T,A,b,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=e.$Wmc=void 0;let N=class{constructor(l,w,g){this.f=g,this.d=new Map,this.a=w.getProxy(b.$jM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===C.$g}getMessage(l,w){const{message:g,args:r,comment:s}=w;if(this.c)return(0,O.$$e)(g,r??{});let o=g;s&&s.length>0&&(o+=`/${Array.isArray(s)?s.join(""):s}`);const i=this.d.get(l)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$$e)(i??g,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let w;const g=await this.g(l);if(!g){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(g),s=JSON.parse(r);w=l.isBuiltin?s.contents?.bundle:s}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${g}: ${r.message}`);return}w&&this.d.set(l.identifier.value,{contents:w,uri:g})}async g(l){if(l.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return M.URI.revive(w)}return l.l10n?M.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Wmc=N,e.$Wmc=N=Je([We(0,m.$4O),We(1,D.$NO),We(2,A.$5j)],N),e.$Xmc=(0,T.$yi)("IExtHostLocalizationService")}),define(Se[248],Ie([1,0,12,4,27,17,2,49]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;let m=class extends C.$dk{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map(w=>(0,b.$8h)(w))),this.r=S.getProxy(O.$jM.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(A.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,w){return new D(this.r,S,l,w)}};e.$$nc=m,e.$$nc=m=Je([We(0,T.$NO),We(1,M.$4O)],m);class D extends C.$$j{constructor(S,l,w,g){super(g?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(l,g).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const w=[[S,l]];this.m?this.u(w):this.n.push(...w)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Se[82],Ie([1,0,4,3,6,17,22]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=void 0,e.$Ymc=(0,O.$yi)("IExtHostManagedSockets");let b=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(C.$jM.MainThreadManagedSockets)}setFactory(S,l){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,w=await this.c.makeConnection(),g=new M.$Tc;return this.d.set(l,new D(l,w,g)),g.add((0,M.$Sc)(()=>this.d.delete(l))),g.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),g.dispose()})),g.add(w.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),g.dispose()})),g.add(w.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,A.$He.wrap(r)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$Zmc=b,e.$Zmc=b=Je([We(0,T.$NO)],b);class m{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class D extends M.$Uc{constructor(S,l,w){super(),this.socketId=S,this.actual=l,this.B(w)}}}),define(Se[249],Ie([1,0,4,12,25]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=void 0;function T(b){return b&&b.title}let A=class{constructor(m,D){this.b=D,this.a=m.getProxy(C.$jM.MainThreadMessageService)}showMessage(m,D,N,S,l){const w={source:{identifier:m.identifier,label:m.displayName||m.name}};let g;typeof S=="string"||T(S)?g=[S,...l]:(w.modal=S?.modal,w.useCustom=S?.useCustom,w.detail=S?.detail,g=l),w.useCustom&&(0,M.$LG)(m,"resolvers");const r=[];let s=!1;for(let o=0;o<g.length;o++){const i=g[o];if(typeof i=="string")r.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:c}=i;r.push({title:n,isCloseAffordance:!!c,handle:o}),c&&(s?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,i):s=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,i)}return this.a.$showMessage(D,N,w,r).then(o=>{if(typeof o=="number")return g[o]})}};e.$ync=A,e.$ync=A=Je([We(1,O.$5j)],A)}),define(Se[250],Ie([1,0,6,15,2,25,4]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=void 0;class b{constructor(D){this.b=new Map,this.a=D.getProxy(A.$jM.MainThreadProfileContentHandlers)}registerProfileContentHandler(D,N,S){if((0,T.$LG)(D,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,S),this.a.$registerProfileContentHandler(N,S.name,S.description,D.identifier.value),(0,C.$Sc)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(D,N,S,l){const w=this.b.get(D);if(!w)throw new Error(`Unknown handler with id: ${D}`);return w.saveProfile(N,S,l)}async $readProfile(D,N,S){const l=this.b.get(D);if(!l)throw new Error(`Unknown handler with id: ${D}`);return l.readProfile((0,O.$$f)(N)?N:M.URI.revive(N),S)}}e.$Hnc=b}),define(Se[83],Ie([1,0,4,5,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=e.$Tmc=void 0;class T{constructor(b){this.b=new O.$fe,this.onDidChangePassword=this.b.event,this.a=b.getProxy(C.$jM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,m){return this.a.$getPassword(b,m)}store(b,m,D){return this.a.$setPassword(b,m,D)}delete(b,m){return this.a.$deletePassword(b,m)}}e.$Tmc=T,e.$Umc=(0,M.$yi)("IExtHostSecretState")}),define(Se[251],Ie([1,0,20,6,4]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=void 0;class T{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.f=new Map,this.b=b.getProxy(M.$jM.MainThreadSpeech)}async $createSpeechToTextSession(b,m,D){const N=this.c.get(b);if(!N)return;const S=new O.$Tc,l=new C.$qe;this.d.set(m,l);const w=await N.provideSpeechToTextSession(l.token,D?{language:D}:void 0);w&&(S.add(w.onDidChange(g=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,g)})),S.add(l.token.onCancellationRequested(()=>S.dispose())))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createTextToSpeechSession(b,m,D){const N=this.c.get(b);if(!N)return;const S=new O.$Tc,l=new C.$qe;this.d.set(m,l);const w=await N.provideTextToSpeechSession(l.token,D?{language:D}:void 0);w&&(this.f.set(m,w),S.add(w.onDidChange(g=>{l.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,g)})),S.add(l.token.onCancellationRequested(()=>S.dispose())))}async $synthesizeSpeech(b,m){this.f.get(b)?.synthesize(m)}async $cancelTextToSpeechSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b),this.f.delete(b)}async $createKeywordRecognitionSession(b,m){const D=this.c.get(b);if(!D)return;const N=new O.$Tc,S=new C.$qe;this.d.set(m,S);const l=await D.provideKeywordRecognitionSession(S.token);l&&(N.add(l.onDidChange(w=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,w)})),N.add(S.token.onCancellationRequested(()=>N.dispose())))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,m,D){const N=T.a++;return this.c.set(N,D),this.b.$registerProvider(N,m,{extension:b,displayName:b.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(N),this.c.delete(N)})}}e.$Onc=T}),define(Se[84],Ie([1,0,4,5,3]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=e.$Jmc=void 0;class T{constructor(b,m){this.c=m,this.b=new O.$fe,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(C.$jM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,m){this.a.$registerExtensionStorageKeysToSync(b,m)}async initializeExtensionStorage(b,m,D){const N=await this.a.$initializeExtensionStorage(b,m);let S;return N&&(S=this.d(b,m,N)),S||D}setValue(b,m,D){return this.a.$setValue(b,m,D)}$acceptValue(b,m,D){const N=this.d(b,m,D);N&&this.b.fire({shared:b,key:m,value:N})}d(b,m,D){try{return JSON.parse(D)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${b}): ${N}`)}}}e.$Jmc=T,e.$Kmc=(0,M.$yi)("IExtHostStorage")}),define(Se[252],Ie([1,0,6,16,2,4]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=void 0;class A{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(T.$jM.MainThreadUriOpeners)}registerExternalUriOpener(m,D,N,S){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const l=S.schemes.find(w=>!A.a.has(w));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(D,N),this.b.$registerUriOpener(D,S.schemes,m,S.label),(0,C.$Sc)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(m,D,N){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener with id: ${m}`);const l=M.URI.revive(D);return S.canOpenExternalUri(l,N)}async $openUri(m,D,N){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener id: '${m}'`);return S.openExternalUri(M.URI.revive(D.resolvedUri),{sourceUri:M.URI.revive(D.sourceUri)},N)}}e.$5nc=A}),define(Se[253],Ie([1,0,4,2,6,14,21]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class b{static{this.a=0}constructor(D){this.c=new A.$Um,this.d=new Map,this.b=D.getProxy(C.$jM.MainThreadUrls)}registerUriHandler(D,N){const S=D.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=b.a++;return this.c.add(S),this.d.set(l,N),this.b.$registerUriHandler(l,S,D.displayName||D.name),(0,M.$Sc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(D,N){const S=this.d.get(D);if(!S)return Promise.resolve(void 0);try{S.handleUri(O.URI.revive(N))}catch(l){(0,T.$1)(l)}return Promise.resolve(void 0)}async createAppUri(D){return O.URI.revive(await this.b.$createAppUri(D))}}e.$6nc=b}),define(Se[64],Ie([1,0,5,6,16,26,2,197,221,78,4]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=e.$umc=void 0,e.$vmc=l,e.$xmc=r,e.$ymc=s;class S{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,u,t,f,a,d,$){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new C.$fe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$fe,this._onDidDispose=this.#h.event,this.#e=c,this.#t=u,this.#o=t,this.#n=f,this.#s=a,this.#r=d,this.#l=l(d),this.#d=w(d),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,D.$bBb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===M.Schemas.https||c.scheme===M.Schemas.http){let u=c.toString();return u.endsWith("/")||(u+="/"),u+" "+D.$aBb}return D.$aBb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),T.$9n(this.#o,c)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const u=(0,m.$$rb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const u=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,d,$,p,v)=>{const y=A.URI.from({scheme:$||"file",path:decodeURIComponent(p)}),h=(0,D.$bBb)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,a,d,$,p,v)=>{const y=A.URI.from({scheme:$||"file",path:decodeURIComponent(p)}),h=(0,D.$bBb)(y,{isRemote:u,authority:t}).toString();return`${a}${h}${v}`})}}e.$umc=S;function l(n){try{const c=(0,b.$Mp)((0,b.$Lp)(n.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function w(n){try{const c=(0,b.$Mp)((0,b.$Lp)(n.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class g extends O.$Uc{constructor(c,u,t,f,a){super(),this.c=u,this.f=t,this.g=f,this.h=a,this.b=new Map,this.a=c.getProxy(N.$jM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,u,t){const f=this.j(c);if(f){const{message:a}=(0,m.$_rb)(u,t.value);f._onMessageEmitter.fire(a)}}$onMissingCsp(c,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,u,t){const f=new S(c,this.a,o(u),this.c,this.f,t,this.h);this.b.set(c,f);const a=f._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return f}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$wmc=g;function r(n){return{id:n.identifier,location:n.extensionLocation}}function s(n,c,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||i(n,c)}}function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(c=>A.URI.from(c))}}function i(n,c){return[...(c?.getWorkspaceFolders()||[]).map(u=>u.uri),n.extensionLocation]}}),define(Se[111],Ie([1,0,5,16,13,2,3,17,4]),function(le,e,C,O,M,T,A,b,m){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=e.$8nc=void 0;let N=class{static{D=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new C.$fe,this.onDidChangeWindowState=this.c.event,this.d=D.a,this.b=l.getProxy(m.$jM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:w,isActive:g})=>{this.onDidChangeWindowProperty("focused",w),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,w){w!==this.d[l]&&(this.d={...this.d,[l]:w},this.c.fire(this.d))}openUri(l,w){let g;if(typeof l=="string"){g=l;try{l=T.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,M.$9e)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,g,w)}async asExternalUri(l,w){if((0,M.$9e)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(l,w);return T.URI.from(g)}};e.$8nc=N,e.$8nc=N=D=Je([We(0,b.$NO)],N),e.$9nc=(0,A.$yi)("IExtHostWindow")}),define(Se[254],Ie([1,0,244,27,17]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=void 0;let T=class extends C.$_nc{constructor(b,m){super(b,m)}f(b,m,D){m.apply(console,D)}};e.$hqc=T,e.$hqc=T=Je([We(0,M.$NO),We(1,O.$4O)],T)}),define(Se[255],Ie([1,0,11,22,20,14,5,6,150,242,34]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=e.ResponsiveState=e.RequestInitiator=void 0,e.$Dac=s,e.$Eac=o;function l(k,I){try{return JSON.stringify(k,I)}catch{return"null"}}const w="$$ref$$",g={[w]:-1};class r{constructor(I,P){this.jsonString=I,this.referencedBuffers=P}}function s(k,I=null,P=!1){const V=[];return{jsonString:(P?l:JSON.stringify)(k,(q,R)=>{if(typeof R>"u")return g;if(typeof R=="object"){if(R instanceof O.$He){const z=V.push(R)-1;return{[w]:z}}if(I)return I(q,R)}return R}),referencedBuffers:V}}function o(k,I,P){return JSON.parse(k,(V,W)=>{if(W){const q=W[w];if(typeof q=="number")return I[q];if(P&&W.$mid===1)return P.transformIncoming(W)}return W})}function i(k,I){return JSON.stringify(k,I)}function n(k){return k?(I,P)=>P&&P.$mid===1?k.transformOutgoing(P):P:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var u;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},f=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends b.$Uc{static{S=f}static{this.a=3*1e3}constructor(I,P=null,V=null){super(),this[S]=!0,this.b=this.B(new A.$fe),this.onDidChangeResponsiveState=this.b.event,this.c=I,this.f=P,this.g=V,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,q=N.$Cw.count;W<q;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$Kh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(I=>{const P=this.w[I];delete this.w[I],P.resolveErr(T.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(I){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(I){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(I){this.y!==I&&(this.y=I,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(I){return this.g?(0,m.$Dn)(I,this.g):I}getProxy(I){const{nid:P,sid:V}=I;return this.s[P]||(this.s[P]=this.J(P,V)),this.s[P]}J(I,P){const V={get:(W,q)=>(typeof q=="string"&&!W[q]&&q.charCodeAt(0)===36&&(W[q]=(...R)=>this.U(I,q,R)),q===a?P:W[q])};return new Proxy(Object.create(null),V)}set(I,P){return this.m[I.nid]=P,P}assertRegistered(I){for(let P=0,V=I.length;P<V;P++){const W=I[P];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(I){if(this.j)return;const P=I.byteLength,V=p.read(I,0),W=V.readUInt8(),q=V.readUInt32();switch(W){case 1:case 2:{let{rpcId:R,method:z,args:G}=y.deserializeRequestJSONArgs(V);this.g&&(G=(0,m.$Dn)(G,this.g)),this.M(P,q,R,z,G,W===2);break}case 3:case 4:{let{rpcId:R,method:z,args:G}=y.deserializeRequestMixedArgs(V);this.g&&(G=(0,m.$Dn)(G,this.g)),this.M(P,q,R,z,G,W===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let R=y.deserializeReplyOKJSON(V);this.g&&(R=(0,m.$Dn)(R,this.g)),this.O(P,q,R);break}case 10:{const R=y.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(P,q,R);break}case 8:{const R=y.deserializeReplyOKVSBuffer(V);this.O(P,q,R);break}case 11:{let R=y.deserializeReplyErrError(V);this.g&&(R=(0,m.$Dn)(R,this.g)),this.P(P,q,R);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(I)}}M(I,P,V,W,q,R){this.f?.logIncoming(I,P,1,`receiveRequest ${(0,N.$Ew)(V)}.${W}(`,q);const z=String(P);let G,ie;if(R){const ye=new M.$qe;q.push(ye.token),G=this.Q(V,W,q),ie=()=>ye.cancel()}else G=this.Q(V,W,q),ie=t;this.u[z]=ie;const de=y.serializeAcknowledged(P);this.f?.logOutgoing(de.byteLength,P,1,"ack"),this.c.send(de),G.then(ye=>{delete this.u[z];const De=y.serializeReplyOK(P,ye,this.h);this.f?.logOutgoing(De.byteLength,P,1,"reply:",ye),this.c.send(De)},ye=>{delete this.u[z];const De=y.serializeReplyErr(P,ye);this.f?.logOutgoing(De.byteLength,P,1,"replyErr:",ye),this.c.send(De)})}N(I,P){this.f?.logIncoming(I,P,1,"receiveCancel");const V=String(P);this.u[V]?.()}O(I,P,V){this.f?.logIncoming(I,P,0,"receiveReply:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W],q.resolveOk(V)}P(I,P,V){this.f?.logIncoming(I,P,0,"receiveReplyErr:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W];let R;V&&(V.$isError?(R=new Error,R.name=V.name,R.message=V.message,R.stack=V.stack):R=V),q.resolveErr(R)}Q(I,P,V){try{return Promise.resolve(this.S(I,P,V))}catch(W){return Promise.reject(W)}}S(I,P,V){const W=this.m[I];if(!W)throw new Error("Unknown actor "+(0,N.$Ew)(I));const q=W[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,N.$Ew)(I));return q.apply(W,V)}U(I,P,V){if(this.j)return new D.$Cac;let W=null;if(V.length>0&&M.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(T.$6());const q=y.serializeRequestArguments(V,this.h),R=++this.t,z=String(R),G=new D.$Bac,ie=new b.$Tc;W&&ie.add(W.onCancellationRequested(()=>{const ye=y.serializeCancel(R);this.f?.logOutgoing(ye.byteLength,R,0,"cancel"),this.c.send(y.serializeCancel(R))})),this.w[z]=new $(G,ie),this.F(R);const de=y.serializeRequest(R,I,P,q,!!W);return this.f?.logOutgoing(de.byteLength,R,0,`request: ${(0,N.$Ew)(I)}.${P}(`,V),this.c.send(de),G}}e.$Fac=d;class ${constructor(I,P){this.a=I,this.b=P}resolveOk(I){this.a.resolveOk(I),this.b.dispose()}resolveErr(I){this.a.resolveErr(I),this.b.dispose()}}class p{static alloc(I,P,V){const W=new p(O.$He.alloc(V+1+4),0);return W.writeUInt8(I),W.writeUInt32(P),W}static read(I,P){return new p(I,P)}get buffer(){return this.a}constructor(I,P){this.a=I,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(I){this.a.writeUInt8(I,this.b),this.b+=1}readUInt8(){const I=this.a.readUInt8(this.b);return this.b+=1,I}writeUInt32(I){this.a.writeUInt32BE(I,this.b),this.b+=4}readUInt32(){const I=this.a.readUInt32BE(this.b);return this.b+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this.a.writeUInt8(I.byteLength,this.b),this.b+=1,this.a.set(I,this.b),this.b+=I.byteLength}readShortString(){const I=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+I).toString();return this.b+=I,V}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readLongString(){const I=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+I).toString();return this.b+=I,V}writeBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readVSBuffer(){const I=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+I);return this.b+=I,P}static sizeMixedArray(I){let P=0;P+=1;for(let V=0,W=I.length;V<W;V++){const q=I[V];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let R=0;R<q.buffers.length;++R)P+=this.sizeVSBuffer(q.buffers[R]);break;case 4:break}}return P}writeMixedArray(I){this.a.writeUInt8(I.length,this.b),this.b+=1;for(let P=0,V=I.length;P<V;P++){const W=I[P];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let q=0;q<W.buffers.length;++q)this.writeBuffer(W.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this.a.readUInt8(this.b);this.b+=1;const P=new Array(I);for(let V=0;V<I;V++)switch(this.readUInt8()){case 1:P[V]=this.readLongString();break;case 2:P[V]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),R=this.readLongString(),z=[];for(let G=0;G<q;++G)z.push(this.readVSBuffer());P[V]=new N.$Fw(o(R,z,null));break}case 4:P[V]=void 0;break}return P}}var v;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(v||(v={}));class y{static a(I){for(let P=0,V=I.length;P<V;P++)if(I[P]instanceof O.$He||I[P]instanceof N.$Fw||typeof I[P]>"u")return!0;return!1}static serializeRequestArguments(I,P){if(this.a(I)){const V=[];for(let W=0,q=I.length;W<q;W++){const R=I[W];if(R instanceof O.$He)V[W]={type:2,value:R};else if(typeof R>"u")V[W]={type:4};else if(R instanceof N.$Fw){const{jsonString:z,referencedBuffers:G}=s(R.value,P);V[W]={type:3,value:O.$He.fromString(z),buffers:G}}else V[W]={type:1,value:O.$He.fromString(i(R,P))}}return{type:1,args:V}}return{type:0,args:i(I,P)}}static serializeRequest(I,P,V,W,q){switch(W.type){case 0:return this.b(I,P,V,W.args,q);case 1:return this.c(I,P,V,W.args,q)}}static b(I,P,V,W,q){const R=O.$He.fromString(V),z=O.$He.fromString(W);let G=0;G+=p.sizeUInt8(),G+=p.sizeShortString(R),G+=p.sizeLongString(z);const ie=p.alloc(q?2:1,I,G);return ie.writeUInt8(P),ie.writeShortString(R),ie.writeLongString(z),ie.buffer}static deserializeRequestJSONArgs(I){const P=I.readUInt8(),V=I.readShortString(),W=I.readLongString();return{rpcId:P,method:V,args:JSON.parse(W)}}static c(I,P,V,W,q){const R=O.$He.fromString(V);let z=0;z+=p.sizeUInt8(),z+=p.sizeShortString(R),z+=p.sizeMixedArray(W);const G=p.alloc(q?4:3,I,z);return G.writeUInt8(P),G.writeShortString(R),G.writeMixedArray(W),G.buffer}static deserializeRequestMixedArgs(I){const P=I.readUInt8(),V=I.readShortString(),W=I.readMixedArray(),q=new Array(W.length);for(let R=0,z=W.length;R<z;R++){const G=W[R];typeof G=="string"?q[R]=JSON.parse(G):q[R]=G}return{rpcId:P,method:V,args:q}}static serializeAcknowledged(I){return p.alloc(5,I,0).buffer}static serializeCancel(I){return p.alloc(6,I,0).buffer}static serializeReplyOK(I,P,V){if(typeof P>"u")return this.d(I);if(P instanceof O.$He)return this.e(I,P);if(P instanceof N.$Fw){const{jsonString:W,referencedBuffers:q}=s(P.value,V,!0);return this.g(I,W,q)}else return this.f(I,l(P,V))}static d(I){return p.alloc(7,I,0).buffer}static e(I,P){let V=0;V+=p.sizeVSBuffer(P);const W=p.alloc(8,I,V);return W.writeVSBuffer(P),W.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static f(I,P){const V=O.$He.fromString(P);let W=0;W+=p.sizeLongString(V);const q=p.alloc(9,I,W);return q.writeLongString(V),q.buffer}static g(I,P,V){const W=O.$He.fromString(P);let q=0;q+=p.sizeUInt32,q+=p.sizeLongString(W);for(const z of V)q+=p.sizeVSBuffer(z);const R=p.alloc(10,I,q);R.writeUInt32(V.length),R.writeLongString(W);for(const z of V)R.writeBuffer(z);return R.buffer}static deserializeReplyOKJSON(I){const P=I.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(I,P){const V=I.readUInt32(),W=I.readLongString(),q=[];for(let R=0;R<V;++R)q.push(I.readVSBuffer());return new N.$Fw(o(W,q,P))}static serializeReplyErr(I,P){const V=P?l(T.$3(P),null):void 0;if(typeof V!="string")return this.h(I);const W=O.$He.fromString(V);let q=0;q+=p.sizeLongString(W);const R=p.alloc(11,I,q);return R.writeLongString(W),R.buffer}static deserializeReplyErrError(I){const P=I.readLongString();return JSON.parse(P)}static h(I){return p.alloc(12,I,0).buffer}}var h;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var E;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(E||(E={}))}),define(Se[256],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqc=void 0;const C=function(T){const A=b=>{globalThis.removeEventListener("message",A);const m=b.data;Object.defineProperties(globalThis,{postMessage:{value(D,N){m.postMessage(D,N)}},onmessage:{get(){return m.onmessage},set(D){m.onmessage=D}}}),m.addEventListener("message",D=>{globalThis.dispatchEvent(new MessageEvent("message",{data:D.data,ports:D.ports?[...D.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",A)}.toString();class O extends EventTarget{constructor(T,A,b){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${C})('${A}'))`,D=new Blob([m],{type:"application/javascript"}),N=URL.createObjectURL(D),S=new MessageChannel,l=N,w={type:"_newWorker",id:l,port:S.port2,url:N,options:b};T(w,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{T({type:"_terminateWorker",id:l}),URL.revokeObjectURL(N),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(g){S.port1.onmessage=g}},onmessageerror:{get(){return S.port1.onmessageerror},set(g){S.port1.onmessageerror=g}}}),S.port1.addEventListener("messageerror",g=>{const r=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(r)}),S.port1.addEventListener("message",g=>{const r=new MessageEvent("message",{data:g.data});this.dispatchEvent(r)}),S.port1.start()}}e.$jqc=O}),define(Se[257],Ie([1,0,22,28,16,56,3]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJ=e.$WJ=void 0,e.$XJ=N,e.$YJ=S,e.$WJ=(0,A.$yi)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${b.join("")}]+`),D=7;function N(w){if(w.scheme!==M.Schemas.vscodeNotebookCell)return;const g=w.fragment.indexOf("s");if(g<0)return;const r=parseInt(w.fragment.substring(0,g).replace(m,""),D),s=(0,C.$1e)(w.fragment.substring(g+1)).toString();if(!isNaN(r))return{handle:r,notebook:w.with({scheme:s,fragment:null})}}function S(w,g){const r=g.toString(D),o=`${r.length<b.length?b[r.length-1]:"z"}${r}s${(0,C.$2e)(C.$He.fromString(w.scheme),!0,!0)}`;return w.with({scheme:M.Schemas.vscodeNotebookCell,fragment:o})}class l{constructor(){this.a=new O.$Ac}getNotebook(g){if(g.scheme===M.Schemas.vscodeNotebookCell){const r=N(g);if(r){const s=this.a.get(r.notebook);if(s)return s}}return this.a.get(g)}addNotebookDocument(g){this.a.set(g.uri,g)}removeNotebookDocument(g){this.a.delete(g.uri)}}e.$ZJ=l,(0,T.$Bs)(e.$WJ,l,1)}),define(Se[85],Ie([1,0,22,37,42,70,16,19,23,31,257]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hK=e.$eK=e.CellStatusbarAlignment=e.$dK=e.NotebookEditorPriority=e.$aK=e.$_J=e.$0J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$9J=e.$8J=e.$7J=e.$6J=e.CellKind=e.$5J=e.$4J=e.$3J=void 0,e.$$J=f,e.$bK=d,e.$cK=$,e.$fK=y,e.$gK=E,e.$3J="workbench.editor.notebook",e.$4J="workbench.editor.notebookTextDiffEditor",e.$5J="workbench.editor.interactive";var S;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(S||(e.CellKind=S={})),e.$6J=["application/json","application/javascript","text/html","image/svg+xml",T.$Us.latex,T.$Us.markdown,"image/png","image/jpeg",T.$Us.text],e.$7J=[T.$Us.latex,T.$Us.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$Us.text],e.$8J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$9J="_notAvailable";var l;(function(G){G[G.Running=1]="Running",G[G.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var w;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var g;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(g||(e.NotebookExecutionState=g={}));var r;(function(G){G[G.WithHardKernelDependency=0]="WithHardKernelDependency",G[G.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",G[G.Pure=2]="Pure",G[G.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var s;(function(G){G.Always="always",G.Never="never",G.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var o;(function(G){G[G.ModelChange=1]="ModelChange",G[G.Move=2]="Move",G[G.ChangeCellLanguage=5]="ChangeCellLanguage",G[G.Initialize=6]="Initialize",G[G.ChangeCellMetadata=7]="ChangeCellMetadata",G[G.Output=8]="Output",G[G.OutputItem=9]="OutputItem",G[G.ChangeCellContent=10]="ChangeCellContent",G[G.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",G[G.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",G[G.ChangeCellMime=13]="ChangeCellMime",G[G.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(G){G[G.Handle=0]="Handle",G[G.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(G){G[G.Replace=1]="Replace",G[G.Output=2]="Output",G[G.Metadata=3]="Metadata",G[G.CellLanguage=4]="CellLanguage",G[G.DocumentMetadata=5]="DocumentMetadata",G[G.Move=6]="Move",G[G.OutputItems=7]="OutputItems",G[G.PartialMetadata=8]="PartialMetadata",G[G.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var c;(function(G){G.scheme=A.Schemas.vscodeNotebookCell;function ie(Ce,se){return(0,N.$YJ)(Ce,se)}G.generate=ie;function de(Ce){return(0,N.$XJ)(Ce)}G.parse=de;function ye(Ce,se){return Ce.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${se??""},${Ce.scheme!==A.Schemas.file?Ce.scheme:""}`})}G.generateCellOutputUri=ye;function De(Ce){if(Ce.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Ce.fragment);if(!se)return;const Oe=se[1]&&se[1]!==""?se[1]:void 0,ne=se[2];return{outputId:Oe,notebook:Ce.with({scheme:ne||A.Schemas.file,fragment:null})}}G.parseCellOutputUri=De;function ge(Ce,se,Oe){return G.generate(Ce,se).with({scheme:Oe})}G.generateCellPropertyUri=ge;function ue(Ce,se){if(Ce.scheme===se)return G.parse(Ce.with({scheme:G.scheme}))}G.parseCellPropertyUri=ue})(c||(e.CellUri=c={}));const u=G=>m.$i?G.replace(/\//g,"\\"):G;class t{constructor(ie=[],de=e.$6J){this.e=de,this.d=[...new Set(ie)].map(ye=>({pattern:ye,matches:O.$sk(u(ye))}))}sort(ie){const de=new Map(M.Iterable.map(ie,De=>[De,u(De)]));let ye=[];for(const{matches:De}of this.d)for(const[ge,ue]of de)if(De(ue)){ye.push(ge),de.delete(ge);break}return de.size&&(ye=ye.concat([...de.keys()].sort((De,ge)=>this.e.indexOf(De)-this.e.indexOf(ge)))),ye}prioritize(ie,de){const ye=this.f(ie);if(ye===-1){this.d.unshift({pattern:ie,matches:O.$sk(u(ie))});return}const De=new Set(de.map(ue=>this.f(ue,ye)));De.delete(-1);const ge=Array.from(De).sort();this.d.splice(ye+1,0,...ge.map(ue=>this.d[ue]));for(let ue=ge.length-1;ue>=0;ue--)this.d.splice(ge[ue],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,de=this.d.length){const ye=u(ie);for(let De=0;De<de;De++)if(this.d[De].matches(ye))return De;return-1}}e.$0J=t;function f(G,ie,de,ye=(De,ge)=>De===ge){const De=[];function ge(se,Oe,ne){if(Oe===0&&ne.length===0)return;const j=De[De.length-1];j&&j.start+j.deleteCount===se?(j.deleteCount+=Oe,j.toInsert.push(...ne)):De.push({start:se,deleteCount:Oe,toInsert:ne})}let ue=0,Ce=0;for(;;){if(ue===G.length){ge(ue,0,ie.slice(Ce));break}if(Ce===ie.length){ge(ue,G.length-ue,[]);break}const se=G[ue],Oe=ie[Ce];if(ye(se,Oe)){ue+=1,Ce+=1;continue}de(Oe)?(ge(ue,1,[]),ue+=1):(ge(ue,0,[Oe]),Ce+=1)}return De}e.$_J=new D.$Pj("notebookEditorCursorAtBoundary","none"),e.$aK=new D.$Pj("notebookEditorCursorAtLineBoundary","none");var a;(function(G){G.default="default",G.option="option"})(a||(e.NotebookEditorPriority=a={}));function d(G){const ie=G;return!!((typeof ie.include=="string"||O.$tk(ie.include))&&(typeof ie.exclude=="string"||O.$tk(ie.exclude)))}function $(G,ie,de){if(Array.isArray(G.viewType)&&G.viewType.indexOf(ie)>=0||G.viewType===ie)return!0;if(G.filenamePattern){const ye=d(G.filenamePattern)?G.filenamePattern.include:G.filenamePattern,De=d(G.filenamePattern)?G.filenamePattern.exclude:void 0;if(O.$rk(ye,(0,b.$nc)(de.fsPath).toLowerCase()))return!(De&&O.$rk(De,(0,b.$nc)(de.fsPath).toLowerCase()))}return!1}e.$dK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var p;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class v{static{this.d="notebook/"}static create(ie){return`${v.d}${ie}`}static parse(ie){if(ie.startsWith(v.d))return ie.substring(v.d.length)}}e.$eK=v;function y(G){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(G)}const h=new TextDecoder;function E(G){const ie=[];let de=!1;for(const ue of G)(ie.length===0||de)&&(ie.push(ue),de=!0);let ye=P(ie);const De=C.$He.concat(ie.map(ue=>C.$He.wrap(ue))),ge=z(De);return ye=ye||ge.byteLength!==De.byteLength,{data:ge,didCompression:ye}}e.$hK="\x1B[A";const k=e.$hK.split("").map(G=>G.charCodeAt(0)),I=10;function P(G){let ie=!1;return G.forEach((de,ye)=>{if(ye===0||de.length<e.$hK.length)return;const De=G[ye-1],ge=de.subarray(0,e.$hK.length);if(ge[0]===k[0]&&ge[1]===k[1]&&ge[2]===k[2]){const ue=De.lastIndexOf(I);if(ue===-1)return;ie=!0,G[ye-1]=De.subarray(0,ue),G[ye]=de.subarray(e.$hK.length)}}),ie}function V(G){let ie=G;do G=ie,ie=G.replace(/[^\n]\x08/gm,"");while(ie.length<G.length);return G}function W(G){for(G=G.replace(/\r+\n/gm,`
`);G.search(/\r[^$]/g)>-1;){const ie=G.match(/^(.*)\r+/m)[1];let de=G.match(/\r+(.*)$/m)[1];de=de+ie.slice(de.length,ie.length),G=G.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,de)}return G}const q=8,R=13;function z(G){return!G.buffer.includes(q)&&!G.buffer.includes(R)?G:C.$He.fromString(W(V(h.decode(G.buffer))))}}),define(Se[7],Ie([1,0,18,14,55,28,70,13,15,2,33,21,38,104,85]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g){"use strict";var r,s,o,i,n,c,u,t,f,a,d,$,p,v,y,h,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$BO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$hO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$7N=e.$6N=e.$5N=e.$4N=e.$2N=e.$1N=e.$ZN=e.$YN=e.TestRunProfileKind=e.TestResultState=e.$XN=e.$WN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$VN=e.NotebookVariablesRequestKind=e.$UN=e.$TN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$SN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.ColorThemeKind=e.$MN=e.$LN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$KN=e.$JN=e.DebugConsoleMode=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$DN=e.$CN=e.FileChangeType=e.$BN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$AN=e.$zN=e.$yN=e.$xN=e.InlineCompletionTriggerKind=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$kN=e.ConfigurationTarget=e.$jN=e.$iN=e.$hN=e.$gN=e.DocumentPasteTriggerKind=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$_M=e.ViewBadge=e.ProgressLocation=e.$$M=e.$0M=e.TaskScope=e.ShellQuoting=e.$9M=e.$8M=e.$7M=e.TaskPanelKind=e.TaskRevealKind=e.$6M=e.TerminalLocation=e.$5M=e.$4M=e.$3M=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$2M=e.$1M=e.$ZM=e.$YM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$WM=e.$VM=e.$UM=e.$TM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$SM=e.$RM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.LanguageStatusSeverity=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.CodeActionTriggerKind=e.$FM=e.$EM=e.SymbolTag=e.SymbolKind=e.$DM=e.$CM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.DiagnosticSeverity=e.DiagnosticTag=e.$wM=e.$vM=e.FileEditType=e.$uM=e.$tM=e.$sM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$XM=Vt,e.$lN=Me,e.$3N=Dn;function k(U){return Object.assign(U,{apply:function(...ee){if(ee.length===0)return Reflect.construct(U,[]);{const Ee=ee.length===1?[]:ee[1];return Reflect.construct(U,Ee,ee[0].constructor)}},call:function(...ee){if(ee.length===0)return Reflect.construct(U,[]);{const[Ee,...Ge]=ee;return Reflect.construct(U,Ge,Ee.constructor)}}})}var I;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(I||(e.TerminalOutputAnchor=I={}));var P;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let V=r=class{static from(...L){let ee=L;return new r(function(){if(ee){for(const Ee of ee)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ee=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$lM=V,e.$lM=V=r=Je([k],V);let W=s=class{static Min(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ge=L[Ee];Ge.isBefore(ee)&&(ee=Ge)}return ee}static Max(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ge=L[Ee];Ge.isAfter(ee)&&(ee=Ge)}return ee}static isPosition(L){if(!L)return!1;if(L instanceof s)return!0;const{line:ee,character:Ee}=L;return typeof ee=="number"&&typeof Ee=="number"}static of(L){if(L instanceof s)return L;if(this.isPosition(L))return new s(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,ee){if(L<0)throw(0,O.$7)("line must be non-negative");if(ee<0)throw(0,O.$7)("character must be non-negative");this.c=L,this.e=ee}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,ee=0){if(L===null||ee===null)throw(0,O.$7)();let Ee;return typeof L>"u"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,ee=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&ee===0?this:new s(this.line+Ee,this.character+ee)}with(L,ee=this.character){if(L===null||ee===null)throw(0,O.$7)();let Ee;return typeof L>"u"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,ee=typeof L.character=="number"?L.character:this.character),Ee===this.line&&ee===this.character?this:new s(Ee,ee)}toJSON(){return{line:this.line,character:this.character}}};e.$mM=W,e.$mM=W=s=Je([k],W);let q=o=class{static isRange(L){return L instanceof o?!0:L?W.isPosition(L.start)&&W.isPosition(L.end):!1}static of(L){if(L instanceof o)return L;if(this.isRange(L))return new o(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,ee,Ee,Ge){let Ye,lt;if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(Ye=new W(L,ee),lt=new W(Ee,Ge)):W.isPosition(L)&&W.isPosition(ee)&&(Ye=W.of(L),lt=W.of(ee)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(L){return o.isRange(L)?this.contains(L.start)&&this.contains(L.end):W.isPosition(L)?!(W.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const ee=W.Max(L.start,this.c),Ee=W.Min(L.end,this.e);if(!ee.isAfter(Ee))return new o(ee,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ee=W.Min(L.start,this.c),Ee=W.Max(L.end,this.end);return new o(ee,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,ee=this.end){if(L===null||ee===null)throw(0,O.$7)();let Ee;return L?W.isPosition(L)?Ee=L:(Ee=L.start||this.start,ee=L.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&ee.isEqual(this.end)?this:new o(Ee,ee)}toJSON(){return[this.start,this.end]}};e.$nM=q,e.$nM=q=o=Je([k],q);let R=i=class extends q{static isSelection(L){return L instanceof i?!0:L?q.isRange(L)&&W.isPosition(L.anchor)&&W.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,ee,Ee,Ge){let Ye,lt;if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(Ye=new W(L,ee),lt=new W(Ee,Ge)):W.isPosition(L)&&W.isPosition(ee)&&(Ye=W.of(L),lt=W.of(ee)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$oM=R,e.$oM=R=i=Je([k],R);const z=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,O.$7)("connectionToken")};class G{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ee,Ee){if(typeof L!="string"||L.length===0)throw(0,O.$7)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,O.$7)("port");typeof Ee<"u"&&z(Ee),this.host=L,this.port=Math.round(ee),this.connectionToken=Ee}}e.$pM=G;class ie{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ee){this.makeConnection=L,this.connectionToken=ee,typeof ee<"u"&&z(ee)}}e.$qM=ie;class de extends Error{static NotAvailable(L,ee){return new de(L,w.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(L){return new de(L,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ee=w.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L),this._message=L,this._code=ee,this._detail=Ee,Object.setPrototypeOf(this,de.prototype)}}e.$rM=de;var ye;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var De;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(De||(e.EnvironmentVariableMutatorType=De={}));let ge=n=class{static isTextEdit(L){return L instanceof n?!0:L?q.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ee){return new n(L,ee)}static insert(L,ee){return n.replace(new q(L,L),ee)}static delete(L){return n.replace(L,"")}static setEndOfLine(L){const ee=new n(new q(new W(0,0),new W(0,0)),"");return ee.newEol=L,ee}get range(){return this.c}set range(L){if(L&&!q.isRange(L))throw(0,O.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,O.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,O.$7)("newEol");this.f=L}constructor(L,ee){this.c=L,this.e=ee}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$sM=ge,e.$sM=ge=n=Je([k],ge);let ue=c=class{static isNotebookCellEdit(L){return L instanceof c?!0:L?gi.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ee){return new c(L,ee)}static insertCells(L,ee){return new c(new gi(L,L),ee)}static deleteCells(L){return new c(L,[])}static updateCellMetadata(L,ee){const Ee=new c(new gi(L,L),[]);return Ee.newCellMetadata=ee,Ee}static updateNotebookMetadata(L){const ee=new c(new gi(0,0),[]);return ee.newNotebookMetadata=L,ee}constructor(L,ee){this.range=L,this.newCells=ee}};e.$tM=ue,e.$tM=ue=c=Je([k],ue);class Ce{static isSnippetTextEdit(L){return L instanceof Ce?!0:L?q.isRange(L.range)&&ne.isSnippetString(L.snippet):!1}static replace(L,ee){return new Ce(L,ee)}static insert(L,ee){return Ce.replace(new q(L,L),ee)}constructor(L,ee){this.range=L,this.snippet=ee}}e.$uM=Ce;var se;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,ee,Ee,Ge){this.c.push({_type:1,from:L,to:ee,options:Ee,metadata:Ge})}createFile(L,ee,Ee){this.c.push({_type:1,from:void 0,to:L,options:ee,metadata:Ee})}deleteFile(L,ee,Ee){this.c.push({_type:1,from:L,to:void 0,options:ee,metadata:Ee})}e(L,ee,Ee){this.c.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:ee},notebookMetadata:ee})}f(L,ee,Ee,Ge){const Ye=ee.start,lt=ee.end;(Ye!==lt||Ee.length>0)&&this.c.push({_type:5,uri:L,index:Ye,count:lt-Ye,cells:Ee,metadata:Ge})}g(L,ee,Ee,Ge){this.c.push({_type:3,metadata:Ge,uri:L,edit:{editType:3,index:ee,metadata:Ee}})}replace(L,ee,Ee,Ge){this.c.push({_type:2,uri:L,edit:new ge(ee,Ee),metadata:Ge})}insert(L,ee,Ee,Ge){this.replace(L,new q(ee,ee),Ee,Ge)}delete(L,ee,Ee){this.replace(L,ee,"",Ee)}has(L){return this.c.some(ee=>ee._type===2&&ee.uri.toString()===L.toString())}set(L,ee){if(ee)for(const Ee of ee){if(!Ee)continue;let Ge,Ye;Array.isArray(Ee)?(Ge=Ee[0],Ye=Ee[1]):Ge=Ee,ue.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(L,Ge.range.start,Ge.newCellMetadata,Ye):Ge.newNotebookMetadata?this.e(L,Ge.newNotebookMetadata,Ye):this.f(L,Ge.range,Ge.newCells,Ye):Ce.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:L,range:Ge.range,edit:Ge.snippet,metadata:Ye}):this.c.push({_type:2,uri:L,edit:Ge,metadata:Ye})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ge=this.c[Ee];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===L.toString()&&(this.c[Ee]=void 0);break}}(0,C.$Ib)(this.c)}}get(L){const ee=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===L.toString()&&ee.push(Ee.edit);return ee}entries(){const L=new T.$Ac;for(const ee of this.c)if(ee._type===2){let Ee=L.get(ee.uri);Ee||(Ee=[ee.uri,[]],L.set(ee.uri,Ee)),Ee[1].push(ee.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$vM=Oe,e.$vM=Oe=Je([k],Oe);let ne=u=class{static isSnippetString(L){return L instanceof u?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=u.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ee=this.e++){if(typeof L=="function"){const Ee=new u;Ee.e=this.e,L(Ee),this.e=Ee.e,L=Ee.value}else L=u.c(L);return this.value+="${",this.value+=ee,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ee=this.e++){const Ee=L.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,ee){if(typeof ee=="function"){const Ee=new u;Ee.e=this.e,ee(Ee),this.e=Ee.e,ee=Ee.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};e.$wM=ne,e.$wM=ne=u=Je([k],ne);var j;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(j||(e.DiagnosticTag=j={}));var x;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let ve=t=class{static isLocation(L){return L instanceof t?!0:L?q.isRange(L.range)&&D.URI.isUri(L.uri):!1}constructor(L,ee){if(this.uri=L,ee)if(q.isRange(ee))this.range=q.of(ee);else if(W.isPosition(ee))this.range=new q(ee,ee);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$xM=ve,e.$xM=ve=t=Je([k],ve);let Le=class{static is(L){return L?typeof L.message=="string"&&L.location&&q.isRange(L.location.range)&&D.URI.isUri(L.location.uri):!1}constructor(L,ee){this.location=L,this.message=ee}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.location.range.isEqual(ee.location.range)&&L.location.uri.toString()===ee.location.uri.toString()}};e.$yM=Le,e.$yM=Le=Je([k],Le);let ke=class{constructor(L,ee,Ee=x.Error){if(!q.isRange(L))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=L,this.message=ee,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.severity===ee.severity&&L.code===ee.code&&L.severity===ee.severity&&L.source===ee.source&&L.range.isEqual(ee.range)&&(0,C.$ub)(L.tags,ee.tags)&&(0,C.$ub)(L.relatedInformation,ee.relatedInformation,Le.isEqual)}};e.$zM=ke,e.$zM=ke=Je([k],ke);let be=class{constructor(L,ee){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ee}};e.$AM=be,e.$AM=be=Je([k],be);let me=class extends be{constructor(L,ee,Ee,Ge){super(L,ee),this.canIncreaseHover=Ee,this.canDecreaseHover=Ge}};e.$BM=me,e.$BM=me=Je([k],me);var Q;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var Y;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let he=class{constructor(L,ee=Y.Text){this.range=L,this.kind=ee}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$CM=he,e.$CM=he=Je([k],he);let ce=class{constructor(L,ee){this.uri=L,this.highlights=ee}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$DM=ce,e.$DM=ce=Je([k],ce);var Te;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Te||(e.SymbolKind=Te={}));var fe;(function(U){U[U.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Pe=f=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ee,Ee,Ge,Ye){this.name=L,this.kind=ee,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),Ge instanceof ve?this.location=Ge:Ee instanceof q&&(this.location=new ve(Ge,Ee)),f.validate(this)}toJSON(){return{name:this.name,kind:Te[this.kind],location:this.location,containerName:this.containerName}}};e.$EM=Pe,e.$EM=Pe=f=Je([k],Pe);let Re=a=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(a.validate)}constructor(L,ee,Ee,Ge,Ye){this.name=L,this.detail=ee,this.kind=Ee,this.range=Ge,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$FM=Re,e.$FM=Re=a=Je([k],Re);var Ue;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(Ue||(e.CodeActionTriggerKind=Ue={}));let B=class{constructor(L,ee){this.title=L,this.kind=ee}};e.$GM=B,e.$GM=B=Je([k],B);let F=class{static{d=this}static{this.c="."}constructor(L){this.value=L}append(L){return new d(this.value?this.value+d.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+d.c)}};e.$HM=F,e.$HM=F=d=Je([k],F),F.Empty=new F(""),F.QuickFix=F.Empty.append("quickfix"),F.Refactor=F.Empty.append("refactor"),F.RefactorExtract=F.Refactor.append("extract"),F.RefactorInline=F.Refactor.append("inline"),F.RefactorMove=F.Refactor.append("move"),F.RefactorRewrite=F.Refactor.append("rewrite"),F.Source=F.Empty.append("source"),F.SourceOrganizeImports=F.Source.append("organizeImports"),F.SourceFixAll=F.Source.append("fixAll"),F.Notebook=F.Empty.append("notebook");let H=class{constructor(L,ee){if(this.range=L,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$IM=H,e.$IM=H=Je([k],H);class K{constructor(L,ee,Ee,Ge,Ye,lt){this.kind=L,this.name=ee,this.detail=Ee,this.uri=Ge,this.range=Ye,this.selectionRange=lt}}e.$JM=K;class te{constructor(L,ee){this.fromRanges=ee,this.from=L}}e.$KM=te;class re{constructor(L,ee){this.fromRanges=ee,this.to=L}}e.$LM=re;var Ne;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Be=class{constructor(L,ee){this.range=L,this.command=ee}get isResolved(){return!!this.command}};e.$MM=Be,e.$MM=Be=Je([k],Be);let Ke=$=class{#e;static isMarkdownString(L){return L instanceof $?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ee=!1){this.#e=new M.$Vk(L,{supportThemeIcons:ee})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,ee){return this.#e.appendCodeblock(ee??"",L),this}};e.$NM=Ke,e.$NM=Ke=$=Je([k],Ke);let _e=class{constructor(L,ee){this.label=L,this.documentation=ee}};e.$OM=_e,e.$OM=_e=Je([k],_e);let xe=class{constructor(L,ee){this.label=L,this.documentation=ee,this.parameters=[]}};e.$PM=xe,e.$PM=xe=Je([k],xe);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$QM=et,e.$QM=et=Je([k],et);var tt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var it;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let ot=class{constructor(L){this.value=L}};e.$RM=ot,e.$RM=ot=Je([k],ot);let gt=class{constructor(L,ee,Ee){this.position=L,this.label=ee,this.kind=Ee}};e.$SM=gt,e.$SM=gt=Je([k],gt);var je;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var rt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(rt||(e.CompletionItemKind=rt={}));var Z;(function(U){U[U.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let X=class{constructor(L,ee){this.label=L,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$TM=X,e.$TM=X=Je([k],X);let $e=class{constructor(L=[],ee=!1){this.items=L,this.isIncomplete=ee}};e.$UM=$e,e.$UM=$e=Je([k],$e);let He=class{constructor(L,ee,Ee){this.insertText=L,this.range=ee,this.command=Ee}};e.$VM=He,e.$VM=He=Je([k],He);let we=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$WM=we,e.$WM=we=Je([k],we);var st;(function(U){U[U.Unknown=0]="Unknown",U[U.Word=1]="Word",U[U.Line=2]="Line",U[U.Suggest=3]="Suggest"})(st||(e.PartialAcceptTriggerKind=st={}));var dt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var Ct;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ct||(e.StatusBarAlignment=Ct={}));function Vt(U,L){return`${S.$Tm.toKey(U)}.${L}`}var Qt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative",U[U.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var ii;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(ii||(e.TextDocumentSaveReason=ii={}));var Xt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Xt||(e.TextEditorRevealType=Xt={}));var Dt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Dt||(e.TextEditorSelectionChangeKind=Dt={}));var Zt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var Yt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(U){function L(ee){switch(ee){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(Dt||(e.TextEditorSelectionChangeKind=Dt={}));var Ze;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Ze||(e.SyntaxTokenType=Ze={})),function(U){function L(ee){switch(ee){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=L}(Ze||(e.SyntaxTokenType=Ze={}));let si=class{constructor(L,ee){if(ee&&!D.URI.isUri(ee))throw(0,O.$7)("target");if(!q.isRange(L)||L.isEmpty)throw(0,O.$7)("range");this.range=L,this.target=ee}};e.$YM=si,e.$YM=si=Je([k],si);let Kt=class{constructor(L,ee,Ee,Ge){this.red=L,this.green=ee,this.blue=Ee,this.alpha=Ge}};e.$ZM=Kt,e.$ZM=Kt=Je([k],Kt);let ht=class{constructor(L,ee){if(ee&&!(ee instanceof Kt))throw(0,O.$7)("color");if(!q.isRange(L)||L.isEmpty)throw(0,O.$7)("range");this.range=L,this.color=ee}};e.$1M=ht,e.$1M=ht=Je([k],ht);let mt=class{constructor(L){if(!L||typeof L!="string")throw(0,O.$7)("label");this.label=L}};e.$2M=mt,e.$2M=mt=Je([k],mt);var xt;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(xt||(e.ColorFormat=xt={}));var Gt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Gt||(e.SourceControlInputBoxValidationType=Gt={}));var Tt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Tt||(e.TerminalExitReason=Tt={}));var ft;(function(U){U[U.Low=0]="Low",U[U.Medium=1]="Medium",U[U.High=2]="High"})(ft||(e.TerminalShellExecutionCommandLineConfidence=ft={}));class Bt{constructor(L,ee,Ee){if(this.startIndex=L,this.length=ee,this.tooltip=Ee,typeof L!="number"||L<0)throw(0,O.$7)("startIndex");if(typeof ee!="number"||ee<1)throw(0,O.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,O.$7)("tooltip")}}e.$3M=Bt;class _t{constructor(L){this.uri=L}}e.$4M=_t;class zt{constructor(L){this.terminalCommand=L}}e.$5M=zt;var Qe;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ui{constructor(L){if(this.options=L,typeof L!="object")throw(0,O.$7)("options")}}e.$6M=ui;var Jt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var jt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(jt||(e.TaskPanelKind=jt={}));let bt=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(L){switch(L){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(L,ee){if(this.label=ee,typeof L!="string"||typeof ee!="string")throw(0,O.$7)("name");this.c=L}get id(){return this.c}};e.$7M=bt,e.$7M=bt=p=Je([k],bt);function Ut(U){let L="";for(let ee=0;ee<U.length;ee++)L+=U[ee].replace(/,/g,",,")+",";return L}let Mt=class{constructor(L,ee,Ee){if(typeof L!="string")throw(0,O.$7)("process");this.e=[],this.c=L,ee!==void 0&&(Array.isArray(ee)?(this.e=ee,this.f=Ee):this.f=ee)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,O.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const ee of this.e)L.push(ee);return Ut(L)}};e.$8M=Mt,e.$8M=Mt=Je([k],Mt);let At=class{constructor(L,ee,Ee){if(this.f=[],Array.isArray(ee)){if(!L)throw(0,O.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,O.$7)("command");this.e=L,this.f=ee,this.g=Ee}else{if(typeof L!="string")throw(0,O.$7)("commandLine");this.c=L,this.g=ee}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,O.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,O.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ee of this.f)L.push(typeof ee=="string"?ee:ee.value);return Ut(L)}};e.$9M=At,e.$9M=At=Je([k],At);var ei;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ei||(e.ShellQuoting=ei={}));var Wt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Wt||(e.TaskScope=Wt={}));class oi{constructor(L){this.c=L}computeId(){return"customExecution"+(0,N.$Ug)()}set callback(L){this.c=L}get callback(){return this.c}}e.$0M=oi;let Ot=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,ee,Ee,Ge,Ye,lt){this.k=!1,this.l=this.definition=L;let pt;typeof ee=="string"?(this.o=this.name=ee,this.w=this.source=Ee,this.execution=Ge,pt=Ye,this.k=!0):ee===Wt.Global||ee===Wt.Workspace?(this.target=ee,this.o=this.name=Ee,this.w=this.source=Ge,this.execution=Ye,pt=lt):(this.target=ee,this.o=this.name=Ee,this.w=this.source=Ge,this.execution=Ye,pt=lt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Mt?this.l={type:v.e,id:this.q.computeId()}:this.q instanceof At?this.l={type:v.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:v.c,id:this.q.computeId()}:this.l={type:v.g,id:(0,N.$Ug)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,O.$7)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const ee=this.l.type;(v.g===ee||v.e===ee||v.f===ee||v.c===ee)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$$M=Ot,e.$$M=Ot=v=Je([k],Ot);var qt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(qt||(e.ProgressLocation=qt={}));var Rt;(function(U){function L(ee){const Ee=ee;return(0,m.$cg)(Ee.value)?Ee.tooltip&&!(0,m.$$f)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}U.isViewBadge=L})(Rt||(e.ViewBadge=Rt={}));let St=y=class{static isTreeItem(L,ee){const Ee=L;if(Ee.checkboxState!==void 0){const Ge=(0,m.$cg)(Ee.checkboxState)?Ee.checkboxState:(0,m.$ag)(Ee.checkboxState)&&(0,m.$cg)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Ye=!(0,m.$cg)(Ee.checkboxState)&&(0,m.$ag)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Et.Checked&&Ge!==Et.Unchecked||Ye!==void 0&&!(0,m.$$f)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(L instanceof y)return!0;if(Ee.label!==void 0&&!(0,m.$$f)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,m.$$f)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,m.$$f)(Ee.iconPath)&&!D.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,m.$$f)(Ee.iconPath.id))){const Ge=Ee.iconPath;if(!Ge||!(0,m.$$f)(Ge.light)&&!D.URI.isUri(Ge.light)&&!(0,m.$$f)(Ge.dark)&&!D.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,m.$$f)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!D.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,m.$$f)(Ee.tooltip)&&!(Ee.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<$t.None&&Ee.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,m.$$f)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(L,ee=$t.None){this.collapsibleState=ee,D.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$_M=St,e.$_M=St=y=Je([k],St);var $t;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var Et;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let ai=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$aN=ai,e.$aN=ai=Je([k],ai);class kt extends ai{}e.$bN=kt;class fi extends kt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$cN=fi;class ni{constructor(L,ee,Ee,Ge){this.name=L,this.uri=ee,this._itemId=Ee,this.c=Ge}data(){return this.c()}}e.$dN=ni;let $i=class{#e=new Map;constructor(L){for(const[ee,Ee]of L??[]){const Ge=this.#e.get(this.#t(ee));Ge?Ge.push(Ee):this.#e.set(this.#t(ee),[Ee])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,ee){this.#e.set(this.#t(L),[ee])}forEach(L,ee){for(const[Ee,Ge]of this.#e)for(const Ye of Ge)L.call(ee,Ye,Ee,this)}*[Symbol.iterator](){for(const[L,ee]of this.#e)for(const Ee of ee)yield[L,Ee]}#t(L){return L.toLowerCase()}};e.$eN=$i,e.$eN=$i=Je([k],$i);let li=class{constructor(L,ee,Ee){this.insertText=L,this.title=ee,this.kind=Ee}};e.$fN=li,e.$fN=li=Je([k],li);var wi;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class It{static{this.c="."}constructor(L){this.value=L}append(...L){return new It((this.value?[this.value,...L]:L).join(It.c))}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+It.c)}}e.$gN=It,It.Empty=new It("");class Di{constructor(L,ee,Ee){this.title=ee,this.insertText=L,this.kind=Ee}}e.$hN=Di;let ri=class{constructor(L,ee){this.id=L,this.color=ee}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$iN=ri,e.$iN=ri=Je([k],ri),ri.File=new ri("file"),ri.Folder=new ri("folder");let pe=class{constructor(L){this.id=L}};e.$jN=pe,e.$jN=pe=Je([k],pe);var Ae;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Ae||(e.ConfigurationTarget=Ae={}));let ae=class{get base(){return this.c}set base(L){this.c=L,this.e=D.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,ee){if(typeof L!="string"&&(!L||!D.URI.isUri(L)&&!D.URI.isUri(L.uri)))throw(0,O.$7)("base");if(typeof ee!="string")throw(0,O.$7)("pattern");typeof L=="string"?this.baseUri=D.URI.file(L):D.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ee}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$kN=ae,e.$kN=ae=Je([k],ae);const J=new WeakMap;function Me(U,L){J.set(U,L)}let Ve=class{constructor(L,ee,Ee,Ge,Ye){this.enabled=typeof L=="boolean"?L:!0,typeof ee=="string"&&(this.condition=ee),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ge=="string"&&(this.logMessage=Ge),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=J.get(this)??(0,N.$Ug)()),this.c}};e.$mN=Ve,e.$mN=Ve=Je([k],Ve);let Xe=class extends Ve{constructor(L,ee,Ee,Ge,Ye,lt){if(super(ee,Ee,Ge,Ye,lt),L===null)throw(0,O.$7)("location");this.location=L}};e.$nN=Xe,e.$nN=Xe=Je([k],Xe);let qe=class extends Ve{constructor(L,ee,Ee,Ge,Ye,lt){super(ee,Ee,Ge,Ye,lt),this.functionName=L}};e.$oN=qe,e.$oN=qe=Je([k],qe);let ut=class extends Ve{constructor(L,ee,Ee,Ge,Ye,lt,pt,Ht){if(super(Ge,Ye,lt,pt,Ht),!ee)throw(0,O.$7)("dataId");this.label=L,this.dataId=ee,this.canPersist=Ee}};e.$pN=ut,e.$pN=ut=Je([k],ut);let yt=class{constructor(L,ee,Ee){this.command=L,this.args=ee||[],this.options=Ee}};e.$qN=yt,e.$qN=yt=Je([k],yt);let Lt=class{constructor(L,ee){this.port=L,this.host=ee}};e.$rN=Lt,e.$rN=Lt=Je([k],Lt);let ct=class{constructor(L){this.path=L}};e.$sN=ct,e.$sN=ct=Je([k],ct);let Nt=class{constructor(L){this.implementation=L}};e.$tN=Nt,e.$tN=Nt=Je([k],Nt);class Ft{constructor(L,ee,Ee){this.session=L,this.threadId=ee,this.frameId=Ee}}e.$uN=Ft;class Ei{constructor(L,ee){this.session=L,this.threadId=ee}}e.$vN=Ei;let Ii=class{constructor(L,ee){this.range=L,this.expression=ee}};e.$wN=Ii,e.$wN=Ii=Je([k],Ii);var Ji;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let Oi=class{constructor(L,ee){this.range=L,this.text=ee}};e.$xN=Oi,e.$xN=Oi=Je([k],Oi);let Ni=class{constructor(L,ee,Ee=!0){this.range=L,this.variableName=ee,this.caseSensitiveLookup=Ee}};e.$yN=Ni,e.$yN=Ni=Je([k],Ni);let Ci=class{constructor(L,ee){this.range=L,this.expression=ee}};e.$zN=Ci,e.$zN=Ci=Je([k],Ci);let Ti=class{constructor(L,ee){this.frameId=L,this.stoppedLocation=ee}};e.$AN=Ti,e.$AN=Ti=Je([k],Ti);var Li;(function(U){U[U.AIGenerated=1]="AIGenerated"})(Li||(e.NewSymbolNameTag=Li={}));var Qi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Qi||(e.NewSymbolNameTriggerKind=Qi={}));class Fi{constructor(L,ee){this.newSymbolName=L,this.tags=ee}}e.$BN=Fi;var Pi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Pi||(e.FileChangeType=Pi={}));let zi=h=class extends Error{static FileExists(L){return new h(L,l.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(L){return new h(L,l.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(L){return new h(L,l.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(L){return new h(L,l.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(L){return new h(L,l.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(L){return new h(L,l.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(L,ee=l.FileSystemProviderErrorCode.Unknown,Ee){super(D.URI.isUri(L)?L.toString(!0):L),this.code=Ee?.name??"Unknown",(0,l.$hl)(this,ee),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$CN=zi,e.$CN=zi=h=Je([k],zi);let ji=class{constructor(L,ee,Ee){this.start=L,this.end=ee,this.kind=Ee}};e.$DN=ji,e.$DN=ji=Je([k],ji);var vi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(vi||(e.FoldingRangeKind=vi={}));var Xi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Xi||(e.CommentThreadCollapsibleState=Xi={}));var Zi;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Mi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Mi||(e.CommentState=Mi={}));var Yi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(Yi||(e.CommentThreadState=Yi={}));var Ui;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(Ui||(e.CommentThreadApplicability=Ui={}));class gn{constructor(L,ee=[]){this.tokenTypes=L,this.tokenModifiers=ee}}e.$EN=gn;function xi(U){return typeof U>"u"||(0,m.$_f)(U)}class Bi{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let ee=0,Ee=L.tokenTypes.length;ee<Ee;ee++)this.k.set(L.tokenTypes[ee],ee);for(let ee=0,Ee=L.tokenModifiers.length;ee<Ee;ee++)this.l.set(L.tokenModifiers[ee],ee)}}push(L,ee,Ee,Ge,Ye){if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof Ge=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(L,ee,Ee,Ge,Ye);if(q.isRange(L)&&typeof ee=="string"&&xi(Ee))return this.o(L,ee,Ee);throw(0,O.$7)()}o(L,ee,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ee))throw new Error("`tokenType` is not in the provided legend");const Ge=L.start.line,Ye=L.start.character,lt=L.end.character-L.start.character,pt=this.k.get(ee);let Ht=0;if(Ee)for(const ci of Ee){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const di=this.l.get(ci);Ht|=1<<di>>>0}this.q(Ge,Ye,lt,pt,Ht)}q(L,ee,Ee,Ge,Ye){if(this.f&&(L<this.c||L===this.c&&ee<this.e)){this.f=!1;const Ht=this.g.length/5|0;let ci=0,di=0;for(let mi=0;mi<Ht;mi++){let bi=this.g[5*mi],Ki=this.g[5*mi+1];bi===0?(bi=ci,Ki+=di):bi+=ci,this.g[5*mi]=bi,this.g[5*mi+1]=Ki,ci=bi,di=Ki}}let lt=L,pt=ee;this.f&&this.j>0&&(lt-=this.c,lt===0&&(pt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=pt,this.g[this.j++]=Ee,this.g[this.j++]=Ge,this.g[this.j++]=Ye,this.c=L,this.e=ee}static r(L){const ee=[],Ee=L.length/5|0;for(let pt=0;pt<Ee;pt++)ee[pt]=pt;ee.sort((pt,Ht)=>{const ci=L[5*pt],di=L[5*Ht];if(ci===di){const mi=L[5*pt+1],bi=L[5*Ht+1];return mi-bi}return ci-di});const Ge=new Uint32Array(L.length);let Ye=0,lt=0;for(let pt=0;pt<Ee;pt++){const Ht=5*ee[pt],ci=L[Ht+0],di=L[Ht+1],mi=L[Ht+2],bi=L[Ht+3],Ki=L[Ht+4],zn=ci-Ye,br=zn===0?di-lt:di,Gi=5*pt;Ge[Gi+0]=zn,Ge[Gi+1]=br,Ge[Gi+2]=mi,Ge[Gi+3]=bi,Ge[Gi+4]=Ki,Ye=ci,lt=di}return Ge}build(L){return this.f?new pi(new Uint32Array(this.g),L):new pi(Bi.r(this.g),L)}}e.$FN=Bi;class pi{constructor(L,ee){this.resultId=ee,this.data=L}}e.$GN=pi;class mn{constructor(L,ee,Ee){this.start=L,this.deleteCount=ee,this.data=Ee}}e.$HN=mn;class $n{constructor(L,ee){this.resultId=ee,this.edits=L}}e.$IN=$n;var _i;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class Vi{constructor(L){this.name=L}}e.$JN=Vi;let Ri=class{static{this.Back={iconPath:new ri("arrow-left")}}constructor(){}};e.$KN=Ri,e.$KN=Ri=Je([k],Ri);var ze;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(ze||(e.QuickPickItemKind=ze={}));var hi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(hi||(e.InputBoxValidationSeverity=hi={}));var Wi;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Wi||(e.ExtensionKind=Wi={}));class nt{static validate(L){if(typeof L.badge=="string"){let ee=(0,b.$Jf)(L.badge,0);if(ee<L.badge.length&&(ee+=(0,b.$Jf)(L.badge,ee)),L.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!ri.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ee,Ee){this.badge=L,this.tooltip=ee,this.color=Ee}}e.$LN=nt;let wt=class{constructor(L){this.kind=L}};e.$MN=wt,e.$MN=wt=Je([k],wt);var en;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class gi{static isNotebookRange(L){return L instanceof gi?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,ee){if(L<0)throw(0,O.$7)("start must be positive");if(ee<0)throw(0,O.$7)("end must be positive");L<=ee?(this.c=L,this.e=ee):(this.c=ee,this.e=L)}with(L){let ee=this.c,Ee=this.e;return L.start!==void 0&&(ee=L.start),L.end!==void 0&&(Ee=L.end),ee===this.c&&Ee===this.e?this:new gi(ee,Ee)}}e.$NN=gi;class ki{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ee=>ki.isNotebookCellData(ee))}static isNotebookCellData(L){return!0}constructor(L,ee,Ee,Ge,Ye,lt,pt){this.kind=L,this.value=ee,this.languageId=Ee,this.mime=Ge,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=pt,ki.validate(this)}}e.$ON=ki;class pn{constructor(L){this.cells=L}}e.$PN=pn;class ti{static isNotebookCellOutputItem(L){return L instanceof ti?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ee={name:L.name,message:L.message,stack:L.stack};return ti.json(ee,"application/vnd.code.notebook.error")}static stdout(L){return ti.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return ti.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ee="application/octet-stream"){return new ti(L,ee)}static#e=new TextEncoder;static text(L,ee=A.$Us.text){const Ee=ti.#e.encode(String(L));return new ti(Ee,ee)}static json(L,ee="text/x-json"){const Ee=JSON.stringify(L,void 0,"	");return ti.text(Ee,ee)}constructor(L,ee){this.data=L,this.mime=ee;const Ee=(0,A.$Ys)(ee,!0);if(!Ee)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$QN=ti;class Ai{static isNotebookCellOutput(L){return L instanceof Ai?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ee=!1){const Ee=new Set,Ge=new Set;for(let Ye=0;Ye<L.length;Ye++){const lt=L[Ye],pt=(0,A.$Ys)(lt.mime);if(!Ee.has(pt)||(0,g.$fK)(pt)){Ee.add(pt);continue}Ge.add(Ye),ee&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?L:L.filter((Ye,lt)=>!Ge.has(lt))}constructor(L,ee,Ee){this.items=Ai.ensureUniqueMimeTypes(L,!0),typeof ee=="string"?(this.id=ee,this.metadata=Ee):(this.id=(0,N.$Ug)(),this.metadata=ee??Ee)}}e.$RN=Ai;var tn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var qi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(qi||(e.NotebookCellStatusBarAlignment=qi={}));var rn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class bn{constructor(L,ee){this.text=L,this.alignment=ee}}e.$SN=bn;var sn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class wn{constructor(L,ee=[]){this.uri=L,this.provides=(0,C.$2b)(ee)}}e.$TN=wn;class vn{constructor(L){this.label=L}}e.$UN=vn;var an;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let Hi=class{constructor(L,ee){this.label=L,this.timestamp=ee}};e.$VN=Hi,e.$VN=Hi=Je([k],Hi);var cn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var ln;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class _{constructor(L,ee){this.ranges=L,this.wordPattern=ee}}e.$WN=_;class oe{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$XN=oe;var Fe;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Fe||(e.TestResultState=Fe={}));var at;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(at||(e.TestRunProfileKind=at={}));let vt=class{constructor(L=void 0,ee=void 0,Ee=void 0,Ge=!1,Ye=!0){this.include=L,this.exclude=ee,this.profile=Ee,this.continuous=Ge,this.preserveFocus=Ye}};e.$YN=vt,e.$YN=vt=Je([k],vt);let Pt=E=class{static diff(L,ee,Ee){const Ge=new E(L);return Ge.expectedOutput=ee,Ge.actualOutput=Ee,Ge}constructor(L){this.message=L}};e.$ZN=Pt,e.$ZN=Pt=E=Je([k],Pt);let Si=class{constructor(L){this.id=L}};e.$1N=Si,e.$1N=Si=Je([k],Si);class hn{constructor(L,ee){this.covered=L,this.total=ee,Dn(this)}}e.$2N=hn;function Dn(U){if(U){if(U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`);if(U.total<0)throw new Error(`The number of covered items (${U.total}) cannot be negative`)}}class yn{static fromDetails(L,ee){const Ee=new hn(0,0),Ge=new hn(0,0),Ye=new hn(0,0);for(const pt of ee)if("branches"in pt){Ee.total+=1,Ee.covered+=pt.executed?1:0;for(const Ht of pt.branches)Ge.total+=1,Ge.covered+=Ht.executed?1:0}else Ye.total+=1,Ye.covered+=pt.executed?1:0;const lt=new yn(L,Ee,Ge.total>0?Ge:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=ee,lt}constructor(L,ee,Ee,Ge,Ye){this.uri=L,this.statementCoverage=ee,this.branchCoverage=Ee,this.declarationCoverage=Ge,this.testItem=Ye}}e.$4N=yn;class jn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ee,Ee=[]){this.executed=L,this.location=ee,this.branches=Ee}}e.$5N=jn;class Un{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ee,Ee){this.executed=L,this.location=ee,this.label=Ee}}e.$6N=Un;class Bn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ee,Ee){this.name=L,this.executed=ee,this.location=Ee}}e.$7N=Bn;var En;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(En||(e.ExternalUriOpenerPriority=En={}));var kn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(kn||(e.WorkspaceTrustState=kn={}));var Sn;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn||(e.PortAutoForwardAction=Sn={}));class Vn{constructor(L,ee,Ee,Ge,Ye,lt){this.kind=L,this.name=ee,this.detail=Ee,this.uri=Ge,this.range=Ye,this.selectionRange=lt}}e.$8N=Vn;class Wn{constructor(L){this.uri=L}}e.$9N=Wn;class qn{constructor(L,ee){this.original=L,this.modified=ee}}e.$0N=qn;class Hn{constructor(L,ee,Ee,Ge){this.base=L,this.input1=ee,this.input2=Ee,this.result=Ge}}e.$$N=Hn;class Kn{constructor(L,ee){this.uri=L,this.viewType=ee}}e.$_N=Kn;class Gn{constructor(L){this.viewType=L}}e.$aO=Gn;class Jn{constructor(L,ee){this.uri=L,this.notebookType=ee}}e.$bO=Jn;class Qn{constructor(L,ee,Ee){this.original=L,this.modified=ee,this.notebookType=Ee}}e.$cO=Qn;class Xn{constructor(){}}e.$dO=Xn;class Zn{constructor(L,ee){this.uri=L,this.inputBoxUri=ee}}e.$eO=Zn;class Yn{constructor(){}}e.$fO=Yn;class xn{constructor(L){this.textDiffs=L}}e.$gO=xn;var In;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(In||(e.InteractiveSessionVoteDirection=In={}));var Cn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(Cn||(e.ChatCopyKind=Cn={}));var Pn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Pn||(e.ChatVariableLevel=Pn={}));class _n{constructor(L,ee){this.label=L,this.values=ee}}e.$hO=_n;var Mn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var Rn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Rn||(e.ChatResultFeedbackKind=Rn={}));class er{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ke(L):L}}e.$iO=er;class tr{constructor(L,ee){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ke(L):L,this.vulnerabilities=ee}}e.$jO=tr;class ir{constructor(L,ee){this.participant=L,this.command=ee}}e.$kO=ir;class nr{constructor(L,ee,Ee){this.title=L,this.message=ee,this.data=Ee}}e.$lO=nr;class rr{constructor(L,ee){this.value=L,this.baseUri=ee}}e.$mO=rr;class sr{constructor(L,ee){this.value=L,this.title=ee}}e.$nO=sr;class or{constructor(L){this.value=L}}e.$oO=or;class ar{constructor(L,ee){this.value=L,this.task=ee}}e.$pO=ar;class cr{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ke(L):L}}e.$qO=cr;class ur{constructor(L){this.value=L}}e.$rO=ur;class lr{constructor(L,ee){this.value=L,this.iconPath=ee}}e.$sO=lr;class hr{constructor(L,ee){this.uri=L,this.edits=Array.isArray(ee)?ee:[ee]}}e.$tO=hr;class dr{constructor(L,ee,Ee,Ge){this.prompt=L,this.command=ee,this.variables=Ee,this.participant=Ge}}e.$uO=dr;class fr{constructor(L,ee,Ee,Ge){this.response=L,this.result=ee,this.participant=Ee,this.command=Ge}}e.$vO=fr;var An;(function(U){U[U.Panel=1]="Panel",U[U.Terminal=2]="Terminal",U[U.Notebook=3]="Notebook",U[U.Editor=4]="Editor"})(An||(e.ChatLocation=An={}));var dn;(function(U){U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.System=3]="System"})(dn||(e.LanguageModelChatMessageRole=dn={}));class fn{static User(L,ee){return new fn(dn.User,L,ee)}static Assistant(L,ee){return new fn(dn.Assistant,L,ee)}constructor(L,ee,Ee){this.role=L,this.content=ee,this.name=Ee}}e.$wO=fn;class gr{constructor(L){this.content=L}}e.$xO=gr;class mr{constructor(L,ee){this.content=L,this.name=ee}}e.$yO=mr;class $r{constructor(L,ee){this.content=L,this.name=ee}}e.$zO=$r;class yi extends Error{static NotFound(L){return new yi(L,yi.NotFound.name)}static NoPermissions(L){return new yi(L,yi.NoPermissions.name)}static Blocked(L){return new yi(L,yi.Blocked.name)}constructor(L,ee,Ee){super(L,{cause:Ee}),this.name="LanguageModelError",this.code=ee??""}}e.$AO=yi;var On;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(On||(e.RelatedInformationType=On={}));var Nn;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped",U[U.Error=5]="Error"})(Nn||(e.SpeechToTextStatus=Nn={}));var Tn;(function(U){U[U.Started=1]="Started",U[U.Stopped=2]="Stopped",U[U.Error=3]="Error"})(Tn||(e.TextToSpeechStatus=Tn={}));var Ln;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(Ln||(e.KeywordRecognitionStatus=Ln={}));class pr{constructor(L,ee){this.text=L,this.range=ee}}e.$BO=pr;var Fn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Fn||(e.InlineEditTriggerKind=Fn={}))}),define(Se[258],Ie([1,0,4,7]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=void 0;class M{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$jM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,b,m){if(this.a.size===0)throw new Error("No related information providers registered");const D=this.a.get(A);if(!D)throw new Error("related information provider not found");return await D.provideRelatedInformation(b,m)??[]}getRelatedInformation(A,b,m){return this.c.$getAiRelatedInformation(b,m)}registerRelatedInformationProvider(A,b,m){const D=this.b;return this.b++,this.a.set(D,m),this.c.$registerAiRelatedInformationProvider(D,b),new O.$lM(()=>{this.c.$unregisterAiRelatedInformationProvider(D),this.a.delete(D)})}}e.$2lc=M}),define(Se[86],Ie([1,0,5,4,7,21,108,3,17]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0,e.$amc=(0,b.$yi)("IExtHostAuthentication");let D=class{constructor(l){this.b=new Map,this.c=new C.$fe,this.onDidChangeSessions=this.c.event,this.d=new N,this.f=new N,this.a=l.getProxy(O.$jM.MainThreadAuthentication)}async getSession(l,w,g,r={}){const s=T.$Tm.toKey(l.identifier),o=[...g].sort().join(" ");return await this.d.getOrCreate(`${s} ${w} ${o}`,async()=>{await this.a.$ensureProvider(w);const i=l.displayName||l.name;return this.a.$getSession(w,g,s,i,r)})}async getSessions(l,w,g){const r=T.$Tm.toKey(l.identifier),s=[...g].sort().join(" ");return await this.f.getOrCreate(`${r} ${s}`,async()=>{await this.a.$ensureProvider(w);const o=l.displayName||l.name;return this.a.$getSessions(w,g,r,o)})}async removeSession(l,w){const g=this.b.get(l);return g?g.provider.removeSession(w):this.a.$removeSession(l,w)}registerAuthenticationProvider(l,w,g,r){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:w,provider:g,options:r??{supportsMultipleAccounts:!1}});const s=g.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(l,o));return this.a.$registerAuthenticationProvider(l,w,r?.supportsMultipleAccounts??!1),new M.$lM(()=>{s.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}async $createSession(l,w,g){const r=this.b.get(l);if(r)return await r.provider.createSession(w,g);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $removeSession(l,w){const g=this.b.get(l);if(g)return await g.provider.removeSession(w);throw new Error(`Unable to find authentication provider with handle: ${l}`)}async $getSessions(l,w){const g=this.b.get(l);if(g)return await g.provider.getSessions(w);throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,w){return l.startsWith(A.$lL)||this.c.fire({provider:{id:l,label:w}}),Promise.resolve()}};e.$bmc=D,e.$bmc=D=Je([We(0,m.$NO)],D);class N{constructor(){this.a=new Map}getOrCreate(l,w){const g=this.a.get(l);if(g)return g;const r=w().finally(()=>this.a.delete(l));return this.a.set(l,r),r}}}),define(Se[112],Ie([1,0,2,4,7,3,17,12,18,13,19,25]),function(le,e,C,O,M,T,A,b,m,D,N,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$bnc=e.$anc=void 0;let w=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,s){this.h=s,this.f=new Map,this.g=r.getProxy(O.$jM.MainThreadDecorations)}registerFileDecorationProvider(r,s){const o=l.c++;this.f.set(o,{provider:r,extensionDescription:s}),this.g.$registerDecorationProvider(o,s.identifier.value);const i=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const c=(0,m.$2b)(n);if(c.length<=l.d){this.g.$onDidChange(o,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,c.length);const u=c.map(a=>({uri:a,rank:(0,D.$cf)(a.path,"/")})),t=(0,m.$zb)(u,(a,d)=>a.rank-d.rank||(0,D.$sf)(a.uri.path,d.uri.path)),f=[];e:for(const a of t){let d;for(const $ of a){const p=(0,N.$mc)($.uri.path);if(d!==p&&(d=p,f.push($.uri)>=l.d))break e}}this.g.$onDidChange(o,f)});return new M.$lM(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(r,s,o){if(!this.f.has(r))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:c}=this.f.get(r);return await Promise.all(s.map(async u=>{try{const{uri:t,id:f}=u,a=await Promise.resolve(n.provideFileDecoration(C.URI.revive(t),o));if(!a)return;try{M.$LN.validate(a),a.badge&&typeof a.badge!="string"&&(0,S.$LG)(c,"codiconDecoration"),i[f]=[a.propagate,a.tooltip,a.badge,a.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(t){this.h.error(t)}})),i}};e.$anc=w,e.$anc=w=l=Je([We(0,A.$NO),We(1,b.$5j)],w),e.$bnc=(0,T.$yi)("IExtHostDecorations")}),define(Se[259],Ie([1,0,14,2,7,4,16,20,13]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dnc=void 0;class D{static{this.a=0}constructor(S,l,w){this.d=l,this.e=w,this.b=new Map,this.c=S.getProxy(T.$jM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(A.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const w=D.a++;this.b.set(w,l),this.c.$registerTextContentProvider(w,S);let g;if(typeof l.onDidChange=="function"){let r;g=l.onDidChange(async s=>{if(s.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(s))return;r&&await r;const o=this.$provideTextDocumentContent(w,s).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(s);if(!n)return;const c=(0,m.$mf)(i);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(s,i)}).catch(C.$1).finally(()=>{r===o&&(r=void 0)});r=o})}return new M.$lM(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(S,l){const w=this.b.get(S);return w?Promise.resolve(w.provideTextDocumentContent(O.URI.revive(l),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$dnc=D}),define(Se[113],Ie([1,0,57,16,13,313,159,7,18]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$QO=void 0,e.$PO=N;const D=new Map;function N(g,r){r?D.set(g,r):D.delete(g)}function S(g){return D.get(g)}class l extends T.$0v{constructor(r,s,o,i,n,c,u){super(s,o,i,n),this.c=r,this.m=c,this.q=u,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,m.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===O.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(s){return s?r.s(s):r.getText()},get eol(){return r.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(s){return r.t(s)},offsetAt(s){return r.u(s)},positionAt(s){return r.v(s)},validateRange(s){return r.w(s)},validatePosition(s){return r.x(s)},getWordRangeAtPosition(s,o){return r.y(s,o)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,C.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,C.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const s=this.w(r);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const o=this.g,i=s.start.line,n=s.end.line,c=[];c.push(this.f[i].substring(s.start.character));for(let u=i+1;u<n;u++)c.push(this.f[u]);return c.push(this.f[n].substring(0,s.end.character)),c.join(o)}t(r){let s;if(r instanceof b.$mM?s=r.line:typeof r=="number"&&(s=r),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new w(s,this.f[s],s===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const s=this.j.getIndexOf(r),o=this.f[s.index].length;return new b.$mM(s.index,Math.min(s.remainder,o))}w(r){if(!(r instanceof b.$nM))throw new Error("Invalid argument");const s=this.x(r.start),o=this.x(r.end);return s===r.start&&o===r.end?r:new b.$nM(s.line,s.character,o.line,o.character)}x(r){if(!(r instanceof b.$mM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:s,character:o}=r,i=!1;if(s<0)s=0,o=0,i=!0;else if(s>=this.f.length)s=this.f.length-1,o=this.f[s].length,i=!0;else{const n=this.f[s].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new b.$mM(s,o):r}y(r,s){const o=this.x(r);if(!s)s=S(this.m);else if((0,M.$lf)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const i=(0,A.$at)(o.character+1,(0,A.$$s)(s),this.f[o.line],0);if(i)return new b.$nM(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$QO=l;class w{constructor(r,s,o){this.a=r,this.b=s,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$nM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$nM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$RO=w}),define(Se[260],Ie([1,0,4,7]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=void 0;class M{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$jM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,b,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const D=this.a.get(A);if(!D)throw new Error("Embedding vector provider not found");const N=await D.provideEmbeddingVector(b,m);if(!N)throw new Error("Embedding vector provider returned undefined");return N}registerEmbeddingVectorProvider(A,b,m){const D=this.b;return this.b++,this.a.set(D,m),this.c.$registerAiEmbeddingVectorProvider(b,D),new O.$lM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(D),this.a.delete(D)})}}e.$gnc=M}),define(Se[65],Ie([1,0,4,38,7,22,3,17,46,6,11,24,16]),function(le,e,C,O,M,T,A,b,m,D,N,S,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$rmc=e.$qmc=void 0;let g=w=class{constructor(s,o){this.b=new Map,this.c=new N.$Hh,this.a=s.getProxy(C.$jM.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let c;const u=i.b.get(n.scheme);return u?(await i.a.$ensureActivation(n.scheme),c=await u.impl.stat(n)):c=await i.a.$stat(n),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===O.FilePermission.Readonly?1:void 0}}catch(c){w.e(c)}},async readDirectory(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(c){return w.e(c)}},async createDirectory(n){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,n)):await i.a.$mkdir(n)}catch(c){return w.e(c)}},async readFile(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(c){return w.e(c)}},async writeFile(n,c){try{const u=i.b.get(n.scheme);return u&&!u.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(u.impl,u.extUri,u.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(u.impl.writeFile(n,c,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,T.$He.wrap(c))}catch(u){return w.e(u)}},async delete(n,c){try{const u=i.b.get(n.scheme);return u&&!u.isReadonly&&!c?.useTrash?(await i.a.$ensureActivation(n.scheme),await u.impl.delete(n,{recursive:!1,...c})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(u){return w.e(u)}},async rename(n,c,u){try{return await i.a.$rename(n,c,{overwrite:!1,...u})}catch(t){return w.e(t)}},async copy(n,c,u){try{return await i.a.$copy(n,c,{overwrite:!1,...u})}catch(t){return w.e(t)}},isWritableFileSystem(n){const c=o.getCapabilities(n);if(typeof c=="number")return!(c&2048)}})}async d(s,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await s.stat(i)).type&O.FileType.Directory))throw M.$CN.FileExists(`Unable to create folder '${i.scheme===l.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(O.$il(c)!==O.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(o.basename(i)),i=o.dirname(i)}for(let c=n.length-1;c>=0;c--){i=o.joinPath(i,n[c]);try{await s.createDirectory(i)}catch(u){if(O.$il(u)!==O.FileSystemProviderErrorCode.FileExists)throw u}}}static e(s){if(s instanceof M.$CN)throw s;if(s instanceof O.$el)switch(s.code){case O.FileSystemProviderErrorCode.FileExists:throw M.$CN.FileExists(s.message);case O.FileSystemProviderErrorCode.FileNotFound:throw M.$CN.FileNotFound(s.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw M.$CN.FileNotADirectory(s.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw M.$CN.FileIsADirectory(s.message);case O.FileSystemProviderErrorCode.NoPermissions:throw M.$CN.NoPermissions(s.message);case O.FileSystemProviderErrorCode.Unavailable:throw M.$CN.Unavailable(s.message);default:throw new M.$CN(s.message,s.name)}if(!(s instanceof Error))throw new M.$CN(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw M.$CN.Unavailable(s.message);switch(s.name){case O.FileSystemProviderErrorCode.FileExists:throw M.$CN.FileExists(s.message);case O.FileSystemProviderErrorCode.FileNotFound:throw M.$CN.FileNotFound(s.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw M.$CN.FileNotADirectory(s.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw M.$CN.FileIsADirectory(s.message);case O.FileSystemProviderErrorCode.NoPermissions:throw M.$CN.NoPermissions(s.message);case O.FileSystemProviderErrorCode.Unavailable:throw M.$CN.Unavailable(s.message);default:throw new M.$CN(s.message,s.name)}}addFileSystemProvider(s,o,i){return this.b.set(s,{impl:o,extUri:i?.isCaseSensitive?S.$2g:S.$4g,isReadonly:!!i?.isReadonly}),(0,D.$Sc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??S.$2g}};e.$qmc=g,e.$qmc=g=w=Je([We(0,b.$NO),We(1,m.$7lc)],g),e.$rmc=(0,A.$yi)("IExtHostConsumerFileSystem")}),define(Se[87],Ie([1,0,3,27,12,65,2]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=e.$smc=void 0,e.$smc=(0,C.$yi)("IExtensionStoragePaths");let b=class{constructor(D,N,S){this.d=N,this.f=S,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(D){return A.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,N=await this.g(D);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(A.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(D){if(this.c)return A.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return A.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$tmc=b,e.$tmc=b=Je([We(0,O.$4O),We(1,M.$5j),We(2,T.$rmc)],b)}),define(Se[261],Ie([1,0,7,17,5]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=void 0;let T=class{constructor(b){this.a=new C.$MN(C.ColorThemeKind.Dark),this.b=new M.$fe}get activeColorTheme(){return this.a}$onColorThemeChange(b){let m;switch(b){case"light":m=C.ColorThemeKind.Light;break;case"hcDark":m=C.ColorThemeKind.HighContrast;break;case"hcLight":m=C.ColorThemeKind.HighContrastLight;break;default:m=C.ColorThemeKind.Dark}this.a=new C.$MN(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$1nc=T,e.$1nc=T=Je([We(0,O.$NO)],T)}),define(Se[88],Ie([1,0,20,5,6,182,3,12,211,4,27,17,7]),function(le,e,C,O,M,T,A,b,m,D,N,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VDb=e.$UDb=e.TunnelDtoConverter=void 0;class w extends m.$ww{}var g;(function(s){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:n.protocol}}s.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==m.TunnelPrivacyId.ConstantPrivate&&n.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}s.fromServiceTunnel=i})(g||(e.TunnelDtoConverter=g={})),e.$UDb=(0,A.$yi)("IExtHostTunnelService");let r=class extends M.$Uc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$fe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(D.$jM.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const c=new w(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new l.$lM(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,c,u){const t=[];for(const a of o){const d=this.r.get(a);if(!d)return[];t.push(...await Promise.all(i.map(async $=>{let p;try{p=await d.provider.providePortAttributes({port:$,pid:n,commandLine:c},u)}catch{p=await d.provider.providePortAttributes($,n,c,u)}return{providedAttributes:p,port:$}})))}const f=t.filter(a=>!!a.providedAttributes);return f.length>0?f.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,u)=>await o.provideTunnel(c,u,C.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let c=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const u=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const c=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const u=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:c,disposeListener:u}),g.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(c=>this.f(c.host,c.port,c.detail??""))),n=o.filter((c,u)=>i[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(c=>c.port).join(", ")} to ${n.map(c=>c.port).join(", ")}`),n}};e.$VDb=r,e.$VDb=r=Je([We(0,S.$NO),We(1,N.$4O),We(2,b.$5j)],r)}),define(Se[8],Ie([1,0,18,22,138,262,55,28,127,49,70,26,133,24,36,15,2,30,89,101,107,106,224,85,52,62,235,7]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c,u,t,f,a,d,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$KO=G,e.$LO=de,e.$MO=ye;var v;(function(pe){function Ae(J){const{selectionStartLineNumber:Me,selectionStartColumn:Ve,positionLineNumber:Xe,positionColumn:qe}=J,ut=new p.$mM(Me-1,Ve-1),yt=new p.$mM(Xe-1,qe-1);return new p.$oM(ut,yt)}pe.to=Ae;function ae(J){const{anchor:Me,active:Ve}=J;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}pe.from=ae})(v||(e.Selection=v={}));var y;(function(pe){function Ae(J){if(!J)return;const{start:Me,end:Ve}=J;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}pe.from=Ae;function ae(J){if(!J)return;const{startLineNumber:Me,startColumn:Ve,endLineNumber:Xe,endColumn:qe}=J;return new p.$nM(Me-1,Ve-1,Xe-1,qe-1)}pe.to=ae})(y||(e.Range=y={}));var h;(function(pe){function Ae(J){return{uri:J.uri,range:y.from(J.range)}}pe.from=Ae;function ae(J){return new p.$xM(s.URI.revive(J.uri),y.to(J.range))}pe.to=ae})(h||(e.Location=h={}));var E;(function(pe){function Ae(ae){switch(ae){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}pe.to=Ae})(E||(e.TokenType=E={}));var k;(function(pe){function Ae(J){return new p.$mM(J.lineNumber-1,J.column-1)}pe.to=Ae;function ae(J){return{lineNumber:J.line+1,column:J.character+1}}pe.from=ae})(k||(e.Position=k={}));var I;(function(pe){function Ae(Me,Ve,Xe){return(0,C.$Hb)((0,C.$2b)(Me).map(qe=>ae(qe,Ve,Xe)))}pe.from=Ae;function ae(Me,Ve,Xe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Xe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:J(Me.scheme,Ve),pattern:$e.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Xe?.isBuiltin}}function J(Me,Ve){return Ve&&typeof Me=="string"?Ve.transformOutgoingScheme(Me):Me}})(I||(e.DocumentSelector=I={}));var P;(function(pe){function Ae(J){switch(J){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}pe.from=Ae;function ae(J){switch(J){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}pe.to=ae})(P||(e.DiagnosticTag=P={}));var V;(function(pe){function Ae(J){let Me;return J.code&&((0,r.$$f)(J.code)||(0,r.$cg)(J.code)?Me=String(J.code):Me={value:String(J.code.value),target:J.code.target}),{...y.from(J.range),message:J.message,source:J.source,code:Me,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(W.from),tags:Array.isArray(J.tags)?(0,C.$Hb)(J.tags.map(P.from)):void 0}}pe.from=Ae;function ae(J){const Me=new p.$zM(y.to(J),J.message,q.to(J.severity));return Me.source=J.source,Me.code=(0,r.$$f)(J.code)?J.code:J.code?.value,Me.relatedInformation=J.relatedInformation&&J.relatedInformation.map(W.to),Me.tags=J.tags&&(0,C.$Hb)(J.tags.map(P.to)),Me}pe.to=ae})(V||(e.Diagnostic=V={}));var W;(function(pe){function Ae(J){return{...y.from(J.location.range),message:J.message,resource:J.location.uri}}pe.from=Ae;function ae(J){return new p.$yM(new p.$xM(J.resource,y.to(J)),J.message)}pe.to=ae})(W||(e.DiagnosticRelatedInformation=W={}));var q;(function(pe){function Ae(J){switch(J){case p.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}pe.from=Ae;function ae(J){switch(J){case n.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}pe.to=ae})(q||(e.DiagnosticSeverity=q={}));var R;(function(pe){function Ae(J){return typeof J=="number"&&J>=p.ViewColumn.One?J-1:J===p.ViewColumn.Beside?$.$9D:$.$8D}pe.from=Ae;function ae(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=ae})(R||(e.ViewColumn=R={}));function z(pe){return typeof pe.range<"u"}function G(pe){return pe.length===0?!0:!!z(pe[0])}var ie;(function(pe){function Ae(qe){return qe.map(pe.from)}pe.fromMany=Ae;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(ae(qe)){const{language:Nt,value:Ft}=qe;ut={value:"```"+Nt+`
`+Ft+"\n```\n"}}else p.$NM.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const Lt=Nt=>{try{let Ft=s.URI.parse(Nt,!0);Ft=Ft.with({query:Me(Ft.query,yt)}),yt[Nt]=Ft}catch{}return""},ct=new m.marked.Renderer;return ct.link=Lt,ct.image=Nt=>typeof Nt=="string"?Lt(A.$4k(Nt).href):"",(0,m.marked)(ut.value,{renderer:ct}),ut}pe.from=J;function Me(qe,ut){if(!qe)return qe;let yt;try{yt=(0,D.$7h)(qe)}catch{}if(!yt)return qe;let Lt=!1;return yt=(0,S.$7n)(yt,ct=>{if(s.URI.isUri(ct)){const Nt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Nt]=ct,Lt=!0,Nt}else return}),Lt?JSON.stringify(yt):qe}function Ve(qe){const ut=new p.$NM(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?s.URI.from(qe.baseUri):void 0,ut}pe.to=Ve;function Xe(qe){if(qe)return typeof qe=="string"?qe:pe.from(qe)}pe.fromStrict=Xe})(ie||(e.MarkdownString=ie={}));function de(pe){return G(pe)?pe.map(Ae=>({range:y.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?ie.fromMany(Ae.hoverMessage):Ae.hoverMessage?ie.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):pe.map(Ae=>({range:y.from(Ae)}))}function ye(pe){return typeof pe>"u"?pe:typeof pe=="string"?s.URI.file(pe):pe}var De;(function(pe){function Ae(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?ye(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}pe.from=Ae})(De||(e.ThemableDecorationAttachmentRenderOptions=De={}));var ge;(function(pe){function Ae(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ye(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?De.from(ae.before):void 0,after:ae.after?De.from(ae.after):void 0}}pe.from=Ae})(ge||(e.ThemableDecorationRenderOptions=ge={}));var ue;(function(pe){function Ae(ae){if(typeof ae>"u")return ae;switch(ae){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=Ae})(ue||(e.DecorationRangeBehavior=ue={}));var Ce;(function(pe){function Ae(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?ue.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?ge.from(ae.light):void 0,dark:ae.dark?ge.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ye(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?De.from(ae.before):void 0,after:ae.after?De.from(ae.after):void 0}}pe.from=Ae})(Ce||(e.DecorationRenderOptions=Ce={}));var se;(function(pe){function Ae(J){return{text:J.newText,eol:J.newEol&&gt.from(J.newEol),range:y.from(J.range)}}pe.from=Ae;function ae(J){const Me=new p.$sM(y.to(J.range),J.text);return Me.newEol=typeof J.eol>"u"?void 0:gt.to(J.eol),Me}pe.to=ae})(se||(e.TextEdit=se={}));var Oe;(function(pe){function Ae(J,Me){const Ve={edits:[]};if(J instanceof p.$vM){const Xe=new b.$Bc;for(const qe of J._allEntries())qe._type===1&&s.URI.isUri(qe.to)&&qe.from===void 0&&Xe.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,O.$2e)(O.$He.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:se.from(qe.edit),versionId:Xe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:y.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Xe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(ii.from)}})}return Ve}pe.from=Ae;function ae(J){const Me=new p.$vM,Ve=new b.$Ac;for(const Xe of J.edits)if(Xe.textEdit){const qe=Xe,ut=s.URI.revive(qe.resource),yt=y.to(qe.textEdit.range),Lt=qe.textEdit.text,ct=qe.textEdit.insertAsSnippet;let Nt;ct?Nt=p.$uM.replace(yt,new p.$wM(Lt)):Nt=p.$sM.replace(yt,Lt);const Ft=Ve.get(ut);Ft?Ft.push(Nt):Ve.set(ut,[Nt])}else Me.renameFile(s.URI.revive(Xe.oldResource),s.URI.revive(Xe.newResource),Xe.options);for(const[Xe,qe]of Ve)Me.set(Xe,qe);return Me}pe.to=ae})(Oe||(e.WorkspaceEdit=Oe={}));var ne;(function(pe){const Ae=Object.create(null);Ae[p.SymbolKind.File]=0,Ae[p.SymbolKind.Module]=1,Ae[p.SymbolKind.Namespace]=2,Ae[p.SymbolKind.Package]=3,Ae[p.SymbolKind.Class]=4,Ae[p.SymbolKind.Method]=5,Ae[p.SymbolKind.Property]=6,Ae[p.SymbolKind.Field]=7,Ae[p.SymbolKind.Constructor]=8,Ae[p.SymbolKind.Enum]=9,Ae[p.SymbolKind.Interface]=10,Ae[p.SymbolKind.Function]=11,Ae[p.SymbolKind.Variable]=12,Ae[p.SymbolKind.Constant]=13,Ae[p.SymbolKind.String]=14,Ae[p.SymbolKind.Number]=15,Ae[p.SymbolKind.Boolean]=16,Ae[p.SymbolKind.Array]=17,Ae[p.SymbolKind.Object]=18,Ae[p.SymbolKind.Key]=19,Ae[p.SymbolKind.Null]=20,Ae[p.SymbolKind.EnumMember]=21,Ae[p.SymbolKind.Struct]=22,Ae[p.SymbolKind.Event]=23,Ae[p.SymbolKind.Operator]=24,Ae[p.SymbolKind.TypeParameter]=25;function ae(Me){return typeof Ae[Me]=="number"?Ae[Me]:6}pe.from=ae;function J(Me){for(const Ve in Ae)if(Ae[Ve]===Me)return Number(Ve);return p.SymbolKind.Property}pe.to=J})(ne||(e.SymbolKind=ne={}));var j;(function(pe){function Ae(J){switch(J){case p.SymbolTag.Deprecated:return 1}}pe.from=Ae;function ae(J){switch(J){case 1:return p.SymbolTag.Deprecated}}pe.to=ae})(j||(e.SymbolTag=j={}));var x;(function(pe){function Ae(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(j.from),containerName:J.containerName,location:me.from(J.location)}}pe.from=Ae;function ae(J){const Me=new p.$EM(J.name,ne.to(J.kind),J.containerName,me.to(J.location));return Me.tags=J.tags&&J.tags.map(j.to),Me}pe.to=ae})(x||(e.WorkspaceSymbol=x={}));var ve;(function(pe){function Ae(J){const Me={name:J.name||"!!MISSING: name!!",detail:J.detail,range:y.from(J.range),selectionRange:y.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(j.from)??[]};return J.children&&(Me.children=J.children.map(Ae)),Me}pe.from=Ae;function ae(J){const Me=new p.$FM(J.name,J.detail,ne.to(J.kind),y.to(J.range),y.to(J.selectionRange));return(0,C.$Lb)(J.tags)&&(Me.tags=J.tags.map(j.to)),J.children&&(Me.children=J.children.map(ae)),Me}pe.to=ae})(ve||(e.DocumentSymbol=ve={}));var Le;(function(pe){function Ae(J){const Me=new p.$JM(ne.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}pe.to=Ae;function ae(J,Me,Ve){if(Me=Me??J._sessionId,Ve=Ve??J._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(j.from)}}pe.from=ae})(Le||(e.CallHierarchyItem=Le={}));var ke;(function(pe){function Ae(ae){return new p.$KM(Le.to(ae.from),ae.fromRanges.map(J=>y.to(J)))}pe.to=Ae})(ke||(e.CallHierarchyIncomingCall=ke={}));var be;(function(pe){function Ae(ae){return new p.$LM(Le.to(ae.to),ae.fromRanges.map(J=>y.to(J)))}pe.to=Ae})(be||(e.CallHierarchyOutgoingCall=be={}));var me;(function(pe){function Ae(J){return{range:J.range&&y.from(J.range),uri:J.uri}}pe.from=Ae;function ae(J){return new p.$xM(s.URI.revive(J.uri),y.to(J.range))}pe.to=ae})(me||(e.location=me={}));var Q;(function(pe){function Ae(J){const Me=J,Ve=J;return{originSelectionRange:Me.originSelectionRange?y.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ve.uri,range:y.from(Me.targetRange?Me.targetRange:Ve.range),targetSelectionRange:Me.targetSelectionRange?y.from(Me.targetSelectionRange):void 0}}pe.from=Ae;function ae(J){return{targetUri:s.URI.revive(J.uri),targetRange:y.to(J.range),targetSelectionRange:J.targetSelectionRange?y.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?y.to(J.originSelectionRange):void 0}}pe.to=ae})(Q||(e.DefinitionLink=Q={}));var Y;(function(pe){function Ae(J){return{range:y.from(J.range),contents:ie.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}pe.from=Ae;function ae(J){const Me=J.contents.map(ie.to),Ve=y.to(J.range),Xe=J.canIncreaseVerbosity,qe=J.canDecreaseVerbosity;return new p.$BM(Me,Ve,Xe,qe)}pe.to=ae})(Y||(e.Hover=Y={}));var he;(function(pe){function Ae(J){return{range:y.from(J.range),expression:J.expression}}pe.from=Ae;function ae(J){return new p.$wN(y.to(J.range),J.expression)}pe.to=ae})(he||(e.EvaluatableExpression=he={}));var ce;(function(pe){function Ae(J){if(J instanceof p.$xN)return{type:"text",range:y.from(J.range),text:J.text};if(J instanceof p.$yN)return{type:"variable",range:y.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof p.$zN)return{type:"expression",range:y.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=Ae;function ae(J){switch(J.type){case"text":return{range:y.to(J.range),text:J.text};case"variable":return{range:y.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:y.to(J.range),expression:J.expression}}}pe.to=ae})(ce||(e.InlineValue=ce={}));var Te;(function(pe){function Ae(J){return{frameId:J.frameId,stoppedLocation:y.from(J.stoppedLocation)}}pe.from=Ae;function ae(J){return new p.$AN(J.frameId,y.to(J.stoppedLocation))}pe.to=ae})(Te||(e.InlineValueContext=Te={}));var fe;(function(pe){function Ae(J){return{range:y.from(J.range),kind:J.kind}}pe.from=Ae;function ae(J){return new p.$CM(y.to(J.range),J.kind)}pe.to=ae})(fe||(e.DocumentHighlight=fe={}));var Pe;(function(pe){function Ae(J){return{uri:J.uri,highlights:J.highlights.map(fe.from)}}pe.from=Ae;function ae(J){return new p.$DM(s.URI.revive(J.uri),J.highlights.map(fe.to))}pe.to=ae})(Pe||(e.MultiDocumentHighlight=Pe={}));var Re;(function(pe){function Ae(ae){switch(ae){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}pe.to=Ae})(Re||(e.CompletionTriggerKind=Re={}));var Ue;(function(pe){function Ae(ae){return{triggerKind:Re.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}pe.to=Ae})(Ue||(e.CompletionContext=Ue={}));var B;(function(pe){function Ae(J){switch(J){case p.CompletionItemTag.Deprecated:return 1}}pe.from=Ae;function ae(J){switch(J){case 1:return p.CompletionItemTag.Deprecated}}pe.to=ae})(B||(e.CompletionItemTag=B={}));var F;(function(pe){const Ae=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function ae(Ve){return Ae.get(Ve)??9}pe.from=ae;const J=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function Me(Ve){return J.get(Ve)??p.CompletionItemKind.Property}pe.to=Me})(F||(e.CompletionItemKind=F={}));var H;(function(pe){function Ae(ae,J){const Me=new p.$TM(ae.label);return Me.insertText=ae.insertText,Me.kind=F.to(ae.kind),Me.tags=ae.tags?.map(B.to),Me.detail=ae.detail,Me.documentation=A.$Xk(ae.documentation)?ie.to(ae.documentation):ae.documentation,Me.sortText=ae.sortText,Me.filterText=ae.filterText,Me.preselect=ae.preselect,Me.commitCharacters=ae.commitCharacters,o.$yt.isIRange(ae.range)?Me.range=y.to(ae.range):typeof ae.range=="object"&&(Me.range={inserting:y.to(ae.range.insert),replacing:y.to(ae.range.replace)}),Me.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?Me.insertText=new p.$wM(ae.insertText):(Me.insertText=ae.insertText,Me.textEdit=Me.range instanceof p.$nM?new p.$sM(Me.range,Me.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Me.additionalTextEdits=ae.additionalTextEdits.map(Ve=>se.to(Ve))),Me.command=J&&ae.command?J.fromInternal(ae.command):void 0,Me}pe.to=Ae})(H||(e.CompletionItem=H={}));var K;(function(pe){function Ae(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}pe.from=Ae;function ae(J){return{label:J.label,documentation:A.$Xk(J.documentation)?ie.to(J.documentation):J.documentation}}pe.to=ae})(K||(e.ParameterInformation=K={}));var te;(function(pe){function Ae(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(K.from):[],activeParameter:J.activeParameter}}pe.from=Ae;function ae(J){return{label:J.label,documentation:A.$Xk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(K.to):[],activeParameter:J.activeParameter}}pe.to=ae})(te||(e.SignatureInformation=te={}));var re;(function(pe){function Ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(te.from):[]}}pe.from=Ae;function ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(te.to):[]}}pe.to=ae})(re||(e.SignatureHelp=re={}));var Ne;(function(pe){function Ae(ae,J){const Me=new p.$SM(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,ae)),J.kind&&Ke.to(J.kind));return Me.textEdits=J.textEdits&&J.textEdits.map(se.to),Me.tooltip=A.$Xk(J.tooltip)?ie.to(J.tooltip):J.tooltip,Me.paddingLeft=J.paddingLeft,Me.paddingRight=J.paddingRight,Me}pe.to=Ae})(Ne||(e.InlayHint=Ne={}));var Be;(function(pe){function Ae(ae,J){const Me=new p.$RM(J.label);return Me.tooltip=A.$Xk(J.tooltip)?ie.to(J.tooltip):J.tooltip,i.Command.is(J.command)&&(Me.command=ae.fromInternal(J.command)),J.location&&(Me.location=me.to(J.location)),Me}pe.to=Ae})(Be||(e.InlayHintLabelPart=Be={}));var Ke;(function(pe){function Ae(J){return J}pe.from=Ae;function ae(J){return J}pe.to=ae})(Ke||(e.InlayHintKind=Ke={}));var _e;(function(pe){function Ae(J){return{range:y.from(J.range),url:J.target,tooltip:J.tooltip}}pe.from=Ae;function ae(J){let Me;if(J.url)try{Me=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}return new p.$YM(y.to(J.range),Me)}pe.to=ae})(_e||(e.DocumentLink=_e={}));var xe;(function(pe){function Ae(J){const Me=new p.$2M(J.label);return J.textEdit&&(Me.textEdit=se.to(J.textEdit)),J.additionalTextEdits&&(Me.additionalTextEdits=J.additionalTextEdits.map(Ve=>se.to(Ve))),Me}pe.to=Ae;function ae(J){return{label:J.label,textEdit:J.textEdit?se.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Me=>se.from(Me)):void 0}}pe.from=ae})(xe||(e.ColorPresentation=xe={}));var et;(function(pe){function Ae(J){return new p.$ZM(J[0],J[1],J[2],J[3])}pe.to=Ae;function ae(J){return[J.red,J.green,J.blue,J.alpha]}pe.from=ae})(et||(e.Color=et={}));var tt;(function(pe){function Ae(J){return{range:y.from(J.range)}}pe.from=Ae;function ae(J){return new p.$IM(y.to(J.range))}pe.to=ae})(tt||(e.SelectionRange=tt={}));var it;(function(pe){function Ae(ae){switch(ae){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}pe.to=Ae})(it||(e.TextDocumentSaveReason=it={}));var ot;(function(pe){function Ae(J){switch(J){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.Interval:return 3;case p.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=Ae;function ae(J){switch(J){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 3:return p.TextEditorLineNumbersStyle.Interval;case 1:default:return p.TextEditorLineNumbersStyle.On}}pe.to=ae})(ot||(e.TextEditorLineNumbersStyle=ot={}));var gt;(function(pe){function Ae(J){if(J===p.EndOfLine.CRLF)return 1;if(J===p.EndOfLine.LF)return 0}pe.from=Ae;function ae(J){if(J===1)return p.EndOfLine.CRLF;if(J===0)return p.EndOfLine.LF}pe.to=ae})(gt||(e.EndOfLine=gt={}));var je;(function(pe){function Ae(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=Ae})(je||(e.ProgressLocation=je={}));var rt;(function(pe){function Ae(J){const Me={start:J.start+1,end:J.end+1};return J.kind&&(Me.kind=Z.from(J.kind)),Me}pe.from=Ae;function ae(J){const Me={start:J.start-1,end:J.end-1};return J.kind&&(Me.kind=Z.to(J.kind)),Me}pe.to=ae})(rt||(e.FoldingRange=rt={}));var Z;(function(pe){function Ae(J){if(J)switch(J){case p.FoldingRangeKind.Comment:return i.$xu.Comment;case p.FoldingRangeKind.Imports:return i.$xu.Imports;case p.FoldingRangeKind.Region:return i.$xu.Region}}pe.from=Ae;function ae(J){if(J)switch(J.value){case i.$xu.Comment.value:return p.FoldingRangeKind.Comment;case i.$xu.Imports.value:return p.FoldingRangeKind.Imports;case i.$xu.Region.value:return p.FoldingRangeKind.Region}}pe.to=ae})(Z||(e.FoldingRangeKind=Z={}));var X;(function(pe){function Ae(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?y.from(ae.selection):void 0,override:typeof ae.override=="boolean"?u.$yF.id:void 0}}pe.from=Ae})(X||(e.TextEditorOpenOptions=X={}));var $e;(function(pe){function Ae(Ve){return Ve instanceof p.$kN?Ve.toJSON():typeof Ve=="string"?Ve:ae(Ve)||J(Ve)?new p.$kN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}pe.from=Ae;function ae(Ve){const Xe=Ve;return Xe?s.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function J(Ve){const Xe=Ve;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Me(Ve){return typeof Ve=="string"?Ve:new p.$kN(s.URI.revive(Ve.baseUri),Ve.pattern)}pe.to=Me})($e||(e.GlobPattern=$e={}));var He;(function(pe){function Ae(ae){if(ae){if(Array.isArray(ae))return ae.map(Ae);if(typeof ae=="string")return ae;{const J=ae;return{language:J.language,scheme:J.scheme,pattern:$e.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}pe.from=Ae})(He||(e.LanguageSelector=He={}));var we;(function(pe){function Ae(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Me=>Array.isArray(Me)&&Me.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&s.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Xe=>Xe instanceof p.$nM)))}pe.is=Ae;function ae(J){return{documents:J.documents.map(Me=>Me.map(Ve=>({uri:s.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Xe=>y.from(Xe))})))}}pe.from=ae})(we||(e.MappedEditsContext=we={}));var st;(function(pe){function Ae(J){return{start:J.start,end:J.end}}pe.from=Ae;function ae(J){return new p.$NN(J.start,J.end)}pe.to=ae})(st||(e.NotebookRange=st={}));var dt;(function(pe){function Ae(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}pe.to=Ae;function ae(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}pe.from=ae})(dt||(e.NotebookCellExecutionSummary=dt={}));var Ct;(function(pe){function Ae(ae){if(ae===f.NotebookCellExecutionState.Unconfirmed)return p.NotebookCellExecutionState.Pending;if(ae===f.NotebookCellExecutionState.Pending)return;if(ae===f.NotebookCellExecutionState.Executing)return p.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}pe.to=Ae})(Ct||(e.NotebookCellExecutionState=Ct={}));var Vt;(function(pe){function Ae(J){switch(J){case p.NotebookCellKind.Markup:return f.CellKind.Markup;case p.NotebookCellKind.Code:default:return f.CellKind.Code}}pe.from=Ae;function ae(J){switch(J){case f.CellKind.Markup:return p.NotebookCellKind.Markup;case f.CellKind.Code:default:return p.NotebookCellKind.Code}}pe.to=ae})(Vt||(e.NotebookCellKind=Vt={}));var Qt;(function(pe){function Ae(J){const Me={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)p.$ON.validate(Ve),Me.cells.push(ii.from(Ve));return Me}pe.from=Ae;function ae(J){const Me=new p.$PN(J.cells.map(ii.to));return(0,r.$lg)(J.metadata)||(Me.metadata=J.metadata),Me}pe.to=ae})(Qt||(e.NotebookData=Qt={}));var ii;(function(pe){function Ae(J){return{cellKind:Vt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Dt.from):[]}}pe.from=Ae;function ae(J){return new p.$ON(Vt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Dt.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}pe.to=ae})(ii||(e.NotebookCellData=ii={}));var Xt;(function(pe){function Ae(J){return{mime:J.mime,valueBytes:O.$He.wrap(J.data)}}pe.from=Ae;function ae(J){return new p.$QN(J.valueBytes.buffer,J.mime)}pe.to=ae})(Xt||(e.NotebookCellOutputItem=Xt={}));var Dt;(function(pe){function Ae(J){return{outputId:J.id,items:J.items.map(Xt.from),metadata:J.metadata}}pe.from=Ae;function ae(J){const Me=J.items.map(Xt.to);return new p.$RN(Me,J.outputId,J.metadata)}pe.to=ae})(Dt||(e.NotebookCellOutput=Dt={}));var Zt;(function(pe){function Ae(Me){return J(Me)?{include:$e.from(Me.include)??void 0,exclude:$e.from(Me.exclude)??void 0}:$e.from(Me)??void 0}pe.from=Ae;function ae(Me){return J(Me)?{include:$e.to(Me.include),exclude:$e.to(Me.exclude)}:$e.to(Me)}pe.to=ae;function J(Me){const Ve=Me;return Ve?!(0,r.$hg)(Ve.include)&&!(0,r.$hg)(Ve.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Yt;(function(pe){function Ae(ae,J,Me){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,Me),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}pe.from=Ae})(Yt||(e.NotebookStatusBarItem=Yt={}));var Ze;(function(pe){function Ae(ae,J,Me){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:J.toInternal(Ve,Me),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}pe.from=Ae})(Ze||(e.NotebookKernelSourceAction=Ze={}));var si;(function(pe){function Ae(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}pe.from=Ae})(si||(e.NotebookDocumentContentOptions=si={}));var Kt;(function(pe){function Ae(J){return{uri:J.uri,provides:J.provides}}pe.from=Ae;function ae(J){return new p.$TN(s.URI.revive(J.uri),J.provides)}pe.to=ae})(Kt||(e.NotebookRendererScript=Kt={}));var ht;(function(pe){function Ae(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:y.from(J.location.range),uri:J.location.uri}}}pe.from=Ae;function ae(J){const Me=new p.$ZN(typeof J.message=="string"?J.message:ie.to(J.message));return Me.actualOutput=J.actual,Me.expectedOutput=J.expected,Me.contextValue=J.contextValue,Me.location=J.location?me.to(J.location):void 0,Me}pe.to=ae})(ht||(e.TestMessage=ht={}));var mt;(function(pe){pe.namespace=d.$aL,pe.denamespace=d.$bL})(mt||(e.TestTag=mt={}));var xt;(function(pe){function Ae(J){const Me=(0,c.$JO)(J).controllerId;return{extId:a.$8K.fromExtHostTestItem(J,Me).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>mt.namespace(Me,Ve.id)),range:o.$yt.lift(y.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}pe.from=Ae;function ae(J){return{parent:void 0,error:void 0,id:a.$8K.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(Me=>{const{tagId:Ve}=mt.denamespace(Me);return new p.$1N(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}pe.toPlain=ae})(xt||(e.TestItem=xt={})),function(pe){function Ae(J){return{id:J.id}}pe.from=Ae;function ae(J){return new p.$1N(J.id)}pe.to=ae}(mt||(e.TestTag=mt={}));var Gt;(function(pe){const Ae=(J,Me)=>{const Ve=J.value;if(!Ve)return;const Xe={...xt.toPlain(Ve.item),parent:Me,taskStates:Ve.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(ht.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Ae(qe,Xe);ut&&Xe.children.push(ut)}return Xe};function ae(J){const Me=new l.$CO;for(const qe of J.items)Me.insert(a.$8K.fromString(qe.item.extId).path,qe);const Ve=[Me.nodes],Xe=[];for(;Ve.length;)for(const qe of Ve.pop())qe.value?Xe.push(qe):qe.children&&Ve.push(qe.children.values());return{completedAt:J.completedAt,results:Xe.map(qe=>Ae(qe)).filter(r.$gg)}}pe.to=ae})(Gt||(e.TestResults=Gt={}));var Tt;(function(pe){function Ae(Ve){return{covered:Ve.covered,total:Ve.total}}function ae(Ve){return"line"in Ve?k.from(Ve):y.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:ae(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&ae(Xe.location),label:Xe.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:ae(Ve.location)}}pe.fromDetails=J;function Me(Ve,Xe,qe){return p.$3N(qe.statementCoverage),p.$3N(qe.branchCoverage),p.$3N(qe.declarationCoverage),{id:Xe,uri:qe.uri,statement:Ae(qe.statementCoverage),branch:qe.branchCoverage&&Ae(qe.branchCoverage),declaration:qe.declarationCoverage&&Ae(qe.declarationCoverage),testId:qe instanceof p.$4N&&qe.testItem?a.$8K.fromExtHostTestItem(qe.testItem,Ve).toString():void 0}}pe.fromFile=Me})(Tt||(e.TestCoverage=Tt={}));var ft;(function(pe){function Ae(ae){switch(ae){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}pe.to=Ae})(ft||(e.CodeActionTriggerKind=ft={}));var Bt;(function(pe){function Ae(J){const Me=new p.$8N(ne.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}pe.to=Ae;function ae(J,Me,Ve){if(Me=Me??J._sessionId,Ve=Ve??J._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(j.from)}}pe.from=ae})(Bt||(e.TypeHierarchyItem=Bt={}));var _t;(function(pe){function Ae(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}pe.from=Ae})(_t||(e.ViewBadge=_t={}));var zt;(function(pe){function Ae(Ve,Xe,qe){const ut=Xe.fileData;return ut?new p.$cN(new p.$dN(ut.name,s.URI.revive(ut.uri),ut.id,(0,T.$db)(()=>qe(ut.id)))):Ve===N.$Us.uriList&&Xe.uriListData?new p.$bN(Me(Xe.uriListData)):new p.$bN(Xe.asString)}pe.to=Ae;async function ae(Ve,Xe){const qe=await Xe.asString();if(Ve===N.$Us.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Xe.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}pe.from=ae;function J(Ve){return M.$cu.split(Ve).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return s.URI.parse(Xe)}catch{}return Xe})}function Me(Ve){return M.$cu.create(Ve.map(Xe=>typeof Xe=="string"?Xe:s.URI.revive(Xe)))}})(zt||(e.DataTransferItem=zt={}));var Qe;(function(pe){function Ae(J,Me){const Ve=J.items.map(([Xe,qe])=>[Xe,zt.to(Xe,qe,Me)]);return new p.$eN(Ve)}pe.toDataTransfer=Ae;async function ae(J){const Me={items:[]},Ve=[];for(const[Xe,qe]of J)Ve.push((async()=>{Me.items.push([Xe,await zt.from(Xe,qe)])})());return await Promise.all(Ve),Me}pe.from=ae})(Qe||(e.DataTransfer=Qe={}));var ui;(function(pe){function Ae(J,Me){return{kind:"reply",agentId:J.participant??Me?.agentId??"",subCommand:J.command??Me?.command,message:J.prompt,title:J.label}}pe.from=Ae;function ae(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}pe.to=ae})(ui||(e.ChatFollowup=ui={}));var Jt;(function(pe){function Ae(J){switch(J.role){case 0:return new p.$wO(p.LanguageModelChatMessageRole.System,J.content);case 1:return new p.$wO(p.LanguageModelChatMessageRole.User,J.content);case 2:return new p.$wO(p.LanguageModelChatMessageRole.Assistant,J.content)}}pe.to=Ae;function ae(J){switch(J.role){case p.LanguageModelChatMessageRole.System:return{role:0,content:J.content};case p.LanguageModelChatMessageRole.User:return{role:1,content:J.content};case p.LanguageModelChatMessageRole.Assistant:return{role:2,content:J.content}}}pe.from=ae})(Jt||(e.LanguageModelChatMessage=Jt={}));var jt;(function(pe){function Ae(J){return{kind:"markdownContent",content:ie.from(J.value)}}pe.from=Ae;function ae(J){return new p.$iO(ie.to(J.content))}pe.to=ae})(jt||(e.ChatResponseMarkdownPart=jt={}));var bt;(function(pe){function Ae(J){return{kind:"markdownVuln",content:ie.from(J.value),vulnerabilities:J.vulnerabilities}}pe.from=Ae;function ae(J){return new p.$jO(ie.to(J.content),J.vulnerabilities)}pe.to=ae})(bt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=bt={}));var Ut;(function(pe){function Ae(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}pe.from=Ae;function ae(J){return new p.$kO(J.agentId,J.command)}pe.to=ae})(Ut||(e.ChatResponseDetectedParticipantPart=Ut={}));var Mt;(function(pe){function Ae(ae){return{kind:"confirmation",title:ae.title,message:ae.message,data:ae.data}}pe.from=Ae})(Mt||(e.ChatResponseConfirmationPart=Mt={}));var At;(function(pe){function Ae(J){const{value:Me,baseUri:Ve}=J;function Xe(qe,ut){return qe.map(yt=>{const Lt=s.URI.joinPath(ut,yt.name);return{label:yt.name,uri:Lt,children:yt.children&&Xe(yt.children,Lt)}})}return{kind:"treeData",treeData:{label:(0,w.$9g)(Ve),uri:Ve,children:Xe(Me,Ve)}}}pe.from=Ae;function ae(J){const Me=(0,D.$8h)(J.treeData);function Ve(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&Ve(yt.children)}))}const Xe=Me.uri,qe=Me.children?Ve(Me.children):[];return new p.$mO(qe,Xe)}pe.to=ae})(At||(e.ChatResponseFilesPart=At={}));var ei;(function(pe){function Ae(J){return{kind:"inlineReference",name:J.title,inlineReference:s.URI.isUri(J.value)?J.value:h.from(J.value)}}pe.from=Ae;function ae(J){const Me=(0,D.$8h)(J);return new p.$nO(s.URI.isUri(Me.inlineReference)?Me.inlineReference:h.to(Me.inlineReference),J.name)}pe.to=ae})(ei||(e.ChatResponseAnchorPart=ei={}));var Wt;(function(pe){function Ae(J){return{kind:"progressMessage",content:ie.from(J.value)}}pe.from=Ae;function ae(J){return new p.$oO(J.content.value)}pe.to=ae})(Wt||(e.ChatResponseProgressPart=Wt={}));var oi;(function(pe){function Ae(J){return{kind:"warning",content:ie.from(J.value)}}pe.from=Ae;function ae(J){return new p.$qO(J.content.value)}pe.to=ae})(oi||(e.ChatResponseWarningPart=oi={}));var Ot;(function(pe){function Ae(ae){return{kind:"progressTask",content:ie.from(ae.value)}}pe.from=Ae})(Ot||(e.ChatTask=Ot={}));var qt;(function(pe){function Ae(ae){return{kind:"progressTaskResult",content:typeof ae=="string"?ie.from(ae):void 0}}pe.from=Ae})(qt||(e.ChatTaskResult=qt={}));var Rt;(function(pe){function Ae(J,Me,Ve){return{kind:"command",command:Me.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}pe.from=Ae;function ae(J,Me){return new p.$rO(Me.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}pe.to=ae})(Rt||(e.ChatResponseCommandButtonPart=Rt={}));var St;(function(pe){function Ae(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Me=>se.from(Me))}}pe.from=Ae;function ae(J){return new p.$tO(s.URI.revive(J.uri),J.edits.map(Me=>se.to(Me)))}pe.to=ae})(St||(e.ChatResponseTextEditPart=St={}));var $t;(function(pe){function Ae(J){const Me=g.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&s.URI.isUri(J.iconPath.light)&&s.URI.isUri(J.iconPath.dark)?{light:s.URI.revive(J.iconPath.light),dark:s.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:h.from(J.value.value)},iconPath:Me}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:h.from(J.value),iconPath:Me}}pe.from=Ae;function ae(J){const Me=(0,D.$8h)(J),Ve=Xe=>s.URI.isUri(Xe)?Xe:h.to(Xe);return new p.$sO("variableName"in Me.reference?{variableName:Me.reference.variableName,value:Me.reference.value&&Ve(Me.reference.value)}:Ve(Me.reference))}pe.to=ae})($t||(e.ChatResponseReferencePart=$t={}));var Et;(function(pe){function Ae(Me,Ve,Xe){return Me instanceof p.$iO?jt.from(Me):Me instanceof p.$nO?ei.from(Me):Me instanceof p.$sO?$t.from(Me):Me instanceof p.$oO?Wt.from(Me):Me instanceof p.$mO?At.from(Me):Me instanceof p.$rO?Rt.from(Me,Ve,Xe):Me instanceof p.$tO?St.from(Me):Me instanceof p.$jO?bt.from(Me):Me instanceof p.$kO?Ut.from(Me):Me instanceof p.$qO?oi.from(Me):{kind:"markdownContent",content:ie.from("")}}pe.from=Ae;function ae(Me,Ve){switch(Me.kind){case"reference":return $t.to(Me);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Me,Ve)}}pe.to=ae;function J(Me,Ve){switch(Me.kind){case"markdownContent":return jt.to(Me);case"inlineReference":return ei.to(Me);case"progressMessage":return;case"treeData":return At.to(Me);case"command":return Rt.to(Me,Ve)}}pe.toContent=J})(Et||(e.ChatResponsePart=Et={}));var ai;(function(pe){function Ae(ae){return{prompt:ae.message,command:ae.command,attempt:ae.attempt??0,enableCommandDetection:ae.enableCommandDetection??!0,variables:ae.variables.variables.map(fi.to),location:kt.to(ae.location),acceptedConfirmationData:ae.acceptedConfirmationData,rejectedConfirmationData:ae.rejectedConfirmationData}}pe.to=Ae})(ai||(e.ChatAgentRequest=ai={}));var kt;(function(pe){function Ae(ae){switch(ae){case t.ChatAgentLocation.Notebook:return p.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return p.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return p.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return p.ChatLocation.Editor}}pe.to=Ae})(kt||(e.ChatLocation=kt={}));var fi;(function(pe){function Ae(ae){const J=ae.value;if(!J)throw new Error("Invalid value reference");return{name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],value:(0,s.$vc)(J)?s.URI.revive(J):J}}pe.to=Ae})(fi||(e.ChatAgentValueReference=fi={}));var ni;(function(pe){function Ae(ae,J,Me){return{label:ae.label,value:ae.values[0].value,insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation,command:J.toInternal(ae.command,Me)}}pe.from=Ae})(ni||(e.ChatAgentCompletionItem=ni={}));var $i;(function(pe){function Ae(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}pe.to=Ae})($i||(e.ChatAgentResult=$i={}));var li;(function(pe){function Ae(ae,J,Me){if(J.action.kind==="vote")return;const Ve=$i.to(ae);if(J.action.kind==="command"){const Xe=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Me.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:ui.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}pe.to=Ae})(li||(e.ChatAgentUserActionEvent=li={}));var wi;(function(pe){function Ae(ae,J,Me){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:J.toInternal(ae,Me)}pe.from=Ae})(wi||(e.TerminalQuickFix=wi={}));var It;(function(pe){function Ae(ae){return{kind:Di.to(ae.kind)}}pe.to=Ae})(It||(e.PartialAcceptInfo=It={}));var Di;(function(pe){function Ae(ae){switch(ae){case 0:return p.PartialAcceptTriggerKind.Word;case 1:return p.PartialAcceptTriggerKind.Line;case 2:return p.PartialAcceptTriggerKind.Suggest;default:return p.PartialAcceptTriggerKind.Unknown}}pe.to=Ae})(Di||(e.PartialAcceptTriggerKind=Di={}));var ri;(function(pe){function Ae(ae,J){return{id:J,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}pe.from=Ae})(ri||(e.DebugTreeItem=ri={}))}),define(Se[263],Ie([1,0,4,17,8,34]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;let A=class{constructor(m,D){this.a=m.getProxy(C.$jM.MainThreadBulkEdits),this.b={getTextDocumentVersion:N=>D.getDocument(N)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,D,N){const S=new T.$Fw(M.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,N?.isRefactoring??!1)}};e.$cmc=A,e.$cmc=A=Je([We(0,O.$NO)],A)}),define(Se[264],Ie([1,0,18,11,44,5,42,6,66,15,2,21,4,8,7,225,25]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class o{constructor(u,t,f,a,d){this.j=u,this.k=t,this.l=f,this.m=a,this.n=d,this.b=m.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(a){if(u.c){const d=new Error("Response stream has been closed");throw Error.captureStackTrace(d,a),d}};const u=this;this.b.reset();const f=(a,d)=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a).then($=>{$&&d?.({report:p=>{if(g.$NM.isMarkdownString(p.value)){this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseWarningPart.from(p),$);return}else this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseReferencePart.from(p),$)}}).then(p=>{typeof $=="number"&&this.l.$handleProgressChunk(this.k.requestId,w.ChatTaskResult.from(p),$)})})};this.g={markdown(a){t(this.markdown);const d=new g.$iO(a),$=w.ChatResponseMarkdownPart.from(d);return f($),this},markdownWithVulnerabilities(a,d){t(this.markdown),d&&(0,s.$LG)(u.j,"chatParticipantAdditions");const $=new g.$jO(a,d),p=w.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return f(p),this},filetree(a,d){t(this.filetree);const $=new g.$mO(a,d),p=w.ChatResponseFilesPart.from($);return f(p),this},anchor(a,d){t(this.anchor);const $=new g.$nO(a,d),p=w.ChatResponseAnchorPart.from($);return f(p),this},button(a){t(this.anchor);const d=new g.$rO(a),$=w.ChatResponseCommandButtonPart.from(d,u.m,u.n);return f($),this},progress(a,d){t(this.progress);const $=new g.$pO(a,d),p=d?w.ChatTask.from($):w.ChatResponseProgressPart.from($);return f(p,d),this},warning(a){t(this.progress),(0,s.$LG)(u.j,"chatParticipantAdditions");const d=new g.$qO(a),$=w.ChatResponseWarningPart.from(d);return f($),this},reference(a,d){if(t(this.reference),"variableName"in a&&!a.value){const $=u.k.variables.variables.find(p=>p.name===a.variableName);if($){let p;if($.references?.length)p=$.references.map(v=>({kind:"reference",reference:{variableName:a.variableName,value:v.reference}}));else{const v=new g.$sO(a,d);p=[w.ChatResponseReferencePart.from(v)]}return p.forEach(v=>f(v)),this}}else{const $=new g.$sO(a,d),p=w.ChatResponseReferencePart.from($);f(p)}return this},textEdit(a,d){t(this.textEdit),(0,s.$LG)(u.j,"chatParticipantAdditions");const $=new g.$tO(a,d),p=w.ChatResponseTextEditPart.from($);return f(p),this},detectedParticipant(a,d){t(this.detectedParticipant),(0,s.$LG)(u.j,"chatParticipantAdditions");const $=new g.$kO(a,d),p=w.ChatResponseDetectedParticipantPart.from($);return f(p),this},confirmation(a,d,$){t(this.confirmation),(0,s.$LG)(u.j,"chatParticipantAdditions");const p=new g.$lO(a,d,$),v=w.ChatResponseConfirmationPart.from(p);return f(v),this},push(a){if(t(this.push),(a instanceof g.$tO||a instanceof g.$jO||a instanceof g.$kO||a instanceof g.$qO||a instanceof g.$lO)&&(0,s.$LG)(u.j,"chatParticipantAdditions"),a instanceof g.$sO)this.reference(a.value,a.iconPath);else{const d=w.ChatResponsePart.from(a,u.m,u.n);f(d)}return this}}}return this.g}}class i extends b.$Uc{static{this.b=0}constructor(u,t,f){super(),this.n=t,this.s=f,this.c=new Map,this.j=this.B(new b.$4c),this.m=this.B(new b.$4c),this.g=u.getProxy(l.$jM.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,t,f){const a=i.b++,d=new n(u,t,this.g,a,f);return this.c.set(a,d),this.g.$registerAgent(a,u.identifier,t,{},void 0),d.apiAgent}createDynamicChatAgent(u,t,f,a){const d=i.b++,$=new n(u,t,this.g,d,a);return this.c.set(d,$),this.g.$registerAgent(d,u.identifier,t,{isSticky:!0},f),$.apiAgent}async $invokeAgent(u,t,f,a){const d=this.c.get(u);if(!d)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(t.sessionId);$||($=new b.$Tc,this.j.set(t.sessionId,$));const p=new o(d.extension,t,this.g,this.s.converter,$);try{const v=await this.t(t.agentId,f),y=d.invoke(w.ChatAgentRequest.to(t),{history:v},p.apiObject,a);return await(0,O.$mh)(Promise.resolve(y).then(h=>{if(h?.metadata)try{JSON.stringify(h.metadata)}catch(E){const k=`result.metadata MUST be JSON.stringify-able. Got error: ${E.message}`;return this.n.error(`[${d.extension.identifier.value}] [@${d.id}] ${k}`,d.extension),{errorDetails:{message:k},timings:p.timings}}return{errorDetails:h?.errorDetails,timings:p.timings,metadata:h?.metadata}}),a)}catch(v){return this.n.error(v,d.extension),{errorDetails:{message:(0,M.$jj)(v),responseIsIncomplete:!0}}}finally{p.close()}}async t(u,t){const f=[];for(const a of t.history){const d=w.ChatAgentResult.to(a.result),$=u===a.request.agentId?d:{...d,metadata:void 0};f.push(new g.$uO(a.request.message,a.request.command,a.request.variables.variables.map(w.ChatAgentValueReference.to),a.request.agentId));const p=(0,C.$Hb)(a.response.map(v=>w.ChatResponsePart.toContent(v,this.s.converter)));f.push(new g.$vO(p,$,a.request.agentId,a.request.command))}return f}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,t,f,a,d){const $=this.c.get(t);if(!$)return Promise.resolve([]);const p=await this.t($.id,a),v=w.ChatAgentResult.to(f);return(await $.provideFollowups(v,{history:p},d)).filter(y=>{const h=!y.participant||A.Iterable.some(this.c.values(),E=>E.id===y.participant&&S.$Tm.equals(E.extension.identifier,$.extension.identifier));return h||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),h}).map(y=>w.ChatFollowup.from(y,u))}$acceptFeedback(u,t,f,a){const d=this.c.get(u);if(!d)return;const $=w.ChatAgentResult.to(t);let p;switch(f){case r.ChatAgentVoteDirection.Down:p=g.ChatResultFeedbackKind.Unhelpful;break;case r.ChatAgentVoteDirection.Up:p=g.ChatResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(a?{result:$,kind:p,reportIssue:a}:{result:$,kind:p}))}$acceptAction(u,t,f){const a=this.c.get(u);if(!a||f.action.kind==="vote")return;const d=w.ChatAgentUserActionEvent.to(t,f,this.s.converter);d&&a.acceptAction(Object.freeze(d))}async $invokeCompletionProvider(u,t,f){const a=this.c.get(u);if(!a)return[];let d=this.m.get(u);return d?d.clear():(d=new b.$Tc,this.m.set(u,d)),(await a.invokeCompletionProvider(t,f)).map(p=>w.ChatAgentCompletionItem.from(p,this.s.converter,d))}async $provideWelcomeMessage(u,t,f){const a=this.c.get(u);if(a)return await a.provideWelcomeMessage(w.ChatLocation.to(t),f)}async $provideSampleQuestions(u,t,f){const a=this.c.get(u);if(a)return(await a.provideSampleQuestions(w.ChatLocation.to(t),f)).map(d=>w.ChatFollowup.from(d,void 0))}}e.$dmc=i;class n{constructor(u,t,f,a,d){this.extension=u,this.id=t,this.u=f,this.w=a,this.x=d,this.m=new T.$fe,this.n=new T.$fe}acceptFeedback(u){this.m.fire(u)}acceptAction(u){this.n.fire(u)}async invokeCompletionProvider(u,t){return this.q?await this.q.provider.provideCompletionItems(u,t)??[]:[]}async provideFollowups(u,t,f){if(!this.b)return[];const a=await this.b.provideFollowups(u,t,f);return a?a.filter(d=>!(d&&"commandId"in d)).filter(d=>!(d&&"message"in d)):[]}async provideWelcomeMessage(u,t){if(!this.s)return[];const f=await this.s.provideWelcomeMessage(u,t);return f?f.map(a=>typeof a=="string"?a:w.MarkdownString.from(a)):[]}async provideSampleQuestions(u,t){if(!this.s||!this.s.provideSampleQuestions)return[];const f=await this.s.provideSampleQuestions(u,t);return f||[]}get apiAgent(){let u=!1,t=!1;const f=()=>{u||t||(t=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{icon:this.c?this.c instanceof N.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof g.$iN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:w.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t}),t=!1}))},a=this;return{get id(){return a.id},get iconPath(){return a.c},set iconPath(d){a.c=d,f()},get requestHandler(){return a.x},set requestHandler(d){(0,D.$ig)(typeof d=="function","Invalid request handler"),a.x=d},get followupProvider(){return a.b},set followupProvider(d){a.b=d,f()},get isDefault(){return(0,s.$LG)(a.extension,"defaultChatParticipant"),a.d},set isDefault(d){(0,s.$LG)(a.extension,"defaultChatParticipant"),a.d=d,f()},get helpTextPrefix(){return(0,s.$LG)(a.extension,"defaultChatParticipant"),a.g},set helpTextPrefix(d){(0,s.$LG)(a.extension,"defaultChatParticipant"),a.g=d,f()},get helpTextVariablesPrefix(){return(0,s.$LG)(a.extension,"defaultChatParticipant"),a.j},set helpTextVariablesPrefix(d){(0,s.$LG)(a.extension,"defaultChatParticipant"),a.j=d,f()},get helpTextPostfix(){return(0,s.$LG)(a.extension,"defaultChatParticipant"),a.k},set helpTextPostfix(d){(0,s.$LG)(a.extension,"defaultChatParticipant"),a.k=d,f()},get isSecondary(){return(0,s.$LG)(a.extension,"defaultChatParticipant"),a.l},set isSecondary(d){(0,s.$LG)(a.extension,"defaultChatParticipant"),a.l=d,f()},get supportIssueReporting(){return(0,s.$LG)(a.extension,"chatParticipantAdditions"),a.o},set supportIssueReporting(d){(0,s.$LG)(a.extension,"chatParticipantAdditions"),a.o=d,f()},get onDidReceiveFeedback(){return a.m.event},set participantVariableProvider(d){if((0,s.$LG)(a.extension,"chatParticipantAdditions"),a.q=d,d){if(!d.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,d.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,s.$LG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(d){(0,s.$LG)(a.extension,"defaultChatParticipant"),a.s=d,f()},get welcomeMessageProvider(){return(0,s.$LG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,s.$KG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(d){a.t=d,f()},get requester(){return a.t},dispose(){u=!0,a.b=void 0,a.m.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(u,t,f,a){return this.x(u,t,f,a)}}}),define(Se[265],Ie([1,0,14,6,4,8,7,25]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;class m{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(M.$jM.MainThreadChatVariables)}async $resolveVariable(S,l,w,g){const r=this.b.get(S);if(r)try{if(r.resolver.resolve2){(0,b.$LG)(r.extension,"chatParticipantAdditions");const s=new D(l,this.c),o=await r.resolver.resolve2(r.data.name,{prompt:w},s.apiObject,g);if(o&&o[0])return o[0].value}else{const s=await r.resolver.resolve(r.data.name,{prompt:w},g);if(s&&s[0])return s[0].value}}catch(s){(0,C.$2)(s)}}registerVariableResolver(S,l,w,g){const r=m.a++;return this.b.set(r,{extension:S,data:{name:l,description:w},resolver:g}),this.c.$registerVariable(r,{name:l,description:w}),(0,O.$Sc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$emc=m;class D{constructor(S,l){this.c=S,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(g){if(S.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,g),r}};const S=this,w=g=>{this.d.$handleProgressChunk(this.c,g)};this.b={progress(g){l(this.progress);const r=new A.$oO(g),s=T.ChatResponseProgressPart.from(r);return w(s),this},reference(g){l(this.reference);const r=new A.$sO(g),s=T.ChatResponseReferencePart.from(r);return w(s),this},push(g){return l(this.push),g instanceof A.$sO?w(T.ChatResponseReferencePart.from(g)):g instanceof A.$oO&&w(T.ChatResponseProgressPart.from(g)),this}}}return this.b}}}),define(Se[266],Ie([1,0,11,69,5,6,2,89,21,8,7,4,25]),function(le,e,C,O,M,T,A,b,m,D,N,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=w;function w(g,r,s){const o=g.getProxy(S.$jM.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$Vm,r.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===6){const y=this.b.get(v.handle);return y?y.value:v}else if(v&&v.$mid===7){const y=v,h=this.b.get(y.commentControlHandle);if(!h)return y;const E=h.getCommentThread(y.commentThreadHandle);return E?E.value:y}else if(v&&(v.$mid===9||v.$mid===8)){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);return h?v.$mid===8?h.value:{thread:h.value,text:v.text}:v}else if(v&&v.$mid===10){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const E=v.commentUniqueId,k=h.getCommentByUniqueId(E);return k||v}else if(v&&v.$mid===11){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const E=v.text,k=v.commentUniqueId,I=h.getCommentByUniqueId(k);return I?(typeof I.body=="string"?I.body=E:I.body=new N.$NM(E),I):v}return v}})}createCommentController(v,y,h){const E=i.a++,k=new c(v,E,y,h);this.b.set(k.handle,k);const I=this.c.get(v.identifier)||[];return I.push(k),this.c.set(v.identifier,I),k.value}async $createCommentThreadTemplate(v,y,h,E){const k=this.b.get(v);k&&k.$createCommentThreadTemplate(y,h,E)}async $setActiveComment(v,y){const h=this.b.get(v);h&&h.$setActiveComment(y??void 0)}async $updateCommentThreadTemplate(v,y,h){const E=this.b.get(v);E&&E.$updateCommentThreadTemplate(y,h)}$deleteCommentThread(v,y){this.b.get(v)?.$deleteCommentThread(y)}async $provideCommentingRanges(v,y,h){const E=this.b.get(v);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const k=await s.ensureDocumentData(A.URI.revive(y));return(0,C.$qh)(async()=>{const I=await E.commentingRangeProvider.provideCommentingRanges(k.document,h);let P;return Array.isArray(I)?P={ranges:I,fileComments:!1}:I?P={ranges:I.ranges||[],fileComments:I.fileComments||!1}:P=I??void 0,P}).then(I=>{let P;return I&&(P={ranges:I.ranges.map(V=>D.Range.from(V)),fileComments:I.fileComments}),P})}$toggleReaction(v,y,h,E,k){const I=this.b.get(v);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,C.$qh)(()=>{const P=I.getCommentThread(y);if(P){const V=P.getCommentByUniqueId(E.uniqueIdInThread);if(I!==void 0&&V&&I.reactionHandler)return I.reactionHandler(V,f(k))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,typeof v=="object"?((0,l.$LG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=v.resolved,this.b.applicability=v.applicability):this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,y,h,E,k,I,P,V,W){this.m=y,this.n=h,this.o=E,this.p=k,this.q=I,this.extensionDescription=P,this.r=V,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$fe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Vc,this.l.value=new T.$Tc,this.n===void 0&&(this.n=`${v}.${this.handle}`),o.$createCommentThread(y,this.handle,this.n,this.o,D.Range.from(this.p),P.identifier,this.r,W),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this.i.push({dispose:()=>{o.$deleteCommentThread(y,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(R){q.range=R},get comments(){return q.comments},set comments(R){q.comments=R},get collapsibleState(){return q.collapsibleState},set collapsibleState(R){q.collapsibleState=R},get canReply(){return q.canReply},set canReply(R){q.canReply=R},get contextValue(){return q.contextValue},set contextValue(R){q.contextValue=R},get label(){return q.label},set label(R){q.label=R},get state(){return q.state},set state(R){q.state=R},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Tc);const v=h=>Object.prototype.hasOwnProperty.call(this.b,h),y={};v("range")&&(y.range=D.Range.from(this.p)),v("label")&&(y.label=this.label),v("contextValue")&&(y.contextValue=this.contextValue??null),v("comments")&&(y.comments=this.q.map(h=>u(this,h,this.k,this.extensionDescription))),v("collapsibleState")&&(y.collapseState=a(this.g)),v("canReply")&&(y.canReply=this.canReply),v("state")&&(y.state=d(this.h)),v("applicability")&&(y.applicability=$(this.h)),v("isTemplate")&&(y.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(v){for(const y of this.k){const h=y[0],E=y[1];if(v===E)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}Je([(0,O.$4h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,v?.resourceHints&&(0,l.$LG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,v?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$LG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$LG)(this.h,"activeComment"),this.f}constructor(v,y,h,E){this.h=v,this.i=y,this.j=h,this.k=E,this.a=new Map,o.$registerCommentController(this.handle,h,E,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(I){k.options=I},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(I){k.commentingRangeProvider=I},get reactionHandler(){return k.reactionHandler},set reactionHandler(I){k.reactionHandler=I},get activeCommentThread(){return k.activeCommentThread},createCommentThread(I,P,V){return k.createCommentThread(I,P,V).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(v,y,h){y===void 0&&(0,l.$LG)(this.h,"fileComments");const E=new n(this.id,this.handle,void 0,v,y,h,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(v){if(!v){this.e=void 0,this.f=void 0;return}const y=this.a.get(v.commentThreadHandle);y&&(this.e=v.uniqueIdInThread?y.getCommentByUniqueId(v.uniqueIdInThread):void 0,this.f=y)}$createCommentThreadTemplate(v,y,h){const E=new n(this.id,this.handle,void 0,A.URI.revive(v),D.Range.to(y),[],this.h,!0,h);return E.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(E.handle,E),E}$updateCommentThreadTemplate(v,y){const h=this.a.get(v);h&&(h.range=D.Range.to(y))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.g.forEach(v=>v.dispose())}}function u(p,v,y,h){let E=y.get(v);return E||(E=++p.commentHandle,y.set(v,E)),v.state!==void 0&&(0,l.$LG)(h,"commentsDraftState"),v.reactions?.some(k=>k.reactors!==void 0)&&(0,l.$LG)(h,"commentReactor"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:E,body:typeof v.body=="string"?v.body:D.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(k=>t(k)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function t(p){return{label:p.label,iconPath:p.iconPath?D.$MO(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(v=>v.name):p.reactors}}function f(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?A.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(v=>({name:v}))}}function a(p){if(p!==void 0)switch(p){case N.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function d(p){let v;if(typeof p=="object"?v=p.resolved:v=p,v!==void 0)switch(v){case N.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function $(p){let v;if(typeof p=="object"&&(v=p.applicability),v!==void 0)switch(v){case N.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case N.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new i}}),define(Se[267],Ie([1,0,20,73,6,16,24,2,8,64,76,4,7]),function(le,e,C,O,M,T,A,b,m,D,N,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=void 0;class w{constructor(f,a){this.document=f,this.b=a,this.a=1,this.c=new N.$1lc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,a){await this.f(f).undo(),a||this.disposeBackup()}async redo(f,a){await this.f(f).redo(),a||this.disposeBackup()}disposeEdits(f){for(const a of f)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=u(this.document.uri)+this.a++;return(0,A.$_g)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const a=this.c.get(f,0);if(!a)throw new Error("No edit found");return a}}class g{constructor(){this.a=new Map}get(f,a){return this.a.get(this.b(f,a))}add(f,a,d){const $=this.b(f,a.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${f} resource:${a.uri}`);const p=new w(a,d);return this.a.set($,p),p}delete(f,a){const d=this.b(f,a.uri);this.a.delete(d)}b(f,a){return`${f}@@@${a}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class s{constructor(){this.a=new Map}addTextProvider(f,a,d){return this.b(f,{type:0,extension:a,provider:d})}addCustomProvider(f,a,d){return this.b(f,{type:1,extension:a,provider:d})}get(f){return this.a.get(f)}b(f,a){if(this.a.has(f))throw new Error(`Provider for viewType:${f} already registered`);return this.a.set(f,a),new l.$lM(()=>this.a.delete(f))}}class o{constructor(f,a,d,$,p){this.d=a,this.f=d,this.g=$,this.h=p,this.b=new s,this.c=new g,this.a=f.getProxy(S.$jM.MainThreadCustomEditors)}registerCustomEditorProvider(f,a,d,$){const p=new M.$Tc;return n(d)?(p.add(this.b.addTextProvider(a,f,d)),this.a.$registerTextEditorProvider((0,D.$xmc)(f),a,$.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,D.$vmc)(f))):(p.add(this.b.addCustomProvider(a,f,d)),i(d)&&p.add(d.onDidChangeCustomDocument(v=>{const y=this.i(a,v.document.uri);if(c(v)){const h=y.addEdit(v);this.a.$onDidEdit(v.document.uri,a,h,v.label)}else this.a.$onContentChange(v.document.uri,a)})),this.a.$registerCustomEditorProvider((0,D.$xmc)(f),a,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,D.$vmc)(f))),l.$lM.from(p,new l.$lM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(f,a,d,$,p){const v=this.b.get(a);if(!v)throw new Error(`No provider found for '${a}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${a}'`);const y=b.URI.revive(f),h=await v.provider.openCustomDocument(y,{backupId:d,untitledDocumentData:$?.buffer},p);let E;return i(v.provider)&&this.f&&(E=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(a,h,E),{editable:i(v.provider)}}async $disposeCustomDocument(f,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const $=b.URI.revive(f),{document:p}=this.i(a,$);this.c.delete(a,p),p.dispose()}async $resolveCustomEditor(f,a,d,$,p,v){const y=this.b.get(d);if(!y)throw new Error(`No provider found for '${d}'`);const h=m.ViewColumn.to(p),E=this.g.createNewWebview(a,$.contentOptions,y.extension),k=this.h.createNewWebviewPanel(a,d,$.title,h,$.options,E,$.active),I=b.URI.revive(f);switch(y.type){case 1:{const{document:P}=this.i(d,I);return y.provider.resolveCustomEditor(P,k,v)}case 0:{const P=this.d.getDocument(I);return y.provider.resolveCustomTextEditor(P,k,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,a,d){this.i(a,f).disposeEdits(d)}async $onMoveCustomEditor(f,a,d){const $=this.b.get(d);if(!$)throw new Error(`No provider found for '${d}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const p=this.h.getWebviewPanel(f);if(!p)throw new Error("No webview found");const v=b.URI.revive(a),y=this.d.getDocument(v);await $.provider.moveCustomTextEditor(y,p,C.CancellationToken.None)}async $undo(f,a,d,$){return this.i(a,f).undo(d,$)}async $redo(f,a,d,$){return this.i(a,f).redo(d,$)}async $revert(f,a,d){const $=this.i(a,f);await this.j(a).revertCustomDocument($.document,d),$.disposeBackup()}async $onSave(f,a,d){const $=this.i(a,f);await this.j(a).saveCustomDocument($.document,d),$.disposeBackup()}async $onSaveAs(f,a,d,$){const p=this.i(a,f);return this.j(a).saveCustomDocumentAs(p.document,b.URI.revive(d),$)}async $backup(f,a,d){const $=this.i(a,f),v=await this.j(a).backupCustomDocument($.document,{destination:$.getNewBackupUri()},d);return $.updateBackup(v),v.id}i(f,a){const d=this.c.get(f,b.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(f){const d=this.b.get(f)?.provider;if(!d||!i(d))throw new Error("Custom document is not editable");return d}}e.$Amc=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const f=t.scheme===T.Schemas.file||t.scheme===T.Schemas.untitled?t.fsPath:t.toString();return(0,O.$mj)(f)+""}}),define(Se[268],Ie([1,0,172,101,2,4,7,8,5,12,28,46]),function(le,e,C,O,M,T,A,b,m,D,N,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=e.$8lc=void 0;class w{#e;#t;#i;constructor(s,o,i,n,c,u,t,f){this.d=s,this.e=o,this.f=i,this.g=n,this.h=c,this.c=!1,this.f=Math.max(n,i),this.#i=new N.$Ac(a=>u.getComparisonKey(a)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,o){if(!s){this.clear();return}this.j();let i=[];if(M.URI.isUri(s)){if(!o){this.delete(s);return}this.#i.set(s,o.slice()),i=[s]}else if(Array.isArray(s)){i=[];let u;s=[...s].sort(w.k);for(const t of s){const[f,a]=t;if((!u||f.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=f,i.push(f),this.#i.set(f,[])),a)this.#i.get(f)?.push(...a);else{const d=this.#i.get(f);d&&(d.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let c=0;for(const u of i){let t=[];const f=this.#i.get(u);if(f)if(f.length>this.g){t=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const $ of f)if($.severity===a[d]&&t.push({...b.Diagnostic.from($),modelVersionId:this.h(u)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,C.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(a=>({...b.Diagnostic.from(a),modelVersionId:this.h(u)}));if(n.push([u,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,n)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,o){this.j();for(const[i,n]of this)s.call(o,i,n,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const o=this.#i.get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.$8lc=w;let g=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(s){const o=new N.$Ac;for(const i of s)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(s,o,i,n){this.j=o,this.k=i,this.l=n,this.g=new Map,this.h=new m.$je({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,l._mapper),this.f=s.getProxy(T.$jM.MainThreadDiagnostics)}createDiagnosticCollection(s,o){const{g:i,f:n,h:c,j:u,k:t,l:f}=this,a=new class{$changeMany(p,v){n.$changeMany(p,v),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,p,v.length===0?"CLEARING":v)}$clear(p){n.$clear(p),u.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,p)}dispose(){n.dispose()}};let d;if(!o)o="_generated_diagnostic_collection_name_#"+l.c++,d=o;else if(!i.has(o))d=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do d=o+l.c++;while(i.has(d))}return new class extends w{constructor(){super(o,d,l.e,l.d,p=>f.getDocument(p)?.version,t.extUri,a,c),i.set(d,this)}dispose(){super.dispose(),i.delete(d)}}}getDiagnostics(s){if(s)return this.m(s);{const o=new Map,i=[];for(const n of this.g.values())n.forEach((c,u)=>{let t=o.get(c.toString());typeof t>"u"&&(t=i.length,o.set(c.toString(),t),i.push([c,[]])),i[t][1]=i[t][1].concat(...u)});return i}}m(s){let o=[];for(const i of this.g.values())i.has(s)&&(o=o.concat(i.get(s)));return o}$acceptMarkersChange(s){if(!this.n){const o="_generated_mirror",i=new w(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of s)this.n.set(M.URI.revive(o),i.map(b.Diagnostic.to))}};e.$9lc=g,e.$9lc=g=l=Je([We(1,D.$5j),We(2,S.$7lc)],g)}),define(Se[269],Ie([1,0,2,14,7,8,200,34]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=void 0;class m{constructor(N,S,l,w={timeout:1500,errors:3}){this.c=N,this.d=S,this.f=l,this.g=w,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(N){return(S,l,w)=>{const r={dispose:this.a.push([S,l,N])};return Array.isArray(w)&&w.push(r),r}}async $participateInSave(N,S){const l=C.URI.revive(N);let w=!1;const g=setTimeout(()=>w=!0,this.g.timeout),r=[];try{for(const s of[...this.a]){if(w)break;const o=this.d.getDocument(l),i=await this.h(s,{document:o,reason:T.TextDocumentSaveReason.to(S)});r.push(i)}}finally{clearTimeout(g)}return r}h([N,S,l],w){const g=this.b.get(N);return typeof g=="number"&&g>this.g.errors?Promise.resolve(!1):this.i(l,N,S,w).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const s=this.b.get(N);this.b.set(N,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(N,S,l,w){const g=[],r=Date.now(),{document:s,reason:o}=w,{version:i}=s,n=Object.freeze({document:s,reason:o,waitUntil(c){if(Object.isFrozen(g))throw(0,O.$8)("waitUntil can not be called async");g.push(Promise.resolve(c))}});try{S.apply(l,[n])}catch(c){return Promise.reject(c)}return Object.freeze(g),new Promise((c,u)=>{const t=setTimeout(()=>u(new Error("timeout")),this.g.timeout);return Promise.all(g).then(f=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${N.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),c(f)}).catch(f=>{clearTimeout(t),u(f)})}).then(c=>{const u={edits:[]};for(const t of c)if(Array.isArray(t)&&t.every(f=>f instanceof M.$sM))for(const{newText:f,newEol:a,range:d}of t)u.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:d&&T.Range.from(d),text:f,eol:a&&T.EndOfLine.from(a)}});if(u.edits.length!==0)return i===s.version?this.f.$tryApplyWorkspaceEdit(new b.$Fw(u)):Promise.reject(new Error("concurrent_edits"))})}}e.$enc=m}),define(Se[270],Ie([1,0,5,6,2,4,113,8,15,26,7]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;class S{constructor(w,g){this.a=new C.$fe,this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=w.getProxy(T.$jM.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(r=>{for(const s of r)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const s of r)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const g=this.g.getDocument(w);if(g)return g}getDocument(w){const g=this.getDocumentData(w);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return g.document}ensureDocumentData(w){const g=this.g.getDocument(w);if(g)return Promise.resolve(g);let r=this.h.get(w.toString());return r||(r=this.f.$tryOpenDocument(w).then(s=>{this.h.delete(w.toString());const o=M.URI.revive(s);return(0,m.$jg)(this.g.getDocument(o))},s=>(this.h.delete(w.toString()),Promise.reject(s))),this.h.set(w.toString(),r)),r}createDocumentData(w){return this.f.$tryCreateDocument(w).then(g=>M.URI.revive(g))}$acceptModelLanguageChanged(w,g){const r=M.URI.revive(w),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(g),this.a.fire(s.document)}$acceptModelSaved(w){const g=M.URI.revive(w),r=this.g.getDocument(g);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(w,g){const r=M.URI.revive(w),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(g),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,g,r){const s=M.URI.revive(w),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(r),o.onEvents(g);let i;g.isUndoing?i=N.TextDocumentChangeReason.Undo:g.isRedoing&&(i=N.TextDocumentChangeReason.Redo),this.c.fire((0,D.$6n)({document:o.document,contentChanges:g.changes.map(n=>({range:b.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(w,g){(0,A.$PO)(w,g)}}e.$0lc=S}),define(Se[67],Ie([1,0,271,5,15,2,3,4,17,8,7]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=e.$Bmc=void 0,e.$Bmc=(0,A.$yi)("IExtHostEditorTabs");class S{constructor(s,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new N.$9N(T.URI.revive(this.b.input.uri));case 2:return new N.$0N(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case 3:return new N.$$N(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case 6:return new N.$_N(T.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new N.$aO(this.b.input.viewType);case 4:return new N.$bO(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new N.$cO(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new N.$dO;case 9:return new N.$eO(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));case 10:return new N.$fO;case 11:return new N.$gO(this.b.input.diffEditors.map(s=>new N.$0N(T.URI.revive(s.original),T.URI.revive(s.modified))));default:return}}}class l{constructor(s,o){this.c=[],this.d="",this.b=s,this.e=o;for(const i of s.tabs)i.isActive&&(this.d=i.id),this.c.push(new S(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,o={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return D.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(i=>i.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const i=new S(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,i),s.tabDto.isActive&&(this.d=i.tabId),i}else if(s.kind===1){const i=this.c.splice(s.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(s.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,i),i}const o=this.c.find(i=>i.tabId===s.tabDto.id);if(!o)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(s.tabDto),o}activeTabId(){return this.d}}let w=class{constructor(s){this.b=new O.$fe,this.c=new O.$fe,this.e=[],this.a=s.getProxy(b.$jM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,o={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(i=>i.apiObject))},get activeTabGroup(){const i=s.d;return(0,M.$jg)(s.e.find(c=>c.groupId===i)?.apiObject)},close:async(i,n)=>{const c=Array.isArray(i)?i:[i];return c.length?g(c[0])?this.j(c,n):this.i(c,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(s){const o=new Set(this.e.map(a=>a.groupId)),i=new Set(s.map(a=>a.groupId)),n=(0,C.$L)(o,i),c=this.e.filter(a=>n.removed.includes(a.groupId)).map(a=>a.apiObject),u=[],t=[];this.e=s.map(a=>{const d=new l(a,()=>this.d);return n.added.includes(d.groupId)?u.push(d.apiObject):t.push(d.apiObject),d});const f=(0,M.$jg)(s.find(a=>a.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:u,closed:c,changed:t}))}$acceptTabGroupUpdate(s){const o=this.e.find(i=>i.groupId===s.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const o=this.e.find(n=>n.groupId===s.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(s){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===s)return i}h(s){return this.e.find(o=>o.apiObject===s)}async i(s,o){const i=[];for(const n of s){const c=this.g(n);if(!c)throw new Error("Tab close: Invalid tab not found!");i.push(c.tabId)}return this.a.$closeTab(i,o)}async j(s,o){const i=[];for(const n of s){const c=this.h(n);if(!c)throw new Error("Group close: Invalid group not found!");i.push(c.groupId)}return this.a.$closeGroup(i,o)}};e.$Cmc=w,e.$Cmc=w=Je([We(0,m.$NO)],w);function g(r){return r.tabs!==void 0}}),define(Se[272],Ie([1,0,2,4,6,7,8,314,13,22,25,55]),function(le,e,C,O,M,T,A,b,m,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const s=this.a.indexOf(r);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),s=[];let o,i,n=14,c=14;for(const u of r){let t=o?(0,m.$Bf)(o,u):0;for(t===0?i=1:i=c;t<u.length;t++)t+1===u.length?(n=c,c=9):c+=1,s.push([i,u.toUpperCase().charCodeAt(t),c]),s.push([i,u.toLowerCase().charCodeAt(t),c]),i=c;o=u,c=n}s.push([9,58,10]),s.push([10,47,12]),this.b=new b.$K2(s)}}provideDocumentLinks(r){this.c();const s=[],o=b.$L2.computeLinks({getLineContent(i){return r.lineAt(i-1).text},getLineCount(){return r.lineCount}},this.b);for(const i of o){const n=A.DocumentLink.to(i);n.target&&s.push(n)}return s}}class w{constructor(r,s){this.i=s,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(O.$jM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,s,o,i={}){if(w.j(o),this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const n=this.h++;this.b.add(s),this.d.add(s),this.c.set(n,o);let c=2;i.isCaseSensitive&&(c+=1024),i.isReadonly&&(c+=2048),typeof o.copy=="function"&&(c+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,N.$LG)(r,"fsChunks"),c+=4);let u;i.isReadonly&&(0,S.$Xk)(i.isReadonly)&&i.isReadonly.value!==""&&(u={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,s,c,u).catch(f=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${s}`),console.error(f)});const t=o.onDidChangeFile(f=>{const a=[];for(const d of f){const{uri:$,type:p}=d;if($.scheme!==s)continue;let v;switch(p){case T.FileChangeType.Changed:v=0;break;case T.FileChangeType.Created:v=1;break;case T.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:$,type:v})}this.a.$onFileSystemChange(n,a)});return(0,M.$Sc)(()=>{t.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:s,ctime:o,mtime:i,size:n,permissions:c}=r;return{type:s,ctime:o,mtime:i,size:n,permissions:c}}$stat(r,s){return Promise.resolve(this.l(r).stat(C.URI.revive(s))).then(o=>w.k(o))}$readdir(r,s){return Promise.resolve(this.l(r).readDirectory(C.URI.revive(s)))}$readFile(r,s){return Promise.resolve(this.l(r).readFile(C.URI.revive(s))).then(o=>D.$He.wrap(o))}$writeFile(r,s,o,i){return Promise.resolve(this.l(r).writeFile(C.URI.revive(s),o.buffer,i))}$delete(r,s,o){return Promise.resolve(this.l(r).delete(C.URI.revive(s),o))}$rename(r,s,o,i){return Promise.resolve(this.l(r).rename(C.URI.revive(s),C.URI.revive(o),i))}$copy(r,s,o,i){const n=this.l(r);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(C.URI.revive(s),C.URI.revive(o),i))}$mkdir(r,s){return Promise.resolve(this.l(r).createDirectory(C.URI.revive(s)))}$watch(r,s,o,i){const n=this.l(r).watch(C.URI.revive(o),i);this.f.set(s,n)}$unwatch(r,s){const o=this.f.get(s);o&&(o.dispose(),this.f.delete(s))}$open(r,s,o){const i=this.l(r);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(C.URI.revive(s),o))}$close(r,s){const o=this.l(r);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(s))}$read(r,s,o,i){const n=this.l(r);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const c=D.$He.alloc(i);return Promise.resolve(n.read(s,o,c.buffer,0,i)).then(u=>c.slice(0,u))}$write(r,s,o,i){const n=this.l(r);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(s,o,i.buffer,0,i.byteLength))}l(r){const s=this.c.get(r);if(!s){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return s}}e.$hnc=w}),define(Se[273],Ie([1,0,5,37,2,4,8,7,43]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;class D{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,g,r,s,o,i){this.a=Math.random(),this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,O.$sk)(o),c=typeof o=="string",u=i?.correlate,t=s(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(u&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const a of f.created){const d=M.URI.revive(a);n(d.fsPath)&&(!c||g.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const a of f.changed){const d=M.URI.revive(a);n(d.fsPath)&&(!c||g.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const a of f.deleted){const d=M.URI.revive(a);n(d.fsPath)&&(!c||g.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=b.$lM.from(this.i(w,r,o,i,i?.correlate),this.b,this.c,this.d,t)}i(w,g,r,s,o){const i=b.$lM.from();if(typeof r=="string"||s?.ignoreChangeEvents&&s?.ignoreCreateEvents&&s?.ignoreDeleteEvents)return i;const n=w.getProxy(T.$jM.MainThreadFileSystemEventService);let c=!1;(r.pattern.includes(O.$ok)||r.pattern.includes(O.$pk))&&(c=!0);let u;return o&&(s?.ignoreChangeEvents||s?.ignoreCreateEvents||s?.ignoreDeleteEvents)&&(u=14,s?.ignoreChangeEvents&&(u&=-3),s?.ignoreCreateEvents&&(u&=-5),s?.ignoreDeleteEvents&&(u&=-9)),n.$watch(g.identifier.value,this.a,r.baseUri,{recursive:c,excludes:s?.excludes??[],filter:u},!!o),b.$lM.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class N{constructor(w){this.a=w,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(M.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(w,g,r){this.j=w,this.k=g,this.l=r,this.a=new C.$fe,this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.g=new C.$he,this.h=new C.$he,this.i=new C.$he,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,g,r,s){return new D(this.j,w,g,this.a.event,A.GlobPattern.from(r),s)}$onFileEvent(w){this.a.fire(new N(w))}$onDidRunFileOperation(w,g){switch(w){case 2:this.b.fire(Object.freeze({files:g.map(r=>({oldUri:M.URI.revive(r.source),newUri:M.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:g.map(r=>M.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:g.map(r=>M.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,g){return(r,s,o)=>{const i=function(c){r.call(s,c)};return i.extension=w,g.event(i,void 0,o)}}async $onWillRunFileOperation(w,g,r,s){switch(w){case 2:return await this.n(this.g,{files:g.map(o=>({oldUri:M.URI.revive(o.source),newUri:M.URI.revive(o.target)}))},r,s);case 1:return await this.n(this.i,{files:g.map(o=>M.URI.revive(o.target))},r,s);case 0:case 3:return await this.n(this.h,{files:g.map(o=>M.URI.revive(o.target))},r,s)}}async n(w,g,r,s){const o=new Set,i=[];if(await w.fireAsync(g,s,async(c,u)=>{const t=Date.now(),f=await Promise.resolve(c);f instanceof b.$vM&&(i.push([u.extension,f]),o.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",u.extension.identifier)}),s.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,c]of i){const{edits:u}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(u)}return{edit:n,extensionNames:Array.from(o)}}}e.$inc=S}),define(Se[274],Ie([1,0,18,11,20,14,91,6,26,66,13,15,2,30,315,89,98,174,21,8,7,25,76,4]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;class a{constructor(B,F){this.d=B,this.e=F}async provideDocumentSymbols(B,F){const H=this.d.getDocument(B),K=await this.e.provideDocumentSymbols(H,F);if(!(0,C.$Kb)(K))return K[0]instanceof c.$FM?K.map(n.DocumentSymbol.from):a.f(K)}static f(B){B=B.slice(0).sort((K,te)=>{let re=K.location.range.start.compareTo(te.location.range.start);return re===0&&(re=te.location.range.end.compareTo(K.location.range.end)),re});const F=[],H=[];for(const K of B){const te={name:K.name||"!!MISSING: name!!",kind:n.SymbolKind.from(K.kind),tags:K.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:n.Range.from(K.location.range),selectionRange:n.Range.from(K.location.range),children:[]};for(;;){if(H.length===0){H.push(te),F.push(te);break}const re=H[H.length-1];if(w.$yt.containsRange(re.range,te.range)&&!w.$yt.equalsRange(re.range,te.range)){re.children?.push(te),H.push(te);break}H.pop()}}return F}}class d{constructor(B,F,H,K,te,re){this.f=B,this.g=F,this.h=H,this.j=K,this.k=te,this.l=re,this.d=new t.$1lc("CodeLens"),this.e=new Map}async provideCodeLenses(B,F){const H=this.f.getDocument(B),K=await this.h.provideCodeLenses(H,F);if(!K||F.isCancellationRequested)return;const te=this.d.add(K),re=new b.$Tc;this.e.set(te,re);const Ne={cacheId:te,lenses:[]};for(let Be=0;Be<K.length;Be++)Ne.lenses.push({cacheId:[te,Be],range:n.Range.from(K[Be].range),command:this.g.toInternal(K[Be].command,re)});return Ne}async resolveCodeLens(B,F){const H=B.cacheId&&this.d.get(...B.cacheId);if(!H)return;let K;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?K=H:K=await this.h.resolveCodeLens(H,F),K||(K=H),F.isCancellationRequested)return;const te=B.cacheId&&this.e.get(B.cacheId[0]);if(te){if(!K.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return B.command=this.g.toInternal(K.command,te),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function $(Ue){return Array.isArray(Ue)?Ue.map(n.DefinitionLink.from):Ue?[n.DefinitionLink.from(Ue)]:[]}class p{constructor(B,F){this.d=B,this.e=F}async provideDefinition(B,F,H){const K=this.d.getDocument(B),te=n.Position.to(F),re=await this.e.provideDefinition(K,te,H);return $(re)}}class v{constructor(B,F){this.d=B,this.e=F}async provideDeclaration(B,F,H){const K=this.d.getDocument(B),te=n.Position.to(F),re=await this.e.provideDeclaration(K,te,H);return $(re)}}class y{constructor(B,F){this.d=B,this.e=F}async provideImplementation(B,F,H){const K=this.d.getDocument(B),te=n.Position.to(F),re=await this.e.provideImplementation(K,te,H);return $(re)}}class h{constructor(B,F){this.d=B,this.e=F}async provideTypeDefinition(B,F,H){const K=this.d.getDocument(B),te=n.Position.to(F),re=await this.e.provideTypeDefinition(K,te,H);return $(re)}}class E{static{this.f=10}constructor(B,F){this.g=B,this.h=F,this.d=0,this.e=new Map}async provideHover(B,F,H,K){const te=this.g.getDocument(B),re=n.Position.to(F);let Ne;if(H&&H.verbosityRequest){const xe=H.verbosityRequest.previousHover.id,et=this.e.get(xe);if(!et)throw new Error(`Hover with id ${xe} not found`);const tt={action:H.verbosityRequest.action,previousHover:et};Ne=await this.h.provideHover(te,re,K,tt)}else Ne=await this.h.provideHover(te,re,K);if(!Ne||(0,C.$Kb)(Ne.contents))return;Ne.range||(Ne.range=te.getWordRangeAtPosition(re)),Ne.range||(Ne.range=new c.$nM(re,re));const Be=n.Hover.from(Ne),Ke=this.d;if(this.e.size===E.f){const xe=Math.min(...this.e.keys());this.e.delete(xe)}return this.e.set(Ke,Ne),this.d+=1,{...Be,id:Ke}}releaseHover(B){this.e.delete(B)}}class k{constructor(B,F){this.d=B,this.e=F}async provideEvaluatableExpression(B,F,H){const K=this.d.getDocument(B),te=n.Position.to(F),re=await this.e.provideEvaluatableExpression(K,te,H);if(re)return n.EvaluatableExpression.from(re)}}class I{constructor(B,F){this.d=B,this.e=F}async provideInlineValues(B,F,H,K){const te=this.d.getDocument(B),re=await this.e.provideInlineValues(te,n.Range.to(F),n.InlineValueContext.to(H),K);if(Array.isArray(re))return re.map(Ne=>n.InlineValue.from(Ne))}}class P{constructor(B,F){this.d=B,this.e=F}async provideDocumentHighlights(B,F,H){const K=this.d.getDocument(B),te=n.Position.to(F),re=await this.e.provideDocumentHighlights(K,te,H);if(Array.isArray(re))return re.map(n.DocumentHighlight.from)}}class V{constructor(B,F){this.d=B,this.e=F}async provideMultiDocumentHighlights(B,F,H,K){const te=this.d.getDocument(B),re=H.map(Ke=>this.d.getDocument(Ke)),Ne=n.Position.to(F),Be=await this.e.provideMultiDocumentHighlights(te,Ne,re,K);if(Array.isArray(Be))return Be.map(n.MultiDocumentHighlight.from)}}class W{constructor(B,F){this.d=B,this.e=F}async provideLinkedEditingRanges(B,F,H){const K=this.d.getDocument(B),te=n.Position.to(F),re=await this.e.provideLinkedEditingRanges(K,te,H);if(re&&Array.isArray(re.ranges))return{ranges:(0,C.$Hb)(re.ranges.map(n.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(B,F){this.d=B,this.e=F}async provideReferences(B,F,H,K){const te=this.d.getDocument(B),re=n.Position.to(F),Ne=await this.e.provideReferences(te,re,H,K);if(Array.isArray(Ne))return Ne.map(n.location.from)}}class R{static{this.d=1e3}constructor(B,F,H,K,te,re,Ne){this.g=B,this.h=F,this.j=H,this.k=K,this.l=te,this.m=re,this.n=Ne,this.e=new t.$1lc("CodeAction"),this.f=new Map}async provideCodeActions(B,F,H,K){const te=this.g.getDocument(B),re=g.$At.isISelection(F)?n.Selection.to(F):n.Range.to(F),Ne=[];for(const tt of this.j.getDiagnostics(B))if(re.intersection(tt.range)&&Ne.push(tt)>R.d)break;const Be={diagnostics:Ne,only:H.only?new c.$HM(H.only):void 0,triggerKind:n.CodeActionTriggerKind.to(H.trigger)},Ke=await this.k.provideCodeActions(te,re,Be,K);if(!(0,C.$Lb)(Ke)||K.isCancellationRequested)return;const _e=this.e.add(Ke),xe=new b.$Tc;this.f.set(_e,xe);const et=[];for(let tt=0;tt<Ke.length;tt++){const it=Ke[tt];if(it)if(R.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,xe)});else{Be.only&&(it.kind?Be.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ot=it.ranges??[];et.push({cacheId:[_e,tt],title:it.title,command:it.command&&this.h.toInternal(it.command,xe),diagnostics:it.diagnostics&&it.diagnostics.map(n.Diagnostic.from),edit:it.edit&&n.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,u.$KG)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,u.$KG)(this.m,"codeActionRanges")?(0,C.$Hb)(ot.map(n.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:_e,actions:et}}async resolveCodeAction(B,F){const[H,K]=B,te=this.e.get(H,K);if(!te||R.o(te))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(te,F)??te;let Ne;re.edit&&(Ne=n.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const Ke=this.f.get(H);Ke&&(Be=this.h.toInternal(re.command,Ke))}return{edit:Ne,command:Be}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{constructor(B,F,H,K,te){this.e=B,this.f=F,this.g=H,this.h=K,this.j=te,this.d=new t.$1lc("DocumentPasteEdit")}async prepareDocumentPaste(B,F,H,K){if(!this.g.prepareDocumentPaste)return;const te=this.f.getDocument(B),re=F.map(Ke=>n.Range.to(Ke)),Ne=n.DataTransfer.toDataTransfer(H,()=>{throw new T.$$});if(await this.g.prepareDocumentPaste(te,re,Ne,K),K.isCancellationRequested)return;const Be=Array.from(Ne).filter(([,Ke])=>!(Ke instanceof c.$bN));return n.DataTransfer.from(Be)}async providePasteEdits(B,F,H,K,te,re){if(!this.g.provideDocumentPasteEdits)return[];const Ne=this.f.getDocument(F),Be=H.map(et=>n.Range.to(et)),Ke=n.DataTransfer.toDataTransfer(K,async et=>(await this.e.$resolvePasteFileData(this.h,B,et)).buffer),_e=await this.g.provideDocumentPasteEdits(Ne,Be,Ke,{only:te.only?new c.$gN(te.only):void 0,triggerKind:te.triggerKind},re);if(!_e||re.isCancellationRequested)return[];const xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,F){const[H,K]=B,te=this.d.get(H,K);if(!te||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(te,F)??te;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(B){this.d.delete(B)}}class G{constructor(B,F){this.d=B,this.e=F}async provideDocumentFormattingEdits(B,F,H){const K=this.d.getDocument(B),te=await this.e.provideDocumentFormattingEdits(K,F,H);if(Array.isArray(te))return te.map(n.TextEdit.from)}}class ie{constructor(B,F){this.d=B,this.e=F}async provideDocumentRangeFormattingEdits(B,F,H,K){const te=this.d.getDocument(B),re=n.Range.to(F),Ne=await this.e.provideDocumentRangeFormattingEdits(te,re,H,K);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,F,H,K){(0,S.$ig)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const te=this.d.getDocument(B),re=F.map(n.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(te,re,H,K);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}}class de{constructor(B,F){this.d=B,this.e=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,F,H,K,te){const re=this.d.getDocument(B),Ne=n.Position.to(F),Be=await this.e.provideOnTypeFormattingEdits(re,Ne,H,K,te);if(Array.isArray(Be))return Be.map(n.TextEdit.from)}}class ye{constructor(B,F){this.e=B,this.f=F,this.d=new t.$1lc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,F){const H=await this.e.provideWorkspaceSymbols(B,F);if(!(0,C.$Lb)(H))return{symbols:[]};const K=this.d.add(H),te={cacheId:K,symbols:[]};for(let re=0;re<H.length;re++){const Ne=H[re];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}te.symbols.push({...n.WorkspaceSymbol.from(Ne),cacheId:[K,re]})}return te}async resolveWorkspaceSymbol(B,F){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const H=this.d.get(...B.cacheId);if(H){const K=await this.e.resolveWorkspaceSymbol(H,F);return K&&(0,m.$8n)(B,n.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class De{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,F,H){this.d=B,this.e=F,this.f=H}async provideRenameEdits(B,F,H,K){const te=this.d.getDocument(B),re=n.Position.to(F);try{const Ne=await this.e.provideRenameEdits(te,re,H,K);return Ne?n.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Be=De.g(Ne);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(B,F,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(B),te=n.Position.to(F);try{const re=await this.e.prepareRename(K,te,H);let Ne,Be;if(c.$nM.isRange(re)?(Ne=re,Be=K.getText(re)):(0,S.$ag)(re)&&(Ne=re.range,Be=re.placeholder),!Ne||!Be)return;if(Ne.start.line>te.line||Ne.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Ne),text:Be}}catch(re){const Ne=De.g(re);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(re)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ge{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(B,F,H){this.e=B,this.f=F,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(B,F,H,K){const te=this.e.getDocument(B),re=n.Range.to(F);try{const Ne=ge.d[H],Be=await this.f.provideNewSymbolNames(te,re,Ne,K);return Be?Be.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Ne){this.g.error(ge.h(Ne)??JSON.stringify(Ne,null,"	"));return}}static h(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ue{constructor(B,F){this.resultId=B,this.tokens=F}}class Ce{constructor(B,F){this.f=B,this.g=F,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,F,H){const K=this.f.getDocument(B),te=F!==0?this.d.get(F):null;let re=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,te.resultId,H):await this.g.provideDocumentSemanticTokens(K,H);return te&&this.d.delete(F),re?(re=Ce.h(re),this.o(Ce.n(te,re),re)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return Ce.j(B)?Ce.k(B)?B:new c.$GN(new Uint32Array(B.data),B.resultId):Ce.l(B)?Ce.m(B)?B:new c.$IN(B.edits.map(F=>new c.$HN(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const F of B.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static n(B,F){if(!Ce.j(F)||!B||!B.tokens)return F;const H=B.tokens,K=H.length,te=F.data,re=te.length;let Ne=0;const Be=Math.min(K,re);for(;Ne<Be&&H[Ne]===te[Ne];)Ne++;if(Ne===K&&Ne===re)return new c.$IN([],F.resultId);let Ke=0;const _e=Be-Ne;for(;Ke<_e&&H[K-Ke-1]===te[re-Ke-1];)Ke++;return new c.$IN([{start:Ne,deleteCount:K-Ne-Ke,data:te.subarray(Ne,re-Ke)}],F.resultId)}o(B,F){if(Ce.j(B)){const H=this.e++;return this.d.set(H,new ue(B.resultId,B.data)),(0,s.$Bbb)({id:H,type:"full",data:B.data})}if(Ce.l(B)){const H=this.e++;return Ce.j(F)?this.d.set(H,new ue(F.resultId,F.data)):this.d.set(H,new ue(B.resultId)),(0,s.$Bbb)({id:H,type:"delta",deltas:(B.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class se{constructor(B,F){this.d=B,this.e=F}async provideDocumentRangeSemanticTokens(B,F,H){const K=this.d.getDocument(B),te=await this.e.provideDocumentRangeSemanticTokens(K,n.Range.to(F),H);return te?this.f(te):null}f(B){return(0,s.$Bbb)({id:0,type:"full",data:B.data})}}class Oe{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,F,H,K,te){this.f=B,this.g=F,this.h=H,this.j=K,this.k=te,this.d=new t.$1lc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,F,H,K){const te=this.f.getDocument(B),re=n.Position.to(F),Ne=te.getWordRangeAtPosition(re)||new c.$nM(re,re),Be=Ne.with({end:re}),Ke=new D.$be,_e=await this.h.provideCompletionItems(te,re,K,n.CompletionContext.to(H));if(!_e||K.isCancellationRequested)return;const xe=Array.isArray(_e)?new c.$UM(_e):_e,et=Oe.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),tt=new b.$Tc;this.e.set(et,tt);const it=[],ot={x:et,b:it,a:{replace:n.Range.from(Ne),insert:n.Range.from(Be)},c:xe.isIncomplete||void 0,d:Ke.elapsed()};for(let gt=0;gt<xe.items.length;gt++){const je=xe.items[gt],rt=this.l(je,[et,gt],Be,Ne);it.push(rt)}return ot}async resolveCompletionItem(B,F){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...B);if(!H)return;const K=this.l(H,B),te=await this.h.resolveCompletionItem(H,F);if(!te)return;const re=this.l(te,B);return(K.h!==re.h||K.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K.n!==re.n||K.o!==re.o||!(0,m.$9n)(K.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,F,H,K){const te=this.e.get(F[0]);if(!te)throw Error("DisposableStore is missing...");const re=this.g.toInternal(B.command,te),Ne={x:F,a:B.label,b:B.kind!==void 0?n.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(n.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:n.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(n.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne.h=B.textEdit.newText):typeof B.insertText=="string"?Ne.h=B.insertText:B.insertText instanceof c.$wM&&(Ne.h=B.insertText.value,Ne.i|=4);let Be;return B.textEdit?Be=B.textEdit.range:B.range&&(Be=B.range),c.$nM.isRange(Be)?Ne.j=n.Range.from(Be):Be&&(!H?.isEqual(Be.inserting)||!K?.isEqual(Be.replacing))&&(Ne.j={insert:n.Range.from(Be.inserting),replace:n.Range.from(Be.replacing)}),Ne}}class ne{async provideInlineCompletions(B,F,H,K){}disposeCompletions(B){}handleDidShowCompletionItem(B,F,H){}handlePartialAccept(B,F,H,K){}}class j extends ne{constructor(B,F,H,K){super(),this.f=B,this.g=F,this.h=H,this.j=K,this.d=new ve,this.e=(0,u.$KG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,u.$KG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,F,H,K){const te=this.g.getDocument(B),re=n.Position.to(F),Ne=await this.h.provideInlineCompletionItems(te,re,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:n.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},K);if(!Ne||K.isCancellationRequested)return;const Be=Array.isArray(Ne)?Ne:Ne.items,Ke=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],_e=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((tt,it)=>{let ot;tt.command&&(xe||(xe=new b.$Tc),ot=this.j.toInternal(tt.command,xe));const gt=tt.insertText;return{insertText:typeof gt=="string"?gt:{snippet:gt.value},filterText:tt.filterText,range:tt.range?n.Range.from(tt.range):void 0,command:ot,idx:it,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Ke.map(tt=>(xe||(xe=new b.$Tc),this.j.toInternal(tt,xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,F,H){const K=this.d.get(B)?.items[F];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K,H)}handlePartialAccept(B,F,H,K){const te=this.d.get(B)?.items[F];te&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(te,H),this.h.handleDidPartiallyAcceptCompletionItem(te,n.PartialAcceptInfo.to(K)))}}class x{async provideInlineEdits(B,F,H){const K=this.f.getDocument(B),te=await this.g.provideInlineEdit(K,{triggerKind:this.e[F.triggerKind]},H);if(!te||H.isCancellationRequested)return;let re;const Ne=this.d.createReferenceId({dispose(){re?.dispose()},item:te});let Be;te.accepted&&(re||(re=new b.$Tc),Be=this.h.toInternal(te.accepted,re));let Ke;return te.rejected&&(re||(re=new b.$Tc),Ke=this.h.toInternal(te.rejected,re)),{pid:Ne,text:te.text,range:n.Range.from(te.range),accepted:Be,rejected:Ke}}disposeEdit(B){this.d.disposeReferenceId(B)?.dispose()}constructor(B,F,H,K){this.f=F,this.g=H,this.h=K,this.d=new ve,this.e={[r.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const F=this.e++;return this.d.set(F,B),F}disposeReferenceId(B){const F=this.d.get(B);return this.d.delete(B),F}get(B){return this.d.get(B)}}class Le{constructor(B,F){this.e=B,this.f=F,this.d=new t.$1lc("SignatureHelp")}async provideSignatureHelp(B,F,H,K){const te=this.e.getDocument(B),re=n.Position.to(F),Ne=this.g(H),Be=await this.f.provideSignatureHelp(te,re,K,Ne);if(Be){const Ke=this.d.add([Be]);return{...n.SignatureHelp.from(Be),id:Ke}}}g(B){let F;if(B.activeSignatureHelp){const H=n.SignatureHelp.to(B.activeSignatureHelp),K=this.d.get(B.activeSignatureHelp.id,0);K?(F=K,F.activeSignature=H.activeSignature,F.activeParameter=H.activeParameter):F=H}return{...B,activeSignatureHelp:F}}releaseSignatureHelp(B){this.d.delete(B)}}class ke{constructor(B,F,H,K,te){this.f=B,this.g=F,this.h=H,this.j=K,this.k=te,this.d=new t.$1lc("InlayHints"),this.e=new Map}async provideInlayHints(B,F,H){const K=this.f.getDocument(B),te=n.Range.to(F),re=await this.h.provideInlayHints(K,te,H);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`);return}if(H.isCancellationRequested)return;const Ne=this.d.add(re);this.e.set(Ne,new b.$Tc);const Be={hints:[],cacheId:Ne};for(let Ke=0;Ke<re.length;Ke++)this.l(re[Ke],te)&&Be.hints.push(this.m(re[Ke],[Ne,Ke]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`),Be}async resolveInlayHint(B,F){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...B);if(!H)return;const K=await this.h.resolveInlayHint(H,F);if(K&&this.l(K))return this.m(K,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,F){return B.label.length===0||Array.isArray(B.label)&&B.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(F&&!F.contains(B.position))}m(B,F){const H=this.e.get(F[0]);if(!H)throw Error("DisposableStore is missing...");const K={label:"",cacheId:F,tooltip:n.MarkdownString.fromStrict(B.tooltip),position:n.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(n.TextEdit.from),kind:B.kind&&n.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")K.label=B.label;else{const te=[];K.label=te;for(const re of B.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:re.value,tooltip:n.MarkdownString.fromStrict(re.tooltip)};c.$xM.isLocation(re.location)&&(Ne.location=n.location.from(re.location)),re.command&&(Ne.command=this.g.toInternal(re.command,H)),te.push(Ne)}}return K}}class be{constructor(B,F){this.e=B,this.f=F,this.d=new t.$1lc("DocumentLink")}async provideLinks(B,F){const H=this.e.getDocument(B),K=await this.f.provideDocumentLinks(H,F);if(!(!Array.isArray(K)||K.length===0)&&!F.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(be.g).map(n.DocumentLink.from)};{const te=this.d.add(K),re={links:[],cacheId:te};for(let Ne=0;Ne<K.length;Ne++){if(!be.g(K[Ne]))continue;const Be=n.DocumentLink.from(K[Ne]);Be.cacheId=[te,Ne],re.links.push(Be)}return re}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,F){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...B);if(!H)return;const K=await this.f.resolveDocumentLink(H,F);if(!(!K||!be.g(K)))return n.DocumentLink.from(K)}releaseLinks(B){this.d.delete(B)}}class me{constructor(B,F){this.d=B,this.e=F}async provideColors(B,F){const H=this.d.getDocument(B),K=await this.e.provideDocumentColors(H,F);return Array.isArray(K)?K.map(re=>({color:n.Color.from(re.color),range:n.Range.from(re.range)})):[]}async provideColorPresentations(B,F,H){const K=this.d.getDocument(B),te=n.Range.to(F.range),re=n.Color.to(F.color),Ne=await this.e.provideColorPresentations(re,{document:K,range:te},H);if(Array.isArray(Ne))return Ne.map(n.ColorPresentation.from)}}class Q{constructor(B,F){this.d=B,this.e=F}async provideFoldingRanges(B,F,H){const K=this.d.getDocument(B),te=await this.e.provideFoldingRanges(K,F,H);if(Array.isArray(te))return te.map(n.FoldingRange.from)}}class Y{constructor(B,F,H){this.d=B,this.e=F,this.f=H}async provideSelectionRanges(B,F,H){const K=this.d.getDocument(B),te=F.map(n.Position.to),re=await this.e.provideSelectionRanges(K,te,H);if(!(0,C.$Lb)(re))return[];if(re.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Be=0;Be<te.length;Be++){const Ke=[];Ne.push(Ke);let _e=te[Be],xe=re[Be];for(;;){if(!xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(xe)),!xe.parent)break;_e=xe.range,xe=xe.parent}}return Ne}}class he{constructor(B,F){this.f=B,this.g=F,this.d=new A.$SO(""),this.e=new Map}async prepareSession(B,F,H){const K=this.f.getDocument(B),te=n.Position.to(F),re=await this.g.prepareCallHierarchy(K,te,H);if(!re)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(re)?re.map(Be=>this.h(Ne,Be)):[this.h(Ne,re)]}async provideCallsTo(B,F,H){const K=this.j(B,F);if(!K)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(K,H);if(te)return te.map(re=>({from:this.h(B,re.from),fromRanges:re.fromRanges.map(Ne=>n.Range.from(Ne))}))}async provideCallsFrom(B,F,H){const K=this.j(B,F);if(!K)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(K,H);if(te)return te.map(re=>({to:this.h(B,re.to),fromRanges:re.fromRanges.map(Ne=>n.Range.from(Ne))}))}releaseSession(B){this.e.delete(B)}h(B,F){const H=this.e.get(B),K=n.CallHierarchyItem.from(F,B,H.size.toString(36));return H.set(K._itemId,F),K}j(B,F){return this.e.get(B)?.get(F)}}class ce{constructor(B,F){this.f=B,this.g=F,this.d=new A.$SO(""),this.e=new Map}async prepareSession(B,F,H){const K=this.f.getDocument(B),te=n.Position.to(F),re=await this.g.prepareTypeHierarchy(K,te,H);if(!re)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(re)?re.map(Be=>this.h(Ne,Be)):[this.h(Ne,re)]}async provideSupertypes(B,F,H){const K=this.j(B,F);if(!K)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(K,H);if(te)return te.map(re=>this.h(B,re))}async provideSubtypes(B,F,H){const K=this.j(B,F);if(!K)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(K,H);if(te)return te.map(re=>this.h(B,re))}releaseSession(B){this.e.delete(B)}h(B,F){const H=this.e.get(B),K=n.TypeHierarchyItem.from(F,B,H.size.toString(36));return H.set(K._itemId,F),K}j(B,F){return this.e.get(B)?.get(F)}}class Te{constructor(B,F,H,K,te){this.e=B,this.f=F,this.g=H,this.h=K,this.j=te,this.d=new t.$1lc("DocumentDropEdit")}async provideDocumentOnDropEdits(B,F,H,K,te){const re=this.f.getDocument(F),Ne=n.Position.to(H),Be=n.DataTransfer.toDataTransfer(K,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,B,et)).buffer),Ke=await this.g.provideDocumentDropEdits(re,Ne,Be,te);if(!Ke)return;const _e=(0,C.$2b)(Ke),xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?n.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(B,F){const[H,K]=B,te=this.d.get(H,K);if(!te||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(te,F)??te;return{additionalEdit:re.additionalEdit?n.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(B){this.d.delete(B)}}class fe{constructor(B,F){this.d=B,this.e=F}async provideMappedEdits(B,F,H,K){const te=l.URI.revive(B),re=this.d.getDocument(te),Ne=H.documents.map(_e=>_e.map(xe=>({uri:l.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(et=>n.Range.to(et))}))),Be={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(re,F,Be,K);return Ke?n.WorkspaceEdit.from(Ke):null}}class Pe{constructor(B,F){this.adapter=B,this.extension=F}}class Re{static{this.d=0}constructor(B,F,H,K,te,re,Ne,Be){this.g=F,this.h=H,this.j=K,this.k=te,this.l=re,this.m=Ne,this.n=Be,this.f=new Map,this.e=B.getProxy(f.$jM.MainThreadLanguageFeatures)}o(B,F){return n.DocumentSelector.from(B,this.g,F)}p(B){return new c.$lM(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return Re.d++}async s(B,F,H,K,te,re=!1){const Ne=this.f.get(B);if(!Ne||!(Ne.adapter instanceof F))return K;const Be=Date.now();re||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ke=H(Ne.adapter,Ne.extension);return Promise.resolve(Ke).catch(_e=>{(0,T.$4)(_e)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ne.extension.identifier,_e))}).finally(()=>{re||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),M.CancellationToken.isCancellationToken(te)?(0,O.$nh)(Ke,te):Ke}t(B,F){const H=this.q();return this.f.set(H,new Pe(B,F)),H}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,F,H,K){const te=this.t(new a(this.h,H),B),re=K&&K.label||Re.u(B);return this.e.$registerDocumentSymbolProvider(te,this.o(F,B),re),this.p(te)}$provideDocumentSymbols(B,F,H){return this.s(B,a,K=>K.provideDocumentSymbols(l.URI.revive(F),H),void 0,H)}registerCodeLensProvider(B,F,H){const K=this.q(),te=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new Pe(new d(this.h,this.j.converter,H,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(K,this.o(F,B),te);let re=this.p(K);if(te!==void 0){const Ne=H.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(te));re=c.$lM.from(re,Ne)}return re}$provideCodeLenses(B,F,H){return this.s(B,d,K=>K.provideCodeLenses(l.URI.revive(F),H),void 0,H)}$resolveCodeLens(B,F,H){return this.s(B,d,K=>K.resolveCodeLens(F,H),void 0,void 0)}$releaseCodeLenses(B,F){this.s(B,d,H=>Promise.resolve(H.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(B,F,H){const K=this.t(new p(this.h,H),B);return this.e.$registerDefinitionSupport(K,this.o(F,B)),this.p(K)}$provideDefinition(B,F,H,K){return this.s(B,p,te=>te.provideDefinition(l.URI.revive(F),H,K),[],K)}registerDeclarationProvider(B,F,H){const K=this.t(new v(this.h,H),B);return this.e.$registerDeclarationSupport(K,this.o(F,B)),this.p(K)}$provideDeclaration(B,F,H,K){return this.s(B,v,te=>te.provideDeclaration(l.URI.revive(F),H,K),[],K)}registerImplementationProvider(B,F,H){const K=this.t(new y(this.h,H),B);return this.e.$registerImplementationSupport(K,this.o(F,B)),this.p(K)}$provideImplementation(B,F,H,K){return this.s(B,y,te=>te.provideImplementation(l.URI.revive(F),H,K),[],K)}registerTypeDefinitionProvider(B,F,H){const K=this.t(new h(this.h,H),B);return this.e.$registerTypeDefinitionSupport(K,this.o(F,B)),this.p(K)}$provideTypeDefinition(B,F,H,K){return this.s(B,h,te=>te.provideTypeDefinition(l.URI.revive(F),H,K),[],K)}registerHoverProvider(B,F,H,K){const te=this.t(new E(this.h,H),B);return this.e.$registerHoverProvider(te,this.o(F,B)),this.p(te)}$provideHover(B,F,H,K,te){return this.s(B,E,re=>re.provideHover(l.URI.revive(F),H,K,te),void 0,te)}$releaseHover(B,F){this.s(B,E,H=>Promise.resolve(H.releaseHover(F)),void 0,void 0)}registerEvaluatableExpressionProvider(B,F,H,K){const te=this.t(new k(this.h,H),B);return this.e.$registerEvaluatableExpressionProvider(te,this.o(F,B)),this.p(te)}$provideEvaluatableExpression(B,F,H,K){return this.s(B,k,te=>te.provideEvaluatableExpression(l.URI.revive(F),H,K),void 0,K)}registerInlineValuesProvider(B,F,H,K){const te=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new I(this.h,H),B);this.e.$registerInlineValuesProvider(re,this.o(F,B),te);let Ne=this.p(re);if(te!==void 0){const Be=H.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(te));Ne=c.$lM.from(Ne,Be)}return Ne}$provideInlineValues(B,F,H,K,te){return this.s(B,I,re=>re.provideInlineValues(l.URI.revive(F),H,K,te),void 0,te)}registerDocumentHighlightProvider(B,F,H){const K=this.t(new P(this.h,H),B);return this.e.$registerDocumentHighlightProvider(K,this.o(F,B)),this.p(K)}registerMultiDocumentHighlightProvider(B,F,H){const K=this.t(new V(this.h,H),B);return this.e.$registerMultiDocumentHighlightProvider(K,this.o(F,B)),this.p(K)}$provideDocumentHighlights(B,F,H,K){return this.s(B,P,te=>te.provideDocumentHighlights(l.URI.revive(F),H,K),void 0,K)}$provideMultiDocumentHighlights(B,F,H,K,te){return this.s(B,V,re=>re.provideMultiDocumentHighlights(l.URI.revive(F),H,K.map(Ne=>l.URI.revive(Ne)),te),void 0,te)}registerLinkedEditingRangeProvider(B,F,H){const K=this.t(new W(this.h,H),B);return this.e.$registerLinkedEditingRangeProvider(K,this.o(F,B)),this.p(K)}$provideLinkedEditingRanges(B,F,H,K){return this.s(B,W,async te=>{const re=await te.provideLinkedEditingRanges(l.URI.revive(F),H,K);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Re.w(re.wordPattern):void 0}},void 0,K)}registerReferenceProvider(B,F,H){const K=this.t(new q(this.h,H),B);return this.e.$registerReferenceSupport(K,this.o(F,B)),this.p(K)}$provideReferences(B,F,H,K,te){return this.s(B,q,re=>re.provideReferences(l.URI.revive(F),H,K,te),void 0,te)}registerCodeActionProvider(B,F,H,K){const te=new b.$Tc,re=this.t(new R(this.h,this.j.converter,this.k,H,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(re,this.o(F,B),{providedKinds:K?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:K?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,te)}))},Re.u(B),!!H.resolveCodeAction),te.add(this.p(re)),te}$provideCodeActions(B,F,H,K,te){return this.s(B,R,re=>re.provideCodeActions(l.URI.revive(F),H,K,te),void 0,te)}$resolveCodeAction(B,F,H){return this.s(B,R,K=>K.resolveCodeAction(F,H),{},void 0)}$releaseCodeActions(B,F){this.s(B,R,H=>Promise.resolve(H.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(B,F,H){const K=this.t(new G(this.h,H),B);return this.e.$registerDocumentFormattingSupport(K,this.o(F,B),B.identifier,B.displayName||B.name),this.p(K)}$provideDocumentFormattingEdits(B,F,H,K){return this.s(B,G,te=>te.provideDocumentFormattingEdits(l.URI.revive(F),H,K),void 0,K)}registerDocumentRangeFormattingEditProvider(B,F,H){const K=typeof H.provideDocumentRangesFormattingEdits=="function",te=this.t(new ie(this.h,H),B);return this.e.$registerRangeFormattingSupport(te,this.o(F,B),B.identifier,B.displayName||B.name,K),this.p(te)}$provideDocumentRangeFormattingEdits(B,F,H,K,te){return this.s(B,ie,re=>re.provideDocumentRangeFormattingEdits(l.URI.revive(F),H,K,te),void 0,te)}$provideDocumentRangesFormattingEdits(B,F,H,K,te){return this.s(B,ie,re=>re.provideDocumentRangesFormattingEdits(l.URI.revive(F),H,K,te),void 0,te)}registerOnTypeFormattingEditProvider(B,F,H,K){const te=this.t(new de(this.h,H),B);return this.e.$registerOnTypeFormattingSupport(te,this.o(F,B),K,B.identifier),this.p(te)}$provideOnTypeFormattingEdits(B,F,H,K,te,re){return this.s(B,de,Ne=>Ne.provideOnTypeFormattingEdits(l.URI.revive(F),H,K,te,re),void 0,re)}registerWorkspaceSymbolProvider(B,F){const H=this.t(new ye(F,this.l),B);return this.e.$registerNavigateTypeSupport(H,typeof F.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(B,F,H){return this.s(B,ye,K=>K.provideWorkspaceSymbols(F,H),{symbols:[]},H)}$resolveWorkspaceSymbol(B,F,H){return this.s(B,ye,K=>K.resolveWorkspaceSymbol(F,H),void 0,void 0)}$releaseWorkspaceSymbols(B,F){this.s(B,ye,H=>H.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(B,F,H){const K=this.t(new De(this.h,H,this.l),B);return this.e.$registerRenameSupport(K,this.o(F,B),De.supportsResolving(H)),this.p(K)}$provideRenameEdits(B,F,H,K,te){return this.s(B,De,re=>re.provideRenameEdits(l.URI.revive(F),H,K,te),void 0,te)}$resolveRenameLocation(B,F,H,K){return this.s(B,De,te=>te.resolveRenameLocation(l.URI.revive(F),H,K),void 0,K)}registerNewSymbolNamesProvider(B,F,H){const K=this.t(new ge(this.h,H,this.l),B);return this.e.$registerNewSymbolNamesProvider(K,this.o(F,B)),this.p(K)}$supportsAutomaticNewSymbolNamesTriggerKind(B){return this.s(B,ge,F=>F.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(B,F,H,K,te){return this.s(B,ge,re=>re.provideNewSymbolNames(l.URI.revive(F),H,K,te),void 0,te)}registerDocumentSemanticTokensProvider(B,F,H,K){const te=this.t(new Ce(this.h,H),B),re=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o(F,B),K,re);let Ne=this.p(te);if(re){const Be=H.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(re));Ne=c.$lM.from(Ne,Be)}return Ne}$provideDocumentSemanticTokens(B,F,H,K){return this.s(B,Ce,te=>te.provideDocumentSemanticTokens(l.URI.revive(F),H,K),null,K)}$releaseDocumentSemanticTokens(B,F){this.s(B,Ce,H=>H.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,F,H,K){const te=this.t(new se(this.h,H),B);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o(F,B),K),this.p(te)}$provideDocumentRangeSemanticTokens(B,F,H,K){return this.s(B,se,te=>te.provideDocumentRangeSemanticTokens(l.URI.revive(F),H,K),null,K)}registerCompletionItemProvider(B,F,H,K){const te=this.t(new Oe(this.h,this.j.converter,H,this.m,B),B);return this.e.$registerCompletionsProvider(te,this.o(F,B),K,Oe.supportsResolving(H),B.identifier),this.p(te)}$provideCompletionItems(B,F,H,K,te){return this.s(B,Oe,re=>re.provideCompletionItems(l.URI.revive(F),H,K,te),void 0,te)}$resolveCompletionItem(B,F,H){return this.s(B,Oe,K=>K.resolveCompletionItem(F,H),void 0,H)}$releaseCompletionItems(B,F){this.s(B,Oe,H=>H.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(B,F,H,K){const te=new j(B,this.h,H,this.j.converter),re=this.t(te,B);return this.e.$registerInlineCompletionsSupport(re,this.o(F,B),te.supportsHandleEvents,i.$Tm.toKey(B.identifier.value),K?.yieldTo?.map(Ne=>i.$Tm.toKey(Ne))||[]),this.p(re)}$provideInlineCompletions(B,F,H,K,te){return this.s(B,ne,re=>re.provideInlineCompletions(l.URI.revive(F),H,K,te),void 0,te)}$handleInlineCompletionDidShow(B,F,H,K){this.s(B,ne,async te=>{te.handleDidShowCompletionItem(F,H,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,F,H,K,te){this.s(B,ne,async re=>{re.handlePartialAccept(F,H,K,te)},void 0,void 0)}$freeInlineCompletionsList(B,F){this.s(B,ne,async H=>{H.disposeCompletions(F)},void 0,void 0)}registerInlineEditProvider(B,F,H){const K=new x(B,this.h,H,this.j.converter),te=this.t(K,B);return this.e.$registerInlineEditProvider(te,this.o(F,B),B.identifier),this.p(te)}$provideInlineEdit(B,F,H,K){return this.s(B,x,te=>te.provideInlineEdits(l.URI.revive(F),H,K),void 0,K)}$freeInlineEdit(B,F){this.s(B,x,async H=>{H.disposeEdit(F)},void 0,void 0)}registerSignatureHelpProvider(B,F,H,K){const te=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,re=this.t(new Le(this.h,H),B);return this.e.$registerSignatureHelpProvider(re,this.o(F,B),te),this.p(re)}$provideSignatureHelp(B,F,H,K,te){return this.s(B,Le,re=>re.provideSignatureHelp(l.URI.revive(F),H,K,te),void 0,te)}$releaseSignatureHelp(B,F){this.s(B,Le,H=>H.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(B,F,H){const K=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new ke(this.h,this.j.converter,H,this.l,B),B);this.e.$registerInlayHintsProvider(te,this.o(F,B),typeof H.resolveInlayHint=="function",K,Re.u(B));let re=this.p(te);if(K!==void 0){const Ne=H.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(K));re=c.$lM.from(re,Ne)}return re}$provideInlayHints(B,F,H,K){return this.s(B,ke,te=>te.provideInlayHints(l.URI.revive(F),H,K),void 0,K)}$resolveInlayHint(B,F,H){return this.s(B,ke,K=>K.resolveInlayHint(F,H),void 0,H)}$releaseInlayHints(B,F){this.s(B,ke,H=>H.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(B,F,H){const K=this.t(new be(this.h,H),B);return this.e.$registerDocumentLinkProvider(K,this.o(F,B),typeof H.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(B,F,H){return this.s(B,be,K=>K.provideLinks(l.URI.revive(F),H),void 0,H,F.scheme==="output")}$resolveDocumentLink(B,F,H){return this.s(B,be,K=>K.resolveLink(F,H),void 0,void 0,!0)}$releaseDocumentLinks(B,F){this.s(B,be,H=>H.releaseLinks(F),void 0,void 0,!0)}registerColorProvider(B,F,H){const K=this.t(new me(this.h,H),B);return this.e.$registerDocumentColorProvider(K,this.o(F,B)),this.p(K)}$provideDocumentColors(B,F,H){return this.s(B,me,K=>K.provideColors(l.URI.revive(F),H),[],H)}$provideColorPresentations(B,F,H,K){return this.s(B,me,te=>te.provideColorPresentations(l.URI.revive(F),H,K),void 0,K)}registerFoldingRangeProvider(B,F,H){const K=this.q(),te=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new Pe(new Q(this.h,H),B)),this.e.$registerFoldingRangeProvider(K,this.o(F,B),B.identifier,te);let re=this.p(K);if(te!==void 0){const Ne=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));re=c.$lM.from(re,Ne)}return re}$provideFoldingRanges(B,F,H,K){return this.s(B,Q,te=>te.provideFoldingRanges(l.URI.revive(F),H,K),void 0,K)}registerSelectionRangeProvider(B,F,H){const K=this.t(new Y(this.h,H,this.l),B);return this.e.$registerSelectionRangeProvider(K,this.o(F,B)),this.p(K)}$provideSelectionRanges(B,F,H,K){return this.s(B,Y,te=>te.provideSelectionRanges(l.URI.revive(F),H,K),[],K)}registerCallHierarchyProvider(B,F,H){const K=this.t(new he(this.h,H),B);return this.e.$registerCallHierarchyProvider(K,this.o(F,B)),this.p(K)}$prepareCallHierarchy(B,F,H,K){return this.s(B,he,te=>Promise.resolve(te.prepareSession(l.URI.revive(F),H,K)),void 0,K)}$provideCallHierarchyIncomingCalls(B,F,H,K){return this.s(B,he,te=>te.provideCallsTo(F,H,K),void 0,K)}$provideCallHierarchyOutgoingCalls(B,F,H,K){return this.s(B,he,te=>te.provideCallsFrom(F,H,K),void 0,K)}$releaseCallHierarchy(B,F){this.s(B,he,H=>Promise.resolve(H.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(B,F,H){const K=this.t(new ce(this.h,H),B);return this.e.$registerTypeHierarchyProvider(K,this.o(F,B)),this.p(K)}$prepareTypeHierarchy(B,F,H,K){return this.s(B,ce,te=>Promise.resolve(te.prepareSession(l.URI.revive(F),H,K)),void 0,K)}$provideTypeHierarchySupertypes(B,F,H,K){return this.s(B,ce,te=>te.provideSupertypes(F,H,K),void 0,K)}$provideTypeHierarchySubtypes(B,F,H,K){return this.s(B,ce,te=>te.provideSubtypes(F,H,K),void 0,K)}$releaseTypeHierarchy(B,F){this.s(B,ce,H=>Promise.resolve(H.releaseSession(F)),void 0,void 0)}registerDocumentOnDropEditProvider(B,F,H,K){const te=this.q();return this.f.set(te,new Pe(new Te(this.e,this.h,H,te,B),B)),this.e.$registerDocumentOnDropEditProvider(te,this.o(F,B),(0,u.$KG)(B,"documentPaste")&&K?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:K.dropMimeTypes}:void 0),this.p(te)}$provideDocumentOnDropEdits(B,F,H,K,te,re){return this.s(B,Te,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(F,l.URI.revive(H),K,te,re)),void 0,void 0)}$resolveDropEdit(B,F,H){return this.s(B,Te,K=>K.resolveDropEdit(F,H),{},void 0)}$releaseDropEdits(B,F){this.s(B,Te,H=>Promise.resolve(H.releaseDropEdits(F)),void 0,void 0)}registerMappedEditsProvider(B,F,H){const K=this.t(new fe(this.h,H),B);return this.e.$registerMappedEditsProvider(K,this.o(F,B)),this.p(K)}$provideMappedEdits(B,F,H,K,te){return this.s(B,fe,re=>Promise.resolve(re.provideMappedEdits(F,H,K,te)),null,te)}registerDocumentPasteEditProvider(B,F,H,K){const te=this.q();return this.f.set(te,new Pe(new z(this.e,this.h,H,te,B),B)),this.e.$registerPasteEditProvider(te,this.o(F,B),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:K.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this.p(te)}$prepareDocumentPaste(B,F,H,K,te){return this.s(B,z,re=>re.prepareDocumentPaste(l.URI.revive(F),H,K,te),void 0,te)}$providePasteEdits(B,F,H,K,te,re,Ne){return this.s(B,z,Be=>Be.providePasteEdits(F,l.URI.revive(H),K,te,re,Ne),void 0,Ne)}$resolvePasteEdit(B,F,H){return this.s(B,z,K=>K.resolvePasteEdit(F,H),{},void 0)}$releasePasteEdits(B,F){this.s(B,z,H=>Promise.resolve(H.releasePasteEdits(F)),void 0,void 0)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:Re.w(B.decreaseIndentPattern),increaseIndentPattern:Re.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Re.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Re.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:Re.w(B.beforeText),afterText:B.afterText?Re.w(B.afterText):void 0,previousLineText:B.previousLineText?Re.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(Re.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(F=>c.SyntaxTokenType.toString(F)):void 0}}static D(B){return B.map(Re.C)}setLanguageConfiguration(B,F,H){const{wordPattern:K}=H;if(K&&(0,N.$lf)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(F,K):this.h.setWordDefinitionFor(F,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const te=this.q(),re={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Re.w(H.wordPattern):void 0,indentationRules:H.indentationRules?Re.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Re.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Re.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(te,F,re),this.p(te)}$setWordDefinitions(B){for(const F of B)this.h.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}e.$$lc=Re}),define(Se[90],Ie([1,0,11,20,14,5,42,6,175,21,3,12,103,4,86,17,8,7,108,25]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Smc=e.$Rmc=void 0,e.$Rmc=(0,N.$yi)("IExtHostLanguageModels");class u{constructor(d,$){this.option=d,this.stream=new C.$2h,this.stream=$??new C.$2h}}class t{constructor(){this.a=new Map,this.b=new C.$2h,this.c=!1,this.d=!1;const d=this;this.apiObject={stream:d.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,d]of this.a)yield d.stream;else yield this.b}handleFragment(d){if(this.c)return;this.d=!0;let $=this.a.get(d.index);$||(this.a.size===0?$=new u(d.index,this.b):$=new u(d.index),this.a.set(d.index,$)),$.stream.emitOne(d.part)}get isStreaming(){return this.d}reject(d){this.c=!0;for(const $ of this.f())$.reject(d)}resolve(){this.c=!0;for(const d of this.f())d.resolve()}}let f=class{static{c=this}static{this.a=1}constructor(d,$,p){this.j=$,this.k=p,this.c=new T.$fe,this.d=new T.$fe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new D.$Vm,this.i=new Map,this.r=new Set,this.b=d.getProxy(w.$jM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(d,$,p,v){const y=c.a++;this.f.set(y,{extension:d.identifier,provider:p,languageModelId:$});let h;v.auth&&(h={providerLabel:d.displayName||d.name,accountLabel:typeof v.auth=="object"?v.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,`${D.$Tm.toKey(d.identifier)}/${y}/${$}`,{extension:d.identifier,id:$,vendor:v.vendor??D.$Tm.toKey(d.identifier),name:v.name??"",family:v.family??"",version:v.version,tokens:v.tokens,auth:h,targetExtensions:v.extensions});const E=p.onDidReceiveLanguageModelResponse2?.(({extensionId:k,participant:I,tokenCount:P})=>{this.b.$whenLanguageModelChatRequestMade($,new D.$Tm(k),I,P)});return(0,b.$Sc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),E?.dispose()})}async $provideLanguageModelResponse(d,$,p,v,y,h){const E=this.f.get(d);if(!E)return;const k=new l.$hw(async I=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${E.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk($,{index:I.index,part:I.part})});return E.provider.provideLanguageModelResponse(v.map(s.LanguageModelChatMessage.to),y,D.$Tm.toKey(p),k,h)}$provideTokenLength(d,$,p){const v=this.f.get(d);return v?Promise.resolve(v.provider.provideTokenCount($,p)):Promise.resolve(0)}$acceptChatModelMetadata(d){if(d.added)for(const{identifier:$,metadata:p}of d.added)this.g.set($,{metadata:p,apiObjects:new D.$Vm});if(d.removed)for(const $ of d.removed){this.g.delete($);for(const[p,v]of this.i)v.languageModelId===$&&(v.res.reject(new M.$5),this.i.delete(p))}d.added?.forEach($=>this.p($.metadata)),this.d.fire(void 0)}async selectLanguageModels(d,$){const p=await this.b.$selectChatModels({...$,extension:d.identifier}),v=[],y=this;for(const h of p){const E=this.g.get(h);if(!E)continue;let k=E.apiObjects.get(d.identifier);k||(k={id:h,vendor:E.metadata.vendor,family:E.metadata.family,version:E.metadata.version,name:E.metadata.name,contextSize:E.metadata.tokens,countTokens(I,P){if(!y.g.has(h))throw o.$AO.NotFound(h);return y.q(h,I,P??O.CancellationToken.None)},sendRequest(I,P,V){if(!y.g.has(h))throw o.$AO.NotFound(h);return y.l(d,h,I,P??{},V??O.CancellationToken.None)}},Object.freeze(k),E.apiObjects.set(d.identifier,k)),v.push(k)}if(v.length!==0)return v}async l(d,$,p,v,y){const h=this.m(d,p),E=d.identifier,k=this.g.get($)?.metadata;if(!k||!this.g.has($))throw o.$AO.NotFound(`Language model '${$}' is unknown.`);if(this.o(E,k)&&(!await this.n(d,{identifier:k.extension,displayName:k.auth.providerLabel},v.justification,!1)||!this.h.get(E)?.has(k.extension)))throw o.$AO.NoPermissions(`Language model '${$}' cannot be used by '${E.value}'.`);const I=Math.random()*1e6|0,P=this.b.$fetchResponse(E,$,I,h,v.modelOptions??{},y),V=new C.$xh,W=new t;this.i.set(I,{languageModelId:$,res:W});let q;if(P.catch(R=>{V.isOpen()?W.reject(R):q=R}).finally(()=>{this.i.delete(I),W.resolve(),V.open()}),await V.wait(),q)throw q.name===o.$AO.name?q:new o.$AO(`Language model '${$}' errored, check cause for more details`,"Unknown",q);return W.apiObject}m(d,$){const p=[];for(const v of $)v.role===o.LanguageModelChatMessageRole.System&&(0,n.$LG)(d,"languageModelSystem"),p.push(s.LanguageModelChatMessage.from(v));return p}async $handleResponseFragment(d,$){const p=this.i.get(d);p&&p.res.handleFragment($)}async n(d,$,p,v){const y=i.$lL+$.identifier.value;if(await this.k.getSession(d,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:d.identifier,to:$.identifier,enabled:!0}]),!0;if(v)return!1;try{const E=p?(0,m.localize)(0,null,$.displayName,p):(0,m.localize)(1,null,$.displayName);return await this.k.getSession(d,y,[],{forceNewSession:{detail:E}}),this.$updateModelAccesslist([{from:d.identifier,to:$.identifier,enabled:!0}]),!0}catch{return!1}}o(d,$){return!!$.auth&&!D.$Tm.equals($.extension,d)}async p(d){for(const $ of this.r)try{await this.n($,{identifier:d.extension,displayName:""},void 0,!0)}catch(p){this.j.error("Fake Auth request failed"),this.j.error(p)}}async q(d,$,p){if(!this.g.get(d))throw o.$AO.NotFound(`Language model '${d}' is unknown.`);const y=A.Iterable.find(this.f.values(),h=>h.languageModelId===d);return y?y.provider.provideTokenCount($,p):this.b.$countTokens(d,typeof $=="string"?$:s.LanguageModelChatMessage.from($),p)}$updateModelAccesslist(d){const $=new Array;for(const{from:p,to:v,enabled:y}of d){const h=this.h.get(p)??new D.$Um;if(h.has(v)!==y){y?h.add(v):h.delete(v),this.h.set(p,h);const k={from:p,to:v};$.push(k),this.c.fire(k)}}}createLanguageModelAccessInformation(d){this.r.add(d);const $=this,p=T.Event.signal(T.Event.filter(this.c.event,y=>D.$Tm.equals(y.from,d.identifier))),v=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(p,v)},canSendRequest(y){const h=$.g.get(y);if(!h)return;if(!$.o(d.identifier,h.metadata))return!0;const E=$.h.get(d.identifier);if(E)return E.has(h.metadata.extension)}}}};e.$Smc=f,e.$Smc=f=c=Je([We(0,r.$NO),We(1,S.$5j),We(2,g.$amc)],f)}),define(Se[275],Ie([1,0,4,8,7,32,11,6,25]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=void 0;class D{constructor(S,l,w,g){this.c=l,this.d=w,this.e=g,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(C.$jM.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const w=this.c.getDocumentData(S);if(!w)throw new Error(`document '${S.toString()}' NOT found`);return w.document}async tokenAtPosition(S,l){const w=S.version,g=O.Position.from(l),r=await this.a.$tokensAtPosition(S.uri,g),s={type:M.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new M.$nM(l.line,l.character,l.line,l.character)};if(!r)return s;const o={range:O.Range.to(r.range),type:O.TokenType.to(r.type)};return!o.range.contains(l)||w!==S.version?s:o}createLanguageStatusItem(S,l,w){const g=this.f++,r=this.a,s=this.g,o=`${S.identifier.value}/${l}`;if(s.has(o))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);s.add(o);const i={selector:w,id:l,name:S.displayName??S.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const c=new b.$Tc,u=()=>{if(n?.dispose(),!s.has(o)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,A.$Ah)(()=>{c.clear(),this.a.$setLanguageStatus(g,{id:o,name:i.name??S.displayName??S.name,source:S.displayName??S.name,selector:O.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===M.LanguageStatusSeverity.Error?T.default.Error:i.severity===M.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:i.command&&this.d.toInternal(i.command,c),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){c.dispose(),n?.dispose(),r.$removeLanguageStatus(g),s.delete(o)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,u()},get selector(){return i.selector},set selector(f){i.selector=f,u()},get text(){return i.text},set text(f){i.text=f,u()},set text2(f){(0,m.$LG)(S,"languageStatusText"),i.text=f,u()},get text2(){return(0,m.$LG)(S,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,u()},get severity(){return i.severity},set severity(f){i.severity=f,u()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,u()},get command(){return i.command},set command(f){i.command=f,u()},get busy(){return i.busy},set busy(f){i.busy=f,u()}};return u(),t}}e.$xnc=D}),define(Se[276],Ie([1,0,16,2,8,7,85]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=e.$jnc=void 0;class b{constructor(S,l,w,g){this.start=S,this.deletedCount=l,this.deletedItems=w,this.items=g}asApiEvent(){return{range:new T.$NN(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,l,w){this.notebook=S,this.h=l,this.j=w,this.handle=w.handle,this.uri=O.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(M.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(g){S.g=g},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(w)}return this.f}setOutputs(S){this.a=S.map(M.NotebookCellOutput.to)}setOutputItems(S,l,w){const g=w.map(M.NotebookCellOutputItem.to),r=this.a.find(s=>s.id===S);if(r&&(l||(r.items.length=0),r.items.push(...g),r.items.length>1&&r.items.every(s=>A.$fK(s.mime)))){const s=new Map,o=[];r.items.forEach(i=>{let n;s.has(i.mime)?n=s.get(i.mime):(n=[],s.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),r.items.length=0,o.forEach(i=>{const n=A.$gK(s.get(i));r.items.push({mime:i,data:n.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$jnc=m;class D{static{this.a=0}constructor(S,l,w,g,r){this.k=S,this.l=l,this.m=w,this.uri=g,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===C.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(w){return w=S.n(w),S.b[w].apiCell},getCells(w){return(w?S.p(w):S.b).map(r=>r.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,w){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:w});const g={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},r=[];for(const o of S.rawEvents)o.kind===A.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,g.contentChanges):o.kind===A.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,g.contentChanges):o.kind===A.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),r.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),r.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),r.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),r.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),r.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const s=new Map;for(let o=0;o<r.length;o++){const i=r[o],n=s.get(i.cell);if(n===void 0){const c=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});s.set(i.cell,c-1)}else g.cellChanges[n]={...g.cellChanges[n],...i}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,w=S.end|0;return l<0&&(l=0),w>this.b.length&&(w=this.b.length),S.with({start:l,end:w})}p(S){S=this.o(S);const l=[];for(let w=S.start;w<S.end;w++)l.push(this.b[w]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,w){if(this.j)return;const g=[],r=[],s=[];if(S.reverse().forEach(o=>{const n=o[2].map(t=>{const f=new m(this,this.l,t);return l||r.push(m.asModelAddData(t)),f}),c=new b(o[0],o[1],[],n),u=this.b.splice(o[0],o[1],...n);for(const t of u)s.push(t.uri),c.deletedItems.push(t.apiCell);g.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:s}),w)for(const o of g)w.push(o.asApiEvent())}s(S,l,w,g){const r=this.b.splice(S,l);this.b.splice(w,0,...r);const s=[new b(S,l,r.map(o=>o.apiCell),[]),new b(w,0,[],r)];for(const o of s)g.push(o.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,w,g){this.b[S].setOutputItems(l,w,g)}v(S,l){const w=this.b[S];w.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(w.uri,l)}w(S,l){const w=this.b[S];w.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$knc=D}),define(Se[277],Ie([1,0,5,2,8,7,34]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;class b{constructor(D,N,S,l={timeout:1500,errors:3}){this.b=D,this.c=N,this.d=S,this.f=l,this.a=new C.$he}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(N,S,l)=>{const w=function(r){N.call(S,r)};return w.extension=D,this.a.event(w,void 0,l)}}async $participateInSave(D,N,S){const l=O.URI.revive(D),w=this.c.getNotebookDocument(l);if(!w)throw new Error("Unable to resolve notebook document");const g=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:M.TextDocumentSaveReason.to(N)},S,async(s,o)=>{const i=Date.now(),n=await await Promise.resolve(s);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!S.isCancellationRequested&&n&&(n instanceof T.$vM?g.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(g.length===0)return!0;const r={edits:[]};for(const s of g){const{edits:o}=M.WorkspaceEdit.from(s);r.edits=r.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new A.$Fw(r))}}e.$znc=b}),define(Se[114],Ie([1,0,14,8,7]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,m,D,N,S,l){this.id=b,this.f=m,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=N,this.c=l}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(m){this.selections=[m]},get selections(){return b.a},set selections(m){if(!Array.isArray(m)||!m.every(M.$NN.isNotebookRange))throw(0,C.$7)("selections");b.a=m,b.g(m)},get visibleRanges(){return b.b},revealRange(m,D){b.f.$tryRevealRange(b.id,O.NotebookRange.from(m),D??M.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(O.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$lnc=T}),define(Se[278],Ie([1,0,5,12,8]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=void 0;let T=class{constructor(b,m){this.c=b,this.d=m,this.a=new C.$fe,this.b=new C.$fe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,m);const D=this.d.getEditorById(b);m.visibleRanges&&D._acceptVisibleRanges(m.visibleRanges.ranges.map(M.NotebookRange.to)),m.selections&&D._acceptSelections(m.selections.selections.map(M.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const m in b)this.d.getEditorById(m)._acceptViewColumn(M.ViewColumn.to(b[m]))}};e.$Bnc=T,e.$Bnc=T=Je([We(0,O.$5j)],T)}),define(Se[279],Ie([1,0,5,4,114]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=void 0;class T{constructor(b,m){this.c=m,this.a=new Map,this.b=b.getProxy(O.$jM.MainThreadNotebookRenderers)}$postRendererMessage(b,m,D){const N=this.c.getEditorById(b);this.a.get(m)?.fire({editor:N.apiEditor,message:D})}createRendererMessaging(b,m){if(!b.contributes?.notebookRenderer?.some(N=>N.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(N,S,l)=>this.d(m).event(N,S,l),postMessage:(N,S)=>{M.$lnc.apiEditorsToExtHost.has(N)&&([N,S]=[S,N]);const l=S&&M.$lnc.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,m,N)}}}d(b){let m=this.a.get(b);return m||(m=new C.$fe({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(b)}}),this.a.set(b,m),m)}}e.$Enc=T}),define(Se[280],Ie([1,0,8,103,20,69,14]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Inc=void 0;class b{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,l,w){const g=this.b++,{title:r,location:s,cancellable:o}=l,i={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(g,{location:C.ProgressLocation.from(s),title:r,source:i,cancellable:o},S.isUnderDevelopment?void 0:S.identifier.value).catch(A.$2),this.d(g,w,!!o)}d(S,l,w){let g;w&&(g=new M.$qe,this.c.set(S,g));const r=o=>{this.a.$progressEnd(o),this.c.delete(o),g?.dispose()};let s;try{s=l(new D(this.a,S),w&&g?g.token:M.CancellationToken.None)}catch(o){throw r(S),o}return s.then(o=>r(S),o=>r(S)),s}$acceptProgressCanceled(S){const l=this.c.get(S);l&&(l.cancel(),this.c.delete(S))}}e.$Inc=b;function m(N,S){return N.message=S.message,typeof S.increment=="number"&&(typeof N.increment=="number"?N.increment+=S.increment:N.increment=S.increment),N}class D extends O.$hw{constructor(S,l){super(w=>this.throttledReport(w)),this.c=S,this.d=l}throttledReport(S){this.c.$progressReport(this.d,S)}}Je([(0,T.$5h)(100,(N,S)=>m(N,S),()=>Object.create(null))],D.prototype,"throttledReport",null)}),define(Se[281],Ie([1,0,2,4,11,8]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0;class A{static{this.a=0}constructor(m,D){this.d=D,this.c=new Map,this.b=m.getProxy(O.$jM.MainThreadQuickDiff)}$provideOriginalResource(m,D,N){const S=C.URI.revive(D),l=this.c.get(m);return l?(0,M.$qh)(()=>l.provideOriginalResource(S,N)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(m,D,N,S){const l=A.a++;return this.c.set(l,D),this.b.$registerQuickDiffProvider(l,T.DocumentSelector.from(m,this.d),N,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Jnc=A}),define(Se[282],Ie([1,0,20,5,6,4,2,7,14,18,32,36,25,8]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=g;function g(r,s,o){const i=r.getProxy(T.$jM.MainThreadQuickOpen);class n{constructor(v,y){this.e=new Map,this.f=0,this.a=v,this.b=y}showQuickPick(v,y,h,E=C.CancellationToken.None){this.c=void 0;const k=Promise.resolve(y),I=++this.f,P=i.$show(I,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},E),V={},W=P.then(()=>V);return Promise.race([W,k]).then(q=>{if(q===V)return;const R=(0,l.$KG)(v,"quickPickItemTooltip");return k.then(z=>{const G=[];for(let ie=0;ie<z.length;ie++){const de=z[ie];if(typeof de=="string")G.push({label:de,handle:ie});else if(de.kind===b.QuickPickItemKind.Separator)G.push({type:"separator",label:de.label});else{de.tooltip&&!R&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const ye=de.iconPath?a(de.iconPath):void 0;G.push({label:de.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:R?w.MarkdownString.fromStrict(de.tooltip):void 0,handle:ie})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=ie=>{h.onDidSelectItem(z[ie])}),i.$setItems(I,G),P.then(ie=>{if(typeof ie=="number")return z[ie];if(Array.isArray(ie))return ie.map(de=>z[de])})})}).then(void 0,q=>{if(!(0,m.$4)(q))return i.$setError(I,q),Promise.reject(q)})}$onItemSelected(v){this.c?.(v)}showInput(v,y=C.CancellationToken.None){return this.d=v?.validateInput,i.$input(v,typeof this.d=="function",y).then(void 0,h=>{if(!(0,m.$4)(h))return Promise.reject(h)})}async $validateInput(v){if(!this.d)return;const y=await this.d(v);if(!y||typeof y=="string")return y;let h;switch(y.severity){case b.InputBoxValidationSeverity.Info:h=N.default.Info;break;case b.InputBoxValidationSeverity.Warning:h=N.default.Warning;break;case b.InputBoxValidationSeverity.Error:h=N.default.Error;break;default:h=y.message?N.default.Error:N.default.Ignore;break}return{content:y.message,severity:h}}async showWorkspaceFolderPick(v,y=C.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!h)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(k=>k.uri.toString()===h.uri.toString())}createQuickPick(v){const y=new d(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(v){const y=new $(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(v,y){this.e.get(v)?._fireDidChangeValue(y)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,y){const h=this.e.get(v);h instanceof d&&h._fireDidChangeActive(y)}$onDidChangeSelection(v,y){const h=this.e.get(v);h instanceof d&&h._fireDidChangeSelection(y)}$onDidTriggerButton(v,y){this.e.get(v)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(v,y,h){const E=this.e.get(v);E instanceof d&&E._fireDidTriggerItemButton(y,h)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class c{static{this.a=1}constructor(v,y){this.x=v,this.y=y,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$fe,this.q=new O.$fe,this.r=new O.$fe,this.s=new O.$fe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((y,h)=>{const E=y===b.$KN.Back?-1:h;this.o.set(E,y)}),this.z({buttons:v.map((y,h)=>({...a(y.iconPath),tooltip:y.tooltip,handle:y===b.$KN.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const y=this.o.get(v);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(v){if(!this.v){for(const y of Object.keys(v)){const h=v[y];this.u[y]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function u(p){if(p instanceof b.$iN)return{id:p.id};const v=f(p),y=t(p);return{dark:typeof v=="string"?A.URI.file(v):v,light:typeof y=="string"?A.URI.file(y):y}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function f(p){return typeof p=="object"&&"dark"in p?p.dark:p}function a(p){const v=u(p);let y,h;return"id"in v?h=S.ThemeIcon.asClassName(v):y=v,{iconPath:y,iconClass:h}}class d extends c{constructor(v,y){super(v.identifier,y),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$fe,this.L=[],this.M=new O.$fe,this.N=new O.$fe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((E,k)=>{this.C.set(k,E),this.D.set(E,k)});const y=(0,l.$KG)(this.O,"quickPickItemTooltip"),h=[];for(let E=0;E<v.length;E++){const k=v[E];if(k.kind===b.QuickPickItemKind.Separator)h.push({type:"separator",label:k.label});else{k.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const I=k.iconPath?a(k.iconPath):void 0;h.push({handle:E,label:k.label,iconPath:I?.iconPath,iconClass:I?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:y?w.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((P,V)=>({...a(P.iconPath),tooltip:P.tooltip,handle:V}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(v){const y=(0,D.$Hb)(v.map(h=>this.C.get(h)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(v){const y=(0,D.$Hb)(v.map(h=>this.C.get(h)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(v,y){const h=this.C.get(v);if(!h||!h.buttons||!h.buttons.length)return;const E=h.buttons[y];E&&this.N.fire({button:E,item:h})}}class $ extends c{constructor(v,y){super(v.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:N.default.Error}):this.z({validationMessage:v.message,severity:v.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new n(s,o)}}),define(Se[283],Ie([1,0,2,5,69,6,11,4,18,149,12,21,36,8,25,16,23]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=e.$Lnc=void 0;function i(I){return I instanceof C.URI}function n(I,P){return I.scheme===r.Schemas.file&&P.scheme===r.Schemas.file&&s.$k?I.toString()===P.toString():I.toString().toLowerCase()===P.toString().toLowerCase()}function c(I){if(I)return typeof I.iconPath=="string"?C.URI.file(I.iconPath):C.URI.isUri(I.iconPath)||l.ThemeIcon.isThemeIcon(I.iconPath)?I.iconPath:void 0}function u(I){if(I.icon){if(C.URI.isUri(I.icon))return I.icon;if(l.ThemeIcon.isThemeIcon(I.icon))return I.icon;{const P=I.icon;return{light:P.light,dark:P.dark}}}else return}function t(I,P){if(!I.iconPath&&!P.iconPath)return 0;if(I.iconPath){if(!P.iconPath)return 1}else return-1;const V=typeof I.iconPath=="string"?I.iconPath:C.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id,W=typeof P.iconPath=="string"?P.iconPath:C.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,D.$ur)(V,W)}function f(I,P){let V=0;if(I.strikeThrough!==P.strikeThrough)return I.strikeThrough?1:-1;if(I.faded!==P.faded)return I.faded?1:-1;if(I.tooltip!==P.tooltip)return(I.tooltip||"").localeCompare(P.tooltip||"");if(V=t(I,P),V!==0)return V;if(I.light&&P.light)V=t(I.light,P.light);else{if(I.light)return 1;if(P.light)return-1}if(V!==0)return V;if(I.dark&&P.dark)V=t(I.dark,P.dark);else{if(I.dark)return 1;if(P.dark)return-1}return V}function a(I,P){if(I.command!==P.command)return I.command<P.command?-1:1;if(I.title!==P.title)return I.title<P.title?-1:1;if(I.tooltip!==P.tooltip){if(I.tooltip!==void 0&&P.tooltip!==void 0)return I.tooltip<P.tooltip?-1:1;if(I.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(I.arguments===P.arguments)return 0;if(I.arguments)if(P.arguments){if(I.arguments.length!==P.arguments.length)return I.arguments.length-P.arguments.length}else return 1;else return-1;for(let V=0;V<I.arguments.length;V++){const W=I.arguments[V],q=P.arguments[V];if(W!==q&&!(i(W)&&i(q)&&n(W,q)))return W<q?-1:1}return 0}function d(I,P){let V=(0,D.$ur)(I.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(V!==0)return V;if(I.command&&P.command)V=a(I.command,P.command);else{if(I.command)return 1;if(P.command)return-1}if(V!==0)return V;if(I.decorations&&P.decorations)V=f(I.decorations,P.decorations);else{if(I.decorations)return 1;if(P.decorations)return-1}if(I.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)V=(0,D.$ur)(I.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(I.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(I.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)V=(0,D.$ur)(I.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(I.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return V}function $(I,P){for(let V=0;V<I.length;V++)if(I[V]!==P[V])return!1;return!0}function p(I,P){return I.command===P.command&&I.title===P.title&&I.tooltip===P.tooltip&&(I.arguments&&P.arguments?$(I.arguments,P.arguments):I.arguments===P.arguments)}function v(I,P){return(0,m.$ub)(I,P,p)}class y{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,g.$LG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,g.$LG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,g.$LG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,V,W,q,R){this.k=P,this.l=q,this.m=R,this.d="",this.e=new O.$fe,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=W}showValidationMessage(P,V){(0,g.$LG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,V)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$Lnc=y;class h{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,V,W,q,R,z,G){this.q=P,this.s=V,this.t=W,this.u=q,this.v=R,this.multiDiffEditorEnableViewChanges=z,this.w=G,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$fe,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$fe,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=h.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,V){const W=this.h.get(P);return W?(0,A.$qh)(()=>this.s.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(d),W=(0,m.$Db)(this.o,P,d).map(z=>{const G=z.toInsert.map(ie=>{const de=this.e++;this.g.set(de,ie);const ye=ie.resourceUri;let De;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const me=new T.$Tc;De=this.s.converter.toInternal(ie.command,me),this.j.set(de,me)}else this.h.set(de,ie.command);const ge=(0,g.$KG)(this.w,"scmMultiDiffEditor"),ue=ge?ie.multiDiffEditorOriginalUri:void 0,Ce=ge?ie.multiFileDiffEditorModifiedUri:void 0,se=c(ie.decorations),Oe=ie.decorations&&c(ie.decorations.light)||se,ne=ie.decorations&&c(ie.decorations.dark)||se,j=[Oe,ne],x=ie.decorations&&ie.decorations.tooltip||"",ve=ie.decorations&&!!ie.decorations.strikeThrough,Le=ie.decorations&&!!ie.decorations.faded,ke=ie.contextValue||"";return{rawResource:[de,ye,j,x,ve,Le,ke,De,ue,Ce],handle:de}});return{start:z.start,deleteCount:z.deleteCount,toInsert:G}}),q=W.map(({start:z,deleteCount:G,toInsert:ie})=>[z,G,ie.map(de=>de.rawResource)]),R=W.reverse();for(const{start:z,deleteCount:G,toInsert:ie}of R){const de=ie.map(De=>De.handle),ye=this.n.splice(z,G,...de);for(const De of ye)this.g.delete(De),this.h.delete(De),this.j.get(De)?.dispose(),this.j.delete(De)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let V;(0,g.$KG)(this.x,"quickDiffProvider")&&(V=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:V})}get historyProvider(){return(0,g.$LG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,g.$LG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new T.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new T.$Tc,this.o=P;const V=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:V})}get actionButton(){return(0,g.$LG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,g.$LG)(this.x,"scmActionButton"),this.p.value=new T.$Tc,this.q=P;const V=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(W=>W.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:V??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&v(this.t,P))return;this.s.value=new T.$Tc,this.t=P;const V=(P||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:V})}get selected(){return this.u}constructor(P,V,W,q,R,z,G){this.x=P,this.y=q,this.z=R,this.A=z,this.B=G,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Vc,this.m=void 0,this.n=new T.$Vc,this.o=void 0,this.p=new T.$Vc,this.s=new T.$Vc,this.t=void 0,this.u=!1,this.v=new O.$fe,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=W;const ie=C.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${R}/scm${this.w}/input`,query:G?`rootUri=${encodeURIComponent(G.toString())}`:void 0});this.f=new y(P,V,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,R,z,G,ie)}createResourceGroup(P,V,W){const q=(0,g.$KG)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,R=new h(this.#e,this.y,this.w,P,V,q,this.x),z=O.Event.once(R.onDidDispose)(()=>this.C.delete(R));return this.C.set(R,z),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const P=[],V=[];for(const[W,q]of this.C){q.dispose();const R=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});O.Event.once(W.onDidDispose)(()=>{this.D.delete(W),R.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),P.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const z=W._takeResourceStateSnapshot();z.length>0&&V.push([W.handle,z]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,P,V),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&P.push([V.handle,W])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$4h)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$4h)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,V,W,q){this.l=V,this.m=W,this.n=q,this.g=new Map,this.h=new S.$Vm,this.j=new O.$fe,this.e=P.getProxy(b.$jM.MainThreadSCM),this.f=P.getProxy(b.$jM.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const z=this.g.get(R.sourceControlHandle);if(!z)return R;const G=z.getResourceGroup(R.groupHandle);return G?G.getResourceState(R.handle):R}else if(R&&R.$mid===4){const z=this.g.get(R.sourceControlHandle);return z?z.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const z=this.g.get(R.handle);return z||R}return R}})}createSourceControl(P,V,W,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,V,W,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const R=o.d++,z=new E(P,this.m,this.e,this.l,V,W,q);this.g.set(R,z);const G=this.h.get(P.identifier)||[];return G.push(z),this.h.set(P.identifier,G),z}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const V=this.h.get(P.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(P,V,W){const q=C.URI.revive(V);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const R=this.g.get(P);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$qh)(()=>R.quickDiffProvider.provideOriginalResource(q,W)).then(z=>z||null)}$onInputBoxValueChange(P,V){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const W=this.g.get(P);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(P,V,W,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,V,W);const R=this.g.get(P);if(!R)return Promise.resolve(void 0);const z=R.getResourceGroup(V);return z?z.$executeResourceCommand(W,q):Promise.resolve(void 0)}$validateInput(P,V,W){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,A.$qh)(()=>q.inputBox.validateInput(V,W)).then(R=>{if(!R)return Promise.resolve(void 0);const z=w.MarkdownString.fromStrict(R.message);return z?Promise.resolve([z,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,V,W,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,q)??void 0}async $provideHistoryItems(P,V,W,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(V,W,q))?.map(G=>({...G,icon:u(G)}))??void 0}async $provideHistoryItemSummary(P,V,W,q){const R=this.g.get(P)?.historyProvider;if(typeof R?.provideHistoryItemSummary!="function")return;const z=await R.provideHistoryItemSummary(V,W,q);return z?{...z,icon:u(z)}:void 0}async $provideHistoryItemChanges(P,V,W,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(V,W,q)??void 0}};e.$Mnc=k,e.$Mnc=k=o=Je([We(3,N.$5j)],k)}),define(Se[284],Ie([1,0,4,8,2]),function(le,e,C,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=void 0;class T{static{this.a=0}constructor(b,m){this.d=m,this.c=new Map,this.b=b.getProxy(C.$jM.MainThreadShare)}async $provideShare(b,m,D){return await this.c.get(b)?.provideShare({selection:O.Range.to(m.selection),resourceUri:M.URI.revive(m.resourceUri)},D)??void 0}registerShareProvider(b,m){const D=T.a++;return this.c.set(D,m),this.b.$registerShareProvider(D,O.DocumentSelector.from(b,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(D),this.c.delete(D)}}}}e.$Nnc=T}),define(Se[285],Ie([1,0,7,4,178,6,8,15]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=e.$Pnc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$jN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$jN("statusBarItem.warningForeground")]])}#e;#t;constructor(l,w,g,r,s,o=C.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new T.$Tc,this.#e=l,this.#t=w,s&&r){this.c=(0,C.$XM)(r.identifier,s);const n=g.get(this.c);n&&(o=n.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(m.a++);this.e=r,this.f=s,this.g=o,this.h=this.u(i)}u(l){if((0,b.$cg)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!m.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new T.$Tc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let w;this.m?w=this.m:w=(0,M.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=m.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,w,this.k,r,this.r?.internal,g,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Pnc=m;class D{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const w={message:l};return this.b.unshift(w),this.c(),new C.$lM(()=>{const g=this.b.indexOf(w);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class N{constructor(l,w){this.e=new Map,this.a=l.getProxy(O.$jM.MainThreadStatusBar),this.b=w,this.c=new D(this)}$acceptStaticEntries(l){for(const w of l)this.e.set(w.entryId,w)}createStatusBarEntry(l,w,g,r){return new m(this.a,this.b,this.e,l,w,g,r)}setStatusBarMessage(l,w){const g=this.c.setMessage(l);let r;return typeof w=="number"?r=setTimeout(()=>g.dispose(),w):typeof w<"u"&&w.then(()=>g.dispose(),()=>g.dispose()),new C.$lM(()=>{g.dispose(),clearTimeout(r)})}}e.$Qnc=N}),define(Se[115],Ie([1,0,30,107,52,77,62,8,2]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=e.$2O=e.$1O=e.$ZO=void 0;const D=(n,c,u,t)=>{let f=c;return{enumerable:!0,configurable:!1,get(){return f},set(a){if(!u(f,a)){const d=f;f=a,n.listener?.(t(a,d))}}}},N=(n,c)=>n===c,S={range:(n,c)=>n===c?!0:!n||!c?!1:n.isEqual(c),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(n,c)=>!(n.length!==c.length||n.some(u=>!c.find(t=>u.id===t.id)))},l=n=>c=>({op:4,update:n(c)}),w=(n,c)=>({range:(()=>{let u;const t=l(f=>({range:C.$yt.lift(b.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return u},set(f){n.listener?.({op:6}),S.range(u,f)||(u=f,n.listener?.(t(f)))}}})(),label:D(n,c,S.label,l(u=>({label:u}))),description:D(n,void 0,S.description,l(u=>({description:u}))),sortText:D(n,void 0,S.sortText,l(u=>({sortText:u}))),canResolveChildren:D(n,!1,S.canResolveChildren,u=>({op:2,state:u})),busy:D(n,!1,S.busy,l(u=>({busy:u}))),error:D(n,void 0,S.error,l(u=>({error:b.MarkdownString.fromStrict(u)||null}))),tags:D(n,[],S.tags,(u,t)=>({op:1,new:u.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),g=n=>{const c=M.$8K.fromString(n.extId),u=new s(c.controllerId,c.localId,n.label,m.URI.revive(n.uri)||void 0);return u.range=b.Range.to(n.range||void 0),u.description=n.description||void 0,u.sortText=n.sortText||void 0,u.tags=n.tags.map(t=>b.TestTag.to({id:(0,A.$bL)(t).tagId})),u},r=n=>{let c;for(const u of n.tests){const t=g(u.item);(0,O.$JO)(t).parent=c,c=t}return c};e.$ZO=r;class s{constructor(c,u,t,f){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const a=(0,O.$IO)(this,c);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof o?void 0:a.parent}},children:{value:(0,T.$HO)(a,O.$JO,s),enumerable:!0,writable:!1},...w(a,t)})}}e.$1O=s;class o extends s{constructor(c,u){super(c,c,u,void 0),this._isRoot=!0}}e.$2O=o;class i extends T.$DO{constructor(c,u,t){super({controllerId:c,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:O.$JO,getChildren:f=>f.children,root:new o(c,u),toITestItem:b.TestItem.from})}}e.$3O=i}),define(Se[35],Ie([1,0,15,7,8,26,4,18,12,49,30,94,2,6,3,17,115,22,34,44,66,59,63,33]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=void 0;let a=class{#e;#t;#i;constructor(h,E,k){this.b=new Map,this.c=new Map,this.#e=h.getProxy(A.$jM.MainThreadCommands),this.d=E,this.#i=k,this.#t=h.getProxy(A.$jM.MainThreadTelemetry),this.converter=new d(this,I=>{const P=this.c.get(I);return P?.result===p.Void?P:void 0},E),this.f=[{processArgument(I){return(0,D.$8h)(I)}},{processArgument(I){return(0,T.$7n)(I,function(P){if(N.$yt.isIRange(P))return M.Range.to(P);if(S.$xt.isIPosition(P))return M.Position.to(P);if(N.$yt.isIRange(P.range)&&l.URI.isUri(P.uri))return M.location.to(P);if(P instanceof o.$He)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const E=this.registerCommand(!1,h.id,async(...k)=>{const I=h.args.map((V,W)=>{if(!V.validate(k[W]))throw new Error(`Invalid argument '${V.name}' when running '${h.id}', received: ${typeof k[W]=="object"?JSON.stringify(k[W],null,"	"):k[W]} `);return V.convert(k[W])}),P=await this.executeCommand(h.internalId,...I);return h.result.convert(P,k,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new O.$lM(()=>{E.dispose(),this.c.delete(h.id)})}registerCommand(h,E,k,I,P,V){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:k,thisArg:I,metadata:P,extension:V}),h&&this.#e.$registerCommand(E),new O.$lM(()=>{this.b.delete(E)&&h&&this.#e.$unregisterCommand(E)})}executeCommand(h,...E){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,E,!0)}async g(h,E,k){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,E,!1);{let I=!1;const P=(0,T.$7n)(E,function(V){if(V instanceof O.$mM)return M.Position.from(V);if(V instanceof O.$nM)return M.Range.from(V);if(V instanceof O.$xM)return M.location.from(V);if(O.$NN.isNotebookRange(V))return M.NotebookRange.from(V);if(V instanceof ArrayBuffer)return I=!0,o.$He.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return I=!0,o.$He.wrap(V);if(V instanceof o.$He)return I=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(h,I?new i.$Fw(P):P,k);return(0,D.$8h)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(h,E,!1);throw V}}}async h(h,E,k){const I=this.b.get(h);if(!I)throw new Error("Unknown command");const{callback:P,thisArg:V,metadata:W}=I;if(W?.args)for(let R=0;R<W.args.length;R++)try{(0,C.$pg)(E[R],W.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${W.args[R].name}' - ${W.args[R].description}`)}const q=c.$be.create();try{return await P.apply(V,E)}catch(R){if(h===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...E);z&&(h=z.command)}if(this.d.error(R,h,I.extension?.identifier),!k)throw R;if(I.extension?.identifier){const z=this.#i.onExtensionError(I.extension.identifier,R);this.d.trace("forwarded error to extension?",z,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$jj)(R)),this.id=h,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,h,q.elapsed())}}j(h,E,k){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new u.$jp(E),duration:k})}$executeContributedCommand(h,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const k=this.b.get(h);return k?(E=E.map(I=>this.f.reduce((P,V)=>V.processArgument(P,k.extension?.identifier),I)),this.h(h,E,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(E=>(h&&(E=E.filter(k=>k[0]!=="_")),E))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[E,k]of this.b){const{metadata:I}=k;I&&(h[E]=I)}return Promise.resolve(h)}};e.$9O=a,e.$9O=a=Je([We(0,r.$NO),We(1,m.$5j),We(2,t.$8O)],a),e.$0O=(0,g.$yi)("IExtHostCommands");class d{constructor(h,E,k){this.d=h,this.f=E,this.g=k,this.delegatingCommandId=`__vsc${(0,f.$Ug)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,E){if(!h)return;const k={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return k;const I=this.f(h.command);if(I)k.id=I.internalId,k.arguments=I.args.map((P,V)=>P.convert(h.arguments&&h.arguments[V]));else if((0,b.$Lb)(h.arguments)){const P=`${h.command} /${++this.c}`;this.b.set(P,h),E.add((0,w.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),k.$ident=P,k.id=this.delegatingCommandId,k.arguments=[P],this.g.trace("CommandsConverter#CREATE",h.command,P)}return k}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const E=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$$O=d;class ${static{this.Uri=new $("uri","Uri of a text document",h=>l.URI.isUri(h),h=>h)}static{this.Position=new $("position","A position in a text document",h=>O.$mM.isPosition(h),M.Position.from)}static{this.Range=new $("range","A range in a text document",h=>O.$nM.isRange(h),M.Range.from)}static{this.Selection=new $("selection","A selection in a text document",h=>O.$oM.isSelection(h),M.Selection.from)}static{this.Number=new $("number","",h=>typeof h=="number",h=>h)}static{this.String=new $("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=$.Arr($.String)}static Arr(h){return new $(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,E=>Array.isArray(E)&&E.every(k=>h.validate(k)),E=>E.map(k=>h.convert(k)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",h=>h instanceof O.$JM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",h=>h instanceof O.$8N,M.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",h=>h instanceof s.$1O,M.TestItem.from)}constructor(h,E,k,I){this.name=h,this.description=E,this.validate=k,this.convert=I}optional(){return new $(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,E){return new $(h??this.name,E??this.description,this.validate,this.convert)}}e.$_O=$;class p{static{this.Void=new p("no result",h=>h)}constructor(h,E){this.description=h,this.convert=E}}e.$aP=p;class v{constructor(h,E,k,I,P){this.id=h,this.internalId=E,this.description=k,this.args=I,this.result=P}}e.$bP=v}),define(Se[286],Ie([1,0,18,16,2,89,98,31,35,8,7]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;const S=[new m.$bP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$_O.Uri,m.$_O.Position],new m.$aP("A promise that resolves to an array of DocumentHighlight-instances.",w(D.DocumentHighlight.to))),new m.$bP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$_O.Uri],new m.$aP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,s)=>{if((0,C.$Kb)(r))return;class o extends N.$EM{static to(n){const c=new o(n.name,D.SymbolKind.to(n.kind),n.containerName||"",new N.$xM(s[0],D.Range.to(n.range)));return c.detail=n.detail,c.range=c.location.range,c.selectionRange=D.Range.to(n.selectionRange),c.children=n.children?n.children.map(o.to):[],c}}return r.map(o.to)})),new m.$bP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$_O.Uri,new m.$_O("options","Formatting options",r=>!0,r=>r)],new m.$aP("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new m.$bP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$_O.Uri,m.$_O.Range,new m.$_O("options","Formatting options",r=>!0,r=>r)],new m.$aP("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new m.$bP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$_O.Uri,m.$_O.Position,new m.$_O("ch","Trigger character",r=>typeof r=="string",r=>r),new m.$_O("options","Formatting options",r=>!0,r=>r)],new m.$aP("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new m.$bP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$_O.Uri,m.$_O.Position],new m.$aP("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$bP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$_O.Uri,m.$_O.Position],new m.$aP("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$bP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$_O.Uri,m.$_O.Position],new m.$aP("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$bP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$_O.Uri,m.$_O.Position],new m.$aP("A promise that resolves to an array of Location or LocationLink instances.",g)),new m.$bP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$_O.Uri,m.$_O.Position],new m.$aP("A promise that resolves to an array of Location-instances.",w(D.location.to))),new m.$bP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$_O.Uri,m.$_O.Position],new m.$aP("A promise that resolves to an array of Hover-instances.",w(D.Hover.to))),new m.$bP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$_O.Uri,new m.$_O("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>N.$mM.isPosition(s)),r=>r.map(D.Position.from))],new m.$aP("A promise that resolves to an array of ranges.",r=>r.map(s=>{let o;for(const i of s.reverse())o=new N.$IM(D.Range.to(i),o);return o}))),new m.$bP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$_O.String.with("query","Search string")],new m.$aP("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(D.WorkspaceSymbol.to))),new m.$bP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$_O.Uri,m.$_O.Position],new m.$aP("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(D.CallHierarchyItem.to))),new m.$bP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$_O.CallHierarchyItem],new m.$aP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(D.CallHierarchyIncomingCall.to))),new m.$bP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$_O.CallHierarchyItem],new m.$aP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(D.CallHierarchyOutgoingCall.to))),new m.$bP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$_O.Uri,m.$_O.Position],new m.$aP("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:D.Range.to(r.range),placeholder:r.text}})),new m.$bP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$_O.Uri,m.$_O.Position,m.$_O.String.with("newName","The new symbol name")],new m.$aP("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return D.WorkspaceEdit.to(r)}})),new m.$bP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$_O.Uri,m.$_O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$aP("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(D.DocumentLink.to))),new m.$bP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$_O.Uri],new m.$aP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new N.$EN(r.tokenTypes,r.tokenModifiers)})),new m.$bP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$_O.Uri],new m.$aP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$Cbb)(r);if(s.type==="full")return new N.$GN(s.data,void 0)})),new m.$bP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$_O.Uri,m.$_O.Range.optional()],new m.$aP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new N.$EN(r.tokenTypes,r.tokenModifiers)})),new m.$bP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$_O.Uri,m.$_O.Range],new m.$aP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$Cbb)(r);if(s.type==="full")return new N.$GN(s.data,void 0)})),new m.$bP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$_O.Uri,m.$_O.Position,m.$_O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$_O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$aP("A promise that resolves to a CompletionList-instance.",(r,s,o)=>{if(!r)return new N.$UM([]);const i=r.suggestions.map(n=>D.CompletionItem.to(n,o));return new N.$UM(i,r.incomplete)})),new m.$bP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$_O.Uri,m.$_O.Position,m.$_O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$aP("A promise that resolves to SignatureHelp.",r=>{if(r)return D.SignatureHelp.to(r)})),new m.$bP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$_O.Uri,m.$_O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$aP("A promise that resolves to an array of CodeLens-instances.",(r,s,o)=>w(i=>new N.$MM(D.Range.to(i.range),i.command&&o.fromInternal(i.command)))(r))),new m.$bP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$_O.Uri,new m.$_O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>N.$nM.isRange(r),r=>N.$oM.isSelection(r)?D.Selection.from(r):D.Range.from(r)),m.$_O.String.with("kind","Code action kind to return code actions for").optional(),m.$_O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$aP("A promise that resolves to an array of Command-instances.",(r,s,o)=>w(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const n=new N.$GM(i.title,i.kind?new N.$HM(i.kind):void 0);return i.edit&&(n.edit=D.WorkspaceEdit.to(i.edit)),i.command&&(n.command=o.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(r))),new m.$bP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$_O.Uri],new m.$aP("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new N.$1M(D.Range.to(s.range),D.Color.to(s.color))):[])),new m.$bP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$_O("color","The color to show and insert",r=>r instanceof N.$ZM,D.Color.from),new m.$_O("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:D.Range.from(r.range)}))],new m.$aP("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(D.ColorPresentation.to):[])),new m.$bP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$_O.Uri,m.$_O.Range],new m.$aP("A promise that resolves to an array of Inlay objects",(r,s,o)=>r.map(D.InlayHint.to.bind(void 0,o)))),new m.$bP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$_O.Uri],new m.$aP("A promise that resolves to an array of FoldingRange objects",(r,s)=>{if(r)return r.map(D.FoldingRange.to)})),new m.$bP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$aP("A promise that resolves to an array of NotebookContentProvider static info objects.",w(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(s=>D.NotebookExclusiveDocumentPattern.to(s))})))),new m.$bP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$_O.Uri,m.$_O.Range,new m.$_O("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof N.$nM,r=>D.InlineValueContext.from(r))],new m.$aP("A promise that resolves to an array of InlineValue objects",r=>r.map(D.InlineValue.to))),new m.$bP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$_O("uriOrString","Uri-instance or string (only http/https)",r=>M.URI.isUri(r)||typeof r=="string"&&(0,O.$Ig)(r,O.Schemas.http,O.Schemas.https),r=>r),new m.$_O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[D.ViewColumn.from(r),void 0]:[D.ViewColumn.from(r.viewColumn),D.TextEditorOpenOptions.from(r)])).optional(),m.$_O.String.with("label","").optional()],m.$aP.Void),new m.$bP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$_O.Uri.with("resource","Resource to open"),m.$_O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$_O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[D.ViewColumn.from(r),void 0]:[D.ViewColumn.from(r.viewColumn),D.TextEditorOpenOptions.from(r)])).optional()],m.$aP.Void),new m.$bP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$_O.Uri.with("left","Left-hand side resource of the diff editor"),m.$_O.Uri.with("right","Right-hand side resource of the diff editor"),m.$_O.String.with("title","Human readable title for the diff editor").optional(),new m.$_O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[D.ViewColumn.from(r.viewColumn),D.TextEditorOpenOptions.from(r)]).optional()],m.$aP.Void),new m.$bP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$_O.String.with("title","Human readable title for the changes editor"),new m.$_O("resourceList","List of resources to compare",r=>{for(const s of r){if(s.length!==3)return!1;const[o,i,n]=s;if(!M.URI.isUri(o)||!M.URI.isUri(i)&&i!==void 0&&i!==null||!M.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},r=>r)],m.$aP.Void),new m.$bP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$_O.Uri,m.$_O.Position],new m.$aP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(D.TypeHierarchyItem.to))),new m.$bP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$_O.TypeHierarchyItem],new m.$aP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(D.TypeHierarchyItem.to))),new m.$bP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$_O.TypeHierarchyItem],new m.$aP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(D.TypeHierarchyItem.to))),new m.$bP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$_O.TestItem],m.$aP.Void),new m.$bP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$_O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$aP.Void),new m.$bP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$_O.String.with("name","The context key name"),new m.$_O("value","The context key value",()=>!0,r=>r)],m.$aP.Void),new m.$bP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$_O.Uri,m.$_O.StringArray,new m.$_O("MappedEditsContext","Mapped Edits Context",r=>D.MappedEditsContext.is(r),r=>D.MappedEditsContext.from(r))],new m.$aP("A promise that resolves to a workspace edit or null",r=>r?D.WorkspaceEdit.to(r):null)),new m.$bP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$_O("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?D.Range.from(r.initialRange):void 0,initialSelection:N.$oM.isSelection(r.initialSelection)?D.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?D.Position.from(r.position):void 0}})],m.$aP.Void)];class l{static register(s){S.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",b.$xj)}}e.$_lc=l;function w(r){return s=>{if(Array.isArray(s))return s.map(r)}}function g(r){if(!Array.isArray(r))return;const s=[];for(const o of r)T.$tu(o)?s.push(D.DefinitionLink.to(o)):s.push(D.location.to(o));return s}}),define(Se[287],Ie([1,0,2,35]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;class M{constructor(A,b,m,D,N){this.a=b,this.b=m,this.c=D;const S=new O.$bP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$_O("showOptions","Show Options",l=>!0,l=>l),new O.$_O("resource","Interactive resource Uri",l=>!0,l=>l),new O.$_O("controllerId","Notebook controller Id",l=>!0,l=>l),new O.$_O("title","Interactive editor title",l=>!0,l=>l)],new O.$aP("Notebook and input URI",l=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const w=this.a.getEditorById(l.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:C.URI.revive(l.notebookUri),inputUri:C.URI.revive(l.inputUri),notebookEditor:w.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:C.URI.revive(l.notebookUri),inputUri:C.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(A,b,m,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:m,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$vnc=M}),define(Se[288],Ie([1,0,18,11,20,5,6,28,2,21,12,4,35,8,7,78,229,25,34,230]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=void 0,e.$Dnc=$;let c=class{constructor(v,y,h,E,k){this.m=y,this.n=h,this.o=E,this.q=k,this.b=new b.$Ac,this.c=new b.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new T.$fe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=v.getProxy(S.$jM.MainThreadNotebookKernels);const I=new l.$bP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$_O("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const W=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:W}}else if(V&&"notebookEditor"in V){const W=this.n.getIdByEditor(V.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return V})],l.$aP.Void),P=new l.$bP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$_O.Uri],new l.$aP("A promise that resolves to an array of variables",(V,W)=>V.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(I),this.o.registerApiCommand(P)}createNotebookController(v,y,h,E,k,I){for(const se of this.j.values())if(se.controller.id===y&&D.$Tm.equals(v.identifier,se.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const P=this.k++,V=this;this.q.trace(`NotebookController[${P}], CREATED by ${v.identifier.value}, ${y}`);const W=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${v.identifier}'`);let q=!1;const R=new T.$fe,z=new T.$fe,G={id:$(v.identifier,y),notebookType:h,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:E||v.identifier.value,preloads:I?I.map(w.NotebookRendererScript.from):[]};let ie=k??W,de,ye;this.a.$addKernel(P,G).catch(se=>{console.log(se),q=!0});let De=0;const ge=()=>{if(q)return;const se=++De;Promise.resolve().then(()=>{se===De&&this.a.$updateKernel(P,G)})},ue=new b.$Ac,Ce={get id(){return y},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return G.label},set label(se){G.label=se??v.displayName??v.name,ge()},get detail(){return G.detail??""},set detail(se){G.detail=se,ge()},get description(){return G.description??""},set description(se){G.description=se,ge()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(se){G.supportedLanguages=se,ge()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(se){G.supportsExecutionOrder=se,ge()},get rendererScripts(){return G.preloads?G.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(se){ie=se??W},get interruptHandler(){return de},set interruptHandler(se){de=se,G.supportsInterrupt=!!se,ge()},set variableProvider(se){(0,o.$LG)(v,"notebookVariableProvider"),ye=se,G.hasVariableProvider=!!se,se?.onDidChangeVariables(Oe=>V.a.$variablesUpdated(Oe.uri)),ge()},get variableProvider(){return ye},createNotebookCellExecution(se){if(q)throw new Error("notebook controller is DISPOSED");if(!ue.has(se.notebook.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Oe=>Oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return V._createNotebookCellExecution(se,$(v.identifier,this.id))},createNotebookExecution(se){if((0,o.$LG)(v,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!ue.has(se.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Oe=>Oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return V._createNotebookExecution(se,$(v.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),R.dispose(),z.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(se,Oe){Oe===g.NotebookControllerAffinity2.Hidden&&(0,o.$LG)(v,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(P,se.uri,Oe)},onDidReceiveMessage:z.event,postMessage(se,Oe){return(0,o.$LG)(v,"notebookMessaging"),V.a.$postMessage(P,Oe&&V.n.getIdByEditor(Oe),se)},asWebviewUri(se){return(0,o.$LG)(v,"notebookMessaging"),(0,r.$bBb)(se,V.m.remote)}};return this.j.set(P,{extensionId:v.identifier,controller:Ce,onDidReceiveMessage:z,onDidChangeSelection:R,associatedNotebooks:ue}),Ce}getIdByController(v){for(const[y,h]of this.j)if(h.controller===v)return $(h.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,y){const h=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask(h,y);const k={dispose:()=>{this.f.delete(h),E.a.$removeKernelDetectionTask(h)}};return this.f.set(h,k),k}registerKernelSourceActionProvider(v,y,h){const E=this.i++,k=typeof h.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,I=this;this.h.set(E,h),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,y);let P;return k!==void 0&&(P=h.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(E),I.a.$removeKernelSourceActionProvider(E,E),P?.dispose()}}}async $provideKernelSourceActions(v,y){const h=this.h.get(v);if(h){const E=new A.$Tc;return(await h.provideNotebookKernelSourceActions(y)??[]).map(I=>w.NotebookKernelSourceAction.from(I,this.o.converter,E))}return[]}$acceptNotebookAssociation(v,y,h){const E=this.j.get(v);if(E){const k=this.n.getNotebookDocument(m.URI.revive(y));h?E.associatedNotebooks.set(k.uri,!0):E.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,k.uri.toString(),h),E.onDidChangeSelection.fire({selected:h,notebook:k.apiNotebook})}}async $executeCells(v,y,h){const E=this.j.get(v);if(!E)return;const k=this.n.getNotebookDocument(m.URI.revive(y)),I=[];for(const P of h){const V=k.getCell(P);V&&I.push(V.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,k.uri.toString(),I.length),await E.controller.executeHandler.call(E.controller,I,k.apiNotebook,E.controller)}catch(P){this.q.error(`NotebookController[${v}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(v,y,h){const E=this.j.get(v);if(!E)return;const k=this.n.getNotebookDocument(m.URI.revive(y));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,k.apiNotebook);else for(const I of h){const P=k.getCell(I);P&&this.b.get(P.uri)?.cancel()}if(E.controller.interruptHandler){const I=this.c.get(k.uri);this.c.delete(k.uri),h.length&&Array.isArray(I)&&I.length&&I.forEach(P=>P.dispose())}}async $provideVariables(v,y,h,E,k,I,P){const V=this.j.get(v);if(!V)return;const W=this.n.getNotebookDocument(m.URI.revive(h)),q=V.controller.variableProvider;if(!q)return;let R;if(E!==void 0){if(R=this.s[E],!R)return}else this.s={};const z=k==="named"?g.NotebookVariablesRequestKind.Named:g.NotebookVariablesRequestKind.Indexed,G=q.provideVariables(W.apiNotebook,R,z,I,P);let ie=0;for await(const de of G){if(P.isCancellationRequested)return;const ye={id:this.r++,name:de.variable.name,value:de.variable.value,type:de.variable.type,interfaces:de.variable.interfaces,language:de.variable.language,expression:de.variable.expression,hasNamedChildren:de.hasNamedChildren,indexedChildrenCount:de.indexedChildrenCount,extensionId:V.extensionId.value};if(this.s[ye.id]=de.variable,this.a.$receiveVariable(y,ye),ie++>=n.$Uib)return}}$acceptKernelMessageFromRenderer(v,y,h){const E=this.j.get(v);if(!E)return;const k=this.n.getEditorById(y);E.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:h}))}$cellExecutionChanged(v,y,h){const k=this.n.getNotebookDocument(m.URI.revive(v)).getCell(y);if(k){const I=h?w.NotebookCellExecutionState.to(h):g.NotebookCellExecutionState.Idle;I!==void 0&&this.l.fire({cell:k.apiCell,state:I})}}_createNotebookCellExecution(v,y){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const k=new t(y,E,this.a);this.b.set(E.uri,k);const I=k.onDidChangeState(()=>{k.state===u.Resolved&&(k.dispose(),I.dispose(),this.b.delete(E.uri))});return k.asApiObject()}_createNotebookExecution(v,y){const h=this.n.getNotebookDocument(v.uri),E=v.getCells().find(P=>{const V=h.getCellFromApiCell(P);return V&&this.b.has(V.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const k=new a(y,h,this.a),I=k.onDidChangeState(()=>{k.state===f.Resolved&&(k.dispose(),I.dispose(),this.c.delete(h.uri))});return this.c.set(h.uri,[k,I]),k.asApiObject()}};e.$Cnc=c,e.$Cnc=c=Je([We(4,N.$5j)],c);var u;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(u||(u={}));class t extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.m=y,this.n=h,this.b=t.a++,this.c=new T.$fe,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new M.$qe),this.h=new d(10,E=>this.s(E)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,v,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(v){await this.h.addItem(v)}async s(v){const y=Array.isArray(v)?v:[v];return this.n.$updateExecution(this.b,new i.$Fw(y))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(v){let y=this.m;if(v&&(y=this.m.notebook.getCellFromApiCell(v)),!y)throw new Error("INVALID cell");return y.handle}y(v){return v.map(y=>{const h=g.$RN.ensureUniqueMimeTypes(y.items,!0);return h===y.items?w.NotebookCellOutput.from(y):w.NotebookCellOutput.from({items:h,id:y.id,metadata:y.metadata})})}async z(v,y,h){const E=this.w(y),k=this.y((0,C.$2b)(v));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:E,append:h,outputs:k})}async C(v,y,h){return v=g.$RN.ensureUniqueMimeTypes((0,C.$2b)(v),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:v.map(w.NotebookCellOutputItem.from),outputId:y.id,append:h})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.m.apiCell},get executionOrder(){return v.j},set executionOrder(h){v.j=h,v.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:v.j}])},start(h){if(v.f===u.Resolved||v.f===u.Started)throw new Error("Cannot call start again");v.f=u.Started,v.c.fire(),v.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,E,k){if(v.f===u.Resolved)throw new Error("Cannot call resolve twice");v.f=u.Resolved,v.c.fire(),v.h.flush();const I=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;v.n.$completeExecution(v.b,new i.$Fw({runEndTime:E,lastRunSuccess:h,error:I}))},clearOutput(h){return v.t(),v.z([],h,!1)},appendOutput(h,E){return v.t(),v.z(h,E,!0)},replaceOutput(h,E){return v.t(),v.z(h,E,!1)},appendOutputItems(h,E){return v.t(),v.C(h,E,!0)},replaceOutputItems(h,E){return v.t(),v.C(h,E,!1)}})}}var f;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(f||(f={}));class a extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.h=y,this.j=h,this.b=a.a++,this.c=new T.$fe,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new M.$qe),this.j.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(v,y){this.f=v,this.g=y,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new O.$Vh,this.b=Date.now(),(0,O.$zh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>v.complete())}}function $(p,v){return`${p.value}/${v}`}}),define(Se[53],Ie([1,0,5,4,3,2,17,6,7,180,14,208,20,33,209,36,11,8,35]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=e.$Omc=e.$Nmc=void 0,e.$Nmc=(0,M.$yi)("IExtHostTerminalService");class n extends b.$Uc{constructor(h,E,k,I){super(),this.u=h,this._id=E,this.w=k,this.y=I,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new C.$fe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(V,W=!0){P.C(),P.u.$sendText(P._id,V,W)},show(V){P.C(),P.u.$show(P._id,V)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(h,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??E?.cwd??void 0,env:h.env??void 0,icon:$(h.iconPath)??void 0,color:r.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(h.location,E?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,E,k,I,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:I,color:r.ThemeColor.isThemeColor(P)?P.id:void 0,location:E?.location||this.z(h,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(h,E){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in h?{viewColumn:o.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.y=h}setExitStatus(h,E){this.j=Object.freeze({code:h,reason:E})}setDimensions(h,E){return h===this.f&&E===this.h||h===0||E===0?!1:(this.f=h,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(h){this.n=h}_setProcessId(h){this.g?(this.g(h),this.g=void 0):this.b.then(E=>{E!==h&&(this.b=Promise.resolve(h))})}}e.$Omc=n;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new C.$fe,this.onProcessData=this.a.event,this.b=new C.$fe,this.d=new C.$fe,this.onDidChangeProperty=this.d.event,this.f=new C.$fe,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,E){this.g.setDimensions?.({columns:h,rows:E})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends b.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,E,k){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$fe,this.onDidCloseTerminal=this.H.event,this.I=new C.$fe,this.onDidOpenTerminal=this.I.event,this.J=new C.$fe,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$fe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$fe,this.onDidChangeTerminalState=this.M.event,this.N=new C.$fe,this.onDidChangeShell=this.N.event,this.O=new C.$fe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$fe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(O.$jM.MainThreadTerminalService),this.y=new g.$_vb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:I=>{const P=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(I?.$mid){case 15:return P(I);default:{if(Array.isArray(I))for(let V=0;V<I.length&&I[V].$mid===15;V++)I[V]=P(I[V]);return I}}}}),this.B({dispose:()=>{for(const[I,P]of this.g)P.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,E){const k=new n(this.a,(0,w.$Ug)(),h,h.name),I=new c(h.pty);return k.createExtensionTerminal(h.location,E,this.R(h,E).resolvedExtHostIdentifier,$(h.iconPath),p(h.color)).then(P=>{const V=this.S(P,I);this.h[P]=V}),this.f.push(k),k.value}R(h,E){if(E=E||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const k=h.location.parentTerminal;if(k){const I=this.f.find(P=>P.value===k);I&&(E.resolvedExtHostIdentifier=I._id)}}else h.location&&typeof h.location!="object"?E.location=h.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(h,E){if(!this.getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const I=new c(E),P=this.S(h,I);this.h[h]=P}async $acceptActiveTerminalChanged(h){const E=this.b;if(h===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(h);k&&(this.b=k,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,E){const k=this.getTerminalById(h);k&&this.O.fire({terminal:k.value,data:E})}async $acceptTerminalDimensions(h,E,k){const I=this.getTerminalById(h);I&&I.setDimensions(E,k)&&this.L.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptDidExecuteCommand(h,E){const k=this.getTerminalById(h);k&&this.P.fire({terminal:k.value,...E})}async $acceptTerminalMaximumDimensions(h,E,k){this.g.get(h)?.resize(E,k)}async $acceptTerminalTitleChange(h,E){const k=this.getTerminalById(h);k&&(k.name=E)}async $acceptTerminalClosed(h,E,k){const I=this.X(this.f,h);if(I!==null){const P=this.f.splice(I,1)[0];P.setExitStatus(E,k),this.H.fire(P.value)}}$acceptTerminalOpened(h,E,k,I){if(E){const W=this.X(this.f,E);if(W!==null){this.f[W]._id=h,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const P={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:T.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},V=new n(this.a,h,P,k);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(h,E){this.getTerminalById(h)?._setProcessId(E)}async $startExtensionTerminal(h,E){const k=this.getTerminalById(h);if(!k)return{message:(0,D.localize)(0,null,h)};k.isOpen||await new Promise(P=>{const V=this.onDidOpenTerminal(async W=>{W===k.value&&(V.dispose(),P())})});const I=this.g.get(h);I?I.startSendingEvents(E):this.j[h]={initialDimensions:E}}S(h,E){const k=new b.$Tc;k.add(E.onProcessReady(P=>this.a.$sendProcessReady(h,P.pid,P.cwd,P.windowsPty))),k.add(E.onDidChangeProperty(P=>this.a.$sendProcessProperty(h,P))),this.y.startBuffering(h,E.onProcessData),k.add(E.onProcessExit(P=>this.U(h,P))),this.g.set(h,E);const I=this.j[h];return I&&E instanceof c&&(E.startSendingEvents(I.initialDimensions),delete this.j[h]),k}$acceptProcessAckDataEvent(h,E){this.g.get(h)?.acknowledgeDataEvent(E)}$acceptProcessInput(h,E){this.g.get(h)?.input(E)}$acceptTerminalInteraction(h){const E=this.getTerminalById(h);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(h,E){this.getTerminalById(h)?.setSelection(E)}$acceptProcessResize(h,E,k){try{this.g.get(h)?.resize(E,k)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(h,E){this.g.get(h)?.shutdown(E)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(E=>this.a.$sendProcessProperty(h,{type:"cwd",value:E}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new m.$lM(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,E,k){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,k),this.a.$registerProfileProvider(E,h.identifier.value),new m.$lM(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(h,E,k){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,k),this.a.$registerQuickFixProvider(h,E),new m.$lM(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,E){const k=new l.$qe().token;if(k.isCancellationRequested)return;const I=this.D.get(h);if(!I)return;const P=await I.provideTerminalQuickFixes(E,k);if(P===null||Array.isArray(P)&&P.length===0)return;const V=new b.$Tc;if(this.w.value=V,!Array.isArray(P))return P?o.TerminalQuickFix.from(P,this.Q.converter,V):void 0;const W=[];for(const q of P){const R=o.TerminalQuickFix.from(q,this.Q.converter,V);R&&W.push(R)}return W}async $createContributedProfileTerminal(h,E){const k=new l.$qe().token;let I=await this.C.get(h)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,E);return}this.createTerminalFromOptions(I.options,E)}}async $provideLinks(h,E){const k=this.getTerminalById(h);if(!k)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const P=new l.$qe;this.G.set(h,P);const V=[],W={terminal:k.value,line:E},q=[];for(const G of this.z)q.push(s.Promises.withAsyncBody(async ie=>{P.token.onCancellationRequested(()=>ie({provider:G,links:[]}));const de=await G.provideTerminalLinks(W,P.token)||[];P.token.isCancellationRequested||ie({provider:G,links:de})}));const R=await Promise.all(q);if(P.token.isCancellationRequested)return[];const z=new Map;for(const G of R)G&&G.links.length>0&&V.push(...G.links.map(ie=>{const de={id:u++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return z.set(de.id,{provider:G.provider,link:ie}),de}));return this.F.set(h,z),V}$activateLink(h,E){const k=this.F.get(h)?.get(E);k&&k.provider.handleTerminalLink(k.link)}U(h,E){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const k=this.h[h];k&&(k.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,E)}getTerminalById(h){return this.W(this.f,h)}getTerminalIdByApiObject(h){const E=this.f.findIndex(k=>k.value===h);return E>=0?E:null}W(h,E){const k=this.X(h,E);return k!==null?h[k]:null}X(h,E){const k=h.findIndex(I=>I._id===E);return k>=0?k:null}getEnvironmentVariableCollection(h){let E=this.n.get(h.identifier.value);return E||(E=new f,this.Z(h.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(h,E){const k=(0,S.$ps)(E.map),I=(0,S.$qs)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(h,E.persistent,k.length===0?void 0:k,I)}$initEnvironmentVariableCollections(h){h.forEach(E=>{const k=E[0],I=new f(E[1]);this.Z(k,I)})}$acceptDefaultProfile(h,E){const k=this.s;this.s=h,this.u=E,k?.path!==h.path&&this.N.fire(h.path)}Z(h,E){this.n.set(h,E),E.onDidChangeCollection(()=>{this.Y(h,E)})}};e.$Pmc=t,e.$Pmc=t=Je([We(1,i.$0O),We(2,A.$NO)],t);class f{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$fe,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const E=this.h(h);let k=this.a.get(E);return k||(k=new a(this,h),this.a.set(E,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(h,E,k,I){this.f(h,{value:E,type:m.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:I})}append(h,E,k,I){this.f(h,{value:E,type:m.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:I})}prepend(h,E,k,I){this.f(h,{value:E,type:m.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:I})}f(h,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(h,E.scope),I=this.map.get(k),P=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!I||I.value!==E.value||I.type!==E.type||I.options?.applyAtProcessCreation!==P.applyAtProcessCreation||I.options?.applyAtShellIntegration!==P.applyAtShellIntegration||I.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const V=this.g(h,E.scope),W={variable:h,...E,options:P};this.map.set(V,W),this.d.fire()}}get(h,E){const k=this.g(h,E),I=this.map.get(k);return I?v(I):void 0}g(h,E){const k=this.h(E);return k.length?`${h}:::${k}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const E=new Map;for(const[k,I]of this.map)this.h(I.scope)===this.h(h)&&E.set(I.variable,v(I));return E}delete(h,E){const k=this.g(h,E);this.map.delete(k),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[E,k]of this.map)k.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(E);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,E){const k=this.h(E),I=this.descriptionMap.get(k);if(!I||I.description!==h){let P;typeof h=="string"?P=h:P=h?.value.split(`

`)[0];const V={description:P,scope:E};this.descriptionMap.set(k,V),this.d.fire()}}getDescription(h){const E=this.h(h);return this.descriptionMap.get(E)?.description}k(h){const E=this.h(h);this.descriptionMap.delete(E)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,E){this.b=h,this.d=E,this.a=new C.$fe}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,E,k){this.b.replace(h,E,k,this.d)}append(h,E,k){this.b.append(h,E,k,this.d)}prepend(h,E,k){this.b.prepend(h,E,k,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,E){this.b.getVariableMap(this.d).forEach((k,I)=>h.call(E,I,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends t{constructor(h,E){super(!1,h,E)}createTerminal(h,E,k){throw new N.$_}createTerminalFromOptions(h,E){throw new N.$_}};e.$Qmc=d,e.$Qmc=d=Je([We(0,i.$0O),We(1,A.$NO)],d);function $(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function p(y){return r.ThemeColor.isThemeColor(y)?y:void 0}function v(y){const h={...y};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Se[116],Ie([1,0,7,6,3,4,17,53,5,2,11]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=e.$Unc=void 0,e.$Unc=(0,M.$yi)("IExtHostTerminalShellIntegration");let S=class extends O.$Uc{constructor(s,o){super(),this.h=o,this.b=new Map,this.c=new m.$fe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$fe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$fe,this.onDidEndTerminalShellExecution=this.g.event,this.a=s.getProxy(T.$jM.MainThreadTerminalShellIntegration),this.B((0,O.$Sc)(()=>{for(const[i,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(s){const o=this.h.getTerminalById(s);if(!o)return;const i=o.value;let n=this.b.get(s);n||(n=new l(o.value,this.f),this.b.set(s,n),n.store.add(o.onWillDispose(()=>this.b.get(s)?.dispose())),n.store.add(n.onDidRequestShellExecution(c=>this.a.$executeCommand(s,c))),n.store.add(n.onDidRequestEndExecution(c=>this.g.fire(c))),n.store.add(n.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),o.shellIntegration=n.value),this.c.fire({terminal:i,shellIntegration:n.value})}$shellExecutionStart(s,o,i,n,c){this.b.has(s)||this.$shellIntegrationChange(s);const u={value:o,confidence:i,isTrusted:n};this.b.get(s)?.startShellExecution(u,c)}$shellExecutionEnd(s,o,i,n,c){const u={value:o,confidence:i,isTrusted:n};this.b.get(s)?.endShellExecution(u,c)}$shellExecutionData(s,o){this.b.get(s)?.emitData(o)}$cwdChange(s,o){this.b.get(s)?.setCwd((0,D.$vc)(o)?D.URI.revive(o):o)}$closeTerminal(s){this.b.get(s)?.dispose(),this.b.delete(s)}};e.$Vnc=S,e.$Vnc=S=Je([We(0,A.$NO),We(1,b.$Nmc)],S);class l extends O.$Uc{get currentExecution(){return this.a}constructor(s,o){super(),this.j=s,this.m=o,this.b=!1,this.store=this.B(new O.$Tc),this.f=this.B(new m.$fe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$fe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$fe),this.onDidRequestEndExecution=this.h.event;const i=this;this.value={get cwd(){return i.c},executeCommand(n,c){let u=n;c&&(u+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),i.g.fire(u);const t={value:u,confidence:C.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},f=i.startShellExecution(t,i.c,!0).value;return i.b=!0,f}}}startShellExecution(s,o,i){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new w(s,o);i?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,o){this.a&&(this.a.endExecution(s),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(s){let o=!1;D.URI.isUri(this.c)?o=!D.URI.isUri(s)||this.c.toString()!==s.toString():this.c!==s&&(o=!0),o&&(this.c=s,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class w{constructor(s,o){this.c=s,this.cwd=o,this.b=!1;const i=this;this.value={get commandLine(){return i.c},get cwd(){return i.cwd},read(){return i.d()}}}d(){if(!this.a){if(this.b)return N.$Yh.EMPTY;this.a=new g}return this.a.createIterable()}emitData(s){this.a?.emitData(s)}endExecution(s){s&&(this.c=s),this.a?.endExecution(),this.a=void 0,this.b=!0}}class g extends O.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new N.$xh);const s=this.a;return new N.$Yh(async i=>{this.b.push(i),await s.wait()})}emitData(s){for(const o of this.b)o.emitOne(s)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Se[289],Ie([1,0,11,22,20,5,262,73,6,15,33,12,4,17,115,8,7,52,77,62,25]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=e.$Ync=e.$Xnc=e.$Wnc=void 0;let u=class extends m.$Uc{constructor(V,W,q,R){super(),this.w=R,this.f=this.B(new T.$fe),this.g=new Map,this.s=this.B(new T.$fe),this.onResultsChanged=this.f.event,this.results=[],this.h=V.getProxy(l.$jM.MainThreadTesting),this.m=new h(this.h),this.j=new d(this.h,W),q.registerArgumentProcessor({processArgument:z=>{switch(z?.$mid){case 16:{const G=z,ie=G.tests[G.tests.length-1].item.extId;return this.g.get(o.$8K.root(ie))?.collection.tree.get(ie)?.actual??(0,g.$ZO)(z)}case 18:{const{test:G,message:ie}=z,de=G.item.extId;return{test:this.g.get(o.$8K.root(de))?.collection.tree.get(de)?.actual??(0,g.$ZO)({$mid:16,tests:[G]}),message:r.TestMessage.to(ie)}}default:return z}}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const z=await q.executeCommand("_testing.getExplorerSelection"),G=ie=>{const de=this.g.get(o.$8K.root(ie));if(de)return o.$8K.isRoot(ie)?de.controller:de.collection.tree.get(ie)?.actual};return{include:z?.include.map(G).filter(D.$gg)||[],exclude:z?.exclude.map(G).filter(D.$gg)||[]}})}createTestController(V,W,q,R){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const z=new m.$Tc,G=z.add(new g.$3O(W,q,this.w));G.root.label=q;const ie=new Map,de=new Set,ye=this.h,De={items:G.root.children,get label(){return q},set label(ue){q=ue,G.root.label=ue,ye.$updateController(W,{label:q})},get refreshHandler(){return R},set refreshHandler(ue){R=ue,ye.$updateController(W,{canRefresh:!!ue})},get id(){return W},createRunProfile:(ue,Ce,se,Oe,ne,j)=>{let x=(0,b.$mj)(ue);for(;ie.has(x);)x++;return new k(this.h,ie,de,this.s.event,W,x,ue,Ce,se,Oe,ne,j)},createTestItem(ue,Ce,se){return new g.$1O(W,ue,Ce,se)},createTestRun:(ue,Ce,se=!0)=>this.j.createTestRun(V,W,G,ue,Ce,se),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const Ce=ue instanceof Array?ue:[ue];this.h.$markTestRetired(Ce.map(se=>o.$8K.fromExtHostTestItem(se,W).toString()))}},set resolveHandler(ue){G.resolveHandler=ue},get resolveHandler(){return G.resolveHandler},dispose:()=>{z.dispose()}};ye.$registerTestController(W,q,!!R),z.add((0,m.$Sc)(()=>ye.$unregisterTestController(W)));const ge={controller:De,collection:G,profiles:ie,extension:V,activeProfiles:de};return this.g.set(W,ge),z.add((0,m.$Sc)(()=>this.g.delete(W))),z.add(G.onDidGenerateDiff(ue=>ye.$publishDiff(W,ue.map(n.TestsDiffOp.serialize)))),De}createTestObserver(){return this.m.checkout()}async runTests(V,W=M.CancellationToken.None){const q=$(V);if(!q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const R=this.g.get(q.controllerId);if(!R)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:V.preserveFocus??!0,targets:[{testIds:V.include?.map(z=>o.$8K.fromExtHostTestItem(z,R.collection.root.id).toString())??[R.collection.root.id],profileGroup:I[q.kind],profileId:q.profileId,controllerId:q.controllerId}],exclude:V.exclude?.map(z=>z.id)},W)}$syncTests(){for(const{collection:V}of this.g.values())V.flushDiff();return Promise.resolve()}async $getCoverageDetails(V,W){return(await this.j.getCoverageDetails(V,W))?.map(r.TestCoverage.fromDetails)}async $disposeRun(V){this.j.disposeTestRun(V)}$configureRunProfile(V,W){this.g.get(V)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(V){const W=new Map;for(const[q,R]of Object.entries(V)){const z=this.g.get(q);if(!z)continue;const G=new Map,ie=R.filter(ye=>!z.activeProfiles.has(ye)),de=[...z.activeProfiles].filter(ye=>!R.includes(ye));for(const ye of ie)G.set(ye,!0),z.activeProfiles.add(ye);for(const ye of de)G.set(ye,!1),z.activeProfiles.delete(ye);G.size&&W.set(q,G)}this.s.fire(W)}async $refreshTests(V,W){await this.g.get(V)?.controller.refreshHandler?.(W)}$publishTestResults(V){this.results=Object.freeze(V.map(r.TestResults.to).concat(this.results).sort((W,q)=>q.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(V,W){const q=this.g.get(o.$8K.fromString(V).controllerId)?.collection;q&&(await q.expand(V,W<0?1/0:W),q.flushDiff())}$acceptDiff(V){this.m.applyDiff(V.map(W=>n.TestsDiffOp.deserialize({asCanonicalUri:q=>q},W)))}async $runControllerTests(V,W){return Promise.all(V.map(q=>this.y(q,!1,W)))}async $startContinuousRun(V,W){const q=new M.$qe(W),R=await Promise.all(V.map(z=>this.y(z,!0,q.token)));return!W.isCancellationRequested&&!R.some(z=>z.error)&&await new Promise(z=>W.onCancellationRequested(z)),q.dispose(!0),R}async y(V,W,q){const R=this.g.get(V.controllerId);if(!R)return{};const{collection:z,profiles:G,extension:ie}=R,de=G.get(V.profileId);if(!de)return{};const ye=V.testIds.map(Ce=>z.tree.get(Ce)).filter(D.$gg),De=V.excludeExtIds.map(Ce=>R.collection.tree.get(Ce)).filter(D.$gg).filter(Ce=>ye.some(se=>se.fullId.compare(Ce.fullId)===2));if(!ye.length)return{};const ge=new s.$YN(ye.some(Ce=>Ce.actual instanceof g.$2O)?void 0:ye.map(Ce=>Ce.actual),De.map(Ce=>Ce.actual),de,W),ue=(0,n.$$K)(V)&&this.j.prepareForMainThreadTestRun(ie,ge,p.fromInternal(V,R.collection),de,q);try{return await de.runHandler(ge,q),{}}catch(Ce){return{error:String(Ce)}}finally{ue&&ue.hasRunningTasks&&!q.isCancellationRequested&&await T.Event.toPromise(ue.onEnd)}}$cancelExtensionTestRun(V){V===void 0?this.j.cancelAllRuns():this.j.cancelRunById(V)}};e.$Wnc=u,e.$Wnc=u=Je([We(0,w.$NO),We(1,S.$5j)],u);const t=1e4;var f;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(f||(f={}));class a extends m.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(V,W,q,R,z,G){super(),this.y=V,this.z=W,this.C=q,this.D=R,this.F=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new T.$fe),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new M.$qe(G));const ie=this.B(new C.$Kh(()=>this.G(),t));this.B(this.j.token.onCancellationRequested(()=>ie.schedule()));const de=new T.$fe;this.s=de.event,this.B((0,m.$Sc)(()=>{de.fire(),de.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.G()}getCoverageDetails(V,W){const[,q]=o.$8K.fromString(V).path,R=this.w.get(V);if(!R)return[];const z=this.g.get(q);if(!z)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(z.run,R,W)??[]}createRun(V){const W=this.y.id,q=this.y.controllerId,R=(0,N.$Ug)(),z=De=>(ge,...ue)=>{if(ie){this.C.warn(`Setting the state of test "${ge.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ge)&&(this.I(ge),De(ge,...ue))},G=(De,ge)=>{const ue=ge instanceof Array?ge.map(r.TestMessage.from):[r.TestMessage.from(ge)];if(De.uri&&De.range){const Ce={range:r.Range.from(De.range),uri:De.uri};for(const se of ue)se.location=se.location||Ce}this.z.$appendTestMessagesInRun(W,R,o.$8K.fromExtHostTestItem(De,q).toString(),ue)};let ie=!1;const de=new Map,ye={isPersisted:this.y.isPersisted,token:this.j.token,name:V,onDidDispose:this.s,addCoverage:De=>{if(ie)return;const ge=De instanceof s.$4N?De.testItem:void 0;let ue;if(ge){if((0,c.$LG)(this.F,"attributableCoverage"),!this.y.isIncluded(ge))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.I(ge),ue=de.get(ge),ue===void 0&&(ue=de.size,de.set(ge,ue))}const Ce=De.uri.toString(),se=new o.$8K(ue!==void 0?[W,R,Ce,String(ue)]:[W,R,Ce]).toString();this.w.set(se,De),this.z.$appendCoverage(W,R,r.TestCoverage.fromFile(q,se,De))},enqueued:z(De=>{this.z.$updateTestStateInRun(W,R,o.$8K.fromExtHostTestItem(De,q).toString(),1)}),skipped:z(De=>{this.z.$updateTestStateInRun(W,R,o.$8K.fromExtHostTestItem(De,q).toString(),5)}),started:z(De=>{this.z.$updateTestStateInRun(W,R,o.$8K.fromExtHostTestItem(De,q).toString(),2)}),errored:z((De,ge,ue)=>{G(De,ge),this.z.$updateTestStateInRun(W,R,o.$8K.fromExtHostTestItem(De,q).toString(),6,ue)}),failed:z((De,ge,ue)=>{G(De,ge),this.z.$updateTestStateInRun(W,R,o.$8K.fromExtHostTestItem(De,q).toString(),4,ue)}),passed:z((De,ge)=>{this.z.$updateTestStateInRun(W,R,o.$8K.fromExtHostTestItem(De,this.y.controllerId).toString(),3,ge)}),appendOutput:(De,ge,ue)=>{ie||(ue&&(this.y.isIncluded(ue)?this.I(ue):ue=void 0),this.z.$appendOutputToRun(W,R,O.$He.fromString(De),ge&&r.location.from(ge),ue&&o.$8K.fromExtHostTestItem(ue,q).toString()))},end:()=>{ie||(ie=!0,de.clear(),this.z.$finishedTestRunTask(W,R),--this.f||this.H())}};return this.f++,this.g.set(R,{run:ye}),this.z.$startedTestRunTask(W,{id:R,name:V,running:!0}),ye}G(){for(const{run:V}of this.g.values())V.end()}H(){this.c!==2&&(this.c=2,this.m.fire())}I(V){if(!(V instanceof g.$1O))throw new i.$FO(V.id);if(this.h.has(o.$8K.fromExtHostTestItem(V,this.y.controllerId).toString()))return;const W=[],q=this.y.colllection.root;for(;;){const R=r.TestItem.from(V);if(W.unshift(R),this.h.has(R.extId)||(this.h.add(R.extId),V===q))break;V=V.parent||q}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.H(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(V,W){this.g=V,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(V,W){const q=o.$8K.root(V);return this.f.get(q)?.getCoverageDetails(V,W)||[]}disposeTestRun(V){this.f.get(V)?.dispose(),this.f.delete(V);for(const[W,{id:q}]of this.c)q===V&&this.c.delete(W)}prepareForMainThreadTestRun(V,W,q,R,z){return this.j(W,q,R,V,z)}cancelRunById(V){this.f.get(V)?.cancel()}cancelAllRuns(){for(const V of this.c.values())V.cancel()}createTestRun(V,W,q,R,z,G){const ie=this.c.get(R);if(ie)return ie.createRun(z);const de=p.fromPublic(W,q,R,G),ye=$(R);this.g.$startedExtensionTestRun({controllerId:W,continuous:!!R.continuous,profile:ye&&{group:I[ye.kind],id:ye.profileId},exclude:R.exclude?.map(ge=>o.$8K.fromExtHostTestItem(ge,q.root.id).toString())??[],id:de.id,include:R.include?.map(ge=>o.$8K.fromExtHostTestItem(ge,q.root.id).toString())??[q.root.id],preserveFocus:R.preserveFocus??!0,persist:G});const De=this.j(R,de,R.profile,V);return T.Event.once(De.onEnd)(()=>{this.g.$finishedExtensionTestRun(de.id)}),De.createRun(z)}j(V,W,q,R,z){const G=new a(W,this.g,this.h,q,R,z);return this.c.set(V,G),this.f.set(G.id,G),G}}e.$Xnc=d;const $=P=>{if(P.profile){if(!(P.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class p{static fromPublic(V,W,q,R){return new p(V,(0,N.$Ug)(),q.include?.map(z=>o.$8K.fromExtHostTestItem(z,V).toString())??[V],q.exclude?.map(z=>o.$8K.fromExtHostTestItem(z,V).toString())??[],R,W)}static fromInternal(V,W){return new p(V.controllerId,V.runId,V.testIds,V.excludeExtIds,!0,W)}constructor(V,W,q,R,z,G){this.controllerId=V,this.id=W,this.isPersisted=z,this.colllection=G,this.c=q.map(ie=>ie+"\0"),this.f=R.map(ie=>ie+"\0")}isIncluded(V){const W=o.$8K.fromExtHostTestItem(V,this.controllerId).toString()+"\0";for(const q of this.f)if(W===q||W.startsWith(q))return!1;for(const q of this.c)if(W===q||W.startsWith(q))return!0;return!1}}e.$Ync=p;class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(V){this.j=V,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(V){this.c.add(V)}update(V){Object.assign(V.revived,r.TestItem.toPlain(V.item)),this.c.has(V)||this.f.add(V)}remove(V){if(this.c.has(V)){this.c.delete(V);return}this.f.delete(V);const W=o.$8K.parentId(V.item.extId);if(W&&this.h.has(W.toString())){this.h.add(V.item.extId);return}this.g.add(V)}getChangeEvent(){const{c:V,f:W,g:q}=this;return{get added(){return[...V].map(R=>R.revived)},get updated(){return[...W].map(R=>R.revived)},get removed(){return[...q].map(R=>R.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends n.$eL{constructor(){super(...arguments),this.s=new T.$fe,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(V){return this.f.get(V)}getMirroredTestDataByReference(V){return this.f.get(V.id)}w(V,W){return{...V,revived:r.TestItem.toPlain(V.item),depth:W?W.depth+1:0,children:new Set}}v(){return new v(this.s)}}class h{constructor(V){this.f=V}checkout(){this.c||(this.c=this.g());const V=this.c;return V.observers++,{onDidChangeTest:V.tests.onDidChangeTests,get tests(){return[...V.tests.rootTests].map(W=>W.revived)},dispose:(0,A.$db)(()=>{--V.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(V){return this.c?.tests.getMirroredTestDataByReference(V)}applyDiff(V){this.c?.tests.apply(V)}g(){const V=new y({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:V}}}const E=(P,V,W,q)=>{W?Object.assign(W,q):V.$updateTestRunConfig(P.controllerId,P.profileId,q)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(V){V!==this.f&&(this.f=V,E(this,this.#e,this.#n,{label:V}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(V){V!==this.g&&(this.g=V,E(this,this.#e,this.#n,{supportsContinuousRun:V}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(V){V!==this.isDefault&&(V?this.#t.add(this.profileId):this.#t.delete(this.profileId),E(this,this.#e,this.#n,{isDefault:V}))}get tag(){return this._tag}set tag(V){V?.id!==this._tag?.id&&(this._tag=V,E(this,this.#e,this.#n,{tag:V?r.TestTag.namespace(this.controllerId,V.id):null}))}get configureHandler(){return this.c}set configureHandler(V){V!==this.c&&(this.c=V,E(this,this.#e,this.#n,{hasConfigurationHandler:!!V}))}get onDidChangeDefault(){return T.Event.chain(this.#i,V=>V.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(D.$gg))}constructor(V,W,q,R,z,G,ie,de,ye,De=!1,ge=void 0,ue=!1){this.controllerId=z,this.profileId=G,this.f=ie,this.kind=de,this.runHandler=ye,this._tag=ge,this.g=ue,this.#e=V,this.#s=W,this.#t=q,this.#i=R,W.set(G,this);const Ce=I[de];if(typeof Ce!="number")throw new Error(`Unknown TestRunProfile.group ${de}`);De&&q.add(G),this.#n={profileId:G,controllerId:z,tag:ge?r.TestTag.namespace(this.controllerId,ge.id):null,label:ie,group:Ce,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Znc=k;const I={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Se[117],Ie([1,0,57,14,91,8,7]),function(le,e,C,O,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=e.$VO=e.$UO=void 0;class b{static{this.c=new M.$SO("TextEditorDecorationType")}constructor(l,w,g){const r=b.c.nextId();l.$registerTextEditorDecorationType(w.identifier,r,T.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$UO=b;class m{constructor(l,w){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,w){this.k();let g=null;if(l instanceof A.$mM)g=new A.$nM(l,l);else if(l instanceof A.$nM)g=l;else throw new Error("Unrecognized location");this.l(g,w,!1)}insert(l,w){this.k(),this.l(new A.$nM(l,l),w,!0)}delete(l){this.k();let w=null;if(l instanceof A.$nM)w=l;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(l,w,g){const r=this.c.validateRange(l);this.g.push({range:r,text:w,forceMoveMarkers:g})}setEndOfLine(l){if(this.k(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=l}}class D{constructor(l,w,g,r){this.c=l,this.d=w,this._accept(g),this.e=r;const s=this;this.value={get tabSize(){return s.f},set tabSize(o){s.n(o)},get indentSize(){return s.g},set indentSize(o){s.p(o)},get insertSpaces(){return s.j},set insertSpaces(o){s.s(o)},get cursorStyle(){return s.k},set cursorStyle(o){s.t(o)},get lineNumbers(){return s.l},set lineNumbers(o){s.u(o)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=T.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}n(l){const w=this.m(l);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}p(l){const w=this.o(l);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const w=this.q(l);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(l)})))}assign(l){const w={};let g=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(g=!0,w.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,g=!0,w.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(g=!0,w.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,g=!0,w.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(g=!0,w.insertSpaces=r):this.j!==r&&(this.j=r,g=!0,w.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,g=!0,w.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,g=!0,w.lineNumbers=T.TextEditorLineNumbersStyle.from(l.lineNumbers)),g&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(l,w){w.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(g)})}}e.$VO=D;class N{constructor(l,w,g,r,s,o,i,n){this.id=l,this.j=w,this.k=g,this.g=!1,this.h=new Set,this.c=s,this.d=new D(this.j,this.id,o,g),this.e=i,this.f=n;const c=this;this.value=Object.freeze({get document(){return r.value},set document(u){throw new O.$9("document")},get selection(){return c.c&&c.c[0]},set selection(u){if(!(u instanceof A.$oM))throw(0,O.$7)("selection");c.c=[u],c.l()},get selections(){return c.c},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof A.$oM)))throw(0,O.$7)("selections");c.c=u,c.l()},get visibleRanges(){return c.e},set visibleRanges(u){throw new O.$9("visibleRanges")},get options(){return c.d.value},set options(u){c.g||c.d.assign(u)},get viewColumn(){return c.f},set viewColumn(u){throw new O.$9("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new m(r.value,t);return u(f),c.m(f)},insertSnippet(u,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=c.c.map(d=>T.Range.from(d));else if(t instanceof A.$mM){const{lineNumber:d,column:$}=T.Position.from(t);a=[{startLineNumber:d,startColumn:$,endLineNumber:d,endColumn:$}]}else if(t instanceof A.$nM)a=[T.Range.from(t)];else{a=[];for(const d of t)if(d instanceof A.$nM)a.push(T.Range.from(d));else{const{lineNumber:$,column:p}=T.Position.from(d);a.push({startLineNumber:$,startColumn:p,endLineNumber:$,endColumn:p})}}return w.$tryInsertSnippet(l,r.value.version,u.value,a,f)},setDecorations(u,t){const f=t.length===0;f&&!c.h.has(u.key)||(f?c.h.delete(u.key):c.h.add(u.key),c.n(()=>{if(T.$KO(t))return w.$trySetDecorations(l,u.key,T.$LO(t));{const a=new Array(4*t.length);for(let d=0,$=t.length;d<$;d++){const p=t[d];a[4*d]=p.start.line+1,a[4*d+1]=p.start.character+1,a[4*d+2]=p.end.line+1,a[4*d+3]=p.end.character+1}return w.$trySetDecorationsFast(l,u.key,a)}}))},revealRange(u,t){c.n(()=>w.$tryRevealRange(l,T.Range.from(u),t||A.TextEditorRevealType.Default))},show(u){w.$tryShowEditor(l,T.ViewColumn.from(u))},hide(){w.$tryHideEditor(l)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,C.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,C.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,C.ok)(!this.g),this.f=l}_acceptSelections(l){(0,C.ok)(!this.g),this.c=l}async l(){const l=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const w=l.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const g=w.edits.map(s=>s.range);g.sort((s,o)=>s.end.line===o.end.line?s.end.character===o.end.character?s.start.line===o.start.line?s.start.character-o.start.character:s.start.line-o.start.line:s.end.character-o.end.character:s.end.line-o.end.line);for(let s=0,o=g.length-1;s<o;s++){const i=g[s].end;if(g[s+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=w.edits.map(s=>({range:T.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,r,{setEndOfLine:typeof w.setEndOfLine=="number"?T.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$WO=N}),define(Se[68],Ie([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=e.$XO=void 0;class o{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(c,u){this.h=c,this.i=u,this.a=null,this.b=new Map,this.c=new w.$Ac,this.d=new O.$fe,this.e=new O.$fe,this.f=new O.$fe,this.g=new O.$fe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],t=[],f=[];if(c.removedDocuments)for(const a of c.removedDocuments){const d=T.URI.revive(a),$=this.c.get(d);$?.unref()&&(this.c.delete(d),u.push($.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const d=T.URI.revive(a.uri);let $=this.c.get(d);if($&&d.scheme!==g.Schemas.vscodeNotebookCell&&d.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);$||($=new o(new m.$QO(this.h.getProxy(b.$jM.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(d,$),t.push($.value)),$.ref()}if(c.removedEditors)for(const a of c.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&f.push(d)}if(c.addedEditors)for(const a of c.addedEditors){const d=T.URI.revive(a.documentUri);C.ok(this.c.has(d),`document '${d}' does not exist`),C.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const $=this.c.get(d).value,p=new N.$WO(a.id,this.h.getProxy(b.$jM.MainThreadTextEditors),this.i,new s.$V(()=>$.document),a.selections.map(S.Selection.to),a.options,a.visibleRanges.map(v=>S.Range.to(v)),typeof a.editorPosition=="number"?S.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,p)}c.newActiveEditor!==void 0&&(C.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,M.$Pc)(u),(0,M.$Pc)(f),c.removedDocuments&&this.e.fire(u),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const u=this.b.get(this.a);return c?u:u?.value}allEditors(){return[...this.b.values()]}};e.$XO=i,e.$XO=i=Je([We(0,D.$NO),We(1,l.$5j)],i),e.$YO=(0,A.$yi)("IExtHostDocumentsAndEditors")}),define(Se[290],Ie([1,0,18,5,4,117,8,7]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=void 0;class m{constructor(N,S){this.i=S,this.a=new O.$fe,this.b=new O.$fe,this.c=new O.$fe,this.d=new O.$fe,this.f=new O.$fe,this.g=new O.$fe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(M.$jM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const S=this.i.allEditors();return N?S:S.map(l=>l.value)}async showTextDocument(N,S,l){let w;typeof S=="number"?w={position:A.ViewColumn.from(S),preserveFocus:l}:typeof S=="object"?w={position:A.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?A.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:w={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(N.uri,w),r=g&&this.i.getEditor(g);if(r)return r.value;throw g?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,S){return new T.$UO(this.h,N,S).value}$acceptEditorPropertiesChanged(N,S){const l=this.i.getEditor(N);if(!l)throw new Error("unknown text editor");if(S.options&&l._acceptOptions(S.options),S.selections){const w=S.selections.selections.map(A.Selection.to);l._acceptSelections(w)}if(S.visibleRanges){const w=C.$Hb(S.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(w)}if(S.options&&this.b.fire({textEditor:l.value,options:{...S.options,lineNumbers:A.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const w=b.TextEditorSelectionChangeKind.fromValue(S.selections.source),g=S.selections.selections.map(A.Selection.to);this.a.fire({textEditor:l.value,selections:g,kind:w})}if(S.visibleRanges){const w=C.$Hb(S.visibleRanges.map(A.Range.to));this.c.fire({textEditor:l.value,visibleRanges:w})}}$acceptEditorPositionData(N){for(const S in N){const l=this.i.getEditor(S);if(!l)throw new Error("Unknown text editor");const w=A.ViewColumn.to(N[S]);l.value.viewColumn!==w&&(l._acceptViewColumn(w),this.d.fire({textEditor:l.value,viewColumn:w}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.$gmc=m}),define(Se[291],Ie([1,0,2,3,4,6,7,8,21,15]),function(le,e,C,O,M,T,A,b,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=e.$2nc=void 0,e.$2nc=(0,O.$yi)("IExtHostTimeline");class N{constructor(w,g){this.b=new Map,this.c=new Map,this.a=w.getProxy(M.$jM.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(r,s)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&m.$Tm.equals(s,this.b.get(r.source)?.extension)){const o=r.uri===void 0?void 0:C.URI.revive(r.uri);return this.c.get(r.source)?.get(S(o))?.get(r.handle)}else return;return r}})}async $getTimeline(w,g,r,s){return this.b.get(w)?.provider.provideTimeline(C.URI.revive(g),r,s)}registerTimelineProvider(w,g,r,s){const o=new T.$Tc,i=this.d(g.id,s,o).bind(this);let n;g.onDidChange&&(n=g.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:g.id}),this));const c=this.c;return this.f({...g,scheme:w,onDidChange:void 0,async provideTimeline(u,t,f){t?.resetCache&&(o.clear(),c.get(g.id)?.clear());const a=await g.provideTimeline(u,t,f);if(a==null)return;const d=i(u,t);return{...a,source:g.id,items:a.items.map(d)}},dispose(){for(const u of c.values())u.get(g.id)?.clear();n?.dispose(),o.dispose()}},r)}d(w,g,r){return(s,o)=>{let i;if(o?.cacheResults){let n=this.c.get(w);n===void 0&&(n=new Map,this.c.set(w,n));const c=S(s);i=n.get(c),i===void 0&&(i=new Map,n.set(c,i))}return n=>{const{iconPath:c,...u}=n,t=`${w}|${n.id??n.timestamp}`;i?.set(t,n);let f,a,d;n.iconPath&&(c instanceof A.$iN?d={id:c.id,color:c.color}:C.URI.isUri(c)?(f=c,a=c):{light:f,dark:a}=c);let $;return A.$NM.isMarkdownString(u.tooltip)?$=b.MarkdownString.from(u.tooltip):(0,D.$$f)(u.tooltip)?$=u.tooltip:A.$NM.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),$=b.MarkdownString.from(u.detail)):(0,D.$$f)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),$=u.detail),{...u,id:u.id??void 0,handle:t,source:w,command:n.command?g.toInternal(n.command,r):void 0,icon:f,iconDark:a,themeIcon:d,tooltip:$,accessibilityInformation:n.accessibilityInformation}}}}f(w,g){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:g}),(0,T.$Sc)(()=>{for(const s of this.c.values())s.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$3nc=N;function S(l){return l?.toString()}}),define(Se[292],Ie([1,0,181,24,2,5,6,222,11,7,15,18,8,55,20,143,25]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=void 0;function o(c,u){if((0,N.$$f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class i extends A.$Uc{constructor(u,t,f){super(),this.f=u,this.g=t,this.h=f,this.a=new Map,this.b=new r.$K0;function a(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:d=>a(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map($=>a($)?this.r($):$):d})}registerTreeDataProvider(u,t,f){const a=this.createTreeView(u,{treeDataProvider:t},f);return{dispose:()=>a.dispose()}}createTreeView(u,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],d=t.dragAndDropController?.dragMimeTypes??[],$=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,v=this.m(u,t,f),y={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:d,hasHandleDrag:$,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(u,y),E={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,s.$LG)(f,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,s.$LG)(f,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(k){(0,w.$Xk)(k)&&(0,s.$LG)(f,"treeViewMarkdownMessage"),v.message=k},get title(){return v.title},set title(k){v.title=k},get description(){return v.description},set description(k){v.description=k},get badge(){return v.badge},set badge(k){k!==void 0&&D.ViewBadge.isViewBadge(k)?v.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(v.badge=void 0)},reveal:(k,I)=>v.reveal(k,I),dispose:async()=>{await h,this.a.delete(u),v.dispose()}};return this.B(E),E}$getChildren(u,t){const f=this.a.get(u);return f?f.getChildren(t):Promise.reject(new b.$8F(u))}async $handleDrop(u,t,f,a,d,$,p,v){const y=this.a.get(u);if(!y)return Promise.reject(new b.$8F(u));const h=l.DataTransfer.toDataTransfer(f,async E=>(await this.f.$resolveDropFileData(u,t,E)).buffer);return p===u&&v&&await this.j(h,y,v,d,$),y.onDrop(h,a,d)}async j(u,t,f,a,d){const $=this.b.removeDragOperationTransfer(d);if($)(await $)?.forEach((p,v)=>{p&&u.set(v,p)});else if(d&&t.handleDrag){const p=t.handleDrag(f,u,a);this.b.addDragOperationTransfer(d,p),await p}return u}async $handleDrag(u,t,f,a){const d=this.a.get(u);if(!d)return Promise.reject(new b.$8F(u));const $=await this.j(new D.$eN,d,t,a,f);if(!(!$||a.isCancellationRequested))return l.DataTransfer.from($)}async $hasResolve(u){const t=this.a.get(u);if(!t)throw new b.$8F(u);return t.hasResolve}$resolve(u,t,f){const a=this.a.get(u);if(!a)throw new b.$8F(u);return a.resolveTreeItem(t,f)}$setExpanded(u,t,f){const a=this.a.get(u);if(!a)throw new b.$8F(u);a.setExpanded(t,f)}$setSelectionAndFocus(u,t,f){const a=this.a.get(u);if(!a)throw new b.$8F(u);a.setSelectionAndFocus(t,f)}$setVisible(u,t){const f=this.a.get(u);if(!f){if(!t)return;throw new b.$8F(u)}f.setVisible(t)}$changeCheckboxState(u,t){const f=this.a.get(u);if(!f)throw new b.$8F(u);f.setCheckboxState(t)}m(u,t,f){const a=this.B(new n(u,t,this.f,this.g.converter,this.h,f));return this.a.set(u,a),a}r(u){const t=this.a.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.$4nc=i;class n extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,N.$hg)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,t,f,a,d,$){if(super(),this.I=u,this.J=f,this.L=a,this.M=d,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$fe),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$fe),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$fe),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$fe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$fe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$fe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$fe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new g.$qe,$.contributes&&$.contributes.views)for(const h in $.contributes.views)for(const E of $.contributes.views[h])E.id===u&&(this.P=E.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>{Array.isArray(h)&&h.length===0||this.F.fire({message:!1,element:h})}));let p,v;const y=T.Event.debounce(this.F.event,(h,E)=>(h||(h={message:!1,elements:[]}),E.element!==!1&&(p||(p=new Promise(k=>v=k),this.G=this.G.then(()=>p)),Array.isArray(E.element)?h.elements.push(...E.element):h.elements.push(E.element)),E.message&&(h.message=!0),h),200,!0);this.B(y(({message:h,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const k=v;return p=null,this.$(E).then(()=>k())})),h&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let f=this.X(u);return f||(f=await this.Y(t)),f?f.map(a=>a.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const f=(0,N.$hg)(t.select)?!0:t.select,a=(0,N.$hg)(t.focus)?!1:t.focus,d=(0,N.$hg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then($=>this.W(u,$[$.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:$.map(v=>v.item)},{select:f,focus:a,expand:d})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:f,focus:a,expand:d})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=l.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,t){const f=this.getExtensionElement(u);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(u,t){const f=!(0,S.$ub)(this.s,u);this.s=u;const a=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async f=>{const a=this.getExtensionElement(f.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:f.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(u,t,f){const a=[];for(const d of u){const $=this.getExtensionElement(d);$&&a.push($)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,t,f){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,m.$qh)(()=>this.g?.handleDrop?this.g.handleDrop(a,u,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(u);if(f){const a=this.m.get(f);if(a){const d=await this.f.resolveTreeItem(a.extensionItem,f,t)??a.extensionItem;return this.hb(d),a.item.tooltip=this.eb(d.tooltip),a.item.command=this.fb(a.disposableStore,d.command),a.item}}}S(u){return this.U(u).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(a=>(f.push(a),f))):Promise.resolve([]))}U(u){const t=this.m.get(u);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,m.$qh)(()=>this.f.getParent(u))}W(u,t){const f=this.m.get(u);return f?Promise.resolve(f):(0,m.$qh)(()=>this.f.getTreeItem(u)).then(a=>this.kb(u,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const d=this.getExtensionElement(a);if(d){const $=this.m.get(d);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let t;if(typeof u=="string"){const f=this.getExtensionElement(u);t=f?this.m.get(f):void 0}else t=u;return t&&t.children||void 0}return this.h}async Y(u){this.rb(u);const t=new g.$qe(this.Z.token);try{const f=u?this.m.get(u):void 0,a=await this.f.getChildren(u);if(t.token.isCancellationRequested)return;const d=(0,S.$Hb)(a||[]),$=await Promise.all((0,S.$Hb)(d).map(v=>this.f.getTreeItem(v)));if(t.token.isCancellationRequested)return;const p=$.map((v,y)=>v?this.db(d[y],v,f):null);return(0,S.$Hb)(p)}finally{t.dispose()}}$(u){if(u.some(f=>!f))return this.Z.dispose(!0),this.Z=new g.$qe,this.tb(),this.J.$refresh(this.I);{const f=this.ab(u);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(u){const t=new Set,f=u.map(d=>this.m.get(d));for(const d of f)if(d&&!t.has(d.item.handle)){let $=d;for(;$&&$.parent&&f.findIndex(p=>$&&$.parent&&p&&p.item.handle===$.parent.item.handle)===-1;){const p=this.j.get($.parent.item.handle);$=p?this.m.get(p):void 0}$&&!$.parent&&t.add(d.item.handle)}const a=[];return t.forEach(d=>{const $=this.j.get(d);if($){const p=this.m.get($);p&&(!p.parent||!t.has(p.parent.item.handle))&&a.push(d)}}),a}bb(u){const t={};return Promise.all(u.map(f=>this.cb(f).then(a=>{a&&(t[f]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(u){const t=this.getExtensionElement(u);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,m.$qh)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const d=this.ib(t,a,f.parent);return this.pb(t,d,f,f.parent),f.dispose(),d}return null})}return Promise.resolve(null)}db(u,t,f){const a=this.ib(u,t,f);if(t.id&&this.j.has(a.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(u,a),this.qb(a,f),a}eb(u){return D.$NM.isMarkdownString(u)?l.MarkdownString.from(u):u}fb(u,t){return t?{...this.L.toInternal(t,u),originalId:t.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let t,f,a;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,f=u.checkboxState.tooltip,a=u.checkboxState.accessibilityInformation),{isChecked:t===D.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:a}}hb(u){if(!D.$_M.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,t,f){this.hb(t);const a=this.B(new A.$Tc),d=this.kb(u,t,f),$=this.lb(t);return{item:{handle:d,parentHandle:f?f.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:$,iconDark:this.mb(t)||$,themeIcon:this.jb(t),collapsibleState:(0,N.$hg)(t.collapsibleState)?D.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(u){return u.iconPath instanceof D.$iN?u.iconPath:void 0}kb(u,{id:t,label:f,resourceUri:a},d,$){if(t)return`${n.b}/${t}`;const p=o(f,this.N),v=d?d.item.handle:n.a;let y=p?p.label:a?(0,O.$9g)(a):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const h=this.m.has(u)?this.m.get(u).item.handle:void 0,E=this.X(d)||[];let k,I=0;do{if(k=`${v}/${I}:${y}`,$||!this.j.has(k)||h===k)break;I++}while(I<=E.length);return k}lb(u){if(u.iconPath&&!(u.iconPath instanceof D.$iN))return typeof u.iconPath=="string"||M.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof D.$iN)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return M.URI.isUri(u)?u:M.URI.file(u)}ob(u,t){this.j.set(t.item.handle,u),this.m.set(u,t)}pb(u,t,f,a){this.j.delete(t.item.handle),this.m.delete(u),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(u,t);const d=this.X(a)||[],$=d.filter(p=>p.item.handle===f.item.handle)[0];$&&d.splice(d.indexOf($),1,t)}qb(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const t=this.m.get(u);if(t){if(t.children)for(const f of t.children){const a=this.j.get(f.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(u){const t=this.m.get(u);if(t){if(t.children)for(const f of t.children){const a=this.j.get(f.item.handle);a&&this.sb(a)}this.m.delete(u),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[293],Ie([1,0,5,6,2,33,8,64,4,7]),function(le,e,C,O,M,T,A,b,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;class N extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(g,r,s,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new C.$fe),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$fe),this.onDidChangeViewState=this.#h.event,this.#e=g,this.#t=r,this.#n=s,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(g){this.c(),this.#r!==g&&(this.#r=g,this.#t.$setTitle(this.#e,g))}get iconPath(){return this.c(),this.#a}set iconPath(g){this.c(),this.#a!==g&&(this.#a=g,this.#t.$setIconPath(this.#e,M.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(g){this.#l||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(this.#u=g.active,this.#c=g.visible,this.#o=g.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(g,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof g>"u"?void 0:A.ViewColumn.from(g),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends O.$Uc{static c(){return(0,T.$Ug)()}constructor(g,r,s){super(),this.j=r,this.m=s,this.g=new Map,this.h=new Map,this.f=g.getProxy(m.$jM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(g=>g.dispose()),this.g.clear()}createWebviewPanel(g,r,s,o,i={}){const n=typeof o=="object"?o.viewColumn:o,c={viewColumn:A.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},u=(0,b.$vmc)(g),t=S.c();this.f.$createWebviewPanel((0,b.$xmc)(g),t,r,{title:s,panelOptions:l(i),webviewOptions:(0,b.$ymc)(g,this.m,i),serializeBuffersForPostMessage:u},c);const f=this.j.createNewWebview(t,i,g);return this.createNewWebviewPanel(t,r,s,n,i,f,!0)}$onDidChangeWebviewPanelViewStates(g){const r=Object.keys(g);r.sort((s,o)=>{const i=g[s],n=g[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const s of r){const o=this.getWebviewPanel(s);if(!o)continue;const i=g[s];o._updateViewState({active:i.active,visible:i.visible,viewColumn:A.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.g.delete(g),this.j.deleteWebview(g)}registerWebviewPanelSerializer(g,r,s){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:s,extension:g}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,b.$vmc)(g)}),new D.$lM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(g,r,s,o){const i=this.h.get(r);if(!i)throw new Error(`No serializer found for '${r}'`);const{serializer:n,extension:c}=i,u=this.j.createNewWebview(g,s.webviewOptions,c),t=this.createNewWebviewPanel(g,r,s.title,o,s.panelOptions,u,s.active);await n.deserializeWebviewPanel(t,s.state)}createNewWebviewPanel(g,r,s,o,i,n,c){const u=new N(g,this.f,n,{viewType:r,title:s,viewColumn:o,panelOptions:i,active:c});return this.g.set(g,u),u}getWebviewPanel(g){return this.g.get(g)}}e.$zmc=S;function l(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Se[294],Ie([1,0,5,6,64,8,4,7]),function(le,e,C,O,M,T,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=void 0;class m extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(S,l,w,g,r,s){super(),this.#s=!1,this.#u=this.B(new C.$fe),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new C.$fe),this.onDidDispose=this.#l.event,this.#i=w,this.#a=g,this.#e=S,this.#t=l,this.#n=r,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#o}set description(S){this.a(),this.#o!==S&&(this.#o=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(S){S===this.#r||this.#s||(this.#r=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=T.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#s)throw new Error("Webview is disposed")}}class D{constructor(S,l){this.d=l,this.b=new Map,this.c=new Map,this.a=S.getProxy(A.$jM.MainThreadWebviewViews)}registerWebviewViewProvider(S,l,w,g){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:w,extension:S}),this.a.$registerWebviewViewProvider((0,M.$xmc)(S),l,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$vmc)(S)}),new b.$lM(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(S,l,w,g,r){const s=this.b.get(l);if(!s)throw new Error(`No view provider found for '${l}'`);const{provider:o,extension:i}=s,n=this.d.createNewWebview(S,{},i),c=new m(S,this.a,l,w,n,!0);this.c.set(S,c),await o.resolveWebviewView(c,{state:g},r)}async $onDidChangeWebviewViewVisibility(S,l){this.e(S)._setVisible(l)}async $disposeWebviewView(S){const l=this.e(S);this.c.delete(S),l.dispose(),this.d.deleteWebview(S)}e(S){const l=this.c.get(S);if(!l)throw new Error("No webview found");return l}}e.$7nc=D}),define(Se[295],Ie([1,0,5,29,31,3]),function(le,e,C,O,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.$EL=e.OutputChannelUpdateMode=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=void 0,e.$rL="text/x-code-output",e.$sL="output",e.$tL="Log",e.$uL="text/x-code-log-output",e.$vL="log",e.$wL="workbench.panel.output",e.$xL=new M.$Pj("inOutput",!1),e.$yL=new M.$Pj("activeLogOutput",!1),e.$zL=new M.$Pj("activeLogOutput.levelSettable",!1),e.$AL=new M.$Pj("activeLogOutput.level",""),e.$BL=new M.$Pj("activeLogOutput.levelIsDefault",!1),e.$CL=new M.$Pj("outputView.scrollLock",!1),e.$DL=(0,T.$yi)("outputService");var A;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$EL={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new C.$fe,this.onDidRegisterChannel=this.b.event,this.c=new C.$fe,this.onDidRemoveChannel=this.c.event}registerChannel(D){this.a.has(D.id)||(this.a.set(D.id,D),this.b.fire(D.id))}getChannels(){const D=[];return this.a.forEach(N=>D.push(N)),D}getChannel(D){return this.a.get(D)}removeChannel(D){this.a.delete(D),this.c.fire(D)}}O.$fo.add(e.$EL.OutputChannels,new b),e.$FL=new M.$Pj("activeOutputChannel","")}),define(Se[118],Ie([1,0,4,3,17,21,12,295,65,27,46,147,22,15,38,5,6]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=e.$Fnc=void 0;class o extends A.$$j{get disposed(){return this.n}constructor(u,t,f,a,d){super(),this.id=u,this.name=t,this.r=f,this.s=a,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.m;this.info(u),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(u,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.s.$close(this.id)}g(u,t){this.m+=l.$He.fromString(t).byteLength,(0,A.log)(this.r,u,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(u){this.append(u)}}let n=class{constructor(u,t,f,a,d,$){this.i=t,this.j=f,this.k=a,this.l=d,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(C.$jM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,S.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(u,t,f){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,d=(0,w.$$f)(t)?t:void 0;if((0,w.$$f)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const p=this.i.environment.extensionLogLevel?.find(([y])=>T.$Tm.equals(f.identifier,y))?.[1];p&&($=(0,A.$jk)(p));const v=a?this.o(u,$,f):this.n(u,d,f);return v.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),a?this.r(u,$??this.m.getLevel(),v):this.q(u,v)}async n(u,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(u,d,t,f.identifier.value);return new o(p,u,$,this.a,f)}async o(u,t,f){const a=await this.p(f),d=u.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(a,`${d}.log`),p=`${f.identifier.value}.${d}`,v=this.l.createLogger($,{id:p,name:u,logLevel:t,extensionId:f.identifier.value});return new i(p,u,v,this.a,f)}p(u){let t=this.d.get(u.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(a){if((0,g.$il)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}return f})())}return t}q(u,t){let f=!1;const a=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return u},append(d){a(),t.then($=>$.append(d))},appendLine(d){a(),t.then($=>$.appendLine(d))},clear(){a(),t.then(d=>d.clear())},replace(d){a(),t.then($=>$.replace(d))},show(d,$){a(),t.then(p=>p.show(d,$))},hide(){a(),t.then(d=>d.hide())},dispose(){f=!0,t.then(d=>d.dispose())}}}r(u,t,f){const a=new s.$Tc,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},$=a.add(new r.$fe);function p(v){t=v,$.fire(v)}return f.then(v=>{a.add(v),v.logLevel!==t&&p(v.logLevel),a.add(v.onDidChangeLogLevel(y=>p(y)))}),{...this.q(u,f),get logLevel(){return t},onDidChangeLogLevel:$.event,trace(v,...y){d(),f.then(h=>h.trace(v,...y))},debug(v,...y){d(),f.then(h=>h.debug(v,...y))},info(v,...y){d(),f.then(h=>h.info(v,...y))},warn(v,...y){d(),f.then(h=>h.warn(v,...y))},error(v,...y){d(),f.then(h=>h.error(v,...y))},dispose(){a.dispose()}}}};e.$Fnc=n,e.$Fnc=n=Je([We(0,M.$NO),We(1,D.$4O),We(2,m.$rmc),We(3,N.$7lc),We(4,A.$6j),We(5,A.$5j)],n),e.$Gnc=(0,O.$yi)("IExtHostOutputService")}),define(Se[119],Ie([1,0,3,11]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$in=(0,C.$yi)("remoteAgentService"),e.$jn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let T=1/0;for(let b=0;b<this.maxSampleCount;b++){const m=await M.getRoundTripTime();if(m===void 0)return;T=Math.min(T,m/2),await(0,O.$zh)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(T):A=this.initial.reduce((b,m)=>b+m,0)/this.initial.length,this.lastMeasurement={initial:A,current:T,average:this.average.reduce((b,m)=>b+m,0)/this.average.length,high:typeof A>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[296],Ie([1,0,184,51,29,45,50,6,5,119,23,26,11]),function(le,e,C,O,M,T,A,b,m,D,N,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgb=e.$Rgb=e.$Qgb=e.$Pgb=e.$Ogb=e.$Ngb=e.$Mgb=void 0,e.$Mgb=Object.freeze({id:"application",order:100,title:(0,C.localize)(0,null),type:"object"}),e.$Ngb=Object.freeze({id:"workbench",order:7,title:(0,C.localize)(1,null),type:"object"}),e.$Ogb=Object.freeze({id:"security",scope:1,title:(0,C.localize)(2,null),type:"object",order:7}),e.$Pgb=Object.freeze({id:"problems",title:(0,C.localize)(3,null),type:"object",order:101}),e.$Qgb={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new m.$fe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const g=new w;M.$fo.add(e.$Qgb.ConfigurationMigration,g);let r=class extends b.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const u of c.added)await this.f(u,g.migrations)})),this.c(g.migrations),this.B(g.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(c=>this.g(c,i?.uri))])}async g(i,n){const c=this.a.inspect(i.key,{resource:n}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of u){const a=c[t];if(!a)continue;const d=[];if(a.value!==void 0){const $=await this.h(i,t,a.value,n,void 0);for(const p of $??[])d.push([p,[]])}for(const{identifiers:$,value:p}of a.overrides??[])if(p!==void 0){const v=await this.h(i,t,p,n,$);for(const y of v??[])d.push([y,$])}d.length&&await Promise.allSettled(d.map(async([[$,p],v])=>this.a.updateValue($,p.value,{resource:n,overrideIdentifiers:v},f)))}}async h(i,n,c,u,t){const f=d=>{const p=this.a.inspect(d,{resource:u})[n];if(p)return t?p.overrides?.find(({identifiers:v})=>(0,S.$9n)(v,t))?.value:p.value},a=await i.migrateFn(c,f);return Array.isArray(a)?a:[[i.key,a]]}};e.$Rgb=r,e.$Rgb=r=Je([We(0,A.$5i),We(1,T.$Hi)],r);let s=class extends b.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new l.$Vh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!N.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$fo.as(O.$ko.Configuration).registerConfiguration({...e.$Ogb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,C.localize)(4,null)},default:[],markdownDescription:(0,C.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,C.localize)(6,null),scope:2}}})}};e.$Sgb=s,e.$Sgb=s=Je([We(0,D.$in)],s)}),define(Se[297],Ie([1,0,37,16,19,24,193,296,51,3,29]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Ugb=e.$Tgb=void 0,e.$Vgb=r,e.$Wgb=s,e.$Tgb=(0,D.$yi)("editorResolverService"),e.$Ugb="workbench.editorAssociations";const S=N.$fo.as(m.$ko.Configuration),l={...b.$Ngb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var w;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(w||(e.RegisteredEditorPriority=w={}));var g;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(g||(e.ResolvedStatus=g={}));function r(o){switch(o){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function s(o,i){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(i.scheme))return!1;const u=typeof o=="string"&&o.indexOf(M.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,T.$9g)(i);return C.$rk(typeof o=="string"?o.toLowerCase():o,u.toLowerCase())}}),define(Se[298],Ie([1,0,48,16,19,23,24,2,3,214,45,236,119]),function(le,e,C,O,M,T,A,b,m,D,N,S,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=e.$XL=void 0,e.$XL=(0,m.$yi)("pathService");let g=w=class{constructor(s,o,i,n){this.d=s,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??s})()}hasValidBasename(s,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(s,n,o)):this.h(s,o,i)}h(s,o,i){return s.scheme===O.Schemas.file||s.scheme===O.Schemas.vscodeRemote?(0,C.$vg)(i??(0,A.$9g)(s),o===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,o){if(s.remoteAuthority)return O.Schemas.vscodeRemote;const i=(0,D.$UL)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const c=o.getWorkspace().configuration;return c?c.scheme:O.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?M.$fc:M.$gc)}async fileURI(s){let o="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const n=s.indexOf("/",2);n===-1?(o=s.substring(2),s="/"):(o=s.substring(2,n),s=s.substring(n)||"/")}return b.URI.from({scheme:O.Schemas.file,authority:o,path:s,query:"",fragment:""})}};e.$YL=g,e.$YL=g=w=Je([We(1,l.$in),We(2,S.$GL),We(3,N.$Hi)],g)}),define(Se[120],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$qK=e.$pK=void 0;class C{constructor(A,b){this.line=A,this.character=b}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,b){return new C(0,0)}with(A){return new C(0,0)}}e.$pK=C;class O{constructor(A,b,m,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(A,b),this.end=new C(m,D)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new O(0,0,0,0)}with(A){return new O(0,0,0,0)}}e.$qK=O;var M;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(Se[47],Ie([1,0,18,37,26,48,13,3,19,14,120,11]),function(le,e,C,O,M,T,A,b,m,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$NK=e.$GK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$DK=e.$CK=e.$BK=e.$AK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.TextSearchCompleteMessageType=void 0,e.$xK=o,e.$yK=i,e.$zK=n,e.$EK=v,e.$FK=y,e.$HK=k,e.$IK=I,e.$JK=P,e.$KK=V,e.$LK=W,e.$MK=q,e.$OK=z,e.$QK=de,e.$RK=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.$rK="workbench.view.search",e.$sK="workbench.panel.search",e.$tK="workbench.view.search",e.$uK="search-result",e.$vK="search.exclude";const l="\u27EA ",w=" characters skipped \u27EB",g=(l.length+w.length+5)*2;e.$wK=(0,b.$yi)("searchService");var r;(function(ge){ge[ge.file=0]="file",ge[ge.text=1]="text",ge[ge.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var s;(function(ge){ge[ge.File=1]="File",ge[ge.Text=2]="Text",ge[ge.aiText=3]="aiText"})(s||(e.QueryType=s={}));function o(ge){return!!ge.preview}function i(ge){return!!ge.resource}function n(ge){return!!ge.message}var c;(function(ge){ge[ge.Normal=0]="Normal",ge[ge.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class u{constructor(ue){this.resource=ue,this.results=[]}}e.$AK=u;class t{constructor(ue,Ce,se,Oe){this.ranges=Ce,this.webviewIndex=Oe;const ne=Array.isArray(Ce)?Ce:[Ce];if(se&&se.matchLines===1&&f(ne)){ue=(0,A.$4f)(ue,se.matchLines);let j="",x=0,ve=0;const Le=Math.floor(se.charsPerLine/5),ke=[];for(const be of ne){const me=Math.max(be.startColumn-Le,0),Q=be.startColumn+se.charsPerLine;if(me>ve+Le+g){const Y=l+(me-ve)+w;j+=Y+ue.slice(me,Q),x+=me-(ve+Y.length)}else j+=ue.slice(ve,Q);ke.push(new d(0,be.startColumn-x,be.endColumn-x)),ve=Q}this.preview={text:j,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const j=Array.isArray(Ce)?Ce[0].startLineNumber:Ce.startLineNumber;this.preview={text:ue,matches:(0,C.$1b)(Ce,x=>new a(x.startLineNumber-j,x.startColumn,x.endLineNumber-j,x.endColumn))}}}}e.$BK=t;function f(ge){const ue=ge[0].startLineNumber;for(const Ce of ge)if(Ce.startLineNumber!==ue||Ce.endLineNumber!==ue)return!1;return!0}class a{constructor(ue,Ce,se,Oe){this.startLineNumber=ue,this.startColumn=Ce,this.endLineNumber=se,this.endColumn=Oe}}e.$CK=a;class d extends a{constructor(ue,Ce,se){super(ue,Ce,ue,se)}}e.$DK=d;var $;(function(ge){ge.List="list",ge.Tree="tree"})($||(e.ViewMode=$={}));var p;(function(ge){ge.Default="default",ge.FileNames="fileNames",ge.Type="type",ge.Modified="modified",ge.CountDescending="countDescending",ge.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function v(ge,ue=!0){const Ce=ge&&ge.files&&ge.files.exclude,se=ue&&ge&&ge.search&&ge.search.exclude;if(!Ce&&!se)return;if(!Ce||!se)return Ce||se;let Oe=Object.create(null);return Oe=M.$8n(Oe,M.$5n(Ce)),Oe=M.$8n(Oe,M.$5n(se),!0),Oe}function y(ge,ue){return ge.excludePattern&&O.$rk(ge.excludePattern,ue)?!1:ge.includePattern||ge.usingSearchPaths?ge.includePattern&&O.$rk(ge.includePattern,ue)?!0:ge.usingSearchPaths?!!ge.folderQueries&&ge.folderQueries.some(Ce=>{const se=Ce.folder.fsPath;if(T.$xg(ue,se)){const Oe=m.$lc(se,ue);return!Ce.includePattern||!!O.$rk(Ce.includePattern,Oe)}else return!1}):!1:!0}var h;(function(ge){ge[ge.unknownEncoding=1]="unknownEncoding",ge[ge.regexParseError=2]="regexParseError",ge[ge.globParseError=3]="globParseError",ge[ge.invalidLiteral=4]="invalidLiteral",ge[ge.rgProcessError=5]="rgProcessError",ge[ge.other=6]="other",ge[ge.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class E extends Error{constructor(ue,Ce){super(ue),this.code=Ce}}e.$GK=E;function k(ge){const ue=ge.message;if((0,D.$4)(ge))return new E(ue,h.canceled);try{const Ce=JSON.parse(ue);return new E(Ce.message,Ce.code)}catch{return new E(ue,h.other)}}function I(ge){const ue={message:ge.message,code:ge.code};return new Error(JSON.stringify(ue))}function P(ge){return ge.type==="error"?!0:ge.type==="success"}function V(ge){return ge.type==="success"}function W(ge){return!!ge.path}function q(ge,ue,Ce=!0){const se=ge.searchPath?ge.searchPath:ge.relativePath;return Ce?(0,A.$1f)(se,ue):O.$rk(ue,se)}class R{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$NK=R;function z(ge,ue){const Ce={...ge||{},...ue||{}};return Object.keys(Ce).filter(se=>{const Oe=Ce[se];return typeof Oe=="boolean"&&Oe})}class G{constructor(ue,Ce){this.c=null,this.a={...ue.excludePattern||{},...Ce.excludePattern||{}},this.b=O.$sk(this.a);let se=ue.includePattern;Ce.includePattern&&(se?se={...se,...Ce.includePattern}:se=Ce.includePattern),se&&(this.c=O.$sk(se))}matchesExcludesSync(ue,Ce,se){return!!(this.b&&this.b(ue,Ce,se))}includedInQuerySync(ue,Ce,se){return!(this.b&&this.b(ue,Ce,se)||this.c&&!this.c(ue,Ce,se))}includedInQuery(ue,Ce,se){const Oe=this.b(ue,Ce,se),ne=()=>this.c?!!this.c(ue,Ce,se):!0;return(0,S.$kh)(Oe)?Oe.then(j=>j?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$PK=G;function ie(ge){for(const ue in ge)if(typeof ge[ue]!="boolean")return!0;return!1}function de(ge){if(!ge)return;let ue;return Ce=>(ue||(ue=(ge()||Promise.resolve([])).then(se=>se?De(se):{})),ue.then(se=>!!se[Ce]))}function ye(ge){if(!ge)return;let ue;return Ce=>{if(!ue){const se=ge();ue=se?De(se):{}}return!!ue[Ce]}}function De(ge){const ue={};for(const Ce of ge)ue[Ce]=!0;return ue}}),define(Se[39],Ie([1,0,18,11,20,5,6,54,16,129,24,13,2,183,3,12,202,45,46,27,17,8,7,61,47,4,49]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c,u,t,f,a,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=e.$lmc=void 0;function p(V,W,q){return new N.$1g(R=>E(R,q)).isEqual(V,W)}function v(V,W,q){return p(V.uri,W.uri,q)?0:(0,S.$sf)(V.uri.toString(),W.uri.toString())}function y(V,W,q){return V.index!==W.index?V.index<W.index?-1:1:p(V.uri,W.uri,q)?(0,S.$sf)(V.name,W.name):(0,S.$sf)(V.uri.toString(),W.uri.toString())}function h(V,W,q,R){const z=V.slice(0).sort((ie,de)=>q(ie,de,R)),G=W.slice(0).sort((ie,de)=>q(ie,de,R));return(0,C.$Eb)(z,G,(ie,de)=>q(ie,de,R))}function E(V,W){const q=W.getCapabilities(V.scheme);return!(q&&q&1024)}class k extends o.$Ri{static toExtHostWorkspace(W,q,R,z){if(!W)return{workspace:null,added:[],removed:[]};const{id:G,name:ie,folders:de,configuration:ye,transient:De,isUntitled:ge}=W,ue=[],Ce=q;q?de.forEach((j,x)=>{const ve=l.URI.revive(j.uri),Le=k.o(R||q,ve,z);Le?(Le.name=j.name,Le.index=j.index,ue.push(Le)):ue.push({uri:ve,name:j.name,index:x})}):ue.push(...de.map(({uri:j,name:x,index:ve})=>({uri:l.URI.revive(j),name:x,index:ve}))),ue.sort((j,x)=>j.index<x.index?-1:1);const se=new k(G,ie,ue,!!De,ye?l.URI.revive(ye):null,!!ge,j=>E(j,z)),{added:Oe,removed:ne}=h(Ce?Ce.workspaceFolders:[],se.workspaceFolders,v,z);return{workspace:se,added:Oe,removed:ne}}static o(W,q,R){for(let z=0;z<W.folders.length;z++){const G=W.workspaceFolders[z];if(p(G.uri,q,R))return G}}constructor(W,q,R,z,G,ie,de){super(W,R.map(ye=>new o.$Si(ye)),z,G,de),this.t=q,this.u=ie,this.q=[],this.s=b.$Ei.forUris(de),R.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,q){return q&&this.s.get(W)&&(W=(0,N.$$g)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let I=class{constructor(W,q,R,z,G){this.c=new T.$fe,this.onDidChangeWorkspace=this.c.event,this.g=new T.$fe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new T.$he,this.C=new Map,this.h=z,this.s=R,this.t=G,this.j=new D.$Fm,this.k=new O.$xh,this.o=W.getProxy(d.$jM.MainThreadWorkspace),this.q=W.getProxy(d.$jM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new k(ie.id,ie.name,[],!!ie.transient,ie.configuration?l.URI.revive(ie.configuration):null,!!ie.isUntitled,de=>E(de,R)):void 0}$initializeWorkspace(W,q){this.v=q,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:m.Schemas.untitled,path:(0,N.$9g)((0,N.$$g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,q,R,...z){const G=[];if(Array.isArray(z)&&z.forEach(ge=>{l.URI.isUri(ge.uri)&&!G.some(ue=>p(ue.uri,ge.uri,this.s))&&G.push({uri:ge.uri,name:ge.name||(0,N.$8g)(ge.uri)})}),this.n||[q,R].some(ge=>typeof ge!="number"||ge<0)||R===0&&G.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+R>ie.length)return!1;const de=ie.slice(0);de.splice(q,R,...G.map(ge=>({uri:ge.uri,name:ge.name||(0,N.$8g)(ge.uri),index:void 0})));for(let ge=0;ge<de.length;ge++){const ue=de[ge];if(de.some((Ce,se)=>se!==ge&&p(ue.uri,Ce.uri,this.s)))return!1}de.forEach((ge,ue)=>ge.index=ue);const{added:ye,removed:De}=h(ie,de,y,this.s);if(ye.length===0&&De.length===0)return!1;if(this.o){const ge=W.displayName||W.name;this.o.$updateWorkspaceFolders(ge,q,R,G).then(void 0,ue=>{this.n=void 0;const Ce={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(s.Severity.Error,(0,w.localize)(0,null,ge,ue.toString()),Ce,[])})}return this.y(de),!0}getWorkspaceFolder(W,q){if(this.x)return this.x.getWorkspaceFolder(W,q)}async getWorkspaceFolder2(W,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,q)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,q){let R,z="";if(typeof W=="string"?(R=l.URI.file(W),z=W):typeof W<"u"&&(R=W,z=W.fsPath),!R)return z;const G=this.getWorkspaceFolder(R,!0);if(!G)return z;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,N.$bh)(G.uri,R);return q&&G.name&&(ie=`${G.name}/${ie}`),ie}y(W){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:q,added:R,removed:z}=k.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:z}))}findFiles(W,q,R,z,G=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let ie="",de=!0;return q===null?de=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(W,void 0,{exclude:ie,maxResults:R,useDefaultExcludes:de,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},G)}findFiles2(W,q={},R,z=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${R.value}, entryPoint: findFiles2`),this.z(void 0,W,q,z)}async z(W,q,R,z=M.CancellationToken.None){if(z&&z.isCancellationRequested)return Promise.resolve([]);const G=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,ie={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof R.useDefaultSearchExcludes=="boolean"?!R.useDefaultSearchExcludes:!1,maxResults:R.maxResults,excludePattern:G,shouldGlobSearch:typeof R.fuzzy=="boolean"?!R.fuzzy:!0,_reason:"startFileSearch"};let de;if(W){const{includePattern:ye,folder:De}=P(u.GlobPattern.from(W));de=De,ie.includePattern=ye}else{const{includePattern:ye,folder:De}=P(u.GlobPattern.from(q));de=De,ie.filePattern=ye}return this.o.$startFileSearch(de??null,ie,z).then(ye=>Array.isArray(ye)?ye.map(De=>l.URI.revive(De)):[])}async findTextInFiles(W,q,R,z,G=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),de=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ye,folder:De}=P(u.GlobPattern.from(q.include)),ge=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,ue={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:de,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ye,excludePattern:ge},Ce=!1;if(this.u[ie]=se=>{if(Ce)return;const Oe=l.URI.revive(se.resource);se.results.forEach(ne=>{const j=(0,$.$8h)(ne);(0,a.$xK)(j)?R({uri:Oe,preview:{text:j.preview.text,matches:(0,C.$1b)(j.preview.matches,x=>new t.$nM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,C.$1b)(j.ranges,x=>new t.$nM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):R({uri:Oe,text:j.text,lineNumber:j.lineNumber})})},G.isCancellationRequested)return{};try{const se=await this.o.$startTextSearch(W,De??null,ue,ie,G);return delete this.u[ie],se||{}}catch(se){throw delete this.u[ie],se}}$handleTextSearchResult(W,q){this.u[q]?.(W)}async save(W){const q=await this.o.$save(W,{saveAs:!1});return l.URI.revive(q)}async saveAs(W){const q=await this.o.$save(W,{saveAs:!0});return l.URI.revive(q)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,q){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,q);const R=this.t.transformOutgoingScheme(W),z=this.A++;return this.o.$registerEditSessionIdentityProvider(z,R),(0,A.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(W,q){this.h.info("Getting edit session identifier for workspaceFolder",W);const R=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const z=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!z),!z)return;const G=await z.provideEditSessionIdentity(R,q);if(this.h.info("Provider returned edit session identifier: ",G),!!G)return G}async $provideEditSessionIdentityMatch(W,q,R,z){this.h.info("Getting edit session identifier for workspaceFolder",W);const G=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!G){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",G);const ie=this.w.get(G.uri.scheme);if(this.h.info(`Provider for scheme ${G.uri.scheme} is defined: `,!!ie),!ie)return;const de=await ie.provideEditSessionIdentityMatch?.(q,R,z);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(W){return(q,R,z)=>{const G=function(de){q.call(R,de)};return G.extension=W,this.B.event(G,void 0,z)}}async $onWillCreateEditSessionIdentity(W,q,R){const z=await this.resolveWorkspaceFolder(l.URI.revive(W));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:z},q,async(G,ie)=>{const de=Date.now();await Promise.resolve(G),Date.now()-de>R&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(W,q){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,q);const R=this.t.transformOutgoingScheme(W),z=this.A++;return this.o.$registerCanonicalUriProvider(z,R),(0,A.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(W,q,R){const z=this.C.get(W.scheme);if(!z)return;const G=await z.provideCanonicalUri?.(l.URI.revive(W),q,R);if(G)return G}async $provideCanonicalUri(W,q,R){return this.provideCanonicalUri(l.URI.revive(W),{targetScheme:q},R)}};e.$lmc=I,e.$lmc=I=Je([We(0,c.$NO),We(1,n.$4O),We(2,i.$7lc),We(3,r.$5j),We(4,f.$jmc)],I),e.$mmc=(0,g.$yi)("IExtHostWorkspace");function P(V){let W,q;return V&&(typeof V=="string"?W=V:(W=V.pattern,q=l.URI.revive(V.baseUri))),{includePattern:W,folder:q}}}),define(Se[40],Ie([1,0,26,5,39,4,7,203,51,15,11,3,17,12,2]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=e.$omc=e.$nmc=void 0;function r(f,a){if(a){const d=a.split(".");let $=f;for(let p=0;$&&p<d.length;p++)$=$[d[p]];return $}}function s(f){return f instanceof g.URI}function o(f){return f&&f.uri instanceof g.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&f.uri instanceof g.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function c(f){if(s(f))return{resource:f};if(o(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(n(f))return{resource:f.uri};if(f===null)return{resource:null}}let u=class{constructor(a,d,$){this.a=a.getProxy(T.$jM.MainThreadConfiguration),this.c=d,this.b=$,this.d=new N.$xh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then($=>$.$acceptConfigurationChanged(a,d))}};e.$nmc=u,e.$nmc=u=Je([We(0,l.$NO),We(1,M.$mmc),We(2,w.$5j)],u);class t{constructor(a,d,$,p){this.a=new O.$fe,this.b=a,this.f=p,this.c=d,this.e=b.$Do.parse($,p),this.d=this.k($.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const $={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Do.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,$))}getConfiguration(a,d,$){const p=c(d)||{},v=this.g(a?r(this.e.getValue(void 0,p,this.c.workspace),a):this.e.getValue(void 0,p,this.c.workspace));a&&this.h(a,p,$?.identifier);function y(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(E){return typeof r(v,E)<"u"},get:(E,k)=>{this.h(a?`${a}.${E}`:E,p,$?.identifier);let I=r(v,E);if(typeof I>"u")I=k;else{let P;const V=(W,q)=>{if((0,D.$ag)(W)){let R;const z=()=>{P=P||(0,C.$5n)(v),R=R||r(P,q)};return new Proxy(W,{get:(G,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return z(),()=>R;if(P)return R=R||r(P,q),R[ie];const de=G[ie];return typeof ie=="string"?V(de,`${q}.${ie}`):de},set:(G,ie,de)=>(z(),R&&(R[ie]=de),!0),deleteProperty:(G,ie)=>(z(),R&&delete R[ie],!0),defineProperty:(G,ie,de)=>(z(),R&&Object.defineProperty(R,ie,de),!0)})}return Array.isArray(W)?(0,C.$5n)(W):W};I=V(I,E)}return I},update:(E,k,I,P)=>{E=a?`${a}.${E}`:E;const V=y(I);return k!==void 0?this.b.$updateConfigurationOption(V,E,k,p,P):this.b.$removeConfigurationOption(V,E,p,P)},inspect:E=>{E=a?`${a}.${E}`:E;const k=this.e.inspect(E,p,this.c.workspace);if(k)return{key:E,defaultValue:(0,C.$5n)(k.policy?.value??k.default?.value),globalValue:(0,C.$5n)(k.user?.value??k.application?.value),workspaceValue:(0,C.$5n)(k.workspace?.value),workspaceFolderValue:(0,C.$5n)(k.workspaceFolder?.value),defaultLanguageValue:(0,C.$5n)(k.default?.override),globalLanguageValue:(0,C.$5n)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,C.$5n)(k.workspace?.override),workspaceFolderLanguageValue:(0,C.$5n)(k.workspaceFolder?.override),languageIds:(0,C.$5n)(k.overrideIdentifiers)}}};return typeof v=="object"&&(0,C.$8n)(h,v,!1),Object.freeze(h)}g(a){const d=$=>(0,D.$ag)($)?new Proxy($,{get:(p,v)=>d(p[v]),set:(p,v,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(p,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(p,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):$;return d(a)}h(a,d,$){const p=m.$uo.test(a)?4:this.d.get(a),v=$?`[${$.value}] `:"";if(p===4){typeof d?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){d?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const $=new b.$Fo(a,d,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(p,v)=>$.affectsConfiguration(p,c(v))})}k(a){return a.reduce((d,$)=>(d.set($[0],$[1]),d),new Map)}}e.$omc=t,e.$pmc=(0,S.$yi)("IExtHostConfiguration")}),define(Se[121],Ie([1,0,2,11,5,4,7,39,68,40,20,53,17,27,3,16,23,12,80,241,14]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnc=e.$Snc=e.$Rnc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(u||(u={}));var t;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(t||(t={}));var f;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(f||(f={}));var a;(function(V){function W(z){if(z){const G=z;return G&&!!G.process}else return!1}V.is=W;function q(z){if(z==null)return;const G={process:z.process,args:z.args};return z.options&&(G.options=f.from(z.options)),G}V.from=q;function R(z){if(z!=null)return new A.$8M(z.process,z.args,z.options)}V.to=R})(a||(a={}));var d;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(d||(d={}));var $;(function(V){function W(z){if(z){const G=z;return G&&(!!G.commandLine||!!G.command)}else return!1}V.is=W;function q(z){if(z==null)return;const G={};return z.commandLine!==void 0?G.commandLine=z.commandLine:(G.command=z.command,G.args=z.args),z.options&&(G.options=d.from(z.options)),G}V.from=q;function R(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$9M(z.commandLine,z.options):new A.$9M(z.command,z.args?z.args:[],z.options)}V.to=R})($||($={}));var p;(function(V){function W(z){if(z){const G=z;return G&&G.customExecution==="customExecution"}else return!1}V.is=W;function q(z){return{customExecution:"customExecution"}}V.from=q;function R(z,G){return G.get(z)}V.to=R})(p||(e.CustomExecutionDTO=p={}));var v;(function(V){function W(q,R){let z;return q.scope!==void 0&&typeof q.scope!="number"?z=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&R&&R.workspaceFile?z=R.workspaceFile:z=n.$jI),{id:q._id,workspaceFolder:z}}V.from=W})(v||(e.TaskHandleDTO=v={}));var y;(function(V){function W(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}V.from=W})(y||(y={}));var h;(function(V){function W(z,G){if(z==null)return[];const ie=[];for(const de of z){const ye=q(de,G);ye&&ie.push(ye)}return ie}V.fromMany=W;function q(z,G){if(z==null)return;let ie;z.execution instanceof A.$8M?ie=a.from(z.execution):z.execution instanceof A.$9M?ie=$.from(z.execution):z.execution&&z.execution instanceof A.$0M&&(ie=p.from(z.execution));const de=u.from(z.definition);let ye;return z.scope?typeof z.scope=="number"?ye=z.scope:ye=z.scope.uri:ye=A.TaskScope.Workspace,!de||!ye?void 0:{_id:z._id,definition:de,name:z.name,source:{extensionId:G.identifier.value,label:z.source,scope:ye},execution:ie,isBackground:z.isBackground,group:y.from(z.group),presentationOptions:t.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}V.from=q;async function R(z,G,ie){if(z==null)return;let de;a.is(z.execution)?de=a.to(z.execution):$.is(z.execution)?de=$.to(z.execution):p.is(z.execution)&&(de=p.to(z._id,ie));const ye=u.to(z.definition);let De;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?De=z.source.scope:De=await G.resolveWorkspaceFolder(C.URI.revive(z.source.scope)):De=A.TaskScope.Workspace),!ye||!De)return;const ge=new A.$$M(ye,De,z.name,z.source.label,de,z.problemMatchers);return z.isBackground!==void 0&&(ge.isBackground=z.isBackground),z.group!==void 0&&(ge.group=A.$7M.from(z.group._id),ge.group&&z.group.isDefault&&(ge.group=new A.$7M(ge.group.id,ge.group.label),z.group.isDefault===!0&&(ge.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ge.presentationOptions=t.to(z.presentationOptions)),z._id&&(ge._id=z._id),z.detail&&(ge.detail=z.detail),ge}V.to=R})(h||(e.TaskDTO=h={}));var E;(function(V){function W(R){return R}V.from=W;function q(R){if(R)return Object.assign(Object.create(null),R)}V.to=q})(E||(E={}));class k{#e;constructor(W,q,R){this._id=q,this.a=R,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let I=class{constructor(W,q,R,z,G,ie,de,ye){this.q=new M.$fe,this.r=new M.$fe,this.s=new M.$fe,this.u=new M.$fe,this.a=W.getProxy(T.$jM.MainThreadTask),this.b=R,this.c=z,this.d=G,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,q,R){if(!R)return new A.$lM(()=>{});const z=this.x();return this.j.set(z,{type:q,provider:R,extension:W}),this.a.$registerTaskProvider(z,q),new A.$lM(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(W,q){this.a.$registerTaskSystem(W,q)}fetchTasks(W){return this.a.$fetchTasks(E.from(W)).then(async q=>{const R=[];for(const z of q){const G=await h.to(z,this.b,this.m);G&&R.push(G)}return R})}get taskExecutions(){const W=[];return this.k.forEach(q=>W.push(q)),W}terminateTask(W){if(!(W instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,q,R){const z=this.m.get(W.id);z&&(this.o.set(W.id,z),this.e.attachPtyToTerminal(q,await z.callback(R))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const q=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const q=await this.z(W.id);this.s.fire({execution:q,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const q=await this.z(W.id);this.u.fire({execution:q,exitCode:W.exitCode})}$provideTasks(W,q){const R=this.j.get(W);if(!R)return Promise.reject(new Error("no handler found"));const z=[],G=(0,O.$qh)(()=>R.provider.provideTasks(N.CancellationToken.None)).then(ie=>this.v(q,z,R,ie));return new Promise(ie=>{G.then(de=>{Promise.all(z).then(()=>{ie(de)})})})}async $resolveTask(W,q){const R=this.j.get(W);if(!R)return Promise.reject(new Error("no handler found"));if(q.definition.type!==R.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${R.type}].`);const z=await h.to(q,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const G=await R.provider.resolveTask(z,N.CancellationToken.None);if(!G)return;this.A(G,R);const ie=h.from(G,R.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(ie.execution)&&await this.y(ie,G,!0),await this.w(ie)}x(){return this.h++}async y(W,q,R){const z=await this.a.$createTaskId(W);!R&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,q.execution)),this.m.set(z,q.execution)}async z(W,q){if(typeof W=="string"){const G=this.l.get(W);if(!G)throw new c.$bb("Unexpected: The specified task is missing an execution");return G}const R=this.l.get(W.id);if(R)return R;let z;return q?z=Promise.resolve(new k(this,W.id,q)):z=h.to(W.task,this.b,this.m).then(G=>{if(!G)throw new c.$bb("Unexpected: Task does not exist.");return new k(this,W.id,G)}),this.l.set(W.id,z),z.then(G=>(this.k.set(W.id,G),G))}A(W,q){W._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const R=this.n.values();let z=R.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=R.next()}};e.$Rnc=I,e.$Rnc=I=Je([We(0,l.$NO),We(1,w.$4O),We(2,b.$mmc),We(3,m.$YO),We(4,D.$pmc),We(5,S.$Nmc),We(6,o.$5j),We(7,i.$3lc)],I);let P=class extends I{constructor(W,q,R,z,G,ie,de,ye){super(W,q,R,z,G,ie,de,ye),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:s.$h(0)})}async executeTask(W,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const R=h.from(q,W);if(R===void 0)throw new Error("Task is not valid");if(p.is(R.execution))await this.y(R,q,!1);else throw new c.$_;const z=await this.z(await this.a.$getTaskExecution(R),q);return this.a.$executeTask(R).catch(G=>{throw new Error(G)}),z}v(W,q,R,z){const G=[];if(z)for(const ie of z){if(this.A(ie,R),!ie.definition||!W[ie.definition.type]){const ye=ie.source?ie.source:"No task source";this.f.warn(`The task [${ye}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const de=h.from(ie,R.extension);de&&p.is(de.execution)?(G.push(de),q.push(this.y(de,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:G,extension:R.extension}}async w(W){if(p.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,q,R){}};e.$Snc=P,e.$Snc=P=Je([We(0,l.$NO),We(1,w.$4O),We(2,b.$mmc),We(3,m.$YO),We(4,D.$pmc),We(5,S.$Nmc),We(6,o.$5j),We(7,i.$3lc)],P),e.$Tnc=(0,g.$yi)("IExtHostTask")}),define(Se[299],Ie([1,0,47,30]),function(le,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=void 0,e.$XK=M,e.$ZK=T;function M(A){return"cellResults"in A}e.$YK="rawCell#";function T(A,b){let m=-1;const D=[];let N=[];return A.forEach(l=>{l.range.startLineNumber!==m&&N.length>0&&(D.push([...N]),N=[]),N.push(l),m=l.range.endLineNumber}),N.length>0&&D.push([...N]),D.map(l=>{const w=[],g=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let s=g;s<=r;s++)w.push(b.getLineContent(s));return new C.$BK(w.join(`
`)+`
`,l.map(s=>new O.$yt(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(Se[300],Ie([1,0,177,22,5,6,28,13,15,2,38,76,4,35,8,7,34,276,114,26,16,231,299,297]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map($=>$.apiEditor)}constructor($,p,v,y,h,E){this.q=v,this.r=y,this.s=h,this.t=E,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new M.$fe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$fe,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$fe,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$fe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$1lc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=$.getProxy(l.$jM.MainThreadNotebook),this.c=$.getProxy(l.$jM.MainThreadNotebookDocuments),this.d=$.getProxy(l.$jM.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const I=k.notebookEditor?.notebookUri,P=k.cell.handle,W=this.g.get(I)?.getCell(P);if(W)return W.apiCell}if(k&&k.$mid===14){const I=k.uri,P=this.g.get(I);if(P)return P.apiNotebook}return k}}),a.B(p)}getEditorById($){const p=this.h.get($);if(!p)throw new Error(`unknown text editor: ${$}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor($){for(const[p,v]of this.h)if(v.apiEditor===$)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument($,p){const v=this.g.get($);if(!v&&!p)throw new Error(`NO notebook document for '${$}'`);return v}static u($,p){if(!p)return;const v=p.filenamePattern.map(y=>g.NotebookExclusiveDocumentPattern.from(y)).filter(y=>y!==void 0);if(p.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:$.identifier,providerDisplayName:$.displayName||$.name,displayName:p.displayName,filenamePattern:v,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider($,p,v){const y=a.a++,h=typeof v.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(y,v),this.b.$registerNotebookCellStatusBarItemProvider(y,h,p);let E;return h!==void 0&&(E=v.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(h))),new r.$lM(()=>{this.f.delete(y),this.b.$unregisterNotebookCellStatusBarItemProvider(y,h),E?.dispose()})}async createNotebookDocument($){const p=await this.c.$tryCreateNotebook({viewType:$.viewType,content:$.content&&g.NotebookData.from($.content)});return D.URI.revive(p)}async openNotebookDocument($){const p=this.g.get($);if(p)return p.apiNotebook;const v=await this.c.$tryOpenNotebook($),y=this.g.get(D.URI.revive(v));return(0,m.$jg)(y?.apiNotebook)}async showNotebookDocument($,p){D.URI.isUri($)&&($=await this.openNotebookDocument($));let v;typeof p=="object"?v={position:g.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(g.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:v={preserveFocus:!1};const y=await this.d.$tryShowNotebookDocument($.uri,$.notebookType,v),h=y&&this.h.get(y)?.apiEditor;if(h)return h;throw y?new Error(`Could NOT open editor for "${$.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${$.uri.toString()}".`)}async $provideNotebookCellStatusBarItems($,p,v,y){const h=this.f.get($),E=D.URI.revive(p),k=this.g.get(E);if(!k||!h)return;const I=k.getCellFromIndex(v);if(!I)return;const P=await h.provideCellStatusBarItems(I.apiCell,y);if(!P)return;const V=new T.$Tc,W=this.p.add([V]),R=(Array.isArray(P)?P:[P]).map(z=>g.NotebookStatusBarItem.from(z,this.i,V));return{cacheId:W,items:R}}$releaseNotebookCellStatusBarItems($){this.p.delete($)}registerNotebookSerializer($,p,v,y,h){if((0,b.$9e)(p))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:p,serializer:v,options:y}),this.b.$registerNotebookSerializer(E,{id:$.identifier,location:$.extensionLocation},p,g.NotebookDocumentContentOptions.from(y),a.u($,h)),(0,T.$Sc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook($,p,v){const y=this.x.get($);if(!y)throw new Error("NO serializer found");const h=await y.serializer.deserializeNotebook(p.buffer,v);return new s.$Fw(g.NotebookData.from(h))}async $notebookToData($,p,v){const y=this.x.get($);if(!y)throw new Error("NO serializer found");const h=await y.serializer.serializeNotebook(g.NotebookData.to(p.value),v);return O.$He.wrap(h)}async $saveNotebook($,p,v,y,h){const E=D.URI.revive(p),k=this.x.get($);if(!k)throw new Error("NO serializer found");const I=this.g.get(E);if(!I)throw new Error("Document NOT found");if(I.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new N.$nl((0,C.localize)(0,null,this.z(E)),6);const P={metadata:(0,n.$ao)(I.apiNotebook.metadata,z=>!(k.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of I.apiNotebook.getCells()){const G=new r.$ON(z.kind,z.document.getText(),z.document.languageId,z.mime,k.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);G.metadata=(0,n.$ao)(z.metadata,ie=>!(k.options?.transientCellMetadata??{})[ie]),P.cells.push(G)}await this.y(E,y);const V=await k.serializer.serializeNotebook(P,h);await this.s.value.writeFile(E,V);const W=this.s.getFileSystemProviderExtUri(E.scheme),q=await this.s.value.stat(E);return{name:W.basename(E),isFile:(q.type&N.FileType.File)!==0,isDirectory:(q.type&N.FileType.Directory)!==0,isSymbolicLink:(q.type&N.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&N.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((q.permissions??0)&N.FilePermission.Locked),etag:N.$yl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks($,p,v,y,h){const E=this.x.get($)?.serializer;if(!E)return{limitHit:!1,results:[]};const k=new A.$Bc;await(async(q,R,z)=>{await Promise.all(q.map(async G=>await Promise.all(G.filenamePatterns.map(ie=>{const de={_reason:z._reason,folderQueries:z.folderQueries,includePattern:z.includePattern,excludePattern:z.excludePattern,maxResults:z.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(de,R,ye=>{ye.forEach(De=>{k.has(De)||y.some(ue=>G.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(Ce=>(0,f.$Wgb)(Ce,De)))||k.add(De)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(v,h,p);const P=new A.$Ac;let V=!1;const W=Array.from(k).map(async q=>{const R=[];try{if(h.isCancellationRequested)return;if(p.maxResults&&[...P.values()].reduce((de,ye)=>de+ye.cellResults.length,0)>p.maxResults){V=!0;return}const z=[],G=this.g.get(q);if(G)G.apiNotebook.getCells().forEach(ye=>z.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(De=>De.items.map(ge=>ge.data.toString()))}));else{const de=await this.s.value.readFile(q),ye=O.$He.fromString(de.toString()),De=await E.deserializeNotebook(ye.buffer,h);if(h.isCancellationRequested)return;g.NotebookData.from(De).cells.forEach(ue=>z.push({input:ue.source,outputs:ue.outputs.flatMap(Ce=>Ce.items.map(se=>se.valueBytes.toString()))}))}if(h.isCancellationRequested)return;z.forEach((de,ye)=>{const De=p.contentPattern.pattern,ge=new u.$EXb(de.input,void 0,de.outputs),ue=ge.findInInputs(De),Ce=ge.findInOutputs(De),se=Ce.flatMap(Oe=>(0,t.$ZK)(Oe.matches,Oe.textBuffer)).map((Oe,ne)=>(Oe.webviewIndex=ne,Oe));if(ue.length>0||Ce.length>0){const Oe={index:ye,contentResults:(0,t.$ZK)(ue,ge.inputTextBuffer),webviewResults:se};R.push(Oe)}});const ie={resource:q,cellResults:R};P.set(q,ie);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...P.values()]}}async y($,p){const v=await this.s.value.stat($);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==N.$xl&&typeof v.mtime=="number"&&typeof v.size=="number"&&p.mtime<v.mtime&&p.etag!==N.$yl({mtime:p.mtime,size:v.size}))throw new N.$nl((0,C.localize)(1,null),3,p)}z($){return $.scheme===c.Schemas.file?$.fsPath:$.toString()}A($,p,v){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const y=new i.$lnc(p,this.d,$,v.visibleRanges.map(g.NotebookRange.to),v.selections.map(g.NotebookRange.to),typeof v.viewColumn=="number"?g.ViewColumn.to(v.viewColumn):void 0);this.h.set(p,y)}$acceptDocumentAndEditorsDelta($){if($.value.removedDocuments)for(const v of $.value.removedDocuments){const y=D.URI.revive(v),h=this.g.get(y);h&&(h.dispose(),this.g.delete(y),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(h.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===y.toString()&&this.h.delete(E.id)}if($.value.addedDocuments){const v=[];for(const y of $.value.addedDocuments){const h=D.URI.revive(y.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const E=new o.$knc(this.c,this.q,this.r,h,y);v.push(...y.cells.map(k=>o.$jnc.asModelAddData(k))),this.g.get(h)?.dispose(),this.g.set(h,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(E.apiNotebook)}}if($.value.addedEditors)for(const v of $.value.addedEditors){if(this.h.has(v.id))return;const y=D.URI.revive(v.documentUri),h=this.g.get(y);h&&this.A(h,v.id,v)}const p=[];if($.value.removedEditors)for(const v of $.value.removedEditors){const y=this.h.get(v);y&&(this.h.delete(v),this.k?.id===y.id&&(this.k=void 0),p.push(y))}if($.value.visibleEditors){this.l=$.value.visibleEditors.map(y=>this.h.get(y)).filter(y=>!!y);const v=new Set;this.l.forEach(y=>v.add(y.id));for(const y of this.h.values()){const h=v.has(y.id);y._acceptVisibility(h)}this.l=[...this.h.values()].map(y=>y).filter(y=>y.visible),this.o.fire(this.visibleNotebookEditors)}$.value.newActiveEditor===null?this.k=void 0:$.value.newActiveEditor&&(this.h.get($.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${$.value.newActiveEditor}`),this.k=this.h.get($.value.newActiveEditor)),$.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B($){const p=w.$_O.String.with("notebookType","A notebook type"),v=new w.$bP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new w.$_O("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>O.$He.wrap(h))],new w.$aP("Notebook Data",h=>g.NotebookData.to(h.value))),y=new w.$bP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new w.$_O("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new s.$Fw(g.NotebookData.from(h)))],new w.$aP("Bytes",h=>h.buffer));$.registerApiCommand(v),$.registerApiCommand(y)}}e.$unc=a}),define(Se[301],Ie([1,0,19,20,44,37,24,66,47]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;class D{constructor(l,w,g){this.k=l,this.l=w,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&T.$sk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&T.$sk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const w=this.k.folderQueries||[];return new Promise((g,r)=>{const s=o=>{this.f++,l(o)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=C.$nc(i);this.j&&this.j(i,n)||this.v(s,{base:o,basename:n})}),Promise.all(w.map(o=>this.p(o,s))).then(o=>{g({limitHit:this.e,stats:o[0]||void 0})},o=>{r(new Error((0,M.$jj)(o)))})})}async p(l,w){const g=new O.$qe,r=this.q(l),s=this.r(),o=new m.$PK(this.k,l),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(g),n=b.$be.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,g.token),u=n.elapsed(),t=b.$be.create();return this.g&&!this.e||(c&&c.forEach(f=>{const a=C.$gc.relative(l.folder.path,f.path);if(i){const d=C.$nc(f.path);this.v(w,{base:l.folder,relativePath:a,basename:d});return}this.s(s,l.folder,a,w)}),this.g&&!this.e)?null:(this.u(s,o,w),{providerTime:u,postProcessTime:t.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(l){const w=(0,m.$OK)(this.k.includePattern,l.includePattern),g=(0,m.$OK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:g,includes:w,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},w,g,r){if(g===this.a){const o=C.$nc(this.a);this.v(r,{base:w,relativePath:this.a,basename:o})}function s(o){const i=C.$nc(o),n=C.$mc(o);let c=l[n];c||(c=l[n]=[],s(n)),c.push({base:w,relativePath:o,basename:i})}s(g)}u({rootEntries:l,pathToEntries:w},g,r){const s=this,o=this.a;function i(n){const c=(0,m.$RK)(()=>n.map(u=>u.basename));for(let u=0,t=n.length;u<t;u++){const f=n[u],{relativePath:a,basename:d}=f;if(g.matchesExcludesSync(a,d,o!==d?c:void 0))continue;const $=w[a];if($)i($);else{if(a===o)continue;s.v(r,f)}if(s.e)break}}i(l)}v(l,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(w))}}class N{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,w,g,r){const s=this.c(l.cacheKey),o=new D(l,w,s&&s.token);let i=0;const n=c=>{i+=c.length,g(c.map(u=>this.d(u)))};return this.e(o,N.a,n,r).then(c=>({limitHit:c.limitHit,stats:c.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:c.stats}:void 0,messages:[]}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new O.$qe),this.b.get(l)}d(l){return l.relativePath?{resource:A.$_g(l.base,l.relativePath)}:{resource:l.base}}e(l,w,g,r){const s=r.onCancellationRequested(()=>{l.cancel()}),o=n=>{n&&(i.push(n),w>0&&i.length>=w&&(g(i),i=[]))};let i=[];return l.search(o).then(n=>(i.length&&g(i),s.dispose(),n),n=>(i.length&&g(i),s.dispose(),Promise.reject(n)))}}e.$mnc=N}),define(Se[302],Ie([1,0,18,271,37,97,28,16,19,24,13,15,2,96,195,50,12,45,109,298,47]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZL=void 0,e.$1L=y;let u=class{constructor(E,k,I,P,V){this.a=E,this.b=k,this.c=I,this.d=P,this.e=V}text(E,k,I={}){E=this.f(E,I);const P=this.a.getValue(),V=k&&k.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(k?.map(o.$Ti),I),type:2,contentPattern:E,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:P.search.usePCRE2||V||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}f(E,k){const I=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const P={...E,wordSeparators:I.editor.wordSeparators};return this.j(E,k)&&(P.isCaseSensitive=!0),this.k(E)&&(P.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),P}file(E,k={}){return{...this.h(E,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(E,k){return E?(E=Array.isArray(E)?E.map($):$(E),k?this.parseSearchPaths(E):{pattern:f(...Array.isArray(E)?E:[E])}):{}}h(E=[],k={}){const I=this.g(k.includePattern,k.expandPatterns),P=this.g(k.excludePattern,k.expandPatterns),V=E.length>1,W=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(z=>this.q(z,k,P)):E.map(z=>this.r(z,k,P,V))).filter(z=>!!z),q={_reason:k._reason,folderQueries:W,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:P.pattern,includePattern:I.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const z=C.$Hb(this.c.groups.flatMap(de=>de.editors.map(ye=>ye.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const G=z.filter(de=>(0,c.$FK)(q,de.fsPath)),ie=this.i(G);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const R=k.extraFileResources&&k.extraFileResources.filter(z=>(0,c.$FK)(q,z.fsPath));return q.extraFileResources=R&&R.length?R:void 0,q}i(E){const k=[],I=new A.$Ac,P={};let V=!1;return E.forEach(W=>{if(W.scheme===b.Schemas.walkThrough)return;if((0,D.$dh)(W)){const R=this.b.getWorkspaceFolder(W)?.uri??W.with({path:m.$mc(W.fsPath)});let z=I.get(R);z||(V=!0,z={folder:R,includePattern:{}},k.push(z),I.set(R,z));const G=m.$lc(R.fsPath,W.fsPath);(0,S.$jg)(z.includePattern)[G.replace(/\\/g,"/")]=!0}else W.fsPath&&(V=!0,P[W.fsPath]=!0)}),{folderQueries:k,includePattern:P,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(E,k){if(k.isSmartCase){if(E.isRegExp){if(N.$2f(E.pattern,!0))return!0}else if(N.$2f(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,w.$UC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const k=ie=>m.$ic(ie)||/^\.\.?([\/\\]|$)/.test(ie),P=(Array.isArray(E)?E:a(E)).map(ie=>{const de=this.e.resolvedUserHome;return de?(0,T.$Kw)(ie,de.scheme===b.Schemas.file?de.fsPath:de.path):ie}),V=O.$K(P,ie=>k(ie)?"searchPaths":"exprSegments"),W=(V.exprSegments||[]).map(ie=>N.$hf(ie,"/")).map(ie=>N.$hf(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),d(ie))),q={},R=this.m(V.searchPaths||[]);R&&R.length&&(q.searchPaths=R);const z=W.flat(),G=f(...z);return G&&(q.pattern=G),q}l(E,k){return k.disregardExcludeSettings?void 0:(0,c.$EK)(E,!k.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const k=E.flatMap(P=>{let{pathPortion:V,globPortion:W}=t(P);return W&&(W=p(W)),this.n(V).flatMap(R=>this.o(R,W))}),I=new Map;return k.forEach(P=>{const V=P.searchPath.toString(),W=I.get(V);W?P.pattern&&(W.pattern=W.pattern||{},W.pattern[P.pattern]=!0):I.set(V,{searchPath:P.searchPath,pattern:P.pattern?f(P.pattern):void 0})}),Array.from(I.values())}n(E){if(m.$ic(E)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==b.Schemas.file?[{searchPath:k[0].uri.with({path:E})}]:[{searchPath:l.URI.file(m.$hc(E))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(E=$(E),E.startsWith("../")||E===".."){const P=m.$gc.resolve(k.path,E);return[{searchPath:k.with({path:P})}]}const I=p(E);return[{searchPath:k,pattern:I}]}else{if(E==="./"||E===".\\")return[];{const k=E.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(V=>{const W=k.match(new RegExp(`^${N.$bf(V.name)}(?:/(.*)|$)`));return W?{match:W,folder:V}:null}).filter(S.$gg);if(P.length)return P.map(V=>{const W=V.match[1];return{searchPath:V.folder.uri,pattern:W&&p(W)}});{const V=E.match(/\.[\/\\](.+)[\/\\]?/),W=V?V[1]:E,q=g.localize(0,null,W);throw new Error(q)}}}}o(E,k){const I=E.pattern&&k?`${E.pattern}/${k}`:E.pattern||k,P=[{searchPath:E.searchPath,pattern:I}];return I&&!I.endsWith("**")&&P.push({searchPath:E.searchPath,pattern:I+"/**"}),P}q(E,k,I){const P=this.r((0,o.$Ti)(E.searchPath),k,I,!1);return P?{...P,includePattern:E.pattern}:null}r(E,k,I,P){let V;const W=l.URI.isUri(E)?E:E.uri;if(I.searchPaths){const ie=I.searchPaths.filter(de=>(0,D.$5g)(de.searchPath,W))[0];if(ie&&!ie.pattern)return null;ie&&(V=ie.pattern)}const q=this.a.getValue({resource:W}),z={...this.l(q,k)||{},...V||{}},G=l.URI.isUri(E)?(0,D.$9g)(E):E.name;return{folder:W,folderName:P?G:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!q.search.followSymlinks}}};e.$ZL=u,e.$ZL=u=Je([We(0,r.$5i),We(1,o.$Hi),We(2,i.$3D),We(3,s.$5j),We(4,n.$XL)],u);function t(h){const E=h.match(/[\*\{\}\(\)\[\]\?]/);if(E){const k=E.index,I=h.substr(0,k).match(/[/|\\][^/\\]*$/);if(I){let P=h.substr(0,I.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:h.substr((I.index||0)+1)}}}return{pathPortion:h}}function f(...h){return h.length?h.reduce((E,k)=>(E[k]=!0,E),Object.create(null)):void 0}function a(h){return M.$qk(h,",").map(E=>E.trim()).filter(E=>!!E.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function $(h){return h.replace(/\\/g,"/")}function p(h){return $(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(h){return h.replace(/([?*[\]])/g,"[$1]")}function y(h,E){h=C.$Mb(h,P=>P.toString());const k=[],I=E.getWorkspace();return h&&h.forEach(P=>{let V;if(E.getWorkbenchState()===2)V=(0,D.$bh)(I.folders[0].uri,P),V&&V!=="."&&(V="./"+V);else{const W=E.getWorkspaceFolder(P);if(W){const q=W.name;if(I.folders.filter(z=>z.name===q).length===1){const z=(0,D.$bh)(W.uri,P);z===""?V=`./${W.name}`:V=`./${W.name}/${z}`}else V=P.fsPath}}V&&k.push(v(V))}),k}}),define(Se[303],Ie([1,0,24,2,20,14,3,302,47,45,11]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rwb=l,e.$Swb=r;const S=7e3;function l(s,o){const i=o.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],c=[];for(const $ of i)if(/^workspaceContains:/.test($)){const p=$.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||s.forceUsingSearch?c.push(p):n.push(p)}if(n.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:u,resolve:t}=(0,N.$rh)(),f=$=>t({activationEvent:$}),a=Promise.all(n.map($=>w(s,$,f))).then(()=>{}),d=g(s,o.identifier,c,f);return Promise.all([a,d]).then(()=>{t(void 0)}),u}async function w(s,o,i){for(const n of s.folders)if(await s.exists(C.$_g(O.URI.revive(n),o))){i(`workspaceContains:${o}`);return}}async function g(s,o,i,n){if(i.length===0)return Promise.resolve(void 0);const c=new M.$qe,u=s.checkExists(s.folders,i,c.token),t=setTimeout(async()=>{c.cancel(),s.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},S);let f=!1;try{f=await u}catch(a){T.$4(a)||T.$1(a)}c.dispose(),clearTimeout(t),f&&n(`workspaceContains:${i.join(",")}`)}function r(s,o,i,n){const c=s.get(A.$xi),u=s.get(m.$wK),f=c.createInstance(b.$ZL).file(o.map(a=>(0,D.$Ti)(O.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return u.fileSearch(f,n).then(a=>!!a.limitHit,a=>T.$4(a)?!1:Promise.reject(a))}}),define(Se[41],Ie([1,0,173,19,60,24,11,6,54,2,12,4,40,237,84,39,25,110,14,21,22,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,23,82]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c,u,t,f,a,d,$,p,v,y,h,E,k,I,P,V,W,q,R,z,G){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=e.$4mc=e.$3mc=e.$2mc=e.$1mc=void 0,e.$1mc=(0,a.$yi)("IHostUtils");let de=ie=class extends b.$Uc{constructor(j,x,ve,Le,ke,be,me,Q,Y,he,ce,Te,fe){super(),this.Y=Te,this.Z=fe,this.a=this.B(new k.$fe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=ve,this.f=me,this.j=Le,this.m=ke,this.s=be,this.t=Y,this.u=he,this.w=ce,this.y=this.g.getProxy(S.$jM.MainThreadWorkspace),this.z=this.g.getProxy(S.$jM.MainThreadTelemetry),this.C=this.g.getProxy(S.$jM.MainThreadExtensionService),this.D=new A.$xh,this.F=new A.$xh,this.G=new A.$xh,this.H=new A.$xh,this.I=new Oe(this.f.extensions.activationEvents),this.L=new o.$xac(this.I,this.f.extensions.allExtensions);const Pe=new n.$Um(this.f.extensions.myExtensions);this.J=new o.$xac(this.I,Ce(this.L,Pe)),z.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ge(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ge(this.J)}`)),this.M=new g.$Jmc(this.g,this.s),this.N=new P.$Tmc(this.g),this.O=Q,this.h=j.createChild(new v.$wi([g.$Kmc,this.M],[P.$Umc,this.N])),this.P=this.B(new w.$Imc(this.J,this.L,{onExtensionActivationError:(Re,Ue,B)=>{this.C.$onExtensionActivationError(Re,i.$3(Ue),B)},actualActivateExtension:async(Re,Ue)=>{if(o.$xac.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,Ue),new w.$Hmc;const B=this.J.getExtensionDescription(Re);return this.fb(B,Ue)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(j){i.$1(j)}}async $(){this.O.onWillDeactivateAll();let j=[];try{j=this.J.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.eb(ke))}catch{}await Promise.all(j)}terminate(j,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${j}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Le=>{this.s.error(Le)}),this.g.dispose();const ve=this.$();Promise.race([(0,A.$zh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(j){return this.G.isOpen()?this.P.isActivated(j):!1}async getExtension(j){const x=await this.C.$getExtension(j);return x&&{...x,identifier:new n.$Tm(x.identifier.value),extensionLocation:D.URI.revive(x.extensionLocation)}}ab(j,x){return this.P.activateByEvent(j,x)}bb(j,x){return this.P.activateById(j,x)}activateByIdWithErrors(j,x){return this.bb(j,x).then(()=>{const ve=this.P.getActivatedExtension(j);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(j=>this.J)}getExtensionExports(j){if(this.G.isOpen())return this.P.getActivatedExtension(j).exports;try{return this.P.getActivatedExtension(j).exports}catch{return null}}async cb(j){if(j.scheme===W.Schemas.file&&this.c.fsRealpath){const x=j.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const ve=await this.R.get(x);return D.URI.file(ve)}return j}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(j=>new se(j))),this.Q}async db(j){const x=m.$Ei.forUris(ve=>T.$3g.ignorePathCasing(ve));return await Promise.all(j.map(async ve=>{if(this.wb(ve)){const Le=await this.cb(ve.extensionLocation);x.set(Le,ve)}})),x}eb(j){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(j))return x;const ve=this.P.getActivatedExtension(j);if(!ve)return x;try{typeof ve.module.deactivate=="function"&&(x=Promise.resolve(ve.module.deactivate()).then(void 0,Le=>(this.s.error(Le),Promise.resolve(void 0))))}catch(Le){this.s.error(`An error occurred when deactivating the extension '${j.value}':`),this.s.error(Le)}try{(0,b.$Pc)(ve.subscriptions)}catch(Le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${j.value}':`),this.s.error(Le)}return x}async fb(j,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(j.identifier):await this.C.$onWillActivateExtension(j.identifier),this.hb(j,x).then(ve=>{const Le=ve.activationTimes;return this.C.$onDidActivateExtension(j.identifier,Le.codeLoadingTime,Le.activateCallTime,Le.activateResolvedTime,x),this.gb(j,x,"success",Le),ve},ve=>{throw this.gb(j,x,"failure"),ve})}gb(j,x,ve,Le){const ke=De(j,x);this.z.$publicLog2("extensionActivationTimes",{...ke,...Le||{},outcome:ve})}hb(j,x){const ve=De(j,x);this.z.$publicLog2("activatePlugin",ve);const Le=this.wb(j);if(!Le)return Promise.resolve(new w.$Gmc(w.$Dmc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${j.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const ke=new w.$Emc(x.startup);return Promise.all([this.xb(j,(0,T.$_g)(j.extensionLocation,Le),ke),this.ib(j)]).then(be=>(M.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),ie.jb(this.s,j.identifier,be[0],be[1],ke))).then(be=>(M.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),be))}ib(j){const x=this.Z.createLanguageModelAccessInformation(j),ve=new u.$Mmc(j,this.M),Le=new u.$Lmc(j.identifier.value,!1,this.M),ke=new V.$Vmc(j,this.N),be=j.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,me=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([ve.whenReady,Le.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,he;const ce=(0,s.$KG)(j,"ipc")?this.f.messagePorts?.get(n.$Tm.toKey(j.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Le,secrets:ke,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(Te){return O.$jc(j.extensionLocation.fsPath,Te)},get storagePath(){return Q.O.workspaceValue(j)?.fsPath},get globalStoragePath(){return Q.O.globalValue(j).fsPath},get logPath(){return O.$jc(Q.f.logsLocation.fsPath,j.identifier.value)},get logUri(){return D.URI.joinPath(Q.f.logsLocation,j.identifier.value)},get storageUri(){return Q.O.workspaceValue(j)},get globalStorageUri(){return Q.O.globalValue(j)},get extensionMode(){return be},get extension(){return Y===void 0&&(Y=new ue(Q,j.identifier,j,me,!1)),Y},get extensionRuntime(){return(0,s.$LG)(j,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(j)},get messagePassingProtocol(){if(!he){if(!ce)return;const Te=k.Event.buffer(k.Event.fromDOMEventEmitter(ce,"message",fe=>fe.data));ce.start(),he={onDidReceiveMessage:Te,postMessage:ce.postMessage.bind(ce)}}return he}})})}static jb(j,x,ve,Le,ke){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(j,x,ve,Le,ke).then(be=>new w.$Fmc(!1,null,ke.build(),ve,be,Le.subscriptions))}static kb(j,x,ve,Le,ke){if(typeof ve.activate=="function")try{ke.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${x.value}`);const be=typeof global=="object"?global:self,me=ve.activate.apply(be,[Le]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(me).then(Q=>(ke.activateResolveStop(),Q))}catch(be){return Promise.reject(be)}else return Promise.resolve(ve)}lb(j,x){this.bb(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:x}).then(void 0,ve=>{this.s.error(ve)})}mb(j,x=0){const Le=Date.now();(0,z.$B)(()=>{for(let ke=x;ke<j.length;ke+=1){const be=j[ke];for(const me of be.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-Le>50){this.mb(j,ke);break}else this.lb(be,me)}})}nb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(j=>{const x=j.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(x)this.mb(ve);else for(const Le of ve)if(Le.activationEvents)for(const ke of Le.activationEvents)ke==="onStartupFinished"&&this.lb(Le,ke)})}ob(){const j=this.ab("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.pb(be.added)));const x=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(x),Le=this.rb(),ke=Promise.all([Le,j,ve]).then(()=>{});return Promise.race([ke,(0,A.$zh)(1e4)]).then(()=>{this.nb()}),ke}pb(j){return j.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(j,x))).then(()=>{})}async qb(j,x){if(this.isActivated(x.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Le={logService:this.s,folders:j.map(be=>be.uri),forceUsingSearch:ve||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,me,Q)=>this.y.$checkExists(be,me,Q)},ke=await(0,I.$Rwb)(Le,x);if(ke)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ke.activationEvent}).then(void 0,be=>this.s.error(be))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(j){throw console.error(j),j}}async sb(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:x}=this.f.environment;if(!j||!x)throw new Error(C.localize(0,null));const ve=await this.xb(null,x,new w.$Emc(!1));if(!ve||typeof ve.run!="function")throw new Error(C.localize(1,null,x.toString()));return new Promise((Le,ke)=>{const be=(Y,he)=>{Y?(z.$t&&this.s.error("Test runner called back with error",Y),ke(Y)):(z.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Le(typeof he=="number"&&he>0?1:0))},me=(0,T.$Zg)(x),Q=ve.run(me,be);Q&&Q.then&&Q.then(()=>{z.$t&&this.s.info("Test runner finished successfully."),Le(0)}).catch(Y=>{z.$t&&this.s.error("Test runner finished with error",Y),ke(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$zh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,x){return this.S[j]=x,(0,b.$Sc)(()=>{delete this.S[j]})}async getRemoteExecServer(j){const{resolver:x}=await this.ub(j);return x?.resolveExecServer?.(j,{resolveAttempt:0})}async ub(j){const x=j.indexOf("+");if(x===-1)throw new t.$rM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=j.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(j,x){const ve=R.$be.create(!1),Le=()=>`[resolveAuthority(${(0,f.$Nl)(j)},${x})][${ve.elapsed()}ms] `,ke=F=>this.s.info(`${Le()}${F}`),be=F=>this.s.warn(`${Le()}${F}`),me=(F,H=void 0)=>this.s.error(`${Le()}${F}`,H),Q=F=>{if(F instanceof t.$rM)return{type:"error",error:{code:F._code,message:F._message,detail:F._detail}};throw F},Y=async F=>{ke(`activating resolver for ${F}...`);const{resolver:H,authorityPrefix:K}=await this.ub(F);if(!H)throw me(`no resolver for ${K}`),new t.$rM(`No remote extension installed to resolve ${K}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:K,remoteAuthority:F}},he=j.split(/@|%40/g).reverse();ke(`activating remote resolvers ${he.join(" -> ")}`);let ce;try{ce=await Promise.all(he.map(Y)).catch(async F=>{if(!(F instanceof t.$rM)||F._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw F;return be(`resolving nested authorities failed: ${F.message}`),[await Y(j)]})}catch(F){return Q(F)}const Te=new A.$Jh;Te.cancelAndSet(()=>ke("waiting..."),1e3);let fe,Pe;for(const[F,{authorityPrefix:H,resolver:K,remoteAuthority:te}]of ce.entries())try{if(F===ce.length-1)ke("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${H}`),fe=await K.resolve(te,{resolveAttempt:x,execServer:Pe}),M.mark(`code/extHost/didResolveAuthorityOK/${H}`),ke("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(K,t.$qM.isManagedResolvedAuthority(fe)?fe:void 0));else{if(ke(`invoking resolveExecServer() for ${te}`),M.mark(`code/extHost/willResolveExecServer/${H}`),Pe=await K.resolveExecServer?.(te,{resolveAttempt:x,execServer:Pe}),!Pe)throw new t.$rM(`Exec server was not available for ${te}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(re){return M.mark(`code/extHost/didResolveAuthorityError/${H}`),me("returned an error",re),Te.dispose(),Q(re)}Te.dispose();const Re={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},Ue={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};ke(`returned ${t.$qM.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let B;if(t.$qM.isManagedResolvedAuthority(fe)){const F=x;this.Y.setFactory(F,fe.makeConnection),B={authority:j,connectTo:new f.$Kl(F),connectionToken:fe.connectionToken}}else B={authority:j,connectTo:new f.$Ll(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:B,options:Ue,tunnelInformation:Re}}}async $getCanonicalURI(j,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$Nl)(j)})`);const{resolver:ve}=await this.ub(j);if(!ve)return null;const Le=D.URI.revive(x);if(typeof ve.getCanonicalURI>"u")return Le;const ke=await(0,A.$qh)(()=>ve.getCanonicalURI(Le));return ke||Le}async $startExtensionHost(j){j.toAdd.forEach(be=>be.extensionLocation=D.URI.revive(be.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,j),Le=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Le),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ge(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ge(this.J)}`)),this.tb()}$activateByEvent(j,x){return x===1?this.D.wait().then(ve=>this.ab(j,!1)):this.G.wait().then(ve=>this.ab(j,!1))}async $activate(j,x){return await this.G.wait(),this.J.getExtensionDescription(j)?(await this.bb(j,x),!0):!1}async $deltaExtensions(j){j.toAdd.forEach(be=>be.extensionLocation=D.URI.revive(be.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,j),Le=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Le),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ge(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ge(this.J)}`)),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){const x=c.$He.alloc(j),ve=Math.random()%256;for(let Le=0;Le<j;Le++)x.writeUInt8(ve,Le);return x}async $updateRemoteConnectionData(j){this.X=j,this.a.fire()}};e.$2mc=de,e.$2mc=de=ie=Je([We(0,a.$xi),We(1,e.$1mc),We(2,p.$NO),We(3,r.$mmc),We(4,l.$pmc),We(5,N.$5j),We(6,d.$4O),We(7,$.$smc),We(8,y.$UDb),We(9,h.$Nmc),We(10,q.$Xmc),We(11,G.$Ymc),We(12,E.$Rmc)],de);function ye(ne,j,x,ve){ne.addActivationEvents(ve.addActivationEvents);const Le=new o.$xac(ne,j.getAllExtensionDescriptions());Le.deltaExtensions(ve.toAdd,ve.toRemove);const ke=new n.$Um(x.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of ve.myToRemove)ke.delete(me);for(const me of ve.myToAdd)ke.add(me);const be=Ce(Le,ke);return{globalRegistry:Le,myExtensions:be}}function De(ne,j){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}function ge(ne){return ne.getAllExtensionDescriptions().map(j=>j.identifier.value).join(",")}e.$3mc=(0,a.$yi)("IExtHostExtensionService");class ue{#e;#t;#i;constructor(j,x,ve,Le,ke){this.#e=j,this.#t=x,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=O.$hc((0,T.$Zg)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Le,this.isFromDifferentExtensionHost=ke}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$4mc=ue;function Ce(ne,j){return ne.getAllExtensionDescriptions().filter(x=>j.has(x.identifier))}class se{constructor(j){this.a=j}setSearchTree(j){this.a=j}findSubstr(j){return this.a.findSubstr(j)}forEach(j){return this.a.forEach(j)}}e.$5mc=se;class Oe{constructor(j){this.a=new n.$Vm,this.addActivationEvents(j)}readActivationEvents(j){return this.a.get(j.identifier)??[]}addActivationEvents(j){for(const x of Object.keys(j))this.a.set(x,j[x])}}}),define(Se[304],Ie([1,0,60,2,4,40,25,21,17,27,3,41,12,13]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=void 0;let r=class{constructor(c,u,t,f,a,d,$){this.c=c,this.d=u,this.e=t,this.f=f,this.g=a,this.h=d,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new o(this.c,u,this.d,c,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,u,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const u of c.nodeModuleName)this.a.set(u,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(u=>c.alternativeModuleName(u))}};e.$boc=r,e.$boc=r=Je([We(2,N.$xi),We(3,T.$pmc),We(4,S.$3mc),We(5,D.$4O),We(6,l.$5j)],r);let s=class{static{g=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&g.a.size){const u=(0,w.$bf)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${a}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const u=this.b.exec(this.c(c));if(!u)return;const[,t,f,a]=u,d=g.a.get(f);if(d!==void 0)return console.warn(`${f} as been renamed to ${d}, please update your imports`),t+d+a}c(c){return c.replace(/\\/g,"/")}};s=g=Je([We(0,D.$4O)],s);class o{constructor(c,u,t,f,a){this.c=c,this.d=u,this.e=t,this.f=f,this.g=a,this.nodeModuleName="vscode",this.a=new b.$Vm}load(c,u){const t=this.d.findSubstr(u);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((a,d)=>f+=`	${d} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${f}`),this.b=this.c(A.$FG,this.e,this.f)}return this.b}}let i=class{constructor(c,u,t){this.e=c,this.f=u,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$jM.MainThreadTelemetry);const f=t.getProxy(M.$jM.MainThreadWindow);this.c=(a,d)=>{const $=O.URI.parse(a);return d?this.g(a,d):$.scheme==="http"||$.scheme==="https"?f.$openUri($,a,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?f.$openUri($,a,{}):this.g(a,d)}}load(c,u,t){const f=this.e.findSubstr(u);return f&&(this.a=f.identifier.value,this.h()),this.b=t(c),this.c}g(c,u){return this.i(),this.b(c,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([We(2,m.$NO)],i)}),define(Se[122],Ie([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=e.$6mc=void 0,e.$6mc=(0,A.$yi)("IExtHostVariableResolverProvider");class g extends l.$RP{constructor(o,i,n,c,u,t,f){function a(){if(n){const d=n.activeEditor();if(d)return d.document.uri;const $=c.tabGroups.all.find(p=>p.isActive)?.activeTab;if($!==void 0){if($.input instanceof N.$0N||$.input instanceof N.$cO)return $.input.modified;if($.input instanceof N.$9N||$.input instanceof N.$bO||$.input instanceof N.$_N)return $.input.uri}}}super({getFolderUri:d=>{const $=t.folders.filter(p=>p.name===d);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(d,$)=>u.getConfiguration(void 0,d).get($),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return M.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const d=a();if(d){const $=i.getWorkspaceFolder(d);if($)return M.$hc($.uri.fsPath)}}},getSelectedText:()=>{if(n){const d=n.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(n){const d=n.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>o.getExtension(d)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(T.env))}}let r=class extends O.$Uc{constructor(o,i,n,c,u){super(),this.b=o,this.c=i,this.g=n,this.h=c,this.j=u,this.a=new C.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$7mc=r,e.$7mc=r=Je([We(0,D.$3mc),We(1,S.$mmc),We(2,b.$YO),We(3,w.$pmc),We(4,m.$Bmc)],r)}),define(Se[123],Ie([1,0,11,5,2,21,3,4,67,41,17,7,39,226,228,40,122,6,36,35,8,18]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=e.$$mc=e.$0mc=e.$9mc=e.$8mc=void 0,e.$8mc=(0,A.$yi)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(y,h,E,k,I,P,V){this.N=h,this.O=E,this.P=k,this.Q=I,this.R=P,this.S=V,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$fe,this.o=new O.$fe,this.q=new O.$fe,this.w=new O.$fe,this.l=y.getProxy(b.$jM.MainThreadDebugService),this.A=new O.$fe,this.C=new O.$fe,this.y=new a(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(q=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(y,h){const E=this.W(h);if(!E)return;const k=await this.H.get(y)?.getTreeItem?.(E);return k?this.U(y,k):void 0}registerDebugVisualizationTree(y,h,E){const k=T.$Tm.toKey(y.identifier),I=this.jb(k,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.H.set(I,E),this.l.$registerDebugVisualizerTree(I,!!E.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(I),this.H.delete(h)})}async $getVisualizerTreeItemChildren(y,h){const E=this.J.get(h)?.item;return E?(await this.H.get(y)?.getChildren?.(E))?.map(I=>this.U(y,I))||[]:[]}async $editVisualizerTreeItem(y,h){const E=this.J.get(y);if(!E)return;const k=await this.H.get(E.provider)?.editItem?.(E.item,h);return this.U(E.provider,k||E.item)}$disposeVisualizedTree(y){const h=this.J.get(y);if(!h)return;const E=[h.children];for(const k of E)if(k)for(const I of k)E.push(this.J.get(I)?.children),this.J.delete(I)}U(y,h){let E=this.I.get(h);return E||(E=this.F++,this.I.set(h,E),this.J.set(E,{provider:y,item:h})),c.DebugTreeItem.from(h,E)}asDebugSourceUri(y,h){const E=y;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let k=`debug:${encodeURIComponent(E.path||"")}`,I="?";return h&&(k+=`${I}session=${encodeURIComponent(h.id)}`,I="&"),k+=`${I}ref=${E.sourceReference}`,M.URI.parse(k)}else{if(E.path)return M.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(y){const h=[];for(const E of y.getAllExtensionDescriptions())if(E.contributes){const k=E.contributes.debuggers;if(k&&k.length>0)for(const I of k)(0,g.$zH)(I)&&h.push(I.type)}this.l.$registerDebugTypes(h)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const y=[];return this.z.forEach(h=>y.push(h)),y}async $resolveDebugVisualizer(y,h){const E=this.L.get(y);if(!E)throw new Error(`No debug visualizer found with id '${y}'`);let{v:k,provider:I,extensionId:P}=E;if(k.visualization||(k=await I.resolveDebugVisualization?.(k,h)||k,E.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${I}'`);return this.kb(P,k.visualization)}async $executeDebugVisualizerCommand(y){const h=this.L.get(y);if(!h)throw new Error(`No debug visualizer found with id '${y}'`);const E=h.v.visualization;E&&"command"in E&&this.S.executeCommand(E.command,...E.arguments||[])}W(y){const h=this.m.get(y.sessionId);return h&&{session:h.api,variable:y.variable,containerId:y.containerId,frameId:y.frameId,threadId:y.threadId}}async $provideDebugVisualizers(y,h,E,k){const I=this.W(E),P=this.jb(y,h),V=this.G.get(P);if(!I||!V)return[];const W=await V.provideDebugVisualization(I,k);return W?W.map(q=>{const R=++this.M;this.L.set(R,{v:q,provider:V,extensionId:y});const z=q.iconPath?this.lb(q.iconPath):void 0;return{id:R,name:q.name,iconClass:z?.iconClass,iconPath:z?.iconPath,visualization:this.kb(y,q.visualization)}}):[]}$disposeDebugVisualizers(y){for(const h of y)this.L.delete(h)}registerDebugVisualizationProvider(y,h,E){if(!y.contributes?.debugVisualizers?.some(P=>P.id===h))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${h})`);const k=T.$Tm.toKey(y.identifier),I=this.jb(k,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.G.set(I,E),this.l.$registerDebugVisualizer(k,h),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,h),this.G.delete(h)})}addBreakpoints(y){const h=y.filter(I=>{const P=I.id;return this.z.has(P)?!1:(this.z.set(P,I),!0)});this.gb(h,[],[]);const E=[],k=new Map;for(const I of h)if(I instanceof S.$nN){let P=k.get(I.location.uri.toString());P||(P={type:"sourceMulti",uri:I.location.uri,lines:[]},k.set(I.location.uri.toString(),P),E.push(P)),P.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character,mode:I.mode})}else I instanceof S.$oN&&E.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName,mode:I.mode});return this.l.$registerBreakpoints(E)}removeBreakpoints(y){const h=y.filter(P=>this.z.delete(P.id));this.gb([],h,[]);const E=h.filter(P=>P instanceof S.$nN).map(P=>P.id),k=h.filter(P=>P instanceof S.$oN).map(P=>P.id),I=h.filter(P=>P instanceof S.$pN).map(P=>P.id);return this.l.$unregisterBreakpoints(E,k,I)}startDebugging(y,h,E){return this.l.$startDebugging(y?y.uri:void 0,h,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(y){return this.l.$stopDebugging(y?y.id:void 0)}registerDebugConfigurationProvider(y,h,E){if(!h)return new S.$lM(()=>{});const k=this.d++;return this.f.push({type:y,handle:k,provider:h}),this.l.$registerDebugConfigurationProvider(y,E,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,k),new S.$lM(()=>{this.f=this.f.filter(I=>I.provider!==h),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(y,h,E){if(!E)return new S.$lM(()=>{});if(!this.cb(y,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.$(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:h,handle:k,factory:E}),this.l.$registerDebugAdapterDescriptorFactory(h,k),new S.$lM(()=>{this.h=this.h.filter(I=>I.factory!==E),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(y,h){if(!h)return new S.$lM(()=>{});const E=this.j++;return this.k.push({type:y,handle:E,factory:h}),new S.$lM(()=>{this.k=this.k.filter(k=>k.factory!==h)})}async $runInTerminal(y,h){return Promise.resolve(void 0)}async $substituteVariables(y,h){let E;const k=await this.ib(y);return k&&(E={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(E,h)}X(y,h){if(y.type==="implementation")return new $(y.implementation)}Y(){}async $startDASession(y,h){const E=this,k=await this.hb(h);return this.eb(this.$(k.type),k).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const P=this.Z(I),V=this.X(P,k);if(!V)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const W=V;return this.D.set(y,W),this.db(k).then(q=>(q&&this.E.set(y,q),W.onMessage(async R=>{if(R.type==="request"&&R.command==="handshake"){const z=R,G={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const ie=await this.K.sign(z.arguments.value);G.body={signature:ie},W.sendResponse(G)}else throw new Error("no signer")}catch(ie){G.success=!1,G.message=ie.message,W.sendResponse(G)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(R),R=(0,g.$EH)(R,!0),E.l.$acceptDAMessage(y,R)}),W.onError(R=>{q&&q.onError&&q.onError(R),this.l.$acceptDAError(y,R.name,R.message,R.stack)}),W.onExit(R=>{q&&q.onExit&&q.onExit(R??void 0,void 0),this.l.$acceptDAExit(y,R??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),W.startSession()))})}$sendDAMessage(y,h){h=(0,g.$DH)(h,!1);const E=this.E.get(y);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(h),this.D.get(y)?.sendMessage(h)}$stopDASession(y){const h=this.E.get(y);this.E.delete(y),h&&h.onWillStopSession&&h.onWillStopSession();const E=this.D.get(y);return this.D.delete(y),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(y){const h=[],E=[],k=[];if(y.added)for(const I of y.added){const P=I.id;if(P&&!this.z.has(P)){let V;if(I.type==="function")V=new S.$oN(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode);else if(I.type==="data")V=new S.$pN(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage,I.mode);else{const W=M.URI.revive(I.uri);V=new S.$nN(new S.$xM(W,new S.$mM(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode)}(0,S.$lN)(V,P),this.z.set(P,V),h.push(V)}}if(y.removed)for(const I of y.removed){const P=this.z.get(I);P&&(this.z.delete(I),E.push(P))}if(y.changed){for(const I of y.changed)if(I.id){const P=this.z.get(I.id);if(P){if(P instanceof S.$oN&&I.type==="function"){const V=P;V.enabled=I.enabled,V.condition=I.condition,V.hitCondition=I.hitCondition,V.logMessage=I.logMessage,V.functionName=I.functionName}else if(P instanceof S.$nN&&I.type==="source"){const V=P;V.enabled=I.enabled,V.condition=I.condition,V.hitCondition=I.hitCondition,V.logMessage=I.logMessage,V.location=new S.$xM(M.URI.revive(I.uri),new S.$mM(I.line,I.character))}k.push(P)}}}this.gb(h,E,k)}async $acceptStackFrameFocus(y){let h;if(y){const E=await this.hb(y.sessionId);y.kind==="thread"?h=new S.$vN(E.api,y.threadId):h=new S.$uN(E.api,y.threadId,y.frameId)}this.B=h,this.C.fire(this.B)}$provideDebugConfigurations(y,h,E){return(0,C.$qh)(async()=>{const k=this.bb(y);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.ib(h);return k.provideDebugConfigurations(I,E)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(y,h,E,k){return(0,C.$qh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(h);return I.resolveDebugConfiguration(P,E,k)})}$resolveDebugConfigurationWithSubstitutedVariables(y,h,E,k){return(0,C.$qh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(h);return I.resolveDebugConfigurationWithSubstitutedVariables(P,E,k)})}async $provideDebugAdapter(y,h){const E=this.ab(y);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(h);return this.eb(E,k).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(I)})}async $acceptDebugSessionStarted(y){const h=await this.hb(y);this.n.fire(h.api)}async $acceptDebugSessionTerminated(y){const h=await this.hb(y);h&&(this.o.fire(h.api),this.m.delete(h.id))}async $acceptDebugSessionActiveChanged(y){this.u=y?await this.hb(y):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(y,h){(await this.hb(y))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(y,h){const k={session:(await this.hb(y)).api,event:h.event,body:h.body};this.w.fire(k)}Z(y){if(y instanceof S.$qN)return{type:"executable",command:y.command,args:y.args,options:y.options};if(y instanceof S.$rN)return{type:"server",port:y.port,host:y.host};if(y instanceof S.$sN)return{type:"pipeServer",path:y.path};if(y instanceof S.$tN)return{type:"implementation",implementation:y.implementation};throw new Error("convertToDto unexpected type")}$(y){const h=this.h.filter(E=>E.type===y);if(h.length>0)return h[0].factory}ab(y){const h=this.h.filter(E=>E.handle===y);if(h.length>0)return h[0].factory}bb(y){const h=this.f.filter(E=>E.handle===y);if(h.length>0)return h[0].provider}cb(y,h){if(y.contributes){const E=y.contributes.debuggers;if(E&&E.length>0){for(const k of E)if(k.label&&k.type&&k.type===h)return!0}}return!1}db(y){const E=y.configuration.type,k=this.k.filter(I=>I.type===E||I.type==="*").map(I=>(0,C.$qh)(()=>I.factory.createDebugAdapterTracker(y.api)).then(P=>P,P=>null));return Promise.race([Promise.all(k).then(I=>{const P=(0,u.$Hb)(I);if(P.length>0)return new d(P)}),new Promise(I=>setTimeout(()=>I(void 0),1e3))]).catch(I=>{})}async eb(y,h){const E=h.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new S.$rN(E));if(y){const I=await this.O.getExtensionRegistry();return(0,C.$qh)(()=>y.createDebugAdapterDescriptor(h.api,this.fb(h,I))).then(P=>{if(P)return P})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(h,k))}fb(y,h){}gb(y,h,E){(y.length>0||h.length>0||E.length>0)&&this.A.fire(Object.freeze({added:y,removed:h,changed:E}))}async hb(y){if(y)if(typeof y=="string"){const h=this.m.get(y);if(h)return h}else{let h=this.m.get(y.id);if(!h){const E=await this.ib(y.folderUri),k=y.parent?this.m.get(y.parent):void 0;h=new f(this.l,y.id,y.type,y.name,E,y.configuration,k?.api),this.m.set(h.id,h),this.l.$sessionCached(h.id)}return h}throw new Error("cannot find session")}ib(y){if(y){const h=M.URI.revive(y);return this.N.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}jb(y,h){return`${y}\0${h}`}kb(y,h){if(h){if("title"in h&&"command"in h)return{type:0};if("treeId"in h)return{type:1,id:`${y}\0${h.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(y){const h=this.mb(y);let E,k;return"id"in h?k=i.ThemeIcon.asClassName(h):E=h,{iconPath:E,iconClass:k}}mb(y){if(y instanceof S.$iN)return{id:y.id};const h=typeof y=="object"&&"dark"in y?y.dark:y,E=typeof y=="object"&&"light"in y?y.light:y;return{dark:typeof h=="string"?M.URI.file(h):h,light:typeof E=="string"?M.URI.file(E):E}}};e.$9mc=t,e.$9mc=t=Je([We(0,N.$NO),We(1,l.$mmc),We(2,D.$3mc),We(3,r.$pmc),We(4,m.$Bmc),We(5,s.$6mc),We(6,n.$0O)],t);class f{constructor(y,h,E,k,I,P,V){this.f=y,this.g=h,this.h=E,this.j=k,this.k=I,this.l=P,this.m=V}get api(){const y=this;return this.d??=Object.freeze({id:y.g,type:y.h,get name(){return y.j},set name(h){y.j=h,y.f.$setDebugSessionName(y.g,h)},parentSession:y.m,workspaceFolder:y.k,configuration:y.l,customRequest(h,E){return y.f.$customDebugAdapterRequest(y.g,h,E)},getDebugProtocolBreakpoint(h){return y.f.$getDebugProtocolBreakpoint(y.g,h.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(y){this.j=y}get configuration(){return this.l}}e.$0mc=f;class a{constructor(y){this.value=Object.freeze({append(h){y.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$$mc=a;class d{constructor(y){this.d=y}onWillStartSession(){this.d.forEach(y=>y.onWillStartSession?y.onWillStartSession():void 0)}onWillReceiveMessage(y){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(y):void 0)}onDidSendMessage(y){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(y):void 0)}onWillStopSession(){this.d.forEach(y=>y.onWillStopSession?y.onWillStopSession():void 0)}onError(y){this.d.forEach(h=>h.onError?h.onError(y):void 0)}onExit(y,h){this.d.forEach(E=>E.onExit?E.onExit(y,h):void 0)}}class $ extends w.$lsb{constructor(y){super(),this.h=y,y.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(y){this.h.handleMessage(y)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let p=class extends t{constructor(y,h,E,k,I,P,V){super(y,h,E,k,I,P,V)}};e.$_mc=p,e.$_mc=p=Je([We(0,N.$NO),We(1,l.$mmc),We(2,D.$3mc),We(3,r.$pmc),We(4,m.$Bmc),We(5,s.$6mc),We(6,n.$0O)],p)}),define(Se[305],Ie([1,0,14,60,2,4,255,12,56,72,27,199,17,61,41,63]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=e.$coc=void 0;class s{static async installEarlyHandler(n){Error.stackTraceLimit=100;const c=n.get(b.$5j),t=n.get(l.$NO).getProxy(T.$jM.MainThreadErrors);C.setUnexpectedErrorHandler(f=>{c.error(f);const a=C.$3(f);t.$onUnexpectedError(a)})}static async installFullHandler(n){const c=n.get(b.$5j),u=n.get(l.$NO),t=n.get(g.$3mc),f=n.get(r.$8O),a=u.getProxy(T.$jM.MainThreadExtensionService),d=u.getProxy(T.$jM.MainThreadErrors),$=await t.getExtensionPathIndex(),p=new WeakMap;function v(E,k){if(p.has(E))return p.get(E).stack;let I="",P,V;for(const q of k)I+=`
	at ${q.toString()}`,V=q.getFileName(),!P&&V&&(P=$.findSubstr(M.URI.file(V)));const W=`${E.name||"Error"}: ${E.message||""}${I}`;return p.set(E,{extensionIdentifier:P?.identifier,stack:W}),W}const y=Symbol("prepareStackTrace wrapped");let h=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(E){if(E===v||!E||E[y]){h=E||v;return}h=function(k,I){return v(k,I),E.call(Error,k,I)},Object.assign(h,{[y]:!0})}}),C.setUnexpectedErrorHandler(E=>{c.error(E);const k=C.$3(E),I=p.get(E);if(!I?.extensionIdentifier){d.$onUnexpectedError(k);return}a.$onExtensionRuntimeError(I.extensionIdentifier,k);const P=f.onExtensionError(I.extensionIdentifier,E);c.trace("forwarded error to extension?",P,I)})}}e.$coc=s;class o{constructor(n,c,u,t,f){this.a=u,this.b=new A.$Fac(n,null,t),c=o.e(c,this.b);const a=new D.$wi(...(0,m.$Cs)());a.set(N.$4O,{_serviceBrand:void 0,...c,messagePorts:f}),a.set(l.$NO,new l.$OO(this.b)),a.set(w.$jmc,new w.$kmc(t)),a.set(g.$1mc,u);const d=new S.$gr(a,!0);d.invokeFunction(s.installEarlyHandler),this.d=d.invokeFunction($=>$.get(b.$5j)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction($=>$.get(g.$3mc)),this.c.initialize(),d.invokeFunction(s.installFullHandler)}async asBrowserUri(n){const c=this.b.getProxy(T.$jM.MainThreadExtensionService);return M.URI.revive(await c.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,c){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=M.URI.revive(c.transformIncomingURIs(n.environment.appRoot));const u=n.environment.extensionDevelopmentLocationURI;return u&&(n.environment.extensionDevelopmentLocationURI=u.map(t=>M.URI.revive(c.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=M.URI.revive(c.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=M.URI.revive(c.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=M.URI.revive(c.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=M.URI.revive(c.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=M.URI.revive(c.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=M.URI.revive(c.transformIncomingURIs(n.logsLocation)),n.workspace=c.transformIncomingURIs(n.workspace),n}}e.$doc=o}),define(Se[306],Ie([1,0,18,11,20,44,16,19,24,2,47]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=e.$onc=e.$nnc=void 0,e.$pnc=r;class S{constructor(i,n,c){this.d=i,this.e=n,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const c=this.g.folderQueries||[],u=new M.$qe(n);return new Promise((t,f)=>{this.a=new w(i);let a=!1;const d=($,p)=>{if(!a&&!this.b){const v=this.h($);r($)&&typeof this.g.maxResults=="number"&&this.c+v>this.g.maxResults&&(this.b=!0,a=!0,u.cancel(),$=this.j($,this.g.maxResults-this.c));const y=this.h($);this.c+=y,(y>0||!r($))&&this.a.add($,p)}};Promise.all(c.map(($,p)=>this.k($,v=>d(v,p),u.token))).then($=>{u.dispose(),this.a.flush();const p=$.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||p,messages:$.flatMap(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[]),stats:{type:this.f}})},$=>{u.dispose();const p=(0,T.$jj)($);f(new Error(p))})})}h(i){return r(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const c=Array.isArray(i.ranges)?i.ranges:[i.ranges],u=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:c.slice(0,n),preview:{matches:u.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,c){const u=new N.$PK(this.g,i),t=[],f={report:$=>{if(!this.l($))return;const p=i.folder.scheme===A.Schemas.file?(0,N.$QK)(()=>this.e.readdir(m.$$g($.uri))):void 0,v=m.$bh(i.folder,$.uri);if(v){const y=u.includedInQuery(v,b.$nc(v),p);(0,O.$kh)(y)?t.push(y.then(h=>{h&&n($)})):y&&n($)}}},a=this.n(i);let d;return this.d.query.type===3?d=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,f,c):d=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),a,f,c),t.length&&await Promise.all(t),d}l(i){if(r(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,N.$OK)(this.g.includePattern,i.includePattern),c=(0,N.$OK)(this.g.excludePattern,i.excludePattern),u={folder:D.URI.from(i.folder),excludes:c,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(u.usePCRE2=this.g.usePCRE2),u}}e.$nnc=S;function l(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class w{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new s(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!m.$5g(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(g(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$onc=w;function g(o){return r(o)?{preview:{matches:(0,C.$1b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,C.$1b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function r(o){return!!o.preview}class s{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$qnc=s}),define(Se[124],Ie([1,0,6,4,3,301,17,61,12,2,306]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=e.$rnc=void 0,e.$tnc=l,e.$rnc=(0,M.$yi)("IExtHostSearch");let S=class{constructor(r,s,o){this.n=r,this.o=s,this.q=o,this.c=this.n.getProxy(O.$jM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new T.$mnc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,s){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const o=this.d++;return this.e.set(o,s),this.c.$registerTextSearchProvider(o,this.s(r)),(0,C.$Sc)(()=>{this.g.delete(r),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(r,s){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const o=this.d++;return this.h.set(o,s),this.c.$registerAITextSearchProvider(o,this.s(r)),(0,C.$Sc)(()=>{this.i.delete(r),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(r,s){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const o=this.d++;return this.j.set(o,s),this.c.$registerFileSearchProvider(o,this.s(r)),(0,C.$Sc)(()=>{this.k.delete(r),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(r,s,o,i){const n=l(o),c=this.j.get(r);if(c)return this.l.fileSearch(n,c,u=>{this.c.$handleFileMatch(r,s,u.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,s,o){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,s,o,i){const n=this.e.get(r);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const c=l(o);return this.t(c,n).search(t=>this.c.$handleTextMatch(r,s,t),i)}$provideAITextSearchResults(r,s,o,i){const n=this.h.get(r);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const c=l(o);return this.v(c,n).search(t=>this.c.$handleTextMatch(r,s,t),i)}$enableExtensionHostSearch(){}t(r,s){return new N.$nnc({query:r,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(r,s){return new N.$nnc({query:r,provider:s},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$snc=S,e.$snc=S=Je([We(0,A.$NO),We(1,b.$jmc),We(2,m.$5j)],S);function l(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(w),extraFileResources:g.extraFileResources&&g.extraFileResources.map(r=>D.URI.revive(r))}}function w(g){return{...g,folder:D.URI.revive(g.folder)}}}),define(Se[307],Ie([1,0,20,14,5,6,16,32,2,158,154,141,95,21,38,12,58,59,213,4,258,286,80,86,263,264,265,243,232,35,266,40,267,123,112,268,245,259,269,270,68,67,246,260,41,272,65,273,46,27,287,247,274,90,275,81,82,249,300,277,219,278,288,279,118,250,280,281,282,17,283,124,83,284,251,285,84,87,121,63,53,116,289,290,261,291,292,88,8,7,252,61,253,64,293,294,111,39,227,79,25,120]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c,u,t,f,a,d,$,p,v,y,h,E,k,I,P,V,W,q,R,z,G,ie,de,ye,De,ge,ue,Ce,se,Oe,ne,j,x,ve,Le,ke,be,me,Q,Y,he,ce,Te,fe,Pe,Re,Ue,B,F,H,K,te,re,Ne,Be,Ke,_e,xe,et,tt,it,ot,gt,je,rt,Z,X,$e,He,we,st,dt,Ct,Vt,Qt,ii,Xt,Dt,Zt,Yt,Ze,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=Kt;function Kt(ht){const mt=ht.get(Oe.$4O),xt=ht.get(se.$7lc),Gt=ht.get(ue.$rmc),Tt=ht.get(De.$3mc),ft=ht.get(Dt.$mmc),Bt=ht.get(tt.$8O),_t=ht.get(E.$pmc),zt=ht.get(dt.$jmc),Qe=ht.get(H.$NO),ui=ht.get(_e.$Kmc),Jt=ht.get(xe.$smc),jt=ht.get(r.$6j),bt=ht.get(r.$5j),Ut=ht.get($e.$UDb),Mt=ht.get(t.$3lc),At=ht.get(Xt.$9nc),ei=ht.get(re.$Umc),Wt=ht.get(ie.$Bmc),oi=ht.get(be.$Ymc),Ot=ht.get(f.$amc),qt=ht.get(ve.$Rmc);Qe.set(n.$kM.ExtHostFileSystemInfo,xt),Qe.set(n.$kM.ExtHostLogLevelServiceShape,jt),Qe.set(n.$kM.ExtHostWorkspace,ft),Qe.set(n.$kM.ExtHostConfiguration,_t),Qe.set(n.$kM.ExtHostExtensionService,Tt),Qe.set(n.$kM.ExtHostStorage,ui),Qe.set(n.$kM.ExtHostTunnelService,Ut),Qe.set(n.$kM.ExtHostWindow,At),Qe.set(n.$kM.ExtHostSecretState,ei),Qe.set(n.$kM.ExtHostTelemetry,Bt),Qe.set(n.$kM.ExtHostEditorTabs,Wt),Qe.set(n.$kM.ExtHostManagedSockets,oi),Qe.set(n.$kM.ExtHostAuthentication,Ot),Qe.set(n.$kM.ExtHostChatProvider,qt);const Rt=Qe.set(n.$kM.ExtHostDecorations,ht.get(P.$bnc)),St=Qe.set(n.$kM.ExtHostDocumentsAndEditors,ht.get(G.$YO)),$t=Qe.set(n.$kM.ExtHostCommands,ht.get(y.$0O)),Et=Qe.set(n.$kM.ExtHostTerminalService,ht.get(it.$Nmc)),ai=Qe.set(n.$kM.ExtHostTerminalShellIntegration,ht.get(ot.$Unc)),kt=Qe.set(n.$kM.ExtHostDebugService,ht.get(I.$8mc)),fi=Qe.set(n.$kM.ExtHostSearch,ht.get(te.$rnc)),ni=Qe.set(n.$kM.ExtHostTask,ht.get(et.$Tnc)),$i=Qe.set(n.$kM.ExtHostOutputService,ht.get(Pe.$Gnc)),li=Qe.set(n.$kM.ExtHostLocalization,ht.get(ke.$Xmc)),wi=Qe.set(n.$kM.ExtHostUrls,new Ct.$6nc(Qe)),It=Qe.set(n.$kM.ExtHostDocuments,new z.$0lc(Qe,St)),Di=Qe.set(n.$kM.ExtHostDocumentContentProviders,new q.$dnc(Qe,St,bt)),ri=Qe.set(n.$kM.ExtHostDocumentSaveParticipant,new R.$enc(bt,It,Qe.getProxy(n.$jM.MainThreadBulkEdits))),pe=Qe.set(n.$kM.ExtHostNotebook,new Q.$unc(Qe,$t,St,It,Gt,fi)),Ae=Qe.set(n.$kM.ExtHostNotebookDocuments,new he.$Anc(pe)),ae=Qe.set(n.$kM.ExtHostNotebookEditors,new ce.$Bnc(bt,pe)),J=Qe.set(n.$kM.ExtHostNotebookKernels,new Te.$Cnc(Qe,mt,pe,$t,bt)),Me=Qe.set(n.$kM.ExtHostNotebookRenderers,new fe.$Enc(Qe,pe)),Ve=Qe.set(n.$kM.ExtHostNotebookDocumentSaveParticipant,new Y.$znc(bt,pe,Qe.getProxy(n.$jM.MainThreadBulkEdits))),Xe=Qe.set(n.$kM.ExtHostEditors,new je.$gmc(Qe,St)),qe=Qe.set(n.$kM.ExtHostTreeViews,new X.$4nc(Qe.getProxy(n.$jM.MainThreadTreeViews),$t,bt)),ut=Qe.set(n.$kM.ExtHostEditorInsets,new v.$hmc(Qe.getProxy(n.$jM.MainThreadEditorInsets),Xe,mt.remote)),yt=Qe.set(n.$kM.ExtHostDiagnostics,new V.$9lc(Qe,bt,xt,St)),Lt=Qe.set(n.$kM.ExtHostLanguages,new Le.$xnc(Qe,It,$t.converter,zt)),ct=Qe.set(n.$kM.ExtHostLanguageFeatures,new x.$$lc(Qe,zt,It,$t,yt,bt,Mt,Bt)),Nt=Qe.set(n.$kM.ExtHostFileSystem,new ge.$hnc(Qe,ct)),Ft=Qe.set(n.$kM.ExtHostFileSystemEventService,new Ce.$inc(Qe,bt,St)),Ei=Qe.set(n.$kM.ExtHostQuickOpen,(0,F.$Knc)(Qe,ft,$t)),Ii=Qe.set(n.$kM.ExtHostSCM,new K.$Mnc(Qe,$t,It,bt)),Ji=Qe.set(n.$kM.ExtHostQuickDiff,new B.$Jnc(Qe,zt)),Oi=Qe.set(n.$kM.ExtHostShare,new Ne.$Nnc(Qe,zt)),Ni=Qe.set(n.$kM.ExtHostComments,(0,h.$imc)(Qe,$t,It)),Ci=Qe.set(n.$kM.ExtHostProgress,new Ue.$Inc(Qe.getProxy(n.$jM.MainThreadProgress))),Ti=Qe.set(n.$kM.ExtHostLabelService,new j.$wnc(Qe)),Li=Qe.set(n.$kM.ExtHostTheming,new rt.$1nc(Qe)),Qi=Qe.set(n.$kM.ExtHostTimeline,new Z.$3nc(Qe,$t)),Fi=Qe.set(n.$kM.ExtHostWebviews,new Vt.$wmc(Qe,mt.remote,ft,bt,Mt)),Pi=Qe.set(n.$kM.ExtHostWebviewPanels,new Qt.$zmc(Qe,Fi,ft)),zi=Qe.set(n.$kM.ExtHostCustomEditors,new k.$Amc(Qe,It,Jt,Fi,Pi)),ji=Qe.set(n.$kM.ExtHostWebviewViews,new ii.$7nc(Qe,Fi)),vi=Qe.set(n.$kM.ExtHostTesting,new gt.$Wnc(Qe,bt,$t,St)),Xi=Qe.set(n.$kM.ExtHostUriOpeners,new st.$5nc(Qe)),Zi=Qe.set(n.$kM.ExtHostProfileContentHandlers,new Re.$Hnc(Qe));Qe.set(n.$kM.ExtHostInteractive,new ne.$vnc(Qe,pe,St,$t,bt));const Mi=Qe.set(n.$kM.ExtHostChatAgents2,new d.$dmc(Qe,bt,$t)),Yi=Qe.set(n.$kM.ExtHostChatVariables,new $.$emc(Qe)),Ui=Qe.set(n.$kM.ExtHostAiRelatedInformation,new c.$2lc(Qe)),gn=Qe.set(n.$kM.ExtHostAiEmbeddingVector,new ye.$gnc(Qe)),xi=Qe.set(n.$kM.ExtHostStatusBar,new Ke.$Qnc(Qe,$t.converter)),Bi=Qe.set(n.$kM.ExtHostSpeech,new Be.$Onc(Qe)),pi=Qe.set(n.$kM.ExtHostEmbeddings,new de.$fnc(Qe)),mn=Object.values(n.$kM);Qe.assertRegistered(mn);const $n=new a.$cmc(Qe,St),_i=new p.$fmc(Qe),Vi=new me.$ync(Qe,bt),Ri=new W.$cnc(Qe);return u.$_lc.register($t),function(ze,hi,Wi){function nt(_){return(oe,Fe,at)=>{const vt=_(Pt=>{try{oe.call(Fe,Pt)}catch(Si){O.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Bt.onExtensionError(ze.identifier,Si)}});return at?.push(vt),vt}}const wt=function(){let _=!ze.isUnderDevelopment;function oe(){_||(bt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Fe(at){if(Array.isArray(at))at.forEach(Fe);else if(typeof at=="string")oe();else{const vt=at;typeof vt.scheme>"u"&&oe(),typeof vt.exclusive=="boolean"&&(0,Ze.$LG)(ze,"documentFiltersExclusive")}return at}}(),en={getSession(_,oe,Fe){return typeof Fe?.forceNewSession=="object"&&Fe.forceNewSession.learnMore&&(0,Ze.$LG)(ze,"authLearnMore"),Ot.getSession(ze,_,oe,Fe)},getSessions(_,oe){return(0,Ze.$LG)(ze,"authGetSessions"),Ot.getSessions(ze,_,oe)},async hasSession(_,oe){return(0,Ze.$LG)(ze,"authSession"),!!await Ot.getSession(ze,_,oe,{silent:!0})},get onDidChangeSessions(){return nt(Ot.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Fe,at){return Ot.registerAuthenticationProvider(_,oe,Fe,at)}},gi={registerCommand(_,oe,Fe){return $t.registerCommand(!0,_,oe,Fe,void 0,ze)},registerTextEditorCommand(_,oe,Fe){return $t.registerCommand(!0,_,(...at)=>{const vt=Xe.getActiveTextEditor();if(!vt){bt.warn("Cannot execute "+_+" because there is no active text editor.");return}return vt.edit(Pt=>{oe.apply(Fe,[vt,Pt,...at])}).then(Pt=>{Pt||bt.warn("Edits from command "+_+" were not applied.")},Pt=>{bt.warn("An error occurred while running command "+_,Pt)})},void 0,void 0,ze)},registerDiffInformationCommand:(_,oe,Fe)=>((0,Ze.$LG)(ze,"diffCommand"),$t.registerCommand(!0,_,async(...at)=>{const vt=St.activeEditor(!0);if(!vt){bt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Pt=await Xe.getDiffInformation(vt.id);oe.apply(Fe,[Pt,...at])},void 0,void 0,ze)),executeCommand(_,...oe){return $t.executeCommand(_,...oe)},getCommands(_=!1){return $t.getCommands(_)}},ki={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return _i.value},get shell(){return Et.getDefaultShell(!1)},get onDidChangeShell(){return nt(Et.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$LG)(ze,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$LG)(ze,"telemetry"),nt(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$7O)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return tt.$6O.validateSender(_),Bt.instantiateLogger(ze,_,oe)},openExternal(_,oe){return At.openUri(_,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===mt.environment.appUriScheme)return wi.createAppUri(_);try{return await At.asExternalUri(_,{allowTunneling:!!mt.remote.authority})}catch(oe){if((0,A.$Hg)(_,A.Schemas.http)||(0,A.$Hg)(_,A.Schemas.https))return _;throw oe}},get remoteName(){return(0,s.$Km)(mt.remote.authority)},get remoteAuthority(){return(0,Ze.$LG)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return nt(bt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$LG)(ze,"resolvers"),mt.quality},get appCommit(){return(0,Ze.$LG)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(ki);const pn={createTestController(_,oe,Fe){return vi.createTestController(ze,_,oe,Fe)},createTestObserver(){return(0,Ze.$LG)(ze,"testObserver"),vi.createTestObserver()},runTests(_){return(0,Ze.$LG)(ze,"testObserver"),vi.runTests(_)},get onDidChangeTestResults(){return(0,Ze.$LG)(ze,"testObserver"),nt(vi.onResultsChanged)},get testResults(){return(0,Ze.$LG)(ze,"testObserver"),vi.results}},ti=mt.remote.isRemote?we.ExtensionKind.Workspace:we.ExtensionKind.UI,Ai={getExtension(_,oe){(0,Ze.$KG)(ze,"extensionsAny")||(oe=!1);const Fe=hi.mine.getExtensionDescription(_);if(Fe)return new De.$4mc(Tt,ze.identifier,Fe,ti,!1);if(oe){const at=hi.all.getExtensionDescription(_);if(at)return new De.$4mc(Tt,ze.identifier,at,ti,!0)}},get all(){const _=[];for(const oe of hi.mine.getAllExtensionDescriptions())_.push(new De.$4mc(Tt,ze.identifier,oe,ti,!1));return _},get allAcrossExtensionHosts(){(0,Ze.$LG)(ze,"extensionsAny");const _=new w.$Um(hi.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),oe=[];for(const Fe of hi.all.getAllExtensionDescriptions()){const at=!_.has(Fe.identifier);oe.push(new De.$4mc(Tt,ze.identifier,Fe,ti,at))}return oe},get onDidChange(){return(0,Ze.$KG)(ze,"extensionsAny")?nt(M.Event.any(hi.mine.onDidChange,hi.all.onDidChange)):nt(hi.mine.onDidChange)}},tn={createDiagnosticCollection(_){return yt.createDiagnosticCollection(ze.identifier,_)},get onDidChangeDiagnostics(){return nt(yt.onDidChangeDiagnostics)},getDiagnostics:_=>yt.getDiagnostics(_),getLanguages(){return Lt.getLanguages()},setTextDocumentLanguage(_,oe){return Lt.changeLanguage(_.uri,oe)},match(_,oe){const Fe=He.LanguageSelector.from(_);let at;return(0,N.$gu)(Fe)&&(at=pe.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Pt=>Pt.document===oe))?.apiNotebook),(0,N.$fu)(Fe,oe.uri,oe.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(_,oe,Fe){return ct.registerCodeActionProvider(ze,wt(_),oe,Fe)},registerDocumentPasteEditProvider(_,oe,Fe){return(0,Ze.$LG)(ze,"documentPaste"),ct.registerDocumentPasteEditProvider(ze,wt(_),oe,Fe)},registerCodeLensProvider(_,oe){return ct.registerCodeLensProvider(ze,wt(_),oe)},registerDefinitionProvider(_,oe){return ct.registerDefinitionProvider(ze,wt(_),oe)},registerDeclarationProvider(_,oe){return ct.registerDeclarationProvider(ze,wt(_),oe)},registerImplementationProvider(_,oe){return ct.registerImplementationProvider(ze,wt(_),oe)},registerTypeDefinitionProvider(_,oe){return ct.registerTypeDefinitionProvider(ze,wt(_),oe)},registerHoverProvider(_,oe){return ct.registerHoverProvider(ze,wt(_),oe,ze.identifier)},registerEvaluatableExpressionProvider(_,oe){return ct.registerEvaluatableExpressionProvider(ze,wt(_),oe,ze.identifier)},registerInlineValuesProvider(_,oe){return ct.registerInlineValuesProvider(ze,wt(_),oe,ze.identifier)},registerDocumentHighlightProvider(_,oe){return ct.registerDocumentHighlightProvider(ze,wt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return ct.registerMultiDocumentHighlightProvider(ze,wt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return ct.registerLinkedEditingRangeProvider(ze,wt(_),oe)},registerReferenceProvider(_,oe){return ct.registerReferenceProvider(ze,wt(_),oe)},registerRenameProvider(_,oe){return ct.registerRenameProvider(ze,wt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Ze.$LG)(ze,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(ze,wt(_),oe)},registerDocumentSymbolProvider(_,oe,Fe){return ct.registerDocumentSymbolProvider(ze,wt(_),oe,Fe)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(ze,_)},registerDocumentFormattingEditProvider(_,oe){return ct.registerDocumentFormattingEditProvider(ze,wt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return ct.registerDocumentRangeFormattingEditProvider(ze,wt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Fe,...at){return ct.registerOnTypeFormattingEditProvider(ze,wt(_),oe,[Fe].concat(at))},registerDocumentSemanticTokensProvider(_,oe,Fe){return ct.registerDocumentSemanticTokensProvider(ze,wt(_),oe,Fe)},registerDocumentRangeSemanticTokensProvider(_,oe,Fe){return ct.registerDocumentRangeSemanticTokensProvider(ze,wt(_),oe,Fe)},registerSignatureHelpProvider(_,oe,Fe,...at){return typeof Fe=="object"?ct.registerSignatureHelpProvider(ze,wt(_),oe,Fe):ct.registerSignatureHelpProvider(ze,wt(_),oe,typeof Fe>"u"?[]:[Fe,...at])},registerCompletionItemProvider(_,oe,...Fe){return ct.registerCompletionItemProvider(ze,wt(_),oe,Fe)},registerInlineCompletionItemProvider(_,oe,Fe){return oe.handleDidShowCompletionItem&&(0,Ze.$LG)(ze,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$LG)(ze,"inlineCompletionsAdditions"),Fe&&(0,Ze.$LG)(ze,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(ze,wt(_),oe,Fe)},registerInlineEditProvider(_,oe){return(0,Ze.$LG)(ze,"inlineEdit"),ct.registerInlineEditProvider(ze,wt(_),oe)},registerDocumentLinkProvider(_,oe){return ct.registerDocumentLinkProvider(ze,wt(_),oe)},registerColorProvider(_,oe){return ct.registerColorProvider(ze,wt(_),oe)},registerFoldingRangeProvider(_,oe){return ct.registerFoldingRangeProvider(ze,wt(_),oe)},registerSelectionRangeProvider(_,oe){return ct.registerSelectionRangeProvider(ze,_,oe)},registerCallHierarchyProvider(_,oe){return ct.registerCallHierarchyProvider(ze,_,oe)},registerTypeHierarchyProvider(_,oe){return ct.registerTypeHierarchyProvider(ze,_,oe)},setLanguageConfiguration:(_,oe)=>ct.setLanguageConfiguration(ze,_,oe),getTokenInformationAtPosition(_,oe){return(0,Ze.$LG)(ze,"tokenInformation"),Lt.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return ct.registerInlayHintsProvider(ze,_,oe)},createLanguageStatusItem(_,oe){return Lt.createLanguageStatusItem(ze,_,oe)},registerDocumentDropEditProvider(_,oe,Fe){return ct.registerDocumentOnDropEditProvider(ze,_,oe,(0,Ze.$KG)(ze,"documentPaste")?Fe:void 0)}},nn={get activeTextEditor(){return Xe.getActiveTextEditor()},get visibleTextEditors(){return Xe.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(_,oe,Fe){m.URI.isUri(_)&&_.scheme===A.Schemas.vscodeRemote&&!_.authority&&Mt.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(m.URI.isUri(_)?Promise.resolve(qi.openTextDocument(_)):Promise.resolve(_));return Xe.showTextDocument(at,oe,Fe)},createTextEditorDecorationType(_){return Xe.createTextEditorDecorationType(ze,_)},onDidChangeActiveTextEditor(_,oe,Fe){return nt(Xe.onDidChangeActiveTextEditor)(_,oe,Fe)},onDidChangeVisibleTextEditors(_,oe,Fe){return nt(Xe.onDidChangeVisibleTextEditors)(_,oe,Fe)},onDidChangeTextEditorSelection(_,oe,Fe){return nt(Xe.onDidChangeTextEditorSelection)(_,oe,Fe)},onDidChangeTextEditorOptions(_,oe,Fe){return nt(Xe.onDidChangeTextEditorOptions)(_,oe,Fe)},onDidChangeTextEditorVisibleRanges(_,oe,Fe){return nt(Xe.onDidChangeTextEditorVisibleRanges)(_,oe,Fe)},onDidChangeTextEditorViewColumn(_,oe,Fe){return nt(Xe.onDidChangeTextEditorViewColumn)(_,oe,Fe)},onDidCloseTerminal(_,oe,Fe){return nt(Et.onDidCloseTerminal)(_,oe,Fe)},onDidOpenTerminal(_,oe,Fe){return nt(Et.onDidOpenTerminal)(_,oe,Fe)},onDidChangeActiveTerminal(_,oe,Fe){return nt(Et.onDidChangeActiveTerminal)(_,oe,Fe)},onDidChangeTerminalDimensions(_,oe,Fe){return(0,Ze.$LG)(ze,"terminalDimensions"),nt(Et.onDidChangeTerminalDimensions)(_,oe,Fe)},onDidChangeTerminalState(_,oe,Fe){return nt(Et.onDidChangeTerminalState)(_,oe,Fe)},onDidWriteTerminalData(_,oe,Fe){return(0,Ze.$LG)(ze,"terminalDataWriteEvent"),nt(Et.onDidWriteTerminalData)(_,oe,Fe)},onDidExecuteTerminalCommand(_,oe,Fe){return(0,Ze.$LG)(ze,"terminalExecuteCommandEvent"),nt(Et.onDidExecuteTerminalCommand)(_,oe,Fe)},onDidChangeTerminalShellIntegration(_,oe,Fe){return(0,Ze.$LG)(ze,"terminalShellIntegration"),nt(ai.onDidChangeTerminalShellIntegration)(_,oe,Fe)},onDidStartTerminalShellExecution(_,oe,Fe){return(0,Ze.$LG)(ze,"terminalShellIntegration"),nt(ai.onDidStartTerminalShellExecution)(_,oe,Fe)},onDidEndTerminalShellExecution(_,oe,Fe){return(0,Ze.$LG)(ze,"terminalShellIntegration"),nt(ai.onDidEndTerminalShellExecution)(_,oe,Fe)},get state(){return At.getState()},onDidChangeWindowState(_,oe,Fe){return nt(At.onDidChangeWindowState)(_,oe,Fe)},showInformationMessage(_,...oe){return Vi.showMessage(ze,b.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Vi.showMessage(ze,b.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Vi.showMessage(ze,b.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Fe){return Ei.showQuickPick(ze,_,oe,Fe)},showWorkspaceFolderPick(_){return Ei.showWorkspaceFolderPick(_)},showInputBox(_,oe){return Ei.showInput(_,oe)},showOpenDialog(_){return Ri.showOpenDialog(ze,_)},showSaveDialog(_){return Ri.showSaveDialog(_)},createStatusBarItem(_,oe,Fe){let at,vt,Pt;return typeof _=="string"?(at=_,vt=oe,Pt=Fe):(vt=_,Pt=oe),xi.createStatusBarEntry(ze,at,vt,Pt)},setStatusBarMessage(_,oe){return xi.setStatusBarMessage(_,oe)},withScmProgress(_){return Mt.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ci.withProgress(ze,{location:we.ProgressLocation.SourceControl},(oe,Fe)=>_({report(at){}}))},withProgress(_,oe){return Ci.withProgress(ze,_,oe)},createOutputChannel(_,oe){return $i.createOutputChannel(_,oe,ze)},createWebviewPanel(_,oe,Fe,at){return Pi.createWebviewPanel(ze,_,oe,Fe,at)},createWebviewTextEditorInset(_,oe,Fe,at){return(0,Ze.$LG)(ze,"editorInsets"),ut.createWebviewEditorInset(_,oe,Fe,at,ze)},createTerminal(_,oe,Fe){return typeof _=="object"?"pty"in _?Et.createExtensionTerminal(_):Et.createTerminalFromOptions(_):Et.createTerminal(_,oe,Fe)},registerTerminalLinkProvider(_){return Et.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return Et.registerProfileProvider(ze,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Ze.$LG)(ze,"terminalQuickFixProvider"),Et.registerTerminalQuickFixProvider(_,ze.identifier.value,oe)},registerTreeDataProvider(_,oe){return qe.registerTreeDataProvider(_,oe,ze)},createTreeView(_,oe){return qe.createTreeView(_,oe,ze)},registerWebviewPanelSerializer:(_,oe)=>Pi.registerWebviewPanelSerializer(ze,_,oe),registerCustomEditorProvider:(_,oe,Fe={})=>zi.registerCustomEditorProvider(ze,_,oe,Fe),registerFileDecorationProvider(_){return Rt.registerFileDecorationProvider(_,ze)},registerUriHandler(_){return wi.registerUriHandler(ze,_)},createQuickPick(){return Ei.createQuickPick(ze)},createInputBox(){return Ei.createInputBox(ze)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Fe){return nt(Li.onDidChangeActiveColorTheme)(_,oe,Fe)},registerWebviewViewProvider(_,oe,Fe){return ji.registerWebviewViewProvider(ze,_,oe,Fe?.webviewOptions)},get activeNotebookEditor(){return pe.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Fe){return nt(pe.onDidChangeActiveNotebookEditor)(_,oe,Fe)},get visibleNotebookEditors(){return pe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(pe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Fe){return nt(ae.onDidChangeNotebookEditorSelection)(_,oe,Fe)},onDidChangeNotebookEditorVisibleRanges(_,oe,Fe){return nt(ae.onDidChangeNotebookEditorVisibleRanges)(_,oe,Fe)},showNotebookDocument(_,oe){return pe.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Fe){return(0,Ze.$LG)(ze,"externalUriOpener"),Xi.registerExternalUriOpener(ze.identifier,_,oe,Fe)},registerProfileContentHandler(_,oe){return(0,Ze.$LG)(ze,"profileContentHandlers"),Zi.registerProfileContentHandler(ze,_,oe)},registerQuickDiffProvider(_,oe,Fe,at){return(0,Ze.$LG)(ze,"quickDiffProvider"),Ji.registerQuickDiffProvider(wt(_),oe,Fe,at)},get tabGroups(){return Wt.tabGroups},registerShareProvider(_,oe){return(0,Ze.$LG)(ze,"shareProvider"),Oi.registerShareProvider(wt(_),oe)}},qi={get rootPath(){return Mt.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new O.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new O.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Fe)=>ft.updateWorkspaceFolders(ze,_,oe||0,...Fe),onDidChangeWorkspaceFolders:function(_,oe,Fe){return nt(ft.onDidChangeWorkspace)(_,oe,Fe)},asRelativePath:(_,oe)=>ft.getRelativePath(_,oe),findFiles:(_,oe,Fe,at)=>ft.findFiles(_,oe,Fe,ze.identifier,at),findFiles2:(_,oe,Fe)=>((0,Ze.$LG)(ze,"findFiles2"),ft.findFiles2(_,oe,ze.identifier,Fe)),findTextInFiles:(_,oe,Fe,at)=>{(0,Ze.$LG)(ze,"findTextInFiles");let vt,Pt;return typeof oe=="object"?(vt=oe,Pt=Fe):(vt={},Pt=oe,at=Fe),ft.findTextInFiles(_,vt||{},Pt,ze.identifier,at)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,oe){return $n.applyWorkspaceEdit(_,ze,oe)},createFileSystemWatcher:(_,oe,Fe,at)=>{let vt;return typeof oe=="boolean"?vt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!at,correlate:!1}:oe&&((0,Ze.$LG)(ze,"createFileSystemWatcher"),vt={...oe,correlate:!0}),Ft.createFileSystemWatcher(ft,ze,_,vt)},get textDocuments(){return It.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new O.$9("textDocuments")},openTextDocument(_){let oe;const Fe=_;if(typeof _=="string")oe=Promise.resolve(m.URI.file(_));else if(m.URI.isUri(_))oe=Promise.resolve(_);else if(!Fe||typeof Fe=="object")oe=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&Mt.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),It.ensureDocumentData(at).then(vt=>vt.document)))},onDidOpenTextDocument:(_,oe,Fe)=>nt(It.onDidAddDocument)(_,oe,Fe),onDidCloseTextDocument:(_,oe,Fe)=>nt(It.onDidRemoveDocument)(_,oe,Fe),onDidChangeTextDocument:(_,oe,Fe)=>nt(It.onDidChangeDocument)(_,oe,Fe),onDidSaveTextDocument:(_,oe,Fe)=>nt(It.onDidSaveDocument)(_,oe,Fe),onWillSaveTextDocument:(_,oe,Fe)=>nt(ri.getOnWillSaveTextDocumentEvent(ze))(_,oe,Fe),get notebookDocuments(){return pe.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Fe;if(m.URI.isUri(_))Fe=_,await pe.openNotebookDocument(_);else if(typeof _=="string")Fe=m.URI.revive(await pe.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return pe.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(_,oe,Fe){return nt(Ae.onDidSaveNotebookDocument)(_,oe,Fe)},onDidChangeNotebookDocument(_,oe,Fe){return nt(Ae.onDidChangeNotebookDocument)(_,oe,Fe)},onWillSaveNotebookDocument(_,oe,Fe){return nt(Ve.getOnWillSaveNotebookDocumentEvent(ze))(_,oe,Fe)},get onDidOpenNotebookDocument(){return nt(pe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(pe.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Fe,at){return pe.registerNotebookSerializer(ze,_,oe,Fe,(0,Ze.$KG)(ze,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(_,oe,Fe)=>nt(Wi.onDidChangeConfiguration)(_,oe,Fe),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,Wi.getConfiguration(_,oe,ze)},registerTextDocumentContentProvider(_,oe){return Di.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(Mt.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ni.registerTaskProvider(ze,_,oe)),registerFileSystemProvider(_,oe,Fe){return(0,T.$Rc)(Nt.registerFileSystemProvider(ze,_,oe,Fe),Gt.addFileSystemProvider(_,oe,Fe))},get fs(){return Gt.value},registerFileSearchProvider:(_,oe)=>((0,Ze.$LG)(ze,"fileSearchProvider"),fi.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Ze.$LG)(ze,"textSearchProvider"),fi.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Ze.$LG)(ze,"aiTextSearchProvider"),(0,Ze.$LG)(ze,"textSearchProvider"),fi.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Ze.$LG)(ze,"resolvers"),Tt.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Ze.$LG)(ze,"resolvers"),Ti.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ze.$LG)(ze,"resolvers"),Tt.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Fe)=>nt(Ft.onDidCreateFile)(_,oe,Fe),onDidDeleteFiles:(_,oe,Fe)=>nt(Ft.onDidDeleteFile)(_,oe,Fe),onDidRenameFiles:(_,oe,Fe)=>nt(Ft.onDidRenameFile)(_,oe,Fe),onWillCreateFiles:(_,oe,Fe)=>nt(Ft.getOnWillCreateFileEvent(ze))(_,oe,Fe),onWillDeleteFiles:(_,oe,Fe)=>nt(Ft.getOnWillDeleteFileEvent(ze))(_,oe,Fe),onWillRenameFiles:(_,oe,Fe)=>nt(Ft.getOnWillRenameFileEvent(ze))(_,oe,Fe),openTunnel:_=>((0,Ze.$LG)(ze,"tunnels"),Ut.openTunnel(ze,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Ze.$LG)(ze,"tunnels"),Ut.getTunnels()},onDidChangeTunnels:(_,oe,Fe)=>((0,Ze.$LG)(ze,"tunnels"),nt(Ut.onDidChangeTunnels)(_,oe,Fe)),registerPortAttributesProvider:(_,oe)=>((0,Ze.$LG)(ze,"portsAttributes"),Ut.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Ze.$LG)(ze,"tunnelFactory"),Ut.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Ze.$LG)(ze,"timeline"),Qi.registerTimelineProvider(_,oe,ze.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Ze.$LG)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Fe)=>nt(ft.onDidGrantWorkspaceTrust)(_,oe,Fe),registerEditSessionIdentityProvider:(_,oe)=>((0,Ze.$LG)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Fe)=>((0,Ze.$LG)(ze,"editSessionIdentityProvider"),nt(ft.getOnWillCreateEditSessionIdentityEvent(ze))(_,oe,Fe)),registerCanonicalUriProvider:(_,oe)=>((0,Ze.$LG)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Fe)=>((0,Ze.$LG)(ze,"canonicalUriProvider"),ft.provideCanonicalUri(_,oe,Fe))},rn={get inputBox(){return Mt.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ii.getLastInputBox(ze)},createSourceControl(_,oe,Fe){return Ii.createSourceControl(ze,_,oe,Fe)}},bn={createCommentController(_,oe){return Ni.createCommentController(ze,_,oe)}},sn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){return kt.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Ze.$LG)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Ze.$LG)(ze,"debugVisualization"),kt.registerDebugVisualizationTree(ze,_,oe)},onDidStartDebugSession(_,oe,Fe){return nt(kt.onDidStartDebugSession)(_,oe,Fe)},onDidTerminateDebugSession(_,oe,Fe){return nt(kt.onDidTerminateDebugSession)(_,oe,Fe)},onDidChangeActiveDebugSession(_,oe,Fe){return nt(kt.onDidChangeActiveDebugSession)(_,oe,Fe)},onDidReceiveDebugSessionCustomEvent(_,oe,Fe){return nt(kt.onDidReceiveDebugSessionCustomEvent)(_,oe,Fe)},onDidChangeBreakpoints(_,oe,Fe){return nt(kt.onDidChangeBreakpoints)(_,oe,Fe)},onDidChangeActiveStackItem(_,oe,Fe){return nt(kt.onDidChangeActiveStackItem)(_,oe,Fe)},registerDebugConfigurationProvider(_,oe,Fe){return kt.registerDebugConfigurationProvider(_,oe,Fe||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return kt.registerDebugAdapterDescriptorFactory(ze,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return kt.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?kt.startDebugging(_,oe,{parentSession:Fe}):kt.startDebugging(_,oe,Fe||{})},stopDebugging(_){return kt.stopDebugging(_)},addBreakpoints(_){return kt.addBreakpoints(_)},removeBreakpoints(_){return kt.removeBreakpoints(_)},asDebugSourceUri(_,oe){return kt.asDebugSourceUri(_,oe)}},on={registerTaskProvider:(_,oe)=>ni.registerTaskProvider(ze,_,oe),fetchTasks:_=>ni.fetchTasks(_),executeTask:_=>ni.executeTask(ze,_),get taskExecutions(){return ni.taskExecutions},onDidStartTask:(_,oe,Fe)=>nt(ni.onDidStartTask)(_,oe,Fe),onDidEndTask:(_,oe,Fe)=>nt(ni.onDidEndTask)(_,oe,Fe),onDidStartTaskProcess:(_,oe,Fe)=>nt(ni.onDidStartTaskProcess)(_,oe,Fe),onDidEndTaskProcess:(_,oe,Fe)=>nt(ni.onDidEndTaskProcess)(_,oe,Fe)},wn={createNotebookController(_,oe,Fe,at,vt){return J.createNotebookController(ze,_,oe,Fe,at,(0,Ze.$KG)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>pe.registerNotebookCellStatusBarItemProvider(ze,_,oe),createRendererMessaging(_){return Me.createRendererMessaging(ze,_)},createNotebookControllerDetectionTask(_){return(0,Ze.$LG)(ze,"notebookKernelSource"),J.createNotebookControllerDetectionTask(ze,_)},registerKernelSourceActionProvider(_,oe){return(0,Ze.$LG)(ze,"notebookKernelSource"),J.registerKernelSourceActionProvider(ze,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Fe){return(0,Ze.$LG)(ze,"notebookCellExecutionState"),nt(J.onDidChangeNotebookCellExecutionState)(_,oe,Fe)}},vn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Fe=!_||typeof _[0]!="object"?_:_[0];return li.getMessage(ze.identifier.value,{message:oe,args:Fe})}return li.getMessage(ze.identifier.value,_[0])},get bundle(){return li.getBundle(ze.identifier.value)},get uri(){return li.getBundleUri(ze.identifier.value)}},an={_version:1,transferActiveChat(_){return(0,Ze.$LG)(ze,"interactive"),Mi.transferActiveChat(_)}},Hi={getRelatedInformation(_,oe){return(0,Ze.$LG)(ze,"aiRelatedInformation"),Ui.getRelatedInformation(ze,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Ze.$LG)(ze,"aiRelatedInformation"),Ui.registerRelatedInformationProvider(ze,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Ze.$LG)(ze,"aiRelatedInformation"),gn.registerEmbeddingVectorProvider(ze,_,oe)}},cn={_version:1,registerChatResponseProvider(_,oe,Fe){return(0,Ze.$LG)(ze,"chatProvider"),qt.registerLanguageModel(ze,_,oe,Fe)},registerChatVariableResolver(_,oe,Fe){return(0,Ze.$LG)(ze,"chatVariableResolver"),Yi.registerVariableResolver(ze,_,oe,Fe)},registerMappedEditsProvider(_,oe){return(0,Ze.$LG)(ze,"mappedEditsProvider"),ct.registerMappedEditsProvider(ze,_,oe)},createChatParticipant(_,oe){return(0,Ze.$LG)(ze,"chatParticipant"),Mi.createChatAgent(ze,_,oe)},createDynamicChatParticipant(_,oe,Fe){return(0,Ze.$LG)(ze,"chatParticipantAdditions"),Mi.createDynamicChatAgent(ze,_,oe,Fe)}},un={selectChatModels:_=>((0,Ze.$LG)(ze,"languageModels"),qt.selectLanguageModels(ze,_??{})),onDidChangeChatModels:(_,oe,Fe)=>((0,Ze.$LG)(ze,"languageModels"),qt.onDidChangeProviders(_,oe,Fe)),get embeddingModels(){return(0,Ze.$LG)(ze,"embeddings"),pi.embeddingsModels},onDidChangeEmbeddingModels:(_,oe,Fe)=>((0,Ze.$LG)(ze,"embeddings"),pi.onDidChange(_,oe,Fe)),registerEmbeddingsProvider(_,oe){return(0,Ze.$LG)(ze,"embeddings"),pi.registerEmbeddingsProvider(ze,_,oe)},async computeEmbeddings(_,oe,Fe){return(0,Ze.$LG)(ze,"embeddings"),pi.computeEmbeddings(_,oe,Fe)}},ln={registerSpeechProvider(_,oe){return(0,Ze.$LG)(ze,"speech"),Bi.registerProvider(ze.identifier,_,oe)}};return{version:mt.version,ai:Hi,authentication:en,commands:gi,comments:bn,chat:cn,debug:sn,env:ki,extensions:Ai,interactive:an,l10n:vn,languages:tn,lm:un,notebooks:wn,scm:rn,speech:ln,tasks:on,tests:pn,window:nn,workspace:qi,Breakpoint:we.$mN,TerminalOutputAnchor:we.TerminalOutputAnchor,ChatResultFeedbackKind:we.ChatResultFeedbackKind,ChatVariableLevel:we.ChatVariableLevel,ChatCompletionItem:we.$hO,CallHierarchyIncomingCall:we.$KM,CallHierarchyItem:we.$JM,CallHierarchyOutgoingCall:we.$LM,CancellationError:O.$5,CancellationTokenSource:C.$qe,CandidatePortSource:n.CandidatePortSource,CodeAction:we.$GM,CodeActionKind:we.$HM,CodeActionTriggerKind:we.CodeActionTriggerKind,CodeLens:we.$MM,Color:we.$ZM,ColorInformation:we.$1M,ColorPresentation:we.$2M,ColorThemeKind:we.ColorThemeKind,CommentMode:we.CommentMode,CommentState:we.CommentState,CommentThreadCollapsibleState:we.CommentThreadCollapsibleState,CommentThreadState:we.CommentThreadState,CommentThreadApplicability:we.CommentThreadApplicability,CompletionItem:we.$TM,CompletionItemKind:we.CompletionItemKind,CompletionItemTag:we.CompletionItemTag,CompletionList:we.$UM,CompletionTriggerKind:we.CompletionTriggerKind,ConfigurationTarget:we.ConfigurationTarget,CustomExecution:we.$0M,DebugAdapterExecutable:we.$qN,DebugAdapterInlineImplementation:we.$tN,DebugAdapterNamedPipeServer:we.$sN,DebugAdapterServer:we.$rN,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:we.DebugConsoleMode,DebugVisualization:we.$JN,DecorationRangeBehavior:we.DecorationRangeBehavior,Diagnostic:we.$zM,DiagnosticRelatedInformation:we.$yM,DiagnosticSeverity:we.DiagnosticSeverity,DiagnosticTag:we.DiagnosticTag,Disposable:we.$lM,DocumentHighlight:we.$CM,DocumentHighlightKind:we.DocumentHighlightKind,MultiDocumentHighlight:we.$DM,DocumentLink:we.$YM,DocumentSymbol:we.$FM,EndOfLine:we.EndOfLine,EnvironmentVariableMutatorType:we.EnvironmentVariableMutatorType,EvaluatableExpression:we.$wN,InlineValueText:we.$xN,InlineValueVariableLookup:we.$yN,InlineValueEvaluatableExpression:we.$zN,InlineCompletionTriggerKind:we.InlineCompletionTriggerKind,EventEmitter:M.$fe,ExtensionKind:we.ExtensionKind,ExtensionMode:we.ExtensionMode,ExternalUriOpenerPriority:we.ExternalUriOpenerPriority,FileChangeType:we.FileChangeType,FileDecoration:we.$LN,FileDecoration2:we.$LN,FileSystemError:we.$CN,FileType:g.FileType,FilePermission:g.FilePermission,FoldingRange:we.$DN,FoldingRangeKind:we.FoldingRangeKind,FunctionBreakpoint:we.$oN,InlineCompletionItem:we.$VM,InlineCompletionList:we.$WM,Hover:we.$AM,VerboseHover:we.$BM,HoverVerbosityAction:we.HoverVerbosityAction,IndentAction:S.IndentAction,Location:we.$xM,MarkdownString:we.$NM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:we.$OM,PortAutoForwardAction:we.PortAutoForwardAction,Position:we.$mM,ProcessExecution:we.$8M,ProgressLocation:we.ProgressLocation,QuickInputButtons:we.$KN,Range:we.$nM,RelativePattern:we.$kN,Selection:we.$oM,SelectionRange:we.$IM,SemanticTokens:we.$GN,SemanticTokensBuilder:we.$FN,SemanticTokensEdit:we.$HN,SemanticTokensEdits:we.$IN,SemanticTokensLegend:we.$EN,ShellExecution:we.$9M,ShellQuoting:we.ShellQuoting,SignatureHelp:we.$QM,SignatureHelpTriggerKind:we.SignatureHelpTriggerKind,SignatureInformation:we.$PM,SnippetString:we.$wM,SourceBreakpoint:we.$nN,StandardTokenType:we.StandardTokenType,StatusBarAlignment:we.StatusBarAlignment,SymbolInformation:we.$EM,SymbolKind:we.SymbolKind,SymbolTag:we.SymbolTag,Task:we.$$M,TaskGroup:we.$7M,TaskPanelKind:we.TaskPanelKind,TaskRevealKind:we.TaskRevealKind,TaskScope:we.TaskScope,TerminalLink:we.$3M,TerminalQuickFixTerminalCommand:we.$5M,TerminalQuickFixOpener:we.$4M,TerminalLocation:we.TerminalLocation,TerminalProfile:we.$6M,TerminalExitReason:we.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:we.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:we.TextDocumentSaveReason,TextEdit:we.$sM,SnippetTextEdit:we.$uM,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:we.TextEditorLineNumbersStyle,TextEditorRevealType:we.TextEditorRevealType,TextEditorSelectionChangeKind:we.TextEditorSelectionChangeKind,SyntaxTokenType:we.SyntaxTokenType,TextDocumentChangeReason:we.TextDocumentChangeReason,ThemeColor:we.$jN,ThemeIcon:we.$iN,TreeItem:we.$_M,TreeItemCheckboxState:we.TreeItemCheckboxState,TreeItemCollapsibleState:we.TreeItemCollapsibleState,TypeHierarchyItem:we.$8N,UIKind:Yt.UIKind,Uri:m.URI,ViewColumn:we.ViewColumn,WorkspaceEdit:we.$vM,DocumentPasteTriggerKind:we.DocumentPasteTriggerKind,DocumentDropEdit:we.$fN,DocumentDropOrPasteEditKind:we.$gN,DocumentPasteEdit:we.$hN,InlayHint:we.$SM,InlayHintLabelPart:we.$RM,InlayHintKind:we.InlayHintKind,RemoteAuthorityResolverError:we.$rM,ResolvedAuthority:we.$pM,ManagedResolvedAuthority:we.$qM,SourceControlInputBoxValidationType:we.SourceControlInputBoxValidationType,ExtensionRuntime:we.ExtensionRuntime,TimelineItem:we.$VN,NotebookRange:we.$NN,NotebookCellKind:we.NotebookCellKind,NotebookCellExecutionState:we.NotebookCellExecutionState,NotebookCellData:we.$ON,NotebookData:we.$PN,NotebookRendererScript:we.$TN,NotebookCellStatusBarAlignment:we.NotebookCellStatusBarAlignment,NotebookEditorRevealType:we.NotebookEditorRevealType,NotebookCellOutput:we.$RN,NotebookCellOutputItem:we.$QN,NotebookCellStatusBarItem:we.$SN,NotebookControllerAffinity:we.NotebookControllerAffinity,NotebookControllerAffinity2:we.NotebookControllerAffinity2,NotebookEdit:we.$tM,NotebookKernelSourceAction:we.$UN,NotebookVariablesRequestKind:we.NotebookVariablesRequestKind,PortAttributes:we.$XN,LinkedEditingRanges:we.$WN,TestResultState:we.TestResultState,TestRunRequest:we.$YN,TestMessage:we.$ZN,TestTag:we.$1N,TestRunProfileKind:we.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:we.$eN,DataTransferItem:we.$aN,TestCoverageCount:we.$2N,FileCoverage:we.$4N,FileCoverage2:we.$4N,StatementCoverage:we.$5N,BranchCoverage:we.$6N,DeclarationCoverage:we.$7N,WorkspaceTrustState:we.WorkspaceTrustState,LanguageStatusSeverity:we.LanguageStatusSeverity,QuickPickItemKind:we.QuickPickItemKind,InputBoxValidationSeverity:we.InputBoxValidationSeverity,TabInputText:we.$9N,TabInputTextDiff:we.$0N,TabInputTextMerge:we.$$N,TabInputCustom:we.$_N,TabInputNotebook:we.$bO,TabInputNotebookDiff:we.$cO,TabInputWebview:we.$aO,TabInputTerminal:we.$dO,TabInputInteractiveWindow:we.$eO,TabInputChat:we.$fO,TabInputTextMultiDiff:we.$gO,TelemetryTrustedValue:o.$jp,LogLevel:r.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:we.InteractiveSessionVoteDirection,ChatCopyKind:we.ChatCopyKind,InteractiveEditorResponseFeedbackKind:we.InteractiveEditorResponseFeedbackKind,DebugStackFrame:we.$uN,DebugThread:we.$vN,RelatedInformationType:we.RelatedInformationType,SpeechToTextStatus:we.SpeechToTextStatus,TextToSpeechStatus:we.TextToSpeechStatus,PartialAcceptTriggerKind:we.PartialAcceptTriggerKind,KeywordRecognitionStatus:we.KeywordRecognitionStatus,ChatResponseMarkdownPart:we.$iO,ChatResponseFileTreePart:we.$mO,ChatResponseAnchorPart:we.$nO,ChatResponseProgressPart:we.$oO,ChatResponseProgressPart2:we.$pO,ChatResponseReferencePart:we.$sO,ChatResponseWarningPart:we.$qO,ChatResponseTextEditPart:we.$tO,ChatResponseMarkdownWithVulnerabilitiesPart:we.$jO,ChatResponseCommandButtonPart:we.$rO,ChatResponseDetectedParticipantPart:we.$kO,ChatResponseConfirmationPart:we.$lO,ChatRequestTurn:we.$uO,ChatResponseTurn:we.$vO,ChatLocation:we.ChatLocation,LanguageModelChatMessageRole:we.LanguageModelChatMessageRole,LanguageModelChatMessage:we.$wO,LanguageModelChatMessage2:we.$wO,LanguageModelChatSystemMessage:we.$xO,LanguageModelChatUserMessage:we.$yO,LanguageModelChatAssistantMessage:we.$zO,LanguageModelError:we.$AO,NewSymbolName:we.$BN,NewSymbolNameTag:we.NewSymbolNameTag,NewSymbolNameTriggerKind:we.NewSymbolNameTriggerKind,InlineEdit:we.$BO,InlineEditTriggerKind:we.InlineEditTriggerKind}}}}),define(Se[308],Ie([1,0,56,118,39,112,40,35,68,53,121,123,124,84,88,80,111,65,46,83,63,67,248,12,122,81,82,86,90,116]),function(le,e,C,O,M,T,A,b,m,D,N,S,l,w,g,r,s,o,i,n,c,u,t,f,a,d,$,p,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Bs)(d.$Xmc,d.$Wmc,1),(0,C.$Bs)(f.$6j,t.$$nc,1),(0,C.$Bs)(r.$3lc,r.$4lc,1),(0,C.$Bs)(b.$0O,b.$9O,0),(0,C.$Bs)(p.$amc,p.$bmc,0),(0,C.$Bs)(v.$Rmc,v.$Smc,0),(0,C.$Bs)(A.$pmc,A.$nmc,0),(0,C.$Bs)(o.$rmc,o.$qmc,0),(0,C.$Bs)(S.$8mc,S.$_mc,0),(0,C.$Bs)(T.$bnc,T.$anc,0),(0,C.$Bs)(m.$YO,m.$XO,0),(0,C.$Bs)($.$Ymc,$.$Zmc,0),(0,C.$Bs)(i.$7lc,i.$6lc,0),(0,C.$Bs)(O.$Gnc,O.$Fnc,1),(0,C.$Bs)(l.$rnc,l.$snc,0),(0,C.$Bs)(w.$Kmc,w.$Jmc,0),(0,C.$Bs)(N.$Tnc,N.$Snc,0),(0,C.$Bs)(D.$Nmc,D.$Qmc,0),(0,C.$Bs)(y.$Unc,y.$Vnc,0),(0,C.$Bs)(g.$UDb,g.$VDb,0),(0,C.$Bs)(s.$9nc,s.$8nc,0),(0,C.$Bs)(M.$mmc,M.$lmc,0),(0,C.$Bs)(n.$Umc,n.$Tmc,0),(0,C.$Bs)(c.$8O,c.$5O,0),(0,C.$Bs)(u.$Bmc,u.$Cmc,0),(0,C.$Bs)(a.$6mc,a.$7mc,0)}),define(Se[309],Ie([1,0,307,41,2,304,7,11,254]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=void 0;class D extends T.$boc{j(){}getModule(w,g){for(const r of this.b){const s=r(w);if(s){w=s;break}}if(this.a.has(w))return this.a.get(w).load(w,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends O.$2mc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(m.$hqc);const w=this.h.invokeFunction(C.$0nc);this.r=this.h.createInstance(D,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(w){return w.browser}async xb(w,g,r){g=g.with({path:S(g.path,".js")});const s=w?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const o=M.URI.revive(await this.C.$asBrowserUri(g)),i=await fetch(o.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),i.status!==200)throw new Error(i.statusText);const n=await i.text(),c=`${g.toString(!0)}#vscode-extension`,u=`${n}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",u)}catch($){throw console.error(s?`Loading code for extension ${s} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${g.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}w&&await this.w.initializeLocalizedMessages(w);const f={},a={exports:f},d=$=>{const p=this.r.getModule($,g);if(p===void 0)throw new Error(`Cannot load module '${$}'`);return p};try{return r.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),t(a,f,d),a.exports!==f?a.exports:f}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),r.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Bb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+w;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,b.$zh)(10)}}e.$iqc=N;function S(l,w){return l.endsWith(w)?l:l+w}}),define(Se[310],Ie([1,0,71,56,12,41,217,87,309]),function(le,e,C,O,M,T,A,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.$Bs)(M.$5j,new C.$vi(A.$aoc,[!0],!0)),(0,O.$Bs)(T.$3mc,m.$iqc,0),(0,O.$Bs)(b.$smc,b.$tmc,0)}),define(Se[316],Ie([1,0,22,5,79,305,256,19,60,16,2,308,310]),function(le,e,C,O,M,T,A,b,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=u;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const g=fetch.bind(self);function r(t){self.fetch=async function(f,a){return f instanceof Request||w(String(f))&&(f=(await t(N.URI.parse(String(f)))).toString(!0)),g(f,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,a,d,$,p){(async()=>(w(a.toString())&&(a=(await t(N.URI.parse(a.toString()))).toString(!0)),super.open(f,a,d??!0,$,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(f,a){if(/^file:/i.test(f.toString()))f=D.$Sg.uriToBrowserUri(N.URI.parse(f.toString())).toString(!0);else if(/^vscode-remote:/i.test(f.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(h){function E(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const k=fetch.bind(self);self.fetch=function(P,V){return P instanceof Request?k(P,V):k(E(P),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,V,W,q,R){return super.open(P,E(V),W??!0,q,R)}};const I=importScripts.bind(self);self.importScripts=(...P)=>{I(...P.map(E))},I(h)}.toString()}('${f}'))`;a=a||{},a.name=`${name} -> ${a.name||b.$nc(f.toString())}`;const p=new Blob([$],{type:"application/javascript"}),v=URL.createObjectURL(p);return new t(v,a)}}else self.Worker=class extends A.$jqc{constructor(t,f){super(l,t,{name:b.$nc(t.toString()),...f})}};const s=new class{constructor(){this.pid=void 0}exit(t){S()}};class o{constructor(){const f=new MessageChannel,a=new O.$fe;let d=!1;l(f.port2,[f.port2]),f.port1.onmessage=$=>{const{data:p}=$;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const v=C.$He.wrap(new Uint8Array(p,0,p.byteLength));if((0,M.$3m)(v,2)){d=!0,n("received terminate message from renderer");return}a.fire(v)},this.protocol={onMessage:a.event,send:$=>{if(!d){const p=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);f.port1.postMessage(p,[p])}}}}}function i(t){return new Promise(f=>{const a=t.onMessage(d=>{a.dispose();const $=JSON.parse(d.toString());t.send((0,M.$2m)(0)),f({protocol:t,initData:$})});t.send((0,M.$2m)(1))})}let n=t=>S();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function u(){m.mark("code/extHost/willConnectToRenderer");const t=new o;return{onmessage(f){c(f)&&i(t.protocol).then(a=>{m.mark("code/extHost/didWaitForInitData");const d=new T.$doc(a.protocol,a.initData,s,null,f.data);r($=>d.asBrowserUri($)),n=$=>d.terminate($)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3028408922e78cc9ca15ee761372a7c0603fa375/core/vs/workbench/api/worker/extensionHostWorker.js.map
